// Koka generated module: "std/num/int32", koka version: 2.4.2, platform: 64-bit
#include "std_num_int32.h"
 
// Show an `:int32` in hexadecimal notation
// The `width`  parameter specifies how wide the hex value is where `'0'`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number (goes between the sign and the number).

kk_string_t kk_std_num_int32_show_hex(int32_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int32, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_integer_t _x2176 = kk_integer_from_int(i,kk_context()); /*int*/
  kk_std_core_types__optional _x2177;
  kk_box_t _x2178;
  kk_integer_t _x2179;
  if (kk_std_core_types__is_Optional(width, _ctx)) {
    kk_box_t _box_x2010 = width._cons.Optional.value;
    kk_integer_t _width_319 = kk_integer_unbox(_box_x2010, _ctx);
    kk_integer_dup(_width_319, _ctx);
    kk_std_core_types__optional_drop(width, _ctx);
    _x2179 = _width_319; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(width, _ctx);
    _x2179 = kk_integer_from_small(1); /*int*/
  }
  _x2178 = kk_integer_box(_x2179, _ctx); /*116*/
  _x2177 = kk_std_core_types__new_Optional(_x2178, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2180;
  kk_box_t _x2181;
  bool _x2182;
  if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
    kk_box_t _box_x2012 = use_capitals._cons.Optional.value;
    bool _use_capitals_323 = kk_bool_unbox(_box_x2012);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2182 = _use_capitals_323; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2182 = true; /*bool*/
  }
  _x2181 = kk_bool_box(_x2182); /*116*/
  _x2180 = kk_std_core_types__new_Optional(_x2181, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2183;
  kk_box_t _x2184;
  kk_string_t _x2185;
  if (kk_std_core_types__is_Optional(pre, _ctx)) {
    kk_box_t _box_x2014 = pre._cons.Optional.value;
    kk_string_t _pre_327 = kk_string_unbox(_box_x2014);
    kk_string_dup(_pre_327, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    _x2185 = _pre_327; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_define_string_literal(, _s2186, 2, "0x", _ctx)
    _x2185 = kk_string_dup(_s2186, _ctx); /*string*/
  }
  _x2184 = kk_string_box(_x2185); /*116*/
  _x2183 = kk_std_core_types__new_Optional(_x2184, _ctx); /*optional<116>*/
  return kk_std_core_show_hex(_x2176, _x2177, _x2180, _x2183, _ctx);
}

int32_t kk_std_num_int32_one;

int32_t kk_std_num_int32_zero;
 
// The minimal integer value before underflow happens

int32_t kk_std_num_int32_min_int32;
 
// Euclidean-0 modulus. See `(/):(x : int32, y : int32) -> int32` division for more information.

int32_t kk_std_num_int32__lp__perc__rp_(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> int32 */ 
  bool _match_2157 = (y == ((KK_I32(0)))); /*bool*/;
  if (_match_2157) {
    return x;
  }
  {
    bool _match_2158 = (y == ((KK_I32(-1)))); /*bool*/;
    if (_match_2158) {
      bool _match_2161 = (x == kk_std_num_int32_min_int32); /*bool*/;
      if (_match_2161) {
        return (KK_I32(0));
      }
      {
        int32_t r = (x % y); /*int32*/;
        bool _match_2162 = (r >= ((KK_I32(0)))); /*bool*/;
        if (_match_2162) {
          return r;
        }
        {
          bool _match_2163 = (y > ((KK_I32(0)))); /*bool*/;
          if (_match_2163) {
            return (int32_t)((uint32_t)r + (uint32_t)y);
          }
          {
            return (int32_t)((uint32_t)r - (uint32_t)y);
          }
        }
      }
    }
    {
      int32_t r0 = (x % y); /*int32*/;
      bool _match_2159 = (r0 >= ((KK_I32(0)))); /*bool*/;
      if (_match_2159) {
        return r0;
      }
      {
        bool _match_2160 = (y > ((KK_I32(0)))); /*bool*/;
        if (_match_2160) {
          return (int32_t)((uint32_t)r0 + (uint32_t)y);
        }
        {
          return (int32_t)((uint32_t)r0 - (uint32_t)y);
        }
      }
    }
  }
}
 
/*
Euclidean-0 division.
Euclidean division is defined as: For any `D`  and `d`  where `d!=0` , we have:
1. `D == d*(D/d) + (D%d)`
2. `D%d`  is always positive where `0 <= D%d < abs(d)`
Moreover, Euclidean-0 is a total function, for the case where `d==0`  we have
that `D%0 == D`  and `D/0 == 0` . So property (1) still holds, but not property (2).
Useful laws that hold for Euclidean-0 division:
* `D/(-d) == -(D/d)`
* `D%(-d) == D%d`
* `D/(2^n) == sar(D,n)         `  (with `0 <= n <= 31`)
* `D%(2^n) == D & ((2^n) - 1)  `  (with `0 <= n <= 31`)
Note that an interesting edge case is `min-int32 / -1` which equals `min-int32` since in modulo 32-bit
arithmetic `min-int32 == -1 * min-int32 == -1 * (min-int32 / -1) + (min-int32 % -1)` satisfying property (1).
Of course `(min-int32 + 1) / -1` is again positive (namely `max-int32`).
See also _Division and modulus for computer scientists, Daan Leijen, 2001_
[pdf](http://research.microsoft.com/pubs/151917/divmodnote.pdf) .
*/

int32_t kk_std_num_int32__lp__fs__rp_(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> int32 */ 
  bool _match_2150 = (y == ((KK_I32(0)))); /*bool*/;
  if (_match_2150) {
    return (KK_I32(0));
  }
  {
    bool _match_2151 = (y == ((KK_I32(-1)))); /*bool*/;
    if (_match_2151) {
      bool _match_2154 = (x == kk_std_num_int32_min_int32); /*bool*/;
      if (_match_2154) {
        return x;
      }
      {
        int32_t q = (x / y); /*int32*/;
        int32_t r = (x % y); /*int32*/;
        bool _match_2155 = (r >= ((KK_I32(0)))); /*bool*/;
        if (_match_2155) {
          return q;
        }
        {
          bool _match_2156 = (y > ((KK_I32(0)))); /*bool*/;
          if (_match_2156) {
            return (int32_t)((uint32_t)q - (uint32_t)((KK_I32(1))));
          }
          {
            return (int32_t)((uint32_t)q + (uint32_t)((KK_I32(1))));
          }
        }
      }
    }
    {
      int32_t q0 = (x / y); /*int32*/;
      int32_t r0 = (x % y); /*int32*/;
      bool _match_2152 = (r0 >= ((KK_I32(0)))); /*bool*/;
      if (_match_2152) {
        return q0;
      }
      {
        bool _match_2153 = (y > ((KK_I32(0)))); /*bool*/;
        if (_match_2153) {
          return (int32_t)((uint32_t)q0 - (uint32_t)((KK_I32(1))));
        }
        {
          return (int32_t)((uint32_t)q0 + (uint32_t)((KK_I32(1))));
        }
      }
    }
  }
}
 
// Return the absolute value of an integer.
// Raises an exception if the `:int32` is `min-int32`
// (since the negation of `min-int32` equals itself and is still negative)


// lift anonymous function
struct kk_std_num_int32_abs_fun2188__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_int32_abs_fun2188(kk_function_t _fself, kk_box_t _b_2021, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32_new_abs_fun2188(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_int32_abs_fun2188, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_int32_abs_fun2188(kk_function_t _fself, kk_box_t _b_2021, kk_context_t* _ctx) {
  kk_unused(_fself);
  bool _x2189;
  bool b_2028 = kk_bool_unbox(_b_2021); /*bool*/;
  if (b_2028) {
    _x2189 = false; /*bool*/
  }
  else {
    _x2189 = true; /*bool*/
  }
  return kk_bool_box(_x2189);
}

int32_t kk_std_num_int32_abs(int32_t i, kk_context_t* _ctx) { /* (i : int32) -> exn int32 */ 
  bool _x1_1989 = 0 > i; /*bool*/;
  bool _match_2148;
  kk_box_t _x2187 = kk_std_core_hnd__open_none1(kk_std_num_int32_new_abs_fun2188(_ctx), kk_bool_box(_x1_1989), _ctx); /*3357*/
  _match_2148 = kk_bool_unbox(_x2187); /*bool*/
  if (_match_2148) {
    return i;
  }
  {
    bool _match_2149 = (i > kk_std_num_int32_min_int32); /*bool*/;
    if (_match_2149) {
      return (int32_t)((uint32_t)((KK_I32(0))) - (uint32_t)i);
    }
    {
      kk_box_t _x2190;
      kk_string_t _x2191;
      kk_define_string_literal(, _s2192, 79, "std/num/int32/abs: cannot make min-int32 into a positive int32 without overflow", _ctx)
      _x2191 = kk_string_dup(_s2192, _ctx); /*string*/
      _x2190 = kk_std_core_throw(_x2191, kk_std_core_types__new_None(_ctx), _ctx); /*11930*/
      return kk_int32_unbox(_x2190, KK_OWNED, _ctx);
    }
  }
}
 
// Return the absolute value of an integer.
// Returns 0 if the `:int32` is `min-int32`
// (since the negation of `min-int32` equals itself and is still negative)

int32_t kk_std_num_int32_abs0(int32_t i, kk_context_t* _ctx) { /* (i : int32) -> int32 */ 
  bool b_1939 = 0 > i; /*bool*/;
  if (b_1939) {
    bool _match_2147 = (i > kk_std_num_int32_min_int32); /*bool*/;
    if (_match_2147) {
      return (int32_t)((uint32_t)((KK_I32(0))) - (uint32_t)i);
    }
    {
      return (KK_I32(0));
    }
  }
  {
    return i;
  }
}
 
// The number of bits in an `:int32` (always 32)

int32_t kk_std_num_int32_bits_int32;
 
// Truncated division (as in C). See also `(/):(x : int32, y : int32) -> int32`.

int32_t kk_std_num_int32_cdiv(int32_t i, int32_t j, kk_context_t* _ctx) { /* (i : int32, j : int32) -> exn int32 */ 
  bool _match_2144 = 0 == j; /*bool*/;
  if (_match_2144) {
    kk_box_t _x2193;
    kk_string_t _x2194;
    kk_define_string_literal(, _s2195, 35, "std/num/int32/cdiv: modulus by zero", _ctx)
    _x2194 = kk_string_dup(_s2195, _ctx); /*string*/
    _x2193 = kk_std_core_throw(_x2194, kk_std_core_types__new_None(_ctx), _ctx); /*11930*/
    return kk_int32_unbox(_x2193, KK_OWNED, _ctx);
  }
  {
    bool _match_2145 = (j == ((KK_I32(-1)))); /*bool*/;
    if (_match_2145) {
      bool _match_2146 = (i == kk_std_num_int32_min_int32); /*bool*/;
      if (_match_2146) {
        kk_box_t _x2196;
        kk_string_t _x2197;
        kk_define_string_literal(, _s2198, 65, "std/num/int32/cdiv: modulus overflow in cdiv(min-int32, -1.int32)", _ctx)
        _x2197 = kk_string_dup(_s2198, _ctx); /*string*/
        _x2196 = kk_std_core_throw(_x2197, kk_std_core_types__new_None(_ctx), _ctx); /*11930*/
        return kk_int32_unbox(_x2196, KK_OWNED, _ctx);
      }
      {
        return (i / j);
      }
    }
    {
      return (i / j);
    }
  }
}
 
// Truncated modulus (as in C). See also `(%):(x : int32, y : int32) -> int32`.

int32_t kk_std_num_int32_cmod(int32_t i, int32_t j, kk_context_t* _ctx) { /* (i : int32, j : int32) -> exn int32 */ 
  bool _match_2141 = 0 == j; /*bool*/;
  if (_match_2141) {
    kk_box_t _x2199;
    kk_string_t _x2200;
    kk_define_string_literal(, _s2201, 35, "std/num/int32/cmod: modulus by zero", _ctx)
    _x2200 = kk_string_dup(_s2201, _ctx); /*string*/
    _x2199 = kk_std_core_throw(_x2200, kk_std_core_types__new_None(_ctx), _ctx); /*11930*/
    return kk_int32_unbox(_x2199, KK_OWNED, _ctx);
  }
  {
    bool _match_2142 = (j == ((KK_I32(-1)))); /*bool*/;
    if (_match_2142) {
      bool _match_2143 = (i == kk_std_num_int32_min_int32); /*bool*/;
      if (_match_2143) {
        kk_box_t _x2202;
        kk_string_t _x2203;
        kk_define_string_literal(, _s2204, 65, "std/num/int32/cmod: modulus overflow in cmod(min-int32, -1.int32)", _ctx)
        _x2203 = kk_string_dup(_s2204, _ctx); /*string*/
        _x2202 = kk_std_core_throw(_x2203, kk_std_core_types__new_None(_ctx), _ctx); /*11930*/
        return kk_int32_unbox(_x2202, KK_OWNED, _ctx);
      }
      {
        return (i % j);
      }
    }
    {
      return (i % j);
    }
  }
}

kk_std_core_types__tuple2_ kk_std_num_int32_divmod(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> (int32, int32) */ 
  bool _match_2136 = 0 == y; /*bool*/;
  if (_match_2136) {
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(kk_std_num_int32_zero, _ctx), kk_int32_box(x, _ctx), _ctx);
  }
  {
    bool _match_2137 = (y == ((KK_I32(-1)))); /*bool*/;
    if (_match_2137) {
      bool _match_2139 = (x == kk_std_num_int32_min_int32); /*bool*/;
      if (_match_2139) {
        int32_t _b_2064_2048 = (KK_I32(0)); /*int32*/;
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(x, _ctx), kk_int32_box(_b_2064_2048, _ctx), _ctx);
      }
      {
        int32_t q = (x / y); /*int32*/;
        int32_t r = (x % y); /*int32*/;
        bool b_1941 = 0 > r; /*bool*/;
        if (b_1941) {
          bool _match_2140 = 0 < y; /*bool*/;
          if (_match_2140) {
            int32_t _b_2065_2049 = (int32_t)((uint32_t)q - (uint32_t)((KK_I32(1)))); /*int32*/;
            int32_t _b_2066_2050 = (int32_t)((uint32_t)r + (uint32_t)y); /*int32*/;
            return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_2065_2049, _ctx), kk_int32_box(_b_2066_2050, _ctx), _ctx);
          }
          {
            int32_t _b_2067_2051 = (int32_t)((uint32_t)q + (uint32_t)((KK_I32(1)))); /*int32*/;
            int32_t _b_2068_2052 = (int32_t)((uint32_t)r - (uint32_t)y); /*int32*/;
            return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_2067_2051, _ctx), kk_int32_box(_b_2068_2052, _ctx), _ctx);
          }
        }
        {
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(q, _ctx), kk_int32_box(r, _ctx), _ctx);
        }
      }
    }
    {
      int32_t q0 = (x / y); /*int32*/;
      int32_t r0 = (x % y); /*int32*/;
      bool b0_1944 = 0 > r0; /*bool*/;
      if (b0_1944) {
        bool _match_2138 = 0 < y; /*bool*/;
        if (_match_2138) {
          int32_t _b_2071_2055 = (int32_t)((uint32_t)q0 - (uint32_t)((KK_I32(1)))); /*int32*/;
          int32_t _b_2072_2056 = (int32_t)((uint32_t)r0 + (uint32_t)y); /*int32*/;
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_2071_2055, _ctx), kk_int32_box(_b_2072_2056, _ctx), _ctx);
        }
        {
          int32_t _b_2073_2057 = (int32_t)((uint32_t)q0 + (uint32_t)((KK_I32(1)))); /*int32*/;
          int32_t _b_2074_2058 = (int32_t)((uint32_t)r0 - (uint32_t)y); /*int32*/;
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_2073_2057, _ctx), kk_int32_box(_b_2074_2058, _ctx), _ctx);
        }
      }
      {
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(q0, _ctx), kk_int32_box(r0, _ctx), _ctx);
      }
    }
  }
}
 
// monadic lift

kk_box_t kk_std_num_int32__mlift1990_fold_int32(int32_t end, kk_function_t f, int32_t start, kk_box_t x, kk_context_t* _ctx) { /* forall<a,e> (end : int32, f : (int32, a) -> e a, start : int32, x : a) -> e a */ 
  int32_t _own_2134 = (int32_t)((uint32_t)start + (uint32_t)((KK_I32(1)))); /*int32*/;
  kk_box_t _brw_2135 = kk_std_num_int32_fold_int32(_own_2134, end, x, f, _ctx); /*63*/;
  kk_function_drop(f, _ctx);
  return _brw_2135;
}


// lift anonymous function
struct kk_std_num_int32_fold_int32_fun2207__t {
  struct kk_function_s _base;
  kk_function_t f0;
  int32_t end0;
  int32_t start0;
};
static kk_box_t kk_std_num_int32_fold_int32_fun2207(kk_function_t _fself, kk_box_t x1, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32_new_fold_int32_fun2207(kk_function_t f0, int32_t end0, int32_t start0, kk_context_t* _ctx) {
  struct kk_std_num_int32_fold_int32_fun2207__t* _self = kk_function_alloc_as(struct kk_std_num_int32_fold_int32_fun2207__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_int32_fold_int32_fun2207, kk_context());
  _self->f0 = f0;
  _self->end0 = end0;
  _self->start0 = start0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_int32_fold_int32_fun2207(kk_function_t _fself, kk_box_t x1, kk_context_t* _ctx) {
  struct kk_std_num_int32_fold_int32_fun2207__t* _self = kk_function_as(struct kk_std_num_int32_fold_int32_fun2207__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int32, 1380) -> 1381 1380 */
  int32_t end0 = _self->end0; /* int32 */
  int32_t start0 = _self->start0; /* int32 */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);;;}, {}, _ctx)
  return kk_std_num_int32__mlift1990_fold_int32(end0, f0, start0, x1, _ctx);
}

kk_box_t kk_std_num_int32_fold_int32(int32_t start0, int32_t end0, kk_box_t init, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,e> (start : int32, end : int32, init : a, f : (int32, a) -> e a) -> e a */ 
  kk__tailcall: ;
  bool _match_2131 = (start0 >= end0); /*bool*/;
  if (_match_2131) {
    return init;
  }
  {
    kk_box_t x0_1994;
    kk_function_t _x2205 = kk_function_dup(f0, _ctx); /*(int32, 1380) -> 1381 1380*/
    x0_1994 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_box_t, kk_context_t*), _x2205, (_x2205, start0, init, _ctx), _ctx); /*1380*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_1994, _ctx);
      kk_function_t _x2206;
      kk_function_dup(f0, _ctx);
      _x2206 = kk_std_num_int32_new_fold_int32_fun2207(f0, end0, start0, _ctx); /*(x1 : 1380) -> 1381 1380*/
      return kk_std_core_hnd_yield_extend(_x2206, _ctx);
    }
    {
      int32_t _own_2133 = (int32_t)((uint32_t)start0 + (uint32_t)((KK_I32(1)))); /*int32*/;
      { // tailcall
        start0 = _own_2133;
        init = x0_1994;
        goto kk__tailcall;
      }
    }
  }
}
 
// monadic lift

kk_box_t kk_std_num_int32__mlift1991_fold_while_int32(int32_t end, kk_function_t f, kk_box_t init, int32_t start, kk_std_core_types__maybe _y_1970, kk_context_t* _ctx) { /* forall<a,e> (end : int32, f : (int32, a) -> e maybe<a>, init : a, start : int32, maybe<a>) -> e a */ 
  if (kk_std_core_types__is_Just(_y_1970, _ctx)) {
    kk_box_t x = _y_1970._cons.Just.value;
    kk_box_drop(init, _ctx);
    int32_t _x2208 = (int32_t)((uint32_t)start + (uint32_t)((KK_I32(1)))); /*int32*/
    return kk_std_num_int32_fold_while_int32(_x2208, end, x, f, _ctx);
  }
  {
    kk_function_drop(f, _ctx);
    return init;
  }
}


// lift anonymous function
struct kk_std_num_int32_fold_while_int32_fun2211__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_box_t init0;
  int32_t end0;
  int32_t start0;
};
static kk_box_t kk_std_num_int32_fold_while_int32_fun2211(kk_function_t _fself, kk_box_t _b_2078, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32_new_fold_while_int32_fun2211(kk_function_t f0, kk_box_t init0, int32_t end0, int32_t start0, kk_context_t* _ctx) {
  struct kk_std_num_int32_fold_while_int32_fun2211__t* _self = kk_function_alloc_as(struct kk_std_num_int32_fold_while_int32_fun2211__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_int32_fold_while_int32_fun2211, kk_context());
  _self->f0 = f0;
  _self->init0 = init0;
  _self->end0 = end0;
  _self->start0 = start0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_int32_fold_while_int32_fun2211(kk_function_t _fself, kk_box_t _b_2078, kk_context_t* _ctx) {
  struct kk_std_num_int32_fold_while_int32_fun2211__t* _self = kk_function_as(struct kk_std_num_int32_fold_while_int32_fun2211__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int32, 1433) -> 1434 maybe<1433> */
  kk_box_t init0 = _self->init0; /* 1433 */
  int32_t end0 = _self->end0; /* int32 */
  int32_t start0 = _self->start0; /* int32 */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_box_dup(init0, _ctx);;;}, {}, _ctx)
  kk_std_core_types__maybe _x2212 = kk_std_core_types__maybe_unbox(_b_2078, KK_OWNED, _ctx); /*maybe<1433>*/
  return kk_std_num_int32__mlift1991_fold_while_int32(end0, f0, init0, start0, _x2212, _ctx);
}

kk_box_t kk_std_num_int32_fold_while_int32(int32_t start0, int32_t end0, kk_box_t init0, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,e> (start : int32, end : int32, init : a, f : (int32, a) -> e maybe<a>) -> e a */ 
  kk__tailcall: ;
  bool _match_2129 = (start0 >= end0); /*bool*/;
  if (_match_2129) {
    kk_function_drop(f0, _ctx);
    return init0;
  }
  {
    kk_std_core_types__maybe x0_1997;
    kk_function_t _x2210 = kk_function_dup(f0, _ctx); /*(int32, 1433) -> 1434 maybe<1433>*/
    kk_box_t _x2209 = kk_box_dup(init0, _ctx); /*1433*/
    x0_1997 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, int32_t, kk_box_t, kk_context_t*), _x2210, (_x2210, start0, _x2209, _ctx), _ctx); /*maybe<1433>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_1997, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_num_int32_new_fold_while_int32_fun2211(f0, init0, end0, start0, _ctx), _ctx);
    }
    if (kk_std_core_types__is_Just(x0_1997, _ctx)) {
      kk_box_t x1 = x0_1997._cons.Just.value;
      kk_box_drop(init0, _ctx);
      { // tailcall
        int32_t _x2213 = (int32_t)((uint32_t)start0 + (uint32_t)((KK_I32(1)))); /*int32*/
        start0 = _x2213;
        init0 = x1;
        goto kk__tailcall;
      }
    }
    {
      kk_function_drop(f0, _ctx);
      return init0;
    }
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_num_int32__mlift1992_lift1935_for_while32(kk_function_t action, int32_t end, int32_t i, kk_std_core_types__maybe _y_1974, kk_context_t* _ctx) { /* forall<a,e> (action : (int32) -> e maybe<a>, end : int32, i : int32, maybe<a>) -> e maybe<a> */ 
  if (kk_std_core_types__is_Nothing(_y_1974, _ctx)) {
    int32_t i0_1947 = (int32_t)((uint32_t)i + (uint32_t)((KK_I32(1)))); /*int32*/;
    return kk_std_num_int32__lift1935_for_while32(action, end, i0_1947, _ctx);
  }
  {
    kk_box_t x = _y_1974._cons.Just.value;
    kk_function_drop(action, _ctx);
    return kk_std_core_types__new_Just(x, _ctx);
  }
}
 
// lifted local: for-while32, rep


// lift anonymous function
struct kk_std_num_int32__lift1935_for_while32_fun2216__t {
  struct kk_function_s _base;
  kk_function_t action0;
  int32_t end0;
  int32_t i0;
};
static kk_box_t kk_std_num_int32__lift1935_for_while32_fun2216(kk_function_t _fself, kk_box_t _b_2082, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32__new_lift1935_for_while32_fun2216(kk_function_t action0, int32_t end0, int32_t i0, kk_context_t* _ctx) {
  struct kk_std_num_int32__lift1935_for_while32_fun2216__t* _self = kk_function_alloc_as(struct kk_std_num_int32__lift1935_for_while32_fun2216__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_int32__lift1935_for_while32_fun2216, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_int32__lift1935_for_while32_fun2216(kk_function_t _fself, kk_box_t _b_2082, kk_context_t* _ctx) {
  struct kk_std_num_int32__lift1935_for_while32_fun2216__t* _self = kk_function_as(struct kk_std_num_int32__lift1935_for_while32_fun2216__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (int32) -> 1488 maybe<1487> */
  int32_t end0 = _self->end0; /* int32 */
  int32_t i0 = _self->i0; /* int32 */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);;;}, {}, _ctx)
  kk_std_core_types__maybe _y_2084_19740 = kk_std_core_types__maybe_unbox(_b_2082, KK_OWNED, _ctx); /*maybe<1487>*/;
  kk_std_core_types__maybe _x2217 = kk_std_num_int32__mlift1992_lift1935_for_while32(action0, end0, i0, _y_2084_19740, _ctx); /*maybe<1487>*/
  return kk_std_core_types__maybe_box(_x2217, _ctx);
}

kk_std_core_types__maybe kk_std_num_int32__lift1935_for_while32(kk_function_t action0, int32_t end0, int32_t i0, kk_context_t* _ctx) { /* forall<a,e> (action : (int32) -> e maybe<a>, end : int32, i : int32) -> e maybe<a> */ 
  kk__tailcall: ;
  bool _match_2127 = (i0 <= end0); /*bool*/;
  if (_match_2127) {
    kk_std_core_types__maybe x0_2000;
    kk_function_t _x2214 = kk_function_dup(action0, _ctx); /*(int32) -> 1488 maybe<1487>*/
    x0_2000 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, int32_t, kk_context_t*), _x2214, (_x2214, i0, _ctx), _ctx); /*maybe<1487>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_2000, _ctx);
      kk_box_t _x2215 = kk_std_core_hnd_yield_extend(kk_std_num_int32__new_lift1935_for_while32_fun2216(action0, end0, i0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x2215, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x0_2000, _ctx)) {
      int32_t i0_19470 = (int32_t)((uint32_t)i0 + (uint32_t)((KK_I32(1)))); /*int32*/;
      { // tailcall
        i0 = i0_19470;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t x1 = x0_2000._cons.Just.value;
      kk_function_drop(action0, _ctx);
      return kk_std_core_types__new_Just(x1, _ctx);
    }
  }
  {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// monadic lift

kk_unit_t kk_std_num_int32__mlift1993_lift1936_for32(kk_function_t action, int32_t end, int32_t i, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<e> (action : (int32) -> e (), end : int32, i : int32, wild_ : ()) -> e () */ 
  int32_t i0_1948 = (int32_t)((uint32_t)i + (uint32_t)((KK_I32(1)))); /*int32*/;
  kk_std_num_int32__lift1936_for32(action, end, i0_1948, _ctx); return kk_Unit;
}
 
// lifted local: for32, rep


// lift anonymous function
struct kk_std_num_int32__lift1936_for32_fun2220__t {
  struct kk_function_s _base;
  kk_function_t action0;
  int32_t end0;
  int32_t i0;
};
static kk_box_t kk_std_num_int32__lift1936_for32_fun2220(kk_function_t _fself, kk_box_t _b_2086, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32__new_lift1936_for32_fun2220(kk_function_t action0, int32_t end0, int32_t i0, kk_context_t* _ctx) {
  struct kk_std_num_int32__lift1936_for32_fun2220__t* _self = kk_function_alloc_as(struct kk_std_num_int32__lift1936_for32_fun2220__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_int32__lift1936_for32_fun2220, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_int32__lift1936_for32_fun2220(kk_function_t _fself, kk_box_t _b_2086, kk_context_t* _ctx) {
  struct kk_std_num_int32__lift1936_for32_fun2220__t* _self = kk_function_as(struct kk_std_num_int32__lift1936_for32_fun2220__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (int32) -> 1527 () */
  int32_t end0 = _self->end0; /* int32 */
  int32_t i0 = _self->i0; /* int32 */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);;;}, {}, _ctx)
  kk_unit_t wild__0_2088 = kk_Unit;
  kk_unit_unbox(_b_2086);
  kk_unit_t _x2221 = kk_Unit;
  kk_std_num_int32__mlift1993_lift1936_for32(action0, end0, i0, wild__0_2088, _ctx);
  return kk_unit_box(_x2221);
}

kk_unit_t kk_std_num_int32__lift1936_for32(kk_function_t action0, int32_t end0, int32_t i0, kk_context_t* _ctx) { /* forall<e> (action : (int32) -> e (), end : int32, i : int32) -> e () */ 
  kk__tailcall: ;
  bool _match_2125 = (i0 <= end0); /*bool*/;
  if (_match_2125) {
    kk_unit_t x_2003 = kk_Unit;
    kk_function_t _x2218 = kk_function_dup(action0, _ctx); /*(int32) -> 1527 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, int32_t, kk_context_t*), _x2218, (_x2218, i0, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x2219 = kk_std_core_hnd_yield_extend(kk_std_num_int32__new_lift1936_for32_fun2220(action0, end0, i0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x2219); return kk_Unit;
    }
    {
      int32_t i0_19480 = (int32_t)((uint32_t)i0 + (uint32_t)((KK_I32(1)))); /*int32*/;
      { // tailcall
        i0 = i0_19480;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}

kk_std_core__list kk_std_num_int32__trmc_list32(int32_t lo, int32_t hi, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int32, hi : int32, ctx<list<int32>>) -> total list<int32> */ 
  kk__tailcall: ;
  bool _match_2124 = (lo <= hi); /*bool*/;
  if (_match_2124) {
    kk_std_core__list _trmc_1952 = kk_datatype_null(); /*list<int32>*/;
    kk_std_core__list _trmc_1953 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_int32_box(lo, _ctx), _trmc_1952, _ctx); /*list<int32>*/;
    kk_box_t* _b_2103_2098 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_1953, _ctx)->tail)); /*field-addr<list<int32>>*/;
    { // tailcall
      int32_t _x2224 = (int32_t)((uint32_t)lo + (uint32_t)((KK_I32(1)))); /*int32*/
      kk_std_core_types__cctx _x2225 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_1953, _ctx)),_b_2103_2098,true,kk_context()); /*ctx<0>*/
      lo = _x2224;
      _acc = _x2225;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x2226 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x2226, KK_OWNED, _ctx);
  }
}

kk_std_core__list kk_std_num_int32_list32(int32_t lo0, int32_t hi0, kk_context_t* _ctx) { /* (lo : int32, hi : int32) -> total list<int32> */ 
  kk_std_core_types__cctx _x2227 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_num_int32__trmc_list32(lo0, hi0, _x2227, _ctx);
}
 
// The maximal integer value before overflow happens

int32_t kk_std_num_int32_max_int32;
 
// Show an `:int32` in hexadecimal notation interpreted as an unsigned 32-bit value.
// The `width`  parameter specifies how wide the hex value is where `'0'`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number.

kk_string_t kk_std_num_int32_show_hex32(int32_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int32, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_integer_t _x2229 = kk_std_num_int32_uint(i, _ctx); /*int*/
  kk_std_core_types__optional _x2230;
  kk_box_t _x2231;
  kk_integer_t _x2232;
  if (kk_std_core_types__is_Optional(width, _ctx)) {
    kk_box_t _box_x2109 = width._cons.Optional.value;
    kk_integer_t _width_1763 = kk_integer_unbox(_box_x2109, _ctx);
    kk_integer_dup(_width_1763, _ctx);
    kk_std_core_types__optional_drop(width, _ctx);
    _x2232 = _width_1763; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(width, _ctx);
    _x2232 = kk_integer_from_small(8); /*int*/
  }
  _x2231 = kk_integer_box(_x2232, _ctx); /*116*/
  _x2230 = kk_std_core_types__new_Optional(_x2231, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2233;
  kk_box_t _x2234;
  bool _x2235;
  if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
    kk_box_t _box_x2111 = use_capitals._cons.Optional.value;
    bool _use_capitals_1767 = kk_bool_unbox(_box_x2111);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2235 = _use_capitals_1767; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2235 = true; /*bool*/
  }
  _x2234 = kk_bool_box(_x2235); /*116*/
  _x2233 = kk_std_core_types__new_Optional(_x2234, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2236;
  kk_box_t _x2237;
  kk_string_t _x2238;
  if (kk_std_core_types__is_Optional(pre, _ctx)) {
    kk_box_t _box_x2113 = pre._cons.Optional.value;
    kk_string_t _pre_1771 = kk_string_unbox(_box_x2113);
    kk_string_dup(_pre_1771, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    _x2238 = _pre_1771; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_define_string_literal(, _s2239, 2, "0x", _ctx)
    _x2238 = kk_string_dup(_s2239, _ctx); /*string*/
  }
  _x2237 = kk_string_box(_x2238); /*116*/
  _x2236 = kk_std_core_types__new_Optional(_x2237, _ctx); /*optional<116>*/
  return kk_std_core_show_hex(_x2229, _x2230, _x2233, _x2236, _ctx);
}

int32_t kk_std_num_int32_sumacc32(kk_std_core__list xs, int32_t acc, kk_context_t* _ctx) { /* (xs : list<int32>, acc : int32) -> int32 */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con2240 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x2118 = _con2240->head;
    kk_std_core__list xx = _con2240->tail;
    int32_t x = kk_int32_unbox(_box_x2118, KK_BORROWED, _ctx);
    int32_t _own_2123 = (int32_t)((uint32_t)acc + (uint32_t)x); /*int32*/;
    { // tailcall
      xs = xx;
      acc = _own_2123;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}
 
// Convert an `:int` to `:int32` but interpret the `int` as an unsigned 32-bit value.
// `i` is clamped between `0` and `0xFFFFFFFF`.
// `0x7FFF_FFFF.uint32 == 0x7FFF_FFFF.int32 == max-int32`
// `0x8000_0000.uint32 == -0x8000_0000.int32 == min-int32`
// `0xFFFF_FFFF.uint32 == -1.int32`

int32_t kk_std_num_int32_uint32(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int32 */ 
  kk_integer_t _x2241;
  bool _match_2119;
  kk_integer_t _brw_2120 = kk_integer_from_int(kk_std_num_int32_max_int32,kk_context()); /*int*/;
  bool _brw_2121 = kk_integer_gt_borrow(i,_brw_2120,kk_context()); /*bool*/;
  kk_integer_drop(_brw_2120, _ctx);
  _match_2119 = _brw_2121; /*bool*/
  if (_match_2119) {
    _x2241 = kk_integer_sub(i,(kk_integer_from_str("4294967296", _ctx)),kk_context()); /*int*/
  }
  else {
    _x2241 = i; /*int*/
  }
  return kk_std_core_int32(_x2241, _ctx);
}

// initialization
void kk_std_num_int32__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_num_int32_one = (KK_I32(1)); /*int32*/
  }
  {
    kk_std_num_int32_zero = (KK_I32(0)); /*int32*/
  }
  {
    kk_std_num_int32_min_int32 = (INT32_MIN); /*int32*/
  }
  {
    kk_std_num_int32_bits_int32 = (KK_I32(32)); /*int32*/
  }
  {
    kk_std_num_int32_max_int32 = (KK_I32(2147483647)); /*int32*/
  }
}

// termination
void kk_std_num_int32__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
