// Koka generated module: "std/num/int64", koka version: 2.4.2, platform: 64-bit
#include "std_num_int64.h"
 
// Show an `:int64` in hexadecimal notation
// The `width`  parameter specifies how wide the hex value is where `'0'`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number (goes between the sign and the number).

kk_string_t kk_std_num_int64_show_hex(int64_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int64, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_integer_t _x2127 = kk_integer_from_int64(i,kk_context()); /*int*/
  kk_std_core_types__optional _x2128;
  kk_box_t _x2129;
  kk_integer_t _x2130;
  if (kk_std_core_types__is_Optional(width, _ctx)) {
    kk_box_t _box_x1975 = width._cons.Optional.value;
    kk_integer_t _width_308 = kk_integer_unbox(_box_x1975, _ctx);
    kk_integer_dup(_width_308, _ctx);
    kk_std_core_types__optional_drop(width, _ctx);
    _x2130 = _width_308; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(width, _ctx);
    _x2130 = kk_integer_from_small(1); /*int*/
  }
  _x2129 = kk_integer_box(_x2130, _ctx); /*116*/
  _x2128 = kk_std_core_types__new_Optional(_x2129, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2131;
  kk_box_t _x2132;
  bool _x2133;
  if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
    kk_box_t _box_x1977 = use_capitals._cons.Optional.value;
    bool _use_capitals_312 = kk_bool_unbox(_box_x1977);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2133 = _use_capitals_312; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2133 = true; /*bool*/
  }
  _x2132 = kk_bool_box(_x2133); /*116*/
  _x2131 = kk_std_core_types__new_Optional(_x2132, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2134;
  kk_box_t _x2135;
  kk_string_t _x2136;
  if (kk_std_core_types__is_Optional(pre, _ctx)) {
    kk_box_t _box_x1979 = pre._cons.Optional.value;
    kk_string_t _pre_316 = kk_string_unbox(_box_x1979);
    kk_string_dup(_pre_316, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    _x2136 = _pre_316; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_define_string_literal(, _s2137, 2, "0x", _ctx)
    _x2136 = kk_string_dup(_s2137, _ctx); /*string*/
  }
  _x2135 = kk_string_box(_x2136); /*116*/
  _x2134 = kk_std_core_types__new_Optional(_x2135, _ctx); /*optional<116>*/
  return kk_std_core_show_hex(_x2127, _x2128, _x2131, _x2134, _ctx);
}

int64_t kk_std_num_int64_one;

int64_t kk_std_num_int64_zero;
 
// The maximal integer value before overflow happens

int64_t kk_std_num_int64_max_int64;
 
// Convert an `:int` to `:int64` but interpret the `int` as an unsigned 64-bit value.
// `i` is clamped between `0` and `0xFFFF_FFFF_FFFF_FFFF`.
// `0x7FFF_FFFF_FFFF_FFFF.uint64 == 0x7FFF_FFFF_FFFF_FFFF.int64 == max-int64`
// `0x8000_0000_0000_0000.uint64 == -0x8000_0000_0000_0000.int64 == min-int64`
// `0xFFFF_FFFF_FFFF_FFFF.uint64 == -1.int64`

int64_t kk_std_num_int64_uint64_1(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int64 */ 
  kk_integer_t _x2142;
  bool _match_2111;
  kk_integer_t _brw_2112 = kk_integer_from_int64(kk_std_num_int64_max_int64,kk_context()); /*int*/;
  bool _brw_2113 = kk_integer_gt_borrow(i,_brw_2112,kk_context()); /*bool*/;
  kk_integer_drop(_brw_2112, _ctx);
  _match_2111 = _brw_2113; /*bool*/
  if (_match_2111) {
    _x2142 = kk_integer_sub(i,(kk_integer_from_str("18446744073709551616", _ctx)),kk_context()); /*int*/
  }
  else {
    _x2142 = i; /*int*/
  }
  return kk_std_core_int64(_x2142, _ctx);
}
 
// The minimal integer value before underflow happens

int64_t kk_std_num_int64_min_int64;
 
// Euclidean-0 modulus. See `(/):(x : int64, y : int64) -> int64` division for more information.

int64_t kk_std_num_int64__lp__perc__rp_(int64_t x, int64_t y, kk_context_t* _ctx) { /* (x : int64, y : int64) -> int64 */ 
  bool _match_2104;
  int64_t _x2143 = (KK_I64(0)); /*int64*/
  _match_2104 = (y == _x2143); /*bool*/
  if (_match_2104) {
    return x;
  }
  {
    bool _match_2105;
    int64_t _x2144 = (KK_I64(-1)); /*int64*/
    _match_2105 = (y == _x2144); /*bool*/
    if (_match_2105) {
      bool _match_2108 = (x == kk_std_num_int64_min_int64); /*bool*/;
      if (_match_2108) {
        return (KK_I64(0));
      }
      {
        int64_t r = x % y; /*int64*/;
        bool _match_2109;
        int64_t _x2145 = (KK_I64(0)); /*int64*/
        _match_2109 = (r >= _x2145); /*bool*/
        if (_match_2109) {
          return r;
        }
        {
          bool _match_2110;
          int64_t _x2146 = (KK_I64(0)); /*int64*/
          _match_2110 = (y > _x2146); /*bool*/
          if (_match_2110) {
            return (int64_t)((uint64_t)r + (uint64_t)y);
          }
          {
            return (int64_t)((uint64_t)r - (uint64_t)y);
          }
        }
      }
    }
    {
      int64_t r0 = x % y; /*int64*/;
      bool _match_2106;
      int64_t _x2147 = (KK_I64(0)); /*int64*/
      _match_2106 = (r0 >= _x2147); /*bool*/
      if (_match_2106) {
        return r0;
      }
      {
        bool _match_2107;
        int64_t _x2148 = (KK_I64(0)); /*int64*/
        _match_2107 = (y > _x2148); /*bool*/
        if (_match_2107) {
          return (int64_t)((uint64_t)r0 + (uint64_t)y);
        }
        {
          return (int64_t)((uint64_t)r0 - (uint64_t)y);
        }
      }
    }
  }
}
 
/*
Euclidean-0 division.
Euclidean division is defined as: For any `D`  and `d`  where `d!=0` , we have:
1. `D == d*(D/d) + (D%d)`
2. `D%d`  is always positive where `0 <= D%d < abs(d)`
Moreover, Euclidean-0 is a total function, for the case where `d==0`  we have
that `D%0 == D`  and `D/0 == 0` . So property (1) still holds, but not property (2).
Useful laws that hold for Euclidean-0 division:
* `D/(-d) == -(D/d)`
* `D%(-d) == D%d`
* `D/(2^n) == sar(D,n)         `  (with `0 <= n <= 31`)
* `D%(2^n) == D & ((2^n) - 1)  `  (with `0 <= n <= 31`)
Note that an interesting edge case is `min-int64 / -1` which equals `min-int64` since in modulo 64-bit
arithmetic `min-int64 == -1 * min-int64 == -1 * (min-int64 / -1) + (min-int64 % -1)` satisfying property (1).
Of course `(min-int64 + 1) / -1` is again positive (namely `max-int64`).
See also _Division and modulus for computer scientists, Daan Leijen, 2001_
[pdf](http://research.microsoft.com/pubs/151917/divmodnote.pdf) .
*/

int64_t kk_std_num_int64__lp__fs__rp_(int64_t x, int64_t y, kk_context_t* _ctx) { /* (x : int64, y : int64) -> int64 */ 
  bool _match_2097;
  int64_t _x2151 = (KK_I64(0)); /*int64*/
  _match_2097 = (y == _x2151); /*bool*/
  if (_match_2097) {
    return (KK_I64(0));
  }
  {
    bool _match_2098;
    int64_t _x2152 = (KK_I64(-1)); /*int64*/
    _match_2098 = (y == _x2152); /*bool*/
    if (_match_2098) {
      bool _match_2101 = (x == kk_std_num_int64_min_int64); /*bool*/;
      if (_match_2101) {
        return x;
      }
      {
        int64_t q = x / y; /*int64*/;
        int64_t r = x % y; /*int64*/;
        bool _match_2102;
        int64_t _x2153 = (KK_I64(0)); /*int64*/
        _match_2102 = (r >= _x2153); /*bool*/
        if (_match_2102) {
          return q;
        }
        {
          bool _match_2103;
          int64_t _x2154 = (KK_I64(0)); /*int64*/
          _match_2103 = (y > _x2154); /*bool*/
          if (_match_2103) {
            int64_t _x2155 = (KK_I64(1)); /*int64*/
            return (int64_t)((uint64_t)q - (uint64_t)_x2155);
          }
          {
            int64_t _x2156 = (KK_I64(1)); /*int64*/
            return (int64_t)((uint64_t)q + (uint64_t)_x2156);
          }
        }
      }
    }
    {
      int64_t q0 = x / y; /*int64*/;
      int64_t r0 = x % y; /*int64*/;
      bool _match_2099;
      int64_t _x2157 = (KK_I64(0)); /*int64*/
      _match_2099 = (r0 >= _x2157); /*bool*/
      if (_match_2099) {
        return q0;
      }
      {
        bool _match_2100;
        int64_t _x2158 = (KK_I64(0)); /*int64*/
        _match_2100 = (y > _x2158); /*bool*/
        if (_match_2100) {
          int64_t _x2159 = (KK_I64(1)); /*int64*/
          return (int64_t)((uint64_t)q0 - (uint64_t)_x2159);
        }
        {
          int64_t _x2160 = (KK_I64(1)); /*int64*/
          return (int64_t)((uint64_t)q0 + (uint64_t)_x2160);
        }
      }
    }
  }
}
 
// Return the absolute value of an integer.
// Raises an exception if the `:int64` is `min-int64`
// (since the negation of `min-int64` equals itself and is still negative)


// lift anonymous function
struct kk_std_num_int64_abs_fun2163__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_int64_abs_fun2163(kk_function_t _fself, kk_box_t _b_1986, kk_context_t* _ctx);
static kk_function_t kk_std_num_int64_new_abs_fun2163(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_int64_abs_fun2163, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_int64_abs_fun2163(kk_function_t _fself, kk_box_t _b_1986, kk_context_t* _ctx) {
  kk_unused(_fself);
  bool _x2164;
  bool b_1993 = kk_bool_unbox(_b_1986); /*bool*/;
  if (b_1993) {
    _x2164 = false; /*bool*/
  }
  else {
    _x2164 = true; /*bool*/
  }
  return kk_bool_box(_x2164);
}

int64_t kk_std_num_int64_abs(int64_t i, kk_context_t* _ctx) { /* (i : int64) -> exn int64 */ 
  bool _x1_1964 = 0 > i; /*bool*/;
  bool _match_2095;
  kk_box_t _x2162 = kk_std_core_hnd__open_none1(kk_std_num_int64_new_abs_fun2163(_ctx), kk_bool_box(_x1_1964), _ctx); /*3357*/
  _match_2095 = kk_bool_unbox(_x2162); /*bool*/
  if (_match_2095) {
    return i;
  }
  {
    bool _match_2096 = (i > kk_std_num_int64_min_int64); /*bool*/;
    if (_match_2096) {
      int64_t _x2165 = (KK_I64(0)); /*int64*/
      return (int64_t)((uint64_t)_x2165 - (uint64_t)i);
    }
    {
      kk_box_t _x2166;
      kk_string_t _x2167;
      kk_define_string_literal(, _s2168, 79, "std/num/int64/abs: cannot make min-int64 into a positive int64 without overflow", _ctx)
      _x2167 = kk_string_dup(_s2168, _ctx); /*string*/
      _x2166 = kk_std_core_throw(_x2167, kk_std_core_types__new_None(_ctx), _ctx); /*11930*/
      return kk_int64_unbox(_x2166, KK_OWNED, _ctx);
    }
  }
}
 
// Return the absolute value of an integer.
// Returns 0 if the `:int64` is `min-int64`
// (since the negation of `min-int64` equals itself and is still negative)

int64_t kk_std_num_int64_abs0(int64_t i, kk_context_t* _ctx) { /* (i : int64) -> int64 */ 
  bool b_1929 = 0 > i; /*bool*/;
  if (b_1929) {
    bool _match_2094 = (i > kk_std_num_int64_min_int64); /*bool*/;
    if (_match_2094) {
      int64_t _x2169 = (KK_I64(0)); /*int64*/
      return (int64_t)((uint64_t)_x2169 - (uint64_t)i);
    }
    {
      return (KK_I64(0));
    }
  }
  {
    return i;
  }
}
 
// The number of bits in an `:int64` (always 64)

int64_t kk_std_num_int64_bits_int64;
 
// Truncated division (as in C). See also `(/):(x : int64, y : int64) -> int64`.

int64_t kk_std_num_int64_cdiv(int64_t i, int64_t j, kk_context_t* _ctx) { /* (i : int64, j : int64) -> exn int64 */ 
  bool _match_2091 = 0 == j; /*bool*/;
  if (_match_2091) {
    kk_box_t _x2170;
    kk_string_t _x2171;
    kk_define_string_literal(, _s2172, 36, "std/num/int64/cdiv: division by zero", _ctx)
    _x2171 = kk_string_dup(_s2172, _ctx); /*string*/
    _x2170 = kk_std_core_throw(_x2171, kk_std_core_types__new_None(_ctx), _ctx); /*11930*/
    return kk_int64_unbox(_x2170, KK_OWNED, _ctx);
  }
  {
    bool _match_2092;
    int64_t _x2173 = (KK_I64(-1)); /*int64*/
    _match_2092 = (j == _x2173); /*bool*/
    if (_match_2092) {
      bool _match_2093 = (i == kk_std_num_int64_min_int64); /*bool*/;
      if (_match_2093) {
        kk_box_t _x2174;
        kk_string_t _x2175;
        kk_define_string_literal(, _s2176, 66, "std/num/int64/cdiv: division overflow in cdiv(min-int64, -1.int64)", _ctx)
        _x2175 = kk_string_dup(_s2176, _ctx); /*string*/
        _x2174 = kk_std_core_throw(_x2175, kk_std_core_types__new_None(_ctx), _ctx); /*11930*/
        return kk_int64_unbox(_x2174, KK_OWNED, _ctx);
      }
      {
        return i / j;
      }
    }
    {
      return i / j;
    }
  }
}
 
// Truncated modulus (as in C). See also `(%):(x : int64, y : int64) -> int64`.

int64_t kk_std_num_int64_cmod(int64_t i, int64_t j, kk_context_t* _ctx) { /* (i : int64, j : int64) -> exn int64 */ 
  bool _match_2088 = 0 == j; /*bool*/;
  if (_match_2088) {
    kk_box_t _x2177;
    kk_string_t _x2178;
    kk_define_string_literal(, _s2179, 35, "std/num/int64/cmod: modulus by zero", _ctx)
    _x2178 = kk_string_dup(_s2179, _ctx); /*string*/
    _x2177 = kk_std_core_throw(_x2178, kk_std_core_types__new_None(_ctx), _ctx); /*11930*/
    return kk_int64_unbox(_x2177, KK_OWNED, _ctx);
  }
  {
    bool _match_2089;
    int64_t _x2180 = (KK_I64(-1)); /*int64*/
    _match_2089 = (j == _x2180); /*bool*/
    if (_match_2089) {
      bool _match_2090 = (i == kk_std_num_int64_min_int64); /*bool*/;
      if (_match_2090) {
        kk_box_t _x2181;
        kk_string_t _x2182;
        kk_define_string_literal(, _s2183, 65, "std/num/int64/cmod: modulus overflow in cmod(min-int64, -1.int64)", _ctx)
        _x2182 = kk_string_dup(_s2183, _ctx); /*string*/
        _x2181 = kk_std_core_throw(_x2182, kk_std_core_types__new_None(_ctx), _ctx); /*11930*/
        return kk_int64_unbox(_x2181, KK_OWNED, _ctx);
      }
      {
        return i % j;
      }
    }
    {
      return i % j;
    }
  }
}

kk_std_core_types__tuple2_ kk_std_num_int64_divmod(int64_t x, int64_t y, kk_context_t* _ctx) { /* (x : int64, y : int64) -> (int64, int64) */ 
  bool _match_2081 = 0 == y; /*bool*/;
  if (_match_2081) {
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_int64_box(kk_std_num_int64_zero, _ctx), kk_int64_box(x, _ctx), _ctx);
  }
  {
    bool _match_2082;
    int64_t _x2184 = (KK_I64(-1)); /*int64*/
    _match_2082 = (y == _x2184); /*bool*/
    if (_match_2082) {
      bool _match_2085 = (x == kk_std_num_int64_min_int64); /*bool*/;
      if (_match_2085) {
        int64_t _b_2029_2013 = (KK_I64(0)); /*int64*/;
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_int64_box(x, _ctx), kk_int64_box(_b_2029_2013, _ctx), _ctx);
      }
      {
        int64_t q = x / y; /*int64*/;
        int64_t r = x % y; /*int64*/;
        bool _match_2086;
        int64_t _x2185 = (KK_I64(0)); /*int64*/
        _match_2086 = (r >= _x2185); /*bool*/
        if (_match_2086) {
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_int64_box(q, _ctx), kk_int64_box(r, _ctx), _ctx);
        }
        {
          bool _match_2087;
          int64_t _x2186 = (KK_I64(0)); /*int64*/
          _match_2087 = (y > _x2186); /*bool*/
          if (_match_2087) {
            int64_t _b_2032_2016;
            int64_t _x2187 = (KK_I64(1)); /*int64*/
            _b_2032_2016 = (int64_t)((uint64_t)q - (uint64_t)_x2187); /*int64*/
            int64_t _b_2033_2017 = (int64_t)((uint64_t)r + (uint64_t)y); /*int64*/;
            return kk_std_core_types__new_dash__lp__comma__rp_(kk_int64_box(_b_2032_2016, _ctx), kk_int64_box(_b_2033_2017, _ctx), _ctx);
          }
          {
            int64_t _b_2034_2018;
            int64_t _x2188 = (KK_I64(1)); /*int64*/
            _b_2034_2018 = (int64_t)((uint64_t)q + (uint64_t)_x2188); /*int64*/
            int64_t _b_2035_2019 = (int64_t)((uint64_t)r - (uint64_t)y); /*int64*/;
            return kk_std_core_types__new_dash__lp__comma__rp_(kk_int64_box(_b_2034_2018, _ctx), kk_int64_box(_b_2035_2019, _ctx), _ctx);
          }
        }
      }
    }
    {
      int64_t q0 = x / y; /*int64*/;
      int64_t r0 = x % y; /*int64*/;
      bool _match_2083;
      int64_t _x2189 = (KK_I64(0)); /*int64*/
      _match_2083 = (r0 >= _x2189); /*bool*/
      if (_match_2083) {
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_int64_box(q0, _ctx), kk_int64_box(r0, _ctx), _ctx);
      }
      {
        bool _match_2084;
        int64_t _x2190 = (KK_I64(0)); /*int64*/
        _match_2084 = (y > _x2190); /*bool*/
        if (_match_2084) {
          int64_t _b_2038_2022;
          int64_t _x2191 = (KK_I64(1)); /*int64*/
          _b_2038_2022 = (int64_t)((uint64_t)q0 - (uint64_t)_x2191); /*int64*/
          int64_t _b_2039_2023 = (int64_t)((uint64_t)r0 + (uint64_t)y); /*int64*/;
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_int64_box(_b_2038_2022, _ctx), kk_int64_box(_b_2039_2023, _ctx), _ctx);
        }
        {
          int64_t _b_2040_2024;
          int64_t _x2192 = (KK_I64(1)); /*int64*/
          _b_2040_2024 = (int64_t)((uint64_t)q0 + (uint64_t)_x2192); /*int64*/
          int64_t _b_2041_2025 = (int64_t)((uint64_t)r0 - (uint64_t)y); /*int64*/;
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_int64_box(_b_2040_2024, _ctx), kk_int64_box(_b_2041_2025, _ctx), _ctx);
        }
      }
    }
  }
}
 
// monadic lift

kk_box_t kk_std_num_int64__mlift1965_fold_int64(int64_t end, kk_function_t f, int64_t start, kk_box_t x, kk_context_t* _ctx) { /* forall<a,e> (end : int64, f : (int64, a) -> e a, start : int64, x : a) -> e a */ 
  int64_t _x2194;
  int64_t _x2195 = (KK_I64(1)); /*int64*/
  _x2194 = (int64_t)((uint64_t)start + (uint64_t)_x2195); /*int64*/
  return kk_std_num_int64_fold_int64(_x2194, end, x, f, _ctx);
}


// lift anonymous function
struct kk_std_num_int64_fold_int64_fun2197__t {
  struct kk_function_s _base;
  kk_function_t f0;
  int64_t end0;
  int64_t start0;
};
static kk_box_t kk_std_num_int64_fold_int64_fun2197(kk_function_t _fself, kk_box_t x1, kk_context_t* _ctx);
static kk_function_t kk_std_num_int64_new_fold_int64_fun2197(kk_function_t f0, int64_t end0, int64_t start0, kk_context_t* _ctx) {
  struct kk_std_num_int64_fold_int64_fun2197__t* _self = kk_function_alloc_as(struct kk_std_num_int64_fold_int64_fun2197__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_int64_fold_int64_fun2197, kk_context());
  _self->f0 = f0;
  _self->end0 = end0;
  _self->start0 = start0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_int64_fold_int64_fun2197(kk_function_t _fself, kk_box_t x1, kk_context_t* _ctx) {
  struct kk_std_num_int64_fold_int64_fun2197__t* _self = kk_function_as(struct kk_std_num_int64_fold_int64_fun2197__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int64, 1563) -> 1564 1563 */
  int64_t end0 = _self->end0; /* int64 */
  int64_t start0 = _self->start0; /* int64 */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);;;}, {}, _ctx)
  return kk_std_num_int64__mlift1965_fold_int64(end0, f0, start0, x1, _ctx);
}

kk_box_t kk_std_num_int64_fold_int64(int64_t start0, int64_t end0, kk_box_t init, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,e> (start : int64, end : int64, init : a, f : (int64, a) -> e a) -> e a */ 
  kk__tailcall: ;
  bool _match_2079 = (start0 >= end0); /*bool*/;
  if (_match_2079) {
    kk_function_drop(f0, _ctx);
    return init;
  }
  {
    kk_box_t x0_1967;
    kk_function_t _x2196 = kk_function_dup(f0, _ctx); /*(int64, 1563) -> 1564 1563*/
    x0_1967 = kk_function_call(kk_box_t, (kk_function_t, int64_t, kk_box_t, kk_context_t*), _x2196, (_x2196, start0, init, _ctx), _ctx); /*1563*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_1967, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_num_int64_new_fold_int64_fun2197(f0, end0, start0, _ctx), _ctx);
    }
    { // tailcall
      int64_t _x2198;
      int64_t _x2199 = (KK_I64(1)); /*int64*/
      _x2198 = (int64_t)((uint64_t)start0 + (uint64_t)_x2199); /*int64*/
      start0 = _x2198;
      init = x0_1967;
      goto kk__tailcall;
    }
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_num_int64__mlift1966_lift1918_for_while64(kk_function_t action, int64_t end, int64_t i, kk_std_core_types__maybe _y_1955, kk_context_t* _ctx) { /* forall<a,e> (action : (int64) -> e maybe<a>, end : int64, i : int64, maybe<a>) -> e maybe<a> */ 
  if (kk_std_core_types__is_Nothing(_y_1955, _ctx)) {
    int64_t i0_1935;
    int64_t _x2200 = (KK_I64(1)); /*int64*/
    i0_1935 = (int64_t)((uint64_t)i + (uint64_t)_x2200); /*int64*/
    return kk_std_num_int64__lift1918_for_while64(action, end, i0_1935, _ctx);
  }
  {
    kk_box_t x = _y_1955._cons.Just.value;
    kk_function_drop(action, _ctx);
    return kk_std_core_types__new_Just(x, _ctx);
  }
}
 
// lifted local: for-while64, rep


// lift anonymous function
struct kk_std_num_int64__lift1918_for_while64_fun2203__t {
  struct kk_function_s _base;
  kk_function_t action0;
  int64_t end0;
  int64_t i0;
};
static kk_box_t kk_std_num_int64__lift1918_for_while64_fun2203(kk_function_t _fself, kk_box_t _b_2043, kk_context_t* _ctx);
static kk_function_t kk_std_num_int64__new_lift1918_for_while64_fun2203(kk_function_t action0, int64_t end0, int64_t i0, kk_context_t* _ctx) {
  struct kk_std_num_int64__lift1918_for_while64_fun2203__t* _self = kk_function_alloc_as(struct kk_std_num_int64__lift1918_for_while64_fun2203__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_int64__lift1918_for_while64_fun2203, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_int64__lift1918_for_while64_fun2203(kk_function_t _fself, kk_box_t _b_2043, kk_context_t* _ctx) {
  struct kk_std_num_int64__lift1918_for_while64_fun2203__t* _self = kk_function_as(struct kk_std_num_int64__lift1918_for_while64_fun2203__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (int64) -> 1618 maybe<1617> */
  int64_t end0 = _self->end0; /* int64 */
  int64_t i0 = _self->i0; /* int64 */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);;;}, {}, _ctx)
  kk_std_core_types__maybe _y_2045_19550 = kk_std_core_types__maybe_unbox(_b_2043, KK_OWNED, _ctx); /*maybe<1617>*/;
  kk_std_core_types__maybe _x2204 = kk_std_num_int64__mlift1966_lift1918_for_while64(action0, end0, i0, _y_2045_19550, _ctx); /*maybe<1617>*/
  return kk_std_core_types__maybe_box(_x2204, _ctx);
}

kk_std_core_types__maybe kk_std_num_int64__lift1918_for_while64(kk_function_t action0, int64_t end0, int64_t i0, kk_context_t* _ctx) { /* forall<a,e> (action : (int64) -> e maybe<a>, end : int64, i : int64) -> e maybe<a> */ 
  kk__tailcall: ;
  bool _match_2077 = (i0 <= end0); /*bool*/;
  if (_match_2077) {
    kk_std_core_types__maybe x0_1970;
    kk_function_t _x2201 = kk_function_dup(action0, _ctx); /*(int64) -> 1618 maybe<1617>*/
    x0_1970 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, int64_t, kk_context_t*), _x2201, (_x2201, i0, _ctx), _ctx); /*maybe<1617>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_1970, _ctx);
      kk_box_t _x2202 = kk_std_core_hnd_yield_extend(kk_std_num_int64__new_lift1918_for_while64_fun2203(action0, end0, i0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x2202, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x0_1970, _ctx)) {
      int64_t i0_19350;
      int64_t _x2205 = (KK_I64(1)); /*int64*/
      i0_19350 = (int64_t)((uint64_t)i0 + (uint64_t)_x2205); /*int64*/
      { // tailcall
        i0 = i0_19350;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t x1 = x0_1970._cons.Just.value;
      kk_function_drop(action0, _ctx);
      return kk_std_core_types__new_Just(x1, _ctx);
    }
  }
  {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}

kk_std_core__list kk_std_num_int64__trmc_list64(int64_t lo, int64_t hi, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int64, hi : int64, ctx<list<int64>>) -> total list<int64> */ 
  kk__tailcall: ;
  bool _match_2076 = (lo <= hi); /*bool*/;
  if (_match_2076) {
    kk_std_core__list _trmc_1937 = kk_datatype_null(); /*list<int64>*/;
    kk_std_core__list _trmc_1938 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_int64_box(lo, _ctx), _trmc_1937, _ctx); /*list<int64>*/;
    kk_box_t* _b_2060_2055 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_1938, _ctx)->tail)); /*field-addr<list<int64>>*/;
    { // tailcall
      int64_t _x2209;
      int64_t _x2210 = (KK_I64(1)); /*int64*/
      _x2209 = (int64_t)((uint64_t)lo + (uint64_t)_x2210); /*int64*/
      kk_std_core_types__cctx _x2211 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_1938, _ctx)),_b_2060_2055,true,kk_context()); /*ctx<0>*/
      lo = _x2209;
      _acc = _x2211;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x2212 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x2212, KK_OWNED, _ctx);
  }
}

kk_std_core__list kk_std_num_int64_list64(int64_t lo0, int64_t hi0, kk_context_t* _ctx) { /* (lo : int64, hi : int64) -> total list<int64> */ 
  kk_std_core_types__cctx _x2213 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_num_int64__trmc_list64(lo0, hi0, _x2213, _ctx);
}
 
// Show an `:int64` in hexadecimal notation interpreted as an unsigned 64-bit value.
// The `width`  parameter specifies how wide the hex value is where `'0'`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number.

kk_string_t kk_std_num_int64_show_hex64(int64_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int64, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_integer_t _x2218 = kk_std_num_int64_uint(i, _ctx); /*int*/
  kk_std_core_types__optional _x2219;
  kk_box_t _x2220;
  kk_integer_t _x2221;
  if (kk_std_core_types__is_Optional(width, _ctx)) {
    kk_box_t _box_x2066 = width._cons.Optional.value;
    kk_integer_t _width_1805 = kk_integer_unbox(_box_x2066, _ctx);
    kk_integer_dup(_width_1805, _ctx);
    kk_std_core_types__optional_drop(width, _ctx);
    _x2221 = _width_1805; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(width, _ctx);
    _x2221 = kk_integer_from_small(16); /*int*/
  }
  _x2220 = kk_integer_box(_x2221, _ctx); /*116*/
  _x2219 = kk_std_core_types__new_Optional(_x2220, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2222;
  kk_box_t _x2223;
  bool _x2224;
  if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
    kk_box_t _box_x2068 = use_capitals._cons.Optional.value;
    bool _use_capitals_1809 = kk_bool_unbox(_box_x2068);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2224 = _use_capitals_1809; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2224 = true; /*bool*/
  }
  _x2223 = kk_bool_box(_x2224); /*116*/
  _x2222 = kk_std_core_types__new_Optional(_x2223, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2225;
  kk_box_t _x2226;
  kk_string_t _x2227;
  if (kk_std_core_types__is_Optional(pre, _ctx)) {
    kk_box_t _box_x2070 = pre._cons.Optional.value;
    kk_string_t _pre_1813 = kk_string_unbox(_box_x2070);
    kk_string_dup(_pre_1813, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    _x2227 = _pre_1813; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_define_string_literal(, _s2228, 2, "0x", _ctx)
    _x2227 = kk_string_dup(_s2228, _ctx); /*string*/
  }
  _x2226 = kk_string_box(_x2227); /*116*/
  _x2225 = kk_std_core_types__new_Optional(_x2226, _ctx); /*optional<116>*/
  return kk_std_core_show_hex(_x2218, _x2219, _x2222, _x2225, _ctx);
}

int64_t kk_std_num_int64_sumacc64(kk_std_core__list xs, int64_t acc, kk_context_t* _ctx) { /* (xs : list<int64>, acc : int64) -> int64 */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con2230 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x2075 = _con2230->head;
    kk_std_core__list xx = _con2230->tail;
    int64_t x = kk_int64_unbox(_box_x2075, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_box_x2075, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    { // tailcall
      int64_t _x2231 = (int64_t)((uint64_t)acc + (uint64_t)x); /*int64*/
      xs = xx;
      acc = _x2231;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}

// initialization
void kk_std_num_int64__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_num_int64_one = (KK_I64(1)); /*int64*/
  }
  {
    kk_std_num_int64_zero = (KK_I64(0)); /*int64*/
  }
  {
    kk_std_num_int64_max_int64 = (KK_I64(9223372036854775807)); /*int64*/
  }
  {
    kk_std_num_int64_min_int64 = (INT64_MIN); /*int64*/
  }
  {
    kk_std_num_int64_bits_int64 = (KK_I64(64)); /*int64*/
  }
}

// termination
void kk_std_num_int64__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
