// Koka generated module: "std/os/dir", koka version: 2.4.2, platform: 64-bit
#include "std_os_dir.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core__error kk_os_ensure_dir_error( kk_string_t path, kk_integer_t mode, kk_context_t* ctx ) {
  int m  = kk_integer_clamp32(mode,ctx);
  const int err = kk_os_ensure_dir(path,m,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core__error kk_os_copy_file_error( kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* ctx ) {
  const int err = kk_os_copy_file(from,to,preserve_mtime,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core__error kk_os_list_directory_prim( kk_string_t dir, kk_context_t* ctx ) {
  kk_vector_t contents;
  const int err = kk_os_list_directory(dir,&contents,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_vector_box(contents,ctx),ctx);
}


kk_std_core__exception kk_std_os_dir_prepend(kk_std_core__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x1318;
  kk_string_t _x1319;
  kk_string_t _x1320;
  kk_define_string_literal(, _s1321, 2, ": ", _ctx)
  _x1320 = kk_string_dup(_s1321, _ctx); /*string*/
  kk_string_t _x1322;
  {
    kk_string_t _x = exn.message;
    kk_string_dup(_x, _ctx);
    _x1322 = _x; /*string*/
  }
  _x1319 = kk_std_core__lp__plus__plus__1_rp_(_x1320, _x1322, _ctx); /*string*/
  _x1318 = kk_std_core__lp__plus__plus__1_rp_(pre, _x1319, _ctx); /*string*/
  kk_std_core__exception_info _x1323;
  {
    kk_std_core__exception_info _x0 = exn.info;
    kk_std_core__exception_info_dup(_x0, _ctx);
    kk_std_core__exception_drop(exn, _ctx);
    _x1323 = _x0; /*exception-info*/
  }
  return kk_std_core__new_Exception(_x1318, _x1323, _ctx);
}

kk_std_core__error kk_std_os_dir_prim_copy_file(kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* _ctx) { /* (from : string, to : string, preserve-mtime : bool) -> fsys error<()> */ 
  return kk_os_copy_file_error(from,to,preserve_mtime,kk_context());
}

kk_std_core__error kk_std_os_dir_ensure_dir_err(kk_string_t path, kk_integer_t mode, kk_context_t* _ctx) { /* (path : string, mode : int) -> fsys error<()> */ 
  return kk_os_ensure_dir_error(path,mode,kk_context());
}

bool kk_std_os_dir_prim_is_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys bool */ 
  return kk_os_is_directory(dir,kk_context());
}

kk_std_core__error kk_std_os_dir_prim_list_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys error<vector<string>> */ 
  return kk_os_list_directory_prim(dir,kk_context());
}

bool kk_std_os_dir_prim_is_file(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys bool */ 
  return kk_os_is_file(path,kk_context());
}
 
// Copy a file.


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1325__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1325(kk_function_t _fself, kk_box_t _b_1009, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1325(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1325, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun1325(kk_function_t _fself, kk_box_t _b_1009, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x1326;
  kk_std_os_path__path _x1327 = kk_std_os_path__path_unbox(_b_1009, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1326 = kk_std_os_path_string(_x1327, _ctx); /*string*/
  return kk_string_box(_x1326);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1331__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1331(kk_function_t _fself, kk_box_t _b_1014, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1331(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1331, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun1331(kk_function_t _fself, kk_box_t _b_1014, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x1332;
  kk_std_os_path__path _x1333 = kk_std_os_path__path_unbox(_b_1014, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1332 = kk_std_os_path_string(_x1333, _ctx); /*string*/
  return kk_string_box(_x1332);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1337__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1337(kk_function_t _fself, kk_box_t _b_1022, kk_box_t _b_1023, kk_box_t _b_1024, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1337(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1337, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun1337(kk_function_t _fself, kk_box_t _b_1022, kk_box_t _b_1023, kk_box_t _b_1024, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x1338;
  kk_string_t _x1339 = kk_string_unbox(_b_1022); /*string*/
  kk_string_t _x1340 = kk_string_unbox(_b_1023); /*string*/
  bool _x1341 = kk_bool_unbox(_b_1024); /*bool*/
  _x1338 = kk_std_os_dir_prim_copy_file(_x1339, _x1340, _x1341, _ctx); /*error<()>*/
  return kk_std_core__error_box(_x1338, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1349__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1349(kk_function_t _fself, kk_box_t _b_1027, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1349(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1349, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun1349(kk_function_t _fself, kk_box_t _b_1027, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x1350;
  kk_string_t _x1351;
  kk_std_os_path__path _x1352 = kk_std_os_path__path_unbox(_b_1027, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1351 = kk_std_os_path_string(_x1352, _ctx); /*string*/
  _x1350 = kk_std_core_show_3(_x1351, _ctx); /*string*/
  return kk_string_box(_x1350);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1358__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1358(kk_function_t _fself, kk_box_t _b_1030, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1358(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1358, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun1358(kk_function_t _fself, kk_box_t _b_1030, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path p0_1058 = kk_std_os_path__path_unbox(_b_1030, KK_OWNED, _ctx); /*std/os/path/path*/;
  kk_string_t _x1359;
  kk_string_t _x1360 = kk_std_os_path_string(p0_1058, _ctx); /*string*/
  _x1359 = kk_std_core_show_3(_x1360, _ctx); /*string*/
  return kk_string_box(_x1359);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1362__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1362(kk_function_t _fself, kk_box_t _b_1038, kk_box_t _b_1039, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1362(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1362, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun1362(kk_function_t _fself, kk_box_t _b_1038, kk_box_t _b_1039, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__exception _x1363;
  kk_string_t _x1364;
  kk_string_t _x1365 = kk_string_unbox(_b_1039); /*string*/
  kk_string_t _x1366;
  kk_string_t _x1367;
  kk_define_string_literal(, _s1368, 2, ": ", _ctx)
  _x1367 = kk_string_dup(_s1368, _ctx); /*string*/
  kk_string_t _x1369;
  kk_std_core__exception _match_1317;
  kk_box_t _x1370 = kk_box_dup(_b_1038, _ctx); /*3447*/
  _match_1317 = kk_std_core__exception_unbox(_x1370, KK_OWNED, _ctx); /*exception*/
  {
    kk_string_t _x = _match_1317.message;
    kk_string_dup(_x, _ctx);
    kk_std_core__exception_drop(_match_1317, _ctx);
    _x1369 = _x; /*string*/
  }
  _x1366 = kk_std_core__lp__plus__plus__1_rp_(_x1367, _x1369, _ctx); /*string*/
  _x1364 = kk_std_core__lp__plus__plus__1_rp_(_x1365, _x1366, _ctx); /*string*/
  kk_std_core__exception_info _x1371;
  kk_std_core__exception _match_1316 = kk_std_core__exception_unbox(_b_1038, KK_OWNED, _ctx); /*exception*/;
  {
    kk_std_core__exception_info _x03 = _match_1316.info;
    kk_std_core__exception_info_dup(_x03, _ctx);
    kk_std_core__exception_drop(_match_1316, _ctx);
    _x1371 = _x03; /*exception-info*/
  }
  _x1363 = kk_std_core__new_Exception(_x1364, _x1371, _ctx); /*exception*/
  return kk_std_core__exception_box(_x1363, _ctx);
}

kk_unit_t kk_std_os_dir_copy_file(kk_std_os_path__path from, kk_std_os_path__path to, kk_std_core_types__optional preserve_mtime, kk_context_t* _ctx) { /* (from : std/os/path/path, to : std/os/path/path, preserve-mtime : optional<bool>) -> <exn,fsys> () */ 
  kk_string_t _x1_955;
  kk_box_t _x1324;
  kk_box_t _x1328;
  kk_std_os_path__path _x1329 = kk_std_os_path__path_dup(from, _ctx); /*std/os/path/path*/
  _x1328 = kk_std_os_path__path_box(_x1329, _ctx); /*3356*/
  _x1324 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1325(_ctx), _x1328, _ctx); /*3357*/
  _x1_955 = kk_string_unbox(_x1324); /*string*/
  kk_string_t _x2_956;
  kk_box_t _x1330;
  kk_box_t _x1334;
  kk_std_os_path__path _x1335 = kk_std_os_path__path_dup(to, _ctx); /*std/os/path/path*/
  _x1334 = kk_std_os_path__path_box(_x1335, _ctx); /*3356*/
  _x1330 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1331(_ctx), _x1334, _ctx); /*3357*/
  _x2_956 = kk_string_unbox(_x1330); /*string*/
  kk_std_core__error _match_1313;
  kk_box_t _x1336;
  kk_box_t _x1342;
  bool _x1343;
  if (kk_std_core_types__is_Optional(preserve_mtime, _ctx)) {
    kk_box_t _box_x1017 = preserve_mtime._cons.Optional.value;
    bool _preserve_mtime_139 = kk_bool_unbox(_box_x1017);
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    _x1343 = _preserve_mtime_139; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    _x1343 = true; /*bool*/
  }
  _x1342 = kk_bool_box(_x1343); /*3492*/
  _x1336 = kk_std_core_hnd__open_none3(kk_std_os_dir_new_copy_file_fun1337(_ctx), kk_string_box(_x1_955), kk_string_box(_x2_956), _x1342, _ctx); /*3493*/
  _match_1313 = kk_std_core__error_unbox(_x1336, KK_OWNED, _ctx); /*error<()>*/
  if (kk_std_core__is_Error(_match_1313, _ctx)) {
    kk_std_core__exception exn = _match_1313._cons.Error.exception;
    kk_std_core__exception_dup(exn, _ctx);
    kk_std_core__error_drop(_match_1313, _ctx);
    kk_string_t _x20_961;
    kk_string_t _x1344;
    kk_define_string_literal(, _s1345, 15, "unable to copy ", _ctx)
    _x1344 = kk_string_dup(_s1345, _ctx); /*string*/
    kk_string_t _x1346;
    kk_string_t _x1347;
    kk_box_t _x1348 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1349(_ctx), kk_std_os_path__path_box(from, _ctx), _ctx); /*3357*/
    _x1347 = kk_string_unbox(_x1348); /*string*/
    kk_string_t _x1353;
    kk_string_t _x1354;
    kk_define_string_literal(, _s1355, 4, " to ", _ctx)
    _x1354 = kk_string_dup(_s1355, _ctx); /*string*/
    kk_string_t _x1356;
    kk_box_t _x1357 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1358(_ctx), kk_std_os_path__path_box(to, _ctx), _ctx); /*3357*/
    _x1356 = kk_string_unbox(_x1357); /*string*/
    _x1353 = kk_std_core__lp__plus__plus__1_rp_(_x1354, _x1356, _ctx); /*string*/
    _x1346 = kk_std_core__lp__plus__plus__1_rp_(_x1347, _x1353, _ctx); /*string*/
    _x20_961 = kk_std_core__lp__plus__plus__1_rp_(_x1344, _x1346, _ctx); /*string*/
    kk_std_core__exception exn0_914;
    kk_box_t _x1361 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_file_fun1362(_ctx), kk_std_core__exception_box(exn, _ctx), kk_string_box(_x20_961), _ctx); /*3449*/
    exn0_914 = kk_std_core__exception_unbox(_x1361, KK_OWNED, _ctx); /*exception*/
    kk_std_core_hnd__ev ev_983;
    kk_ssize_t _x1372 = (KK_IZ(0)); /*ssize_t*/
    ev_983 = kk_evv_at(_x1372,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t _x1373;
    {
      struct kk_std_core_hnd_Ev* _con1374 = kk_std_core_hnd__as_Ev(ev_983, _ctx);
      kk_box_t _box_x1045 = _con1374->hnd;
      kk_std_core_hnd__marker m0 = _con1374->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x1045, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_1314;
      kk_std_core_hnd__clause1 _brw_1315 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_1314 = _brw_1315; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
      {
        kk_function_t _fun_unbox_x1049 = _match_1314.clause;
        _x1373 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x1049, (_fun_unbox_x1049, m0, ev_983, kk_std_core__exception_box(exn0_914, _ctx), _ctx), _ctx); /*52*/
      }
    }
    kk_unit_unbox(_x1373); return kk_Unit;
  }
  {
    kk_std_os_path__path_drop(to, _ctx);
    kk_std_os_path__path_drop(from, _ctx);
    kk_std_core__error_drop(_match_1313, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Ensure a directory path exists


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1376__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun1376(kk_function_t _fself, kk_box_t _b_1061, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1376(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun1376, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun1376(kk_function_t _fself, kk_box_t _b_1061, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x1377;
  kk_std_os_path__path _x1378 = kk_std_os_path__path_unbox(_b_1061, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1377 = kk_std_os_path_string(_x1378, _ctx); /*string*/
  return kk_string_box(_x1377);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1382__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun1382(kk_function_t _fself, kk_box_t _b_1067, kk_box_t _b_1068, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1382(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun1382, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun1382(kk_function_t _fself, kk_box_t _b_1067, kk_box_t _b_1068, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x1383;
  kk_string_t _x1384 = kk_string_unbox(_b_1067); /*string*/
  kk_integer_t _x1385 = kk_integer_unbox(_b_1068, _ctx); /*int*/
  _x1383 = kk_std_os_dir_ensure_dir_err(_x1384, _x1385, _ctx); /*error<()>*/
  return kk_std_core__error_box(_x1383, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1390__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun1390(kk_function_t _fself, kk_box_t _b_1071, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1390(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun1390, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun1390(kk_function_t _fself, kk_box_t _b_1071, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x1391;
  kk_string_t _x1392;
  kk_std_os_path__path _x1393 = kk_std_os_path__path_unbox(_b_1071, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1392 = kk_std_os_path_string(_x1393, _ctx); /*string*/
  _x1391 = kk_std_core_show_3(_x1392, _ctx); /*string*/
  return kk_string_box(_x1391);
}


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1395__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun1395(kk_function_t _fself, kk_box_t _b_1078, kk_box_t _b_1079, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1395(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun1395, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun1395(kk_function_t _fself, kk_box_t _b_1078, kk_box_t _b_1079, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__exception _x1396;
  kk_string_t _x1397;
  kk_string_t _x1398 = kk_string_unbox(_b_1079); /*string*/
  kk_string_t _x1399;
  kk_string_t _x1400;
  kk_define_string_literal(, _s1401, 2, ": ", _ctx)
  _x1400 = kk_string_dup(_s1401, _ctx); /*string*/
  kk_string_t _x1402;
  kk_std_core__exception _match_1312;
  kk_box_t _x1403 = kk_box_dup(_b_1078, _ctx); /*3447*/
  _match_1312 = kk_std_core__exception_unbox(_x1403, KK_OWNED, _ctx); /*exception*/
  {
    kk_string_t _x = _match_1312.message;
    kk_string_dup(_x, _ctx);
    kk_std_core__exception_drop(_match_1312, _ctx);
    _x1402 = _x; /*string*/
  }
  _x1399 = kk_std_core__lp__plus__plus__1_rp_(_x1400, _x1402, _ctx); /*string*/
  _x1397 = kk_std_core__lp__plus__plus__1_rp_(_x1398, _x1399, _ctx); /*string*/
  kk_std_core__exception_info _x1404;
  kk_std_core__exception _match_1311 = kk_std_core__exception_unbox(_b_1078, KK_OWNED, _ctx); /*exception*/;
  {
    kk_std_core__exception_info _x02 = _match_1311.info;
    kk_std_core__exception_info_dup(_x02, _ctx);
    kk_std_core__exception_drop(_match_1311, _ctx);
    _x1404 = _x02; /*exception-info*/
  }
  _x1396 = kk_std_core__new_Exception(_x1397, _x1404, _ctx); /*exception*/
  return kk_std_core__exception_box(_x1396, _ctx);
}

kk_unit_t kk_std_os_dir_ensure_dir(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_string_t _x1_964;
  kk_box_t _x1375;
  kk_box_t _x1379;
  kk_std_os_path__path _x1380 = kk_std_os_path__path_dup(dir, _ctx); /*std/os/path/path*/
  _x1379 = kk_std_os_path__path_box(_x1380, _ctx); /*3356*/
  _x1375 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun1376(_ctx), _x1379, _ctx); /*3357*/
  _x1_964 = kk_string_unbox(_x1375); /*string*/
  kk_std_core__error _match_1308;
  kk_box_t _x1381 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_ensure_dir_fun1382(_ctx), kk_string_box(_x1_964), kk_integer_box(kk_integer_from_small(-1), _ctx), _ctx); /*3449*/
  _match_1308 = kk_std_core__error_unbox(_x1381, KK_OWNED, _ctx); /*error<()>*/
  if (kk_std_core__is_Error(_match_1308, _ctx)) {
    kk_std_core__exception exn = _match_1308._cons.Error.exception;
    kk_std_core__exception_dup(exn, _ctx);
    kk_std_core__error_drop(_match_1308, _ctx);
    kk_string_t _x20_968;
    kk_string_t _x1386;
    kk_define_string_literal(, _s1387, 27, "unable to create directory ", _ctx)
    _x1386 = kk_string_dup(_s1387, _ctx); /*string*/
    kk_string_t _x1388;
    kk_box_t _x1389 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun1390(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*3357*/
    _x1388 = kk_string_unbox(_x1389); /*string*/
    _x20_968 = kk_std_core__lp__plus__plus__1_rp_(_x1386, _x1388, _ctx); /*string*/
    kk_std_core__exception exn0_917;
    kk_box_t _x1394 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_ensure_dir_fun1395(_ctx), kk_std_core__exception_box(exn, _ctx), kk_string_box(_x20_968), _ctx); /*3449*/
    exn0_917 = kk_std_core__exception_unbox(_x1394, KK_OWNED, _ctx); /*exception*/
    kk_std_core_hnd__ev ev_986;
    kk_ssize_t _x1405 = (KK_IZ(0)); /*ssize_t*/
    ev_986 = kk_evv_at(_x1405,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t _x1406;
    {
      struct kk_std_core_hnd_Ev* _con1407 = kk_std_core_hnd__as_Ev(ev_986, _ctx);
      kk_box_t _box_x1085 = _con1407->hnd;
      kk_std_core_hnd__marker m0 = _con1407->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x1085, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_1309;
      kk_std_core_hnd__clause1 _brw_1310 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_1309 = _brw_1310; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
      {
        kk_function_t _fun_unbox_x1089 = _match_1309.clause;
        _x1406 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x1089, (_fun_unbox_x1089, m0, ev_986, kk_std_core__exception_box(exn0_917, _ctx), _ctx), _ctx); /*52*/
      }
    }
    kk_unit_unbox(_x1406); return kk_Unit;
  }
  {
    kk_box_t _box_x1093 = _match_1308._cons.Ok.result;
    kk_unit_t _pat300 = kk_unit_unbox(_box_x1093);
    kk_std_os_path__path_drop(dir, _ctx);
    kk_std_core__error_drop(_match_1308, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// List directory contents (excluding `.` and `..`).
// Returns a list of full paths (not just the names in the directory).


// lift anonymous function
struct kk_std_os_dir_list_directory_fun1411__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir;
};
static kk_box_t kk_std_os_dir_list_directory_fun1411(kk_function_t _fself, kk_box_t _b_1100, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_fun1411(kk_std_os_path__path dir, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_fun1411__t* _self = kk_function_alloc_as(struct kk_std_os_dir_list_directory_fun1411__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_list_directory_fun1411, kk_context());
  _self->dir = dir;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_list_directory_fun1411(kk_function_t _fself, kk_box_t _b_1100, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_fun1411__t* _self = kk_function_as(struct kk_std_os_dir_list_directory_fun1411__t*, _fself, _ctx);
  kk_std_os_path__path dir = _self->dir; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir, _ctx);}, {}, _ctx)
  kk_string_t name_1103 = kk_string_unbox(_b_1100); /*string*/;
  kk_std_os_path__path _x1412;
  kk_std_os_path__path _x1413 = kk_std_os_path_path(name_1103, _ctx); /*std/os/path/path*/
  _x1412 = kk_std_os_path__lp__fs__rp_(dir, _x1413, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1412, _ctx);
}

kk_std_core__list kk_std_os_dir_list_directory(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> fsys list<std/os/path/path> */ 
  kk_std_core__error _match_1307;
  kk_string_t _x1409;
  kk_std_os_path__path _x1410 = kk_std_os_path__path_dup(dir, _ctx); /*std/os/path/path*/
  _x1409 = kk_std_os_path_string(_x1410, _ctx); /*string*/
  _match_1307 = kk_std_os_dir_prim_list_dir(_x1409, _ctx); /*error<vector<string>>*/
  if (kk_std_core__is_Error(_match_1307, _ctx)) {
    kk_std_core__exception _pat0 = _match_1307._cons.Error.exception;
    kk_std_os_path__path_drop(dir, _ctx);
    kk_std_core__error_drop(_match_1307, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
  {
    kk_box_t _box_x1097 = _match_1307._cons.Ok.result;
    kk_vector_t contents = kk_vector_unbox(_box_x1097, _ctx);
    kk_vector_dup(contents, _ctx);
    kk_std_core__error_drop(_match_1307, _ctx);
    kk_std_core__list _b_1101_1098 = kk_std_core_vlist(contents, kk_std_core_types__new_None(_ctx), _ctx); /*list<string>*/;
    return kk_std_core_map_5(_b_1101_1098, kk_std_os_dir_new_list_directory_fun1411(dir, _ctx), _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift980_copy_directory_fun1414__t {
  struct kk_function_s _base;
  kk_std_os_path__path to;
};
static kk_unit_t kk_std_os_dir__mlift980_copy_directory_fun1414(kk_function_t _fself, kk_box_t _b_1120, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift980_copy_directory_fun1414(kk_std_os_path__path to, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift980_copy_directory_fun1414__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift980_copy_directory_fun1414__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift980_copy_directory_fun1414, kk_context());
  _self->to = to;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir__mlift980_copy_directory_fun1416__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift980_copy_directory_fun1416(kk_function_t _fself, kk_box_t _b_1109, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift980_copy_directory_fun1416(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift980_copy_directory_fun1416, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift980_copy_directory_fun1416(kk_function_t _fself, kk_box_t _b_1109, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _b_1105_1104;
  kk_std_core__list _x1417;
  kk_std_os_path__path _match_1306;
  kk_box_t _x1418 = kk_box_dup(_b_1109, _ctx); /*3356*/
  _match_1306 = kk_std_os_path__path_unbox(_x1418, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core__list _x100 = _match_1306.parts;
    kk_std_core__list_dup(_x100, _ctx);
    kk_std_os_path__path_drop(_match_1306, _ctx);
    _x1417 = _x100; /*list<string>*/
  }
  _b_1105_1104 = kk_std_core_take(_x1417, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x1419;
  kk_string_t _x1420 = kk_string_empty(); /*string*/
  kk_std_core__list _x1422;
  kk_std_core_types__optional _match_1304 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1105_1104, _ctx), _ctx); /*optional<116>*/;
  if (kk_std_core_types__is_Optional(_match_1304, _ctx)) {
    kk_box_t _box_x1106 = _match_1304._cons.Optional.value;
    kk_std_core__list _parts_1110 = kk_std_core__list_unbox(_box_x1106, KK_BORROWED, _ctx);
    kk_std_core__list_dup(_parts_1110, _ctx);
    kk_std_core_types__optional_drop(_match_1304, _ctx);
    kk_box_drop(_b_1109, _ctx);
    _x1422 = _parts_1110; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_1304, _ctx);
    kk_std_os_path__path _match_1305 = kk_std_os_path__path_unbox(_b_1109, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core__list _x000 = _match_1305.parts;
      kk_std_core__list_dup(_x000, _ctx);
      kk_std_os_path__path_drop(_match_1305, _ctx);
      _x1422 = _x000; /*list<string>*/
    }
  }
  _x1419 = kk_std_os_path__new_Path(_x1420, _x1422, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1419, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift980_copy_directory_fun1427__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift980_copy_directory_fun1427(kk_function_t _fself, kk_box_t _b_1116, kk_box_t _b_1117, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift980_copy_directory_fun1427(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift980_copy_directory_fun1427, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift980_copy_directory_fun1427(kk_function_t _fself, kk_box_t _b_1116, kk_box_t _b_1117, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x1428;
  kk_std_os_path__path _x1429 = kk_std_os_path__path_unbox(_b_1116, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1430 = kk_std_os_path__path_unbox(_b_1117, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1428 = kk_std_os_path__lp__fs__rp_(_x1429, _x1430, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1428, _ctx);
}
static kk_unit_t kk_std_os_dir__mlift980_copy_directory_fun1414(kk_function_t _fself, kk_box_t _b_1120, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift980_copy_directory_fun1414__t* _self = kk_function_as(struct kk_std_os_dir__mlift980_copy_directory_fun1414__t*, _fself, _ctx);
  kk_std_os_path__path to = _self->to; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x20_975;
  kk_box_t _x1415;
  kk_box_t _x1423 = kk_box_dup(_b_1120, _ctx); /*11277*/
  _x1415 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift980_copy_directory_fun1416(_ctx), _x1423, _ctx); /*3357*/
  _x20_975 = kk_std_os_path__path_unbox(_x1415, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1424 = kk_std_os_path__path_unbox(_b_1120, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1425;
  kk_box_t _x1426 = kk_std_core_hnd__open_none2(kk_std_os_dir__new_mlift980_copy_directory_fun1427(_ctx), kk_std_os_path__path_box(to, _ctx), kk_std_os_path__path_box(_x20_975, _ctx), _ctx); /*3449*/
  _x1425 = kk_std_os_path__path_unbox(_x1426, KK_OWNED, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_copy_directory(_x1424, _x1425, _ctx);
}

kk_unit_t kk_std_os_dir__mlift980_copy_directory(kk_std_core__list dirs, kk_std_os_path__path to, kk_unit_t wild__0, kk_context_t* _ctx) { /* (dirs : list<std/os/path/path>, to : std/os/path/path, wild_0 : ()) -> <exn,fsys,div> () */ 
  kk_std_core_foreach(dirs, kk_std_os_dir__new_mlift980_copy_directory_fun1414(to, _ctx), _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift981_copy_directory_fun1432__t {
  struct kk_function_s _base;
  kk_std_os_path__path to0;
};
static kk_unit_t kk_std_os_dir__mlift981_copy_directory_fun1432(kk_function_t _fself, kk_box_t _b_1145, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift981_copy_directory_fun1432(kk_std_os_path__path to0, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift981_copy_directory_fun1432__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift981_copy_directory_fun1432__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift981_copy_directory_fun1432, kk_context());
  _self->to0 = to0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir__mlift981_copy_directory_fun1434__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift981_copy_directory_fun1434(kk_function_t _fself, kk_box_t _b_1134, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift981_copy_directory_fun1434(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift981_copy_directory_fun1434, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift981_copy_directory_fun1434(kk_function_t _fself, kk_box_t _b_1134, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _b_1130_1129;
  kk_std_core__list _x1435;
  kk_std_os_path__path _match_1303;
  kk_box_t _x1436 = kk_box_dup(_b_1134, _ctx); /*3356*/
  _match_1303 = kk_std_os_path__path_unbox(_x1436, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core__list _x13 = _match_1303.parts;
    kk_std_core__list_dup(_x13, _ctx);
    kk_std_os_path__path_drop(_match_1303, _ctx);
    _x1435 = _x13; /*list<string>*/
  }
  _b_1130_1129 = kk_std_core_take(_x1435, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x1437;
  kk_string_t _x1438 = kk_string_empty(); /*string*/
  kk_std_core__list _x1440;
  kk_std_core_types__optional _match_1301 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1130_1129, _ctx), _ctx); /*optional<116>*/;
  if (kk_std_core_types__is_Optional(_match_1301, _ctx)) {
    kk_box_t _box_x1131 = _match_1301._cons.Optional.value;
    kk_std_core__list _parts_111 = kk_std_core__list_unbox(_box_x1131, KK_BORROWED, _ctx);
    kk_std_core__list_dup(_parts_111, _ctx);
    kk_std_core_types__optional_drop(_match_1301, _ctx);
    kk_box_drop(_b_1134, _ctx);
    _x1440 = _parts_111; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_1301, _ctx);
    kk_std_os_path__path _match_1302 = kk_std_os_path__path_unbox(_b_1134, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core__list _x03 = _match_1302.parts;
      kk_std_core__list_dup(_x03, _ctx);
      kk_std_os_path__path_drop(_match_1302, _ctx);
      _x1440 = _x03; /*list<string>*/
    }
  }
  _x1437 = kk_std_os_path__new_Path(_x1438, _x1440, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1437, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift981_copy_directory_fun1445__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift981_copy_directory_fun1445(kk_function_t _fself, kk_box_t _b_1141, kk_box_t _b_1142, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift981_copy_directory_fun1445(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift981_copy_directory_fun1445, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift981_copy_directory_fun1445(kk_function_t _fself, kk_box_t _b_1141, kk_box_t _b_1142, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x1446;
  kk_std_os_path__path _x1447 = kk_std_os_path__path_unbox(_b_1141, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1448 = kk_std_os_path__path_unbox(_b_1142, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1446 = kk_std_os_path__lp__fs__rp_(_x1447, _x1448, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1446, _ctx);
}
static kk_unit_t kk_std_os_dir__mlift981_copy_directory_fun1432(kk_function_t _fself, kk_box_t _b_1145, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift981_copy_directory_fun1432__t* _self = kk_function_as(struct kk_std_os_dir__mlift981_copy_directory_fun1432__t*, _fself, _ctx);
  kk_std_os_path__path to0 = _self->to0; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to0, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x2_972;
  kk_box_t _x1433;
  kk_box_t _x1441 = kk_box_dup(_b_1145, _ctx); /*11277*/
  _x1433 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift981_copy_directory_fun1434(_ctx), _x1441, _ctx); /*3357*/
  _x2_972 = kk_std_os_path__path_unbox(_x1433, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1442 = kk_std_os_path__path_unbox(_b_1145, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1443;
  kk_box_t _x1444 = kk_std_core_hnd__open_none2(kk_std_os_dir__new_mlift981_copy_directory_fun1445(_ctx), kk_std_os_path__path_box(to0, _ctx), kk_std_os_path__path_box(_x2_972, _ctx), _ctx); /*3449*/
  _x1443 = kk_std_os_path__path_unbox(_x1444, KK_OWNED, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_copy_file(_x1442, _x1443, kk_std_core_types__new_None(_ctx), _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift981_copy_directory_fun1450__t {
  struct kk_function_s _base;
  kk_std_core__list dirs0;
  kk_std_os_path__path to0;
};
static kk_box_t kk_std_os_dir__mlift981_copy_directory_fun1450(kk_function_t _fself, kk_box_t _b_1153, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift981_copy_directory_fun1450(kk_std_core__list dirs0, kk_std_os_path__path to0, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift981_copy_directory_fun1450__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift981_copy_directory_fun1450__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift981_copy_directory_fun1450, kk_context());
  _self->dirs0 = dirs0;
  _self->to0 = to0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__mlift981_copy_directory_fun1450(kk_function_t _fself, kk_box_t _b_1153, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift981_copy_directory_fun1450__t* _self = kk_function_as(struct kk_std_os_dir__mlift981_copy_directory_fun1450__t*, _fself, _ctx);
  kk_std_core__list dirs0 = _self->dirs0; /* list<std/os/path/path> */
  kk_std_os_path__path to0 = _self->to0; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core__list_dup(dirs0, _ctx);kk_std_os_path__path_dup(to0, _ctx);}, {}, _ctx)
  kk_unit_t wild__00_1155 = kk_Unit;
  kk_unit_unbox(_b_1153);
  kk_unit_t _x1451 = kk_Unit;
  kk_std_os_dir__mlift980_copy_directory(dirs0, to0, wild__00_1155, _ctx);
  return kk_unit_box(_x1451);
}

kk_unit_t kk_std_os_dir__mlift981_copy_directory(kk_std_os_path__path to0, kk_std_core_types__tuple2_ _y_930, kk_context_t* _ctx) { /* (to : std/os/path/path, (list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */ 
  {
    kk_box_t _box_x1127 = _y_930.fst;
    kk_box_t _box_x1128 = _y_930.snd;
    kk_std_core__list dirs0 = kk_std_core__list_unbox(_box_x1127, KK_BORROWED, _ctx);
    kk_std_core__list files = kk_std_core__list_unbox(_box_x1128, KK_BORROWED, _ctx);
    kk_std_core__list_dup(dirs0, _ctx);
    kk_std_core__list_dup(files, _ctx);
    kk_std_core_types__tuple2__drop(_y_930, _ctx);
    kk_unit_t x_989 = kk_Unit;
    kk_function_t _x1431;
    kk_std_os_path__path_dup(to0, _ctx);
    _x1431 = kk_std_os_dir__new_mlift981_copy_directory_fun1432(to0, _ctx); /*(11277) -> 11278 ()*/
    kk_std_core_foreach(files, _x1431, _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x1449 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift981_copy_directory_fun1450(dirs0, to0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x1449); return kk_Unit;
    }
    {
      kk_std_os_dir__mlift980_copy_directory(dirs0, to0, x_989, _ctx); return kk_Unit;
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift982_copy_directory_fun1453__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift982_copy_directory_fun1453(kk_function_t _fself, kk_box_t _b_1158, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift982_copy_directory_fun1453(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift982_copy_directory_fun1453, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift982_copy_directory_fun1453(kk_function_t _fself, kk_box_t _b_1158, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _x1454;
  kk_std_os_path__path _x1455 = kk_std_os_path__path_unbox(_b_1158, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1454 = kk_std_os_dir_list_directory(_x1455, _ctx); /*list<std/os/path/path>*/
  return kk_std_core__list_box(_x1454, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift982_copy_directory_fun1456__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir__mlift982_copy_directory_fun1456(kk_function_t _fself, kk_box_t _b_1166, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift982_copy_directory_fun1456(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift982_copy_directory_fun1456, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_os_dir__mlift982_copy_directory_fun1458__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift982_copy_directory_fun1458(kk_function_t _fself, kk_box_t _b_1163, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift982_copy_directory_fun1458(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift982_copy_directory_fun1458, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift982_copy_directory_fun1458(kk_function_t _fself, kk_box_t _b_1163, kk_context_t* _ctx) {
  kk_unused(_fself);
  bool _x1459;
  kk_std_os_path__path _x1460 = kk_std_os_path__path_unbox(_b_1163, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1459 = kk_std_os_dir_is_directory(_x1460, _ctx); /*bool*/
  return kk_bool_box(_x1459);
}
static bool kk_std_os_dir__mlift982_copy_directory_fun1456(kk_function_t _fself, kk_box_t _b_1166, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _x1457 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift982_copy_directory_fun1458(_ctx), _b_1166, _ctx); /*3357*/
  return kk_bool_unbox(_x1457);
}


// lift anonymous function
struct kk_std_os_dir__mlift982_copy_directory_fun1462__t {
  struct kk_function_s _base;
  kk_std_os_path__path to1;
};
static kk_box_t kk_std_os_dir__mlift982_copy_directory_fun1462(kk_function_t _fself, kk_box_t _b_1173, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift982_copy_directory_fun1462(kk_std_os_path__path to1, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift982_copy_directory_fun1462__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift982_copy_directory_fun1462__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift982_copy_directory_fun1462, kk_context());
  _self->to1 = to1;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__mlift982_copy_directory_fun1462(kk_function_t _fself, kk_box_t _b_1173, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift982_copy_directory_fun1462__t* _self = kk_function_as(struct kk_std_os_dir__mlift982_copy_directory_fun1462__t*, _fself, _ctx);
  kk_std_os_path__path to1 = _self->to1; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to1, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2_ _y_1175_9300 = kk_std_core_types__tuple2__unbox(_b_1173, KK_OWNED, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  kk_unit_t _x1463 = kk_Unit;
  kk_std_os_dir__mlift981_copy_directory(to1, _y_1175_9300, _ctx);
  return kk_unit_box(_x1463);
}

kk_unit_t kk_std_os_dir__mlift982_copy_directory(kk_std_os_path__path dir, kk_std_os_path__path to1, kk_unit_t wild__, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path, wild_ : ()) -> <exn,fsys> () */ 
  kk_std_core__list all;
  kk_box_t _x1452 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift982_copy_directory_fun1453(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*3357*/
  all = kk_std_core__list_unbox(_x1452, KK_OWNED, _ctx); /*list<std/os/path/path>*/
  kk_std_core_types__tuple2_ x0_991 = kk_std_core_partition(all, kk_std_os_dir__new_mlift982_copy_directory_fun1456(_ctx), _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2__drop(x0_991, _ctx);
    kk_box_t _x1461 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift982_copy_directory_fun1462(to1, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x1461); return kk_Unit;
  }
  {
    kk_std_os_dir__mlift981_copy_directory(to1, x0_991, _ctx); return kk_Unit;
  }
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1466__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir0;
  kk_std_os_path__path to2;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1466(kk_function_t _fself, kk_box_t _b_1177, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1466(kk_std_os_path__path dir0, kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1466__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1466__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun1466, kk_context());
  _self->dir0 = dir0;
  _self->to2 = to2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1466(kk_function_t _fself, kk_box_t _b_1177, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1466__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1466__t*, _fself, _ctx);
  kk_std_os_path__path dir0 = _self->dir0; /* std/os/path/path */
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir0, _ctx);kk_std_os_path__path_dup(to2, _ctx);}, {}, _ctx)
  kk_unit_t wild__1_1248 = kk_Unit;
  kk_unit_unbox(_b_1177);
  kk_unit_t _x1467 = kk_Unit;
  kk_std_os_dir__mlift982_copy_directory(dir0, to2, wild__1_1248, _ctx);
  return kk_unit_box(_x1467);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1469__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1469(kk_function_t _fself, kk_box_t _b_1180, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1469(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1469, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1469(kk_function_t _fself, kk_box_t _b_1180, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _x1470;
  kk_std_os_path__path _x1471 = kk_std_os_path__path_unbox(_b_1180, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1470 = kk_std_os_dir_list_directory(_x1471, _ctx); /*list<std/os/path/path>*/
  return kk_std_core__list_box(_x1470, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1472__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_copy_directory_fun1472(kk_function_t _fself, kk_box_t _b_1188, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1472(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1472, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1474__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1474(kk_function_t _fself, kk_box_t _b_1185, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1474(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1474, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1474(kk_function_t _fself, kk_box_t _b_1185, kk_context_t* _ctx) {
  kk_unused(_fself);
  bool _x1475;
  kk_std_os_path__path _x1476 = kk_std_os_path__path_unbox(_b_1185, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1475 = kk_std_os_dir_is_directory(_x1476, _ctx); /*bool*/
  return kk_bool_box(_x1475);
}
static bool kk_std_os_dir_copy_directory_fun1472(kk_function_t _fself, kk_box_t _b_1188, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _x1473 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1474(_ctx), _b_1188, _ctx); /*3357*/
  return kk_bool_unbox(_x1473);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1478__t {
  struct kk_function_s _base;
  kk_std_os_path__path to2;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1478(kk_function_t _fself, kk_box_t _b_1195, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1478(kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1478__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1478__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun1478, kk_context());
  _self->to2 = to2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1478(kk_function_t _fself, kk_box_t _b_1195, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1478__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1478__t*, _fself, _ctx);
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to2, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2_ _y_1249_9301 = kk_std_core_types__tuple2__unbox(_b_1195, KK_OWNED, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  kk_unit_t _x1479 = kk_Unit;
  kk_std_os_dir__mlift981_copy_directory(to2, _y_1249_9301, _ctx);
  return kk_unit_box(_x1479);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1481__t {
  struct kk_function_s _base;
  kk_std_os_path__path to2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1481(kk_function_t _fself, kk_box_t _b_1214, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1481(kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1481__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1481__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun1481, kk_context());
  _self->to2 = to2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1483__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1483(kk_function_t _fself, kk_box_t _b_1203, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1483(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1483, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1483(kk_function_t _fself, kk_box_t _b_1203, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _b_1199_1198;
  kk_std_core__list _x1484;
  kk_std_os_path__path _match_1298;
  kk_box_t _x1485 = kk_box_dup(_b_1203, _ctx); /*3356*/
  _match_1298 = kk_std_os_path__path_unbox(_x1485, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core__list _x130 = _match_1298.parts;
    kk_std_core__list_dup(_x130, _ctx);
    kk_std_os_path__path_drop(_match_1298, _ctx);
    _x1484 = _x130; /*list<string>*/
  }
  _b_1199_1198 = kk_std_core_take(_x1484, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x1486;
  kk_string_t _x1487 = kk_string_empty(); /*string*/
  kk_std_core__list _x1489;
  kk_std_core_types__optional _match_1296 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1199_1198, _ctx), _ctx); /*optional<116>*/;
  if (kk_std_core_types__is_Optional(_match_1296, _ctx)) {
    kk_box_t _box_x1200 = _match_1296._cons.Optional.value;
    kk_std_core__list _parts_1111 = kk_std_core__list_unbox(_box_x1200, KK_BORROWED, _ctx);
    kk_std_core__list_dup(_parts_1111, _ctx);
    kk_std_core_types__optional_drop(_match_1296, _ctx);
    kk_box_drop(_b_1203, _ctx);
    _x1489 = _parts_1111; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_1296, _ctx);
    kk_std_os_path__path _match_1297 = kk_std_os_path__path_unbox(_b_1203, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core__list _x030 = _match_1297.parts;
      kk_std_core__list_dup(_x030, _ctx);
      kk_std_os_path__path_drop(_match_1297, _ctx);
      _x1489 = _x030; /*list<string>*/
    }
  }
  _x1486 = kk_std_os_path__new_Path(_x1487, _x1489, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1486, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1494__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1494(kk_function_t _fself, kk_box_t _b_1210, kk_box_t _b_1211, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1494(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1494, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1494(kk_function_t _fself, kk_box_t _b_1210, kk_box_t _b_1211, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x1495;
  kk_std_os_path__path _x1496 = kk_std_os_path__path_unbox(_b_1210, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1497 = kk_std_os_path__path_unbox(_b_1211, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1495 = kk_std_os_path__lp__fs__rp_(_x1496, _x1497, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1495, _ctx);
}
static kk_unit_t kk_std_os_dir_copy_directory_fun1481(kk_function_t _fself, kk_box_t _b_1214, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1481__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1481__t*, _fself, _ctx);
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to2, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x2_9720;
  kk_box_t _x1482;
  kk_box_t _x1490 = kk_box_dup(_b_1214, _ctx); /*11277*/
  _x1482 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1483(_ctx), _x1490, _ctx); /*3357*/
  _x2_9720 = kk_std_os_path__path_unbox(_x1482, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1491 = kk_std_os_path__path_unbox(_b_1214, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1492;
  kk_box_t _x1493 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_directory_fun1494(_ctx), kk_std_os_path__path_box(to2, _ctx), kk_std_os_path__path_box(_x2_9720, _ctx), _ctx); /*3449*/
  _x1492 = kk_std_os_path__path_unbox(_x1493, KK_OWNED, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_copy_file(_x1491, _x1492, kk_std_core_types__new_None(_ctx), _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1499__t {
  struct kk_function_s _base;
  kk_std_core__list dirs1;
  kk_std_os_path__path to2;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1499(kk_function_t _fself, kk_box_t _b_1222, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1499(kk_std_core__list dirs1, kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1499__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1499__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun1499, kk_context());
  _self->dirs1 = dirs1;
  _self->to2 = to2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1499(kk_function_t _fself, kk_box_t _b_1222, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1499__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1499__t*, _fself, _ctx);
  kk_std_core__list dirs1 = _self->dirs1; /* list<std/os/path/path> */
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core__list_dup(dirs1, _ctx);kk_std_os_path__path_dup(to2, _ctx);}, {}, _ctx)
  kk_unit_t wild__01_1250 = kk_Unit;
  kk_unit_unbox(_b_1222);
  kk_unit_t _x1500 = kk_Unit;
  kk_std_os_dir__mlift980_copy_directory(dirs1, to2, wild__01_1250, _ctx);
  return kk_unit_box(_x1500);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1501__t {
  struct kk_function_s _base;
  kk_std_os_path__path to2;
};
static kk_unit_t kk_std_os_dir_copy_directory_fun1501(kk_function_t _fself, kk_box_t _b_1239, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1501(kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1501__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1501__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun1501, kk_context());
  _self->to2 = to2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1503__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1503(kk_function_t _fself, kk_box_t _b_1228, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1503(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1503, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1503(kk_function_t _fself, kk_box_t _b_1228, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _b_1224_1223;
  kk_std_core__list _x1504;
  kk_std_os_path__path _match_1295;
  kk_box_t _x1505 = kk_box_dup(_b_1228, _ctx); /*3356*/
  _match_1295 = kk_std_os_path__path_unbox(_x1505, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core__list _x1000 = _match_1295.parts;
    kk_std_core__list_dup(_x1000, _ctx);
    kk_std_os_path__path_drop(_match_1295, _ctx);
    _x1504 = _x1000; /*list<string>*/
  }
  _b_1224_1223 = kk_std_core_take(_x1504, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x1506;
  kk_string_t _x1507 = kk_string_empty(); /*string*/
  kk_std_core__list _x1509;
  kk_std_core_types__optional _match_1293 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1224_1223, _ctx), _ctx); /*optional<116>*/;
  if (kk_std_core_types__is_Optional(_match_1293, _ctx)) {
    kk_box_t _box_x1225 = _match_1293._cons.Optional.value;
    kk_std_core__list _parts_11100 = kk_std_core__list_unbox(_box_x1225, KK_BORROWED, _ctx);
    kk_std_core__list_dup(_parts_11100, _ctx);
    kk_std_core_types__optional_drop(_match_1293, _ctx);
    kk_box_drop(_b_1228, _ctx);
    _x1509 = _parts_11100; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_1293, _ctx);
    kk_std_os_path__path _match_1294 = kk_std_os_path__path_unbox(_b_1228, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core__list _x0000 = _match_1294.parts;
      kk_std_core__list_dup(_x0000, _ctx);
      kk_std_os_path__path_drop(_match_1294, _ctx);
      _x1509 = _x0000; /*list<string>*/
    }
  }
  _x1506 = kk_std_os_path__new_Path(_x1507, _x1509, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1506, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1514__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1514(kk_function_t _fself, kk_box_t _b_1235, kk_box_t _b_1236, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1514(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1514, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1514(kk_function_t _fself, kk_box_t _b_1235, kk_box_t _b_1236, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x1515;
  kk_std_os_path__path _x1516 = kk_std_os_path__path_unbox(_b_1235, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1517 = kk_std_os_path__path_unbox(_b_1236, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1515 = kk_std_os_path__lp__fs__rp_(_x1516, _x1517, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1515, _ctx);
}
static kk_unit_t kk_std_os_dir_copy_directory_fun1501(kk_function_t _fself, kk_box_t _b_1239, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1501__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1501__t*, _fself, _ctx);
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to2, _ctx);}, {}, _ctx)
  kk_std_os_path__path _x20_9750;
  kk_box_t _x1502;
  kk_box_t _x1510 = kk_box_dup(_b_1239, _ctx); /*11277*/
  _x1502 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1503(_ctx), _x1510, _ctx); /*3357*/
  _x20_9750 = kk_std_os_path__path_unbox(_x1502, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1511 = kk_std_os_path__path_unbox(_b_1239, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1512;
  kk_box_t _x1513 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_directory_fun1514(_ctx), kk_std_os_path__path_box(to2, _ctx), kk_std_os_path__path_box(_x20_9750, _ctx), _ctx); /*3449*/
  _x1512 = kk_std_os_path__path_unbox(_x1513, KK_OWNED, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_copy_directory(_x1511, _x1512, _ctx);
}

kk_unit_t kk_std_os_dir_copy_directory(kk_std_os_path__path dir0, kk_std_os_path__path to2, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path) -> <pure,fsys> () */ 
  kk_unit_t x1_993 = kk_Unit;
  kk_std_os_path__path _x1464 = kk_std_os_path__path_dup(to2, _ctx); /*std/os/path/path*/
  kk_std_os_dir_ensure_dir(_x1464, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x1465 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1466(dir0, to2, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x1465); return kk_Unit;
  }
  {
    kk_std_core__list all0;
    kk_box_t _x1468 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1469(_ctx), kk_std_os_path__path_box(dir0, _ctx), _ctx); /*3357*/
    all0 = kk_std_core__list_unbox(_x1468, KK_OWNED, _ctx); /*list<std/os/path/path>*/
    kk_std_core_types__tuple2_ x2_996 = kk_std_core_partition(all0, kk_std_os_dir_new_copy_directory_fun1472(_ctx), _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
    if (kk_yielding(kk_context())) {
      kk_std_core_types__tuple2__drop(x2_996, _ctx);
      kk_box_t _x1477 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1478(to2, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x1477); return kk_Unit;
    }
    {
      kk_box_t _box_x1196 = x2_996.fst;
      kk_box_t _box_x1197 = x2_996.snd;
      kk_std_core__list dirs1 = kk_std_core__list_unbox(_box_x1196, KK_BORROWED, _ctx);
      kk_std_core__list files0 = kk_std_core__list_unbox(_box_x1197, KK_BORROWED, _ctx);
      kk_std_core__list_dup(dirs1, _ctx);
      kk_std_core__list_dup(files0, _ctx);
      kk_std_core_types__tuple2__drop(x2_996, _ctx);
      kk_unit_t x3_999 = kk_Unit;
      kk_function_t _x1480;
      kk_std_os_path__path_dup(to2, _ctx);
      _x1480 = kk_std_os_dir_new_copy_directory_fun1481(to2, _ctx); /*(11277) -> 11278 ()*/
      kk_std_core_foreach(files0, _x1480, _ctx);
      if (kk_yielding(kk_context())) {
        kk_box_t _x1498 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1499(dirs1, to2, _ctx), _ctx); /*3926*/
        kk_unit_unbox(_x1498); return kk_Unit;
      }
      {
        kk_std_core_foreach(dirs1, kk_std_os_dir_new_copy_directory_fun1501(to2, _ctx), _ctx); return kk_Unit;
      }
    }
  }
}
 
// Copy a file to a directory


// lift anonymous function
struct kk_std_os_dir_copy_file_to_dir_fun1519__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_to_dir_fun1519(kk_function_t _fself, kk_box_t _b_1257, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_to_dir_fun1519(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_to_dir_fun1519, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_to_dir_fun1519(kk_function_t _fself, kk_box_t _b_1257, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _b_1253_1252;
  kk_std_core__list _x1520;
  kk_std_os_path__path _match_1289;
  kk_box_t _x1521 = kk_box_dup(_b_1257, _ctx); /*3356*/
  _match_1289 = kk_std_os_path__path_unbox(_x1521, KK_OWNED, _ctx); /*std/os/path/path*/
  {
    kk_std_core__list _x11 = _match_1289.parts;
    kk_std_core__list_dup(_x11, _ctx);
    kk_std_os_path__path_drop(_match_1289, _ctx);
    _x1520 = _x11; /*list<string>*/
  }
  _b_1253_1252 = kk_std_core_take(_x1520, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_std_os_path__path _x1522;
  kk_string_t _x1523 = kk_string_empty(); /*string*/
  kk_std_core__list _x1525;
  kk_std_core_types__optional _match_1287 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1253_1252, _ctx), _ctx); /*optional<116>*/;
  if (kk_std_core_types__is_Optional(_match_1287, _ctx)) {
    kk_box_t _box_x1254 = _match_1287._cons.Optional.value;
    kk_std_core__list _parts_111 = kk_std_core__list_unbox(_box_x1254, KK_BORROWED, _ctx);
    kk_std_core__list_dup(_parts_111, _ctx);
    kk_std_core_types__optional_drop(_match_1287, _ctx);
    kk_box_drop(_b_1257, _ctx);
    _x1525 = _parts_111; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_1287, _ctx);
    kk_std_os_path__path _match_1288 = kk_std_os_path__path_unbox(_b_1257, KK_OWNED, _ctx); /*std/os/path/path*/;
    {
      kk_std_core__list _x01 = _match_1288.parts;
      kk_std_core__list_dup(_x01, _ctx);
      kk_std_os_path__path_drop(_match_1288, _ctx);
      _x1525 = _x01; /*list<string>*/
    }
  }
  _x1522 = kk_std_os_path__new_Path(_x1523, _x1525, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1522, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_to_dir_fun1530__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_to_dir_fun1530(kk_function_t _fself, kk_box_t _b_1264, kk_box_t _b_1265, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_to_dir_fun1530(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_to_dir_fun1530, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_to_dir_fun1530(kk_function_t _fself, kk_box_t _b_1264, kk_box_t _b_1265, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x1531;
  kk_std_os_path__path _x1532 = kk_std_os_path__path_unbox(_b_1264, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1533 = kk_std_os_path__path_unbox(_b_1265, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1531 = kk_std_os_path__lp__fs__rp_(_x1532, _x1533, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x1531, _ctx);
}

kk_unit_t kk_std_os_dir_copy_file_to_dir(kk_std_os_path__path from, kk_std_os_path__path dir, kk_context_t* _ctx) { /* (from : std/os/path/path, dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_std_os_path__path _x2_978;
  kk_box_t _x1518;
  kk_box_t _x1526;
  kk_std_os_path__path _x1527 = kk_std_os_path__path_dup(from, _ctx); /*std/os/path/path*/
  _x1526 = kk_std_os_path__path_box(_x1527, _ctx); /*3356*/
  _x1518 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_to_dir_fun1519(_ctx), _x1526, _ctx); /*3357*/
  _x2_978 = kk_std_os_path__path_unbox(_x1518, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_path__path _x1528;
  kk_box_t _x1529 = kk_std_core_hnd__open_none2(kk_std_os_dir_new_copy_file_to_dir_fun1530(_ctx), kk_std_os_path__path_box(dir, _ctx), kk_std_os_path__path_box(_x2_978, _ctx), _ctx); /*3449*/
  _x1528 = kk_std_os_path__path_unbox(_x1529, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(from, _x1528, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}
 
// Recursively list all the entries under a directory.


// lift anonymous function
struct kk_std_os_dir_list_directory_recursive_fun1536__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir_list_directory_recursive_fun1536(kk_function_t _fself, kk_box_t _b_1272, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_recursive_fun1536(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_list_directory_recursive_fun1536, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static bool kk_std_os_dir_list_directory_recursive_fun1536(kk_function_t _fself, kk_box_t _b_1272, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x1537 = kk_std_os_path__path_unbox(_b_1272, KK_OWNED, _ctx); /*std/os/path/path*/
  return kk_std_os_dir_is_directory(_x1537, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_list_directory_recursive_fun1538__t {
  struct kk_function_s _base;
  kk_std_core_types__optional max_depth;
};
static kk_std_core__list kk_std_os_dir_list_directory_recursive_fun1538(kk_function_t _fself, kk_box_t _b_1279, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_list_directory_recursive_fun1538(kk_std_core_types__optional max_depth, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_recursive_fun1538__t* _self = kk_function_alloc_as(struct kk_std_os_dir_list_directory_recursive_fun1538__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_list_directory_recursive_fun1538, kk_context());
  _self->max_depth = max_depth;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_core__list kk_std_os_dir_list_directory_recursive_fun1538(kk_function_t _fself, kk_box_t _b_1279, kk_context_t* _ctx) {
  struct kk_std_os_dir_list_directory_recursive_fun1538__t* _self = kk_function_as(struct kk_std_os_dir_list_directory_recursive_fun1538__t*, _fself, _ctx);
  kk_std_core_types__optional max_depth = _self->max_depth; /* optional<int> */
  kk_drop_match(_self, {kk_std_core_types__optional_dup(max_depth, _ctx);}, {}, _ctx)
  kk_integer_t _b_1282_1276;
  kk_integer_t _x1539;
  if (kk_std_core_types__is_Optional(max_depth, _ctx)) {
    kk_box_t _box_x1275 = max_depth._cons.Optional.value;
    kk_integer_t _max_depth_8160 = kk_integer_unbox(_box_x1275, _ctx);
    kk_integer_dup(_max_depth_8160, _ctx);
    kk_std_core_types__optional_drop(max_depth, _ctx);
    _x1539 = _max_depth_8160; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(max_depth, _ctx);
    _x1539 = kk_integer_from_small(1000); /*int*/
  }
  _b_1282_1276 = kk_integer_add_small_const(_x1539, -1, _ctx); /*int*/
  kk_std_os_path__path _x1540 = kk_std_os_path__path_unbox(_b_1279, KK_OWNED, _ctx); /*std/os/path/path*/
  kk_std_core_types__optional _x1541 = kk_std_core_types__new_Optional(kk_integer_box(_b_1282_1276, _ctx), _ctx); /*optional<116>*/
  return kk_std_os_dir_list_directory_recursive(_x1540, _x1541, _ctx);
}

kk_std_core__list kk_std_os_dir_list_directory_recursive(kk_std_os_path__path dir, kk_std_core_types__optional max_depth, kk_context_t* _ctx) { /* (dir : std/os/path/path, max-depth : optional<int>) -> <div,fsys> list<std/os/path/path> */ 
  bool _match_1284;
  kk_integer_t _brw_1285;
  if (kk_std_core_types__is_Optional(max_depth, _ctx)) {
    kk_box_t _box_x1269 = max_depth._cons.Optional.value;
    kk_integer_t _max_depth_816 = kk_integer_unbox(_box_x1269, _ctx);
    kk_integer_dup(_max_depth_816, _ctx);
    _brw_1285 = _max_depth_816; /*int*/
  }
  else {
    _brw_1285 = kk_integer_from_small(1000); /*int*/
  }
  bool _brw_1286 = kk_integer_lt_borrow(_brw_1285,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_1285, _ctx);
  _match_1284 = _brw_1286; /*bool*/
  if (_match_1284) {
    kk_std_core_types__optional_drop(max_depth, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
  {
    kk_std_core__list all = kk_std_os_dir_list_directory(dir, _ctx); /*list<std/os/path/path>*/;
    kk_std_core__list dirs;
    kk_std_core__list _x1535 = kk_std_core__list_dup(all, _ctx); /*list<std/os/path/path>*/
    dirs = kk_std_core_filter(_x1535, kk_std_os_dir_new_list_directory_recursive_fun1536(_ctx), _ctx); /*list<std/os/path/path>*/
    kk_std_core__list ys_922 = kk_std_core_flatmap(dirs, kk_std_os_dir_new_list_directory_recursive_fun1538(max_depth, _ctx), _ctx); /*list<std/os/path/path>*/;
    return kk_std_core_append(all, ys_922, _ctx);
  }
}

// initialization
void kk_std_os_dir__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_dir__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
