// Koka generated module: "std/os/file", koka version: 2.4.2, platform: 64-bit
#include "std_os_file.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core__error kk_os_read_text_file_error( kk_string_t path, kk_context_t* ctx ) {
  kk_string_t content;
  const int err = kk_os_read_text_file(path,&content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_string_box(content),ctx);
}

static kk_std_core__error kk_os_write_text_file_error( kk_string_t path, kk_string_t content, kk_context_t* ctx ) {
  const int err = kk_os_write_text_file(path,content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}


kk_std_core__exception kk_std_os_file_prepend(kk_std_core__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x464;
  kk_string_t _x465;
  kk_string_t _x466;
  kk_define_string_literal(, _s467, 2, ": ", _ctx)
  _x466 = kk_string_dup(_s467, _ctx); /*string*/
  kk_string_t _x468;
  {
    kk_string_t _x = exn.message;
    kk_string_dup(_x, _ctx);
    _x468 = _x; /*string*/
  }
  _x465 = kk_std_core__lp__plus__plus__1_rp_(_x466, _x468, _ctx); /*string*/
  _x464 = kk_std_core__lp__plus__plus__1_rp_(pre, _x465, _ctx); /*string*/
  kk_std_core__exception_info _x469;
  {
    kk_std_core__exception_info _x0 = exn.info;
    kk_std_core__exception_info_dup(_x0, _ctx);
    kk_std_core__exception_drop(exn, _ctx);
    _x469 = _x0; /*exception-info*/
  }
  return kk_std_core__new_Exception(_x464, _x469, _ctx);
}

kk_std_core__error kk_std_os_file_read_text_file_err(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys error<string> */ 
  return kk_os_read_text_file_error(path,kk_context());
}

kk_std_core__error kk_std_os_file_write_text_file_err(kk_string_t path, kk_string_t content, kk_context_t* _ctx) { /* (path : string, content : string) -> fsys error<()> */ 
  return kk_os_write_text_file_error(path,content,kk_context());
}
 
// Read a text file synchronously (using UTF8 encoding)


// lift anonymous function
struct kk_std_os_file_read_text_file_fun471__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun471(kk_function_t _fself, kk_box_t _b_312, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun471(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun471, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_read_text_file_fun471(kk_function_t _fself, kk_box_t _b_312, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x472;
  kk_std_os_path__path _x473 = kk_std_os_path__path_unbox(_b_312, KK_OWNED, _ctx); /*std/os/path/path*/
  _x472 = kk_std_os_path_string(_x473, _ctx); /*string*/
  return kk_string_box(_x472);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun477__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun477(kk_function_t _fself, kk_box_t _b_317, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun477(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun477, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_read_text_file_fun477(kk_function_t _fself, kk_box_t _b_317, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x478;
  kk_string_t _x479 = kk_string_unbox(_b_317); /*string*/
  _x478 = kk_std_os_file_read_text_file_err(_x479, _ctx); /*error<string>*/
  return kk_std_core__error_box(_x478, _ctx);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun484__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun484(kk_function_t _fself, kk_box_t _b_320, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun484(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun484, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_read_text_file_fun484(kk_function_t _fself, kk_box_t _b_320, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x485;
  kk_string_t _x486;
  kk_std_os_path__path _x487 = kk_std_os_path__path_unbox(_b_320, KK_OWNED, _ctx); /*std/os/path/path*/
  _x486 = kk_std_os_path_string(_x487, _ctx); /*string*/
  _x485 = kk_std_core_show_3(_x486, _ctx); /*string*/
  return kk_string_box(_x485);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun489__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun489(kk_function_t _fself, kk_box_t _b_327, kk_box_t _b_328, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun489(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun489, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_read_text_file_fun489(kk_function_t _fself, kk_box_t _b_327, kk_box_t _b_328, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__exception _x490;
  kk_string_t _x491;
  kk_string_t _x492 = kk_string_unbox(_b_328); /*string*/
  kk_string_t _x493;
  kk_string_t _x494;
  kk_define_string_literal(, _s495, 2, ": ", _ctx)
  _x494 = kk_string_dup(_s495, _ctx); /*string*/
  kk_string_t _x496;
  kk_std_core__exception _match_461;
  kk_box_t _x497 = kk_box_dup(_b_327, _ctx); /*3447*/
  _match_461 = kk_std_core__exception_unbox(_x497, KK_OWNED, _ctx); /*exception*/
  {
    kk_string_t _x = _match_461.message;
    kk_string_dup(_x, _ctx);
    kk_std_core__exception_drop(_match_461, _ctx);
    _x496 = _x; /*string*/
  }
  _x493 = kk_std_core__lp__plus__plus__1_rp_(_x494, _x496, _ctx); /*string*/
  _x491 = kk_std_core__lp__plus__plus__1_rp_(_x492, _x493, _ctx); /*string*/
  kk_std_core__exception_info _x498;
  kk_std_core__exception _match_460 = kk_std_core__exception_unbox(_b_327, KK_OWNED, _ctx); /*exception*/;
  {
    kk_std_core__exception_info _x02 = _match_460.info;
    kk_std_core__exception_info_dup(_x02, _ctx);
    kk_std_core__exception_drop(_match_460, _ctx);
    _x498 = _x02; /*exception-info*/
  }
  _x490 = kk_std_core__new_Exception(_x491, _x498, _ctx); /*exception*/
  return kk_std_core__exception_box(_x490, _ctx);
}

kk_string_t kk_std_os_file_read_text_file(kk_std_os_path__path path, kk_context_t* _ctx) { /* (path : std/os/path/path) -> <exn,fsys> string */ 
  kk_string_t _x1_283;
  kk_box_t _x470;
  kk_box_t _x474;
  kk_std_os_path__path _x475 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
  _x474 = kk_std_os_path__path_box(_x475, _ctx); /*3356*/
  _x470 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun471(_ctx), _x474, _ctx); /*3357*/
  _x1_283 = kk_string_unbox(_x470); /*string*/
  kk_std_core__error _match_457;
  kk_box_t _x476 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun477(_ctx), kk_string_box(_x1_283), _ctx); /*3357*/
  _match_457 = kk_std_core__error_unbox(_x476, KK_OWNED, _ctx); /*error<string>*/
  if (kk_std_core__is_Error(_match_457, _ctx)) {
    kk_std_core__exception exn = _match_457._cons.Error.exception;
    kk_std_core__exception_dup(exn, _ctx);
    kk_std_core__error_drop(_match_457, _ctx);
    kk_string_t _x2_286;
    kk_string_t _x480;
    kk_define_string_literal(, _s481, 25, "unable to read text file ", _ctx)
    _x480 = kk_string_dup(_s481, _ctx); /*string*/
    kk_string_t _x482;
    kk_box_t _x483 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun484(_ctx), kk_std_os_path__path_box(path, _ctx), _ctx); /*3357*/
    _x482 = kk_string_unbox(_x483); /*string*/
    _x2_286 = kk_std_core__lp__plus__plus__1_rp_(_x480, _x482, _ctx); /*string*/
    kk_std_core__exception exn0_259;
    kk_box_t _x488 = kk_std_core_hnd__open_none2(kk_std_os_file_new_read_text_file_fun489(_ctx), kk_std_core__exception_box(exn, _ctx), kk_string_box(_x2_286), _ctx); /*3449*/
    exn0_259 = kk_std_core__exception_unbox(_x488, KK_OWNED, _ctx); /*exception*/
    kk_std_core_hnd__ev ev_297;
    kk_ssize_t _x499 = (KK_IZ(0)); /*ssize_t*/
    ev_297 = kk_evv_at(_x499,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t _x500;
    {
      struct kk_std_core_hnd_Ev* _con501 = kk_std_core_hnd__as_Ev(ev_297, _ctx);
      kk_box_t _box_x334 = _con501->hnd;
      kk_std_core_hnd__marker m0 = _con501->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x334, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_458;
      kk_std_core_hnd__clause1 _brw_459 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_458 = _brw_459; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
      {
        kk_function_t _fun_unbox_x338 = _match_458.clause;
        _x500 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x338, (_fun_unbox_x338, m0, ev_297, kk_std_core__exception_box(exn0_259, _ctx), _ctx), _ctx); /*52*/
      }
    }
    return kk_string_unbox(_x500);
  }
  {
    kk_box_t _box_x342 = _match_457._cons.Ok.result;
    kk_string_t content = kk_string_unbox(_box_x342);
    kk_std_os_path__path_drop(path, _ctx);
    kk_string_dup(content, _ctx);
    kk_std_core__error_drop(_match_457, _ctx);
    return content;
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_file__mlift296_write_text_file_fun503__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift296_write_text_file_fun503(kk_function_t _fself, kk_box_t _b_347, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift296_write_text_file_fun503(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift296_write_text_file_fun503, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file__mlift296_write_text_file_fun503(kk_function_t _fself, kk_box_t _b_347, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x504;
  kk_std_os_path__path _x505 = kk_std_os_path__path_unbox(_b_347, KK_OWNED, _ctx); /*std/os/path/path*/
  _x504 = kk_std_os_path_string(_x505, _ctx); /*string*/
  return kk_string_box(_x504);
}


// lift anonymous function
struct kk_std_os_file__mlift296_write_text_file_fun509__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift296_write_text_file_fun509(kk_function_t _fself, kk_box_t _b_353, kk_box_t _b_354, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift296_write_text_file_fun509(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift296_write_text_file_fun509, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file__mlift296_write_text_file_fun509(kk_function_t _fself, kk_box_t _b_353, kk_box_t _b_354, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x510;
  kk_string_t _x511 = kk_string_unbox(_b_353); /*string*/
  kk_string_t _x512 = kk_string_unbox(_b_354); /*string*/
  _x510 = kk_std_os_file_write_text_file_err(_x511, _x512, _ctx); /*error<()>*/
  return kk_std_core__error_box(_x510, _ctx);
}


// lift anonymous function
struct kk_std_os_file__mlift296_write_text_file_fun517__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift296_write_text_file_fun517(kk_function_t _fself, kk_box_t _b_357, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift296_write_text_file_fun517(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift296_write_text_file_fun517, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file__mlift296_write_text_file_fun517(kk_function_t _fself, kk_box_t _b_357, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x518;
  kk_string_t _x519;
  kk_std_os_path__path _x520 = kk_std_os_path__path_unbox(_b_357, KK_OWNED, _ctx); /*std/os/path/path*/
  _x519 = kk_std_os_path_string(_x520, _ctx); /*string*/
  _x518 = kk_std_core_show_3(_x519, _ctx); /*string*/
  return kk_string_box(_x518);
}


// lift anonymous function
struct kk_std_os_file__mlift296_write_text_file_fun522__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift296_write_text_file_fun522(kk_function_t _fself, kk_box_t _b_364, kk_box_t _b_365, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift296_write_text_file_fun522(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift296_write_text_file_fun522, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file__mlift296_write_text_file_fun522(kk_function_t _fself, kk_box_t _b_364, kk_box_t _b_365, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__exception _x523;
  kk_string_t _x524;
  kk_string_t _x525 = kk_string_unbox(_b_365); /*string*/
  kk_string_t _x526;
  kk_string_t _x527;
  kk_define_string_literal(, _s528, 2, ": ", _ctx)
  _x527 = kk_string_dup(_s528, _ctx); /*string*/
  kk_string_t _x529;
  kk_std_core__exception _match_456;
  kk_box_t _x530 = kk_box_dup(_b_364, _ctx); /*3447*/
  _match_456 = kk_std_core__exception_unbox(_x530, KK_OWNED, _ctx); /*exception*/
  {
    kk_string_t _x21 = _match_456.message;
    kk_string_dup(_x21, _ctx);
    kk_std_core__exception_drop(_match_456, _ctx);
    _x529 = _x21; /*string*/
  }
  _x526 = kk_std_core__lp__plus__plus__1_rp_(_x527, _x529, _ctx); /*string*/
  _x524 = kk_std_core__lp__plus__plus__1_rp_(_x525, _x526, _ctx); /*string*/
  kk_std_core__exception_info _x531;
  kk_std_core__exception _match_455 = kk_std_core__exception_unbox(_b_364, KK_OWNED, _ctx); /*exception*/;
  {
    kk_std_core__exception_info _x3 = _match_455.info;
    kk_std_core__exception_info_dup(_x3, _ctx);
    kk_std_core__exception_drop(_match_455, _ctx);
    _x531 = _x3; /*exception-info*/
  }
  _x523 = kk_std_core__new_Exception(_x524, _x531, _ctx); /*exception*/
  return kk_std_core__exception_box(_x523, _ctx);
}

kk_unit_t kk_std_os_file__mlift296_write_text_file(kk_string_t content, kk_std_os_path__path path, kk_unit_t _c_270, kk_context_t* _ctx) { /* (content : string, path : std/os/path/path, ()) -> () */ 
  kk_string_t _x12_290;
  kk_box_t _x502;
  kk_box_t _x506;
  kk_std_os_path__path _x507 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
  _x506 = kk_std_os_path__path_box(_x507, _ctx); /*3356*/
  _x502 = kk_std_core_hnd__open_none1(kk_std_os_file__new_mlift296_write_text_file_fun503(_ctx), _x506, _ctx); /*3357*/
  _x12_290 = kk_string_unbox(_x502); /*string*/
  kk_std_core__error _match_452;
  kk_box_t _x508 = kk_std_core_hnd__open_none2(kk_std_os_file__new_mlift296_write_text_file_fun509(_ctx), kk_string_box(_x12_290), kk_string_box(content), _ctx); /*3449*/
  _match_452 = kk_std_core__error_unbox(_x508, KK_OWNED, _ctx); /*error<()>*/
  if (kk_std_core__is_Error(_match_452, _ctx)) {
    kk_std_core__exception exn = _match_452._cons.Error.exception;
    kk_std_core__exception_dup(exn, _ctx);
    kk_std_core__error_drop(_match_452, _ctx);
    kk_string_t _x20_294;
    kk_string_t _x513;
    kk_define_string_literal(, _s514, 26, "unable to write text file ", _ctx)
    _x513 = kk_string_dup(_s514, _ctx); /*string*/
    kk_string_t _x515;
    kk_box_t _x516 = kk_std_core_hnd__open_none1(kk_std_os_file__new_mlift296_write_text_file_fun517(_ctx), kk_std_os_path__path_box(path, _ctx), _ctx); /*3357*/
    _x515 = kk_string_unbox(_x516); /*string*/
    _x20_294 = kk_std_core__lp__plus__plus__1_rp_(_x513, _x515, _ctx); /*string*/
    kk_std_core__exception exn0_262;
    kk_box_t _x521 = kk_std_core_hnd__open_none2(kk_std_os_file__new_mlift296_write_text_file_fun522(_ctx), kk_std_core__exception_box(exn, _ctx), kk_string_box(_x20_294), _ctx); /*3449*/
    exn0_262 = kk_std_core__exception_unbox(_x521, KK_OWNED, _ctx); /*exception*/
    kk_std_core_hnd__ev ev_300;
    kk_ssize_t _x532 = (KK_IZ(0)); /*ssize_t*/
    ev_300 = kk_evv_at(_x532,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t _x533;
    {
      struct kk_std_core_hnd_Ev* _con534 = kk_std_core_hnd__as_Ev(ev_300, _ctx);
      kk_box_t _box_x371 = _con534->hnd;
      kk_std_core_hnd__marker m0 = _con534->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x371, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_453;
      kk_std_core_hnd__clause1 _brw_454 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_453 = _brw_454; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
      {
        kk_function_t _fun_unbox_x375 = _match_453.clause;
        _x533 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x375, (_fun_unbox_x375, m0, ev_300, kk_std_core__exception_box(exn0_262, _ctx), _ctx), _ctx); /*52*/
      }
    }
    kk_unit_unbox(_x533); return kk_Unit;
  }
  {
    kk_std_os_path__path_drop(path, _ctx);
    kk_std_core__error_drop(_match_452, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Write a text file synchronously (using UTF8 encoding)


// lift anonymous function
struct kk_std_os_file_write_text_file_fun537__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun537(kk_function_t _fself, kk_box_t _b_387, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun537(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun537, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun537(kk_function_t _fself, kk_box_t _b_387, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x538;
  kk_string_t _x539;
  kk_std_core_types__optional _match_450 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_450, _ctx)) {
    kk_box_t _box_x383 = _match_450._cons.Optional.value;
    kk_string_t _root_105 = kk_string_unbox(_box_x383);
    kk_string_dup(_root_105, _ctx);
    kk_std_core_types__optional_drop(_match_450, _ctx);
    _x539 = _root_105; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(_match_450, _ctx);
    kk_std_os_path__path _match_451;
    kk_box_t _x540 = kk_box_dup(_b_387, _ctx); /*3356*/
    _match_451 = kk_std_os_path__path_unbox(_x540, KK_OWNED, _ctx); /*std/os/path/path*/
    {
      kk_string_t _x00 = _match_451.root;
      kk_string_dup(_x00, _ctx);
      kk_std_os_path__path_drop(_match_451, _ctx);
      _x539 = _x00; /*string*/
    }
  }
  kk_std_core__list _x541;
  kk_std_os_path__path _match_449 = kk_std_os_path__path_unbox(_b_387, KK_OWNED, _ctx); /*std/os/path/path*/;
  {
    kk_std_core__list _x = _match_449.parts;
    kk_std_core__list_dup(_x, _ctx);
    kk_std_os_path__path_drop(_match_449, _ctx);
    if (kk_std_core__is_Cons(_x, _ctx)) {
      struct kk_std_core_Cons* _con542 = kk_std_core__as_Cons(_x, _ctx);
      kk_box_t _box_x384 = _con542->head;
      kk_std_core__list xx = _con542->tail;
      if kk_likely(kk_datatype_ptr_is_unique(_x, _ctx)) {
        kk_box_drop(_box_x384, _ctx);
        kk_datatype_ptr_free(_x, _ctx);
      }
      else {
        kk_std_core__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(_x, _ctx);
      }
      _x541 = xx; /*list<string>*/
    }
    else {
      _x541 = kk_std_core__new_Nil(_ctx); /*list<string>*/
    }
  }
  _x538 = kk_std_os_path__new_Path(_x539, _x541, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x538, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun547__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun547(kk_function_t _fself, kk_box_t _b_392, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun547(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun547, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun547(kk_function_t _fself, kk_box_t _b_392, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_os_path__path _x548;
  kk_string_t _x549;
  kk_std_core_types__optional _match_447 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_447, _ctx)) {
    kk_box_t _box_x388 = _match_447._cons.Optional.value;
    kk_string_t _root_1050 = kk_string_unbox(_box_x388);
    kk_string_dup(_root_1050, _ctx);
    kk_std_core_types__optional_drop(_match_447, _ctx);
    _x549 = _root_1050; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(_match_447, _ctx);
    kk_std_os_path__path _match_448;
    kk_box_t _x550 = kk_box_dup(_b_392, _ctx); /*3356*/
    _match_448 = kk_std_os_path__path_unbox(_x550, KK_OWNED, _ctx); /*std/os/path/path*/
    {
      kk_string_t _x000 = _match_448.root;
      kk_string_dup(_x000, _ctx);
      kk_std_os_path__path_drop(_match_448, _ctx);
      _x549 = _x000; /*string*/
    }
  }
  kk_std_core__list _x551;
  kk_std_os_path__path _match_446 = kk_std_os_path__path_unbox(_b_392, KK_OWNED, _ctx); /*std/os/path/path*/;
  {
    kk_std_core__list _x11 = _match_446.parts;
    kk_std_core__list_dup(_x11, _ctx);
    kk_std_os_path__path_drop(_match_446, _ctx);
    if (kk_std_core__is_Cons(_x11, _ctx)) {
      struct kk_std_core_Cons* _con552 = kk_std_core__as_Cons(_x11, _ctx);
      kk_box_t _box_x389 = _con552->head;
      kk_std_core__list xx0 = _con552->tail;
      if kk_likely(kk_datatype_ptr_is_unique(_x11, _ctx)) {
        kk_box_drop(_box_x389, _ctx);
        kk_datatype_ptr_free(_x11, _ctx);
      }
      else {
        kk_std_core__list_dup(xx0, _ctx);
        kk_datatype_ptr_decref(_x11, _ctx);
      }
      _x551 = xx0; /*list<string>*/
    }
    else {
      _x551 = kk_std_core__new_Nil(_ctx); /*list<string>*/
    }
  }
  _x548 = kk_std_os_path__new_Path(_x549, _x551, _ctx); /*std/os/path/path*/
  return kk_std_os_path__path_box(_x548, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun556__t {
  struct kk_function_s _base;
  kk_string_t content;
  kk_std_os_path__path path;
};
static kk_box_t kk_std_os_file_write_text_file_fun556(kk_function_t _fself, kk_box_t _b_400, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun556(kk_string_t content, kk_std_os_path__path path, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun556__t* _self = kk_function_alloc_as(struct kk_std_os_file_write_text_file_fun556__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_file_write_text_file_fun556, kk_context());
  _self->content = content;
  _self->path = path;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun556(kk_function_t _fself, kk_box_t _b_400, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun556__t* _self = kk_function_as(struct kk_std_os_file_write_text_file_fun556__t*, _fself, _ctx);
  kk_string_t content = _self->content; /* string */
  kk_std_os_path__path path = _self->path; /* std/os/path/path */
  kk_drop_match(_self, {kk_string_dup(content, _ctx);kk_std_os_path__path_dup(path, _ctx);}, {}, _ctx)
  kk_unit_t _c_439_270 = kk_Unit;
  kk_unit_unbox(_b_400);
  kk_unit_t _x557 = kk_Unit;
  kk_std_os_file__mlift296_write_text_file(content, path, _c_439_270, _ctx);
  return kk_unit_box(_x557);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun559__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun559(kk_function_t _fself, kk_box_t _b_403, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun559(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun559, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun559(kk_function_t _fself, kk_box_t _b_403, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x560;
  kk_std_os_path__path _x561 = kk_std_os_path__path_unbox(_b_403, KK_OWNED, _ctx); /*std/os/path/path*/
  _x560 = kk_std_os_path_string(_x561, _ctx); /*string*/
  return kk_string_box(_x560);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun565__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun565(kk_function_t _fself, kk_box_t _b_409, kk_box_t _b_410, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun565(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun565, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun565(kk_function_t _fself, kk_box_t _b_409, kk_box_t _b_410, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x566;
  kk_string_t _x567 = kk_string_unbox(_b_409); /*string*/
  kk_string_t _x568 = kk_string_unbox(_b_410); /*string*/
  _x566 = kk_std_os_file_write_text_file_err(_x567, _x568, _ctx); /*error<()>*/
  return kk_std_core__error_box(_x566, _ctx);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun573__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun573(kk_function_t _fself, kk_box_t _b_413, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun573(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun573, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun573(kk_function_t _fself, kk_box_t _b_413, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x574;
  kk_string_t _x575;
  kk_std_os_path__path _x576 = kk_std_os_path__path_unbox(_b_413, KK_OWNED, _ctx); /*std/os/path/path*/
  _x575 = kk_std_os_path_string(_x576, _ctx); /*string*/
  _x574 = kk_std_core_show_3(_x575, _ctx); /*string*/
  return kk_string_box(_x574);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun578__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun578(kk_function_t _fself, kk_box_t _b_420, kk_box_t _b_421, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun578(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun578, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun578(kk_function_t _fself, kk_box_t _b_420, kk_box_t _b_421, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__exception _x579;
  kk_string_t _x580;
  kk_string_t _x581 = kk_string_unbox(_b_421); /*string*/
  kk_string_t _x582;
  kk_string_t _x583;
  kk_define_string_literal(, _s584, 2, ": ", _ctx)
  _x583 = kk_string_dup(_s584, _ctx); /*string*/
  kk_string_t _x585;
  kk_std_core__exception _match_445;
  kk_box_t _x586 = kk_box_dup(_b_420, _ctx); /*3447*/
  _match_445 = kk_std_core__exception_unbox(_x586, KK_OWNED, _ctx); /*exception*/
  {
    kk_string_t _x21 = _match_445.message;
    kk_string_dup(_x21, _ctx);
    kk_std_core__exception_drop(_match_445, _ctx);
    _x585 = _x21; /*string*/
  }
  _x582 = kk_std_core__lp__plus__plus__1_rp_(_x583, _x585, _ctx); /*string*/
  _x580 = kk_std_core__lp__plus__plus__1_rp_(_x581, _x582, _ctx); /*string*/
  kk_std_core__exception_info _x587;
  kk_std_core__exception _match_444 = kk_std_core__exception_unbox(_b_420, KK_OWNED, _ctx); /*exception*/;
  {
    kk_std_core__exception_info _x3 = _match_444.info;
    kk_std_core__exception_info_dup(_x3, _ctx);
    kk_std_core__exception_drop(_match_444, _ctx);
    _x587 = _x3; /*exception-info*/
  }
  _x579 = kk_std_core__new_Exception(_x580, _x587, _ctx); /*exception*/
  return kk_std_core__exception_box(_x579, _ctx);
}

kk_unit_t kk_std_os_file_write_text_file(kk_std_os_path__path path, kk_string_t content, kk_std_core_types__optional create_dir, kk_context_t* _ctx) { /* (path : std/os/path/path, content : string, create-dir : optional<bool>) -> <exn,fsys> () */ 
  kk_unit_t x_303 = kk_Unit;
  if (kk_std_core_types__is_Optional(create_dir, _ctx)) {
    kk_box_t _box_x382 = create_dir._cons.Optional.value;
    bool _create_dir_169 = kk_bool_unbox(_box_x382);
    kk_std_core_types__optional_drop(create_dir, _ctx);
    if (_create_dir_169) {
      kk_std_os_path__path _x535;
      kk_box_t _x536;
      kk_box_t _x543;
      kk_std_os_path__path _x544 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
      _x543 = kk_std_os_path__path_box(_x544, _ctx); /*3356*/
      _x536 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun537(_ctx), _x543, _ctx); /*3357*/
      _x535 = kk_std_os_path__path_unbox(_x536, KK_OWNED, _ctx); /*std/os/path/path*/
      kk_std_os_dir_ensure_dir(_x535, _ctx);
    }
    else {
      
    }
  }
  else {
    kk_std_core_types__optional_drop(create_dir, _ctx);
    kk_std_os_path__path _x545;
    kk_box_t _x546;
    kk_box_t _x553;
    kk_std_os_path__path _x554 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
    _x553 = kk_std_os_path__path_box(_x554, _ctx); /*3356*/
    _x546 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun547(_ctx), _x553, _ctx); /*3357*/
    _x545 = kk_std_os_path__path_unbox(_x546, KK_OWNED, _ctx); /*std/os/path/path*/
    kk_std_os_dir_ensure_dir(_x545, _ctx);
  }
  if (kk_yielding(kk_context())) {
    kk_box_t _x555 = kk_std_core_hnd_yield_extend(kk_std_os_file_new_write_text_file_fun556(content, path, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x555); return kk_Unit;
  }
  {
    kk_string_t _x12_290;
    kk_box_t _x558;
    kk_box_t _x562;
    kk_std_os_path__path _x563 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
    _x562 = kk_std_os_path__path_box(_x563, _ctx); /*3356*/
    _x558 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun559(_ctx), _x562, _ctx); /*3357*/
    _x12_290 = kk_string_unbox(_x558); /*string*/
    kk_std_core__error _match_441;
    kk_box_t _x564 = kk_std_core_hnd__open_none2(kk_std_os_file_new_write_text_file_fun565(_ctx), kk_string_box(_x12_290), kk_string_box(content), _ctx); /*3449*/
    _match_441 = kk_std_core__error_unbox(_x564, KK_OWNED, _ctx); /*error<()>*/
    if (kk_std_core__is_Error(_match_441, _ctx)) {
      kk_std_core__exception exn = _match_441._cons.Error.exception;
      kk_std_core__exception_dup(exn, _ctx);
      kk_std_core__error_drop(_match_441, _ctx);
      kk_string_t _x20_294;
      kk_string_t _x569;
      kk_define_string_literal(, _s570, 26, "unable to write text file ", _ctx)
      _x569 = kk_string_dup(_s570, _ctx); /*string*/
      kk_string_t _x571;
      kk_box_t _x572 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun573(_ctx), kk_std_os_path__path_box(path, _ctx), _ctx); /*3357*/
      _x571 = kk_string_unbox(_x572); /*string*/
      _x20_294 = kk_std_core__lp__plus__plus__1_rp_(_x569, _x571, _ctx); /*string*/
      kk_std_core__exception exn0_262;
      kk_box_t _x577 = kk_std_core_hnd__open_none2(kk_std_os_file_new_write_text_file_fun578(_ctx), kk_std_core__exception_box(exn, _ctx), kk_string_box(_x20_294), _ctx); /*3449*/
      exn0_262 = kk_std_core__exception_unbox(_x577, KK_OWNED, _ctx); /*exception*/
      kk_std_core_hnd__ev ev_306;
      kk_ssize_t _x588 = (KK_IZ(0)); /*ssize_t*/
      ev_306 = kk_evv_at(_x588,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
      kk_box_t _x589;
      {
        struct kk_std_core_hnd_Ev* _con590 = kk_std_core_hnd__as_Ev(ev_306, _ctx);
        kk_box_t _box_x427 = _con590->hnd;
        kk_std_core_hnd__marker m0 = _con590->marker;
        kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x427, KK_BORROWED, _ctx);
        kk_std_core__hnd_exn_dup(h, _ctx);
        kk_std_core_hnd__clause1 _match_442;
        kk_std_core_hnd__clause1 _brw_443 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
        kk_std_core__hnd_exn_drop(h, _ctx);
        _match_442 = _brw_443; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
        {
          kk_function_t _fun_unbox_x431 = _match_442.clause;
          _x589 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x431, (_fun_unbox_x431, m0, ev_306, kk_std_core__exception_box(exn0_262, _ctx), _ctx), _ctx); /*52*/
        }
      }
      kk_unit_unbox(_x589); return kk_Unit;
    }
    {
      kk_std_os_path__path_drop(path, _ctx);
      kk_std_core__error_drop(_match_441, _ctx);
      kk_Unit; return kk_Unit;
    }
  }
}

// initialization
void kk_std_os_file__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  kk_std_os_dir__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_file__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_dir__done(_ctx);
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
