// Koka generated module: "std/time/chrono", koka version: 2.4.2, platform: 64-bit
#include "std_time_chrono.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_types__tuple2_ kk_time_unix_now_tuple(kk_context_t* ctx) {
  kk_duration_t d = kk_time_unix_now(ctx);
  // the conversion has about 15 digits of precision
  // we cannot do this more precisely as the api expects the fraction between 0.0 and 2.0 (for leap seconds).
  double secs = (double)d.seconds;
  double frac = (double)d.attoseconds * 1e-18;
  return kk_std_core_types__new_dash__lp__comma__rp_( kk_double_box(secs,ctx), kk_double_box(frac,ctx), ctx );
}

static double kk_time_dresolution(kk_context_t* ctx) {
  int64_t asecs = kk_time_resolution(ctx);
  return (double)asecs * 1e-18;
}

 
// Returns a unix time stamp as seconds and fraction of seconds;
// The fraction of seconds is for added precision if necessary,
// and can be larger than one to indicate leap seconds.
// This still needs to be adjusted to our epoch and taking account of leap seconds.

kk_std_core_types__tuple2_ kk_std_time_chrono_unix_now(kk_context_t* _ctx) { /* () -> ndet (float64, float64) */ 
  return kk_time_unix_now_tuple(kk_context());
}

double kk_std_time_chrono_xnow_resolution(kk_context_t* _ctx) { /* () -> ndet float64 */ 
  return kk_time_dresolution(kk_context());
}
 
// The current `:instant` in time as returned by the system clock
// in an optional time scale `ts` (`= ts-ti`).
//
// This uses the best available system clock for the requested
// timescale. For example
// it uses [``CLOCK_UTC``](http://www.madore.org/~david/computers/unix-leap-seconds.html)
// when available to get proper UTC time, or ``CLOCK_TAI`` for TAI time.
//
// Otherwise, it usually uses Unix (POSIX) time (``CLOCK_REALTIME``).
// Unfortunately, most operating systems cannot not report time in leap
// seconds accurately. The `now` function is limited by the OS in this case.
//
// To guard against inaccurate clocks and increase monotonicity,
// the `now` function guarantees that if the current measurement is
// upto 1 second in the past with regard to the previous call to `now`,
// that the returned instant is monotonic by adding nano seconds to the
// previous measurement until the system clock catches up again.
//
// This is effective in particular on older OS's where the time sometimes jumps
// back one second after a leap second. By limiting the adjustment to at most
// one second it ensures the clock catches up soon and does not affect the user
// setting a new time in the past.

kk_std_time_instant__instant kk_std_time_chrono_now_in(kk_std_core_types__optional ts, kk_context_t* _ctx) { /* (ts : optional<std/time/instant/timescale>) -> ndet std/time/instant/instant */ 
  kk_std_core_types__tuple2_ _match_170 = kk_std_time_chrono_unix_now(_ctx); /*(float64, float64)*/;
  {
    kk_box_t _box_x137 = _match_170.fst;
    kk_box_t _box_x138 = _match_170.snd;
    double secs = kk_double_unbox(_box_x137, KK_BORROWED, _ctx);
    double frac = kk_double_unbox(_box_x138, KK_BORROWED, _ctx);
    kk_std_core_types__tuple2__drop(_match_170, _ctx);
    kk_std_num_ddouble__ddouble _x172;
    bool _match_171 = (frac == (0x0p+0)); /*bool*/;
    if (_match_171) {
      _x172 = kk_std_num_ddouble__new_Ddouble(secs, 0x0p+0, _ctx); /*std/num/ddouble/ddouble*/
    }
    else {
      _x172 = kk_std_num_ddouble_dsum(secs, frac, _ctx); /*std/num/ddouble/ddouble*/
    }
    kk_std_core_types__optional _x173 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(0), _ctx), _ctx); /*optional<116>*/
    kk_std_core_types__optional _x174;
    kk_box_t _x175;
    kk_std_time_instant__timescale _x176;
    if (kk_std_core_types__is_Optional(ts, _ctx)) {
      kk_box_t _box_x140 = ts._cons.Optional.value;
      kk_std_time_instant__timescale _ts_37 = kk_std_time_instant__timescale_unbox(_box_x140, KK_BORROWED, _ctx);
      kk_std_time_instant__timescale_dup(_ts_37, _ctx);
      kk_std_core_types__optional_drop(ts, _ctx);
      _x176 = _ts_37; /*std/time/instant/timescale*/
    }
    else {
      kk_std_core_types__optional_drop(ts, _ctx);
      _x176 = kk_std_time_instant__timescale_dup(kk_std_time_utc_ts_ti, _ctx); /*std/time/instant/timescale*/
    }
    _x175 = kk_std_time_instant__timescale_box(_x176, _ctx); /*116*/
    _x174 = kk_std_core_types__new_Optional(_x175, _ctx); /*optional<116>*/
    return kk_std_time_utc_unix_instant_2(_x172, _x173, _x174, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_time_chrono__mlift130_now_fun178__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_time_chrono__mlift130_now_fun178(kk_function_t _fself, kk_box_t _b_147, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono__new_mlift130_now_fun178(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_chrono__mlift130_now_fun178, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_time_chrono__mlift130_now_fun178(kk_function_t _fself, kk_box_t _b_147, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_time_instant__instant _x179;
  kk_std_core_types__optional _x180 = kk_std_core_types__optional_unbox(_b_147, KK_OWNED, _ctx); /*optional<std/time/instant/timescale>*/
  _x179 = kk_std_time_chrono_now_in(_x180, _ctx); /*std/time/instant/instant*/
  return kk_std_time_instant__instant_box(_x179, _ctx);
}

kk_std_time_instant__instant kk_std_time_chrono__mlift130_now(kk_std_time_instant__timescale _y_127, kk_context_t* _ctx) { /* (std/time/instant/timescale) -> std/time/utc/utc std/time/instant/instant */ 
  kk_box_t _x177;
  kk_box_t _x181;
  kk_std_core_types__optional _x182 = kk_std_core_types__new_Optional(kk_std_time_instant__timescale_box(_y_127, _ctx), _ctx); /*optional<116>*/
  _x181 = kk_std_core_types__optional_box(_x182, _ctx); /*3356*/
  _x177 = kk_std_core_hnd__open_none1(kk_std_time_chrono__new_mlift130_now_fun178(_ctx), _x181, _ctx); /*3357*/
  return kk_std_time_instant__instant_unbox(_x177, KK_OWNED, _ctx);
}
 
// The current `:instant` in time as returned by the system clock
// in the UTC timescale. Equivalent to `now-in(utc())`, see
// `now-in` for further information about the system clock.


// lift anonymous function
struct kk_std_time_chrono_now_fun187__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_time_chrono_now_fun187(kk_function_t _fself, kk_box_t _b_158, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono_new_now_fun187(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_chrono_now_fun187, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_time_chrono_now_fun187(kk_function_t _fself, kk_box_t _b_158, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_time_instant__instant _x188;
  kk_std_time_instant__timescale _x189 = kk_std_time_instant__timescale_unbox(_b_158, KK_OWNED, _ctx); /*std/time/instant/timescale*/
  _x188 = kk_std_time_chrono__mlift130_now(_x189, _ctx); /*std/time/instant/instant*/
  return kk_std_time_instant__instant_box(_x188, _ctx);
}


// lift anonymous function
struct kk_std_time_chrono_now_fun190__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_time_chrono_now_fun190(kk_function_t _fself, kk_box_t _b_162, kk_context_t* _ctx);
static kk_function_t kk_std_time_chrono_new_now_fun190(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_time_chrono_now_fun190, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_time_chrono_now_fun190(kk_function_t _fself, kk_box_t _b_162, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_time_instant__instant _x191;
  kk_std_core_types__optional _x192 = kk_std_core_types__optional_unbox(_b_162, KK_OWNED, _ctx); /*optional<std/time/instant/timescale>*/
  _x191 = kk_std_time_chrono_now_in(_x192, _ctx); /*std/time/instant/instant*/
  return kk_std_time_instant__instant_box(_x191, _ctx);
}

kk_std_time_instant__instant kk_std_time_chrono_now(kk_context_t* _ctx) { /* () -> <ndet,std/time/utc/utc> std/time/instant/instant */ 
  kk_std_core_hnd__ev ev_134;
  kk_ssize_t _x183 = (KK_IZ(0)); /*ssize_t*/
  ev_134 = kk_evv_at(_x183,kk_context()); /*std/core/hnd/ev<std/time/utc/.hnd-utc>*/
  kk_std_time_instant__timescale x_131;
  kk_box_t _x184;
  {
    struct kk_std_core_hnd_Ev* _con185 = kk_std_core_hnd__as_Ev(ev_134, _ctx);
    kk_box_t _box_x151 = _con185->hnd;
    kk_std_core_hnd__marker m0 = _con185->marker;
    kk_std_time_utc__hnd_utc h = kk_std_time_utc__hnd_utc_unbox(_box_x151, KK_BORROWED, _ctx);
    kk_std_time_utc__hnd_utc_dup(h, _ctx);
    kk_std_core_hnd__clause0 _match_168;
    kk_std_core_hnd__clause0 _brw_169 = kk_std_time_utc__select_utc(h, _ctx); /*std/core/hnd/clause0<std/time/instant/timescale,std/time/utc/.hnd-utc,277,278>*/;
    kk_std_time_utc__hnd_utc_drop(h, _ctx);
    _match_168 = _brw_169; /*std/core/hnd/clause0<std/time/instant/timescale,std/time/utc/.hnd-utc,277,278>*/
    {
      kk_function_t _fun_unbox_x154 = _match_168.clause;
      _x184 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x154, (_fun_unbox_x154, m0, ev_134, _ctx), _ctx); /*37*/
    }
  }
  x_131 = kk_std_time_instant__timescale_unbox(_x184, KK_OWNED, _ctx); /*std/time/instant/timescale*/
  kk_box_t _x186;
  if (kk_yielding(kk_context())) {
    kk_datatype_ptr_dropn(x_131, (KK_I32(10)), _ctx);
    _x186 = kk_std_core_hnd_yield_extend(kk_std_time_chrono_new_now_fun187(_ctx), _ctx); /*3926*/
  }
  else {
    kk_box_t _x193;
    kk_std_core_types__optional _x194 = kk_std_core_types__new_Optional(kk_std_time_instant__timescale_box(x_131, _ctx), _ctx); /*optional<116>*/
    _x193 = kk_std_core_types__optional_box(_x194, _ctx); /*3356*/
    _x186 = kk_std_core_hnd__open_none1(kk_std_time_chrono_new_now_fun190(_ctx), _x193, _ctx); /*3926*/
  }
  return kk_std_time_instant__instant_unbox(_x186, KK_OWNED, _ctx);
}

// initialization
void kk_std_time_chrono__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_num_ddouble__init(_ctx);
  kk_std_time_duration__init(_ctx);
  kk_std_time_instant__init(_ctx);
  kk_std_time_utc__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_time_chrono__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_time_utc__done(_ctx);
  kk_std_time_instant__done(_ctx);
  kk_std_time_duration__done(_ctx);
  kk_std_num_ddouble__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
