// Koka generated module: "std/time/timer", koka version: 2.4.2, platform: 64-bit
#include "std_time_timer.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_types__tuple2_ kk_timer_ticks_tuple(kk_context_t* ctx) {
  kk_duration_t d = kk_timer_ticks(ctx);
  // the conversion has about 15 digits of precision
  // we cannot do this more precisely as the api expects the fraction between 0.0 and 2.0 (for leap seconds).  
  double secs = (double)d.seconds;
  double frac = (double)d.attoseconds * 1e-18;
  return kk_std_core_types__new_dash__lp__comma__rp_( kk_double_box(secs,ctx), kk_double_box(frac,ctx), ctx );
}

static double kk_timer_dresolution(kk_context_t* ctx) {
  int64_t asecs = kk_timer_resolution(ctx);
  return (double)asecs * 1e-18;
}


kk_std_core_types__tuple2_ kk_std_time_timer_xticks(kk_context_t* _ctx) { /* () -> ndet (float64, float64) */ 
  return kk_timer_ticks_tuple(kk_context());
}
 
// Return the smallest time difference in seconds that `ticks` can measure.

double kk_std_time_timer_xticks_resolution(kk_context_t* _ctx) { /* () -> ndet float64 */ 
  return kk_timer_dresolution(kk_context());
}
 
// monadic lift

kk_std_core_types__tuple2_ kk_std_time_timer__mlift306_elapsed(kk_std_time_duration__duration t0, kk_box_t x, kk_context_t* _ctx) { /* forall<a,e> (t0 : std/time/duration/duration, x : a) -> <ndet|e> (std/time/duration/duration, a) */ 
  kk_std_time_duration__duration t1;
  kk_std_core_types__tuple2_ _match_361 = kk_std_time_timer_xticks(_ctx); /*(float64, float64)*/;
  {
    kk_box_t _box_x320 = _match_361.fst;
    kk_box_t _box_x321 = _match_361.snd;
    double secs0 = kk_double_unbox(_box_x320, KK_BORROWED, _ctx);
    double frac0 = kk_double_unbox(_box_x321, KK_BORROWED, _ctx);
    kk_std_core_types__tuple2__drop(_match_361, _ctx);
    t1 = kk_std_time_duration_duration_3(secs0, frac0, _ctx); /*std/time/duration/duration*/
  }
  kk_std_time_duration__duration _b_324_322 = kk_std_time_duration__lp__dash__rp_(t1, t0, _ctx); /*std/time/duration/duration*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_time_duration__duration_box(_b_324_322, _ctx), x, _ctx);
}
 
// Return the number of fractional seconds that it takes to evaluate `action`.


// lift anonymous function
struct kk_std_time_timer_elapsed_fun364__t {
  struct kk_function_s _base;
  kk_std_time_duration__duration t0;
};
static kk_box_t kk_std_time_timer_elapsed_fun364(kk_function_t _fself, kk_box_t _b_333, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_elapsed_fun364(kk_std_time_duration__duration t0, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun364__t* _self = kk_function_alloc_as(struct kk_std_time_timer_elapsed_fun364__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_timer_elapsed_fun364, kk_context());
  _self->t0 = t0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_time_timer_elapsed_fun364(kk_function_t _fself, kk_box_t _b_333, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun364__t* _self = kk_function_as(struct kk_std_time_timer_elapsed_fun364__t*, _fself, _ctx);
  kk_std_time_duration__duration t0 = _self->t0; /* std/time/duration/duration */
  kk_drop_match(_self, {kk_std_time_duration__duration_dup(t0, _ctx);}, {}, _ctx)
  kk_box_t x0_343 = _b_333; /*110*/;
  kk_std_time_duration__duration t1;
  kk_std_core_types__tuple2_ _match_359 = kk_std_time_timer_xticks(_ctx); /*(float64, float64)*/;
  {
    kk_box_t _box_x328 = _match_359.fst;
    kk_box_t _box_x329 = _match_359.snd;
    double secs0 = kk_double_unbox(_box_x328, KK_BORROWED, _ctx);
    double frac0 = kk_double_unbox(_box_x329, KK_BORROWED, _ctx);
    kk_std_core_types__tuple2__drop(_match_359, _ctx);
    t1 = kk_std_time_duration_duration_3(secs0, frac0, _ctx); /*std/time/duration/duration*/
  }
  kk_std_time_duration__duration _b_339_330 = kk_std_time_duration__lp__dash__rp_(t1, t0, _ctx); /*std/time/duration/duration*/;
  kk_std_core_types__tuple2_ _x365 = kk_std_core_types__new_dash__lp__comma__rp_(kk_std_time_duration__duration_box(_b_339_330, _ctx), x0_343, _ctx); /*(6, 7)*/
  return kk_std_core_types__tuple2__box(_x365, _ctx);
}

kk_std_core_types__tuple2_ kk_std_time_timer_elapsed(kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <ndet|e> a) -> <ndet|e> (std/time/duration/duration, a) */ 
  kk_std_time_duration__duration t0;
  kk_std_core_types__tuple2_ _match_360 = kk_std_time_timer_xticks(_ctx); /*(float64, float64)*/;
  {
    kk_box_t _box_x326 = _match_360.fst;
    kk_box_t _box_x327 = _match_360.snd;
    double secs = kk_double_unbox(_box_x326, KK_BORROWED, _ctx);
    double frac = kk_double_unbox(_box_x327, KK_BORROWED, _ctx);
    kk_std_core_types__tuple2__drop(_match_360, _ctx);
    t0 = kk_std_time_duration_duration_3(secs, frac, _ctx); /*std/time/duration/duration*/
  }
  kk_box_t x_308 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx); /*110*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_308, _ctx);
    kk_box_t _x363 = kk_std_core_hnd_yield_extend(kk_std_time_timer_new_elapsed_fun364(t0, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple2__unbox(_x363, KK_OWNED, _ctx);
  }
  {
    kk_std_time_duration__duration t10;
    kk_std_core_types__tuple2_ _match_358 = kk_std_time_timer_xticks(_ctx); /*(float64, float64)*/;
    {
      kk_box_t _box_x334 = _match_358.fst;
      kk_box_t _box_x335 = _match_358.snd;
      double secs00 = kk_double_unbox(_box_x334, KK_BORROWED, _ctx);
      double frac00 = kk_double_unbox(_box_x335, KK_BORROWED, _ctx);
      kk_std_core_types__tuple2__drop(_match_358, _ctx);
      t10 = kk_std_time_duration_duration_3(secs00, frac00, _ctx); /*std/time/duration/duration*/
    }
    kk_std_time_duration__duration _b_341_336 = kk_std_time_duration__lp__dash__rp_(t10, t0, _ctx); /*std/time/duration/duration*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_time_duration__duration_box(_b_341_336, _ctx), x_308, _ctx);
  }
}
 
// monadic lift

kk_box_t kk_std_time_timer__mlift307_print_elapsed(kk_std_core_types__optional msg, kk_std_core_types__tuple2_ _y_304, kk_context_t* _ctx) { /* forall<a,e> (msg : optional<string>, (std/time/duration/duration, a)) -> <ndet,console|e> a */ 
  {
    kk_box_t _box_x344 = _y_304.fst;
    kk_std_time_duration__duration t = kk_std_time_duration__duration_unbox(_box_x344, KK_BORROWED, _ctx);
    kk_box_t x = _y_304.snd;
    kk_box_dup(x, _ctx);
    kk_std_core_types__tuple2__drop(_y_304, _ctx);
    kk_unit_t __ = kk_Unit;
    kk_string_t _x366;
    kk_string_t _x367;
    if (kk_std_core_types__is_Optional(msg, _ctx)) {
      kk_box_t _box_x345 = msg._cons.Optional.value;
      kk_string_t _msg_117 = kk_string_unbox(_box_x345);
      kk_string_dup(_msg_117, _ctx);
      kk_std_core_types__optional_drop(msg, _ctx);
      _x367 = _msg_117; /*string*/
    }
    else {
      kk_std_core_types__optional_drop(msg, _ctx);
      kk_define_string_literal(, _s368, 7, "elapsed", _ctx)
      _x367 = kk_string_dup(_s368, _ctx); /*string*/
    }
    kk_string_t _x369;
    kk_string_t _x370;
    kk_define_string_literal(, _s371, 1, " ", _ctx)
    _x370 = kk_string_dup(_s371, _ctx); /*string*/
    kk_string_t _x372;
    kk_std_core_types__optional _x373 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(3), _ctx), _ctx); /*optional<116>*/
    _x372 = kk_std_time_duration_show(t, _x373, _ctx); /*string*/
    _x369 = kk_std_core__lp__plus__plus__1_rp_(_x370, _x372, _ctx); /*string*/
    _x366 = kk_std_core__lp__plus__plus__1_rp_(_x367, _x369, _ctx); /*string*/
    kk_std_core_printsln(_x366, _ctx);
    return x;
  }
}
 
// Measure the number of fractional seconds that it takes to evaluate `action`, and print `msg` postfixed with the
// measured time in millisecond resolution.


// lift anonymous function
struct kk_std_time_timer_print_elapsed_fun374__t {
  struct kk_function_s _base;
  kk_std_core_types__optional msg;
};
static kk_box_t kk_std_time_timer_print_elapsed_fun374(kk_function_t _fself, kk_box_t _b_349, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_print_elapsed_fun374(kk_std_core_types__optional msg, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun374__t* _self = kk_function_alloc_as(struct kk_std_time_timer_print_elapsed_fun374__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_timer_print_elapsed_fun374, kk_context());
  _self->msg = msg;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_time_timer_print_elapsed_fun374(kk_function_t _fself, kk_box_t _b_349, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun374__t* _self = kk_function_as(struct kk_std_time_timer_print_elapsed_fun374__t*, _fself, _ctx);
  kk_std_core_types__optional msg = _self->msg; /* optional<string> */
  kk_drop_match(_self, {kk_std_core_types__optional_dup(msg, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2_ _x375 = kk_std_core_types__tuple2__unbox(_b_349, KK_OWNED, _ctx); /*(std/time/duration/duration, 284)*/
  return kk_std_time_timer__mlift307_print_elapsed(msg, _x375, _ctx);
}

kk_box_t kk_std_time_timer_print_elapsed(kk_function_t action, kk_std_core_types__optional msg, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <ndet,console|e> a, msg : optional<string>) -> <ndet,console|e> a */ 
  kk_std_core_types__tuple2_ x_313 = kk_std_time_timer_elapsed(action, _ctx); /*(std/time/duration/duration, 284)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2__drop(x_313, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_time_timer_new_print_elapsed_fun374(msg, _ctx), _ctx);
  }
  {
    kk_box_t _box_x350 = x_313.fst;
    kk_std_time_duration__duration t = kk_std_time_duration__duration_unbox(_box_x350, KK_BORROWED, _ctx);
    kk_box_t x0 = x_313.snd;
    kk_box_dup(x0, _ctx);
    kk_std_core_types__tuple2__drop(x_313, _ctx);
    kk_unit_t __ = kk_Unit;
    kk_string_t _x376;
    kk_string_t _x377;
    if (kk_std_core_types__is_Optional(msg, _ctx)) {
      kk_box_t _box_x351 = msg._cons.Optional.value;
      kk_string_t _msg_117 = kk_string_unbox(_box_x351);
      kk_string_dup(_msg_117, _ctx);
      kk_std_core_types__optional_drop(msg, _ctx);
      _x377 = _msg_117; /*string*/
    }
    else {
      kk_std_core_types__optional_drop(msg, _ctx);
      kk_define_string_literal(, _s378, 7, "elapsed", _ctx)
      _x377 = kk_string_dup(_s378, _ctx); /*string*/
    }
    kk_string_t _x379;
    kk_string_t _x380;
    kk_define_string_literal(, _s381, 1, " ", _ctx)
    _x380 = kk_string_dup(_s381, _ctx); /*string*/
    kk_string_t _x382;
    kk_std_core_types__optional _x383 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(3), _ctx), _ctx); /*optional<116>*/
    _x382 = kk_std_time_duration_show(t, _x383, _ctx); /*string*/
    _x379 = kk_std_core__lp__plus__plus__1_rp_(_x380, _x382, _ctx); /*string*/
    _x376 = kk_std_core__lp__plus__plus__1_rp_(_x377, _x379, _ctx); /*string*/
    kk_std_core_printsln(_x376, _ctx);
    return x0;
  }
}

// initialization
void kk_std_time_timer__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_num_ddouble__init(_ctx);
  kk_std_time_duration__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_time_timer__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_time_duration__done(_ctx);
  kk_std_num_ddouble__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
