#pragma once
#ifndef kk_std_time_timer_H
#define kk_std_time_timer_H
// Koka generated module: "std/time/timer", koka version: 2.4.2, platform: 64-bit
#include <kklib.h>
#include "std_core_types.h"
#include "std_core_hnd.h"
#include "std_core.h"
#include "std_num_ddouble.h"
#include "std_time_duration.h"

// type declarations

// value declarations

kk_std_core_types__tuple2_ kk_std_time_timer_xticks(kk_context_t* _ctx); /* () -> ndet (float64, float64) */ 

double kk_std_time_timer_xticks_resolution(kk_context_t* _ctx); /* () -> ndet float64 */ 
 
// Return a high-resolution time stamp in fractional SI seconds.
// The duration is guaranteed to be monotonically increasing
// and have at least millisecond resolution.

static inline kk_std_time_duration__duration kk_std_time_timer_ticks(kk_context_t* _ctx) { /* () -> ndet std/time/duration/duration */ 
  kk_std_core_types__tuple2_ _match_362 = kk_std_time_timer_xticks(_ctx); /*(float64, float64)*/;
  {
    kk_box_t _box_x318 = _match_362.fst;
    kk_box_t _box_x319 = _match_362.snd;
    double secs = kk_double_unbox(_box_x318, KK_BORROWED, _ctx);
    double frac = kk_double_unbox(_box_x319, KK_BORROWED, _ctx);
    kk_std_core_types__tuple2__drop(_match_362, _ctx);
    return kk_std_time_duration_duration_3(secs, frac, _ctx);
  }
}

kk_std_core_types__tuple2_ kk_std_time_timer__mlift306_elapsed(kk_std_time_duration__duration t0, kk_box_t x, kk_context_t* _ctx); /* forall<a,e> (t0 : std/time/duration/duration, x : a) -> <ndet|e> (std/time/duration/duration, a) */ 

kk_std_core_types__tuple2_ kk_std_time_timer_elapsed(kk_function_t action, kk_context_t* _ctx); /* forall<a,e> (action : () -> <ndet|e> a) -> <ndet|e> (std/time/duration/duration, a) */ 

kk_box_t kk_std_time_timer__mlift307_print_elapsed(kk_std_core_types__optional msg, kk_std_core_types__tuple2_ _y_304, kk_context_t* _ctx); /* forall<a,e> (msg : optional<string>, (std/time/duration/duration, a)) -> <ndet,console|e> a */ 

kk_box_t kk_std_time_timer_print_elapsed(kk_function_t action, kk_std_core_types__optional msg, kk_context_t* _ctx); /* forall<a,e> (action : () -> <ndet,console|e> a, msg : optional<string>) -> <ndet,console|e> a */ 
 
// Return the smallest time difference in seconds that `ticks` can measure.

static inline kk_std_time_duration__duration kk_std_time_timer_ticks_resolution(kk_context_t* _ctx) { /* () -> ndet std/time/duration/duration */ 
  double secs0_302 = kk_std_time_timer_xticks_resolution(_ctx); /*float64*/;
  kk_std_num_ddouble__ddouble _x384 = kk_std_num_ddouble__new_Ddouble(secs0_302, 0x0p+0, _ctx); /*std/num/ddouble/ddouble*/
  return kk_std_time_duration__new_Duration(_x384, _ctx);
}

void kk_std_time_timer__init(kk_context_t* _ctx);


void kk_std_time_timer__done(kk_context_t* _ctx);

#endif // header
