// Koka generated module: "std/num/int32", koka version: 2.4.2, platform: 64-bit
#include "std_num_int32.h"
 
// Show an `:int32` in hexadecimal notation
// The `width`  parameter specifies how wide the hex value is where `'0'`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number (goes between the sign and the number).

kk_string_t kk_std_num_int32_show_hex(int32_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int32, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_integer_t _x2338 = kk_integer_from_int(i,kk_context()); /*int*/
  kk_std_core_types__optional _x2339;
  kk_box_t _x2340;
  kk_integer_t _x2341;
  if (kk_std_core_types__is_Optional(width, _ctx)) {
    kk_box_t _box_x2140 = width._cons.Optional.value;
    kk_integer_t _width_319 = kk_integer_unbox(_box_x2140, _ctx);
    kk_integer_dup(_width_319, _ctx);
    kk_std_core_types__optional_drop(width, _ctx);
    _x2341 = _width_319; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(width, _ctx);
    _x2341 = kk_integer_from_small(1); /*int*/
  }
  _x2340 = kk_integer_box(_x2341, _ctx); /*116*/
  _x2339 = kk_std_core_types__new_Optional(_x2340, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2342;
  kk_box_t _x2343;
  bool _x2344;
  if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
    kk_box_t _box_x2142 = use_capitals._cons.Optional.value;
    bool _use_capitals_323 = kk_bool_unbox(_box_x2142);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2344 = _use_capitals_323; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2344 = true; /*bool*/
  }
  _x2343 = kk_bool_box(_x2344); /*116*/
  _x2342 = kk_std_core_types__new_Optional(_x2343, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2345;
  kk_box_t _x2346;
  kk_string_t _x2347;
  if (kk_std_core_types__is_Optional(pre, _ctx)) {
    kk_box_t _box_x2144 = pre._cons.Optional.value;
    kk_string_t _pre_327 = kk_string_unbox(_box_x2144);
    kk_string_dup(_pre_327, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    _x2347 = _pre_327; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_define_string_literal(, _s2348, 2, "0x", _ctx)
    _x2347 = kk_string_dup(_s2348, _ctx); /*string*/
  }
  _x2346 = kk_string_box(_x2347); /*116*/
  _x2345 = kk_std_core_types__new_Optional(_x2346, _ctx); /*optional<116>*/
  return kk_std_core_show_hex(_x2338, _x2339, _x2342, _x2345, _ctx);
}

int32_t kk_std_num_int32_one;

int32_t kk_std_num_int32_zero;
 
// The minimal integer value before underflow happens

int32_t kk_std_num_int32_min_int32;
 
// Euclidean-0 modulus. See `(/):(x : int32, y : int32) -> int32` division for more information.

int32_t kk_std_num_int32__lp__perc__rp_(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> int32 */ 
  bool _match_2319 = (y == ((KK_I32(0)))); /*bool*/;
  if (_match_2319) {
    return x;
  }
  {
    bool _match_2320 = (y == ((KK_I32(-1)))); /*bool*/;
    if (_match_2320) {
      bool _match_2323 = (x == kk_std_num_int32_min_int32); /*bool*/;
      if (_match_2323) {
        return (KK_I32(0));
      }
      {
        int32_t r = (x % y); /*int32*/;
        bool _match_2324 = (r >= ((KK_I32(0)))); /*bool*/;
        if (_match_2324) {
          return r;
        }
        {
          bool _match_2325 = (y > ((KK_I32(0)))); /*bool*/;
          if (_match_2325) {
            return (int32_t)((uint32_t)r + (uint32_t)y);
          }
          {
            return (int32_t)((uint32_t)r - (uint32_t)y);
          }
        }
      }
    }
    {
      int32_t r0 = (x % y); /*int32*/;
      bool _match_2321 = (r0 >= ((KK_I32(0)))); /*bool*/;
      if (_match_2321) {
        return r0;
      }
      {
        bool _match_2322 = (y > ((KK_I32(0)))); /*bool*/;
        if (_match_2322) {
          return (int32_t)((uint32_t)r0 + (uint32_t)y);
        }
        {
          return (int32_t)((uint32_t)r0 - (uint32_t)y);
        }
      }
    }
  }
}
 
/*
Euclidean-0 division.
Euclidean division is defined as: For any `D`  and `d`  where `d!=0` , we have:
1. `D == d*(D/d) + (D%d)`
2. `D%d`  is always positive where `0 <= D%d < abs(d)`
Moreover, Euclidean-0 is a total function, for the case where `d==0`  we have
that `D%0 == D`  and `D/0 == 0` . So property (1) still holds, but not property (2).
Useful laws that hold for Euclidean-0 division:
* `D/(-d) == -(D/d)`
* `D%(-d) == D%d`
* `D/(2^n) == sar(D,n)         `  (with `0 <= n <= 31`)
* `D%(2^n) == D & ((2^n) - 1)  `  (with `0 <= n <= 31`)
Note that an interesting edge case is `min-int32 / -1` which equals `min-int32` since in modulo 32-bit
arithmetic `min-int32 == -1 * min-int32 == -1 * (min-int32 / -1) + (min-int32 % -1)` satisfying property (1).
Of course `(min-int32 + 1) / -1` is again positive (namely `max-int32`).
See also _Division and modulus for computer scientists, Daan Leijen, 2001_
[pdf](http://research.microsoft.com/pubs/151917/divmodnote.pdf) .
*/

int32_t kk_std_num_int32__lp__fs__rp_(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> int32 */ 
  bool _match_2312 = (y == ((KK_I32(0)))); /*bool*/;
  if (_match_2312) {
    return (KK_I32(0));
  }
  {
    bool _match_2313 = (y == ((KK_I32(-1)))); /*bool*/;
    if (_match_2313) {
      bool _match_2316 = (x == kk_std_num_int32_min_int32); /*bool*/;
      if (_match_2316) {
        return x;
      }
      {
        int32_t q = (x / y); /*int32*/;
        int32_t r = (x % y); /*int32*/;
        bool _match_2317 = (r >= ((KK_I32(0)))); /*bool*/;
        if (_match_2317) {
          return q;
        }
        {
          bool _match_2318 = (y > ((KK_I32(0)))); /*bool*/;
          if (_match_2318) {
            return (int32_t)((uint32_t)q - (uint32_t)((KK_I32(1))));
          }
          {
            return (int32_t)((uint32_t)q + (uint32_t)((KK_I32(1))));
          }
        }
      }
    }
    {
      int32_t q0 = (x / y); /*int32*/;
      int32_t r0 = (x % y); /*int32*/;
      bool _match_2314 = (r0 >= ((KK_I32(0)))); /*bool*/;
      if (_match_2314) {
        return q0;
      }
      {
        bool _match_2315 = (y > ((KK_I32(0)))); /*bool*/;
        if (_match_2315) {
          return (int32_t)((uint32_t)q0 - (uint32_t)((KK_I32(1))));
        }
        {
          return (int32_t)((uint32_t)q0 + (uint32_t)((KK_I32(1))));
        }
      }
    }
  }
}
 
// Return the absolute value of an integer.
// Raises an exception if the `:int32` is `min-int32`
// (since the negation of `min-int32` equals itself and is still negative)

int32_t kk_std_num_int32_abs(int32_t i, kk_context_t* _ctx) { /* (i : int32) -> exn int32 */ 
  bool _x1_2102 = 0 > i; /*bool*/;
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<exn>*/;
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  if (_x1_2102) {
    bool _match_2308 = (i > kk_std_num_int32_min_int32); /*bool*/;
    if (_match_2308) {
      return (int32_t)((uint32_t)((KK_I32(0))) - (uint32_t)i);
    }
    {
      kk_std_core_hnd__ev ev_2109;
      kk_ssize_t _x2349 = (KK_IZ(0)); /*ssize_t*/
      ev_2109 = kk_evv_at(_x2349,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
      kk_box_t _x2350;
      {
        struct kk_std_core_hnd_Ev* _con2351 = kk_std_core_hnd__as_Ev(ev_2109, _ctx);
        kk_box_t _box_x2149 = _con2351->hnd;
        kk_std_core_hnd__marker m0 = _con2351->marker;
        kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x2149, KK_BORROWED, _ctx);
        kk_std_core__hnd_exn_dup(h, _ctx);
        kk_std_core_hnd__clause1 _match_2309;
        kk_std_core_hnd__clause1 _brw_2311 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
        kk_std_core__hnd_exn_drop(h, _ctx);
        _match_2309 = _brw_2311; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
        {
          kk_function_t _fun_unbox_x2153 = _match_2309.clause;
          kk_box_t _x2352;
          kk_std_core__exception _x2353;
          kk_string_t _x2354;
          kk_define_string_literal(, _s2355, 79, "std/num/int32/abs: cannot make min-int32 into a positive int32 without overflow", _ctx)
          _x2354 = kk_string_dup(_s2355, _ctx); /*string*/
          kk_std_core__exception_info _x2356;
          kk_std_core_types__optional _match_2310 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
          if (kk_std_core_types__is_Optional(_match_2310, _ctx)) {
            kk_box_t _box_x2157 = _match_2310._cons.Optional.value;
            kk_std_core__exception_info _info_11917 = kk_std_core__exception_info_unbox(_box_x2157, KK_BORROWED, _ctx);
            kk_std_core__exception_info_dup(_info_11917, _ctx);
            kk_std_core_types__optional_drop(_match_2310, _ctx);
            _x2356 = _info_11917; /*exception-info*/
          }
          else {
            kk_std_core_types__optional_drop(_match_2310, _ctx);
            _x2356 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
          }
          _x2353 = kk_std_core__new_Exception(_x2354, _x2356, _ctx); /*exception*/
          _x2352 = kk_std_core__exception_box(_x2353, _ctx); /*51*/
          _x2350 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x2153, (_fun_unbox_x2153, m0, ev_2109, _x2352, _ctx), _ctx); /*52*/
        }
      }
      return kk_int32_unbox(_x2350, KK_OWNED, _ctx);
    }
  }
  {
    return i;
  }
}
 
// Return the absolute value of an integer.
// Returns 0 if the `:int32` is `min-int32`
// (since the negation of `min-int32` equals itself and is still negative)

int32_t kk_std_num_int32_abs0(int32_t i, kk_context_t* _ctx) { /* (i : int32) -> int32 */ 
  bool b_1942 = 0 > i; /*bool*/;
  if (b_1942) {
    bool _match_2307 = (i > kk_std_num_int32_min_int32); /*bool*/;
    if (_match_2307) {
      return (int32_t)((uint32_t)((KK_I32(0))) - (uint32_t)i);
    }
    {
      return (KK_I32(0));
    }
  }
  {
    return i;
  }
}
 
// The number of bits in an `:int32` (always 32)

int32_t kk_std_num_int32_bits_int32;
 
// Truncated division (as in C). See also `(/):(x : int32, y : int32) -> int32`.

int32_t kk_std_num_int32_cdiv(int32_t i, int32_t j, kk_context_t* _ctx) { /* (i : int32, j : int32) -> exn int32 */ 
  bool _match_2298 = 0 == j; /*bool*/;
  if (_match_2298) {
    kk_std_core_hnd__ev ev_2112;
    kk_ssize_t _x2357 = (KK_IZ(0)); /*ssize_t*/
    ev_2112 = kk_evv_at(_x2357,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t _x2358;
    {
      struct kk_std_core_hnd_Ev* _con2359 = kk_std_core_hnd__as_Ev(ev_2112, _ctx);
      kk_box_t _box_x2158 = _con2359->hnd;
      kk_std_core_hnd__marker m0 = _con2359->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x2158, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_2304;
      kk_std_core_hnd__clause1 _brw_2306 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_2304 = _brw_2306; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
      {
        kk_function_t _fun_unbox_x2162 = _match_2304.clause;
        kk_box_t _x2360;
        kk_std_core__exception _x2361;
        kk_string_t _x2362;
        kk_define_string_literal(, _s2363, 35, "std/num/int32/cdiv: modulus by zero", _ctx)
        _x2362 = kk_string_dup(_s2363, _ctx); /*string*/
        kk_std_core__exception_info _x2364;
        kk_std_core_types__optional _match_2305 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
        if (kk_std_core_types__is_Optional(_match_2305, _ctx)) {
          kk_box_t _box_x2166 = _match_2305._cons.Optional.value;
          kk_std_core__exception_info _info_11917 = kk_std_core__exception_info_unbox(_box_x2166, KK_BORROWED, _ctx);
          kk_std_core__exception_info_dup(_info_11917, _ctx);
          kk_std_core_types__optional_drop(_match_2305, _ctx);
          _x2364 = _info_11917; /*exception-info*/
        }
        else {
          kk_std_core_types__optional_drop(_match_2305, _ctx);
          _x2364 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
        }
        _x2361 = kk_std_core__new_Exception(_x2362, _x2364, _ctx); /*exception*/
        _x2360 = kk_std_core__exception_box(_x2361, _ctx); /*51*/
        _x2358 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x2162, (_fun_unbox_x2162, m0, ev_2112, _x2360, _ctx), _ctx); /*52*/
      }
    }
    return kk_int32_unbox(_x2358, KK_OWNED, _ctx);
  }
  {
    bool _match_2299 = (j == ((KK_I32(-1)))); /*bool*/;
    if (_match_2299) {
      bool _match_2300 = (i == kk_std_num_int32_min_int32); /*bool*/;
      if (_match_2300) {
        kk_std_core_hnd__ev ev0_2115;
        kk_ssize_t _x2365 = (KK_IZ(0)); /*ssize_t*/
        ev0_2115 = kk_evv_at(_x2365,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
        kk_box_t _x2366;
        {
          struct kk_std_core_hnd_Ev* _con2367 = kk_std_core_hnd__as_Ev(ev0_2115, _ctx);
          kk_box_t _box_x2167 = _con2367->hnd;
          kk_std_core_hnd__marker m00 = _con2367->marker;
          kk_std_core__hnd_exn h0 = kk_std_core__hnd_exn_unbox(_box_x2167, KK_BORROWED, _ctx);
          kk_std_core__hnd_exn_dup(h0, _ctx);
          kk_std_core_hnd__clause1 _match_2301;
          kk_std_core_hnd__clause1 _brw_2303 = kk_std_core__select_throw_exn(h0, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
          kk_std_core__hnd_exn_drop(h0, _ctx);
          _match_2301 = _brw_2303; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
          {
            kk_function_t _fun_unbox_x2171 = _match_2301.clause;
            kk_box_t _x2368;
            kk_std_core__exception _x2369;
            kk_string_t _x2370;
            kk_define_string_literal(, _s2371, 65, "std/num/int32/cdiv: modulus overflow in cdiv(min-int32, -1.int32)", _ctx)
            _x2370 = kk_string_dup(_s2371, _ctx); /*string*/
            kk_std_core__exception_info _x2372;
            kk_std_core_types__optional _match_2302 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
            if (kk_std_core_types__is_Optional(_match_2302, _ctx)) {
              kk_box_t _box_x2175 = _match_2302._cons.Optional.value;
              kk_std_core__exception_info _info_119170 = kk_std_core__exception_info_unbox(_box_x2175, KK_BORROWED, _ctx);
              kk_std_core__exception_info_dup(_info_119170, _ctx);
              kk_std_core_types__optional_drop(_match_2302, _ctx);
              _x2372 = _info_119170; /*exception-info*/
            }
            else {
              kk_std_core_types__optional_drop(_match_2302, _ctx);
              _x2372 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
            }
            _x2369 = kk_std_core__new_Exception(_x2370, _x2372, _ctx); /*exception*/
            _x2368 = kk_std_core__exception_box(_x2369, _ctx); /*51*/
            _x2366 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x2171, (_fun_unbox_x2171, m00, ev0_2115, _x2368, _ctx), _ctx); /*52*/
          }
        }
        return kk_int32_unbox(_x2366, KK_OWNED, _ctx);
      }
      {
        return (i / j);
      }
    }
    {
      return (i / j);
    }
  }
}
 
// Truncated modulus (as in C). See also `(%):(x : int32, y : int32) -> int32`.

int32_t kk_std_num_int32_cmod(int32_t i, int32_t j, kk_context_t* _ctx) { /* (i : int32, j : int32) -> exn int32 */ 
  bool _match_2289 = 0 == j; /*bool*/;
  if (_match_2289) {
    kk_std_core_hnd__ev ev_2118;
    kk_ssize_t _x2373 = (KK_IZ(0)); /*ssize_t*/
    ev_2118 = kk_evv_at(_x2373,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t _x2374;
    {
      struct kk_std_core_hnd_Ev* _con2375 = kk_std_core_hnd__as_Ev(ev_2118, _ctx);
      kk_box_t _box_x2176 = _con2375->hnd;
      kk_std_core_hnd__marker m0 = _con2375->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x2176, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_2295;
      kk_std_core_hnd__clause1 _brw_2297 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_2295 = _brw_2297; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
      {
        kk_function_t _fun_unbox_x2180 = _match_2295.clause;
        kk_box_t _x2376;
        kk_std_core__exception _x2377;
        kk_string_t _x2378;
        kk_define_string_literal(, _s2379, 35, "std/num/int32/cmod: modulus by zero", _ctx)
        _x2378 = kk_string_dup(_s2379, _ctx); /*string*/
        kk_std_core__exception_info _x2380;
        kk_std_core_types__optional _match_2296 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
        if (kk_std_core_types__is_Optional(_match_2296, _ctx)) {
          kk_box_t _box_x2184 = _match_2296._cons.Optional.value;
          kk_std_core__exception_info _info_11917 = kk_std_core__exception_info_unbox(_box_x2184, KK_BORROWED, _ctx);
          kk_std_core__exception_info_dup(_info_11917, _ctx);
          kk_std_core_types__optional_drop(_match_2296, _ctx);
          _x2380 = _info_11917; /*exception-info*/
        }
        else {
          kk_std_core_types__optional_drop(_match_2296, _ctx);
          _x2380 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
        }
        _x2377 = kk_std_core__new_Exception(_x2378, _x2380, _ctx); /*exception*/
        _x2376 = kk_std_core__exception_box(_x2377, _ctx); /*51*/
        _x2374 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x2180, (_fun_unbox_x2180, m0, ev_2118, _x2376, _ctx), _ctx); /*52*/
      }
    }
    return kk_int32_unbox(_x2374, KK_OWNED, _ctx);
  }
  {
    bool _match_2290 = (j == ((KK_I32(-1)))); /*bool*/;
    if (_match_2290) {
      bool _match_2291 = (i == kk_std_num_int32_min_int32); /*bool*/;
      if (_match_2291) {
        kk_std_core_hnd__ev ev0_2121;
        kk_ssize_t _x2381 = (KK_IZ(0)); /*ssize_t*/
        ev0_2121 = kk_evv_at(_x2381,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
        kk_box_t _x2382;
        {
          struct kk_std_core_hnd_Ev* _con2383 = kk_std_core_hnd__as_Ev(ev0_2121, _ctx);
          kk_box_t _box_x2185 = _con2383->hnd;
          kk_std_core_hnd__marker m00 = _con2383->marker;
          kk_std_core__hnd_exn h0 = kk_std_core__hnd_exn_unbox(_box_x2185, KK_BORROWED, _ctx);
          kk_std_core__hnd_exn_dup(h0, _ctx);
          kk_std_core_hnd__clause1 _match_2292;
          kk_std_core_hnd__clause1 _brw_2294 = kk_std_core__select_throw_exn(h0, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
          kk_std_core__hnd_exn_drop(h0, _ctx);
          _match_2292 = _brw_2294; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
          {
            kk_function_t _fun_unbox_x2189 = _match_2292.clause;
            kk_box_t _x2384;
            kk_std_core__exception _x2385;
            kk_string_t _x2386;
            kk_define_string_literal(, _s2387, 65, "std/num/int32/cmod: modulus overflow in cmod(min-int32, -1.int32)", _ctx)
            _x2386 = kk_string_dup(_s2387, _ctx); /*string*/
            kk_std_core__exception_info _x2388;
            kk_std_core_types__optional _match_2293 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
            if (kk_std_core_types__is_Optional(_match_2293, _ctx)) {
              kk_box_t _box_x2193 = _match_2293._cons.Optional.value;
              kk_std_core__exception_info _info_119170 = kk_std_core__exception_info_unbox(_box_x2193, KK_BORROWED, _ctx);
              kk_std_core__exception_info_dup(_info_119170, _ctx);
              kk_std_core_types__optional_drop(_match_2293, _ctx);
              _x2388 = _info_119170; /*exception-info*/
            }
            else {
              kk_std_core_types__optional_drop(_match_2293, _ctx);
              _x2388 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
            }
            _x2385 = kk_std_core__new_Exception(_x2386, _x2388, _ctx); /*exception*/
            _x2384 = kk_std_core__exception_box(_x2385, _ctx); /*51*/
            _x2382 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x2189, (_fun_unbox_x2189, m00, ev0_2121, _x2384, _ctx), _ctx); /*52*/
          }
        }
        return kk_int32_unbox(_x2382, KK_OWNED, _ctx);
      }
      {
        return (i % j);
      }
    }
    {
      return (i % j);
    }
  }
}

kk_std_core_types__tuple2_ kk_std_num_int32_divmod(int32_t x, int32_t y, kk_context_t* _ctx) { /* (x : int32, y : int32) -> (int32, int32) */ 
  bool _match_2284 = 0 == y; /*bool*/;
  if (_match_2284) {
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(kk_std_num_int32_zero, _ctx), kk_int32_box(x, _ctx), _ctx);
  }
  {
    bool _match_2285 = (y == ((KK_I32(-1)))); /*bool*/;
    if (_match_2285) {
      bool _match_2287 = (x == kk_std_num_int32_min_int32); /*bool*/;
      if (_match_2287) {
        int32_t _b_2213_2197 = (KK_I32(0)); /*int32*/;
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(x, _ctx), kk_int32_box(_b_2213_2197, _ctx), _ctx);
      }
      {
        int32_t q = (x / y); /*int32*/;
        int32_t r = (x % y); /*int32*/;
        bool b_1952 = 0 > r; /*bool*/;
        if (b_1952) {
          bool _match_2288 = 0 < y; /*bool*/;
          if (_match_2288) {
            int32_t _b_2214_2198 = (int32_t)((uint32_t)q - (uint32_t)((KK_I32(1)))); /*int32*/;
            int32_t _b_2215_2199 = (int32_t)((uint32_t)r + (uint32_t)y); /*int32*/;
            return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_2214_2198, _ctx), kk_int32_box(_b_2215_2199, _ctx), _ctx);
          }
          {
            int32_t _b_2216_2200 = (int32_t)((uint32_t)q + (uint32_t)((KK_I32(1)))); /*int32*/;
            int32_t _b_2217_2201 = (int32_t)((uint32_t)r - (uint32_t)y); /*int32*/;
            return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_2216_2200, _ctx), kk_int32_box(_b_2217_2201, _ctx), _ctx);
          }
        }
        {
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(q, _ctx), kk_int32_box(r, _ctx), _ctx);
        }
      }
    }
    {
      int32_t q0 = (x / y); /*int32*/;
      int32_t r0 = (x % y); /*int32*/;
      bool b0_1955 = 0 > r0; /*bool*/;
      if (b0_1955) {
        bool _match_2286 = 0 < y; /*bool*/;
        if (_match_2286) {
          int32_t _b_2220_2204 = (int32_t)((uint32_t)q0 - (uint32_t)((KK_I32(1)))); /*int32*/;
          int32_t _b_2221_2205 = (int32_t)((uint32_t)r0 + (uint32_t)y); /*int32*/;
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_2220_2204, _ctx), kk_int32_box(_b_2221_2205, _ctx), _ctx);
        }
        {
          int32_t _b_2222_2206 = (int32_t)((uint32_t)q0 + (uint32_t)((KK_I32(1)))); /*int32*/;
          int32_t _b_2223_2207 = (int32_t)((uint32_t)r0 - (uint32_t)y); /*int32*/;
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(_b_2222_2206, _ctx), kk_int32_box(_b_2223_2207, _ctx), _ctx);
        }
      }
      {
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_int32_box(q0, _ctx), kk_int32_box(r0, _ctx), _ctx);
      }
    }
  }
}
 
// monadic lift

kk_box_t kk_std_num_int32__mlift2103_fold_int32(int32_t end, kk_function_t f, int32_t start, kk_box_t x, kk_context_t* _ctx) { /* forall<a,e> (end : int32, f : (int32, a) -> e a, start : int32, x : a) -> e a */ 
  int32_t _own_2282 = (int32_t)((uint32_t)start + (uint32_t)((KK_I32(1)))); /*int32*/;
  kk_box_t _brw_2283 = kk_std_num_int32_fold_int32(_own_2282, end, x, f, _ctx); /*63*/;
  kk_function_drop(f, _ctx);
  return _brw_2283;
}


// lift anonymous function
struct kk_std_num_int32_fold_int32_fun2391__t {
  struct kk_function_s _base;
  kk_function_t f0;
  int32_t end0;
  int32_t start0;
};
static kk_box_t kk_std_num_int32_fold_int32_fun2391(kk_function_t _fself, kk_box_t x1, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32_new_fold_int32_fun2391(kk_function_t f0, int32_t end0, int32_t start0, kk_context_t* _ctx) {
  struct kk_std_num_int32_fold_int32_fun2391__t* _self = kk_function_alloc_as(struct kk_std_num_int32_fold_int32_fun2391__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_int32_fold_int32_fun2391, kk_context());
  _self->f0 = f0;
  _self->end0 = end0;
  _self->start0 = start0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_int32_fold_int32_fun2391(kk_function_t _fself, kk_box_t x1, kk_context_t* _ctx) {
  struct kk_std_num_int32_fold_int32_fun2391__t* _self = kk_function_as(struct kk_std_num_int32_fold_int32_fun2391__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int32, 1380) -> 1381 1380 */
  int32_t end0 = _self->end0; /* int32 */
  int32_t start0 = _self->start0; /* int32 */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);;;}, {}, _ctx)
  return kk_std_num_int32__mlift2103_fold_int32(end0, f0, start0, x1, _ctx);
}

kk_box_t kk_std_num_int32_fold_int32(int32_t start0, int32_t end0, kk_box_t init, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,e> (start : int32, end : int32, init : a, f : (int32, a) -> e a) -> e a */ 
  kk__tailcall: ;
  bool _match_2279 = (start0 >= end0); /*bool*/;
  if (_match_2279) {
    return init;
  }
  {
    kk_box_t x0_2124;
    kk_function_t _x2389 = kk_function_dup(f0, _ctx); /*(int32, 1380) -> 1381 1380*/
    x0_2124 = kk_function_call(kk_box_t, (kk_function_t, int32_t, kk_box_t, kk_context_t*), _x2389, (_x2389, start0, init, _ctx), _ctx); /*1380*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_2124, _ctx);
      kk_function_t _x2390;
      kk_function_dup(f0, _ctx);
      _x2390 = kk_std_num_int32_new_fold_int32_fun2391(f0, end0, start0, _ctx); /*(x1 : 1380) -> 1381 1380*/
      return kk_std_core_hnd_yield_extend(_x2390, _ctx);
    }
    {
      int32_t _own_2281 = (int32_t)((uint32_t)start0 + (uint32_t)((KK_I32(1)))); /*int32*/;
      { // tailcall
        start0 = _own_2281;
        init = x0_2124;
        goto kk__tailcall;
      }
    }
  }
}
 
// monadic lift

kk_box_t kk_std_num_int32__mlift2104_fold_while_int32(int32_t end, kk_function_t f, kk_box_t init, int32_t start, kk_std_core_types__maybe _y_2083, kk_context_t* _ctx) { /* forall<a,e> (end : int32, f : (int32, a) -> e maybe<a>, init : a, start : int32, maybe<a>) -> e a */ 
  if (kk_std_core_types__is_Just(_y_2083, _ctx)) {
    kk_box_t x = _y_2083._cons.Just.value;
    kk_box_drop(init, _ctx);
    int32_t _x2392 = (int32_t)((uint32_t)start + (uint32_t)((KK_I32(1)))); /*int32*/
    return kk_std_num_int32_fold_while_int32(_x2392, end, x, f, _ctx);
  }
  {
    kk_function_drop(f, _ctx);
    return init;
  }
}


// lift anonymous function
struct kk_std_num_int32_fold_while_int32_fun2395__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_box_t init0;
  int32_t end0;
  int32_t start0;
};
static kk_box_t kk_std_num_int32_fold_while_int32_fun2395(kk_function_t _fself, kk_box_t _b_2227, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32_new_fold_while_int32_fun2395(kk_function_t f0, kk_box_t init0, int32_t end0, int32_t start0, kk_context_t* _ctx) {
  struct kk_std_num_int32_fold_while_int32_fun2395__t* _self = kk_function_alloc_as(struct kk_std_num_int32_fold_while_int32_fun2395__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_int32_fold_while_int32_fun2395, kk_context());
  _self->f0 = f0;
  _self->init0 = init0;
  _self->end0 = end0;
  _self->start0 = start0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_int32_fold_while_int32_fun2395(kk_function_t _fself, kk_box_t _b_2227, kk_context_t* _ctx) {
  struct kk_std_num_int32_fold_while_int32_fun2395__t* _self = kk_function_as(struct kk_std_num_int32_fold_while_int32_fun2395__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int32, 1433) -> 1434 maybe<1433> */
  kk_box_t init0 = _self->init0; /* 1433 */
  int32_t end0 = _self->end0; /* int32 */
  int32_t start0 = _self->start0; /* int32 */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_box_dup(init0, _ctx);;;}, {}, _ctx)
  kk_std_core_types__maybe _x2396 = kk_std_core_types__maybe_unbox(_b_2227, KK_OWNED, _ctx); /*maybe<1433>*/
  return kk_std_num_int32__mlift2104_fold_while_int32(end0, f0, init0, start0, _x2396, _ctx);
}

kk_box_t kk_std_num_int32_fold_while_int32(int32_t start0, int32_t end0, kk_box_t init0, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,e> (start : int32, end : int32, init : a, f : (int32, a) -> e maybe<a>) -> e a */ 
  kk__tailcall: ;
  bool _match_2277 = (start0 >= end0); /*bool*/;
  if (_match_2277) {
    kk_function_drop(f0, _ctx);
    return init0;
  }
  {
    kk_std_core_types__maybe x0_2127;
    kk_function_t _x2394 = kk_function_dup(f0, _ctx); /*(int32, 1433) -> 1434 maybe<1433>*/
    kk_box_t _x2393 = kk_box_dup(init0, _ctx); /*1433*/
    x0_2127 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, int32_t, kk_box_t, kk_context_t*), _x2394, (_x2394, start0, _x2393, _ctx), _ctx); /*maybe<1433>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_2127, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_num_int32_new_fold_while_int32_fun2395(f0, init0, end0, start0, _ctx), _ctx);
    }
    if (kk_std_core_types__is_Just(x0_2127, _ctx)) {
      kk_box_t x1 = x0_2127._cons.Just.value;
      kk_box_drop(init0, _ctx);
      { // tailcall
        int32_t _x2397 = (int32_t)((uint32_t)start0 + (uint32_t)((KK_I32(1)))); /*int32*/
        start0 = _x2397;
        init0 = x1;
        goto kk__tailcall;
      }
    }
    {
      kk_function_drop(f0, _ctx);
      return init0;
    }
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_num_int32__mlift2105_lift1935_for_while32(kk_function_t action, int32_t end, int32_t i, kk_std_core_types__maybe _y_2087, kk_context_t* _ctx) { /* forall<a,e> (action : (int32) -> e maybe<a>, end : int32, i : int32, maybe<a>) -> e maybe<a> */ 
  if (kk_std_core_types__is_Nothing(_y_2087, _ctx)) {
    int32_t i0_1958 = (int32_t)((uint32_t)i + (uint32_t)((KK_I32(1)))); /*int32*/;
    return kk_std_num_int32__lift1935_for_while32(action, end, i0_1958, _ctx);
  }
  {
    kk_box_t x = _y_2087._cons.Just.value;
    kk_function_drop(action, _ctx);
    return kk_std_core_types__new_Just(x, _ctx);
  }
}
 
// lifted local: for-while32, rep


// lift anonymous function
struct kk_std_num_int32__lift1935_for_while32_fun2400__t {
  struct kk_function_s _base;
  kk_function_t action0;
  int32_t end0;
  int32_t i0;
};
static kk_box_t kk_std_num_int32__lift1935_for_while32_fun2400(kk_function_t _fself, kk_box_t _b_2231, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32__new_lift1935_for_while32_fun2400(kk_function_t action0, int32_t end0, int32_t i0, kk_context_t* _ctx) {
  struct kk_std_num_int32__lift1935_for_while32_fun2400__t* _self = kk_function_alloc_as(struct kk_std_num_int32__lift1935_for_while32_fun2400__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_int32__lift1935_for_while32_fun2400, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_int32__lift1935_for_while32_fun2400(kk_function_t _fself, kk_box_t _b_2231, kk_context_t* _ctx) {
  struct kk_std_num_int32__lift1935_for_while32_fun2400__t* _self = kk_function_as(struct kk_std_num_int32__lift1935_for_while32_fun2400__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (int32) -> 1488 maybe<1487> */
  int32_t end0 = _self->end0; /* int32 */
  int32_t i0 = _self->i0; /* int32 */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);;;}, {}, _ctx)
  kk_std_core_types__maybe _y_2233_20870 = kk_std_core_types__maybe_unbox(_b_2231, KK_OWNED, _ctx); /*maybe<1487>*/;
  kk_std_core_types__maybe _x2401 = kk_std_num_int32__mlift2105_lift1935_for_while32(action0, end0, i0, _y_2233_20870, _ctx); /*maybe<1487>*/
  return kk_std_core_types__maybe_box(_x2401, _ctx);
}

kk_std_core_types__maybe kk_std_num_int32__lift1935_for_while32(kk_function_t action0, int32_t end0, int32_t i0, kk_context_t* _ctx) { /* forall<a,e> (action : (int32) -> e maybe<a>, end : int32, i : int32) -> e maybe<a> */ 
  kk__tailcall: ;
  bool _match_2275 = (i0 <= end0); /*bool*/;
  if (_match_2275) {
    kk_std_core_types__maybe x0_2130;
    kk_function_t _x2398 = kk_function_dup(action0, _ctx); /*(int32) -> 1488 maybe<1487>*/
    x0_2130 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, int32_t, kk_context_t*), _x2398, (_x2398, i0, _ctx), _ctx); /*maybe<1487>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_2130, _ctx);
      kk_box_t _x2399 = kk_std_core_hnd_yield_extend(kk_std_num_int32__new_lift1935_for_while32_fun2400(action0, end0, i0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x2399, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x0_2130, _ctx)) {
      int32_t i0_19580 = (int32_t)((uint32_t)i0 + (uint32_t)((KK_I32(1)))); /*int32*/;
      { // tailcall
        i0 = i0_19580;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t x1 = x0_2130._cons.Just.value;
      kk_function_drop(action0, _ctx);
      return kk_std_core_types__new_Just(x1, _ctx);
    }
  }
  {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// monadic lift

kk_unit_t kk_std_num_int32__mlift2106_lift1936_for32(kk_function_t action, int32_t end, int32_t i, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<e> (action : (int32) -> e (), end : int32, i : int32, wild_ : ()) -> e () */ 
  int32_t i0_1959 = (int32_t)((uint32_t)i + (uint32_t)((KK_I32(1)))); /*int32*/;
  kk_std_num_int32__lift1936_for32(action, end, i0_1959, _ctx); return kk_Unit;
}
 
// lifted local: for32, rep


// lift anonymous function
struct kk_std_num_int32__lift1936_for32_fun2404__t {
  struct kk_function_s _base;
  kk_function_t action0;
  int32_t end0;
  int32_t i0;
};
static kk_box_t kk_std_num_int32__lift1936_for32_fun2404(kk_function_t _fself, kk_box_t _b_2235, kk_context_t* _ctx);
static kk_function_t kk_std_num_int32__new_lift1936_for32_fun2404(kk_function_t action0, int32_t end0, int32_t i0, kk_context_t* _ctx) {
  struct kk_std_num_int32__lift1936_for32_fun2404__t* _self = kk_function_alloc_as(struct kk_std_num_int32__lift1936_for32_fun2404__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_int32__lift1936_for32_fun2404, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_int32__lift1936_for32_fun2404(kk_function_t _fself, kk_box_t _b_2235, kk_context_t* _ctx) {
  struct kk_std_num_int32__lift1936_for32_fun2404__t* _self = kk_function_as(struct kk_std_num_int32__lift1936_for32_fun2404__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (int32) -> 1527 () */
  int32_t end0 = _self->end0; /* int32 */
  int32_t i0 = _self->i0; /* int32 */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);;;}, {}, _ctx)
  kk_unit_t wild__0_2237 = kk_Unit;
  kk_unit_unbox(_b_2235);
  kk_unit_t _x2405 = kk_Unit;
  kk_std_num_int32__mlift2106_lift1936_for32(action0, end0, i0, wild__0_2237, _ctx);
  return kk_unit_box(_x2405);
}

kk_unit_t kk_std_num_int32__lift1936_for32(kk_function_t action0, int32_t end0, int32_t i0, kk_context_t* _ctx) { /* forall<e> (action : (int32) -> e (), end : int32, i : int32) -> e () */ 
  kk__tailcall: ;
  bool _match_2273 = (i0 <= end0); /*bool*/;
  if (_match_2273) {
    kk_unit_t x_2133 = kk_Unit;
    kk_function_t _x2402 = kk_function_dup(action0, _ctx); /*(int32) -> 1527 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, int32_t, kk_context_t*), _x2402, (_x2402, i0, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x2403 = kk_std_core_hnd_yield_extend(kk_std_num_int32__new_lift1936_for32_fun2404(action0, end0, i0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x2403); return kk_Unit;
    }
    {
      int32_t i0_19590 = (int32_t)((uint32_t)i0 + (uint32_t)((KK_I32(1)))); /*int32*/;
      { // tailcall
        i0 = i0_19590;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}

kk_std_core__list kk_std_num_int32__trmc_list32(int32_t lo, int32_t hi, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int32, hi : int32, ctx<list<int32>>) -> total list<int32> */ 
  kk__tailcall: ;
  bool _match_2272 = (lo <= hi); /*bool*/;
  if (_match_2272) {
    kk_std_core__list _trmc_2065 = kk_datatype_null(); /*list<int32>*/;
    kk_std_core__list _trmc_2066 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_int32_box(lo, _ctx), _trmc_2065, _ctx); /*list<int32>*/;
    kk_box_t* _b_2252_2247 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_2066, _ctx)->tail)); /*field-addr<list<int32>>*/;
    { // tailcall
      int32_t _x2408 = (int32_t)((uint32_t)lo + (uint32_t)((KK_I32(1)))); /*int32*/
      kk_std_core_types__cctx _x2409 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_2066, _ctx)),_b_2252_2247,true,kk_context()); /*ctx<0>*/
      lo = _x2408;
      _acc = _x2409;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x2410 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x2410, KK_OWNED, _ctx);
  }
}

kk_std_core__list kk_std_num_int32_list32(int32_t lo0, int32_t hi0, kk_context_t* _ctx) { /* (lo : int32, hi : int32) -> total list<int32> */ 
  kk_std_core_types__cctx _x2411 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_num_int32__trmc_list32(lo0, hi0, _x2411, _ctx);
}
 
// The maximal integer value before overflow happens

int32_t kk_std_num_int32_max_int32;
 
// Show an `:int32` in hexadecimal notation interpreted as an unsigned 32-bit value.
// The `width`  parameter specifies how wide the hex value is where `'0'`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number.

kk_string_t kk_std_num_int32_show_hex32(int32_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int32, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_integer_t _x2413 = kk_std_num_int32_uint(i, _ctx); /*int*/
  kk_std_core_types__optional _x2414;
  kk_box_t _x2415;
  kk_integer_t _x2416;
  if (kk_std_core_types__is_Optional(width, _ctx)) {
    kk_box_t _box_x2258 = width._cons.Optional.value;
    kk_integer_t _width_1763 = kk_integer_unbox(_box_x2258, _ctx);
    kk_integer_dup(_width_1763, _ctx);
    kk_std_core_types__optional_drop(width, _ctx);
    _x2416 = _width_1763; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(width, _ctx);
    _x2416 = kk_integer_from_small(8); /*int*/
  }
  _x2415 = kk_integer_box(_x2416, _ctx); /*116*/
  _x2414 = kk_std_core_types__new_Optional(_x2415, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2417;
  kk_box_t _x2418;
  bool _x2419;
  if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
    kk_box_t _box_x2260 = use_capitals._cons.Optional.value;
    bool _use_capitals_1767 = kk_bool_unbox(_box_x2260);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2419 = _use_capitals_1767; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x2419 = true; /*bool*/
  }
  _x2418 = kk_bool_box(_x2419); /*116*/
  _x2417 = kk_std_core_types__new_Optional(_x2418, _ctx); /*optional<116>*/
  kk_std_core_types__optional _x2420;
  kk_box_t _x2421;
  kk_string_t _x2422;
  if (kk_std_core_types__is_Optional(pre, _ctx)) {
    kk_box_t _box_x2262 = pre._cons.Optional.value;
    kk_string_t _pre_1771 = kk_string_unbox(_box_x2262);
    kk_string_dup(_pre_1771, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    _x2422 = _pre_1771; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_define_string_literal(, _s2423, 2, "0x", _ctx)
    _x2422 = kk_string_dup(_s2423, _ctx); /*string*/
  }
  _x2421 = kk_string_box(_x2422); /*116*/
  _x2420 = kk_std_core_types__new_Optional(_x2421, _ctx); /*optional<116>*/
  return kk_std_core_show_hex(_x2413, _x2414, _x2417, _x2420, _ctx);
}

int32_t kk_std_num_int32__unroll1937_sumacc32(kk_std_core__list xs, int32_t acc, kk_context_t* _ctx) { /* (xs : list<int32>, acc : int32) -> int32 */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con2424 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x2267 = _con2424->head;
    kk_std_core__list xx = _con2424->tail;
    int32_t x = kk_int32_unbox(_box_x2267, KK_BORROWED, _ctx);
    int32_t _own_2271 = (int32_t)((uint32_t)acc + (uint32_t)x); /*int32*/;
    { // tailcall
      xs = xx;
      acc = _own_2271;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}
 
// Convert an `:int` to `:int32` but interpret the `int` as an unsigned 32-bit value.
// `i` is clamped between `0` and `0xFFFFFFFF`.
// `0x7FFF_FFFF.uint32 == 0x7FFF_FFFF.int32 == max-int32`
// `0x8000_0000.uint32 == -0x8000_0000.int32 == min-int32`
// `0xFFFF_FFFF.uint32 == -1.int32`

int32_t kk_std_num_int32_uint32(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int32 */ 
  kk_integer_t _x2425;
  bool _match_2268;
  kk_integer_t _brw_2269 = kk_integer_from_int(kk_std_num_int32_max_int32,kk_context()); /*int*/;
  bool _brw_2270 = kk_integer_gt_borrow(i,_brw_2269,kk_context()); /*bool*/;
  kk_integer_drop(_brw_2269, _ctx);
  _match_2268 = _brw_2270; /*bool*/
  if (_match_2268) {
    _x2425 = kk_integer_sub(i,(kk_integer_from_str("4294967296", _ctx)),kk_context()); /*int*/
  }
  else {
    _x2425 = i; /*int*/
  }
  return kk_std_core_int32(_x2425, _ctx);
}

// initialization
void kk_std_num_int32__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_num_int32_one = (KK_I32(1)); /*int32*/
  }
  {
    kk_std_num_int32_zero = (KK_I32(0)); /*int32*/
  }
  {
    kk_std_num_int32_min_int32 = (INT32_MIN); /*int32*/
  }
  {
    kk_std_num_int32_bits_int32 = (KK_I32(32)); /*int32*/
  }
  {
    kk_std_num_int32_max_int32 = (KK_I32(2147483647)); /*int32*/
  }
}

// termination
void kk_std_num_int32__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
