// Koka generated module: "std/os/dir", koka version: 2.4.2, platform: 64-bit
#include "std_os_dir.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core__error kk_os_ensure_dir_error( kk_string_t path, kk_integer_t mode, kk_context_t* ctx ) {
  int m  = kk_integer_clamp32(mode,ctx);
  const int err = kk_os_ensure_dir(path,m,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core__error kk_os_copy_file_error( kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* ctx ) {
  const int err = kk_os_copy_file(from,to,preserve_mtime,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}

static kk_std_core__error kk_os_list_directory_prim( kk_string_t dir, kk_context_t* ctx ) {
  kk_vector_t contents;
  const int err = kk_os_list_directory(dir,&contents,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_vector_box(contents,ctx),ctx);
}


kk_std_core__exception kk_std_os_dir_prepend(kk_std_core__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x1480;
  kk_string_t _x1481;
  kk_string_t _x1482;
  kk_define_string_literal(, _s1483, 2, ": ", _ctx)
  _x1482 = kk_string_dup(_s1483, _ctx); /*string*/
  kk_string_t _x1484;
  {
    kk_string_t _x = exn.message;
    kk_string_dup(_x, _ctx);
    _x1484 = _x; /*string*/
  }
  _x1481 = kk_std_core__lp__plus__plus__1_rp_(_x1482, _x1484, _ctx); /*string*/
  _x1480 = kk_std_core__lp__plus__plus__1_rp_(pre, _x1481, _ctx); /*string*/
  kk_std_core__exception_info _x1485;
  {
    kk_std_core__exception_info _x0 = exn.info;
    kk_std_core__exception_info_dup(_x0, _ctx);
    kk_std_core__exception_drop(exn, _ctx);
    _x1485 = _x0; /*exception-info*/
  }
  return kk_std_core__new_Exception(_x1480, _x1485, _ctx);
}

kk_std_core__error kk_std_os_dir_prim_copy_file(kk_string_t from, kk_string_t to, bool preserve_mtime, kk_context_t* _ctx) { /* (from : string, to : string, preserve-mtime : bool) -> fsys error<()> */ 
  return kk_os_copy_file_error(from,to,preserve_mtime,kk_context());
}

kk_std_core__error kk_std_os_dir_ensure_dir_err(kk_string_t path, kk_integer_t mode, kk_context_t* _ctx) { /* (path : string, mode : int) -> fsys error<()> */ 
  return kk_os_ensure_dir_error(path,mode,kk_context());
}

bool kk_std_os_dir_prim_is_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys bool */ 
  return kk_os_is_directory(dir,kk_context());
}

kk_std_core__error kk_std_os_dir_prim_list_dir(kk_string_t dir, kk_context_t* _ctx) { /* (dir : string) -> fsys error<vector<string>> */ 
  return kk_os_list_directory_prim(dir,kk_context());
}

bool kk_std_os_dir_prim_is_file(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys bool */ 
  return kk_os_is_file(path,kk_context());
}
 
// Copy a file.


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1487__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1487(kk_function_t _fself, kk_box_t _b_1283, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1487(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1487, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun1487(kk_function_t _fself, kk_box_t _b_1283, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x1488;
  kk_std_os_path__path _x1489 = kk_std_os_path__path_unbox(_b_1283, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1488 = kk_std_os_path_string(_x1489, _ctx); /*string*/
  return kk_string_box(_x1488);
}


// lift anonymous function
struct kk_std_os_dir_copy_file_fun1493__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_file_fun1493(kk_function_t _fself, kk_box_t _b_1288, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_file_fun1493(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_file_fun1493, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_file_fun1493(kk_function_t _fself, kk_box_t _b_1288, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x1494;
  kk_std_os_path__path _x1495 = kk_std_os_path__path_unbox(_b_1288, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1494 = kk_std_os_path_string(_x1495, _ctx); /*string*/
  return kk_string_box(_x1494);
}

kk_unit_t kk_std_os_dir_copy_file(kk_std_os_path__path from, kk_std_os_path__path to, kk_std_core_types__optional preserve_mtime, kk_context_t* _ctx) { /* (from : std/os/path/path, to : std/os/path/path, preserve-mtime : optional<bool>) -> <exn,fsys> () */ 
  kk_string_t _x1_1177;
  kk_box_t _x1486;
  kk_box_t _x1490;
  kk_std_os_path__path _x1491 = kk_std_os_path__path_dup(from, _ctx); /*std/os/path/path*/
  _x1490 = kk_std_os_path__path_box(_x1491, _ctx); /*3356*/
  _x1486 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1487(_ctx), _x1490, _ctx); /*3357*/
  _x1_1177 = kk_string_unbox(_x1486); /*string*/
  kk_string_t _x2_1178;
  kk_box_t _x1492;
  kk_box_t _x1496;
  kk_std_os_path__path _x1497 = kk_std_os_path__path_dup(to, _ctx); /*std/os/path/path*/
  _x1496 = kk_std_os_path__path_box(_x1497, _ctx); /*3356*/
  _x1492 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_file_fun1493(_ctx), _x1496, _ctx); /*3357*/
  _x2_1178 = kk_string_unbox(_x1492); /*string*/
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<fsys,exn>>*/;
  kk_std_core__error x;
  bool _x1498;
  if (kk_std_core_types__is_Optional(preserve_mtime, _ctx)) {
    kk_box_t _box_x1291 = preserve_mtime._cons.Optional.value;
    bool _preserve_mtime_139 = kk_bool_unbox(_box_x1291);
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    _x1498 = _preserve_mtime_139; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(preserve_mtime, _ctx);
    _x1498 = true; /*bool*/
  }
  x = kk_std_os_dir_prim_copy_file(_x1_1177, _x2_1178, _x1498, _ctx); /*error<()>*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_std_core__is_Error(x, _ctx)) {
    kk_std_core__exception exn = x._cons.Error.exception;
    kk_std_core__exception_dup(exn, _ctx);
    kk_std_core__error_drop(x, _ctx);
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
    kk_string_t x0;
    kk_string_t _x1499 = kk_std_os_path_string(from, _ctx); /*string*/
    x0 = kk_std_core_show_3(_x1499, _ctx); /*string*/
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    kk_evv_t w1 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
    kk_string_t x2;
    kk_string_t _x1500 = kk_std_os_path_string(to, _ctx); /*string*/
    x2 = kk_std_core_show_3(_x1500, _ctx); /*string*/
    kk_unit_t keep1 = kk_Unit;
    kk_evv_set(w1,kk_context());
    kk_string_t _x20_1183;
    kk_string_t _x1501;
    kk_define_string_literal(, _s1502, 15, "unable to copy ", _ctx)
    _x1501 = kk_string_dup(_s1502, _ctx); /*string*/
    kk_string_t _x1503;
    kk_string_t _x1504;
    kk_string_t _x1505;
    kk_define_string_literal(, _s1506, 4, " to ", _ctx)
    _x1505 = kk_string_dup(_s1506, _ctx); /*string*/
    _x1504 = kk_std_core__lp__plus__plus__1_rp_(_x1505, x2, _ctx); /*string*/
    _x1503 = kk_std_core__lp__plus__plus__1_rp_(x0, _x1504, _ctx); /*string*/
    _x20_1183 = kk_std_core__lp__plus__plus__1_rp_(_x1501, _x1503, _ctx); /*string*/
    kk_evv_t w10 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
    kk_std_core__exception x4;
    kk_string_t _x1507;
    kk_string_t _x1508;
    kk_string_t _x1509;
    kk_define_string_literal(, _s1510, 2, ": ", _ctx)
    _x1509 = kk_string_dup(_s1510, _ctx); /*string*/
    kk_string_t _x1511;
    {
      kk_string_t _x = exn.message;
      kk_string_dup(_x, _ctx);
      _x1511 = _x; /*string*/
    }
    _x1508 = kk_std_core__lp__plus__plus__1_rp_(_x1509, _x1511, _ctx); /*string*/
    _x1507 = kk_std_core__lp__plus__plus__1_rp_(_x20_1183, _x1508, _ctx); /*string*/
    kk_std_core__exception_info _x1512;
    {
      kk_std_core__exception_info _x03 = exn.info;
      kk_std_core__exception_info_dup(_x03, _ctx);
      kk_std_core__exception_drop(exn, _ctx);
      _x1512 = _x03; /*exception-info*/
    }
    x4 = kk_std_core__new_Exception(_x1507, _x1512, _ctx); /*exception*/
    kk_unit_t keep10 = kk_Unit;
    kk_evv_set(w10,kk_context());
    kk_std_core_hnd__ev ev_1218;
    kk_ssize_t _x1513 = (KK_IZ(0)); /*ssize_t*/
    ev_1218 = kk_evv_at(_x1513,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t _x1514;
    {
      struct kk_std_core_hnd_Ev* _con1515 = kk_std_core_hnd__as_Ev(ev_1218, _ctx);
      kk_box_t _box_x1292 = _con1515->hnd;
      kk_std_core_hnd__marker m0 = _con1515->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x1292, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_1472;
      kk_std_core_hnd__clause1 _brw_1473 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_1472 = _brw_1473; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
      {
        kk_function_t _fun_unbox_x1296 = _match_1472.clause;
        _x1514 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x1296, (_fun_unbox_x1296, m0, ev_1218, kk_std_core__exception_box(x4, _ctx), _ctx), _ctx); /*52*/
      }
    }
    kk_unit_unbox(_x1514); return kk_Unit;
  }
  {
    kk_std_core__error_drop(x, _ctx);
    kk_std_os_path__path_drop(to, _ctx);
    kk_std_os_path__path_drop(from, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Ensure a directory path exists


// lift anonymous function
struct kk_std_os_dir_ensure_dir_fun1517__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_ensure_dir_fun1517(kk_function_t _fself, kk_box_t _b_1302, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_ensure_dir_fun1517(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_ensure_dir_fun1517, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_ensure_dir_fun1517(kk_function_t _fself, kk_box_t _b_1302, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x1518;
  kk_std_os_path__path _x1519 = kk_std_os_path__path_unbox(_b_1302, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1518 = kk_std_os_path_string(_x1519, _ctx); /*string*/
  return kk_string_box(_x1518);
}

kk_unit_t kk_std_os_dir_ensure_dir(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_string_t _x1_1186;
  kk_box_t _x1516;
  kk_box_t _x1520;
  kk_std_os_path__path _x1521 = kk_std_os_path__path_dup(dir, _ctx); /*std/os/path/path*/
  _x1520 = kk_std_os_path__path_box(_x1521, _ctx); /*3356*/
  _x1516 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_ensure_dir_fun1517(_ctx), _x1520, _ctx); /*3357*/
  _x1_1186 = kk_string_unbox(_x1516); /*string*/
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<fsys,exn>>*/;
  kk_std_core__error x = kk_std_os_dir_ensure_dir_err(_x1_1186, kk_integer_from_small(-1), _ctx); /*error<()>*/;
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_std_core__is_Error(x, _ctx)) {
    kk_std_core__exception exn = x._cons.Error.exception;
    kk_std_core__exception_dup(exn, _ctx);
    kk_std_core__error_drop(x, _ctx);
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
    kk_string_t x0;
    kk_string_t _x1522 = kk_std_os_path_string(dir, _ctx); /*string*/
    x0 = kk_std_core_show_3(_x1522, _ctx); /*string*/
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    kk_string_t _x20_1190;
    kk_string_t _x1523;
    kk_define_string_literal(, _s1524, 27, "unable to create directory ", _ctx)
    _x1523 = kk_string_dup(_s1524, _ctx); /*string*/
    _x20_1190 = kk_std_core__lp__plus__plus__1_rp_(_x1523, x0, _ctx); /*string*/
    kk_evv_t w1 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
    kk_std_core__exception x3;
    kk_string_t _x1525;
    kk_string_t _x1526;
    kk_string_t _x1527;
    kk_define_string_literal(, _s1528, 2, ": ", _ctx)
    _x1527 = kk_string_dup(_s1528, _ctx); /*string*/
    kk_string_t _x1529;
    {
      kk_string_t _x = exn.message;
      kk_string_dup(_x, _ctx);
      _x1529 = _x; /*string*/
    }
    _x1526 = kk_std_core__lp__plus__plus__1_rp_(_x1527, _x1529, _ctx); /*string*/
    _x1525 = kk_std_core__lp__plus__plus__1_rp_(_x20_1190, _x1526, _ctx); /*string*/
    kk_std_core__exception_info _x1530;
    {
      kk_std_core__exception_info _x02 = exn.info;
      kk_std_core__exception_info_dup(_x02, _ctx);
      kk_std_core__exception_drop(exn, _ctx);
      _x1530 = _x02; /*exception-info*/
    }
    x3 = kk_std_core__new_Exception(_x1525, _x1530, _ctx); /*exception*/
    kk_unit_t keep1 = kk_Unit;
    kk_evv_set(w1,kk_context());
    kk_std_core_hnd__ev ev_1229;
    kk_ssize_t _x1531 = (KK_IZ(0)); /*ssize_t*/
    ev_1229 = kk_evv_at(_x1531,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t _x1532;
    {
      struct kk_std_core_hnd_Ev* _con1533 = kk_std_core_hnd__as_Ev(ev_1229, _ctx);
      kk_box_t _box_x1305 = _con1533->hnd;
      kk_std_core_hnd__marker m0 = _con1533->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x1305, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_1470;
      kk_std_core_hnd__clause1 _brw_1471 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_1470 = _brw_1471; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
      {
        kk_function_t _fun_unbox_x1309 = _match_1470.clause;
        _x1532 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x1309, (_fun_unbox_x1309, m0, ev_1229, kk_std_core__exception_box(x3, _ctx), _ctx), _ctx); /*52*/
      }
    }
    kk_unit_unbox(_x1532); return kk_Unit;
  }
  {
    kk_box_t _box_x1313 = x._cons.Ok.result;
    kk_unit_t _pat300 = kk_unit_unbox(_box_x1313);
    kk_std_core__error_drop(x, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// lifted local: .lift1110-list-directory, list-directory, .spec.1038
// specialized: std/core/.unroll17333-map.5, on parameters f1033, using:
// f1033 = fn<(fsys :: X)>(name: string){
//   val p2.922 : std/os/path/path;
//   val parts1.2179 : (list :: V -> V)<string>;
//   val parts0.2177 : (optional :: V -> V)<(list :: V -> V)<string>>;
//   std/os/path/Path((match (dir) {
//       ((.skip std/os/path/Path((.x: string) : string, (.pat00: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat30: std/os/path/path)
//          -> .x;
//     }), (match (parts0.2177) {
//       ((std/core/types/Optional((.parts.894: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat10: ((optional :: V -> V)<(list :: V -> V)<string>>))
//          -> .parts.894;
//       ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat20: ((optional :: V -> V)<(list :: V -> V)<string>>))
//          -> std/core/Nil<string>;
//     }));
// }

kk_std_core__list kk_std_os_dir__trmc_lift1111_list_directory(kk_std_os_path__path dir, kk_std_core__list xs1032, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (dir : std/os/path/path, xs1032 : list<string>, ctx<list<std/os/path/path>>) -> fsys list<std/os/path/path> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs1032, _ctx)) {
    struct kk_std_core_Cons* _con1535 = kk_std_core__as_Cons(xs1032, _ctx);
    kk_box_t _box_x1314 = _con1535->head;
    kk_std_core__list xx1036 = _con1535->tail;
    kk_string_t x1035 = kk_string_unbox(_box_x1314);
    kk_reuse_t _ru_1474 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs1032, _ctx)) {
      _ru_1474 = (kk_datatype_ptr_reuse(xs1032, _ctx));
    }
    else {
      kk_string_dup(x1035, _ctx);
      kk_std_core__list_dup(xx1036, _ctx);
      kk_datatype_ptr_decref(xs1032, _ctx);
    }
    kk_std_os_path__path p2_922 = kk_std_os_path_path(x1035, _ctx); /*std/os/path/path*/;
    kk_std_core__list parts1_2179;
    {
      kk_std_core__list _x0 = p2_922.parts;
      kk_std_core__list_dup(_x0, _ctx);
      if (kk_std_core__is_Nil(_x0, _ctx)) {
        kk_std_os_path__path_drop(p2_922, _ctx);
        parts1_2179 = kk_std_core__new_Nil(_ctx); /*list<string>*/
      }
      else {
        kk_std_core__list_drop(_x0, _ctx);
        kk_std_core__list _x1536;
        {
          kk_std_core__list _x00 = p2_922.parts;
          kk_std_core__list_dup(_x00, _ctx);
          kk_std_os_path__path_drop(p2_922, _ctx);
          _x1536 = _x00; /*list<string>*/
        }
        parts1_2179 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), _x1536, _ctx); /*list<string>*/
      }
    }
    kk_std_core__list _b_1316_1315;
    if (kk_std_core__is_Nil(parts1_2179, _ctx)) {
      kk_std_core__list _x1 = dir.parts;
      kk_std_core__list_dup(_x1, _ctx);
      _b_1316_1315 = _x1; /*list<string>*/
    }
    else {
      kk_std_core__list _x1537;
      {
        kk_std_core__list _x10 = dir.parts;
        kk_std_core__list_dup(_x10, _ctx);
        _x1537 = _x10; /*list<string>*/
      }
      _b_1316_1315 = kk_std_os_path__unroll2107_push_parts(parts1_2179, _x1537, _ctx); /*list<string>*/
    }
    kk_std_core__list _trmc_1131 = kk_datatype_null(); /*list<std/os/path/path>*/;
    kk_std_core__list _trmc_1132;
    kk_box_t _x1538;
    kk_std_os_path__path _x1539;
    kk_string_t _x1540;
    {
      kk_string_t _x = dir.root;
      kk_string_dup(_x, _ctx);
      _x1540 = _x; /*string*/
    }
    kk_std_core__list _x1541;
    kk_std_core_types__optional _match_1469 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1316_1315, _ctx), _ctx); /*optional<116>*/;
    if (kk_std_core_types__is_Optional(_match_1469, _ctx)) {
      kk_box_t _box_x1317 = _match_1469._cons.Optional.value;
      kk_std_core__list _parts_894 = kk_std_core__list_unbox(_box_x1317, KK_BORROWED, _ctx);
      kk_std_core__list_dup(_parts_894, _ctx);
      kk_std_core_types__optional_drop(_match_1469, _ctx);
      _x1541 = _parts_894; /*list<string>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_1469, _ctx);
      _x1541 = kk_std_core__new_Nil(_ctx); /*list<string>*/
    }
    _x1539 = kk_std_os_path__new_Path(_x1540, _x1541, _ctx); /*std/os/path/path*/
    _x1538 = kk_std_os_path__path_box(_x1539, _ctx); /*61*/
    _trmc_1132 = kk_std_core__new_Cons(_ru_1474, 0, _x1538, _trmc_1131, _ctx); /*list<std/os/path/path>*/
    kk_box_t* _b_1332_1327 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_1132, _ctx)->tail)); /*field-addr<list<std/os/path/path>>*/;
    { // tailcall
      kk_std_core_types__cctx _x1542 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_1132, _ctx)),_b_1332_1327,true,kk_context()); /*ctx<0>*/
      xs1032 = xx1036;
      _acc = _x1542;
      goto kk__tailcall;
    }
  }
  {
    kk_std_os_path__path_drop(dir, _ctx);
    kk_box_t _x1543 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x1543, KK_OWNED, _ctx);
  }
}
 
// lifted local: .lift1110-list-directory, list-directory, .spec.1038
// specialized: std/core/.unroll17333-map.5, on parameters f1033, using:
// f1033 = fn<(fsys :: X)>(name: string){
//   val p2.922 : std/os/path/path;
//   val parts1.2179 : (list :: V -> V)<string>;
//   val parts0.2177 : (optional :: V -> V)<(list :: V -> V)<string>>;
//   std/os/path/Path((match (dir) {
//       ((.skip std/os/path/Path((.x: string) : string, (.pat00: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat30: std/os/path/path)
//          -> .x;
//     }), (match (parts0.2177) {
//       ((std/core/types/Optional((.parts.894: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat10: ((optional :: V -> V)<(list :: V -> V)<string>>))
//          -> .parts.894;
//       ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat20: ((optional :: V -> V)<(list :: V -> V)<string>>))
//          -> std/core/Nil<string>;
//     }));
// }

kk_std_core__list kk_std_os_dir__lift1111_list_directory(kk_std_os_path__path dir0, kk_std_core__list xs10320, kk_context_t* _ctx) { /* (dir : std/os/path/path, xs1032 : list<string>) -> fsys list<std/os/path/path> */ 
  kk_std_core_types__cctx _x1544 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_os_dir__trmc_lift1111_list_directory(dir0, xs10320, _x1544, _ctx);
}
 
// lifted local: list-directory, .spec.1031
// specialized: std/core/map.5, on parameters f1028, using:
// f1028 = fn<(fsys :: X)>(name: string){
//   val p2.922 : std/os/path/path;
//   val parts1.2179 : (list :: V -> V)<string>;
//   val parts0.2177 : (optional :: V -> V)<(list :: V -> V)<string>>;
//   std/os/path/Path((match (dir) {
//       ((.skip std/os/path/Path((.x: string) : string, (.pat00: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat30: std/os/path/path)
//          -> .x;
//     }), (match (parts0.2177) {
//       ((std/core/types/Optional((.parts.894: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat10: ((optional :: V -> V)<(list :: V -> V)<string>>))
//          -> .parts.894;
//       ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat20: ((optional :: V -> V)<(list :: V -> V)<string>>))
//          -> std/core/Nil<string>;
//     }));
// }

kk_std_core__list kk_std_os_dir__lift1110_list_directory(kk_std_os_path__path dir, kk_std_core__list xs1027, kk_context_t* _ctx) { /* (dir : std/os/path/path, xs1027 : list<string>) -> fsys list<std/os/path/path> */ 
  if (kk_std_core__is_Nil(xs1027, _ctx)) {
    kk_std_os_path__path_drop(dir, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
  {
    return kk_std_os_dir__lift1111_list_directory(dir, xs1027, _ctx);
  }
}
 
// List directory contents (excluding `.` and `..`).
// Returns a list of full paths (not just the names in the directory).

kk_std_core__list kk_std_os_dir_list_directory(kk_std_os_path__path dir, kk_context_t* _ctx) { /* (dir : std/os/path/path) -> fsys list<std/os/path/path> */ 
  kk_std_core__error _match_1468;
  kk_string_t _x1545;
  kk_std_os_path__path _x1546 = kk_std_os_path__path_dup(dir, _ctx); /*std/os/path/path*/
  _x1545 = kk_std_os_path_string(_x1546, _ctx); /*string*/
  _match_1468 = kk_std_os_dir_prim_list_dir(_x1545, _ctx); /*error<vector<string>>*/
  if (kk_std_core__is_Error(_match_1468, _ctx)) {
    kk_std_core__exception _pat0 = _match_1468._cons.Error.exception;
    kk_std_os_path__path_drop(dir, _ctx);
    kk_std_core__error_drop(_match_1468, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
  {
    kk_box_t _box_x1338 = _match_1468._cons.Ok.result;
    kk_vector_t contents = kk_vector_unbox(_box_x1338, _ctx);
    kk_vector_dup(contents, _ctx);
    kk_std_core__error_drop(_match_1468, _ctx);
    kk_std_core__list xs1027 = kk_std_core_vlist(contents, kk_std_core_types__new_None(_ctx), _ctx); /*list<string>*/;
    return kk_std_os_dir__lift1110_list_directory(dir, xs1027, _ctx);
  }
}
 
// lifted local: copy-directory, .spec.1050
// specialized: std/core/partition, on parameters pred1041, using:
// pred1041 = std/core/types/.open<(fsys :: X),<(fsys :: X),(div :: X),(exn :: HX)>,(dir : std/os/path/path) -> (fsys :: X) bool,(dir : std/os/path/path) -> <(fsys :: X),(div :: X),(exn :: HX)> bool>(std/os/dir/is-directory)


// lift anonymous function
struct kk_std_os_dir__lift1112_copy_directory_fun1547__t {
  struct kk_function_s _base;
};
static bool kk_std_os_dir__lift1112_copy_directory_fun1547(kk_function_t _fself, kk_box_t _b_1348, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift1112_copy_directory_fun1547(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__lift1112_copy_directory_fun1547, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_os_dir__lift1112_copy_directory_fun1549__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__lift1112_copy_directory_fun1549(kk_function_t _fself, kk_box_t _b_1343, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift1112_copy_directory_fun1549(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__lift1112_copy_directory_fun1549, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__lift1112_copy_directory_fun1549(kk_function_t _fself, kk_box_t _b_1343, kk_context_t* _ctx) {
  kk_unused(_fself);
  bool _x1550;
  kk_std_os_path__path _x1551 = kk_std_os_path__path_unbox(_b_1343, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1550 = kk_std_os_dir_is_directory(_x1551, _ctx); /*bool*/
  return kk_bool_box(_x1550);
}
static bool kk_std_os_dir__lift1112_copy_directory_fun1547(kk_function_t _fself, kk_box_t _b_1348, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _x1548 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_lift1112_copy_directory_fun1549(_ctx), _b_1348, _ctx); /*3357*/
  return kk_bool_unbox(_x1548);
}

kk_std_core_types__tuple2_ kk_std_os_dir__lift1112_copy_directory(kk_std_core__list xs1040, kk_context_t* _ctx) { /* (xs1040 : list<std/os/path/path>) -> <fsys,div,exn> (list<std/os/path/path>, list<std/os/path/path>) */ 
  if (kk_std_core__is_Nil(xs1040, _ctx)) {
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<fsys,div,exn>>*/;
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<fsys,div,exn>>*/;
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx), kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx), _ctx);
  }
  {
    return kk_std_core__unroll17349_partition_acc(xs1040, kk_std_os_dir__new_lift1112_copy_directory_fun1547(_ctx), kk_std_core__new_Nil(_ctx), kk_std_core__new_Nil(_ctx), _ctx);
  }
}
 
// monadic lift

kk_unit_t kk_std_os_dir__mlift1204_lift1114_copy_directory(kk_std_os_path__path to, kk_std_core__list xx1060, kk_unit_t wild__1061, kk_context_t* _ctx) { /* (to : std/os/path/path, xx1060 : list<std/os/path/path>, wild_1061 : ()) -> <exn,fsys> () */ 
  kk_std_os_dir__lift1114_copy_directory(to, xx1060, _ctx); return kk_Unit;
}
 
// lifted local: .lift1113-copy-directory, copy-directory, .spec.1063
// specialized: std/core/.unroll17339-foreach, on parameters action1057, using:
// action1057 = fn<<(exn :: HX),(fsys :: X),(div :: X)>>(f: std/os/path/path){
//   std/os/dir/copy-file(f, (std/core/types/.open<((<>) :: E),<(exn :: HX),(fsys :: X),(div :: X)>,(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path,(p1 : std/os/path/path, p2 : std/os/path/path) -> <(exn :: HX),(fsys :: X),(div :: X)> std/os/path/path>((fn(p1: std/os/path/path, p2: std/os/path/path){
//       val parts1.2179 : ((list :: V -> V)<string>);
//       val parts0.2177 : ((optional :: V -> V)<(list :: V -> V)<string>>);
//       (std/os/path/Path((match (p1) {
//           ((.skip std/os/path/Path((.x: string) : string, (.pat00: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat3: std/os/path/path)
//              -> .x;
//         }), (match (parts0.2177) {
//           ((std/core/types/Optional((.parts.894: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat1: ((optional :: V -> V)<(list :: V -> V)<string>>))
//              -> .parts.894;
//           ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat2: ((optional :: V -> V)<(list :: V -> V)<string>>))
//              -> std/core/Nil<string>;
//         })));
//     }))(to, (std/core/types/.open<((<>) :: E),<(exn :: HX),(fsys :: X),(div :: X)>,(p : std/os/path/path) -> std/os/path/path,(p : std/os/path/path) -> <(exn :: HX),(fsys :: X),(div :: X)> std/os/path/path>((fn(p: std/os/path/path){
//         val parts0.2130 : ((optional :: V -> V)<(list :: V -> V)<string>>)
//               = (std/core/types/Optional<(list :: V -> V)<string>>((std/core/take<string>((match (p) {
//                   ((.skip std/os/path/Path((.pat020: string) : string, (.x11: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat40: std/os/path/path)
//                      -> .x11;
//                 }), 1))));
//         (std/os/path/Path("", (match (parts0.2130) {
//             ((std/core/types/Optional((.parts.111: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat10: ((optional :: V -> V)<(list :: V -> V)<string>>))
//                -> .parts.111;
//             ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat20: ((optional :: V -> V)<(list :: V -> V)<string>>))
//                -> (match (p) {
//                 ((.skip std/os/path/Path((.pat010: string) : string, (.x01: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat30: std/os/path/path)
//                    -> .x01;
//               });
//           })));
//       }))(f)))), (std/core/types/None<bool>));
// }


// lift anonymous function
struct kk_std_os_dir__lift1114_copy_directory_fun1563__t {
  struct kk_function_s _base;
  kk_std_os_path__path to0;
  kk_std_core__list xx10600;
};
static kk_box_t kk_std_os_dir__lift1114_copy_directory_fun1563(kk_function_t _fself, kk_box_t _b_1366, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift1114_copy_directory_fun1563(kk_std_os_path__path to0, kk_std_core__list xx10600, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1114_copy_directory_fun1563__t* _self = kk_function_alloc_as(struct kk_std_os_dir__lift1114_copy_directory_fun1563__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__lift1114_copy_directory_fun1563, kk_context());
  _self->to0 = to0;
  _self->xx10600 = xx10600;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__lift1114_copy_directory_fun1563(kk_function_t _fself, kk_box_t _b_1366, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1114_copy_directory_fun1563__t* _self = kk_function_as(struct kk_std_os_dir__lift1114_copy_directory_fun1563__t*, _fself, _ctx);
  kk_std_os_path__path to0 = _self->to0; /* std/os/path/path */
  kk_std_core__list xx10600 = _self->xx10600; /* list<std/os/path/path> */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to0, _ctx);kk_std_core__list_dup(xx10600, _ctx);}, {}, _ctx)
  kk_unit_t wild__10610_1368 = kk_Unit;
  kk_unit_unbox(_b_1366);
  kk_unit_t _x1564 = kk_Unit;
  kk_std_os_dir__mlift1204_lift1114_copy_directory(to0, xx10600, wild__10610_1368, _ctx);
  return kk_unit_box(_x1564);
}

kk_unit_t kk_std_os_dir__lift1114_copy_directory(kk_std_os_path__path to0, kk_std_core__list xs1056, kk_context_t* _ctx) { /* (to : std/os/path/path, xs1056 : list<std/os/path/path>) -> <exn,fsys,div> () */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs1056, _ctx)) {
    struct kk_std_core_Cons* _con1552 = kk_std_core__as_Cons(xs1056, _ctx);
    kk_box_t _box_x1358 = _con1552->head;
    kk_std_core__list xx10600 = _con1552->tail;
    kk_std_os_path__path x1059 = kk_std_os_path__path_unbox(_box_x1358, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs1056, _ctx)) {
      kk_std_os_path__path_dup(x1059, _ctx);
      kk_box_drop(_box_x1358, _ctx);
      kk_datatype_ptr_free(xs1056, _ctx);
    }
    else {
      kk_std_os_path__path_dup(x1059, _ctx);
      kk_std_core__list_dup(xx10600, _ctx);
      kk_datatype_ptr_decref(xs1056, _ctx);
    }
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys,div>>*/;
    kk_std_core__list _b_1360_1359;
    kk_std_core__list _x1553;
    {
      kk_std_core__list _x110 = x1059.parts;
      kk_std_core__list_dup(_x110, _ctx);
      _x1553 = _x110; /*list<string>*/
    }
    _b_1360_1359 = kk_std_core_take(_x1553, kk_integer_from_small(1), _ctx); /*list<string>*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys,div>>*/;
    kk_std_os_path__path p2;
    kk_string_t _x1554 = kk_string_empty(); /*string*/
    kk_std_core__list _x1556;
    kk_std_core_types__optional _match_1467 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1360_1359, _ctx), _ctx); /*optional<116>*/;
    if (kk_std_core_types__is_Optional(_match_1467, _ctx)) {
      kk_box_t _box_x1361 = _match_1467._cons.Optional.value;
      kk_std_core__list _parts_111 = kk_std_core__list_unbox(_box_x1361, KK_BORROWED, _ctx);
      kk_std_core__list_dup(_parts_111, _ctx);
      kk_std_core_types__optional_drop(_match_1467, _ctx);
      _x1556 = _parts_111; /*list<string>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_1467, _ctx);
      {
        kk_std_core__list _x010 = x1059.parts;
        kk_std_core__list_dup(_x010, _ctx);
        _x1556 = _x010; /*list<string>*/
      }
    }
    p2 = kk_std_os_path__new_Path(_x1554, _x1556, _ctx); /*std/os/path/path*/
    kk_std_core__list parts1_2179;
    {
      kk_std_core__list _x00 = p2.parts;
      kk_std_core__list_dup(_x00, _ctx);
      if (kk_std_core__is_Nil(_x00, _ctx)) {
        kk_std_os_path__path_drop(p2, _ctx);
        parts1_2179 = kk_std_core__new_Nil(_ctx); /*list<string>*/
      }
      else {
        kk_std_core__list_drop(_x00, _ctx);
        kk_std_core__list _x1557;
        {
          kk_std_core__list _x000 = p2.parts;
          kk_std_core__list_dup(_x000, _ctx);
          kk_std_os_path__path_drop(p2, _ctx);
          _x1557 = _x000; /*list<string>*/
        }
        parts1_2179 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), _x1557, _ctx); /*list<string>*/
      }
    }
    kk_std_core__list _b_1363_1362;
    if (kk_std_core__is_Nil(parts1_2179, _ctx)) {
      kk_std_core__list _x10 = to0.parts;
      kk_std_core__list_dup(_x10, _ctx);
      _b_1363_1362 = _x10; /*list<string>*/
    }
    else {
      kk_std_core__list _x1558;
      {
        kk_std_core__list _x100 = to0.parts;
        kk_std_core__list_dup(_x100, _ctx);
        _x1558 = _x100; /*list<string>*/
      }
      _b_1363_1362 = kk_std_os_path__unroll2107_push_parts(parts1_2179, _x1558, _ctx); /*list<string>*/
    }
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    kk_unit_t x0_1238 = kk_Unit;
    kk_std_os_path__path _x1559;
    kk_string_t _x1560;
    {
      kk_string_t _x = to0.root;
      kk_string_dup(_x, _ctx);
      _x1560 = _x; /*string*/
    }
    kk_std_core__list _x1561;
    kk_std_core_types__optional _match_1466 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1363_1362, _ctx), _ctx); /*optional<116>*/;
    if (kk_std_core_types__is_Optional(_match_1466, _ctx)) {
      kk_box_t _box_x1364 = _match_1466._cons.Optional.value;
      kk_std_core__list _parts_894 = kk_std_core__list_unbox(_box_x1364, KK_BORROWED, _ctx);
      kk_std_core__list_dup(_parts_894, _ctx);
      kk_std_core_types__optional_drop(_match_1466, _ctx);
      _x1561 = _parts_894; /*list<string>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_1466, _ctx);
      _x1561 = kk_std_core__new_Nil(_ctx); /*list<string>*/
    }
    _x1559 = kk_std_os_path__new_Path(_x1560, _x1561, _ctx); /*std/os/path/path*/
    kk_std_os_dir_copy_file(x1059, _x1559, kk_std_core_types__new_None(_ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x1562 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_lift1114_copy_directory_fun1563(to0, xx10600, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x1562); return kk_Unit;
    }
    { // tailcall
      xs1056 = xx10600;
      goto kk__tailcall;
    }
  }
  {
    kk_std_os_path__path_drop(to0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// lifted local: copy-directory, .spec.1055
// specialized: std/core/foreach, on parameters action1052, using:
// action1052 = fn<<(exn :: HX),(fsys :: X),(div :: X)>>(f: std/os/path/path){
//   std/os/dir/copy-file(f, (std/core/types/.open<((<>) :: E),<(exn :: HX),(fsys :: X),(div :: X)>,(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path,(p1 : std/os/path/path, p2 : std/os/path/path) -> <(exn :: HX),(fsys :: X),(div :: X)> std/os/path/path>((fn(p1: std/os/path/path, p2: std/os/path/path){
//       val parts1.2179 : ((list :: V -> V)<string>);
//       val parts0.2177 : ((optional :: V -> V)<(list :: V -> V)<string>>);
//       (std/os/path/Path((match (p1) {
//           ((.skip std/os/path/Path((.x: string) : string, (.pat00: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat3: std/os/path/path)
//              -> .x;
//         }), (match (parts0.2177) {
//           ((std/core/types/Optional((.parts.894: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat1: ((optional :: V -> V)<(list :: V -> V)<string>>))
//              -> .parts.894;
//           ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat2: ((optional :: V -> V)<(list :: V -> V)<string>>))
//              -> std/core/Nil<string>;
//         })));
//     }))(to, (std/core/types/.open<((<>) :: E),<(exn :: HX),(fsys :: X),(div :: X)>,(p : std/os/path/path) -> std/os/path/path,(p : std/os/path/path) -> <(exn :: HX),(fsys :: X),(div :: X)> std/os/path/path>((fn(p: std/os/path/path){
//         val parts0.2130 : ((optional :: V -> V)<(list :: V -> V)<string>>)
//               = (std/core/types/Optional<(list :: V -> V)<string>>((std/core/take<string>((match (p) {
//                   ((.skip std/os/path/Path((.pat020: string) : string, (.x11: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat40: std/os/path/path)
//                      -> .x11;
//                 }), 1))));
//         (std/os/path/Path("", (match (parts0.2130) {
//             ((std/core/types/Optional((.parts.111: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat10: ((optional :: V -> V)<(list :: V -> V)<string>>))
//                -> .parts.111;
//             ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat20: ((optional :: V -> V)<(list :: V -> V)<string>>))
//                -> (match (p) {
//                 ((.skip std/os/path/Path((.pat010: string) : string, (.x01: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat30: std/os/path/path)
//                    -> .x01;
//               });
//           })));
//       }))(f)))), (std/core/types/None<bool>));
// }

kk_unit_t kk_std_os_dir__lift1113_copy_directory(kk_std_os_path__path to, kk_std_core__list xs1051, kk_context_t* _ctx) { /* (to : std/os/path/path, xs1051 : list<std/os/path/path>) -> <exn,fsys,div> () */ 
  if (kk_std_core__is_Nil(xs1051, _ctx)) {
    kk_std_os_path__path_drop(to, _ctx);
    kk_Unit; return kk_Unit;
  }
  {
    kk_std_os_dir__lift1114_copy_directory(to, xs1051, _ctx); return kk_Unit;
  }
}
 
// lifted local: copy-directory, .spec.1069
// specialized: std/core/foreach, on parameters action1066, using:
// action1066 = fn<<(div :: X),(exn :: HX),(fsys :: X)>>(d: std/os/path/path){
//   std/os/dir/copy-directory(d, (std/core/types/.open<((<>) :: E),<(div :: X),(exn :: HX),(fsys :: X)>,(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path,(p1 : std/os/path/path, p2 : std/os/path/path) -> <(div :: X),(exn :: HX),(fsys :: X)> std/os/path/path>((fn(p10: std/os/path/path, p20: std/os/path/path){
//       val parts1.21790 : ((list :: V -> V)<string>);
//       val parts0.21770 : ((optional :: V -> V)<(list :: V -> V)<string>>);
//       (std/os/path/Path((match (p10) {
//           ((.skip std/os/path/Path((.x2: string) : string, (.pat000: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat31: std/os/path/path)
//              -> .x2;
//         }), (match (parts0.21770) {
//           ((std/core/types/Optional((.parts.8940: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat11: ((optional :: V -> V)<(list :: V -> V)<string>>))
//              -> .parts.8940;
//           ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat21: ((optional :: V -> V)<(list :: V -> V)<string>>))
//              -> std/core/Nil<string>;
//         })));
//     }))(to, (std/core/types/.open<((<>) :: E),<(div :: X),(exn :: HX),(fsys :: X)>,(p : std/os/path/path) -> std/os/path/path,(p : std/os/path/path) -> <(div :: X),(exn :: HX),(fsys :: X)> std/os/path/path>((fn(p0: std/os/path/path){
//         val parts0.21300 : ((optional :: V -> V)<(list :: V -> V)<string>>)
//               = (std/core/types/Optional<(list :: V -> V)<string>>((std/core/take<string>((match (p0) {
//                   ((.skip std/os/path/Path((.pat022: string) : string, (.x13: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat42: std/os/path/path)
//                      -> .x13;
//                 }), 1))));
//         (std/os/path/Path("", (match (parts0.21300) {
//             ((std/core/types/Optional((.parts.1110: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat100: ((optional :: V -> V)<(list :: V -> V)<string>>))
//                -> .parts.1110;
//             ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat22: ((optional :: V -> V)<(list :: V -> V)<string>>))
//                -> (match (p0) {
//                 ((.skip std/os/path/Path((.pat012: string) : string, (.x03: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat32: std/os/path/path)
//                    -> .x03;
//               });
//           })));
//       }))(d)))));
// }

kk_unit_t kk_std_os_dir__lift1115_copy_directory(kk_std_os_path__path to, kk_std_core__list xs1065, kk_context_t* _ctx) { /* (to : std/os/path/path, xs1065 : list<std/os/path/path>) -> <div,exn,fsys> () */ 
  if (kk_std_core__is_Nil(xs1065, _ctx)) {
    kk_std_os_path__path_drop(to, _ctx);
    kk_Unit; return kk_Unit;
  }
  {
    kk_std_os_dir__lift1116_copy_directory(to, xs1065, _ctx); return kk_Unit;
  }
}
 
// monadic lift

kk_unit_t kk_std_os_dir__mlift1205_lift1116_copy_directory(kk_std_os_path__path to, kk_std_core__list xx1074, kk_unit_t wild__1075, kk_context_t* _ctx) { /* (to : std/os/path/path, xx1074 : list<std/os/path/path>, wild_1075 : ()) -> <fsys,pure> () */ 
  kk_std_os_dir__lift1116_copy_directory(to, xx1074, _ctx); return kk_Unit;
}
 
// monadic lift

kk_unit_t kk_std_os_dir__mlift1206_copy_directory(kk_std_core__list dirs, kk_std_os_path__path to0, kk_unit_t wild__0, kk_context_t* _ctx) { /* (dirs : list<std/os/path/path>, to : std/os/path/path, wild_0 : ()) -> <exn,fsys,div> () */ 
  kk_std_os_dir__lift1115_copy_directory(to0, dirs, _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift1207_copy_directory_fun1567__t {
  struct kk_function_s _base;
  kk_std_core__list dirs0;
  kk_std_os_path__path to1;
};
static kk_box_t kk_std_os_dir__mlift1207_copy_directory_fun1567(kk_function_t _fself, kk_box_t _b_1372, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1207_copy_directory_fun1567(kk_std_core__list dirs0, kk_std_os_path__path to1, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1207_copy_directory_fun1567__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1207_copy_directory_fun1567__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift1207_copy_directory_fun1567, kk_context());
  _self->dirs0 = dirs0;
  _self->to1 = to1;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__mlift1207_copy_directory_fun1567(kk_function_t _fself, kk_box_t _b_1372, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1207_copy_directory_fun1567__t* _self = kk_function_as(struct kk_std_os_dir__mlift1207_copy_directory_fun1567__t*, _fself, _ctx);
  kk_std_core__list dirs0 = _self->dirs0; /* list<std/os/path/path> */
  kk_std_os_path__path to1 = _self->to1; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core__list_dup(dirs0, _ctx);kk_std_os_path__path_dup(to1, _ctx);}, {}, _ctx)
  kk_unit_t wild__00_1374 = kk_Unit;
  kk_unit_unbox(_b_1372);
  kk_unit_t _x1568 = kk_Unit;
  kk_std_os_dir__mlift1206_copy_directory(dirs0, to1, wild__00_1374, _ctx);
  return kk_unit_box(_x1568);
}

kk_unit_t kk_std_os_dir__mlift1207_copy_directory(kk_std_os_path__path to1, kk_std_core_types__tuple2_ _y_1152, kk_context_t* _ctx) { /* (to : std/os/path/path, (list<std/os/path/path>, list<std/os/path/path>)) -> <fsys,div,exn> () */ 
  {
    kk_box_t _box_x1369 = _y_1152.fst;
    kk_box_t _box_x1370 = _y_1152.snd;
    kk_std_core__list dirs0 = kk_std_core__list_unbox(_box_x1369, KK_BORROWED, _ctx);
    kk_std_core__list files = kk_std_core__list_unbox(_box_x1370, KK_BORROWED, _ctx);
    kk_std_core__list_dup(dirs0, _ctx);
    kk_std_core__list_dup(files, _ctx);
    kk_std_core_types__tuple2__drop(_y_1152, _ctx);
    kk_unit_t x_1244 = kk_Unit;
    kk_std_os_path__path _x1565 = kk_std_os_path__path_dup(to1, _ctx); /*std/os/path/path*/
    kk_std_os_dir__lift1113_copy_directory(_x1565, files, _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x1566 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift1207_copy_directory_fun1567(dirs0, to1, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x1566); return kk_Unit;
    }
    {
      kk_std_os_dir__mlift1206_copy_directory(dirs0, to1, x_1244, _ctx); return kk_Unit;
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_dir__mlift1208_copy_directory_fun1570__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir__mlift1208_copy_directory_fun1570(kk_function_t _fself, kk_box_t _b_1377, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1208_copy_directory_fun1570(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir__mlift1208_copy_directory_fun1570, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir__mlift1208_copy_directory_fun1570(kk_function_t _fself, kk_box_t _b_1377, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _x1571;
  kk_std_os_path__path _x1572 = kk_std_os_path__path_unbox(_b_1377, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1571 = kk_std_os_dir_list_directory(_x1572, _ctx); /*list<std/os/path/path>*/
  return kk_std_core__list_box(_x1571, _ctx);
}


// lift anonymous function
struct kk_std_os_dir__mlift1208_copy_directory_fun1574__t {
  struct kk_function_s _base;
  kk_std_os_path__path to2;
};
static kk_box_t kk_std_os_dir__mlift1208_copy_directory_fun1574(kk_function_t _fself, kk_box_t _b_1381, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_mlift1208_copy_directory_fun1574(kk_std_os_path__path to2, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1208_copy_directory_fun1574__t* _self = kk_function_alloc_as(struct kk_std_os_dir__mlift1208_copy_directory_fun1574__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__mlift1208_copy_directory_fun1574, kk_context());
  _self->to2 = to2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__mlift1208_copy_directory_fun1574(kk_function_t _fself, kk_box_t _b_1381, kk_context_t* _ctx) {
  struct kk_std_os_dir__mlift1208_copy_directory_fun1574__t* _self = kk_function_as(struct kk_std_os_dir__mlift1208_copy_directory_fun1574__t*, _fself, _ctx);
  kk_std_os_path__path to2 = _self->to2; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to2, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2_ _y_1383_11520 = kk_std_core_types__tuple2__unbox(_b_1381, KK_OWNED, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  kk_unit_t _x1575 = kk_Unit;
  kk_std_os_dir__mlift1207_copy_directory(to2, _y_1383_11520, _ctx);
  return kk_unit_box(_x1575);
}

kk_unit_t kk_std_os_dir__mlift1208_copy_directory(kk_std_os_path__path dir, kk_std_os_path__path to2, kk_unit_t wild__, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path, wild_ : ()) -> <exn,fsys> () */ 
  kk_std_core__list all;
  kk_box_t _x1569 = kk_std_core_hnd__open_none1(kk_std_os_dir__new_mlift1208_copy_directory_fun1570(_ctx), kk_std_os_path__path_box(dir, _ctx), _ctx); /*3357*/
  all = kk_std_core__list_unbox(_x1569, KK_OWNED, _ctx); /*list<std/os/path/path>*/
  kk_std_core_types__tuple2_ x0_1246 = kk_std_os_dir__lift1112_copy_directory(all, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2__drop(x0_1246, _ctx);
    kk_box_t _x1573 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_mlift1208_copy_directory_fun1574(to2, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x1573); return kk_Unit;
  }
  {
    kk_std_os_dir__mlift1207_copy_directory(to2, x0_1246, _ctx); return kk_Unit;
  }
}
 
// lifted local: .lift1115-copy-directory, copy-directory, .spec.1077
// specialized: std/core/.unroll17339-foreach, on parameters action1071, using:
// action1071 = fn<<(div :: X),(exn :: HX),(fsys :: X)>>(d: std/os/path/path){
//   std/os/dir/copy-directory(d, (std/core/types/.open<((<>) :: E),<(div :: X),(exn :: HX),(fsys :: X)>,(p1 : std/os/path/path, p2 : std/os/path/path) -> std/os/path/path,(p1 : std/os/path/path, p2 : std/os/path/path) -> <(div :: X),(exn :: HX),(fsys :: X)> std/os/path/path>((fn(p10: std/os/path/path, p20: std/os/path/path){
//       val parts1.21790 : ((list :: V -> V)<string>);
//       val parts0.21770 : ((optional :: V -> V)<(list :: V -> V)<string>>);
//       (std/os/path/Path((match (p10) {
//           ((.skip std/os/path/Path((.x2: string) : string, (.pat000: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat31: std/os/path/path)
//              -> .x2;
//         }), (match (parts0.21770) {
//           ((std/core/types/Optional((.parts.8940: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat11: ((optional :: V -> V)<(list :: V -> V)<string>>))
//              -> .parts.8940;
//           ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat21: ((optional :: V -> V)<(list :: V -> V)<string>>))
//              -> std/core/Nil<string>;
//         })));
//     }))(to, (std/core/types/.open<((<>) :: E),<(div :: X),(exn :: HX),(fsys :: X)>,(p : std/os/path/path) -> std/os/path/path,(p : std/os/path/path) -> <(div :: X),(exn :: HX),(fsys :: X)> std/os/path/path>((fn(p0: std/os/path/path){
//         val parts0.21300 : ((optional :: V -> V)<(list :: V -> V)<string>>)
//               = (std/core/types/Optional<(list :: V -> V)<string>>((std/core/take<string>((match (p0) {
//                   ((.skip std/os/path/Path((.pat022: string) : string, (.x13: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat42: std/os/path/path)
//                      -> .x13;
//                 }), 1))));
//         (std/os/path/Path("", (match (parts0.21300) {
//             ((std/core/types/Optional((.parts.1110: (list :: V -> V)<string>) : (list :: V -> V)<string>) : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat100: ((optional :: V -> V)<(list :: V -> V)<string>>))
//                -> .parts.1110;
//             ((.skip std/core/types/None() : (optional :: V -> V)<(list :: V -> V)<string>> ) as .pat22: ((optional :: V -> V)<(list :: V -> V)<string>>))
//                -> (match (p0) {
//                 ((.skip std/os/path/Path((.pat012: string) : string, (.x03: (list :: V -> V)<string>) : (list :: V -> V)<string>) : std/os/path/path ) as .pat32: std/os/path/path)
//                    -> .x03;
//               });
//           })));
//       }))(d)))));
// }


// lift anonymous function
struct kk_std_os_dir__lift1116_copy_directory_fun1587__t {
  struct kk_function_s _base;
  kk_std_os_path__path to3;
  kk_std_core__list xx10740;
};
static kk_box_t kk_std_os_dir__lift1116_copy_directory_fun1587(kk_function_t _fself, kk_box_t _b_1392, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir__new_lift1116_copy_directory_fun1587(kk_std_os_path__path to3, kk_std_core__list xx10740, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1116_copy_directory_fun1587__t* _self = kk_function_alloc_as(struct kk_std_os_dir__lift1116_copy_directory_fun1587__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir__lift1116_copy_directory_fun1587, kk_context());
  _self->to3 = to3;
  _self->xx10740 = xx10740;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir__lift1116_copy_directory_fun1587(kk_function_t _fself, kk_box_t _b_1392, kk_context_t* _ctx) {
  struct kk_std_os_dir__lift1116_copy_directory_fun1587__t* _self = kk_function_as(struct kk_std_os_dir__lift1116_copy_directory_fun1587__t*, _fself, _ctx);
  kk_std_os_path__path to3 = _self->to3; /* std/os/path/path */
  kk_std_core__list xx10740 = _self->xx10740; /* list<std/os/path/path> */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to3, _ctx);kk_std_core__list_dup(xx10740, _ctx);}, {}, _ctx)
  kk_unit_t wild__10750_1394 = kk_Unit;
  kk_unit_unbox(_b_1392);
  kk_unit_t _x1588 = kk_Unit;
  kk_std_os_dir__mlift1205_lift1116_copy_directory(to3, xx10740, wild__10750_1394, _ctx);
  return kk_unit_box(_x1588);
}

kk_unit_t kk_std_os_dir__lift1116_copy_directory(kk_std_os_path__path to3, kk_std_core__list xs1070, kk_context_t* _ctx) { /* (to : std/os/path/path, xs1070 : list<std/os/path/path>) -> <div,exn,fsys> () */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs1070, _ctx)) {
    struct kk_std_core_Cons* _con1576 = kk_std_core__as_Cons(xs1070, _ctx);
    kk_box_t _box_x1384 = _con1576->head;
    kk_std_core__list xx10740 = _con1576->tail;
    kk_std_os_path__path x1073 = kk_std_os_path__path_unbox(_box_x1384, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs1070, _ctx)) {
      kk_std_os_path__path_dup(x1073, _ctx);
      kk_box_drop(_box_x1384, _ctx);
      kk_datatype_ptr_free(xs1070, _ctx);
    }
    else {
      kk_std_os_path__path_dup(x1073, _ctx);
      kk_std_core__list_dup(xx10740, _ctx);
      kk_datatype_ptr_decref(xs1070, _ctx);
    }
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<div,exn,fsys>>*/;
    kk_std_core__list _b_1386_1385;
    kk_std_core__list _x1577;
    {
      kk_std_core__list _x13 = x1073.parts;
      kk_std_core__list_dup(_x13, _ctx);
      _x1577 = _x13; /*list<string>*/
    }
    _b_1386_1385 = kk_std_core_take(_x1577, kk_integer_from_small(1), _ctx); /*list<string>*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<div,exn,fsys>>*/;
    kk_std_os_path__path p20;
    kk_string_t _x1578 = kk_string_empty(); /*string*/
    kk_std_core__list _x1580;
    kk_std_core_types__optional _match_1462 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1386_1385, _ctx), _ctx); /*optional<116>*/;
    if (kk_std_core_types__is_Optional(_match_1462, _ctx)) {
      kk_box_t _box_x1387 = _match_1462._cons.Optional.value;
      kk_std_core__list _parts_1110 = kk_std_core__list_unbox(_box_x1387, KK_BORROWED, _ctx);
      kk_std_core__list_dup(_parts_1110, _ctx);
      kk_std_core_types__optional_drop(_match_1462, _ctx);
      _x1580 = _parts_1110; /*list<string>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_1462, _ctx);
      {
        kk_std_core__list _x03 = x1073.parts;
        kk_std_core__list_dup(_x03, _ctx);
        _x1580 = _x03; /*list<string>*/
      }
    }
    p20 = kk_std_os_path__new_Path(_x1578, _x1580, _ctx); /*std/os/path/path*/
    kk_std_core__list parts1_21790;
    {
      kk_std_core__list _x02 = p20.parts;
      kk_std_core__list_dup(_x02, _ctx);
      if (kk_std_core__is_Nil(_x02, _ctx)) {
        kk_std_os_path__path_drop(p20, _ctx);
        parts1_21790 = kk_std_core__new_Nil(_ctx); /*list<string>*/
      }
      else {
        kk_std_core__list_drop(_x02, _ctx);
        kk_std_core__list _x1581;
        {
          kk_std_core__list _x000 = p20.parts;
          kk_std_core__list_dup(_x000, _ctx);
          kk_std_os_path__path_drop(p20, _ctx);
          _x1581 = _x000; /*list<string>*/
        }
        parts1_21790 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), _x1581, _ctx); /*list<string>*/
      }
    }
    kk_std_core__list _b_1389_1388;
    if (kk_std_core__is_Nil(parts1_21790, _ctx)) {
      kk_std_core__list _x12 = to3.parts;
      kk_std_core__list_dup(_x12, _ctx);
      _b_1389_1388 = _x12; /*list<string>*/
    }
    else {
      kk_std_core__list _x1582;
      {
        kk_std_core__list _x100 = to3.parts;
        kk_std_core__list_dup(_x100, _ctx);
        _x1582 = _x100; /*list<string>*/
      }
      _b_1389_1388 = kk_std_os_path__unroll2107_push_parts(parts1_21790, _x1582, _ctx); /*list<string>*/
    }
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    kk_unit_t x3_1250 = kk_Unit;
    kk_std_os_path__path _x1583;
    kk_string_t _x1584;
    {
      kk_string_t _x20 = to3.root;
      kk_string_dup(_x20, _ctx);
      _x1584 = _x20; /*string*/
    }
    kk_std_core__list _x1585;
    kk_std_core_types__optional _match_1461 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1389_1388, _ctx), _ctx); /*optional<116>*/;
    if (kk_std_core_types__is_Optional(_match_1461, _ctx)) {
      kk_box_t _box_x1390 = _match_1461._cons.Optional.value;
      kk_std_core__list _parts_8940 = kk_std_core__list_unbox(_box_x1390, KK_BORROWED, _ctx);
      kk_std_core__list_dup(_parts_8940, _ctx);
      kk_std_core_types__optional_drop(_match_1461, _ctx);
      _x1585 = _parts_8940; /*list<string>*/
    }
    else {
      kk_std_core_types__optional_drop(_match_1461, _ctx);
      _x1585 = kk_std_core__new_Nil(_ctx); /*list<string>*/
    }
    _x1583 = kk_std_os_path__new_Path(_x1584, _x1585, _ctx); /*std/os/path/path*/
    kk_std_os_dir_copy_directory(x1073, _x1583, _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x1586 = kk_std_core_hnd_yield_extend(kk_std_os_dir__new_lift1116_copy_directory_fun1587(to3, xx10740, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x1586); return kk_Unit;
    }
    { // tailcall
      xs1070 = xx10740;
      goto kk__tailcall;
    }
  }
  {
    kk_std_os_path__path_drop(to3, _ctx);
    kk_Unit; return kk_Unit;
  }
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1591__t {
  struct kk_function_s _base;
  kk_std_os_path__path dir0;
  kk_std_os_path__path to4;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1591(kk_function_t _fself, kk_box_t _b_1396, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1591(kk_std_os_path__path dir0, kk_std_os_path__path to4, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1591__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1591__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun1591, kk_context());
  _self->dir0 = dir0;
  _self->to4 = to4;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1591(kk_function_t _fself, kk_box_t _b_1396, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1591__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1591__t*, _fself, _ctx);
  kk_std_os_path__path dir0 = _self->dir0; /* std/os/path/path */
  kk_std_os_path__path to4 = _self->to4; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(dir0, _ctx);kk_std_os_path__path_dup(to4, _ctx);}, {}, _ctx)
  kk_unit_t wild__1_1411 = kk_Unit;
  kk_unit_unbox(_b_1396);
  kk_unit_t _x1592 = kk_Unit;
  kk_std_os_dir__mlift1208_copy_directory(dir0, to4, wild__1_1411, _ctx);
  return kk_unit_box(_x1592);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1594__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1594(kk_function_t _fself, kk_box_t _b_1399, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1594(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_dir_copy_directory_fun1594, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1594(kk_function_t _fself, kk_box_t _b_1399, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _x1595;
  kk_std_os_path__path _x1596 = kk_std_os_path__path_unbox(_b_1399, KK_OWNED, _ctx); /*std/os/path/path*/
  _x1595 = kk_std_os_dir_list_directory(_x1596, _ctx); /*list<std/os/path/path>*/
  return kk_std_core__list_box(_x1595, _ctx);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1598__t {
  struct kk_function_s _base;
  kk_std_os_path__path to4;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1598(kk_function_t _fself, kk_box_t _b_1403, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1598(kk_std_os_path__path to4, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1598__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1598__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun1598, kk_context());
  _self->to4 = to4;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1598(kk_function_t _fself, kk_box_t _b_1403, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1598__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1598__t*, _fself, _ctx);
  kk_std_os_path__path to4 = _self->to4; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_os_path__path_dup(to4, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2_ _y_1412_11521 = kk_std_core_types__tuple2__unbox(_b_1403, KK_OWNED, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
  kk_unit_t _x1599 = kk_Unit;
  kk_std_os_dir__mlift1207_copy_directory(to4, _y_1412_11521, _ctx);
  return kk_unit_box(_x1599);
}


// lift anonymous function
struct kk_std_os_dir_copy_directory_fun1602__t {
  struct kk_function_s _base;
  kk_std_core__list dirs1;
  kk_std_os_path__path to4;
};
static kk_box_t kk_std_os_dir_copy_directory_fun1602(kk_function_t _fself, kk_box_t _b_1407, kk_context_t* _ctx);
static kk_function_t kk_std_os_dir_new_copy_directory_fun1602(kk_std_core__list dirs1, kk_std_os_path__path to4, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1602__t* _self = kk_function_alloc_as(struct kk_std_os_dir_copy_directory_fun1602__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_dir_copy_directory_fun1602, kk_context());
  _self->dirs1 = dirs1;
  _self->to4 = to4;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_dir_copy_directory_fun1602(kk_function_t _fself, kk_box_t _b_1407, kk_context_t* _ctx) {
  struct kk_std_os_dir_copy_directory_fun1602__t* _self = kk_function_as(struct kk_std_os_dir_copy_directory_fun1602__t*, _fself, _ctx);
  kk_std_core__list dirs1 = _self->dirs1; /* list<std/os/path/path> */
  kk_std_os_path__path to4 = _self->to4; /* std/os/path/path */
  kk_drop_match(_self, {kk_std_core__list_dup(dirs1, _ctx);kk_std_os_path__path_dup(to4, _ctx);}, {}, _ctx)
  kk_unit_t wild__01_1413 = kk_Unit;
  kk_unit_unbox(_b_1407);
  kk_unit_t _x1603 = kk_Unit;
  kk_std_os_dir__mlift1206_copy_directory(dirs1, to4, wild__01_1413, _ctx);
  return kk_unit_box(_x1603);
}

kk_unit_t kk_std_os_dir_copy_directory(kk_std_os_path__path dir0, kk_std_os_path__path to4, kk_context_t* _ctx) { /* (dir : std/os/path/path, to : std/os/path/path) -> <pure,fsys> () */ 
  kk_unit_t x5_1256 = kk_Unit;
  kk_std_os_path__path _x1589 = kk_std_os_path__path_dup(to4, _ctx); /*std/os/path/path*/
  kk_std_os_dir_ensure_dir(_x1589, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x1590 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1591(dir0, to4, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x1590); return kk_Unit;
  }
  {
    kk_std_core__list all0;
    kk_box_t _x1593 = kk_std_core_hnd__open_none1(kk_std_os_dir_new_copy_directory_fun1594(_ctx), kk_std_os_path__path_box(dir0, _ctx), _ctx); /*3357*/
    all0 = kk_std_core__list_unbox(_x1593, KK_OWNED, _ctx); /*list<std/os/path/path>*/
    kk_std_core_types__tuple2_ x6_1259 = kk_std_os_dir__lift1112_copy_directory(all0, _ctx); /*(list<std/os/path/path>, list<std/os/path/path>)*/;
    if (kk_yielding(kk_context())) {
      kk_std_core_types__tuple2__drop(x6_1259, _ctx);
      kk_box_t _x1597 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1598(to4, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x1597); return kk_Unit;
    }
    {
      kk_box_t _box_x1404 = x6_1259.fst;
      kk_box_t _box_x1405 = x6_1259.snd;
      kk_std_core__list dirs1 = kk_std_core__list_unbox(_box_x1404, KK_BORROWED, _ctx);
      kk_std_core__list files0 = kk_std_core__list_unbox(_box_x1405, KK_BORROWED, _ctx);
      kk_std_core__list_dup(dirs1, _ctx);
      kk_std_core__list_dup(files0, _ctx);
      kk_std_core_types__tuple2__drop(x6_1259, _ctx);
      kk_unit_t x7_1262 = kk_Unit;
      kk_std_os_path__path _x1600 = kk_std_os_path__path_dup(to4, _ctx); /*std/os/path/path*/
      kk_std_os_dir__lift1113_copy_directory(_x1600, files0, _ctx);
      if (kk_yielding(kk_context())) {
        kk_box_t _x1601 = kk_std_core_hnd_yield_extend(kk_std_os_dir_new_copy_directory_fun1602(dirs1, to4, _ctx), _ctx); /*3926*/
        kk_unit_unbox(_x1601); return kk_Unit;
      }
      {
        kk_std_os_dir__lift1115_copy_directory(to4, dirs1, _ctx); return kk_Unit;
      }
    }
  }
}
 
// Copy a file to a directory

kk_unit_t kk_std_os_dir_copy_file_to_dir(kk_std_os_path__path from, kk_std_os_path__path dir, kk_context_t* _ctx) { /* (from : std/os/path/path, dir : std/os/path/path) -> <exn,fsys> () */ 
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
  kk_std_core__list _b_1415_1414;
  kk_std_core__list _x1604;
  {
    kk_std_core__list _x110 = from.parts;
    kk_std_core__list_dup(_x110, _ctx);
    _x1604 = _x110; /*list<string>*/
  }
  _b_1415_1414 = kk_std_core_take(_x1604, kk_integer_from_small(1), _ctx); /*list<string>*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
  kk_std_os_path__path p2;
  kk_string_t _x1605 = kk_string_empty(); /*string*/
  kk_std_core__list _x1607;
  kk_std_core_types__optional _match_1456 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1415_1414, _ctx), _ctx); /*optional<116>*/;
  if (kk_std_core_types__is_Optional(_match_1456, _ctx)) {
    kk_box_t _box_x1416 = _match_1456._cons.Optional.value;
    kk_std_core__list _parts_111 = kk_std_core__list_unbox(_box_x1416, KK_BORROWED, _ctx);
    kk_std_core__list_dup(_parts_111, _ctx);
    kk_std_core_types__optional_drop(_match_1456, _ctx);
    _x1607 = _parts_111; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_1456, _ctx);
    {
      kk_std_core__list _x010 = from.parts;
      kk_std_core__list_dup(_x010, _ctx);
      _x1607 = _x010; /*list<string>*/
    }
  }
  p2 = kk_std_os_path__new_Path(_x1605, _x1607, _ctx); /*std/os/path/path*/
  kk_std_core__list parts1_2179;
  {
    kk_std_core__list _x00 = p2.parts;
    kk_std_core__list_dup(_x00, _ctx);
    if (kk_std_core__is_Nil(_x00, _ctx)) {
      kk_std_os_path__path_drop(p2, _ctx);
      parts1_2179 = kk_std_core__new_Nil(_ctx); /*list<string>*/
    }
    else {
      kk_std_core__list_drop(_x00, _ctx);
      kk_std_core__list _x1608;
      {
        kk_std_core__list _x000 = p2.parts;
        kk_std_core__list_dup(_x000, _ctx);
        kk_std_os_path__path_drop(p2, _ctx);
        _x1608 = _x000; /*list<string>*/
      }
      parts1_2179 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), _x1608, _ctx); /*list<string>*/
    }
  }
  kk_std_core__list _b_1418_1417;
  if (kk_std_core__is_Nil(parts1_2179, _ctx)) {
    kk_std_core__list _x10 = dir.parts;
    kk_std_core__list_dup(_x10, _ctx);
    _b_1418_1417 = _x10; /*list<string>*/
  }
  else {
    kk_std_core__list _x1609;
    {
      kk_std_core__list _x100 = dir.parts;
      kk_std_core__list_dup(_x100, _ctx);
      _x1609 = _x100; /*list<string>*/
    }
    _b_1418_1417 = kk_std_os_path__unroll2107_push_parts(parts1_2179, _x1609, _ctx); /*list<string>*/
  }
  kk_unit_t keep0 = kk_Unit;
  kk_evv_set(w0,kk_context());
  kk_std_os_path__path _x1610;
  kk_string_t _x1611;
  {
    kk_string_t _x = dir.root;
    kk_string_dup(_x, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    _x1611 = _x; /*string*/
  }
  kk_std_core__list _x1612;
  kk_std_core_types__optional _match_1455 = kk_std_core_types__new_Optional(kk_std_core__list_box(_b_1418_1417, _ctx), _ctx); /*optional<116>*/;
  if (kk_std_core_types__is_Optional(_match_1455, _ctx)) {
    kk_box_t _box_x1419 = _match_1455._cons.Optional.value;
    kk_std_core__list _parts_894 = kk_std_core__list_unbox(_box_x1419, KK_BORROWED, _ctx);
    kk_std_core__list_dup(_parts_894, _ctx);
    kk_std_core_types__optional_drop(_match_1455, _ctx);
    _x1612 = _parts_894; /*list<string>*/
  }
  else {
    kk_std_core_types__optional_drop(_match_1455, _ctx);
    _x1612 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  }
  _x1610 = kk_std_os_path__new_Path(_x1611, _x1612, _ctx); /*std/os/path/path*/
  kk_std_os_dir_copy_file(from, _x1610, kk_std_core_types__new_None(_ctx), _ctx); return kk_Unit;
}
 
// lifted local: .lift1117-list-directory-recursive, list-directory-recursive, .spec.1092
// specialized: std/core/.unroll17341-filter, on parameters pred1085, using:
// pred1085 = std/os/dir/is-directory

kk_std_core__list kk_std_os_dir__trmc_lift1118_list_directory_recursive(kk_std_core__list xs1084, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (xs1084 : list<std/os/path/path>, ctx<list<std/os/path/path>>) -> <fsys,div> list<std/os/path/path> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs1084, _ctx)) {
    struct kk_std_core_Cons* _con1614 = kk_std_core__as_Cons(xs1084, _ctx);
    kk_box_t _box_x1420 = _con1614->head;
    kk_std_core__list xx1088 = _con1614->tail;
    kk_std_os_path__path x1087 = kk_std_os_path__path_unbox(_box_x1420, KK_BORROWED, _ctx);
    kk_reuse_t _ru_1477 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs1084, _ctx)) {
      kk_std_os_path__path_dup(x1087, _ctx);
      kk_box_drop(_box_x1420, _ctx);
      _ru_1477 = (kk_datatype_ptr_reuse(xs1084, _ctx));
    }
    else {
      kk_std_os_path__path_dup(x1087, _ctx);
      kk_std_core__list_dup(xx1088, _ctx);
      kk_datatype_ptr_decref(xs1084, _ctx);
    }
    bool _match_1454;
    kk_string_t _x1615;
    kk_std_os_path__path _x1616 = kk_std_os_path__path_dup(x1087, _ctx); /*std/os/path/path*/
    _x1615 = kk_std_os_path_string(_x1616, _ctx); /*string*/
    _match_1454 = kk_std_os_dir_prim_is_dir(_x1615, _ctx); /*bool*/
    if (_match_1454) {
      kk_std_core__list _trmc_1133 = kk_datatype_null(); /*list<std/os/path/path>*/;
      kk_std_core__list _trmc_1134 = kk_std_core__new_Cons(_ru_1477, 0, kk_std_os_path__path_box(x1087, _ctx), _trmc_1133, _ctx); /*list<std/os/path/path>*/;
      kk_box_t* _b_1435_1430 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_1134, _ctx)->tail)); /*field-addr<list<std/os/path/path>>*/;
      { // tailcall
        kk_std_core_types__cctx _x1617 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_1134, _ctx)),_b_1435_1430,true,kk_context()); /*ctx<0>*/
        xs1084 = xx1088;
        _acc = _x1617;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_1477,kk_context());
      kk_std_os_path__path_drop(x1087, _ctx);
      { // tailcall
        xs1084 = xx1088;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_box_t _x1618 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x1618, KK_OWNED, _ctx);
  }
}
 
// lifted local: .lift1117-list-directory-recursive, list-directory-recursive, .spec.1092
// specialized: std/core/.unroll17341-filter, on parameters pred1085, using:
// pred1085 = std/os/dir/is-directory

kk_std_core__list kk_std_os_dir__lift1118_list_directory_recursive(kk_std_core__list xs10840, kk_context_t* _ctx) { /* (xs1084 : list<std/os/path/path>) -> <fsys,div> list<std/os/path/path> */ 
  kk_std_core_types__cctx _x1619 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_os_dir__trmc_lift1118_list_directory_recursive(xs10840, _x1619, _ctx);
}
 
// lifted local: list-directory-recursive, .spec.1083
// specialized: std/core/filter, on parameters pred1080, using:
// pred1080 = std/os/dir/is-directory

kk_std_core__list kk_std_os_dir__lift1117_list_directory_recursive(kk_std_core__list xs1079, kk_context_t* _ctx) { /* (xs1079 : list<std/os/path/path>) -> <fsys,div> list<std/os/path/path> */ 
  if (kk_std_core__is_Nil(xs1079, _ctx)) {
    return kk_std_core__new_Nil(_ctx);
  }
  {
    return kk_std_os_dir__lift1118_list_directory_recursive(xs1079, _ctx);
  }
}
 
// lifted local: list-directory-recursive, .spec.1095
// specialized: std/core/flatmap, on parameters f1094, using:
// f1094 = fn<<(div :: X),(fsys :: X)>>(sub: std/os/path/path){
//   std/os/dir/list-directory-recursive(sub, (std/core/types/Optional<int>((std/core/int-sub((match (max-depth) {
//         ((std/core/types/Optional((.max-depth.816: int) : int) : (optional :: V -> V)<int> ) as .pat: ((optional :: V -> V)<int>))
//            -> .max-depth.816;
//         ((.skip std/core/types/None() : (optional :: V -> V)<int> ) as .pat0: ((optional :: V -> V)<int>))
//            -> 1000;
//       }), 1)))));
// }

kk_std_core__list kk_std_os_dir__lift1119_list_directory_recursive(kk_std_core_types__optional max_depth, kk_std_core__list xs1093, kk_context_t* _ctx) { /* (max-depth : optional<int>, xs1093 : list<std/os/path/path>) -> <div,fsys> list<std/os/path/path> */ 
  return kk_std_os_dir__lift1120_list_directory_recursive(max_depth, kk_std_core__new_Nil(_ctx), xs1093, _ctx);
}
 
// lifted local: .lift1119-list-directory-recursive, list-directory-recursive, .spec.1108
// specialized: std/core/.lift17312-flatmap, on parameters f1096, using:
// f1096 = fn<<(div :: X),(fsys :: X)>>(sub: std/os/path/path){
//   std/os/dir/list-directory-recursive(sub, (std/core/types/Optional<int>((std/core/int-sub((match (max-depth) {
//         ((std/core/types/Optional((.max-depth.816: int) : int) : (optional :: V -> V)<int> ) as .pat: ((optional :: V -> V)<int>))
//            -> .max-depth.816;
//         ((.skip std/core/types/None() : (optional :: V -> V)<int> ) as .pat0: ((optional :: V -> V)<int>))
//            -> 1000;
//       }), 1)))));
// }

kk_std_core__list kk_std_os_dir__lift1120_list_directory_recursive(kk_std_core_types__optional max_depth, kk_std_core__list ys1097, kk_std_core__list zs1098, kk_context_t* _ctx) { /* (max-depth : optional<int>, ys1097 : list<std/os/path/path>, zs1098 : list<std/os/path/path>) -> <div,fsys> list<std/os/path/path> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys1097, _ctx)) {
    struct kk_std_core_Cons* _con1620 = kk_std_core__as_Cons(ys1097, _ctx);
    kk_box_t _box_x1441 = _con1620->head;
    kk_std_core__list yy1101 = _con1620->tail;
    kk_std_os_path__path y1100 = kk_std_os_path__path_unbox(_box_x1441, KK_BORROWED, _ctx);
    kk_reuse_t _ru_1478 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys1097, _ctx)) {
      kk_std_os_path__path_dup(y1100, _ctx);
      kk_box_drop(_box_x1441, _ctx);
      _ru_1478 = (kk_datatype_ptr_reuse(ys1097, _ctx));
    }
    else {
      kk_std_os_path__path_dup(y1100, _ctx);
      kk_std_core__list_dup(yy1101, _ctx);
      kk_datatype_ptr_decref(ys1097, _ctx);
    }
    kk_std_core__list _b_1449_1443 = kk_std_os_dir__lift1120_list_directory_recursive(max_depth, yy1101, zs1098, _ctx); /*list<std/os/path/path>*/;
    return kk_std_core__new_Cons(_ru_1478, 0, kk_std_os_path__path_box(y1100, _ctx), _b_1449_1443, _ctx);
  }
  if (kk_std_core__is_Cons(zs1098, _ctx)) {
    struct kk_std_core_Cons* _con1621 = kk_std_core__as_Cons(zs1098, _ctx);
    kk_box_t _box_x1444 = _con1621->head;
    kk_std_core__list zz1105 = _con1621->tail;
    kk_std_os_path__path z1104 = kk_std_os_path__path_unbox(_box_x1444, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(zs1098, _ctx)) {
      kk_std_os_path__path_dup(z1104, _ctx);
      kk_box_drop(_box_x1444, _ctx);
      kk_datatype_ptr_free(zs1098, _ctx);
    }
    else {
      kk_std_os_path__path_dup(z1104, _ctx);
      kk_std_core__list_dup(zz1105, _ctx);
      kk_datatype_ptr_decref(zs1098, _ctx);
    }
    kk_integer_t _b_1447_1446;
    kk_integer_t _x1622;
    if (kk_std_core_types__is_Optional(max_depth, _ctx)) {
      kk_box_t _box_x1445 = max_depth._cons.Optional.value;
      kk_integer_t _max_depth_8160 = kk_integer_unbox(_box_x1445, _ctx);
      kk_integer_dup(_max_depth_8160, _ctx);
      _x1622 = _max_depth_8160; /*int*/
    }
    else {
      _x1622 = kk_integer_from_small(1000); /*int*/
    }
    _b_1447_1446 = kk_integer_add_small_const(_x1622, -1, _ctx); /*int*/
    kk_std_core__list ys1_173671106;
    kk_std_core_types__optional _x1623 = kk_std_core_types__new_Optional(kk_integer_box(_b_1447_1446, _ctx), _ctx); /*optional<116>*/
    ys1_173671106 = kk_std_os_dir_list_directory_recursive(z1104, _x1623, _ctx); /*list<std/os/path/path>*/
    { // tailcall
      ys1097 = ys1_173671106;
      zs1098 = zz1105;
      goto kk__tailcall;
    }
  }
  {
    kk_std_core_types__optional_drop(max_depth, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
}
 
// Recursively list all the entries under a directory.

kk_std_core__list kk_std_os_dir_list_directory_recursive(kk_std_os_path__path dir, kk_std_core_types__optional max_depth0, kk_context_t* _ctx) { /* (dir : std/os/path/path, max-depth : optional<int>) -> <div,fsys> list<std/os/path/path> */ 
  bool _match_1451;
  kk_integer_t _brw_1452;
  if (kk_std_core_types__is_Optional(max_depth0, _ctx)) {
    kk_box_t _box_x1450 = max_depth0._cons.Optional.value;
    kk_integer_t _max_depth_816 = kk_integer_unbox(_box_x1450, _ctx);
    kk_integer_dup(_max_depth_816, _ctx);
    _brw_1452 = _max_depth_816; /*int*/
  }
  else {
    _brw_1452 = kk_integer_from_small(1000); /*int*/
  }
  bool _brw_1453 = kk_integer_lt_borrow(_brw_1452,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_1452, _ctx);
  _match_1451 = _brw_1453; /*bool*/
  if (_match_1451) {
    kk_std_core_types__optional_drop(max_depth0, _ctx);
    kk_std_os_path__path_drop(dir, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
  {
    kk_std_core__list all = kk_std_os_dir_list_directory(dir, _ctx); /*list<std/os/path/path>*/;
    kk_std_core__list dirs;
    kk_std_core__list _x1624 = kk_std_core__list_dup(all, _ctx); /*list<std/os/path/path>*/
    dirs = kk_std_os_dir__lift1117_list_directory_recursive(_x1624, _ctx); /*list<std/os/path/path>*/
    kk_std_core__list ys_924 = kk_std_os_dir__lift1119_list_directory_recursive(max_depth0, dirs, _ctx); /*list<std/os/path/path>*/;
    if (kk_std_core__is_Nil(all, _ctx)) {
      return ys_924;
    }
    {
      return kk_std_core__unroll17330_append(all, ys_924, _ctx);
    }
  }
}

// initialization
void kk_std_os_dir__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_dir__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
