// Koka generated module: "std/os/file", koka version: 2.4.2, platform: 64-bit
#include "std_os_file.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core__error kk_os_read_text_file_error( kk_string_t path, kk_context_t* ctx ) {
  kk_string_t content;
  const int err = kk_os_read_text_file(path,&content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_string_box(content),ctx);
}

static kk_std_core__error kk_os_write_text_file_error( kk_string_t path, kk_string_t content, kk_context_t* ctx ) {
  const int err = kk_os_write_text_file(path,content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_unit_box(kk_Unit),ctx);
}


kk_std_core__exception kk_std_os_file_prepend(kk_std_core__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x513;
  kk_string_t _x514;
  kk_string_t _x515;
  kk_define_string_literal(, _s516, 2, ": ", _ctx)
  _x515 = kk_string_dup(_s516, _ctx); /*string*/
  kk_string_t _x517;
  {
    kk_string_t _x = exn.message;
    kk_string_dup(_x, _ctx);
    _x517 = _x; /*string*/
  }
  _x514 = kk_std_core__lp__plus__plus__1_rp_(_x515, _x517, _ctx); /*string*/
  _x513 = kk_std_core__lp__plus__plus__1_rp_(pre, _x514, _ctx); /*string*/
  kk_std_core__exception_info _x518;
  {
    kk_std_core__exception_info _x0 = exn.info;
    kk_std_core__exception_info_dup(_x0, _ctx);
    kk_std_core__exception_drop(exn, _ctx);
    _x518 = _x0; /*exception-info*/
  }
  return kk_std_core__new_Exception(_x513, _x518, _ctx);
}

kk_std_core__error kk_std_os_file_read_text_file_err(kk_string_t path, kk_context_t* _ctx) { /* (path : string) -> fsys error<string> */ 
  return kk_os_read_text_file_error(path,kk_context());
}

kk_std_core__error kk_std_os_file_write_text_file_err(kk_string_t path, kk_string_t content, kk_context_t* _ctx) { /* (path : string, content : string) -> fsys error<()> */ 
  return kk_os_write_text_file_error(path,content,kk_context());
}
 
// Read a text file synchronously (using UTF8 encoding)


// lift anonymous function
struct kk_std_os_file_read_text_file_fun520__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun520(kk_function_t _fself, kk_box_t _b_431, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun520(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun520, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_read_text_file_fun520(kk_function_t _fself, kk_box_t _b_431, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x521;
  kk_std_os_path__path _x522 = kk_std_os_path__path_unbox(_b_431, KK_OWNED, _ctx); /*std/os/path/path*/
  _x521 = kk_std_os_path_string(_x522, _ctx); /*string*/
  return kk_string_box(_x521);
}


// lift anonymous function
struct kk_std_os_file_read_text_file_fun526__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_read_text_file_fun526(kk_function_t _fself, kk_box_t _b_436, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_read_text_file_fun526(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_read_text_file_fun526, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_read_text_file_fun526(kk_function_t _fself, kk_box_t _b_436, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x527;
  kk_string_t _x528 = kk_string_unbox(_b_436); /*string*/
  _x527 = kk_std_os_file_read_text_file_err(_x528, _ctx); /*error<string>*/
  return kk_std_core__error_box(_x527, _ctx);
}

kk_string_t kk_std_os_file_read_text_file(kk_std_os_path__path path, kk_context_t* _ctx) { /* (path : std/os/path/path) -> <exn,fsys> string */ 
  kk_string_t _x1_383;
  kk_box_t _x519;
  kk_box_t _x523;
  kk_std_os_path__path _x524 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
  _x523 = kk_std_os_path__path_box(_x524, _ctx); /*3356*/
  _x519 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun520(_ctx), _x523, _ctx); /*3357*/
  _x1_383 = kk_string_unbox(_x519); /*string*/
  kk_std_core__error _match_508;
  kk_box_t _x525 = kk_std_core_hnd__open_none1(kk_std_os_file_new_read_text_file_fun526(_ctx), kk_string_box(_x1_383), _ctx); /*3357*/
  _match_508 = kk_std_core__error_unbox(_x525, KK_OWNED, _ctx); /*error<string>*/
  if (kk_std_core__is_Error(_match_508, _ctx)) {
    kk_std_core__exception exn = _match_508._cons.Error.exception;
    kk_std_core__exception_dup(exn, _ctx);
    kk_std_core__error_drop(_match_508, _ctx);
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
    kk_string_t x;
    kk_string_t _x529 = kk_std_os_path_string(path, _ctx); /*string*/
    x = kk_std_core_show_3(_x529, _ctx); /*string*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    kk_string_t _x2_386;
    kk_string_t _x530;
    kk_define_string_literal(, _s531, 25, "unable to read text file ", _ctx)
    _x530 = kk_string_dup(_s531, _ctx); /*string*/
    _x2_386 = kk_std_core__lp__plus__plus__1_rp_(_x530, x, _ctx); /*string*/
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
    kk_std_core__exception x0;
    kk_string_t _x532;
    kk_string_t _x533;
    kk_string_t _x534;
    kk_define_string_literal(, _s535, 2, ": ", _ctx)
    _x534 = kk_string_dup(_s535, _ctx); /*string*/
    kk_string_t _x536;
    {
      kk_string_t _x = exn.message;
      kk_string_dup(_x, _ctx);
      _x536 = _x; /*string*/
    }
    _x533 = kk_std_core__lp__plus__plus__1_rp_(_x534, _x536, _ctx); /*string*/
    _x532 = kk_std_core__lp__plus__plus__1_rp_(_x2_386, _x533, _ctx); /*string*/
    kk_std_core__exception_info _x537;
    {
      kk_std_core__exception_info _x02 = exn.info;
      kk_std_core__exception_info_dup(_x02, _ctx);
      kk_std_core__exception_drop(exn, _ctx);
      _x537 = _x02; /*exception-info*/
    }
    x0 = kk_std_core__new_Exception(_x532, _x537, _ctx); /*exception*/
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    kk_std_core_hnd__ev ev_402;
    kk_ssize_t _x538 = (KK_IZ(0)); /*ssize_t*/
    ev_402 = kk_evv_at(_x538,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t _x539;
    {
      struct kk_std_core_hnd_Ev* _con540 = kk_std_core_hnd__as_Ev(ev_402, _ctx);
      kk_box_t _box_x437 = _con540->hnd;
      kk_std_core_hnd__marker m0 = _con540->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x437, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_509;
      kk_std_core_hnd__clause1 _brw_510 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_509 = _brw_510; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
      {
        kk_function_t _fun_unbox_x441 = _match_509.clause;
        _x539 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x441, (_fun_unbox_x441, m0, ev_402, kk_std_core__exception_box(x0, _ctx), _ctx), _ctx); /*52*/
      }
    }
    return kk_string_unbox(_x539);
  }
  {
    kk_box_t _box_x445 = _match_508._cons.Ok.result;
    kk_string_t content = kk_string_unbox(_box_x445);
    kk_std_os_path__path_drop(path, _ctx);
    kk_string_dup(content, _ctx);
    kk_std_core__error_drop(_match_508, _ctx);
    return content;
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_os_file__mlift396_write_text_file_fun542__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift396_write_text_file_fun542(kk_function_t _fself, kk_box_t _b_450, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift396_write_text_file_fun542(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift396_write_text_file_fun542, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file__mlift396_write_text_file_fun542(kk_function_t _fself, kk_box_t _b_450, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x543;
  kk_std_os_path__path _x544 = kk_std_os_path__path_unbox(_b_450, KK_OWNED, _ctx); /*std/os/path/path*/
  _x543 = kk_std_os_path_string(_x544, _ctx); /*string*/
  return kk_string_box(_x543);
}


// lift anonymous function
struct kk_std_os_file__mlift396_write_text_file_fun548__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file__mlift396_write_text_file_fun548(kk_function_t _fself, kk_box_t _b_456, kk_box_t _b_457, kk_context_t* _ctx);
static kk_function_t kk_std_os_file__new_mlift396_write_text_file_fun548(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file__mlift396_write_text_file_fun548, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file__mlift396_write_text_file_fun548(kk_function_t _fself, kk_box_t _b_456, kk_box_t _b_457, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x549;
  kk_string_t _x550 = kk_string_unbox(_b_456); /*string*/
  kk_string_t _x551 = kk_string_unbox(_b_457); /*string*/
  _x549 = kk_std_os_file_write_text_file_err(_x550, _x551, _ctx); /*error<()>*/
  return kk_std_core__error_box(_x549, _ctx);
}

kk_unit_t kk_std_os_file__mlift396_write_text_file(kk_string_t content, kk_std_os_path__path path, kk_unit_t _c_370, kk_context_t* _ctx) { /* (content : string, path : std/os/path/path, ()) -> () */ 
  kk_string_t _x12_390;
  kk_box_t _x541;
  kk_box_t _x545;
  kk_std_os_path__path _x546 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
  _x545 = kk_std_os_path__path_box(_x546, _ctx); /*3356*/
  _x541 = kk_std_core_hnd__open_none1(kk_std_os_file__new_mlift396_write_text_file_fun542(_ctx), _x545, _ctx); /*3357*/
  _x12_390 = kk_string_unbox(_x541); /*string*/
  kk_std_core__error _match_505;
  kk_box_t _x547 = kk_std_core_hnd__open_none2(kk_std_os_file__new_mlift396_write_text_file_fun548(_ctx), kk_string_box(_x12_390), kk_string_box(content), _ctx); /*3449*/
  _match_505 = kk_std_core__error_unbox(_x547, KK_OWNED, _ctx); /*error<()>*/
  if (kk_std_core__is_Error(_match_505, _ctx)) {
    kk_std_core__exception exn = _match_505._cons.Error.exception;
    kk_std_core__exception_dup(exn, _ctx);
    kk_std_core__error_drop(_match_505, _ctx);
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
    kk_string_t x;
    kk_string_t _x552 = kk_std_os_path_string(path, _ctx); /*string*/
    x = kk_std_core_show_3(_x552, _ctx); /*string*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    kk_string_t _x20_394;
    kk_string_t _x553;
    kk_define_string_literal(, _s554, 26, "unable to write text file ", _ctx)
    _x553 = kk_string_dup(_s554, _ctx); /*string*/
    _x20_394 = kk_std_core__lp__plus__plus__1_rp_(_x553, x, _ctx); /*string*/
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
    kk_std_core__exception x0;
    kk_string_t _x555;
    kk_string_t _x556;
    kk_string_t _x557;
    kk_define_string_literal(, _s558, 2, ": ", _ctx)
    _x557 = kk_string_dup(_s558, _ctx); /*string*/
    kk_string_t _x559;
    {
      kk_string_t _x21 = exn.message;
      kk_string_dup(_x21, _ctx);
      _x559 = _x21; /*string*/
    }
    _x556 = kk_std_core__lp__plus__plus__1_rp_(_x557, _x559, _ctx); /*string*/
    _x555 = kk_std_core__lp__plus__plus__1_rp_(_x20_394, _x556, _ctx); /*string*/
    kk_std_core__exception_info _x560;
    {
      kk_std_core__exception_info _x3 = exn.info;
      kk_std_core__exception_info_dup(_x3, _ctx);
      kk_std_core__exception_drop(exn, _ctx);
      _x560 = _x3; /*exception-info*/
    }
    x0 = kk_std_core__new_Exception(_x555, _x560, _ctx); /*exception*/
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    kk_std_core_hnd__ev ev_410;
    kk_ssize_t _x561 = (KK_IZ(0)); /*ssize_t*/
    ev_410 = kk_evv_at(_x561,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t _x562;
    {
      struct kk_std_core_hnd_Ev* _con563 = kk_std_core_hnd__as_Ev(ev_410, _ctx);
      kk_box_t _box_x458 = _con563->hnd;
      kk_std_core_hnd__marker m0 = _con563->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x458, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_506;
      kk_std_core_hnd__clause1 _brw_507 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
      kk_std_core__hnd_exn_drop(h, _ctx);
      _match_506 = _brw_507; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
      {
        kk_function_t _fun_unbox_x462 = _match_506.clause;
        _x562 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x462, (_fun_unbox_x462, m0, ev_410, kk_std_core__exception_box(x0, _ctx), _ctx), _ctx); /*52*/
      }
    }
    kk_unit_unbox(_x562); return kk_Unit;
  }
  {
    kk_std_os_path__path_drop(path, _ctx);
    kk_std_core__error_drop(_match_505, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Write a text file synchronously (using UTF8 encoding)


// lift anonymous function
struct kk_std_os_file_write_text_file_fun573__t {
  struct kk_function_s _base;
  kk_string_t content;
  kk_std_os_path__path path;
};
static kk_box_t kk_std_os_file_write_text_file_fun573(kk_function_t _fself, kk_box_t _b_475, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun573(kk_string_t content, kk_std_os_path__path path, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun573__t* _self = kk_function_alloc_as(struct kk_std_os_file_write_text_file_fun573__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_os_file_write_text_file_fun573, kk_context());
  _self->content = content;
  _self->path = path;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun573(kk_function_t _fself, kk_box_t _b_475, kk_context_t* _ctx) {
  struct kk_std_os_file_write_text_file_fun573__t* _self = kk_function_as(struct kk_std_os_file_write_text_file_fun573__t*, _fself, _ctx);
  kk_string_t content = _self->content; /* string */
  kk_std_os_path__path path = _self->path; /* std/os/path/path */
  kk_drop_match(_self, {kk_string_dup(content, _ctx);kk_std_os_path__path_dup(path, _ctx);}, {}, _ctx)
  kk_unit_t _c_498_370 = kk_Unit;
  kk_unit_unbox(_b_475);
  kk_unit_t _x574 = kk_Unit;
  kk_std_os_file__mlift396_write_text_file(content, path, _c_498_370, _ctx);
  return kk_unit_box(_x574);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun576__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun576(kk_function_t _fself, kk_box_t _b_478, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun576(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun576, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun576(kk_function_t _fself, kk_box_t _b_478, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x577;
  kk_std_os_path__path _x578 = kk_std_os_path__path_unbox(_b_478, KK_OWNED, _ctx); /*std/os/path/path*/
  _x577 = kk_std_os_path_string(_x578, _ctx); /*string*/
  return kk_string_box(_x577);
}


// lift anonymous function
struct kk_std_os_file_write_text_file_fun582__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_file_write_text_file_fun582(kk_function_t _fself, kk_box_t _b_484, kk_box_t _b_485, kk_context_t* _ctx);
static kk_function_t kk_std_os_file_new_write_text_file_fun582(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_file_write_text_file_fun582, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_file_write_text_file_fun582(kk_function_t _fself, kk_box_t _b_484, kk_box_t _b_485, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x583;
  kk_string_t _x584 = kk_string_unbox(_b_484); /*string*/
  kk_string_t _x585 = kk_string_unbox(_b_485); /*string*/
  _x583 = kk_std_os_file_write_text_file_err(_x584, _x585, _ctx); /*error<()>*/
  return kk_std_core__error_box(_x583, _ctx);
}

kk_unit_t kk_std_os_file_write_text_file(kk_std_os_path__path path, kk_string_t content, kk_std_core_types__optional create_dir, kk_context_t* _ctx) { /* (path : std/os/path/path, content : string, create-dir : optional<bool>) -> <exn,fsys> () */ 
  kk_unit_t x_413 = kk_Unit;
  if (kk_std_core_types__is_Optional(create_dir, _ctx)) {
    kk_box_t _box_x469 = create_dir._cons.Optional.value;
    bool _create_dir_169 = kk_bool_unbox(_box_x469);
    kk_std_core_types__optional_drop(create_dir, _ctx);
    if (_create_dir_169) {
      kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
      kk_unit_t keep = kk_Unit;
      kk_evv_set(w,kk_context());
      kk_std_os_path__path _x564;
      kk_string_t _x565;
      kk_std_core_types__optional _match_504 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
      if (kk_std_core_types__is_Optional(_match_504, _ctx)) {
        kk_box_t _box_x470 = _match_504._cons.Optional.value;
        kk_string_t _root_105 = kk_string_unbox(_box_x470);
        kk_string_dup(_root_105, _ctx);
        kk_std_core_types__optional_drop(_match_504, _ctx);
        _x565 = _root_105; /*string*/
      }
      else {
        kk_std_core_types__optional_drop(_match_504, _ctx);
        {
          kk_string_t _x00 = path.root;
          kk_string_dup(_x00, _ctx);
          _x565 = _x00; /*string*/
        }
      }
      kk_std_core__list _x566;
      {
        kk_std_core__list _x = path.parts;
        kk_std_core__list_dup(_x, _ctx);
        if (kk_std_core__is_Cons(_x, _ctx)) {
          struct kk_std_core_Cons* _con567 = kk_std_core__as_Cons(_x, _ctx);
          kk_box_t _box_x471 = _con567->head;
          kk_std_core__list xx = _con567->tail;
          if kk_likely(kk_datatype_ptr_is_unique(_x, _ctx)) {
            kk_box_drop(_box_x471, _ctx);
            kk_datatype_ptr_free(_x, _ctx);
          }
          else {
            kk_std_core__list_dup(xx, _ctx);
            kk_datatype_ptr_decref(_x, _ctx);
          }
          _x566 = xx; /*list<string>*/
        }
        else {
          _x566 = kk_std_core__new_Nil(_ctx); /*list<string>*/
        }
      }
      _x564 = kk_std_os_path__new_Path(_x565, _x566, _ctx); /*std/os/path/path*/
      kk_std_os_dir_ensure_dir(_x564, _ctx);
    }
    else {
      
    }
  }
  else {
    kk_std_core_types__optional_drop(create_dir, _ctx);
    kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
    kk_unit_t keep0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    kk_std_os_path__path _x568;
    kk_string_t _x569;
    kk_std_core_types__optional _match_503 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_503, _ctx)) {
      kk_box_t _box_x472 = _match_503._cons.Optional.value;
      kk_string_t _root_1050 = kk_string_unbox(_box_x472);
      kk_string_dup(_root_1050, _ctx);
      kk_std_core_types__optional_drop(_match_503, _ctx);
      _x569 = _root_1050; /*string*/
    }
    else {
      kk_std_core_types__optional_drop(_match_503, _ctx);
      {
        kk_string_t _x000 = path.root;
        kk_string_dup(_x000, _ctx);
        _x569 = _x000; /*string*/
      }
    }
    kk_std_core__list _x570;
    {
      kk_std_core__list _x11 = path.parts;
      kk_std_core__list_dup(_x11, _ctx);
      if (kk_std_core__is_Cons(_x11, _ctx)) {
        struct kk_std_core_Cons* _con571 = kk_std_core__as_Cons(_x11, _ctx);
        kk_box_t _box_x473 = _con571->head;
        kk_std_core__list xx0 = _con571->tail;
        if kk_likely(kk_datatype_ptr_is_unique(_x11, _ctx)) {
          kk_box_drop(_box_x473, _ctx);
          kk_datatype_ptr_free(_x11, _ctx);
        }
        else {
          kk_std_core__list_dup(xx0, _ctx);
          kk_datatype_ptr_decref(_x11, _ctx);
        }
        _x570 = xx0; /*list<string>*/
      }
      else {
        _x570 = kk_std_core__new_Nil(_ctx); /*list<string>*/
      }
    }
    _x568 = kk_std_os_path__new_Path(_x569, _x570, _ctx); /*std/os/path/path*/
    kk_std_os_dir_ensure_dir(_x568, _ctx);
  }
  if (kk_yielding(kk_context())) {
    kk_box_t _x572 = kk_std_core_hnd_yield_extend(kk_std_os_file_new_write_text_file_fun573(content, path, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x572); return kk_Unit;
  }
  {
    kk_string_t _x12_390;
    kk_box_t _x575;
    kk_box_t _x579;
    kk_std_os_path__path _x580 = kk_std_os_path__path_dup(path, _ctx); /*std/os/path/path*/
    _x579 = kk_std_os_path__path_box(_x580, _ctx); /*3356*/
    _x575 = kk_std_core_hnd__open_none1(kk_std_os_file_new_write_text_file_fun576(_ctx), _x579, _ctx); /*3357*/
    _x12_390 = kk_string_unbox(_x575); /*string*/
    kk_std_core__error _match_500;
    kk_box_t _x581 = kk_std_core_hnd__open_none2(kk_std_os_file_new_write_text_file_fun582(_ctx), kk_string_box(_x12_390), kk_string_box(content), _ctx); /*3449*/
    _match_500 = kk_std_core__error_unbox(_x581, KK_OWNED, _ctx); /*error<()>*/
    if (kk_std_core__is_Error(_match_500, _ctx)) {
      kk_std_core__exception exn = _match_500._cons.Error.exception;
      kk_std_core__exception_dup(exn, _ctx);
      kk_std_core__error_drop(_match_500, _ctx);
      kk_evv_t w1 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
      kk_string_t x3;
      kk_string_t _x586 = kk_std_os_path_string(path, _ctx); /*string*/
      x3 = kk_std_core_show_3(_x586, _ctx); /*string*/
      kk_unit_t keep1 = kk_Unit;
      kk_evv_set(w1,kk_context());
      kk_string_t _x20_394;
      kk_string_t _x587;
      kk_define_string_literal(, _s588, 26, "unable to write text file ", _ctx)
      _x587 = kk_string_dup(_s588, _ctx); /*string*/
      _x20_394 = kk_std_core__lp__plus__plus__1_rp_(_x587, x3, _ctx); /*string*/
      kk_evv_t w2 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,fsys>>*/;
      kk_std_core__exception x4;
      kk_string_t _x589;
      kk_string_t _x590;
      kk_string_t _x591;
      kk_define_string_literal(, _s592, 2, ": ", _ctx)
      _x591 = kk_string_dup(_s592, _ctx); /*string*/
      kk_string_t _x593;
      {
        kk_string_t _x21 = exn.message;
        kk_string_dup(_x21, _ctx);
        _x593 = _x21; /*string*/
      }
      _x590 = kk_std_core__lp__plus__plus__1_rp_(_x591, _x593, _ctx); /*string*/
      _x589 = kk_std_core__lp__plus__plus__1_rp_(_x20_394, _x590, _ctx); /*string*/
      kk_std_core__exception_info _x594;
      {
        kk_std_core__exception_info _x3 = exn.info;
        kk_std_core__exception_info_dup(_x3, _ctx);
        kk_std_core__exception_drop(exn, _ctx);
        _x594 = _x3; /*exception-info*/
      }
      x4 = kk_std_core__new_Exception(_x589, _x594, _ctx); /*exception*/
      kk_unit_t keep2 = kk_Unit;
      kk_evv_set(w2,kk_context());
      kk_std_core_hnd__ev ev_425;
      kk_ssize_t _x595 = (KK_IZ(0)); /*ssize_t*/
      ev_425 = kk_evv_at(_x595,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
      kk_box_t _x596;
      {
        struct kk_std_core_hnd_Ev* _con597 = kk_std_core_hnd__as_Ev(ev_425, _ctx);
        kk_box_t _box_x486 = _con597->hnd;
        kk_std_core_hnd__marker m0 = _con597->marker;
        kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x486, KK_BORROWED, _ctx);
        kk_std_core__hnd_exn_dup(h, _ctx);
        kk_std_core_hnd__clause1 _match_501;
        kk_std_core_hnd__clause1 _brw_502 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
        kk_std_core__hnd_exn_drop(h, _ctx);
        _match_501 = _brw_502; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
        {
          kk_function_t _fun_unbox_x490 = _match_501.clause;
          _x596 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x490, (_fun_unbox_x490, m0, ev_425, kk_std_core__exception_box(x4, _ctx), _ctx), _ctx); /*52*/
        }
      }
      kk_unit_unbox(_x596); return kk_Unit;
    }
    {
      kk_std_os_path__path_drop(path, _ctx);
      kk_std_core__error_drop(_match_500, _ctx);
      kk_Unit; return kk_Unit;
    }
  }
}

// initialization
void kk_std_os_file__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_os_path__init(_ctx);
  kk_std_os_dir__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_file__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_os_dir__done(_ctx);
  kk_std_os_path__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
