// Koka generated module: "std/os/readline", koka version: 2.4.2, platform: 64-bit
#include "std_os_readline.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core__error kk_os_read_line_error( kk_context_t* ctx ) {
  kk_string_t content;
  const int err = kk_os_read_line(&content,ctx);
  if (err != 0) return kk_error_from_errno(err,ctx);
           else return kk_error_ok(kk_string_box(content),ctx);
}



kk_std_core__exception kk_std_os_readline_prepend(kk_std_core__exception exn, kk_string_t pre, kk_context_t* _ctx) { /* (exn : exception, pre : string) -> exception */ 
  kk_string_t _x239;
  kk_string_t _x240;
  kk_string_t _x241;
  kk_define_string_literal(, _s242, 2, ": ", _ctx)
  _x241 = kk_string_dup(_s242, _ctx); /*string*/
  kk_string_t _x243;
  {
    kk_string_t _x = exn.message;
    kk_string_dup(_x, _ctx);
    _x243 = _x; /*string*/
  }
  _x240 = kk_std_core__lp__plus__plus__1_rp_(_x241, _x243, _ctx); /*string*/
  _x239 = kk_std_core__lp__plus__plus__1_rp_(pre, _x240, _ctx); /*string*/
  kk_std_core__exception_info _x244;
  {
    kk_std_core__exception_info _x0 = exn.info;
    kk_std_core__exception_info_dup(_x0, _ctx);
    kk_std_core__exception_drop(exn, _ctx);
    _x244 = _x0; /*exception-info*/
  }
  return kk_std_core__new_Exception(_x239, _x244, _ctx);
}

kk_std_core__error kk_std_os_readline_readline_err(kk_context_t* _ctx) { /* () -> console error<string> */ 
  return kk_os_read_line_error(kk_context());
}
 
// Read a line of input synchronously from stdin (using UTF8 encoding).
// Read chararacters until either a newline is encountered (not included in the result),
// or 1023 characters have been read.


// lift anonymous function
struct kk_std_os_readline_readline_fun246__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_os_readline_readline_fun246(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_os_readline_new_readline_fun246(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_os_readline_readline_fun246, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_os_readline_readline_fun246(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x247 = kk_std_os_readline_readline_err(_ctx); /*error<string>*/
  return kk_std_core__error_box(_x247, _ctx);
}

kk_string_t kk_std_os_readline_readline(kk_context_t* _ctx) { /* () -> <console,exn> string */ 
  kk_std_core__error _match_235;
  kk_box_t _x245 = kk_std_core_hnd__open_none0(kk_std_os_readline_new_readline_fun246(_ctx), _ctx); /*3280*/
  _match_235 = kk_std_core__error_unbox(_x245, KK_OWNED, _ctx); /*error<string>*/
  if (kk_std_core__is_Error(_match_235, _ctx)) {
    kk_std_core__exception exn = _match_235._cons.Error.exception;
    kk_std_core__exception_dup(exn, _ctx);
    kk_std_core__error_drop(_match_235, _ctx);
    kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn,console>>*/;
    kk_std_core__exception x;
    kk_string_t _x248;
    kk_string_t _x249;
    kk_define_string_literal(, _s250, 25, "unable to read from stdin", _ctx)
    _x249 = kk_string_dup(_s250, _ctx); /*string*/
    kk_string_t _x251;
    kk_string_t _x252;
    kk_define_string_literal(, _s253, 2, ": ", _ctx)
    _x252 = kk_string_dup(_s253, _ctx); /*string*/
    kk_string_t _x254;
    {
      kk_string_t _x = exn.message;
      kk_string_dup(_x, _ctx);
      _x254 = _x; /*string*/
    }
    _x251 = kk_std_core__lp__plus__plus__1_rp_(_x252, _x254, _ctx); /*string*/
    _x248 = kk_std_core__lp__plus__plus__1_rp_(_x249, _x251, _ctx); /*string*/
    kk_std_core__exception_info _x255;
    {
      kk_std_core__exception_info _x01 = exn.info;
      kk_std_core__exception_info_dup(_x01, _ctx);
      kk_std_core__exception_drop(exn, _ctx);
      _x255 = _x01; /*exception-info*/
    }
    x = kk_std_core__new_Exception(_x248, _x255, _ctx); /*exception*/
    kk_unit_t keep = kk_Unit;
    kk_evv_set(w,kk_context());
    kk_std_core__error _match_236 = kk_std_core__new_Error(x, _ctx); /*error<30>*/;
    if (kk_std_core__is_Error(_match_236, _ctx)) {
      kk_std_core__exception exn0 = _match_236._cons.Error.exception;
      kk_std_core__exception_dup(exn0, _ctx);
      kk_std_core__error_drop(_match_236, _ctx);
      kk_std_core_hnd__ev ev_220;
      kk_ssize_t _x256 = (KK_IZ(0)); /*ssize_t*/
      ev_220 = kk_evv_at(_x256,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
      kk_box_t _x257;
      {
        struct kk_std_core_hnd_Ev* _con258 = kk_std_core_hnd__as_Ev(ev_220, _ctx);
        kk_box_t _box_x224 = _con258->hnd;
        kk_std_core_hnd__marker m0 = _con258->marker;
        kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x224, KK_BORROWED, _ctx);
        kk_std_core__hnd_exn_dup(h, _ctx);
        kk_std_core_hnd__clause1 _match_237;
        kk_std_core_hnd__clause1 _brw_238 = kk_std_core__select_throw_exn(h, _ctx); /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/;
        kk_std_core__hnd_exn_drop(h, _ctx);
        _match_237 = _brw_238; /*std/core/hnd/clause1<exception,1945,.hnd-exn,1946,1947>*/
        {
          kk_function_t _fun_unbox_x228 = _match_237.clause;
          _x257 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x228, (_fun_unbox_x228, m0, ev_220, kk_std_core__exception_box(exn0, _ctx), _ctx), _ctx); /*52*/
        }
      }
      return kk_string_unbox(_x257);
    }
    {
      kk_box_t _box_x232 = _match_236._cons.Ok.result;
      kk_string_t x3 = kk_string_unbox(_box_x232);
      kk_string_dup(x3, _ctx);
      kk_std_core__error_drop(_match_236, _ctx);
      return x3;
    }
  }
  {
    kk_box_t _box_x233 = _match_235._cons.Ok.result;
    kk_string_t line = kk_string_unbox(_box_x233);
    kk_string_dup(line, _ctx);
    kk_std_core__error_drop(_match_235, _ctx);
    return line;
  }
}

// initialization
void kk_std_os_readline__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_os_readline__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
