#pragma once
#ifndef kk_std_time_timestamp_H
#define kk_std_time_timestamp_H
// Koka generated module: "std/time/timestamp", koka version: 2.4.2, platform: 64-bit
#include <kklib.h>
#include "std_core_types.h"
#include "std_core.h"
#include "std_num_int32.h"
#include "std_num_float64.h"
#include "std_num_ddouble.h"
#include "std_time_date.h"

// type declarations

// type std/time/timestamp/timestamp
struct kk_std_time_timestamp__timestamp_s {
  kk_block_t _block;
};
typedef kk_datatype_ptr_t kk_std_time_timestamp__timestamp;
struct kk_std_time_timestamp_Timestamp {
  struct kk_std_time_timestamp__timestamp_s _base;
  kk_std_num_ddouble__ddouble since;
  int32_t leap32;
};
static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp__base_Timestamp(struct kk_std_time_timestamp_Timestamp* _x, kk_context_t* _ctx) {
  return kk_datatype_from_base(&_x->_base, _ctx);
}
static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp__new_Timestamp(kk_reuse_t _at, int32_t _cpath, kk_std_num_ddouble__ddouble since, int32_t leap32, kk_context_t* _ctx) {
  struct kk_std_time_timestamp_Timestamp* _con = kk_block_alloc_at_as(struct kk_std_time_timestamp_Timestamp, _at, 0 /* scan count */, _cpath, (kk_tag_t)(1), _ctx);
  _con->since = since;
  _con->leap32 = leap32;
  return kk_std_time_timestamp__base_Timestamp(_con, _ctx);
}
static inline struct kk_std_time_timestamp_Timestamp* kk_std_time_timestamp__as_Timestamp(kk_std_time_timestamp__timestamp x, kk_context_t* _ctx) {
  return kk_datatype_as_assert(struct kk_std_time_timestamp_Timestamp*, x, (kk_tag_t)(1), _ctx);
}
static inline bool kk_std_time_timestamp__is_Timestamp(kk_std_time_timestamp__timestamp x, kk_context_t* _ctx) {
  return (true);
}
static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp__timestamp_dup(kk_std_time_timestamp__timestamp _x, kk_context_t* _ctx) {
  return kk_datatype_ptr_dup(_x, _ctx);
}
static inline void kk_std_time_timestamp__timestamp_drop(kk_std_time_timestamp__timestamp _x, kk_context_t* _ctx) {
  kk_datatype_ptr_drop(_x, _ctx);
}
static inline kk_box_t kk_std_time_timestamp__timestamp_box(kk_std_time_timestamp__timestamp _x, kk_context_t* _ctx) {
  return kk_datatype_ptr_box(_x);
}
static inline kk_std_time_timestamp__timestamp kk_std_time_timestamp__timestamp_unbox(kk_box_t _x, kk_borrow_t _borrow, kk_context_t* _ctx) {
  return kk_datatype_ptr_unbox(_x);
}

// value declarations
 
// Automatically generated. Retrieves the `since` constructor field of the `:timestamp` type.

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_since(kk_std_time_timestamp__timestamp timestamp1, kk_context_t* _ctx) { /* (timestamp : timestamp) -> timespan */ 
  {
    struct kk_std_time_timestamp_Timestamp* _con2692 = kk_std_time_timestamp__as_Timestamp(timestamp1, _ctx);
    kk_std_num_ddouble__ddouble _x = _con2692->since;
    return _x;
  }
}
 
// Automatically generated. Retrieves the `leap32` constructor field of the `:timestamp` type.

static inline int32_t kk_std_time_timestamp_leap32(kk_std_time_timestamp__timestamp timestamp1, kk_context_t* _ctx) { /* (timestamp : timestamp) -> int32 */ 
  {
    struct kk_std_time_timestamp_Timestamp* _con2693 = kk_std_time_timestamp__as_Timestamp(timestamp1, _ctx);
    kk_std_num_ddouble__ddouble _pat0 = _con2693->since;
    int32_t _x = _con2693->leap32;
    return _x;
  }
}

kk_std_time_timestamp__timestamp kk_std_time_timestamp__copy(kk_std_time_timestamp__timestamp _this, kk_std_core_types__optional since0, kk_std_core_types__optional leap320, kk_context_t* _ctx); /* (timestamp, since : optional<timespan>, leap32 : optional<int32>) -> timestamp */ 

static inline kk_integer_t kk_std_time_timestamp_leap(kk_std_time_timestamp__timestamp t, kk_context_t* _ctx) { /* (t : timestamp) -> int */ 
  int32_t _x2698;
  {
    struct kk_std_time_timestamp_Timestamp* _con2699 = kk_std_time_timestamp__as_Timestamp(t, _ctx);
    kk_std_num_ddouble__ddouble _pat0 = _con2699->since;
    int32_t _x = _con2699->leap32;
    if kk_likely(kk_datatype_ptr_is_unique(t, _ctx)) {
      kk_datatype_ptr_free(t, _ctx);
    }
    else {
      kk_datatype_ptr_decref(t, _ctx);
    }
    _x2698 = _x; /*int32*/
  }
  return kk_integer_from_int(_x2698,kk_context());
}
 
// Seconds in a solar day, 86400.

extern kk_integer_t kk_std_time_timestamp_isolar_secs_per_day;
 
// Divide using `div` to allow for different timespan representations

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_div(kk_std_num_ddouble__ddouble x, kk_std_num_ddouble__ddouble y, kk_std_core_types__optional prec, kk_context_t* _ctx) { /* (x : timespan, y : timespan, prec : optional<int>) -> timespan */ 
  kk_std_core_types__optional_drop(prec, _ctx);
  return kk_std_num_ddouble__lp__fs__rp_(x, y, _ctx);
}
 
// The time span since 2000-01-01 for time scales that do not have
// leap seconds and where every day is 86400s. For time scales
// with leap seconds, this effectively ignores any leap seconds.

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan_noleap(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx) { /* (ts : timestamp) -> timespan */ 
  {
    struct kk_std_time_timestamp_Timestamp* _con2700 = kk_std_time_timestamp__as_Timestamp(ts, _ctx);
    kk_std_num_ddouble__ddouble _x = _con2700->since;
    if kk_likely(kk_datatype_ptr_is_unique(ts, _ctx)) {
      kk_datatype_ptr_free(ts, _ctx);
    }
    else {
      kk_datatype_ptr_decref(ts, _ctx);
    }
    return _x;
  }
}
 
// A zero-valued timespan.

extern kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan0;

kk_std_core_types__order kk_std_time_timestamp_compare(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx); /* (i : timestamp, j : timestamp) -> order */ 

static inline bool kk_std_time_timestamp__lp__excl__eq__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx) { /* (i : timestamp, j : timestamp) -> bool */ 
  kk_std_core_types__order x_2303 = kk_std_time_timestamp_compare(i, j, _ctx); /*order*/;
  kk_integer_t _brw_2659;
  if (kk_std_core_types__is_Lt(x_2303, _ctx)) {
    _brw_2659 = kk_integer_from_small(-1); /*int*/
    goto _match2713;
  }
  if (kk_std_core_types__is_Eq(x_2303, _ctx)) {
    _brw_2659 = kk_integer_from_small(0); /*int*/
    goto _match2713;
  }
  {
    _brw_2659 = kk_integer_from_small(1); /*int*/
  }
  _match2713: ;
  bool _brw_2660 = kk_integer_neq_borrow(_brw_2659,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_2659, _ctx);
  return _brw_2660;
}

kk_std_time_timestamp__timestamp kk_std_time_timestamp__lp__plus__rp_(kk_std_time_timestamp__timestamp ts, kk_std_num_ddouble__ddouble t, kk_context_t* _ctx); /* (ts : timestamp, t : timespan) -> timestamp */ 

kk_std_time_timestamp__timestamp kk_std_time_timestamp_timestamp(kk_std_num_ddouble__ddouble t, kk_std_core_types__optional leap0, kk_context_t* _ctx); /* (t : timespan, leap : optional<int>) -> timestamp */ 

kk_std_time_timestamp__timestamp kk_std_time_timestamp_timestamp_1(kk_integer_t t, kk_std_core_types__optional frac, kk_std_core_types__optional leap0, kk_context_t* _ctx); /* (t : int, frac : optional<float64>, leap : optional<int>) -> timestamp */ 

kk_std_time_timestamp__timestamp kk_std_time_timestamp__lp__dash__rp_(kk_std_time_timestamp__timestamp ts, kk_std_num_ddouble__ddouble t, kk_context_t* _ctx); /* (ts : timestamp, t : timespan) -> timestamp */ 

static inline bool kk_std_time_timestamp__lp__eq__eq__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx) { /* (i : timestamp, j : timestamp) -> bool */ 
  kk_std_core_types__order x_2315 = kk_std_time_timestamp_compare(i, j, _ctx); /*order*/;
  kk_integer_t _brw_2657;
  if (kk_std_core_types__is_Lt(x_2315, _ctx)) {
    _brw_2657 = kk_integer_from_small(-1); /*int*/
    goto _match2736;
  }
  if (kk_std_core_types__is_Eq(x_2315, _ctx)) {
    _brw_2657 = kk_integer_from_small(0); /*int*/
    goto _match2736;
  }
  {
    _brw_2657 = kk_integer_from_small(1); /*int*/
  }
  _match2736: ;
  bool _brw_2658 = kk_integer_eq_borrow(_brw_2657,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_2657, _ctx);
  return _brw_2658;
}

static inline bool kk_std_time_timestamp__lp__lt__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx) { /* (i : timestamp, j : timestamp) -> bool */ 
  kk_std_core_types__order x_2317 = kk_std_time_timestamp_compare(i, j, _ctx); /*order*/;
  kk_integer_t _brw_2655;
  if (kk_std_core_types__is_Lt(x_2317, _ctx)) {
    _brw_2655 = kk_integer_from_small(-1); /*int*/
    goto _match2737;
  }
  if (kk_std_core_types__is_Eq(x_2317, _ctx)) {
    _brw_2655 = kk_integer_from_small(0); /*int*/
    goto _match2737;
  }
  {
    _brw_2655 = kk_integer_from_small(1); /*int*/
  }
  _match2737: ;
  bool _brw_2656 = kk_integer_eq_borrow(_brw_2655,(kk_integer_from_small(-1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_2655, _ctx);
  return _brw_2656;
}

static inline bool kk_std_time_timestamp__lp__lt__eq__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx) { /* (i : timestamp, j : timestamp) -> bool */ 
  kk_std_core_types__order x_2319 = kk_std_time_timestamp_compare(i, j, _ctx); /*order*/;
  kk_integer_t _brw_2653;
  if (kk_std_core_types__is_Lt(x_2319, _ctx)) {
    _brw_2653 = kk_integer_from_small(-1); /*int*/
    goto _match2738;
  }
  if (kk_std_core_types__is_Eq(x_2319, _ctx)) {
    _brw_2653 = kk_integer_from_small(0); /*int*/
    goto _match2738;
  }
  {
    _brw_2653 = kk_integer_from_small(1); /*int*/
  }
  _match2738: ;
  bool _brw_2654 = kk_integer_neq_borrow(_brw_2653,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_2653, _ctx);
  return _brw_2654;
}

static inline bool kk_std_time_timestamp__lp__gt__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx) { /* (i : timestamp, j : timestamp) -> bool */ 
  kk_std_core_types__order x_2321 = kk_std_time_timestamp_compare(i, j, _ctx); /*order*/;
  kk_integer_t _brw_2651;
  if (kk_std_core_types__is_Lt(x_2321, _ctx)) {
    _brw_2651 = kk_integer_from_small(-1); /*int*/
    goto _match2739;
  }
  if (kk_std_core_types__is_Eq(x_2321, _ctx)) {
    _brw_2651 = kk_integer_from_small(0); /*int*/
    goto _match2739;
  }
  {
    _brw_2651 = kk_integer_from_small(1); /*int*/
  }
  _match2739: ;
  bool _brw_2652 = kk_integer_eq_borrow(_brw_2651,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_2651, _ctx);
  return _brw_2652;
}

static inline bool kk_std_time_timestamp__lp__gt__eq__rp_(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx) { /* (i : timestamp, j : timestamp) -> bool */ 
  kk_std_core_types__order x_2323 = kk_std_time_timestamp_compare(i, j, _ctx); /*order*/;
  kk_integer_t _brw_2649;
  if (kk_std_core_types__is_Lt(x_2323, _ctx)) {
    _brw_2649 = kk_integer_from_small(-1); /*int*/
    goto _match2740;
  }
  if (kk_std_core_types__is_Eq(x_2323, _ctx)) {
    _brw_2649 = kk_integer_from_small(0); /*int*/
    goto _match2740;
  }
  {
    _brw_2649 = kk_integer_from_small(1); /*int*/
  }
  _match2740: ;
  bool _brw_2650 = kk_integer_neq_borrow(_brw_2649,(kk_integer_from_small(-1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_2649, _ctx);
  return _brw_2650;
}

kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan(kk_integer_t seconds, kk_std_core_types__optional frac, kk_context_t* _ctx); /* (seconds : int, frac : optional<float64>) -> timespan */ 

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan_1(double secs, kk_context_t* _ctx) { /* (secs : float64) -> timespan */ 
  return kk_std_num_ddouble__new_Ddouble(secs, 0x0p+0, _ctx);
}

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan_2(double secs, double frac, kk_context_t* _ctx) { /* (secs : float64, frac : float64) -> timespan */ 
  bool _match_2647 = (frac == (0x0p+0)); /*bool*/;
  if (_match_2647) {
    return kk_std_num_ddouble__new_Ddouble(secs, 0x0p+0, _ctx);
  }
  {
    return kk_std_num_ddouble_dsum(secs, frac, _ctx);
  }
}
 
// Timespan from a `:ddouble`. Just for convenience as `:timespan` is an alias

static inline kk_std_num_ddouble__ddouble kk_std_time_timestamp_timespan_3(kk_std_num_ddouble__ddouble secs, kk_context_t* _ctx) { /* (secs : std/num/ddouble/ddouble) -> timespan */ 
  return secs;
}

kk_std_time_timestamp__timestamp kk_std_time_timestamp_add_days(kk_std_time_timestamp__timestamp ts, kk_integer_t days0, kk_context_t* _ctx); /* (ts : timestamp, days : int) -> timestamp */ 

kk_std_time_timestamp__timestamp kk_std_time_timestamp_add_leap_seconds(kk_std_time_timestamp__timestamp ts, kk_std_num_ddouble__ddouble leaps, kk_context_t* _ctx); /* (ts : timestamp, leaps : timespan) -> timestamp */ 

kk_std_core_types__tuple2_ kk_std_time_timestamp_days_seconds(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx); /* (ts : timestamp) -> (int, std/num/ddouble/ddouble) */ 

static inline kk_integer_t kk_std_time_timestamp_days(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx) { /* (ts : timestamp) -> int */ 
  kk_std_core_types__tuple2_ _this_2374 = kk_std_time_timestamp_days_seconds(ts, _ctx); /*(int, std/num/ddouble/ddouble)*/;
  {
    kk_box_t _box_x2551 = _this_2374.fst;
    kk_box_t _box_x2552 = _this_2374.snd;
    kk_integer_t _x = kk_integer_unbox(_box_x2551, _ctx);
    kk_integer_dup(_x, _ctx);
    kk_std_core_types__tuple2__drop(_this_2374, _ctx);
    return _x;
  }
}

kk_std_core_types__tuple2_ kk_std_time_timestamp_days_clock(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx); /* (ts : timestamp) -> (int, std/time/date/clock) */ 

kk_std_time_timestamp__timestamp kk_std_time_timestamp_max(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx); /* (i : timestamp, j : timestamp) -> timestamp */ 

kk_std_time_timestamp__timestamp kk_std_time_timestamp_min(kk_std_time_timestamp__timestamp i, kk_std_time_timestamp__timestamp j, kk_context_t* _ctx); /* (i : timestamp, j : timestamp) -> timestamp */ 

kk_std_time_timestamp__timestamp kk_std_time_timestamp_round_to_prec(kk_std_time_timestamp__timestamp t, kk_integer_t prec, kk_context_t* _ctx); /* (t : timestamp, prec : int) -> timestamp */ 

kk_std_num_ddouble__ddouble kk_std_time_timestamp_seconds_into_day(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx); /* (ts : timestamp) -> std/num/ddouble/ddouble */ 

extern kk_std_num_ddouble__ddouble kk_std_time_timestamp_solar_secs_per_day;

kk_std_time_timestamp__timestamp kk_std_time_timestamp_timestamp_days(kk_integer_t days0, kk_std_core_types__optional secs, kk_std_core_types__optional leap0, kk_context_t* _ctx); /* (days : int, secs : optional<timespan>, leap : optional<int>) -> timestamp */ 

extern kk_std_time_timestamp__timestamp kk_std_time_timestamp_timestamp0;

kk_string_t kk_std_time_timestamp_ts_show(kk_std_time_timestamp__timestamp ts, kk_std_core_types__optional max_prec, kk_std_core_types__optional secs_width, kk_std_core_types__optional unit, kk_context_t* _ctx); /* (ts : timestamp, max-prec : optional<int>, secs-width : optional<int>, unit : optional<string>) -> string */ 

kk_string_t kk_std_time_timestamp_ts_show_days(kk_std_time_timestamp__timestamp ts, kk_std_core_types__optional prec, kk_context_t* _ctx); /* (ts : timestamp, prec : optional<int>) -> string */ 

kk_std_num_ddouble__ddouble kk_std_time_timestamp_unsafe_timespan_withleap(kk_std_time_timestamp__timestamp ts, kk_context_t* _ctx); /* (ts : timestamp) -> timespan */ 

void kk_std_time_timestamp__init(kk_context_t* _ctx);


void kk_std_time_timestamp__done(kk_context_t* _ctx);

#endif // header
