// Koka generated module: "std/time/timer", koka version: 2.4.2, platform: 64-bit
#include "std_time_timer.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static kk_std_core_types__tuple2_ kk_timer_ticks_tuple(kk_context_t* ctx) {
  kk_duration_t d = kk_timer_ticks(ctx);
  // the conversion has about 15 digits of precision
  // we cannot do this more precisely as the api expects the fraction between 0.0 and 2.0 (for leap seconds).  
  double secs = (double)d.seconds;
  double frac = (double)d.attoseconds * 1e-18;
  return kk_std_core_types__new_dash__lp__comma__rp_( kk_double_box(secs,ctx), kk_double_box(frac,ctx), ctx );
}

static double kk_timer_dresolution(kk_context_t* ctx) {
  int64_t asecs = kk_timer_resolution(ctx);
  return (double)asecs * 1e-18;
}


kk_std_core_types__tuple2_ kk_std_time_timer_xticks(kk_context_t* _ctx) { /* () -> ndet (float64, float64) */ 
  return kk_timer_ticks_tuple(kk_context());
}
 
// Return the smallest time difference in seconds that `ticks` can measure.

double kk_std_time_timer_xticks_resolution(kk_context_t* _ctx) { /* () -> ndet float64 */ 
  return kk_timer_dresolution(kk_context());
}
 
// monadic lift

kk_std_core_types__tuple2_ kk_std_time_timer__mlift408_elapsed(kk_std_time_duration__duration t0, kk_box_t x, kk_context_t* _ctx) { /* forall<a,e> (t0 : std/time/duration/duration, x : a) -> <ndet|e> (std/time/duration/duration, a) */ 
  kk_std_time_duration__duration t1;
  kk_std_core_types__tuple2_ _match_463 = kk_std_time_timer_xticks(_ctx); /*(float64, float64)*/;
  {
    kk_box_t _box_x422 = _match_463.fst;
    kk_box_t _box_x423 = _match_463.snd;
    double secs0 = kk_double_unbox(_box_x422, KK_BORROWED, _ctx);
    double frac0 = kk_double_unbox(_box_x423, KK_BORROWED, _ctx);
    kk_std_core_types__tuple2__drop(_match_463, _ctx);
    t1 = kk_std_time_duration_duration_3(secs0, frac0, _ctx); /*std/time/duration/duration*/
  }
  kk_std_time_duration__duration _b_426_424 = kk_std_time_duration__lp__dash__rp_(t1, t0, _ctx); /*std/time/duration/duration*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_time_duration__duration_box(_b_426_424, _ctx), x, _ctx);
}
 
// Return the number of fractional seconds that it takes to evaluate `action`.


// lift anonymous function
struct kk_std_time_timer_elapsed_fun466__t {
  struct kk_function_s _base;
  kk_std_time_duration__duration t0;
};
static kk_box_t kk_std_time_timer_elapsed_fun466(kk_function_t _fself, kk_box_t _b_435, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_elapsed_fun466(kk_std_time_duration__duration t0, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun466__t* _self = kk_function_alloc_as(struct kk_std_time_timer_elapsed_fun466__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_timer_elapsed_fun466, kk_context());
  _self->t0 = t0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_time_timer_elapsed_fun466(kk_function_t _fself, kk_box_t _b_435, kk_context_t* _ctx) {
  struct kk_std_time_timer_elapsed_fun466__t* _self = kk_function_as(struct kk_std_time_timer_elapsed_fun466__t*, _fself, _ctx);
  kk_std_time_duration__duration t0 = _self->t0; /* std/time/duration/duration */
  kk_drop_match(_self, {kk_std_time_duration__duration_dup(t0, _ctx);}, {}, _ctx)
  kk_box_t x0_445 = _b_435; /*110*/;
  kk_std_time_duration__duration t1;
  kk_std_core_types__tuple2_ _match_461 = kk_std_time_timer_xticks(_ctx); /*(float64, float64)*/;
  {
    kk_box_t _box_x430 = _match_461.fst;
    kk_box_t _box_x431 = _match_461.snd;
    double secs0 = kk_double_unbox(_box_x430, KK_BORROWED, _ctx);
    double frac0 = kk_double_unbox(_box_x431, KK_BORROWED, _ctx);
    kk_std_core_types__tuple2__drop(_match_461, _ctx);
    t1 = kk_std_time_duration_duration_3(secs0, frac0, _ctx); /*std/time/duration/duration*/
  }
  kk_std_time_duration__duration _b_441_432 = kk_std_time_duration__lp__dash__rp_(t1, t0, _ctx); /*std/time/duration/duration*/;
  kk_std_core_types__tuple2_ _x467 = kk_std_core_types__new_dash__lp__comma__rp_(kk_std_time_duration__duration_box(_b_441_432, _ctx), x0_445, _ctx); /*(6, 7)*/
  return kk_std_core_types__tuple2__box(_x467, _ctx);
}

kk_std_core_types__tuple2_ kk_std_time_timer_elapsed(kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <ndet|e> a) -> <ndet|e> (std/time/duration/duration, a) */ 
  kk_std_time_duration__duration t0;
  kk_std_core_types__tuple2_ _match_462 = kk_std_time_timer_xticks(_ctx); /*(float64, float64)*/;
  {
    kk_box_t _box_x428 = _match_462.fst;
    kk_box_t _box_x429 = _match_462.snd;
    double secs = kk_double_unbox(_box_x428, KK_BORROWED, _ctx);
    double frac = kk_double_unbox(_box_x429, KK_BORROWED, _ctx);
    kk_std_core_types__tuple2__drop(_match_462, _ctx);
    t0 = kk_std_time_duration_duration_3(secs, frac, _ctx); /*std/time/duration/duration*/
  }
  kk_box_t x_410 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx); /*110*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_410, _ctx);
    kk_box_t _x465 = kk_std_core_hnd_yield_extend(kk_std_time_timer_new_elapsed_fun466(t0, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple2__unbox(_x465, KK_OWNED, _ctx);
  }
  {
    kk_std_time_duration__duration t10;
    kk_std_core_types__tuple2_ _match_460 = kk_std_time_timer_xticks(_ctx); /*(float64, float64)*/;
    {
      kk_box_t _box_x436 = _match_460.fst;
      kk_box_t _box_x437 = _match_460.snd;
      double secs00 = kk_double_unbox(_box_x436, KK_BORROWED, _ctx);
      double frac00 = kk_double_unbox(_box_x437, KK_BORROWED, _ctx);
      kk_std_core_types__tuple2__drop(_match_460, _ctx);
      t10 = kk_std_time_duration_duration_3(secs00, frac00, _ctx); /*std/time/duration/duration*/
    }
    kk_std_time_duration__duration _b_443_438 = kk_std_time_duration__lp__dash__rp_(t10, t0, _ctx); /*std/time/duration/duration*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_time_duration__duration_box(_b_443_438, _ctx), x_410, _ctx);
  }
}
 
// monadic lift

kk_box_t kk_std_time_timer__mlift409_print_elapsed(kk_std_core_types__optional msg, kk_std_core_types__tuple2_ _y_404, kk_context_t* _ctx) { /* forall<a,e> (msg : optional<string>, (std/time/duration/duration, a)) -> <ndet,console|e> a */ 
  {
    kk_box_t _box_x446 = _y_404.fst;
    kk_std_time_duration__duration t = kk_std_time_duration__duration_unbox(_box_x446, KK_BORROWED, _ctx);
    kk_box_t x = _y_404.snd;
    kk_box_dup(x, _ctx);
    kk_std_core_types__tuple2__drop(_y_404, _ctx);
    kk_unit_t __ = kk_Unit;
    kk_integer_t _b_449_448;
    kk_integer_t _x468 = kk_integer_abs((kk_integer_from_small(3)),kk_context()); /*int*/
    _b_449_448 = kk_integer_neg(_x468,kk_context()); /*int*/
    kk_string_t _x469;
    kk_string_t _x470;
    if (kk_std_core_types__is_Optional(msg, _ctx)) {
      kk_box_t _box_x447 = msg._cons.Optional.value;
      kk_string_t _msg_117 = kk_string_unbox(_box_x447);
      kk_string_dup(_msg_117, _ctx);
      kk_std_core_types__optional_drop(msg, _ctx);
      _x470 = _msg_117; /*string*/
    }
    else {
      kk_std_core_types__optional_drop(msg, _ctx);
      kk_define_string_literal(, _s471, 7, "elapsed", _ctx)
      _x470 = kk_string_dup(_s471, _ctx); /*string*/
    }
    kk_string_t _x472;
    kk_string_t _x473;
    kk_define_string_literal(, _s474, 1, " ", _ctx)
    _x473 = kk_string_dup(_s474, _ctx); /*string*/
    kk_string_t _x475;
    kk_string_t _x476;
    kk_std_num_ddouble__ddouble _x477;
    {
      kk_std_num_ddouble__ddouble _x = t.secs;
      _x477 = _x; /*std/time/timestamp/timespan*/
    }
    kk_std_core_types__optional _x478 = kk_std_core_types__new_Optional(kk_integer_box(_b_449_448, _ctx), _ctx); /*optional<116>*/
    _x476 = kk_std_num_ddouble_show_fixed(_x477, _x478, _ctx); /*string*/
    kk_string_t _x479;
    kk_define_string_literal(, _s480, 1, "s", _ctx)
    _x479 = kk_string_dup(_s480, _ctx); /*string*/
    _x475 = kk_std_core__lp__plus__plus__1_rp_(_x476, _x479, _ctx); /*string*/
    _x472 = kk_std_core__lp__plus__plus__1_rp_(_x473, _x475, _ctx); /*string*/
    _x469 = kk_std_core__lp__plus__plus__1_rp_(_x470, _x472, _ctx); /*string*/
    kk_std_core_printsln(_x469, _ctx);
    return x;
  }
}
 
// Measure the number of fractional seconds that it takes to evaluate `action`, and print `msg` postfixed with the
// measured time in millisecond resolution.


// lift anonymous function
struct kk_std_time_timer_print_elapsed_fun481__t {
  struct kk_function_s _base;
  kk_std_core_types__optional msg;
};
static kk_box_t kk_std_time_timer_print_elapsed_fun481(kk_function_t _fself, kk_box_t _b_451, kk_context_t* _ctx);
static kk_function_t kk_std_time_timer_new_print_elapsed_fun481(kk_std_core_types__optional msg, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun481__t* _self = kk_function_alloc_as(struct kk_std_time_timer_print_elapsed_fun481__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_time_timer_print_elapsed_fun481, kk_context());
  _self->msg = msg;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_time_timer_print_elapsed_fun481(kk_function_t _fself, kk_box_t _b_451, kk_context_t* _ctx) {
  struct kk_std_time_timer_print_elapsed_fun481__t* _self = kk_function_as(struct kk_std_time_timer_print_elapsed_fun481__t*, _fself, _ctx);
  kk_std_core_types__optional msg = _self->msg; /* optional<string> */
  kk_drop_match(_self, {kk_std_core_types__optional_dup(msg, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple2_ _x482 = kk_std_core_types__tuple2__unbox(_b_451, KK_OWNED, _ctx); /*(std/time/duration/duration, 284)*/
  return kk_std_time_timer__mlift409_print_elapsed(msg, _x482, _ctx);
}

kk_box_t kk_std_time_timer_print_elapsed(kk_function_t action, kk_std_core_types__optional msg, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <ndet,console|e> a, msg : optional<string>) -> <ndet,console|e> a */ 
  kk_std_core_types__tuple2_ x_415 = kk_std_time_timer_elapsed(action, _ctx); /*(std/time/duration/duration, 284)*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__tuple2__drop(x_415, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_time_timer_new_print_elapsed_fun481(msg, _ctx), _ctx);
  }
  {
    kk_box_t _box_x452 = x_415.fst;
    kk_std_time_duration__duration t = kk_std_time_duration__duration_unbox(_box_x452, KK_BORROWED, _ctx);
    kk_box_t x0 = x_415.snd;
    kk_box_dup(x0, _ctx);
    kk_std_core_types__tuple2__drop(x_415, _ctx);
    kk_unit_t __ = kk_Unit;
    kk_integer_t _b_455_454;
    kk_integer_t _x483 = kk_integer_abs((kk_integer_from_small(3)),kk_context()); /*int*/
    _b_455_454 = kk_integer_neg(_x483,kk_context()); /*int*/
    kk_string_t _x484;
    kk_string_t _x485;
    if (kk_std_core_types__is_Optional(msg, _ctx)) {
      kk_box_t _box_x453 = msg._cons.Optional.value;
      kk_string_t _msg_117 = kk_string_unbox(_box_x453);
      kk_string_dup(_msg_117, _ctx);
      kk_std_core_types__optional_drop(msg, _ctx);
      _x485 = _msg_117; /*string*/
    }
    else {
      kk_std_core_types__optional_drop(msg, _ctx);
      kk_define_string_literal(, _s486, 7, "elapsed", _ctx)
      _x485 = kk_string_dup(_s486, _ctx); /*string*/
    }
    kk_string_t _x487;
    kk_string_t _x488;
    kk_define_string_literal(, _s489, 1, " ", _ctx)
    _x488 = kk_string_dup(_s489, _ctx); /*string*/
    kk_string_t _x490;
    kk_string_t _x491;
    kk_std_num_ddouble__ddouble _x492;
    {
      kk_std_num_ddouble__ddouble _x = t.secs;
      _x492 = _x; /*std/time/timestamp/timespan*/
    }
    kk_std_core_types__optional _x493 = kk_std_core_types__new_Optional(kk_integer_box(_b_455_454, _ctx), _ctx); /*optional<116>*/
    _x491 = kk_std_num_ddouble_show_fixed(_x492, _x493, _ctx); /*string*/
    kk_string_t _x494;
    kk_define_string_literal(, _s495, 1, "s", _ctx)
    _x494 = kk_string_dup(_s495, _ctx); /*string*/
    _x490 = kk_std_core__lp__plus__plus__1_rp_(_x491, _x494, _ctx); /*string*/
    _x487 = kk_std_core__lp__plus__plus__1_rp_(_x488, _x490, _ctx); /*string*/
    _x484 = kk_std_core__lp__plus__plus__1_rp_(_x485, _x487, _ctx); /*string*/
    kk_std_core_printsln(_x484, _ctx);
    return x0;
  }
}

// initialization
void kk_std_time_timer__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_num_ddouble__init(_ctx);
  kk_std_time_duration__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_time_timer__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_time_duration__done(_ctx);
  kk_std_num_ddouble__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
