// Koka generated module: "std/core", koka version: 2.4.2, platform: 64-bit
#include "std_core.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

kk_std_core__list kk_vector_to_list(kk_vector_t v, kk_std_core__list tail, kk_context_t* ctx) {
  // todo: avoid boxed_dup if v is unique
  kk_ssize_t n;
  kk_box_t* p = kk_vector_buf_borrow(v, &n, ctx);
  if (n <= 0) {
    kk_vector_drop(v,ctx);
    return tail;
  }
  kk_std_core__list nil  = kk_std_core__new_Nil(ctx);
  struct kk_std_core_Cons* cons = NULL;
  kk_std_core__list list = kk_std_core__new_Nil(ctx);
  for( kk_ssize_t i = 0; i < n; i++ ) {
    kk_std_core__list hd = kk_std_core__new_Cons(kk_reuse_null,0,kk_box_dup(p[i],ctx), nil, ctx);
    if (cons==NULL) {
      list = hd;
    }
    else {
      cons->tail = hd;
    }
    cons = kk_std_core__as_Cons(hd,ctx);
  }
  if (cons == NULL) { list = tail; } 
               else { cons->tail = tail; }
  kk_vector_drop(v,ctx);
  return list;
}

kk_vector_t kk_list_to_vector(kk_std_core__list xs, kk_context_t* ctx) {
  // todo: avoid boxed_dup if xs is unique
  // find the length
  kk_ssize_t len = 0;
  kk_std_core__list ys = xs;
  while (kk_std_core__is_Cons(ys,ctx)) {
    struct kk_std_core_Cons* cons = kk_std_core__as_Cons(ys,ctx);
    len++;
    ys = cons->tail;
  }
  // alloc the vector and copy
  kk_box_t* p;
  kk_vector_t v = kk_vector_alloc_uninit(len, &p, ctx);  
  ys = xs;
  for( kk_ssize_t i = 0; i < len; i++) {
    struct kk_std_core_Cons* cons = kk_std_core__as_Cons(ys,ctx);
    ys = cons->tail;
    p[i] = kk_box_dup(cons->head,ctx);
  }
  kk_std_core__list_drop(xs,ctx);  // todo: drop while visiting?
  return v;
}

kk_vector_t kk_vector_init( kk_ssize_t n, kk_function_t init, kk_context_t* ctx) {
  kk_box_t* p;
  kk_vector_t v = kk_vector_alloc_uninit(n, &p, ctx);  
  for(kk_ssize_t i = 0; i < n; i++) {
    kk_function_dup(init,ctx);
    p[i] = kk_function_call(kk_box_t,(kk_function_t,kk_ssize_t,kk_context_t*),init,(init,i,ctx),ctx);
  }
  kk_function_drop(init,ctx);
  return v;
}

kk_box_t kk_main_console( kk_function_t action, kk_context_t* ctx ) {
  return kk_function_call(kk_box_t,(kk_function_t,kk_unit_t,kk_context_t*),action,(action,kk_Unit,ctx),ctx);
}


kk_std_core__list kk_string_to_list(kk_string_t s, kk_context_t* ctx) {
  kk_ssize_t len;
  const uint8_t* p = kk_string_buf_borrow(s,&len,ctx);
  const uint8_t* const end = p + len;
  kk_std_core__list nil  = kk_std_core__new_Nil(ctx);
  kk_std_core__list list = nil;
  struct kk_std_core_Cons* tl = NULL;
  kk_ssize_t count;
  while( p < end ) {
    kk_char_t c = kk_utf8_read(p,&count);
    p += count;
    kk_std_core__list cons = kk_std_core__new_Cons(kk_reuse_null,0,kk_char_box(c,ctx), nil, ctx);
    if (tl!=NULL) {
      tl->tail = cons;
    }
    else {
      list = cons;
    }
    tl = kk_std_core__as_Cons(cons,ctx);
  }
  kk_string_drop(s,ctx);
  return list;
}

kk_string_t kk_string_from_list(kk_std_core__list cs, kk_context_t* ctx) {
  // TODO: optimize for short strings to write directly into a local buffer?
  // find total UTF8 length
  kk_ssize_t len = 0;
  kk_std_core__list xs = cs;
  while (kk_std_core__is_Cons(xs,ctx)) {
    struct kk_std_core_Cons* cons = kk_std_core__as_Cons(xs,ctx);
    len += kk_utf8_len(kk_char_unbox(cons->head,KK_BORROWED,ctx));
    xs = cons->tail;
  }
  // allocate and copy the characters
  uint8_t* p;
  kk_string_t s = kk_unsafe_string_alloc_buf(len,&p,ctx);  // must be initialized
  xs = cs;
  while (kk_std_core__is_Cons(xs,ctx)) {
    struct kk_std_core_Cons* cons = kk_std_core__as_Cons(xs,ctx);
    kk_ssize_t count;
    kk_utf8_write( kk_char_unbox(cons->head,KK_BORROWED,ctx), p, &count );
    p += count;
    xs = cons->tail;
  }
  kk_assert_internal(*p == 0 && (p - kk_string_buf_borrow(s,NULL,ctx)) == len);
  kk_std_core__list_drop(cs,ctx);  // todo: drop while visiting?
  return s;
}

static inline void kk_sslice_start_end_borrowx( kk_std_core__sslice sslice, const uint8_t** start, const uint8_t** end, const uint8_t** sstart, const uint8_t** send, kk_context_t* ctx) {
  kk_ssize_t strlen;
  const uint8_t* s = kk_string_buf_borrow(sslice.str,&strlen,ctx);
  kk_ssize_t slstart = kk_integer_clamp_ssize_t_borrow(sslice.start,ctx);
  kk_ssize_t sllen   = kk_integer_clamp_ssize_t_borrow(sslice.len,ctx);
  *start = s + slstart;
  *end = s + slstart + sllen;
  if (sstart != NULL) *sstart = s;
  if (send != NULL) *send = s + strlen;
  kk_assert_internal(*start >= s && *start <= *end);
  kk_assert_internal(*end >= *start && *end <= s + strlen);
}

static inline void kk_sslice_start_end_borrow( kk_std_core__sslice sslice, const uint8_t** start, const uint8_t** end, kk_context_t* ctx) {
  kk_sslice_start_end_borrowx(sslice,start,end,NULL,NULL,ctx);
}

kk_integer_t kk_slice_count( kk_std_core__sslice sslice, kk_context_t* ctx ) {
  // TODO: optimize this by extending kk_string_count
  const uint8_t* start;
  const uint8_t* end;
  kk_sslice_start_end_borrow(sslice, &start, &end, ctx);
  kk_ssize_t count = 0;
  while( start < end && *start != 0 ) {
    const uint8_t* next = kk_utf8_next(start);
    count++;
    start = next;
  }
  kk_std_core__sslice_drop(sslice,ctx);
  return kk_integer_from_ssize_t(count,ctx);
}

kk_string_t kk_slice_to_string( kk_std_core__sslice  sslice, kk_context_t* ctx ) {
  const uint8_t* start;
  const uint8_t* end;
  kk_sslice_start_end_borrow(sslice, &start, &end, ctx);
  // is it the full string?
  if (kk_integer_is_zero_borrow(sslice.start) && 
      kk_integer_eq_borrow(sslice.len,kk_integer_from_ssize_t(kk_string_len_borrow(sslice.str,ctx),ctx),ctx)) {
    // TODO: drop sslice and dup sslice.str?
    return sslice.str;
  }
  else {
    // if not, we copy len bytes
    kk_string_t s = kk_string_alloc_dupn_valid_utf8(kk_integer_clamp_ssize_t_borrow(sslice.len,ctx), start, ctx);
    kk_std_core__sslice_drop(sslice,ctx);
    return s;
  }
}

kk_std_core__sslice kk_slice_first( kk_string_t str, kk_context_t* ctx ) {
  kk_ssize_t slen;
  const uint8_t* s = kk_string_buf_borrow(str,&slen,ctx);
  const uint8_t* next = (slen > 0 ? kk_utf8_next(s) : s);
  return kk_std_core__new_Sslice(str, kk_integer_zero, kk_integer_from_ptrdiff_t(next - s,ctx), ctx);
}

kk_std_core__sslice kk_slice_last( kk_string_t str, kk_context_t* ctx ) {
  kk_ssize_t slen;
  const uint8_t* s = kk_string_buf_borrow(str,&slen,ctx);
  const uint8_t* end = s + slen;
  const uint8_t* prev = (s==end ? s : kk_utf8_prev(end));
  return kk_std_core__new_Sslice(str, kk_integer_from_ptrdiff_t(prev - s,ctx), kk_integer_from_ptrdiff_t(end - prev,ctx), ctx);
}

kk_std_core__sslice kk_slice_between( struct kk_std_core_Sslice slice1, struct kk_std_core_Sslice slice2, kk_context_t* ctx ) {
  const uint8_t* s1 = kk_string_buf_borrow( slice1.str, NULL, ctx );
  const uint8_t* s2 = kk_string_buf_borrow( slice2.str, NULL, ctx );
  if (s1 != s2) {
    kk_info_message("between: not equal slices: %p vs. %p\n", s1, s2);
    return kk_std_core__new_Sslice(kk_string_empty(), kk_integer_zero, kk_integer_min_one, ctx); // invalid slice
  }
  
  kk_integer_t start;
  kk_integer_t len;
  if (kk_integer_lte_borrow(slice1.start,slice2.start,ctx)) {
    start = kk_integer_dup(slice1.start,ctx);
    len   = kk_integer_sub(kk_integer_dup(slice2.start,ctx),kk_integer_dup(slice1.start,ctx),ctx);
  }
  else  {
    start = kk_integer_dup(slice2.start,ctx);
    len   = kk_integer_sub(kk_integer_dup(slice1.start,ctx),kk_integer_dup(slice2.start,ctx),ctx);
  }  
  return kk_std_core__new_Sslice(slice1.str, start, len, ctx);
}

kk_std_core_types__maybe kk_slice_next( struct kk_std_core_Sslice slice, kk_context_t* ctx ) {
  if (!kk_integer_is_pos_borrow(slice.len,ctx)) {
    kk_std_core__sslice_drop(slice,ctx);
    return kk_std_core_types__new_Nothing(ctx);
  }
  const uint8_t* start;
  const uint8_t* end;
  kk_sslice_start_end_borrow(slice, &start, &end, ctx);
  kk_ssize_t clen;
  const kk_char_t c = kk_utf8_read(start,&clen);
  kk_assert_internal(clen > 0 && clen <= kk_integer_clamp_ssize_t_borrow(slice.len,ctx));
  kk_integer_t iclen = kk_integer_min(kk_integer_from_ssize_t(clen,ctx),kk_integer_dup(slice.len,ctx),ctx);
  // TODO: specialize type to avoid boxing
  // note: don't drop slice as we take over all fields  
  kk_integer_t istart = kk_integer_add(slice.start,kk_integer_dup(iclen,ctx),ctx);
  kk_integer_t ilen   = kk_integer_sub(slice.len,iclen,ctx);
  kk_std_core__sslice snext = kk_std_core__new_Sslice(slice.str, istart, ilen, ctx);
  kk_std_core_types__tuple2_ res = kk_std_core_types__new_dash__lp__comma__rp_( kk_char_box(c,ctx), kk_std_core__sslice_box(snext,ctx), ctx);
  return kk_std_core_types__new_Just( kk_std_core_types__tuple2__box(res,ctx), ctx );
}

/* Borrow count */
struct kk_std_core_Sslice kk_slice_extend_borrow( struct kk_std_core_Sslice slice, kk_integer_t count, kk_context_t* ctx ) {
  kk_ssize_t cnt = kk_integer_clamp_ssize_t_borrow(count,ctx);
  if (cnt==0 || (!kk_integer_is_pos_borrow(slice.len,ctx) && cnt<0)) return slice;
  const uint8_t* s0;
  const uint8_t* s1;
  kk_sslice_start_end_borrow(slice,&s0,&s1,ctx);
  const uint8_t* t  = s1;
  if (cnt >= 0) {
    do {
      t = kk_utf8_next(t);
      cnt--;
    } while (cnt > 0 && *t != 0);
  }
  else {  // cnt < 0
    const uint8_t* sstart = s0 - kk_integer_clamp_ssize_t_borrow(slice.start,ctx);
    do {
      t = kk_utf8_prev(t);
      cnt++;
    } while (cnt < 0 && t > sstart);
  }
  if (t == s1) return slice;  // length is unchanged
  kk_integer_drop(slice.len,ctx);
  return kk_std_core__new_Sslice(slice.str, slice.start, kk_integer_from_ptrdiff_t(t < s0 ? 0 : (t - s0),ctx), ctx);
}

/* Borrow count */
struct kk_std_core_Sslice kk_slice_advance_borrow( struct kk_std_core_Sslice slice, kk_integer_t count, kk_context_t* ctx ) {
  const kk_ssize_t cnt0 = kk_integer_clamp_ssize_t_borrow(count,ctx);
  kk_ssize_t cnt = cnt0;
  if (cnt==0 || (kk_integer_is_zero_borrow(slice.start) && cnt<0)) return slice;
  const uint8_t* sstart;
  const uint8_t* s0;
  const uint8_t* s1;
  const uint8_t* send;
  kk_sslice_start_end_borrowx(slice,&s0,&s1,&sstart,&send,ctx);
  // advance the start
  const uint8_t* t0  = s0;
  if (cnt >= 0) {
    do {
      t0 = kk_utf8_next(t0);
      cnt--;
    } while (cnt > 0 && t0 < send);
  }
  else {  // cnt < 0
    do {
      t0 = kk_utf8_prev(t0);
      cnt++;
    } while (cnt < 0 && t0 > sstart);
  }
  if (t0 == s0) return slice;  // start is unchanged
  // "t0" points to the new start, now advance the end by the same amount of codepoints
  const uint8_t* t1 = s1;
  cnt = cnt0;
  if (cnt >= 0) {
    do {
      t1 = kk_utf8_next(t1);
      cnt--;
    } while (cnt > 0 && t1 < send);
  }
  else {  // cnt < 0
    do {
      t1 = kk_utf8_prev(t1);
      cnt++;
    } while (cnt < 0 && t1 > sstart);
  }
  // t1 points to the new end
  kk_assert_internal(t1 >= t0);
  kk_integer_drop(slice.start,ctx);
  kk_integer_drop(slice.len,ctx);
  return kk_std_core__new_Sslice(slice.str, kk_integer_from_ptrdiff_t(t0 - sstart,ctx), 
                                            kk_integer_from_ptrdiff_t(t1 - t0,ctx), ctx);
}

/* Borrow iupto */
struct kk_std_core_Sslice kk_slice_common_prefix_borrow( kk_string_t str1, kk_string_t str2, kk_integer_t iupto, kk_context_t* ctx ) {
  const uint8_t* s1 = kk_string_buf_borrow(str1,NULL,ctx);
  const uint8_t* s2 = kk_string_buf_borrow(str2,NULL,ctx);
  kk_ssize_t upto = kk_integer_clamp_ssize_t_borrow(iupto,ctx);
  kk_ssize_t count;
  for(count = 0; count < upto && *s1 != 0 && *s2 != 0; count++, s1++, s2++ ) {
    if (*s1 != *s2) break;
  }
  kk_string_drop(str2,ctx);
  return kk_std_core__new_Sslice(str1, kk_integer_zero, kk_integer_from_ssize_t(count,ctx), ctx);
}


kk_std_core__error kk_error_ok( kk_box_t result, kk_context_t* ctx ) {
  return kk_std_core__new_Ok( result, ctx );
}

kk_std_core__error kk_error_from_errno( int err, kk_context_t* ctx ) {  
  kk_string_t msg;
  #if defined(__GLIBC__) && !defined(WIN32) && !defined(__APPLE__) && !defined(__FreeBSD__)
    // GNU version of strerror_r
    char buf[256];
    char* serr = strerror_r(err, buf, 255); buf[255] = 0;
    msg = kk_string_alloc_from_qutf8( serr, ctx );
  #elif (/* _POSIX_C_SOURCE >= 200112L ||*/ !defined(WIN32) && (_XOPEN_SOURCE >= 600 || defined(__APPLE__) || defined(__FreeBSD__) || defined(__MUSL__)))
    // XSI version of strerror_r
    char buf[256];
    strerror_r(err, buf, 255); buf[255] = 0;
    msg = kk_string_alloc_from_qutf8( buf, ctx );
  #elif defined(_MSC_VER) || (__STDC_VERSION__ >= 201112L || __cplusplus >= 201103L)
    // MSVC, or C/C++ 11
    char buf[256];
    strerror_s(buf, 255, err); buf[255] = 0;
    msg = kk_string_alloc_from_qutf8( buf, ctx );
  #else
    // Old style
    msg = kk_string_alloc_from_qutf8( strerror(err), ctx );
  #endif
  return kk_std_core__new_Error( kk_std_core__new_Exception( msg, kk_std_core__new_ExnSystem(kk_reuse_null, 0, kk_integer_from_int(err,ctx), ctx), ctx), ctx );  
}


kk_unit_t kk_assert_fail( kk_string_t msg, kk_context_t* ctx ) {
  kk_fatal_error(EINVAL, "assertion failed: %s\n", kk_string_cbuf_borrow(msg,NULL,ctx));
  kk_string_drop(msg,ctx);
  return kk_Unit;
}
kk_declare_string_literal(, kk_std_core__tag_ExnError, 17, "std/core/ExnError")
kk_declare_string_literal(, kk_std_core__tag_ExnAssert, 18, "std/core/ExnAssert")
kk_declare_string_literal(, kk_std_core__tag_ExnTodo, 16, "std/core/ExnTodo")
kk_declare_string_literal(, kk_std_core__tag_ExnRange, 17, "std/core/ExnRange")
kk_declare_string_literal(, kk_std_core__tag_ExnPattern, 19, "std/core/ExnPattern")
kk_declare_string_literal(, kk_std_core__tag_ExnSystem, 18, "std/core/ExnSystem")
kk_declare_string_literal(, kk_std_core__tag_ExnInternal, 20, "std/core/ExnInternal")

kk_std_core__exception kk_std_core__copy(kk_std_core__exception _this, kk_std_core_types__optional message0, kk_std_core_types__optional info0, kk_context_t* _ctx) { /* (exception, message : optional<string>, info : optional<exception-info>) -> exception */ 
  kk_string_t _x20093;
  if (kk_std_core_types__is_Optional(message0, _ctx)) {
    kk_box_t _box_x18395 = message0._cons.Optional.value;
    kk_string_t _message_1695 = kk_string_unbox(_box_x18395);
    kk_string_dup(_message_1695, _ctx);
    kk_std_core_types__optional_drop(message0, _ctx);
    _x20093 = _message_1695; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(message0, _ctx);
    {
      kk_string_t _x = _this.message;
      kk_string_dup(_x, _ctx);
      _x20093 = _x; /*string*/
    }
  }
  kk_std_core__exception_info _x20094;
  if (kk_std_core_types__is_Optional(info0, _ctx)) {
    kk_box_t _box_x18396 = info0._cons.Optional.value;
    kk_std_core__exception_info _info_1701 = kk_std_core__exception_info_unbox(_box_x18396, KK_BORROWED, _ctx);
    kk_std_core__exception_info_dup(_info_1701, _ctx);
    kk_std_core_types__optional_drop(info0, _ctx);
    kk_std_core__exception_drop(_this, _ctx);
    _x20094 = _info_1701; /*exception-info*/
  }
  else {
    kk_std_core_types__optional_drop(info0, _ctx);
    {
      kk_std_core__exception_info _x0 = _this.info;
      kk_std_core__exception_info_dup(_x0, _ctx);
      kk_std_core__exception_drop(_this, _ctx);
      _x20094 = _x0; /*exception-info*/
    }
  }
  return kk_std_core__new_Exception(_x20093, _x20094, _ctx);
}

kk_std_core__delayed kk_std_core__copy_1(kk_std_core__delayed _this, kk_std_core_types__optional dref0, kk_context_t* _ctx) { /* forall<e,a> (delayed<e,a>, dref : optional<ref<global,either<() -> e a,a>>>) -> delayed<e,a> */ 
  kk_ref_t _x20095;
  if (kk_std_core_types__is_Optional(dref0, _ctx)) {
    kk_box_t _box_x18397 = dref0._cons.Optional.value;
    kk_ref_t _dref_1734 = kk_ref_unbox(_box_x18397, _ctx);
    kk_ref_dup(_dref_1734, _ctx);
    kk_std_core_types__optional_drop(dref0, _ctx);
    kk_std_core__delayed_drop(_this, _ctx);
    _x20095 = _dref_1734; /*ref<global,either<() -> 1746 1747,1747>>*/
  }
  else {
    kk_std_core_types__optional_drop(dref0, _ctx);
    {
      kk_ref_t _x = _this.dref;
      _x20095 = _x; /*ref<global,either<() -> 1746 1747,1747>>*/
    }
  }
  return kk_std_core__new_Delay(_x20095, _ctx);
}

kk_std_core__sslice kk_std_core__copy_2(kk_std_core__sslice _this, kk_std_core_types__optional str0, kk_std_core_types__optional start0, kk_std_core_types__optional len0, kk_context_t* _ctx) { /* (sslice, str : optional<string>, start : optional<int>, len : optional<int>) -> sslice */ 
  kk_string_t _x20097;
  if (kk_std_core_types__is_Optional(str0, _ctx)) {
    kk_box_t _box_x18398 = str0._cons.Optional.value;
    kk_string_t _str_1833 = kk_string_unbox(_box_x18398);
    kk_string_dup(_str_1833, _ctx);
    kk_std_core_types__optional_drop(str0, _ctx);
    _x20097 = _str_1833; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(str0, _ctx);
    {
      kk_string_t _x = _this.str;
      kk_string_dup(_x, _ctx);
      _x20097 = _x; /*string*/
    }
  }
  kk_integer_t _x20098;
  if (kk_std_core_types__is_Optional(start0, _ctx)) {
    kk_box_t _box_x18399 = start0._cons.Optional.value;
    kk_integer_t _start_1839 = kk_integer_unbox(_box_x18399, _ctx);
    kk_integer_dup(_start_1839, _ctx);
    kk_std_core_types__optional_drop(start0, _ctx);
    _x20098 = _start_1839; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(start0, _ctx);
    {
      kk_integer_t _x0 = _this.start;
      kk_integer_dup(_x0, _ctx);
      _x20098 = _x0; /*int*/
    }
  }
  kk_integer_t _x20099;
  if (kk_std_core_types__is_Optional(len0, _ctx)) {
    kk_box_t _box_x18400 = len0._cons.Optional.value;
    kk_integer_t _len_1845 = kk_integer_unbox(_box_x18400, _ctx);
    kk_integer_dup(_len_1845, _ctx);
    kk_std_core_types__optional_drop(len0, _ctx);
    kk_std_core__sslice_drop(_this, _ctx);
    _x20099 = _len_1845; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(len0, _ctx);
    {
      kk_integer_t _x1 = _this.len;
      kk_integer_dup(_x1, _ctx);
      kk_std_core__sslice_drop(_this, _ctx);
      _x20099 = _x1; /*int*/
    }
  }
  return kk_std_core__new_Sslice(_x20097, _x20098, _x20099, _ctx);
}

kk_std_core__stream kk_std_core__copy_3(kk_std_core__stream _this, kk_std_core_types__optional head0, kk_std_core_types__optional tail0, kk_context_t* _ctx) { /* forall<a> (stream<a>, head : optional<a>, tail : optional<stream<a>>) -> stream<a> */ 
  kk_box_t _x20102;
  if (kk_std_core_types__is_Optional(head0, _ctx)) {
    kk_box_t _head_1891 = head0._cons.Optional.value;
    kk_box_dup(_head_1891, _ctx);
    kk_std_core_types__optional_drop(head0, _ctx);
    _x20102 = _head_1891; /*1908*/
  }
  else {
    kk_std_core_types__optional_drop(head0, _ctx);
    {
      struct kk_std_core_Next* _con20103 = kk_std_core__as_Next(_this, _ctx);
      kk_box_t _x = _con20103->head;
      kk_box_dup(_x, _ctx);
      _x20102 = _x; /*1908*/
    }
  }
  kk_std_core__stream _x20104;
  if (kk_std_core_types__is_Optional(tail0, _ctx)) {
    kk_box_t _box_x18401 = tail0._cons.Optional.value;
    kk_std_core__stream _tail_1898 = kk_std_core__stream_unbox(_box_x18401, KK_BORROWED, _ctx);
    kk_std_core__stream_dup(_tail_1898, _ctx);
    kk_std_core_types__optional_drop(tail0, _ctx);
    kk_std_core__stream_drop(_this, _ctx);
    _x20104 = _tail_1898; /*stream<1908>*/
  }
  else {
    kk_std_core_types__optional_drop(tail0, _ctx);
    {
      struct kk_std_core_Next* _con20105 = kk_std_core__as_Next(_this, _ctx);
      kk_box_t _pat01 = _con20105->head;
      kk_std_core__stream _x0 = _con20105->tail;
      if kk_likely(kk_datatype_ptr_is_unique(_this, _ctx)) {
        kk_box_drop(_pat01, _ctx);
        kk_datatype_ptr_free(_this, _ctx);
      }
      else {
        kk_std_core__stream_dup(_x0, _ctx);
        kk_datatype_ptr_decref(_this, _ctx);
      }
      _x20104 = _x0; /*stream<1908>*/
    }
  }
  return kk_std_core__new_Next(kk_reuse_null, 0, _x20102, _x20104, _ctx);
}
 
// runtime tag for the `:exn` effect

kk_std_core_hnd__htag kk_std_core__tag_exn;
 
// handler for the `:exn` effect

kk_box_t kk_std_core__handle_exn(int32_t cfc, kk_std_core__hnd_exn hnd, kk_function_t ret, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e,b> (cfc : int32, hnd : .hnd-exn<e,b>, ret : (res : a) -> e b, action : () -> <exn|e> a) -> e b */ 
  kk_std_core_hnd__htag _x20109 = kk_std_core_hnd__htag_dup(kk_std_core__tag_exn, _ctx); /*std/core/hnd/htag<.hnd-exn>*/
  return kk_std_core_hnd__hhandle(_x20109, cfc, kk_std_core__hnd_exn_box(hnd, _ctx), ret, action, _ctx);
}
 
// Unsafe: transform any type to a `null` type; used internally by the compiler.

kk_std_core__null kk_std_core__null_any(kk_box_t x, kk_context_t* _ctx) { /* forall<a> (x : a) -> null<a> */ 
  return (kk_box_is_null(x) ? kk_datatype_null() : kk_datatype_unbox(x));
}

kk_ref_t kk_std_core_redirect;
 
// Print a string to the console, including a final newline character.

kk_unit_t kk_std_core_xprintsln(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> console () */ 
  kk_println(s,kk_context()); return kk_Unit;
}

kk_integer_t kk_std_core_string_compare(kk_string_t x, kk_string_t y, kk_context_t* _ctx) { /* (x : string, y : string) -> int */ 
  return kk_string_cmp_int(x,y,kk_context());
}
 
// Convert an integer to an `:int32`. The number is _clamped_ to the maximal or minimum `:int32`
// value if it is outside the range of an `:int32`.

int32_t kk_std_core_int32(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int32 */ 
  return kk_integer_clamp32(i,kk_context());
}
 
// Convert an integer to an `:ssize_t`. The number is _clamped_ to the maximal or minimum `:ssize_t`
// value if it is outside the range of an `:ssize_t`.

kk_ssize_t kk_std_core_ssize__t(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> ssize_t */ 
  return kk_integer_clamp_ssize_t(i,kk_context());
}
 
// Convert a character to a string

kk_string_t kk_std_core_string(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> string */ 
  return kk_string_from_char(c,kk_context());
}
 
// Convert a vector of characters to a string.

kk_string_t kk_std_core_string_1(kk_vector_t _arg1, kk_context_t* _ctx) { /* (vector<char>) -> string */ 
  return kk_string_from_chars(_arg1,kk_context());
}
 
// Convert a list of characters to a string

kk_string_t kk_std_core_string_2(kk_std_core__list cs, kk_context_t* _ctx) { /* (cs : list<char>) -> total string */ 
  return kk_string_from_list(cs,kk_context());
}
 
// O(n). Copy the `slice` argument into a fresh string.
// Takes O(1) time if the slice covers the entire string.

kk_string_t kk_std_core_string_3(kk_std_core__sslice slice0, kk_context_t* _ctx) { /* (slice : sslice) -> string */ 
  return kk_slice_to_string(slice0,kk_context());
}
 
// Convert a vector to a list with an optional tail.

kk_std_core__list kk_std_core_vlist(kk_vector_t v, kk_std_core_types__optional tail0, kk_context_t* _ctx) { /* forall<a> (v : vector<a>, tail : optional<list<a>>) -> list<a> */ 
  kk_std_core__list _x20111;
  if (kk_std_core_types__is_Optional(tail0, _ctx)) {
    kk_box_t _box_x18415 = tail0._cons.Optional.value;
    kk_std_core__list _tail_2139 = kk_std_core__list_unbox(_box_x18415, KK_BORROWED, _ctx);
    kk_std_core__list_dup(_tail_2139, _ctx);
    kk_std_core_types__optional_drop(tail0, _ctx);
    _x20111 = _tail_2139; /*list<2149>*/
  }
  else {
    kk_std_core_types__optional_drop(tail0, _ctx);
    _x20111 = kk_std_core__new_Nil(_ctx); /*list<2149>*/
  }
  return kk_vector_to_list(v,_x20111,kk_context());
}

kk_string_t kk_std_core_int_show_hex(kk_integer_t i, bool use_capitals, kk_context_t* _ctx) { /* (i : int, use-capitals : bool) -> string */ 
  return kk_integer_to_hex_string(i,use_capitals,kk_context());
}

kk_string_t kk_std_core_repeatz(kk_string_t s, kk_ssize_t n, kk_context_t* _ctx) { /* (s : string, n : ssize_t) -> string */ 
  return kk_string_repeat(s,n,kk_context());
}

kk_string_t kk_std_core_show_expx(double d, int32_t prec, kk_context_t* _ctx) { /* (d : float64, prec : int32) -> string */ 
  return kk_double_show_exp(d,prec,kk_context());
}

kk_string_t kk_std_core_show_fixedx(double d, int32_t prec, kk_context_t* _ctx) { /* (d : float64, prec : int32) -> string */ 
  return kk_double_show_fixed(d,prec,kk_context());
}
 
// Print a string to the console

kk_unit_t kk_std_core_xprints(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> console () */ 
  kk_print(s,kk_context()); return kk_Unit;
}
 
// Raise an integer `i` to the power of `exp`.

kk_integer_t kk_std_core_pow(kk_integer_t i, kk_integer_t exp, kk_context_t* _ctx) { /* (i : int, exp : int) -> int */ 
  return kk_integer_pow(i,exp,kk_context());
}
 
// O(`count`). Advance the start position of a string slice by `count` characters
// up to the end of the string.
// A negative `count` advances the start position backwards upto the first position
// in a string.
// Maintains the character count of the original slice upto the end of the string.
// For example:
//
// * `"abc".first.advance(1).string == "b"`,
// * `"abc".first.advance(3).string == ""`,
// * `"abc".last.advance(-1).string == "b"`.
//

kk_std_core__sslice kk_std_core_advance(kk_std_core__sslice slice0, kk_integer_t count, kk_context_t* _ctx) { /* (slice : sslice, count : int) -> sslice */ 
  return kk_slice_advance_borrow(slice0,count,kk_context());
}

kk_unit_t kk_std_core_unsafe_assert_fail(kk_string_t msg, kk_context_t* _ctx) { /* (msg : string) -> () */ 
  kk_assert_fail(msg,kk_context()); return kk_Unit;
}
 
// O(`count`). Extend a string slice by `count` characters up to the end of the string.
// A negative `count` shrinks the slice up to the empty slice.
// For example:
//
// * `"abc".first.extend(1).string == "ab"`
// * `"abc".last.extend(-1).string == ""`
//

kk_std_core__sslice kk_std_core_extend(kk_std_core__sslice slice0, kk_integer_t count, kk_context_t* _ctx) { /* (slice : sslice, count : int) -> sslice */ 
  return kk_slice_extend_borrow(slice0,count,kk_context());
}

kk_std_core__sslice kk_std_core_first1(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> sslice */ 
  return kk_slice_first(s,kk_context());
}
 
// Convert a string to upper-case

kk_string_t kk_std_core_to_upper(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  return kk_string_to_upper(s,kk_context());
}

kk_integer_t kk_std_core_cdiv_exp10(kk_integer_t i, kk_integer_t n, kk_context_t* _ctx) { /* (i : int, n : int) -> int */ 
  return kk_integer_cdiv_pow10(i,n,kk_context());
}

kk_integer_t kk_std_core_mul_exp10(kk_integer_t i, kk_integer_t n, kk_context_t* _ctx) { /* (i : int, n : int) -> int */ 
  return kk_integer_mul_pow10(i,n,kk_context());
}
 
// Return the common prefix of two strings (upto `upto` characters (default is minimum length of the two strings))

kk_std_core__sslice kk_std_core_common_prefix(kk_string_t s, kk_string_t t, kk_std_core_types__optional upto, kk_context_t* _ctx) { /* (s : string, t : string, upto : optional<int>) -> sslice */ 
  kk_integer_t _brw_20011;
  if (kk_std_core_types__is_Optional(upto, _ctx)) {
    kk_box_t _box_x18416 = upto._cons.Optional.value;
    kk_integer_t _upto_2249 = kk_integer_unbox(_box_x18416, _ctx);
    _brw_20011 = kk_integer_dup(_upto_2249, _ctx); /*int*/
  }
  else {
    _brw_20011 = kk_integer_from_small(-1); /*int*/
  }
  kk_std_core__sslice _brw_20012 = kk_slice_common_prefix_borrow(s,t,_brw_20011,kk_context()); /*sslice*/;
  kk_integer_drop(_brw_20011, _ctx);
  return _brw_20012;
}
 
// lifted local: concat, concat-pre

kk_std_core__list kk_std_core__trmc_lift17311_concat(kk_std_core__list ys, kk_std_core__list zss, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, zss : list<list<a>>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con20112 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con20112->head;
    kk_std_core__list yy = _con20112->tail;
    kk_reuse_t _ru_20014 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_20014 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core__list _trmc_17669 = kk_datatype_null(); /*list<2297>*/;
    kk_std_core__list _trmc_17670 = kk_std_core__new_Cons(_ru_20014, 0, y, _trmc_17669, _ctx); /*list<2297>*/;
    kk_box_t* _b_18428_18422 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17670, _ctx)->tail)); /*field-addr<list<2297>>*/;
    { // tailcall
      kk_std_core_types__cctx _x20113 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17670, _ctx)),_b_18428_18422,true,kk_context()); /*ctx<0>*/
      ys = yy;
      _acc = _x20113;
      goto kk__tailcall;
    }
  }
  if (kk_std_core__is_Cons(zss, _ctx)) {
    struct kk_std_core_Cons* _con20114 = kk_std_core__as_Cons(zss, _ctx);
    kk_box_t _box_x18423 = _con20114->head;
    kk_std_core__list zzs = _con20114->tail;
    kk_std_core__list zs = kk_std_core__list_unbox(_box_x18423, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(zss, _ctx)) {
      kk_datatype_ptr_free(zss, _ctx);
    }
    else {
      kk_std_core__list_dup(zs, _ctx);
      kk_std_core__list_dup(zzs, _ctx);
      kk_datatype_ptr_decref(zss, _ctx);
    }
    { // tailcall
      ys = zs;
      zss = zzs;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x20115 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20115, KK_OWNED, _ctx);
  }
}
 
// lifted local: concat, concat-pre

kk_std_core__list kk_std_core__lift17311_concat(kk_std_core__list ys0, kk_std_core__list zss0, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, zss : list<list<a>>) -> list<a> */ 
  kk_std_core_types__cctx _x20116 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17311_concat(ys0, zss0, _x20116, _ctx);
}
extern kk_box_t kk_std_core_const_fun20117_1(kk_function_t _fself, kk_box_t ___wildcard__109__6, kk_context_t* _ctx) {
  struct kk_std_core_const_fun20117__t_1* _self = kk_function_as(struct kk_std_core_const_fun20117__t_1*, _fself, _ctx);
  kk_box_t default0 = _self->default0; /* 2325 */
  kk_drop_match(_self, {kk_box_dup(default0, _ctx);}, {}, _ctx)
  kk_box_drop(___wildcard__109__6, _ctx);
  return default0;
}
 
// If the slice is not empty,
// return the first character, and a new slice that is advanced by 1.

kk_std_core_types__maybe kk_std_core_next(kk_std_core__sslice slice0, kk_context_t* _ctx) { /* (slice : sslice) -> maybe<(char, sslice)> */ 
  return kk_slice_next(slice0,kk_context());
}
 
// Return the number of decimal digits of `i`. Return `0` when `i==0`.

kk_integer_t kk_std_core_count_digits(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int */ 
  return kk_integer_count_digits(i,kk_context());
}
 
// Transform an `:error` type to an `:either` value.

kk_std_core_types__either kk_std_core_either(kk_std_core__error t, kk_context_t* _ctx) { /* forall<a> (t : error<a>) -> either<exception,a> */ 
  if (kk_std_core__is_Error(t, _ctx)) {
    kk_std_core__exception exn0 = t._cons.Error.exception;
    kk_std_core__exception_dup(exn0, _ctx);
    kk_std_core__error_drop(t, _ctx);
    return kk_std_core_types__new_Left(kk_std_core__exception_box(exn0, _ctx), _ctx);
  }
  {
    kk_box_t x = t._cons.Ok.result;
    return kk_std_core_types__new_Right(x, _ctx);
  }
}
 
// An empty slice

kk_std_core__sslice kk_std_core_empty;

bool kk_std_core_xends_with(kk_string_t s, kk_string_t post, kk_context_t* _ctx) { /* (s : string, post : string) -> bool */ 
  return kk_string_ends_with(s,post,kk_context());
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift17993_trmc_lift17312_flatmap(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core__list zz, kk_std_core__list ys1_17338, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e list<b>, zz : list<a>, ys1.17338 : list<b>) -> e list<b> */ 
  return kk_std_core__trmc_lift17312_flatmap(f, ys1_17338, zz, _acc, _ctx);
}
 
// lifted local: flatmap, flatmap-pre


// lift anonymous function
struct kk_std_core__trmc_lift17312_flatmap_fun20125__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list zz0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_lift17312_flatmap_fun20125(kk_function_t _fself, kk_box_t _b_18443, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_lift17312_flatmap_fun20125(kk_function_t f0, kk_std_core__list zz0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17312_flatmap_fun20125__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_lift17312_flatmap_fun20125__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_lift17312_flatmap_fun20125, kk_context());
  _self->f0 = f0;
  _self->zz0 = zz0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_lift17312_flatmap_fun20125(kk_function_t _fself, kk_box_t _b_18443, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17312_flatmap_fun20125__t* _self = kk_function_as(struct kk_std_core__trmc_lift17312_flatmap_fun20125__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (2479) -> 2481 list<2480> */
  kk_std_core__list zz0 = _self->zz0; /* list<2479> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<2480>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(zz0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_std_core__list ys1_18455_173380 = kk_std_core__list_unbox(_b_18443, KK_OWNED, _ctx); /*list<2480>*/;
  kk_std_core__list _x20126 = kk_std_core__mlift17993_trmc_lift17312_flatmap(_acc0, f0, zz0, ys1_18455_173380, _ctx); /*list<2480>*/
  return kk_std_core__list_box(_x20126, _ctx);
}

kk_std_core__list kk_std_core__trmc_lift17312_flatmap(kk_function_t f0, kk_std_core__list ys, kk_std_core__list zs, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e list<b>, ys : list<b>, zs : list<a>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con20120 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con20120->head;
    kk_std_core__list yy = _con20120->tail;
    kk_reuse_t _ru_20016 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_20016 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core__list _trmc_17671 = kk_datatype_null(); /*list<2480>*/;
    kk_std_core__list _trmc_17672 = kk_std_core__new_Cons(_ru_20016, kk_field_index_of(struct kk_std_core_Cons, tail), y, _trmc_17671, _ctx); /*list<2480>*/;
    kk_box_t* _b_18448_18441 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17672, _ctx)->tail)); /*field-addr<list<2480>>*/;
    { // tailcall
      kk_std_core_types__cctx _x20121 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_17672, _ctx)),_b_18448_18441,false,kk_context()); /*ctx<0>*/
      ys = yy;
      _acc0 = _x20121;
      goto kk__tailcall;
    }
  }
  if (kk_std_core__is_Cons(zs, _ctx)) {
    struct kk_std_core_Cons* _con20122 = kk_std_core__as_Cons(zs, _ctx);
    kk_box_t z = _con20122->head;
    kk_std_core__list zz0 = _con20122->tail;
    if kk_likely(kk_datatype_ptr_is_unique(zs, _ctx)) {
      kk_datatype_ptr_free(zs, _ctx);
    }
    else {
      kk_box_dup(z, _ctx);
      kk_std_core__list_dup(zz0, _ctx);
      kk_datatype_ptr_decref(zs, _ctx);
    }
    kk_std_core__list x_18055;
    kk_function_t _x20123 = kk_function_dup(f0, _ctx); /*(2479) -> 2481 list<2480>*/
    x_18055 = kk_function_call(kk_std_core__list, (kk_function_t, kk_box_t, kk_context_t*), _x20123, (_x20123, z, _ctx), _ctx); /*list<2480>*/
    if (kk_yielding(kk_context())) {
      kk_std_core__list_drop(x_18055, _ctx);
      kk_box_t _x20124 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_lift17312_flatmap_fun20125(f0, zz0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20124, KK_OWNED, _ctx);
    }
    { // tailcall
      ys = x_18055;
      zs = zz0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(f0, _ctx);
    kk_box_t _x20127 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20127, KK_OWNED, _ctx);
  }
}
 
// lifted local: flatmap, flatmap-pre

kk_std_core__list kk_std_core__lift17312_flatmap(kk_function_t f1, kk_std_core__list ys0, kk_std_core__list zs0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e list<b>, ys : list<b>, zs : list<a>) -> e list<b> */ 
  kk_std_core_types__cctx _x20128 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17312_flatmap(f1, ys0, zs0, _x20128, _ctx);
}
 
// lifted local: reverse-append, reverse-acc

kk_std_core__list kk_std_core__lift17313_reverse_append(kk_std_core__list acc, kk_std_core__list ys, kk_context_t* _ctx) { /* forall<a> (acc : list<a>, ys : list<a>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con20129 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t x = _con20129->head;
    kk_std_core__list xx = _con20129->tail;
    kk_reuse_t _ru_20018 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_20018 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    { // tailcall
      kk_std_core__list _x20130 = kk_std_core__new_Cons(_ru_20018, 0, x, acc, _ctx); /*list<61>*/
      acc = _x20130;
      ys = xx;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift17995_force_fun20134__t {
  struct kk_function_s _base;
  kk_ref_t r;
};
static kk_box_t kk_std_core__mlift17995_force_fun20134(kk_function_t _fself, kk_box_t x0, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift17995_force_fun20134(kk_ref_t r, kk_context_t* _ctx) {
  struct kk_std_core__mlift17995_force_fun20134__t* _self = kk_function_alloc_as(struct kk_std_core__mlift17995_force_fun20134__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift17995_force_fun20134, kk_context());
  _self->r = r;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift17995_force_fun20134(kk_function_t _fself, kk_box_t x0, kk_context_t* _ctx) {
  struct kk_std_core__mlift17995_force_fun20134__t* _self = kk_function_as(struct kk_std_core__mlift17995_force_fun20134__t*, _fself, _ctx);
  kk_ref_t r = _self->r; /* ref<global,either<() -> 2616 2615,2615>> */
  kk_drop_match(_self, {kk_ref_dup(r, _ctx);}, {}, _ctx)
  kk_unit_t __ = kk_Unit;
  kk_unit_t _brw_20008 = kk_Unit;
  kk_box_t _x20135;
  kk_std_core_types__either _x20136;
  kk_box_t _x20137 = kk_box_dup(x0, _ctx); /*2615*/
  _x20136 = kk_std_core_types__new_Right(_x20137, _ctx); /*either<76,77>*/
  _x20135 = kk_std_core_types__either_box(_x20136, _ctx); /*176*/
  kk_ref_set_borrow(r,_x20135,kk_context());
  kk_ref_drop(r, _ctx);
  _brw_20008;
  return x0;
}

kk_box_t kk_std_core__mlift17995_force(kk_ref_t r, kk_function_t _y_17736, kk_context_t* _ctx) { /* forall<a,e> (r : ref<global,either<() -> e a,a>>, () -> <st<global>,div|e> a) -> <alloc<global>,div,read<global>,write<global>|e> a */ 
  kk_box_t x_18058 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), _y_17736, (_y_17736, _ctx), _ctx); /*2615*/;
  kk_function_t next0_18059 = kk_std_core__new_mlift17995_force_fun20134(r, _ctx); /*(2615) -> <st<global>,div|2616> 2615*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18058, _ctx);
    return kk_std_core_hnd_yield_extend(next0_18059, _ctx);
  }
  {
    return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), next0_18059, (next0_18059, x_18058, _ctx), _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift17996_force_fun20138__t {
  struct kk_function_s _base;
  kk_ref_t r;
};
static kk_box_t kk_std_core__mlift17996_force_fun20138(kk_function_t _fself, kk_box_t _b_18468, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift17996_force_fun20138(kk_ref_t r, kk_context_t* _ctx) {
  struct kk_std_core__mlift17996_force_fun20138__t* _self = kk_function_alloc_as(struct kk_std_core__mlift17996_force_fun20138__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift17996_force_fun20138, kk_context());
  _self->r = r;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift17996_force_fun20138(kk_function_t _fself, kk_box_t _b_18468, kk_context_t* _ctx) {
  struct kk_std_core__mlift17996_force_fun20138__t* _self = kk_function_as(struct kk_std_core__mlift17996_force_fun20138__t*, _fself, _ctx);
  kk_ref_t r = _self->r; /* ref<global,either<() -> 2616 2615,2615>> */
  kk_drop_match(_self, {kk_ref_dup(r, _ctx);}, {}, _ctx)
  kk_function_t _x20139 = kk_function_unbox(_b_18468, _ctx); /*() -> <st<global>,div|2616> 18469*/
  return kk_std_core__mlift17995_force(r, _x20139, _ctx);
}

kk_box_t kk_std_core__mlift17996_force(kk_ref_t r, kk_std_core_types__either _y_17734, kk_context_t* _ctx) { /* forall<a,e> (r : ref<global,either<() -> e a,a>>, either<() -> e a,a>) -> <read<global>,div,alloc<global>,write<global>|e> a */ 
  if (kk_std_core_types__is_Right(_y_17734, _ctx)) {
    kk_box_t x = _y_17734._cons.Right.right;
    kk_ref_drop(r, _ctx);
    return x;
  }
  {
    kk_box_t _fun_unbox_x18465 = _y_17734._cons.Left.left;
    if (kk_yielding(kk_context())) {
      kk_box_drop(_fun_unbox_x18465, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core__new_mlift17996_force_fun20138(r, _ctx), _ctx);
    }
    {
      kk_function_t _x20140 = kk_function_unbox(_fun_unbox_x18465, _ctx); /*() -> 2616 18466*/
      return kk_std_core__mlift17995_force(r, _x20140, _ctx);
    }
  }
}
 
// Force a delayed value; the value is computed only on the first
// call to `force` and cached afterwards.


// lift anonymous function
struct kk_std_core_force_fun20143__t {
  struct kk_function_s _base;
  kk_std_core__delayed delayed;
};
static kk_box_t kk_std_core_force_fun20143(kk_function_t _fself, kk_box_t _b_18475, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_force_fun20143(kk_std_core__delayed delayed, kk_context_t* _ctx) {
  struct kk_std_core_force_fun20143__t* _self = kk_function_alloc_as(struct kk_std_core_force_fun20143__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_force_fun20143, kk_context());
  _self->delayed = delayed;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_force_fun20143(kk_function_t _fself, kk_box_t _b_18475, kk_context_t* _ctx) {
  struct kk_std_core_force_fun20143__t* _self = kk_function_as(struct kk_std_core_force_fun20143__t*, _fself, _ctx);
  kk_std_core__delayed delayed = _self->delayed; /* delayed<2616,2615> */
  kk_drop_match(_self, {kk_std_core__delayed_dup(delayed, _ctx);}, {}, _ctx)
  kk_std_core_types__either _y_18477_17734 = kk_std_core_types__either_unbox(_b_18475, KK_OWNED, _ctx); /*either<() -> 2616 2615,2615>*/;
  kk_ref_t _x20144;
  {
    kk_ref_t _x0 = delayed.dref;
    _x20144 = _x0; /*ref<global,either<() -> 2616 2615,2615>>*/
  }
  return kk_std_core__mlift17996_force(_x20144, _y_18477_17734, _ctx);
}

kk_box_t kk_std_core_force(kk_std_core__delayed delayed, kk_context_t* _ctx) { /* forall<a,e> (delayed : delayed<e,a>) -> e a */ 
  kk_std_core_types__either x_18065;
  kk_box_t _x20141;
  kk_ref_t _x20142;
  {
    kk_ref_t _x = delayed.dref;
    kk_ref_dup(_x, _ctx);
    _x20142 = _x; /*ref<global,either<() -> 2616 2615,2615>>*/
  }
  _x20141 = kk_ref_get(_x20142,kk_context()); /*190*/
  x_18065 = kk_std_core_types__either_unbox(_x20141, KK_OWNED, _ctx); /*either<() -> 2616 2615,2615>*/
  if (kk_yielding(kk_context())) {
    kk_std_core_types__either_drop(x_18065, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_new_force_fun20143(delayed, _ctx), _ctx);
  }
  {
    kk_std_core_types__either _y_18478_17734 = x_18065; /*either<() -> 2616 2615,2615>*/;
    kk_ref_t _x20145;
    {
      kk_ref_t _x0 = delayed.dref;
      _x20145 = _x0; /*ref<global,either<() -> 2616 2615,2615>>*/
    }
    return kk_std_core__mlift17996_force(_x20145, _y_18478_17734, _ctx);
  }
}
 
// Generic show: shows the internal representation of an object as a string
// Note: this breaks parametricity so it should not be pub

kk_string_t kk_std_core_gshow(kk_box_t _arg1, kk_context_t* _ctx) { /* forall<a> (a) -> string */ 
  return kk_show_any(_arg1,kk_context());
}
 
// Return the host environment: `dotnet`, `browser`, `webworker`, `node`, or `libc`.

kk_string_t kk_std_core_host(kk_context_t* _ctx) { /* () -> ndet string */ 
  return kk_get_host(kk_context());
}
 
// clamp an `:int` to fit in an `:int64_t`.

int64_t kk_std_core_int64(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int64 */ 
  return kk_integer_clamp64(i,kk_context());
}
 
// clamp an `:int` to fit in an `:int16`.

int16_t kk_std_core_int16(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int16 */ 
  return kk_integer_clamp_int16(i,kk_context());
}
 
// clamp an `:int` to fit in an `:int8`.

int8_t kk_std_core_int8(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int8 */ 
  return kk_integer_clamp_int8(i,kk_context());
}
 
// lifted local: intersperse, before

kk_std_core__list kk_std_core__trmc_lift17314_intersperse(kk_box_t sep, kk_std_core__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (sep : a, ys : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con20146 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con20146->head;
    kk_std_core__list yy = _con20146->tail;
    kk_reuse_t _ru_20019 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_20019 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core__list _trmc_17673;
    kk_std_core__list _x20147 = kk_datatype_null(); /*list<2702>*/
    _trmc_17673 = kk_std_core__new_Cons(_ru_20019, 0, y, _x20147, _ctx); /*list<2702>*/
    kk_box_t* _b_18489_18484 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17673, _ctx)->tail)); /*field-addr<list<2702>>*/;
    { // tailcall
      kk_box_t _x20148 = kk_box_dup(sep, _ctx); /*2702*/
      kk_std_core_types__cctx _x20149;
      kk_box_t _x20150;
      kk_std_core__list _x20151 = kk_std_core__new_Cons(kk_reuse_null, 0, sep, _trmc_17673, _ctx); /*list<61>*/
      _x20150 = kk_std_core__list_box(_x20151, _ctx); /*0*/
      _x20149 = kk_cctx_extend(_acc,_x20150,_b_18489_18484,true,kk_context()); /*ctx<0>*/
      sep = _x20148;
      ys = yy;
      _acc = _x20149;
      goto kk__tailcall;
    }
  }
  {
    kk_box_drop(sep, _ctx);
    kk_box_t _x20152 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20152, KK_OWNED, _ctx);
  }
}
 
// lifted local: intersperse, before

kk_std_core__list kk_std_core__lift17314_intersperse(kk_box_t sep0, kk_std_core__list ys0, kk_context_t* _ctx) { /* forall<a> (sep : a, ys : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x20153 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17314_intersperse(sep0, ys0, _x20153, _ctx);
}
 
// Insert a separator `sep`  between all elements of a list `xs` .

kk_std_core__list kk_std_core_intersperse(kk_std_core__list xs, kk_box_t sep, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, sep : a) -> list<a> */ 
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20154 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20154->head;
    kk_std_core__list xx = _con20154->tail;
    kk_reuse_t _ru_20020 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_20020 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core__list _x20155 = kk_std_core__lift17314_intersperse(sep, xx, _ctx); /*list<2702>*/
    return kk_std_core__new_Cons(_ru_20020, 0, x, _x20155, _ctx);
  }
  {
    kk_box_drop(sep, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
}
 
// clamp an `:int` to fit in an `:intptr_t`.

intptr_t kk_std_core_intptr__t(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> intptr_t */ 
  return kk_integer_clamp_intptr_t(i,kk_context());
}
 
// An invalid slice

kk_std_core__sslice kk_std_core_invalid;
 
// Return the number of ending `0` digits of `i`. Return `0` when `i==0`.

kk_integer_t kk_std_core_is_exp10(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int */ 
  return kk_integer_ctz(i,kk_context());
}

kk_std_core__sslice kk_std_core_last1(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> sslice */ 
  return kk_slice_last(s,kk_context());
}
 
// Used by the compiler to wrap main console applications

kk_box_t kk_std_core_main_console(kk_function_t main, kk_context_t* _ctx) { /* forall<a,e> (main : () -> e a) -> e a */ 
  return kk_main_console(main,kk_context());
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift17997_trmc_lift17315_map_peek(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core__list yy, kk_box_t _trmc_17675, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (value : a, rest : list<a>) -> e b, yy : list<a>, b) -> e list<b> */ 
  kk_std_core__list _trmc_17676 = kk_datatype_null(); /*list<2798>*/;
  kk_std_core__list _trmc_17677 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_17675, _trmc_17676, _ctx); /*list<2798>*/;
  kk_box_t* _b_18503_18500 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17677, _ctx)->tail)); /*field-addr<list<2798>>*/;
  kk_std_core_types__cctx _x20158 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17677, _ctx)),_b_18503_18500,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17315_map_peek(f, yy, _x20158, _ctx);
}
 
// lifted local: map-peek, mappeek


// lift anonymous function
struct kk_std_core__trmc_lift17315_map_peek_fun20163__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list yy0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_lift17315_map_peek_fun20163(kk_function_t _fself, kk_box_t _b_18508, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_lift17315_map_peek_fun20163(kk_function_t f0, kk_std_core__list yy0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17315_map_peek_fun20163__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_lift17315_map_peek_fun20163__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_lift17315_map_peek_fun20163, kk_context());
  _self->f0 = f0;
  _self->yy0 = yy0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_lift17315_map_peek_fun20163(kk_function_t _fself, kk_box_t _b_18508, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17315_map_peek_fun20163__t* _self = kk_function_as(struct kk_std_core__trmc_lift17315_map_peek_fun20163__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (value : 2797, rest : list<2797>) -> 2799 2798 */
  kk_std_core__list yy0 = _self->yy0; /* list<2797> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<2798>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(yy0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_18526_176750 = _b_18508; /*2798*/;
  kk_std_core__list _x20164 = kk_std_core__mlift17997_trmc_lift17315_map_peek(_acc0, f0, yy0, _trmc_18526_176750, _ctx); /*list<2798>*/
  return kk_std_core__list_box(_x20164, _ctx);
}

kk_std_core__list kk_std_core__trmc_lift17315_map_peek(kk_function_t f0, kk_std_core__list ys, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (value : a, rest : list<a>) -> e b, ys : list<a>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con20159 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con20159->head;
    kk_std_core__list yy0 = _con20159->tail;
    kk_reuse_t _ru_20021 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_20021 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_box_t x_18067;
    kk_function_t _x20161 = kk_function_dup(f0, _ctx); /*(value : 2797, rest : list<2797>) -> 2799 2798*/
    kk_std_core__list _x20160 = kk_std_core__list_dup(yy0, _ctx); /*list<2797>*/
    x_18067 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_std_core__list, kk_context_t*), _x20161, (_x20161, y, _x20160, _ctx), _ctx); /*2798*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_20021,kk_context());
      kk_box_drop(x_18067, _ctx);
      kk_box_t _x20162 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_lift17315_map_peek_fun20163(f0, yy0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20162, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_176760 = kk_datatype_null(); /*list<2798>*/;
      kk_std_core__list _trmc_176770 = kk_std_core__new_Cons(_ru_20021, kk_field_index_of(struct kk_std_core_Cons, tail), x_18067, _trmc_176760, _ctx); /*list<2798>*/;
      kk_box_t* _b_18520_18514 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_176770, _ctx)->tail)); /*field-addr<list<2798>>*/;
      { // tailcall
        kk_std_core_types__cctx _x20165 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_176770, _ctx)),_b_18520_18514,false,kk_context()); /*ctx<0>*/
        ys = yy0;
        _acc0 = _x20165;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(f0, _ctx);
    kk_box_t _x20166 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20166, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-peek, mappeek

kk_std_core__list kk_std_core__lift17315_map_peek(kk_function_t f1, kk_std_core__list ys0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (value : a, rest : list<a>) -> e b, ys : list<a>) -> e list<b> */ 
  kk_std_core_types__cctx _x20167 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17315_map_peek(f1, ys0, _x20167, _ctx);
}

kk_ref_t kk_std_core_trace_enabled;
 
// Compose two funs `f` and `g`.


// lift anonymous function
struct kk_std_core_o_fun20168__t {
  struct kk_function_s _base;
  kk_function_t f;
  kk_function_t g;
};
static kk_box_t kk_std_core_o_fun20168(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_o_fun20168(kk_function_t f, kk_function_t g, kk_context_t* _ctx) {
  struct kk_std_core_o_fun20168__t* _self = kk_function_alloc_as(struct kk_std_core_o_fun20168__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_o_fun20168, kk_context());
  _self->f = f;
  _self->g = g;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_o_fun20168(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_o_fun20168__t* _self = kk_function_as(struct kk_std_core_o_fun20168__t*, _fself, _ctx);
  kk_function_t f = _self->f; /* (2840) -> 2837 2838 */
  kk_function_t g = _self->g; /* (2836) -> 2837 2840 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_function_dup(g, _ctx);}, {}, _ctx)
  kk_box_t x0_18070 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), g, (g, x, _ctx), _ctx); /*2840*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x0_18070, _ctx);
    return kk_std_core_hnd_yield_extend(f, _ctx);
  }
  {
    return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x0_18070, _ctx), _ctx);
  }
}

kk_function_t kk_std_core_o(kk_function_t f, kk_function_t g, kk_context_t* _ctx) { /* forall<a,b,c,e> (f : (a) -> e b, g : (c) -> e a) -> ((x : c) -> e b) */ 
  return kk_std_core_new_o_fun20168(f, g, _ctx);
}
 
// monadic lift

kk_box_t kk_std_core__mlift17998_once(kk_function_t calc, kk_ref_t r, kk_std_core_types__maybe _y_17748, kk_context_t* _ctx) { /* forall<_h,_e,a> (calc : () -> a, r : ref<_h,maybe<a>>, maybe<a>) -> <read<_h>,write<_h>,div|_e> a */ 
  if (kk_std_core_types__is_Just(_y_17748, _ctx)) {
    kk_box_t x = _y_17748._cons.Just.value;
    kk_ref_drop(r, _ctx);
    kk_function_drop(calc, _ctx);
    return x;
  }
  {
    kk_box_t x0 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), calc, (calc, _ctx), _ctx); /*2961*/;
    kk_unit_t __ = kk_Unit;
    kk_unit_t _brw_20002 = kk_Unit;
    kk_box_t _x20170;
    kk_std_core_types__maybe _x20171;
    kk_box_t _x20172 = kk_box_dup(x0, _ctx); /*2961*/
    _x20171 = kk_std_core_types__new_Just(_x20172, _ctx); /*maybe<111>*/
    _x20170 = kk_std_core_types__maybe_box(_x20171, _ctx); /*176*/
    kk_ref_set_borrow(r,_x20170,kk_context());
    kk_ref_drop(r, _ctx);
    _brw_20002;
    return x0;
  }
}
 
// Given a total function to calculate a value `:a`, return
// a total function that only calculates the value once and then
// returns the cached result.


// lift anonymous function
struct kk_std_core_once_fun20173__t {
  struct kk_function_s _base;
  kk_function_t calc;
  kk_ref_t r;
};
static kk_box_t kk_std_core_once_fun20173(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_once_fun20173(kk_function_t calc, kk_ref_t r, kk_context_t* _ctx) {
  struct kk_std_core_once_fun20173__t* _self = kk_function_alloc_as(struct kk_std_core_once_fun20173__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_once_fun20173, kk_context());
  _self->calc = calc;
  _self->r = r;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_once_fun20176__t {
  struct kk_function_s _base;
  kk_function_t calc;
  kk_ref_t r;
};
static kk_box_t kk_std_core_once_fun20176(kk_function_t _fself, kk_std_core_types__maybe _y_17748, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_once_fun20176(kk_function_t calc, kk_ref_t r, kk_context_t* _ctx) {
  struct kk_std_core_once_fun20176__t* _self = kk_function_alloc_as(struct kk_std_core_once_fun20176__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_once_fun20176, kk_context());
  _self->calc = calc;
  _self->r = r;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_once_fun20176(kk_function_t _fself, kk_std_core_types__maybe _y_17748, kk_context_t* _ctx) {
  struct kk_std_core_once_fun20176__t* _self = kk_function_as(struct kk_std_core_once_fun20176__t*, _fself, _ctx);
  kk_function_t calc = _self->calc; /* () -> 2961 */
  kk_ref_t r = _self->r; /* ref<_2870,maybe<2961>> */
  kk_drop_match(_self, {kk_function_dup(calc, _ctx);kk_ref_dup(r, _ctx);}, {}, _ctx)
  if (kk_std_core_types__is_Just(_y_17748, _ctx)) {
    kk_box_t x0 = _y_17748._cons.Just.value;
    kk_ref_drop(r, _ctx);
    kk_function_drop(calc, _ctx);
    return x0;
  }
  {
    kk_box_t x00 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), calc, (calc, _ctx), _ctx); /*2961*/;
    kk_unit_t __ = kk_Unit;
    kk_unit_t _brw_20001 = kk_Unit;
    kk_box_t _x20177;
    kk_std_core_types__maybe _x20178;
    kk_box_t _x20179 = kk_box_dup(x00, _ctx); /*2961*/
    _x20178 = kk_std_core_types__new_Just(_x20179, _ctx); /*maybe<111>*/
    _x20177 = kk_std_core_types__maybe_box(_x20178, _ctx); /*176*/
    kk_ref_set_borrow(r,_x20177,kk_context());
    kk_ref_drop(r, _ctx);
    _brw_20001;
    return x00;
  }
}


// lift anonymous function
struct kk_std_core_once_fun20180__t {
  struct kk_function_s _base;
  kk_function_t next0_18075;
};
static kk_box_t kk_std_core_once_fun20180(kk_function_t _fself, kk_box_t _b_18543, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_once_fun20180(kk_function_t next0_18075, kk_context_t* _ctx) {
  struct kk_std_core_once_fun20180__t* _self = kk_function_alloc_as(struct kk_std_core_once_fun20180__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_once_fun20180, kk_context());
  _self->next0_18075 = next0_18075;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_once_fun20180(kk_function_t _fself, kk_box_t _b_18543, kk_context_t* _ctx) {
  struct kk_std_core_once_fun20180__t* _self = kk_function_as(struct kk_std_core_once_fun20180__t*, _fself, _ctx);
  kk_function_t next0_18075 = _self->next0_18075; /* (maybe<2961>) -> <read<_2870>,write<_2870>,div|_2953> 2961 */
  kk_drop_match(_self, {kk_function_dup(next0_18075, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _x20181 = kk_std_core_types__maybe_unbox(_b_18543, KK_OWNED, _ctx); /*maybe<2961>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__maybe, kk_context_t*), next0_18075, (next0_18075, _x20181, _ctx), _ctx);
}
static kk_box_t kk_std_core_once_fun20173(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_once_fun20173__t* _self = kk_function_as(struct kk_std_core_once_fun20173__t*, _fself, _ctx);
  kk_function_t calc = _self->calc; /* () -> 2961 */
  kk_ref_t r = _self->r; /* ref<_2870,maybe<2961>> */
  kk_drop_match(_self, {kk_function_dup(calc, _ctx);kk_ref_dup(r, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe x_18074;
  kk_box_t _x20174;
  kk_ref_t _x20175 = kk_ref_dup(r, _ctx); /*ref<_2870,maybe<2961>>*/
  _x20174 = kk_ref_get(_x20175,kk_context()); /*190*/
  x_18074 = kk_std_core_types__maybe_unbox(_x20174, KK_OWNED, _ctx); /*maybe<2961>*/
  kk_function_t next0_18075 = kk_std_core_new_once_fun20176(calc, r, _ctx); /*(maybe<2961>) -> <read<_2870>,write<_2870>,div|_2953> 2961*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__maybe_drop(x_18074, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_new_once_fun20180(next0_18075, _ctx), _ctx);
  }
  {
    return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__maybe, kk_context_t*), next0_18075, (next0_18075, x_18074, _ctx), _ctx);
  }
}

kk_function_t kk_std_core_once(kk_function_t calc, kk_context_t* _ctx) { /* forall<a> (calc : () -> a) -> (() -> a) */ 
  kk_ref_t r = kk_ref_alloc((kk_std_core_types__maybe_box(kk_std_core_types__new_Nothing(_ctx), _ctx)),kk_context()); /*ref<_2870,maybe<2961>>*/;
  return kk_std_core_new_once_fun20173(calc, r, _ctx);
}

kk_std_core_types__maybe kk_std_core_xparse_int(kk_string_t s, bool hex, kk_context_t* _ctx) { /* (s : string, hex : bool) -> maybe<int> */ 
  return kk_integer_xparse(s,hex,kk_context());
}
 
// Internal: used for value effects
// TODO: revisit value effects codegen

kk_box_t kk_std_core_phantom(kk_context_t* _ctx) { /* forall<a> () -> a */ 
  return kk_box_null();
}
 
// Convert a string to lower-case

kk_string_t kk_std_core_to_lower(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  return kk_string_to_lower(s,kk_context());
}

kk_unit_t kk_std_core_xtrace(kk_string_t message0, kk_context_t* _ctx) { /* (message : string) -> () */ 
  kk_trace(message0,kk_context()); return kk_Unit;
}

kk_unit_t kk_std_core_xtrace_any(kk_string_t message0, kk_box_t x, kk_context_t* _ctx) { /* forall<a> (message : string, x : a) -> () */ 
  kk_trace_any(message0,x,kk_context()); return kk_Unit;
}
 
// clamp an `:int` to fit in an `:int8` but interpret the `:int` as an unsigned 8-bit value,
// and clamp between 0 and 255.

int8_t kk_std_core_uint8(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int8 */ 
  return kk_integer_clamp_byte(i,kk_context());
}

kk_ref_t kk_std_core_unique_count;

kk_vector_t kk_std_core_unvlist(kk_std_core__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> vector<a> */ 
  return kk_list_to_vector(xs,kk_context());
}
 
// Create a new vector of length `n`  with initial elements given by function `f` .

kk_vector_t kk_std_core_vector_initz(kk_ssize_t n, kk_function_t f, kk_context_t* _ctx) { /* forall<a> (n : ssize_t, f : (ssize_t) -> a) -> vector<a> */ 
  return kk_vector_init(n,f,kk_context());
}

bool kk_std_core__lp__excl__eq__4_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_19998;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_19998 = kk_integer_from_small(-1); /*int*/
    goto _match20182;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_19998 = kk_integer_from_small(0); /*int*/
    goto _match20182;
  }
  {
    _brw_19998 = kk_integer_from_small(1); /*int*/
  }
  _match20182: ;
  kk_integer_t _brw_19997;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_19997 = kk_integer_from_small(-1); /*int*/
    goto _match20183;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_19997 = kk_integer_from_small(0); /*int*/
    goto _match20183;
  }
  {
    _brw_19997 = kk_integer_from_small(1); /*int*/
  }
  _match20183: ;
  bool _brw_19999 = kk_integer_neq_borrow(_brw_19998,_brw_19997,kk_context()); /*bool*/;
  kk_integer_drop(_brw_19998, _ctx);
  kk_integer_drop(_brw_19997, _ctx);
  return _brw_19999;
}
 
// Append two lists.

kk_std_core__list kk_std_core__trmc_append(kk_std_core__list xs, kk_std_core__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20185 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20185->head;
    kk_std_core__list xx = _con20185->tail;
    kk_reuse_t _ru_20022 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_20022 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core__list _trmc_17678 = kk_datatype_null(); /*list<3252>*/;
    kk_std_core__list _trmc_17679 = kk_std_core__new_Cons(_ru_20022, 0, x, _trmc_17678, _ctx); /*list<3252>*/;
    kk_box_t* _b_18557_18552 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17679, _ctx)->tail)); /*field-addr<list<3252>>*/;
    { // tailcall
      kk_std_core_types__cctx _x20186 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17679, _ctx)),_b_18557_18552,true,kk_context()); /*ctx<0>*/
      xs = xx;
      _acc = _x20186;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x20187 = kk_cctx_apply(_acc,(kk_std_core__list_box(ys, _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20187, KK_OWNED, _ctx);
  }
}
 
// Append two lists.

kk_std_core__list kk_std_core_append(kk_std_core__list xs0, kk_std_core__list ys0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x20188 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_append(xs0, ys0, _x20188, _ctx);
}
 
// Append two strings.

kk_string_t kk_std_core__lp__plus__plus__1_rp_(kk_string_t x, kk_string_t y, kk_context_t* _ctx) { /* (x : string, y : string) -> string */ 
  return kk_string_cat(x,y,kk_context());
}

kk_unit_t kk_std_core_printsln(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> console () */ 
  kk_std_core_types__maybe _match_19996;
  kk_box_t _x20190;
  kk_ref_t _x20191 = kk_ref_dup(kk_std_core_redirect, _ctx); /*ref<global,maybe<(string) -> console ()>>*/
  _x20190 = kk_ref_get(_x20191,kk_context()); /*190*/
  _match_19996 = kk_std_core_types__maybe_unbox(_x20190, KK_OWNED, _ctx); /*maybe<(string) -> console ()>*/
  if (kk_std_core_types__is_Nothing(_match_19996, _ctx)) {
    kk_std_core_xprintsln(s, _ctx); return kk_Unit;
  }
  {
    kk_box_t _fun_unbox_x18567 = _match_19996._cons.Just.value;
    kk_string_t _b_18570;
    kk_string_t _x20192;
    kk_define_string_literal(, _s20193, 1, "\n", _ctx)
    _x20192 = kk_string_dup(_s20193, _ctx); /*string*/
    _b_18570 = kk_std_core__lp__plus__plus__1_rp_(s, _x20192, _ctx); /*string*/
    kk_box_t _x20194;
    kk_function_t _x20195 = kk_function_unbox(_fun_unbox_x18567, _ctx); /*(18568) -> console 18569*/
    _x20194 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20195, (_x20195, kk_string_box(_b_18570), _ctx), _ctx); /*18569*/
    kk_unit_unbox(_x20194); return kk_Unit;
  }
}

bool kk_std_core__lp__eq__eq__4_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_19994;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_19994 = kk_integer_from_small(-1); /*int*/
    goto _match20196;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_19994 = kk_integer_from_small(0); /*int*/
    goto _match20196;
  }
  {
    _brw_19994 = kk_integer_from_small(1); /*int*/
  }
  _match20196: ;
  kk_integer_t _brw_19993;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_19993 = kk_integer_from_small(-1); /*int*/
    goto _match20197;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_19993 = kk_integer_from_small(0); /*int*/
    goto _match20197;
  }
  {
    _brw_19993 = kk_integer_from_small(1); /*int*/
  }
  _match20197: ;
  bool _brw_19995 = kk_integer_eq_borrow(_brw_19994,_brw_19993,kk_context()); /*bool*/;
  kk_integer_drop(_brw_19994, _ctx);
  kk_integer_drop(_brw_19993, _ctx);
  return _brw_19995;
}

bool kk_std_core__lp__lt__5_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_19991;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_19991 = kk_integer_from_small(-1); /*int*/
    goto _match20198;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_19991 = kk_integer_from_small(0); /*int*/
    goto _match20198;
  }
  {
    _brw_19991 = kk_integer_from_small(1); /*int*/
  }
  _match20198: ;
  kk_integer_t _brw_19990;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_19990 = kk_integer_from_small(-1); /*int*/
    goto _match20199;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_19990 = kk_integer_from_small(0); /*int*/
    goto _match20199;
  }
  {
    _brw_19990 = kk_integer_from_small(1); /*int*/
  }
  _match20199: ;
  bool _brw_19992 = kk_integer_lt_borrow(_brw_19991,_brw_19990,kk_context()); /*bool*/;
  kk_integer_drop(_brw_19991, _ctx);
  kk_integer_drop(_brw_19990, _ctx);
  return _brw_19992;
}

kk_std_core_types__order kk_std_core_order(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> order */ 
  bool _match_19987 = kk_integer_lt_borrow(i,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_19987) {
    kk_integer_drop(i, _ctx);
    return kk_std_core_types__new_Lt(_ctx);
  }
  {
    bool _match_19988;
    bool _brw_19989 = kk_integer_gt_borrow(i,(kk_integer_from_small(0)),kk_context()); /*bool*/;
    kk_integer_drop(i, _ctx);
    _match_19988 = _brw_19989; /*bool*/
    if (_match_19988) {
      return kk_std_core_types__new_Gt(_ctx);
    }
    {
      return kk_std_core_types__new_Eq(_ctx);
    }
  }
}
 
// Compare two strings.
// Uses the character codes directly for comparison

kk_std_core_types__order kk_std_core_compare_3(kk_string_t x, kk_string_t y, kk_context_t* _ctx) { /* (x : string, y : string) -> order */ 
  kk_integer_t i_17361 = kk_std_core_string_compare(x, y, _ctx); /*int*/;
  bool _match_19984 = kk_integer_lt_borrow(i_17361,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_19984) {
    kk_integer_drop(i_17361, _ctx);
    return kk_std_core_types__new_Lt(_ctx);
  }
  {
    bool _match_19985;
    bool _brw_19986 = kk_integer_gt_borrow(i_17361,(kk_integer_from_small(0)),kk_context()); /*bool*/;
    kk_integer_drop(i_17361, _ctx);
    _match_19985 = _brw_19986; /*bool*/
    if (_match_19985) {
      return kk_std_core_types__new_Gt(_ctx);
    }
    {
      return kk_std_core_types__new_Eq(_ctx);
    }
  }
}

bool kk_std_core__lp__gt__3_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_19980;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_19980 = kk_integer_from_small(-1); /*int*/
    goto _match20201;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_19980 = kk_integer_from_small(0); /*int*/
    goto _match20201;
  }
  {
    _brw_19980 = kk_integer_from_small(1); /*int*/
  }
  _match20201: ;
  kk_integer_t _brw_19979;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_19979 = kk_integer_from_small(-1); /*int*/
    goto _match20202;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_19979 = kk_integer_from_small(0); /*int*/
    goto _match20202;
  }
  {
    _brw_19979 = kk_integer_from_small(1); /*int*/
  }
  _match20202: ;
  bool _brw_19981 = kk_integer_gt_borrow(_brw_19980,_brw_19979,kk_context()); /*bool*/;
  kk_integer_drop(_brw_19980, _ctx);
  kk_integer_drop(_brw_19979, _ctx);
  return _brw_19981;
}

kk_std_core_types__order kk_std_core_compare_2(bool x, bool y, kk_context_t* _ctx) { /* (x : bool, y : bool) -> order */ 
  if (x) {
    if (x) {
      if (y) {
        return kk_std_core_types__new_Eq(_ctx);
      }
      {
        return kk_std_core_types__new_Gt(_ctx);
      }
    }
    {
      return kk_std_core_types__new_Eq(_ctx);
    }
  }
  if (y) {
    return kk_std_core_types__new_Lt(_ctx);
  }
  if (x) {
    if (y) {
      return kk_std_core_types__new_Eq(_ctx);
    }
    {
      return kk_std_core_types__new_Gt(_ctx);
    }
  }
  {
    return kk_std_core_types__new_Eq(_ctx);
  }
}

bool kk_std_core__lp__gt__eq__4_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_19973;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_19973 = kk_integer_from_small(-1); /*int*/
    goto _match20204;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_19973 = kk_integer_from_small(0); /*int*/
    goto _match20204;
  }
  {
    _brw_19973 = kk_integer_from_small(1); /*int*/
  }
  _match20204: ;
  kk_integer_t _brw_19972;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_19972 = kk_integer_from_small(-1); /*int*/
    goto _match20205;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_19972 = kk_integer_from_small(0); /*int*/
    goto _match20205;
  }
  {
    _brw_19972 = kk_integer_from_small(1); /*int*/
  }
  _match20205: ;
  bool _brw_19974 = kk_integer_gte_borrow(_brw_19973,_brw_19972,kk_context()); /*bool*/;
  kk_integer_drop(_brw_19973, _ctx);
  kk_integer_drop(_brw_19972, _ctx);
  return _brw_19974;
}
 
// lifted local: joinsep, join-acc

kk_string_t kk_std_core__lift17316_joinsep(kk_string_t sep, kk_std_core__list ys, kk_string_t acc, kk_context_t* _ctx) { /* (sep : string, ys : list<string>, acc : string) -> string */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con20207 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t _box_x18572 = _con20207->head;
    kk_std_core__list yy = _con20207->tail;
    kk_string_t y = kk_string_unbox(_box_x18572);
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_datatype_ptr_free(ys, _ctx);
    }
    else {
      kk_string_dup(y, _ctx);
      kk_std_core__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_string_t acc0_17390;
    kk_string_t _x20208;
    kk_string_t _x20209 = kk_string_dup(sep, _ctx); /*string*/
    _x20208 = kk_std_core__lp__plus__plus__1_rp_(_x20209, y, _ctx); /*string*/
    acc0_17390 = kk_std_core__lp__plus__plus__1_rp_(acc, _x20208, _ctx); /*string*/
    { // tailcall
      ys = yy;
      acc = acc0_17390;
      goto kk__tailcall;
    }
  }
  {
    kk_string_drop(sep, _ctx);
    return acc;
  }
}
 
// Concatenate all strings in a list

kk_string_t kk_std_core_joinsep(kk_std_core__list xs, kk_string_t sep, kk_context_t* _ctx) { /* (xs : list<string>, sep : string) -> string */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_string_drop(sep, _ctx);
    return kk_string_empty();
  }
  {
    struct kk_std_core_Cons* _con20211 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x18573 = _con20211->head;
    kk_std_core__list xx = _con20211->tail;
    kk_string_t x = kk_string_unbox(_box_x18573);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return kk_std_core__lift17316_joinsep(sep, xx, x, _ctx);
  }
}
 
// Concatenate all strings in a list

kk_string_t kk_std_core_join_2(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_Cons* _con20213 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x18574 = _con20213->head;
    kk_std_core__list xx = _con20213->tail;
    kk_string_t x = kk_string_unbox(_box_x18574);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_string_t _x20214 = kk_string_empty(); /*string*/
    return kk_std_core__lift17316_joinsep(_x20214, xx, x, _ctx);
  }
}
 
// Concatenate all strings in a list using a specific separator

kk_string_t kk_std_core_join_3(kk_std_core__list xs, kk_string_t sep, kk_context_t* _ctx) { /* (xs : list<string>, sep : string) -> string */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_string_drop(sep, _ctx);
    return kk_string_empty();
  }
  {
    struct kk_std_core_Cons* _con20217 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x18575 = _con20217->head;
    kk_std_core__list xx = _con20217->tail;
    kk_string_t x = kk_string_unbox(_box_x18575);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return kk_std_core__lift17316_joinsep(sep, xx, x, _ctx);
  }
}

bool kk_std_core__lp__lt__eq__5_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_19968;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_19968 = kk_integer_from_small(-1); /*int*/
    goto _match20218;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_19968 = kk_integer_from_small(0); /*int*/
    goto _match20218;
  }
  {
    _brw_19968 = kk_integer_from_small(1); /*int*/
  }
  _match20218: ;
  kk_integer_t _brw_19967;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_19967 = kk_integer_from_small(-1); /*int*/
    goto _match20219;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_19967 = kk_integer_from_small(0); /*int*/
    goto _match20219;
  }
  {
    _brw_19967 = kk_integer_from_small(1); /*int*/
  }
  _match20219: ;
  bool _brw_19969 = kk_integer_lte_borrow(_brw_19968,_brw_19967,kk_context()); /*bool*/;
  kk_integer_drop(_brw_19968, _ctx);
  kk_integer_drop(_brw_19967, _ctx);
  return _brw_19969;
}

kk_ssize_t kk_std_core_decr_1(kk_ssize_t i, kk_context_t* _ctx) { /* (i : ssize_t) -> ssize_t */ 
  return (i - 1);
}

kk_ssize_t kk_std_core_incr_1(kk_ssize_t i, kk_context_t* _ctx) { /* (i : ssize_t) -> ssize_t */ 
  return (i + 1);
}
 
// monadic lift

kk_unit_t kk_std_core__mlift17999_lift17317_forz(kk_function_t action, kk_ssize_t end, kk_ssize_t i, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<e> (action : (ssize_t) -> e (), end : ssize_t, i : ssize_t, wild_ : ()) -> e () */ 
  kk_ssize_t i0_17409 = kk_std_core_incr_1(i, _ctx); /*ssize_t*/;
  kk_std_core__lift17317_forz(action, end, i0_17409, _ctx); return kk_Unit;
}
 
// lifted local: forz, rep


// lift anonymous function
struct kk_std_core__lift17317_forz_fun20223__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_ssize_t end0;
  kk_ssize_t i0;
};
static kk_box_t kk_std_core__lift17317_forz_fun20223(kk_function_t _fself, kk_box_t _b_18577, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift17317_forz_fun20223(kk_function_t action0, kk_ssize_t end0, kk_ssize_t i0, kk_context_t* _ctx) {
  struct kk_std_core__lift17317_forz_fun20223__t* _self = kk_function_alloc_as(struct kk_std_core__lift17317_forz_fun20223__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift17317_forz_fun20223, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift17317_forz_fun20223(kk_function_t _fself, kk_box_t _b_18577, kk_context_t* _ctx) {
  struct kk_std_core__lift17317_forz_fun20223__t* _self = kk_function_as(struct kk_std_core__lift17317_forz_fun20223__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (ssize_t) -> 4452 () */
  kk_ssize_t end0 = _self->end0; /* ssize_t */
  kk_ssize_t i0 = _self->i0; /* ssize_t */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);;;}, {}, _ctx)
  kk_unit_t wild__0_18579 = kk_Unit;
  kk_unit_unbox(_b_18577);
  kk_unit_t _x20224 = kk_Unit;
  kk_std_core__mlift17999_lift17317_forz(action0, end0, i0, wild__0_18579, _ctx);
  return kk_unit_box(_x20224);
}

kk_unit_t kk_std_core__lift17317_forz(kk_function_t action0, kk_ssize_t end0, kk_ssize_t i0, kk_context_t* _ctx) { /* forall<e> (action : (ssize_t) -> e (), end : ssize_t, i : ssize_t) -> e () */ 
  kk__tailcall: ;
  bool _match_19963 = (i0 <= end0); /*bool*/;
  if (_match_19963) {
    kk_unit_t x_18079 = kk_Unit;
    kk_function_t _x20221 = kk_function_dup(action0, _ctx); /*(ssize_t) -> 4452 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_ssize_t, kk_context_t*), _x20221, (_x20221, i0, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x20222 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift17317_forz_fun20223(action0, end0, i0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x20222); return kk_Unit;
    }
    {
      kk_ssize_t i0_174090 = kk_std_core_incr_1(i0, _ctx); /*ssize_t*/;
      { // tailcall
        i0 = i0_174090;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}


// lift anonymous function
struct kk_std_core_foreach_indexedz_fun20226__t {
  struct kk_function_s _base;
  kk_function_t f;
  kk_vector_t v;
};
static kk_unit_t kk_std_core_foreach_indexedz_fun20226(kk_function_t _fself, kk_ssize_t i0, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_indexedz_fun20226(kk_function_t f, kk_vector_t v, kk_context_t* _ctx) {
  struct kk_std_core_foreach_indexedz_fun20226__t* _self = kk_function_alloc_as(struct kk_std_core_foreach_indexedz_fun20226__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_indexedz_fun20226, kk_context());
  _self->f = f;
  _self->v = v;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_unit_t kk_std_core_foreach_indexedz_fun20226(kk_function_t _fself, kk_ssize_t i0, kk_context_t* _ctx) {
  struct kk_std_core_foreach_indexedz_fun20226__t* _self = kk_function_as(struct kk_std_core_foreach_indexedz_fun20226__t*, _fself, _ctx);
  kk_function_t f = _self->f; /* (ssize_t, 4486) -> 4487 () */
  kk_vector_t v = _self->v; /* vector<4486> */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_vector_dup(v, _ctx);}, {}, _ctx)
  kk_box_t _x20227;
  kk_box_t _brw_19962 = kk_vector_at_borrow(v,i0,kk_context()); /*228*/;
  kk_vector_drop(v, _ctx);
  _x20227 = _brw_19962; /*228*/
  return kk_function_call(kk_unit_t, (kk_function_t, kk_ssize_t, kk_box_t, kk_context_t*), f, (f, i0, _x20227, _ctx), _ctx);
}

kk_unit_t kk_std_core_foreach_indexedz(kk_vector_t v, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e> (v : vector<a>, f : (ssize_t, a) -> e ()) -> e () */ 
  kk_ssize_t start0_17410 = (KK_IZ(0)); /*ssize_t*/;
  kk_ssize_t end_17411;
  kk_ssize_t _x20225 = kk_vector_len_borrow(v,kk_context()); /*ssize_t*/
  end_17411 = kk_std_core_decr_1(_x20225, _ctx); /*ssize_t*/
  kk_std_core__lift17317_forz(kk_std_core_new_foreach_indexedz_fun20226(f, v, _ctx), end_17411, start0_17410, _ctx); return kk_Unit;
}
 
// lifted local: length.1, len

kk_integer_t kk_std_core__lift17318_length_1(kk_std_core__list ys, kk_integer_t acc, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, acc : int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con20228 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t _pat0 = _con20228->head;
    kk_std_core__list yy = _con20228->tail;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_box_drop(_pat0, _ctx);
      kk_datatype_ptr_free(ys, _ctx);
    }
    else {
      kk_std_core__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    { // tailcall
      kk_integer_t _x20229 = kk_integer_add_small_const(acc, 1, _ctx); /*int*/
      ys = yy;
      acc = _x20229;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core__trmc_list(kk_integer_t lo, kk_integer_t hi, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int, hi : int, ctx<list<int>>) -> total list<int> */ 
  kk__tailcall: ;
  bool _match_19961 = kk_integer_lte_borrow(lo,hi,kk_context()); /*bool*/;
  if (_match_19961) {
    kk_std_core__list _trmc_17680 = kk_datatype_null(); /*list<int>*/;
    kk_std_core__list _trmc_17681;
    kk_box_t _x20231;
    kk_integer_t _x20232 = kk_integer_dup(lo, _ctx); /*int*/
    _x20231 = kk_integer_box(_x20232, _ctx); /*61*/
    _trmc_17681 = kk_std_core__new_Cons(kk_reuse_null, 0, _x20231, _trmc_17680, _ctx); /*list<int>*/
    kk_box_t* _b_18594_18589 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17681, _ctx)->tail)); /*field-addr<list<int>>*/;
    { // tailcall
      kk_integer_t _x20233 = kk_integer_add_small_const(lo, 1, _ctx); /*int*/
      kk_std_core_types__cctx _x20234 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17681, _ctx)),_b_18594_18589,true,kk_context()); /*ctx<0>*/
      lo = _x20233;
      _acc = _x20234;
      goto kk__tailcall;
    }
  }
  {
    kk_integer_drop(lo, _ctx);
    kk_integer_drop(hi, _ctx);
    kk_box_t _x20235 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20235, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core_list(kk_integer_t lo0, kk_integer_t hi0, kk_context_t* _ctx) { /* (lo : int, hi : int) -> total list<int> */ 
  kk_std_core_types__cctx _x20236 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list(lo0, hi0, _x20236, _ctx);
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core__trmc_list_1(kk_integer_t lo, kk_integer_t hi, kk_integer_t stride, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int, hi : int, stride : int, ctx<list<int>>) -> total list<int> */ 
  kk__tailcall: ;
  bool _match_19960 = kk_integer_lte_borrow(lo,hi,kk_context()); /*bool*/;
  if (_match_19960) {
    kk_std_core__list _trmc_17682 = kk_datatype_null(); /*list<int>*/;
    kk_std_core__list _trmc_17683;
    kk_box_t _x20237;
    kk_integer_t _x20238 = kk_integer_dup(lo, _ctx); /*int*/
    _x20237 = kk_integer_box(_x20238, _ctx); /*61*/
    _trmc_17683 = kk_std_core__new_Cons(kk_reuse_null, 0, _x20237, _trmc_17682, _ctx); /*list<int>*/
    kk_box_t* _b_18614_18609 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17683, _ctx)->tail)); /*field-addr<list<int>>*/;
    { // tailcall
      kk_integer_t _x20239;
      kk_integer_t _x20240 = kk_integer_dup(stride, _ctx); /*int*/
      _x20239 = kk_integer_add(lo,_x20240,kk_context()); /*int*/
      kk_std_core_types__cctx _x20241 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17683, _ctx)),_b_18614_18609,true,kk_context()); /*ctx<0>*/
      lo = _x20239;
      _acc = _x20241;
      goto kk__tailcall;
    }
  }
  {
    kk_integer_drop(stride, _ctx);
    kk_integer_drop(lo, _ctx);
    kk_integer_drop(hi, _ctx);
    kk_box_t _x20242 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20242, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core_list_1(kk_integer_t lo0, kk_integer_t hi0, kk_integer_t stride0, kk_context_t* _ctx) { /* (lo : int, hi : int, stride : int) -> total list<int> */ 
  kk_std_core_types__cctx _x20243 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list_1(lo0, hi0, stride0, _x20243, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18000_trmc_list_2(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t hi, kk_integer_t lo, kk_box_t _trmc_17684, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, f : (int) -> e a, hi : int, lo : int, a) -> e list<a> */ 
  kk_std_core__list _trmc_17685 = kk_datatype_null(); /*list<5040>*/;
  kk_std_core__list _trmc_17686 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_17684, _trmc_17685, _ctx); /*list<5040>*/;
  kk_box_t* _b_18628_18625 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17686, _ctx)->tail)); /*field-addr<list<5040>>*/;
  kk_integer_t _x20244 = kk_integer_add_small_const(lo, 1, _ctx); /*int*/
  kk_std_core_types__cctx _x20245 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17686, _ctx)),_b_18628_18625,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list_2(_x20244, hi, f, _x20245, _ctx);
}
 
// Applies a function `f` to list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.


// lift anonymous function
struct kk_std_core__trmc_list_fun20249__t_2 {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_integer_t hi0;
  kk_integer_t lo0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_list_fun20249_2(kk_function_t _fself, kk_box_t _b_18633, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_list_fun20249_2(kk_function_t f0, kk_integer_t hi0, kk_integer_t lo0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_list_fun20249__t_2* _self = kk_function_alloc_as(struct kk_std_core__trmc_list_fun20249__t_2, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_list_fun20249_2, kk_context());
  _self->f0 = f0;
  _self->hi0 = hi0;
  _self->lo0 = lo0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_list_fun20249_2(kk_function_t _fself, kk_box_t _b_18633, kk_context_t* _ctx) {
  struct kk_std_core__trmc_list_fun20249__t_2* _self = kk_function_as(struct kk_std_core__trmc_list_fun20249__t_2*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int) -> 5041 5040 */
  kk_integer_t hi0 = _self->hi0; /* int */
  kk_integer_t lo0 = _self->lo0; /* int */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<5040>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_integer_dup(hi0, _ctx);kk_integer_dup(lo0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_18651_176840 = _b_18633; /*5040*/;
  kk_std_core__list _x20250 = kk_std_core__mlift18000_trmc_list_2(_acc0, f0, hi0, lo0, _trmc_18651_176840, _ctx); /*list<5040>*/
  return kk_std_core__list_box(_x20250, _ctx);
}

kk_std_core__list kk_std_core__trmc_list_2(kk_integer_t lo0, kk_integer_t hi0, kk_function_t f0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, f : (int) -> e a, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  bool _match_19958 = kk_integer_lte_borrow(lo0,hi0,kk_context()); /*bool*/;
  if (_match_19958) {
    kk_box_t x_18082;
    kk_function_t _x20247 = kk_function_dup(f0, _ctx); /*(int) -> 5041 5040*/
    kk_integer_t _x20246 = kk_integer_dup(lo0, _ctx); /*int*/
    x_18082 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_context_t*), _x20247, (_x20247, _x20246, _ctx), _ctx); /*5040*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_18082, _ctx);
      kk_box_t _x20248 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_list_fun20249_2(f0, hi0, lo0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20248, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_176850 = kk_datatype_null(); /*list<5040>*/;
      kk_std_core__list _trmc_176860 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), x_18082, _trmc_176850, _ctx); /*list<5040>*/;
      kk_box_t* _b_18645_18639 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_176860, _ctx)->tail)); /*field-addr<list<5040>>*/;
      { // tailcall
        kk_integer_t _x20251 = kk_integer_add_small_const(lo0, 1, _ctx); /*int*/
        kk_std_core_types__cctx _x20252 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_176860, _ctx)),_b_18645_18639,false,kk_context()); /*ctx<0>*/
        lo0 = _x20251;
        _acc0 = _x20252;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(lo0, _ctx);
    kk_integer_drop(hi0, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x20253 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20253, KK_OWNED, _ctx);
  }
}
 
// Applies a function `f` to list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core_list_2(kk_integer_t lo1, kk_integer_t hi1, kk_function_t f1, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, f : (int) -> e a) -> e list<a> */ 
  kk_std_core_types__cctx _x20254 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list_2(lo1, hi1, f1, _x20254, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18001_trmc_list_3(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t hi, kk_integer_t lo, kk_integer_t stride, kk_box_t _trmc_17687, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, f : (int) -> e a, hi : int, lo : int, stride : int, a) -> e list<a> */ 
  kk_std_core__list _trmc_17688 = kk_datatype_null(); /*list<5131>*/;
  kk_std_core__list _trmc_17689 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_17687, _trmc_17688, _ctx); /*list<5131>*/;
  kk_box_t* _b_18660_18657 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17689, _ctx)->tail)); /*field-addr<list<5131>>*/;
  kk_integer_t _x20255;
  kk_integer_t _x20256 = kk_integer_dup(stride, _ctx); /*int*/
  _x20255 = kk_integer_add(lo,_x20256,kk_context()); /*int*/
  kk_std_core_types__cctx _x20257 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17689, _ctx)),_b_18660_18657,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list_3(_x20255, hi, stride, f, _x20257, _ctx);
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.


// lift anonymous function
struct kk_std_core__trmc_list_fun20261__t_3 {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_integer_t hi0;
  kk_integer_t lo0;
  kk_integer_t stride0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_list_fun20261_3(kk_function_t _fself, kk_box_t _b_18665, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_list_fun20261_3(kk_function_t f0, kk_integer_t hi0, kk_integer_t lo0, kk_integer_t stride0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_list_fun20261__t_3* _self = kk_function_alloc_as(struct kk_std_core__trmc_list_fun20261__t_3, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_list_fun20261_3, kk_context());
  _self->f0 = f0;
  _self->hi0 = hi0;
  _self->lo0 = lo0;
  _self->stride0 = stride0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_list_fun20261_3(kk_function_t _fself, kk_box_t _b_18665, kk_context_t* _ctx) {
  struct kk_std_core__trmc_list_fun20261__t_3* _self = kk_function_as(struct kk_std_core__trmc_list_fun20261__t_3*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int) -> 5132 5131 */
  kk_integer_t hi0 = _self->hi0; /* int */
  kk_integer_t lo0 = _self->lo0; /* int */
  kk_integer_t stride0 = _self->stride0; /* int */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<5131>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_integer_dup(hi0, _ctx);kk_integer_dup(lo0, _ctx);kk_integer_dup(stride0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_18683_176870 = _b_18665; /*5131*/;
  kk_std_core__list _x20262 = kk_std_core__mlift18001_trmc_list_3(_acc0, f0, hi0, lo0, stride0, _trmc_18683_176870, _ctx); /*list<5131>*/
  return kk_std_core__list_box(_x20262, _ctx);
}

kk_std_core__list kk_std_core__trmc_list_3(kk_integer_t lo0, kk_integer_t hi0, kk_integer_t stride0, kk_function_t f0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, stride : int, f : (int) -> e a, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  bool _match_19956 = kk_integer_lte_borrow(lo0,hi0,kk_context()); /*bool*/;
  if (_match_19956) {
    kk_box_t x_18085;
    kk_function_t _x20259 = kk_function_dup(f0, _ctx); /*(int) -> 5132 5131*/
    kk_integer_t _x20258 = kk_integer_dup(lo0, _ctx); /*int*/
    x_18085 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_context_t*), _x20259, (_x20259, _x20258, _ctx), _ctx); /*5131*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_18085, _ctx);
      kk_box_t _x20260 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_list_fun20261_3(f0, hi0, lo0, stride0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20260, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_176880 = kk_datatype_null(); /*list<5131>*/;
      kk_std_core__list _trmc_176890 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), x_18085, _trmc_176880, _ctx); /*list<5131>*/;
      kk_box_t* _b_18677_18671 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_176890, _ctx)->tail)); /*field-addr<list<5131>>*/;
      { // tailcall
        kk_integer_t _x20263;
        kk_integer_t _x20264 = kk_integer_dup(stride0, _ctx); /*int*/
        _x20263 = kk_integer_add(lo0,_x20264,kk_context()); /*int*/
        kk_std_core_types__cctx _x20265 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_176890, _ctx)),_b_18677_18671,false,kk_context()); /*ctx<0>*/
        lo0 = _x20263;
        _acc0 = _x20265;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(stride0, _ctx);
    kk_integer_drop(lo0, _ctx);
    kk_integer_drop(hi0, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x20266 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20266, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core_list_3(kk_integer_t lo1, kk_integer_t hi1, kk_integer_t stride1, kk_function_t f1, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, stride : int, f : (int) -> e a) -> e list<a> */ 
  kk_std_core_types__cctx _x20267 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list_3(lo1, hi1, stride1, f1, _x20267, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18002_trmc_map_5(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core__list xx, kk_box_t _trmc_17690, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e b, xx : list<a>, b) -> e list<b> */ 
  kk_std_core__list _trmc_17691 = kk_datatype_null(); /*list<6253>*/;
  kk_std_core__list _trmc_17692 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_17690, _trmc_17691, _ctx); /*list<6253>*/;
  kk_box_t* _b_18692_18689 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17692, _ctx)->tail)); /*field-addr<list<6253>>*/;
  kk_std_core_types__cctx _x20268 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17692, _ctx)),_b_18692_18689,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_map_5(xx, f, _x20268, _ctx);
}
 
// Apply a function `f`  to each element of the input list in sequence.


// lift anonymous function
struct kk_std_core__trmc_map_fun20272__t_5 {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_map_fun20272_5(kk_function_t _fself, kk_box_t _b_18697, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_map_fun20272_5(kk_function_t f0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_map_fun20272__t_5* _self = kk_function_alloc_as(struct kk_std_core__trmc_map_fun20272__t_5, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_map_fun20272_5, kk_context());
  _self->f0 = f0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_map_fun20272_5(kk_function_t _fself, kk_box_t _b_18697, kk_context_t* _ctx) {
  struct kk_std_core__trmc_map_fun20272__t_5* _self = kk_function_as(struct kk_std_core__trmc_map_fun20272__t_5*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (6252) -> 6254 6253 */
  kk_std_core__list xx0 = _self->xx0; /* list<6252> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<6253>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_18715_176900 = _b_18697; /*6253*/;
  kk_std_core__list _x20273 = kk_std_core__mlift18002_trmc_map_5(_acc0, f0, xx0, _trmc_18715_176900, _ctx); /*list<6253>*/
  return kk_std_core__list_box(_x20273, _ctx);
}

kk_std_core__list kk_std_core__trmc_map_5(kk_std_core__list xs, kk_function_t f0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e b, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20269 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20269->head;
    kk_std_core__list xx0 = _con20269->tail;
    kk_reuse_t _ru_20028 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_20028 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t x0_18088;
    kk_function_t _x20270 = kk_function_dup(f0, _ctx); /*(6252) -> 6254 6253*/
    x0_18088 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20270, (_x20270, x, _ctx), _ctx); /*6253*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_20028,kk_context());
      kk_box_drop(x0_18088, _ctx);
      kk_box_t _x20271 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_map_fun20272_5(f0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20271, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_176910 = kk_datatype_null(); /*list<6253>*/;
      kk_std_core__list _trmc_176920 = kk_std_core__new_Cons(_ru_20028, kk_field_index_of(struct kk_std_core_Cons, tail), x0_18088, _trmc_176910, _ctx); /*list<6253>*/;
      kk_box_t* _b_18709_18703 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_176920, _ctx)->tail)); /*field-addr<list<6253>>*/;
      { // tailcall
        kk_std_core_types__cctx _x20274 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_176920, _ctx)),_b_18709_18703,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x20274;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(f0, _ctx);
    kk_box_t _x20275 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20275, KK_OWNED, _ctx);
  }
}
 
// Apply a function `f`  to each element of the input list in sequence.

kk_std_core__list kk_std_core_map_5(kk_std_core__list xs0, kk_function_t f1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e b) -> e list<b> */ 
  kk_std_core_types__cctx _x20276 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_map_5(xs0, f1, _x20276, _ctx);
}
 
// Create a list of characters from `lo`  to `hi`  (inclusive).


// lift anonymous function
struct kk_std_core_list_fun20279__t_4 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_list_fun20279_4(kk_function_t _fself, kk_box_t _b_18718, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_list_fun20279_4(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_list_fun20279_4, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_list_fun20279_4(kk_function_t _fself, kk_box_t _b_18718, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_char_t _x20280;
  kk_integer_t _x20281 = kk_integer_unbox(_b_18718, _ctx); /*int*/
  _x20280 = kk_integer_clamp32(_x20281,kk_context()); /*char*/
  return kk_char_box(_x20280, _ctx);
}

kk_std_core__list kk_std_core_list_4(kk_char_t lo, kk_char_t hi, kk_context_t* _ctx) { /* (lo : char, hi : char) -> total list<char> */ 
  kk_std_core__list _b_18719_18716;
  kk_integer_t _x20277 = kk_integer_from_int(lo,kk_context()); /*int*/
  kk_integer_t _x20278 = kk_integer_from_int(hi,kk_context()); /*int*/
  _b_18719_18716 = kk_std_core_list(_x20277, _x20278, _ctx); /*list<int>*/
  return kk_std_core_map_5(_b_18719_18716, kk_std_core_new_list_fun20279_4(_ctx), _ctx);
}
 
// Convert a string to a list of characters

kk_std_core__list kk_std_core_list_6(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> total list<char> */ 
  return kk_string_to_list(s,kk_context());
}


// lift anonymous function
struct kk_std_core_map_fun20283__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_map_fun20283(kk_function_t _fself, kk_box_t _b_18722, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20283(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_map_fun20283, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_map_fun20283(kk_function_t _fself, kk_box_t _b_18722, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _y_18724_17768 = _b_18722; /*5433*/;
  kk_std_core_types__maybe _x20284 = kk_std_core_types__new_Just(_y_18724_17768, _ctx); /*maybe<111>*/
  return kk_std_core_types__maybe_box(_x20284, _ctx);
}

kk_std_core_types__maybe kk_std_core_map(kk_std_core_types__maybe m, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (m : maybe<a>, f : (a) -> e b) -> e maybe<b> */ 
  if (kk_std_core_types__is_Nothing(m, _ctx)) {
    kk_function_drop(f, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_box_t x = m._cons.Just.value;
    kk_box_t x0_18091 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx), _ctx); /*5433*/;
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18091, _ctx);
      kk_box_t _x20282 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20283(_ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x20282, KK_OWNED, _ctx);
    }
    {
      return kk_std_core_types__new_Just(x0_18091, _ctx);
    }
  }
}
 
// Map over the `Right` component of an `:either` type.


// lift anonymous function
struct kk_std_core_map_fun20286__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_map_fun20286_1(kk_function_t _fself, kk_box_t _b_18726, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20286_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_map_fun20286_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_map_fun20286_1(kk_function_t _fself, kk_box_t _b_18726, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _y_18728_17770 = _b_18726; /*5471*/;
  kk_std_core_types__either _x20287 = kk_std_core_types__new_Right(_y_18728_17770, _ctx); /*either<76,77>*/
  return kk_std_core_types__either_box(_x20287, _ctx);
}

kk_std_core_types__either kk_std_core_map_1(kk_std_core_types__either e, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,c,e> (e : either<a,b>, f : (b) -> e c) -> e either<a,c> */ 
  if (kk_std_core_types__is_Right(e, _ctx)) {
    kk_box_t x = e._cons.Right.right;
    kk_box_t x0_18095 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx), _ctx); /*5471*/;
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18095, _ctx);
      kk_box_t _x20285 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20286_1(_ctx), _ctx); /*3926*/
      return kk_std_core_types__either_unbox(_x20285, KK_OWNED, _ctx);
    }
    {
      return kk_std_core_types__new_Right(x0_18095, _ctx);
    }
  }
  {
    kk_box_t x00 = e._cons.Left.left;
    kk_function_drop(f, _ctx);
    return kk_std_core_types__new_Left(x00, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18006_map_fun20290__t_2 {
  struct kk_function_s _base;
  kk_box_t _y_17772;
};
static kk_box_t kk_std_core__mlift18006_map_fun20290_2(kk_function_t _fself, kk_box_t _b_18730, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18006_map_fun20290_2(kk_box_t _y_17772, kk_context_t* _ctx) {
  struct kk_std_core__mlift18006_map_fun20290__t_2* _self = kk_function_alloc_as(struct kk_std_core__mlift18006_map_fun20290__t_2, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18006_map_fun20290_2, kk_context());
  _self->_y_17772 = _y_17772;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18006_map_fun20290_2(kk_function_t _fself, kk_box_t _b_18730, kk_context_t* _ctx) {
  struct kk_std_core__mlift18006_map_fun20290__t_2* _self = kk_function_as(struct kk_std_core__mlift18006_map_fun20290__t_2*, _fself, _ctx);
  kk_box_t _y_17772 = _self->_y_17772; /* 5616 */
  kk_drop_match(_self, {kk_box_dup(_y_17772, _ctx);}, {}, _ctx)
  kk_box_t _y_18732_17773 = _b_18730; /*5616*/;
  kk_std_core_types__tuple2_ _x20291 = kk_std_core_types__new_dash__lp__comma__rp_(_y_17772, _y_18732_17773, _ctx); /*(6, 7)*/
  return kk_std_core_types__tuple2__box(_x20291, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core__mlift18006_map_2(kk_function_t f, kk_std_core_types__tuple2_ t, kk_box_t _y_17772, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e b, t : (a, a), b) -> e (b, b) */ 
  kk_box_t x_18099;
  kk_box_t _x20288;
  {
    kk_box_t _x0 = t.snd;
    kk_box_dup(_x0, _ctx);
    kk_std_core_types__tuple2__drop(t, _ctx);
    _x20288 = _x0; /*5615*/
  }
  x_18099 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x20288, _ctx), _ctx); /*5616*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18099, _ctx);
    kk_box_t _x20289 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18006_map_fun20290_2(_y_17772, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple2__unbox(_x20289, KK_OWNED, _ctx);
  }
  {
    return kk_std_core_types__new_dash__lp__comma__rp_(_y_17772, x_18099, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_map_fun20295__t_2 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple2_ t;
};
static kk_box_t kk_std_core_map_fun20295_2(kk_function_t _fself, kk_box_t _b_18734, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20295_2(kk_function_t f, kk_std_core_types__tuple2_ t, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20295__t_2* _self = kk_function_alloc_as(struct kk_std_core_map_fun20295__t_2, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20295_2, kk_context());
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20295_2(kk_function_t _fself, kk_box_t _b_18734, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20295__t_2* _self = kk_function_as(struct kk_std_core_map_fun20295__t_2*, _fself, _ctx);
  kk_function_t f = _self->f; /* (5615) -> 5617 5616 */
  kk_std_core_types__tuple2_ t = _self->t; /* (5615, 5615) */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple2__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_18739_17772 = _b_18734; /*5616*/;
  kk_std_core_types__tuple2_ _x20296 = kk_std_core__mlift18006_map_2(f, t, _y_18739_17772, _ctx); /*(5616, 5616)*/
  return kk_std_core_types__tuple2__box(_x20296, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun20299__t_2 {
  struct kk_function_s _base;
  kk_box_t x_18103;
};
static kk_box_t kk_std_core_map_fun20299_2(kk_function_t _fself, kk_box_t _b_18736, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20299_2(kk_box_t x_18103, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20299__t_2* _self = kk_function_alloc_as(struct kk_std_core_map_fun20299__t_2, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20299_2, kk_context());
  _self->x_18103 = x_18103;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20299_2(kk_function_t _fself, kk_box_t _b_18736, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20299__t_2* _self = kk_function_as(struct kk_std_core_map_fun20299__t_2*, _fself, _ctx);
  kk_box_t x_18103 = _self->x_18103; /* 5616 */
  kk_drop_match(_self, {kk_box_dup(x_18103, _ctx);}, {}, _ctx)
  kk_box_t _y_18740_17773 = _b_18736; /*5616*/;
  kk_std_core_types__tuple2_ _x20300 = kk_std_core_types__new_dash__lp__comma__rp_(x_18103, _y_18740_17773, _ctx); /*(6, 7)*/
  return kk_std_core_types__tuple2__box(_x20300, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core_map_2(kk_std_core_types__tuple2_ t, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (t : (a, a), f : (a) -> e b) -> e (b, b) */ 
  kk_box_t x_18103;
  kk_function_t _x20293 = kk_function_dup(f, _ctx); /*(5615) -> 5617 5616*/
  kk_box_t _x20292;
  {
    kk_box_t _x = t.fst;
    kk_box_dup(_x, _ctx);
    _x20292 = _x; /*5615*/
  }
  x_18103 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20293, (_x20293, _x20292, _ctx), _ctx); /*5616*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18103, _ctx);
    kk_box_t _x20294 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20295_2(f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple2__unbox(_x20294, KK_OWNED, _ctx);
  }
  {
    kk_box_t x0_18106;
    kk_box_t _x20297;
    {
      kk_box_t _x0 = t.snd;
      kk_box_dup(_x0, _ctx);
      kk_std_core_types__tuple2__drop(t, _ctx);
      _x20297 = _x0; /*5615*/
    }
    x0_18106 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x20297, _ctx), _ctx); /*5616*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18106, _ctx);
      kk_box_t _x20298 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20299_2(x_18103, _ctx), _ctx); /*3926*/
      return kk_std_core_types__tuple2__unbox(_x20298, KK_OWNED, _ctx);
    }
    {
      return kk_std_core_types__new_dash__lp__comma__rp_(x_18103, x0_18106, _ctx);
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18008_map_fun20303__t_3 {
  struct kk_function_s _base;
  kk_box_t _y_17774;
  kk_box_t _y_17775;
};
static kk_box_t kk_std_core__mlift18008_map_fun20303_3(kk_function_t _fself, kk_box_t _b_18742, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18008_map_fun20303_3(kk_box_t _y_17774, kk_box_t _y_17775, kk_context_t* _ctx) {
  struct kk_std_core__mlift18008_map_fun20303__t_3* _self = kk_function_alloc_as(struct kk_std_core__mlift18008_map_fun20303__t_3, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18008_map_fun20303_3, kk_context());
  _self->_y_17774 = _y_17774;
  _self->_y_17775 = _y_17775;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18008_map_fun20303_3(kk_function_t _fself, kk_box_t _b_18742, kk_context_t* _ctx) {
  struct kk_std_core__mlift18008_map_fun20303__t_3* _self = kk_function_as(struct kk_std_core__mlift18008_map_fun20303__t_3*, _fself, _ctx);
  kk_box_t _y_17774 = _self->_y_17774; /* 5834 */
  kk_box_t _y_17775 = _self->_y_17775; /* 5834 */
  kk_drop_match(_self, {kk_box_dup(_y_17774, _ctx);kk_box_dup(_y_17775, _ctx);}, {}, _ctx)
  kk_box_t _y_18744_17776 = _b_18742; /*5834*/;
  kk_std_core_types__tuple3_ _x20304 = kk_std_core_types__new_dash__lp__comma__comma__rp_(_y_17774, _y_17775, _y_18744_17776, _ctx); /*(13, 14, 15)*/
  return kk_std_core_types__tuple3__box(_x20304, _ctx);
}

kk_std_core_types__tuple3_ kk_std_core__mlift18008_map_3(kk_box_t _y_17774, kk_function_t f, kk_std_core_types__tuple3_ t, kk_box_t _y_17775, kk_context_t* _ctx) { /* forall<a,b,e> (b, f : (a) -> e b, t : (a, a, a), b) -> e (b, b, b) */ 
  kk_box_t x_18111;
  kk_box_t _x20301;
  {
    kk_box_t _x1 = t.thd;
    kk_box_dup(_x1, _ctx);
    kk_std_core_types__tuple3__drop(t, _ctx);
    _x20301 = _x1; /*5833*/
  }
  x_18111 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x20301, _ctx), _ctx); /*5834*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18111, _ctx);
    kk_box_t _x20302 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18008_map_fun20303_3(_y_17774, _y_17775, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple3__unbox(_x20302, KK_OWNED, _ctx);
  }
  {
    return kk_std_core_types__new_dash__lp__comma__comma__rp_(_y_17774, _y_17775, x_18111, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18009_map_fun20308__t_3 {
  struct kk_function_s _base;
  kk_box_t _y_17774;
  kk_function_t f;
  kk_std_core_types__tuple3_ t;
};
static kk_box_t kk_std_core__mlift18009_map_fun20308_3(kk_function_t _fself, kk_box_t _b_18746, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18009_map_fun20308_3(kk_box_t _y_17774, kk_function_t f, kk_std_core_types__tuple3_ t, kk_context_t* _ctx) {
  struct kk_std_core__mlift18009_map_fun20308__t_3* _self = kk_function_alloc_as(struct kk_std_core__mlift18009_map_fun20308__t_3, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18009_map_fun20308_3, kk_context());
  _self->_y_17774 = _y_17774;
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18009_map_fun20308_3(kk_function_t _fself, kk_box_t _b_18746, kk_context_t* _ctx) {
  struct kk_std_core__mlift18009_map_fun20308__t_3* _self = kk_function_as(struct kk_std_core__mlift18009_map_fun20308__t_3*, _fself, _ctx);
  kk_box_t _y_17774 = _self->_y_17774; /* 5834 */
  kk_function_t f = _self->f; /* (5833) -> 5835 5834 */
  kk_std_core_types__tuple3_ t = _self->t; /* (5833, 5833, 5833) */
  kk_drop_match(_self, {kk_box_dup(_y_17774, _ctx);kk_function_dup(f, _ctx);kk_std_core_types__tuple3__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_18748_17775 = _b_18746; /*5834*/;
  kk_std_core_types__tuple3_ _x20309 = kk_std_core__mlift18008_map_3(_y_17774, f, t, _y_18748_17775, _ctx); /*(5834, 5834, 5834)*/
  return kk_std_core_types__tuple3__box(_x20309, _ctx);
}

kk_std_core_types__tuple3_ kk_std_core__mlift18009_map_3(kk_function_t f, kk_std_core_types__tuple3_ t, kk_box_t _y_17774, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e b, t : (a, a, a), b) -> e (b, b, b) */ 
  kk_box_t x_18116;
  kk_function_t _x20306 = kk_function_dup(f, _ctx); /*(5833) -> 5835 5834*/
  kk_box_t _x20305;
  {
    kk_box_t _x0 = t.snd;
    kk_box_dup(_x0, _ctx);
    _x20305 = _x0; /*5833*/
  }
  x_18116 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20306, (_x20306, _x20305, _ctx), _ctx); /*5834*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18116, _ctx);
    kk_box_t _x20307 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18009_map_fun20308_3(_y_17774, f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple3__unbox(_x20307, KK_OWNED, _ctx);
  }
  {
    return kk_std_core__mlift18008_map_3(_y_17774, f, t, x_18116, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_map_fun20313__t_3 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple3_ t;
};
static kk_box_t kk_std_core_map_fun20313_3(kk_function_t _fself, kk_box_t _b_18750, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20313_3(kk_function_t f, kk_std_core_types__tuple3_ t, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20313__t_3* _self = kk_function_alloc_as(struct kk_std_core_map_fun20313__t_3, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20313_3, kk_context());
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20313_3(kk_function_t _fself, kk_box_t _b_18750, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20313__t_3* _self = kk_function_as(struct kk_std_core_map_fun20313__t_3*, _fself, _ctx);
  kk_function_t f = _self->f; /* (5833) -> 5835 5834 */
  kk_std_core_types__tuple3_ t = _self->t; /* (5833, 5833, 5833) */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple3__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_18758_17774 = _b_18750; /*5834*/;
  kk_std_core_types__tuple3_ _x20314 = kk_std_core__mlift18009_map_3(f, t, _y_18758_17774, _ctx); /*(5834, 5834, 5834)*/
  return kk_std_core_types__tuple3__box(_x20314, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun20318__t_3 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple3_ t;
  kk_box_t x_18118;
};
static kk_box_t kk_std_core_map_fun20318_3(kk_function_t _fself, kk_box_t _b_18752, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20318_3(kk_function_t f, kk_std_core_types__tuple3_ t, kk_box_t x_18118, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20318__t_3* _self = kk_function_alloc_as(struct kk_std_core_map_fun20318__t_3, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20318_3, kk_context());
  _self->f = f;
  _self->t = t;
  _self->x_18118 = x_18118;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20318_3(kk_function_t _fself, kk_box_t _b_18752, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20318__t_3* _self = kk_function_as(struct kk_std_core_map_fun20318__t_3*, _fself, _ctx);
  kk_function_t f = _self->f; /* (5833) -> 5835 5834 */
  kk_std_core_types__tuple3_ t = _self->t; /* (5833, 5833, 5833) */
  kk_box_t x_18118 = _self->x_18118; /* 5834 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple3__dup(t, _ctx);kk_box_dup(x_18118, _ctx);}, {}, _ctx)
  kk_box_t _y_18759_17775 = _b_18752; /*5834*/;
  kk_std_core_types__tuple3_ _x20319 = kk_std_core__mlift18008_map_3(x_18118, f, t, _y_18759_17775, _ctx); /*(5834, 5834, 5834)*/
  return kk_std_core_types__tuple3__box(_x20319, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun20322__t_3 {
  struct kk_function_s _base;
  kk_box_t x_18118;
  kk_box_t x0_18121;
};
static kk_box_t kk_std_core_map_fun20322_3(kk_function_t _fself, kk_box_t _b_18754, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20322_3(kk_box_t x_18118, kk_box_t x0_18121, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20322__t_3* _self = kk_function_alloc_as(struct kk_std_core_map_fun20322__t_3, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20322_3, kk_context());
  _self->x_18118 = x_18118;
  _self->x0_18121 = x0_18121;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20322_3(kk_function_t _fself, kk_box_t _b_18754, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20322__t_3* _self = kk_function_as(struct kk_std_core_map_fun20322__t_3*, _fself, _ctx);
  kk_box_t x_18118 = _self->x_18118; /* 5834 */
  kk_box_t x0_18121 = _self->x0_18121; /* 5834 */
  kk_drop_match(_self, {kk_box_dup(x_18118, _ctx);kk_box_dup(x0_18121, _ctx);}, {}, _ctx)
  kk_box_t _y_18760_17776 = _b_18754; /*5834*/;
  kk_std_core_types__tuple3_ _x20323 = kk_std_core_types__new_dash__lp__comma__comma__rp_(x_18118, x0_18121, _y_18760_17776, _ctx); /*(13, 14, 15)*/
  return kk_std_core_types__tuple3__box(_x20323, _ctx);
}

kk_std_core_types__tuple3_ kk_std_core_map_3(kk_std_core_types__tuple3_ t, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (t : (a, a, a), f : (a) -> e b) -> e (b, b, b) */ 
  kk_box_t x_18118;
  kk_function_t _x20311 = kk_function_dup(f, _ctx); /*(5833) -> 5835 5834*/
  kk_box_t _x20310;
  {
    kk_box_t _x = t.fst;
    kk_box_dup(_x, _ctx);
    _x20310 = _x; /*5833*/
  }
  x_18118 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20311, (_x20311, _x20310, _ctx), _ctx); /*5834*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18118, _ctx);
    kk_box_t _x20312 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20313_3(f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple3__unbox(_x20312, KK_OWNED, _ctx);
  }
  {
    kk_box_t x0_18121;
    kk_function_t _x20316 = kk_function_dup(f, _ctx); /*(5833) -> 5835 5834*/
    kk_box_t _x20315;
    {
      kk_box_t _x0 = t.snd;
      kk_box_dup(_x0, _ctx);
      _x20315 = _x0; /*5833*/
    }
    x0_18121 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20316, (_x20316, _x20315, _ctx), _ctx); /*5834*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18121, _ctx);
      kk_box_t _x20317 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20318_3(f, t, x_18118, _ctx), _ctx); /*3926*/
      return kk_std_core_types__tuple3__unbox(_x20317, KK_OWNED, _ctx);
    }
    {
      kk_box_t x1_18124;
      kk_box_t _x20320;
      {
        kk_box_t _x1 = t.thd;
        kk_box_dup(_x1, _ctx);
        kk_std_core_types__tuple3__drop(t, _ctx);
        _x20320 = _x1; /*5833*/
      }
      x1_18124 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x20320, _ctx), _ctx); /*5834*/
      if (kk_yielding(kk_context())) {
        kk_box_drop(x1_18124, _ctx);
        kk_box_t _x20321 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20322_3(x_18118, x0_18121, _ctx), _ctx); /*3926*/
        return kk_std_core_types__tuple3__unbox(_x20321, KK_OWNED, _ctx);
      }
      {
        return kk_std_core_types__new_dash__lp__comma__comma__rp_(x_18118, x0_18121, x1_18124, _ctx);
      }
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18011_map_fun20327__t_4 {
  struct kk_function_s _base;
  kk_box_t _y_17777;
  kk_box_t _y_17778;
  kk_box_t _y_17779;
};
static kk_box_t kk_std_core__mlift18011_map_fun20327_4(kk_function_t _fself, kk_box_t _b_18762, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18011_map_fun20327_4(kk_box_t _y_17777, kk_box_t _y_17778, kk_box_t _y_17779, kk_context_t* _ctx) {
  struct kk_std_core__mlift18011_map_fun20327__t_4* _self = kk_function_alloc_as(struct kk_std_core__mlift18011_map_fun20327__t_4, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18011_map_fun20327_4, kk_context());
  _self->_y_17777 = _y_17777;
  _self->_y_17778 = _y_17778;
  _self->_y_17779 = _y_17779;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18011_map_fun20327_4(kk_function_t _fself, kk_box_t _b_18762, kk_context_t* _ctx) {
  struct kk_std_core__mlift18011_map_fun20327__t_4* _self = kk_function_as(struct kk_std_core__mlift18011_map_fun20327__t_4*, _fself, _ctx);
  kk_box_t _y_17777 = _self->_y_17777; /* 6121 */
  kk_box_t _y_17778 = _self->_y_17778; /* 6121 */
  kk_box_t _y_17779 = _self->_y_17779; /* 6121 */
  kk_drop_match(_self, {kk_box_dup(_y_17777, _ctx);kk_box_dup(_y_17778, _ctx);kk_box_dup(_y_17779, _ctx);}, {}, _ctx)
  kk_box_t _y_18764_17780 = _b_18762; /*6121*/;
  kk_std_core_types__tuple4_ _x20328 = kk_std_core_types__new_dash__lp__comma__comma__comma__rp_(kk_reuse_null, 0, _y_17777, _y_17778, _y_17779, _y_18764_17780, _ctx); /*(22, 23, 24, 25)*/
  return kk_std_core_types__tuple4__box(_x20328, _ctx);
}

kk_std_core_types__tuple4_ kk_std_core__mlift18011_map_4(kk_box_t _y_17777, kk_box_t _y_17778, kk_function_t f, kk_std_core_types__tuple4_ t, kk_box_t _y_17779, kk_context_t* _ctx) { /* forall<a,b,e> (b, b, f : (a) -> e b, t : (a, a, a, a), b) -> e (b, b, b, b) */ 
  kk_box_t x_18130;
  kk_box_t _x20324;
  {
    struct kk_std_core_types__Tuple4_* _con20325 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
    kk_box_t _pat02 = _con20325->fst;
    kk_box_t _pat12 = _con20325->snd;
    kk_box_t _pat22 = _con20325->thd;
    kk_box_t _x2 = _con20325->field4;
    if kk_likely(kk_datatype_ptr_is_unique(t, _ctx)) {
      kk_box_drop(_pat22, _ctx);
      kk_box_drop(_pat12, _ctx);
      kk_box_drop(_pat02, _ctx);
      kk_datatype_ptr_free(t, _ctx);
    }
    else {
      kk_box_dup(_x2, _ctx);
      kk_datatype_ptr_decref(t, _ctx);
    }
    _x20324 = _x2; /*6120*/
  }
  x_18130 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x20324, _ctx), _ctx); /*6121*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18130, _ctx);
    kk_box_t _x20326 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18011_map_fun20327_4(_y_17777, _y_17778, _y_17779, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple4__unbox(_x20326, KK_OWNED, _ctx);
  }
  {
    return kk_std_core_types__new_dash__lp__comma__comma__comma__rp_(kk_reuse_null, 0, _y_17777, _y_17778, _y_17779, x_18130, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18012_map_fun20333__t_4 {
  struct kk_function_s _base;
  kk_box_t _y_17777;
  kk_box_t _y_17778;
  kk_function_t f;
  kk_std_core_types__tuple4_ t;
};
static kk_box_t kk_std_core__mlift18012_map_fun20333_4(kk_function_t _fself, kk_box_t _b_18766, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18012_map_fun20333_4(kk_box_t _y_17777, kk_box_t _y_17778, kk_function_t f, kk_std_core_types__tuple4_ t, kk_context_t* _ctx) {
  struct kk_std_core__mlift18012_map_fun20333__t_4* _self = kk_function_alloc_as(struct kk_std_core__mlift18012_map_fun20333__t_4, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18012_map_fun20333_4, kk_context());
  _self->_y_17777 = _y_17777;
  _self->_y_17778 = _y_17778;
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18012_map_fun20333_4(kk_function_t _fself, kk_box_t _b_18766, kk_context_t* _ctx) {
  struct kk_std_core__mlift18012_map_fun20333__t_4* _self = kk_function_as(struct kk_std_core__mlift18012_map_fun20333__t_4*, _fself, _ctx);
  kk_box_t _y_17777 = _self->_y_17777; /* 6121 */
  kk_box_t _y_17778 = _self->_y_17778; /* 6121 */
  kk_function_t f = _self->f; /* (6120) -> 6122 6121 */
  kk_std_core_types__tuple4_ t = _self->t; /* (6120, 6120, 6120, 6120) */
  kk_drop_match(_self, {kk_box_dup(_y_17777, _ctx);kk_box_dup(_y_17778, _ctx);kk_function_dup(f, _ctx);kk_std_core_types__tuple4__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_18768_17779 = _b_18766; /*6121*/;
  kk_std_core_types__tuple4_ _x20334 = kk_std_core__mlift18011_map_4(_y_17777, _y_17778, f, t, _y_18768_17779, _ctx); /*(6121, 6121, 6121, 6121)*/
  return kk_std_core_types__tuple4__box(_x20334, _ctx);
}

kk_std_core_types__tuple4_ kk_std_core__mlift18012_map_4(kk_box_t _y_17777, kk_function_t f, kk_std_core_types__tuple4_ t, kk_box_t _y_17778, kk_context_t* _ctx) { /* forall<a,b,e> (b, f : (a) -> e b, t : (a, a, a, a), b) -> e (b, b, b, b) */ 
  kk_box_t x_18136;
  kk_function_t _x20331 = kk_function_dup(f, _ctx); /*(6120) -> 6122 6121*/
  kk_box_t _x20329;
  {
    struct kk_std_core_types__Tuple4_* _con20330 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
    kk_box_t _x1 = _con20330->thd;
    kk_box_dup(_x1, _ctx);
    _x20329 = _x1; /*6120*/
  }
  x_18136 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20331, (_x20331, _x20329, _ctx), _ctx); /*6121*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18136, _ctx);
    kk_box_t _x20332 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18012_map_fun20333_4(_y_17777, _y_17778, f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple4__unbox(_x20332, KK_OWNED, _ctx);
  }
  {
    return kk_std_core__mlift18011_map_4(_y_17777, _y_17778, f, t, x_18136, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18013_map_fun20339__t_4 {
  struct kk_function_s _base;
  kk_box_t _y_17777;
  kk_function_t f;
  kk_std_core_types__tuple4_ t;
};
static kk_box_t kk_std_core__mlift18013_map_fun20339_4(kk_function_t _fself, kk_box_t _b_18770, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18013_map_fun20339_4(kk_box_t _y_17777, kk_function_t f, kk_std_core_types__tuple4_ t, kk_context_t* _ctx) {
  struct kk_std_core__mlift18013_map_fun20339__t_4* _self = kk_function_alloc_as(struct kk_std_core__mlift18013_map_fun20339__t_4, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18013_map_fun20339_4, kk_context());
  _self->_y_17777 = _y_17777;
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18013_map_fun20339_4(kk_function_t _fself, kk_box_t _b_18770, kk_context_t* _ctx) {
  struct kk_std_core__mlift18013_map_fun20339__t_4* _self = kk_function_as(struct kk_std_core__mlift18013_map_fun20339__t_4*, _fself, _ctx);
  kk_box_t _y_17777 = _self->_y_17777; /* 6121 */
  kk_function_t f = _self->f; /* (6120) -> 6122 6121 */
  kk_std_core_types__tuple4_ t = _self->t; /* (6120, 6120, 6120, 6120) */
  kk_drop_match(_self, {kk_box_dup(_y_17777, _ctx);kk_function_dup(f, _ctx);kk_std_core_types__tuple4__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_18772_17778 = _b_18770; /*6121*/;
  kk_std_core_types__tuple4_ _x20340 = kk_std_core__mlift18012_map_4(_y_17777, f, t, _y_18772_17778, _ctx); /*(6121, 6121, 6121, 6121)*/
  return kk_std_core_types__tuple4__box(_x20340, _ctx);
}

kk_std_core_types__tuple4_ kk_std_core__mlift18013_map_4(kk_function_t f, kk_std_core_types__tuple4_ t, kk_box_t _y_17777, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e b, t : (a, a, a, a), b) -> e (b, b, b, b) */ 
  kk_box_t x_18138;
  kk_function_t _x20337 = kk_function_dup(f, _ctx); /*(6120) -> 6122 6121*/
  kk_box_t _x20335;
  {
    struct kk_std_core_types__Tuple4_* _con20336 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
    kk_box_t _x0 = _con20336->snd;
    kk_box_dup(_x0, _ctx);
    _x20335 = _x0; /*6120*/
  }
  x_18138 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20337, (_x20337, _x20335, _ctx), _ctx); /*6121*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18138, _ctx);
    kk_box_t _x20338 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18013_map_fun20339_4(_y_17777, f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple4__unbox(_x20338, KK_OWNED, _ctx);
  }
  {
    return kk_std_core__mlift18012_map_4(_y_17777, f, t, x_18138, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_map_fun20345__t_4 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple4_ t;
};
static kk_box_t kk_std_core_map_fun20345_4(kk_function_t _fself, kk_box_t _b_18774, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20345_4(kk_function_t f, kk_std_core_types__tuple4_ t, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20345__t_4* _self = kk_function_alloc_as(struct kk_std_core_map_fun20345__t_4, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20345_4, kk_context());
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20345_4(kk_function_t _fself, kk_box_t _b_18774, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20345__t_4* _self = kk_function_as(struct kk_std_core_map_fun20345__t_4*, _fself, _ctx);
  kk_function_t f = _self->f; /* (6120) -> 6122 6121 */
  kk_std_core_types__tuple4_ t = _self->t; /* (6120, 6120, 6120, 6120) */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple4__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_18785_17777 = _b_18774; /*6121*/;
  kk_std_core_types__tuple4_ _x20346 = kk_std_core__mlift18013_map_4(f, t, _y_18785_17777, _ctx); /*(6121, 6121, 6121, 6121)*/
  return kk_std_core_types__tuple4__box(_x20346, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun20351__t_4 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple4_ t;
  kk_box_t x_18140;
};
static kk_box_t kk_std_core_map_fun20351_4(kk_function_t _fself, kk_box_t _b_18776, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20351_4(kk_function_t f, kk_std_core_types__tuple4_ t, kk_box_t x_18140, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20351__t_4* _self = kk_function_alloc_as(struct kk_std_core_map_fun20351__t_4, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20351_4, kk_context());
  _self->f = f;
  _self->t = t;
  _self->x_18140 = x_18140;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20351_4(kk_function_t _fself, kk_box_t _b_18776, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20351__t_4* _self = kk_function_as(struct kk_std_core_map_fun20351__t_4*, _fself, _ctx);
  kk_function_t f = _self->f; /* (6120) -> 6122 6121 */
  kk_std_core_types__tuple4_ t = _self->t; /* (6120, 6120, 6120, 6120) */
  kk_box_t x_18140 = _self->x_18140; /* 6121 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple4__dup(t, _ctx);kk_box_dup(x_18140, _ctx);}, {}, _ctx)
  kk_box_t _y_18786_17778 = _b_18776; /*6121*/;
  kk_std_core_types__tuple4_ _x20352 = kk_std_core__mlift18012_map_4(x_18140, f, t, _y_18786_17778, _ctx); /*(6121, 6121, 6121, 6121)*/
  return kk_std_core_types__tuple4__box(_x20352, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun20357__t_4 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple4_ t;
  kk_box_t x_18140;
  kk_box_t x0_18143;
};
static kk_box_t kk_std_core_map_fun20357_4(kk_function_t _fself, kk_box_t _b_18778, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20357_4(kk_function_t f, kk_std_core_types__tuple4_ t, kk_box_t x_18140, kk_box_t x0_18143, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20357__t_4* _self = kk_function_alloc_as(struct kk_std_core_map_fun20357__t_4, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20357_4, kk_context());
  _self->f = f;
  _self->t = t;
  _self->x_18140 = x_18140;
  _self->x0_18143 = x0_18143;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20357_4(kk_function_t _fself, kk_box_t _b_18778, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20357__t_4* _self = kk_function_as(struct kk_std_core_map_fun20357__t_4*, _fself, _ctx);
  kk_function_t f = _self->f; /* (6120) -> 6122 6121 */
  kk_std_core_types__tuple4_ t = _self->t; /* (6120, 6120, 6120, 6120) */
  kk_box_t x_18140 = _self->x_18140; /* 6121 */
  kk_box_t x0_18143 = _self->x0_18143; /* 6121 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple4__dup(t, _ctx);kk_box_dup(x_18140, _ctx);kk_box_dup(x0_18143, _ctx);}, {}, _ctx)
  kk_box_t _y_18787_17779 = _b_18778; /*6121*/;
  kk_std_core_types__tuple4_ _x20358 = kk_std_core__mlift18011_map_4(x_18140, x0_18143, f, t, _y_18787_17779, _ctx); /*(6121, 6121, 6121, 6121)*/
  return kk_std_core_types__tuple4__box(_x20358, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun20362__t_4 {
  struct kk_function_s _base;
  kk_box_t x_18140;
  kk_box_t x0_18143;
  kk_box_t x1_18146;
};
static kk_box_t kk_std_core_map_fun20362_4(kk_function_t _fself, kk_box_t _b_18780, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20362_4(kk_box_t x_18140, kk_box_t x0_18143, kk_box_t x1_18146, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20362__t_4* _self = kk_function_alloc_as(struct kk_std_core_map_fun20362__t_4, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20362_4, kk_context());
  _self->x_18140 = x_18140;
  _self->x0_18143 = x0_18143;
  _self->x1_18146 = x1_18146;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20362_4(kk_function_t _fself, kk_box_t _b_18780, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20362__t_4* _self = kk_function_as(struct kk_std_core_map_fun20362__t_4*, _fself, _ctx);
  kk_box_t x_18140 = _self->x_18140; /* 6121 */
  kk_box_t x0_18143 = _self->x0_18143; /* 6121 */
  kk_box_t x1_18146 = _self->x1_18146; /* 6121 */
  kk_drop_match(_self, {kk_box_dup(x_18140, _ctx);kk_box_dup(x0_18143, _ctx);kk_box_dup(x1_18146, _ctx);}, {}, _ctx)
  kk_box_t _y_18788_17780 = _b_18780; /*6121*/;
  kk_std_core_types__tuple4_ _x20363 = kk_std_core_types__new_dash__lp__comma__comma__comma__rp_(kk_reuse_null, 0, x_18140, x0_18143, x1_18146, _y_18788_17780, _ctx); /*(22, 23, 24, 25)*/
  return kk_std_core_types__tuple4__box(_x20363, _ctx);
}

kk_std_core_types__tuple4_ kk_std_core_map_4(kk_std_core_types__tuple4_ t, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (t : (a, a, a, a), f : (a) -> e b) -> e (b, b, b, b) */ 
  kk_box_t x_18140;
  kk_function_t _x20343 = kk_function_dup(f, _ctx); /*(6120) -> 6122 6121*/
  kk_box_t _x20341;
  {
    struct kk_std_core_types__Tuple4_* _con20342 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
    kk_box_t _x = _con20342->fst;
    kk_box_dup(_x, _ctx);
    _x20341 = _x; /*6120*/
  }
  x_18140 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20343, (_x20343, _x20341, _ctx), _ctx); /*6121*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18140, _ctx);
    kk_box_t _x20344 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20345_4(f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple4__unbox(_x20344, KK_OWNED, _ctx);
  }
  {
    kk_box_t x0_18143;
    kk_function_t _x20349 = kk_function_dup(f, _ctx); /*(6120) -> 6122 6121*/
    kk_box_t _x20347;
    {
      struct kk_std_core_types__Tuple4_* _con20348 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
      kk_box_t _x0 = _con20348->snd;
      kk_box_dup(_x0, _ctx);
      _x20347 = _x0; /*6120*/
    }
    x0_18143 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20349, (_x20349, _x20347, _ctx), _ctx); /*6121*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18143, _ctx);
      kk_box_t _x20350 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20351_4(f, t, x_18140, _ctx), _ctx); /*3926*/
      return kk_std_core_types__tuple4__unbox(_x20350, KK_OWNED, _ctx);
    }
    {
      kk_box_t x1_18146;
      kk_function_t _x20355 = kk_function_dup(f, _ctx); /*(6120) -> 6122 6121*/
      kk_box_t _x20353;
      {
        struct kk_std_core_types__Tuple4_* _con20354 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
        kk_box_t _x1 = _con20354->thd;
        kk_box_dup(_x1, _ctx);
        _x20353 = _x1; /*6120*/
      }
      x1_18146 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20355, (_x20355, _x20353, _ctx), _ctx); /*6121*/
      if (kk_yielding(kk_context())) {
        kk_box_drop(x1_18146, _ctx);
        kk_box_t _x20356 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20357_4(f, t, x_18140, x0_18143, _ctx), _ctx); /*3926*/
        return kk_std_core_types__tuple4__unbox(_x20356, KK_OWNED, _ctx);
      }
      {
        kk_box_t x2_18149;
        kk_box_t _x20359;
        {
          struct kk_std_core_types__Tuple4_* _con20360 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
          kk_box_t _pat020 = _con20360->fst;
          kk_box_t _pat12 = _con20360->snd;
          kk_box_t _pat22 = _con20360->thd;
          kk_box_t _x2 = _con20360->field4;
          if kk_likely(kk_datatype_ptr_is_unique(t, _ctx)) {
            kk_box_drop(_pat22, _ctx);
            kk_box_drop(_pat12, _ctx);
            kk_box_drop(_pat020, _ctx);
            kk_datatype_ptr_free(t, _ctx);
          }
          else {
            kk_box_dup(_x2, _ctx);
            kk_datatype_ptr_decref(t, _ctx);
          }
          _x20359 = _x2; /*6120*/
        }
        x2_18149 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x20359, _ctx), _ctx); /*6121*/
        if (kk_yielding(kk_context())) {
          kk_box_drop(x2_18149, _ctx);
          kk_box_t _x20361 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20362_4(x_18140, x0_18143, x1_18146, _ctx), _ctx); /*3926*/
          return kk_std_core_types__tuple4__unbox(_x20361, KK_OWNED, _ctx);
        }
        {
          return kk_std_core_types__new_dash__lp__comma__comma__comma__rp_(kk_reuse_null, 0, x_18140, x0_18143, x1_18146, x2_18149, _ctx);
        }
      }
    }
  }
}
 
// Apply a function `f` to each character in a string


// lift anonymous function
struct kk_std_core_map_fun20364__t_6 {
  struct kk_function_s _base;
  kk_function_t f;
};
static kk_box_t kk_std_core_map_fun20364_6(kk_function_t _fself, kk_box_t _b_18791, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20364_6(kk_function_t f, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20364__t_6* _self = kk_function_alloc_as(struct kk_std_core_map_fun20364__t_6, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20364_6, kk_context());
  _self->f = f;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20364_6(kk_function_t _fself, kk_box_t _b_18791, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20364__t_6* _self = kk_function_as(struct kk_std_core_map_fun20364__t_6*, _fself, _ctx);
  kk_function_t f = _self->f; /* (char) -> 6589 char */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);}, {}, _ctx)
  kk_char_t _x20365;
  kk_char_t _x20366 = kk_char_unbox(_b_18791, KK_OWNED, _ctx); /*char*/
  _x20365 = kk_function_call(kk_char_t, (kk_function_t, kk_char_t, kk_context_t*), f, (f, _x20366, _ctx), _ctx); /*char*/
  return kk_char_box(_x20365, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun20368__t_6 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_map_fun20368_6(kk_function_t _fself, kk_box_t _b_18795, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20368_6(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_map_fun20368_6, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_map_fun20368_6(kk_function_t _fself, kk_box_t _b_18795, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x20369;
  kk_std_core__list _x20370 = kk_std_core__list_unbox(_b_18795, KK_OWNED, _ctx); /*list<char>*/
  _x20369 = kk_std_core_string_2(_x20370, _ctx); /*string*/
  return kk_string_box(_x20369);
}

kk_string_t kk_std_core_map_6(kk_string_t s, kk_function_t f, kk_context_t* _ctx) { /* forall<e> (s : string, f : (char) -> e char) -> e string */ 
  kk_std_core__list _b_18792_18789 = kk_std_core_list_6(s, _ctx); /*list<char>*/;
  kk_std_core__list x_18156 = kk_std_core_map_5(_b_18792_18789, kk_std_core_new_map_fun20364_6(f, _ctx), _ctx); /*list<char>*/;
  if (kk_yielding(kk_context())) {
    kk_std_core__list_drop(x_18156, _ctx);
    kk_box_t _x20367 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20368_6(_ctx), _ctx); /*3926*/
    return kk_string_unbox(_x20367);
  }
  {
    return kk_std_core_string_2(x_18156, _ctx);
  }
}
 
// Apply a total function `f` to each element in a vector `v`


// lift anonymous function
struct kk_std_core_map_fun20376__t_7 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_vector_t v;
  kk_vector_t w;
};
static kk_unit_t kk_std_core_map_fun20376_7(kk_function_t _fself, kk_ssize_t i0, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20376_7(kk_function_t f, kk_vector_t v, kk_vector_t w, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20376__t_7* _self = kk_function_alloc_as(struct kk_std_core_map_fun20376__t_7, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20376_7, kk_context());
  _self->f = f;
  _self->v = v;
  _self->w = w;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_map_fun20378__t_7 {
  struct kk_function_s _base;
  kk_vector_t w;
  kk_ssize_t i0;
};
static kk_box_t kk_std_core_map_fun20378_7(kk_function_t _fself, kk_box_t _b_18798, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20378_7(kk_vector_t w, kk_ssize_t i0, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20378__t_7* _self = kk_function_alloc_as(struct kk_std_core_map_fun20378__t_7, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20378_7, kk_context());
  _self->w = w;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20378_7(kk_function_t _fself, kk_box_t _b_18798, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20378__t_7* _self = kk_function_as(struct kk_std_core_map_fun20378__t_7*, _fself, _ctx);
  kk_vector_t w = _self->w; /* vector<6638> */
  kk_ssize_t i0 = _self->i0; /* ssize_t */
  kk_drop_match(_self, {kk_vector_dup(w, _ctx);;}, {}, _ctx)
  kk_unit_t _x20379 = kk_Unit;
  kk_vector_unsafe_assign(w,i0,_b_18798,kk_context());
  return kk_unit_box(_x20379);
}
static kk_unit_t kk_std_core_map_fun20376_7(kk_function_t _fself, kk_ssize_t i0, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20376__t_7* _self = kk_function_as(struct kk_std_core_map_fun20376__t_7*, _fself, _ctx);
  kk_function_t f = _self->f; /* (6637) -> 6639 6638 */
  kk_vector_t v = _self->v; /* vector<6637> */
  kk_vector_t w = _self->w; /* vector<6638> */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_vector_dup(v, _ctx);kk_vector_dup(w, _ctx);}, {}, _ctx)
  kk_box_t x0_18339;
  kk_box_t _brw_19936 = kk_vector_at_borrow(v,i0,kk_context()); /*228*/;
  kk_vector_drop(v, _ctx);
  x0_18339 = _brw_19936; /*6637*/
  kk_box_t x1_18163 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x0_18339, _ctx), _ctx); /*6638*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x1_18163, _ctx);
    kk_box_t _x20377 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20378_7(w, i0, _ctx), _ctx); /*3926*/
    return kk_unit_unbox(_x20377);
  }
  {
    return kk_vector_unsafe_assign(w,i0,x1_18163,kk_context());
  }
}


// lift anonymous function
struct kk_std_core_map_fun20381__t_7 {
  struct kk_function_s _base;
  kk_vector_t w;
};
static kk_box_t kk_std_core_map_fun20381_7(kk_function_t _fself, kk_box_t _b_18802, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun20381_7(kk_vector_t w, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20381__t_7* _self = kk_function_alloc_as(struct kk_std_core_map_fun20381__t_7, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun20381_7, kk_context());
  _self->w = w;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun20381_7(kk_function_t _fself, kk_box_t _b_18802, kk_context_t* _ctx) {
  struct kk_std_core_map_fun20381__t_7* _self = kk_function_as(struct kk_std_core_map_fun20381__t_7*, _fself, _ctx);
  kk_vector_t w = _self->w; /* vector<6638> */
  kk_drop_match(_self, {kk_vector_dup(w, _ctx);}, {}, _ctx)
  kk_unit_t wild___18804 = kk_Unit;
  kk_unit_unbox(_b_18802);
  return kk_vector_box(w, _ctx);
}

kk_vector_t kk_std_core_map_7(kk_vector_t v, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (v : vector<a>, f : (a) -> e b) -> e vector<b> */ 
  kk_vector_t w;
  kk_ssize_t _x20371;
  kk_integer_t _x20372;
  kk_ssize_t _x20373 = kk_vector_len_borrow(v,kk_context()); /*ssize_t*/
  _x20372 = kk_integer_from_ssize_t(_x20373,kk_context()); /*int*/
  _x20371 = kk_std_core_ssize__t(_x20372, _ctx); /*ssize_t*/
  w = kk_vector_alloc_uninit(_x20371,NULL,kk_context()); /*vector<6638>*/
  kk_ssize_t start0_17410 = (KK_IZ(0)); /*ssize_t*/;
  kk_ssize_t end_17411;
  kk_ssize_t _x20374 = kk_vector_len_borrow(v,kk_context()); /*ssize_t*/
  end_17411 = kk_std_core_decr_1(_x20374, _ctx); /*ssize_t*/
  kk_unit_t x_18158 = kk_Unit;
  kk_function_t _x20375;
  kk_vector_dup(w, _ctx);
  _x20375 = kk_std_core_new_map_fun20376_7(f, v, w, _ctx); /*(i0 : ssize_t) -> 6639 ()*/
  kk_std_core__lift17317_forz(_x20375, end_17411, start0_17410, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x20380 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun20381_7(w, _ctx), _ctx); /*3926*/
    return kk_vector_unbox(_x20380, _ctx);
  }
  {
    return w;
  }
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18016_lift17319_for(kk_function_t action, kk_integer_t end, kk_integer_t i, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<e> (action : (int) -> e (), end : int, i : int, wild_ : ()) -> e () */ 
  kk_integer_t i0_17422 = kk_integer_add_small_const(i, 1, _ctx); /*int*/;
  kk_std_core__lift17319_for(action, end, i0_17422, _ctx); return kk_Unit;
}
 
// lifted local: for, rep


// lift anonymous function
struct kk_std_core__lift17319_for_fun20385__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_integer_t end0;
  kk_integer_t i0;
};
static kk_box_t kk_std_core__lift17319_for_fun20385(kk_function_t _fself, kk_box_t _b_18806, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift17319_for_fun20385(kk_function_t action0, kk_integer_t end0, kk_integer_t i0, kk_context_t* _ctx) {
  struct kk_std_core__lift17319_for_fun20385__t* _self = kk_function_alloc_as(struct kk_std_core__lift17319_for_fun20385__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift17319_for_fun20385, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift17319_for_fun20385(kk_function_t _fself, kk_box_t _b_18806, kk_context_t* _ctx) {
  struct kk_std_core__lift17319_for_fun20385__t* _self = kk_function_as(struct kk_std_core__lift17319_for_fun20385__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (int) -> 7419 () */
  kk_integer_t end0 = _self->end0; /* int */
  kk_integer_t i0 = _self->i0; /* int */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_integer_dup(end0, _ctx);kk_integer_dup(i0, _ctx);}, {}, _ctx)
  kk_unit_t wild__0_18808 = kk_Unit;
  kk_unit_unbox(_b_18806);
  kk_unit_t _x20386 = kk_Unit;
  kk_std_core__mlift18016_lift17319_for(action0, end0, i0, wild__0_18808, _ctx);
  return kk_unit_box(_x20386);
}

kk_unit_t kk_std_core__lift17319_for(kk_function_t action0, kk_integer_t end0, kk_integer_t i0, kk_context_t* _ctx) { /* forall<e> (action : (int) -> e (), end : int, i : int) -> e () */ 
  kk__tailcall: ;
  bool _match_19932 = kk_integer_lte_borrow(i0,end0,kk_context()); /*bool*/;
  if (_match_19932) {
    kk_unit_t x_18170 = kk_Unit;
    kk_function_t _x20383 = kk_function_dup(action0, _ctx); /*(int) -> 7419 ()*/
    kk_integer_t _x20382 = kk_integer_dup(i0, _ctx); /*int*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_context_t*), _x20383, (_x20383, _x20382, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x20384 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift17319_for_fun20385(action0, end0, i0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x20384); return kk_Unit;
    }
    {
      kk_integer_t i0_174220 = kk_integer_add_small_const(i0, 1, _ctx); /*int*/;
      { // tailcall
        i0 = i0_174220;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i0, _ctx);
    kk_integer_drop(end0, _ctx);
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
extern kk_unit_t kk_std_core_repeat_fun20390_1(kk_function_t _fself, kk_integer_t i0, kk_context_t* _ctx) {
  struct kk_std_core_repeat_fun20390__t_1* _self = kk_function_as(struct kk_std_core_repeat_fun20390__t_1*, _fself, _ctx);
  kk_function_t action = _self->action; /* () -> 7438 () */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);}, {}, _ctx)
  kk_integer_drop(i0, _ctx);
  return kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx);
}
 
// Right-align a string to width `width`  using `fill`  (default is a space) to fill from the left.

kk_string_t kk_std_core_pad_left(kk_string_t s, kk_integer_t width, kk_std_core_types__optional fill, kk_context_t* _ctx) { /* (s : string, width : int, fill : optional<char>) -> string */ 
  kk_integer_t n;
  kk_string_t _x20392 = kk_string_dup(s, _ctx); /*string*/
  n = kk_string_len_int(_x20392,kk_context()); /*int*/
  bool _match_19931 = kk_integer_lte_borrow(width,n,kk_context()); /*bool*/;
  if (_match_19931) {
    kk_integer_drop(n, _ctx);
    kk_std_core_types__optional_drop(fill, _ctx);
    return s;
  }
  {
    kk_string_t s0_17428;
    kk_char_t _x20393;
    if (kk_std_core_types__is_Optional(fill, _ctx)) {
      kk_box_t _box_x18809 = fill._cons.Optional.value;
      kk_char_t _fill_7448 = kk_char_unbox(_box_x18809, KK_BORROWED, _ctx);
      kk_std_core_types__optional_drop(fill, _ctx);
      _x20393 = _fill_7448; /*char*/
    }
    else {
      kk_std_core_types__optional_drop(fill, _ctx);
      _x20393 = ' '; /*char*/
    }
    s0_17428 = kk_std_core_string(_x20393, _ctx); /*string*/
    kk_integer_t n0_17429;
    kk_integer_t _x20394 = kk_integer_dup(width, _ctx); /*int*/
    n0_17429 = kk_integer_sub(_x20394,n,kk_context()); /*int*/
    kk_string_t _x20395;
    kk_ssize_t _x20396 = kk_std_core_ssize__t(n0_17429, _ctx); /*ssize_t*/
    _x20395 = kk_std_core_repeatz(s0_17428, _x20396, _ctx); /*string*/
    return kk_std_core__lp__plus__plus__1_rp_(_x20395, s, _ctx);
  }
}
 
// Show an `:int` as a hexadecimal value.
// The `width`  parameter specifies how wide the hex value is where `"0"`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number (goes between the sign and the number).

kk_string_t kk_std_core_show_hex(kk_integer_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_string_t _x20397;
  bool _match_19930 = kk_integer_lt_borrow(i,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_19930) {
    kk_define_string_literal(, _s20398, 1, "-", _ctx)
    _x20397 = kk_string_dup(_s20398, _ctx); /*string*/
  }
  else {
    _x20397 = kk_string_empty(); /*string*/
  }
  kk_string_t _x20400;
  kk_char_t _b_18814_18813 = '0'; /*char*/;
  kk_string_t _x20401;
  if (kk_std_core_types__is_Optional(pre, _ctx)) {
    kk_box_t _box_x18810 = pre._cons.Optional.value;
    kk_string_t _pre_7596 = kk_string_unbox(_box_x18810);
    kk_string_dup(_pre_7596, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    _x20401 = _pre_7596; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_define_string_literal(, _s20402, 2, "0x", _ctx)
    _x20401 = kk_string_dup(_s20402, _ctx); /*string*/
  }
  kk_string_t _x20403;
  kk_string_t _own_19928;
  kk_integer_t _x20404 = kk_integer_abs(i,kk_context()); /*int*/
  bool _x20405;
  if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
    kk_box_t _box_x18811 = use_capitals._cons.Optional.value;
    bool _use_capitals_7592 = kk_bool_unbox(_box_x18811);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x20405 = _use_capitals_7592; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x20405 = true; /*bool*/
  }
  _own_19928 = kk_std_core_int_show_hex(_x20404, _x20405, _ctx); /*string*/
  kk_integer_t _brw_19927;
  if (kk_std_core_types__is_Optional(width, _ctx)) {
    kk_box_t _box_x18812 = width._cons.Optional.value;
    kk_integer_t _width_7588 = kk_integer_unbox(_box_x18812, _ctx);
    kk_integer_dup(_width_7588, _ctx);
    kk_std_core_types__optional_drop(width, _ctx);
    _brw_19927 = _width_7588; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(width, _ctx);
    _brw_19927 = kk_integer_from_small(1); /*int*/
  }
  kk_string_t _brw_19929;
  kk_std_core_types__optional _x20406 = kk_std_core_types__new_Optional(kk_char_box(_b_18814_18813, _ctx), _ctx); /*optional<116>*/
  _brw_19929 = kk_std_core_pad_left(_own_19928, _brw_19927, _x20406, _ctx); /*string*/
  kk_integer_drop(_brw_19927, _ctx);
  _x20403 = _brw_19929; /*string*/
  _x20400 = kk_std_core__lp__plus__plus__1_rp_(_x20401, _x20403, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x20397, _x20400, _ctx);
}
 
// Show a character as a string

kk_string_t kk_std_core_show_char(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> string */ 
  bool _match_19898 = (c < (' ')); /*bool*/;
  if (_match_19898) {
    bool _match_19913 = (c == 0x000A); /*bool*/;
    if (_match_19913) {
      kk_define_string_literal(, _s20412, 2, "\\n", _ctx)
      return kk_string_dup(_s20412, _ctx);
    }
    {
      bool _match_19914 = (c == 0x000D); /*bool*/;
      if (_match_19914) {
        kk_define_string_literal(, _s20413, 2, "\\r", _ctx)
        return kk_string_dup(_s20413, _ctx);
      }
      {
        bool _match_19915 = (c == 0x0009); /*bool*/;
        if (_match_19915) {
          kk_define_string_literal(, _s20414, 2, "\\t", _ctx)
          return kk_string_dup(_s20414, _ctx);
        }
        {
          bool _match_19916;
          kk_integer_t _brw_19921 = kk_integer_from_int(c,kk_context()); /*int*/;
          bool _brw_19922 = kk_integer_lte_borrow(_brw_19921,(kk_integer_from_small(255)),kk_context()); /*bool*/;
          kk_integer_drop(_brw_19921, _ctx);
          _match_19916 = _brw_19922; /*bool*/
          if (_match_19916) {
            kk_integer_t _arg_8042 = kk_integer_from_int(c,kk_context()); /*int*/;
            kk_integer_t _b_18827_18815 = kk_integer_from_small(2); /*int*/;
            kk_string_t _b_18828_18816 = kk_string_empty(); /*string*/;
            kk_string_t _x20416;
            kk_define_string_literal(, _s20417, 2, "\\x", _ctx)
            _x20416 = kk_string_dup(_s20417, _ctx); /*string*/
            kk_string_t _x20418;
            kk_std_core_types__optional _x20419 = kk_std_core_types__new_Optional(kk_integer_box(_b_18827_18815, _ctx), _ctx); /*optional<116>*/
            kk_std_core_types__optional _x20420 = kk_std_core_types__new_Optional(kk_string_box(_b_18828_18816), _ctx); /*optional<116>*/
            _x20418 = kk_std_core_show_hex(_arg_8042, _x20419, kk_std_core_types__new_None(_ctx), _x20420, _ctx); /*string*/
            return kk_std_core__lp__plus__plus__1_rp_(_x20416, _x20418, _ctx);
          }
          {
            bool _match_19917;
            kk_integer_t _brw_19919 = kk_integer_from_int(c,kk_context()); /*int*/;
            kk_integer_t _brw_19918 = kk_integer_from_int(65535, _ctx); /*int*/;
            bool _brw_19920 = kk_integer_lte_borrow(_brw_19919,_brw_19918,kk_context()); /*bool*/;
            kk_integer_drop(_brw_19919, _ctx);
            kk_integer_drop(_brw_19918, _ctx);
            _match_19917 = _brw_19920; /*bool*/
            if (_match_19917) {
              kk_integer_t _arg_8140 = kk_integer_from_int(c,kk_context()); /*int*/;
              kk_integer_t _b_18829_18817 = kk_integer_from_small(4); /*int*/;
              kk_string_t _b_18830_18818 = kk_string_empty(); /*string*/;
              kk_string_t _x20422;
              kk_define_string_literal(, _s20423, 2, "\\u", _ctx)
              _x20422 = kk_string_dup(_s20423, _ctx); /*string*/
              kk_string_t _x20424;
              kk_std_core_types__optional _x20425 = kk_std_core_types__new_Optional(kk_integer_box(_b_18829_18817, _ctx), _ctx); /*optional<116>*/
              kk_std_core_types__optional _x20426 = kk_std_core_types__new_Optional(kk_string_box(_b_18830_18818), _ctx); /*optional<116>*/
              _x20424 = kk_std_core_show_hex(_arg_8140, _x20425, kk_std_core_types__new_None(_ctx), _x20426, _ctx); /*string*/
              return kk_std_core__lp__plus__plus__1_rp_(_x20422, _x20424, _ctx);
            }
            {
              kk_integer_t _arg_8194 = kk_integer_from_int(c,kk_context()); /*int*/;
              kk_integer_t _b_18831_18819 = kk_integer_from_small(6); /*int*/;
              kk_string_t _b_18832_18820 = kk_string_empty(); /*string*/;
              kk_string_t _x20428;
              kk_define_string_literal(, _s20429, 2, "\\U", _ctx)
              _x20428 = kk_string_dup(_s20429, _ctx); /*string*/
              kk_string_t _x20430;
              kk_std_core_types__optional _x20431 = kk_std_core_types__new_Optional(kk_integer_box(_b_18831_18819, _ctx), _ctx); /*optional<116>*/
              kk_std_core_types__optional _x20432 = kk_std_core_types__new_Optional(kk_string_box(_b_18832_18820), _ctx); /*optional<116>*/
              _x20430 = kk_std_core_show_hex(_arg_8194, _x20431, kk_std_core_types__new_None(_ctx), _x20432, _ctx); /*string*/
              return kk_std_core__lp__plus__plus__1_rp_(_x20428, _x20430, _ctx);
            }
          }
        }
      }
    }
  }
  {
    bool _match_19899 = (c > ('~')); /*bool*/;
    if (_match_19899) {
      bool _match_19903 = (c == 0x000A); /*bool*/;
      if (_match_19903) {
        kk_define_string_literal(, _s20433, 2, "\\n", _ctx)
        return kk_string_dup(_s20433, _ctx);
      }
      {
        bool _match_19904 = (c == 0x000D); /*bool*/;
        if (_match_19904) {
          kk_define_string_literal(, _s20434, 2, "\\r", _ctx)
          return kk_string_dup(_s20434, _ctx);
        }
        {
          bool _match_19905 = (c == 0x0009); /*bool*/;
          if (_match_19905) {
            kk_define_string_literal(, _s20435, 2, "\\t", _ctx)
            return kk_string_dup(_s20435, _ctx);
          }
          {
            bool _match_19906;
            kk_integer_t _brw_19911 = kk_integer_from_int(c,kk_context()); /*int*/;
            bool _brw_19912 = kk_integer_lte_borrow(_brw_19911,(kk_integer_from_small(255)),kk_context()); /*bool*/;
            kk_integer_drop(_brw_19911, _ctx);
            _match_19906 = _brw_19912; /*bool*/
            if (_match_19906) {
              kk_integer_t _arg_80420 = kk_integer_from_int(c,kk_context()); /*int*/;
              kk_integer_t _b_18833_18821 = kk_integer_from_small(2); /*int*/;
              kk_string_t _b_18834_18822 = kk_string_empty(); /*string*/;
              kk_string_t _x20437;
              kk_define_string_literal(, _s20438, 2, "\\x", _ctx)
              _x20437 = kk_string_dup(_s20438, _ctx); /*string*/
              kk_string_t _x20439;
              kk_std_core_types__optional _x20440 = kk_std_core_types__new_Optional(kk_integer_box(_b_18833_18821, _ctx), _ctx); /*optional<116>*/
              kk_std_core_types__optional _x20441 = kk_std_core_types__new_Optional(kk_string_box(_b_18834_18822), _ctx); /*optional<116>*/
              _x20439 = kk_std_core_show_hex(_arg_80420, _x20440, kk_std_core_types__new_None(_ctx), _x20441, _ctx); /*string*/
              return kk_std_core__lp__plus__plus__1_rp_(_x20437, _x20439, _ctx);
            }
            {
              bool _match_19907;
              kk_integer_t _brw_19909 = kk_integer_from_int(c,kk_context()); /*int*/;
              kk_integer_t _brw_19908 = kk_integer_from_int(65535, _ctx); /*int*/;
              bool _brw_19910 = kk_integer_lte_borrow(_brw_19909,_brw_19908,kk_context()); /*bool*/;
              kk_integer_drop(_brw_19909, _ctx);
              kk_integer_drop(_brw_19908, _ctx);
              _match_19907 = _brw_19910; /*bool*/
              if (_match_19907) {
                kk_integer_t _arg_81400 = kk_integer_from_int(c,kk_context()); /*int*/;
                kk_integer_t _b_18835_18823 = kk_integer_from_small(4); /*int*/;
                kk_string_t _b_18836_18824 = kk_string_empty(); /*string*/;
                kk_string_t _x20443;
                kk_define_string_literal(, _s20444, 2, "\\u", _ctx)
                _x20443 = kk_string_dup(_s20444, _ctx); /*string*/
                kk_string_t _x20445;
                kk_std_core_types__optional _x20446 = kk_std_core_types__new_Optional(kk_integer_box(_b_18835_18823, _ctx), _ctx); /*optional<116>*/
                kk_std_core_types__optional _x20447 = kk_std_core_types__new_Optional(kk_string_box(_b_18836_18824), _ctx); /*optional<116>*/
                _x20445 = kk_std_core_show_hex(_arg_81400, _x20446, kk_std_core_types__new_None(_ctx), _x20447, _ctx); /*string*/
                return kk_std_core__lp__plus__plus__1_rp_(_x20443, _x20445, _ctx);
              }
              {
                kk_integer_t _arg_81940 = kk_integer_from_int(c,kk_context()); /*int*/;
                kk_integer_t _b_18837_18825 = kk_integer_from_small(6); /*int*/;
                kk_string_t _b_18838_18826 = kk_string_empty(); /*string*/;
                kk_string_t _x20449;
                kk_define_string_literal(, _s20450, 2, "\\U", _ctx)
                _x20449 = kk_string_dup(_s20450, _ctx); /*string*/
                kk_string_t _x20451;
                kk_std_core_types__optional _x20452 = kk_std_core_types__new_Optional(kk_integer_box(_b_18837_18825, _ctx), _ctx); /*optional<116>*/
                kk_std_core_types__optional _x20453 = kk_std_core_types__new_Optional(kk_string_box(_b_18838_18826), _ctx); /*optional<116>*/
                _x20451 = kk_std_core_show_hex(_arg_81940, _x20452, kk_std_core_types__new_None(_ctx), _x20453, _ctx); /*string*/
                return kk_std_core__lp__plus__plus__1_rp_(_x20449, _x20451, _ctx);
              }
            }
          }
        }
      }
    }
    {
      bool _match_19900 = (c == ('\'')); /*bool*/;
      if (_match_19900) {
        kk_define_string_literal(, _s20454, 2, "\\\'", _ctx)
        return kk_string_dup(_s20454, _ctx);
      }
      {
        bool _match_19901 = (c == ('"')); /*bool*/;
        if (_match_19901) {
          kk_define_string_literal(, _s20455, 2, "\\\"", _ctx)
          return kk_string_dup(_s20455, _ctx);
        }
        {
          bool _match_19902 = (c == ('\\')); /*bool*/;
          if (_match_19902) {
            kk_define_string_literal(, _s20456, 2, "\\\\", _ctx)
            return kk_string_dup(_s20456, _ctx);
          }
          {
            return kk_std_core_string(c, _ctx);
          }
        }
      }
    }
  }
}
 
// Show a `:float64` in exponential (scientific) notation.
// The optional `precision` (= `-17`) specifies the precision.
// If `>=0` it specifies the number of digits behind the dot (up to `17` max).
// If negative, then at most the absolute value of `precision` digits behind the dot are used.

kk_string_t kk_std_core_show_exp(double d, kk_std_core_types__optional precision, kk_context_t* _ctx) { /* (d : float64, precision : optional<int>) -> string */ 
  int32_t _x20457;
  kk_integer_t _x20458;
  if (kk_std_core_types__is_Optional(precision, _ctx)) {
    kk_box_t _box_x18839 = precision._cons.Optional.value;
    kk_integer_t _precision_8272 = kk_integer_unbox(_box_x18839, _ctx);
    kk_integer_dup(_precision_8272, _ctx);
    kk_std_core_types__optional_drop(precision, _ctx);
    _x20458 = _precision_8272; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(precision, _ctx);
    _x20458 = kk_integer_from_small(-17); /*int*/
  }
  _x20457 = kk_std_core_int32(_x20458, _ctx); /*int32*/
  return kk_std_core_show_expx(d, _x20457, _ctx);
}
 
// Show a `:float64` fixed-point notation.
// The optional `precision` (= `-2`) specifies the maximum precision.
// If `>=0` it specifies the number of digits behind the dot (up to `20` max).
// If negative, then at most the absolute value of `precision` digits behind the dot are used.
// This may still show a number in exponential notation if the it is too small or large,
// in particular, for  a `d` where `d > 1.0e21` or `d < 1.0e-15`, or if
// `precision.abs > 17`, the `show-exp` routine is used.

kk_string_t kk_std_core_show_fixed(double d, kk_std_core_types__optional precision, kk_context_t* _ctx) { /* (d : float64, precision : optional<int>) -> string */ 
  double dabs = kk_double_abs(d); /*float64*/;
  bool _match_19896 = (dabs < (0x1.203af9ee75616p-50)); /*bool*/;
  if (_match_19896) {
    int32_t _x20459;
    kk_integer_t _x20460;
    if (kk_std_core_types__is_Optional(precision, _ctx)) {
      kk_box_t _box_x18840 = precision._cons.Optional.value;
      kk_integer_t _precision_8283 = kk_integer_unbox(_box_x18840, _ctx);
      kk_integer_dup(_precision_8283, _ctx);
      kk_std_core_types__optional_drop(precision, _ctx);
      _x20460 = _precision_8283; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(precision, _ctx);
      _x20460 = kk_integer_from_small(-2); /*int*/
    }
    _x20459 = kk_std_core_int32(_x20460, _ctx); /*int32*/
    return kk_std_core_show_expx(d, _x20459, _ctx);
  }
  {
    bool _match_19897 = (dabs > (0x1.b1ae4d6e2ef5p69)); /*bool*/;
    if (_match_19897) {
      int32_t _x20461;
      kk_integer_t _x20462;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x18841 = precision._cons.Optional.value;
        kk_integer_t _precision_82830 = kk_integer_unbox(_box_x18841, _ctx);
        kk_integer_dup(_precision_82830, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x20462 = _precision_82830; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x20462 = kk_integer_from_small(-2); /*int*/
      }
      _x20461 = kk_std_core_int32(_x20462, _ctx); /*int32*/
      return kk_std_core_show_expx(d, _x20461, _ctx);
    }
    {
      int32_t _x20463;
      kk_integer_t _x20464;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x18842 = precision._cons.Optional.value;
        kk_integer_t _precision_82831 = kk_integer_unbox(_box_x18842, _ctx);
        kk_integer_dup(_precision_82831, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x20464 = _precision_82831; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x20464 = kk_integer_from_small(-2); /*int*/
      }
      _x20463 = kk_std_core_int32(_x20464, _ctx); /*int32*/
      return kk_std_core_show_fixedx(d, _x20463, _ctx);
    }
  }
}
 
// monadic lift

kk_string_t kk_std_core__mlift18017_show_list(kk_std_core__list _y_17790, kk_context_t* _ctx) { /* forall<e> (list<string>) -> e string */ 
  kk_string_t _x20465;
  kk_define_string_literal(, _s20466, 1, "[", _ctx)
  _x20465 = kk_string_dup(_s20466, _ctx); /*string*/
  kk_string_t _x20467;
  kk_string_t _x20468;
  if (kk_std_core__is_Nil(_y_17790, _ctx)) {
    _x20468 = kk_string_empty(); /*string*/
  }
  else {
    struct kk_std_core_Cons* _con20470 = kk_std_core__as_Cons(_y_17790, _ctx);
    kk_box_t _box_x18843 = _con20470->head;
    kk_std_core__list xx = _con20470->tail;
    kk_string_t x = kk_string_unbox(_box_x18843);
    if kk_likely(kk_datatype_ptr_is_unique(_y_17790, _ctx)) {
      kk_datatype_ptr_free(_y_17790, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(_y_17790, _ctx);
    }
    kk_string_t _x20471;
    kk_define_string_literal(, _s20472, 1, ",", _ctx)
    _x20471 = kk_string_dup(_s20472, _ctx); /*string*/
    _x20468 = kk_std_core__lift17316_joinsep(_x20471, xx, x, _ctx); /*string*/
  }
  kk_string_t _x20473;
  kk_define_string_literal(, _s20474, 1, "]", _ctx)
  _x20473 = kk_string_dup(_s20474, _ctx); /*string*/
  _x20467 = kk_std_core__lp__plus__plus__1_rp_(_x20468, _x20473, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x20465, _x20467, _ctx);
}
 
// Convert a list to a string


// lift anonymous function
struct kk_std_core_show_list_fun20475__t {
  struct kk_function_s _base;
  kk_function_t show_elem;
};
static kk_box_t kk_std_core_show_list_fun20475(kk_function_t _fself, kk_box_t _b_18846, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_show_list_fun20475(kk_function_t show_elem, kk_context_t* _ctx) {
  struct kk_std_core_show_list_fun20475__t* _self = kk_function_alloc_as(struct kk_std_core_show_list_fun20475__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_show_list_fun20475, kk_context());
  _self->show_elem = show_elem;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_show_list_fun20475(kk_function_t _fself, kk_box_t _b_18846, kk_context_t* _ctx) {
  struct kk_std_core_show_list_fun20475__t* _self = kk_function_as(struct kk_std_core_show_list_fun20475__t*, _fself, _ctx);
  kk_function_t show_elem = _self->show_elem; /* (8848) -> 8849 string */
  kk_drop_match(_self, {kk_function_dup(show_elem, _ctx);}, {}, _ctx)
  kk_string_t _x20476 = kk_function_call(kk_string_t, (kk_function_t, kk_box_t, kk_context_t*), show_elem, (show_elem, _b_18846, _ctx), _ctx); /*string*/
  return kk_string_box(_x20476);
}


// lift anonymous function
struct kk_std_core_show_list_fun20478__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_show_list_fun20478(kk_function_t _fself, kk_box_t _b_18851, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_show_list_fun20478(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_show_list_fun20478, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_show_list_fun20478(kk_function_t _fself, kk_box_t _b_18851, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _y_18854_17790 = kk_std_core__list_unbox(_b_18851, KK_OWNED, _ctx); /*list<string>*/;
  kk_string_t _x20479;
  kk_string_t _x20480;
  kk_define_string_literal(, _s20481, 1, "[", _ctx)
  _x20480 = kk_string_dup(_s20481, _ctx); /*string*/
  kk_string_t _x20482;
  kk_string_t _x20483;
  if (kk_std_core__is_Nil(_y_18854_17790, _ctx)) {
    _x20483 = kk_string_empty(); /*string*/
  }
  else {
    struct kk_std_core_Cons* _con20485 = kk_std_core__as_Cons(_y_18854_17790, _ctx);
    kk_box_t _box_x18849 = _con20485->head;
    kk_std_core__list xx = _con20485->tail;
    kk_string_t x0 = kk_string_unbox(_box_x18849);
    if kk_likely(kk_datatype_ptr_is_unique(_y_18854_17790, _ctx)) {
      kk_datatype_ptr_free(_y_18854_17790, _ctx);
    }
    else {
      kk_string_dup(x0, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(_y_18854_17790, _ctx);
    }
    kk_string_t _x20486;
    kk_define_string_literal(, _s20487, 1, ",", _ctx)
    _x20486 = kk_string_dup(_s20487, _ctx); /*string*/
    _x20483 = kk_std_core__lift17316_joinsep(_x20486, xx, x0, _ctx); /*string*/
  }
  kk_string_t _x20488;
  kk_define_string_literal(, _s20489, 1, "]", _ctx)
  _x20488 = kk_string_dup(_s20489, _ctx); /*string*/
  _x20482 = kk_std_core__lp__plus__plus__1_rp_(_x20483, _x20488, _ctx); /*string*/
  _x20479 = kk_std_core__lp__plus__plus__1_rp_(_x20480, _x20482, _ctx); /*string*/
  return kk_string_box(_x20479);
}

kk_string_t kk_std_core_show_list(kk_std_core__list xs, kk_function_t show_elem, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, show-elem : (a) -> e string) -> e string */ 
  kk_std_core__list x_18173 = kk_std_core_map_5(xs, kk_std_core_new_show_list_fun20475(show_elem, _ctx), _ctx); /*list<string>*/;
  if (kk_yielding(kk_context())) {
    kk_std_core__list_drop(x_18173, _ctx);
    kk_box_t _x20477 = kk_std_core_hnd_yield_extend(kk_std_core_new_show_list_fun20478(_ctx), _ctx); /*3926*/
    return kk_string_unbox(_x20477);
  }
  {
    kk_string_t _x20490;
    kk_define_string_literal(, _s20491, 1, "[", _ctx)
    _x20490 = kk_string_dup(_s20491, _ctx); /*string*/
    kk_string_t _x20492;
    kk_string_t _x20493;
    if (kk_std_core__is_Nil(x_18173, _ctx)) {
      _x20493 = kk_string_empty(); /*string*/
    }
    else {
      struct kk_std_core_Cons* _con20495 = kk_std_core__as_Cons(x_18173, _ctx);
      kk_box_t _box_x18852 = _con20495->head;
      kk_std_core__list xx0 = _con20495->tail;
      kk_string_t x1 = kk_string_unbox(_box_x18852);
      if kk_likely(kk_datatype_ptr_is_unique(x_18173, _ctx)) {
        kk_datatype_ptr_free(x_18173, _ctx);
      }
      else {
        kk_string_dup(x1, _ctx);
        kk_std_core__list_dup(xx0, _ctx);
        kk_datatype_ptr_decref(x_18173, _ctx);
      }
      kk_string_t _x20496;
      kk_define_string_literal(, _s20497, 1, ",", _ctx)
      _x20496 = kk_string_dup(_s20497, _ctx); /*string*/
      _x20493 = kk_std_core__lift17316_joinsep(_x20496, xx0, x1, _ctx); /*string*/
    }
    kk_string_t _x20498;
    kk_define_string_literal(, _s20499, 1, "]", _ctx)
    _x20498 = kk_string_dup(_s20499, _ctx); /*string*/
    _x20492 = kk_std_core__lp__plus__plus__1_rp_(_x20493, _x20498, _ctx); /*string*/
    return kk_std_core__lp__plus__plus__1_rp_(_x20490, _x20492, _ctx);
  }
}
 
// Convert an `:int` to a string

kk_string_t kk_std_core_show(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> string */ 
  return kk_integer_to_string(i,kk_context());
}
 
// Show a `:float64` as a string.
// If `d >= 1.0e-5` and `d < 1.0e+21`, `show-fixed` is used and otherwise `show-exp`.
// Default `precision` is `-17`.

kk_string_t kk_std_core_show_1(double d, kk_std_core_types__optional precision, kk_context_t* _ctx) { /* (d : float64, precision : optional<int>) -> string */ 
  double dabs = kk_double_abs(d); /*float64*/;
  bool _match_19893 = (dabs >= (0x1.4f8b588e368f1p-17)); /*bool*/;
  if (_match_19893) {
    bool _match_19894 = (dabs < (0x1.b1ae4d6e2ef5p69)); /*bool*/;
    if (_match_19894) {
      kk_std_core_types__optional _x20500;
      kk_box_t _x20501;
      kk_integer_t _x20502;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x18855 = precision._cons.Optional.value;
        kk_integer_t _precision_8858 = kk_integer_unbox(_box_x18855, _ctx);
        kk_integer_dup(_precision_8858, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x20502 = _precision_8858; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x20502 = kk_integer_from_small(-17); /*int*/
      }
      _x20501 = kk_integer_box(_x20502, _ctx); /*116*/
      _x20500 = kk_std_core_types__new_Optional(_x20501, _ctx); /*optional<116>*/
      return kk_std_core_show_fixed(d, _x20500, _ctx);
    }
    {
      int32_t _x20503;
      kk_integer_t _x20504;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x18857 = precision._cons.Optional.value;
        kk_integer_t _precision_88580 = kk_integer_unbox(_box_x18857, _ctx);
        kk_integer_dup(_precision_88580, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x20504 = _precision_88580; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x20504 = kk_integer_from_small(-17); /*int*/
      }
      _x20503 = kk_std_core_int32(_x20504, _ctx); /*int32*/
      return kk_std_core_show_expx(d, _x20503, _ctx);
    }
  }
  {
    int32_t _x20505;
    kk_integer_t _x20506;
    if (kk_std_core_types__is_Optional(precision, _ctx)) {
      kk_box_t _box_x18858 = precision._cons.Optional.value;
      kk_integer_t _precision_88581 = kk_integer_unbox(_box_x18858, _ctx);
      kk_integer_dup(_precision_88581, _ctx);
      kk_std_core_types__optional_drop(precision, _ctx);
      _x20506 = _precision_88581; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(precision, _ctx);
      _x20506 = kk_integer_from_small(-17); /*int*/
    }
    _x20505 = kk_std_core_int32(_x20506, _ctx); /*int32*/
    return kk_std_core_show_expx(d, _x20505, _ctx);
  }
}
 
// Show a string as a string literal


// lift anonymous function
struct kk_std_core_show_fun20513__t_3 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_show_fun20513_3(kk_function_t _fself, kk_box_t _b_18862, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_show_fun20513_3(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_show_fun20513_3, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_show_fun20513_3(kk_function_t _fself, kk_box_t _b_18862, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x20514;
  kk_char_t _x20515 = kk_char_unbox(_b_18862, KK_OWNED, _ctx); /*char*/
  _x20514 = kk_std_core_show_char(_x20515, _ctx); /*string*/
  return kk_string_box(_x20514);
}

kk_string_t kk_std_core_show_3(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  kk_std_core__list _b_18863_18860 = kk_std_core_list_6(s, _ctx); /*list<char>*/;
  kk_std_core__list xs_17447 = kk_std_core_map_5(_b_18863_18860, kk_std_core_new_show_fun20513_3(_ctx), _ctx); /*list<string>*/;
  kk_string_t _x20516;
  kk_define_string_literal(, _s20517, 1, "\"", _ctx)
  _x20516 = kk_string_dup(_s20517, _ctx); /*string*/
  kk_string_t _x20518;
  kk_string_t _x20519;
  if (kk_std_core__is_Nil(xs_17447, _ctx)) {
    _x20519 = kk_string_empty(); /*string*/
  }
  else {
    struct kk_std_core_Cons* _con20521 = kk_std_core__as_Cons(xs_17447, _ctx);
    kk_box_t _box_x18865 = _con20521->head;
    kk_std_core__list xx = _con20521->tail;
    kk_string_t x = kk_string_unbox(_box_x18865);
    if kk_likely(kk_datatype_ptr_is_unique(xs_17447, _ctx)) {
      kk_datatype_ptr_free(xs_17447, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs_17447, _ctx);
    }
    kk_string_t _x20522 = kk_string_empty(); /*string*/
    _x20519 = kk_std_core__lift17316_joinsep(_x20522, xx, x, _ctx); /*string*/
  }
  kk_string_t _x20524;
  kk_define_string_literal(, _s20525, 1, "\"", _ctx)
  _x20524 = kk_string_dup(_s20525, _ctx); /*string*/
  _x20518 = kk_std_core__lp__plus__plus__1_rp_(_x20519, _x20524, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x20516, _x20518, _ctx);
}
extern kk_string_t kk_std_core_show_fun20530_7(kk_function_t _fself, kk_box_t _b_18868, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x20531 = kk_string_unbox(_b_18868); /*string*/
  return kk_std_core_show_3(_x20531, _ctx);
}
extern kk_string_t kk_std_core_show_fun20532_8(kk_function_t _fself, kk_box_t _b_18873, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x20533 = kk_integer_unbox(_b_18873, _ctx); /*int*/
  return kk_std_core_show(_x20533, _ctx);
}
extern kk_string_t kk_std_core_show_fun20534_9(kk_function_t _fself, kk_box_t _b_18878, kk_context_t* _ctx) {
  kk_unused(_fself);
  bool _x20535 = kk_bool_unbox(_b_18878); /*bool*/
  return kk_std_core_show_4(_x20535, _ctx);
}

kk_unit_t kk_std_core_prints(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> console () */ 
  kk_std_core_types__maybe _match_19892;
  kk_box_t _x20544;
  kk_ref_t _x20545 = kk_ref_dup(kk_std_core_redirect, _ctx); /*ref<global,maybe<(string) -> console ()>>*/
  _x20544 = kk_ref_get(_x20545,kk_context()); /*190*/
  _match_19892 = kk_std_core_types__maybe_unbox(_x20544, KK_OWNED, _ctx); /*maybe<(string) -> console ()>*/
  if (kk_std_core_types__is_Nothing(_match_19892, _ctx)) {
    kk_std_core_xprints(s, _ctx); return kk_Unit;
  }
  {
    kk_box_t _fun_unbox_x18885 = _match_19892._cons.Just.value;
    kk_box_t _x20546;
    kk_function_t _x20547 = kk_function_unbox(_fun_unbox_x18885, _ctx); /*(18886) -> console 18887*/
    _x20546 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x20547, (_x20547, kk_string_box(s), _ctx), _ctx); /*18887*/
    kk_unit_unbox(_x20546); return kk_Unit;
  }
}


// lift anonymous function
struct kk_std_core__default_exn_fun20552__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core__default_exn_fun20552(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun20552(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core__default_exn_fun20552, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_core__default_exn_fun20553__t {
  struct kk_function_s _base;
  kk_std_core__exception x;
};
static kk_box_t kk_std_core__default_exn_fun20553(kk_function_t _fself, kk_function_t _b_18900, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun20553(kk_std_core__exception x, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun20553__t* _self = kk_function_alloc_as(struct kk_std_core__default_exn_fun20553__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__default_exn_fun20553, kk_context());
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core__default_exn_fun20554__t {
  struct kk_function_s _base;
  kk_function_t _b_18900;
};
static kk_unit_t kk_std_core__default_exn_fun20554(kk_function_t _fself, kk_std_core_hnd__resume_result _b_18901, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun20554(kk_function_t _b_18900, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun20554__t* _self = kk_function_alloc_as(struct kk_std_core__default_exn_fun20554__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__default_exn_fun20554, kk_context());
  _self->_b_18900 = _b_18900;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_unit_t kk_std_core__default_exn_fun20554(kk_function_t _fself, kk_std_core_hnd__resume_result _b_18901, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun20554__t* _self = kk_function_as(struct kk_std_core__default_exn_fun20554__t*, _fself, _ctx);
  kk_function_t _b_18900 = _self->_b_18900; /* (std/core/hnd/resume-result<3990,3993>) -> 3992 3993 */
  kk_drop_match(_self, {kk_function_dup(_b_18900, _ctx);}, {}, _ctx)
  kk_box_t _x20555 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), _b_18900, (_b_18900, _b_18901, _ctx), _ctx); /*3993*/
  return kk_unit_unbox(_x20555);
}
static kk_box_t kk_std_core__default_exn_fun20553(kk_function_t _fself, kk_function_t _b_18900, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun20553__t* _self = kk_function_as(struct kk_std_core__default_exn_fun20553__t*, _fself, _ctx);
  kk_std_core__exception x = _self->x; /* exception */
  kk_drop_match(_self, {kk_std_core__exception_dup(x, _ctx);}, {}, _ctx)
  kk_function_t ___wildcard__525__45_18918 = kk_std_core__new_default_exn_fun20554(_b_18900, _ctx); /*(std/core/hnd/resume-result<9952,()>) -> <console|9950> ()*/;
  kk_function_drop(___wildcard__525__45_18918, _ctx);
  kk_unit_t __ = kk_Unit;
  kk_string_t _x20556;
  kk_define_string_literal(, _s20557, 20, "uncaught exception: ", _ctx)
  _x20556 = kk_string_dup(_s20557, _ctx); /*string*/
  kk_std_core_prints(_x20556, _ctx);
  kk_unit_t _x20558 = kk_Unit;
  kk_string_t _x20559;
  {
    kk_string_t _x = x.message;
    kk_string_dup(_x, _ctx);
    kk_std_core__exception_drop(x, _ctx);
    _x20559 = _x; /*string*/
  }
  kk_std_core_printsln(_x20559, _ctx);
  return kk_unit_box(_x20558);
}
static kk_box_t kk_std_core__default_exn_fun20552(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_datatype_ptr_dropn(___wildcard__525__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core__new_default_exn_fun20553(x, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core__default_exn_fun20562__t {
  struct kk_function_s _base;
  kk_function_t _b_18915_18902;
};
static kk_box_t kk_std_core__default_exn_fun20562(kk_function_t _fself, kk_std_core_hnd__marker _b_18903, kk_std_core_hnd__ev _b_18904, kk_box_t _b_18905, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun20562(kk_function_t _b_18915_18902, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun20562__t* _self = kk_function_alloc_as(struct kk_std_core__default_exn_fun20562__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__default_exn_fun20562, kk_context());
  _self->_b_18915_18902 = _b_18915_18902;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__default_exn_fun20562(kk_function_t _fself, kk_std_core_hnd__marker _b_18903, kk_std_core_hnd__ev _b_18904, kk_box_t _b_18905, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun20562__t* _self = kk_function_as(struct kk_std_core__default_exn_fun20562__t*, _fself, _ctx);
  kk_function_t _b_18915_18902 = _self->_b_18915_18902; /* (m0 : std/core/hnd/marker<<console|9950>,()>, std/core/hnd/ev<.hnd-exn>, x : exception) -> <console|9950> 9952 */
  kk_drop_match(_self, {kk_function_dup(_b_18915_18902, _ctx);}, {}, _ctx)
  kk_std_core__exception _x20563 = kk_std_core__exception_unbox(_b_18905, KK_OWNED, _ctx); /*exception*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_std_core__exception, kk_context_t*), _b_18915_18902, (_b_18915_18902, _b_18903, _b_18904, _x20563, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core__default_exn_fun20564__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core__default_exn_fun20564(kk_function_t _fself, kk_box_t _b_18910, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun20564(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core__default_exn_fun20564, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core__default_exn_fun20564(kk_function_t _fself, kk_box_t _b_18910, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_unit_t _x0_18919 = kk_Unit;
  kk_unit_unbox(_b_18910);
  return kk_unit_box(_x0_18919);
}


// lift anonymous function
struct kk_std_core__default_exn_fun20565__t {
  struct kk_function_s _base;
  kk_function_t action;
};
static kk_box_t kk_std_core__default_exn_fun20565(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun20565(kk_function_t action, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun20565__t* _self = kk_function_alloc_as(struct kk_std_core__default_exn_fun20565__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__default_exn_fun20565, kk_context());
  _self->action = action;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__default_exn_fun20565(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun20565__t* _self = kk_function_as(struct kk_std_core__default_exn_fun20565__t*, _fself, _ctx);
  kk_function_t action = _self->action; /* () -> <exn,console|9950> () */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);}, {}, _ctx)
  kk_unit_t _x20566 = kk_Unit;
  kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx);
  return kk_unit_box(_x20566);
}

kk_unit_t kk_std_core__default_exn(kk_function_t action, kk_context_t* _ctx) { /* forall<e> (action : () -> <console,exn|e> ()) -> <console|e> () */ 
  int32_t _b_18911_18906 = (KK_I32(0)); /*int32*/;
  kk_box_t _x20551;
  kk_function_t _b_18915_18902 = kk_std_core__new_default_exn_fun20552(_ctx); /*(m0 : std/core/hnd/marker<<console|9950>,()>, std/core/hnd/ev<.hnd-exn>, x : exception) -> <console|9950> 9952*/;
  kk_std_core__hnd_exn _x20560;
  kk_std_core_hnd__clause1 _x20561 = kk_std_core_hnd__new_Clause1(kk_std_core__new_default_exn_fun20562(_b_18915_18902, _ctx), _ctx); /*std/core/hnd/clause1<51,52,53,54,55>*/
  _x20560 = kk_std_core__new_Hnd_exn(kk_reuse_null, 0, _x20561, _ctx); /*.hnd-exn<11,12>*/
  _x20551 = kk_std_core__handle_exn(_b_18911_18906, _x20560, kk_std_core__new_default_exn_fun20564(_ctx), kk_std_core__new_default_exn_fun20565(action, _ctx), _ctx); /*1976*/
  kk_unit_unbox(_x20551); return kk_Unit;
}
 
// Get (zero-based) element `n`  of a list. Return a `:maybe` type.

kk_std_core_types__maybe kk_std_core__lp__lb__rb__2_rp_(kk_std_core__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> maybe<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20567 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20567->head;
    kk_std_core__list xx = _con20567->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool _match_19889 = kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
    if (_match_19889) {
      kk_box_drop(x, _ctx);
      { // tailcall
        kk_integer_t _x20568 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        xs = xx;
        n = _x20568;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core__list_drop(xx, _ctx);
      bool _match_19890;
      bool _brw_19891 = kk_integer_eq_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
      kk_integer_drop(n, _ctx);
      _match_19890 = _brw_19891; /*bool*/
      if (_match_19890) {
        return kk_std_core_types__new_Just(x, _ctx);
      }
      {
        kk_box_drop(x, _ctx);
        return kk_std_core_types__new_Nothing(_ctx);
      }
    }
  }
  {
    kk_integer_drop(n, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// O(1). Return the string slice from the end of `slice` argument
// to the end of the string.

kk_std_core__sslice kk_std_core_after(kk_std_core__sslice slice0, kk_context_t* _ctx) { /* (slice : sslice) -> sslice */ 
  {
    kk_string_t s = slice0.str;
    kk_integer_t start0 = slice0.start;
    kk_integer_t len0 = slice0.len;
    kk_integer_t x0_17457;
    kk_string_t _x20569 = kk_string_dup(s, _ctx); /*string*/
    x0_17457 = kk_string_len_int(_x20569,kk_context()); /*int*/
    kk_integer_t y0_17458;
    kk_integer_t _x20570 = kk_integer_dup(start0, _ctx); /*int*/
    kk_integer_t _x20571 = kk_integer_dup(len0, _ctx); /*int*/
    y0_17458 = kk_integer_add(_x20570,_x20571,kk_context()); /*int*/
    kk_integer_t _x20572 = kk_integer_add(start0,len0,kk_context()); /*int*/
    kk_integer_t _x20573 = kk_integer_sub(x0_17457,y0_17458,kk_context()); /*int*/
    return kk_std_core__new_Sslice(s, _x20572, _x20573, _ctx);
  }
}
 
// monadic lift

bool kk_std_core__mlift18018_all(kk_function_t predicate, kk_std_core__list xx, bool _y_17793, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xx : list<a>, bool) -> e bool */ 
  if (_y_17793) {
    return kk_std_core_all(xx, predicate, _ctx);
  }
  {
    kk_std_core__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return false;
  }
}
 
// Do all elements satisfy a predicate ?


// lift anonymous function
struct kk_std_core_all_fun20577__t {
  struct kk_function_s _base;
  kk_function_t predicate0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core_all_fun20577(kk_function_t _fself, kk_box_t _b_18921, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_all_fun20577(kk_function_t predicate0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core_all_fun20577__t* _self = kk_function_alloc_as(struct kk_std_core_all_fun20577__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_all_fun20577, kk_context());
  _self->predicate0 = predicate0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_all_fun20577(kk_function_t _fself, kk_box_t _b_18921, kk_context_t* _ctx) {
  struct kk_std_core_all_fun20577__t* _self = kk_function_as(struct kk_std_core_all_fun20577__t*, _fself, _ctx);
  kk_function_t predicate0 = _self->predicate0; /* (10199) -> 10200 bool */
  kk_std_core__list xx0 = _self->xx0; /* list<10199> */
  kk_drop_match(_self, {kk_function_dup(predicate0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  bool _y_18923_177930 = kk_bool_unbox(_b_18921); /*bool*/;
  bool _x20578 = kk_std_core__mlift18018_all(predicate0, xx0, _y_18923_177930, _ctx); /*bool*/
  return kk_bool_box(_x20578);
}

bool kk_std_core_all(kk_std_core__list xs, kk_function_t predicate0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e bool */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20574 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20574->head;
    kk_std_core__list xx0 = _con20574->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x0_18181;
    kk_function_t _x20575 = kk_function_dup(predicate0, _ctx); /*(10199) -> 10200 bool*/
    x0_18181 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x20575, (_x20575, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x20576 = kk_std_core_hnd_yield_extend(kk_std_core_new_all_fun20577(predicate0, xx0, _ctx), _ctx); /*3926*/
      return kk_bool_unbox(_x20576);
    }
    if (x0_18181) { // tailcall
                    xs = xx0;
                    goto kk__tailcall;
    }
    {
      kk_std_core__list_drop(xx0, _ctx);
      kk_function_drop(predicate0, _ctx);
      return false;
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    return true;
  }
}
 
// monadic lift

bool kk_std_core__mlift18019_any(kk_function_t predicate, kk_std_core__list xx, bool _y_17797, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xx : list<a>, bool) -> e bool */ 
  if (_y_17797) {
    kk_std_core__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return true;
  }
  {
    return kk_std_core_any(xx, predicate, _ctx);
  }
}
 
// Are there any elements in a list that satisfy a predicate ?


// lift anonymous function
struct kk_std_core_any_fun20582__t {
  struct kk_function_s _base;
  kk_function_t predicate0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core_any_fun20582(kk_function_t _fself, kk_box_t _b_18925, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_any_fun20582(kk_function_t predicate0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core_any_fun20582__t* _self = kk_function_alloc_as(struct kk_std_core_any_fun20582__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_any_fun20582, kk_context());
  _self->predicate0 = predicate0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_any_fun20582(kk_function_t _fself, kk_box_t _b_18925, kk_context_t* _ctx) {
  struct kk_std_core_any_fun20582__t* _self = kk_function_as(struct kk_std_core_any_fun20582__t*, _fself, _ctx);
  kk_function_t predicate0 = _self->predicate0; /* (10227) -> 10228 bool */
  kk_std_core__list xx0 = _self->xx0; /* list<10227> */
  kk_drop_match(_self, {kk_function_dup(predicate0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  bool _y_18927_177970 = kk_bool_unbox(_b_18925); /*bool*/;
  bool _x20583 = kk_std_core__mlift18019_any(predicate0, xx0, _y_18927_177970, _ctx); /*bool*/
  return kk_bool_box(_x20583);
}

bool kk_std_core_any(kk_std_core__list xs, kk_function_t predicate0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e bool */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20579 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20579->head;
    kk_std_core__list xx0 = _con20579->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x0_18184;
    kk_function_t _x20580 = kk_function_dup(predicate0, _ctx); /*(10227) -> 10228 bool*/
    x0_18184 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x20580, (_x20580, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x20581 = kk_std_core_hnd_yield_extend(kk_std_core_new_any_fun20582(predicate0, xx0, _ctx), _ctx); /*3926*/
      return kk_bool_unbox(_x20581);
    }
    if (x0_18184) {
      kk_std_core__list_drop(xx0, _ctx);
      kk_function_drop(predicate0, _ctx);
      return true;
    }
    { // tailcall
      xs = xx0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    return false;
  }
}
 
// Return the element at position `index` in vector `v`, or `Nothing` if out of bounds

kk_std_core_types__maybe kk_std_core_at(kk_vector_t v, kk_integer_t index, kk_context_t* _ctx) { /* forall<a> (v : vector<a>, index : int) -> maybe<a> */ 
  kk_ssize_t idx;
  kk_integer_t _x20584 = kk_integer_dup(index, _ctx); /*int*/
  idx = kk_std_core_ssize__t(_x20584, _ctx); /*ssize_t*/
  bool _match_19886;
  kk_ssize_t _x20585 = kk_vector_len_borrow(v,kk_context()); /*ssize_t*/
  _match_19886 = (_x20585 <= idx); /*bool*/
  if (_match_19886) {
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_box_t _x20586 = kk_vector_at_borrow(v,idx,kk_context()); /*228*/
    return kk_std_core_types__new_Just(_x20586, _ctx);
  }
}
 
// O(`n`). The first `n` (default = `1`) characters in a string.

kk_std_core__sslice kk_std_core_first(kk_string_t s, kk_std_core_types__optional n, kk_context_t* _ctx) { /* (s : string, n : optional<int>) -> sslice */ 
  kk_std_core__sslice slice0 = kk_std_core_first1(s, _ctx); /*sslice*/;
  bool _match_19880;
  kk_integer_t _brw_19883;
  if (kk_std_core_types__is_Optional(n, _ctx)) {
    kk_box_t _box_x18928 = n._cons.Optional.value;
    kk_integer_t _n_10357 = kk_integer_unbox(_box_x18928, _ctx);
    kk_integer_dup(_n_10357, _ctx);
    _brw_19883 = _n_10357; /*int*/
  }
  else {
    _brw_19883 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_19884 = kk_integer_eq_borrow(_brw_19883,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_19883, _ctx);
  _match_19880 = _brw_19884; /*bool*/
  if (_match_19880) {
    kk_std_core_types__optional_drop(n, _ctx);
    return slice0;
  }
  {
    kk_integer_t _brw_19881;
    kk_integer_t _x20589;
    if (kk_std_core_types__is_Optional(n, _ctx)) {
      kk_box_t _box_x18929 = n._cons.Optional.value;
      kk_integer_t _n_103570 = kk_integer_unbox(_box_x18929, _ctx);
      kk_integer_dup(_n_103570, _ctx);
      kk_std_core_types__optional_drop(n, _ctx);
      _x20589 = _n_103570; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(n, _ctx);
      _x20589 = kk_integer_from_small(1); /*int*/
    }
    _brw_19881 = kk_integer_add_small_const(_x20589, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_19882 = kk_std_core_extend(slice0, _brw_19881, _ctx); /*sslice*/;
    kk_integer_drop(_brw_19881, _ctx);
    return _brw_19882;
  }
}
 
// Convert the first character of a string to uppercase.

kk_string_t kk_std_core_capitalize(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  kk_std_core__sslice slice2;
  kk_string_t _x20590 = kk_string_dup(s, _ctx); /*string*/
  slice2 = kk_std_core_first1(_x20590, _ctx); /*sslice*/
  kk_std_core__sslice slice1_17468;
  bool _match_19873;
  kk_integer_t _brw_19878;
  kk_std_core_types__optional _match_19877 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_19877, _ctx)) {
    kk_box_t _box_x18930 = _match_19877._cons.Optional.value;
    kk_integer_t _n_103570 = kk_integer_unbox(_box_x18930, _ctx);
    kk_integer_dup(_n_103570, _ctx);
    kk_std_core_types__optional_drop(_match_19877, _ctx);
    _brw_19878 = _n_103570; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_19877, _ctx);
    _brw_19878 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_19879 = kk_integer_eq_borrow(_brw_19878,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_19878, _ctx);
  _match_19873 = _brw_19879; /*bool*/
  if (_match_19873) {
    slice1_17468 = slice2; /*sslice*/
  }
  else {
    kk_integer_t _brw_19875;
    kk_integer_t _x20591;
    kk_std_core_types__optional _match_19874 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_19874, _ctx)) {
      kk_box_t _box_x18931 = _match_19874._cons.Optional.value;
      kk_integer_t _n_1035700 = kk_integer_unbox(_box_x18931, _ctx);
      kk_integer_dup(_n_1035700, _ctx);
      kk_std_core_types__optional_drop(_match_19874, _ctx);
      _x20591 = _n_1035700; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(_match_19874, _ctx);
      _x20591 = kk_integer_from_small(1); /*int*/
    }
    _brw_19875 = kk_integer_add_small_const(_x20591, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_19876 = kk_std_core_extend(slice2, _brw_19875, _ctx); /*sslice*/;
    kk_integer_drop(_brw_19875, _ctx);
    slice1_17468 = _brw_19876; /*sslice*/
  }
  kk_std_core__sslice slice0 = kk_std_core_first1(s, _ctx); /*sslice*/;
  kk_string_t _x20592;
  kk_string_t _x20593;
  kk_std_core__sslice _x20594;
  bool _match_19866;
  kk_integer_t _brw_19871;
  kk_std_core_types__optional _match_19870 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_19870, _ctx)) {
    kk_box_t _box_x18932 = _match_19870._cons.Optional.value;
    kk_integer_t _n_10357 = kk_integer_unbox(_box_x18932, _ctx);
    kk_integer_dup(_n_10357, _ctx);
    kk_std_core_types__optional_drop(_match_19870, _ctx);
    _brw_19871 = _n_10357; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_19870, _ctx);
    _brw_19871 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_19872 = kk_integer_eq_borrow(_brw_19871,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_19871, _ctx);
  _match_19866 = _brw_19872; /*bool*/
  if (_match_19866) {
    _x20594 = slice0; /*sslice*/
  }
  else {
    kk_integer_t _brw_19868;
    kk_integer_t _x20595;
    kk_std_core_types__optional _match_19867 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_19867, _ctx)) {
      kk_box_t _box_x18933 = _match_19867._cons.Optional.value;
      kk_integer_t _n_103571 = kk_integer_unbox(_box_x18933, _ctx);
      kk_integer_dup(_n_103571, _ctx);
      kk_std_core_types__optional_drop(_match_19867, _ctx);
      _x20595 = _n_103571; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(_match_19867, _ctx);
      _x20595 = kk_integer_from_small(1); /*int*/
    }
    _brw_19868 = kk_integer_add_small_const(_x20595, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_19869 = kk_std_core_extend(slice0, _brw_19868, _ctx); /*sslice*/;
    kk_integer_drop(_brw_19868, _ctx);
    _x20594 = _brw_19869; /*sslice*/
  }
  _x20593 = kk_std_core_string_3(_x20594, _ctx); /*string*/
  _x20592 = kk_std_core_to_upper(_x20593, _ctx); /*string*/
  kk_string_t _x20596;
  kk_std_core__sslice _x20597;
  {
    kk_string_t s1 = slice1_17468.str;
    kk_integer_t start0 = slice1_17468.start;
    kk_integer_t len0 = slice1_17468.len;
    kk_integer_t x1_17475;
    kk_string_t _x20598 = kk_string_dup(s1, _ctx); /*string*/
    x1_17475 = kk_string_len_int(_x20598,kk_context()); /*int*/
    kk_integer_t y1_17476;
    kk_integer_t _x20599 = kk_integer_dup(start0, _ctx); /*int*/
    kk_integer_t _x20600 = kk_integer_dup(len0, _ctx); /*int*/
    y1_17476 = kk_integer_add(_x20599,_x20600,kk_context()); /*int*/
    kk_integer_t _x20601 = kk_integer_add(start0,len0,kk_context()); /*int*/
    kk_integer_t _x20602 = kk_integer_sub(x1_17475,y1_17476,kk_context()); /*int*/
    _x20597 = kk_std_core__new_Sslice(s1, _x20601, _x20602, _ctx); /*sslice*/
  }
  _x20596 = kk_std_core_string_3(_x20597, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x20592, _x20596, _ctx);
}
 
// Catch any exception raised in `action` and handle it.
// Use `on-exn` or `on-exit` when appropiate.


// lift anonymous function
struct kk_std_core_try_fun20603__t {
  struct kk_function_s _base;
  kk_function_t hndl;
};
static kk_box_t kk_std_core_try_fun20603(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20603(kk_function_t hndl, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20603__t* _self = kk_function_alloc_as(struct kk_std_core_try_fun20603__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun20603, kk_context());
  _self->hndl = hndl;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_try_fun20604__t {
  struct kk_function_s _base;
  kk_function_t hndl;
  kk_std_core__exception x;
};
static kk_box_t kk_std_core_try_fun20604(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20604(kk_function_t hndl, kk_std_core__exception x, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20604__t* _self = kk_function_alloc_as(struct kk_std_core_try_fun20604__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun20604, kk_context());
  _self->hndl = hndl;
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_try_fun20604(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20604__t* _self = kk_function_as(struct kk_std_core_try_fun20604__t*, _fself, _ctx);
  kk_function_t hndl = _self->hndl; /* (exception) -> 10534 10533 */
  kk_std_core__exception x = _self->x; /* exception */
  kk_drop_match(_self, {kk_function_dup(hndl, _ctx);kk_std_core__exception_dup(x, _ctx);}, {}, _ctx)
  kk_function_drop(___wildcard__525__45, _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core__exception, kk_context_t*), hndl, (hndl, x, _ctx), _ctx);
}
static kk_box_t kk_std_core_try_fun20603(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20603__t* _self = kk_function_as(struct kk_std_core_try_fun20603__t*, _fself, _ctx);
  kk_function_t hndl = _self->hndl; /* (exception) -> 10534 10533 */
  kk_drop_match(_self, {kk_function_dup(hndl, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__525__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_new_try_fun20604(hndl, x, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_fun20607__t {
  struct kk_function_s _base;
  kk_function_t _b_18938_18934;
};
static kk_box_t kk_std_core_try_fun20607(kk_function_t _fself, kk_std_core_hnd__marker _b_18935, kk_std_core_hnd__ev _b_18936, kk_box_t _b_18937, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20607(kk_function_t _b_18938_18934, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20607__t* _self = kk_function_alloc_as(struct kk_std_core_try_fun20607__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun20607, kk_context());
  _self->_b_18938_18934 = _b_18938_18934;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_try_fun20607(kk_function_t _fself, kk_std_core_hnd__marker _b_18935, kk_std_core_hnd__ev _b_18936, kk_box_t _b_18937, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20607__t* _self = kk_function_as(struct kk_std_core_try_fun20607__t*, _fself, _ctx);
  kk_function_t _b_18938_18934 = _self->_b_18938_18934; /* (m0 : std/core/hnd/marker<10534,10533>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 10534 10520 */
  kk_drop_match(_self, {kk_function_dup(_b_18938_18934, _ctx);}, {}, _ctx)
  kk_std_core__exception _x20608 = kk_std_core__exception_unbox(_b_18937, KK_OWNED, _ctx); /*exception*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_std_core__exception, kk_context_t*), _b_18938_18934, (_b_18938_18934, _b_18935, _b_18936, _x20608, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_fun20609__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_try_fun20609(kk_function_t _fself, kk_box_t _x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20609(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_try_fun20609, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_try_fun20609(kk_function_t _fself, kk_box_t _x, kk_context_t* _ctx) {
  kk_unused(_fself);
  return _x;
}

kk_box_t kk_std_core_try(kk_function_t action, kk_function_t hndl, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <exn|e> a, hndl : (exception) -> e a) -> e a */ 
  kk_function_t _b_18938_18934 = kk_std_core_new_try_fun20603(hndl, _ctx); /*(m0 : std/core/hnd/marker<10534,10533>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 10534 10520*/;
  kk_std_core__hnd_exn _x20605;
  kk_std_core_hnd__clause1 _x20606 = kk_std_core_hnd__new_Clause1(kk_std_core_new_try_fun20607(_b_18938_18934, _ctx), _ctx); /*std/core/hnd/clause1<51,52,53,54,55>*/
  _x20605 = kk_std_core__new_Hnd_exn(kk_reuse_null, 0, _x20606, _ctx); /*.hnd-exn<11,12>*/
  return kk_std_core__handle_exn((KK_I32(0)), _x20605, kk_std_core_new_try_fun20609(_ctx), action, _ctx);
}
 
// Transform an exception effect to an  `:error` type.


// lift anonymous function
struct kk_std_core_try_fun20611__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_try_fun20611_1(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20611_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_try_fun20611_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_core_try_fun20612__t_1 {
  struct kk_function_s _base;
  kk_std_core__exception x;
};
static kk_box_t kk_std_core_try_fun20612_1(kk_function_t _fself, kk_function_t _b_18941, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20612_1(kk_std_core__exception x, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20612__t_1* _self = kk_function_alloc_as(struct kk_std_core_try_fun20612__t_1, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun20612_1, kk_context());
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_try_fun20613__t_1 {
  struct kk_function_s _base;
  kk_function_t _b_18941;
};
static kk_std_core__error kk_std_core_try_fun20613_1(kk_function_t _fself, kk_std_core_hnd__resume_result _b_18942, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20613_1(kk_function_t _b_18941, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20613__t_1* _self = kk_function_alloc_as(struct kk_std_core_try_fun20613__t_1, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun20613_1, kk_context());
  _self->_b_18941 = _b_18941;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_core__error kk_std_core_try_fun20613_1(kk_function_t _fself, kk_std_core_hnd__resume_result _b_18942, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20613__t_1* _self = kk_function_as(struct kk_std_core_try_fun20613__t_1*, _fself, _ctx);
  kk_function_t _b_18941 = _self->_b_18941; /* (std/core/hnd/resume-result<3990,3993>) -> 3992 3993 */
  kk_drop_match(_self, {kk_function_dup(_b_18941, _ctx);}, {}, _ctx)
  kk_box_t _x20614 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), _b_18941, (_b_18941, _b_18942, _ctx), _ctx); /*3993*/
  return kk_std_core__error_unbox(_x20614, KK_OWNED, _ctx);
}
static kk_box_t kk_std_core_try_fun20612_1(kk_function_t _fself, kk_function_t _b_18941, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20612__t_1* _self = kk_function_as(struct kk_std_core_try_fun20612__t_1*, _fself, _ctx);
  kk_std_core__exception x = _self->x; /* exception */
  kk_drop_match(_self, {kk_std_core__exception_dup(x, _ctx);}, {}, _ctx)
  kk_function_t ___wildcard__525__45_18962 = kk_std_core_new_try_fun20613_1(_b_18941, _ctx); /*(std/core/hnd/resume-result<10520,error<10572>>) -> 10573 error<10572>*/;
  kk_function_drop(___wildcard__525__45_18962, _ctx);
  kk_std_core__error _x20615 = kk_std_core__new_Error(x, _ctx); /*error<30>*/
  return kk_std_core__error_box(_x20615, _ctx);
}
static kk_box_t kk_std_core_try_fun20611_1(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_datatype_ptr_dropn(___wildcard__525__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_new_try_fun20612_1(x, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_fun20618__t_1 {
  struct kk_function_s _base;
  kk_function_t _b_18958_18943;
};
static kk_box_t kk_std_core_try_fun20618_1(kk_function_t _fself, kk_std_core_hnd__marker _b_18944, kk_std_core_hnd__ev _b_18945, kk_box_t _b_18946, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20618_1(kk_function_t _b_18958_18943, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20618__t_1* _self = kk_function_alloc_as(struct kk_std_core_try_fun20618__t_1, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun20618_1, kk_context());
  _self->_b_18958_18943 = _b_18958_18943;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_try_fun20618_1(kk_function_t _fself, kk_std_core_hnd__marker _b_18944, kk_std_core_hnd__ev _b_18945, kk_box_t _b_18946, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20618__t_1* _self = kk_function_as(struct kk_std_core_try_fun20618__t_1*, _fself, _ctx);
  kk_function_t _b_18958_18943 = _self->_b_18958_18943; /* (m0 : std/core/hnd/marker<10573,error<10572>>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 10573 10520 */
  kk_drop_match(_self, {kk_function_dup(_b_18958_18943, _ctx);}, {}, _ctx)
  kk_std_core__exception _x20619 = kk_std_core__exception_unbox(_b_18946, KK_OWNED, _ctx); /*exception*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_std_core__exception, kk_context_t*), _b_18958_18943, (_b_18958_18943, _b_18944, _b_18945, _x20619, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_fun20620__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_try_fun20620_1(kk_function_t _fself, kk_box_t _b_18953, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20620_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_try_fun20620_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_try_fun20620_1(kk_function_t _fself, kk_box_t _b_18953, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x_18963 = kk_std_core__error_unbox(_b_18953, KK_OWNED, _ctx); /*error<10572>*/;
  return kk_std_core__error_box(_x_18963, _ctx);
}


// lift anonymous function
struct kk_std_core_try_fun20621__t_1 {
  struct kk_function_s _base;
  kk_function_t action;
};
static kk_box_t kk_std_core_try_fun20621_1(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20621_1(kk_function_t action, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20621__t_1* _self = kk_function_alloc_as(struct kk_std_core_try_fun20621__t_1, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun20621_1, kk_context());
  _self->action = action;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_try_fun20624__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_try_fun20624_1(kk_function_t _fself, kk_box_t _b_18948, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun20624_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_try_fun20624_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_try_fun20624_1(kk_function_t _fself, kk_box_t _b_18948, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _y_18964_17802 = _b_18948; /*10572*/;
  kk_std_core__error _x20625 = kk_std_core__new_Ok(_y_18964_17802, _ctx); /*error<30>*/
  return kk_std_core__error_box(_x20625, _ctx);
}
static kk_box_t kk_std_core_try_fun20621_1(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_try_fun20621__t_1* _self = kk_function_as(struct kk_std_core_try_fun20621__t_1*, _fself, _ctx);
  kk_function_t action = _self->action; /* () -> <exn|10573> 10572 */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);}, {}, _ctx)
  kk_box_t x0_18189 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx); /*10572*/;
  kk_std_core__error _x20622;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x0_18189, _ctx);
    kk_box_t _x20623 = kk_std_core_hnd_yield_extend(kk_std_core_new_try_fun20624_1(_ctx), _ctx); /*3926*/
    _x20622 = kk_std_core__error_unbox(_x20623, KK_OWNED, _ctx); /*error<10572>*/
  }
  else {
    _x20622 = kk_std_core__new_Ok(x0_18189, _ctx); /*error<10572>*/
  }
  return kk_std_core__error_box(_x20622, _ctx);
}

kk_std_core__error kk_std_core_try_1(kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <exn|e> a) -> e error<a> */ 
  int32_t _b_18954_18949 = (KK_I32(0)); /*int32*/;
  kk_box_t _x20610;
  kk_function_t _b_18958_18943 = kk_std_core_new_try_fun20611_1(_ctx); /*(m0 : std/core/hnd/marker<10573,error<10572>>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 10573 10520*/;
  kk_std_core__hnd_exn _x20616;
  kk_std_core_hnd__clause1 _x20617 = kk_std_core_hnd__new_Clause1(kk_std_core_new_try_fun20618_1(_b_18958_18943, _ctx), _ctx); /*std/core/hnd/clause1<51,52,53,54,55>*/
  _x20616 = kk_std_core__new_Hnd_exn(kk_reuse_null, 0, _x20617, _ctx); /*.hnd-exn<11,12>*/
  _x20610 = kk_std_core__handle_exn(_b_18954_18949, _x20616, kk_std_core_new_try_fun20620_1(_ctx), kk_std_core_new_try_fun20621_1(action, _ctx), _ctx); /*1976*/
  return kk_std_core__error_unbox(_x20610, KK_OWNED, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core_cdivmod_exp10(kk_integer_t i, kk_integer_t n, kk_context_t* _ctx) { /* (i : int, n : int) -> (int, int) */ 
  bool _match_19864 = kk_integer_lte_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_19864) {
    kk_integer_drop(n, _ctx);
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(i, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
  }
  {
    kk_integer_t cq;
    kk_integer_t _x20626 = kk_integer_dup(i, _ctx); /*int*/
    kk_integer_t _x20627 = kk_integer_dup(n, _ctx); /*int*/
    cq = kk_std_core_cdiv_exp10(_x20626, _x20627, _ctx); /*int*/
    kk_integer_t y_17482;
    kk_integer_t _x20628 = kk_integer_dup(cq, _ctx); /*int*/
    y_17482 = kk_std_core_mul_exp10(_x20628, n, _ctx); /*int*/
    kk_integer_t cr = kk_integer_sub(i,y_17482,kk_context()); /*int*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(cq, _ctx), kk_integer_box(cr, _ctx), _ctx);
  }
}
 
// Concatenate a list of `:maybe` values

kk_std_core__list kk_std_core__trmc_concat_maybe(kk_std_core__list xs, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<maybe<a>>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20629 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x18973 = _con20629->head;
    kk_std_core__list xx = _con20629->tail;
    kk_std_core_types__maybe x = kk_std_core_types__maybe_unbox(_box_x18973, KK_BORROWED, _ctx);
    kk_reuse_t _ru_20039 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core_types__maybe_dup(x, _ctx);
      kk_box_drop(_box_x18973, _ctx);
      _ru_20039 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_std_core_types__maybe_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Just(x, _ctx)) {
      kk_box_t y = x._cons.Just.value;
      kk_std_core__list _trmc_17693 = kk_datatype_null(); /*list<10712>*/;
      kk_std_core__list _trmc_17694 = kk_std_core__new_Cons(_ru_20039, 0, y, _trmc_17693, _ctx); /*list<10712>*/;
      kk_box_t* _b_18984_18979 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17694, _ctx)->tail)); /*field-addr<list<10712>>*/;
      { // tailcall
        kk_std_core_types__cctx _x20630 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17694, _ctx)),_b_18984_18979,true,kk_context()); /*ctx<0>*/
        xs = xx;
        _acc = _x20630;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_20039,kk_context());
      { // tailcall
        xs = xx;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_box_t _x20631 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20631, KK_OWNED, _ctx);
  }
}
 
// Concatenate a list of `:maybe` values

kk_std_core__list kk_std_core_concat_maybe(kk_std_core__list xs0, kk_context_t* _ctx) { /* forall<a> (xs : list<maybe<a>>) -> list<a> */ 
  kk_std_core_types__cctx _x20632 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_concat_maybe(xs0, _x20632, _ctx);
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18021_lift17320_for_whilez(kk_function_t action, kk_ssize_t end, kk_ssize_t i, kk_std_core_types__maybe _y_17805, kk_context_t* _ctx) { /* forall<a,e> (action : (ssize_t) -> e maybe<a>, end : ssize_t, i : ssize_t, maybe<a>) -> e maybe<a> */ 
  if (kk_std_core_types__is_Nothing(_y_17805, _ctx)) {
    kk_ssize_t i0_17483 = kk_std_core_incr_1(i, _ctx); /*ssize_t*/;
    return kk_std_core__lift17320_for_whilez(action, end, i0_17483, _ctx);
  }
  {
    kk_box_t x = _y_17805._cons.Just.value;
    kk_function_drop(action, _ctx);
    return kk_std_core_types__new_Just(x, _ctx);
  }
}
 
// lifted local: for-whilez, rep


// lift anonymous function
struct kk_std_core__lift17320_for_whilez_fun20635__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_ssize_t end0;
  kk_ssize_t i0;
};
static kk_box_t kk_std_core__lift17320_for_whilez_fun20635(kk_function_t _fself, kk_box_t _b_18991, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift17320_for_whilez_fun20635(kk_function_t action0, kk_ssize_t end0, kk_ssize_t i0, kk_context_t* _ctx) {
  struct kk_std_core__lift17320_for_whilez_fun20635__t* _self = kk_function_alloc_as(struct kk_std_core__lift17320_for_whilez_fun20635__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift17320_for_whilez_fun20635, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift17320_for_whilez_fun20635(kk_function_t _fself, kk_box_t _b_18991, kk_context_t* _ctx) {
  struct kk_std_core__lift17320_for_whilez_fun20635__t* _self = kk_function_as(struct kk_std_core__lift17320_for_whilez_fun20635__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (ssize_t) -> 10767 maybe<10766> */
  kk_ssize_t end0 = _self->end0; /* ssize_t */
  kk_ssize_t i0 = _self->i0; /* ssize_t */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);;;}, {}, _ctx)
  kk_std_core_types__maybe _y_18993_178050 = kk_std_core_types__maybe_unbox(_b_18991, KK_OWNED, _ctx); /*maybe<10766>*/;
  kk_std_core_types__maybe _x20636 = kk_std_core__mlift18021_lift17320_for_whilez(action0, end0, i0, _y_18993_178050, _ctx); /*maybe<10766>*/
  return kk_std_core_types__maybe_box(_x20636, _ctx);
}

kk_std_core_types__maybe kk_std_core__lift17320_for_whilez(kk_function_t action0, kk_ssize_t end0, kk_ssize_t i0, kk_context_t* _ctx) { /* forall<a,e> (action : (ssize_t) -> e maybe<a>, end : ssize_t, i : ssize_t) -> e maybe<a> */ 
  kk__tailcall: ;
  bool _match_19862 = (i0 <= end0); /*bool*/;
  if (_match_19862) {
    kk_std_core_types__maybe x0_18192;
    kk_function_t _x20633 = kk_function_dup(action0, _ctx); /*(ssize_t) -> 10767 maybe<10766>*/
    x0_18192 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_ssize_t, kk_context_t*), _x20633, (_x20633, i0, _ctx), _ctx); /*maybe<10766>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_18192, _ctx);
      kk_box_t _x20634 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift17320_for_whilez_fun20635(action0, end0, i0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x20634, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x0_18192, _ctx)) {
      kk_ssize_t i0_174830 = kk_std_core_incr_1(i0, _ctx); /*ssize_t*/;
      { // tailcall
        i0 = i0_174830;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t x1 = x0_18192._cons.Just.value;
      kk_function_drop(action0, _ctx);
      return kk_std_core_types__new_Just(x1, _ctx);
    }
  }
  {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18022_foreach_while(kk_function_t action, kk_std_core__list xx, kk_std_core_types__maybe _y_17810, kk_context_t* _ctx) { /* forall<a,b,e> (action : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e maybe<b> */ 
  if (kk_std_core_types__is_Nothing(_y_17810, _ctx)) {
    return kk_std_core_foreach_while(xx, action, _ctx);
  }
  {
    kk_std_core__list_drop(xx, _ctx);
    kk_function_drop(action, _ctx);
    return _y_17810;
  }
}
 
// Invoke `action` for each element of a list while `action` return `Nothing`


// lift anonymous function
struct kk_std_core_foreach_while_fun20642__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core_foreach_while_fun20642(kk_function_t _fself, kk_box_t _b_18995, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_while_fun20642(kk_function_t action0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core_foreach_while_fun20642__t* _self = kk_function_alloc_as(struct kk_std_core_foreach_while_fun20642__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_while_fun20642, kk_context());
  _self->action0 = action0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_foreach_while_fun20642(kk_function_t _fself, kk_box_t _b_18995, kk_context_t* _ctx) {
  struct kk_std_core_foreach_while_fun20642__t* _self = kk_function_as(struct kk_std_core_foreach_while_fun20642__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (10898) -> 10900 maybe<10899> */
  kk_std_core__list xx0 = _self->xx0; /* list<10898> */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_18997_178100 = kk_std_core_types__maybe_unbox(_b_18995, KK_OWNED, _ctx); /*maybe<10899>*/;
  kk_std_core_types__maybe _x20643 = kk_std_core__mlift18022_foreach_while(action0, xx0, _y_18997_178100, _ctx); /*maybe<10899>*/
  return kk_std_core_types__maybe_box(_x20643, _ctx);
}

kk_std_core_types__maybe kk_std_core_foreach_while(kk_std_core__list xs, kk_function_t action0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>) -> e maybe<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    struct kk_std_core_Cons* _con20639 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20639->head;
    kk_std_core__list xx0 = _con20639->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x0_18195;
    kk_function_t _x20640 = kk_function_dup(action0, _ctx); /*(10898) -> 10900 maybe<10899>*/
    x0_18195 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x20640, (_x20640, x, _ctx), _ctx); /*maybe<10899>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_18195, _ctx);
      kk_box_t _x20641 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_while_fun20642(action0, xx0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x20641, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x0_18195, _ctx)) { // tailcall
                                                         xs = xx0;
                                                         goto kk__tailcall;
    }
    {
      kk_std_core__list_drop(xx0, _ctx);
      kk_function_drop(action0, _ctx);
      return x0_18195;
    }
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18023_foreach_while_1(kk_function_t action, kk_std_core__sslice rest, kk_std_core_types__maybe _y_17814, kk_context_t* _ctx) { /* forall<a,e> (action : (c : char) -> e maybe<a>, rest : sslice, maybe<a>) -> e maybe<a> */ 
  if (kk_std_core_types__is_Nothing(_y_17814, _ctx)) {
    return kk_std_core_foreach_while_1(rest, action, _ctx);
  }
  {
    kk_std_core__sslice_drop(rest, _ctx);
    kk_function_drop(action, _ctx);
    return _y_17814;
  }
}
 
// Apply a function for each character in a string slice.
// If `action` returns `Just`, the function returns immediately with that result.


// lift anonymous function
struct kk_std_core_foreach_while_fun20646__t_1 {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_std_core__sslice rest0;
};
static kk_box_t kk_std_core_foreach_while_fun20646_1(kk_function_t _fself, kk_box_t _b_19002, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_while_fun20646_1(kk_function_t action0, kk_std_core__sslice rest0, kk_context_t* _ctx) {
  struct kk_std_core_foreach_while_fun20646__t_1* _self = kk_function_alloc_as(struct kk_std_core_foreach_while_fun20646__t_1, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_while_fun20646_1, kk_context());
  _self->action0 = action0;
  _self->rest0 = rest0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_foreach_while_fun20646_1(kk_function_t _fself, kk_box_t _b_19002, kk_context_t* _ctx) {
  struct kk_std_core_foreach_while_fun20646__t_1* _self = kk_function_as(struct kk_std_core_foreach_while_fun20646__t_1*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (c : char) -> 10985 maybe<10984> */
  kk_std_core__sslice rest0 = _self->rest0; /* sslice */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_std_core__sslice_dup(rest0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_19004_178140 = kk_std_core_types__maybe_unbox(_b_19002, KK_OWNED, _ctx); /*maybe<10984>*/;
  kk_std_core_types__maybe _x20647 = kk_std_core__mlift18023_foreach_while_1(action0, rest0, _y_19004_178140, _ctx); /*maybe<10984>*/
  return kk_std_core_types__maybe_box(_x20647, _ctx);
}

kk_std_core_types__maybe kk_std_core_foreach_while_1(kk_std_core__sslice slice0, kk_function_t action0, kk_context_t* _ctx) { /* forall<a,e> (slice : sslice, action : (c : char) -> e maybe<a>) -> e maybe<a> */ 
  kk__tailcall: ;
  kk_std_core_types__maybe _match_19859 = kk_std_core_next(slice0, _ctx); /*maybe<(char, sslice)>*/;
  if (kk_std_core_types__is_Nothing(_match_19859, _ctx)) {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_box_t _box_x18998 = _match_19859._cons.Just.value;
    kk_std_core_types__tuple2_ _pat1 = kk_std_core_types__tuple2__unbox(_box_x18998, KK_BORROWED, _ctx);
    kk_box_t _box_x18999 = _pat1.fst;
    kk_box_t _box_x19000 = _pat1.snd;
    kk_std_core__sslice rest0 = kk_std_core__sslice_unbox(_box_x19000, KK_BORROWED, _ctx);
    kk_char_t c = kk_char_unbox(_box_x18999, KK_BORROWED, _ctx);
    kk_std_core__sslice_dup(rest0, _ctx);
    kk_std_core_types__maybe_drop(_match_19859, _ctx);
    kk_std_core_types__maybe x_18198;
    kk_function_t _x20644 = kk_function_dup(action0, _ctx); /*(c : char) -> 10985 maybe<10984>*/
    x_18198 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_char_t, kk_context_t*), _x20644, (_x20644, c, _ctx), _ctx); /*maybe<10984>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x_18198, _ctx);
      kk_box_t _x20645 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_while_fun20646_1(action0, rest0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x20645, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x_18198, _ctx)) { // tailcall
                                                        slice0 = rest0;
                                                        goto kk__tailcall;
    }
    {
      kk_std_core__sslice_drop(rest0, _ctx);
      kk_function_drop(action0, _ctx);
      return x_18198;
    }
  }
}
 
// Invoke a function `f` for each element in a vector `v`.
// If `f` returns `Just`, the iteration is stopped early and the result is returned.


// lift anonymous function
struct kk_std_core_foreach_while_fun20652__t_3 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_vector_t v;
};
static kk_std_core_types__maybe kk_std_core_foreach_while_fun20652_3(kk_function_t _fself, kk_ssize_t i0, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_while_fun20652_3(kk_function_t f, kk_vector_t v, kk_context_t* _ctx) {
  struct kk_std_core_foreach_while_fun20652__t_3* _self = kk_function_alloc_as(struct kk_std_core_foreach_while_fun20652__t_3, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_while_fun20652_3, kk_context());
  _self->f = f;
  _self->v = v;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_core_types__maybe kk_std_core_foreach_while_fun20652_3(kk_function_t _fself, kk_ssize_t i0, kk_context_t* _ctx) {
  struct kk_std_core_foreach_while_fun20652__t_3* _self = kk_function_as(struct kk_std_core_foreach_while_fun20652__t_3*, _fself, _ctx);
  kk_function_t f = _self->f; /* (11083) -> 11085 maybe<11084> */
  kk_vector_t v = _self->v; /* vector<11083> */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_vector_dup(v, _ctx);}, {}, _ctx)
  kk_box_t _x20653;
  kk_box_t _brw_19858 = kk_vector_at_borrow(v,i0,kk_context()); /*228*/;
  kk_vector_drop(v, _ctx);
  _x20653 = _brw_19858; /*228*/
  return kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x20653, _ctx), _ctx);
}

kk_std_core_types__maybe kk_std_core_foreach_while_3(kk_vector_t v, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (v : vector<a>, f : (a) -> e maybe<b>) -> e maybe<b> */ 
  kk_ssize_t start0_17484 = (KK_IZ(0)); /*ssize_t*/;
  kk_ssize_t end_17485;
  kk_ssize_t _x20651 = kk_vector_len_borrow(v,kk_context()); /*ssize_t*/
  end_17485 = kk_std_core_decr_1(_x20651, _ctx); /*ssize_t*/
  return kk_std_core__lift17320_for_whilez(kk_std_core_new_foreach_while_fun20652_3(f, v, _ctx), end_17485, start0_17484, _ctx);
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18024_foreach(kk_function_t action, kk_std_core__list xx, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<a,e> (action : (a) -> e (), xx : list<a>, wild_ : ()) -> e () */ 
  kk_std_core_foreach(xx, action, _ctx); return kk_Unit;
}
 
// Invoke `action` for each element of a list


// lift anonymous function
struct kk_std_core_foreach_fun20657__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core_foreach_fun20657(kk_function_t _fself, kk_box_t _b_19006, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_fun20657(kk_function_t action0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core_foreach_fun20657__t* _self = kk_function_alloc_as(struct kk_std_core_foreach_fun20657__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_fun20657, kk_context());
  _self->action0 = action0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_foreach_fun20657(kk_function_t _fself, kk_box_t _b_19006, kk_context_t* _ctx) {
  struct kk_std_core_foreach_fun20657__t* _self = kk_function_as(struct kk_std_core_foreach_fun20657__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (11277) -> 11278 () */
  kk_std_core__list xx0 = _self->xx0; /* list<11277> */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  kk_unit_t wild__0_19008 = kk_Unit;
  kk_unit_unbox(_b_19006);
  kk_unit_t _x20658 = kk_Unit;
  kk_std_core__mlift18024_foreach(action0, xx0, wild__0_19008, _ctx);
  return kk_unit_box(_x20658);
}

kk_unit_t kk_std_core_foreach(kk_std_core__list xs, kk_function_t action0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, action : (a) -> e ()) -> e () */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20654 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20654->head;
    kk_std_core__list xx0 = _con20654->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_unit_t x0_18201 = kk_Unit;
    kk_function_t _x20655 = kk_function_dup(action0, _ctx); /*(11277) -> 11278 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_box_t, kk_context_t*), _x20655, (_x20655, x, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x20656 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_fun20657(action0, xx0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x20656); return kk_Unit;
    }
    { // tailcall
      xs = xx0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Apply a function for each character in a string slice.


// lift anonymous function
struct kk_std_core_foreach_fun20659__t_1 {
  struct kk_function_s _base;
  kk_function_t action;
};
static kk_std_core_types__maybe kk_std_core_foreach_fun20659_1(kk_function_t _fself, kk_char_t c, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_fun20659_1(kk_function_t action, kk_context_t* _ctx) {
  struct kk_std_core_foreach_fun20659__t_1* _self = kk_function_alloc_as(struct kk_std_core_foreach_fun20659__t_1, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_fun20659_1, kk_context());
  _self->action = action;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_foreach_fun20661__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_foreach_fun20661_1(kk_function_t _fself, kk_box_t _b_19010, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_fun20661_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_foreach_fun20661_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_foreach_fun20661_1(kk_function_t _fself, kk_box_t _b_19010, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_drop(_b_19010, _ctx);
  return kk_std_core_types__maybe_box(kk_std_core_types__new_Nothing(_ctx), _ctx);
}
static kk_std_core_types__maybe kk_std_core_foreach_fun20659_1(kk_function_t _fself, kk_char_t c, kk_context_t* _ctx) {
  struct kk_std_core_foreach_fun20659__t_1* _self = kk_function_as(struct kk_std_core_foreach_fun20659__t_1*, _fself, _ctx);
  kk_function_t action = _self->action; /* (c : char) -> 11336 () */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);}, {}, _ctx)
  kk_unit_t x0_18207 = kk_Unit;
  kk_function_call(kk_unit_t, (kk_function_t, kk_char_t, kk_context_t*), action, (action, c, _ctx), _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x20660 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_fun20661_1(_ctx), _ctx); /*3926*/
    return kk_std_core_types__maybe_unbox(_x20660, KK_OWNED, _ctx);
  }
  {
    return kk_std_core_types__new_Nothing(_ctx);
  }
}


// lift anonymous function
struct kk_std_core_foreach_fun20663__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_foreach_fun20663_1(kk_function_t _fself, kk_box_t _b_19014, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_fun20663_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_foreach_fun20663_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_foreach_fun20663_1(kk_function_t _fself, kk_box_t _b_19014, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__maybe wild__00_19016 = kk_std_core_types__maybe_unbox(_b_19014, KK_OWNED, _ctx); /*maybe<_11323>*/;
  kk_std_core_types__maybe_drop(wild__00_19016, _ctx);
  return kk_unit_box(kk_Unit);
}

kk_unit_t kk_std_core_foreach_1(kk_std_core__sslice slice0, kk_function_t action, kk_context_t* _ctx) { /* forall<e> (slice : sslice, action : (c : char) -> e ()) -> e () */ 
  kk_std_core_types__maybe x_18204 = kk_std_core_foreach_while_1(slice0, kk_std_core_new_foreach_fun20659_1(action, _ctx), _ctx); /*maybe<_11323>*/;
  kk_std_core_types__maybe_drop(x_18204, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x20662 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_fun20663_1(_ctx), _ctx); /*3926*/
    kk_unit_unbox(_x20662); return kk_Unit;
  }
  {
    kk_Unit; return kk_Unit;
  }
}
 
// Invoke a function for each character in a string


// lift anonymous function
struct kk_std_core_foreach_fun20666__t_2 {
  struct kk_function_s _base;
  kk_function_t action;
};
static kk_std_core_types__maybe kk_std_core_foreach_fun20666_2(kk_function_t _fself, kk_char_t c, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_fun20666_2(kk_function_t action, kk_context_t* _ctx) {
  struct kk_std_core_foreach_fun20666__t_2* _self = kk_function_alloc_as(struct kk_std_core_foreach_fun20666__t_2, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_fun20666_2, kk_context());
  _self->action = action;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_foreach_fun20668__t_2 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_foreach_fun20668_2(kk_function_t _fself, kk_box_t _b_19018, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_fun20668_2(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_foreach_fun20668_2, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_foreach_fun20668_2(kk_function_t _fself, kk_box_t _b_19018, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_drop(_b_19018, _ctx);
  return kk_std_core_types__maybe_box(kk_std_core_types__new_Nothing(_ctx), _ctx);
}
static kk_std_core_types__maybe kk_std_core_foreach_fun20666_2(kk_function_t _fself, kk_char_t c, kk_context_t* _ctx) {
  struct kk_std_core_foreach_fun20666__t_2* _self = kk_function_as(struct kk_std_core_foreach_fun20666__t_2*, _fself, _ctx);
  kk_function_t action = _self->action; /* (c : char) -> 11375 () */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);}, {}, _ctx)
  kk_unit_t x0_18214 = kk_Unit;
  kk_function_call(kk_unit_t, (kk_function_t, kk_char_t, kk_context_t*), action, (action, c, _ctx), _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x20667 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_fun20668_2(_ctx), _ctx); /*3926*/
    return kk_std_core_types__maybe_unbox(_x20667, KK_OWNED, _ctx);
  }
  {
    return kk_std_core_types__new_Nothing(_ctx);
  }
}


// lift anonymous function
struct kk_std_core_foreach_fun20670__t_2 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_foreach_fun20670_2(kk_function_t _fself, kk_box_t _b_19022, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_fun20670_2(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_foreach_fun20670_2, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_foreach_fun20670_2(kk_function_t _fself, kk_box_t _b_19022, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__maybe wild__00_19024 = kk_std_core_types__maybe_unbox(_b_19022, KK_OWNED, _ctx); /*maybe<_11323>*/;
  kk_std_core_types__maybe_drop(wild__00_19024, _ctx);
  return kk_unit_box(kk_Unit);
}

kk_unit_t kk_std_core_foreach_2(kk_string_t s, kk_function_t action, kk_context_t* _ctx) { /* forall<e> (s : string, action : (c : char) -> e ()) -> e () */ 
  kk_std_core__sslice slice0_17487;
  kk_string_t _x20664 = kk_string_dup(s, _ctx); /*string*/
  kk_integer_t _x20665 = kk_string_len_int(s,kk_context()); /*int*/
  slice0_17487 = kk_std_core__new_Sslice(_x20664, kk_integer_from_small(0), _x20665, _ctx); /*sslice*/
  kk_std_core_types__maybe x_18211 = kk_std_core_foreach_while_1(slice0_17487, kk_std_core_new_foreach_fun20666_2(action, _ctx), _ctx); /*maybe<_11323>*/;
  kk_std_core_types__maybe_drop(x_18211, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x20669 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_fun20670_2(_ctx), _ctx); /*3926*/
    kk_unit_unbox(_x20669); return kk_Unit;
  }
  {
    kk_Unit; return kk_Unit;
  }
}
 
// Invoke a function `f` for each element in a vector `v`


// lift anonymous function
struct kk_std_core_foreach_fun20672__t_3 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_vector_t v;
};
static kk_unit_t kk_std_core_foreach_fun20672_3(kk_function_t _fself, kk_ssize_t i0, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_fun20672_3(kk_function_t f, kk_vector_t v, kk_context_t* _ctx) {
  struct kk_std_core_foreach_fun20672__t_3* _self = kk_function_alloc_as(struct kk_std_core_foreach_fun20672__t_3, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_fun20672_3, kk_context());
  _self->f = f;
  _self->v = v;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_unit_t kk_std_core_foreach_fun20672_3(kk_function_t _fself, kk_ssize_t i0, kk_context_t* _ctx) {
  struct kk_std_core_foreach_fun20672__t_3* _self = kk_function_as(struct kk_std_core_foreach_fun20672__t_3*, _fself, _ctx);
  kk_function_t f = _self->f; /* (11390) -> 11391 () */
  kk_vector_t v = _self->v; /* vector<11390> */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_vector_dup(v, _ctx);}, {}, _ctx)
  kk_box_t x_18354;
  kk_box_t _brw_19852 = kk_vector_at_borrow(v,i0,kk_context()); /*228*/;
  kk_vector_drop(v, _ctx);
  x_18354 = _brw_19852; /*11390*/
  return kk_function_call(kk_unit_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x_18354, _ctx), _ctx);
}

kk_unit_t kk_std_core_foreach_3(kk_vector_t v, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e> (v : vector<a>, f : (a) -> e ()) -> e () */ 
  kk_ssize_t start0_17410 = (KK_IZ(0)); /*ssize_t*/;
  kk_ssize_t end_17411;
  kk_ssize_t _x20671 = kk_vector_len_borrow(v,kk_context()); /*ssize_t*/
  end_17411 = kk_std_core_decr_1(_x20671, _ctx); /*ssize_t*/
  kk_std_core__lift17317_forz(kk_std_core_new_foreach_fun20672_3(f, v, _ctx), end_17411, start0_17410, _ctx); return kk_Unit;
}
 
// O(n). Return the number of characters in a string.

kk_integer_t kk_std_core_count_1(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> int */ 
  return kk_string_count_int(s,kk_context());
}
 
// O(n). Return the number of characters in a string slice

kk_integer_t kk_std_core_count_2(kk_std_core__sslice slice0, kk_context_t* _ctx) { /* (slice : sslice) -> int */ 
  return kk_slice_count(slice0,kk_context());
}
 
// Count the number of times a predicate is true for each character in a string


// lift anonymous function
struct kk_std_core_count_fun20676__t_3 {
  struct kk_function_s _base;
  kk_ref_t loc;
  kk_function_t pred;
};
static kk_std_core_types__maybe kk_std_core_count_fun20676_3(kk_function_t _fself, kk_char_t c, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_count_fun20676_3(kk_ref_t loc, kk_function_t pred, kk_context_t* _ctx) {
  struct kk_std_core_count_fun20676__t_3* _self = kk_function_alloc_as(struct kk_std_core_count_fun20676__t_3, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_count_fun20676_3, kk_context());
  _self->loc = loc;
  _self->pred = pred;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_core_types__maybe kk_std_core_count_fun20676_3(kk_function_t _fself, kk_char_t c, kk_context_t* _ctx) {
  struct kk_std_core_count_fun20676__t_3* _self = kk_function_as(struct kk_std_core_count_fun20676__t_3*, _fself, _ctx);
  kk_ref_t loc = _self->loc; /* local-var<11584,int> */
  kk_function_t pred = _self->pred; /* (char) -> bool */
  kk_drop_match(_self, {kk_ref_dup(loc, _ctx);kk_function_dup(pred, _ctx);}, {}, _ctx)
  kk_unit_t __ = kk_Unit;
  bool _match_19850 = kk_function_call(bool, (kk_function_t, kk_char_t, kk_context_t*), pred, (pred, c, _ctx), _ctx); /*bool*/;
  if (_match_19850) {
    kk_integer_t x_17492;
    kk_box_t _x20677;
    kk_ref_t _x20678 = kk_ref_dup(loc, _ctx); /*local-var<11584,int>*/
    _x20677 = kk_ref_get(_x20678,kk_context()); /*264*/
    x_17492 = kk_integer_unbox(_x20677, _ctx); /*int*/
    kk_integer_t _b_19032_19030 = kk_integer_add_small_const(x_17492, 1, _ctx); /*int*/;
    kk_unit_t _brw_19851 = kk_Unit;
    kk_ref_set_borrow(loc,(kk_integer_box(_b_19032_19030, _ctx)),kk_context());
    kk_ref_drop(loc, _ctx);
    _brw_19851;
  }
  else {
    kk_ref_drop(loc, _ctx);
  }
  return kk_std_core_types__new_Nothing(_ctx);
}

kk_integer_t kk_std_core_count_3(kk_string_t s, kk_function_t pred, kk_context_t* _ctx) { /* (s : string, pred : (char) -> bool) -> int */ 
  kk_ref_t loc = kk_ref_alloc((kk_integer_box(kk_integer_from_small(0), _ctx)),kk_context()); /*local-var<11584,int>*/;
  kk_std_core__sslice slice0_17494;
  kk_string_t _x20673 = kk_string_dup(s, _ctx); /*string*/
  kk_integer_t _x20674 = kk_string_len_int(s,kk_context()); /*int*/
  slice0_17494 = kk_std_core__new_Sslice(_x20673, kk_integer_from_small(0), _x20674, _ctx); /*sslice*/
  kk_std_core_types__maybe __0;
  kk_function_t _x20675;
  kk_ref_dup(loc, _ctx);
  _x20675 = kk_std_core_new_count_fun20676_3(loc, pred, _ctx); /*(c : char) -> (local<11584>) (forall<a> maybe<a>)*/
  __0 = kk_std_core_foreach_while_1(slice0_17494, _x20675, _ctx); /*maybe<_11323>*/
  kk_std_core_types__maybe_drop(__0, _ctx);
  kk_integer_t res;
  kk_box_t _x20679;
  kk_ref_t _x20680 = kk_ref_dup(loc, _ctx); /*local-var<11584,int>*/
  _x20679 = kk_ref_get(_x20680,kk_context()); /*264*/
  res = kk_integer_unbox(_x20679, _ctx); /*int*/
  kk_box_t _x20681 = kk_std_core_hnd_prompt_local_var(loc, kk_integer_box(res, _ctx), _ctx); /*10459*/
  return kk_integer_unbox(_x20681, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core_divmod_exp10(kk_integer_t i, kk_integer_t n, kk_context_t* _ctx) { /* (i : int, n : int) -> (int, int) */ 
  kk_std_core_types__tuple2_ _match_19848;
  kk_integer_t _x20685 = kk_integer_dup(n, _ctx); /*int*/
  _match_19848 = kk_std_core_cdivmod_exp10(i, _x20685, _ctx); /*(int, int)*/
  {
    kk_box_t _box_x19044 = _match_19848.fst;
    kk_box_t _box_x19045 = _match_19848.snd;
    kk_integer_t cq = kk_integer_unbox(_box_x19044, _ctx);
    kk_integer_t cr = kk_integer_unbox(_box_x19045, _ctx);
    kk_integer_dup(cq, _ctx);
    kk_integer_dup(cr, _ctx);
    kk_std_core_types__tuple2__drop(_match_19848, _ctx);
    bool b_17499 = kk_integer_lt_borrow(cr,(kk_integer_from_small(0)),kk_context()); /*bool*/;
    if (b_17499) {
      kk_integer_t y0_17505 = kk_std_core_mul_exp10(kk_integer_from_small(1), n, _ctx); /*int*/;
      kk_integer_t _b_19050_19046 = kk_integer_add_small_const(cq, -1, _ctx); /*int*/;
      kk_integer_t _b_19051_19047 = kk_integer_add(cr,y0_17505,kk_context()); /*int*/;
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_19050_19046, _ctx), kk_integer_box(_b_19051_19047, _ctx), _ctx);
    }
    {
      kk_integer_drop(n, _ctx);
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(cq, _ctx), kk_integer_box(cr, _ctx), _ctx);
    }
  }
}
 
// Drop the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core__list kk_std_core_drop(kk_std_core__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20686 = kk_std_core__as_Cons(xs, _ctx);
    if (kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context())) {
      kk_box_t _pat0 = _con20686->head;
      kk_std_core__list xx = _con20686->tail;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_box_drop(_pat0, _ctx);
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_std_core__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      { // tailcall
        kk_integer_t _x20687 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        xs = xx;
        n = _x20687;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(n, _ctx);
    return xs;
  }
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18029_drop_while(kk_function_t predicate, kk_std_core__list xs, kk_std_core__list xx, bool _y_17830, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xs : list<a>, xx : list<a>, bool) -> e list<a> */ 
  if (_y_17830) {
    kk_std_core__list_drop(xs, _ctx);
    return kk_std_core_drop_while(xx, predicate, _ctx);
  }
  {
    kk_std_core__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return xs;
  }
}
 
// Drop all initial elements that satisfy `predicate`


// lift anonymous function
struct kk_std_core_drop_while_fun20691__t {
  struct kk_function_s _base;
  kk_function_t predicate0;
  kk_std_core__list xs0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core_drop_while_fun20691(kk_function_t _fself, kk_box_t _b_19055, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_drop_while_fun20691(kk_function_t predicate0, kk_std_core__list xs0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core_drop_while_fun20691__t* _self = kk_function_alloc_as(struct kk_std_core_drop_while_fun20691__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_drop_while_fun20691, kk_context());
  _self->predicate0 = predicate0;
  _self->xs0 = xs0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_drop_while_fun20691(kk_function_t _fself, kk_box_t _b_19055, kk_context_t* _ctx) {
  struct kk_std_core_drop_while_fun20691__t* _self = kk_function_as(struct kk_std_core_drop_while_fun20691__t*, _fself, _ctx);
  kk_function_t predicate0 = _self->predicate0; /* (11842) -> 11843 bool */
  kk_std_core__list xs0 = _self->xs0; /* list<11842> */
  kk_std_core__list xx0 = _self->xx0; /* list<11842> */
  kk_drop_match(_self, {kk_function_dup(predicate0, _ctx);kk_std_core__list_dup(xs0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  bool _y_19057_178300 = kk_bool_unbox(_b_19055); /*bool*/;
  kk_std_core__list _x20692 = kk_std_core__mlift18029_drop_while(predicate0, xs0, xx0, _y_19057_178300, _ctx); /*list<11842>*/
  return kk_std_core__list_box(_x20692, _ctx);
}

kk_std_core__list kk_std_core_drop_while(kk_std_core__list xs0, kk_function_t predicate0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs0, _ctx)) {
    struct kk_std_core_Cons* _con20688 = kk_std_core__as_Cons(xs0, _ctx);
    kk_box_t x = _con20688->head;
    kk_std_core__list xx0 = _con20688->tail;
    kk_box_dup(x, _ctx);
    kk_std_core__list_dup(xx0, _ctx);
    bool x0_18222;
    kk_function_t _x20689 = kk_function_dup(predicate0, _ctx); /*(11842) -> 11843 bool*/
    x0_18222 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x20689, (_x20689, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x20690 = kk_std_core_hnd_yield_extend(kk_std_core_new_drop_while_fun20691(predicate0, xs0, xx0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20690, KK_OWNED, _ctx);
    }
    if (x0_18222) {
      if kk_likely(kk_datatype_ptr_is_unique(xs0, _ctx)) {
        kk_std_core__list_drop(xx0, _ctx);
        kk_box_drop(x, _ctx);
        kk_datatype_ptr_free(xs0, _ctx);
      }
      else {
        kk_datatype_ptr_decref(xs0, _ctx);
      }
      { // tailcall
        xs0 = xx0;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core__list_drop(xx0, _ctx);
      kk_function_drop(predicate0, _ctx);
      return xs0;
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
}
 
// Does string `s`  end with `post`?
// If so, returns a slice of `s` from the start up to the `post` string at the end.

kk_std_core_types__maybe kk_std_core_ends_with(kk_string_t s, kk_string_t post, kk_context_t* _ctx) { /* (s : string, post : string) -> maybe<sslice> */ 
  bool _match_19846;
  kk_string_t _x20693 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x20694 = kk_string_dup(post, _ctx); /*string*/
  _match_19846 = kk_std_core_xends_with(_x20693, _x20694, _ctx); /*bool*/
  if (_match_19846) {
    kk_integer_t x_17509;
    kk_string_t _x20695 = kk_string_dup(s, _ctx); /*string*/
    x_17509 = kk_string_len_int(_x20695,kk_context()); /*int*/
    kk_integer_t y_17510 = kk_string_len_int(post,kk_context()); /*int*/;
    kk_std_core__sslice _b_19059_19058;
    kk_integer_t _x20696 = kk_integer_sub(x_17509,y_17510,kk_context()); /*int*/
    _b_19059_19058 = kk_std_core__new_Sslice(s, kk_integer_from_small(0), _x20696, _ctx); /*sslice*/
    return kk_std_core_types__new_Just(kk_std_core__sslice_box(_b_19059_19058, _ctx), _ctx);
  }
  {
    kk_string_drop(s, _ctx);
    kk_string_drop(post, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Throw an exception with a specified message.

kk_box_t kk_std_core_throw(kk_string_t message0, kk_std_core_types__optional info0, kk_context_t* _ctx) { /* forall<a> (message : string, info : optional<exception-info>) -> exn a */ 
  kk_std_core_hnd__ev ev_18225;
  kk_ssize_t _x20697 = (KK_IZ(0)); /*ssize_t*/
  ev_18225 = kk_evv_at(_x20697,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
  {
    struct kk_std_core_hnd_Ev* _con20698 = kk_std_core_hnd__as_Ev(ev_18225, _ctx);
    kk_box_t _box_x19060 = _con20698->hnd;
    kk_std_core_hnd__marker m0 = _con20698->marker;
    kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x19060, KK_BORROWED, _ctx);
    kk_std_core__hnd_exn_dup(h, _ctx);
    {
      struct kk_std_core__Hnd_exn* _con20699 = kk_std_core__as_Hnd_exn(h, _ctx);
      kk_std_core_hnd__clause1 ctl_throw_exn = _con20699->ctl_throw_exn;
      if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
        kk_datatype_ptr_free(h, _ctx);
      }
      else {
        kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
        kk_datatype_ptr_decref(h, _ctx);
      }
      {
        kk_function_t _fun_unbox_x19064 = ctl_throw_exn.clause;
        kk_box_t _x20700;
        kk_std_core__exception _x20701;
        kk_std_core__exception_info _x20702;
        if (kk_std_core_types__is_Optional(info0, _ctx)) {
          kk_box_t _box_x19068 = info0._cons.Optional.value;
          kk_std_core__exception_info _info_11917 = kk_std_core__exception_info_unbox(_box_x19068, KK_BORROWED, _ctx);
          kk_std_core__exception_info_dup(_info_11917, _ctx);
          kk_std_core_types__optional_drop(info0, _ctx);
          _x20702 = _info_11917; /*exception-info*/
        }
        else {
          kk_std_core_types__optional_drop(info0, _ctx);
          _x20702 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
        }
        _x20701 = kk_std_core__new_Exception(message0, _x20702, _ctx); /*exception*/
        _x20700 = kk_std_core__exception_box(_x20701, _ctx); /*51*/
        return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x19064, (_fun_unbox_x19064, m0, ev_18225, _x20700, _ctx), _ctx);
      }
    }
  }
}
 
// monadic lift

kk_box_t kk_std_core__mlift18030_error_pattern(kk_string_t definition, kk_string_t location, kk_string_t _c_17835, kk_context_t* _ctx) { /* forall<a> (definition : string, location : string, string) -> a */ 
  kk_string_t message0_17512;
  kk_string_t _x20703 = kk_string_dup(location, _ctx); /*string*/
  kk_string_t _x20704;
  kk_string_t _x20705;
  kk_define_string_literal(, _s20706, 23, ": pattern match failure", _ctx)
  _x20705 = kk_string_dup(_s20706, _ctx); /*string*/
  _x20704 = kk_std_core__lp__plus__plus__1_rp_(_c_17835, _x20705, _ctx); /*string*/
  message0_17512 = kk_std_core__lp__plus__plus__1_rp_(_x20703, _x20704, _ctx); /*string*/
  kk_std_core_hnd__ev ev_18228;
  kk_ssize_t _x20707 = (KK_IZ(0)); /*ssize_t*/
  ev_18228 = kk_evv_at(_x20707,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
  {
    struct kk_std_core_hnd_Ev* _con20708 = kk_std_core_hnd__as_Ev(ev_18228, _ctx);
    kk_box_t _box_x19069 = _con20708->hnd;
    kk_std_core_hnd__marker m0 = _con20708->marker;
    kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x19069, KK_BORROWED, _ctx);
    kk_std_core__hnd_exn_dup(h, _ctx);
    {
      struct kk_std_core__Hnd_exn* _con20709 = kk_std_core__as_Hnd_exn(h, _ctx);
      kk_std_core_hnd__clause1 ctl_throw_exn = _con20709->ctl_throw_exn;
      if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
        kk_datatype_ptr_free(h, _ctx);
      }
      else {
        kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
        kk_datatype_ptr_decref(h, _ctx);
      }
      {
        kk_function_t _fun_unbox_x19073 = ctl_throw_exn.clause;
        kk_box_t _x20710;
        kk_std_core__exception _x20711;
        kk_std_core__exception_info _x20712 = kk_std_core__new_ExnPattern(kk_reuse_null, 0, location, definition, _ctx); /*exception-info*/
        _x20711 = kk_std_core__new_Exception(message0_17512, _x20712, _ctx); /*exception*/
        _x20710 = kk_std_core__exception_box(_x20711, _ctx); /*51*/
        return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x19073, (_fun_unbox_x19073, m0, ev_18228, _x20710, _ctx), _ctx);
      }
    }
  }
}
 
// Raise a pattern match exception. This is function is used internally by the
// compiler to generate error messages on pattern match failures.


// lift anonymous function
struct kk_std_core_error_pattern_fun20720__t {
  struct kk_function_s _base;
  kk_string_t definition;
  kk_string_t location;
};
static kk_box_t kk_std_core_error_pattern_fun20720(kk_function_t _fself, kk_box_t _b_19078, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_error_pattern_fun20720(kk_string_t definition, kk_string_t location, kk_context_t* _ctx) {
  struct kk_std_core_error_pattern_fun20720__t* _self = kk_function_alloc_as(struct kk_std_core_error_pattern_fun20720__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_error_pattern_fun20720, kk_context());
  _self->definition = definition;
  _self->location = location;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_error_pattern_fun20720(kk_function_t _fself, kk_box_t _b_19078, kk_context_t* _ctx) {
  struct kk_std_core_error_pattern_fun20720__t* _self = kk_function_as(struct kk_std_core_error_pattern_fun20720__t*, _fself, _ctx);
  kk_string_t definition = _self->definition; /* string */
  kk_string_t location = _self->location; /* string */
  kk_drop_match(_self, {kk_string_dup(definition, _ctx);kk_string_dup(location, _ctx);}, {}, _ctx)
  kk_string_t _x20721 = kk_string_unbox(_b_19078); /*string*/
  return kk_std_core__mlift18030_error_pattern(definition, location, _x20721, _ctx);
}

kk_box_t kk_std_core_error_pattern(kk_string_t location, kk_string_t definition, kk_context_t* _ctx) { /* forall<a> (location : string, definition : string) -> exn a */ 
  kk_string_t x_18231;
  bool _match_19845;
  kk_string_t _x20713 = kk_string_dup(definition, _ctx); /*string*/
  kk_string_t _x20714 = kk_string_empty(); /*string*/
  _match_19845 = kk_string_is_eq(_x20713,_x20714,kk_context()); /*bool*/
  if (_match_19845) {
    x_18231 = kk_string_empty(); /*string*/
  }
  else {
    kk_string_t _x20717;
    kk_define_string_literal(, _s20718, 2, ": ", _ctx)
    _x20717 = kk_string_dup(_s20718, _ctx); /*string*/
    kk_string_t _x20719 = kk_string_dup(definition, _ctx); /*string*/
    x_18231 = kk_std_core__lp__plus__plus__1_rp_(_x20717, _x20719, _ctx); /*string*/
  }
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_18231, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_new_error_pattern_fun20720(definition, location, _ctx), _ctx);
  }
  {
    kk_string_t message0_17512;
    kk_string_t _x20722 = kk_string_dup(location, _ctx); /*string*/
    kk_string_t _x20723;
    kk_string_t _x20724;
    kk_define_string_literal(, _s20725, 23, ": pattern match failure", _ctx)
    _x20724 = kk_string_dup(_s20725, _ctx); /*string*/
    _x20723 = kk_std_core__lp__plus__plus__1_rp_(x_18231, _x20724, _ctx); /*string*/
    message0_17512 = kk_std_core__lp__plus__plus__1_rp_(_x20722, _x20723, _ctx); /*string*/
    kk_std_core_hnd__ev ev_18234;
    kk_ssize_t _x20726 = (KK_IZ(0)); /*ssize_t*/
    ev_18234 = kk_evv_at(_x20726,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    {
      struct kk_std_core_hnd_Ev* _con20727 = kk_std_core_hnd__as_Ev(ev_18234, _ctx);
      kk_box_t _box_x19079 = _con20727->hnd;
      kk_std_core_hnd__marker m0 = _con20727->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x19079, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      {
        struct kk_std_core__Hnd_exn* _con20728 = kk_std_core__as_Hnd_exn(h, _ctx);
        kk_std_core_hnd__clause1 ctl_throw_exn = _con20728->ctl_throw_exn;
        if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
          kk_datatype_ptr_free(h, _ctx);
        }
        else {
          kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
          kk_datatype_ptr_decref(h, _ctx);
        }
        {
          kk_function_t _fun_unbox_x19083 = ctl_throw_exn.clause;
          kk_box_t _x20729;
          kk_std_core__exception _x20730;
          kk_std_core__exception_info _x20731 = kk_std_core__new_ExnPattern(kk_reuse_null, 0, location, definition, _ctx); /*exception-info*/
          _x20730 = kk_std_core__new_Exception(message0_17512, _x20731, _ctx); /*exception*/
          _x20729 = kk_std_core__exception_box(_x20730, _ctx); /*51*/
          return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x19083, (_fun_unbox_x19083, m0, ev_18234, _x20729, _ctx), _ctx);
        }
      }
    }
  }
}
 
// Transform an `:error` type back to an `exn` effect.

kk_box_t kk_std_core_untry(kk_std_core__error err, kk_context_t* _ctx) { /* forall<a> (err : error<a>) -> exn a */ 
  if (kk_std_core__is_Error(err, _ctx)) {
    kk_std_core__exception exn0 = err._cons.Error.exception;
    kk_std_core__exception_dup(exn0, _ctx);
    kk_std_core__error_drop(err, _ctx);
    kk_std_core_hnd__ev ev_18237;
    kk_ssize_t _x20732 = (KK_IZ(0)); /*ssize_t*/
    ev_18237 = kk_evv_at(_x20732,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    {
      struct kk_std_core_hnd_Ev* _con20733 = kk_std_core_hnd__as_Ev(ev_18237, _ctx);
      kk_box_t _box_x19089 = _con20733->hnd;
      kk_std_core_hnd__marker m0 = _con20733->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x19089, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      {
        struct kk_std_core__Hnd_exn* _con20734 = kk_std_core__as_Hnd_exn(h, _ctx);
        kk_std_core_hnd__clause1 ctl_throw_exn = _con20734->ctl_throw_exn;
        if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
          kk_datatype_ptr_free(h, _ctx);
        }
        else {
          kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
          kk_datatype_ptr_decref(h, _ctx);
        }
        {
          kk_function_t _fun_unbox_x19093 = ctl_throw_exn.clause;
          return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x19093, (_fun_unbox_x19093, m0, ev_18237, kk_std_core__exception_box(exn0, _ctx), _ctx), _ctx);
        }
      }
    }
  }
  {
    kk_box_t x0 = err._cons.Ok.result;
    return x0;
  }
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18031_trmc_filter(kk_std_core_types__cctx _acc, kk_function_t pred, kk_box_t x, kk_std_core__list xx, bool _y_17840, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, pred : (a) -> e bool, x : a, xx : list<a>, bool) -> e list<a> */ 
  if (_y_17840) {
    kk_std_core__list _trmc_17695 = kk_datatype_null(); /*list<12137>*/;
    kk_std_core__list _trmc_17696 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), x, _trmc_17695, _ctx); /*list<12137>*/;
    kk_box_t* _b_19105_19102 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17696, _ctx)->tail)); /*field-addr<list<12137>>*/;
    kk_std_core_types__cctx _x20735 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17696, _ctx)),_b_19105_19102,false,kk_context()); /*ctx<0>*/
    return kk_std_core__trmc_filter(xx, pred, _x20735, _ctx);
  }
  {
    kk_box_drop(x, _ctx);
    return kk_std_core__trmc_filter(xx, pred, _acc, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filter([1,2,3],odd?) == [1,3]`


// lift anonymous function
struct kk_std_core__trmc_filter_fun20740__t {
  struct kk_function_s _base;
  kk_function_t pred0;
  kk_box_t x0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_filter_fun20740(kk_function_t _fself, kk_box_t _b_19110, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_filter_fun20740(kk_function_t pred0, kk_box_t x0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_filter_fun20740__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_filter_fun20740__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_filter_fun20740, kk_context());
  _self->pred0 = pred0;
  _self->x0 = x0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_filter_fun20740(kk_function_t _fself, kk_box_t _b_19110, kk_context_t* _ctx) {
  struct kk_std_core__trmc_filter_fun20740__t* _self = kk_function_as(struct kk_std_core__trmc_filter_fun20740__t*, _fself, _ctx);
  kk_function_t pred0 = _self->pred0; /* (12137) -> 12138 bool */
  kk_box_t x0 = _self->x0; /* 12137 */
  kk_std_core__list xx0 = _self->xx0; /* list<12137> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<12137>> */
  kk_drop_match(_self, {kk_function_dup(pred0, _ctx);kk_box_dup(x0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  bool _y_19128_178400 = kk_bool_unbox(_b_19110); /*bool*/;
  kk_std_core__list _x20741 = kk_std_core__mlift18031_trmc_filter(_acc0, pred0, x0, xx0, _y_19128_178400, _ctx); /*list<12137>*/
  return kk_std_core__list_box(_x20741, _ctx);
}

kk_std_core__list kk_std_core__trmc_filter(kk_std_core__list xs, kk_function_t pred0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20736 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x0 = _con20736->head;
    kk_std_core__list xx0 = _con20736->tail;
    kk_reuse_t _ru_20048 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_20048 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x0, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x1_18240;
    kk_function_t _x20738 = kk_function_dup(pred0, _ctx); /*(12137) -> 12138 bool*/
    kk_box_t _x20737 = kk_box_dup(x0, _ctx); /*12137*/
    x1_18240 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x20738, (_x20738, _x20737, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_20048,kk_context());
      kk_box_t _x20739 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_filter_fun20740(pred0, x0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20739, KK_OWNED, _ctx);
    }
    if (x1_18240) {
      kk_std_core__list _trmc_176950 = kk_datatype_null(); /*list<12137>*/;
      kk_std_core__list _trmc_176960 = kk_std_core__new_Cons(_ru_20048, kk_field_index_of(struct kk_std_core_Cons, tail), x0, _trmc_176950, _ctx); /*list<12137>*/;
      kk_box_t* _b_19122_19116 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_176960, _ctx)->tail)); /*field-addr<list<12137>>*/;
      { // tailcall
        kk_std_core_types__cctx _x20742 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_176960, _ctx)),_b_19122_19116,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x20742;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_20048,kk_context());
      kk_box_drop(x0, _ctx);
      { // tailcall
        xs = xx0;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(pred0, _ctx);
    kk_box_t _x20743 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20743, KK_OWNED, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filter([1,2,3],odd?) == [1,3]`

kk_std_core__list kk_std_core_filter(kk_std_core__list xs0, kk_function_t pred1, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool) -> e list<a> */ 
  kk_std_core_types__cctx _x20744 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_filter(xs0, pred1, _x20744, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18032_trmc_filter_map(kk_std_core_types__cctx _acc, kk_function_t pred, kk_std_core__list xx, kk_std_core_types__maybe _y_17846, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, pred : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Nothing(_y_17846, _ctx)) {
    return kk_std_core__trmc_filter_map(xx, pred, _acc, _ctx);
  }
  {
    kk_box_t y = _y_17846._cons.Just.value;
    kk_std_core__list _trmc_17697 = kk_datatype_null(); /*list<12183>*/;
    kk_std_core__list _trmc_17698 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), y, _trmc_17697, _ctx); /*list<12183>*/;
    kk_box_t* _b_19137_19134 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17698, _ctx)->tail)); /*field-addr<list<12183>>*/;
    kk_std_core_types__cctx _x20745 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17698, _ctx)),_b_19137_19134,false,kk_context()); /*ctx<0>*/
    return kk_std_core__trmc_filter_map(xx, pred, _x20745, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filterMap([1,2,3],fn(i) { if i.odd? then Nothing else Just(i*i) }) == [4]`


// lift anonymous function
struct kk_std_core__trmc_filter_map_fun20750__t {
  struct kk_function_s _base;
  kk_function_t pred0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_filter_map_fun20750(kk_function_t _fself, kk_box_t _b_19144, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_filter_map_fun20750(kk_function_t pred0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_filter_map_fun20750__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_filter_map_fun20750__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_filter_map_fun20750, kk_context());
  _self->pred0 = pred0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_filter_map_fun20750(kk_function_t _fself, kk_box_t _b_19144, kk_context_t* _ctx) {
  struct kk_std_core__trmc_filter_map_fun20750__t* _self = kk_function_as(struct kk_std_core__trmc_filter_map_fun20750__t*, _fself, _ctx);
  kk_function_t pred0 = _self->pred0; /* (12182) -> 12184 maybe<12183> */
  kk_std_core__list xx0 = _self->xx0; /* list<12182> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<12183>> */
  kk_drop_match(_self, {kk_function_dup(pred0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_19160_178460 = kk_std_core_types__maybe_unbox(_b_19144, KK_OWNED, _ctx); /*maybe<12183>*/;
  kk_std_core__list _x20751 = kk_std_core__mlift18032_trmc_filter_map(_acc0, pred0, xx0, _y_19160_178460, _ctx); /*list<12183>*/
  return kk_std_core__list_box(_x20751, _ctx);
}

kk_std_core__list kk_std_core__trmc_filter_map(kk_std_core__list xs, kk_function_t pred0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, pred : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(pred0, _ctx);
    kk_box_t _x20746 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20746, KK_OWNED, _ctx);
  }
  {
    struct kk_std_core_Cons* _con20747 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20747->head;
    kk_std_core__list xx0 = _con20747->tail;
    kk_reuse_t _ru_20049 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_20049 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x0_18243;
    kk_function_t _x20748 = kk_function_dup(pred0, _ctx); /*(12182) -> 12184 maybe<12183>*/
    x0_18243 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x20748, (_x20748, x, _ctx), _ctx); /*maybe<12183>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_20049,kk_context());
      kk_std_core_types__maybe_drop(x0_18243, _ctx);
      kk_box_t _x20749 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_filter_map_fun20750(pred0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20749, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x0_18243, _ctx)) {
      kk_reuse_drop(_ru_20049,kk_context());
      { // tailcall
        xs = xx0;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t y0 = x0_18243._cons.Just.value;
      kk_std_core__list _trmc_176970 = kk_datatype_null(); /*list<12183>*/;
      kk_std_core__list _trmc_176980 = kk_std_core__new_Cons(_ru_20049, kk_field_index_of(struct kk_std_core_Cons, tail), y0, _trmc_176970, _ctx); /*list<12183>*/;
      kk_box_t* _b_19156_19150 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_176980, _ctx)->tail)); /*field-addr<list<12183>>*/;
      { // tailcall
        kk_std_core_types__cctx _x20752 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_176980, _ctx)),_b_19156_19150,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x20752;
        goto kk__tailcall;
      }
    }
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filterMap([1,2,3],fn(i) { if i.odd? then Nothing else Just(i*i) }) == [4]`

kk_std_core__list kk_std_core_filter_map(kk_std_core__list xs0, kk_function_t pred1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, pred : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x20753 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_filter_map(xs0, pred1, _x20753, _ctx);
}

bool kk_std_core_is_zero_1(kk_ssize_t i, kk_context_t* _ctx) { /* (i : ssize_t) -> bool */ 
  return (i == 0);
}
 
// Find the first element satisfying some predicate


// lift anonymous function
struct kk_std_core_find_fun20754__t {
  struct kk_function_s _base;
  kk_function_t pred;
};
static kk_std_core_types__maybe kk_std_core_find_fun20754(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_find_fun20754(kk_function_t pred, kk_context_t* _ctx) {
  struct kk_std_core_find_fun20754__t* _self = kk_function_alloc_as(struct kk_std_core_find_fun20754__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_find_fun20754, kk_context());
  _self->pred = pred;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_core_types__maybe kk_std_core_find_fun20754(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_find_fun20754__t* _self = kk_function_as(struct kk_std_core_find_fun20754__t*, _fself, _ctx);
  kk_function_t pred = _self->pred; /* (12281) -> bool */
  kk_drop_match(_self, {kk_function_dup(pred, _ctx);}, {}, _ctx)
  bool _match_19841;
  kk_box_t _x20755 = kk_box_dup(x, _ctx); /*12281*/
  _match_19841 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), pred, (pred, _x20755, _ctx), _ctx); /*bool*/
  if (_match_19841) {
    return kk_std_core_types__new_Just(x, _ctx);
  }
  {
    kk_box_drop(x, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}

kk_std_core_types__maybe kk_std_core_find(kk_std_core__list xs, kk_function_t pred, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, pred : (a) -> bool) -> maybe<a> */ 
  return kk_std_core_foreach_while(xs, kk_std_core_new_find_fun20754(pred, _ctx), _ctx);
}
 
// O(n). If it occurs, return the position of substring `sub` in `s`, tupled with
// the position just following the substring `sub`.

kk_std_core_types__maybe kk_std_core_find_1(kk_string_t s, kk_string_t sub, kk_context_t* _ctx) { /* (s : string, sub : string) -> maybe<sslice> */ 
  kk_ssize_t i;
  kk_string_t _x20756 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x20757 = kk_string_dup(sub, _ctx); /*string*/
  i = kk_string_index_of1(_x20756,_x20757,kk_context()); /*ssize_t*/
  bool _match_19840 = kk_std_core_is_zero_1(i, _ctx); /*bool*/;
  if (_match_19840) {
    kk_string_drop(sub, _ctx);
    kk_string_drop(s, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_std_core__sslice _b_19162_19161;
    kk_integer_t _x20758;
    kk_ssize_t _x20759 = kk_std_core_decr_1(i, _ctx); /*ssize_t*/
    _x20758 = kk_integer_from_ssize_t(_x20759,kk_context()); /*int*/
    kk_integer_t _x20760 = kk_string_len_int(sub,kk_context()); /*int*/
    _b_19162_19161 = kk_std_core__new_Sslice(s, _x20758, _x20760, _ctx); /*sslice*/
    return kk_std_core_types__new_Just(kk_std_core__sslice_box(_b_19162_19161, _ctx), _ctx);
  }
}
 
// Return the last index of substring `sub` in `s` if it occurs.

kk_std_core_types__maybe kk_std_core_find_last(kk_string_t s, kk_string_t sub, kk_context_t* _ctx) { /* (s : string, sub : string) -> maybe<sslice> */ 
  kk_ssize_t i;
  kk_string_t _x20761 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x20762 = kk_string_dup(sub, _ctx); /*string*/
  i = kk_string_last_index_of1(_x20761,_x20762,kk_context()); /*ssize_t*/
  bool _match_19839 = kk_std_core_is_zero_1(i, _ctx); /*bool*/;
  if (_match_19839) {
    kk_string_drop(sub, _ctx);
    kk_string_drop(s, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_std_core__sslice _b_19164_19163;
    kk_integer_t _x20763;
    kk_ssize_t _x20764 = kk_std_core_decr_1(i, _ctx); /*ssize_t*/
    _x20763 = kk_integer_from_ssize_t(_x20764,kk_context()); /*int*/
    kk_integer_t _x20765 = kk_string_len_int(sub,kk_context()); /*int*/
    _b_19164_19163 = kk_std_core__new_Sslice(s, _x20763, _x20765, _ctx); /*sslice*/
    return kk_std_core_types__new_Just(kk_std_core__sslice_box(_b_19164_19163, _ctx), _ctx);
  }
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18033_trmc_flatmap_maybe(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core__list xx, kk_std_core_types__maybe _y_17852, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Just(_y_17852, _ctx)) {
    kk_box_t y = _y_17852._cons.Just.value;
    kk_std_core__list _trmc_17699 = kk_datatype_null(); /*list<12527>*/;
    kk_std_core__list _trmc_17700 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), y, _trmc_17699, _ctx); /*list<12527>*/;
    kk_box_t* _b_19173_19170 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17700, _ctx)->tail)); /*field-addr<list<12527>>*/;
    kk_std_core_types__cctx _x20766 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17700, _ctx)),_b_19173_19170,false,kk_context()); /*ctx<0>*/
    return kk_std_core__trmc_flatmap_maybe(xx, f, _x20766, _ctx);
  }
  {
    return kk_std_core__trmc_flatmap_maybe(xx, f, _acc, _ctx);
  }
}
 
// Concatenate the `Just` result elements from applying a function to all elements.


// lift anonymous function
struct kk_std_core__trmc_flatmap_maybe_fun20770__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_flatmap_maybe_fun20770(kk_function_t _fself, kk_box_t _b_19178, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_flatmap_maybe_fun20770(kk_function_t f0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_flatmap_maybe_fun20770__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_flatmap_maybe_fun20770__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_flatmap_maybe_fun20770, kk_context());
  _self->f0 = f0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_flatmap_maybe_fun20770(kk_function_t _fself, kk_box_t _b_19178, kk_context_t* _ctx) {
  struct kk_std_core__trmc_flatmap_maybe_fun20770__t* _self = kk_function_as(struct kk_std_core__trmc_flatmap_maybe_fun20770__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (12526) -> 12528 maybe<12527> */
  kk_std_core__list xx0 = _self->xx0; /* list<12526> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<12527>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_19196_178520 = kk_std_core_types__maybe_unbox(_b_19178, KK_OWNED, _ctx); /*maybe<12527>*/;
  kk_std_core__list _x20771 = kk_std_core__mlift18033_trmc_flatmap_maybe(_acc0, f0, xx0, _y_19196_178520, _ctx); /*list<12527>*/
  return kk_std_core__list_box(_x20771, _ctx);
}

kk_std_core__list kk_std_core__trmc_flatmap_maybe(kk_std_core__list xs, kk_function_t f0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20767 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20767->head;
    kk_std_core__list xx0 = _con20767->tail;
    kk_reuse_t _ru_20050 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_20050 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x0_18246;
    kk_function_t _x20768 = kk_function_dup(f0, _ctx); /*(12526) -> 12528 maybe<12527>*/
    x0_18246 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x20768, (_x20768, x, _ctx), _ctx); /*maybe<12527>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_20050,kk_context());
      kk_std_core_types__maybe_drop(x0_18246, _ctx);
      kk_box_t _x20769 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_flatmap_maybe_fun20770(f0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20769, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Just(x0_18246, _ctx)) {
      kk_box_t y0 = x0_18246._cons.Just.value;
      kk_std_core__list _trmc_176990 = kk_datatype_null(); /*list<12527>*/;
      kk_std_core__list _trmc_177000 = kk_std_core__new_Cons(_ru_20050, kk_field_index_of(struct kk_std_core_Cons, tail), y0, _trmc_176990, _ctx); /*list<12527>*/;
      kk_box_t* _b_19190_19184 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_177000, _ctx)->tail)); /*field-addr<list<12527>>*/;
      { // tailcall
        kk_std_core_types__cctx _x20772 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_177000, _ctx)),_b_19190_19184,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x20772;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_20050,kk_context());
      { // tailcall
        xs = xx0;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(f0, _ctx);
    kk_box_t _x20773 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20773, KK_OWNED, _ctx);
  }
}
 
// Concatenate the `Just` result elements from applying a function to all elements.

kk_std_core__list kk_std_core_flatmap_maybe(kk_std_core__list xs0, kk_function_t f1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x20774 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_flatmap_maybe(xs0, f1, _x20774, _ctx);
}
 
// monadic lift

kk_box_t kk_std_core__mlift18034_fold_int(kk_integer_t end, kk_function_t f, kk_integer_t start0, kk_box_t x, kk_context_t* _ctx) { /* forall<a,e> (end : int, f : (int, a) -> e a, start0 : int, x : a) -> e a */ 
  kk_integer_t _x20775 = kk_integer_add_small_const(start0, 1, _ctx); /*int*/
  return kk_std_core_fold_int(_x20775, end, x, f, _ctx);
}
 
// fold over the integers between [`start`,`end`] (inclusive).


// lift anonymous function
struct kk_std_core_fold_int_fun20778__t {
  struct kk_function_s _base;
  kk_integer_t end0;
  kk_function_t f0;
  kk_integer_t start00;
};
static kk_box_t kk_std_core_fold_int_fun20778(kk_function_t _fself, kk_box_t x1, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_fold_int_fun20778(kk_integer_t end0, kk_function_t f0, kk_integer_t start00, kk_context_t* _ctx) {
  struct kk_std_core_fold_int_fun20778__t* _self = kk_function_alloc_as(struct kk_std_core_fold_int_fun20778__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_fold_int_fun20778, kk_context());
  _self->end0 = end0;
  _self->f0 = f0;
  _self->start00 = start00;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_fold_int_fun20778(kk_function_t _fself, kk_box_t x1, kk_context_t* _ctx) {
  struct kk_std_core_fold_int_fun20778__t* _self = kk_function_as(struct kk_std_core_fold_int_fun20778__t*, _fself, _ctx);
  kk_integer_t end0 = _self->end0; /* int */
  kk_function_t f0 = _self->f0; /* (int, 12587) -> 12588 12587 */
  kk_integer_t start00 = _self->start00; /* int */
  kk_drop_match(_self, {kk_integer_dup(end0, _ctx);kk_function_dup(f0, _ctx);kk_integer_dup(start00, _ctx);}, {}, _ctx)
  return kk_std_core__mlift18034_fold_int(end0, f0, start00, x1, _ctx);
}

kk_box_t kk_std_core_fold_int(kk_integer_t start00, kk_integer_t end0, kk_box_t init0, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,e> (start : int, end : int, init : a, f : (int, a) -> e a) -> e a */ 
  kk__tailcall: ;
  bool _match_19836 = kk_integer_gte_borrow(start00,end0,kk_context()); /*bool*/;
  if (_match_19836) {
    kk_integer_drop(start00, _ctx);
    kk_function_drop(f0, _ctx);
    kk_integer_drop(end0, _ctx);
    return init0;
  }
  {
    kk_box_t x0_18249;
    kk_function_t _x20777 = kk_function_dup(f0, _ctx); /*(int, 12587) -> 12588 12587*/
    kk_integer_t _x20776 = kk_integer_dup(start00, _ctx); /*int*/
    x0_18249 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x20777, (_x20777, _x20776, init0, _ctx), _ctx); /*12587*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18249, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core_new_fold_int_fun20778(end0, f0, start00, _ctx), _ctx);
    }
    { // tailcall
      kk_integer_t _x20779 = kk_integer_add_small_const(start00, 1, _ctx); /*int*/
      start00 = _x20779;
      init0 = x0_18249;
      goto kk__tailcall;
    }
  }
}
 
// monadic lift

kk_box_t kk_std_core__mlift18035_fold_while_int(kk_integer_t end, kk_function_t f, kk_box_t init0, kk_integer_t start0, kk_std_core_types__maybe _y_17862, kk_context_t* _ctx) { /* forall<a,e> (end : int, f : (int, a) -> e maybe<a>, init0 : a, start0 : int, maybe<a>) -> e a */ 
  if (kk_std_core_types__is_Just(_y_17862, _ctx)) {
    kk_box_t x = _y_17862._cons.Just.value;
    kk_box_drop(init0, _ctx);
    kk_integer_t _x20781 = kk_integer_add_small_const(start0, 1, _ctx); /*int*/
    return kk_std_core_fold_while_int(_x20781, end, x, f, _ctx);
  }
  {
    kk_integer_drop(start0, _ctx);
    kk_function_drop(f, _ctx);
    kk_integer_drop(end, _ctx);
    return init0;
  }
}


// lift anonymous function
struct kk_std_core_fold_while_int_fun20785__t {
  struct kk_function_s _base;
  kk_integer_t end0;
  kk_function_t f0;
  kk_box_t init00;
  kk_integer_t start00;
};
static kk_box_t kk_std_core_fold_while_int_fun20785(kk_function_t _fself, kk_box_t _b_19198, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_fold_while_int_fun20785(kk_integer_t end0, kk_function_t f0, kk_box_t init00, kk_integer_t start00, kk_context_t* _ctx) {
  struct kk_std_core_fold_while_int_fun20785__t* _self = kk_function_alloc_as(struct kk_std_core_fold_while_int_fun20785__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_fold_while_int_fun20785, kk_context());
  _self->end0 = end0;
  _self->f0 = f0;
  _self->init00 = init00;
  _self->start00 = start00;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_fold_while_int_fun20785(kk_function_t _fself, kk_box_t _b_19198, kk_context_t* _ctx) {
  struct kk_std_core_fold_while_int_fun20785__t* _self = kk_function_as(struct kk_std_core_fold_while_int_fun20785__t*, _fself, _ctx);
  kk_integer_t end0 = _self->end0; /* int */
  kk_function_t f0 = _self->f0; /* (int, 12692) -> 12693 maybe<12692> */
  kk_box_t init00 = _self->init00; /* 12692 */
  kk_integer_t start00 = _self->start00; /* int */
  kk_drop_match(_self, {kk_integer_dup(end0, _ctx);kk_function_dup(f0, _ctx);kk_box_dup(init00, _ctx);kk_integer_dup(start00, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _x20786 = kk_std_core_types__maybe_unbox(_b_19198, KK_OWNED, _ctx); /*maybe<12692>*/
  return kk_std_core__mlift18035_fold_while_int(end0, f0, init00, start00, _x20786, _ctx);
}

kk_box_t kk_std_core_fold_while_int(kk_integer_t start00, kk_integer_t end0, kk_box_t init00, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,e> (start : int, end : int, init : a, f : (int, a) -> e maybe<a>) -> e a */ 
  kk__tailcall: ;
  bool _match_19834 = kk_integer_gte_borrow(start00,end0,kk_context()); /*bool*/;
  if (_match_19834) {
    kk_integer_drop(start00, _ctx);
    kk_function_drop(f0, _ctx);
    kk_integer_drop(end0, _ctx);
    return init00;
  }
  {
    kk_std_core_types__maybe x0_18252;
    kk_function_t _x20784 = kk_function_dup(f0, _ctx); /*(int, 12692) -> 12693 maybe<12692>*/
    kk_integer_t _x20782 = kk_integer_dup(start00, _ctx); /*int*/
    kk_box_t _x20783 = kk_box_dup(init00, _ctx); /*12692*/
    x0_18252 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x20784, (_x20784, _x20782, _x20783, _ctx), _ctx); /*maybe<12692>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_18252, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core_new_fold_while_int_fun20785(end0, f0, init00, start00, _ctx), _ctx);
    }
    if (kk_std_core_types__is_Just(x0_18252, _ctx)) {
      kk_box_t x1 = x0_18252._cons.Just.value;
      kk_box_drop(init00, _ctx);
      { // tailcall
        kk_integer_t _x20787 = kk_integer_add_small_const(start00, 1, _ctx); /*int*/
        start00 = _x20787;
        init00 = x1;
        goto kk__tailcall;
      }
    }
    {
      kk_integer_drop(start00, _ctx);
      kk_function_drop(f0, _ctx);
      kk_integer_drop(end0, _ctx);
      return init00;
    }
  }
}
 
// monadic lift

kk_box_t kk_std_core__mlift18036_foldl(kk_function_t f, kk_std_core__list xx, kk_box_t _y_17866, kk_context_t* _ctx) { /* forall<a,e,b> (f : (a, b) -> e a, xx : list<b>, a) -> e a */ 
  return kk_std_core_foldl(xx, _y_17866, f, _ctx);
}
 
// Fold a list from the left, i.e. `foldl([1,2],0,(+)) == (0+1)+2`
// Since `foldl` is tail recursive, it is preferred over `foldr` when using an associative function `f`


// lift anonymous function
struct kk_std_core_foldl_fun20790__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core_foldl_fun20790(kk_function_t _fself, kk_box_t _y_178660, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foldl_fun20790(kk_function_t f0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core_foldl_fun20790__t* _self = kk_function_alloc_as(struct kk_std_core_foldl_fun20790__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foldl_fun20790, kk_context());
  _self->f0 = f0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_foldl_fun20790(kk_function_t _fself, kk_box_t _y_178660, kk_context_t* _ctx) {
  struct kk_std_core_foldl_fun20790__t* _self = kk_function_as(struct kk_std_core_foldl_fun20790__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (12696, 12701) -> 12698 12696 */
  kk_std_core__list xx0 = _self->xx0; /* list<12701> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  return kk_std_core__mlift18036_foldl(f0, xx0, _y_178660, _ctx);
}

kk_box_t kk_std_core_foldl(kk_std_core__list xs, kk_box_t z, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,b,e> (list<a>, b, (b, a) -> e b) -> e b */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20788 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20788->head;
    kk_std_core__list xx0 = _con20788->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t x0_18255;
    kk_function_t _x20789 = kk_function_dup(f0, _ctx); /*(12696, 12701) -> 12698 12696*/
    x0_18255 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x20789, (_x20789, z, x, _ctx), _ctx); /*12696*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18255, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core_new_foldl_fun20790(f0, xx0, _ctx), _ctx);
    }
    { // tailcall
      xs = xx0;
      z = x0_18255;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(f0, _ctx);
    return z;
  }
}


// lift anonymous function
struct kk_std_core_foldl1_fun20793__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_foldl1_fun20793(kk_function_t _fself, kk_box_t _b_19214, kk_box_t _b_19215, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foldl1_fun20793(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_foldl1_fun20793, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_foldl1_fun20793(kk_function_t _fself, kk_box_t _b_19214, kk_box_t _b_19215, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_hnd__ev ev_18258;
  kk_ssize_t _x20794 = (KK_IZ(0)); /*ssize_t*/
  ev_18258 = kk_evv_at(_x20794,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
  {
    struct kk_std_core_hnd_Ev* _con20795 = kk_std_core_hnd__as_Ev(ev_18258, _ctx);
    kk_box_t _box_x19201 = _con20795->hnd;
    kk_std_core_hnd__marker m0 = _con20795->marker;
    kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x19201, KK_BORROWED, _ctx);
    kk_std_core__hnd_exn_dup(h, _ctx);
    {
      struct kk_std_core__Hnd_exn* _con20796 = kk_std_core__as_Hnd_exn(h, _ctx);
      kk_std_core_hnd__clause1 ctl_throw_exn = _con20796->ctl_throw_exn;
      if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
        kk_datatype_ptr_free(h, _ctx);
      }
      else {
        kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
        kk_datatype_ptr_decref(h, _ctx);
      }
      {
        kk_function_t _fun_unbox_x19205 = ctl_throw_exn.clause;
        kk_box_t _x20797;
        kk_std_core__exception _x20798;
        kk_string_t _x20799 = kk_string_unbox(_b_19214); /*string*/
        kk_std_core__exception_info _x20800;
        kk_std_core_types__optional _match_19832 = kk_std_core_types__optional_unbox(_b_19215, KK_OWNED, _ctx); /*optional<exception-info>*/;
        if (kk_std_core_types__is_Optional(_match_19832, _ctx)) {
          kk_box_t _box_x19209 = _match_19832._cons.Optional.value;
          kk_std_core__exception_info _info_11917 = kk_std_core__exception_info_unbox(_box_x19209, KK_BORROWED, _ctx);
          kk_std_core__exception_info_dup(_info_11917, _ctx);
          kk_std_core_types__optional_drop(_match_19832, _ctx);
          _x20800 = _info_11917; /*exception-info*/
        }
        else {
          kk_std_core_types__optional_drop(_match_19832, _ctx);
          _x20800 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
        }
        _x20798 = kk_std_core__new_Exception(_x20799, _x20800, _ctx); /*exception*/
        _x20797 = kk_std_core__exception_box(_x20798, _ctx); /*51*/
        return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x19205, (_fun_unbox_x19205, m0, ev_18258, _x20797, _ctx), _ctx);
      }
    }
  }
}

kk_box_t kk_std_core_foldl1(kk_std_core__list xs, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, f : (a, a) -> <exn|e> a) -> <exn|e> a */ 
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20791 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20791->head;
    kk_std_core__list xx = _con20791->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return kk_std_core_foldl(xx, x, f, _ctx);
  }
  {
    kk_function_drop(f, _ctx);
    kk_ssize_t _b_19216_19210;
    kk_std_core_hnd__htag _x20792 = kk_std_core_hnd__htag_dup(kk_std_core__tag_exn, _ctx); /*std/core/hnd/htag<.hnd-exn>*/
    _b_19216_19210 = kk_std_core_hnd__evv_index(_x20792, _ctx); /*std/core/hnd/ev-index*/
    kk_box_t _x20801;
    kk_string_t _x20802;
    kk_define_string_literal(, _s20803, 33, "unexpected Nil in std/core/foldl1", _ctx)
    _x20802 = kk_string_dup(_s20803, _ctx); /*string*/
    _x20801 = kk_string_box(_x20802); /*5615*/
    return kk_std_core_hnd__open_at2(_b_19216_19210, kk_std_core_new_foldl1_fun20793(_ctx), _x20801, kk_std_core_types__optional_box(kk_std_core_types__new_None(_ctx), _ctx), _ctx);
  }
}
extern kk_box_t kk_std_core_foldr_fun20805(kk_function_t _fself, kk_box_t x, kk_box_t y, kk_context_t* _ctx) {
  struct kk_std_core_foldr_fun20805__t* _self = kk_function_as(struct kk_std_core_foldr_fun20805__t*, _fself, _ctx);
  kk_function_t f = _self->f; /* (12774, 12770) -> 12772 12770 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);}, {}, _ctx)
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, y, x, _ctx), _ctx);
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18037_lift17321_for_while(kk_function_t action, kk_integer_t end, kk_integer_t i, kk_std_core_types__maybe _y_17876, kk_context_t* _ctx) { /* forall<a,e> (action : (int) -> e maybe<a>, end : int, i : int, maybe<a>) -> e maybe<a> */ 
  if (kk_std_core_types__is_Nothing(_y_17876, _ctx)) {
    kk_integer_t i0_17529 = kk_integer_add_small_const(i, 1, _ctx); /*int*/;
    return kk_std_core__lift17321_for_while(action, end, i0_17529, _ctx);
  }
  {
    kk_box_t x0 = _y_17876._cons.Just.value;
    kk_integer_drop(i, _ctx);
    kk_integer_drop(end, _ctx);
    kk_function_drop(action, _ctx);
    return kk_std_core_types__new_Just(x0, _ctx);
  }
}
 
// lifted local: for-while, rep


// lift anonymous function
struct kk_std_core__lift17321_for_while_fun20810__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_integer_t end0;
  kk_integer_t i0;
};
static kk_box_t kk_std_core__lift17321_for_while_fun20810(kk_function_t _fself, kk_box_t _b_19223, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift17321_for_while_fun20810(kk_function_t action0, kk_integer_t end0, kk_integer_t i0, kk_context_t* _ctx) {
  struct kk_std_core__lift17321_for_while_fun20810__t* _self = kk_function_alloc_as(struct kk_std_core__lift17321_for_while_fun20810__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift17321_for_while_fun20810, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift17321_for_while_fun20810(kk_function_t _fself, kk_box_t _b_19223, kk_context_t* _ctx) {
  struct kk_std_core__lift17321_for_while_fun20810__t* _self = kk_function_as(struct kk_std_core__lift17321_for_while_fun20810__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (int) -> 12860 maybe<12859> */
  kk_integer_t end0 = _self->end0; /* int */
  kk_integer_t i0 = _self->i0; /* int */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_integer_dup(end0, _ctx);kk_integer_dup(i0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_19225_178760 = kk_std_core_types__maybe_unbox(_b_19223, KK_OWNED, _ctx); /*maybe<12859>*/;
  kk_std_core_types__maybe _x20811 = kk_std_core__mlift18037_lift17321_for_while(action0, end0, i0, _y_19225_178760, _ctx); /*maybe<12859>*/
  return kk_std_core_types__maybe_box(_x20811, _ctx);
}

kk_std_core_types__maybe kk_std_core__lift17321_for_while(kk_function_t action0, kk_integer_t end0, kk_integer_t i0, kk_context_t* _ctx) { /* forall<a,e> (action : (int) -> e maybe<a>, end : int, i : int) -> e maybe<a> */ 
  kk__tailcall: ;
  bool _match_19830 = kk_integer_lte_borrow(i0,end0,kk_context()); /*bool*/;
  if (_match_19830) {
    kk_std_core_types__maybe x_18261;
    kk_function_t _x20808 = kk_function_dup(action0, _ctx); /*(int) -> 12860 maybe<12859>*/
    kk_integer_t _x20807 = kk_integer_dup(i0, _ctx); /*int*/
    x_18261 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_integer_t, kk_context_t*), _x20808, (_x20808, _x20807, _ctx), _ctx); /*maybe<12859>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x_18261, _ctx);
      kk_box_t _x20809 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift17321_for_while_fun20810(action0, end0, i0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x20809, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x_18261, _ctx)) {
      kk_integer_t i0_175290 = kk_integer_add_small_const(i0, 1, _ctx); /*int*/;
      { // tailcall
        i0 = i0_175290;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t x00 = x_18261._cons.Just.value;
      kk_integer_drop(i0, _ctx);
      kk_integer_drop(end0, _ctx);
      kk_function_drop(action0, _ctx);
      return kk_std_core_types__new_Just(x00, _ctx);
    }
  }
  {
    kk_integer_drop(i0, _ctx);
    kk_integer_drop(end0, _ctx);
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18039_foreach_indexed_fun20814__t {
  struct kk_function_s _base;
  kk_ref_t i;
};
static kk_unit_t kk_std_core__mlift18039_foreach_indexed_fun20814(kk_function_t _fself, kk_integer_t _y_17884, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18039_foreach_indexed_fun20814(kk_ref_t i, kk_context_t* _ctx) {
  struct kk_std_core__mlift18039_foreach_indexed_fun20814__t* _self = kk_function_alloc_as(struct kk_std_core__mlift18039_foreach_indexed_fun20814__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18039_foreach_indexed_fun20814, kk_context());
  _self->i = i;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_unit_t kk_std_core__mlift18039_foreach_indexed_fun20814(kk_function_t _fself, kk_integer_t _y_17884, kk_context_t* _ctx) {
  struct kk_std_core__mlift18039_foreach_indexed_fun20814__t* _self = kk_function_as(struct kk_std_core__mlift18039_foreach_indexed_fun20814__t*, _fself, _ctx);
  kk_ref_t i = _self->i; /* local-var<12964,int> */
  kk_drop_match(_self, {kk_ref_dup(i, _ctx);}, {}, _ctx)
  kk_integer_t _b_19235_19233 = kk_integer_add_small_const(_y_17884, 1, _ctx); /*int*/;
  kk_unit_t _brw_19828 = kk_Unit;
  kk_ref_set_borrow(i,(kk_integer_box(_b_19235_19233, _ctx)),kk_context());
  kk_ref_drop(i, _ctx);
  return _brw_19828;
}


// lift anonymous function
struct kk_std_core__mlift18039_foreach_indexed_fun20816__t {
  struct kk_function_s _base;
  kk_function_t next0_18265;
};
static kk_box_t kk_std_core__mlift18039_foreach_indexed_fun20816(kk_function_t _fself, kk_box_t _b_19237, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18039_foreach_indexed_fun20816(kk_function_t next0_18265, kk_context_t* _ctx) {
  struct kk_std_core__mlift18039_foreach_indexed_fun20816__t* _self = kk_function_alloc_as(struct kk_std_core__mlift18039_foreach_indexed_fun20816__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18039_foreach_indexed_fun20816, kk_context());
  _self->next0_18265 = next0_18265;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18039_foreach_indexed_fun20816(kk_function_t _fself, kk_box_t _b_19237, kk_context_t* _ctx) {
  struct kk_std_core__mlift18039_foreach_indexed_fun20816__t* _self = kk_function_as(struct kk_std_core__mlift18039_foreach_indexed_fun20816__t*, _fself, _ctx);
  kk_function_t next0_18265 = _self->next0_18265; /* (int) -> <local<12964>|12971> () */
  kk_drop_match(_self, {kk_function_dup(next0_18265, _ctx);}, {}, _ctx)
  kk_unit_t _x20817 = kk_Unit;
  kk_integer_t _x20818 = kk_integer_unbox(_b_19237, _ctx); /*int*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_context_t*), next0_18265, (next0_18265, _x20818, _ctx), _ctx);
  return kk_unit_box(_x20817);
}

kk_unit_t kk_std_core__mlift18039_foreach_indexed(kk_ref_t i, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<h,e> (i : local-var<h,int>, wild_ : ()) -> <local<h>|e> () */ 
  kk_integer_t x_18264;
  kk_box_t _x20812;
  kk_ref_t _x20813 = kk_ref_dup(i, _ctx); /*local-var<12964,int>*/
  _x20812 = kk_ref_get(_x20813,kk_context()); /*264*/
  x_18264 = kk_integer_unbox(_x20812, _ctx); /*int*/
  kk_function_t next0_18265 = kk_std_core__new_mlift18039_foreach_indexed_fun20814(i, _ctx); /*(int) -> <local<12964>|12971> ()*/;
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_18264, _ctx);
    kk_box_t _x20815 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18039_foreach_indexed_fun20816(next0_18265, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x20815); return kk_Unit;
  }
  {
    kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_context_t*), next0_18265, (next0_18265, x_18264, _ctx), _ctx); return kk_Unit;
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18040_foreach_indexed_fun20820__t {
  struct kk_function_s _base;
  kk_ref_t i;
};
static kk_box_t kk_std_core__mlift18040_foreach_indexed_fun20820(kk_function_t _fself, kk_box_t _b_19240, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18040_foreach_indexed_fun20820(kk_ref_t i, kk_context_t* _ctx) {
  struct kk_std_core__mlift18040_foreach_indexed_fun20820__t* _self = kk_function_alloc_as(struct kk_std_core__mlift18040_foreach_indexed_fun20820__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18040_foreach_indexed_fun20820, kk_context());
  _self->i = i;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18040_foreach_indexed_fun20820(kk_function_t _fself, kk_box_t _b_19240, kk_context_t* _ctx) {
  struct kk_std_core__mlift18040_foreach_indexed_fun20820__t* _self = kk_function_as(struct kk_std_core__mlift18040_foreach_indexed_fun20820__t*, _fself, _ctx);
  kk_ref_t i = _self->i; /* local-var<12964,int> */
  kk_drop_match(_self, {kk_ref_dup(i, _ctx);}, {}, _ctx)
  kk_unit_t wild___19242 = kk_Unit;
  kk_unit_unbox(_b_19240);
  kk_unit_t _x20821 = kk_Unit;
  kk_std_core__mlift18039_foreach_indexed(i, wild___19242, _ctx);
  return kk_unit_box(_x20821);
}

kk_unit_t kk_std_core__mlift18040_foreach_indexed(kk_function_t action, kk_ref_t i, kk_box_t x, kk_integer_t j, kk_context_t* _ctx) { /* forall<h,a,e> (action : (int, a) -> e (), i : local-var<h,int>, x : a, j : int) -> <local<h>|e> () */ 
  kk_unit_t x0_18268 = kk_Unit;
  kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), action, (action, j, x, _ctx), _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x20819 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18040_foreach_indexed_fun20820(i, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x20819); return kk_Unit;
  }
  {
    kk_std_core__mlift18039_foreach_indexed(i, x0_18268, _ctx); return kk_Unit;
  }
}
 
// Invoke `action` for each element of a list, passing also the position of the element.


// lift anonymous function
struct kk_std_core_foreach_indexed_fun20823__t {
  struct kk_function_s _base;
  kk_function_t action;
  kk_ref_t loc;
};
static kk_unit_t kk_std_core_foreach_indexed_fun20823(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_indexed_fun20823(kk_function_t action, kk_ref_t loc, kk_context_t* _ctx) {
  struct kk_std_core_foreach_indexed_fun20823__t* _self = kk_function_alloc_as(struct kk_std_core_foreach_indexed_fun20823__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_indexed_fun20823, kk_context());
  _self->action = action;
  _self->loc = loc;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_foreach_indexed_fun20827__t {
  struct kk_function_s _base;
  kk_function_t action;
  kk_ref_t loc;
  kk_box_t x;
};
static kk_box_t kk_std_core_foreach_indexed_fun20827(kk_function_t _fself, kk_box_t _b_19248, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_indexed_fun20827(kk_function_t action, kk_ref_t loc, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_foreach_indexed_fun20827__t* _self = kk_function_alloc_as(struct kk_std_core_foreach_indexed_fun20827__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_indexed_fun20827, kk_context());
  _self->action = action;
  _self->loc = loc;
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_foreach_indexed_fun20827(kk_function_t _fself, kk_box_t _b_19248, kk_context_t* _ctx) {
  struct kk_std_core_foreach_indexed_fun20827__t* _self = kk_function_as(struct kk_std_core_foreach_indexed_fun20827__t*, _fself, _ctx);
  kk_function_t action = _self->action; /* (int, 12970) -> 12971 () */
  kk_ref_t loc = _self->loc; /* local-var<12964,int> */
  kk_box_t x = _self->x; /* 12970 */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);kk_ref_dup(loc, _ctx);kk_box_dup(x, _ctx);}, {}, _ctx)
  kk_unit_t _x20828 = kk_Unit;
  kk_integer_t _x20829 = kk_integer_unbox(_b_19248, _ctx); /*int*/
  kk_std_core__mlift18040_foreach_indexed(action, loc, x, _x20829, _ctx);
  return kk_unit_box(_x20828);
}
static kk_unit_t kk_std_core_foreach_indexed_fun20823(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_foreach_indexed_fun20823__t* _self = kk_function_as(struct kk_std_core_foreach_indexed_fun20823__t*, _fself, _ctx);
  kk_function_t action = _self->action; /* (int, 12970) -> 12971 () */
  kk_ref_t loc = _self->loc; /* local-var<12964,int> */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);kk_ref_dup(loc, _ctx);}, {}, _ctx)
  kk_integer_t x0_18273;
  kk_box_t _x20824;
  kk_ref_t _x20825 = kk_ref_dup(loc, _ctx); /*local-var<12964,int>*/
  _x20824 = kk_ref_get(_x20825,kk_context()); /*264*/
  x0_18273 = kk_integer_unbox(_x20824, _ctx); /*int*/
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x0_18273, _ctx);
    kk_box_t _x20826 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_indexed_fun20827(action, loc, x, _ctx), _ctx); /*3926*/
    return kk_unit_unbox(_x20826);
  }
  {
    return kk_std_core__mlift18040_foreach_indexed(action, loc, x, x0_18273, _ctx);
  }
}

kk_unit_t kk_std_core_foreach_indexed(kk_std_core__list xs, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, action : (int, a) -> e ()) -> e () */ 
  kk_ref_t loc = kk_ref_alloc((kk_integer_box(kk_integer_from_small(0), _ctx)),kk_context()); /*local-var<12964,int>*/;
  kk_unit_t res = kk_Unit;
  kk_function_t _x20822;
  kk_ref_dup(loc, _ctx);
  _x20822 = kk_std_core_new_foreach_indexed_fun20823(action, loc, _ctx); /*(x : 12970) -> <local<12964>|12971> ()*/
  kk_std_core_foreach(xs, _x20822, _ctx);
  kk_box_t _x20830 = kk_std_core_hnd_prompt_local_var(loc, kk_unit_box(res), _ctx); /*10459*/
  kk_unit_unbox(_x20830); return kk_Unit;
}
 
// Invoke a function `f` for each element in a vector `v`


// lift anonymous function
struct kk_std_core_foreach_indexed_fun20832__t_1 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_vector_t v;
};
static kk_unit_t kk_std_core_foreach_indexed_fun20832_1(kk_function_t _fself, kk_ssize_t i0, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_indexed_fun20832_1(kk_function_t f, kk_vector_t v, kk_context_t* _ctx) {
  struct kk_std_core_foreach_indexed_fun20832__t_1* _self = kk_function_alloc_as(struct kk_std_core_foreach_indexed_fun20832__t_1, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_indexed_fun20832_1, kk_context());
  _self->f = f;
  _self->v = v;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_unit_t kk_std_core_foreach_indexed_fun20832_1(kk_function_t _fself, kk_ssize_t i0, kk_context_t* _ctx) {
  struct kk_std_core_foreach_indexed_fun20832__t_1* _self = kk_function_as(struct kk_std_core_foreach_indexed_fun20832__t_1*, _fself, _ctx);
  kk_function_t f = _self->f; /* (int, 13001) -> 13002 () */
  kk_vector_t v = _self->v; /* vector<13001> */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_vector_dup(v, _ctx);}, {}, _ctx)
  kk_box_t x_18365;
  kk_box_t _brw_19824 = kk_vector_at_borrow(v,i0,kk_context()); /*228*/;
  kk_vector_drop(v, _ctx);
  x_18365 = _brw_19824; /*13001*/
  kk_integer_t _x20833 = kk_integer_from_ssize_t(i0,kk_context()); /*int*/
  return kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), f, (f, _x20833, x_18365, _ctx), _ctx);
}

kk_unit_t kk_std_core_foreach_indexed_1(kk_vector_t v, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e> (v : vector<a>, f : (int, a) -> e ()) -> e () */ 
  kk_ssize_t start0_17410 = (KK_IZ(0)); /*ssize_t*/;
  kk_ssize_t end_17411;
  kk_ssize_t _x20831 = kk_vector_len_borrow(v,kk_context()); /*ssize_t*/
  end_17411 = kk_std_core_decr_1(_x20831, _ctx); /*ssize_t*/
  kk_std_core__lift17317_forz(kk_std_core_new_foreach_indexed_fun20832_1(f, v, _ctx), end_17411, start0_17410, _ctx); return kk_Unit;
}
 
// Return the head of list if the list is not empty.

kk_std_core_types__maybe kk_std_core_head_1(kk_std_core__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> maybe<a> */ 
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20842 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20842->head;
    kk_std_core__list _pat0 = _con20842->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core__list_drop(_pat0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return kk_std_core_types__new_Just(x, _ctx);
  }
  {
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Return the head of list if the list is not empty, or use `default` otherwise

kk_box_t kk_std_core_head_2(kk_std_core__list xs, kk_box_t default0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, default : a) -> a */ 
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20843 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20843->head;
    kk_std_core__list _pat0 = _con20843->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core__list_drop(_pat0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_drop(default0, _ctx);
    return x;
  }
  {
    return default0;
  }
}
 
// Return the first character of a string as a string (or the empty string)

kk_string_t kk_std_core_head_3(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  kk_std_core__sslice slice0 = kk_std_core_first1(s, _ctx); /*sslice*/;
  kk_std_core__sslice _x20844;
  bool _match_19817;
  kk_integer_t _brw_19822;
  kk_std_core_types__optional _match_19821 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_19821, _ctx)) {
    kk_box_t _box_x19255 = _match_19821._cons.Optional.value;
    kk_integer_t _n_10357 = kk_integer_unbox(_box_x19255, _ctx);
    kk_integer_dup(_n_10357, _ctx);
    kk_std_core_types__optional_drop(_match_19821, _ctx);
    _brw_19822 = _n_10357; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_19821, _ctx);
    _brw_19822 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_19823 = kk_integer_eq_borrow(_brw_19822,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_19822, _ctx);
  _match_19817 = _brw_19823; /*bool*/
  if (_match_19817) {
    _x20844 = slice0; /*sslice*/
  }
  else {
    kk_integer_t _brw_19819;
    kk_integer_t _x20845;
    kk_std_core_types__optional _match_19818 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_19818, _ctx)) {
      kk_box_t _box_x19256 = _match_19818._cons.Optional.value;
      kk_integer_t _n_103570 = kk_integer_unbox(_box_x19256, _ctx);
      kk_integer_dup(_n_103570, _ctx);
      kk_std_core_types__optional_drop(_match_19818, _ctx);
      _x20845 = _n_103570; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(_match_19818, _ctx);
      _x20845 = kk_integer_from_small(1); /*int*/
    }
    _brw_19819 = kk_integer_add_small_const(_x20845, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_19820 = kk_std_core_extend(slice0, _brw_19819, _ctx); /*sslice*/;
    kk_integer_drop(_brw_19819, _ctx);
    _x20844 = _brw_19820; /*sslice*/
  }
  return kk_std_core_string_3(_x20844, _ctx);
}
 
// Return the first character of a string (or `Nothing` for the empty string).


// lift anonymous function
struct kk_std_core_head_char_fun20849__t {
  struct kk_function_s _base;
};
static kk_std_core_types__maybe kk_std_core_head_char_fun20849(kk_function_t _fself, kk_char_t _b_19257, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_head_char_fun20849(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_head_char_fun20849, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_std_core_types__maybe kk_std_core_head_char_fun20849(kk_function_t _fself, kk_char_t _b_19257, kk_context_t* _ctx) {
  kk_unused(_fself);
  return kk_std_core_types__new_Just(kk_char_box(_b_19257, _ctx), _ctx);
}

kk_std_core_types__maybe kk_std_core_head_char(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> maybe<char> */ 
  kk_std_core__sslice _x20846;
  kk_string_t _x20847 = kk_string_dup(s, _ctx); /*string*/
  kk_integer_t _x20848 = kk_string_len_int(s,kk_context()); /*int*/
  _x20846 = kk_std_core__new_Sslice(_x20847, kk_integer_from_small(0), _x20848, _ctx); /*sslice*/
  return kk_std_core_foreach_while_1(_x20846, kk_std_core_new_head_char_fun20849(_ctx), _ctx);
}

kk_integer_t kk_std_core_index_of_acc(kk_std_core__list xs, kk_function_t pred, kk_integer_t idx, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, pred : (a) -> bool, idx : int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20850 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20850->head;
    kk_std_core__list xx = _con20850->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool _match_19816;
    kk_function_t _x20851 = kk_function_dup(pred, _ctx); /*(13377) -> bool*/
    _match_19816 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x20851, (_x20851, x, _ctx), _ctx); /*bool*/
    if (_match_19816) {
      kk_std_core__list_drop(xx, _ctx);
      kk_function_drop(pred, _ctx);
      return idx;
    }
    { // tailcall
      kk_integer_t _x20852 = kk_integer_add_small_const(idx, 1, _ctx); /*int*/
      xs = xx;
      idx = _x20852;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(pred, _ctx);
    kk_integer_drop(idx, _ctx);
    return kk_integer_from_small(-1);
  }
}
 
// Return the list without its last element.
// Return an empty list for an empty list.

kk_std_core__list kk_std_core__trmc_init(kk_std_core__list xs, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20853 = kk_std_core__as_Cons(xs, _ctx);
    kk_std_core__list xx = _con20853->tail;
    if (kk_std_core__is_Cons(xx, _ctx)) {
      struct kk_std_core_Cons* _con20854 = kk_std_core__as_Cons(xx, _ctx);
      kk_box_t x = _con20853->head;
      kk_reuse_t _ru_20057 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        _ru_20057 = (kk_datatype_ptr_reuse(xs, _ctx));
      }
      else {
        kk_box_dup(x, _ctx);
        kk_std_core__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_std_core__list _trmc_17701 = kk_datatype_null(); /*list<13414>*/;
      kk_std_core__list _trmc_17702 = kk_std_core__new_Cons(_ru_20057, 0, x, _trmc_17701, _ctx); /*list<13414>*/;
      kk_box_t* _b_19268_19263 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17702, _ctx)->tail)); /*field-addr<list<13414>>*/;
      { // tailcall
        kk_std_core_types__cctx _x20855 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17702, _ctx)),_b_19268_19263,true,kk_context()); /*ctx<0>*/
        xs = xx;
        _acc = _x20855;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_std_core__list_drop(xs, _ctx);
    kk_box_t _x20856 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20856, KK_OWNED, _ctx);
  }
}
 
// Return the list without its last element.
// Return an empty list for an empty list.

kk_std_core__list kk_std_core_init(kk_std_core__list xs0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x20857 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_init(xs0, _x20857, _ctx);
}
 
// Is the character an ASCII letter is-

bool kk_std_core_is_alpha(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> bool */ 
  bool _match_19810 = (c >= ('a')); /*bool*/;
  if (_match_19810) {
    bool _match_19812 = (c <= ('z')); /*bool*/;
    if (_match_19812) {
      return true;
    }
    {
      bool _match_19813 = (c >= ('A')); /*bool*/;
      if (_match_19813) {
        return (c <= ('Z'));
      }
      {
        return false;
      }
    }
  }
  {
    bool _match_19811 = (c >= ('A')); /*bool*/;
    if (_match_19811) {
      return (c <= ('Z'));
    }
    {
      return false;
    }
  }
}
 
// Is the character an ASCII hexa-decimal digit ?

bool kk_std_core_is_hex_digit(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> bool */ 
  bool _match_19797 = (c >= ('0')); /*bool*/;
  if (_match_19797) {
    bool _match_19802 = (c <= ('9')); /*bool*/;
    if (_match_19802) {
      return true;
    }
    {
      bool _match_19803 = (c >= ('a')); /*bool*/;
      if (_match_19803) {
        bool _match_19805 = (c <= ('f')); /*bool*/;
        if (_match_19805) {
          return true;
        }
        {
          bool _match_19806 = (c >= ('A')); /*bool*/;
          if (_match_19806) {
            return (c <= ('F'));
          }
          {
            return false;
          }
        }
      }
      {
        bool _match_19804 = (c >= ('A')); /*bool*/;
        if (_match_19804) {
          return (c <= ('F'));
        }
        {
          return false;
        }
      }
    }
  }
  {
    bool _match_19798 = (c >= ('a')); /*bool*/;
    if (_match_19798) {
      bool _match_19800 = (c <= ('f')); /*bool*/;
      if (_match_19800) {
        return true;
      }
      {
        bool _match_19801 = (c >= ('A')); /*bool*/;
        if (_match_19801) {
          return (c <= ('F'));
        }
        {
          return false;
        }
      }
    }
    {
      bool _match_19799 = (c >= ('A')); /*bool*/;
      if (_match_19799) {
        return (c <= ('F'));
      }
      {
        return false;
      }
    }
  }
}
 
// Tests if a character is an element of `" \t\n\r"`

bool kk_std_core_is_white(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> bool */ 
  bool _match_19790 = (c == (' ')); /*bool*/;
  if (_match_19790) {
    return true;
  }
  {
    bool _match_19791 = (c == 0x0009); /*bool*/;
    if (_match_19791) {
      return true;
    }
    {
      bool _match_19792 = (c == 0x000A); /*bool*/;
      if (_match_19792) {
        return true;
      }
      {
        return (c == 0x000D);
      }
    }
  }
}
 
// Append `end` to each string in the list `xs` and join them all together.
// `join-end([],end) === ""`
// `join-end(["a","b"],"/") === "a/b/"`

kk_string_t kk_std_core_join_end(kk_std_core__list xs, kk_string_t end, kk_context_t* _ctx) { /* (xs : list<string>, end : string) -> string */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_string_drop(end, _ctx);
    return kk_string_empty();
  }
  {
    kk_string_t _x20861;
    if (kk_std_core__is_Nil(xs, _ctx)) {
      _x20861 = kk_string_empty(); /*string*/
    }
    else {
      struct kk_std_core_Cons* _con20863 = kk_std_core__as_Cons(xs, _ctx);
      kk_box_t _box_x19274 = _con20863->head;
      kk_std_core__list xx = _con20863->tail;
      kk_string_t x = kk_string_unbox(_box_x19274);
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_std_core__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_string_t _x20864 = kk_string_dup(end, _ctx); /*string*/
      _x20861 = kk_std_core__lift17316_joinsep(_x20864, xx, x, _ctx); /*string*/
    }
    return kk_std_core__lp__plus__plus__1_rp_(_x20861, end, _ctx);
  }
}
 
// Return the last element of a list (or `Nothing` for the empty list)

kk_std_core_types__maybe kk_std_core_last(kk_std_core__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> maybe<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20865 = kk_std_core__as_Cons(xs, _ctx);
    kk_std_core__list _pat0 = _con20865->tail;
    if (kk_std_core__is_Nil(_pat0, _ctx)) {
      kk_box_t x = _con20865->head;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_box_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      return kk_std_core_types__new_Just(x, _ctx);
    }
  }
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20866 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _pat2 = _con20866->head;
    kk_std_core__list xx = _con20866->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_pat2, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    { // tailcall
      xs = xx;
      goto kk__tailcall;
    }
  }
  {
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Return the last element of a list (or `default` for the empty list)

kk_box_t kk_std_core_last_1(kk_std_core__list xs, kk_box_t default0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, default : a) -> a */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20867 = kk_std_core__as_Cons(xs, _ctx);
    kk_std_core__list _pat0 = _con20867->tail;
    if (kk_std_core__is_Nil(_pat0, _ctx)) {
      kk_box_t x = _con20867->head;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_box_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_box_drop(default0, _ctx);
      return x;
    }
  }
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20868 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _pat2 = _con20868->head;
    kk_std_core__list xx = _con20868->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_pat2, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    { // tailcall
      xs = xx;
      goto kk__tailcall;
    }
  }
  {
    return default0;
  }
}
 
// O(`n`). The last `n` (default = `1`) characters in a string

kk_std_core__sslice kk_std_core_last_2(kk_string_t s, kk_std_core_types__optional n, kk_context_t* _ctx) { /* (s : string, n : optional<int>) -> sslice */ 
  kk_std_core__sslice slice0 = kk_std_core_last1(s, _ctx); /*sslice*/;
  bool _match_19782;
  kk_integer_t _brw_19788;
  if (kk_std_core_types__is_Optional(n, _ctx)) {
    kk_box_t _box_x19275 = n._cons.Optional.value;
    kk_integer_t _n_14007 = kk_integer_unbox(_box_x19275, _ctx);
    kk_integer_dup(_n_14007, _ctx);
    _brw_19788 = _n_14007; /*int*/
  }
  else {
    _brw_19788 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_19789 = kk_integer_eq_borrow(_brw_19788,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_19788, _ctx);
  _match_19782 = _brw_19789; /*bool*/
  if (_match_19782) {
    kk_std_core_types__optional_drop(n, _ctx);
    return slice0;
  }
  {
    kk_std_core__sslice _own_19784;
    kk_integer_t _brw_19785;
    kk_integer_t _x20869;
    if (kk_std_core_types__is_Optional(n, _ctx)) {
      kk_box_t _box_x19276 = n._cons.Optional.value;
      kk_integer_t _n_140070 = kk_integer_unbox(_box_x19276, _ctx);
      kk_integer_dup(_n_140070, _ctx);
      _x20869 = _n_140070; /*int*/
    }
    else {
      _x20869 = kk_integer_from_small(1); /*int*/
    }
    _brw_19785 = kk_integer_sub((kk_integer_from_small(1)),_x20869,kk_context()); /*int*/
    kk_std_core__sslice _brw_19786 = kk_std_core_advance(slice0, _brw_19785, _ctx); /*sslice*/;
    kk_integer_drop(_brw_19785, _ctx);
    _own_19784 = _brw_19786; /*sslice*/
    kk_integer_t _brw_19783;
    kk_integer_t _x20870;
    if (kk_std_core_types__is_Optional(n, _ctx)) {
      kk_box_t _box_x19277 = n._cons.Optional.value;
      kk_integer_t _n_140071 = kk_integer_unbox(_box_x19277, _ctx);
      kk_integer_dup(_n_140071, _ctx);
      kk_std_core_types__optional_drop(n, _ctx);
      _x20870 = _n_140071; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(n, _ctx);
      _x20870 = kk_integer_from_small(1); /*int*/
    }
    _brw_19783 = kk_integer_add_small_const(_x20870, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_19787 = kk_std_core_extend(_own_19784, _brw_19783, _ctx); /*sslice*/;
    kk_integer_drop(_brw_19783, _ctx);
    return _brw_19787;
  }
}
 
// Take the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core__list kk_std_core__trmc_take(kk_std_core__list xs, kk_integer_t n, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con20871 = kk_std_core__as_Cons(xs, _ctx);
    if (kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context())) {
      kk_box_t x = _con20871->head;
      kk_std_core__list xx = _con20871->tail;
      kk_reuse_t _ru_20063 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        _ru_20063 = (kk_datatype_ptr_reuse(xs, _ctx));
      }
      else {
        kk_box_dup(x, _ctx);
        kk_std_core__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_std_core__list _trmc_17703 = kk_datatype_null(); /*list<14131>*/;
      kk_std_core__list _trmc_17704 = kk_std_core__new_Cons(_ru_20063, 0, x, _trmc_17703, _ctx); /*list<14131>*/;
      kk_box_t* _b_19288_19283 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17704, _ctx)->tail)); /*field-addr<list<14131>>*/;
      { // tailcall
        kk_integer_t _x20872 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        kk_std_core_types__cctx _x20873 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17704, _ctx)),_b_19288_19283,true,kk_context()); /*ctx<0>*/
        xs = xx;
        n = _x20872;
        _acc = _x20873;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_std_core__list_drop(xs, _ctx);
    kk_integer_drop(n, _ctx);
    kk_box_t _x20874 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20874, KK_OWNED, _ctx);
  }
}
 
// Take the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core__list kk_std_core_take(kk_std_core__list xs0, kk_integer_t n0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> list<a> */ 
  kk_std_core_types__cctx _x20875 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_take(xs0, n0, _x20875, _ctx);
}
 
// split a list at position `n`

kk_std_core_types__tuple2_ kk_std_core_split(kk_std_core__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> (list<a>, list<a>) */ 
  kk_std_core__list _b_19296_19294;
  kk_std_core__list _x20876 = kk_std_core__list_dup(xs, _ctx); /*list<14151>*/
  kk_integer_t _x20877 = kk_integer_dup(n, _ctx); /*int*/
  _b_19296_19294 = kk_std_core_take(_x20876, _x20877, _ctx); /*list<14151>*/
  kk_std_core__list _b_19297_19295 = kk_std_core_drop(xs, n, _ctx); /*list<14151>*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_19296_19294, _ctx), kk_std_core__list_box(_b_19297_19295, _ctx), _ctx);
}
 
// Lookup the first element satisfying some predicate


// lift anonymous function
struct kk_std_core_lookup_fun20882__t {
  struct kk_function_s _base;
  kk_function_t pred;
};
static kk_std_core_types__maybe kk_std_core_lookup_fun20882(kk_function_t _fself, kk_box_t _b_19300, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_lookup_fun20882(kk_function_t pred, kk_context_t* _ctx) {
  struct kk_std_core_lookup_fun20882__t* _self = kk_function_alloc_as(struct kk_std_core_lookup_fun20882__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_lookup_fun20882, kk_context());
  _self->pred = pred;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_core_types__maybe kk_std_core_lookup_fun20882(kk_function_t _fself, kk_box_t _b_19300, kk_context_t* _ctx) {
  struct kk_std_core_lookup_fun20882__t* _self = kk_function_as(struct kk_std_core_lookup_fun20882__t*, _fself, _ctx);
  kk_function_t pred = _self->pred; /* (14483) -> bool */
  kk_drop_match(_self, {kk_function_dup(pred, _ctx);}, {}, _ctx)
  bool _match_19779;
  kk_box_t _x20883;
  kk_std_core_types__tuple2_ _match_19781;
  kk_box_t _x20884 = kk_box_dup(_b_19300, _ctx); /*10898*/
  _match_19781 = kk_std_core_types__tuple2__unbox(_x20884, KK_OWNED, _ctx); /*(14483, 14484)*/
  {
    kk_box_t _x = _match_19781.fst;
    kk_box_dup(_x, _ctx);
    kk_std_core_types__tuple2__drop(_match_19781, _ctx);
    _x20883 = _x; /*14483*/
  }
  _match_19779 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), pred, (pred, _x20883, _ctx), _ctx); /*bool*/
  if (_match_19779) {
    kk_box_t _x20885;
    kk_std_core_types__tuple2_ _match_19780 = kk_std_core_types__tuple2__unbox(_b_19300, KK_OWNED, _ctx); /*(14483, 14484)*/;
    {
      kk_box_t _x0 = _match_19780.snd;
      kk_box_dup(_x0, _ctx);
      kk_std_core_types__tuple2__drop(_match_19780, _ctx);
      _x20885 = _x0; /*14484*/
    }
    return kk_std_core_types__new_Just(_x20885, _ctx);
  }
  {
    kk_box_drop(_b_19300, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}

kk_std_core_types__maybe kk_std_core_lookup(kk_std_core__list xs, kk_function_t pred, kk_context_t* _ctx) { /* forall<a,b> (xs : list<(a, b)>, pred : (a) -> bool) -> maybe<b> */ 
  return kk_std_core_foreach_while(xs, kk_std_core_new_lookup_fun20882(pred, _ctx), _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18041_trmc_lift17322_map_indexed(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i0_17568, kk_std_core__list yy, kk_box_t _trmc_17705, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (idx : int, value : a) -> e b, i0.17568 : int, yy : list<a>, b) -> e list<b> */ 
  kk_std_core__list _trmc_17706 = kk_datatype_null(); /*list<14539>*/;
  kk_std_core__list _trmc_17707 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_17705, _trmc_17706, _ctx); /*list<14539>*/;
  kk_box_t* _b_19312_19309 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17707, _ctx)->tail)); /*field-addr<list<14539>>*/;
  kk_std_core_types__cctx _x20886 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17707, _ctx)),_b_19312_19309,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17322_map_indexed(f, yy, i0_17568, _x20886, _ctx);
}
 
// lifted local: map-indexed, map-idx


// lift anonymous function
struct kk_std_core__trmc_lift17322_map_indexed_fun20891__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_integer_t i0_175680;
  kk_std_core__list yy0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_lift17322_map_indexed_fun20891(kk_function_t _fself, kk_box_t _b_19317, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_lift17322_map_indexed_fun20891(kk_function_t f0, kk_integer_t i0_175680, kk_std_core__list yy0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17322_map_indexed_fun20891__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_lift17322_map_indexed_fun20891__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_lift17322_map_indexed_fun20891, kk_context());
  _self->f0 = f0;
  _self->i0_175680 = i0_175680;
  _self->yy0 = yy0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_lift17322_map_indexed_fun20891(kk_function_t _fself, kk_box_t _b_19317, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17322_map_indexed_fun20891__t* _self = kk_function_as(struct kk_std_core__trmc_lift17322_map_indexed_fun20891__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (idx : int, value : 14538) -> 14540 14539 */
  kk_integer_t i0_175680 = _self->i0_175680; /* int */
  kk_std_core__list yy0 = _self->yy0; /* list<14538> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<14539>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_integer_dup(i0_175680, _ctx);kk_std_core__list_dup(yy0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_19335_177050 = _b_19317; /*14539*/;
  kk_std_core__list _x20892 = kk_std_core__mlift18041_trmc_lift17322_map_indexed(_acc0, f0, i0_175680, yy0, _trmc_19335_177050, _ctx); /*list<14539>*/
  return kk_std_core__list_box(_x20892, _ctx);
}

kk_std_core__list kk_std_core__trmc_lift17322_map_indexed(kk_function_t f0, kk_std_core__list ys, kk_integer_t i, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a) -> e b, ys : list<a>, i : int, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con20887 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con20887->head;
    kk_std_core__list yy0 = _con20887->tail;
    kk_reuse_t _ru_20064 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_20064 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_integer_t i0_175680;
    kk_integer_t _x20888 = kk_integer_dup(i, _ctx); /*int*/
    i0_175680 = kk_integer_add_small_const(_x20888, 1, _ctx); /*int*/
    kk_box_t x_18277;
    kk_function_t _x20889 = kk_function_dup(f0, _ctx); /*(idx : int, value : 14538) -> 14540 14539*/
    x_18277 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x20889, (_x20889, i, y, _ctx), _ctx); /*14539*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_20064,kk_context());
      kk_box_drop(x_18277, _ctx);
      kk_box_t _x20890 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_lift17322_map_indexed_fun20891(f0, i0_175680, yy0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20890, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_177060 = kk_datatype_null(); /*list<14539>*/;
      kk_std_core__list _trmc_177070 = kk_std_core__new_Cons(_ru_20064, kk_field_index_of(struct kk_std_core_Cons, tail), x_18277, _trmc_177060, _ctx); /*list<14539>*/;
      kk_box_t* _b_19329_19323 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_177070, _ctx)->tail)); /*field-addr<list<14539>>*/;
      { // tailcall
        kk_std_core_types__cctx _x20893 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_177070, _ctx)),_b_19329_19323,false,kk_context()); /*ctx<0>*/
        ys = yy0;
        i = i0_175680;
        _acc0 = _x20893;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x20894 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20894, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-indexed, map-idx

kk_std_core__list kk_std_core__lift17322_map_indexed(kk_function_t f1, kk_std_core__list ys0, kk_integer_t i0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a) -> e b, ys : list<a>, i : int) -> e list<b> */ 
  kk_std_core_types__cctx _x20895 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17322_map_indexed(f1, ys0, i0, _x20895, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18042_trmc_lift17323_map_indexed_peek(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i0_17570, kk_std_core__list yy, kk_box_t _trmc_17708, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (idx : int, value : a, rest : list<a>) -> e b, i0.17570 : int, yy : list<a>, b) -> e list<b> */ 
  kk_std_core__list _trmc_17709 = kk_datatype_null(); /*list<14596>*/;
  kk_std_core__list _trmc_17710 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_17708, _trmc_17709, _ctx); /*list<14596>*/;
  kk_box_t* _b_19344_19341 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17710, _ctx)->tail)); /*field-addr<list<14596>>*/;
  kk_std_core_types__cctx _x20896 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17710, _ctx)),_b_19344_19341,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17323_map_indexed_peek(f, yy, i0_17570, _x20896, _ctx);
}
 
// lifted local: map-indexed-peek, mapidx


// lift anonymous function
struct kk_std_core__trmc_lift17323_map_indexed_peek_fun20902__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_integer_t i0_175700;
  kk_std_core__list yy0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_lift17323_map_indexed_peek_fun20902(kk_function_t _fself, kk_box_t _b_19349, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_lift17323_map_indexed_peek_fun20902(kk_function_t f0, kk_integer_t i0_175700, kk_std_core__list yy0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17323_map_indexed_peek_fun20902__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_lift17323_map_indexed_peek_fun20902__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_lift17323_map_indexed_peek_fun20902, kk_context());
  _self->f0 = f0;
  _self->i0_175700 = i0_175700;
  _self->yy0 = yy0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_lift17323_map_indexed_peek_fun20902(kk_function_t _fself, kk_box_t _b_19349, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17323_map_indexed_peek_fun20902__t* _self = kk_function_as(struct kk_std_core__trmc_lift17323_map_indexed_peek_fun20902__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (idx : int, value : 14595, rest : list<14595>) -> 14597 14596 */
  kk_integer_t i0_175700 = _self->i0_175700; /* int */
  kk_std_core__list yy0 = _self->yy0; /* list<14595> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<14596>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_integer_dup(i0_175700, _ctx);kk_std_core__list_dup(yy0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_19367_177080 = _b_19349; /*14596*/;
  kk_std_core__list _x20903 = kk_std_core__mlift18042_trmc_lift17323_map_indexed_peek(_acc0, f0, i0_175700, yy0, _trmc_19367_177080, _ctx); /*list<14596>*/
  return kk_std_core__list_box(_x20903, _ctx);
}

kk_std_core__list kk_std_core__trmc_lift17323_map_indexed_peek(kk_function_t f0, kk_std_core__list ys, kk_integer_t i, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a, rest : list<a>) -> e b, ys : list<a>, i : int, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con20897 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con20897->head;
    kk_std_core__list yy0 = _con20897->tail;
    kk_reuse_t _ru_20065 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_20065 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_integer_t i0_175700;
    kk_integer_t _x20898 = kk_integer_dup(i, _ctx); /*int*/
    i0_175700 = kk_integer_add_small_const(_x20898, 1, _ctx); /*int*/
    kk_box_t x_18280;
    kk_function_t _x20900 = kk_function_dup(f0, _ctx); /*(idx : int, value : 14595, rest : list<14595>) -> 14597 14596*/
    kk_std_core__list _x20899 = kk_std_core__list_dup(yy0, _ctx); /*list<14595>*/
    x_18280 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_std_core__list, kk_context_t*), _x20900, (_x20900, i, y, _x20899, _ctx), _ctx); /*14596*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_20065,kk_context());
      kk_box_drop(x_18280, _ctx);
      kk_box_t _x20901 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_lift17323_map_indexed_peek_fun20902(f0, i0_175700, yy0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20901, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_177090 = kk_datatype_null(); /*list<14596>*/;
      kk_std_core__list _trmc_177100 = kk_std_core__new_Cons(_ru_20065, kk_field_index_of(struct kk_std_core_Cons, tail), x_18280, _trmc_177090, _ctx); /*list<14596>*/;
      kk_box_t* _b_19361_19355 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_177100, _ctx)->tail)); /*field-addr<list<14596>>*/;
      { // tailcall
        kk_std_core_types__cctx _x20904 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_177100, _ctx)),_b_19361_19355,false,kk_context()); /*ctx<0>*/
        ys = yy0;
        i = i0_175700;
        _acc0 = _x20904;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x20905 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20905, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-indexed-peek, mapidx

kk_std_core__list kk_std_core__lift17323_map_indexed_peek(kk_function_t f1, kk_std_core__list ys0, kk_integer_t i0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a, rest : list<a>) -> e b, ys : list<a>, i : int) -> e list<b> */ 
  kk_std_core_types__cctx _x20906 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17323_map_indexed_peek(f1, ys0, i0, _x20906, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18043_trmc_map_while(kk_std_core_types__cctx _acc, kk_function_t action, kk_std_core__list xx, kk_std_core_types__maybe _y_17901, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, action : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Just(_y_17901, _ctx)) {
    kk_box_t y = _y_17901._cons.Just.value;
    kk_std_core__list _trmc_17711 = kk_datatype_null(); /*list<14638>*/;
    kk_std_core__list _trmc_17712 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), y, _trmc_17711, _ctx); /*list<14638>*/;
    kk_box_t* _b_19378_19373 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17712, _ctx)->tail)); /*field-addr<list<14638>>*/;
    kk_std_core_types__cctx _x20907 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17712, _ctx)),_b_19378_19373,false,kk_context()); /*ctx<0>*/
    return kk_std_core__trmc_map_while(xx, action, _x20907, _ctx);
  }
  {
    kk_std_core__list_drop(xx, _ctx);
    kk_function_drop(action, _ctx);
    kk_box_t _x20908 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20908, KK_OWNED, _ctx);
  }
}
 
// Invoke `action` on each element of a list while `action` returns `Just`


// lift anonymous function
struct kk_std_core__trmc_map_while_fun20913__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_map_while_fun20913(kk_function_t _fself, kk_box_t _b_19387, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_map_while_fun20913(kk_function_t action0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_map_while_fun20913__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_map_while_fun20913__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_map_while_fun20913, kk_context());
  _self->action0 = action0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_map_while_fun20913(kk_function_t _fself, kk_box_t _b_19387, kk_context_t* _ctx) {
  struct kk_std_core__trmc_map_while_fun20913__t* _self = kk_function_as(struct kk_std_core__trmc_map_while_fun20913__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (14637) -> 14639 maybe<14638> */
  kk_std_core__list xx0 = _self->xx0; /* list<14637> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<14638>> */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_19407_179010 = kk_std_core_types__maybe_unbox(_b_19387, KK_OWNED, _ctx); /*maybe<14638>*/;
  kk_std_core__list _x20914 = kk_std_core__mlift18043_trmc_map_while(_acc0, action0, xx0, _y_19407_179010, _ctx); /*list<14638>*/
  return kk_std_core__list_box(_x20914, _ctx);
}

kk_std_core__list kk_std_core__trmc_map_while(kk_std_core__list xs, kk_function_t action0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(action0, _ctx);
    kk_box_t _x20909 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x20909, KK_OWNED, _ctx);
  }
  {
    struct kk_std_core_Cons* _con20910 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20910->head;
    kk_std_core__list xx0 = _con20910->tail;
    kk_reuse_t _ru_20066 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_20066 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x0_18283;
    kk_function_t _x20911 = kk_function_dup(action0, _ctx); /*(14637) -> 14639 maybe<14638>*/
    x0_18283 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x20911, (_x20911, x, _ctx), _ctx); /*maybe<14638>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_20066,kk_context());
      kk_std_core_types__maybe_drop(x0_18283, _ctx);
      kk_box_t _x20912 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_map_while_fun20913(action0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x20912, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Just(x0_18283, _ctx)) {
      kk_box_t y0 = x0_18283._cons.Just.value;
      kk_std_core__list _trmc_177110 = kk_datatype_null(); /*list<14638>*/;
      kk_std_core__list _trmc_177120 = kk_std_core__new_Cons(_ru_20066, kk_field_index_of(struct kk_std_core_Cons, tail), y0, _trmc_177110, _ctx); /*list<14638>*/;
      kk_box_t* _b_19401_19393 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_177120, _ctx)->tail)); /*field-addr<list<14638>>*/;
      { // tailcall
        kk_std_core_types__cctx _x20915 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_177120, _ctx)),_b_19401_19393,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x20915;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_20066,kk_context());
      kk_std_core__list_drop(xx0, _ctx);
      kk_function_drop(action0, _ctx);
      kk_box_t _x20916 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
      return kk_std_core__list_unbox(_x20916, KK_OWNED, _ctx);
    }
  }
}
 
// Invoke `action` on each element of a list while `action` returns `Just`

kk_std_core__list kk_std_core_map_while(kk_std_core__list xs0, kk_function_t action1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x20917 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_map_while(xs0, action1, _x20917, _ctx);
}
 
// Returns the largest element of a list of integers (or `default` (=`0`) for the empty list)


// lift anonymous function
struct kk_std_core_maximum_fun20920__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_maximum_fun20920(kk_function_t _fself, kk_box_t _b_19413, kk_box_t _b_19414, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_maximum_fun20920(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_maximum_fun20920, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_maximum_fun20920(kk_function_t _fself, kk_box_t _b_19413, kk_box_t _b_19414, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x20921;
  kk_integer_t _x20922 = kk_integer_unbox(_b_19413, _ctx); /*int*/
  kk_integer_t _x20923 = kk_integer_unbox(_b_19414, _ctx); /*int*/
  _x20921 = kk_std_core_max(_x20922, _x20923, _ctx); /*int*/
  return kk_integer_box(_x20921, _ctx);
}

kk_integer_t kk_std_core_maximum(kk_std_core__list xs, kk_std_core_types__optional default0, kk_context_t* _ctx) { /* (xs : list<int>, default : optional<int>) -> int */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    if (kk_std_core_types__is_Optional(default0, _ctx)) {
      kk_box_t _box_x19408 = default0._cons.Optional.value;
      kk_integer_t _default_14687 = kk_integer_unbox(_box_x19408, _ctx);
      kk_integer_dup(_default_14687, _ctx);
      kk_std_core_types__optional_drop(default0, _ctx);
      return _default_14687;
    }
    {
      kk_std_core_types__optional_drop(default0, _ctx);
      return kk_integer_from_small(0);
    }
  }
  {
    struct kk_std_core_Cons* _con20918 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x19409 = _con20918->head;
    kk_std_core__list xx = _con20918->tail;
    kk_integer_t x = kk_integer_unbox(_box_x19409, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_integer_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__optional_drop(default0, _ctx);
    kk_box_t _x20919 = kk_std_core_foldl(xx, kk_integer_box(x, _ctx), kk_std_core_new_maximum_fun20920(_ctx), _ctx); /*12696*/
    return kk_integer_unbox(_x20919, _ctx);
  }
}
 
// Returns the largest element of a list of floats (or `0` for the empty list)


// lift anonymous function
struct kk_std_core_maximum_fun20926__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_maximum_fun20926_1(kk_function_t _fself, kk_box_t _b_19422, kk_box_t _b_19423, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_maximum_fun20926_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_maximum_fun20926_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_maximum_fun20926_1(kk_function_t _fself, kk_box_t _b_19422, kk_box_t _b_19423, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x20927;
  double _x20928 = kk_double_unbox(_b_19422, KK_OWNED, _ctx); /*float64*/
  double _x20929 = kk_double_unbox(_b_19423, KK_OWNED, _ctx); /*float64*/
  _x20927 = kk_std_core_max_1(_x20928, _x20929, _ctx); /*float64*/
  return kk_double_box(_x20927, _ctx);
}

double kk_std_core_maximum_1(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    return 0x0p+0;
  }
  {
    struct kk_std_core_Cons* _con20924 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x19418 = _con20924->head;
    kk_std_core__list xx = _con20924->tail;
    double x = kk_double_unbox(_box_x19418, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_box_x19418, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t _x20925 = kk_std_core_foldl(xx, kk_double_box(x, _ctx), kk_std_core_new_maximum_fun20926_1(_ctx), _ctx); /*12696*/
    return kk_double_unbox(_x20925, KK_OWNED, _ctx);
  }
}
 
// Convert a list to a `:maybe` type, using `Nothing` for an empty list, and otherwise `Just` on the head element.
// Note: this is just `head`.

kk_std_core_types__maybe kk_std_core_maybe_3(kk_std_core__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> maybe<a> */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    struct kk_std_core_Cons* _con20930 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con20930->head;
    kk_std_core__list _pat1 = _con20930->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core__list_drop(_pat1, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return kk_std_core_types__new_Just(x, _ctx);
  }
}
 
// Transform a string to a maybe type, using `Nothing` for an empty string

kk_std_core_types__maybe kk_std_core_maybe_6(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> maybe<string> */ 
  bool _match_19772;
  kk_string_t _x20931 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x20932 = kk_string_empty(); /*string*/
  _match_19772 = kk_string_is_eq(_x20931,_x20932,kk_context()); /*bool*/
  if (_match_19772) {
    kk_string_drop(s, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    return kk_std_core_types__new_Just(kk_string_box(s), _ctx);
  }
}
 
// Transform a `:null` type to a `:maybe` type. Note that it is not
// always the case that `id(x) == maybe(null(x))` (e.g. when `x = Just(Nothing)`).

kk_std_core_types__maybe kk_std_core_maybe_8(kk_std_core__null n, kk_context_t* _ctx) { /* forall<a> (n : null<a>) -> maybe<a> */ 
  return (kk_datatype_is_null(n) ? kk_std_core_types__new_Nothing(kk_context()) : kk_std_core_types__new_Just(kk_datatype_box(n),kk_context()));
}
 
// Returns the smallest element of a list of integers (or `default` (=`0`) for the empty list)


// lift anonymous function
struct kk_std_core_minimum_fun20936__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_minimum_fun20936(kk_function_t _fself, kk_box_t _b_19438, kk_box_t _b_19439, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_minimum_fun20936(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_minimum_fun20936, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_minimum_fun20936(kk_function_t _fself, kk_box_t _b_19438, kk_box_t _b_19439, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x20937;
  kk_integer_t _x20938 = kk_integer_unbox(_b_19438, _ctx); /*int*/
  kk_integer_t _x20939 = kk_integer_unbox(_b_19439, _ctx); /*int*/
  _x20937 = kk_std_core_min(_x20938, _x20939, _ctx); /*int*/
  return kk_integer_box(_x20937, _ctx);
}

kk_integer_t kk_std_core_minimum(kk_std_core__list xs, kk_std_core_types__optional default0, kk_context_t* _ctx) { /* (xs : list<int>, default : optional<int>) -> int */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    if (kk_std_core_types__is_Optional(default0, _ctx)) {
      kk_box_t _box_x19433 = default0._cons.Optional.value;
      kk_integer_t _default_15166 = kk_integer_unbox(_box_x19433, _ctx);
      kk_integer_dup(_default_15166, _ctx);
      kk_std_core_types__optional_drop(default0, _ctx);
      return _default_15166;
    }
    {
      kk_std_core_types__optional_drop(default0, _ctx);
      return kk_integer_from_small(0);
    }
  }
  {
    struct kk_std_core_Cons* _con20934 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x19434 = _con20934->head;
    kk_std_core__list xx = _con20934->tail;
    kk_integer_t x = kk_integer_unbox(_box_x19434, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_integer_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__optional_drop(default0, _ctx);
    kk_box_t _x20935 = kk_std_core_foldl(xx, kk_integer_box(x, _ctx), kk_std_core_new_minimum_fun20936(_ctx), _ctx); /*12696*/
    return kk_integer_unbox(_x20935, _ctx);
  }
}
 
// Returns the smallest element of a list of floats (or `0` for the empty list)


// lift anonymous function
struct kk_std_core_minimum_fun20942__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_minimum_fun20942_1(kk_function_t _fself, kk_box_t _b_19447, kk_box_t _b_19448, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_minimum_fun20942_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_minimum_fun20942_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_minimum_fun20942_1(kk_function_t _fself, kk_box_t _b_19447, kk_box_t _b_19448, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x20943;
  double _x20944 = kk_double_unbox(_b_19447, KK_OWNED, _ctx); /*float64*/
  double _x20945 = kk_double_unbox(_b_19448, KK_OWNED, _ctx); /*float64*/
  _x20943 = kk_std_core_min_1(_x20944, _x20945, _ctx); /*float64*/
  return kk_double_box(_x20943, _ctx);
}

double kk_std_core_minimum_1(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    return 0x0p+0;
  }
  {
    struct kk_std_core_Cons* _con20940 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x19443 = _con20940->head;
    kk_std_core__list xx = _con20940->tail;
    double x = kk_double_unbox(_box_x19443, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_box_x19443, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t _x20941 = kk_std_core_foldl(xx, kk_double_box(x, _ctx), kk_std_core_new_minimum_fun20942_1(_ctx), _ctx); /*12696*/
    return kk_double_unbox(_x20941, KK_OWNED, _ctx);
  }
}
 
// Disable tracing completely.

kk_unit_t kk_std_core_notrace(kk_context_t* _ctx) { /* () -> (st<global>) () */ 
  kk_ref_set_borrow(kk_std_core_trace_enabled,(kk_bool_box(false)),kk_context()); return kk_Unit;
}
 
// Transform a `:maybe` type to a `:null` type (using `null` for `Nothing`).

kk_std_core__null kk_std_core_null(kk_std_core_types__maybe x, kk_context_t* _ctx) { /* forall<a> (x : maybe<a>) -> null<a> */ 
  return (kk_std_core_types__is_Nothing(x,kk_context()) ? kk_datatype_null() : kk_datatype_unbox((x)._cons.Just.value) /* kk_datatype_unbox(kk_datatype_unjust(x,kk_context())) */ );
}
 
// Cast a integer that is zero to a null

kk_std_core__null kk_std_core_null_1(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> null<int> */ 
  kk_std_core_types__maybe _x20946;
  bool _match_19769 = kk_integer_eq_borrow(i,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_19769) {
    kk_integer_drop(i, _ctx);
    _x20946 = kk_std_core_types__new_Nothing(_ctx); /*forall<a> maybe<a>*/
  }
  else {
    _x20946 = kk_std_core_types__new_Just(kk_integer_box(i, _ctx), _ctx); /*forall<a> maybe<a>*/
  }
  return kk_std_core_null(_x20946, _ctx);
}
 
// Cast an empty string a null

kk_std_core__null kk_std_core_null_2(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> null<string> */ 
  kk_std_core_types__maybe _x20947;
  bool _match_19768;
  kk_string_t _x20948 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x20949 = kk_string_empty(); /*string*/
  _match_19768 = kk_string_is_eq(_x20948,_x20949,kk_context()); /*bool*/
  if (_match_19768) {
    kk_string_drop(s, _ctx);
    _x20947 = kk_std_core_types__new_Nothing(_ctx); /*forall<a> maybe<a>*/
  }
  else {
    _x20947 = kk_std_core_types__new_Just(kk_string_box(s), _ctx); /*forall<a> maybe<a>*/
  }
  return kk_std_core_null(_x20947, _ctx);
}
 
// Left-align a string to width `width`  using `fill`  (default is a space) to fill on the right.

kk_string_t kk_std_core_pad_right(kk_string_t s, kk_integer_t width, kk_std_core_types__optional fill, kk_context_t* _ctx) { /* (s : string, width : int, fill : optional<char>) -> string */ 
  kk_integer_t n;
  kk_string_t _x20952 = kk_string_dup(s, _ctx); /*string*/
  n = kk_string_len_int(_x20952,kk_context()); /*int*/
  bool _match_19767 = kk_integer_lte_borrow(width,n,kk_context()); /*bool*/;
  if (_match_19767) {
    kk_integer_drop(n, _ctx);
    kk_std_core_types__optional_drop(fill, _ctx);
    return s;
  }
  {
    kk_string_t s0_17578;
    kk_char_t _x20953;
    if (kk_std_core_types__is_Optional(fill, _ctx)) {
      kk_box_t _box_x19462 = fill._cons.Optional.value;
      kk_char_t _fill_15568 = kk_char_unbox(_box_x19462, KK_BORROWED, _ctx);
      kk_std_core_types__optional_drop(fill, _ctx);
      _x20953 = _fill_15568; /*char*/
    }
    else {
      kk_std_core_types__optional_drop(fill, _ctx);
      _x20953 = ' '; /*char*/
    }
    s0_17578 = kk_std_core_string(_x20953, _ctx); /*string*/
    kk_integer_t n0_17579;
    kk_integer_t _x20954 = kk_integer_dup(width, _ctx); /*int*/
    n0_17579 = kk_integer_sub(_x20954,n,kk_context()); /*int*/
    kk_string_t _x20955;
    kk_ssize_t _x20956 = kk_std_core_ssize__t(n0_17579, _ctx); /*ssize_t*/
    _x20955 = kk_std_core_repeatz(s0_17578, _x20956, _ctx); /*string*/
    return kk_std_core__lp__plus__plus__1_rp_(s, _x20955, _ctx);
  }
}
 
// Is `pre`  a prefix of `s`? If so, returns a slice
// of `s` following `pre` up to the end of `s`.

kk_std_core_types__maybe kk_std_core_starts_with(kk_string_t s, kk_string_t pre, kk_context_t* _ctx) { /* (s : string, pre : string) -> maybe<sslice> */ 
  bool _match_19766;
  kk_string_t _x20957 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x20958 = kk_string_dup(pre, _ctx); /*string*/
  _match_19766 = kk_string_starts_with(_x20957,_x20958,kk_context()); /*bool*/
  if (_match_19766) {
    kk_integer_t x_17582;
    kk_string_t _x20959 = kk_string_dup(s, _ctx); /*string*/
    x_17582 = kk_string_len_int(_x20959,kk_context()); /*int*/
    kk_integer_t y_17583;
    kk_string_t _x20960 = kk_string_dup(pre, _ctx); /*string*/
    y_17583 = kk_string_len_int(_x20960,kk_context()); /*int*/
    kk_std_core__sslice _b_19464_19463;
    kk_integer_t _x20961 = kk_string_len_int(pre,kk_context()); /*int*/
    kk_integer_t _x20962 = kk_integer_sub(x_17582,y_17583,kk_context()); /*int*/
    _b_19464_19463 = kk_std_core__new_Sslice(s, _x20961, _x20962, _ctx); /*sslice*/
    return kk_std_core_types__new_Just(kk_std_core__sslice_box(_b_19464_19463, _ctx), _ctx);
  }
  {
    kk_string_drop(s, _ctx);
    kk_string_drop(pre, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Trim off a substring `sub` while `s` starts with that string.

kk_string_t kk_std_core_trim_left_1(kk_string_t s, kk_string_t sub, kk_context_t* _ctx) { /* (s : string, sub : string) -> string */ 
  kk__tailcall: ;
  bool _match_19764;
  kk_string_t _x20963 = kk_string_dup(sub, _ctx); /*string*/
  kk_string_t _x20964 = kk_string_empty(); /*string*/
  _match_19764 = kk_string_is_eq(_x20963,_x20964,kk_context()); /*bool*/
  if (_match_19764) {
    kk_string_drop(sub, _ctx);
    return s;
  }
  {
    kk_std_core_types__maybe _match_19765;
    kk_string_t _x20966 = kk_string_dup(s, _ctx); /*string*/
    kk_string_t _x20967 = kk_string_dup(sub, _ctx); /*string*/
    _match_19765 = kk_std_core_starts_with(_x20966, _x20967, _ctx); /*maybe<sslice>*/
    if (kk_std_core_types__is_Just(_match_19765, _ctx)) {
      kk_box_t _box_x19465 = _match_19765._cons.Just.value;
      kk_std_core__sslice slice0 = kk_std_core__sslice_unbox(_box_x19465, KK_BORROWED, _ctx);
      kk_string_drop(s, _ctx);
      kk_std_core__sslice_dup(slice0, _ctx);
      kk_std_core_types__maybe_drop(_match_19765, _ctx);
      { // tailcall
        kk_string_t _x20968 = kk_std_core_string_3(slice0, _ctx); /*string*/
        s = _x20968;
        goto kk__tailcall;
      }
    }
    {
      kk_string_drop(sub, _ctx);
      return s;
    }
  }
}
 
// Trim off a substring `sub` while `s` ends with that string.

kk_string_t kk_std_core_trim_right_1(kk_string_t s, kk_string_t sub, kk_context_t* _ctx) { /* (s : string, sub : string) -> string */ 
  kk__tailcall: ;
  bool _match_19762;
  kk_string_t _x20969 = kk_string_dup(sub, _ctx); /*string*/
  kk_string_t _x20970 = kk_string_empty(); /*string*/
  _match_19762 = kk_string_is_eq(_x20969,_x20970,kk_context()); /*bool*/
  if (_match_19762) {
    kk_string_drop(sub, _ctx);
    return s;
  }
  {
    kk_std_core_types__maybe _match_19763;
    kk_string_t _x20972 = kk_string_dup(s, _ctx); /*string*/
    kk_string_t _x20973 = kk_string_dup(sub, _ctx); /*string*/
    _match_19763 = kk_std_core_ends_with(_x20972, _x20973, _ctx); /*maybe<sslice>*/
    if (kk_std_core_types__is_Just(_match_19763, _ctx)) {
      kk_box_t _box_x19466 = _match_19763._cons.Just.value;
      kk_std_core__sslice slice0 = kk_std_core__sslice_unbox(_box_x19466, KK_BORROWED, _ctx);
      kk_string_drop(s, _ctx);
      kk_std_core__sslice_dup(slice0, _ctx);
      kk_std_core_types__maybe_drop(_match_19763, _ctx);
      { // tailcall
        kk_string_t _x20974 = kk_std_core_string_3(slice0, _ctx); /*string*/
        s = _x20974;
        goto kk__tailcall;
      }
    }
    {
      kk_string_drop(sub, _ctx);
      return s;
    }
  }
}
 
// Parse an integer after trimming whitespace.
// If an illegal digit character is encountered `Nothing` is returned.
// An empty string will result in `Just(0)`.
// A string can start with a `-` sign for negative numbers,
// and with `0x` or `0X` for hexadecimal numbers (in which case the `hex` parameter is ignored).

kk_std_core_types__maybe kk_std_core_parse_int(kk_string_t s, kk_std_core_types__optional hex, kk_context_t* _ctx) { /* (s : string, hex : optional<bool>) -> maybe<int> */ 
  kk_string_t _x20976;
  kk_string_t _x20977 = kk_string_trim_left(s,kk_context()); /*string*/
  _x20976 = kk_string_trim_right(_x20977,kk_context()); /*string*/
  bool _x20978;
  if (kk_std_core_types__is_Optional(hex, _ctx)) {
    kk_box_t _box_x19467 = hex._cons.Optional.value;
    bool _hex_15862 = kk_bool_unbox(_box_x19467);
    kk_std_core_types__optional_drop(hex, _ctx);
    _x20978 = _hex_15862; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(hex, _ctx);
    _x20978 = false; /*bool*/
  }
  return kk_std_core_xparse_int(_x20976, _x20978, _ctx);
}
 
// Parse an integer using `parseInt`. If an illegal digit character is encountered the
// `default` value is returned. An empty string will also result in `default`.

kk_integer_t kk_std_core_parse_int_default(kk_string_t s, kk_std_core_types__optional default0, kk_std_core_types__optional hex, kk_context_t* _ctx) { /* (s : string, default : optional<int>, hex : optional<bool>) -> int */ 
  bool _match_19761;
  kk_string_t _x20979 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x20980 = kk_string_empty(); /*string*/
  _match_19761 = kk_string_is_eq(_x20979,_x20980,kk_context()); /*bool*/
  if (_match_19761) {
    kk_string_drop(s, _ctx);
    kk_std_core_types__optional_drop(hex, _ctx);
    if (kk_std_core_types__is_Optional(default0, _ctx)) {
      kk_box_t _box_x19468 = default0._cons.Optional.value;
      kk_integer_t _default_15874 = kk_integer_unbox(_box_x19468, _ctx);
      kk_integer_dup(_default_15874, _ctx);
      kk_std_core_types__optional_drop(default0, _ctx);
      return _default_15874;
    }
    {
      kk_std_core_types__optional_drop(default0, _ctx);
      return kk_integer_from_small(0);
    }
  }
  {
    kk_std_core_types__maybe m_17588;
    kk_string_t _x20982;
    kk_string_t _x20983 = kk_string_trim_left(s,kk_context()); /*string*/
    _x20982 = kk_string_trim_right(_x20983,kk_context()); /*string*/
    bool _x20984;
    if (kk_std_core_types__is_Optional(hex, _ctx)) {
      kk_box_t _box_x19469 = hex._cons.Optional.value;
      bool _hex_15878 = kk_bool_unbox(_box_x19469);
      kk_std_core_types__optional_drop(hex, _ctx);
      _x20984 = _hex_15878; /*bool*/
    }
    else {
      kk_std_core_types__optional_drop(hex, _ctx);
      _x20984 = false; /*bool*/
    }
    m_17588 = kk_std_core_xparse_int(_x20982, _x20984, _ctx); /*maybe<int>*/
    if (kk_std_core_types__is_Nothing(m_17588, _ctx)) {
      if (kk_std_core_types__is_Optional(default0, _ctx)) {
        kk_box_t _box_x19470 = default0._cons.Optional.value;
        kk_integer_t _default_158740 = kk_integer_unbox(_box_x19470, _ctx);
        kk_integer_dup(_default_158740, _ctx);
        kk_std_core_types__optional_drop(default0, _ctx);
        return _default_158740;
      }
      {
        kk_std_core_types__optional_drop(default0, _ctx);
        return kk_integer_from_small(0);
      }
    }
    {
      kk_box_t _box_x19471 = m_17588._cons.Just.value;
      kk_integer_t x = kk_integer_unbox(_box_x19471, _ctx);
      kk_integer_dup(x, _ctx);
      kk_std_core_types__maybe_drop(m_17588, _ctx);
      kk_std_core_types__optional_drop(default0, _ctx);
      return x;
    }
  }
}
 
// monadic lift

kk_std_core_types__tuple2_ kk_std_core__mlift18044_partition_acc(kk_std_core__list acc1, kk_std_core__list acc2, kk_function_t pred, kk_box_t x, kk_std_core__list xx, bool _y_17908, kk_context_t* _ctx) { /* forall<a,e> (acc1 : list<a>, acc2 : list<a>, pred : (a) -> e bool, x : a, xx : list<a>, bool) -> e (list<a>, list<a>) */ 
  if (_y_17908) {
    kk_std_core__list _x20985 = kk_std_core__new_Cons(kk_reuse_null, 0, x, acc1, _ctx); /*list<61>*/
    return kk_std_core_partition_acc(xx, pred, _x20985, acc2, _ctx);
  }
  {
    kk_std_core__list _x20986 = kk_std_core__new_Cons(kk_reuse_null, 0, x, acc2, _ctx); /*list<61>*/
    return kk_std_core_partition_acc(xx, pred, acc1, _x20986, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_partition_acc_fun20991__t {
  struct kk_function_s _base;
  kk_std_core__list acc10;
  kk_std_core__list acc20;
  kk_function_t pred0;
  kk_box_t x0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core_partition_acc_fun20991(kk_function_t _fself, kk_box_t _b_19475, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_partition_acc_fun20991(kk_std_core__list acc10, kk_std_core__list acc20, kk_function_t pred0, kk_box_t x0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core_partition_acc_fun20991__t* _self = kk_function_alloc_as(struct kk_std_core_partition_acc_fun20991__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_partition_acc_fun20991, kk_context());
  _self->acc10 = acc10;
  _self->acc20 = acc20;
  _self->pred0 = pred0;
  _self->x0 = x0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_partition_acc_fun20991(kk_function_t _fself, kk_box_t _b_19475, kk_context_t* _ctx) {
  struct kk_std_core_partition_acc_fun20991__t* _self = kk_function_as(struct kk_std_core_partition_acc_fun20991__t*, _fself, _ctx);
  kk_std_core__list acc10 = _self->acc10; /* list<15996> */
  kk_std_core__list acc20 = _self->acc20; /* list<15996> */
  kk_function_t pred0 = _self->pred0; /* (15996) -> 15997 bool */
  kk_box_t x0 = _self->x0; /* 15996 */
  kk_std_core__list xx0 = _self->xx0; /* list<15996> */
  kk_drop_match(_self, {kk_std_core__list_dup(acc10, _ctx);kk_std_core__list_dup(acc20, _ctx);kk_function_dup(pred0, _ctx);kk_box_dup(x0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  bool _y_19479_179080 = kk_bool_unbox(_b_19475); /*bool*/;
  kk_std_core_types__tuple2_ _x20992 = kk_std_core__mlift18044_partition_acc(acc10, acc20, pred0, x0, xx0, _y_19479_179080, _ctx); /*(list<15996>, list<15996>)*/
  return kk_std_core_types__tuple2__box(_x20992, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core_partition_acc(kk_std_core__list xs, kk_function_t pred0, kk_std_core__list acc10, kk_std_core__list acc20, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool, acc1 : list<a>, acc2 : list<a>) -> e (list<a>, list<a>) */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(pred0, _ctx);
    kk_std_core__list _b_19476_19472 = kk_std_core__lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc10, _ctx); /*list<15996>*/;
    kk_std_core__list _b_19477_19473 = kk_std_core__lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc20, _ctx); /*list<15996>*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_19476_19472, _ctx), kk_std_core__list_box(_b_19477_19473, _ctx), _ctx);
  }
  {
    struct kk_std_core_Cons* _con20987 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x0 = _con20987->head;
    kk_std_core__list xx0 = _con20987->tail;
    kk_reuse_t _ru_20072 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_20072 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x0, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x1_18286;
    kk_function_t _x20989 = kk_function_dup(pred0, _ctx); /*(15996) -> 15997 bool*/
    kk_box_t _x20988 = kk_box_dup(x0, _ctx); /*15996*/
    x1_18286 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x20989, (_x20989, _x20988, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_20072,kk_context());
      kk_box_t _x20990 = kk_std_core_hnd_yield_extend(kk_std_core_new_partition_acc_fun20991(acc10, acc20, pred0, x0, xx0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__tuple2__unbox(_x20990, KK_OWNED, _ctx);
    }
    if (x1_18286) { // tailcall
                    kk_std_core__list _x20993 = kk_std_core__new_Cons(_ru_20072, 0, x0, acc10, _ctx); /*list<61>*/
                    xs = xx0;
                    acc10 = _x20993;
                    goto kk__tailcall;
    }
    { // tailcall
      kk_std_core__list _x20994 = kk_std_core__new_Cons(_ru_20072, 0, x0, acc20, _ctx); /*list<61>*/
      xs = xx0;
      acc20 = _x20994;
      goto kk__tailcall;
    }
  }
}
 
// redirect `print` and `println` calls to a specified function.


// lift anonymous function
struct kk_std_core_print_redirect_fun20997__t {
  struct kk_function_s _base;
  kk_function_t print0;
};
static kk_box_t kk_std_core_print_redirect_fun20997(kk_function_t _fself, kk_box_t _b_19483, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_print_redirect_fun20997(kk_function_t print0, kk_context_t* _ctx) {
  struct kk_std_core_print_redirect_fun20997__t* _self = kk_function_alloc_as(struct kk_std_core_print_redirect_fun20997__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_print_redirect_fun20997, kk_context());
  _self->print0 = print0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_print_redirect_fun20997(kk_function_t _fself, kk_box_t _b_19483, kk_context_t* _ctx) {
  struct kk_std_core_print_redirect_fun20997__t* _self = kk_function_as(struct kk_std_core_print_redirect_fun20997__t*, _fself, _ctx);
  kk_function_t print0 = _self->print0; /* (msg : string) -> console () */
  kk_drop_match(_self, {kk_function_dup(print0, _ctx);}, {}, _ctx)
  kk_unit_t _x20998 = kk_Unit;
  kk_string_t _x20999 = kk_string_unbox(_b_19483); /*string*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_string_t, kk_context_t*), print0, (print0, _x20999, _ctx), _ctx);
  return kk_unit_box(_x20998);
}

kk_unit_t kk_std_core_print_redirect(kk_function_t print0, kk_context_t* _ctx) { /* (print : (msg : string) -> console ()) -> io () */ 
  kk_box_t _x20995;
  kk_std_core_types__maybe _x20996 = kk_std_core_types__new_Just(kk_function_box(kk_std_core_new_print_redirect_fun20997(print0, _ctx), _ctx), _ctx); /*maybe<111>*/
  _x20995 = kk_std_core_types__maybe_box(_x20996, _ctx); /*176*/
  kk_ref_set_borrow(kk_std_core_redirect,_x20995,kk_context()); return kk_Unit;
}
extern bool kk_std_core_remove_fun21000(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_remove_fun21000__t* _self = kk_function_as(struct kk_std_core_remove_fun21000__t*, _fself, _ctx);
  kk_function_t pred = _self->pred; /* (16065) -> bool */
  kk_drop_match(_self, {kk_function_dup(pred, _ctx);}, {}, _ctx)
  bool b_17599 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), pred, (pred, x, _ctx), _ctx); /*bool*/;
  if (b_17599) {
    return false;
  }
  {
    return true;
  }
}
 
// Create a list of `n`  repeated elementes `x`

kk_std_core__list kk_std_core__trmc_replicate(kk_box_t x, kk_integer_t n, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (x : a, n : int, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  bool _match_19759 = kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_19759) {
    kk_std_core__list _trmc_17713 = kk_datatype_null(); /*list<16103>*/;
    kk_std_core__list _trmc_17714;
    kk_box_t _x21001 = kk_box_dup(x, _ctx); /*16103*/
    _trmc_17714 = kk_std_core__new_Cons(kk_reuse_null, 0, _x21001, _trmc_17713, _ctx); /*list<16103>*/
    kk_box_t* _b_19499_19494 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17714, _ctx)->tail)); /*field-addr<list<16103>>*/;
    { // tailcall
      kk_integer_t _x21002 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
      kk_std_core_types__cctx _x21003 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17714, _ctx)),_b_19499_19494,true,kk_context()); /*ctx<0>*/
      n = _x21002;
      _acc = _x21003;
      goto kk__tailcall;
    }
  }
  {
    kk_box_drop(x, _ctx);
    kk_integer_drop(n, _ctx);
    kk_box_t _x21004 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21004, KK_OWNED, _ctx);
  }
}
 
// Create a list of `n`  repeated elementes `x`

kk_std_core__list kk_std_core_replicate(kk_box_t x0, kk_integer_t n0, kk_context_t* _ctx) { /* forall<a> (x : a, n : int) -> list<a> */ 
  kk_std_core_types__cctx _x21005 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_replicate(x0, n0, _x21005, _ctx);
}
 
// Concatenate all strings in a list in reverse order

kk_string_t kk_std_core_reverse_join(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  kk_std_core__list xs0_17603 = kk_std_core__lift17313_reverse_append(kk_std_core__new_Nil(_ctx), xs, _ctx); /*list<string>*/;
  if (kk_std_core__is_Nil(xs0_17603, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_Cons* _con21007 = kk_std_core__as_Cons(xs0_17603, _ctx);
    kk_box_t _box_x19505 = _con21007->head;
    kk_std_core__list xx = _con21007->tail;
    kk_string_t x = kk_string_unbox(_box_x19505);
    if kk_likely(kk_datatype_ptr_is_unique(xs0_17603, _ctx)) {
      kk_datatype_ptr_free(xs0_17603, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs0_17603, _ctx);
    }
    kk_string_t _x21008 = kk_string_empty(); /*string*/
    return kk_std_core__lift17316_joinsep(_x21008, xx, x, _ctx);
  }
}

kk_string_t kk_std_core_show_tuple(kk_std_core_types__tuple2_ x, kk_function_t showfst, kk_function_t showsnd, kk_context_t* _ctx) { /* forall<a,b> (x : (a, b), showfst : (a) -> string, showsnd : (b) -> string) -> string */ 
  kk_string_t _x21010;
  kk_define_string_literal(, _s21011, 1, "(", _ctx)
  _x21010 = kk_string_dup(_s21011, _ctx); /*string*/
  kk_string_t _x21012;
  kk_string_t _x21013;
  kk_box_t _x21014;
  {
    kk_box_t _x = x.fst;
    kk_box_dup(_x, _ctx);
    _x21014 = _x; /*16462*/
  }
  _x21013 = kk_function_call(kk_string_t, (kk_function_t, kk_box_t, kk_context_t*), showfst, (showfst, _x21014, _ctx), _ctx); /*string*/
  kk_string_t _x21015;
  kk_string_t _x21016;
  kk_define_string_literal(, _s21017, 1, ",", _ctx)
  _x21016 = kk_string_dup(_s21017, _ctx); /*string*/
  kk_string_t _x21018;
  kk_string_t _x21019;
  kk_box_t _x21020;
  {
    kk_box_t _x0 = x.snd;
    kk_box_dup(_x0, _ctx);
    kk_std_core_types__tuple2__drop(x, _ctx);
    _x21020 = _x0; /*16463*/
  }
  _x21019 = kk_function_call(kk_string_t, (kk_function_t, kk_box_t, kk_context_t*), showsnd, (showsnd, _x21020, _ctx), _ctx); /*string*/
  kk_string_t _x21021;
  kk_define_string_literal(, _s21022, 1, ")", _ctx)
  _x21021 = kk_string_dup(_s21022, _ctx); /*string*/
  _x21018 = kk_std_core__lp__plus__plus__1_rp_(_x21019, _x21021, _ctx); /*string*/
  _x21015 = kk_std_core__lp__plus__plus__1_rp_(_x21016, _x21018, _ctx); /*string*/
  _x21012 = kk_std_core__lp__plus__plus__1_rp_(_x21013, _x21015, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x21010, _x21012, _ctx);
}
 
// monadic lift

kk_std_core_types__tuple2_ kk_std_core__mlift18045_lift17324_span(kk_std_core__list acc, kk_function_t predicate, kk_box_t y, kk_std_core__list ys, kk_std_core__list yy, bool _y_17914, kk_context_t* _ctx) { /* forall<a,e> (acc : list<a>, predicate : (a) -> e bool, y : a, ys : list<a>, yy : list<a>, bool) -> e (list<a>, list<a>) */ 
  if (_y_17914) {
    kk_std_core__list_drop(ys, _ctx);
    kk_std_core__list _x21023 = kk_std_core__new_Cons(kk_reuse_null, 0, y, acc, _ctx); /*list<61>*/
    return kk_std_core__lift17324_span(predicate, yy, _x21023, _ctx);
  }
  {
    kk_std_core__list_drop(yy, _ctx);
    kk_box_drop(y, _ctx);
    kk_function_drop(predicate, _ctx);
    kk_std_core__list _b_19508_19506 = kk_std_core__lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc, _ctx); /*list<16562>*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_19508_19506, _ctx), kk_std_core__list_box(ys, _ctx), _ctx);
  }
}
 
// lifted local: span, span-acc
// todo: implement TRMC with multiple results to avoid the reverse


// lift anonymous function
struct kk_std_core__lift17324_span_fun21028__t {
  struct kk_function_s _base;
  kk_std_core__list acc0;
  kk_function_t predicate0;
  kk_box_t y0;
  kk_std_core__list ys0;
  kk_std_core__list yy0;
};
static kk_box_t kk_std_core__lift17324_span_fun21028(kk_function_t _fself, kk_box_t _b_19511, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift17324_span_fun21028(kk_std_core__list acc0, kk_function_t predicate0, kk_box_t y0, kk_std_core__list ys0, kk_std_core__list yy0, kk_context_t* _ctx) {
  struct kk_std_core__lift17324_span_fun21028__t* _self = kk_function_alloc_as(struct kk_std_core__lift17324_span_fun21028__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift17324_span_fun21028, kk_context());
  _self->acc0 = acc0;
  _self->predicate0 = predicate0;
  _self->y0 = y0;
  _self->ys0 = ys0;
  _self->yy0 = yy0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift17324_span_fun21028(kk_function_t _fself, kk_box_t _b_19511, kk_context_t* _ctx) {
  struct kk_std_core__lift17324_span_fun21028__t* _self = kk_function_as(struct kk_std_core__lift17324_span_fun21028__t*, _fself, _ctx);
  kk_std_core__list acc0 = _self->acc0; /* list<16562> */
  kk_function_t predicate0 = _self->predicate0; /* (16562) -> 16563 bool */
  kk_box_t y0 = _self->y0; /* 16562 */
  kk_std_core__list ys0 = _self->ys0; /* list<16562> */
  kk_std_core__list yy0 = _self->yy0; /* list<16562> */
  kk_drop_match(_self, {kk_std_core__list_dup(acc0, _ctx);kk_function_dup(predicate0, _ctx);kk_box_dup(y0, _ctx);kk_std_core__list_dup(ys0, _ctx);kk_std_core__list_dup(yy0, _ctx);}, {}, _ctx)
  bool _y_19521_179140 = kk_bool_unbox(_b_19511); /*bool*/;
  kk_std_core_types__tuple2_ _x21029 = kk_std_core__mlift18045_lift17324_span(acc0, predicate0, y0, ys0, yy0, _y_19521_179140, _ctx); /*(list<16562>, list<16562>)*/
  return kk_std_core_types__tuple2__box(_x21029, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core__lift17324_span(kk_function_t predicate0, kk_std_core__list ys0, kk_std_core__list acc0, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, ys : list<a>, acc : list<a>) -> e (list<a>, list<a>) */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys0, _ctx)) {
    struct kk_std_core_Cons* _con21024 = kk_std_core__as_Cons(ys0, _ctx);
    kk_box_t y0 = _con21024->head;
    kk_std_core__list yy0 = _con21024->tail;
    kk_box_dup(y0, _ctx);
    kk_std_core__list_dup(yy0, _ctx);
    bool x_18289;
    kk_function_t _x21026 = kk_function_dup(predicate0, _ctx); /*(16562) -> 16563 bool*/
    kk_box_t _x21025 = kk_box_dup(y0, _ctx); /*16562*/
    x_18289 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x21026, (_x21026, _x21025, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x21027 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift17324_span_fun21028(acc0, predicate0, y0, ys0, yy0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__tuple2__unbox(_x21027, KK_OWNED, _ctx);
    }
    if (x_18289) {
      kk_reuse_t _ru_20074 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys0, _ctx)) {
        kk_std_core__list_drop(yy0, _ctx);
        kk_box_drop(y0, _ctx);
        _ru_20074 = (kk_datatype_ptr_reuse(ys0, _ctx));
      }
      else {
        kk_datatype_ptr_decref(ys0, _ctx);
      }
      { // tailcall
        kk_std_core__list _x21030 = kk_std_core__new_Cons(_ru_20074, 0, y0, acc0, _ctx); /*list<61>*/
        ys0 = yy0;
        acc0 = _x21030;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core__list_drop(yy0, _ctx);
      kk_box_drop(y0, _ctx);
      kk_function_drop(predicate0, _ctx);
      kk_std_core__list _b_19517_19512 = kk_std_core__lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc0, _ctx); /*list<16562>*/;
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_19517_19512, _ctx), kk_std_core__list_box(ys0, _ctx), _ctx);
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    kk_std_core__list _b_19519_19514 = kk_std_core__lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc0, _ctx); /*list<16562>*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_19519_19514, _ctx), kk_std_core__list_box(ys0, _ctx), _ctx);
  }
}
 
// Return the sum of a list of integers


// lift anonymous function
struct kk_std_core_sum_fun21032__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_sum_fun21032(kk_function_t _fself, kk_box_t _b_19525, kk_box_t _b_19526, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_sum_fun21032(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_sum_fun21032, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_sum_fun21032(kk_function_t _fself, kk_box_t _b_19525, kk_box_t _b_19526, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x21033;
  kk_integer_t _x21034 = kk_integer_unbox(_b_19525, _ctx); /*int*/
  kk_integer_t _x21035 = kk_integer_unbox(_b_19526, _ctx); /*int*/
  _x21033 = kk_std_core__lp__plus__4_rp_(_x21034, _x21035, _ctx); /*int*/
  return kk_integer_box(_x21033, _ctx);
}

kk_integer_t kk_std_core_sum(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<int>) -> int */ 
  kk_box_t _x21031 = kk_std_core_foldl(xs, kk_integer_box(kk_integer_from_small(0), _ctx), kk_std_core_new_sum_fun21032(_ctx), _ctx); /*12696*/
  return kk_integer_unbox(_x21031, _ctx);
}
 
// Return the tail of list. Returns the empty list if `xs` is empty.

kk_std_core__list kk_std_core_tail_1(kk_std_core__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> list<a> */ 
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21036 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _pat0 = _con21036->head;
    kk_std_core__list xx = _con21036->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_pat0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return xx;
  }
  {
    return kk_std_core__new_Nil(_ctx);
  }
}
 
// Return the tail of a string (or the empty string)

kk_string_t kk_std_core_tail_2(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  kk_std_core__sslice slice1 = kk_std_core_first1(s, _ctx); /*sslice*/;
  kk_std_core__sslice slice0_17616;
  bool _match_19749;
  kk_integer_t _brw_19754;
  kk_std_core_types__optional _match_19753 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_19753, _ctx)) {
    kk_box_t _box_x19530 = _match_19753._cons.Optional.value;
    kk_integer_t _n_10357 = kk_integer_unbox(_box_x19530, _ctx);
    kk_integer_dup(_n_10357, _ctx);
    kk_std_core_types__optional_drop(_match_19753, _ctx);
    _brw_19754 = _n_10357; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_19753, _ctx);
    _brw_19754 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_19755 = kk_integer_eq_borrow(_brw_19754,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_19754, _ctx);
  _match_19749 = _brw_19755; /*bool*/
  if (_match_19749) {
    slice0_17616 = slice1; /*sslice*/
  }
  else {
    kk_integer_t _brw_19751;
    kk_integer_t _x21037;
    kk_std_core_types__optional _match_19750 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_19750, _ctx)) {
      kk_box_t _box_x19531 = _match_19750._cons.Optional.value;
      kk_integer_t _n_103570 = kk_integer_unbox(_box_x19531, _ctx);
      kk_integer_dup(_n_103570, _ctx);
      kk_std_core_types__optional_drop(_match_19750, _ctx);
      _x21037 = _n_103570; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(_match_19750, _ctx);
      _x21037 = kk_integer_from_small(1); /*int*/
    }
    _brw_19751 = kk_integer_add_small_const(_x21037, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_19752 = kk_std_core_extend(slice1, _brw_19751, _ctx); /*sslice*/;
    kk_integer_drop(_brw_19751, _ctx);
    slice0_17616 = _brw_19752; /*sslice*/
  }
  kk_std_core__sslice _x21038;
  {
    kk_string_t s0 = slice0_17616.str;
    kk_integer_t start0 = slice0_17616.start;
    kk_integer_t len0 = slice0_17616.len;
    kk_integer_t x0_17623;
    kk_string_t _x21039 = kk_string_dup(s0, _ctx); /*string*/
    x0_17623 = kk_string_len_int(_x21039,kk_context()); /*int*/
    kk_integer_t y0_17624;
    kk_integer_t _x21040 = kk_integer_dup(start0, _ctx); /*int*/
    kk_integer_t _x21041 = kk_integer_dup(len0, _ctx); /*int*/
    y0_17624 = kk_integer_add(_x21040,_x21041,kk_context()); /*int*/
    kk_integer_t _x21042 = kk_integer_add(start0,len0,kk_context()); /*int*/
    kk_integer_t _x21043 = kk_integer_sub(x0_17623,y0_17624,kk_context()); /*int*/
    _x21038 = kk_std_core__new_Sslice(s0, _x21042, _x21043, _ctx); /*sslice*/
  }
  return kk_std_core_string_3(_x21038, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18046_trmc_take_while(kk_std_core_types__cctx _acc, kk_function_t predicate, kk_box_t x, kk_std_core__list xx, bool _y_17919, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, predicate : (a) -> e bool, x : a, xx : list<a>, bool) -> e list<a> */ 
  if (_y_17919) {
    kk_std_core__list _trmc_17715 = kk_datatype_null(); /*list<16673>*/;
    kk_std_core__list _trmc_17716 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), x, _trmc_17715, _ctx); /*list<16673>*/;
    kk_box_t* _b_19542_19537 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17716, _ctx)->tail)); /*field-addr<list<16673>>*/;
    kk_std_core_types__cctx _x21044 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17716, _ctx)),_b_19542_19537,false,kk_context()); /*ctx<0>*/
    return kk_std_core__trmc_take_while(xx, predicate, _x21044, _ctx);
  }
  {
    kk_std_core__list_drop(xx, _ctx);
    kk_box_drop(x, _ctx);
    kk_function_drop(predicate, _ctx);
    kk_box_t _x21045 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21045, KK_OWNED, _ctx);
  }
}
 
// Keep only those initial elements that satisfy `predicate`


// lift anonymous function
struct kk_std_core__trmc_take_while_fun21050__t {
  struct kk_function_s _base;
  kk_function_t predicate0;
  kk_box_t x0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_take_while_fun21050(kk_function_t _fself, kk_box_t _b_19549, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_take_while_fun21050(kk_function_t predicate0, kk_box_t x0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_take_while_fun21050__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_take_while_fun21050__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_take_while_fun21050, kk_context());
  _self->predicate0 = predicate0;
  _self->x0 = x0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_take_while_fun21050(kk_function_t _fself, kk_box_t _b_19549, kk_context_t* _ctx) {
  struct kk_std_core__trmc_take_while_fun21050__t* _self = kk_function_as(struct kk_std_core__trmc_take_while_fun21050__t*, _fself, _ctx);
  kk_function_t predicate0 = _self->predicate0; /* (16673) -> 16674 bool */
  kk_box_t x0 = _self->x0; /* 16673 */
  kk_std_core__list xx0 = _self->xx0; /* list<16673> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<16673>> */
  kk_drop_match(_self, {kk_function_dup(predicate0, _ctx);kk_box_dup(x0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  bool _y_19571_179190 = kk_bool_unbox(_b_19549); /*bool*/;
  kk_std_core__list _x21051 = kk_std_core__mlift18046_trmc_take_while(_acc0, predicate0, x0, xx0, _y_19571_179190, _ctx); /*list<16673>*/
  return kk_std_core__list_box(_x21051, _ctx);
}

kk_std_core__list kk_std_core__trmc_take_while(kk_std_core__list xs, kk_function_t predicate0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21046 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x0 = _con21046->head;
    kk_std_core__list xx0 = _con21046->tail;
    kk_reuse_t _ru_20076 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_20076 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x0, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x1_18292;
    kk_function_t _x21048 = kk_function_dup(predicate0, _ctx); /*(16673) -> 16674 bool*/
    kk_box_t _x21047 = kk_box_dup(x0, _ctx); /*16673*/
    x1_18292 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x21048, (_x21048, _x21047, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_20076,kk_context());
      kk_box_t _x21049 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_take_while_fun21050(predicate0, x0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x21049, KK_OWNED, _ctx);
    }
    if (x1_18292) {
      kk_std_core__list _trmc_177150 = kk_datatype_null(); /*list<16673>*/;
      kk_std_core__list _trmc_177160 = kk_std_core__new_Cons(_ru_20076, kk_field_index_of(struct kk_std_core_Cons, tail), x0, _trmc_177150, _ctx); /*list<16673>*/;
      kk_box_t* _b_19563_19555 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_177160, _ctx)->tail)); /*field-addr<list<16673>>*/;
      { // tailcall
        kk_std_core_types__cctx _x21052 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_177160, _ctx)),_b_19563_19555,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x21052;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_20076,kk_context());
      kk_std_core__list_drop(xx0, _ctx);
      kk_box_drop(x0, _ctx);
      kk_function_drop(predicate0, _ctx);
      kk_box_t _x21053 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
      return kk_std_core__list_unbox(_x21053, KK_OWNED, _ctx);
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    kk_box_t _x21054 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21054, KK_OWNED, _ctx);
  }
}
 
// Keep only those initial elements that satisfy `predicate`

kk_std_core__list kk_std_core_take_while(kk_std_core__list xs0, kk_function_t predicate1, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e list<a> */ 
  kk_std_core_types__cctx _x21055 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_take_while(xs0, predicate1, _x21055, _ctx);
}
 
// Trace a message used for debug purposes.
// The behaviour is system dependent. On a browser and node it uses
// `console.log`  by default.
// Disabled if `notrace` is called.


// lift anonymous function
struct kk_std_core_trace_fun21059__t {
  struct kk_function_s _base;
  kk_string_t message0;
};
static kk_box_t kk_std_core_trace_fun21059(kk_function_t _fself, kk_box_t _b_19575, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_trace_fun21059(kk_string_t message0, kk_context_t* _ctx) {
  struct kk_std_core_trace_fun21059__t* _self = kk_function_alloc_as(struct kk_std_core_trace_fun21059__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_trace_fun21059, kk_context());
  _self->message0 = message0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_trace_fun21059(kk_function_t _fself, kk_box_t _b_19575, kk_context_t* _ctx) {
  struct kk_std_core_trace_fun21059__t* _self = kk_function_as(struct kk_std_core_trace_fun21059__t*, _fself, _ctx);
  kk_string_t message0 = _self->message0; /* string */
  kk_drop_match(_self, {kk_string_dup(message0, _ctx);}, {}, _ctx)
  kk_unit_t _x21060 = kk_Unit;
  bool _y_19577_17924 = kk_bool_unbox(_b_19575); /*bool*/;
  if (_y_19577_17924) {
    kk_std_core_xtrace(message0, _ctx);
  }
  else {
    kk_string_drop(message0, _ctx);
  }
  return kk_unit_box(_x21060);
}

kk_unit_t kk_std_core_trace(kk_string_t message0, kk_context_t* _ctx) { /* (message : string) -> () */ 
  bool x_18295;
  kk_box_t _x21056;
  kk_ref_t _x21057 = kk_ref_dup(kk_std_core_trace_enabled, _ctx); /*ref<global,bool>*/
  _x21056 = kk_ref_get(_x21057,kk_context()); /*190*/
  x_18295 = kk_bool_unbox(_x21056); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x21058 = kk_std_core_hnd_yield_extend(kk_std_core_new_trace_fun21059(message0, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x21058); return kk_Unit;
  }
  if (x_18295) {
    kk_std_core_xtrace(message0, _ctx); return kk_Unit;
  }
  {
    kk_string_drop(message0, _ctx);
    kk_Unit; return kk_Unit;
  }
}


// lift anonymous function
struct kk_std_core_trace_any_fun21064__t {
  struct kk_function_s _base;
  kk_string_t message0;
  kk_box_t x;
};
static kk_box_t kk_std_core_trace_any_fun21064(kk_function_t _fself, kk_box_t _b_19582, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_trace_any_fun21064(kk_string_t message0, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_trace_any_fun21064__t* _self = kk_function_alloc_as(struct kk_std_core_trace_any_fun21064__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_trace_any_fun21064, kk_context());
  _self->message0 = message0;
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_trace_any_fun21064(kk_function_t _fself, kk_box_t _b_19582, kk_context_t* _ctx) {
  struct kk_std_core_trace_any_fun21064__t* _self = kk_function_as(struct kk_std_core_trace_any_fun21064__t*, _fself, _ctx);
  kk_string_t message0 = _self->message0; /* string */
  kk_box_t x = _self->x; /* 16782 */
  kk_drop_match(_self, {kk_string_dup(message0, _ctx);kk_box_dup(x, _ctx);}, {}, _ctx)
  kk_unit_t _x21065 = kk_Unit;
  bool _y_19584_17926 = kk_bool_unbox(_b_19582); /*bool*/;
  if (_y_19584_17926) {
    kk_std_core_xtrace_any(message0, x, _ctx);
  }
  else {
    kk_box_drop(x, _ctx);
    kk_string_drop(message0, _ctx);
  }
  return kk_unit_box(_x21065);
}

kk_unit_t kk_std_core_trace_any(kk_string_t message0, kk_box_t x, kk_context_t* _ctx) { /* forall<a> (message : string, x : a) -> () */ 
  bool x0_18299;
  kk_box_t _x21061;
  kk_ref_t _x21062 = kk_ref_dup(kk_std_core_trace_enabled, _ctx); /*ref<global,bool>*/
  _x21061 = kk_ref_get(_x21062,kk_context()); /*190*/
  x0_18299 = kk_bool_unbox(_x21061); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x21063 = kk_std_core_hnd_yield_extend(kk_std_core_new_trace_any_fun21064(message0, x, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x21063); return kk_Unit;
  }
  if (x0_18299) {
    kk_std_core_xtrace_any(message0, x, _ctx); return kk_Unit;
  }
  {
    kk_box_drop(x, _ctx);
    kk_string_drop(message0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Truncate a string to `count` characters.

kk_string_t kk_std_core_truncate(kk_string_t s, kk_integer_t count, kk_context_t* _ctx) { /* (s : string, count : int) -> string */ 
  kk_std_core__sslice slice0 = kk_std_core_first1(s, _ctx); /*sslice*/;
  kk_std_core__sslice _x21066;
  kk_std_core__sslice _own_19737;
  bool _match_19738;
  kk_integer_t _brw_19743;
  kk_std_core_types__optional _match_19742 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_19742, _ctx)) {
    kk_box_t _box_x19586 = _match_19742._cons.Optional.value;
    kk_integer_t _n_10357 = kk_integer_unbox(_box_x19586, _ctx);
    kk_integer_dup(_n_10357, _ctx);
    kk_std_core_types__optional_drop(_match_19742, _ctx);
    _brw_19743 = _n_10357; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_19742, _ctx);
    _brw_19743 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_19744 = kk_integer_eq_borrow(_brw_19743,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_19743, _ctx);
  _match_19738 = _brw_19744; /*bool*/
  if (_match_19738) {
    _own_19737 = slice0; /*sslice*/
  }
  else {
    kk_integer_t _brw_19740;
    kk_integer_t _x21067;
    kk_std_core_types__optional _match_19739 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_19739, _ctx)) {
      kk_box_t _box_x19587 = _match_19739._cons.Optional.value;
      kk_integer_t _n_103570 = kk_integer_unbox(_box_x19587, _ctx);
      kk_integer_dup(_n_103570, _ctx);
      kk_std_core_types__optional_drop(_match_19739, _ctx);
      _x21067 = _n_103570; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(_match_19739, _ctx);
      _x21067 = kk_integer_from_small(1); /*int*/
    }
    _brw_19740 = kk_integer_add_small_const(_x21067, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_19741 = kk_std_core_extend(slice0, _brw_19740, _ctx); /*sslice*/;
    kk_integer_drop(_brw_19740, _ctx);
    _own_19737 = _brw_19741; /*sslice*/
  }
  kk_integer_t _brw_19736 = kk_integer_add_small_const(count, -1, _ctx); /*int*/;
  kk_std_core__sslice _brw_19745 = kk_std_core_extend(_own_19737, _brw_19736, _ctx); /*sslice*/;
  kk_integer_drop(_brw_19736, _ctx);
  _x21066 = _brw_19745; /*sslice*/
  return kk_std_core_string_3(_x21066, _ctx);
}
 
// Return a default value when an exception is raised


// lift anonymous function
struct kk_std_core_try_default_fun21068__t {
  struct kk_function_s _base;
  kk_box_t value;
};
static kk_box_t kk_std_core_try_default_fun21068(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_default_fun21068(kk_box_t value, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun21068__t* _self = kk_function_alloc_as(struct kk_std_core_try_default_fun21068__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_default_fun21068, kk_context());
  _self->value = value;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_try_default_fun21069__t {
  struct kk_function_s _base;
  kk_box_t value;
};
static kk_box_t kk_std_core_try_default_fun21069(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_default_fun21069(kk_box_t value, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun21069__t* _self = kk_function_alloc_as(struct kk_std_core_try_default_fun21069__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_default_fun21069, kk_context());
  _self->value = value;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_try_default_fun21069(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun21069__t* _self = kk_function_as(struct kk_std_core_try_default_fun21069__t*, _fself, _ctx);
  kk_box_t value = _self->value; /* 16858 */
  kk_drop_match(_self, {kk_box_dup(value, _ctx);}, {}, _ctx)
  kk_function_drop(___wildcard__525__45, _ctx);
  return value;
}
static kk_box_t kk_std_core_try_default_fun21068(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun21068__t* _self = kk_function_as(struct kk_std_core_try_default_fun21068__t*, _fself, _ctx);
  kk_box_t value = _self->value; /* 16858 */
  kk_drop_match(_self, {kk_box_dup(value, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__525__16, (KK_I32(3)), _ctx);
  kk_std_core__exception_drop(x, _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_new_try_default_fun21069(value, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_default_fun21072__t {
  struct kk_function_s _base;
  kk_function_t _b_19592_19588;
};
static kk_box_t kk_std_core_try_default_fun21072(kk_function_t _fself, kk_std_core_hnd__marker _b_19589, kk_std_core_hnd__ev _b_19590, kk_box_t _b_19591, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_default_fun21072(kk_function_t _b_19592_19588, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun21072__t* _self = kk_function_alloc_as(struct kk_std_core_try_default_fun21072__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_default_fun21072, kk_context());
  _self->_b_19592_19588 = _b_19592_19588;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_try_default_fun21072(kk_function_t _fself, kk_std_core_hnd__marker _b_19589, kk_std_core_hnd__ev _b_19590, kk_box_t _b_19591, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun21072__t* _self = kk_function_as(struct kk_std_core_try_default_fun21072__t*, _fself, _ctx);
  kk_function_t _b_19592_19588 = _self->_b_19592_19588; /* (m0 : std/core/hnd/marker<16859,16858>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 16859 10520 */
  kk_drop_match(_self, {kk_function_dup(_b_19592_19588, _ctx);}, {}, _ctx)
  kk_std_core__exception _x21073 = kk_std_core__exception_unbox(_b_19591, KK_OWNED, _ctx); /*exception*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_std_core__exception, kk_context_t*), _b_19592_19588, (_b_19592_19588, _b_19589, _b_19590, _x21073, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_default_fun21074__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_try_default_fun21074(kk_function_t _fself, kk_box_t _x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_default_fun21074(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_try_default_fun21074, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_try_default_fun21074(kk_function_t _fself, kk_box_t _x, kk_context_t* _ctx) {
  kk_unused(_fself);
  return _x;
}

kk_box_t kk_std_core_try_default(kk_box_t value, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (value : a, action : () -> <exn|e> a) -> e a */ 
  kk_function_t _b_19592_19588 = kk_std_core_new_try_default_fun21068(value, _ctx); /*(m0 : std/core/hnd/marker<16859,16858>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 16859 10520*/;
  kk_std_core__hnd_exn _x21070;
  kk_std_core_hnd__clause1 _x21071 = kk_std_core_hnd__new_Clause1(kk_std_core_new_try_default_fun21072(_b_19592_19588, _ctx), _ctx); /*std/core/hnd/clause1<51,52,53,54,55>*/
  _x21070 = kk_std_core__new_Hnd_exn(kk_reuse_null, 0, _x21071, _ctx); /*.hnd-exn<11,12>*/
  return kk_std_core__handle_exn((KK_I32(0)), _x21070, kk_std_core_new_try_default_fun21074(_ctx), action, _ctx);
}
 
// Returns a unique integer (modulo 32-bits).


// lift anonymous function
struct kk_std_core_unique_fun21078__t {
  struct kk_function_s _base;
};
static kk_integer_t kk_std_core_unique_fun21078(kk_function_t _fself, kk_integer_t u, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_unique_fun21078(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_unique_fun21078, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_integer_t kk_std_core_unique_fun21078(kk_function_t _fself, kk_integer_t u, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _b_19602_19600;
  kk_integer_t _x21079 = kk_integer_dup(u, _ctx); /*int*/
  _b_19602_19600 = kk_integer_add_small_const(_x21079, 1, _ctx); /*int*/
  kk_unit_t __ = kk_Unit;
  kk_ref_set_borrow(kk_std_core_unique_count,(kk_integer_box(_b_19602_19600, _ctx)),kk_context());
  return u;
}


// lift anonymous function
struct kk_std_core_unique_fun21081__t {
  struct kk_function_s _base;
  kk_function_t next0_18306;
};
static kk_box_t kk_std_core_unique_fun21081(kk_function_t _fself, kk_box_t _b_19604, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_unique_fun21081(kk_function_t next0_18306, kk_context_t* _ctx) {
  struct kk_std_core_unique_fun21081__t* _self = kk_function_alloc_as(struct kk_std_core_unique_fun21081__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_unique_fun21081, kk_context());
  _self->next0_18306 = next0_18306;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_unique_fun21081(kk_function_t _fself, kk_box_t _b_19604, kk_context_t* _ctx) {
  struct kk_std_core_unique_fun21081__t* _self = kk_function_as(struct kk_std_core_unique_fun21081__t*, _fself, _ctx);
  kk_function_t next0_18306 = _self->next0_18306; /* (int) -> <read<global>,write<global>|_16919> int */
  kk_drop_match(_self, {kk_function_dup(next0_18306, _ctx);}, {}, _ctx)
  kk_integer_t _x21082;
  kk_integer_t _x21083 = kk_integer_unbox(_b_19604, _ctx); /*int*/
  _x21082 = kk_function_call(kk_integer_t, (kk_function_t, kk_integer_t, kk_context_t*), next0_18306, (next0_18306, _x21083, _ctx), _ctx); /*int*/
  return kk_integer_box(_x21082, _ctx);
}

kk_integer_t kk_std_core_unique(kk_context_t* _ctx) { /* () -> ndet int */ 
  kk_integer_t x_18305;
  kk_box_t _x21076;
  kk_ref_t _x21077 = kk_ref_dup(kk_std_core_unique_count, _ctx); /*ref<global,int>*/
  _x21076 = kk_ref_get(_x21077,kk_context()); /*190*/
  x_18305 = kk_integer_unbox(_x21076, _ctx); /*int*/
  kk_function_t next0_18306 = kk_std_core_new_unique_fun21078(_ctx); /*(int) -> <read<global>,write<global>|_16919> int*/;
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_18305, _ctx);
    kk_box_t _x21080 = kk_std_core_hnd_yield_extend(kk_std_core_new_unique_fun21081(next0_18306, _ctx), _ctx); /*3926*/
    return kk_integer_unbox(_x21080, _ctx);
  }
  {
    return kk_function_call(kk_integer_t, (kk_function_t, kk_integer_t, kk_context_t*), next0_18306, (next0_18306, x_18305, _ctx), _ctx);
  }
}
 
// Get the value of the `Just` constructor or raise an exception

kk_box_t kk_std_core_unjust(kk_std_core_types__maybe m, kk_context_t* _ctx) { /* forall<a> (m : maybe<a>) -> exn a */ 
  if (kk_std_core_types__is_Just(m, _ctx)) {
    kk_box_t x = m._cons.Just.value;
    return x;
  }
  {
    kk_std_core_hnd__ev ev_18308;
    kk_ssize_t _x21084 = (KK_IZ(0)); /*ssize_t*/
    ev_18308 = kk_evv_at(_x21084,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    {
      struct kk_std_core_hnd_Ev* _con21085 = kk_std_core_hnd__as_Ev(ev_18308, _ctx);
      kk_box_t _box_x19606 = _con21085->hnd;
      kk_std_core_hnd__marker m0 = _con21085->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x19606, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      {
        struct kk_std_core__Hnd_exn* _con21086 = kk_std_core__as_Hnd_exn(h, _ctx);
        kk_std_core_hnd__clause1 ctl_throw_exn = _con21086->ctl_throw_exn;
        if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
          kk_datatype_ptr_free(h, _ctx);
        }
        else {
          kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
          kk_datatype_ptr_decref(h, _ctx);
        }
        {
          kk_function_t _fun_unbox_x19610 = ctl_throw_exn.clause;
          kk_box_t _x21087;
          kk_std_core__exception _x21088;
          kk_string_t _x21089;
          kk_define_string_literal(, _s21090, 37, "unexpected Nothing in std/core/unjust", _ctx)
          _x21089 = kk_string_dup(_s21090, _ctx); /*string*/
          kk_std_core__exception_info _x21091;
          kk_std_core_types__optional _match_19734 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
          if (kk_std_core_types__is_Optional(_match_19734, _ctx)) {
            kk_box_t _box_x19614 = _match_19734._cons.Optional.value;
            kk_std_core__exception_info _info_11917 = kk_std_core__exception_info_unbox(_box_x19614, KK_BORROWED, _ctx);
            kk_std_core__exception_info_dup(_info_11917, _ctx);
            kk_std_core_types__optional_drop(_match_19734, _ctx);
            _x21091 = _info_11917; /*exception-info*/
          }
          else {
            kk_std_core_types__optional_drop(_match_19734, _ctx);
            _x21091 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
          }
          _x21088 = kk_std_core__new_Exception(_x21089, _x21091, _ctx); /*exception*/
          _x21087 = kk_std_core__exception_box(_x21088, _ctx); /*51*/
          return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x19610, (_fun_unbox_x19610, m0, ev_18308, _x21087, _ctx), _ctx);
        }
      }
    }
  }
}
 
// Join a list of strings with newlines

kk_string_t kk_std_core_unlines(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_Cons* _con21093 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x19615 = _con21093->head;
    kk_std_core__list xx = _con21093->tail;
    kk_string_t x = kk_string_unbox(_box_x19615);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_string_t _x21094;
    kk_define_string_literal(, _s21095, 1, "\n", _ctx)
    _x21094 = kk_string_dup(_s21095, _ctx); /*string*/
    return kk_std_core__lift17316_joinsep(_x21094, xx, x, _ctx);
  }
}
 
// lifted local: unzip, iter
// todo: implement TRMC for multiple results

kk_std_core_types__tuple2_ kk_std_core__lift17325_unzip(kk_std_core__list ys, kk_std_core__list acc1, kk_std_core__list acc2, kk_context_t* _ctx) { /* forall<a,b> (ys : list<(a, b)>, acc1 : list<a>, acc2 : list<b>) -> (list<a>, list<b>) */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con21096 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t _box_x19616 = _con21096->head;
    kk_std_core_types__tuple2_ _pat0 = kk_std_core_types__tuple2__unbox(_box_x19616, KK_BORROWED, _ctx);
    kk_std_core__list xx = _con21096->tail;
    kk_box_t x = _pat0.fst;
    kk_box_t y = _pat0.snd;
    kk_reuse_t _ru_20079 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_box_dup(x, _ctx);
      kk_box_dup(y, _ctx);
      kk_box_drop(_box_x19616, _ctx);
      _ru_20079 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_box_dup(y, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    { // tailcall
      kk_std_core__list _x21097 = kk_std_core__new_Cons(_ru_20079, 0, x, acc1, _ctx); /*list<61>*/
      kk_std_core__list _x21098 = kk_std_core__new_Cons(kk_reuse_null, 0, y, acc2, _ctx); /*list<61>*/
      ys = xx;
      acc1 = _x21097;
      acc2 = _x21098;
      goto kk__tailcall;
    }
  }
  {
    kk_std_core__list _b_19619_19617 = kk_std_core__lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc1, _ctx); /*list<16974>*/;
    kk_std_core__list _b_19620_19618 = kk_std_core__lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc2, _ctx); /*list<16975>*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_19619_19617, _ctx), kk_std_core__list_box(_b_19620_19618, _ctx), _ctx);
  }
}
 
// Convert a string to a vector of characters.

kk_vector_t kk_std_core_vector_1(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> vector<char> */ 
  return kk_string_to_chars(s,kk_context());
}
extern kk_box_t kk_std_core_vector_fun21101_2(kk_function_t _fself, kk_ssize_t ___wildcard__1859__30, kk_context_t* _ctx) {
  struct kk_std_core_vector_fun21101__t_2* _self = kk_function_as(struct kk_std_core_vector_fun21101__t_2*, _fself, _ctx);
  kk_box_t default0 = _self->default0; /* 17051 */
  kk_drop_match(_self, {kk_box_dup(default0, _ctx);}, {}, _ctx)
  return default0;
}
extern kk_box_t kk_std_core_vector_init_fun21104(kk_function_t _fself, kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_vector_init_fun21104__t* _self = kk_function_as(struct kk_std_core_vector_init_fun21104__t*, _fself, _ctx);
  kk_function_t f = _self->f; /* (int) -> 17121 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);}, {}, _ctx)
  kk_integer_t _x21105 = kk_integer_from_ssize_t(i,kk_context()); /*int*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_context_t*), f, (f, _x21105, _ctx), _ctx);
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18050_while(kk_function_t action, kk_function_t predicate, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<e> (action : () -> <div|e> (), predicate : () -> <div|e> bool, wild_ : ()) -> <div|e> () */ 
  kk_std_core_while(predicate, action, _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18051_while_fun21108__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_function_t predicate0;
};
static kk_box_t kk_std_core__mlift18051_while_fun21108(kk_function_t _fself, kk_box_t _b_19622, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18051_while_fun21108(kk_function_t action0, kk_function_t predicate0, kk_context_t* _ctx) {
  struct kk_std_core__mlift18051_while_fun21108__t* _self = kk_function_alloc_as(struct kk_std_core__mlift18051_while_fun21108__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18051_while_fun21108, kk_context());
  _self->action0 = action0;
  _self->predicate0 = predicate0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18051_while_fun21108(kk_function_t _fself, kk_box_t _b_19622, kk_context_t* _ctx) {
  struct kk_std_core__mlift18051_while_fun21108__t* _self = kk_function_as(struct kk_std_core__mlift18051_while_fun21108__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* () -> <div|17142> () */
  kk_function_t predicate0 = _self->predicate0; /* () -> <div|17142> bool */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_function_dup(predicate0, _ctx);}, {}, _ctx)
  kk_unit_t wild__0_19624 = kk_Unit;
  kk_unit_unbox(_b_19622);
  kk_unit_t _x21109 = kk_Unit;
  kk_std_core__mlift18050_while(action0, predicate0, wild__0_19624, _ctx);
  return kk_unit_box(_x21109);
}

kk_unit_t kk_std_core__mlift18051_while(kk_function_t action0, kk_function_t predicate0, bool _y_17932, kk_context_t* _ctx) { /* forall<e> (action : () -> <div|e> (), predicate : () -> <div|e> bool, bool) -> <div|e> () */ 
  if (_y_17932) {
    kk_unit_t x_18311 = kk_Unit;
    kk_function_t _x21106 = kk_function_dup(action0, _ctx); /*() -> <div|17142> ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), _x21106, (_x21106, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21107 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18051_while_fun21108(action0, predicate0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21107); return kk_Unit;
    }
    {
      kk_std_core__mlift18050_while(action0, predicate0, x_18311, _ctx); return kk_Unit;
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// The `while` fun executes `action`  as long as `pred`  is `true`.


// lift anonymous function
struct kk_std_core_while_fun21112__t {
  struct kk_function_s _base;
  kk_function_t action1;
  kk_function_t predicate1;
};
static kk_box_t kk_std_core_while_fun21112(kk_function_t _fself, kk_box_t _b_19626, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_while_fun21112(kk_function_t action1, kk_function_t predicate1, kk_context_t* _ctx) {
  struct kk_std_core_while_fun21112__t* _self = kk_function_alloc_as(struct kk_std_core_while_fun21112__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_while_fun21112, kk_context());
  _self->action1 = action1;
  _self->predicate1 = predicate1;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_while_fun21112(kk_function_t _fself, kk_box_t _b_19626, kk_context_t* _ctx) {
  struct kk_std_core_while_fun21112__t* _self = kk_function_as(struct kk_std_core_while_fun21112__t*, _fself, _ctx);
  kk_function_t action1 = _self->action1; /* () -> <div|17142> () */
  kk_function_t predicate1 = _self->predicate1; /* () -> <div|17142> bool */
  kk_drop_match(_self, {kk_function_dup(action1, _ctx);kk_function_dup(predicate1, _ctx);}, {}, _ctx)
  bool _y_19631_179320 = kk_bool_unbox(_b_19626); /*bool*/;
  kk_unit_t _x21113 = kk_Unit;
  kk_std_core__mlift18051_while(action1, predicate1, _y_19631_179320, _ctx);
  return kk_unit_box(_x21113);
}


// lift anonymous function
struct kk_std_core_while_fun21116__t {
  struct kk_function_s _base;
  kk_function_t action1;
  kk_function_t predicate1;
};
static kk_box_t kk_std_core_while_fun21116(kk_function_t _fself, kk_box_t _b_19628, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_while_fun21116(kk_function_t action1, kk_function_t predicate1, kk_context_t* _ctx) {
  struct kk_std_core_while_fun21116__t* _self = kk_function_alloc_as(struct kk_std_core_while_fun21116__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_while_fun21116, kk_context());
  _self->action1 = action1;
  _self->predicate1 = predicate1;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_while_fun21116(kk_function_t _fself, kk_box_t _b_19628, kk_context_t* _ctx) {
  struct kk_std_core_while_fun21116__t* _self = kk_function_as(struct kk_std_core_while_fun21116__t*, _fself, _ctx);
  kk_function_t action1 = _self->action1; /* () -> <div|17142> () */
  kk_function_t predicate1 = _self->predicate1; /* () -> <div|17142> bool */
  kk_drop_match(_self, {kk_function_dup(action1, _ctx);kk_function_dup(predicate1, _ctx);}, {}, _ctx)
  kk_unit_t wild__1_19632 = kk_Unit;
  kk_unit_unbox(_b_19628);
  kk_unit_t _x21117 = kk_Unit;
  kk_std_core__mlift18050_while(action1, predicate1, wild__1_19632, _ctx);
  return kk_unit_box(_x21117);
}

kk_unit_t kk_std_core_while(kk_function_t predicate1, kk_function_t action1, kk_context_t* _ctx) { /* forall<e> (predicate : () -> <div|e> bool, action : () -> <div|e> ()) -> <div|e> () */ 
  kk__tailcall: ;
  bool x0_18313;
  kk_function_t _x21110 = kk_function_dup(predicate1, _ctx); /*() -> <div|17142> bool*/
  x0_18313 = kk_function_call(bool, (kk_function_t, kk_context_t*), _x21110, (_x21110, _ctx), _ctx); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x21111 = kk_std_core_hnd_yield_extend(kk_std_core_new_while_fun21112(action1, predicate1, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x21111); return kk_Unit;
  }
  if (x0_18313) {
    kk_unit_t x1_18316 = kk_Unit;
    kk_function_t _x21114 = kk_function_dup(action1, _ctx); /*() -> <div|17142> ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), _x21114, (_x21114, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21115 = kk_std_core_hnd_yield_extend(kk_std_core_new_while_fun21116(action1, predicate1, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21115); return kk_Unit;
    }
    { // tailcall
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(predicate1, _ctx);
    kk_function_drop(action1, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Zip two lists together by pairing the corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core__list kk_std_core__trmc_zip(kk_std_core__list xs, kk_std_core__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a,b> (xs : list<a>, ys : list<b>, ctx<list<(a, b)>>) -> list<(a, b)> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21118 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21118->head;
    kk_std_core__list xx = _con21118->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Cons(ys, _ctx)) {
      struct kk_std_core_Cons* _con21119 = kk_std_core__as_Cons(ys, _ctx);
      kk_box_t y = _con21119->head;
      kk_std_core__list yy = _con21119->tail;
      kk_reuse_t _ru_20081 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_20081 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core__list_dup(yy, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_std_core__list _trmc_17717 = kk_datatype_null(); /*list<(17185, 17186)>*/;
      kk_std_core__list _trmc_17718;
      kk_box_t _x21120;
      kk_std_core_types__tuple2_ _x21121 = kk_std_core_types__new_dash__lp__comma__rp_(x, y, _ctx); /*(6, 7)*/
      _x21120 = kk_std_core_types__tuple2__box(_x21121, _ctx); /*61*/
      _trmc_17718 = kk_std_core__new_Cons(_ru_20081, 0, _x21120, _trmc_17717, _ctx); /*list<(17185, 17186)>*/
      kk_box_t* _b_19649_19642 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17718, _ctx)->tail)); /*field-addr<list<(17185, 17186)>>*/;
      { // tailcall
        kk_std_core_types__cctx _x21122 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17718, _ctx)),_b_19649_19642,true,kk_context()); /*ctx<0>*/
        xs = xx;
        ys = yy;
        _acc = _x21122;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core__list_drop(xx, _ctx);
      kk_box_drop(x, _ctx);
      kk_box_t _x21123 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
      return kk_std_core__list_unbox(_x21123, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core__list_drop(ys, _ctx);
    kk_box_t _x21124 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21124, KK_OWNED, _ctx);
  }
}
 
// Zip two lists together by pairing the corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core__list kk_std_core_zip(kk_std_core__list xs0, kk_std_core__list ys0, kk_context_t* _ctx) { /* forall<a,b> (xs : list<a>, ys : list<b>) -> list<(a, b)> */ 
  kk_std_core_types__cctx _x21125 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_zip(xs0, ys0, _x21125, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18052_trmc_zipwith(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core__list xx, kk_std_core__list yy, kk_box_t _trmc_17719, kk_context_t* _ctx) { /* forall<a,b,c,e> (ctx<list<c>>, f : (a, b) -> e c, xx : list<a>, yy : list<b>, c) -> e list<c> */ 
  kk_std_core__list _trmc_17720 = kk_datatype_null(); /*list<17233>*/;
  kk_std_core__list _trmc_17721 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_17719, _trmc_17720, _ctx); /*list<17233>*/;
  kk_box_t* _b_19665_19662 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17721, _ctx)->tail)); /*field-addr<list<17233>>*/;
  kk_std_core_types__cctx _x21126 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17721, _ctx)),_b_19665_19662,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_zipwith(xx, yy, f, _x21126, _ctx);
}
 
// Zip two lists together by apply a function `f` to all corresponding elements.
// The returned list is only as long as the smallest input list.


// lift anonymous function
struct kk_std_core__trmc_zipwith_fun21131__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list xx0;
  kk_std_core__list yy0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_zipwith_fun21131(kk_function_t _fself, kk_box_t _b_19670, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_zipwith_fun21131(kk_function_t f0, kk_std_core__list xx0, kk_std_core__list yy0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_zipwith_fun21131__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_zipwith_fun21131__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_zipwith_fun21131, kk_context());
  _self->f0 = f0;
  _self->xx0 = xx0;
  _self->yy0 = yy0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_zipwith_fun21131(kk_function_t _fself, kk_box_t _b_19670, kk_context_t* _ctx) {
  struct kk_std_core__trmc_zipwith_fun21131__t* _self = kk_function_as(struct kk_std_core__trmc_zipwith_fun21131__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (17231, 17232) -> 17234 17233 */
  kk_std_core__list xx0 = _self->xx0; /* list<17231> */
  kk_std_core__list yy0 = _self->yy0; /* list<17232> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<17233>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core__list_dup(yy0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_19692_177190 = _b_19670; /*17233*/;
  kk_std_core__list _x21132 = kk_std_core__mlift18052_trmc_zipwith(_acc0, f0, xx0, yy0, _trmc_19692_177190, _ctx); /*list<17233>*/
  return kk_std_core__list_box(_x21132, _ctx);
}

kk_std_core__list kk_std_core__trmc_zipwith(kk_std_core__list xs, kk_std_core__list ys, kk_function_t f0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,c,e> (xs : list<a>, ys : list<b>, f : (a, b) -> e c, ctx<list<c>>) -> e list<c> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21127 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21127->head;
    kk_std_core__list xx0 = _con21127->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Cons(ys, _ctx)) {
      struct kk_std_core_Cons* _con21128 = kk_std_core__as_Cons(ys, _ctx);
      kk_box_t y = _con21128->head;
      kk_std_core__list yy0 = _con21128->tail;
      kk_reuse_t _ru_20083 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_20083 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core__list_dup(yy0, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_box_t x0_18319;
      kk_function_t _x21129 = kk_function_dup(f0, _ctx); /*(17231, 17232) -> 17234 17233*/
      x0_18319 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x21129, (_x21129, x, y, _ctx), _ctx); /*17233*/
      if (kk_yielding(kk_context())) {
        kk_reuse_drop(_ru_20083,kk_context());
        kk_box_drop(x0_18319, _ctx);
        kk_box_t _x21130 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_zipwith_fun21131(f0, xx0, yy0, _acc0, _ctx), _ctx); /*3926*/
        return kk_std_core__list_unbox(_x21130, KK_OWNED, _ctx);
      }
      {
        kk_std_core__list _trmc_177200 = kk_datatype_null(); /*list<17233>*/;
        kk_std_core__list _trmc_177210 = kk_std_core__new_Cons(_ru_20083, kk_field_index_of(struct kk_std_core_Cons, tail), x0_18319, _trmc_177200, _ctx); /*list<17233>*/;
        kk_box_t* _b_19684_19676 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_177210, _ctx)->tail)); /*field-addr<list<17233>>*/;
        { // tailcall
          kk_std_core_types__cctx _x21133 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_177210, _ctx)),_b_19684_19676,false,kk_context()); /*ctx<0>*/
          xs = xx0;
          ys = yy0;
          _acc0 = _x21133;
          goto kk__tailcall;
        }
      }
    }
    {
      kk_std_core__list_drop(xx0, _ctx);
      kk_box_drop(x, _ctx);
      kk_function_drop(f0, _ctx);
      kk_box_t _x21134 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
      return kk_std_core__list_unbox(_x21134, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core__list_drop(ys, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x21135 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21135, KK_OWNED, _ctx);
  }
}
 
// Zip two lists together by apply a function `f` to all corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core__list kk_std_core_zipwith(kk_std_core__list xs0, kk_std_core__list ys0, kk_function_t f1, kk_context_t* _ctx) { /* forall<a,b,c,e> (xs : list<a>, ys : list<b>, f : (a, b) -> e c) -> e list<c> */ 
  kk_std_core_types__cctx _x21136 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_zipwith(xs0, ys0, f1, _x21136, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18053_trmc_lift17326_zipwith_indexed(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i0_17651, kk_std_core__list xx, kk_std_core__list yy, kk_box_t _trmc_17722, kk_context_t* _ctx) { /* forall<a,b,c,e> (ctx<list<c>>, f : (int, a, b) -> e c, i0.17651 : int, xx : list<a>, yy : list<b>, c) -> e list<c> */ 
  kk_std_core__list _trmc_17723 = kk_datatype_null(); /*list<17307>*/;
  kk_std_core__list _trmc_17724 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_17722, _trmc_17723, _ctx); /*list<17307>*/;
  kk_box_t* _b_19701_19698 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_17724, _ctx)->tail)); /*field-addr<list<17307>>*/;
  kk_std_core_types__cctx _x21137 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_17724, _ctx)),_b_19701_19698,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17326_zipwith_indexed(f, i0_17651, xx, yy, _x21137, _ctx);
}
 
// lifted local: zipwith-indexed, zipwith-iter


// lift anonymous function
struct kk_std_core__trmc_lift17326_zipwith_indexed_fun21143__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_integer_t i0_176510;
  kk_std_core__list xx0;
  kk_std_core__list yy0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_lift17326_zipwith_indexed_fun21143(kk_function_t _fself, kk_box_t _b_19706, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_lift17326_zipwith_indexed_fun21143(kk_function_t f0, kk_integer_t i0_176510, kk_std_core__list xx0, kk_std_core__list yy0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17326_zipwith_indexed_fun21143__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_lift17326_zipwith_indexed_fun21143__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_lift17326_zipwith_indexed_fun21143, kk_context());
  _self->f0 = f0;
  _self->i0_176510 = i0_176510;
  _self->xx0 = xx0;
  _self->yy0 = yy0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_lift17326_zipwith_indexed_fun21143(kk_function_t _fself, kk_box_t _b_19706, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17326_zipwith_indexed_fun21143__t* _self = kk_function_as(struct kk_std_core__trmc_lift17326_zipwith_indexed_fun21143__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int, 17305, 17306) -> 17308 17307 */
  kk_integer_t i0_176510 = _self->i0_176510; /* int */
  kk_std_core__list xx0 = _self->xx0; /* list<17305> */
  kk_std_core__list yy0 = _self->yy0; /* list<17306> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<17307>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_integer_dup(i0_176510, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core__list_dup(yy0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_19728_177220 = _b_19706; /*17307*/;
  kk_std_core__list _x21144 = kk_std_core__mlift18053_trmc_lift17326_zipwith_indexed(_acc0, f0, i0_176510, xx0, yy0, _trmc_19728_177220, _ctx); /*list<17307>*/
  return kk_std_core__list_box(_x21144, _ctx);
}

kk_std_core__list kk_std_core__trmc_lift17326_zipwith_indexed(kk_function_t f0, kk_integer_t i, kk_std_core__list xs, kk_std_core__list ys, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,c,e> (f : (int, a, b) -> e c, i : int, xs : list<a>, ys : list<b>, ctx<list<c>>) -> e list<c> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21138 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21138->head;
    kk_std_core__list xx0 = _con21138->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Cons(ys, _ctx)) {
      struct kk_std_core_Cons* _con21139 = kk_std_core__as_Cons(ys, _ctx);
      kk_box_t y = _con21139->head;
      kk_std_core__list yy0 = _con21139->tail;
      kk_reuse_t _ru_20085 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_20085 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core__list_dup(yy0, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_integer_t i0_176510;
      kk_integer_t _x21140 = kk_integer_dup(i, _ctx); /*int*/
      i0_176510 = kk_integer_add_small_const(_x21140, 1, _ctx); /*int*/
      kk_box_t x0_18322;
      kk_function_t _x21141 = kk_function_dup(f0, _ctx); /*(int, 17305, 17306) -> 17308 17307*/
      x0_18322 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_box_t, kk_context_t*), _x21141, (_x21141, i, x, y, _ctx), _ctx); /*17307*/
      if (kk_yielding(kk_context())) {
        kk_reuse_drop(_ru_20085,kk_context());
        kk_box_drop(x0_18322, _ctx);
        kk_box_t _x21142 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_lift17326_zipwith_indexed_fun21143(f0, i0_176510, xx0, yy0, _acc0, _ctx), _ctx); /*3926*/
        return kk_std_core__list_unbox(_x21142, KK_OWNED, _ctx);
      }
      {
        kk_std_core__list _trmc_177230 = kk_datatype_null(); /*list<17307>*/;
        kk_std_core__list _trmc_177240 = kk_std_core__new_Cons(_ru_20085, kk_field_index_of(struct kk_std_core_Cons, tail), x0_18322, _trmc_177230, _ctx); /*list<17307>*/;
        kk_box_t* _b_19720_19712 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_177240, _ctx)->tail)); /*field-addr<list<17307>>*/;
        { // tailcall
          kk_std_core_types__cctx _x21145 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_177240, _ctx)),_b_19720_19712,false,kk_context()); /*ctx<0>*/
          i = i0_176510;
          xs = xx0;
          ys = yy0;
          _acc0 = _x21145;
          goto kk__tailcall;
        }
      }
    }
    {
      kk_std_core__list_drop(xx0, _ctx);
      kk_box_drop(x, _ctx);
      kk_integer_drop(i, _ctx);
      kk_function_drop(f0, _ctx);
      kk_box_t _x21146 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
      return kk_std_core__list_unbox(_x21146, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core__list_drop(ys, _ctx);
    kk_integer_drop(i, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x21147 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21147, KK_OWNED, _ctx);
  }
}
 
// lifted local: zipwith-indexed, zipwith-iter

kk_std_core__list kk_std_core__lift17326_zipwith_indexed(kk_function_t f1, kk_integer_t i0, kk_std_core__list xs0, kk_std_core__list ys0, kk_context_t* _ctx) { /* forall<a,b,c,e> (f : (int, a, b) -> e c, i : int, xs : list<a>, ys : list<b>) -> e list<c> */ 
  kk_std_core_types__cctx _x21148 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17326_zipwith_indexed(f1, i0, xs0, ys0, _x21148, _ctx);
}

// initialization
void kk_std_core__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  kk_init_string_literal(kk_std_core__tag_ExnError, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnAssert, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnTodo, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnRange, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnPattern, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnSystem, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnInternal, _ctx)
  {
    kk_string_t _x20107;
    kk_define_string_literal(, _s20108, 8, "exn.core", _ctx)
    _x20107 = kk_string_dup(_s20108, _ctx); /*string*/
    kk_std_core__tag_exn = kk_std_core_hnd__new_Htag(_x20107, _ctx); /*std/core/hnd/htag<.hnd-exn>*/
  }
  {
    kk_std_core_redirect = kk_ref_alloc((kk_std_core_types__maybe_box(kk_std_core_types__new_Nothing(_ctx), _ctx)),kk_context()); /*ref<global,maybe<(string) -> console ()>>*/
  }
  {
    kk_string_t _x20118 = kk_string_empty(); /*string*/
    kk_std_core_empty = kk_std_core__new_Sslice(_x20118, kk_integer_from_small(0), kk_integer_from_small(0), _ctx); /*sslice*/
  }
  {
    kk_string_t _x20156 = kk_string_empty(); /*string*/
    kk_std_core_invalid = kk_std_core__new_Sslice(_x20156, kk_integer_from_small(-1), kk_integer_from_small(0), _ctx); /*sslice*/
  }
  {
    kk_std_core_trace_enabled = kk_ref_alloc((kk_bool_box(true)),kk_context()); /*ref<global,bool>*/
  }
  {
    kk_std_core_unique_count = kk_ref_alloc((kk_integer_box(kk_integer_from_small(0), _ctx)),kk_context()); /*ref<global,int>*/
  }
}

// termination
void kk_std_core__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_ref_drop(kk_std_core_unique_count, _ctx);
  kk_ref_drop(kk_std_core_trace_enabled, _ctx);
  kk_std_core__sslice_drop(kk_std_core_invalid, _ctx);
  kk_std_core__sslice_drop(kk_std_core_empty, _ctx);
  kk_ref_drop(kk_std_core_redirect, _ctx);
  kk_std_core_hnd__htag_drop(kk_std_core__tag_exn, _ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
