// Koka generated module: "std/core/hnd", koka version: 2.4.2, platform: 64-bit
#include "std_core_hnd.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/
/*
typedef datatype_t kk_std_core_hnd__ev;
struct kk_std_core_hnd_Ev {
  kk_std_core_hnd__htag htag;
  kk_box_t hnd;
  int32_t cfc;  // control flow context
  kk_std_core_hnd__evv hevv;
  kk_std_core_hnd__marker marker;
};
*/

static kk_evv_vector_t kk_evv_vector_alloc(kk_ssize_t length, int32_t cfc, kk_context_t* ctx) {
  kk_assert_internal(length>=0);
  kk_evv_vector_t v = (kk_evv_vector_t)kk_block_alloc(kk_ssizeof(struct kk_evv_vector_s) + (length-1)*kk_ssizeof(void*), length + 1 /* cfc */, KK_TAG_EVV_VECTOR, ctx);
  v->cfc = kk_integer_from_int32(cfc,ctx);
  return v;
}

static kk_std_core_hnd__ev* kk_evv_vector_buf(kk_evv_vector_t vec, kk_ssize_t* len) {
  if (len != NULL) { *len = kk_block_scan_fsize(&vec->_block) - 1; }
  return &vec->vec[0];
}

static kk_std_core_hnd__ev* kk_evv_as_vec(kk_evv_t evv, kk_ssize_t* len, kk_std_core_hnd__ev* single, kk_context_t* ctx) {
  if (kk_evv_is_vector(evv,ctx)) {
    kk_evv_vector_t vec = kk_evv_as_vector(evv,ctx);
    *len = kk_block_scan_fsize(&vec->_block) - 1;
    return &vec->vec[0];
  }
  else {
    // single evidence
    *single = kk_evv_as_ev(evv,ctx);
    *len = 1;
    return single;
  }
}

kk_std_core_hnd__ev kk_ev_none(kk_context_t* ctx) {
  static kk_std_core_hnd__ev ev_none_singleton = { kk_datatype_null_init };
  if (kk_datatype_is_null(ev_none_singleton)) {
    ev_none_singleton = kk_std_core_hnd__new_Ev(
      kk_reuse_null,
      0, // cpath
      kk_std_core_hnd__new_Htag(kk_string_empty(),ctx), // tag ""
      kk_std_core_hnd__new_Marker(0,ctx),               // marker 0
      kk_box_null(),                                    // no handler
      -1,                                               // bot
      kk_evv_empty(ctx),
      ctx
    );
  }
  return kk_std_core_hnd__ev_dup(ev_none_singleton,ctx);
}


kk_ssize_t kk_evv_index( struct kk_std_core_hnd_Htag htag, kk_context_t* ctx ) {
  // todo: drop htag?
  kk_ssize_t len;
  kk_std_core_hnd__ev single;
  kk_std_core_hnd__ev* vec = kk_evv_as_vec(ctx->evv,&len,&single,ctx);
  for(kk_ssize_t i = 0; i < len; i++) {
    struct kk_std_core_hnd_Ev* ev = kk_std_core_hnd__as_Ev(vec[i],ctx);
    if (kk_string_cmp_borrow(htag.tagname,ev->htag.tagname,ctx) <= 0) return i; // break on insertion point
  }
  //string_t evvs = kk_evv_show(dup_datatype_as(kk_evv_t,ctx->evv),ctx);
  //fatal_error(EFAULT,"cannot find tag '%s' in: %s", string_cbuf_borrow(htag.htag), string_cbuf_borrow(evvs));
  //drop_string_t(evvs,ctx);
  return len;
}

kk_std_core_hnd__ev kk_evv_lookup( struct kk_std_core_hnd_Htag htag, kk_context_t* ctx ) {
  // todo: drop htag
  kk_ssize_t idx = kk_evv_index(htag,ctx);
  return kk_evv_at(idx,ctx);
}

static inline int32_t kk_cfc_lub(int32_t cfc1, int32_t cfc2) {
  if (cfc1 < 0) return cfc2;
  else if (cfc1+cfc2 == 1) return 2;
  else if (cfc1>cfc2) return cfc1;
  else return cfc2;
}

static inline struct kk_std_core_hnd_Ev* kk_evv_as_Ev( kk_evv_t evv, kk_context_t* ctx ) {
  return kk_std_core_hnd__as_Ev(kk_evv_as_ev(evv,ctx),ctx);
}


static int32_t kk_evv_cfc_of_borrow(kk_evv_t evv, kk_context_t* ctx) {
  if (kk_evv_is_vector(evv,ctx)) {
    kk_evv_vector_t vec = kk_evv_as_vector(evv,ctx);
    return kk_integer_clamp32_borrow(vec->cfc,ctx);
  }
  else {
    struct kk_std_core_hnd_Ev* ev = kk_evv_as_Ev(evv,ctx);
    return ev->cfc;
  }
}

int32_t kk_evv_cfc(kk_context_t* ctx) {
  return kk_evv_cfc_of_borrow(ctx->evv,ctx);
}

static void kk_evv_update_cfc_borrow(kk_evv_t evv, int32_t cfc, kk_context_t* ctx) {
  kk_assert_internal(!kk_evv_is_empty(evv,ctx)); // should never happen (as named handlers are always in some context)
  if (kk_evv_is_vector(evv,ctx)) {
    kk_evv_vector_t vec = kk_evv_as_vector(evv,ctx);
    vec->cfc = kk_integer_from_int32(kk_cfc_lub(kk_integer_clamp32_borrow(vec->cfc,ctx),cfc), ctx);
  }
  else {
    struct kk_std_core_hnd_Ev* ev = kk_evv_as_Ev(evv,ctx);
    ev->cfc = kk_cfc_lub(ev->cfc,cfc);
  }
}

kk_evv_t kk_evv_insert(kk_evv_t evvd, kk_std_core_hnd__ev evd, kk_context_t* ctx) {
  struct kk_std_core_hnd_Ev* ev = kk_std_core_hnd__as_Ev(evd,ctx);
  // update ev with parent evidence vector (either at init, or due to non-scoped resumptions)
  int32_t marker = ev->marker.m;
  if (marker==0) { kk_std_core_hnd__ev_drop(evd,ctx); return evvd; } // ev-none
  kk_evv_drop(ev->hevv,ctx);
  ev->hevv = kk_evv_dup(evvd,ctx);
  if (marker<0) { // negative marker is used for named evidence; this means this evidence should not be inserted into the evidence vector
    kk_evv_update_cfc_borrow(evvd,ev->cfc,ctx); // update cfc in-place for named evidence
    kk_std_core_hnd__ev_drop(evd,ctx);
    return evvd;
  }
  // for regular handler evidence, insert ev
  kk_ssize_t n;
  kk_std_core_hnd__ev single;
  kk_std_core_hnd__ev* const evv1 = kk_evv_as_vec(evvd, &n, &single, ctx);
  if (n == 0) {
    // use ev directly as the evidence vector
    kk_evv_drop(evvd, ctx);
    return kk_ev_as_evv(evd,ctx);
  }
  else {
    // create evidence vector
    const int32_t cfc = kk_cfc_lub(kk_evv_cfc_of_borrow(evvd, ctx), ev->cfc);
    ev->cfc = cfc; // update in place
    kk_evv_vector_t vec2 = kk_evv_vector_alloc(n+1, cfc, ctx);
    kk_std_core_hnd__ev* const evv2 = kk_evv_vector_buf(vec2, NULL);
    kk_ssize_t i;
    for (i = 0; i < n; i++) {
      struct kk_std_core_hnd_Ev* ev1 = kk_std_core_hnd__as_Ev(evv1[i],ctx);
      if (kk_string_cmp_borrow(ev->htag.tagname, ev1->htag.tagname,ctx) <= 0) break;
      evv2[i] = kk_std_core_hnd__ev_dup(evv1[i],ctx);
    }
    evv2[i] = evd;
    for (; i < n; i++) {
      evv2[i+1] = kk_std_core_hnd__ev_dup(evv1[i],ctx);
    }
    kk_evv_drop(evvd, ctx);  // assigned to evidence already
    return kk_datatype_from_base(vec2,ctx);
  }
}

kk_evv_t kk_evv_delete(kk_evv_t evvd, kk_ssize_t index, bool behind, kk_context_t* ctx) {
  kk_ssize_t n;
  kk_std_core_hnd__ev single;
  const kk_std_core_hnd__ev* evv1 = kk_evv_as_vec(evvd, &n, &single, ctx);
  if (n <= 1) {
    kk_evv_drop(evvd,ctx);
    return kk_evv_total(ctx);
  }
  if (behind) index++;
  kk_assert_internal(index < n);
  // todo: copy without dupping (and later dropping) when possible
  const int32_t cfc1 = kk_evv_cfc_of_borrow(evvd,ctx);
  kk_evv_vector_t const vec2 = kk_evv_vector_alloc(n-1,cfc1,ctx);
  kk_std_core_hnd__ev* const evv2 = kk_evv_vector_buf(vec2,NULL);
  kk_ssize_t i;
  for(i = 0; i < index; i++) {
    evv2[i] = kk_std_core_hnd__ev_dup(evv1[i],ctx);
  }
  for(; i < n-1; i++) {
    evv2[i] = kk_std_core_hnd__ev_dup(evv1[i+1],ctx);
  }
  struct kk_std_core_hnd_Ev* ev = kk_std_core_hnd__as_Ev(evv1[index],ctx);
  if (ev->cfc >= cfc1) {
    int32_t cfc = kk_std_core_hnd__as_Ev(evv2[0],ctx)->cfc;
    for(i = 1; i < n-1; i++) {
      cfc = kk_cfc_lub(cfc,kk_std_core_hnd__as_Ev(evv2[i],ctx)->cfc);
    }
    vec2->cfc = kk_integer_from_int32(cfc,ctx);
  }
  kk_evv_drop(evvd,ctx);
  return kk_datatype_from_base(vec2,ctx);
}

kk_evv_t kk_evv_create(kk_evv_t evv1, kk_vector_t indices, kk_context_t* ctx) {
  kk_ssize_t len;
  kk_box_t* elems = kk_vector_buf_borrow(indices,&len,ctx); // borrows
  kk_evv_vector_t evv2 = kk_evv_vector_alloc(len,kk_evv_cfc_of_borrow(evv1,ctx),ctx);
  kk_std_core_hnd__ev* buf2 = kk_evv_vector_buf(evv2,NULL);
  kk_assert_internal(kk_evv_is_vector(evv1,ctx));
  kk_ssize_t len1;
  kk_std_core_hnd__ev single;
  kk_std_core_hnd__ev* buf1 = kk_evv_as_vec(evv1,&len1,&single,ctx);
  for(kk_ssize_t i = 0; i < len; i++) {
    kk_ssize_t idx = kk_ssize_unbox(elems[i],KK_BORROWED,ctx);
    kk_assert_internal(idx < len1);
    buf2[i] = kk_std_core_hnd__ev_dup( buf1[idx], ctx );
  }
  kk_vector_drop(indices,ctx);
  kk_evv_drop(evv1,ctx);
  return kk_datatype_from_base(evv2,ctx);
}

kk_evv_t kk_evv_swap_create( kk_vector_t indices, kk_context_t* ctx ) {
  kk_ssize_t len;
  kk_box_t* vec = kk_vector_buf_borrow(indices,&len,ctx);
  if (len==0) {
    kk_vector_drop(indices,ctx);
    return kk_evv_swap_create0(ctx);
  }
  if (len==1) {
    kk_ssize_t i = kk_ssize_unbox(vec[0],KK_BORROWED,ctx);
    kk_vector_drop(indices,ctx);
    return kk_evv_swap_create1(i,ctx);
  }
  return kk_evv_swap( kk_evv_create(kk_evv_dup(ctx->evv,ctx),indices,ctx), ctx );
}


kk_string_t kk_evv_show(kk_evv_t evv, kk_context_t* ctx) {
  return kk_string_alloc_dup_valid_utf8("(not yet implemented: kk_evv_show)",ctx);
}


/*-----------------------------------------------------------------------
  Compose continuations
-----------------------------------------------------------------------*/

struct kcompose_fun_s {
  struct kk_function_s _base;
  kk_box_t      count;
  kk_function_t conts[1];
};

// kleisli composition of continuations
static kk_box_t kcompose( kk_function_t fself, kk_box_t x, kk_context_t* ctx) {
  struct kcompose_fun_s* self = kk_function_as(struct kcompose_fun_s*,fself,ctx);
  kk_intx_t count = kk_intf_unbox(self->count);
  kk_function_t* conts = &self->conts[0];
  // call each continuation in order
  for(kk_intx_t i = 0; i < count; i++) {
    // todo: take uniqueness of fself into account to avoid dup_function
    kk_function_t f = kk_function_dup(conts[i],ctx);
    x = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, ctx), ctx);
    if (kk_yielding(ctx)) {
      // if yielding, `yield_next` all continuations that still need to be done
      while(++i < count) {
        // todo: if fself is unique, we could copy without dup?
        kk_yield_extend(kk_function_dup(conts[i],ctx),ctx);
      }
      kk_function_drop(fself,ctx);
      kk_box_drop(x,ctx);     // still drop even though we yield as it may release a boxed value type?
      return kk_box_any(ctx); // return yielding
    }
  }
  kk_function_drop(fself,ctx);
  return x;
}

static kk_function_t new_kcompose( kk_function_t* conts, kk_intf_t count, kk_context_t* ctx ) {
  if (count==0) return kk_function_id(ctx);
  if (count==1) return conts[0];
  struct kcompose_fun_s* f = kk_block_as(struct kcompose_fun_s*,
                               kk_block_alloc(kk_ssizeof(struct kcompose_fun_s) - kk_ssizeof(kk_function_t) + (count*kk_ssizeof(kk_function_t)),
                                 2 + count /* scan size */, KK_TAG_FUNCTION, ctx));
  f->_base.fun = kk_kkfun_ptr_box(&kcompose,ctx);
  f->count = kk_intf_box(count);
  kk_memcpy(f->conts, conts, count * kk_ssizeof(kk_function_t));
  return kk_datatype_from_base(&f->_base,ctx);
}

/*-----------------------------------------------------------------------
  Yield extension
-----------------------------------------------------------------------*/

kk_box_t kk_yield_extend( kk_function_t next, kk_context_t* ctx ) {
  kk_yield_t* yield = &ctx->yield;
  kk_assert_internal(kk_yielding(ctx));  // cannot extend if not yielding
  if (kk_unlikely(kk_yielding_final(ctx))) {
    // todo: can we optimize this so `next` is never allocated in the first place?
    kk_function_drop(next,ctx); // ignore extension if never resuming
  }
  else {
    if (kk_unlikely(yield->conts_count >= KK_YIELD_CONT_MAX)) {
      // alloc a function to compose all continuations in the array
      kk_function_t comp = new_kcompose( yield->conts, yield->conts_count, ctx );
      yield->conts[0] = comp;
      yield->conts_count = 1;
    }
    yield->conts[yield->conts_count++] = next;
  }
  return kk_box_any(ctx);
}

// cont_apply: \x -> f(cont,x)
struct cont_apply_fun_s {
  struct kk_function_s _base;
  kk_function_t f;
  kk_function_t cont;
};

static kk_box_t cont_apply( kk_function_t fself, kk_box_t x, kk_context_t* ctx ) {
  struct cont_apply_fun_s* self = kk_function_as(struct cont_apply_fun_s*, fself, ctx);
  kk_function_t f = self->f;
  kk_function_t cont = self->cont;
  kk_drop_match(self,{kk_function_dup(f,ctx);kk_function_dup(cont,ctx);},{},ctx);
  return kk_function_call( kk_box_t, (kk_function_t, kk_function_t, kk_box_t, kk_context_t* ctx), f, (f, cont, x, ctx), ctx);
}

static kk_function_t kk_new_cont_apply( kk_function_t f, kk_function_t cont, kk_context_t* ctx ) {
  struct cont_apply_fun_s* self = kk_function_alloc_as(struct cont_apply_fun_s, 3, ctx);
  self->_base.fun = kk_kkfun_ptr_box(&cont_apply,ctx);
  self->f = f;
  self->cont = cont;
  return kk_datatype_from_base(&self->_base,ctx);
}

// Unlike `yield_extend`, `yield_cont` gets access to the current continuation. This is used in `yield_prompt`.
kk_box_t kk_yield_cont( kk_function_t f, kk_context_t* ctx ) {
  kk_yield_t* yield = &ctx->yield;
  kk_assert_internal(kk_yielding(ctx)); // cannot extend if not yielding
  if (kk_unlikely(kk_yielding_final(ctx))) {
    kk_function_drop(f,ctx); // ignore extension if never resuming
  }
  else {
    kk_function_t cont = new_kcompose(yield->conts, yield->conts_count, ctx);
    yield->conts_count = 1;
    yield->conts[0] = kk_new_cont_apply(f, cont, ctx);
  }
  return kk_box_any(ctx);
}

kk_function_t kk_yield_to( struct kk_std_core_hnd_Marker m, kk_function_t clause, kk_context_t* ctx ) {
  kk_yield_t* yield = &ctx->yield;
  kk_assert_internal(!kk_yielding(ctx)); // already yielding
  ctx->yielding = KK_YIELD_NORMAL;
  yield->marker = m.m;
  yield->clause = clause;
  yield->conts_count = 0;
  return kk_datatype_unbox(kk_box_any(ctx));
}

kk_box_t kk_yield_final( struct kk_std_core_hnd_Marker m, kk_function_t clause, kk_context_t* ctx ) {
  kk_yield_to(m,clause,ctx);
  ctx->yielding = KK_YIELD_FINAL;
  return kk_box_any(ctx);
}

kk_box_t kk_fatal_resume_final(kk_context_t* ctx) {
  kk_fatal_error(EFAULT,"trying to resume a finalized resumption");
  return kk_box_any(ctx);
}

static kk_box_t _fatal_resume_final(kk_function_t self, kk_context_t* ctx) {
  kk_function_drop(self,ctx);
  return kk_fatal_resume_final(ctx);
}
static kk_function_t fun_fatal_resume_final(kk_context_t* ctx) {
  kk_define_static_function(f,_fatal_resume_final,ctx);
  return kk_function_dup(f,ctx);
}


struct kk_std_core_hnd_yld_s kk_yield_prompt( struct kk_std_core_hnd_Marker m, kk_context_t* ctx ) {
  kk_yield_t* yield = &ctx->yield;
  if (ctx->yielding == KK_YIELD_NONE) {
    return kk_std_core_hnd__new_Pure(ctx);
  }
  else if (yield->marker != m.m) {
    return (ctx->yielding == KK_YIELD_FINAL ? kk_std_core_hnd__new_YieldingFinal(ctx) : kk_std_core_hnd__new_Yielding(ctx));
  }
  else {
    kk_function_t cont = (ctx->yielding == KK_YIELD_FINAL ? fun_fatal_resume_final(ctx) : new_kcompose(yield->conts, yield->conts_count, ctx));
    kk_function_t clause = yield->clause;
    ctx->yielding = KK_YIELD_NONE;
    #ifndef NDEBUG
    kk_memset(yield,0,kk_ssizeof(kk_yield_t));
    #endif
    return kk_std_core_hnd__new_Yield(clause, cont, ctx);
  }
}

kk_unit_t  kk_evv_guard(kk_evv_t evv, kk_context_t* ctx) {
  bool eq = kk_datatype_eq(ctx->evv,evv);
  kk_evv_drop(evv,ctx);
  if (!eq) {
    // todo: improve error message with diagnostics
    kk_fatal_error(EFAULT,"trying to resume outside the (handler) scope of the original handler");
  }
  return kk_Unit;
}

typedef struct yield_info_s {
  struct kk_std_core_hnd__yield_info_s _base;
  kk_function_t clause;
  kk_function_t conts[KK_YIELD_CONT_MAX];
  kk_intf_t     conts_count;
  int32_t       marker;
  int8_t        yielding;
}* yield_info_t;

kk_std_core_hnd__yield_info kk_yield_capture(kk_context_t* ctx) {
  kk_assert_internal(kk_yielding(ctx));
  yield_info_t yld = kk_block_alloc_as(struct yield_info_s, 1 + KK_YIELD_CONT_MAX, (kk_tag_t)1, ctx);
  yld->clause = ctx->yield.clause;
  kk_ssize_t i = 0;
  for( ; i < ctx->yield.conts_count; i++) {
    yld->conts[i] = ctx->yield.conts[i];
  }
  for( ; i < KK_YIELD_CONT_MAX; i++) {
    yld->conts[i] = kk_function_null(ctx);
  }
  yld->conts_count = ctx->yield.conts_count;
  yld->marker = ctx->yield.marker;
  yld->yielding = ctx->yielding;
  ctx->yielding = 0;
  ctx->yield.conts_count = 0;
  return kk_datatype_from_base(&yld->_base,ctx);
}

kk_box_t kk_yield_reyield( kk_std_core_hnd__yield_info yldinfo, kk_context_t* ctx) {
  kk_assert_internal(!kk_yielding(ctx));
  yield_info_t yld = kk_datatype_as_assert(yield_info_t, yldinfo, (kk_tag_t)1, ctx);
  ctx->yield.clause = kk_function_dup(yld->clause,ctx);
  ctx->yield.marker = yld->marker;
  ctx->yield.conts_count = yld->conts_count;
  ctx->yielding = yld->yielding;
  for(kk_ssize_t i = 0; i < yld->conts_count; i++) {
    ctx->yield.conts[i] = kk_function_dup(yld->conts[i],ctx);
  }
  kk_constructor_drop(yld,ctx);
  return kk_box_any(ctx);
}


kk_std_core_hnd__htag kk_std_core_hnd__copy(kk_std_core_hnd__htag _this, kk_std_core_types__optional tagname0, kk_context_t* _ctx) { /* forall<a> (htag<a>, tagname : optional<string>) -> htag<a> */ 
  kk_string_t _x11173;
  if (kk_std_core_types__is_Optional(tagname0, _ctx)) {
    kk_box_t _box_x10889 = tagname0._cons.Optional.value;
    kk_string_t _tagname_2006 = kk_string_unbox(_box_x10889);
    kk_string_dup(_tagname_2006, _ctx);
    kk_std_core_types__optional_drop(tagname0, _ctx);
    kk_std_core_hnd__htag_drop(_this, _ctx);
    _x11173 = _tagname_2006; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(tagname0, _ctx);
    {
      kk_string_t _x = _this.tagname;
      _x11173 = _x; /*string*/
    }
  }
  return kk_std_core_hnd__new_Htag(_x11173, _ctx);
}

kk_std_core_hnd__ev kk_std_core_hnd__copy_2(kk_std_core_hnd__ev _this, kk_std_core_types__optional htag0, kk_std_core_hnd__marker marker, kk_box_t hnd, kk_std_core_types__optional cfc0, kk_evv_t hevv, kk_context_t* _ctx) { /* forall<a,e,b> (ev<a>, htag : optional<htag<a>>, marker : marker<e,b>, hnd : a<e,b>, cfc : optional<cfc>, hevv : evv<e>) -> ev<a> */ 
  kk_std_core_hnd__htag _x11177;
  if (kk_std_core_types__is_Optional(htag0, _ctx)) {
    kk_box_t _box_x10891 = htag0._cons.Optional.value;
    kk_std_core_hnd__htag _htag_2119 = kk_std_core_hnd__htag_unbox(_box_x10891, KK_BORROWED, _ctx);
    kk_std_core_hnd__htag_dup(_htag_2119, _ctx);
    kk_std_core_types__optional_drop(htag0, _ctx);
    _x11177 = _htag_2119; /*std/core/hnd/htag<2145>*/
  }
  else {
    kk_std_core_types__optional_drop(htag0, _ctx);
    {
      struct kk_std_core_hnd_Ev* _con11178 = kk_std_core_hnd__as_Ev(_this, _ctx);
      kk_std_core_hnd__htag _x = _con11178->htag;
      kk_std_core_hnd__htag_dup(_x, _ctx);
      _x11177 = _x; /*std/core/hnd/htag<2145>*/
    }
  }
  int32_t _x11179;
  if (kk_std_core_types__is_Optional(cfc0, _ctx)) {
    kk_box_t _box_x10892 = cfc0._cons.Optional.value;
    int32_t _cfc_2126 = kk_int32_unbox(_box_x10892, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(cfc0, _ctx);
    kk_datatype_ptr_dropn(_this, (KK_I32(3)), _ctx);
    _x11179 = _cfc_2126; /*std/core/hnd/cfc*/
  }
  else {
    kk_std_core_types__optional_drop(cfc0, _ctx);
    {
      struct kk_std_core_hnd_Ev* _con11180 = kk_std_core_hnd__as_Ev(_this, _ctx);
      kk_std_core_hnd__htag _pat01 = _con11180->htag;
      kk_box_t _pat21 = _con11180->hnd;
      int32_t _x0 = _con11180->cfc;
      kk_evv_t _pat30 = _con11180->hevv;
      if kk_likely(kk_datatype_ptr_is_unique(_this, _ctx)) {
        kk_evv_drop(_pat30, _ctx);
        kk_box_drop(_pat21, _ctx);
        kk_std_core_hnd__htag_drop(_pat01, _ctx);
        kk_datatype_ptr_free(_this, _ctx);
      }
      else {
        kk_datatype_ptr_decref(_this, _ctx);
      }
      _x11179 = _x0; /*std/core/hnd/cfc*/
    }
  }
  return kk_std_core_hnd__new_Ev(kk_reuse_null, 0, _x11177, marker, hnd, _x11179, hevv, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd__copy_fun11182__t_3 {
  struct kk_function_s _base;
  kk_box_t _fun_unbox_x10898;
};
static kk_box_t kk_std_core_hnd__copy_fun11182_3(kk_function_t _fself, kk_std_core_hnd__marker _b_10902, kk_std_core_hnd__ev _b_10903, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_copy_fun11182_3(kk_box_t _fun_unbox_x10898, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun11182__t_3* _self = kk_function_alloc_as(struct kk_std_core_hnd__copy_fun11182__t_3, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__copy_fun11182_3, kk_context());
  _self->_fun_unbox_x10898 = _fun_unbox_x10898;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__copy_fun11182_3(kk_function_t _fself, kk_std_core_hnd__marker _b_10902, kk_std_core_hnd__ev _b_10903, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun11182__t_3* _self = kk_function_as(struct kk_std_core_hnd__copy_fun11182__t_3*, _fself, _ctx);
  kk_box_t _fun_unbox_x10898 = _self->_fun_unbox_x10898; /* 116 */
  kk_drop_match(_self, {kk_box_dup(_fun_unbox_x10898, _ctx);}, {}, _ctx)
  kk_function_t _x11183 = kk_function_unbox(_fun_unbox_x10898, _ctx); /*(10899, 10900) -> 2238 10901*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x11183, (_x11183, kk_std_core_hnd__marker_box(_b_10902, _ctx), kk_std_core_hnd__ev_box(_b_10903, _ctx), _ctx), _ctx);
}

kk_std_core_hnd__clause0 kk_std_core_hnd__copy_3(kk_std_core_hnd__clause0 _this, kk_std_core_types__optional clause0, kk_context_t* _ctx) { /* forall<a,b,e,c> (clause0<a,b,e,c>, clause : optional<(marker<e,c>, ev<b>) -> e a>) -> clause0<a,b,e,c> */ 
  kk_function_t _x11181;
  if (kk_std_core_types__is_Optional(clause0, _ctx)) {
    kk_box_t _fun_unbox_x10898 = clause0._cons.Optional.value;
    kk_box_dup(_fun_unbox_x10898, _ctx);
    kk_std_core_types__optional_drop(clause0, _ctx);
    kk_std_core_hnd__clause0_drop(_this, _ctx);
    _x11181 = kk_std_core_hnd__new_copy_fun11182_3(_fun_unbox_x10898, _ctx); /*(std/core/hnd/marker<2238,2239>, std/core/hnd/ev<2237>) -> 2238 10901*/
  }
  else {
    kk_std_core_types__optional_drop(clause0, _ctx);
    {
      kk_function_t _x = _this.clause;
      _x11181 = _x; /*(std/core/hnd/marker<2238,2239>, std/core/hnd/ev<2237>) -> 2238 10901*/
    }
  }
  return kk_std_core_hnd__new_Clause0(_x11181, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd__copy_fun11185__t_4 {
  struct kk_function_s _base;
  kk_box_t _fun_unbox_x10911;
};
static kk_box_t kk_std_core_hnd__copy_fun11185_4(kk_function_t _fself, kk_std_core_hnd__marker _b_10916, kk_std_core_hnd__ev _b_10917, kk_box_t _b_10918, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_copy_fun11185_4(kk_box_t _fun_unbox_x10911, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun11185__t_4* _self = kk_function_alloc_as(struct kk_std_core_hnd__copy_fun11185__t_4, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__copy_fun11185_4, kk_context());
  _self->_fun_unbox_x10911 = _fun_unbox_x10911;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__copy_fun11185_4(kk_function_t _fself, kk_std_core_hnd__marker _b_10916, kk_std_core_hnd__ev _b_10917, kk_box_t _b_10918, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun11185__t_4* _self = kk_function_as(struct kk_std_core_hnd__copy_fun11185__t_4*, _fself, _ctx);
  kk_box_t _fun_unbox_x10911 = _self->_fun_unbox_x10911; /* 116 */
  kk_drop_match(_self, {kk_box_dup(_fun_unbox_x10911, _ctx);}, {}, _ctx)
  kk_function_t _x11186 = kk_function_unbox(_fun_unbox_x10911, _ctx); /*(10912, 10913, 10914) -> 2444 10915*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), _x11186, (_x11186, kk_std_core_hnd__marker_box(_b_10916, _ctx), kk_std_core_hnd__ev_box(_b_10917, _ctx), _b_10918, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd__copy_4(kk_std_core_hnd__clause1 _this, kk_std_core_types__optional clause0, kk_context_t* _ctx) { /* forall<a,b,c,e,d> (clause1<a,b,c,e,d>, clause : optional<(marker<e,d>, ev<c>, a) -> e b>) -> clause1<a,b,c,e,d> */ 
  kk_function_t _x11184;
  if (kk_std_core_types__is_Optional(clause0, _ctx)) {
    kk_box_t _fun_unbox_x10911 = clause0._cons.Optional.value;
    kk_box_dup(_fun_unbox_x10911, _ctx);
    kk_std_core_types__optional_drop(clause0, _ctx);
    kk_std_core_hnd__clause1_drop(_this, _ctx);
    _x11184 = kk_std_core_hnd__new_copy_fun11185_4(_fun_unbox_x10911, _ctx); /*(std/core/hnd/marker<2444,2445>, std/core/hnd/ev<2443>, 2441) -> 2444 10915*/
  }
  else {
    kk_std_core_types__optional_drop(clause0, _ctx);
    {
      kk_function_t _x = _this.clause;
      _x11184 = _x; /*(std/core/hnd/marker<2444,2445>, std/core/hnd/ev<2443>, 2441) -> 2444 10915*/
    }
  }
  return kk_std_core_hnd__new_Clause1(_x11184, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd__copy_fun11188__t_5 {
  struct kk_function_s _base;
  kk_box_t _fun_unbox_x10928;
};
static kk_box_t kk_std_core_hnd__copy_fun11188_5(kk_function_t _fself, kk_std_core_hnd__marker _b_10934, kk_std_core_hnd__ev _b_10935, kk_box_t _b_10936, kk_box_t _b_10937, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_copy_fun11188_5(kk_box_t _fun_unbox_x10928, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun11188__t_5* _self = kk_function_alloc_as(struct kk_std_core_hnd__copy_fun11188__t_5, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__copy_fun11188_5, kk_context());
  _self->_fun_unbox_x10928 = _fun_unbox_x10928;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__copy_fun11188_5(kk_function_t _fself, kk_std_core_hnd__marker _b_10934, kk_std_core_hnd__ev _b_10935, kk_box_t _b_10936, kk_box_t _b_10937, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun11188__t_5* _self = kk_function_as(struct kk_std_core_hnd__copy_fun11188__t_5*, _fself, _ctx);
  kk_box_t _fun_unbox_x10928 = _self->_fun_unbox_x10928; /* 116 */
  kk_drop_match(_self, {kk_box_dup(_fun_unbox_x10928, _ctx);}, {}, _ctx)
  kk_function_t _x11189 = kk_function_unbox(_fun_unbox_x10928, _ctx); /*(10929, 10930, 10931, 10932) -> 2745 10933*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), _x11189, (_x11189, kk_std_core_hnd__marker_box(_b_10934, _ctx), kk_std_core_hnd__ev_box(_b_10935, _ctx), _b_10936, _b_10937, _ctx), _ctx);
}

kk_std_core_hnd__clause2 kk_std_core_hnd__copy_5(kk_std_core_hnd__clause2 _this, kk_std_core_types__optional clause0, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1> (clause2<a,b,c,d,e,a1>, clause : optional<(marker<e,a1>, ev<d>, a, b) -> e c>) -> clause2<a,b,c,d,e,a1> */ 
  kk_function_t _x11187;
  if (kk_std_core_types__is_Optional(clause0, _ctx)) {
    kk_box_t _fun_unbox_x10928 = clause0._cons.Optional.value;
    kk_box_dup(_fun_unbox_x10928, _ctx);
    kk_std_core_types__optional_drop(clause0, _ctx);
    kk_std_core_hnd__clause2_drop(_this, _ctx);
    _x11187 = kk_std_core_hnd__new_copy_fun11188_5(_fun_unbox_x10928, _ctx); /*(std/core/hnd/marker<2745,2746>, std/core/hnd/ev<2744>, 2741, 2742) -> 2745 10933*/
  }
  else {
    kk_std_core_types__optional_drop(clause0, _ctx);
    {
      kk_function_t _x = _this.clause;
      _x11187 = _x; /*(std/core/hnd/marker<2745,2746>, std/core/hnd/ev<2744>, 2741, 2742) -> 2745 10933*/
    }
  }
  return kk_std_core_hnd__new_Clause2(_x11187, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd__copy_fun11191__t_6 {
  struct kk_function_s _base;
  kk_box_t _fun_unbox_x10941;
};
static kk_box_t kk_std_core_hnd__copy_fun11191_6(kk_function_t _fself, kk_std_core_hnd__resume_result _b_10944, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_copy_fun11191_6(kk_box_t _fun_unbox_x10941, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun11191__t_6* _self = kk_function_alloc_as(struct kk_std_core_hnd__copy_fun11191__t_6, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__copy_fun11191_6, kk_context());
  _self->_fun_unbox_x10941 = _fun_unbox_x10941;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__copy_fun11191_6(kk_function_t _fself, kk_std_core_hnd__resume_result _b_10944, kk_context_t* _ctx) {
  struct kk_std_core_hnd__copy_fun11191__t_6* _self = kk_function_as(struct kk_std_core_hnd__copy_fun11191__t_6*, _fself, _ctx);
  kk_box_t _fun_unbox_x10941 = _self->_fun_unbox_x10941; /* 116 */
  kk_drop_match(_self, {kk_box_dup(_fun_unbox_x10941, _ctx);}, {}, _ctx)
  kk_function_t _x11192 = kk_function_unbox(_fun_unbox_x10941, _ctx); /*(10942) -> 2959 10943*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x11192, (_x11192, kk_std_core_hnd__resume_result_box(_b_10944, _ctx), _ctx), _ctx);
}

kk_std_core_hnd__resume_context kk_std_core_hnd__copy_6(kk_std_core_hnd__resume_context _this, kk_std_core_types__optional k0, kk_context_t* _ctx) { /* forall<a,e,e1,b> (resume-context<a,e,e1,b>, k : optional<(resume-result<a,b>) -> e b>) -> resume-context<a,e,e1,b> */ 
  kk_function_t _x11190;
  if (kk_std_core_types__is_Optional(k0, _ctx)) {
    kk_box_t _fun_unbox_x10941 = k0._cons.Optional.value;
    kk_box_dup(_fun_unbox_x10941, _ctx);
    kk_std_core_types__optional_drop(k0, _ctx);
    kk_std_core_hnd__resume_context_drop(_this, _ctx);
    _x11190 = kk_std_core_hnd__new_copy_fun11191_6(_fun_unbox_x10941, _ctx); /*(std/core/hnd/resume-result<2958,2961>) -> 2959 10943*/
  }
  else {
    kk_std_core_types__optional_drop(k0, _ctx);
    {
      kk_function_t _x = _this.k;
      _x11190 = _x; /*(std/core/hnd/resume-result<2958,2961>) -> 2959 10943*/
    }
  }
  return kk_std_core_hnd__new_Resume_context(_x11190, _ctx);
}
 
// (dynamically) find evidence insertion/deletion index in the evidence vector

kk_ssize_t kk_std_core_hnd__evv_index(kk_std_core_hnd__htag htag0, kk_context_t* _ctx) { /* forall<e,a> (htag : htag<a>) -> e ev-index */ 
  return kk_evv_index(htag0,kk_context());
}

bool kk_std_core_hnd__evv_is_affine(kk_context_t* _ctx) { /* () -> bool */ 
  return kk_evv_cfc(kk_context())<=2;
}

kk_std_core_hnd__ev kk_std_core_hnd__evv_lookup(kk_std_core_hnd__htag htag0, kk_context_t* _ctx) { /* forall<a> (htag : htag<a>) -> ev<a> */ 
  return kk_evv_lookup(htag0,kk_context());
}

kk_evv_t kk_std_core_hnd_evv_get(kk_context_t* _ctx) { /* forall<e> () -> e evv<e> */ 
  return kk_evv_get(kk_context());
}

kk_evv_t kk_std_core_hnd_evv_insert(kk_evv_t evv, kk_std_core_hnd__ev ev, kk_context_t* _ctx) { /* forall<e,e1,a> (evv : evv<e>, ev : ev<a>) -> e evv<e1> */ 
  return kk_evv_insert(evv,ev,kk_context());
}

int32_t kk_std_core_hnd_fresh_marker_int(kk_context_t* _ctx) { /* () -> int32 */ 
  return kk_marker_unique(kk_context());
}

bool kk_std_core_hnd_evv_eq(kk_evv_t evv0, kk_evv_t evv1, kk_context_t* _ctx) { /* forall<e> (evv0 : evv<e>, evv1 : evv<e>) -> bool */ 
  return kk_evv_eq(evv0,evv1,kk_context());
}

kk_unit_t kk_std_core_hnd_guard(kk_evv_t w, kk_context_t* _ctx) { /* forall<e> (w : evv<e>) -> e () */ 
  kk_evv_guard(w,kk_context()); return kk_Unit;
}

kk_box_t kk_std_core_hnd_yield_extend(kk_function_t next, kk_context_t* _ctx) { /* forall<a,b,e> (next : (a) -> e b) -> e b */ 
  return kk_yield_extend(next,kk_context());
}

kk_box_t kk_std_core_hnd_yield_cont(kk_function_t f, kk_context_t* _ctx) { /* forall<a,e,b> (f : forall<c> ((c) -> e a, c) -> e b) -> e b */ 
  return kk_yield_cont(f,kk_context());
}

kk_std_core_hnd__yld kk_std_core_hnd_yield_prompt(kk_std_core_hnd__marker m0, kk_context_t* _ctx) { /* forall<a,e,b> (m : marker<e,b>) -> yld<e,a,b> */ 
  return kk_yield_prompt(m0,kk_context());
}

kk_box_t kk_std_core_hnd_yield_to_final(kk_std_core_hnd__marker m0, kk_function_t clause0, kk_context_t* _ctx) { /* forall<a,e,e1,b> (m : marker<e1,b>, clause : ((resume-result<a,b>) -> e1 b) -> e1 b) -> e a */ 
  return kk_yield_final(m0,clause0,kk_context());
}

kk_evv_t kk_std_core_hnd_evv_swap_delete(kk_ssize_t i, bool behind, kk_context_t* _ctx) { /* forall<e,e1> (i : ev-index, behind : bool) -> e1 evv<e> */ 
  return kk_evv_swap_delete(i,behind,kk_context());
}

int32_t kk_std_core_hnd_fresh_marker_named_int(kk_context_t* _ctx) { /* () -> int32 */ 
  return -kk_marker_unique(kk_context());
}

kk_evv_t kk_std_core_hnd_evv_swap_create(kk_vector_t indices, kk_context_t* _ctx) { /* forall<e> (indices : vector<ev-index>) -> e evv<e> */ 
  return kk_evv_swap_create(indices,kk_context());
}

kk_function_t kk_std_core_hnd_yield_to_prim(kk_std_core_hnd__marker m0, kk_function_t clause0, kk_context_t* _ctx) { /* forall<a,e,e1,b> (m : marker<e1,b>, clause : ((resume-result<a,b>) -> e1 b) -> e1 b) -> e (() -> a) */ 
  return kk_yield_to(m0,clause0,kk_context());
}
extern kk_box_t kk_std_core_hnd_clause_tail_noyield0_fun11197(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__565__14, kk_std_core_hnd__ev ___wildcard__565__17, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield0_fun11197__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail_noyield0_fun11197__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* () -> 4172 4174 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__565__17, (KK_I32(3)), _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), op, (op, _ctx), _ctx);
}
extern kk_box_t kk_std_core_hnd_clause_tail_noyield1_fun11198(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__522__14, kk_std_core_hnd__ev ___wildcard__522__17, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield1_fun11198__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail_noyield1_fun11198__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (4205) -> 4203 4206 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__522__17, (KK_I32(3)), _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), op, (op, x, _ctx), _ctx);
}
extern kk_box_t kk_std_core_hnd_clause_tail_noyield2_fun11199(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__607__14, kk_std_core_hnd__ev ___wildcard__607__17, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield2_fun11199__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail_noyield2_fun11199__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (4242, 4243) -> 4240 4244 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__607__17, (KK_I32(3)), _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, x1, x2, _ctx), _ctx);
}

kk_evv_t kk_std_core_hnd_evv_swap_with(kk_std_core_hnd__ev ev, kk_context_t* _ctx) { /* forall<a,e> (ev : ev<a>) -> evv<e> */ 
  kk_evv_t _x11200;
  {
    struct kk_std_core_hnd_Ev* _con11201 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_std_core_hnd__htag _pat0 = _con11201->htag;
    kk_box_t _pat2 = _con11201->hnd;
    kk_evv_t w = _con11201->hevv;
    if kk_likely(kk_datatype_ptr_is_unique(ev, _ctx)) {
      kk_box_drop(_pat2, _ctx);
      kk_std_core_hnd__htag_drop(_pat0, _ctx);
      kk_datatype_ptr_free(ev, _ctx);
    }
    else {
      kk_evv_dup(w, _ctx);
      kk_datatype_ptr_decref(ev, _ctx);
    }
    _x11200 = w; /*std/core/hnd/evv<4249>*/
  }
  return kk_evv_swap(_x11200,kk_context());
}
extern kk_box_t kk_std_core_hnd_clause_value_fun11202(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__568__14, kk_std_core_hnd__ev ___wildcard__568__17, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_value_fun11202__t* _self = kk_function_as(struct kk_std_core_hnd_clause_value_fun11202__t*, _fself, _ctx);
  kk_box_t v = _self->v; /* 4292 */
  kk_drop_match(_self, {kk_box_dup(v, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__568__17, (KK_I32(3)), _ctx);
  return v;
}

kk_string_t kk_std_core_hnd_evv_show(kk_evv_t evv, kk_context_t* _ctx) { /* forall<e> (evv : evv<e>) -> string */ 
  return kk_evv_show(evv,kk_context());
}

kk_box_t kk_std_core_hnd_unsafe_reyield(kk_std_core_hnd__yield_info yld, kk_context_t* _ctx) { /* forall<a,e> (yld : yield-info) -> e a */ 
  return kk_yield_reyield(yld,kk_context());
}

kk_std_core_hnd__yield_info kk_std_core_hnd_yield_capture(kk_context_t* _ctx) { /* forall<e> () -> e yield-info */ 
  return kk_yield_capture(kk_context());
}

kk_box_t kk_std_core_hnd_resume_final(kk_context_t* _ctx) { /* forall<a> () -> a */ 
  return kk_fatal_resume_final(kk_context());
}


// lift anonymous function
struct kk_std_core_hnd_prompt_fun11208__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
  kk_function_t ret;
  kk_evv_t w0;
  kk_evv_t w1;
  kk_std_core_hnd__marker m0;
};
static kk_box_t kk_std_core_hnd_prompt_fun11208(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun11208(kk_std_core_hnd__ev ev, kk_function_t ret, kk_evv_t w0, kk_evv_t w1, kk_std_core_hnd__marker m0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11208__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun11208__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_prompt_fun11208, kk_context());
  _self->ev = ev;
  _self->ret = ret;
  _self->w0 = w0;
  _self->w1 = w1;
  _self->m0 = m0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_prompt_fun11208(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11208__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun11208__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<4764> */
  kk_function_t ret = _self->ret; /* (4762) -> 4763 4765 */
  kk_evv_t w0 = _self->w0; /* std/core/hnd/evv<4763> */
  kk_evv_t w1 = _self->w1; /* std/core/hnd/evv<4763> */
  kk_std_core_hnd__marker m0 = _self->m0; /* std/core/hnd/marker<4763,4765> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);kk_function_dup(ret, _ctx);kk_evv_dup(w0, _ctx);kk_evv_dup(w1, _ctx);kk_std_core_hnd__marker_dup(m0, _ctx);}, {}, _ctx)
  kk_evv_t w0_sq_ = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<4763>*/;
  kk_evv_t w1_sq_;
  bool _match_11161;
  kk_evv_t _x11209 = kk_evv_dup(w0_sq_, _ctx); /*std/core/hnd/evv<4763>*/
  _match_11161 = kk_std_core_hnd_evv_eq(w0, _x11209, _ctx); /*bool*/
  if (_match_11161) {
    w1_sq_ = w1; /*std/core/hnd/evv<4763>*/
  }
  else {
    kk_evv_drop(w1, _ctx);
    kk_evv_t _x11210 = kk_evv_dup(w0_sq_, _ctx); /*std/core/hnd/evv<4763>*/
    kk_std_core_hnd__ev _x11211 = kk_std_core_hnd__ev_dup(ev, _ctx); /*std/core/hnd/ev<4764>*/
    w1_sq_ = kk_std_core_hnd_evv_insert(_x11210, _x11211, _ctx); /*std/core/hnd/evv<4763>*/
  }
  kk_unit_t __1 = kk_Unit;
  kk_evv_t _x11212 = kk_evv_dup(w1_sq_, _ctx); /*std/core/hnd/evv<4763>*/
  kk_evv_set(_x11212,kk_context());
  kk_box_t _x11213 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx), _ctx); /*4762*/
  return kk_std_core_hnd_prompt(w0_sq_, w1_sq_, ev, m0, ret, _x11213, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_prompt_fun11214__t {
  struct kk_function_s _base;
  kk_function_t cont0;
  kk_std_core_hnd__ev ev;
  kk_function_t ret;
  kk_evv_t w0;
  kk_evv_t w1;
  kk_std_core_hnd__marker m0;
};
static kk_box_t kk_std_core_hnd_prompt_fun11214(kk_function_t _fself, kk_std_core_hnd__resume_result r, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun11214(kk_function_t cont0, kk_std_core_hnd__ev ev, kk_function_t ret, kk_evv_t w0, kk_evv_t w1, kk_std_core_hnd__marker m0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11214__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun11214__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_prompt_fun11214, kk_context());
  _self->cont0 = cont0;
  _self->ev = ev;
  _self->ret = ret;
  _self->w0 = w0;
  _self->w1 = w1;
  _self->m0 = m0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_prompt_fun11220__t {
  struct kk_function_s _base;
  kk_box_t x;
};
static kk_box_t kk_std_core_hnd_prompt_fun11220(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun11220(kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11220__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun11220__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_prompt_fun11220, kk_context());
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_prompt_fun11220(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11220__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun11220__t*, _fself, _ctx);
  kk_box_t x = _self->x; /* 4628 */
  kk_drop_match(_self, {kk_box_dup(x, _ctx);}, {}, _ctx)
  return x;
}


// lift anonymous function
struct kk_std_core_hnd_prompt_fun11221__t {
  struct kk_function_s _base;
  kk_box_t x0;
};
static kk_box_t kk_std_core_hnd_prompt_fun11221(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun11221(kk_box_t x0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11221__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun11221__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_prompt_fun11221, kk_context());
  _self->x0 = x0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_prompt_fun11221(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11221__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun11221__t*, _fself, _ctx);
  kk_box_t x0 = _self->x0; /* 4628 */
  kk_drop_match(_self, {kk_box_dup(x0, _ctx);}, {}, _ctx)
  return x0;
}


// lift anonymous function
struct kk_std_core_hnd_prompt_fun11227__t {
  struct kk_function_s _base;
  kk_box_t x10;
  kk_std_core_hnd__marker m0;
};
static kk_box_t kk_std_core_hnd_prompt_fun11227(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun11227(kk_box_t x10, kk_std_core_hnd__marker m0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11227__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun11227__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_prompt_fun11227, kk_context());
  _self->x10 = x10;
  _self->m0 = m0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_prompt_fun11228__t {
  struct kk_function_s _base;
  kk_box_t x10;
};
static kk_box_t kk_std_core_hnd_prompt_fun11228(kk_function_t _fself, kk_function_t ___wildcard__302__84, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_fun11228(kk_box_t x10, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11228__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_fun11228__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_prompt_fun11228, kk_context());
  _self->x10 = x10;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_prompt_fun11228(kk_function_t _fself, kk_function_t ___wildcard__302__84, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11228__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun11228__t*, _fself, _ctx);
  kk_box_t x10 = _self->x10; /* 4765 */
  kk_drop_match(_self, {kk_box_dup(x10, _ctx);}, {}, _ctx)
  kk_function_drop(___wildcard__302__84, _ctx);
  return x10;
}
static kk_box_t kk_std_core_hnd_prompt_fun11227(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11227__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun11227__t*, _fself, _ctx);
  kk_box_t x10 = _self->x10; /* 4765 */
  kk_std_core_hnd__marker m0 = _self->m0; /* std/core/hnd/marker<4763,4765> */
  kk_drop_match(_self, {kk_box_dup(x10, _ctx);kk_std_core_hnd__marker_dup(m0, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_hnd_new_prompt_fun11228(x10, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_prompt_fun11214(kk_function_t _fself, kk_std_core_hnd__resume_result r, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_fun11214__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_fun11214__t*, _fself, _ctx);
  kk_function_t cont0 = _self->cont0; /* (() -> 4628) -> 4763 4762 */
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<4764> */
  kk_function_t ret = _self->ret; /* (4762) -> 4763 4765 */
  kk_evv_t w0 = _self->w0; /* std/core/hnd/evv<4763> */
  kk_evv_t w1 = _self->w1; /* std/core/hnd/evv<4763> */
  kk_std_core_hnd__marker m0 = _self->m0; /* std/core/hnd/marker<4763,4765> */
  kk_drop_match(_self, {kk_function_dup(cont0, _ctx);kk_std_core_hnd__ev_dup(ev, _ctx);kk_function_dup(ret, _ctx);kk_evv_dup(w0, _ctx);kk_evv_dup(w1, _ctx);kk_std_core_hnd__marker_dup(m0, _ctx);}, {}, _ctx)
  if (kk_std_core_hnd__is_Deep(r, _ctx)) {
    kk_box_t x = r._cons.Deep.result;
    kk_evv_t w00_sq_ = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<4763>*/;
    kk_evv_t w10_sq_;
    bool _match_11160;
    kk_evv_t _x11215 = kk_evv_dup(w00_sq_, _ctx); /*std/core/hnd/evv<4763>*/
    _match_11160 = kk_std_core_hnd_evv_eq(w0, _x11215, _ctx); /*bool*/
    if (_match_11160) {
      w10_sq_ = w1; /*std/core/hnd/evv<4763>*/
    }
    else {
      kk_evv_drop(w1, _ctx);
      kk_evv_t _x11216 = kk_evv_dup(w00_sq_, _ctx); /*std/core/hnd/evv<4763>*/
      kk_std_core_hnd__ev _x11217 = kk_std_core_hnd__ev_dup(ev, _ctx); /*std/core/hnd/ev<4764>*/
      w10_sq_ = kk_std_core_hnd_evv_insert(_x11216, _x11217, _ctx); /*std/core/hnd/evv<4763>*/
    }
    kk_unit_t __2 = kk_Unit;
    kk_evv_t _x11218 = kk_evv_dup(w10_sq_, _ctx); /*std/core/hnd/evv<4763>*/
    kk_evv_set(_x11218,kk_context());
    kk_box_t _x11219 = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), cont0, (cont0, kk_std_core_hnd_new_prompt_fun11220(x, _ctx), _ctx), _ctx); /*4762*/
    return kk_std_core_hnd_prompt(w00_sq_, w10_sq_, ev, m0, ret, _x11219, _ctx);
  }
  if (kk_std_core_hnd__is_Shallow(r, _ctx)) {
    kk_box_t x0 = r._cons.Shallow.result;
    kk_evv_drop(w1, _ctx);
    kk_evv_drop(w0, _ctx);
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    kk_box_t x1_10832 = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), cont0, (cont0, kk_std_core_hnd_new_prompt_fun11221(x0, _ctx), _ctx), _ctx); /*4762*/;
    if (kk_yielding(kk_context())) {
      kk_box_drop(x1_10832, _ctx);
      return kk_std_core_hnd_yield_extend(ret, _ctx);
    }
    {
      return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), ret, (ret, x1_10832, _ctx), _ctx);
    }
  }
  {
    kk_box_t x10 = r._cons.Finalize.result;
    kk_evv_t w01_sq_ = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<4763>*/;
    kk_evv_t w11_sq_;
    bool _match_11158;
    kk_evv_t _x11222 = kk_evv_dup(w01_sq_, _ctx); /*std/core/hnd/evv<4763>*/
    _match_11158 = kk_std_core_hnd_evv_eq(w0, _x11222, _ctx); /*bool*/
    if (_match_11158) {
      w11_sq_ = w1; /*std/core/hnd/evv<4763>*/
    }
    else {
      kk_evv_drop(w1, _ctx);
      kk_evv_t _x11223 = kk_evv_dup(w01_sq_, _ctx); /*std/core/hnd/evv<4763>*/
      kk_std_core_hnd__ev _x11224 = kk_std_core_hnd__ev_dup(ev, _ctx); /*std/core/hnd/ev<4764>*/
      w11_sq_ = kk_std_core_hnd_evv_insert(_x11223, _x11224, _ctx); /*std/core/hnd/evv<4763>*/
    }
    kk_unit_t __3 = kk_Unit;
    kk_evv_t _x11225 = kk_evv_dup(w11_sq_, _ctx); /*std/core/hnd/evv<4763>*/
    kk_evv_set(_x11225,kk_context());
    kk_box_t _x11226 = kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), cont0, (cont0, kk_std_core_hnd_new_prompt_fun11227(x10, m0, _ctx), _ctx), _ctx); /*4762*/
    return kk_std_core_hnd_prompt(w01_sq_, w11_sq_, ev, m0, ret, _x11226, _ctx);
  }
}

kk_box_t kk_std_core_hnd_prompt(kk_evv_t w0, kk_evv_t w1, kk_std_core_hnd__ev ev, kk_std_core_hnd__marker m0, kk_function_t ret, kk_box_t result, kk_context_t* _ctx) { /* forall<a,e,b,c> (w0 : evv<e>, w1 : evv<e>, ev : ev<b>, m : marker<e,c>, ret : (a) -> e c, result : a) -> e c */ 
  kk_unit_t __ = kk_Unit;
  kk_evv_t _x11206 = kk_evv_dup(w1, _ctx); /*std/core/hnd/evv<4763>*/
  kk_std_core_hnd_guard(_x11206, _ctx);
  kk_unit_t __0 = kk_Unit;
  kk_evv_t _x11207 = kk_evv_dup(w0, _ctx); /*std/core/hnd/evv<4763>*/
  kk_evv_set(_x11207,kk_context());
  kk_std_core_hnd__yld _match_11157 = kk_std_core_hnd_yield_prompt(m0, _ctx); /*std/core/hnd/yld<3968,3967,3969>*/;
  if (kk_std_core_hnd__is_Pure(_match_11157, _ctx)) {
    kk_evv_drop(w1, _ctx);
    kk_evv_drop(w0, _ctx);
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), ret, (ret, result, _ctx), _ctx);
  }
  if (kk_std_core_hnd__is_YieldingFinal(_match_11157, _ctx)) {
    kk_evv_drop(w1, _ctx);
    kk_evv_drop(w0, _ctx);
    kk_function_drop(ret, _ctx);
    kk_box_drop(result, _ctx);
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    return kk_box_any(kk_context());
  }
  if (kk_std_core_hnd__is_Yielding(_match_11157, _ctx)) {
    kk_box_drop(result, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_prompt_fun11208(ev, ret, w0, w1, m0, _ctx), _ctx);
  }
  {
    kk_function_t clause0 = _match_11157._cons.Yield.clause;
    kk_function_t cont0 = _match_11157._cons.Yield.cont;
    kk_box_drop(result, _ctx);
    return kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), clause0, (clause0, kk_std_core_hnd_new_prompt_fun11214(cont0, ev, ret, w0, w1, m0, _ctx), _ctx), _ctx);
  }
}

kk_box_t kk_std_core_hnd__hhandle(kk_std_core_hnd__htag tag, int32_t cfc0, kk_box_t h, kk_function_t ret, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e,e1,b,c> (tag : htag<b>, cfc : cfc, h : b<e,c>, ret : (a) -> e c, action : () -> e1 a) -> e c */ 
  kk_evv_t w0 = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<4861>*/;
  kk_std_core_hnd__marker m0;
  int32_t _x11229 = kk_std_core_hnd_fresh_marker_int(_ctx); /*int32*/
  m0 = kk_std_core_hnd__new_Marker(_x11229, _ctx); /*std/core/hnd/marker<4861,4864>*/
  kk_std_core_hnd__ev ev;
  kk_evv_t _x11230 = kk_evv_dup(w0, _ctx); /*std/core/hnd/evv<4861>*/
  ev = kk_std_core_hnd__new_Ev(kk_reuse_null, 0, tag, m0, h, cfc0, _x11230, _ctx); /*std/core/hnd/ev<4863>*/
  kk_evv_t w1;
  kk_evv_t _x11231 = kk_evv_dup(w0, _ctx); /*std/core/hnd/evv<4861>*/
  kk_std_core_hnd__ev _x11232 = kk_std_core_hnd__ev_dup(ev, _ctx); /*std/core/hnd/ev<4863>*/
  w1 = kk_std_core_hnd_evv_insert(_x11231, _x11232, _ctx); /*std/core/hnd/evv<4861>*/
  kk_unit_t __ = kk_Unit;
  kk_evv_t _x11233 = kk_evv_dup(w1, _ctx); /*std/core/hnd/evv<4861>*/
  kk_evv_set(_x11233,kk_context());
  kk_box_t _x11234 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx); /*4860*/
  return kk_std_core_hnd_prompt(w0, w1, ev, m0, ret, _x11234, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_mask_at1_fun11235__t {
  struct kk_function_s _base;
  kk_ssize_t i;
  bool behind;
};
static kk_box_t kk_std_core_hnd_mask_at1_fun11235(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_mask_at1_fun11235(kk_ssize_t i, bool behind, kk_context_t* _ctx) {
  struct kk_std_core_hnd_mask_at1_fun11235__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_mask_at1_fun11235__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_mask_at1_fun11235, kk_context());
  _self->i = i;
  _self->behind = behind;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_mask_at1_fun11235(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_mask_at1_fun11235__t* _self = kk_function_as(struct kk_std_core_hnd_mask_at1_fun11235__t*, _fself, _ctx);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  bool behind = _self->behind; /* bool */
  kk_drop_match(_self, {;;}, {}, _ctx)
  return kk_std_core_hnd_mask_at1(i, behind, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd_mask_at1(kk_ssize_t i, bool behind, kk_function_t action, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,e1> (i : ev-index, behind : bool, action : (a) -> e b, x : a) -> e1 b */ 
  kk_evv_t w0 = kk_std_core_hnd_evv_swap_delete(i, behind, _ctx); /*std/core/hnd/evv<_4869>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), action, (action, x, _ctx), _ctx); /*4975*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_mask_at1_fun11235(i, behind, _ctx), _ctx);
  }
  {
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__mask_at_fun11236__t {
  struct kk_function_s _base;
  kk_ssize_t i;
  bool behind;
};
static kk_box_t kk_std_core_hnd__mask_at_fun11236(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_mask_at_fun11236(kk_ssize_t i, bool behind, kk_context_t* _ctx) {
  struct kk_std_core_hnd__mask_at_fun11236__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__mask_at_fun11236__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__mask_at_fun11236, kk_context());
  _self->i = i;
  _self->behind = behind;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__mask_at_fun11236(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__mask_at_fun11236__t* _self = kk_function_as(struct kk_std_core_hnd__mask_at_fun11236__t*, _fself, _ctx);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  bool behind = _self->behind; /* bool */
  kk_drop_match(_self, {;;}, {}, _ctx)
  return kk_std_core_hnd_mask_at1(i, behind, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__mask_at(kk_ssize_t i, bool behind, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e,e1> (i : ev-index, behind : bool, action : () -> e a) -> e1 a */ 
  kk_evv_t w0 = kk_std_core_hnd_evv_swap_delete(i, behind, _ctx); /*std/core/hnd/evv<_4981>*/;
  kk_box_t x = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx); /*5070*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(x, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_mask_at_fun11236(i, behind, _ctx), _ctx);
  }
  {
    return x;
  }
}

kk_box_t kk_std_core_hnd__named_handle(kk_std_core_hnd__htag tag, int32_t cfc0, kk_box_t h, kk_function_t ret, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e,e1,b,c> (tag : htag<b>, cfc : cfc, h : b<e,c>, ret : (a) -> e c, action : (ev<b>) -> e1 a) -> e c */ 
  kk_std_core_hnd__marker m0;
  int32_t _x11238 = kk_std_core_hnd_fresh_marker_named_int(_ctx); /*int32*/
  m0 = kk_std_core_hnd__new_Marker(_x11238, _ctx); /*std/core/hnd/marker<5185,5188>*/
  kk_evv_t w0 = kk_std_core_hnd_evv_get(_ctx); /*std/core/hnd/evv<5185>*/;
  kk_std_core_hnd__ev ev;
  kk_evv_t _x11239 = kk_evv_dup(w0, _ctx); /*std/core/hnd/evv<5185>*/
  ev = kk_std_core_hnd__new_Ev(kk_reuse_null, 0, tag, m0, h, cfc0, _x11239, _ctx); /*std/core/hnd/ev<5187>*/
  kk_evv_t _x11240 = kk_evv_dup(w0, _ctx); /*std/core/hnd/evv<5185>*/
  kk_std_core_hnd__ev _x11241 = kk_std_core_hnd__ev_dup(ev, _ctx); /*std/core/hnd/ev<5187>*/
  kk_box_t _x11242 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__ev, kk_context_t*), action, (action, ev, _ctx), _ctx); /*5184*/
  return kk_std_core_hnd_prompt(_x11240, w0, _x11241, m0, ret, _x11242, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_open_at1_fun11243__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd_open_at1_fun11243(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_open_at1_fun11243(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd_open_at1_fun11243__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_open_at1_fun11243__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_open_at1_fun11243, kk_context());
  _self->i = i;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_open_at1_fun11243(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_open_at1_fun11243__t* _self = kk_function_as(struct kk_std_core_hnd_open_at1_fun11243__t*, _fself, _ctx);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd_open_at1(kk_ssize_t i, kk_function_t f, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,e1> (i : ev-index, f : (a) -> e b, x : a) -> e1 b */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5298>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx), _ctx); /*5296*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_open_at1_fun11243(i, _ctx), _ctx);
  }
  {
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__open_at0_fun11244__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__open_at0_fun11244(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open_at0_fun11244(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at0_fun11244__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open_at0_fun11244__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__open_at0_fun11244, kk_context());
  _self->i = i;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__open_at0_fun11244(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at0_fun11244__t* _self = kk_function_as(struct kk_std_core_hnd__open_at0_fun11244__t*, _fself, _ctx);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open_at0(kk_ssize_t i, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e,e1> (i : ev-index, f : () -> e a) -> e1 a */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5390>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), f, (f, _ctx), _ctx); /*5388*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open_at0_fun11244(i, _ctx), _ctx);
  }
  {
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__open_at1_fun11245__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__open_at1_fun11245(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open_at1_fun11245(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at1_fun11245__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open_at1_fun11245__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__open_at1_fun11245, kk_context());
  _self->i = i;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__open_at1_fun11245(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at1_fun11245__t* _self = kk_function_as(struct kk_std_core_hnd__open_at1_fun11245__t*, _fself, _ctx);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open_at1(kk_ssize_t i, kk_function_t f, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,e1> (i : ev-index, f : (a) -> e b, x : a) -> e1 b */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5497>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx), _ctx); /*5495*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open_at1_fun11245(i, _ctx), _ctx);
  }
  {
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__open_at2_fun11246__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__open_at2_fun11246(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open_at2_fun11246(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at2_fun11246__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open_at2_fun11246__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__open_at2_fun11246, kk_context());
  _self->i = i;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__open_at2_fun11246(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at2_fun11246__t* _self = kk_function_as(struct kk_std_core_hnd__open_at2_fun11246__t*, _fself, _ctx);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open_at2(kk_ssize_t i, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) { /* forall<a,b,c,e,e1> (i : ev-index, f : (a, b) -> e c, x1 : a, x2 : b) -> e1 c */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5619>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, _ctx), _ctx); /*5617*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open_at2_fun11246(i, _ctx), _ctx);
  }
  {
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__open_at3_fun11247__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__open_at3_fun11247(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open_at3_fun11247(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at3_fun11247__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open_at3_fun11247__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__open_at3_fun11247, kk_context());
  _self->i = i;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__open_at3_fun11247(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at3_fun11247__t* _self = kk_function_as(struct kk_std_core_hnd__open_at3_fun11247__t*, _fself, _ctx);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open_at3(kk_ssize_t i, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_context_t* _ctx) { /* forall<a,b,c,d,e,e1> (i : ev-index, f : (a, b, c) -> e d, x1 : a, x2 : b, x3 : c) -> e1 d */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5693>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, x3, _ctx), _ctx); /*5691*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open_at3_fun11247(i, _ctx), _ctx);
  }
  {
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__open_at4_fun11248__t {
  struct kk_function_s _base;
  kk_ssize_t i;
};
static kk_box_t kk_std_core_hnd__open_at4_fun11248(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open_at4_fun11248(kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at4_fun11248__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open_at4_fun11248__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__open_at4_fun11248, kk_context());
  _self->i = i;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__open_at4_fun11248(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open_at4_fun11248__t* _self = kk_function_as(struct kk_std_core_hnd__open_at4_fun11248__t*, _fself, _ctx);
  kk_ssize_t i = _self->i; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open_at4(kk_ssize_t i, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_box_t x4, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,e1> (i : ev-index, f : (a, b, c, d) -> e a1, x1 : a, x2 : b, x3 : c, x4 : d) -> e1 a1 */ 
  kk_evv_t w = kk_evv_swap_create1(i,kk_context()); /*std/core/hnd/evv<5773>*/;
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, x3, x4, _ctx), _ctx); /*5771*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open_at4_fun11248(i, _ctx), _ctx);
  }
  {
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd_open1_fun11250__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd_open1_fun11250(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_open1_fun11250(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd_open1_fun11250__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_open1_fun11250__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_open1_fun11250, kk_context());
  _self->indices = indices;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_open1_fun11250(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_open1_fun11250__t* _self = kk_function_as(struct kk_std_core_hnd_open1_fun11250__t*, _fself, _ctx);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd_open1(kk_vector_t indices, kk_function_t f, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,e1> (indices : vector<ev-index>, f : (a) -> e b, x : a) -> e1 b */ 
  kk_evv_t w;
  kk_vector_t _x11249 = kk_vector_dup(indices, _ctx); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x11249, _ctx); /*std/core/hnd/evv<5883>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx), _ctx); /*5881*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_open1_fun11250(indices, _ctx), _ctx);
  }
  {
    kk_vector_drop(indices, _ctx);
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__open0_fun11252__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd__open0_fun11252(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open0_fun11252(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open0_fun11252__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open0_fun11252__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__open0_fun11252, kk_context());
  _self->indices = indices;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__open0_fun11252(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open0_fun11252__t* _self = kk_function_as(struct kk_std_core_hnd__open0_fun11252__t*, _fself, _ctx);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open0(kk_vector_t indices, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e,e1> (indices : vector<ev-index>, f : () -> e a) -> e1 a */ 
  kk_evv_t w;
  kk_vector_t _x11251 = kk_vector_dup(indices, _ctx); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x11251, _ctx); /*std/core/hnd/evv<5975>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), f, (f, _ctx), _ctx); /*5973*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open0_fun11252(indices, _ctx), _ctx);
  }
  {
    kk_vector_drop(indices, _ctx);
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__open1_fun11254__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd__open1_fun11254(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open1_fun11254(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open1_fun11254__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open1_fun11254__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__open1_fun11254, kk_context());
  _self->indices = indices;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__open1_fun11254(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open1_fun11254__t* _self = kk_function_as(struct kk_std_core_hnd__open1_fun11254__t*, _fself, _ctx);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open1(kk_vector_t indices, kk_function_t f, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,e1> (indices : vector<ev-index>, f : (a) -> e b, x : a) -> e1 b */ 
  kk_evv_t w;
  kk_vector_t _x11253 = kk_vector_dup(indices, _ctx); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x11253, _ctx); /*std/core/hnd/evv<6082>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx), _ctx); /*6080*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open1_fun11254(indices, _ctx), _ctx);
  }
  {
    kk_vector_drop(indices, _ctx);
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__open2_fun11256__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd__open2_fun11256(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open2_fun11256(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open2_fun11256__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open2_fun11256__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__open2_fun11256, kk_context());
  _self->indices = indices;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__open2_fun11256(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open2_fun11256__t* _self = kk_function_as(struct kk_std_core_hnd__open2_fun11256__t*, _fself, _ctx);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open2(kk_vector_t indices, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) { /* forall<a,b,c,e,e1> (indices : vector<ev-index>, f : (a, b) -> e c, x1 : a, x2 : b) -> e1 c */ 
  kk_evv_t w;
  kk_vector_t _x11255 = kk_vector_dup(indices, _ctx); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x11255, _ctx); /*std/core/hnd/evv<6204>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, _ctx), _ctx); /*6202*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open2_fun11256(indices, _ctx), _ctx);
  }
  {
    kk_vector_drop(indices, _ctx);
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__open3_fun11258__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd__open3_fun11258(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open3_fun11258(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open3_fun11258__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open3_fun11258__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__open3_fun11258, kk_context());
  _self->indices = indices;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__open3_fun11258(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open3_fun11258__t* _self = kk_function_as(struct kk_std_core_hnd__open3_fun11258__t*, _fself, _ctx);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open3(kk_vector_t indices, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_context_t* _ctx) { /* forall<a,b,c,d,e,e1> (indices : vector<ev-index>, f : (a, b, c) -> e d, x1 : a, x2 : b, x3 : c) -> e1 d */ 
  kk_evv_t w;
  kk_vector_t _x11257 = kk_vector_dup(indices, _ctx); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x11257, _ctx); /*std/core/hnd/evv<6278>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, x3, _ctx), _ctx); /*6276*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open3_fun11258(indices, _ctx), _ctx);
  }
  {
    kk_vector_drop(indices, _ctx);
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd__open4_fun11260__t {
  struct kk_function_s _base;
  kk_vector_t indices;
};
static kk_box_t kk_std_core_hnd__open4_fun11260(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd__new_open4_fun11260(kk_vector_t indices, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open4_fun11260__t* _self = kk_function_alloc_as(struct kk_std_core_hnd__open4_fun11260__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd__open4_fun11260, kk_context());
  _self->indices = indices;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd__open4_fun11260(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd__open4_fun11260__t* _self = kk_function_as(struct kk_std_core_hnd__open4_fun11260__t*, _fself, _ctx);
  kk_vector_t indices = _self->indices; /* vector<std/core/hnd/ev-index> */
  kk_drop_match(_self, {kk_vector_dup(indices, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_open1(indices, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd__open4(kk_vector_t indices, kk_function_t f, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_box_t x4, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,e1> (indices : vector<ev-index>, f : (a, b, c, d) -> e a1, x1 : a, x2 : b, x3 : c, x4 : d) -> e1 a1 */ 
  kk_evv_t w;
  kk_vector_t _x11259 = kk_vector_dup(indices, _ctx); /*vector<std/core/hnd/ev-index>*/
  w = kk_std_core_hnd_evv_swap_create(_x11259, _ctx); /*std/core/hnd/evv<6358>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), f, (f, x1, x2, x3, x4, _ctx), _ctx); /*6356*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd__new_open4_fun11260(indices, _ctx), _ctx);
  }
  {
    kk_vector_drop(indices, _ctx);
    return y;
  }
}


// lift anonymous function
struct kk_std_core_hnd_yield_to_fun11267__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_hnd_yield_to_fun11267(kk_function_t _fself, kk_box_t _b_10960, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_yield_to_fun11267(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_hnd_yield_to_fun11267, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_hnd_yield_to_fun11267(kk_function_t _fself, kk_box_t _b_10960, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_function_t _x11268 = kk_function_unbox(_b_10960, _ctx); /*() -> 6490 10961*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), _x11268, (_x11268, _ctx), _ctx);
}

kk_box_t kk_std_core_hnd_yield_to(kk_std_core_hnd__marker m0, kk_function_t clause0, kk_context_t* _ctx) { /* forall<a,e,b> (m : marker<e,b>, clause : ((resume-result<a,b>) -> e b) -> e b) -> e a */ 
  kk_function_t g = kk_std_core_hnd_yield_to_prim(m0, clause0, _ctx); /*() -> 6489*/;
  kk_function_drop(g, _ctx);
  return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_yield_to_fun11267(_ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control_raw0_fun11269__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw0_fun11269(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__550__16, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw0_fun11269(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw0_fun11269__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw0_fun11269__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control_raw0_fun11269, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_control_raw0_fun11270__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw0_fun11270(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw0_fun11270(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw0_fun11270__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw0_fun11270__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control_raw0_fun11270, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_control_raw0_fun11270(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw0_fun11270__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw0_fun11270__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (std/core/hnd/resume-context<6530,6531,6532,6534>) -> 6531 6534 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_std_core_hnd__resume_context _x11271 = kk_std_core_hnd__new_Resume_context(k0, _ctx); /*std/core/hnd/resume-context<89,90,91,92>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_context, kk_context_t*), op, (op, _x11271, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control_raw0_fun11269(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__550__16, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw0_fun11269__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw0_fun11269__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (std/core/hnd/resume-context<6530,6531,6532,6534>) -> 6531 6534 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__550__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control_raw0_fun11270(op, _ctx), _ctx);
}

kk_std_core_hnd__clause0 kk_std_core_hnd_clause_control_raw0(kk_function_t op, kk_context_t* _ctx) { /* forall<a,e,e1,b,c> (op : (resume-context<a,e,e1,c>) -> e c) -> clause0<a,b,e,c> */ 
  return kk_std_core_hnd__new_Clause0(kk_std_core_hnd_new_clause_control_raw0_fun11269(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control_raw1_fun11272__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw1_fun11272(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__487__16, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw1_fun11272(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw1_fun11272__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw1_fun11272__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control_raw1_fun11272, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_control_raw1_fun11273__t {
  struct kk_function_s _base;
  kk_function_t op;
  kk_box_t x;
};
static kk_box_t kk_std_core_hnd_clause_control_raw1_fun11273(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw1_fun11273(kk_function_t op, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw1_fun11273__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw1_fun11273__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control_raw1_fun11273, kk_context());
  _self->op = op;
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_control_raw1_fun11273(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw1_fun11273__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw1_fun11273__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (x : 6578, r : std/core/hnd/resume-context<6579,6580,6581,6583>) -> 6580 6583 */
  kk_box_t x = _self->x; /* 6578 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);kk_box_dup(x, _ctx);}, {}, _ctx)
  kk_std_core_hnd__resume_context _x11274 = kk_std_core_hnd__new_Resume_context(k0, _ctx); /*std/core/hnd/resume-context<89,90,91,92>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_std_core_hnd__resume_context, kk_context_t*), op, (op, x, _x11274, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control_raw1_fun11272(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__487__16, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw1_fun11272__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw1_fun11272__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (x : 6578, r : std/core/hnd/resume-context<6579,6580,6581,6583>) -> 6580 6583 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__487__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control_raw1_fun11273(op, x, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_control_raw1(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,e,e1,c,d> (op : (x : a, r : resume-context<b,e,e1,d>) -> e d) -> clause1<a,b,c,e,d> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_control_raw1_fun11272(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control_raw2_fun11275__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw2_fun11275(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__601__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw2_fun11275(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw2_fun11275__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw2_fun11275__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control_raw2_fun11275, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_control_raw2_fun11276__t {
  struct kk_function_s _base;
  kk_function_t op;
  kk_box_t x1;
  kk_box_t x2;
};
static kk_box_t kk_std_core_hnd_clause_control_raw2_fun11276(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw2_fun11276(kk_function_t op, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw2_fun11276__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw2_fun11276__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control_raw2_fun11276, kk_context());
  _self->op = op;
  _self->x1 = x1;
  _self->x2 = x2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_control_raw2_fun11276(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw2_fun11276__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw2_fun11276__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (x1 : 6632, x2 : 6633, r : std/core/hnd/resume-context<6634,6635,6636,6638>) -> 6635 6638 */
  kk_box_t x1 = _self->x1; /* 6632 */
  kk_box_t x2 = _self->x2; /* 6633 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);kk_box_dup(x1, _ctx);kk_box_dup(x2, _ctx);}, {}, _ctx)
  kk_std_core_hnd__resume_context _x11277 = kk_std_core_hnd__new_Resume_context(k0, _ctx); /*std/core/hnd/resume-context<89,90,91,92>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_std_core_hnd__resume_context, kk_context_t*), op, (op, x1, x2, _x11277, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control_raw2_fun11275(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__601__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw2_fun11275__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw2_fun11275__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (x1 : 6632, x2 : 6633, r : std/core/hnd/resume-context<6634,6635,6636,6638>) -> 6635 6638 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__601__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control_raw2_fun11276(op, x1, x2, _ctx), _ctx);
}

kk_std_core_hnd__clause2 kk_std_core_hnd_clause_control_raw2(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,e,e1,d,a1> (op : (x1 : a, x2 : b, r : resume-context<c,e,e1,a1>) -> e a1) -> clause2<a,b,c,d,e,a1> */ 
  return kk_std_core_hnd__new_Clause2(kk_std_core_hnd_new_clause_control_raw2_fun11275(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control_raw3_fun11278__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw3_fun11278(kk_function_t _fself, kk_std_core_hnd__marker _b_10965, kk_std_core_hnd__ev _b_10966, kk_box_t _b_10967, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw3_fun11278(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw3_fun11278__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw3_fun11278__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control_raw3_fun11278, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_control_raw3_fun11279__t {
  struct kk_function_s _base;
  kk_box_t _b_10967;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control_raw3_fun11279(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control_raw3_fun11279(kk_box_t _b_10967, kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw3_fun11279__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control_raw3_fun11279__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control_raw3_fun11279, kk_context());
  _self->_b_10967 = _b_10967;
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_control_raw3_fun11279(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw3_fun11279__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw3_fun11279__t*, _fself, _ctx);
  kk_box_t _b_10967 = _self->_b_10967; /* 51 */
  kk_function_t op = _self->op; /* (x1 : 6873, x2 : 6874, x3 : 6875, r : std/core/hnd/resume-context<6876,6877,6878,6880>) -> 6877 6880 */
  kk_drop_match(_self, {kk_box_dup(_b_10967, _ctx);kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_box_t _x11280;
  kk_std_core_types__tuple3_ _match_11140;
  kk_box_t _x11281 = kk_box_dup(_b_10967, _ctx); /*51*/
  _match_11140 = kk_std_core_types__tuple3__unbox(_x11281, KK_OWNED, _ctx); /*(6873, 6874, 6875)*/
  {
    kk_box_t _x = _match_11140.fst;
    kk_box_dup(_x, _ctx);
    kk_std_core_types__tuple3__drop(_match_11140, _ctx);
    _x11280 = _x; /*6873*/
  }
  kk_box_t _x11282;
  kk_std_core_types__tuple3_ _match_11139;
  kk_box_t _x11283 = kk_box_dup(_b_10967, _ctx); /*51*/
  _match_11139 = kk_std_core_types__tuple3__unbox(_x11283, KK_OWNED, _ctx); /*(6873, 6874, 6875)*/
  {
    kk_box_t _x0 = _match_11139.snd;
    kk_box_dup(_x0, _ctx);
    kk_std_core_types__tuple3__drop(_match_11139, _ctx);
    _x11282 = _x0; /*6874*/
  }
  kk_box_t _x11284;
  kk_std_core_types__tuple3_ _match_11138 = kk_std_core_types__tuple3__unbox(_b_10967, KK_OWNED, _ctx); /*(6873, 6874, 6875)*/;
  {
    kk_box_t _x1 = _match_11138.thd;
    kk_box_dup(_x1, _ctx);
    kk_std_core_types__tuple3__drop(_match_11138, _ctx);
    _x11284 = _x1; /*6875*/
  }
  kk_std_core_hnd__resume_context _x11285 = kk_std_core_hnd__new_Resume_context(k0, _ctx); /*std/core/hnd/resume-context<89,90,91,92>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_std_core_hnd__resume_context, kk_context_t*), op, (op, _x11280, _x11282, _x11284, _x11285, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control_raw3_fun11278(kk_function_t _fself, kk_std_core_hnd__marker _b_10965, kk_std_core_hnd__ev _b_10966, kk_box_t _b_10967, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control_raw3_fun11278__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control_raw3_fun11278__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (x1 : 6873, x2 : 6874, x3 : 6875, r : std/core/hnd/resume-context<6876,6877,6878,6880>) -> 6877 6880 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(_b_10966, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to(_b_10965, kk_std_core_hnd_new_clause_control_raw3_fun11279(_b_10967, op, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_control_raw3(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,e,e1,a1,b1> (op : (x1 : a, x2 : b, x3 : c, r : resume-context<d,e,e1,b1>) -> e b1) -> clause1<(a, b, c),d,a1,e,b1> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_control_raw3_fun11278(op, _ctx), _ctx);
}

kk_box_t kk_std_core_hnd_protect_check(kk_ref_t resumed, kk_function_t k0, kk_box_t res, kk_context_t* _ctx) { /* forall<a,e,b> (resumed : ref<global,bool>, k : (resume-result<a,b>) -> e b, res : b) -> e b */ 
  bool did_resume;
  kk_box_t _x11287 = kk_ref_get(resumed,kk_context()); /*190*/
  did_resume = kk_bool_unbox(_x11287); /*bool*/
  if (did_resume) {
    kk_function_drop(k0, _ctx);
    return res;
  }
  {
    kk_std_core_hnd__resume_result _x11288 = kk_std_core_hnd__new_Finalize(res, _ctx); /*std/core/hnd/resume-result<80,81>*/
    return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), k0, (k0, _x11288, _ctx), _ctx);
  }
}


// lift anonymous function
struct kk_std_core_hnd_protect_fun11290__t {
  struct kk_function_s _base;
  kk_function_t k0;
  kk_ref_t resumed;
};
static kk_box_t kk_std_core_hnd_protect_fun11290(kk_function_t _fself, kk_box_t ret, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_protect_fun11290(kk_function_t k0, kk_ref_t resumed, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun11290__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_protect_fun11290__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_protect_fun11290, kk_context());
  _self->k0 = k0;
  _self->resumed = resumed;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_protect_fun11290(kk_function_t _fself, kk_box_t ret, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun11290__t* _self = kk_function_as(struct kk_std_core_hnd_protect_fun11290__t*, _fself, _ctx);
  kk_function_t k0 = _self->k0; /* (std/core/hnd/resume-result<7088,7090>) -> 7089 7090 */
  kk_ref_t resumed = _self->resumed; /* ref<global,bool> */
  kk_drop_match(_self, {kk_function_dup(k0, _ctx);kk_ref_dup(resumed, _ctx);}, {}, _ctx)
  kk_unit_t __ = kk_Unit;
  kk_unit_t _brw_11137 = kk_Unit;
  kk_ref_set_borrow(resumed,(kk_bool_box(true)),kk_context());
  kk_ref_drop(resumed, _ctx);
  _brw_11137;
  kk_std_core_hnd__resume_result _x11291 = kk_std_core_hnd__new_Deep(ret, _ctx); /*std/core/hnd/resume-result<80,81>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), k0, (k0, _x11291, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_protect_fun11292__t {
  struct kk_function_s _base;
  kk_function_t k0;
  kk_ref_t resumed;
};
static kk_box_t kk_std_core_hnd_protect_fun11292(kk_function_t _fself, kk_box_t xres, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_protect_fun11292(kk_function_t k0, kk_ref_t resumed, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun11292__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_protect_fun11292__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_protect_fun11292, kk_context());
  _self->k0 = k0;
  _self->resumed = resumed;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_protect_fun11292(kk_function_t _fself, kk_box_t xres, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun11292__t* _self = kk_function_as(struct kk_std_core_hnd_protect_fun11292__t*, _fself, _ctx);
  kk_function_t k0 = _self->k0; /* (std/core/hnd/resume-result<7088,7090>) -> 7089 7090 */
  kk_ref_t resumed = _self->resumed; /* ref<global,bool> */
  kk_drop_match(_self, {kk_function_dup(k0, _ctx);kk_ref_dup(resumed, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_protect_check(resumed, k0, xres, _ctx);
}

kk_box_t kk_std_core_hnd_protect(kk_box_t x, kk_function_t clause0, kk_function_t k0, kk_context_t* _ctx) { /* forall<a,b,e,c> (x : a, clause : (x : a, k : (b) -> e c) -> e c, k : (resume-result<b,c>) -> e c) -> e c */ 
  kk_ref_t resumed = kk_ref_alloc((kk_bool_box(false)),kk_context()); /*ref<global,bool>*/;
  kk_box_t res;
  kk_function_t _x11289;
  kk_function_dup(k0, _ctx);
  kk_ref_dup(resumed, _ctx);
  _x11289 = kk_std_core_hnd_new_protect_fun11290(k0, resumed, _ctx); /*(ret : 7088) -> 7089 7090*/
  res = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_function_t, kk_context_t*), clause0, (clause0, x, _x11289, _ctx), _ctx); /*7090*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_protect_fun11292(k0, resumed, _ctx), _ctx);
  }
  {
    return kk_std_core_hnd_protect_check(resumed, k0, res, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_hnd_protect_fun11294__t_1 {
  struct kk_function_s _base;
  kk_function_t k0;
  kk_ref_t resumed;
};
static kk_box_t kk_std_core_hnd_protect_fun11294_1(kk_function_t _fself, kk_box_t ret, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_protect_fun11294_1(kk_function_t k0, kk_ref_t resumed, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun11294__t_1* _self = kk_function_alloc_as(struct kk_std_core_hnd_protect_fun11294__t_1, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_protect_fun11294_1, kk_context());
  _self->k0 = k0;
  _self->resumed = resumed;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_protect_fun11294_1(kk_function_t _fself, kk_box_t ret, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun11294__t_1* _self = kk_function_as(struct kk_std_core_hnd_protect_fun11294__t_1*, _fself, _ctx);
  kk_function_t k0 = _self->k0; /* (std/core/hnd/resume-result<7181,7183>) -> 7182 7183 */
  kk_ref_t resumed = _self->resumed; /* ref<global,bool> */
  kk_drop_match(_self, {kk_function_dup(k0, _ctx);kk_ref_dup(resumed, _ctx);}, {}, _ctx)
  kk_unit_t __ = kk_Unit;
  kk_unit_t _brw_11135 = kk_Unit;
  kk_ref_set_borrow(resumed,(kk_bool_box(true)),kk_context());
  kk_ref_drop(resumed, _ctx);
  _brw_11135;
  kk_std_core_hnd__resume_result _x11295 = kk_std_core_hnd__new_Deep(ret, _ctx); /*std/core/hnd/resume-result<80,81>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), k0, (k0, _x11295, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_protect_fun11296__t_1 {
  struct kk_function_s _base;
  kk_function_t k0;
  kk_ref_t resumed;
};
static kk_box_t kk_std_core_hnd_protect_fun11296_1(kk_function_t _fself, kk_box_t xres, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_protect_fun11296_1(kk_function_t k0, kk_ref_t resumed, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun11296__t_1* _self = kk_function_alloc_as(struct kk_std_core_hnd_protect_fun11296__t_1, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_protect_fun11296_1, kk_context());
  _self->k0 = k0;
  _self->resumed = resumed;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_protect_fun11296_1(kk_function_t _fself, kk_box_t xres, kk_context_t* _ctx) {
  struct kk_std_core_hnd_protect_fun11296__t_1* _self = kk_function_as(struct kk_std_core_hnd_protect_fun11296__t_1*, _fself, _ctx);
  kk_function_t k0 = _self->k0; /* (std/core/hnd/resume-result<7181,7183>) -> 7182 7183 */
  kk_ref_t resumed = _self->resumed; /* ref<global,bool> */
  kk_drop_match(_self, {kk_function_dup(k0, _ctx);kk_ref_dup(resumed, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_protect_check(resumed, k0, xres, _ctx);
}

kk_box_t kk_std_core_hnd_protect_1(kk_box_t x1, kk_box_t x2, kk_function_t clause0, kk_function_t k0, kk_context_t* _ctx) { /* forall<a,b,c,e,d> (x1 : a, x2 : b, clause : (x : a, x : b, k : (c) -> e d) -> e d, k : (resume-result<c,d>) -> e d) -> e d */ 
  kk_ref_t resumed = kk_ref_alloc((kk_bool_box(false)),kk_context()); /*ref<global,bool>*/;
  kk_box_t res;
  kk_function_t _x11293;
  kk_function_dup(k0, _ctx);
  kk_ref_dup(resumed, _ctx);
  _x11293 = kk_std_core_hnd_new_protect_fun11294_1(k0, resumed, _ctx); /*(ret : 7181) -> 7182 7183*/
  res = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_function_t, kk_context_t*), clause0, (clause0, x1, x2, _x11293, _ctx), _ctx); /*7183*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_protect_fun11296_1(k0, resumed, _ctx), _ctx);
  }
  {
    return kk_std_core_hnd_protect_check(resumed, k0, res, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_hnd_clause_control0_fun11297__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control0_fun11297(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__558__16, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control0_fun11297(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun11297__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control0_fun11297__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control0_fun11297, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_control0_fun11298__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control0_fun11298(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control0_fun11298(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun11298__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control0_fun11298__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control0_fun11298, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_control0_fun11299__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control0_fun11299(kk_function_t _fself, kk_box_t _b_10989, kk_function_t _b_10990, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control0_fun11299(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun11299__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control0_fun11299__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control0_fun11299, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_control0_fun11299(kk_function_t _fself, kk_box_t _b_10989, kk_function_t _b_10990, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun11299__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control0_fun11299__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* ((7284) -> 7285 7287) -> 7285 7287 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_box_drop(_b_10989, _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_function_t, kk_context_t*), op, (op, _b_10990, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control0_fun11298(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun11298__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control0_fun11298__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* ((7284) -> 7285 7287) -> 7285 7287 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_protect(kk_unit_box(kk_Unit), kk_std_core_hnd_new_clause_control0_fun11299(op, _ctx), k0, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control0_fun11297(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__558__16, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control0_fun11297__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control0_fun11297__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* ((7284) -> 7285 7287) -> 7285 7287 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__558__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control0_fun11298(op, _ctx), _ctx);
}

kk_std_core_hnd__clause0 kk_std_core_hnd_clause_control0(kk_function_t op, kk_context_t* _ctx) { /* forall<a,e,b,c> (op : ((a) -> e c) -> e c) -> clause0<a,b,e,c> */ 
  return kk_std_core_hnd__new_Clause0(kk_std_core_hnd_new_clause_control0_fun11297(op, _ctx), _ctx);
}
extern kk_box_t kk_std_core_hnd_clause_control1_fun11301(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control1_fun11301__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control1_fun11301__t*, _fself, _ctx);
  kk_function_t clause0 = _self->clause0; /* (x : 7357, k : (7358) -> 7359 7361) -> 7359 7361 */
  kk_box_t x = _self->x; /* 7357 */
  kk_drop_match(_self, {kk_function_dup(clause0, _ctx);kk_box_dup(x, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_protect(x, clause0, k0, _ctx);
}
extern kk_box_t kk_std_core_hnd_clause_control1_fun11300(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__516__16, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control1_fun11300__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control1_fun11300__t*, _fself, _ctx);
  kk_function_t clause0 = _self->clause0; /* (x : 7357, k : (7358) -> 7359 7361) -> 7359 7361 */
  kk_drop_match(_self, {kk_function_dup(clause0, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__516__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control1_fun11301(clause0, x, _ctx), _ctx);
}
extern kk_box_t kk_std_core_hnd_clause_control2_fun11303(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control2_fun11303__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control2_fun11303__t*, _fself, _ctx);
  kk_function_t clause0 = _self->clause0; /* (x1 : 7440, x2 : 7441, k : (7442) -> 7443 7445) -> 7443 7445 */
  kk_box_t x1 = _self->x1; /* 7440 */
  kk_box_t x2 = _self->x2; /* 7441 */
  kk_drop_match(_self, {kk_function_dup(clause0, _ctx);kk_box_dup(x1, _ctx);kk_box_dup(x2, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_protect_1(x1, x2, clause0, k0, _ctx);
}
extern kk_box_t kk_std_core_hnd_clause_control2_fun11302(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__597__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control2_fun11302__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control2_fun11302__t*, _fself, _ctx);
  kk_function_t clause0 = _self->clause0; /* (x1 : 7440, x2 : 7441, k : (7442) -> 7443 7445) -> 7443 7445 */
  kk_drop_match(_self, {kk_function_dup(clause0, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__597__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to(m0, kk_std_core_hnd_new_clause_control2_fun11303(clause0, x1, x2, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control3_fun11304__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control3_fun11304(kk_function_t _fself, kk_std_core_hnd__marker _b_11002, kk_std_core_hnd__ev _b_11003, kk_box_t _b_11004, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control3_fun11304(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control3_fun11304__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control3_fun11304__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control3_fun11304, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_control3_fun11305__t {
  struct kk_function_s _base;
  kk_box_t _b_11004;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control3_fun11305(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control3_fun11305(kk_box_t _b_11004, kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control3_fun11305__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control3_fun11305__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control3_fun11305, kk_context());
  _self->_b_11004 = _b_11004;
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_control3_fun11306__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control3_fun11306(kk_function_t _fself, kk_box_t _b_10999, kk_function_t _b_11000, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control3_fun11306(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control3_fun11306__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control3_fun11306__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control3_fun11306, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_control3_fun11306(kk_function_t _fself, kk_box_t _b_10999, kk_function_t _b_11000, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control3_fun11306__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control3_fun11306__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (x1 : 7676, x2 : 7677, x3 : 7678, k : (7679) -> 7680 7682) -> 7680 7682 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_box_t _x11307;
  kk_std_core_types__tuple3_ _match_11133;
  kk_box_t _x11308 = kk_box_dup(_b_10999, _ctx); /*7087*/
  _match_11133 = kk_std_core_types__tuple3__unbox(_x11308, KK_OWNED, _ctx); /*(7676, 7677, 7678)*/
  {
    kk_box_t _x = _match_11133.fst;
    kk_box_dup(_x, _ctx);
    kk_std_core_types__tuple3__drop(_match_11133, _ctx);
    _x11307 = _x; /*7676*/
  }
  kk_box_t _x11309;
  kk_std_core_types__tuple3_ _match_11132;
  kk_box_t _x11310 = kk_box_dup(_b_10999, _ctx); /*7087*/
  _match_11132 = kk_std_core_types__tuple3__unbox(_x11310, KK_OWNED, _ctx); /*(7676, 7677, 7678)*/
  {
    kk_box_t _x0 = _match_11132.snd;
    kk_box_dup(_x0, _ctx);
    kk_std_core_types__tuple3__drop(_match_11132, _ctx);
    _x11309 = _x0; /*7677*/
  }
  kk_box_t _x11311;
  kk_std_core_types__tuple3_ _match_11131 = kk_std_core_types__tuple3__unbox(_b_10999, KK_OWNED, _ctx); /*(7676, 7677, 7678)*/;
  {
    kk_box_t _x1 = _match_11131.thd;
    kk_box_dup(_x1, _ctx);
    kk_std_core_types__tuple3__drop(_match_11131, _ctx);
    _x11311 = _x1; /*7678*/
  }
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_function_t, kk_context_t*), op, (op, _x11307, _x11309, _x11311, _b_11000, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control3_fun11305(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control3_fun11305__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control3_fun11305__t*, _fself, _ctx);
  kk_box_t _b_11004 = _self->_b_11004; /* 51 */
  kk_function_t op = _self->op; /* (x1 : 7676, x2 : 7677, x3 : 7678, k : (7679) -> 7680 7682) -> 7680 7682 */
  kk_drop_match(_self, {kk_box_dup(_b_11004, _ctx);kk_function_dup(op, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_protect(_b_11004, kk_std_core_hnd_new_clause_control3_fun11306(op, _ctx), k0, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control3_fun11304(kk_function_t _fself, kk_std_core_hnd__marker _b_11002, kk_std_core_hnd__ev _b_11003, kk_box_t _b_11004, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control3_fun11304__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control3_fun11304__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (x1 : 7676, x2 : 7677, x3 : 7678, k : (7679) -> 7680 7682) -> 7680 7682 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(_b_11003, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to(_b_11002, kk_std_core_hnd_new_clause_control3_fun11305(_b_11004, op, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_control3(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1,b1> (op : (x1 : a, x2 : b, x3 : c, k : (d) -> e b1) -> e b1) -> clause1<(a, b, c),d,a1,e,b1> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_control3_fun11304(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_control4_fun11312__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control4_fun11312(kk_function_t _fself, kk_std_core_hnd__marker _b_11020, kk_std_core_hnd__ev _b_11021, kk_box_t _b_11022, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control4_fun11312(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control4_fun11312__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control4_fun11312__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control4_fun11312, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_control4_fun11313__t {
  struct kk_function_s _base;
  kk_box_t _b_11022;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control4_fun11313(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control4_fun11313(kk_box_t _b_11022, kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control4_fun11313__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control4_fun11313__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control4_fun11313, kk_context());
  _self->_b_11022 = _b_11022;
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_control4_fun11314__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_control4_fun11314(kk_function_t _fself, kk_box_t _b_11017, kk_function_t _b_11018, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_control4_fun11314(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control4_fun11314__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_control4_fun11314__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_control4_fun11314, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_control4_fun11314(kk_function_t _fself, kk_box_t _b_11017, kk_function_t _b_11018, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control4_fun11314__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control4_fun11314__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (x1 : 7983, x2 : 7984, x3 : 7985, x4 : 7986, k : (7987) -> 7988 7990) -> 7988 7990 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_std_core_types__tuple4_ x0_11030 = kk_std_core_types__tuple4__unbox(_b_11017, KK_OWNED, _ctx); /*(7983, 7984, 7985, 7986)*/;
  kk_box_t _x11315;
  {
    struct kk_std_core_types__Tuple4_* _con11316 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x0_11030, _ctx);
    kk_box_t _x = _con11316->fst;
    kk_box_dup(_x, _ctx);
    _x11315 = _x; /*7983*/
  }
  kk_box_t _x11317;
  {
    struct kk_std_core_types__Tuple4_* _con11318 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x0_11030, _ctx);
    kk_box_t _x0 = _con11318->snd;
    kk_box_dup(_x0, _ctx);
    _x11317 = _x0; /*7984*/
  }
  kk_box_t _x11319;
  {
    struct kk_std_core_types__Tuple4_* _con11320 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x0_11030, _ctx);
    kk_box_t _x1 = _con11320->thd;
    kk_box_dup(_x1, _ctx);
    _x11319 = _x1; /*7985*/
  }
  kk_box_t _x11321;
  {
    struct kk_std_core_types__Tuple4_* _con11322 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x0_11030, _ctx);
    kk_box_t _pat02 = _con11322->fst;
    kk_box_t _pat12 = _con11322->snd;
    kk_box_t _pat22 = _con11322->thd;
    kk_box_t _x2 = _con11322->field4;
    if kk_likely(kk_datatype_ptr_is_unique(x0_11030, _ctx)) {
      kk_box_drop(_pat22, _ctx);
      kk_box_drop(_pat12, _ctx);
      kk_box_drop(_pat02, _ctx);
      kk_datatype_ptr_free(x0_11030, _ctx);
    }
    else {
      kk_box_dup(_x2, _ctx);
      kk_datatype_ptr_decref(x0_11030, _ctx);
    }
    _x11321 = _x2; /*7986*/
  }
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_function_t, kk_context_t*), op, (op, _x11315, _x11317, _x11319, _x11321, _b_11018, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control4_fun11313(kk_function_t _fself, kk_function_t k0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control4_fun11313__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control4_fun11313__t*, _fself, _ctx);
  kk_box_t _b_11022 = _self->_b_11022; /* 51 */
  kk_function_t op = _self->op; /* (x1 : 7983, x2 : 7984, x3 : 7985, x4 : 7986, k : (7987) -> 7988 7990) -> 7988 7990 */
  kk_drop_match(_self, {kk_box_dup(_b_11022, _ctx);kk_function_dup(op, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_protect(_b_11022, kk_std_core_hnd_new_clause_control4_fun11314(op, _ctx), k0, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_control4_fun11312(kk_function_t _fself, kk_std_core_hnd__marker _b_11020, kk_std_core_hnd__ev _b_11021, kk_box_t _b_11022, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_control4_fun11312__t* _self = kk_function_as(struct kk_std_core_hnd_clause_control4_fun11312__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (x1 : 7983, x2 : 7984, x3 : 7985, x4 : 7986, k : (7987) -> 7988 7990) -> 7988 7990 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(_b_11021, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to(_b_11020, kk_std_core_hnd_new_clause_control4_fun11313(_b_11022, op, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_control4(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,b1,c1> (op : (x1 : a, x2 : b, x3 : c, x4 : d, k : (a1) -> e c1) -> e c1) -> clause1<(a, b, c, d),a1,b1,e,c1> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_control4_fun11312(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_never0_fun11323__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never0_fun11323(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__571__16, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never0_fun11323(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never0_fun11323__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never0_fun11323__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_never0_fun11323, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_never0_fun11324__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never0_fun11324(kk_function_t _fself, kk_function_t ___wildcard__571__43, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never0_fun11324(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never0_fun11324__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never0_fun11324__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_never0_fun11324, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_never0_fun11324(kk_function_t _fself, kk_function_t ___wildcard__571__43, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never0_fun11324__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never0_fun11324__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* () -> 8021 8023 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_function_drop(___wildcard__571__43, _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), op, (op, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_never0_fun11323(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__571__16, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never0_fun11323__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never0_fun11323__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* () -> 8021 8023 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__571__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_hnd_new_clause_never0_fun11324(op, _ctx), _ctx);
}

kk_std_core_hnd__clause0 kk_std_core_hnd_clause_never0(kk_function_t op, kk_context_t* _ctx) { /* forall<a,e,b,c> (op : () -> e c) -> clause0<a,b,e,c> */ 
  return kk_std_core_hnd__new_Clause0(kk_std_core_hnd_new_clause_never0_fun11323(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_never1_fun11325__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never1_fun11325(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never1_fun11325(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never1_fun11325__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never1_fun11325__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_never1_fun11325, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_never1_fun11326__t {
  struct kk_function_s _base;
  kk_function_t op;
  kk_box_t x;
};
static kk_box_t kk_std_core_hnd_clause_never1_fun11326(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never1_fun11326(kk_function_t op, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never1_fun11326__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never1_fun11326__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_never1_fun11326, kk_context());
  _self->op = op;
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_never1_fun11326(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never1_fun11326__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never1_fun11326__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (8058) -> 8060 8062 */
  kk_box_t x = _self->x; /* 8058 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);kk_box_dup(x, _ctx);}, {}, _ctx)
  kk_function_drop(___wildcard__525__45, _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), op, (op, x, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_never1_fun11325(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never1_fun11325__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never1_fun11325__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (8058) -> 8060 8062 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__525__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_hnd_new_clause_never1_fun11326(op, x, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_never1(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,e,c,d> (op : (a) -> e d) -> clause1<a,b,c,e,d> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_never1_fun11325(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_never2_fun11327__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never2_fun11327(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__615__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never2_fun11327(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never2_fun11327__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never2_fun11327__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_never2_fun11327, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_never2_fun11328__t {
  struct kk_function_s _base;
  kk_function_t op;
  kk_box_t x1;
  kk_box_t x2;
};
static kk_box_t kk_std_core_hnd_clause_never2_fun11328(kk_function_t _fself, kk_function_t ___wildcard__615__49, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never2_fun11328(kk_function_t op, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never2_fun11328__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never2_fun11328__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_never2_fun11328, kk_context());
  _self->op = op;
  _self->x1 = x1;
  _self->x2 = x2;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_never2_fun11328(kk_function_t _fself, kk_function_t ___wildcard__615__49, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never2_fun11328__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never2_fun11328__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (8102, 8103) -> 8105 8107 */
  kk_box_t x1 = _self->x1; /* 8102 */
  kk_box_t x2 = _self->x2; /* 8103 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);kk_box_dup(x1, _ctx);kk_box_dup(x2, _ctx);}, {}, _ctx)
  kk_function_drop(___wildcard__615__49, _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, x1, x2, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_never2_fun11327(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__615__16, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never2_fun11327__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never2_fun11327__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (8102, 8103) -> 8105 8107 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__615__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_hnd_new_clause_never2_fun11328(op, x1, x2, _ctx), _ctx);
}

kk_std_core_hnd__clause2 kk_std_core_hnd_clause_never2(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,e,d,a1> (op : (a, b) -> e a1) -> clause2<a,b,c,d,e,a1> */ 
  return kk_std_core_hnd__new_Clause2(kk_std_core_hnd_new_clause_never2_fun11327(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_never3_fun11329__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never3_fun11329(kk_function_t _fself, kk_std_core_hnd__marker _b_11033, kk_std_core_hnd__ev _b_11034, kk_box_t _b_11035, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never3_fun11329(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never3_fun11329__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never3_fun11329__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_never3_fun11329, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_never3_fun11330__t {
  struct kk_function_s _base;
  kk_box_t _b_11035;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never3_fun11330(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never3_fun11330(kk_box_t _b_11035, kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never3_fun11330__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never3_fun11330__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_never3_fun11330, kk_context());
  _self->_b_11035 = _b_11035;
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_never3_fun11330(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never3_fun11330__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never3_fun11330__t*, _fself, _ctx);
  kk_box_t _b_11035 = _self->_b_11035; /* 51 */
  kk_function_t op = _self->op; /* (8337, 8338, 8339) -> 8341 8343 */
  kk_drop_match(_self, {kk_box_dup(_b_11035, _ctx);kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_function_drop(___wildcard__525__45, _ctx);
  kk_box_t _x11331;
  kk_std_core_types__tuple3_ _match_11130;
  kk_box_t _x11332 = kk_box_dup(_b_11035, _ctx); /*51*/
  _match_11130 = kk_std_core_types__tuple3__unbox(_x11332, KK_OWNED, _ctx); /*(8337, 8338, 8339)*/
  {
    kk_box_t _x = _match_11130.fst;
    kk_box_dup(_x, _ctx);
    kk_std_core_types__tuple3__drop(_match_11130, _ctx);
    _x11331 = _x; /*8337*/
  }
  kk_box_t _x11333;
  kk_std_core_types__tuple3_ _match_11129;
  kk_box_t _x11334 = kk_box_dup(_b_11035, _ctx); /*51*/
  _match_11129 = kk_std_core_types__tuple3__unbox(_x11334, KK_OWNED, _ctx); /*(8337, 8338, 8339)*/
  {
    kk_box_t _x0 = _match_11129.snd;
    kk_box_dup(_x0, _ctx);
    kk_std_core_types__tuple3__drop(_match_11129, _ctx);
    _x11333 = _x0; /*8338*/
  }
  kk_box_t _x11335;
  kk_std_core_types__tuple3_ _match_11128 = kk_std_core_types__tuple3__unbox(_b_11035, KK_OWNED, _ctx); /*(8337, 8338, 8339)*/;
  {
    kk_box_t _x1 = _match_11128.thd;
    kk_box_dup(_x1, _ctx);
    kk_std_core_types__tuple3__drop(_match_11128, _ctx);
    _x11335 = _x1; /*8339*/
  }
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, _x11331, _x11333, _x11335, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_never3_fun11329(kk_function_t _fself, kk_std_core_hnd__marker _b_11033, kk_std_core_hnd__ev _b_11034, kk_box_t _b_11035, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never3_fun11329__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never3_fun11329__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (8337, 8338, 8339) -> 8341 8343 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(_b_11034, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to_final(_b_11033, kk_std_core_hnd_new_clause_never3_fun11330(_b_11035, op, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_never3(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1,b1> (op : (a, b, c) -> e b1) -> clause1<(a, b, c),d,a1,e,b1> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_never3_fun11329(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_never4_fun11336__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_never4_fun11336(kk_function_t _fself, kk_std_core_hnd__marker _b_11041, kk_std_core_hnd__ev _b_11042, kk_box_t _b_11043, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never4_fun11336(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never4_fun11336__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never4_fun11336__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_never4_fun11336, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_never4_fun11337__t {
  struct kk_function_s _base;
  kk_function_t op;
  kk_std_core_types__tuple4_ x_11047;
};
static kk_box_t kk_std_core_hnd_clause_never4_fun11337(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_never4_fun11337(kk_function_t op, kk_std_core_types__tuple4_ x_11047, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never4_fun11337__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_never4_fun11337__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_never4_fun11337, kk_context());
  _self->op = op;
  _self->x_11047 = x_11047;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_never4_fun11337(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never4_fun11337__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never4_fun11337__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (8643, 8644, 8645, 8646) -> 8648 8650 */
  kk_std_core_types__tuple4_ x_11047 = _self->x_11047; /* (8643, 8644, 8645, 8646) */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);kk_std_core_types__tuple4__dup(x_11047, _ctx);}, {}, _ctx)
  kk_function_drop(___wildcard__525__45, _ctx);
  kk_box_t _x11338;
  {
    struct kk_std_core_types__Tuple4_* _con11339 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11047, _ctx);
    kk_box_t _x = _con11339->fst;
    kk_box_dup(_x, _ctx);
    _x11338 = _x; /*8643*/
  }
  kk_box_t _x11340;
  {
    struct kk_std_core_types__Tuple4_* _con11341 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11047, _ctx);
    kk_box_t _x0 = _con11341->snd;
    kk_box_dup(_x0, _ctx);
    _x11340 = _x0; /*8644*/
  }
  kk_box_t _x11342;
  {
    struct kk_std_core_types__Tuple4_* _con11343 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11047, _ctx);
    kk_box_t _x1 = _con11343->thd;
    kk_box_dup(_x1, _ctx);
    _x11342 = _x1; /*8645*/
  }
  kk_box_t _x11344;
  {
    struct kk_std_core_types__Tuple4_* _con11345 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11047, _ctx);
    kk_box_t _pat02 = _con11345->fst;
    kk_box_t _pat12 = _con11345->snd;
    kk_box_t _pat22 = _con11345->thd;
    kk_box_t _x2 = _con11345->field4;
    if kk_likely(kk_datatype_ptr_is_unique(x_11047, _ctx)) {
      kk_box_drop(_pat22, _ctx);
      kk_box_drop(_pat12, _ctx);
      kk_box_drop(_pat02, _ctx);
      kk_datatype_ptr_free(x_11047, _ctx);
    }
    else {
      kk_box_dup(_x2, _ctx);
      kk_datatype_ptr_decref(x_11047, _ctx);
    }
    _x11344 = _x2; /*8646*/
  }
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, _x11338, _x11340, _x11342, _x11344, _ctx), _ctx);
}
static kk_box_t kk_std_core_hnd_clause_never4_fun11336(kk_function_t _fself, kk_std_core_hnd__marker _b_11041, kk_std_core_hnd__ev _b_11042, kk_box_t _b_11043, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_never4_fun11336__t* _self = kk_function_as(struct kk_std_core_hnd_clause_never4_fun11336__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (8643, 8644, 8645, 8646) -> 8648 8650 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(_b_11042, (KK_I32(3)), _ctx);
  kk_std_core_types__tuple4_ x_11047 = kk_std_core_types__tuple4__unbox(_b_11043, KK_OWNED, _ctx); /*(8643, 8644, 8645, 8646)*/;
  return kk_std_core_hnd_yield_to_final(_b_11041, kk_std_core_hnd_new_clause_never4_fun11337(op, x_11047, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_never4(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,b1,c1> (op : (a, b, c, d) -> e c1) -> clause1<(a, b, c, d),a1,b1,e,c1> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_never4_fun11336(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail_noyield3_fun11346__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail_noyield3_fun11346(kk_function_t _fself, kk_std_core_hnd__marker _b_11049, kk_std_core_hnd__ev _b_11050, kk_box_t _b_11051, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail_noyield3_fun11346(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield3_fun11346__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail_noyield3_fun11346__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_tail_noyield3_fun11346, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_tail_noyield3_fun11346(kk_function_t _fself, kk_std_core_hnd__marker _b_11049, kk_std_core_hnd__ev _b_11050, kk_box_t _b_11051, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield3_fun11346__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail_noyield3_fun11346__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (8880, 8881, 8882) -> 8884 8883 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(_b_11050, (KK_I32(3)), _ctx);
  kk_box_t _x11347;
  kk_std_core_types__tuple3_ _match_11127;
  kk_box_t _x11348 = kk_box_dup(_b_11051, _ctx); /*51*/
  _match_11127 = kk_std_core_types__tuple3__unbox(_x11348, KK_OWNED, _ctx); /*(8880, 8881, 8882)*/
  {
    kk_box_t _x = _match_11127.fst;
    kk_box_dup(_x, _ctx);
    kk_std_core_types__tuple3__drop(_match_11127, _ctx);
    _x11347 = _x; /*8880*/
  }
  kk_box_t _x11349;
  kk_std_core_types__tuple3_ _match_11126;
  kk_box_t _x11350 = kk_box_dup(_b_11051, _ctx); /*51*/
  _match_11126 = kk_std_core_types__tuple3__unbox(_x11350, KK_OWNED, _ctx); /*(8880, 8881, 8882)*/
  {
    kk_box_t _x0 = _match_11126.snd;
    kk_box_dup(_x0, _ctx);
    kk_std_core_types__tuple3__drop(_match_11126, _ctx);
    _x11349 = _x0; /*8881*/
  }
  kk_box_t _x11351;
  kk_std_core_types__tuple3_ _match_11125 = kk_std_core_types__tuple3__unbox(_b_11051, KK_OWNED, _ctx); /*(8880, 8881, 8882)*/;
  {
    kk_box_t _x1 = _match_11125.thd;
    kk_box_dup(_x1, _ctx);
    kk_std_core_types__tuple3__drop(_match_11125, _ctx);
    _x11351 = _x1; /*8882*/
  }
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, _x11347, _x11349, _x11351, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_tail_noyield3(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1,b1> (op : (a, b, c) -> e d) -> clause1<(a, b, c),d,a1,e,b1> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_tail_noyield3_fun11346(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail_noyield4_fun11352__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail_noyield4_fun11352(kk_function_t _fself, kk_std_core_hnd__marker _b_11057, kk_std_core_hnd__ev _b_11058, kk_box_t _b_11059, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail_noyield4_fun11352(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield4_fun11352__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail_noyield4_fun11352__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_tail_noyield4_fun11352, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_tail_noyield4_fun11352(kk_function_t _fself, kk_std_core_hnd__marker _b_11057, kk_std_core_hnd__ev _b_11058, kk_box_t _b_11059, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail_noyield4_fun11352__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail_noyield4_fun11352__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (9186, 9187, 9188, 9189) -> 9191 9190 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(_b_11058, (KK_I32(3)), _ctx);
  kk_std_core_types__tuple4_ x_11063 = kk_std_core_types__tuple4__unbox(_b_11059, KK_OWNED, _ctx); /*(9186, 9187, 9188, 9189)*/;
  kk_box_t _x11353;
  {
    struct kk_std_core_types__Tuple4_* _con11354 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11063, _ctx);
    kk_box_t _x = _con11354->fst;
    kk_box_dup(_x, _ctx);
    _x11353 = _x; /*9186*/
  }
  kk_box_t _x11355;
  {
    struct kk_std_core_types__Tuple4_* _con11356 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11063, _ctx);
    kk_box_t _x0 = _con11356->snd;
    kk_box_dup(_x0, _ctx);
    _x11355 = _x0; /*9187*/
  }
  kk_box_t _x11357;
  {
    struct kk_std_core_types__Tuple4_* _con11358 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11063, _ctx);
    kk_box_t _x1 = _con11358->thd;
    kk_box_dup(_x1, _ctx);
    _x11357 = _x1; /*9188*/
  }
  kk_box_t _x11359;
  {
    struct kk_std_core_types__Tuple4_* _con11360 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11063, _ctx);
    kk_box_t _pat02 = _con11360->fst;
    kk_box_t _pat12 = _con11360->snd;
    kk_box_t _pat22 = _con11360->thd;
    kk_box_t _x2 = _con11360->field4;
    if kk_likely(kk_datatype_ptr_is_unique(x_11063, _ctx)) {
      kk_box_drop(_pat22, _ctx);
      kk_box_drop(_pat12, _ctx);
      kk_box_drop(_pat02, _ctx);
      kk_datatype_ptr_free(x_11063, _ctx);
    }
    else {
      kk_box_dup(_x2, _ctx);
      kk_datatype_ptr_decref(x_11063, _ctx);
    }
    _x11359 = _x2; /*9189*/
  }
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, _x11353, _x11355, _x11357, _x11359, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_tail_noyield4(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,b1,c1> (op : (a, b, c, d) -> e a1) -> clause1<(a, b, c, d),a1,b1,e,c1> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_tail_noyield4_fun11352(op, _ctx), _ctx);
}
 
// extra under1x to make under1 inlineable


// lift anonymous function
struct kk_std_core_hnd_under1x_fun11363__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under1x_fun11363(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under1x_fun11363(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under1x_fun11363__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under1x_fun11363__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_under1x_fun11363, kk_context());
  _self->ev = ev;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_under1x_fun11363(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under1x_fun11363__t* _self = kk_function_as(struct kk_std_core_hnd_under1x_fun11363__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<9254> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont, res, _ctx);
}

kk_box_t kk_std_core_hnd_under1x(kk_std_core_hnd__ev ev, kk_function_t op, kk_box_t x, kk_context_t* _ctx) { /* forall<a,b,e,c> (ev : ev<c>, op : (a) -> e b, x : a) -> e b */ 
  kk_evv_t w0;
  kk_evv_t _x11361;
  {
    struct kk_std_core_hnd_Ev* _con11362 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w = _con11362->hevv;
    kk_evv_dup(w, _ctx);
    _x11361 = w; /*std/core/hnd/evv<4249>*/
  }
  w0 = kk_evv_swap(_x11361,kk_context()); /*std/core/hnd/evv<_9199>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), op, (op, x, _ctx), _ctx); /*9252*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    kk_evv_drop(w0, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under1x_fun11363(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    kk_unit_t __0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    return y;
  }
}
extern kk_box_t kk_std_core_hnd_under1_fun11366(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under1_fun11366__t* _self = kk_function_as(struct kk_std_core_hnd_under1_fun11366__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<9315> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont, res, _ctx);
}
extern kk_box_t kk_std_core_hnd_under0_fun11372(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under0_fun11372__t* _self = kk_function_as(struct kk_std_core_hnd_under0_fun11372__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<9368> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont0, res0, _ctx);
}
extern kk_box_t kk_std_core_hnd_under0_fun11369(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under0_fun11369__t* _self = kk_function_as(struct kk_std_core_hnd_under0_fun11369__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<9368> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  kk_evv_t w00;
  kk_evv_t _x11370;
  {
    struct kk_std_core_hnd_Ev* _con11371 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w1 = _con11371->hevv;
    kk_evv_dup(w1, _ctx);
    _x11370 = w1; /*std/core/hnd/evv<4249>*/
  }
  w00 = kk_evv_swap(_x11370,kk_context()); /*std/core/hnd/evv<_9260>*/
  kk_box_t y0 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx), _ctx); /*9366*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(y0, _ctx);
    kk_evv_drop(w00, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under0_fun11372(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    kk_unit_t __0 = kk_Unit;
    kk_evv_set(w00,kk_context());
    return y0;
  }
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail0_fun11373__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail0_fun11373(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__562__14, kk_std_core_hnd__ev ev, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail0_fun11373(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun11373__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail0_fun11373__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_tail0_fun11373, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_tail0_fun11376__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_clause_tail0_fun11376(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail0_fun11376(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun11376__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail0_fun11376__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_tail0_fun11376, kk_context());
  _self->ev = ev;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_tail0_fun11379__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_clause_tail0_fun11379(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail0_fun11379(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun11379__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail0_fun11379__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_tail0_fun11379, kk_context());
  _self->ev = ev;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_tail0_fun11379(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun11379__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail0_fun11379__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<9399> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont0, res0, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_tail0_fun11376(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun11376__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail0_fun11376__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<9399> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  kk_evv_t w00;
  kk_evv_t _x11377;
  {
    struct kk_std_core_hnd_Ev* _con11378 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w1 = _con11378->hevv;
    kk_evv_dup(w1, _ctx);
    _x11377 = w1; /*std/core/hnd/evv<4249>*/
  }
  w00 = kk_evv_swap(_x11377,kk_context()); /*std/core/hnd/evv<_9260>*/
  kk_box_t y0 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx), _ctx); /*9398*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(y0, _ctx);
    kk_evv_drop(w00, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_clause_tail0_fun11379(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    kk_unit_t __0 = kk_Unit;
    kk_evv_set(w00,kk_context());
    return y0;
  }
}
static kk_box_t kk_std_core_hnd_clause_tail0_fun11373(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__562__14, kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail0_fun11373__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail0_fun11373__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* () -> 9396 9398 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_evv_t w0;
  kk_evv_t _x11374;
  {
    struct kk_std_core_hnd_Ev* _con11375 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w = _con11375->hevv;
    kk_evv_dup(w, _ctx);
    _x11374 = w; /*std/core/hnd/evv<4249>*/
  }
  w0 = kk_evv_swap(_x11374,kk_context()); /*std/core/hnd/evv<_9320>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), op, (op, _ctx), _ctx); /*9398*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_clause_tail0_fun11376(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    return y;
  }
}

kk_std_core_hnd__clause0 kk_std_core_hnd_clause_tail0(kk_function_t op, kk_context_t* _ctx) { /* forall<e,a,b,c> (op : () -> e b) -> clause0<b,c,e,a> */ 
  return kk_std_core_hnd__new_Clause0(kk_std_core_hnd_new_clause_tail0_fun11373(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail1_fun11380__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail1_fun11380(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__519__14, kk_std_core_hnd__ev ev, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail1_fun11380(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail1_fun11380__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail1_fun11380__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_tail1_fun11380, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_clause_tail1_fun11383__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_clause_tail1_fun11383(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail1_fun11383(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail1_fun11383__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail1_fun11383__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_tail1_fun11383, kk_context());
  _self->ev = ev;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_tail1_fun11383(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail1_fun11383__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail1_fun11383__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<9437> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont, res, _ctx);
}
static kk_box_t kk_std_core_hnd_clause_tail1_fun11380(kk_function_t _fself, kk_std_core_hnd__marker ___wildcard__519__14, kk_std_core_hnd__ev ev, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail1_fun11380__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail1_fun11380__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (9435) -> 9433 9436 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_evv_t w0;
  kk_evv_t _x11381;
  {
    struct kk_std_core_hnd_Ev* _con11382 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w = _con11382->hevv;
    kk_evv_dup(w, _ctx);
    _x11381 = w; /*std/core/hnd/evv<4249>*/
  }
  w0 = kk_evv_swap(_x11381,kk_context()); /*std/core/hnd/evv<_9260>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), op, (op, x, _ctx), _ctx); /*9436*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    kk_evv_drop(w0, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_clause_tail1_fun11383(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    kk_unit_t __0 = kk_Unit;
    kk_evv_set(w0,kk_context());
    return y;
  }
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_tail1(kk_function_t op, kk_context_t* _ctx) { /* forall<e,a,b,c,d> (op : (b) -> e c) -> clause1<b,c,d,e,a> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_tail1_fun11380(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_under2_fun11386__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under2_fun11386(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under2_fun11386(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under2_fun11386__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under2_fun11386__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_under2_fun11386, kk_context());
  _self->ev = ev;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_under2_fun11389__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under2_fun11389(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under2_fun11389(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under2_fun11389__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under2_fun11389__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_under2_fun11389, kk_context());
  _self->ev = ev;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_under2_fun11389(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under2_fun11389__t* _self = kk_function_as(struct kk_std_core_hnd_under2_fun11389__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<9500> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont0, res0, _ctx);
}
static kk_box_t kk_std_core_hnd_under2_fun11386(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under2_fun11386__t* _self = kk_function_as(struct kk_std_core_hnd_under2_fun11386__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<9500> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  kk_evv_t w00;
  kk_evv_t _x11387;
  {
    struct kk_std_core_hnd_Ev* _con11388 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w1 = _con11388->hevv;
    kk_evv_dup(w1, _ctx);
    _x11387 = w1; /*std/core/hnd/evv<4249>*/
  }
  w00 = kk_evv_swap(_x11387,kk_context()); /*std/core/hnd/evv<_9260>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx), _ctx); /*9498*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    kk_evv_drop(w00, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under2_fun11389(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    kk_unit_t __0 = kk_Unit;
    kk_evv_set(w00,kk_context());
    return y;
  }
}

kk_box_t kk_std_core_hnd_under2(kk_std_core_hnd__ev ev, kk_function_t op, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) { /* forall<a,b,c,e,d> (ev : ev<d>, op : (a, b) -> e c, x1 : a, x2 : b) -> e c */ 
  kk_evv_t w0;
  kk_evv_t _x11384;
  {
    struct kk_std_core_hnd_Ev* _con11385 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w = _con11385->hevv;
    kk_evv_dup(w, _ctx);
    _x11384 = w; /*std/core/hnd/evv<4249>*/
  }
  w0 = kk_evv_swap(_x11384,kk_context()); /*std/core/hnd/evv<_9444>*/
  kk_box_t z = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, x1, x2, _ctx), _ctx); /*9498*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(z, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under2_fun11386(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    return z;
  }
}
extern kk_box_t kk_std_core_hnd_clause_tail2_fun11390(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ev, kk_box_t x1, kk_box_t x2, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail2_fun11390__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail2_fun11390__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (9542, 9543) -> 9540 9544 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_under2(ev, op, x1, x2, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail3_fun11391__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail3_fun11391(kk_function_t _fself, kk_std_core_hnd__marker _b_11065, kk_std_core_hnd__ev _b_11066, kk_box_t _b_11067, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail3_fun11391(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail3_fun11391__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail3_fun11391__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_tail3_fun11391, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_tail3_fun11391(kk_function_t _fself, kk_std_core_hnd__marker _b_11065, kk_std_core_hnd__ev _b_11066, kk_box_t _b_11067, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail3_fun11391__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail3_fun11391__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (9775, 9776, 9777) -> 9779 9778 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(_b_11066, (KK_I32(3)), _ctx);
  kk_box_t _x11392;
  kk_std_core_types__tuple3_ _match_11115;
  kk_box_t _x11393 = kk_box_dup(_b_11067, _ctx); /*51*/
  _match_11115 = kk_std_core_types__tuple3__unbox(_x11393, KK_OWNED, _ctx); /*(9775, 9776, 9777)*/
  {
    kk_box_t _x = _match_11115.fst;
    kk_box_dup(_x, _ctx);
    kk_std_core_types__tuple3__drop(_match_11115, _ctx);
    _x11392 = _x; /*9775*/
  }
  kk_box_t _x11394;
  kk_std_core_types__tuple3_ _match_11114;
  kk_box_t _x11395 = kk_box_dup(_b_11067, _ctx); /*51*/
  _match_11114 = kk_std_core_types__tuple3__unbox(_x11395, KK_OWNED, _ctx); /*(9775, 9776, 9777)*/
  {
    kk_box_t _x0 = _match_11114.snd;
    kk_box_dup(_x0, _ctx);
    kk_std_core_types__tuple3__drop(_match_11114, _ctx);
    _x11394 = _x0; /*9776*/
  }
  kk_box_t _x11396;
  kk_std_core_types__tuple3_ _match_11113 = kk_std_core_types__tuple3__unbox(_b_11067, KK_OWNED, _ctx); /*(9775, 9776, 9777)*/;
  {
    kk_box_t _x1 = _match_11113.thd;
    kk_box_dup(_x1, _ctx);
    kk_std_core_types__tuple3__drop(_match_11113, _ctx);
    _x11396 = _x1; /*9777*/
  }
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, _x11392, _x11394, _x11396, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_tail3(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1,b1> (op : (a, b, c) -> e d) -> clause1<(a, b, c),d,a1,e,b1> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_tail3_fun11391(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_clause_tail4_fun11397__t {
  struct kk_function_s _base;
  kk_function_t op;
};
static kk_box_t kk_std_core_hnd_clause_tail4_fun11397(kk_function_t _fself, kk_std_core_hnd__marker _b_11073, kk_std_core_hnd__ev _b_11074, kk_box_t _b_11075, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_clause_tail4_fun11397(kk_function_t op, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail4_fun11397__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_clause_tail4_fun11397__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_clause_tail4_fun11397, kk_context());
  _self->op = op;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_clause_tail4_fun11397(kk_function_t _fself, kk_std_core_hnd__marker _b_11073, kk_std_core_hnd__ev _b_11074, kk_box_t _b_11075, kk_context_t* _ctx) {
  struct kk_std_core_hnd_clause_tail4_fun11397__t* _self = kk_function_as(struct kk_std_core_hnd_clause_tail4_fun11397__t*, _fself, _ctx);
  kk_function_t op = _self->op; /* (10081, 10082, 10083, 10084) -> 10086 10085 */
  kk_drop_match(_self, {kk_function_dup(op, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(_b_11074, (KK_I32(3)), _ctx);
  kk_std_core_types__tuple4_ x_11079 = kk_std_core_types__tuple4__unbox(_b_11075, KK_OWNED, _ctx); /*(10081, 10082, 10083, 10084)*/;
  kk_box_t _x11398;
  {
    struct kk_std_core_types__Tuple4_* _con11399 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11079, _ctx);
    kk_box_t _x = _con11399->fst;
    kk_box_dup(_x, _ctx);
    _x11398 = _x; /*10081*/
  }
  kk_box_t _x11400;
  {
    struct kk_std_core_types__Tuple4_* _con11401 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11079, _ctx);
    kk_box_t _x0 = _con11401->snd;
    kk_box_dup(_x0, _ctx);
    _x11400 = _x0; /*10082*/
  }
  kk_box_t _x11402;
  {
    struct kk_std_core_types__Tuple4_* _con11403 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11079, _ctx);
    kk_box_t _x1 = _con11403->thd;
    kk_box_dup(_x1, _ctx);
    _x11402 = _x1; /*10083*/
  }
  kk_box_t _x11404;
  {
    struct kk_std_core_types__Tuple4_* _con11405 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(x_11079, _ctx);
    kk_box_t _pat02 = _con11405->fst;
    kk_box_t _pat12 = _con11405->snd;
    kk_box_t _pat22 = _con11405->thd;
    kk_box_t _x2 = _con11405->field4;
    if kk_likely(kk_datatype_ptr_is_unique(x_11079, _ctx)) {
      kk_box_drop(_pat22, _ctx);
      kk_box_drop(_pat12, _ctx);
      kk_box_drop(_pat02, _ctx);
      kk_datatype_ptr_free(x_11079, _ctx);
    }
    else {
      kk_box_dup(_x2, _ctx);
      kk_datatype_ptr_decref(x_11079, _ctx);
    }
    _x11404 = _x2; /*10084*/
  }
  return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, _x11398, _x11400, _x11402, _x11404, _ctx), _ctx);
}

kk_std_core_hnd__clause1 kk_std_core_hnd_clause_tail4(kk_function_t op, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,b1,c1> (op : (a, b, c, d) -> e a1) -> clause1<(a, b, c, d),a1,b1,e,c1> */ 
  return kk_std_core_hnd__new_Clause1(kk_std_core_hnd_new_clause_tail4_fun11397(op, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_finally_prompt_fun11406__t {
  struct kk_function_s _base;
  kk_function_t fin;
};
static kk_box_t kk_std_core_hnd_finally_prompt_fun11406(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_finally_prompt_fun11406(kk_function_t fin, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finally_prompt_fun11406__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_finally_prompt_fun11406__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_finally_prompt_fun11406, kk_context());
  _self->fin = fin;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_finally_prompt_fun11406(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finally_prompt_fun11406__t* _self = kk_function_as(struct kk_std_core_hnd_finally_prompt_fun11406__t*, _fself, _ctx);
  kk_function_t fin = _self->fin; /* () -> 10178 () */
  kk_drop_match(_self, {kk_function_dup(fin, _ctx);}, {}, _ctx)
  kk_box_t _x11407 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx), _ctx); /*10177*/
  return kk_std_core_hnd_finally_prompt(fin, _x11407, _ctx);
}


// lift anonymous function
struct kk_std_core_hnd_finally_prompt_fun11408__t {
  struct kk_function_s _base;
  kk_std_core_hnd__yield_info yld;
};
static kk_box_t kk_std_core_hnd_finally_prompt_fun11408(kk_function_t _fself, kk_box_t ___wildcard__380__43, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_finally_prompt_fun11408(kk_std_core_hnd__yield_info yld, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finally_prompt_fun11408__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_finally_prompt_fun11408__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_finally_prompt_fun11408, kk_context());
  _self->yld = yld;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_finally_prompt_fun11408(kk_function_t _fself, kk_box_t ___wildcard__380__43, kk_context_t* _ctx) {
  struct kk_std_core_hnd_finally_prompt_fun11408__t* _self = kk_function_as(struct kk_std_core_hnd_finally_prompt_fun11408__t*, _fself, _ctx);
  kk_std_core_hnd__yield_info yld = _self->yld; /* std/core/hnd/yield-info */
  kk_drop_match(_self, {kk_std_core_hnd__yield_info_dup(yld, _ctx);}, {}, _ctx)
  kk_box_drop(___wildcard__380__43, _ctx);
  return kk_std_core_hnd_unsafe_reyield(yld, _ctx);
}

kk_box_t kk_std_core_hnd_finally_prompt(kk_function_t fin, kk_box_t res, kk_context_t* _ctx) { /* forall<a,e> (fin : () -> e (), res : a) -> e a */ 
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    bool _match_11111 = kk_yielding_non_final(kk_context()); /*bool*/;
    if (_match_11111) {
      return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_finally_prompt_fun11406(fin, _ctx), _ctx);
    }
    {
      kk_std_core_hnd__yield_info yld = kk_std_core_hnd_yield_capture(_ctx); /*std/core/hnd/yield-info*/;
      kk_unit_t __0 = kk_Unit;
      kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), fin, (fin, _ctx), _ctx);
      if (kk_yielding(kk_context())) {
        return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_finally_prompt_fun11408(yld, _ctx), _ctx);
      }
      {
        return kk_std_core_hnd_unsafe_reyield(yld, _ctx);
      }
    }
  }
  {
    kk_unit_t __ = kk_Unit;
    kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), fin, (fin, _ctx), _ctx);
    return res;
  }
}


// lift anonymous function
struct kk_std_core_hnd_initially_prompt_fun11410__t {
  struct kk_function_s _base;
  kk_ref_t count;
  kk_function_t init;
};
static kk_box_t kk_std_core_hnd_initially_prompt_fun11410(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_initially_prompt_fun11410(kk_ref_t count, kk_function_t init, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_prompt_fun11410__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_initially_prompt_fun11410__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_initially_prompt_fun11410, kk_context());
  _self->count = count;
  _self->init = init;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_initially_prompt_fun11416__t {
  struct kk_function_s _base;
  kk_function_t cont;
  kk_function_t init;
  kk_box_t x;
};
static kk_box_t kk_std_core_hnd_initially_prompt_fun11416(kk_function_t _fself, kk_box_t ___wildcard__420__47, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_initially_prompt_fun11416(kk_function_t cont, kk_function_t init, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_prompt_fun11416__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_initially_prompt_fun11416__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_initially_prompt_fun11416, kk_context());
  _self->cont = cont;
  _self->init = init;
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_initially_prompt_fun11416(kk_function_t _fself, kk_box_t ___wildcard__420__47, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_prompt_fun11416__t* _self = kk_function_as(struct kk_std_core_hnd_initially_prompt_fun11416__t*, _fself, _ctx);
  kk_function_t cont = _self->cont; /* (10322) -> 10332 10331 */
  kk_function_t init = _self->init; /* (int) -> 10332 () */
  kk_box_t x = _self->x; /* 10322 */
  kk_drop_match(_self, {kk_function_dup(cont, _ctx);kk_function_dup(init, _ctx);kk_box_dup(x, _ctx);}, {}, _ctx)
  kk_box_drop(___wildcard__420__47, _ctx);
  kk_box_t _x11417 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx), _ctx); /*10331*/
  return kk_std_core_hnd_initially_prompt(init, _x11417, _ctx);
}
static kk_box_t kk_std_core_hnd_initially_prompt_fun11410(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_prompt_fun11410__t* _self = kk_function_as(struct kk_std_core_hnd_initially_prompt_fun11410__t*, _fself, _ctx);
  kk_ref_t count = _self->count; /* ref<global,int> */
  kk_function_t init = _self->init; /* (int) -> 10332 () */
  kk_drop_match(_self, {kk_ref_dup(count, _ctx);kk_function_dup(init, _ctx);}, {}, _ctx)
  kk_integer_t cnt;
  kk_box_t _x11411;
  kk_ref_t _x11412 = kk_ref_dup(count, _ctx); /*ref<global,int>*/
  _x11411 = kk_ref_get(_x11412,kk_context()); /*190*/
  cnt = kk_integer_unbox(_x11411, _ctx); /*int*/
  kk_integer_t _b_11087_11085;
  kk_integer_t _x11413 = kk_integer_dup(cnt, _ctx); /*int*/
  _b_11087_11085 = kk_integer_add(_x11413,(kk_integer_from_small(1)),kk_context()); /*int*/
  kk_unit_t __ = kk_Unit;
  kk_unit_t _brw_11110 = kk_Unit;
  kk_ref_set_borrow(count,(kk_integer_box(_b_11087_11085, _ctx)),kk_context());
  kk_ref_drop(count, _ctx);
  _brw_11110;
  bool _match_11108 = kk_integer_eq_borrow(cnt,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_11108) {
    kk_integer_drop(cnt, _ctx);
    kk_box_t _x11414 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx), _ctx); /*10331*/
    return kk_std_core_hnd_initially_prompt(init, _x11414, _ctx);
  }
  {
    kk_unit_t r = kk_Unit;
    kk_function_t _x11415 = kk_function_dup(init, _ctx); /*(int) -> 10332 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_context_t*), _x11415, (_x11415, cnt, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_initially_prompt_fun11416(cont, init, x, _ctx), _ctx);
    }
    {
      kk_box_t _x11418 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx), _ctx); /*10331*/
      return kk_std_core_hnd_initially_prompt(init, _x11418, _ctx);
    }
  }
}

kk_box_t kk_std_core_hnd_initially_prompt(kk_function_t init, kk_box_t res, kk_context_t* _ctx) { /* forall<a,e> (init : (int) -> e (), res : a) -> e a */ 
  bool _match_11107 = kk_yielding_non_final(kk_context()); /*bool*/;
  if (_match_11107) {
    kk_box_drop(res, _ctx);
    kk_ref_t count = kk_ref_alloc((kk_integer_box(kk_integer_from_small(0), _ctx)),kk_context()); /*ref<global,int>*/;
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_initially_prompt_fun11410(count, init, _ctx), _ctx);
  }
  {
    kk_function_drop(init, _ctx);
    return res;
  }
}


// lift anonymous function
struct kk_std_core_hnd_initially_fun11420__t {
  struct kk_function_s _base;
  kk_function_t action;
  kk_function_t init;
};
static kk_box_t kk_std_core_hnd_initially_fun11420(kk_function_t _fself, kk_box_t _b_11089, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_initially_fun11420(kk_function_t action, kk_function_t init, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_fun11420__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_initially_fun11420__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_initially_fun11420, kk_context());
  _self->action = action;
  _self->init = init;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_initially_fun11420(kk_function_t _fself, kk_box_t _b_11089, kk_context_t* _ctx) {
  struct kk_std_core_hnd_initially_fun11420__t* _self = kk_function_as(struct kk_std_core_hnd_initially_fun11420__t*, _fself, _ctx);
  kk_function_t action = _self->action; /* () -> 10368 10367 */
  kk_function_t init = _self->init; /* (int) -> 10368 () */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);kk_function_dup(init, _ctx);}, {}, _ctx)
  kk_box_drop(_b_11089, _ctx);
  kk_box_t _x11421 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx); /*10367*/
  return kk_std_core_hnd_initially_prompt(init, _x11421, _ctx);
}

kk_box_t kk_std_core_hnd_initially(kk_function_t init, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (init : (int) -> e (), action : () -> e a) -> e a */ 
  kk_unit_t __ = kk_Unit;
  kk_function_t _x11419 = kk_function_dup(init, _ctx); /*(int) -> 10368 ()*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_context_t*), _x11419, (_x11419, kk_integer_from_small(0), _ctx), _ctx);
  if (kk_yielding(kk_context())) {
    return kk_std_core_hnd_yield_extend(kk_std_core_hnd_new_initially_fun11420(action, init, _ctx), _ctx);
  }
  {
    kk_box_t _x11422 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx); /*10367*/
    return kk_std_core_hnd_initially_prompt(init, _x11422, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_hnd_prompt_local_var_fun11424__t {
  struct kk_function_s _base;
  kk_ref_t loc;
  kk_box_t v;
};
static kk_box_t kk_std_core_hnd_prompt_local_var_fun11424(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_prompt_local_var_fun11424(kk_ref_t loc, kk_box_t v, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_local_var_fun11424__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_prompt_local_var_fun11424__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_prompt_local_var_fun11424, kk_context());
  _self->loc = loc;
  _self->v = v;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_prompt_local_var_fun11424(kk_function_t _fself, kk_function_t cont, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_hnd_prompt_local_var_fun11424__t* _self = kk_function_as(struct kk_std_core_hnd_prompt_local_var_fun11424__t*, _fself, _ctx);
  kk_ref_t loc = _self->loc; /* local-var<10461,10458> */
  kk_box_t v = _self->v; /* 10458 */
  kk_drop_match(_self, {kk_ref_dup(loc, _ctx);kk_box_dup(v, _ctx);}, {}, _ctx)
  kk_unit_t __0 = kk_Unit;
  kk_ref_set_borrow(loc,v,kk_context());
  kk_box_t _x11425 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, x, _ctx), _ctx); /*10459*/
  return kk_std_core_hnd_prompt_local_var(loc, _x11425, _ctx);
}

kk_box_t kk_std_core_hnd_prompt_local_var(kk_ref_t loc, kk_box_t res, kk_context_t* _ctx) { /* forall<a,b,h> (loc : local-var<h,a>, res : b) -> <div,local<h>> b */ 
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    kk_box_t v;
    kk_ref_t _x11423 = kk_ref_dup(loc, _ctx); /*local-var<10461,10458>*/
    v = kk_ref_get(_x11423,kk_context()); /*10458*/
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_prompt_local_var_fun11424(loc, v, _ctx), _ctx);
  }
  {
    kk_ref_drop(loc, _ctx);
    return res;
  }
}


// lift anonymous function
struct kk_std_core_hnd_try_finalize_prompt_fun11428__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_hnd_try_finalize_prompt_fun11428(kk_function_t _fself, kk_function_t _b_11093, kk_box_t _b_11094, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_try_finalize_prompt_fun11428(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_hnd_try_finalize_prompt_fun11428, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_hnd_try_finalize_prompt_fun11428(kk_function_t _fself, kk_function_t _b_11093, kk_box_t _b_11094, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_function_t cont_11098 = _b_11093; /*(10584) -> 10635 10634*/;
  kk_box_t x_11099 = _b_11094; /*10584*/;
  kk_std_core_types__either _x11429;
  kk_box_t _x11430 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont_11098, (cont_11098, x_11099, _ctx), _ctx); /*10634*/
  _x11429 = kk_std_core_hnd_try_finalize_prompt(_x11430, _ctx); /*either<std/core/hnd/yield-info,1926>*/
  return kk_std_core_types__either_box(_x11429, _ctx);
}

kk_std_core_types__either kk_std_core_hnd_try_finalize_prompt(kk_box_t res, kk_context_t* _ctx) { /* forall<a,e> (res : a) -> e either<yield-info,a> */ 
  bool _match_11105 = kk_yielding_non_final(kk_context()); /*bool*/;
  if (_match_11105) {
    kk_box_drop(res, _ctx);
    kk_box_t _x11427 = kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_try_finalize_prompt_fun11428(_ctx), _ctx); /*3949*/
    return kk_std_core_types__either_unbox(_x11427, KK_OWNED, _ctx);
  }
  if (kk_yielding(kk_context())) {
    kk_box_drop(res, _ctx);
    kk_std_core_hnd__yield_info _b_11097_11095 = kk_std_core_hnd_yield_capture(_ctx); /*std/core/hnd/yield-info*/;
    return kk_std_core_types__new_Left(kk_std_core_hnd__yield_info_box(_b_11097_11095, _ctx), _ctx);
  }
  {
    return kk_std_core_types__new_Right(res, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_hnd_under3_fun11433__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under3_fun11433(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under3_fun11433(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under3_fun11433__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under3_fun11433__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_under3_fun11433, kk_context());
  _self->ev = ev;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_under3_fun11436__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under3_fun11436(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under3_fun11436(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under3_fun11436__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under3_fun11436__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_under3_fun11436, kk_context());
  _self->ev = ev;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_under3_fun11436(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under3_fun11436__t* _self = kk_function_as(struct kk_std_core_hnd_under3_fun11436__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<10703> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont0, res0, _ctx);
}
static kk_box_t kk_std_core_hnd_under3_fun11433(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under3_fun11433__t* _self = kk_function_as(struct kk_std_core_hnd_under3_fun11433__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<10703> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  kk_evv_t w00;
  kk_evv_t _x11434;
  {
    struct kk_std_core_hnd_Ev* _con11435 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w1 = _con11435->hevv;
    kk_evv_dup(w1, _ctx);
    _x11434 = w1; /*std/core/hnd/evv<4249>*/
  }
  w00 = kk_evv_swap(_x11434,kk_context()); /*std/core/hnd/evv<_9260>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx), _ctx); /*10701*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    kk_evv_drop(w00, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under3_fun11436(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    kk_unit_t __0 = kk_Unit;
    kk_evv_set(w00,kk_context());
    return y;
  }
}

kk_box_t kk_std_core_hnd_under3(kk_std_core_hnd__ev ev, kk_function_t op, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_context_t* _ctx) { /* forall<a,b,c,d,e,a1> (ev : ev<a1>, op : (a, b, c) -> e d, x1 : a, x2 : b, x3 : c) -> e d */ 
  kk_evv_t w0;
  kk_evv_t _x11431;
  {
    struct kk_std_core_hnd_Ev* _con11432 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w = _con11432->hevv;
    kk_evv_dup(w, _ctx);
    _x11431 = w; /*std/core/hnd/evv<4249>*/
  }
  w0 = kk_evv_swap(_x11431,kk_context()); /*std/core/hnd/evv<_10643>*/
  kk_box_t z = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, x1, x2, x3, _ctx), _ctx); /*10701*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(z, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under3_fun11433(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    return z;
  }
}


// lift anonymous function
struct kk_std_core_hnd_under4_fun11439__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under4_fun11439(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under4_fun11439(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under4_fun11439__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under4_fun11439__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_under4_fun11439, kk_context());
  _self->ev = ev;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_hnd_under4_fun11442__t {
  struct kk_function_s _base;
  kk_std_core_hnd__ev ev;
};
static kk_box_t kk_std_core_hnd_under4_fun11442(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx);
static kk_function_t kk_std_core_hnd_new_under4_fun11442(kk_std_core_hnd__ev ev, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under4_fun11442__t* _self = kk_function_alloc_as(struct kk_std_core_hnd_under4_fun11442__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_hnd_under4_fun11442, kk_context());
  _self->ev = ev;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_hnd_under4_fun11442(kk_function_t _fself, kk_function_t cont0, kk_box_t res0, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under4_fun11442__t* _self = kk_function_as(struct kk_std_core_hnd_under4_fun11442__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<10776> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  return kk_std_core_hnd_under1x(ev, cont0, res0, _ctx);
}
static kk_box_t kk_std_core_hnd_under4_fun11439(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_hnd_under4_fun11439__t* _self = kk_function_as(struct kk_std_core_hnd_under4_fun11439__t*, _fself, _ctx);
  kk_std_core_hnd__ev ev = _self->ev; /* std/core/hnd/ev<10776> */
  kk_drop_match(_self, {kk_std_core_hnd__ev_dup(ev, _ctx);}, {}, _ctx)
  kk_evv_t w00;
  kk_evv_t _x11440;
  {
    struct kk_std_core_hnd_Ev* _con11441 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w1 = _con11441->hevv;
    kk_evv_dup(w1, _ctx);
    _x11440 = w1; /*std/core/hnd/evv<4249>*/
  }
  w00 = kk_evv_swap(_x11440,kk_context()); /*std/core/hnd/evv<_9260>*/
  kk_box_t y = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), cont, (cont, res, _ctx), _ctx); /*10774*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(y, _ctx);
    kk_evv_drop(w00, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under4_fun11442(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    kk_unit_t __0 = kk_Unit;
    kk_evv_set(w00,kk_context());
    return y;
  }
}

kk_box_t kk_std_core_hnd_under4(kk_std_core_hnd__ev ev, kk_function_t op, kk_box_t x1, kk_box_t x2, kk_box_t x3, kk_box_t x4, kk_context_t* _ctx) { /* forall<a,b,c,d,a1,e,b1> (ev : ev<b1>, op : (a, b, c, d) -> e a1, x1 : a, x2 : b, x3 : c, x4 : d) -> e a1 */ 
  kk_evv_t w0;
  kk_evv_t _x11437;
  {
    struct kk_std_core_hnd_Ev* _con11438 = kk_std_core_hnd__as_Ev(ev, _ctx);
    kk_evv_t w = _con11438->hevv;
    kk_evv_dup(w, _ctx);
    _x11437 = w; /*std/core/hnd/evv<4249>*/
  }
  w0 = kk_evv_swap(_x11437,kk_context()); /*std/core/hnd/evv<_10712>*/
  kk_box_t z = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_box_t, kk_box_t, kk_context_t*), op, (op, x1, x2, x3, x4, _ctx), _ctx); /*10774*/;
  kk_unit_t __ = kk_Unit;
  kk_evv_set(w0,kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_drop(z, _ctx);
    return kk_std_core_hnd_yield_cont(kk_std_core_hnd_new_under4_fun11439(ev, _ctx), _ctx);
  }
  {
    kk_datatype_ptr_dropn(ev, (KK_I32(3)), _ctx);
    return z;
  }
}

// initialization
void kk_std_core_hnd__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
}

// termination
void kk_std_core_hnd__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_std_core_types__done(_ctx);
}
