// Koka generated module: "std/num/float64", koka version: 2.4.2, platform: 64-bit
#include "std_num_float64.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static inline int64_t kk_double_to_bits( double d, kk_context_t* ctx ) {
  kk_unused(ctx);
  return (int64_t)kk_bits_from_double(d);
}

static inline double kk_double_from_bits( int64_t i, kk_context_t* ctx ) {
  kk_unused(ctx);
  return kk_bits_to_double((uint64_t)i);
}

static inline double kk_prim_parse_double( kk_string_t str, kk_context_t* ctx) {
  const char* s = kk_string_cbuf_borrow(str,NULL,ctx);
  char* end;
  double d = strtod(s,&end);
  kk_string_drop(str,ctx);  
  return d;
}

 
// The maximum of a list of absolute values.


// lift anonymous function
struct kk_std_num_float64_abs_max_fun5373__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_abs_max_fun5373_1(kk_function_t _fself, kk_box_t _b_4764, kk_box_t _b_4765, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_abs_max_fun5373_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_abs_max_fun5373_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_abs_max_fun5373_1(kk_function_t _fself, kk_box_t _b_4764, kk_box_t _b_4765, kk_context_t* _ctx) {
  kk_unused(_fself);
  double m_4769 = kk_double_unbox(_b_4764, KK_OWNED, _ctx); /*float64*/;
  double x_4770 = kk_double_unbox(_b_4765, KK_OWNED, _ctx); /*float64*/;
  double x0_4441 = kk_double_abs(x_4770); /*float64*/;
  double _x5374;
  bool _match_5368 = (x0_4441 >= m_4769); /*bool*/;
  if (_match_5368) {
    _x5374 = x0_4441; /*float64*/
  }
  else {
    _x5374 = m_4769; /*float64*/
  }
  return kk_double_box(_x5374, _ctx);
}

double kk_std_num_float64_abs_max_1(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  kk_box_t _x5372 = kk_std_core_foldl(xs, kk_double_box(0x0p+0, _ctx), kk_std_num_float64_new_abs_max_fun5373_1(_ctx), _ctx); /*12696*/
  return kk_double_unbox(_x5372, KK_OWNED, _ctx);
}
 
// The area hyperbolic cosine of `d`

double kk_std_num_float64_acosh(double d, kk_context_t* _ctx) { /* (d : float64) -> float64 */ 
  return acosh(d);
}
 
// The area hyperbolic sine of `d`

double kk_std_num_float64_asinh(double d, kk_context_t* _ctx) { /* (d : float64) -> float64 */ 
  return asinh(d);
}
 
// The area hyperbolic tangent of `d`

double kk_std_num_float64_atanh(double d, kk_context_t* _ctx) { /* (d : float64) -> float64 */ 
  return atanh(d);
}
 
// Low-level: return the bits of a 64-bit `:float64` as in `:int64`

int64_t kk_std_num_float64_float64_to_bits(double d, kk_context_t* _ctx) { /* (d : float64) -> int64 */ 
  return kk_double_to_bits(d,kk_context());
}
 
// Extend a `:float32` to a `:float64`

double kk_std_num_float64_float64(float f, kk_context_t* _ctx) { /* (f : float32) -> float64 */ 
  return (double)(f);
}
 
// Low-level: create a `:float64` from the given 64-bit integer.

double kk_std_num_float64_float64_from_bits(int64_t i, kk_context_t* _ctx) { /* (i : int64) -> float64 */ 
  return kk_double_from_bits(i,kk_context());
}

double kk_std_num_float64_make_neginf(kk_context_t* _ctx) { /* () -> float64 */ 
  return -HUGE_VAL;
}

double kk_std_num_float64_make_posinf(kk_context_t* _ctx) { /* () -> float64 */ 
  return HUGE_VAL;
}
 
// Round a `:float64` to a `:float32`

float kk_std_num_float64_float32(double f, kk_context_t* _ctx) { /* (f : float64) -> float32 */ 
  return (float)(f);
}

kk_integer_t kk_std_num_float64_flt_max_prec;
 
// fused multiply-add. Computes `(x*y)+z` as if to infinite precision
// with only the final result rounded back to a `:float64`.

double kk_std_num_float64_fmadd(double x, double y, double z, kk_context_t* _ctx) { /* (x : float64, y : float64, z : float64) -> float64 */ 
  return fma(x,y,z);
}
 
// Return the sum of a list of floats.
// Uses [Kahan-Babu&scaron;kan-Neumaier summation](https://en.wikipedia.org/wiki/Kahan_summation_algorithm#Further_enhancements)
// to minimize rounding errors. This
// is more precise as Kahan summation and about as fast.
// `[1.0e3,1.0e97,1.0e3,-1.0e97].sum == 2000.0`
// while
// `[1.0e3,1.0e97,1.0e3,-1.0e97].foldl(0.0,(+)) == 0.0` (!)
// A. Neumaier, _Rundungsfehleranalyse einiger Verfahren zur Summation endlicher Summen_.
// Math. Mechanik, 54:39--51, 1974.


// lift anonymous function
struct kk_std_num_float64_sum_fun5378__t {
  struct kk_function_s _base;
  kk_ref_t loc;
  kk_ref_t loc0;
};
static kk_unit_t kk_std_num_float64_sum_fun5378(kk_function_t _fself, kk_box_t _b_4793, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_sum_fun5378(kk_ref_t loc, kk_ref_t loc0, kk_context_t* _ctx) {
  struct kk_std_num_float64_sum_fun5378__t* _self = kk_function_alloc_as(struct kk_std_num_float64_sum_fun5378__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_sum_fun5378, kk_context());
  _self->loc = loc;
  _self->loc0 = loc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_unit_t kk_std_num_float64_sum_fun5378(kk_function_t _fself, kk_box_t _b_4793, kk_context_t* _ctx) {
  struct kk_std_num_float64_sum_fun5378__t* _self = kk_function_as(struct kk_std_num_float64_sum_fun5378__t*, _fself, _ctx);
  kk_ref_t loc = _self->loc; /* local-var<672,float64> */
  kk_ref_t loc0 = _self->loc0; /* local-var<672,float64> */
  kk_drop_match(_self, {kk_ref_dup(loc, _ctx);kk_ref_dup(loc0, _ctx);}, {}, _ctx)
  double x_4798 = kk_double_unbox(_b_4793, KK_OWNED, _ctx); /*float64*/;
  double t;
  double _x5379;
  kk_box_t _x5380;
  kk_ref_t _x5381 = kk_ref_dup(loc, _ctx); /*local-var<672,float64>*/
  _x5380 = kk_ref_get(_x5381,kk_context()); /*264*/
  _x5379 = kk_double_unbox(_x5380, KK_OWNED, _ctx); /*float64*/
  t = (_x5379 + x_4798); /*float64*/
  double c;
  bool _match_5365;
  double _x5382;
  double _x5383;
  kk_box_t _x5384;
  kk_ref_t _x5385 = kk_ref_dup(loc, _ctx); /*local-var<672,float64>*/
  _x5384 = kk_ref_get(_x5385,kk_context()); /*264*/
  _x5383 = kk_double_unbox(_x5384, KK_OWNED, _ctx); /*float64*/
  _x5382 = kk_double_abs(_x5383); /*float64*/
  double _x5386 = kk_double_abs(x_4798); /*float64*/
  _match_5365 = (_x5382 >= _x5386); /*bool*/
  if (_match_5365) {
    double _x5387;
    double _x5388;
    kk_box_t _x5389;
    kk_ref_t _x5390 = kk_ref_dup(loc, _ctx); /*local-var<672,float64>*/
    _x5389 = kk_ref_get(_x5390,kk_context()); /*264*/
    _x5388 = kk_double_unbox(_x5389, KK_OWNED, _ctx); /*float64*/
    _x5387 = (_x5388 - t); /*float64*/
    c = (_x5387 + x_4798); /*float64*/
  }
  else {
    double _x5391 = (x_4798 - t); /*float64*/
    double _x5392;
    kk_box_t _x5393;
    kk_ref_t _x5394 = kk_ref_dup(loc, _ctx); /*local-var<672,float64>*/
    _x5393 = kk_ref_get(_x5394,kk_context()); /*264*/
    _x5392 = kk_double_unbox(_x5393, KK_OWNED, _ctx); /*float64*/
    c = (_x5391 + _x5392); /*float64*/
  }
  double _b_4787_4785;
  double _x5395;
  kk_box_t _x5396;
  kk_ref_t _x5397 = kk_ref_dup(loc0, _ctx); /*local-var<672,float64>*/
  _x5396 = kk_ref_get(_x5397,kk_context()); /*264*/
  _x5395 = kk_double_unbox(_x5396, KK_OWNED, _ctx); /*float64*/
  _b_4787_4785 = (_x5395 + c); /*float64*/
  kk_unit_t __ = kk_Unit;
  kk_unit_t _brw_5364 = kk_Unit;
  kk_ref_set_borrow(loc0,(kk_double_box(_b_4787_4785, _ctx)),kk_context());
  kk_ref_drop(loc0, _ctx);
  _brw_5364;
  kk_unit_t _brw_5363 = kk_Unit;
  kk_ref_set_borrow(loc,(kk_double_box(t, _ctx)),kk_context());
  kk_ref_drop(loc, _ctx);
  return _brw_5363;
}

double kk_std_num_float64_sum(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  kk_ref_t loc = kk_ref_alloc((kk_double_box(0x0p+0, _ctx)),kk_context()); /*local-var<672,float64>*/;
  kk_ref_t loc0 = kk_ref_alloc((kk_double_box(0x0p+0, _ctx)),kk_context()); /*local-var<672,float64>*/;
  kk_unit_t __0 = kk_Unit;
  kk_function_t _x5377;
  kk_ref_dup(loc, _ctx);
  kk_ref_dup(loc0, _ctx);
  _x5377 = kk_std_num_float64_new_sum_fun5378(loc, loc0, _ctx); /*(11277) -> 11278 ()*/
  kk_std_core_foreach(xs, _x5377, _ctx);
  double res0;
  double _x5398;
  kk_box_t _x5399;
  kk_ref_t _x5400 = kk_ref_dup(loc, _ctx); /*local-var<672,float64>*/
  _x5399 = kk_ref_get(_x5400,kk_context()); /*264*/
  _x5398 = kk_double_unbox(_x5399, KK_OWNED, _ctx); /*float64*/
  double _x5401;
  kk_box_t _x5402;
  kk_ref_t _x5403 = kk_ref_dup(loc0, _ctx); /*local-var<672,float64>*/
  _x5402 = kk_ref_get(_x5403,kk_context()); /*264*/
  _x5401 = kk_double_unbox(_x5402, KK_OWNED, _ctx); /*float64*/
  res0 = (_x5398 + _x5401); /*float64*/
  double res;
  kk_box_t _x5404 = kk_std_core_hnd_prompt_local_var(loc0, kk_double_box(res0, _ctx), _ctx); /*10459*/
  res = kk_double_unbox(_x5404, KK_OWNED, _ctx); /*float64*/
  kk_box_t _x5405 = kk_std_core_hnd_prompt_local_var(loc, kk_double_box(res, _ctx), _ctx); /*10459*/
  return kk_double_unbox(_x5405, KK_OWNED, _ctx);
}
 
// Is this value equal to negative or positive infinity ?

bool kk_std_num_float64_is_inf(double d, kk_context_t* _ctx) { /* (d : float64) -> bool */ 
  return isinf(d);
}
 
// Linear interpolation, calculating `x + t*(y - x)` but avoids troublesome edge cases.
// Follows the C++20 [specification](http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2019/p0811r3.html).
// In particular, if `x.is-finite && y.is-finite`, then:
// - exact: `lerp(x,y,0.0) == x` and  `lerp(x,y,1.0) == y`
// - monotonic: if `x <= y` and `t1 <= t2`, then `compare( lerp(x,y,t1), lerp(x,y,t2) ) <= Eq` (and other cases)
// - deterministic: only `lerp(x,x,flt-inf)` results in `nan`
// - bounded: `t<0.0 || t>1.0 || is-finite(lerp(x,y,t))`
// - consistent: `lerp(x,x,t) == x`

double kk_std_num_float64_lerp(double x, double y, double t, kk_context_t* _ctx) { /* (x : float64, y : float64, t : float64) -> float64 */ 
  bool _match_5341 = (x <= (0x0p+0)); /*bool*/;
  if (_match_5341) {
    bool _match_5352 = (y >= (0x0p+0)); /*bool*/;
    if (_match_5352) {
      double _x5406 = (t * y); /*float64*/
      double _x5407;
      double _x5408 = (0x1p0 - t); /*float64*/
      _x5407 = (_x5408 * x); /*float64*/
      return (_x5406 + _x5407);
    }
    {
      bool _match_5353 = (x >= (0x0p+0)); /*bool*/;
      if (_match_5353) {
        bool _match_5358 = (y <= (0x0p+0)); /*bool*/;
        if (_match_5358) {
          double _x5409 = (t * y); /*float64*/
          double _x5410;
          double _x5411 = (0x1p0 - t); /*float64*/
          _x5410 = (_x5411 * x); /*float64*/
          return (_x5409 + _x5410);
        }
        {
          bool _match_5359 = (t == 0x1p0); /*bool*/;
          if (_match_5359) {
            return y;
          }
          {
            double z;
            double _x5412;
            double _x5413 = (y - x); /*float64*/
            _x5412 = (t * _x5413); /*float64*/
            z = (x + _x5412); /*float64*/
            bool x0_4444 = (t > 0x1p0); /*bool*/;
            bool y0_4445 = (y > x); /*bool*/;
            bool _match_5360;
            if (x0_4444) {
              _match_5360 = y0_4445; /*bool*/
            }
            else {
              if (y0_4445) {
                _match_5360 = false; /*bool*/
              }
              else {
                _match_5360 = true; /*bool*/
              }
            }
            if (_match_5360) {
              bool _match_5362 = (y >= z); /*bool*/;
              if (_match_5362) {
                return y;
              }
              {
                return z;
              }
            }
            {
              bool _match_5361 = (y <= z); /*bool*/;
              if (_match_5361) {
                return y;
              }
              {
                return z;
              }
            }
          }
        }
      }
      {
        bool _match_5354 = (t == 0x1p0); /*bool*/;
        if (_match_5354) {
          return y;
        }
        {
          double z0;
          double _x5414;
          double _x5415 = (y - x); /*float64*/
          _x5414 = (t * _x5415); /*float64*/
          z0 = (x + _x5414); /*float64*/
          bool x3_4450 = (t > 0x1p0); /*bool*/;
          bool y3_4451 = (y > x); /*bool*/;
          bool _match_5355;
          if (x3_4450) {
            _match_5355 = y3_4451; /*bool*/
          }
          else {
            if (y3_4451) {
              _match_5355 = false; /*bool*/
            }
            else {
              _match_5355 = true; /*bool*/
            }
          }
          if (_match_5355) {
            bool _match_5357 = (y >= z0); /*bool*/;
            if (_match_5357) {
              return y;
            }
            {
              return z0;
            }
          }
          {
            bool _match_5356 = (y <= z0); /*bool*/;
            if (_match_5356) {
              return y;
            }
            {
              return z0;
            }
          }
        }
      }
    }
  }
  {
    bool _match_5342 = (x >= (0x0p+0)); /*bool*/;
    if (_match_5342) {
      bool _match_5347 = (y <= (0x0p+0)); /*bool*/;
      if (_match_5347) {
        double _x5416 = (t * y); /*float64*/
        double _x5417;
        double _x5418 = (0x1p0 - t); /*float64*/
        _x5417 = (_x5418 * x); /*float64*/
        return (_x5416 + _x5417);
      }
      {
        bool _match_5348 = (t == 0x1p0); /*bool*/;
        if (_match_5348) {
          return y;
        }
        {
          double z1;
          double _x5419;
          double _x5420 = (y - x); /*float64*/
          _x5419 = (t * _x5420); /*float64*/
          z1 = (x + _x5419); /*float64*/
          bool x6_4456 = (t > 0x1p0); /*bool*/;
          bool y6_4457 = (y > x); /*bool*/;
          bool _match_5349;
          if (x6_4456) {
            _match_5349 = y6_4457; /*bool*/
          }
          else {
            if (y6_4457) {
              _match_5349 = false; /*bool*/
            }
            else {
              _match_5349 = true; /*bool*/
            }
          }
          if (_match_5349) {
            bool _match_5351 = (y >= z1); /*bool*/;
            if (_match_5351) {
              return y;
            }
            {
              return z1;
            }
          }
          {
            bool _match_5350 = (y <= z1); /*bool*/;
            if (_match_5350) {
              return y;
            }
            {
              return z1;
            }
          }
        }
      }
    }
    {
      bool _match_5343 = (t == 0x1p0); /*bool*/;
      if (_match_5343) {
        return y;
      }
      {
        double z00;
        double _x5421;
        double _x5422 = (y - x); /*float64*/
        _x5421 = (t * _x5422); /*float64*/
        z00 = (x + _x5421); /*float64*/
        bool x9_4462 = (t > 0x1p0); /*bool*/;
        bool y9_4463 = (y > x); /*bool*/;
        bool _match_5344;
        if (x9_4462) {
          _match_5344 = y9_4463; /*bool*/
        }
        else {
          if (y9_4463) {
            _match_5344 = false; /*bool*/
          }
          else {
            _match_5344 = true; /*bool*/
          }
        }
        if (_match_5344) {
          bool _match_5346 = (y >= z00); /*bool*/;
          if (_match_5346) {
            return y;
          }
          {
            return z00;
          }
        }
        {
          bool _match_5345 = (y <= z00); /*bool*/;
          if (_match_5345) {
            return y;
          }
          {
            return z00;
          }
        }
      }
    }
  }
}

double kk_std_num_float64_make_nan(kk_context_t* _ctx) { /* () -> float64 */ 
  return (double)NAN;
}
 
// Return `nan` on failure

double kk_std_num_float64_prim_parse_float64(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> float64 */ 
  return kk_prim_parse_double(s,kk_context());
}
 
// Compare floats using a total ordering on the `:float64`.
// The ordering follows the `totalOrder` predicate as defined in IEEE 754-2008 exactly.
// The values are ordered in following order:
// negative quiet nan,
// negative signaling nan,
// `neginf`,
// -finite,
// -0.0,
// +0.0,
// finite,
// `posinf`,
// signaling nan,
// and quiet nan.

kk_std_core_types__order kk_std_num_float64_compare(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> order */ 
  int64_t bx = kk_std_num_float64_float64_to_bits(x, _ctx); /*int64*/;
  int64_t by = kk_std_num_float64_float64_to_bits(y, _ctx); /*int64*/;
  int64_t i_4468;
  int64_t _x5426 = (KK_I64(63)); /*int64*/
  i_4468 = kk_sar64(bx,_x5426); /*int64*/
  int64_t ix;
  int64_t _x5427;
  int64_t _x5428 = (KK_I64(1)); /*int64*/
  _x5427 = (int64_t)kk_shr64(i_4468,_x5428); /*int64*/
  ix = _x5427 ^ bx; /*int64*/
  int64_t i1_4472;
  int64_t _x5429 = (KK_I64(63)); /*int64*/
  i1_4472 = kk_sar64(by,_x5429); /*int64*/
  int64_t iy;
  int64_t _x5430;
  int64_t _x5431 = (KK_I64(1)); /*int64*/
  _x5430 = (int64_t)kk_shr64(i1_4472,_x5431); /*int64*/
  iy = _x5430 ^ by; /*int64*/
  bool _match_5338 = (ix < iy); /*bool*/;
  if (_match_5338) {
    return kk_std_core_types__new_Lt(_ctx);
  }
  {
    bool _match_5339 = (ix > iy); /*bool*/;
    if (_match_5339) {
      return kk_std_core_types__new_Gt(_ctx);
    }
    {
      return kk_std_core_types__new_Eq(_ctx);
    }
  }
}
 
// decode a normalized float64 (i.e. not subnormal)

kk_std_core_types__tuple2_ kk_std_num_float64_decode_normalized(double d, kk_std_core_types__optional e_adjust, kk_context_t* _ctx) { /* (d : float64, e-adjust : optional<int>) -> (int, int) */ 
  int64_t i = kk_std_num_float64_float64_to_bits(d, _ctx); /*int64*/;
  int64_t exp;
  int64_t _x5432;
  int64_t _x5433;
  int64_t _x5434 = (KK_I64(52)); /*int64*/
  _x5433 = (int64_t)kk_shr64(i,_x5434); /*int64*/
  int64_t _x5435 = (KK_I64(2047)); /*int64*/
  _x5432 = _x5433 & _x5435; /*int64*/
  int64_t _x5436 = (KK_I64(1043)); /*int64*/
  exp = (int64_t)((uint64_t)_x5432 - (uint64_t)_x5436); /*int64*/
  int64_t man;
  int64_t _x5437;
  int64_t _x5438 = (KK_I64(4503599627370495)); /*int64*/
  _x5437 = i & _x5438; /*int64*/
  int64_t _x5439 = (KK_I64(4503599627370496)); /*int64*/
  man = (int64_t)((uint64_t)_x5437 + (uint64_t)_x5439); /*int64*/
  kk_integer_t x0_4483 = kk_integer_from_int64(exp,kk_context()); /*int*/;
  kk_integer_t x_4481 = kk_integer_add_small_const(x0_4483, -32, _ctx); /*int*/;
  kk_integer_t _b_4814_4812;
  int64_t _x5440;
  bool _match_5337 = 0 > i; /*bool*/;
  if (_match_5337) {
    int64_t _x5441 = (KK_I64(0)); /*int64*/
    _x5440 = (int64_t)((uint64_t)_x5441 - (uint64_t)man); /*int64*/
  }
  else {
    _x5440 = man; /*int64*/
  }
  _b_4814_4812 = kk_integer_from_int64(_x5440,kk_context()); /*int*/
  kk_integer_t _b_4815_4813;
  kk_integer_t _x5442;
  if (kk_std_core_types__is_Optional(e_adjust, _ctx)) {
    kk_box_t _box_x4811 = e_adjust._cons.Optional.value;
    kk_integer_t _e_adjust_1099 = kk_integer_unbox(_box_x4811, _ctx);
    kk_integer_dup(_e_adjust_1099, _ctx);
    kk_std_core_types__optional_drop(e_adjust, _ctx);
    _x5442 = _e_adjust_1099; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(e_adjust, _ctx);
    _x5442 = kk_integer_from_small(0); /*int*/
  }
  _b_4815_4813 = kk_integer_add(x_4481,_x5442,kk_context()); /*int*/
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_4814_4812, _ctx), kk_integer_box(_b_4815_4813, _ctx), _ctx);
}
 
// Decode a float64 `d` into a tuple `(m,e)` of a mantissa `m` and exponent `e`
// such that `m`&middot;2^`e`^ =  `d` exactly. The mantissa `m` is
// always either 0 or in the range [2^52^, 2^53^). See also `frexp`.

kk_std_core_types__tuple2_ kk_std_num_float64_decode(double d, kk_context_t* _ctx) { /* (d : float64) -> (int, int) */ 
  bool _match_5333 = (d == (0x0p+0)); /*bool*/;
  if (_match_5333) {
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(kk_integer_from_small(0), _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
  }
  {
    bool _match_5334 = (d != (0x0p+0)); /*bool*/;
    if (_match_5334) {
      bool _match_5335;
      double _x5444 = kk_double_abs(d); /*float64*/
      _match_5335 = (_x5444 < (0x1p-1022)); /*bool*/
      if (_match_5335) {
        double _x5445 = (d * 0x1p54); /*float64*/
        kk_std_core_types__optional _x5446 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(-54), _ctx), _ctx); /*optional<116>*/
        return kk_std_num_float64_decode_normalized(_x5445, _x5446, _ctx);
      }
      {
        kk_std_core_types__optional _x5447 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(0), _ctx), _ctx); /*optional<116>*/
        return kk_std_num_float64_decode_normalized(d, _x5447, _ctx);
      }
    }
    {
      kk_std_core_types__optional _x5448 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(0), _ctx), _ctx); /*optional<116>*/
      return kk_std_num_float64_decode_normalized(d, _x5448, _ctx);
    }
  }
}

double kk_std_num_float64_rad2deg;

double kk_std_num_float64_deg2rad;
 
// Calculate 2&middot;^`e`^ for an integer `e`.
// Uses efficient bit conversion for exponents between  -1022 and 1023 and
// otherwise falls back to the regular `exp2` function converting `e` to a float64.

double kk_std_num_float64_exp2_1(kk_integer_t e, kk_context_t* _ctx) { /* (e : int) -> float64 */ 
  bool _match_5331 = kk_integer_gte_borrow(e,(kk_integer_from_small(-1022)),kk_context()); /*bool*/;
  if (_match_5331) {
    bool _match_5332 = kk_integer_lte_borrow(e,(kk_integer_from_small(1023)),kk_context()); /*bool*/;
    if (_match_5332) {
      int64_t i_4486;
      kk_integer_t _x5449 = kk_integer_add_small_const(e, 1023, _ctx); /*int*/
      i_4486 = kk_std_core_int64(_x5449, _ctx); /*int64*/
      int64_t _x5450;
      int64_t _x5451 = (KK_I64(52)); /*int64*/
      _x5450 = kk_shl64(i_4486,_x5451); /*int64*/
      return kk_std_num_float64_float64_from_bits(_x5450, _ctx);
    }
    {
      double _x5452 = kk_integer_as_double(e,kk_context()); /*float64*/
      return exp2(_x5452);
    }
  }
  {
    double _x5453 = kk_integer_as_double(e,kk_context()); /*float64*/
    return exp2(_x5453);
  }
}
 
// Negative infinity

double kk_std_num_float64_neginf;
 
// Positive infinity

double kk_std_num_float64_posinf;
 
// 'Load exponent': returns `x`&middot;2^`e`^ for a `is-finite` `x` and
// otherwise `x` itself. See also `encode` which loads an integer mantissa.

double kk_std_num_float64_ldexp(double x, kk_integer_t e, kk_context_t* _ctx) { /* (x : float64, e : int) -> float64 */ 
  bool b_4490 = isfinite(x); /*bool*/;
  if (b_4490) {
    bool _match_5323 = kk_integer_gte_borrow(e,(kk_integer_from_small(-1022)),kk_context()); /*bool*/;
    if (_match_5323) {
      bool _match_5327 = kk_integer_lte_borrow(e,(kk_integer_from_small(1023)),kk_context()); /*bool*/;
      if (_match_5327) {
        double _x5455 = kk_std_num_float64_exp2_1(e, _ctx); /*float64*/
        return (x * _x5455);
      }
      {
        bool _match_5328 = kk_integer_lte_borrow(e,(kk_integer_from_small(2046)),kk_context()); /*bool*/;
        if (_match_5328) {
          double x1_4493 = (x * 0x1p1023); /*float64*/;
          kk_integer_t e1_4494 = kk_integer_add_small_const(e, -1023, _ctx); /*int*/;
          double _x5456 = kk_std_num_float64_exp2_1(e1_4494, _ctx); /*float64*/
          return (x1_4493 * _x5456);
        }
        {
          bool _match_5329 = kk_integer_lte_borrow(e,(kk_integer_from_small(3069)),kk_context()); /*bool*/;
          if (_match_5329) {
            double x3_4497;
            double _x5457 = (x * 0x1p1023); /*float64*/
            x3_4497 = (_x5457 * 0x1p1023); /*float64*/
            kk_integer_t e2_4498 = kk_integer_add_small_const(e, -2046, _ctx); /*int*/;
            double _x5458 = kk_std_num_float64_exp2_1(e2_4498, _ctx); /*float64*/
            return (x3_4497 * _x5458);
          }
          {
            kk_integer_drop(e, _ctx);
            bool _match_5330 = (x < (0x0p+0)); /*bool*/;
            if (_match_5330) {
              return kk_std_num_float64_neginf;
            }
            {
              return kk_std_num_float64_posinf;
            }
          }
        }
      }
    }
    {
      bool _match_5324 = kk_integer_gte_borrow(e,(kk_integer_from_small(-2044)),kk_context()); /*bool*/;
      if (_match_5324) {
        double x5_4501 = (x * (0x1p-1022)); /*float64*/;
        kk_integer_t e3_4502 = kk_integer_add_small_const(e, 1022, _ctx); /*int*/;
        double _x5459 = kk_std_num_float64_exp2_1(e3_4502, _ctx); /*float64*/
        return (x5_4501 * _x5459);
      }
      {
        bool _match_5325 = kk_integer_gte_borrow(e,(kk_integer_from_small(-3066)),kk_context()); /*bool*/;
        if (_match_5325) {
          double x7_4505;
          double _x5460 = (x * (0x1p-1022)); /*float64*/
          x7_4505 = (_x5460 * (0x1p-1022)); /*float64*/
          kk_integer_t e4_4506 = kk_integer_add_small_const(e, 2044, _ctx); /*int*/;
          double _x5461 = kk_std_num_float64_exp2_1(e4_4506, _ctx); /*float64*/
          return (x7_4505 * _x5461);
        }
        {
          kk_integer_drop(e, _ctx);
          bool _match_5326 = (x < (0x0p+0)); /*bool*/;
          if (_match_5326) {
            return -0x0p+0;
          }
          {
            return 0x0p+0;
          }
        }
      }
    }
  }
  {
    kk_integer_drop(e, _ctx);
    return x;
  }
}
 
// 'Fraction/exponent': return the normalized fraction `f` and exponent `exp`
// for a number `x` such that `x == f`&middot;2^`exp`^.
// The absolute value of the fraction `f` is always in the range [0.5, 1.0), or
// one of `0.0`, `-0.0`, `neginf`, `posinf`, or `nan`.
// See also `decode` which  decodes to an integer mantissa.

kk_std_core_types__tuple2_ kk_std_num_float64_frexp(double x, kk_context_t* _ctx) { /* (x : float64) -> (float64, int) */ 
  bool b_4510 = isfinite(x); /*bool*/;
  if (b_4510) {
    bool _match_5318 = (x == (0x0p+0)); /*bool*/;
    if (_match_5318) {
      bool _match_5320;
      double _x5465 = (0x1p0 / x); /*float64*/
      _match_5320 = (isinf(_x5465) && signbit(_x5465)); /*bool*/
      if (_match_5320) {
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(x, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
      }
      {
        kk_std_core_types__tuple2_ _match_5321 = kk_std_num_float64_decode(x, _ctx); /*(int, int)*/;
        {
          kk_box_t _box_x4828 = _match_5321.fst;
          kk_box_t _box_x4829 = _match_5321.snd;
          kk_integer_t m = kk_integer_unbox(_box_x4828, _ctx);
          kk_integer_t e = kk_integer_unbox(_box_x4829, _ctx);
          kk_integer_dup(e, _ctx);
          kk_integer_dup(m, _ctx);
          kk_std_core_types__tuple2__drop(_match_5321, _ctx);
          double _b_4840_4830;
          double _x5466 = kk_integer_as_double(m,kk_context()); /*float64*/
          _b_4840_4830 = (_x5466 * (0x1p-53)); /*float64*/
          kk_integer_t _b_4841_4831 = kk_integer_add_small_const(e, 53, _ctx); /*int*/;
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_4840_4830, _ctx), kk_integer_box(_b_4841_4831, _ctx), _ctx);
        }
      }
    }
    {
      kk_std_core_types__tuple2_ _match_5319 = kk_std_num_float64_decode(x, _ctx); /*(int, int)*/;
      {
        kk_box_t _box_x4832 = _match_5319.fst;
        kk_box_t _box_x4833 = _match_5319.snd;
        kk_integer_t m0 = kk_integer_unbox(_box_x4832, _ctx);
        kk_integer_t e0 = kk_integer_unbox(_box_x4833, _ctx);
        kk_integer_dup(e0, _ctx);
        kk_integer_dup(m0, _ctx);
        kk_std_core_types__tuple2__drop(_match_5319, _ctx);
        double _b_4842_4834;
        double _x5467 = kk_integer_as_double(m0,kk_context()); /*float64*/
        _b_4842_4834 = (_x5467 * (0x1p-53)); /*float64*/
        kk_integer_t _b_4843_4835 = kk_integer_add_small_const(e0, 53, _ctx); /*int*/;
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_4842_4834, _ctx), kk_integer_box(_b_4843_4835, _ctx), _ctx);
      }
    }
  }
  {
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(x, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
  }
}
 
// The hypotenuse of `x` and `y`: `sqrt(x*x + y*y)`.
// Prevents overflow for large numbers.

double kk_std_num_float64_hypot(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  double xx = kk_double_abs(x); /*float64*/;
  double yy = kk_double_abs(y); /*float64*/;
  double lo;
  bool _match_5317 = (xx <= yy); /*bool*/;
  if (_match_5317) {
    lo = xx; /*float64*/
  }
  else {
    lo = yy; /*float64*/
  }
  double hi;
  bool _match_5316 = (xx >= yy); /*bool*/;
  if (_match_5316) {
    hi = xx; /*float64*/
  }
  else {
    hi = yy; /*float64*/
  }
  bool _match_5315 = (hi == (0x0p+0)); /*bool*/;
  if (_match_5315) {
    return 0x0p+0;
  }
  {
    double z = (lo / hi); /*float64*/;
    double _x5468;
    double _x5469;
    double _x5470 = (z * z); /*float64*/
    _x5469 = (0x1p0 + _x5470); /*float64*/
    _x5468 = sqrt(_x5469); /*float64*/
    return (hi * _x5468);
  }
}
 
// The square root of the sum of the squares of three floats.
// Prevents overflow for large numbers.

double kk_std_num_float64_hypot_1(double x, double y, double z, kk_context_t* _ctx) { /* (x : float64, y : float64, z : float64) -> float64 */ 
  double xx = kk_double_abs(x); /*float64*/;
  double yy = kk_double_abs(y); /*float64*/;
  double zz = kk_double_abs(z); /*float64*/;
  double x0_4518;
  bool _match_5314 = (xx >= yy); /*bool*/;
  if (_match_5314) {
    x0_4518 = xx; /*float64*/
  }
  else {
    x0_4518 = yy; /*float64*/
  }
  double hi;
  bool _match_5313 = (x0_4518 >= zz); /*bool*/;
  if (_match_5313) {
    hi = x0_4518; /*float64*/
  }
  else {
    hi = zz; /*float64*/
  }
  bool _match_5312 = (hi == (0x0p+0)); /*bool*/;
  if (_match_5312) {
    return 0x0p+0;
  }
  {
    double x4_4524 = (zz / hi); /*float64*/;
    double x2_4522 = (xx / hi); /*float64*/;
    double x3_4523 = (yy / hi); /*float64*/;
    double _x5471;
    double _x5472;
    double _x5473;
    double _x5474 = (x2_4522 * x2_4522); /*float64*/
    double _x5475 = (x3_4523 * x3_4523); /*float64*/
    _x5473 = (_x5474 + _x5475); /*float64*/
    double _x5476 = (x4_4524 * x4_4524); /*float64*/
    _x5472 = (_x5473 + _x5476); /*float64*/
    _x5471 = sqrt(_x5472); /*float64*/
    return (hi * _x5471);
  }
}
 
// The square root of the sum of squares of a list of floats.
// Prevents overflow for large numbers and uses Kahan-Babu&scaron;kan-Neumaier summation
// for precision.


// lift anonymous function
struct kk_std_num_float64_hypot_fun5479__t_2 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_hypot_fun5479_2(kk_function_t _fself, kk_box_t _b_4849, kk_box_t _b_4850, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_hypot_fun5479_2(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_hypot_fun5479_2, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_hypot_fun5479_2(kk_function_t _fself, kk_box_t _b_4849, kk_box_t _b_4850, kk_context_t* _ctx) {
  kk_unused(_fself);
  double x0_4441;
  double _x5480 = kk_double_unbox(_b_4850, KK_OWNED, _ctx); /*float64*/
  x0_4441 = kk_double_abs(_x5480); /*float64*/
  double _x5481;
  bool _match_5311;
  double _x5482;
  kk_box_t _x5483 = kk_box_dup(_b_4849, _ctx); /*12696*/
  _x5482 = kk_double_unbox(_x5483, KK_OWNED, _ctx); /*float64*/
  _match_5311 = (x0_4441 >= _x5482); /*bool*/
  if (_match_5311) {
    kk_box_drop(_b_4849, _ctx);
    _x5481 = x0_4441; /*float64*/
  }
  else {
    _x5481 = kk_double_unbox(_b_4849, KK_OWNED, _ctx); /*float64*/
  }
  return kk_double_box(_x5481, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_hypot_fun5485__t_2 {
  struct kk_function_s _base;
  double hi;
};
static double kk_std_num_float64_hypot_fun5485_2(kk_function_t _fself, double x0, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_hypot_fun5485_2(double hi, kk_context_t* _ctx) {
  struct kk_std_num_float64_hypot_fun5485__t_2* _self = kk_function_alloc_as(struct kk_std_num_float64_hypot_fun5485__t_2, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_hypot_fun5485_2, kk_context());
  _self->hi = hi;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static double kk_std_num_float64_hypot_fun5485_2(kk_function_t _fself, double x0, kk_context_t* _ctx) {
  struct kk_std_num_float64_hypot_fun5485__t_2* _self = kk_function_as(struct kk_std_num_float64_hypot_fun5485__t_2*, _fself, _ctx);
  double hi = _self->hi; /* float64 */
  kk_drop_match(_self, {;}, {}, _ctx)
  double x0_4525 = (x0 / hi); /*float64*/;
  return (x0_4525 * x0_4525);
}


// lift anonymous function
struct kk_std_num_float64_hypot_fun5488__t_2 {
  struct kk_function_s _base;
  kk_function_t _b_4860_4857;
};
static kk_box_t kk_std_num_float64_hypot_fun5488_2(kk_function_t _fself, kk_box_t _b_4858, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_hypot_fun5488_2(kk_function_t _b_4860_4857, kk_context_t* _ctx) {
  struct kk_std_num_float64_hypot_fun5488__t_2* _self = kk_function_alloc_as(struct kk_std_num_float64_hypot_fun5488__t_2, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_hypot_fun5488_2, kk_context());
  _self->_b_4860_4857 = _b_4860_4857;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_hypot_fun5488_2(kk_function_t _fself, kk_box_t _b_4858, kk_context_t* _ctx) {
  struct kk_std_num_float64_hypot_fun5488__t_2* _self = kk_function_as(struct kk_std_num_float64_hypot_fun5488__t_2*, _fself, _ctx);
  kk_function_t _b_4860_4857 = _self->_b_4860_4857; /* (x0 : float64) -> float64 */
  kk_drop_match(_self, {kk_function_dup(_b_4860_4857, _ctx);}, {}, _ctx)
  double _x5489;
  double _x5490 = kk_double_unbox(_b_4858, KK_OWNED, _ctx); /*float64*/
  _x5489 = kk_function_call(double, (kk_function_t, double, kk_context_t*), _b_4860_4857, (_b_4860_4857, _x5490, _ctx), _ctx); /*float64*/
  return kk_double_box(_x5489, _ctx);
}

double kk_std_num_float64_hypot_2(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  double hi;
  kk_box_t _x5477;
  kk_std_core__list _x5478 = kk_std_core__list_dup(xs, _ctx); /*list<float64>*/
  _x5477 = kk_std_core_foldl(_x5478, kk_double_box(0x0p+0, _ctx), kk_std_num_float64_new_hypot_fun5479_2(_ctx), _ctx); /*12696*/
  hi = kk_double_unbox(_x5477, KK_OWNED, _ctx); /*float64*/
  bool _match_5310 = (hi == (0x0p+0)); /*bool*/;
  if (_match_5310) {
    kk_std_core__list_drop(xs, _ctx);
    return 0x0p+0;
  }
  {
    double _x5484;
    kk_std_core__list _b_4859_4856 = xs; /*list<float64>*/;
    kk_function_t _b_4860_4857 = kk_std_num_float64_new_hypot_fun5485_2(hi, _ctx); /*(x0 : float64) -> float64*/;
    double _x5486;
    kk_std_core__list _x5487 = kk_std_core_map_5(_b_4859_4856, kk_std_num_float64_new_hypot_fun5488_2(_b_4860_4857, _ctx), _ctx); /*list<6253>*/
    _x5486 = kk_std_num_float64_sum(_x5487, _ctx); /*float64*/
    _x5484 = sqrt(_x5486); /*float64*/
    return (hi * _x5484);
  }
}
 
// Returns `ln(exp(x) + exp(y))`.
// Avoids overlow/underflow errors.

double kk_std_num_float64_lnaddexp(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  bool _match_5308 = (x == y); /*bool*/;
  if (_match_5308) {
    return (x + (0x1.62e42fefa39efp-1));
  }
  {
    double z = (x - y); /*float64*/;
    bool _match_5309 = (z > (0x0p+0)); /*bool*/;
    if (_match_5309) {
      double _x5491;
      double _x5492;
      double _x5493 = (-z); /*float64*/
      _x5492 = exp(_x5493); /*float64*/
      _x5491 = log1p(_x5492); /*float64*/
      return (x + _x5491);
    }
    {
      double _x5494;
      double _x5495 = exp(z); /*float64*/
      _x5494 = log1p(_x5495); /*float64*/
      return (y + _x5494);
    }
  }
}
 
// Returns `log2( exp2(x) + exp2(y) )`.
// Avoids overlow/underflow errors.

double kk_std_num_float64_logaddexp2(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  bool _match_5306 = (x == y); /*bool*/;
  if (_match_5306) {
    return (x + 0x1p0);
  }
  {
    double z = (x - y); /*float64*/;
    bool _match_5307 = (z > (0x0p+0)); /*bool*/;
    if (_match_5307) {
      double x0_4526;
      double _x5497 = (-z); /*float64*/
      x0_4526 = exp2(_x5497); /*float64*/
      double _x5498;
      double _x5499 = log1p(x0_4526); /*float64*/
      _x5498 = ((0x1.71547652b82fep0) * _x5499); /*float64*/
      return (x + _x5498);
    }
    {
      double x1_4527 = exp2(z); /*float64*/;
      double _x5500;
      double _x5501 = log1p(x1_4527); /*float64*/
      _x5500 = ((0x1.71547652b82fep0) * _x5501); /*float64*/
      return (y + _x5500);
    }
  }
}
 
// The midpoint is the average of `x` and `y`.
// Avoids overflow on large numbers.

double kk_std_num_float64_midpoint(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  bool _match_5300 = (x != (0x0p+0)); /*bool*/;
  if (_match_5300) {
    bool _match_5303;
    double _x5502 = kk_double_abs(x); /*float64*/
    _match_5303 = (_x5502 < (0x1p-1022)); /*bool*/
    if (_match_5303) {
      double _x5503 = (x + y); /*float64*/
      return (_x5503 / 0x1p1);
    }
    {
      bool _match_5304 = (y != (0x0p+0)); /*bool*/;
      if (_match_5304) {
        bool _match_5305;
        double _x5504 = kk_double_abs(y); /*float64*/
        _match_5305 = (_x5504 < (0x1p-1022)); /*bool*/
        if (_match_5305) {
          double _x5505 = (x + y); /*float64*/
          return (_x5505 / 0x1p1);
        }
        {
          double _x5506 = (x / 0x1p1); /*float64*/
          double _x5507 = (y / 0x1p1); /*float64*/
          return (_x5506 + _x5507);
        }
      }
      {
        double _x5508 = (x / 0x1p1); /*float64*/
        double _x5509 = (y / 0x1p1); /*float64*/
        return (_x5508 + _x5509);
      }
    }
  }
  {
    bool _match_5301 = (y != (0x0p+0)); /*bool*/;
    if (_match_5301) {
      bool _match_5302;
      double _x5510 = kk_double_abs(y); /*float64*/
      _match_5302 = (_x5510 < (0x1p-1022)); /*bool*/
      if (_match_5302) {
        double _x5511 = (x + y); /*float64*/
        return (_x5511 / 0x1p1);
      }
      {
        double _x5512 = (x / 0x1p1); /*float64*/
        double _x5513 = (y / 0x1p1); /*float64*/
        return (_x5512 + _x5513);
      }
    }
    {
      double _x5514 = (x / 0x1p1); /*float64*/
      double _x5515 = (y / 0x1p1); /*float64*/
      return (_x5514 + _x5515);
    }
  }
}
 
// Represents a value that is _not a number_ (NaN)

double kk_std_num_float64_nan;
 
// Return if two floats are nearly equal with respect to some `epsilon` (=`8*flt-epsilon`).
// The epsilon is the nearest difference for numbers around 1.0. The routine automatically
// scales the epsilon for larger and smaller numbers, and for subnormal numbers.

bool kk_std_num_float64_nearly_eq(double x, double y, kk_std_core_types__optional epsilon, kk_context_t* _ctx) { /* (x : float64, y : float64, epsilon : optional<float64>) -> bool */ 
  double _epsilon_2963;
  if (kk_std_core_types__is_Optional(epsilon, _ctx)) {
    kk_box_t _box_x4861 = epsilon._cons.Optional.value;
    double _epsilon_2964 = kk_double_unbox(_box_x4861, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(epsilon, _ctx);
    _epsilon_2963 = _epsilon_2964; /*float64*/
  }
  else {
    kk_std_core_types__optional_drop(epsilon, _ctx);
    _epsilon_2963 = (0x1p3 * (0x1p-52)); /*float64*/
  }
  bool _match_5295 = (x == y); /*bool*/;
  if (_match_5295) {
    return true;
  }
  {
    double diff;
    double _x5516 = (x - y); /*float64*/
    diff = kk_double_abs(_x5516); /*float64*/
    bool _match_5296 = (x == (0x0p+0)); /*bool*/;
    if (_match_5296) {
      double _x5517 = (0x1p1 * diff); /*float64*/
      double _x5518 = (_epsilon_2963 * (0x1p-1022)); /*float64*/
      return (_x5517 < _x5518);
    }
    {
      bool _match_5297 = (y == (0x0p+0)); /*bool*/;
      if (_match_5297) {
        double _x5519 = (0x1p1 * diff); /*float64*/
        double _x5520 = (_epsilon_2963 * (0x1p-1022)); /*float64*/
        return (_x5519 < _x5520);
      }
      {
        bool _match_5298 = (diff < (0x1p-1022)); /*bool*/;
        if (_match_5298) {
          double _x5521 = (0x1p1 * diff); /*float64*/
          double _x5522 = (_epsilon_2963 * (0x1p-1022)); /*float64*/
          return (_x5521 < _x5522);
        }
        {
          double sum0;
          double _x5523 = kk_double_abs(x); /*float64*/
          double _x5524 = kk_double_abs(y); /*float64*/
          sum0 = (_x5523 + _x5524); /*float64*/
          double _x5525;
          double _x5526 = (0x1p1 * diff); /*float64*/
          double _x5527;
          bool _match_5299 = (sum0 > (0x1.fffffffffffffp1023)); /*bool*/;
          if (_match_5299) {
            _x5527 = 0x1.fffffffffffffp1023; /*float64*/
          }
          else {
            _x5527 = sum0; /*float64*/
          }
          _x5525 = (_x5526 / _x5527); /*float64*/
          return (_x5525 < _epsilon_2963);
        }
      }
    }
  }
}
 
// Returns the greatest `:float64` less than `x`.
// This behaves exactly as `nextDown` in the IEEE 754-2008 standard.
// The identity `x.next-down == ~next-down(~x)` holds for all `x`.
// When `x` is finite `x == x.next-down.next-up` also holds.

double kk_std_num_float64_next_down(double x, kk_context_t* _ctx) { /* (x : float64) -> float64 */ 
  bool _match_5291 = isnan(x); /*bool*/;
  if (_match_5291) {
    return x;
  }
  {
    bool _match_5292 = (isinf(x) && signbit(x)); /*bool*/;
    if (_match_5292) {
      return x;
    }
    {
      bool _match_5293 = (x == (0x0p+0)); /*bool*/;
      if (_match_5293) {
        return (-(0x1p-1074));
      }
      {
        int64_t i = kk_std_num_float64_float64_to_bits(x, _ctx); /*int64*/;
        int64_t next;
        bool _match_5294 = 0 > i; /*bool*/;
        if (_match_5294) {
          int64_t _x5528 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i + (uint64_t)_x5528); /*int64*/
        }
        else {
          int64_t _x5529 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i - (uint64_t)_x5529); /*int64*/
        }
        return kk_std_num_float64_float64_from_bits(next, _ctx);
      }
    }
  }
}
 
// Returns the least `:float64` greater than `x`.
// This behaves exactly as `nextUp` in the IEEE 754-2008 standard.
// The identity `x.next-up == ~next-down(~x)` holds for all `x`.
// When `x` is finite `x == x.next-up.next-down` also holds.

double kk_std_num_float64_next_up(double x, kk_context_t* _ctx) { /* (x : float64) -> float64 */ 
  bool _match_5287 = isnan(x); /*bool*/;
  if (_match_5287) {
    return x;
  }
  {
    bool _match_5288 = (isinf(x) && !signbit(x)); /*bool*/;
    if (_match_5288) {
      return x;
    }
    {
      bool _match_5289 = (x == (0x0p+0)); /*bool*/;
      if (_match_5289) {
        return 0x1p-1074;
      }
      {
        int64_t i = kk_std_num_float64_float64_to_bits(x, _ctx); /*int64*/;
        int64_t next;
        bool _match_5290 = 0 > i; /*bool*/;
        if (_match_5290) {
          int64_t _x5530 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i - (uint64_t)_x5530); /*int64*/
        }
        else {
          int64_t _x5531 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i + (uint64_t)_x5531); /*int64*/
        }
        return kk_std_num_float64_float64_from_bits(next, _ctx);
      }
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4603_pdecdouble_fun5533__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4603_pdecdouble_fun5533(kk_function_t _fself, kk_box_t _b_4864, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4603_pdecdouble_fun5533(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4603_pdecdouble_fun5533, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4603_pdecdouble_fun5533(kk_function_t _fself, kk_box_t _b_4864, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5534;
  kk_string_t _x5535 = kk_string_unbox(_b_4864); /*string*/
  _x5534 = kk_std_num_float64_prim_parse_float64(_x5535, _ctx); /*float64*/
  return kk_double_box(_x5534, _ctx);
}

double kk_std_num_float64__mlift4603_pdecdouble(kk_std_core__sslice cur, kk_integer_t exp, kk_context_t* _ctx) { /* (cur : sslice, exp : int) -> std/text/parse/parse float64 */ 
  kk_integer_drop(exp, _ctx);
  kk_string_t _x1_4595 = kk_std_core_string_3(cur, _ctx); /*string*/;
  kk_box_t _x5532 = kk_std_core_hnd__open_none1(kk_std_num_float64__new_mlift4603_pdecdouble_fun5533(_ctx), kk_string_box(_x1_4595), _ctx); /*3357*/
  return kk_double_unbox(_x5532, KK_OWNED, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4605_pdecdouble_fun5539__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4605_pdecdouble_fun5539(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4605_pdecdouble_fun5539(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4605_pdecdouble_fun5539, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4605_pdecdouble_fun5544__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4605_pdecdouble_fun5544(kk_function_t _fself, kk_box_t _b_4868, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4605_pdecdouble_fun5544(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4605_pdecdouble_fun5544, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4605_pdecdouble_fun5544(kk_function_t _fself, kk_box_t _b_4868, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x5545;
  kk_char_t _x5546 = kk_char_unbox(_b_4868, KK_OWNED, _ctx); /*char*/
  _x5545 = kk_std_num_float64__mlift4602_pdecdouble(_x5546, _ctx); /*int*/
  return kk_integer_box(_x5545, _ctx);
}
static kk_box_t kk_std_num_float64__mlift4605_pdecdouble_fun5539(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_char_t x0_4631;
  kk_string_t _x5540;
  kk_define_string_literal(, _s5541, 2, "eE", _ctx)
  _x5540 = kk_string_dup(_s5541, _ctx); /*string*/
  x0_4631 = kk_std_text_parse_one_of(_x5540, _ctx); /*char*/
  kk_integer_t _x5542;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5543 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4605_pdecdouble_fun5544(_ctx), _ctx); /*3926*/
    _x5542 = kk_integer_unbox(_x5543, _ctx); /*int*/
  }
  else {
    _x5542 = kk_std_text_parse_pint(_ctx); /*int*/
  }
  return kk_integer_box(_x5542, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4605_pdecdouble_fun5547__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4605_pdecdouble_fun5547(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4605_pdecdouble_fun5547(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4605_pdecdouble_fun5547, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4605_pdecdouble_fun5547(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  return kk_integer_box(kk_integer_from_small(0), _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4605_pdecdouble_fun5548__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static double kk_std_num_float64__mlift4605_pdecdouble_fun5548(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4605_pdecdouble_fun5548(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4605_pdecdouble_fun5548__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4605_pdecdouble_fun5548__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4605_pdecdouble_fun5548, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4605_pdecdouble_fun5550__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4605_pdecdouble_fun5550(kk_function_t _fself, kk_box_t _b_4876, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4605_pdecdouble_fun5550(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4605_pdecdouble_fun5550, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4605_pdecdouble_fun5550(kk_function_t _fself, kk_box_t _b_4876, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5551;
  kk_string_t _x5552 = kk_string_unbox(_b_4876); /*string*/
  _x5551 = kk_std_num_float64_prim_parse_float64(_x5552, _ctx); /*float64*/
  return kk_double_box(_x5551, _ctx);
}
static double kk_std_num_float64__mlift4605_pdecdouble_fun5548(kk_function_t _fself, kk_integer_t exp, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4605_pdecdouble_fun5548__t* _self = kk_function_as(struct kk_std_num_float64__mlift4605_pdecdouble_fun5548__t*, _fself, _ctx);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur, _ctx);}, {}, _ctx)
  kk_integer_drop(exp, _ctx);
  kk_string_t _x1_4595 = kk_std_core_string_3(cur, _ctx); /*string*/;
  kk_box_t _x5549 = kk_std_core_hnd__open_none1(kk_std_num_float64__new_mlift4605_pdecdouble_fun5550(_ctx), kk_string_box(_x1_4595), _ctx); /*3357*/
  return kk_double_unbox(_x5549, KK_OWNED, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4605_pdecdouble_fun5554__t {
  struct kk_function_s _base;
  kk_function_t next_4630;
};
static kk_box_t kk_std_num_float64__mlift4605_pdecdouble_fun5554(kk_function_t _fself, kk_box_t _b_4880, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4605_pdecdouble_fun5554(kk_function_t next_4630, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4605_pdecdouble_fun5554__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4605_pdecdouble_fun5554__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4605_pdecdouble_fun5554, kk_context());
  _self->next_4630 = next_4630;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4605_pdecdouble_fun5554(kk_function_t _fself, kk_box_t _b_4880, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4605_pdecdouble_fun5554__t* _self = kk_function_as(struct kk_std_num_float64__mlift4605_pdecdouble_fun5554__t*, _fself, _ctx);
  kk_function_t next_4630 = _self->next_4630; /* (int) -> std/text/parse/parse float64 */
  kk_drop_match(_self, {kk_function_dup(next_4630, _ctx);}, {}, _ctx)
  double _x5555;
  kk_integer_t _x5556 = kk_integer_unbox(_b_4880, _ctx); /*int*/
  _x5555 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), next_4630, (next_4630, _x5556, _ctx), _ctx); /*float64*/
  return kk_double_box(_x5555, _ctx);
}

double kk_std_num_float64__mlift4605_pdecdouble(kk_std_core__sslice cur, kk_string_t _y_4563, kk_context_t* _ctx) { /* (cur : sslice, string) -> std/text/parse/parse float64 */ 
  kk_string_t frac;
  kk_string_t _x5536;
  kk_define_string_literal(, _s5537, 1, "0", _ctx)
  _x5536 = kk_string_dup(_s5537, _ctx); /*string*/
  frac = kk_std_core_trim_right_1(_y_4563, _x5536, _ctx); /*string*/
  kk_string_drop(frac, _ctx);
  kk_integer_t x_4629;
  kk_box_t _x5538 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64__new_mlift4605_pdecdouble_fun5539(_ctx), kk_std_num_float64__new_mlift4605_pdecdouble_fun5547(_ctx), _ctx); /*944*/
  x_4629 = kk_integer_unbox(_x5538, _ctx); /*int*/
  kk_function_t next_4630 = kk_std_num_float64__new_mlift4605_pdecdouble_fun5548(cur, _ctx); /*(int) -> std/text/parse/parse float64*/;
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_4629, _ctx);
    kk_box_t _x5553 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4605_pdecdouble_fun5554(next_4630, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5553, KK_OWNED, _ctx);
  }
  {
    return kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), next_4630, (next_4630, x_4629, _ctx), _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4606_pdecdouble_fun5558__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4606_pdecdouble_fun5558(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4606_pdecdouble_fun5558(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4606_pdecdouble_fun5558, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4606_pdecdouble_fun5561__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4606_pdecdouble_fun5561(kk_function_t _fself, kk_box_t _b_4883, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4606_pdecdouble_fun5561(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4606_pdecdouble_fun5561, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4606_pdecdouble_fun5561(kk_function_t _fself, kk_box_t _b_4883, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x5562;
  kk_char_t _x5563 = kk_char_unbox(_b_4883, KK_OWNED, _ctx); /*char*/
  _x5562 = kk_std_num_float64__mlift4604_pdecdouble(_x5563, _ctx); /*string*/
  return kk_string_box(_x5562);
}
static kk_box_t kk_std_num_float64__mlift4606_pdecdouble_fun5558(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_char_t x0_4637 = kk_std_text_parse_char('.', _ctx); /*char*/;
  kk_string_t _x5559;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5560 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4606_pdecdouble_fun5561(_ctx), _ctx); /*3926*/
    _x5559 = kk_string_unbox(_x5560); /*string*/
  }
  else {
    _x5559 = kk_std_text_parse_digits0(_ctx); /*string*/
  }
  return kk_string_box(_x5559);
}


// lift anonymous function
struct kk_std_num_float64__mlift4606_pdecdouble_fun5564__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4606_pdecdouble_fun5564(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4606_pdecdouble_fun5564(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4606_pdecdouble_fun5564, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4606_pdecdouble_fun5564(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x5565 = kk_string_empty(); /*string*/
  return kk_string_box(_x5565);
}


// lift anonymous function
struct kk_std_num_float64__mlift4606_pdecdouble_fun5568__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static kk_box_t kk_std_num_float64__mlift4606_pdecdouble_fun5568(kk_function_t _fself, kk_box_t _b_4890, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4606_pdecdouble_fun5568(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4606_pdecdouble_fun5568__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4606_pdecdouble_fun5568__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4606_pdecdouble_fun5568, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4606_pdecdouble_fun5568(kk_function_t _fself, kk_box_t _b_4890, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4606_pdecdouble_fun5568__t* _self = kk_function_as(struct kk_std_num_float64__mlift4606_pdecdouble_fun5568__t*, _fself, _ctx);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur, _ctx);}, {}, _ctx)
  kk_string_t _y_4892_4563 = kk_string_unbox(_b_4890); /*string*/;
  double _x5569 = kk_std_num_float64__mlift4605_pdecdouble(cur, _y_4892_4563, _ctx); /*float64*/
  return kk_double_box(_x5569, _ctx);
}

double kk_std_num_float64__mlift4606_pdecdouble(kk_std_core__sslice cur, kk_string_t man, kk_context_t* _ctx) { /* (cur : sslice, man : string) -> std/text/parse/parse float64 */ 
  kk_string_drop(man, _ctx);
  kk_string_t x_4635;
  kk_box_t _x5557 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64__new_mlift4606_pdecdouble_fun5558(_ctx), kk_std_num_float64__new_mlift4606_pdecdouble_fun5564(_ctx), _ctx); /*944*/
  x_4635 = kk_string_unbox(_x5557); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4635, _ctx);
    kk_box_t _x5567 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4606_pdecdouble_fun5568(cur, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5567, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4605_pdecdouble(cur, x_4635, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4607_pdecdouble_fun5571__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static kk_box_t kk_std_num_float64__mlift4607_pdecdouble_fun5571(kk_function_t _fself, kk_box_t _b_4894, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4607_pdecdouble_fun5571(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4607_pdecdouble_fun5571__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4607_pdecdouble_fun5571__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4607_pdecdouble_fun5571, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4607_pdecdouble_fun5571(kk_function_t _fself, kk_box_t _b_4894, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4607_pdecdouble_fun5571__t* _self = kk_function_as(struct kk_std_num_float64__mlift4607_pdecdouble_fun5571__t*, _fself, _ctx);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur, _ctx);}, {}, _ctx)
  kk_string_t man_4896 = kk_string_unbox(_b_4894); /*string*/;
  double _x5572 = kk_std_num_float64__mlift4606_pdecdouble(cur, man_4896, _ctx); /*float64*/
  return kk_double_box(_x5572, _ctx);
}

double kk_std_num_float64__mlift4607_pdecdouble(kk_std_core__sslice cur, kk_context_t* _ctx) { /* (cur : sslice) -> std/text/parse/parse float64 */ 
  kk_string_t x_4639 = kk_std_text_parse_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4639, _ctx);
    kk_box_t _x5570 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4607_pdecdouble_fun5571(cur, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5570, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4606_pdecdouble(cur, x_4639, _ctx);
  }
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5577__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5577(kk_function_t _fself, kk_box_t _b_4904, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5577(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5577, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5577(kk_function_t _fself, kk_box_t _b_4904, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5578;
  kk_std_core__sslice _x5579 = kk_std_core__sslice_unbox(_b_4904, KK_OWNED, _ctx); /*sslice*/
  _x5578 = kk_std_num_float64__mlift4607_pdecdouble(_x5579, _ctx); /*float64*/
  return kk_double_box(_x5578, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5581__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_4641;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5581(kk_function_t _fself, kk_box_t _b_4906, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5581(kk_std_core__sslice x_4641, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5581__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun5581__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun5581, kk_context());
  _self->x_4641 = x_4641;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5581(kk_function_t _fself, kk_box_t _b_4906, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5581__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun5581__t*, _fself, _ctx);
  kk_std_core__sslice x_4641 = _self->x_4641; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_4641, _ctx);}, {}, _ctx)
  kk_string_t man_4939 = kk_string_unbox(_b_4906); /*string*/;
  double _x5582 = kk_std_num_float64__mlift4606_pdecdouble(x_4641, man_4939, _ctx); /*float64*/
  return kk_double_box(_x5582, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5584__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5584(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5584(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5584, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5587__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5587(kk_function_t _fself, kk_box_t _b_4908, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5587(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5587, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5587(kk_function_t _fself, kk_box_t _b_4908, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x5588;
  kk_char_t _x5589 = kk_char_unbox(_b_4908, KK_OWNED, _ctx); /*char*/
  _x5588 = kk_std_num_float64__mlift4604_pdecdouble(_x5589, _ctx); /*string*/
  return kk_string_box(_x5588);
}
static kk_box_t kk_std_num_float64_pdecdouble_fun5584(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_char_t x2_4652 = kk_std_text_parse_char('.', _ctx); /*char*/;
  kk_string_t _x5585;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5586 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5587(_ctx), _ctx); /*3926*/
    _x5585 = kk_string_unbox(_x5586); /*string*/
  }
  else {
    _x5585 = kk_std_text_parse_digits0(_ctx); /*string*/
  }
  return kk_string_box(_x5585);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5590__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5590(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5590(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5590, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5590(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x5591 = kk_string_empty(); /*string*/
  return kk_string_box(_x5591);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5594__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_4641;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5594(kk_function_t _fself, kk_box_t _b_4915, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5594(kk_std_core__sslice x_4641, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5594__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun5594__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun5594, kk_context());
  _self->x_4641 = x_4641;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5594(kk_function_t _fself, kk_box_t _b_4915, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5594__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun5594__t*, _fself, _ctx);
  kk_std_core__sslice x_4641 = _self->x_4641; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_4641, _ctx);}, {}, _ctx)
  kk_string_t _y_4940_4563 = kk_string_unbox(_b_4915); /*string*/;
  double _x5595 = kk_std_num_float64__mlift4605_pdecdouble(x_4641, _y_4940_4563, _ctx); /*float64*/
  return kk_double_box(_x5595, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5599__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5599(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5599(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5599, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5604__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5604(kk_function_t _fself, kk_box_t _b_4917, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5604(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5604, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5604(kk_function_t _fself, kk_box_t _b_4917, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x5605;
  kk_char_t _x5606 = kk_char_unbox(_b_4917, KK_OWNED, _ctx); /*char*/
  _x5605 = kk_std_num_float64__mlift4602_pdecdouble(_x5606, _ctx); /*int*/
  return kk_integer_box(_x5605, _ctx);
}
static kk_box_t kk_std_num_float64_pdecdouble_fun5599(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_char_t x4_4657;
  kk_string_t _x5600;
  kk_define_string_literal(, _s5601, 2, "eE", _ctx)
  _x5600 = kk_string_dup(_s5601, _ctx); /*string*/
  x4_4657 = kk_std_text_parse_one_of(_x5600, _ctx); /*char*/
  kk_integer_t _x5602;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5603 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5604(_ctx), _ctx); /*3926*/
    _x5602 = kk_integer_unbox(_x5603, _ctx); /*int*/
  }
  else {
    _x5602 = kk_std_text_parse_pint(_ctx); /*int*/
  }
  return kk_integer_box(_x5602, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5607__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5607(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5607(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5607, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5607(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  return kk_integer_box(kk_integer_from_small(0), _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5609__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_4641;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5609(kk_function_t _fself, kk_box_t _b_4927, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5609(kk_std_core__sslice x_4641, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5609__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun5609__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun5609, kk_context());
  _self->x_4641 = x_4641;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5610__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5610(kk_function_t _fself, kk_box_t _b_4925, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5610(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5610, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5610(kk_function_t _fself, kk_box_t _b_4925, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5611;
  kk_string_t _x5612 = kk_string_unbox(_b_4925); /*string*/
  _x5611 = kk_std_num_float64_prim_parse_float64(_x5612, _ctx); /*float64*/
  return kk_double_box(_x5611, _ctx);
}
static kk_box_t kk_std_num_float64_pdecdouble_fun5609(kk_function_t _fself, kk_box_t _b_4927, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5609__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun5609__t*, _fself, _ctx);
  kk_std_core__sslice x_4641 = _self->x_4641; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_4641, _ctx);}, {}, _ctx)
  kk_integer_t exp_4941 = kk_integer_unbox(_b_4927, _ctx); /*int*/;
  kk_integer_drop(exp_4941, _ctx);
  kk_string_t _x1_4595 = kk_std_core_string_3(x_4641, _ctx); /*string*/;
  return kk_std_core_hnd__open_none1(kk_std_num_float64_new_pdecdouble_fun5610(_ctx), kk_string_box(_x1_4595), _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5614__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5614(kk_function_t _fself, kk_box_t _b_4930, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5614(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5614, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5614(kk_function_t _fself, kk_box_t _b_4930, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5615;
  kk_string_t _x5616 = kk_string_unbox(_b_4930); /*string*/
  _x5615 = kk_std_num_float64_prim_parse_float64(_x5616, _ctx); /*float64*/
  return kk_double_box(_x5615, _ctx);
}

double kk_std_num_float64_pdecdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  kk_std_core_hnd__ev ev_4644;
  kk_ssize_t _x5573 = (KK_IZ(0)); /*ssize_t*/
  ev_4644 = kk_evv_at(_x5573,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  kk_std_core__sslice x_4641;
  kk_box_t _x5574;
  {
    struct kk_std_core_hnd_Ev* _con5575 = kk_std_core_hnd__as_Ev(ev_4644, _ctx);
    kk_box_t _box_x4897 = _con5575->hnd;
    kk_std_core_hnd__marker m0 = _con5575->marker;
    kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x4897, KK_BORROWED, _ctx);
    kk_std_text_parse__hnd_parse_dup(h, _ctx);
    kk_std_core_hnd__clause0 _match_5280;
    kk_std_core_hnd__clause0 _brw_5281 = kk_std_text_parse__select_current_input(h, _ctx); /*std/core/hnd/clause0<sslice,std/text/parse/.hnd-parse,373,374>*/;
    kk_std_text_parse__hnd_parse_drop(h, _ctx);
    _match_5280 = _brw_5281; /*std/core/hnd/clause0<sslice,std/text/parse/.hnd-parse,373,374>*/
    {
      kk_function_t _fun_unbox_x4900 = _match_5280.clause;
      _x5574 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x4900, (_fun_unbox_x4900, m0, ev_4644, _ctx), _ctx); /*37*/
    }
  }
  x_4641 = kk_std_core__sslice_unbox(_x5574, KK_OWNED, _ctx); /*sslice*/
  if (kk_yielding(kk_context())) {
    kk_std_core__sslice_drop(x_4641, _ctx);
    kk_box_t _x5576 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5577(_ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5576, KK_OWNED, _ctx);
  }
  {
    kk_string_t x0_4646 = kk_std_text_parse_digits(_ctx); /*string*/;
    kk_string_drop(x0_4646, _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x5580 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5581(x_4641, _ctx), _ctx); /*3926*/
      return kk_double_unbox(_x5580, KK_OWNED, _ctx);
    }
    {
      kk_string_t x1_4649;
      kk_box_t _x5583 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64_new_pdecdouble_fun5584(_ctx), kk_std_num_float64_new_pdecdouble_fun5590(_ctx), _ctx); /*944*/
      x1_4649 = kk_string_unbox(_x5583); /*string*/
      if (kk_yielding(kk_context())) {
        kk_string_drop(x1_4649, _ctx);
        kk_box_t _x5593 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5594(x_4641, _ctx), _ctx); /*3926*/
        return kk_double_unbox(_x5593, KK_OWNED, _ctx);
      }
      {
        kk_string_t frac;
        kk_string_t _x5596;
        kk_define_string_literal(, _s5597, 1, "0", _ctx)
        _x5596 = kk_string_dup(_s5597, _ctx); /*string*/
        frac = kk_std_core_trim_right_1(x1_4649, _x5596, _ctx); /*string*/
        kk_string_drop(frac, _ctx);
        kk_integer_t x3_4654;
        kk_box_t _x5598 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64_new_pdecdouble_fun5599(_ctx), kk_std_num_float64_new_pdecdouble_fun5607(_ctx), _ctx); /*944*/
        x3_4654 = kk_integer_unbox(_x5598, _ctx); /*int*/
        kk_integer_drop(x3_4654, _ctx);
        if (kk_yielding(kk_context())) {
          kk_box_t _x5608 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5609(x_4641, _ctx), _ctx); /*3926*/
          return kk_double_unbox(_x5608, KK_OWNED, _ctx);
        }
        {
          kk_string_t _x1_45950 = kk_std_core_string_3(x_4641, _ctx); /*string*/;
          kk_box_t _x5613 = kk_std_core_hnd__open_none1(kk_std_num_float64_new_pdecdouble_fun5614(_ctx), kk_string_box(_x1_45950), _ctx); /*3357*/
          return kk_double_unbox(_x5613, KK_OWNED, _ctx);
        }
      }
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4609_phexdouble_fun5619__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4609_phexdouble_fun5619(kk_function_t _fself, kk_box_t _b_4947, kk_box_t _b_4948, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4609_phexdouble_fun5619(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4609_phexdouble_fun5619, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4609_phexdouble_fun5619(kk_function_t _fself, kk_box_t _b_4947, kk_box_t _b_4948, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__maybe _x5620;
  kk_string_t _x5621;
  kk_string_t _x5622;
  kk_string_t _x5623 = kk_string_unbox(_b_4947); /*string*/
  _x5622 = kk_string_trim_left(_x5623,kk_context()); /*string*/
  _x5621 = kk_string_trim_right(_x5622,kk_context()); /*string*/
  bool _x5624;
  kk_std_core_types__optional _match_5273 = kk_std_core_types__optional_unbox(_b_4948, KK_OWNED, _ctx); /*optional<bool>*/;
  if (kk_std_core_types__is_Optional(_match_5273, _ctx)) {
    kk_box_t _box_x4942 = _match_5273._cons.Optional.value;
    bool _hex_15862 = kk_bool_unbox(_box_x4942);
    kk_std_core_types__optional_drop(_match_5273, _ctx);
    _x5624 = _hex_15862; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(_match_5273, _ctx);
    _x5624 = false; /*bool*/
  }
  _x5620 = kk_std_core_xparse_int(_x5621, _x5624, _ctx); /*maybe<int>*/
  return kk_std_core_types__maybe_box(_x5620, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4609_phexdouble_fun5628__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4609_phexdouble_fun5628(kk_function_t _fself, kk_box_t _b_4959, kk_box_t _b_4960, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4609_phexdouble_fun5628(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4609_phexdouble_fun5628, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4609_phexdouble_fun5628(kk_function_t _fself, kk_box_t _b_4959, kk_box_t _b_4960, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x5629;
  kk_std_core_types__maybe _match_5272 = kk_std_core_types__maybe_unbox(_b_4959, KK_OWNED, _ctx); /*maybe<int>*/;
  if (kk_std_core_types__is_Nothing(_match_5272, _ctx)) {
    _x5629 = kk_integer_unbox(_b_4960, _ctx); /*int*/
  }
  else {
    kk_box_t _box_x4955 = _match_5272._cons.Just.value;
    kk_integer_t x = kk_integer_unbox(_box_x4955, _ctx);
    kk_integer_dup(x, _ctx);
    kk_std_core_types__maybe_drop(_match_5272, _ctx);
    kk_box_drop(_b_4960, _ctx);
    _x5629 = x; /*int*/
  }
  return kk_integer_box(_x5629, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4609_phexdouble_fun5632__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4609_phexdouble_fun5632(kk_function_t _fself, kk_box_t _b_4969, kk_box_t _b_4970, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4609_phexdouble_fun5632(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4609_phexdouble_fun5632, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4609_phexdouble_fun5632(kk_function_t _fself, kk_box_t _b_4969, kk_box_t _b_4970, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t man0_4974 = kk_integer_unbox(_b_4969, _ctx); /*int*/;
  kk_integer_t exp0_4975 = kk_integer_unbox(_b_4970, _ctx); /*int*/;
  double _x5633;
  double _x5634 = kk_integer_as_double(man0_4974,kk_context()); /*float64*/
  _x5633 = kk_std_num_float64_ldexp(_x5634, exp0_4975, _ctx); /*float64*/
  return kk_double_box(_x5633, _ctx);
}

double kk_std_num_float64__mlift4609_phexdouble(kk_string_t frac, kk_string_t man, kk_integer_t exp, kk_context_t* _ctx) { /* (frac : string, man : string, exp : int) -> std/text/parse/parse float64 */ 
  kk_string_t _x10_4598;
  kk_string_t _x5617 = kk_string_dup(frac, _ctx); /*string*/
  _x10_4598 = kk_std_core__lp__plus__plus__1_rp_(man, _x5617, _ctx); /*string*/
  kk_std_core_types__maybe _x1_4596;
  kk_box_t _x5618;
  kk_box_t _x5625;
  kk_std_core_types__optional _x5626 = kk_std_core_types__new_Optional(kk_bool_box(true), _ctx); /*optional<116>*/
  _x5625 = kk_std_core_types__optional_box(_x5626, _ctx); /*3448*/
  _x5618 = kk_std_core_hnd__open_none2(kk_std_num_float64__new_mlift4609_phexdouble_fun5619(_ctx), kk_string_box(_x10_4598), _x5625, _ctx); /*3449*/
  _x1_4596 = kk_std_core_types__maybe_unbox(_x5618, KK_OWNED, _ctx); /*maybe<int>*/
  kk_integer_t m0;
  kk_box_t _x5627 = kk_std_core_hnd__open_none2(kk_std_num_float64__new_mlift4609_phexdouble_fun5628(_ctx), kk_std_core_types__maybe_box(_x1_4596, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx); /*3449*/
  m0 = kk_integer_unbox(_x5627, _ctx); /*int*/
  kk_integer_t y_4593;
  kk_integer_t _x5630 = kk_std_core_count_1(frac, _ctx); /*int*/
  y_4593 = kk_integer_mul((kk_integer_from_small(4)),_x5630,kk_context()); /*int*/
  kk_integer_t e = kk_integer_sub(exp,y_4593,kk_context()); /*int*/;
  kk_box_t _x5631 = kk_std_core_hnd__open_none2(kk_std_num_float64__new_mlift4609_phexdouble_fun5632(_ctx), kk_integer_box(m0, _ctx), kk_integer_box(e, _ctx), _ctx); /*3449*/
  return kk_double_unbox(_x5631, KK_OWNED, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4611_phexdouble_fun5638__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4611_phexdouble_fun5638(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4611_phexdouble_fun5638(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4611_phexdouble_fun5638, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4611_phexdouble_fun5643__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4611_phexdouble_fun5643(kk_function_t _fself, kk_box_t _b_4977, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4611_phexdouble_fun5643(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4611_phexdouble_fun5643, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4611_phexdouble_fun5643(kk_function_t _fself, kk_box_t _b_4977, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x5644;
  kk_char_t _x5645 = kk_char_unbox(_b_4977, KK_OWNED, _ctx); /*char*/
  _x5644 = kk_std_num_float64__mlift4608_phexdouble(_x5645, _ctx); /*int*/
  return kk_integer_box(_x5644, _ctx);
}
static kk_box_t kk_std_num_float64__mlift4611_phexdouble_fun5638(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_char_t x0_4663;
  kk_string_t _x5639;
  kk_define_string_literal(, _s5640, 2, "pP", _ctx)
  _x5639 = kk_string_dup(_s5640, _ctx); /*string*/
  x0_4663 = kk_std_text_parse_one_of(_x5639, _ctx); /*char*/
  kk_integer_t _x5641;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5642 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4611_phexdouble_fun5643(_ctx), _ctx); /*3926*/
    _x5641 = kk_integer_unbox(_x5642, _ctx); /*int*/
  }
  else {
    _x5641 = kk_std_text_parse_pint(_ctx); /*int*/
  }
  return kk_integer_box(_x5641, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4611_phexdouble_fun5646__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4611_phexdouble_fun5646(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4611_phexdouble_fun5646(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4611_phexdouble_fun5646, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4611_phexdouble_fun5646(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  return kk_integer_box(kk_integer_from_small(0), _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4611_phexdouble_fun5648__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t man;
};
static kk_box_t kk_std_num_float64__mlift4611_phexdouble_fun5648(kk_function_t _fself, kk_box_t _b_4984, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4611_phexdouble_fun5648(kk_string_t frac, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4611_phexdouble_fun5648__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4611_phexdouble_fun5648__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4611_phexdouble_fun5648, kk_context());
  _self->frac = frac;
  _self->man = man;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4611_phexdouble_fun5648(kk_function_t _fself, kk_box_t _b_4984, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4611_phexdouble_fun5648__t* _self = kk_function_as(struct kk_std_num_float64__mlift4611_phexdouble_fun5648__t*, _fself, _ctx);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(frac, _ctx);kk_string_dup(man, _ctx);}, {}, _ctx)
  kk_integer_t exp_4986 = kk_integer_unbox(_b_4984, _ctx); /*int*/;
  double _x5649 = kk_std_num_float64__mlift4609_phexdouble(frac, man, exp_4986, _ctx); /*float64*/
  return kk_double_box(_x5649, _ctx);
}

double kk_std_num_float64__mlift4611_phexdouble(kk_string_t man, kk_string_t _y_4572, kk_context_t* _ctx) { /* (man : string, string) -> std/text/parse/parse float64 */ 
  kk_string_t frac;
  kk_string_t _x5635;
  kk_define_string_literal(, _s5636, 1, "0", _ctx)
  _x5635 = kk_string_dup(_s5636, _ctx); /*string*/
  frac = kk_std_core_trim_right_1(_y_4572, _x5635, _ctx); /*string*/
  kk_integer_t x_4661;
  kk_box_t _x5637 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64__new_mlift4611_phexdouble_fun5638(_ctx), kk_std_num_float64__new_mlift4611_phexdouble_fun5646(_ctx), _ctx); /*944*/
  x_4661 = kk_integer_unbox(_x5637, _ctx); /*int*/
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_4661, _ctx);
    kk_box_t _x5647 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4611_phexdouble_fun5648(frac, man, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5647, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4609_phexdouble(frac, man, x_4661, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4612_phexdouble_fun5651__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4612_phexdouble_fun5651(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4612_phexdouble_fun5651(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4612_phexdouble_fun5651, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4612_phexdouble_fun5654__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4612_phexdouble_fun5654(kk_function_t _fself, kk_box_t _b_4988, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4612_phexdouble_fun5654(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4612_phexdouble_fun5654, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4612_phexdouble_fun5654(kk_function_t _fself, kk_box_t _b_4988, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x5655;
  kk_char_t _x5656 = kk_char_unbox(_b_4988, KK_OWNED, _ctx); /*char*/
  _x5655 = kk_std_num_float64__mlift4610_phexdouble(_x5656, _ctx); /*string*/
  return kk_string_box(_x5655);
}
static kk_box_t kk_std_num_float64__mlift4612_phexdouble_fun5651(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_char_t x0_4667 = kk_std_text_parse_char('.', _ctx); /*char*/;
  kk_string_t _x5652;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5653 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4612_phexdouble_fun5654(_ctx), _ctx); /*3926*/
    _x5652 = kk_string_unbox(_x5653); /*string*/
  }
  else {
    _x5652 = kk_std_text_parse_hex_digits(_ctx); /*string*/
  }
  return kk_string_box(_x5652);
}


// lift anonymous function
struct kk_std_num_float64__mlift4612_phexdouble_fun5657__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4612_phexdouble_fun5657(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4612_phexdouble_fun5657(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4612_phexdouble_fun5657, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4612_phexdouble_fun5657(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x5658 = kk_string_empty(); /*string*/
  return kk_string_box(_x5658);
}


// lift anonymous function
struct kk_std_num_float64__mlift4612_phexdouble_fun5661__t {
  struct kk_function_s _base;
  kk_string_t man;
};
static kk_box_t kk_std_num_float64__mlift4612_phexdouble_fun5661(kk_function_t _fself, kk_box_t _b_4995, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4612_phexdouble_fun5661(kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4612_phexdouble_fun5661__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4612_phexdouble_fun5661__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4612_phexdouble_fun5661, kk_context());
  _self->man = man;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4612_phexdouble_fun5661(kk_function_t _fself, kk_box_t _b_4995, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4612_phexdouble_fun5661__t* _self = kk_function_as(struct kk_std_num_float64__mlift4612_phexdouble_fun5661__t*, _fself, _ctx);
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(man, _ctx);}, {}, _ctx)
  kk_string_t _y_4997_4572 = kk_string_unbox(_b_4995); /*string*/;
  double _x5662 = kk_std_num_float64__mlift4611_phexdouble(man, _y_4997_4572, _ctx); /*float64*/
  return kk_double_box(_x5662, _ctx);
}

double kk_std_num_float64__mlift4612_phexdouble(kk_string_t man, kk_context_t* _ctx) { /* (man : string) -> std/text/parse/parse float64 */ 
  kk_string_t x_4665;
  kk_box_t _x5650 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64__new_mlift4612_phexdouble_fun5651(_ctx), kk_std_num_float64__new_mlift4612_phexdouble_fun5657(_ctx), _ctx); /*944*/
  x_4665 = kk_string_unbox(_x5650); /*string*/
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4665, _ctx);
    kk_box_t _x5660 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4612_phexdouble_fun5661(man, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5660, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4611_phexdouble(man, x_4665, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4613_phexdouble_fun5664__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4613_phexdouble_fun5664(kk_function_t _fself, kk_box_t _b_4999, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4613_phexdouble_fun5664(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4613_phexdouble_fun5664, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4613_phexdouble_fun5664(kk_function_t _fself, kk_box_t _b_4999, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5665;
  kk_string_t _x5666 = kk_string_unbox(_b_4999); /*string*/
  _x5665 = kk_std_num_float64__mlift4612_phexdouble(_x5666, _ctx); /*float64*/
  return kk_double_box(_x5665, _ctx);
}

double kk_std_num_float64__mlift4613_phexdouble(kk_char_t wild__0, kk_context_t* _ctx) { /* (wild_0 : char) -> std/text/parse/parse float64 */ 
  kk_string_t x_4669 = kk_std_text_parse_hex_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4669, _ctx);
    kk_box_t _x5663 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4613_phexdouble_fun5664(_ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5663, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4612_phexdouble(x_4669, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4614_phexdouble_fun5670__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4614_phexdouble_fun5670(kk_function_t _fself, kk_box_t _b_5002, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4614_phexdouble_fun5670(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4614_phexdouble_fun5670, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4614_phexdouble_fun5670(kk_function_t _fself, kk_box_t _b_5002, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5671;
  kk_char_t _x5672 = kk_char_unbox(_b_5002, KK_OWNED, _ctx); /*char*/
  _x5671 = kk_std_num_float64__mlift4613_phexdouble(_x5672, _ctx); /*float64*/
  return kk_double_box(_x5671, _ctx);
}

double kk_std_num_float64__mlift4614_phexdouble(kk_char_t wild__, kk_context_t* _ctx) { /* (wild_ : char) -> std/text/parse/parse float64 */ 
  kk_char_t x_4671;
  kk_string_t _x5667;
  kk_define_string_literal(, _s5668, 2, "xX", _ctx)
  _x5667 = kk_string_dup(_s5668, _ctx); /*string*/
  x_4671 = kk_std_text_parse_one_of(_x5667, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x5669 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4614_phexdouble_fun5670(_ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5669, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4613_phexdouble(x_4671, _ctx);
  }
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5674__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5674(kk_function_t _fself, kk_box_t _b_5005, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5674(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5674, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5674(kk_function_t _fself, kk_box_t _b_5005, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5675;
  kk_char_t _x5676 = kk_char_unbox(_b_5005, KK_OWNED, _ctx); /*char*/
  _x5675 = kk_std_num_float64__mlift4614_phexdouble(_x5676, _ctx); /*float64*/
  return kk_double_box(_x5675, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5680__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5680(kk_function_t _fself, kk_box_t _b_5007, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5680(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5680, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5680(kk_function_t _fself, kk_box_t _b_5007, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5681;
  kk_char_t _x5682 = kk_char_unbox(_b_5007, KK_OWNED, _ctx); /*char*/
  _x5681 = kk_std_num_float64__mlift4613_phexdouble(_x5682, _ctx); /*float64*/
  return kk_double_box(_x5681, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5684__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5684(kk_function_t _fself, kk_box_t _b_5009, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5684(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5684, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5684(kk_function_t _fself, kk_box_t _b_5009, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5685;
  kk_string_t _x5686 = kk_string_unbox(_b_5009); /*string*/
  _x5685 = kk_std_num_float64__mlift4612_phexdouble(_x5686, _ctx); /*float64*/
  return kk_double_box(_x5685, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5688__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5688(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5688(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5688, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5691__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5691(kk_function_t _fself, kk_box_t _b_5011, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5691(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5691, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5691(kk_function_t _fself, kk_box_t _b_5011, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x5692;
  kk_char_t _x5693 = kk_char_unbox(_b_5011, KK_OWNED, _ctx); /*char*/
  _x5692 = kk_std_num_float64__mlift4610_phexdouble(_x5693, _ctx); /*string*/
  return kk_string_box(_x5692);
}
static kk_box_t kk_std_num_float64_phexdouble_fun5688(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_char_t x3_4685 = kk_std_text_parse_char('.', _ctx); /*char*/;
  kk_string_t _x5689;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5690 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun5691(_ctx), _ctx); /*3926*/
    _x5689 = kk_string_unbox(_x5690); /*string*/
  }
  else {
    _x5689 = kk_std_text_parse_hex_digits(_ctx); /*string*/
  }
  return kk_string_box(_x5689);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5694__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5694(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5694(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5694, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5694(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x5695 = kk_string_empty(); /*string*/
  return kk_string_box(_x5695);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5698__t {
  struct kk_function_s _base;
  kk_string_t x1_4679;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5698(kk_function_t _fself, kk_box_t _b_5018, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5698(kk_string_t x1_4679, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun5698__t* _self = kk_function_alloc_as(struct kk_std_num_float64_phexdouble_fun5698__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_phexdouble_fun5698, kk_context());
  _self->x1_4679 = x1_4679;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5698(kk_function_t _fself, kk_box_t _b_5018, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun5698__t* _self = kk_function_as(struct kk_std_num_float64_phexdouble_fun5698__t*, _fself, _ctx);
  kk_string_t x1_4679 = _self->x1_4679; /* string */
  kk_drop_match(_self, {kk_string_dup(x1_4679, _ctx);}, {}, _ctx)
  kk_string_t _y_5065_4572 = kk_string_unbox(_b_5018); /*string*/;
  double _x5699 = kk_std_num_float64__mlift4611_phexdouble(x1_4679, _y_5065_4572, _ctx); /*float64*/
  return kk_double_box(_x5699, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5703__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5703(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5703(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5703, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5708__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5708(kk_function_t _fself, kk_box_t _b_5020, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5708(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5708, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5708(kk_function_t _fself, kk_box_t _b_5020, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x5709;
  kk_char_t _x5710 = kk_char_unbox(_b_5020, KK_OWNED, _ctx); /*char*/
  _x5709 = kk_std_num_float64__mlift4608_phexdouble(_x5710, _ctx); /*int*/
  return kk_integer_box(_x5709, _ctx);
}
static kk_box_t kk_std_num_float64_phexdouble_fun5703(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_char_t x5_4690;
  kk_string_t _x5704;
  kk_define_string_literal(, _s5705, 2, "pP", _ctx)
  _x5704 = kk_string_dup(_s5705, _ctx); /*string*/
  x5_4690 = kk_std_text_parse_one_of(_x5704, _ctx); /*char*/
  kk_integer_t _x5706;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5707 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun5708(_ctx), _ctx); /*3926*/
    _x5706 = kk_integer_unbox(_x5707, _ctx); /*int*/
  }
  else {
    _x5706 = kk_std_text_parse_pint(_ctx); /*int*/
  }
  return kk_integer_box(_x5706, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5711__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5711(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5711(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5711, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5711(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  return kk_integer_box(kk_integer_from_small(0), _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5713__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t x1_4679;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5713(kk_function_t _fself, kk_box_t _b_5027, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5713(kk_string_t frac, kk_string_t x1_4679, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun5713__t* _self = kk_function_alloc_as(struct kk_std_num_float64_phexdouble_fun5713__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_phexdouble_fun5713, kk_context());
  _self->frac = frac;
  _self->x1_4679 = x1_4679;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5713(kk_function_t _fself, kk_box_t _b_5027, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun5713__t* _self = kk_function_as(struct kk_std_num_float64_phexdouble_fun5713__t*, _fself, _ctx);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t x1_4679 = _self->x1_4679; /* string */
  kk_drop_match(_self, {kk_string_dup(frac, _ctx);kk_string_dup(x1_4679, _ctx);}, {}, _ctx)
  kk_integer_t exp_5066 = kk_integer_unbox(_b_5027, _ctx); /*int*/;
  double _x5714 = kk_std_num_float64__mlift4609_phexdouble(frac, x1_4679, exp_5066, _ctx); /*float64*/
  return kk_double_box(_x5714, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5717__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5717(kk_function_t _fself, kk_box_t _b_5033, kk_box_t _b_5034, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5717(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5717, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5717(kk_function_t _fself, kk_box_t _b_5033, kk_box_t _b_5034, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__maybe _x5718;
  kk_string_t _x5719;
  kk_string_t _x5720;
  kk_string_t _x5721 = kk_string_unbox(_b_5033); /*string*/
  _x5720 = kk_string_trim_left(_x5721,kk_context()); /*string*/
  _x5719 = kk_string_trim_right(_x5720,kk_context()); /*string*/
  bool _x5722;
  kk_std_core_types__optional _match_5263 = kk_std_core_types__optional_unbox(_b_5034, KK_OWNED, _ctx); /*optional<bool>*/;
  if (kk_std_core_types__is_Optional(_match_5263, _ctx)) {
    kk_box_t _box_x5028 = _match_5263._cons.Optional.value;
    bool _hex_15862 = kk_bool_unbox(_box_x5028);
    kk_std_core_types__optional_drop(_match_5263, _ctx);
    _x5722 = _hex_15862; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(_match_5263, _ctx);
    _x5722 = false; /*bool*/
  }
  _x5718 = kk_std_core_xparse_int(_x5719, _x5722, _ctx); /*maybe<int>*/
  return kk_std_core_types__maybe_box(_x5718, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5726__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5726(kk_function_t _fself, kk_box_t _b_5045, kk_box_t _b_5046, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5726(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5726, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5726(kk_function_t _fself, kk_box_t _b_5045, kk_box_t _b_5046, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x5727;
  kk_std_core_types__maybe _match_5262 = kk_std_core_types__maybe_unbox(_b_5045, KK_OWNED, _ctx); /*maybe<int>*/;
  if (kk_std_core_types__is_Nothing(_match_5262, _ctx)) {
    _x5727 = kk_integer_unbox(_b_5046, _ctx); /*int*/
  }
  else {
    kk_box_t _box_x5041 = _match_5262._cons.Just.value;
    kk_integer_t x6 = kk_integer_unbox(_box_x5041, _ctx);
    kk_integer_dup(x6, _ctx);
    kk_std_core_types__maybe_drop(_match_5262, _ctx);
    kk_box_drop(_b_5046, _ctx);
    _x5727 = x6; /*int*/
  }
  return kk_integer_box(_x5727, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun5730__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun5730(kk_function_t _fself, kk_box_t _b_5055, kk_box_t _b_5056, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun5730(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun5730, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun5730(kk_function_t _fself, kk_box_t _b_5055, kk_box_t _b_5056, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t man0_5067 = kk_integer_unbox(_b_5055, _ctx); /*int*/;
  kk_integer_t exp00_5068 = kk_integer_unbox(_b_5056, _ctx); /*int*/;
  double _x5731;
  double _x5732 = kk_integer_as_double(man0_5067,kk_context()); /*float64*/
  _x5731 = kk_std_num_float64_ldexp(_x5732, exp00_5068, _ctx); /*float64*/
  return kk_double_box(_x5731, _ctx);
}

double kk_std_num_float64_phexdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  kk_char_t x_4673 = kk_std_text_parse_char('0', _ctx); /*char*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5673 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun5674(_ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5673, KK_OWNED, _ctx);
  }
  {
    kk_char_t x0_4676;
    kk_string_t _x5677;
    kk_define_string_literal(, _s5678, 2, "xX", _ctx)
    _x5677 = kk_string_dup(_s5678, _ctx); /*string*/
    x0_4676 = kk_std_text_parse_one_of(_x5677, _ctx); /*char*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x5679 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun5680(_ctx), _ctx); /*3926*/
      return kk_double_unbox(_x5679, KK_OWNED, _ctx);
    }
    {
      kk_string_t x1_4679 = kk_std_text_parse_hex_digits(_ctx); /*string*/;
      if (kk_yielding(kk_context())) {
        kk_string_drop(x1_4679, _ctx);
        kk_box_t _x5683 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun5684(_ctx), _ctx); /*3926*/
        return kk_double_unbox(_x5683, KK_OWNED, _ctx);
      }
      {
        kk_string_t x2_4682;
        kk_box_t _x5687 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64_new_phexdouble_fun5688(_ctx), kk_std_num_float64_new_phexdouble_fun5694(_ctx), _ctx); /*944*/
        x2_4682 = kk_string_unbox(_x5687); /*string*/
        if (kk_yielding(kk_context())) {
          kk_string_drop(x2_4682, _ctx);
          kk_box_t _x5697 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun5698(x1_4679, _ctx), _ctx); /*3926*/
          return kk_double_unbox(_x5697, KK_OWNED, _ctx);
        }
        {
          kk_string_t frac;
          kk_string_t _x5700;
          kk_define_string_literal(, _s5701, 1, "0", _ctx)
          _x5700 = kk_string_dup(_s5701, _ctx); /*string*/
          frac = kk_std_core_trim_right_1(x2_4682, _x5700, _ctx); /*string*/
          kk_integer_t x4_4687;
          kk_box_t _x5702 = kk_std_text_parse__lp__bar__bar__rp_(kk_std_num_float64_new_phexdouble_fun5703(_ctx), kk_std_num_float64_new_phexdouble_fun5711(_ctx), _ctx); /*944*/
          x4_4687 = kk_integer_unbox(_x5702, _ctx); /*int*/
          if (kk_yielding(kk_context())) {
            kk_integer_drop(x4_4687, _ctx);
            kk_box_t _x5712 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun5713(frac, x1_4679, _ctx), _ctx); /*3926*/
            return kk_double_unbox(_x5712, KK_OWNED, _ctx);
          }
          {
            kk_string_t _x10_4598;
            kk_string_t _x5715 = kk_string_dup(frac, _ctx); /*string*/
            _x10_4598 = kk_std_core__lp__plus__plus__1_rp_(x1_4679, _x5715, _ctx); /*string*/
            kk_std_core_types__maybe _x1_4596;
            kk_box_t _x5716;
            kk_box_t _x5723;
            kk_std_core_types__optional _x5724 = kk_std_core_types__new_Optional(kk_bool_box(true), _ctx); /*optional<116>*/
            _x5723 = kk_std_core_types__optional_box(_x5724, _ctx); /*3448*/
            _x5716 = kk_std_core_hnd__open_none2(kk_std_num_float64_new_phexdouble_fun5717(_ctx), kk_string_box(_x10_4598), _x5723, _ctx); /*3449*/
            _x1_4596 = kk_std_core_types__maybe_unbox(_x5716, KK_OWNED, _ctx); /*maybe<int>*/
            kk_integer_t m0;
            kk_box_t _x5725 = kk_std_core_hnd__open_none2(kk_std_num_float64_new_phexdouble_fun5726(_ctx), kk_std_core_types__maybe_box(_x1_4596, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx); /*3449*/
            m0 = kk_integer_unbox(_x5725, _ctx); /*int*/
            kk_integer_t y_4593;
            kk_integer_t _x5728 = kk_std_core_count_1(frac, _ctx); /*int*/
            y_4593 = kk_integer_mul((kk_integer_from_small(4)),_x5728,kk_context()); /*int*/
            kk_integer_t e = kk_integer_sub(x4_4687,y_4593,kk_context()); /*int*/;
            kk_box_t _x5729 = kk_std_core_hnd__open_none2(kk_std_num_float64_new_phexdouble_fun5730(_ctx), kk_integer_box(m0, _ctx), kk_integer_box(e, _ctx), _ctx); /*3449*/
            return kk_double_unbox(_x5729, KK_OWNED, _ctx);
          }
        }
      }
    }
  }
}


// lift anonymous function
struct kk_std_num_float64_pspecial_fun5735__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun5735(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun5735(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun5735, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pspecial_fun5740__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun5740(kk_function_t _fself, kk_box_t _b_5070, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun5740(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun5740, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pspecial_fun5740(kk_function_t _fself, kk_box_t _b_5070, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5741;
  kk_string_t _x5742 = kk_string_unbox(_b_5070); /*string*/
  _x5741 = kk_std_num_float64__mlift4615_pspecial(_x5742, _ctx); /*float64*/
  return kk_double_box(_x5741, _ctx);
}
static kk_box_t kk_std_num_float64_pspecial_fun5735(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x_4692;
  kk_string_t _x5736;
  kk_define_string_literal(, _s5737, 3, "nan", _ctx)
  _x5736 = kk_string_dup(_s5737, _ctx); /*string*/
  x_4692 = kk_std_text_parse_pstring(_x5736, _ctx); /*string*/
  kk_string_drop(x_4692, _ctx);
  double _x5738;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5739 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pspecial_fun5740(_ctx), _ctx); /*3926*/
    _x5738 = kk_double_unbox(_x5739, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x5738 = kk_std_num_float64_nan; /*float64*/
  }
  return kk_double_box(_x5738, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pspecial_fun5744__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun5744(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun5744(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun5744, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pspecial_fun5749__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun5749(kk_function_t _fself, kk_box_t _b_5072, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun5749(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun5749, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pspecial_fun5749(kk_function_t _fself, kk_box_t _b_5072, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5750;
  kk_string_t _x5751 = kk_string_unbox(_b_5072); /*string*/
  _x5750 = kk_std_num_float64__mlift4616_pspecial(_x5751, _ctx); /*float64*/
  return kk_double_box(_x5750, _ctx);
}
static kk_box_t kk_std_num_float64_pspecial_fun5744(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x0_4694;
  kk_string_t _x5745;
  kk_define_string_literal(, _s5746, 8, "infinity", _ctx)
  _x5745 = kk_string_dup(_s5746, _ctx); /*string*/
  x0_4694 = kk_std_text_parse_pstring(_x5745, _ctx); /*string*/
  kk_string_drop(x0_4694, _ctx);
  double _x5747;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5748 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pspecial_fun5749(_ctx), _ctx); /*3926*/
    _x5747 = kk_double_unbox(_x5748, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x5747 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x5747, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pspecial_fun5753__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun5753(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun5753(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun5753, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pspecial_fun5758__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun5758(kk_function_t _fself, kk_box_t _b_5074, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun5758(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun5758, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pspecial_fun5758(kk_function_t _fself, kk_box_t _b_5074, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5759;
  kk_string_t _x5760 = kk_string_unbox(_b_5074); /*string*/
  _x5759 = kk_std_num_float64__mlift4617_pspecial(_x5760, _ctx); /*float64*/
  return kk_double_box(_x5759, _ctx);
}
static kk_box_t kk_std_num_float64_pspecial_fun5753(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x1_4696;
  kk_string_t _x5754;
  kk_define_string_literal(, _s5755, 3, "inf", _ctx)
  _x5754 = kk_string_dup(_s5755, _ctx); /*string*/
  x1_4696 = kk_std_text_parse_pstring(_x5754, _ctx); /*string*/
  kk_string_drop(x1_4696, _ctx);
  double _x5756;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5757 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pspecial_fun5758(_ctx), _ctx); /*3926*/
    _x5756 = kk_double_unbox(_x5757, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x5756 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x5756, _ctx);
}

double kk_std_num_float64_pspecial(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  kk_box_t _x5733;
  kk_std_core__list _x5734;
  kk_std_core__list _x5743;
  kk_std_core__list _x5752 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pspecial_fun5753(_ctx), _ctx), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x5743 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pspecial_fun5744(_ctx), _ctx), _x5752, _ctx); /*list<61>*/
  _x5734 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pspecial_fun5735(_ctx), _ctx), _x5743, _ctx); /*list<61>*/
  _x5733 = kk_std_text_parse_choose(_x5734, _ctx); /*765*/
  return kk_double_unbox(_x5733, KK_OWNED, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5763__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5763(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5763(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4622_pdouble_fun5763, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5763(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5764 = kk_std_num_float64_phexdouble(_ctx); /*float64*/
  return kk_double_box(_x5764, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5766__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5766(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5766(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4622_pdouble_fun5766, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5766(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5767 = kk_std_num_float64_pdecdouble(_ctx); /*float64*/
  return kk_double_box(_x5767, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5769__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5769(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5769(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4622_pdouble_fun5769, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5771__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5771(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5771(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4622_pdouble_fun5771, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5776__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5776(kk_function_t _fself, kk_box_t _b_5096, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5776(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4622_pdouble_fun5776, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5776(kk_function_t _fself, kk_box_t _b_5096, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5777;
  kk_string_t _x5778 = kk_string_unbox(_b_5096); /*string*/
  _x5777 = kk_std_num_float64__mlift4618_pdouble(_x5778, _ctx); /*float64*/
  return kk_double_box(_x5777, _ctx);
}
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5771(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x0_4700;
  kk_string_t _x5772;
  kk_define_string_literal(, _s5773, 3, "nan", _ctx)
  _x5772 = kk_string_dup(_s5773, _ctx); /*string*/
  x0_4700 = kk_std_text_parse_pstring(_x5772, _ctx); /*string*/
  kk_string_drop(x0_4700, _ctx);
  double _x5774;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5775 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4622_pdouble_fun5776(_ctx), _ctx); /*3926*/
    _x5774 = kk_double_unbox(_x5775, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x5774 = kk_std_num_float64_nan; /*float64*/
  }
  return kk_double_box(_x5774, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5780__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5780(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5780(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4622_pdouble_fun5780, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5785__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5785(kk_function_t _fself, kk_box_t _b_5098, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5785(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4622_pdouble_fun5785, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5785(kk_function_t _fself, kk_box_t _b_5098, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5786;
  kk_string_t _x5787 = kk_string_unbox(_b_5098); /*string*/
  _x5786 = kk_std_num_float64__mlift4619_pdouble(_x5787, _ctx); /*float64*/
  return kk_double_box(_x5786, _ctx);
}
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5780(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x1_4702;
  kk_string_t _x5781;
  kk_define_string_literal(, _s5782, 8, "infinity", _ctx)
  _x5781 = kk_string_dup(_s5782, _ctx); /*string*/
  x1_4702 = kk_std_text_parse_pstring(_x5781, _ctx); /*string*/
  kk_string_drop(x1_4702, _ctx);
  double _x5783;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5784 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4622_pdouble_fun5785(_ctx), _ctx); /*3926*/
    _x5783 = kk_double_unbox(_x5784, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x5783 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x5783, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5789__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5789(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5789(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4622_pdouble_fun5789, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5794__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5794(kk_function_t _fself, kk_box_t _b_5100, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5794(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4622_pdouble_fun5794, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5794(kk_function_t _fself, kk_box_t _b_5100, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5795;
  kk_string_t _x5796 = kk_string_unbox(_b_5100); /*string*/
  _x5795 = kk_std_num_float64__mlift4620_pdouble(_x5796, _ctx); /*float64*/
  return kk_double_box(_x5795, _ctx);
}
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5789(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x2_4704;
  kk_string_t _x5790;
  kk_define_string_literal(, _s5791, 3, "inf", _ctx)
  _x5790 = kk_string_dup(_s5791, _ctx); /*string*/
  x2_4704 = kk_std_text_parse_pstring(_x5790, _ctx); /*string*/
  kk_string_drop(x2_4704, _ctx);
  double _x5792;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5793 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4622_pdouble_fun5794(_ctx), _ctx); /*3926*/
    _x5792 = kk_double_unbox(_x5793, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x5792 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x5792, _ctx);
}
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5769(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _x5770;
  kk_std_core__list _x5779;
  kk_std_core__list _x5788 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4622_pdouble_fun5789(_ctx), _ctx), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x5779 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4622_pdouble_fun5780(_ctx), _ctx), _x5788, _ctx); /*list<61>*/
  _x5770 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4622_pdouble_fun5771(_ctx), _ctx), _x5779, _ctx); /*list<61>*/
  return kk_std_text_parse_choose(_x5770, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5798__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5798(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5798(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4622_pdouble_fun5798, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5798(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  return kk_double_box(0x0p+0, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4622_pdouble_fun5800__t {
  struct kk_function_s _base;
  bool neg;
};
static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5800(kk_function_t _fself, kk_box_t _b_5144, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4622_pdouble_fun5800(bool neg, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4622_pdouble_fun5800__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4622_pdouble_fun5800__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4622_pdouble_fun5800, kk_context());
  _self->neg = neg;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4622_pdouble_fun5800(kk_function_t _fself, kk_box_t _b_5144, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4622_pdouble_fun5800__t* _self = kk_function_as(struct kk_std_num_float64__mlift4622_pdouble_fun5800__t*, _fself, _ctx);
  bool neg = _self->neg; /* bool */
  kk_drop_match(_self, {;}, {}, _ctx)
  double _x5801;
  double d_5146 = kk_double_unbox(_b_5144, KK_OWNED, _ctx); /*float64*/;
  if (neg) {
    _x5801 = (-d_5146); /*float64*/
  }
  else {
    _x5801 = d_5146; /*float64*/
  }
  return kk_double_box(_x5801, _ctx);
}

double kk_std_num_float64__mlift4622_pdouble(bool neg, kk_context_t* _ctx) { /* (neg : bool) -> std/text/parse/parse float64 */ 
  double x_4698;
  kk_box_t _x5761;
  kk_std_core__list _x5762;
  kk_std_core__list _x5765;
  kk_std_core__list _x5768;
  kk_std_core__list _x5797 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4622_pdouble_fun5798(_ctx), _ctx), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x5768 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4622_pdouble_fun5769(_ctx), _ctx), _x5797, _ctx); /*list<61>*/
  _x5765 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4622_pdouble_fun5766(_ctx), _ctx), _x5768, _ctx); /*list<61>*/
  _x5762 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4622_pdouble_fun5763(_ctx), _ctx), _x5765, _ctx); /*list<61>*/
  _x5761 = kk_std_text_parse_choose(_x5762, _ctx); /*765*/
  x_4698 = kk_double_unbox(_x5761, KK_OWNED, _ctx); /*float64*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x5799 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4622_pdouble_fun5800(neg, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5799, KK_OWNED, _ctx);
  }
  {
    double d_5147 = x_4698; /*float64*/;
    if (neg) {
      return (-d_5147);
    }
    {
      return d_5147;
    }
  }
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun5803__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5803(kk_function_t _fself, kk_box_t _b_5149, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5803(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5803, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun5803(kk_function_t _fself, kk_box_t _b_5149, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5804;
  bool _x5805 = kk_bool_unbox(_b_5149); /*bool*/
  _x5804 = kk_std_num_float64__mlift4622_pdouble(_x5805, _ctx); /*float64*/
  return kk_double_box(_x5804, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun5808__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5808(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5808(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5808, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun5808(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5809 = kk_std_num_float64_phexdouble(_ctx); /*float64*/
  return kk_double_box(_x5809, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun5811__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5811(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5811(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5811, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun5811(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5812 = kk_std_num_float64_pdecdouble(_ctx); /*float64*/
  return kk_double_box(_x5812, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun5814__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5814(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5814(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5814, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun5816__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5816(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5816(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5816, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun5821__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5821(kk_function_t _fself, kk_box_t _b_5151, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5821(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5821, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun5821(kk_function_t _fself, kk_box_t _b_5151, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5822;
  kk_string_t _x5823 = kk_string_unbox(_b_5151); /*string*/
  _x5822 = kk_std_num_float64__mlift4618_pdouble(_x5823, _ctx); /*float64*/
  return kk_double_box(_x5822, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun5816(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x1_4714;
  kk_string_t _x5817;
  kk_define_string_literal(, _s5818, 3, "nan", _ctx)
  _x5817 = kk_string_dup(_s5818, _ctx); /*string*/
  x1_4714 = kk_std_text_parse_pstring(_x5817, _ctx); /*string*/
  kk_string_drop(x1_4714, _ctx);
  double _x5819;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5820 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun5821(_ctx), _ctx); /*3926*/
    _x5819 = kk_double_unbox(_x5820, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x5819 = kk_std_num_float64_nan; /*float64*/
  }
  return kk_double_box(_x5819, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun5825__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5825(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5825(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5825, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun5830__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5830(kk_function_t _fself, kk_box_t _b_5153, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5830(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5830, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun5830(kk_function_t _fself, kk_box_t _b_5153, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5831;
  kk_string_t _x5832 = kk_string_unbox(_b_5153); /*string*/
  _x5831 = kk_std_num_float64__mlift4619_pdouble(_x5832, _ctx); /*float64*/
  return kk_double_box(_x5831, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun5825(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x2_4716;
  kk_string_t _x5826;
  kk_define_string_literal(, _s5827, 8, "infinity", _ctx)
  _x5826 = kk_string_dup(_s5827, _ctx); /*string*/
  x2_4716 = kk_std_text_parse_pstring(_x5826, _ctx); /*string*/
  kk_string_drop(x2_4716, _ctx);
  double _x5828;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5829 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun5830(_ctx), _ctx); /*3926*/
    _x5828 = kk_double_unbox(_x5829, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x5828 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x5828, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun5834__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5834(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5834(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5834, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun5839__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5839(kk_function_t _fself, kk_box_t _b_5155, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5839(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5839, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun5839(kk_function_t _fself, kk_box_t _b_5155, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5840;
  kk_string_t _x5841 = kk_string_unbox(_b_5155); /*string*/
  _x5840 = kk_std_num_float64__mlift4620_pdouble(_x5841, _ctx); /*float64*/
  return kk_double_box(_x5840, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun5834(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x3_4718;
  kk_string_t _x5835;
  kk_define_string_literal(, _s5836, 3, "inf", _ctx)
  _x5835 = kk_string_dup(_s5836, _ctx); /*string*/
  x3_4718 = kk_std_text_parse_pstring(_x5835, _ctx); /*string*/
  kk_string_drop(x3_4718, _ctx);
  double _x5837;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5838 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun5839(_ctx), _ctx); /*3926*/
    _x5837 = kk_double_unbox(_x5838, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x5837 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x5837, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun5814(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list _x5815;
  kk_std_core__list _x5824;
  kk_std_core__list _x5833 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun5834(_ctx), _ctx), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x5824 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun5825(_ctx), _ctx), _x5833, _ctx); /*list<61>*/
  _x5815 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun5816(_ctx), _ctx), _x5824, _ctx); /*list<61>*/
  return kk_std_text_parse_choose(_x5815, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun5843__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun5843(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5843(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun5843, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun5843(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  return kk_double_box(0x0p+0, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun5845__t {
  struct kk_function_s _base;
  bool x_4708;
};
static kk_box_t kk_std_num_float64_pdouble_fun5845(kk_function_t _fself, kk_box_t _b_5199, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun5845(bool x_4708, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdouble_fun5845__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdouble_fun5845__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdouble_fun5845, kk_context());
  _self->x_4708 = x_4708;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun5845(kk_function_t _fself, kk_box_t _b_5199, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdouble_fun5845__t* _self = kk_function_as(struct kk_std_num_float64_pdouble_fun5845__t*, _fself, _ctx);
  bool x_4708 = _self->x_4708; /* bool */
  kk_drop_match(_self, {;}, {}, _ctx)
  double d_5202 = kk_double_unbox(_b_5199, KK_OWNED, _ctx); /*float64*/;
  double _x5846;
  if (x_4708) {
    _x5846 = (-d_5202); /*float64*/
  }
  else {
    _x5846 = d_5202; /*float64*/
  }
  return kk_double_box(_x5846, _ctx);
}

double kk_std_num_float64_pdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  bool x_4708 = kk_std_text_parse_sign(_ctx); /*bool*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5802 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun5803(_ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5802, KK_OWNED, _ctx);
  }
  {
    double x0_4711;
    kk_box_t _x5806;
    kk_std_core__list _x5807;
    kk_std_core__list _x5810;
    kk_std_core__list _x5813;
    kk_std_core__list _x5842 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun5843(_ctx), _ctx), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
    _x5813 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun5814(_ctx), _ctx), _x5842, _ctx); /*list<61>*/
    _x5810 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun5811(_ctx), _ctx), _x5813, _ctx); /*list<61>*/
    _x5807 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun5808(_ctx), _ctx), _x5810, _ctx); /*list<61>*/
    _x5806 = kk_std_text_parse_choose(_x5807, _ctx); /*765*/
    x0_4711 = kk_double_unbox(_x5806, KK_OWNED, _ctx); /*float64*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x5844 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun5845(x_4708, _ctx), _ctx); /*3926*/
      return kk_double_unbox(_x5844, KK_OWNED, _ctx);
    }
    if (x_4708) {
      return (-x0_4711);
    }
    {
      return x0_4711;
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4624_parse_float64_fun5848__t {
  struct kk_function_s _base;
  double x;
};
static kk_box_t kk_std_num_float64__mlift4624_parse_float64_fun5848(kk_function_t _fself, kk_box_t _b_5204, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4624_parse_float64_fun5848(double x, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4624_parse_float64_fun5848__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4624_parse_float64_fun5848__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4624_parse_float64_fun5848, kk_context());
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4624_parse_float64_fun5848(kk_function_t _fself, kk_box_t _b_5204, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4624_parse_float64_fun5848__t* _self = kk_function_as(struct kk_std_num_float64__mlift4624_parse_float64_fun5848__t*, _fself, _ctx);
  double x = _self->x; /* float64 */
  kk_drop_match(_self, {;}, {}, _ctx)
  kk_unit_t wild___5206 = kk_Unit;
  kk_unit_unbox(_b_5204);
  return kk_double_box(x, _ctx);
}

double kk_std_num_float64__mlift4624_parse_float64(double x, kk_context_t* _ctx) { /* (x : float64) -> std/text/parse/parse float64 */ 
  kk_unit_t x0_4722 = kk_Unit;
  kk_std_text_parse_eof(_ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x5847 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4624_parse_float64_fun5848(x, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5847, KK_OWNED, _ctx);
  }
  {
    return x;
  }
}
 
// Parse a float64 number. Can be "NaN", "Inf(inity)" (case-insensitive),
// a fix-point number (`1.2`) or in scientific notation (`-2.3e-5`).
// Also allows floats in [hexadecimal notation](https://books.google.com/books?id=FgMsCwAAQBAJ&pg=PA41) (`0xA.Fp-10`) that can
// be represented precisely (and are the preferred _round trip_ format).


// lift anonymous function
struct kk_std_num_float64_parse_float64_fun5853__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_parse_float64_fun5853(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_parse_float64_fun5853(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_parse_float64_fun5853, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_parse_float64_fun5856__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_parse_float64_fun5856(kk_function_t _fself, kk_box_t _b_5208, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_parse_float64_fun5856(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_parse_float64_fun5856, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_parse_float64_fun5856(kk_function_t _fself, kk_box_t _b_5208, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5857;
  double _x5858 = kk_double_unbox(_b_5208, KK_OWNED, _ctx); /*float64*/
  _x5857 = kk_std_num_float64__mlift4624_parse_float64(_x5858, _ctx); /*float64*/
  return kk_double_box(_x5857, _ctx);
}
static kk_box_t kk_std_num_float64_parse_float64_fun5853(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  double x_4726 = kk_std_num_float64_pdouble(_ctx); /*float64*/;
  double _x5854;
  if (kk_yielding(kk_context())) {
    kk_box_t _x5855 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_parse_float64_fun5856(_ctx), _ctx); /*3926*/
    _x5854 = kk_double_unbox(_x5855, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x5854 = kk_std_num_float64__mlift4624_parse_float64(x_4726, _ctx); /*float64*/
  }
  return kk_double_box(_x5854, _ctx);
}

kk_std_core_types__maybe kk_std_num_float64_parse_float64(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> maybe<float64> */ 
  kk_string_t s0_4547;
  kk_string_t _x5849;
  kk_string_t _x5850 = kk_string_trim_left(s,kk_context()); /*string*/
  _x5849 = kk_string_trim_right(_x5850,kk_context()); /*string*/
  s0_4547 = kk_std_core_to_lower(_x5849, _ctx); /*string*/
  kk_std_core__sslice input_4545;
  kk_string_t _x5851 = kk_string_dup(s0_4547, _ctx); /*string*/
  kk_integer_t _x5852 = kk_string_len_int(s0_4547,kk_context()); /*int*/
  input_4545 = kk_std_core__new_Sslice(_x5851, kk_integer_from_small(0), _x5852, _ctx); /*sslice*/
  kk_std_text_parse__parse_error perr_4544 = kk_std_text_parse_parse(input_4545, kk_std_num_float64_new_parse_float64_fun5853(_ctx), _ctx); /*std/text/parse/parse-error<float64>*/;
  if (kk_std_text_parse__is_ParseOk(perr_4544, _ctx)) {
    struct kk_std_text_parse_ParseOk* _con5859 = kk_std_text_parse__as_ParseOk(perr_4544, _ctx);
    kk_box_t _box_x5214 = _con5859->result;
    kk_std_core__sslice _pat00 = _con5859->rest;
    double x0 = kk_double_unbox(_box_x5214, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(perr_4544, _ctx)) {
      kk_std_core__sslice_drop(_pat00, _ctx);
      kk_box_drop(_box_x5214, _ctx);
      kk_datatype_ptr_free(perr_4544, _ctx);
    }
    else {
      kk_datatype_ptr_decref(perr_4544, _ctx);
    }
    return kk_std_core_types__new_Just(kk_double_box(x0, _ctx), _ctx);
  }
  {
    struct kk_std_text_parse_ParseError* _con5860 = kk_std_text_parse__as_ParseError(perr_4544, _ctx);
    kk_std_core__sslice _pat5 = _con5860->rest;
    kk_string_t msg = _con5860->msg;
    if kk_likely(kk_datatype_ptr_is_unique(perr_4544, _ctx)) {
      kk_string_drop(msg, _ctx);
      kk_std_core__sslice_drop(_pat5, _ctx);
      kk_datatype_ptr_free(perr_4544, _ctx);
    }
    else {
      kk_datatype_ptr_decref(perr_4544, _ctx);
    }
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Round a float64 to a specified precision. Rounds to the  even number in case of a tie.
// `123.456.round-to-prec(2) == 123.46`
// `123.456.round-to-prec(-1) == 120.0`

double kk_std_num_float64_round_to_prec(double d, kk_integer_t prec, kk_context_t* _ctx) { /* (d : float64, prec : int) -> float64 */ 
  bool _match_5242 = kk_integer_lte_borrow(prec,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_5242) {
    kk_integer_drop(prec, _ctx);
    return kk_double_round_even(d,kk_context());
  }
  {
    double p;
    double _x5861 = kk_integer_as_double(prec,kk_context()); /*float64*/
    p = pow(10.0,_x5861); /*float64*/
    double _x5862;
    double _x5863 = (d * p); /*float64*/
    _x5862 = kk_double_round_even(_x5863,kk_context()); /*float64*/
    return (_x5862 / p);
  }
}
 
/* Show a float64 in [hexadecimal notation](https://books.google.com/books?id=FgMsCwAAQBAJ&pg=PA41).
An advantage of this format is that it precisely represents the `:float64` and can
reliably (and efficiently) be parsed back, i.e. `d.show-hex.parse-float64 == Just(d)`.
The significant is the _hexadecimal_ fraction while the
exponent after the `p` is the _decimal_ power of 2.
 For example, ``0xA.Fp-10`` = (10 + 15/16)&middot;2^-10^  (not 2^-16^!) = 0.01068115234375.
 Equivalently, ``0xA.Fp-10 == 0x5.78p-9 == 0x2.BCp-8 == 0x1.5Ep-7``.
```
> flt-min.show-hex
"0x1.0p-1022"
> 0.1.show-hex
"0x1.999999999999Ap-4"
> flt-max.show-hex
"0x1.FFFFFFFFFFFFFp+1023"
> -0.0.show-hex
"-0x0.0p+0"
> nan.show-hex
"NaN"
> 0.01068115234375.show-hex
"0x1.5Ep-7"
```
.
*/

kk_string_t kk_std_num_float64_show_hex(double d, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (d : float64, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  bool b_4549 = isfinite(d); /*bool*/;
  if (b_4549) {
    kk_std_core_types__tuple2_ _match_5231 = kk_std_num_float64_decode(d, _ctx); /*(int, int)*/;
    {
      kk_box_t _box_x5217 = _match_5231.fst;
      kk_box_t _box_x5218 = _match_5231.snd;
      kk_integer_t m = kk_integer_unbox(_box_x5217, _ctx);
      kk_integer_t e = kk_integer_unbox(_box_x5218, _ctx);
      kk_integer_dup(e, _ctx);
      kk_integer_dup(m, _ctx);
      kk_std_core_types__tuple2__drop(_match_5231, _ctx);
      kk_string_t man;
      kk_integer_t _x5864 = kk_integer_abs(m,kk_context()); /*int*/
      kk_std_core_types__optional _x5865 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(1), _ctx), _ctx); /*optional<116>*/
      kk_std_core_types__optional _x5866;
      kk_box_t _x5867;
      bool _x5868;
      if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
        kk_box_t _box_x5220 = use_capitals._cons.Optional.value;
        bool _use_capitals_3963 = kk_bool_unbox(_box_x5220);
        kk_std_core_types__optional_drop(use_capitals, _ctx);
        _x5868 = _use_capitals_3963; /*bool*/
      }
      else {
        kk_std_core_types__optional_drop(use_capitals, _ctx);
        _x5868 = true; /*bool*/
      }
      _x5867 = kk_bool_box(_x5868); /*116*/
      _x5866 = kk_std_core_types__new_Optional(_x5867, _ctx); /*optional<116>*/
      kk_std_core_types__optional _x5869;
      kk_box_t _x5870;
      kk_string_t _x5871 = kk_string_empty(); /*string*/
      _x5870 = kk_string_box(_x5871); /*116*/
      _x5869 = kk_std_core_types__new_Optional(_x5870, _ctx); /*optional<116>*/
      man = kk_std_core_show_hex(_x5864, _x5865, _x5866, _x5869, _ctx); /*string*/
      kk_integer_t x0_4552;
      kk_string_t _x5873 = kk_string_dup(man, _ctx); /*string*/
      x0_4552 = kk_std_core_count_1(_x5873, _ctx); /*int*/
      kk_integer_t y_4551;
      kk_integer_t _x5874 = kk_integer_add_small_const(x0_4552, -1, _ctx); /*int*/
      y_4551 = kk_integer_mul((kk_integer_from_small(4)),_x5874,kk_context()); /*int*/
      kk_integer_t exp0 = kk_integer_add(e,y_4551,kk_context()); /*int*/;
      kk_string_t exp;
      kk_string_t _x5875;
      bool _match_5241 = kk_integer_gte_borrow(exp0,(kk_integer_from_small(0)),kk_context()); /*bool*/;
      if (_match_5241) {
        kk_define_string_literal(, _s5876, 1, "+", _ctx)
        _x5875 = kk_string_dup(_s5876, _ctx); /*string*/
      }
      else {
        _x5875 = kk_string_empty(); /*string*/
      }
      kk_string_t _x5878 = kk_std_core_show(exp0, _ctx); /*string*/
      exp = kk_std_core__lp__plus__plus__1_rp_(_x5875, _x5878, _ctx); /*string*/
      kk_string_t frac;
      kk_string_t _own_5239;
      kk_string_t _x5879;
      kk_string_t _x5880 = kk_string_dup(man, _ctx); /*string*/
      _x5879 = kk_std_core_tail_2(_x5880, _ctx); /*string*/
      kk_string_t _x5881;
      kk_define_string_literal(, _s5882, 1, "0", _ctx)
      _x5881 = kk_string_dup(_s5882, _ctx); /*string*/
      _own_5239 = kk_std_core_trim_right_1(_x5879, _x5881, _ctx); /*string*/
      kk_integer_t _brw_5238;
      bool _match_5235;
      kk_integer_t _brw_5236;
      if (kk_std_core_types__is_Optional(width, _ctx)) {
        kk_box_t _box_x5226 = width._cons.Optional.value;
        kk_integer_t _width_3959 = kk_integer_unbox(_box_x5226, _ctx);
        kk_integer_dup(_width_3959, _ctx);
        _brw_5236 = _width_3959; /*int*/
      }
      else {
        _brw_5236 = kk_integer_from_small(1); /*int*/
      }
      bool _brw_5237 = kk_integer_gte_borrow((kk_integer_from_small(1)),_brw_5236,kk_context()); /*bool*/;
      kk_integer_drop(_brw_5236, _ctx);
      _match_5235 = _brw_5237; /*bool*/
      if (_match_5235) {
        kk_std_core_types__optional_drop(width, _ctx);
        _brw_5238 = kk_integer_from_small(1); /*int*/
      }
      else {
        if (kk_std_core_types__is_Optional(width, _ctx)) {
          kk_box_t _box_x5227 = width._cons.Optional.value;
          kk_integer_t _width_39590 = kk_integer_unbox(_box_x5227, _ctx);
          kk_integer_dup(_width_39590, _ctx);
          kk_std_core_types__optional_drop(width, _ctx);
          _brw_5238 = _width_39590; /*int*/
        }
        else {
          kk_std_core_types__optional_drop(width, _ctx);
          _brw_5238 = kk_integer_from_small(1); /*int*/
        }
      }
      kk_string_t _brw_5240;
      kk_std_core_types__optional _x5883 = kk_std_core_types__new_Optional(kk_char_box('0', _ctx), _ctx); /*optional<116>*/
      _brw_5240 = kk_std_core_pad_right(_own_5239, _brw_5238, _x5883, _ctx); /*string*/
      kk_integer_drop(_brw_5238, _ctx);
      frac = _brw_5240; /*string*/
      kk_string_t sign;
      bool _match_5232 = (d < (0x0p+0)); /*bool*/;
      if (_match_5232) {
        kk_define_string_literal(, _s5884, 1, "-", _ctx)
        sign = kk_string_dup(_s5884, _ctx); /*string*/
      }
      else {
        bool _match_5233 = (d == (0x0p+0)); /*bool*/;
        if (_match_5233) {
          bool _match_5234;
          double _x5885 = (0x1p0 / d); /*float64*/
          _match_5234 = (isinf(_x5885) && signbit(_x5885)); /*bool*/
          if (_match_5234) {
            kk_define_string_literal(, _s5886, 1, "-", _ctx)
            sign = kk_string_dup(_s5886, _ctx); /*string*/
          }
          else {
            sign = kk_string_empty(); /*string*/
          }
        }
        else {
          sign = kk_string_empty(); /*string*/
        }
      }
      kk_string_t _x5889;
      kk_string_t _x5890;
      if (kk_std_core_types__is_Optional(pre, _ctx)) {
        kk_box_t _box_x5230 = pre._cons.Optional.value;
        kk_string_t _pre_3967 = kk_string_unbox(_box_x5230);
        kk_string_dup(_pre_3967, _ctx);
        kk_std_core_types__optional_drop(pre, _ctx);
        _x5890 = _pre_3967; /*string*/
      }
      else {
        kk_std_core_types__optional_drop(pre, _ctx);
        kk_define_string_literal(, _s5891, 2, "0x", _ctx)
        _x5890 = kk_string_dup(_s5891, _ctx); /*string*/
      }
      kk_string_t _x5892;
      kk_string_t _x5893 = kk_std_core_head_3(man, _ctx); /*string*/
      kk_string_t _x5894;
      kk_string_t _x5895;
      kk_define_string_literal(, _s5896, 1, ".", _ctx)
      _x5895 = kk_string_dup(_s5896, _ctx); /*string*/
      kk_string_t _x5897;
      kk_string_t _x5898;
      kk_string_t _x5899;
      kk_define_string_literal(, _s5900, 1, "p", _ctx)
      _x5899 = kk_string_dup(_s5900, _ctx); /*string*/
      _x5898 = kk_std_core__lp__plus__plus__1_rp_(_x5899, exp, _ctx); /*string*/
      _x5897 = kk_std_core__lp__plus__plus__1_rp_(frac, _x5898, _ctx); /*string*/
      _x5894 = kk_std_core__lp__plus__plus__1_rp_(_x5895, _x5897, _ctx); /*string*/
      _x5892 = kk_std_core__lp__plus__plus__1_rp_(_x5893, _x5894, _ctx); /*string*/
      _x5889 = kk_std_core__lp__plus__plus__1_rp_(_x5890, _x5892, _ctx); /*string*/
      return kk_std_core__lp__plus__plus__1_rp_(sign, _x5889, _ctx);
    }
  }
  {
    kk_std_core_types__optional_drop(width, _ctx);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    return kk_std_core_show_1(d, kk_std_core_types__new_None(_ctx), _ctx);
  }
}

// initialization
void kk_std_num_float64__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_text_parse__init(_ctx);
  kk_std_num_int64__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_num_float64_flt_max_prec = kk_integer_from_small(15); /*int*/
  }
  {
    kk_std_num_float64_rad2deg = ((0x1.68p7) / (0x1.921fb54442d18p1)); /*float64*/
  }
  {
    kk_std_num_float64_deg2rad = ((0x1.921fb54442d18p1) / (0x1.68p7)); /*float64*/
  }
  {
    kk_std_num_float64_neginf = kk_std_num_float64_make_neginf(_ctx); /*float64*/
  }
  {
    kk_std_num_float64_posinf = kk_std_num_float64_make_posinf(_ctx); /*float64*/
  }
  {
    kk_std_num_float64_nan = kk_std_num_float64_make_nan(_ctx); /*float64*/
  }
}

// termination
void kk_std_num_float64__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_integer_drop(kk_std_num_float64_flt_max_prec, _ctx);
  kk_std_num_int64__done(_ctx);
  kk_std_text_parse__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
