// Koka generated module: "std/num/float64", koka version: 2.4.2, platform: 64-bit
#include "std_num_float64.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

static inline int64_t kk_double_to_bits( double d, kk_context_t* ctx ) {
  kk_unused(ctx);
  return (int64_t)kk_bits_from_double(d);
}

static inline double kk_double_from_bits( int64_t i, kk_context_t* ctx ) {
  kk_unused(ctx);
  return kk_bits_to_double((uint64_t)i);
}

static inline double kk_prim_parse_double( kk_string_t str, kk_context_t* ctx) {
  const char* s = kk_string_cbuf_borrow(str,NULL,ctx);
  char* end;
  double d = strtod(s,&end);
  kk_string_drop(str,ctx);  
  return d;
}

 
// lifted local: .lift4728-abs-max.1, abs-max.1, .spec.4682
// specialized: std/core/.unroll17344-foldl, on parameters f4677, using:
// f4677 = fn(m: float64, x: float64){
//   val x0.4441 : float64
//         = std/core/abs.1(x);
//   match ((std/core/(>=.3)(x0.4441, m))) {
//     ((std/core/types/True() : bool ) as .pat: bool)
//        -> x0.4441;
//     ((.skip std/core/types/False() : bool ) as .pat0: bool)
//        -> m;
//   };
// }

double kk_std_num_float64__lift4729_abs_max_1(kk_std_core__list xs4675, double z4676, kk_context_t* _ctx) { /* (xs4675 : list<float64>, z4676 : float64) -> float64 */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs4675, _ctx)) {
    struct kk_std_core_Cons* _con5696 = kk_std_core__as_Cons(xs4675, _ctx);
    kk_box_t _box_x5026 = _con5696->head;
    kk_std_core__list xx4680 = _con5696->tail;
    double x4679 = kk_double_unbox(_box_x5026, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs4675, _ctx)) {
      kk_box_drop(_box_x5026, _ctx);
      kk_datatype_ptr_free(xs4675, _ctx);
    }
    else {
      kk_std_core__list_dup(xx4680, _ctx);
      kk_datatype_ptr_decref(xs4675, _ctx);
    }
    double x0_4441 = kk_double_abs(x4679); /*float64*/;
    { // tailcall
      double _x5697;
      bool _match_5688 = (x0_4441 >= z4676); /*bool*/;
      if (_match_5688) {
        _x5697 = x0_4441; /*float64*/
      }
      else {
        _x5697 = z4676; /*float64*/
      }
      xs4675 = xx4680;
      z4676 = _x5697;
      goto kk__tailcall;
    }
  }
  {
    return z4676;
  }
}
 
// lifted local: abs-max.1, .spec.4674
// specialized: std/core/foldl, on parameters f4671, using:
// f4671 = fn(m: float64, x: float64){
//   val x0.4441 : float64
//         = std/core/abs.1(x);
//   match ((std/core/(>=.3)(x0.4441, m))) {
//     ((std/core/types/True() : bool ) as .pat: bool)
//        -> x0.4441;
//     ((.skip std/core/types/False() : bool ) as .pat0: bool)
//        -> m;
//   };
// }

double kk_std_num_float64__lift4728_abs_max_1(kk_std_core__list xs4669, double z4670, kk_context_t* _ctx) { /* (xs4669 : list<float64>, z4670 : float64) -> float64 */ 
  if (kk_std_core__is_Nil(xs4669, _ctx)) {
    return z4670;
  }
  {
    return kk_std_num_float64__lift4729_abs_max_1(xs4669, z4670, _ctx);
  }
}
 
// The area hyperbolic cosine of `d`

double kk_std_num_float64_acosh(double d, kk_context_t* _ctx) { /* (d : float64) -> float64 */ 
  return acosh(d);
}
 
// The area hyperbolic sine of `d`

double kk_std_num_float64_asinh(double d, kk_context_t* _ctx) { /* (d : float64) -> float64 */ 
  return asinh(d);
}
 
// The area hyperbolic tangent of `d`

double kk_std_num_float64_atanh(double d, kk_context_t* _ctx) { /* (d : float64) -> float64 */ 
  return atanh(d);
}
 
// Low-level: return the bits of a 64-bit `:float64` as in `:int64`

int64_t kk_std_num_float64_float64_to_bits(double d, kk_context_t* _ctx) { /* (d : float64) -> int64 */ 
  return kk_double_to_bits(d,kk_context());
}
 
// Extend a `:float32` to a `:float64`

double kk_std_num_float64_float64(float f, kk_context_t* _ctx) { /* (f : float32) -> float64 */ 
  return (double)(f);
}
 
// Low-level: create a `:float64` from the given 64-bit integer.

double kk_std_num_float64_float64_from_bits(int64_t i, kk_context_t* _ctx) { /* (i : int64) -> float64 */ 
  return kk_double_from_bits(i,kk_context());
}

double kk_std_num_float64_make_neginf(kk_context_t* _ctx) { /* () -> float64 */ 
  return -HUGE_VAL;
}

double kk_std_num_float64_make_posinf(kk_context_t* _ctx) { /* () -> float64 */ 
  return HUGE_VAL;
}
 
// Round a `:float64` to a `:float32`

float kk_std_num_float64_float32(double f, kk_context_t* _ctx) { /* (f : float64) -> float32 */ 
  return (float)(f);
}

kk_integer_t kk_std_num_float64_flt_max_prec;
 
// fused multiply-add. Computes `(x*y)+z` as if to infinite precision
// with only the final result rounded back to a `:float64`.

double kk_std_num_float64_fmadd(double x, double y, double z, kk_context_t* _ctx) { /* (x : float64, y : float64, z : float64) -> float64 */ 
  return fma(x,y,z);
}
 
// lifted local: .lift4730-sum, sum, .spec.4697
// specialized: std/core/.unroll17339-foreach, on parameters action4691, using:
// action4691 = fn<((local :: H -> X)<(h :: H)>)>(x: float64){
//   val t : float64;
//   val c : float64;
//   val _ : ();
//   std/core/types/local-set<float64,((<>) :: E),(h :: H)>(total, t);
// }

kk_unit_t kk_std_num_float64__lift4731_sum(kk_ref_t comp, kk_ref_t total, kk_std_core__list xs4690, kk_context_t* _ctx) { /* forall<h> (comp : local-var<h,float64>, total : local-var<h,float64>, xs4690 : list<float64>) -> (local<h>) () */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs4690, _ctx)) {
    struct kk_std_core_Cons* _con5700 = kk_std_core__as_Cons(xs4690, _ctx);
    kk_box_t _box_x5027 = _con5700->head;
    kk_std_core__list xx4694 = _con5700->tail;
    double x4693 = kk_double_unbox(_box_x5027, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs4690, _ctx)) {
      kk_box_drop(_box_x5027, _ctx);
      kk_datatype_ptr_free(xs4690, _ctx);
    }
    else {
      kk_std_core__list_dup(xx4694, _ctx);
      kk_datatype_ptr_decref(xs4690, _ctx);
    }
    double t;
    double _x5701;
    kk_box_t _x5702;
    kk_ref_t _x5703 = kk_ref_dup(total, _ctx); /*local-var<672,float64>*/
    _x5702 = kk_ref_get(_x5703,kk_context()); /*264*/
    _x5701 = kk_double_unbox(_x5702, KK_OWNED, _ctx); /*float64*/
    t = (_x5701 + x4693); /*float64*/
    double c;
    bool _match_5685;
    double _x5704;
    double _x5705;
    kk_box_t _x5706;
    kk_ref_t _x5707 = kk_ref_dup(total, _ctx); /*local-var<672,float64>*/
    _x5706 = kk_ref_get(_x5707,kk_context()); /*264*/
    _x5705 = kk_double_unbox(_x5706, KK_OWNED, _ctx); /*float64*/
    _x5704 = kk_double_abs(_x5705); /*float64*/
    double _x5708 = kk_double_abs(x4693); /*float64*/
    _match_5685 = (_x5704 >= _x5708); /*bool*/
    if (_match_5685) {
      double _x5709;
      double _x5710;
      kk_box_t _x5711;
      kk_ref_t _x5712 = kk_ref_dup(total, _ctx); /*local-var<672,float64>*/
      _x5711 = kk_ref_get(_x5712,kk_context()); /*264*/
      _x5710 = kk_double_unbox(_x5711, KK_OWNED, _ctx); /*float64*/
      _x5709 = (_x5710 - t); /*float64*/
      c = (_x5709 + x4693); /*float64*/
    }
    else {
      double _x5713 = (x4693 - t); /*float64*/
      double _x5714;
      kk_box_t _x5715;
      kk_ref_t _x5716 = kk_ref_dup(total, _ctx); /*local-var<672,float64>*/
      _x5715 = kk_ref_get(_x5716,kk_context()); /*264*/
      _x5714 = kk_double_unbox(_x5715, KK_OWNED, _ctx); /*float64*/
      c = (_x5713 + _x5714); /*float64*/
    }
    double _b_5040_5038;
    double _x5717;
    kk_box_t _x5718;
    kk_ref_t _x5719 = kk_ref_dup(comp, _ctx); /*local-var<672,float64>*/
    _x5718 = kk_ref_get(_x5719,kk_context()); /*264*/
    _x5717 = kk_double_unbox(_x5718, KK_OWNED, _ctx); /*float64*/
    _b_5040_5038 = (_x5717 + c); /*float64*/
    kk_unit_t __ = kk_Unit;
    kk_ref_set_borrow(comp,(kk_double_box(_b_5040_5038, _ctx)),kk_context());
    kk_unit_t __4695 = kk_Unit;
    kk_ref_set_borrow(total,(kk_double_box(t, _ctx)),kk_context());
    { // tailcall
      xs4690 = xx4694;
      goto kk__tailcall;
    }
  }
  {
    kk_ref_drop(total, _ctx);
    kk_ref_drop(comp, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// lifted local: sum, .spec.4689
// specialized: std/core/foreach, on parameters action4686, using:
// action4686 = fn<((local :: H -> X)<(h :: H)>)>(x: float64){
//   val t : float64;
//   val c : float64;
//   val _ : ();
//   std/core/types/local-set<float64,((<>) :: E),(h :: H)>(total, t);
// }

kk_unit_t kk_std_num_float64__lift4730_sum(kk_ref_t comp, kk_ref_t total, kk_std_core__list xs4685, kk_context_t* _ctx) { /* forall<h> (comp : local-var<h,float64>, total : local-var<h,float64>, xs4685 : list<float64>) -> (local<h>) () */ 
  if (kk_std_core__is_Nil(xs4685, _ctx)) {
    kk_ref_drop(total, _ctx);
    kk_ref_drop(comp, _ctx);
    kk_Unit; return kk_Unit;
  }
  {
    kk_std_num_float64__lift4731_sum(comp, total, xs4685, _ctx); return kk_Unit;
  }
}
 
// Return the sum of a list of floats.
// Uses [Kahan-Babu&scaron;kan-Neumaier summation](https://en.wikipedia.org/wiki/Kahan_summation_algorithm#Further_enhancements)
// to minimize rounding errors. This
// is more precise as Kahan summation and about as fast.
// `[1.0e3,1.0e97,1.0e3,-1.0e97].sum == 2000.0`
// while
// `[1.0e3,1.0e97,1.0e3,-1.0e97].foldl(0.0,(+)) == 0.0` (!)
// A. Neumaier, _Rundungsfehleranalyse einiger Verfahren zur Summation endlicher Summen_.
// Math. Mechanik, 54:39--51, 1974.

double kk_std_num_float64_sum(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  kk_ref_t loc = kk_ref_alloc((kk_double_box(0x0p+0, _ctx)),kk_context()); /*local-var<672,float64>*/;
  kk_ref_t loc0 = kk_ref_alloc((kk_double_box(0x0p+0, _ctx)),kk_context()); /*local-var<672,float64>*/;
  kk_unit_t __0 = kk_Unit;
  kk_ref_t _x5720 = kk_ref_dup(loc0, _ctx); /*local-var<672,float64>*/
  kk_ref_t _x5721 = kk_ref_dup(loc, _ctx); /*local-var<672,float64>*/
  kk_std_num_float64__lift4730_sum(_x5720, _x5721, xs, _ctx);
  double res0;
  double _x5722;
  kk_box_t _x5723;
  kk_ref_t _x5724 = kk_ref_dup(loc, _ctx); /*local-var<672,float64>*/
  _x5723 = kk_ref_get(_x5724,kk_context()); /*264*/
  _x5722 = kk_double_unbox(_x5723, KK_OWNED, _ctx); /*float64*/
  double _x5725;
  kk_box_t _x5726;
  kk_ref_t _x5727 = kk_ref_dup(loc0, _ctx); /*local-var<672,float64>*/
  _x5726 = kk_ref_get(_x5727,kk_context()); /*264*/
  _x5725 = kk_double_unbox(_x5726, KK_OWNED, _ctx); /*float64*/
  res0 = (_x5722 + _x5725); /*float64*/
  double res;
  kk_box_t _x5728 = kk_std_core_hnd_prompt_local_var(loc0, kk_double_box(res0, _ctx), _ctx); /*10459*/
  res = kk_double_unbox(_x5728, KK_OWNED, _ctx); /*float64*/
  kk_box_t _x5729 = kk_std_core_hnd_prompt_local_var(loc, kk_double_box(res, _ctx), _ctx); /*10459*/
  return kk_double_unbox(_x5729, KK_OWNED, _ctx);
}
 
// Is this value equal to negative or positive infinity ?

bool kk_std_num_float64_is_inf(double d, kk_context_t* _ctx) { /* (d : float64) -> bool */ 
  return isinf(d);
}
 
// Linear interpolation, calculating `x + t*(y - x)` but avoids troublesome edge cases.
// Follows the C++20 [specification](http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2019/p0811r3.html).
// In particular, if `x.is-finite && y.is-finite`, then:
// - exact: `lerp(x,y,0.0) == x` and  `lerp(x,y,1.0) == y`
// - monotonic: if `x <= y` and `t1 <= t2`, then `compare( lerp(x,y,t1), lerp(x,y,t2) ) <= Eq` (and other cases)
// - deterministic: only `lerp(x,x,flt-inf)` results in `nan`
// - bounded: `t<0.0 || t>1.0 || is-finite(lerp(x,y,t))`
// - consistent: `lerp(x,x,t) == x`

double kk_std_num_float64_lerp(double x, double y, double t, kk_context_t* _ctx) { /* (x : float64, y : float64, t : float64) -> float64 */ 
  bool _match_5663 = (x <= (0x0p+0)); /*bool*/;
  if (_match_5663) {
    bool _match_5674 = (y >= (0x0p+0)); /*bool*/;
    if (_match_5674) {
      double _x5730 = (t * y); /*float64*/
      double _x5731;
      double _x5732 = (0x1p0 - t); /*float64*/
      _x5731 = (_x5732 * x); /*float64*/
      return (_x5730 + _x5731);
    }
    {
      bool _match_5675 = (x >= (0x0p+0)); /*bool*/;
      if (_match_5675) {
        bool _match_5680 = (y <= (0x0p+0)); /*bool*/;
        if (_match_5680) {
          double _x5733 = (t * y); /*float64*/
          double _x5734;
          double _x5735 = (0x1p0 - t); /*float64*/
          _x5734 = (_x5735 * x); /*float64*/
          return (_x5733 + _x5734);
        }
        {
          bool _match_5681 = (t == 0x1p0); /*bool*/;
          if (_match_5681) {
            return y;
          }
          {
            double z;
            double _x5736;
            double _x5737 = (y - x); /*float64*/
            _x5736 = (t * _x5737); /*float64*/
            z = (x + _x5736); /*float64*/
            bool x0_4444 = (t > 0x1p0); /*bool*/;
            bool y0_4445 = (y > x); /*bool*/;
            bool _match_5682;
            if (x0_4444) {
              _match_5682 = y0_4445; /*bool*/
            }
            else {
              if (y0_4445) {
                _match_5682 = false; /*bool*/
              }
              else {
                _match_5682 = true; /*bool*/
              }
            }
            if (_match_5682) {
              bool _match_5684 = (y >= z); /*bool*/;
              if (_match_5684) {
                return y;
              }
              {
                return z;
              }
            }
            {
              bool _match_5683 = (y <= z); /*bool*/;
              if (_match_5683) {
                return y;
              }
              {
                return z;
              }
            }
          }
        }
      }
      {
        bool _match_5676 = (t == 0x1p0); /*bool*/;
        if (_match_5676) {
          return y;
        }
        {
          double z0;
          double _x5738;
          double _x5739 = (y - x); /*float64*/
          _x5738 = (t * _x5739); /*float64*/
          z0 = (x + _x5738); /*float64*/
          bool x3_4450 = (t > 0x1p0); /*bool*/;
          bool y3_4451 = (y > x); /*bool*/;
          bool _match_5677;
          if (x3_4450) {
            _match_5677 = y3_4451; /*bool*/
          }
          else {
            if (y3_4451) {
              _match_5677 = false; /*bool*/
            }
            else {
              _match_5677 = true; /*bool*/
            }
          }
          if (_match_5677) {
            bool _match_5679 = (y >= z0); /*bool*/;
            if (_match_5679) {
              return y;
            }
            {
              return z0;
            }
          }
          {
            bool _match_5678 = (y <= z0); /*bool*/;
            if (_match_5678) {
              return y;
            }
            {
              return z0;
            }
          }
        }
      }
    }
  }
  {
    bool _match_5664 = (x >= (0x0p+0)); /*bool*/;
    if (_match_5664) {
      bool _match_5669 = (y <= (0x0p+0)); /*bool*/;
      if (_match_5669) {
        double _x5740 = (t * y); /*float64*/
        double _x5741;
        double _x5742 = (0x1p0 - t); /*float64*/
        _x5741 = (_x5742 * x); /*float64*/
        return (_x5740 + _x5741);
      }
      {
        bool _match_5670 = (t == 0x1p0); /*bool*/;
        if (_match_5670) {
          return y;
        }
        {
          double z1;
          double _x5743;
          double _x5744 = (y - x); /*float64*/
          _x5743 = (t * _x5744); /*float64*/
          z1 = (x + _x5743); /*float64*/
          bool x6_4456 = (t > 0x1p0); /*bool*/;
          bool y6_4457 = (y > x); /*bool*/;
          bool _match_5671;
          if (x6_4456) {
            _match_5671 = y6_4457; /*bool*/
          }
          else {
            if (y6_4457) {
              _match_5671 = false; /*bool*/
            }
            else {
              _match_5671 = true; /*bool*/
            }
          }
          if (_match_5671) {
            bool _match_5673 = (y >= z1); /*bool*/;
            if (_match_5673) {
              return y;
            }
            {
              return z1;
            }
          }
          {
            bool _match_5672 = (y <= z1); /*bool*/;
            if (_match_5672) {
              return y;
            }
            {
              return z1;
            }
          }
        }
      }
    }
    {
      bool _match_5665 = (t == 0x1p0); /*bool*/;
      if (_match_5665) {
        return y;
      }
      {
        double z00;
        double _x5745;
        double _x5746 = (y - x); /*float64*/
        _x5745 = (t * _x5746); /*float64*/
        z00 = (x + _x5745); /*float64*/
        bool x9_4462 = (t > 0x1p0); /*bool*/;
        bool y9_4463 = (y > x); /*bool*/;
        bool _match_5666;
        if (x9_4462) {
          _match_5666 = y9_4463; /*bool*/
        }
        else {
          if (y9_4463) {
            _match_5666 = false; /*bool*/
          }
          else {
            _match_5666 = true; /*bool*/
          }
        }
        if (_match_5666) {
          bool _match_5668 = (y >= z00); /*bool*/;
          if (_match_5668) {
            return y;
          }
          {
            return z00;
          }
        }
        {
          bool _match_5667 = (y <= z00); /*bool*/;
          if (_match_5667) {
            return y;
          }
          {
            return z00;
          }
        }
      }
    }
  }
}

double kk_std_num_float64_make_nan(kk_context_t* _ctx) { /* () -> float64 */ 
  return (double)NAN;
}
 
// Return `nan` on failure

double kk_std_num_float64_prim_parse_float64(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> float64 */ 
  return kk_prim_parse_double(s,kk_context());
}
 
// Compare floats using a total ordering on the `:float64`.
// The ordering follows the `totalOrder` predicate as defined in IEEE 754-2008 exactly.
// The values are ordered in following order:
// negative quiet nan,
// negative signaling nan,
// `neginf`,
// -finite,
// -0.0,
// +0.0,
// finite,
// `posinf`,
// signaling nan,
// and quiet nan.

kk_std_core_types__order kk_std_num_float64_compare(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> order */ 
  int64_t bx = kk_std_num_float64_float64_to_bits(x, _ctx); /*int64*/;
  int64_t by = kk_std_num_float64_float64_to_bits(y, _ctx); /*int64*/;
  int64_t i_4468;
  int64_t _x5750 = (KK_I64(63)); /*int64*/
  i_4468 = kk_sar64(bx,_x5750); /*int64*/
  int64_t ix;
  int64_t _x5751;
  int64_t _x5752 = (KK_I64(1)); /*int64*/
  _x5751 = (int64_t)kk_shr64(i_4468,_x5752); /*int64*/
  ix = _x5751 ^ bx; /*int64*/
  int64_t i1_4472;
  int64_t _x5753 = (KK_I64(63)); /*int64*/
  i1_4472 = kk_sar64(by,_x5753); /*int64*/
  int64_t iy;
  int64_t _x5754;
  int64_t _x5755 = (KK_I64(1)); /*int64*/
  _x5754 = (int64_t)kk_shr64(i1_4472,_x5755); /*int64*/
  iy = _x5754 ^ by; /*int64*/
  bool _match_5660 = (ix < iy); /*bool*/;
  if (_match_5660) {
    return kk_std_core_types__new_Lt(_ctx);
  }
  {
    bool _match_5661 = (ix > iy); /*bool*/;
    if (_match_5661) {
      return kk_std_core_types__new_Gt(_ctx);
    }
    {
      return kk_std_core_types__new_Eq(_ctx);
    }
  }
}
 
// decode a normalized float64 (i.e. not subnormal)

kk_std_core_types__tuple2_ kk_std_num_float64_decode_normalized(double d, kk_std_core_types__optional e_adjust, kk_context_t* _ctx) { /* (d : float64, e-adjust : optional<int>) -> (int, int) */ 
  int64_t i = kk_std_num_float64_float64_to_bits(d, _ctx); /*int64*/;
  int64_t exp;
  int64_t _x5756;
  int64_t _x5757;
  int64_t _x5758 = (KK_I64(52)); /*int64*/
  _x5757 = (int64_t)kk_shr64(i,_x5758); /*int64*/
  int64_t _x5759 = (KK_I64(2047)); /*int64*/
  _x5756 = _x5757 & _x5759; /*int64*/
  int64_t _x5760 = (KK_I64(1043)); /*int64*/
  exp = (int64_t)((uint64_t)_x5756 - (uint64_t)_x5760); /*int64*/
  int64_t man;
  int64_t _x5761;
  int64_t _x5762 = (KK_I64(4503599627370495)); /*int64*/
  _x5761 = i & _x5762; /*int64*/
  int64_t _x5763 = (KK_I64(4503599627370496)); /*int64*/
  man = (int64_t)((uint64_t)_x5761 + (uint64_t)_x5763); /*int64*/
  kk_integer_t x0_4483 = kk_integer_from_int64(exp,kk_context()); /*int*/;
  kk_integer_t x_4481 = kk_integer_add_small_const(x0_4483, -32, _ctx); /*int*/;
  kk_integer_t _b_5065_5063;
  int64_t _x5764;
  bool _match_5659 = 0 > i; /*bool*/;
  if (_match_5659) {
    int64_t _x5765 = (KK_I64(0)); /*int64*/
    _x5764 = (int64_t)((uint64_t)_x5765 - (uint64_t)man); /*int64*/
  }
  else {
    _x5764 = man; /*int64*/
  }
  _b_5065_5063 = kk_integer_from_int64(_x5764,kk_context()); /*int*/
  kk_integer_t _b_5066_5064;
  kk_integer_t _x5766;
  if (kk_std_core_types__is_Optional(e_adjust, _ctx)) {
    kk_box_t _box_x5062 = e_adjust._cons.Optional.value;
    kk_integer_t _e_adjust_1099 = kk_integer_unbox(_box_x5062, _ctx);
    kk_integer_dup(_e_adjust_1099, _ctx);
    kk_std_core_types__optional_drop(e_adjust, _ctx);
    _x5766 = _e_adjust_1099; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(e_adjust, _ctx);
    _x5766 = kk_integer_from_small(0); /*int*/
  }
  _b_5066_5064 = kk_integer_add(x_4481,_x5766,kk_context()); /*int*/
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_5065_5063, _ctx), kk_integer_box(_b_5066_5064, _ctx), _ctx);
}
 
// Decode a float64 `d` into a tuple `(m,e)` of a mantissa `m` and exponent `e`
// such that `m`&middot;2^`e`^ =  `d` exactly. The mantissa `m` is
// always either 0 or in the range [2^52^, 2^53^). See also `frexp`.

kk_std_core_types__tuple2_ kk_std_num_float64_decode(double d, kk_context_t* _ctx) { /* (d : float64) -> (int, int) */ 
  bool _match_5652 = (d == (0x0p+0)); /*bool*/;
  if (_match_5652) {
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(kk_integer_from_small(0), _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
  }
  {
    bool _match_5653 = (d != (0x0p+0)); /*bool*/;
    if (_match_5653) {
      bool _match_5655;
      double _x5768 = kk_double_abs(d); /*float64*/
      _match_5655 = (_x5768 < (0x1p-1022)); /*bool*/
      if (_match_5655) {
        double d0_4562 = (d * 0x1p54); /*float64*/;
        int64_t i = kk_std_num_float64_float64_to_bits(d0_4562, _ctx); /*int64*/;
        int64_t exp;
        int64_t _x5769;
        int64_t _x5770;
        int64_t _x5771 = (KK_I64(52)); /*int64*/
        _x5770 = (int64_t)kk_shr64(i,_x5771); /*int64*/
        int64_t _x5772 = (KK_I64(2047)); /*int64*/
        _x5769 = _x5770 & _x5772; /*int64*/
        int64_t _x5773 = (KK_I64(1043)); /*int64*/
        exp = (int64_t)((uint64_t)_x5769 - (uint64_t)_x5773); /*int64*/
        int64_t man;
        int64_t _x5774;
        int64_t _x5775 = (KK_I64(4503599627370495)); /*int64*/
        _x5774 = i & _x5775; /*int64*/
        int64_t _x5776 = (KK_I64(4503599627370496)); /*int64*/
        man = (int64_t)((uint64_t)_x5774 + (uint64_t)_x5776); /*int64*/
        kk_integer_t x0_4483 = kk_integer_from_int64(exp,kk_context()); /*int*/;
        kk_integer_t x_4481 = kk_integer_add_small_const(x0_4483, -32, _ctx); /*int*/;
        kk_integer_t _b_5077_5069;
        int64_t _x5777;
        bool _match_5657 = 0 > i; /*bool*/;
        if (_match_5657) {
          int64_t _x5778 = (KK_I64(0)); /*int64*/
          _x5777 = (int64_t)((uint64_t)_x5778 - (uint64_t)man); /*int64*/
        }
        else {
          _x5777 = man; /*int64*/
        }
        _b_5077_5069 = kk_integer_from_int64(_x5777,kk_context()); /*int*/
        kk_integer_t _b_5078_5070 = kk_integer_add_small_const(x_4481, -54, _ctx); /*int*/;
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_5077_5069, _ctx), kk_integer_box(_b_5078_5070, _ctx), _ctx);
      }
      {
        int64_t i0 = kk_std_num_float64_float64_to_bits(d, _ctx); /*int64*/;
        int64_t exp0;
        int64_t _x5779;
        int64_t _x5780;
        int64_t _x5781 = (KK_I64(52)); /*int64*/
        _x5780 = (int64_t)kk_shr64(i0,_x5781); /*int64*/
        int64_t _x5782 = (KK_I64(2047)); /*int64*/
        _x5779 = _x5780 & _x5782; /*int64*/
        int64_t _x5783 = (KK_I64(1043)); /*int64*/
        exp0 = (int64_t)((uint64_t)_x5779 - (uint64_t)_x5783); /*int64*/
        int64_t man0;
        int64_t _x5784;
        int64_t _x5785 = (KK_I64(4503599627370495)); /*int64*/
        _x5784 = i0 & _x5785; /*int64*/
        int64_t _x5786 = (KK_I64(4503599627370496)); /*int64*/
        man0 = (int64_t)((uint64_t)_x5784 + (uint64_t)_x5786); /*int64*/
        kk_integer_t x0_44830 = kk_integer_from_int64(exp0,kk_context()); /*int*/;
        kk_integer_t x_44810 = kk_integer_add_small_const(x0_44830, -32, _ctx); /*int*/;
        kk_integer_t _b_5079_5071;
        int64_t _x5787;
        bool _match_5656 = 0 > i0; /*bool*/;
        if (_match_5656) {
          int64_t _x5788 = (KK_I64(0)); /*int64*/
          _x5787 = (int64_t)((uint64_t)_x5788 - (uint64_t)man0); /*int64*/
        }
        else {
          _x5787 = man0; /*int64*/
        }
        _b_5079_5071 = kk_integer_from_int64(_x5787,kk_context()); /*int*/
        kk_integer_t _b_5080_5072 = kk_integer_add_small_const(x_44810, 0, _ctx); /*int*/;
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_5079_5071, _ctx), kk_integer_box(_b_5080_5072, _ctx), _ctx);
      }
    }
    {
      int64_t i1 = kk_std_num_float64_float64_to_bits(d, _ctx); /*int64*/;
      int64_t exp1;
      int64_t _x5789;
      int64_t _x5790;
      int64_t _x5791 = (KK_I64(52)); /*int64*/
      _x5790 = (int64_t)kk_shr64(i1,_x5791); /*int64*/
      int64_t _x5792 = (KK_I64(2047)); /*int64*/
      _x5789 = _x5790 & _x5792; /*int64*/
      int64_t _x5793 = (KK_I64(1043)); /*int64*/
      exp1 = (int64_t)((uint64_t)_x5789 - (uint64_t)_x5793); /*int64*/
      int64_t man1;
      int64_t _x5794;
      int64_t _x5795 = (KK_I64(4503599627370495)); /*int64*/
      _x5794 = i1 & _x5795; /*int64*/
      int64_t _x5796 = (KK_I64(4503599627370496)); /*int64*/
      man1 = (int64_t)((uint64_t)_x5794 + (uint64_t)_x5796); /*int64*/
      kk_integer_t x0_44831 = kk_integer_from_int64(exp1,kk_context()); /*int*/;
      kk_integer_t x_44811 = kk_integer_add_small_const(x0_44831, -32, _ctx); /*int*/;
      kk_integer_t _b_5081_5073;
      int64_t _x5797;
      bool _match_5654 = 0 > i1; /*bool*/;
      if (_match_5654) {
        int64_t _x5798 = (KK_I64(0)); /*int64*/
        _x5797 = (int64_t)((uint64_t)_x5798 - (uint64_t)man1); /*int64*/
      }
      else {
        _x5797 = man1; /*int64*/
      }
      _b_5081_5073 = kk_integer_from_int64(_x5797,kk_context()); /*int*/
      kk_integer_t _b_5082_5074 = kk_integer_add_small_const(x_44811, 0, _ctx); /*int*/;
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_5081_5073, _ctx), kk_integer_box(_b_5082_5074, _ctx), _ctx);
    }
  }
}

double kk_std_num_float64_rad2deg;

double kk_std_num_float64_deg2rad;
 
// Calculate 2&middot;^`e`^ for an integer `e`.
// Uses efficient bit conversion for exponents between  -1022 and 1023 and
// otherwise falls back to the regular `exp2` function converting `e` to a float64.

double kk_std_num_float64_exp2_1(kk_integer_t e, kk_context_t* _ctx) { /* (e : int) -> float64 */ 
  bool _match_5650 = kk_integer_gte_borrow(e,(kk_integer_from_small(-1022)),kk_context()); /*bool*/;
  if (_match_5650) {
    bool _match_5651 = kk_integer_lte_borrow(e,(kk_integer_from_small(1023)),kk_context()); /*bool*/;
    if (_match_5651) {
      int64_t i_4486;
      kk_integer_t _x5799 = kk_integer_add_small_const(e, 1023, _ctx); /*int*/
      i_4486 = kk_std_core_int64(_x5799, _ctx); /*int64*/
      int64_t _x5800;
      int64_t _x5801 = (KK_I64(52)); /*int64*/
      _x5800 = kk_shl64(i_4486,_x5801); /*int64*/
      return kk_std_num_float64_float64_from_bits(_x5800, _ctx);
    }
    {
      double _x5802 = kk_integer_as_double(e,kk_context()); /*float64*/
      return exp2(_x5802);
    }
  }
  {
    double _x5803 = kk_integer_as_double(e,kk_context()); /*float64*/
    return exp2(_x5803);
  }
}
 
// Negative infinity

double kk_std_num_float64_neginf;
 
// Positive infinity

double kk_std_num_float64_posinf;
 
// 'Load exponent': returns `x`&middot;2^`e`^ for a `is-finite` `x` and
// otherwise `x` itself. See also `encode` which loads an integer mantissa.

double kk_std_num_float64_ldexp(double x, kk_integer_t e, kk_context_t* _ctx) { /* (x : float64, e : int) -> float64 */ 
  bool b_4490 = isfinite(x); /*bool*/;
  if (b_4490) {
    bool _match_5642 = kk_integer_gte_borrow(e,(kk_integer_from_small(-1022)),kk_context()); /*bool*/;
    if (_match_5642) {
      bool _match_5646 = kk_integer_lte_borrow(e,(kk_integer_from_small(1023)),kk_context()); /*bool*/;
      if (_match_5646) {
        double _x5805 = kk_std_num_float64_exp2_1(e, _ctx); /*float64*/
        return (x * _x5805);
      }
      {
        bool _match_5647 = kk_integer_lte_borrow(e,(kk_integer_from_small(2046)),kk_context()); /*bool*/;
        if (_match_5647) {
          double x1_4493 = (x * 0x1p1023); /*float64*/;
          kk_integer_t e1_4494 = kk_integer_add_small_const(e, -1023, _ctx); /*int*/;
          double _x5806 = kk_std_num_float64_exp2_1(e1_4494, _ctx); /*float64*/
          return (x1_4493 * _x5806);
        }
        {
          bool _match_5648 = kk_integer_lte_borrow(e,(kk_integer_from_small(3069)),kk_context()); /*bool*/;
          if (_match_5648) {
            double x3_4497;
            double _x5807 = (x * 0x1p1023); /*float64*/
            x3_4497 = (_x5807 * 0x1p1023); /*float64*/
            kk_integer_t e2_4498 = kk_integer_add_small_const(e, -2046, _ctx); /*int*/;
            double _x5808 = kk_std_num_float64_exp2_1(e2_4498, _ctx); /*float64*/
            return (x3_4497 * _x5808);
          }
          {
            kk_integer_drop(e, _ctx);
            bool _match_5649 = (x < (0x0p+0)); /*bool*/;
            if (_match_5649) {
              return kk_std_num_float64_neginf;
            }
            {
              return kk_std_num_float64_posinf;
            }
          }
        }
      }
    }
    {
      bool _match_5643 = kk_integer_gte_borrow(e,(kk_integer_from_small(-2044)),kk_context()); /*bool*/;
      if (_match_5643) {
        double x5_4501 = (x * (0x1p-1022)); /*float64*/;
        kk_integer_t e3_4502 = kk_integer_add_small_const(e, 1022, _ctx); /*int*/;
        double _x5809 = kk_std_num_float64_exp2_1(e3_4502, _ctx); /*float64*/
        return (x5_4501 * _x5809);
      }
      {
        bool _match_5644 = kk_integer_gte_borrow(e,(kk_integer_from_small(-3066)),kk_context()); /*bool*/;
        if (_match_5644) {
          double x7_4505;
          double _x5810 = (x * (0x1p-1022)); /*float64*/
          x7_4505 = (_x5810 * (0x1p-1022)); /*float64*/
          kk_integer_t e4_4506 = kk_integer_add_small_const(e, 2044, _ctx); /*int*/;
          double _x5811 = kk_std_num_float64_exp2_1(e4_4506, _ctx); /*float64*/
          return (x7_4505 * _x5811);
        }
        {
          kk_integer_drop(e, _ctx);
          bool _match_5645 = (x < (0x0p+0)); /*bool*/;
          if (_match_5645) {
            return -0x0p+0;
          }
          {
            return 0x0p+0;
          }
        }
      }
    }
  }
  {
    kk_integer_drop(e, _ctx);
    return x;
  }
}
 
// 'Fraction/exponent': return the normalized fraction `f` and exponent `exp`
// for a number `x` such that `x == f`&middot;2^`exp`^.
// The absolute value of the fraction `f` is always in the range [0.5, 1.0), or
// one of `0.0`, `-0.0`, `neginf`, `posinf`, or `nan`.
// See also `decode` which  decodes to an integer mantissa.

kk_std_core_types__tuple2_ kk_std_num_float64_frexp(double x, kk_context_t* _ctx) { /* (x : float64) -> (float64, int) */ 
  bool b_4510 = isfinite(x); /*bool*/;
  if (b_4510) {
    bool _match_5637 = (x == (0x0p+0)); /*bool*/;
    if (_match_5637) {
      bool _match_5639;
      double _x5815 = (0x1p0 / x); /*float64*/
      _match_5639 = (isinf(_x5815) && signbit(_x5815)); /*bool*/
      if (_match_5639) {
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(x, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
      }
      {
        kk_std_core_types__tuple2_ _match_5640 = kk_std_num_float64_decode(x, _ctx); /*(int, int)*/;
        {
          kk_box_t _box_x5085 = _match_5640.fst;
          kk_box_t _box_x5086 = _match_5640.snd;
          kk_integer_t m = kk_integer_unbox(_box_x5085, _ctx);
          kk_integer_t e = kk_integer_unbox(_box_x5086, _ctx);
          kk_integer_dup(e, _ctx);
          kk_integer_dup(m, _ctx);
          kk_std_core_types__tuple2__drop(_match_5640, _ctx);
          double _b_5097_5087;
          double _x5816 = kk_integer_as_double(m,kk_context()); /*float64*/
          _b_5097_5087 = (_x5816 * (0x1p-53)); /*float64*/
          kk_integer_t _b_5098_5088 = kk_integer_add_small_const(e, 53, _ctx); /*int*/;
          return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_5097_5087, _ctx), kk_integer_box(_b_5098_5088, _ctx), _ctx);
        }
      }
    }
    {
      kk_std_core_types__tuple2_ _match_5638 = kk_std_num_float64_decode(x, _ctx); /*(int, int)*/;
      {
        kk_box_t _box_x5089 = _match_5638.fst;
        kk_box_t _box_x5090 = _match_5638.snd;
        kk_integer_t m0 = kk_integer_unbox(_box_x5089, _ctx);
        kk_integer_t e0 = kk_integer_unbox(_box_x5090, _ctx);
        kk_integer_dup(e0, _ctx);
        kk_integer_dup(m0, _ctx);
        kk_std_core_types__tuple2__drop(_match_5638, _ctx);
        double _b_5099_5091;
        double _x5817 = kk_integer_as_double(m0,kk_context()); /*float64*/
        _b_5099_5091 = (_x5817 * (0x1p-53)); /*float64*/
        kk_integer_t _b_5100_5092 = kk_integer_add_small_const(e0, 53, _ctx); /*int*/;
        return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(_b_5099_5091, _ctx), kk_integer_box(_b_5100_5092, _ctx), _ctx);
      }
    }
  }
  {
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_double_box(x, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
  }
}
 
// The hypotenuse of `x` and `y`: `sqrt(x*x + y*y)`.
// Prevents overflow for large numbers.

double kk_std_num_float64_hypot(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  double xx = kk_double_abs(x); /*float64*/;
  double yy = kk_double_abs(y); /*float64*/;
  double lo;
  bool _match_5636 = (xx <= yy); /*bool*/;
  if (_match_5636) {
    lo = xx; /*float64*/
  }
  else {
    lo = yy; /*float64*/
  }
  double hi;
  bool _match_5635 = (xx >= yy); /*bool*/;
  if (_match_5635) {
    hi = xx; /*float64*/
  }
  else {
    hi = yy; /*float64*/
  }
  bool _match_5634 = (hi == (0x0p+0)); /*bool*/;
  if (_match_5634) {
    return 0x0p+0;
  }
  {
    double z = (lo / hi); /*float64*/;
    double _x5818;
    double _x5819;
    double _x5820 = (z * z); /*float64*/
    _x5819 = (0x1p0 + _x5820); /*float64*/
    _x5818 = sqrt(_x5819); /*float64*/
    return (hi * _x5818);
  }
}
 
// The square root of the sum of the squares of three floats.
// Prevents overflow for large numbers.

double kk_std_num_float64_hypot_1(double x, double y, double z, kk_context_t* _ctx) { /* (x : float64, y : float64, z : float64) -> float64 */ 
  double xx = kk_double_abs(x); /*float64*/;
  double yy = kk_double_abs(y); /*float64*/;
  double zz = kk_double_abs(z); /*float64*/;
  double x0_4518;
  bool _match_5633 = (xx >= yy); /*bool*/;
  if (_match_5633) {
    x0_4518 = xx; /*float64*/
  }
  else {
    x0_4518 = yy; /*float64*/
  }
  double hi;
  bool _match_5632 = (x0_4518 >= zz); /*bool*/;
  if (_match_5632) {
    hi = x0_4518; /*float64*/
  }
  else {
    hi = zz; /*float64*/
  }
  bool _match_5631 = (hi == (0x0p+0)); /*bool*/;
  if (_match_5631) {
    return 0x0p+0;
  }
  {
    double x4_4524 = (zz / hi); /*float64*/;
    double x2_4522 = (xx / hi); /*float64*/;
    double x3_4523 = (yy / hi); /*float64*/;
    double _x5821;
    double _x5822;
    double _x5823;
    double _x5824 = (x2_4522 * x2_4522); /*float64*/
    double _x5825 = (x3_4523 * x3_4523); /*float64*/
    _x5823 = (_x5824 + _x5825); /*float64*/
    double _x5826 = (x4_4524 * x4_4524); /*float64*/
    _x5822 = (_x5823 + _x5826); /*float64*/
    _x5821 = sqrt(_x5822); /*float64*/
    return (hi * _x5821);
  }
}
 
// lifted local: .lift4732-hypot.2, hypot.2, .spec.4712
// specialized: std/core/.unroll17344-foldl, on parameters f4707, using:
// f4707 = fn(m: float64, x: float64){
//   val x0.4441 : float64
//         = std/core/abs.1(x);
//   match ((std/core/(>=.3)(x0.4441, m))) {
//     ((std/core/types/True() : bool ) as .pat: bool)
//        -> x0.4441;
//     ((.skip std/core/types/False() : bool ) as .pat0: bool)
//        -> m;
//   };
// }

double kk_std_num_float64__lift4733_hypot_2(kk_std_core__list xs4705, double z4706, kk_context_t* _ctx) { /* (xs4705 : list<float64>, z4706 : float64) -> float64 */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs4705, _ctx)) {
    struct kk_std_core_Cons* _con5827 = kk_std_core__as_Cons(xs4705, _ctx);
    kk_box_t _box_x5103 = _con5827->head;
    kk_std_core__list xx4710 = _con5827->tail;
    double x4709 = kk_double_unbox(_box_x5103, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs4705, _ctx)) {
      kk_box_drop(_box_x5103, _ctx);
      kk_datatype_ptr_free(xs4705, _ctx);
    }
    else {
      kk_std_core__list_dup(xx4710, _ctx);
      kk_datatype_ptr_decref(xs4705, _ctx);
    }
    double x0_4441 = kk_double_abs(x4709); /*float64*/;
    { // tailcall
      double _x5828;
      bool _match_5630 = (x0_4441 >= z4706); /*bool*/;
      if (_match_5630) {
        _x5828 = x0_4441; /*float64*/
      }
      else {
        _x5828 = z4706; /*float64*/
      }
      xs4705 = xx4710;
      z4706 = _x5828;
      goto kk__tailcall;
    }
  }
  {
    return z4706;
  }
}
 
// lifted local: hypot.2, .spec.4704
// specialized: std/core/foldl, on parameters f4701, using:
// f4701 = fn(m: float64, x: float64){
//   val x0.4441 : float64
//         = std/core/abs.1(x);
//   match ((std/core/(>=.3)(x0.4441, m))) {
//     ((std/core/types/True() : bool ) as .pat: bool)
//        -> x0.4441;
//     ((.skip std/core/types/False() : bool ) as .pat0: bool)
//        -> m;
//   };
// }

double kk_std_num_float64__lift4732_hypot_2(kk_std_core__list xs4699, double z4700, kk_context_t* _ctx) { /* (xs4699 : list<float64>, z4700 : float64) -> float64 */ 
  if (kk_std_core__is_Nil(xs4699, _ctx)) {
    return z4700;
  }
  {
    return kk_std_num_float64__lift4733_hypot_2(xs4699, z4700, _ctx);
  }
}
 
// lifted local: .lift4734-hypot.2, hypot.2, .spec.4726
// specialized: std/core/.unroll17333-map.5, on parameters f4721, using:
// f4721 = fn(x0: float64){
//   val x0.4525 : float64
//         = std/core/(/.1)(x0, hi);
//   std/core/(*.1)(x0.4525, x0.4525);
// }

kk_std_core__list kk_std_num_float64__trmc_lift4735_hypot_2(double hi, kk_std_core__list xs4720, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (hi : float64, xs4720 : list<float64>, ctx<list<float64>>) -> list<float64> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs4720, _ctx)) {
    struct kk_std_core_Cons* _con5829 = kk_std_core__as_Cons(xs4720, _ctx);
    kk_box_t _box_x5104 = _con5829->head;
    kk_std_core__list xx4724 = _con5829->tail;
    double x4723 = kk_double_unbox(_box_x5104, KK_BORROWED, _ctx);
    kk_reuse_t _ru_5693 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs4720, _ctx)) {
      kk_box_drop(_box_x5104, _ctx);
      _ru_5693 = (kk_datatype_ptr_reuse(xs4720, _ctx));
    }
    else {
      kk_std_core__list_dup(xx4724, _ctx);
      kk_datatype_ptr_decref(xs4720, _ctx);
    }
    double x0_4525 = (x4723 / hi); /*float64*/;
    double _trmc_4740 = (x0_4525 * x0_4525); /*float64*/;
    kk_std_core__list _trmc_4741 = kk_datatype_null(); /*list<float64>*/;
    kk_std_core__list _trmc_4742 = kk_std_core__new_Cons(_ru_5693, 0, kk_double_box(_trmc_4740, _ctx), _trmc_4741, _ctx); /*list<float64>*/;
    kk_box_t* _b_5119_5114 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_4742, _ctx)->tail)); /*field-addr<list<float64>>*/;
    { // tailcall
      kk_std_core_types__cctx _x5830 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_4742, _ctx)),_b_5119_5114,true,kk_context()); /*ctx<0>*/
      xs4720 = xx4724;
      _acc = _x5830;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x5831 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x5831, KK_OWNED, _ctx);
  }
}
 
// lifted local: .lift4734-hypot.2, hypot.2, .spec.4726
// specialized: std/core/.unroll17333-map.5, on parameters f4721, using:
// f4721 = fn(x0: float64){
//   val x0.4525 : float64
//         = std/core/(/.1)(x0, hi);
//   std/core/(*.1)(x0.4525, x0.4525);
// }

kk_std_core__list kk_std_num_float64__lift4735_hypot_2(double hi0, kk_std_core__list xs47200, kk_context_t* _ctx) { /* (hi : float64, xs4720 : list<float64>) -> list<float64> */ 
  kk_std_core_types__cctx _x5832 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_num_float64__trmc_lift4735_hypot_2(hi0, xs47200, _x5832, _ctx);
}
 
// lifted local: hypot.2, .spec.4719
// specialized: std/core/map.5, on parameters f4716, using:
// f4716 = fn(x0: float64){
//   val x0.4525 : float64
//         = std/core/(/.1)(x0, hi);
//   std/core/(*.1)(x0.4525, x0.4525);
// }

kk_std_core__list kk_std_num_float64__lift4734_hypot_2(double hi, kk_std_core__list xs4715, kk_context_t* _ctx) { /* (hi : float64, xs4715 : list<float64>) -> list<float64> */ 
  if (kk_std_core__is_Nil(xs4715, _ctx)) {
    return kk_std_core__new_Nil(_ctx);
  }
  {
    return kk_std_num_float64__lift4735_hypot_2(hi, xs4715, _ctx);
  }
}
 
// The square root of the sum of squares of a list of floats.
// Prevents overflow for large numbers and uses Kahan-Babu&scaron;kan-Neumaier summation
// for precision.

double kk_std_num_float64_hypot_2(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  double hi;
  kk_std_core__list _x5833 = kk_std_core__list_dup(xs, _ctx); /*list<float64>*/
  hi = kk_std_num_float64__lift4732_hypot_2(_x5833, 0x0p+0, _ctx); /*float64*/
  bool _match_5629 = (hi == (0x0p+0)); /*bool*/;
  if (_match_5629) {
    kk_std_core__list_drop(xs, _ctx);
    return 0x0p+0;
  }
  {
    kk_std_core__list xs0_5000 = kk_std_num_float64__lift4734_hypot_2(hi, xs, _ctx); /*list<float64>*/;
    kk_ref_t loc = kk_ref_alloc((kk_double_box(0x0p+0, _ctx)),kk_context()); /*local-var<672,float64>*/;
    kk_ref_t loc0 = kk_ref_alloc((kk_double_box(0x0p+0, _ctx)),kk_context()); /*local-var<672,float64>*/;
    kk_unit_t __0 = kk_Unit;
    kk_ref_t _x5834 = kk_ref_dup(loc0, _ctx); /*local-var<672,float64>*/
    kk_ref_t _x5835 = kk_ref_dup(loc, _ctx); /*local-var<672,float64>*/
    kk_std_num_float64__lift4730_sum(_x5834, _x5835, xs0_5000, _ctx);
    double res0;
    double _x5836;
    kk_box_t _x5837;
    kk_ref_t _x5838 = kk_ref_dup(loc, _ctx); /*local-var<672,float64>*/
    _x5837 = kk_ref_get(_x5838,kk_context()); /*264*/
    _x5836 = kk_double_unbox(_x5837, KK_OWNED, _ctx); /*float64*/
    double _x5839;
    kk_box_t _x5840;
    kk_ref_t _x5841 = kk_ref_dup(loc0, _ctx); /*local-var<672,float64>*/
    _x5840 = kk_ref_get(_x5841,kk_context()); /*264*/
    _x5839 = kk_double_unbox(_x5840, KK_OWNED, _ctx); /*float64*/
    res0 = (_x5836 + _x5839); /*float64*/
    double res;
    kk_box_t _x5842 = kk_std_core_hnd_prompt_local_var(loc0, kk_double_box(res0, _ctx), _ctx); /*10459*/
    res = kk_double_unbox(_x5842, KK_OWNED, _ctx); /*float64*/
    kk_ref_t _b_5139_5137 = loc; /*local-var<672,float64>*/;
    double _b_5140_5138 = res; /*float64*/;
    double _x5843;
    double _x5844;
    kk_box_t _x5845 = kk_std_core_hnd_prompt_local_var(_b_5139_5137, kk_double_box(_b_5140_5138, _ctx), _ctx); /*10459*/
    _x5844 = kk_double_unbox(_x5845, KK_OWNED, _ctx); /*float64*/
    _x5843 = sqrt(_x5844); /*float64*/
    return (hi * _x5843);
  }
}
 
// Returns `ln(exp(x) + exp(y))`.
// Avoids overlow/underflow errors.

double kk_std_num_float64_lnaddexp(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  bool _match_5627 = (x == y); /*bool*/;
  if (_match_5627) {
    return (x + (0x1.62e42fefa39efp-1));
  }
  {
    double z = (x - y); /*float64*/;
    bool _match_5628 = (z > (0x0p+0)); /*bool*/;
    if (_match_5628) {
      double _x5846;
      double _x5847;
      double _x5848 = (-z); /*float64*/
      _x5847 = exp(_x5848); /*float64*/
      _x5846 = log1p(_x5847); /*float64*/
      return (x + _x5846);
    }
    {
      double _x5849;
      double _x5850 = exp(z); /*float64*/
      _x5849 = log1p(_x5850); /*float64*/
      return (y + _x5849);
    }
  }
}
 
// Returns `log2( exp2(x) + exp2(y) )`.
// Avoids overlow/underflow errors.

double kk_std_num_float64_logaddexp2(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  bool _match_5625 = (x == y); /*bool*/;
  if (_match_5625) {
    return (x + 0x1p0);
  }
  {
    double z = (x - y); /*float64*/;
    bool _match_5626 = (z > (0x0p+0)); /*bool*/;
    if (_match_5626) {
      double x0_4526;
      double _x5852 = (-z); /*float64*/
      x0_4526 = exp2(_x5852); /*float64*/
      double _x5853;
      double _x5854 = log1p(x0_4526); /*float64*/
      _x5853 = ((0x1.71547652b82fep0) * _x5854); /*float64*/
      return (x + _x5853);
    }
    {
      double x1_4527 = exp2(z); /*float64*/;
      double _x5855;
      double _x5856 = log1p(x1_4527); /*float64*/
      _x5855 = ((0x1.71547652b82fep0) * _x5856); /*float64*/
      return (y + _x5855);
    }
  }
}
 
// The midpoint is the average of `x` and `y`.
// Avoids overflow on large numbers.

double kk_std_num_float64_midpoint(double x, double y, kk_context_t* _ctx) { /* (x : float64, y : float64) -> float64 */ 
  bool _match_5619 = (x != (0x0p+0)); /*bool*/;
  if (_match_5619) {
    bool _match_5622;
    double _x5857 = kk_double_abs(x); /*float64*/
    _match_5622 = (_x5857 < (0x1p-1022)); /*bool*/
    if (_match_5622) {
      double _x5858 = (x + y); /*float64*/
      return (_x5858 / 0x1p1);
    }
    {
      bool _match_5623 = (y != (0x0p+0)); /*bool*/;
      if (_match_5623) {
        bool _match_5624;
        double _x5859 = kk_double_abs(y); /*float64*/
        _match_5624 = (_x5859 < (0x1p-1022)); /*bool*/
        if (_match_5624) {
          double _x5860 = (x + y); /*float64*/
          return (_x5860 / 0x1p1);
        }
        {
          double _x5861 = (x / 0x1p1); /*float64*/
          double _x5862 = (y / 0x1p1); /*float64*/
          return (_x5861 + _x5862);
        }
      }
      {
        double _x5863 = (x / 0x1p1); /*float64*/
        double _x5864 = (y / 0x1p1); /*float64*/
        return (_x5863 + _x5864);
      }
    }
  }
  {
    bool _match_5620 = (y != (0x0p+0)); /*bool*/;
    if (_match_5620) {
      bool _match_5621;
      double _x5865 = kk_double_abs(y); /*float64*/
      _match_5621 = (_x5865 < (0x1p-1022)); /*bool*/
      if (_match_5621) {
        double _x5866 = (x + y); /*float64*/
        return (_x5866 / 0x1p1);
      }
      {
        double _x5867 = (x / 0x1p1); /*float64*/
        double _x5868 = (y / 0x1p1); /*float64*/
        return (_x5867 + _x5868);
      }
    }
    {
      double _x5869 = (x / 0x1p1); /*float64*/
      double _x5870 = (y / 0x1p1); /*float64*/
      return (_x5869 + _x5870);
    }
  }
}
 
// Represents a value that is _not a number_ (NaN)

double kk_std_num_float64_nan;
 
// Return if two floats are nearly equal with respect to some `epsilon` (=`8*flt-epsilon`).
// The epsilon is the nearest difference for numbers around 1.0. The routine automatically
// scales the epsilon for larger and smaller numbers, and for subnormal numbers.

bool kk_std_num_float64_nearly_eq(double x, double y, kk_std_core_types__optional epsilon, kk_context_t* _ctx) { /* (x : float64, y : float64, epsilon : optional<float64>) -> bool */ 
  double _epsilon_2963;
  if (kk_std_core_types__is_Optional(epsilon, _ctx)) {
    kk_box_t _box_x5141 = epsilon._cons.Optional.value;
    double _epsilon_2964 = kk_double_unbox(_box_x5141, KK_BORROWED, _ctx);
    kk_std_core_types__optional_drop(epsilon, _ctx);
    _epsilon_2963 = _epsilon_2964; /*float64*/
  }
  else {
    kk_std_core_types__optional_drop(epsilon, _ctx);
    _epsilon_2963 = (0x1p3 * (0x1p-52)); /*float64*/
  }
  bool _match_5614 = (x == y); /*bool*/;
  if (_match_5614) {
    return true;
  }
  {
    double diff;
    double _x5871 = (x - y); /*float64*/
    diff = kk_double_abs(_x5871); /*float64*/
    bool _match_5615 = (x == (0x0p+0)); /*bool*/;
    if (_match_5615) {
      double _x5872 = (0x1p1 * diff); /*float64*/
      double _x5873 = (_epsilon_2963 * (0x1p-1022)); /*float64*/
      return (_x5872 < _x5873);
    }
    {
      bool _match_5616 = (y == (0x0p+0)); /*bool*/;
      if (_match_5616) {
        double _x5874 = (0x1p1 * diff); /*float64*/
        double _x5875 = (_epsilon_2963 * (0x1p-1022)); /*float64*/
        return (_x5874 < _x5875);
      }
      {
        bool _match_5617 = (diff < (0x1p-1022)); /*bool*/;
        if (_match_5617) {
          double _x5876 = (0x1p1 * diff); /*float64*/
          double _x5877 = (_epsilon_2963 * (0x1p-1022)); /*float64*/
          return (_x5876 < _x5877);
        }
        {
          double sum0;
          double _x5878 = kk_double_abs(x); /*float64*/
          double _x5879 = kk_double_abs(y); /*float64*/
          sum0 = (_x5878 + _x5879); /*float64*/
          double _x5880;
          double _x5881 = (0x1p1 * diff); /*float64*/
          double _x5882;
          bool _match_5618 = (sum0 > (0x1.fffffffffffffp1023)); /*bool*/;
          if (_match_5618) {
            _x5882 = 0x1.fffffffffffffp1023; /*float64*/
          }
          else {
            _x5882 = sum0; /*float64*/
          }
          _x5880 = (_x5881 / _x5882); /*float64*/
          return (_x5880 < _epsilon_2963);
        }
      }
    }
  }
}
 
// Returns the greatest `:float64` less than `x`.
// This behaves exactly as `nextDown` in the IEEE 754-2008 standard.
// The identity `x.next-down == ~next-down(~x)` holds for all `x`.
// When `x` is finite `x == x.next-down.next-up` also holds.

double kk_std_num_float64_next_down(double x, kk_context_t* _ctx) { /* (x : float64) -> float64 */ 
  bool _match_5610 = isnan(x); /*bool*/;
  if (_match_5610) {
    return x;
  }
  {
    bool _match_5611 = (isinf(x) && signbit(x)); /*bool*/;
    if (_match_5611) {
      return x;
    }
    {
      bool _match_5612 = (x == (0x0p+0)); /*bool*/;
      if (_match_5612) {
        return (-(0x1p-1074));
      }
      {
        int64_t i = kk_std_num_float64_float64_to_bits(x, _ctx); /*int64*/;
        int64_t next;
        bool _match_5613 = 0 > i; /*bool*/;
        if (_match_5613) {
          int64_t _x5883 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i + (uint64_t)_x5883); /*int64*/
        }
        else {
          int64_t _x5884 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i - (uint64_t)_x5884); /*int64*/
        }
        return kk_std_num_float64_float64_from_bits(next, _ctx);
      }
    }
  }
}
 
// Returns the least `:float64` greater than `x`.
// This behaves exactly as `nextUp` in the IEEE 754-2008 standard.
// The identity `x.next-up == ~next-down(~x)` holds for all `x`.
// When `x` is finite `x == x.next-up.next-down` also holds.

double kk_std_num_float64_next_up(double x, kk_context_t* _ctx) { /* (x : float64) -> float64 */ 
  bool _match_5606 = isnan(x); /*bool*/;
  if (_match_5606) {
    return x;
  }
  {
    bool _match_5607 = (isinf(x) && !signbit(x)); /*bool*/;
    if (_match_5607) {
      return x;
    }
    {
      bool _match_5608 = (x == (0x0p+0)); /*bool*/;
      if (_match_5608) {
        return 0x1p-1074;
      }
      {
        int64_t i = kk_std_num_float64_float64_to_bits(x, _ctx); /*int64*/;
        int64_t next;
        bool _match_5609 = 0 > i; /*bool*/;
        if (_match_5609) {
          int64_t _x5885 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i - (uint64_t)_x5885); /*int64*/
        }
        else {
          int64_t _x5886 = (KK_I64(1)); /*int64*/
          next = (int64_t)((uint64_t)i + (uint64_t)_x5886); /*int64*/
        }
        return kk_std_num_float64_float64_from_bits(next, _ctx);
      }
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4795_pdecdouble_fun5888__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4795_pdecdouble_fun5888(kk_function_t _fself, kk_box_t _b_5144, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4795_pdecdouble_fun5888(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4795_pdecdouble_fun5888, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4795_pdecdouble_fun5888(kk_function_t _fself, kk_box_t _b_5144, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5889;
  kk_string_t _x5890 = kk_string_unbox(_b_5144); /*string*/
  _x5889 = kk_std_num_float64_prim_parse_float64(_x5890, _ctx); /*float64*/
  return kk_double_box(_x5889, _ctx);
}

double kk_std_num_float64__mlift4795_pdecdouble(kk_std_core__sslice cur, kk_integer_t _c_4752, kk_context_t* _ctx) { /* (cur : sslice, int) -> float64 */ 
  kk_integer_drop(_c_4752, _ctx);
  kk_string_t _x1_4787 = kk_std_core_string_3(cur, _ctx); /*string*/;
  kk_box_t _x5887 = kk_std_core_hnd__open_none1(kk_std_num_float64__new_mlift4795_pdecdouble_fun5888(_ctx), kk_string_box(_x1_4787), _ctx); /*3357*/
  return kk_double_unbox(_x5887, KK_OWNED, _ctx);
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4796_pdecdouble_fun5894__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4796_pdecdouble_fun5894(kk_function_t _fself, kk_box_t _b_5148, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4796_pdecdouble_fun5894(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4796_pdecdouble_fun5894, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4796_pdecdouble_fun5894(kk_function_t _fself, kk_box_t _b_5148, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x5895;
  kk_char_t _x5896 = kk_char_unbox(_b_5148, KK_OWNED, _ctx); /*char*/
  _x5895 = kk_std_num_float64__mlift4794_pdecdouble(_x5896, _ctx); /*int*/
  return kk_integer_box(_x5895, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4796_pdecdouble_fun5897__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static double kk_std_num_float64__mlift4796_pdecdouble_fun5897(kk_function_t _fself, kk_integer_t _c_4752, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4796_pdecdouble_fun5897(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4796_pdecdouble_fun5897__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4796_pdecdouble_fun5897__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4796_pdecdouble_fun5897, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4796_pdecdouble_fun5899__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4796_pdecdouble_fun5899(kk_function_t _fself, kk_box_t _b_5152, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4796_pdecdouble_fun5899(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4796_pdecdouble_fun5899, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4796_pdecdouble_fun5899(kk_function_t _fself, kk_box_t _b_5152, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5900;
  kk_string_t _x5901 = kk_string_unbox(_b_5152); /*string*/
  _x5900 = kk_std_num_float64_prim_parse_float64(_x5901, _ctx); /*float64*/
  return kk_double_box(_x5900, _ctx);
}
static double kk_std_num_float64__mlift4796_pdecdouble_fun5897(kk_function_t _fself, kk_integer_t _c_4752, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4796_pdecdouble_fun5897__t* _self = kk_function_as(struct kk_std_num_float64__mlift4796_pdecdouble_fun5897__t*, _fself, _ctx);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur, _ctx);}, {}, _ctx)
  kk_integer_drop(_c_4752, _ctx);
  kk_string_t _x1_4787 = kk_std_core_string_3(cur, _ctx); /*string*/;
  kk_box_t _x5898 = kk_std_core_hnd__open_none1(kk_std_num_float64__new_mlift4796_pdecdouble_fun5899(_ctx), kk_string_box(_x1_4787), _ctx); /*3357*/
  return kk_double_unbox(_x5898, KK_OWNED, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4796_pdecdouble_fun5903__t {
  struct kk_function_s _base;
  kk_function_t next_4824;
};
static kk_box_t kk_std_num_float64__mlift4796_pdecdouble_fun5903(kk_function_t _fself, kk_box_t _b_5156, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4796_pdecdouble_fun5903(kk_function_t next_4824, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4796_pdecdouble_fun5903__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4796_pdecdouble_fun5903__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4796_pdecdouble_fun5903, kk_context());
  _self->next_4824 = next_4824;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4796_pdecdouble_fun5903(kk_function_t _fself, kk_box_t _b_5156, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4796_pdecdouble_fun5903__t* _self = kk_function_as(struct kk_std_num_float64__mlift4796_pdecdouble_fun5903__t*, _fself, _ctx);
  kk_function_t next_4824 = _self->next_4824; /* (int) -> float64 */
  kk_drop_match(_self, {kk_function_dup(next_4824, _ctx);}, {}, _ctx)
  double _x5904;
  kk_integer_t _x5905 = kk_integer_unbox(_b_5156, _ctx); /*int*/
  _x5904 = kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), next_4824, (next_4824, _x5905, _ctx), _ctx); /*float64*/
  return kk_double_box(_x5904, _ctx);
}

double kk_std_num_float64__mlift4796_pdecdouble(kk_std_core__sslice cur, bool _y_4749, kk_context_t* _ctx) { /* (cur : sslice, bool) -> std/text/parse/parse float64 */ 
  kk_integer_t x_4823;
  if (_y_4749) {
    kk_char_t x0_4825;
    kk_string_t _x5891;
    kk_define_string_literal(, _s5892, 2, "eE", _ctx)
    _x5891 = kk_string_dup(_s5892, _ctx); /*string*/
    x0_4825 = kk_std_text_parse_one_of(_x5891, _ctx); /*char*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x5893 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4796_pdecdouble_fun5894(_ctx), _ctx); /*3926*/
      x_4823 = kk_integer_unbox(_x5893, _ctx); /*int*/
    }
    else {
      x_4823 = kk_std_text_parse_pint(_ctx); /*int*/
    }
  }
  else {
    x_4823 = kk_integer_from_small(0); /*int*/
  }
  kk_function_t next_4824 = kk_std_num_float64__new_mlift4796_pdecdouble_fun5897(cur, _ctx); /*(int) -> float64*/;
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_4823, _ctx);
    kk_box_t _x5902 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4796_pdecdouble_fun5903(next_4824, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5902, KK_OWNED, _ctx);
  }
  {
    return kk_function_call(double, (kk_function_t, kk_integer_t, kk_context_t*), next_4824, (next_4824, x_4823, _ctx), _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4798_pdecdouble_fun5912__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static kk_box_t kk_std_num_float64__mlift4798_pdecdouble_fun5912(kk_function_t _fself, kk_box_t _b_5165, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4798_pdecdouble_fun5912(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4798_pdecdouble_fun5912__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4798_pdecdouble_fun5912__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4798_pdecdouble_fun5912, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4798_pdecdouble_fun5912(kk_function_t _fself, kk_box_t _b_5165, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4798_pdecdouble_fun5912__t* _self = kk_function_as(struct kk_std_num_float64__mlift4798_pdecdouble_fun5912__t*, _fself, _ctx);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur, _ctx);}, {}, _ctx)
  bool _y_5167_4749 = kk_bool_unbox(_b_5165); /*bool*/;
  double _x5913 = kk_std_num_float64__mlift4796_pdecdouble(cur, _y_5167_4749, _ctx); /*float64*/
  return kk_double_box(_x5913, _ctx);
}

double kk_std_num_float64__mlift4798_pdecdouble(kk_std_core__sslice cur, kk_string_t _c_4748, kk_context_t* _ctx) { /* (cur : sslice, string) -> float64 */ 
  kk_string_t frac;
  kk_string_t _x5906;
  kk_define_string_literal(, _s5907, 1, "0", _ctx)
  _x5906 = kk_string_dup(_s5907, _ctx); /*string*/
  frac = kk_std_core_trim_right_1(_c_4748, _x5906, _ctx); /*string*/
  kk_string_drop(frac, _ctx);
  kk_std_core_hnd__ev ev_4831;
  kk_ssize_t _x5908 = (KK_IZ(0)); /*ssize_t*/
  ev_4831 = kk_evv_at(_x5908,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x_4829;
  kk_box_t _x5909;
  {
    struct kk_std_core_hnd_Ev* _con5910 = kk_std_core_hnd__as_Ev(ev_4831, _ctx);
    kk_box_t _box_x5158 = _con5910->hnd;
    kk_std_core_hnd__marker m0 = _con5910->marker;
    kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x5158, KK_BORROWED, _ctx);
    kk_std_text_parse__hnd_parse_dup(h, _ctx);
    kk_std_core_hnd__clause0 _match_5602;
    kk_std_core_hnd__clause0 _brw_5603 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/;
    kk_std_text_parse__hnd_parse_drop(h, _ctx);
    _match_5602 = _brw_5603; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/
    {
      kk_function_t _fun_unbox_x5161 = _match_5602.clause;
      _x5909 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x5161, (_fun_unbox_x5161, m0, ev_4831, _ctx), _ctx); /*37*/
    }
  }
  x_4829 = kk_bool_unbox(_x5909); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x5911 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4798_pdecdouble_fun5912(cur, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5911, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4796_pdecdouble(cur, x_4829, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4799_pdecdouble_fun5915__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4799_pdecdouble_fun5915(kk_function_t _fself, kk_box_t _b_5169, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4799_pdecdouble_fun5915(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4799_pdecdouble_fun5915, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4799_pdecdouble_fun5915(kk_function_t _fself, kk_box_t _b_5169, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x5916;
  kk_char_t _x5917 = kk_char_unbox(_b_5169, KK_OWNED, _ctx); /*char*/
  _x5916 = kk_std_num_float64__mlift4797_pdecdouble(_x5917, _ctx); /*string*/
  return kk_string_box(_x5916);
}


// lift anonymous function
struct kk_std_num_float64__mlift4799_pdecdouble_fun5920__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static kk_box_t kk_std_num_float64__mlift4799_pdecdouble_fun5920(kk_function_t _fself, kk_box_t _b_5172, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4799_pdecdouble_fun5920(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4799_pdecdouble_fun5920__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4799_pdecdouble_fun5920__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4799_pdecdouble_fun5920, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4799_pdecdouble_fun5920(kk_function_t _fself, kk_box_t _b_5172, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4799_pdecdouble_fun5920__t* _self = kk_function_as(struct kk_std_num_float64__mlift4799_pdecdouble_fun5920__t*, _fself, _ctx);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur, _ctx);}, {}, _ctx)
  kk_string_t _c_5174_4748 = kk_string_unbox(_b_5172); /*string*/;
  double _x5921 = kk_std_num_float64__mlift4798_pdecdouble(cur, _c_5174_4748, _ctx); /*float64*/
  return kk_double_box(_x5921, _ctx);
}

double kk_std_num_float64__mlift4799_pdecdouble(kk_std_core__sslice cur, bool _y_4745, kk_context_t* _ctx) { /* (cur : sslice, bool) -> std/text/parse/parse float64 */ 
  kk_string_t x_4833;
  if (_y_4745) {
    kk_char_t x0_4835 = kk_std_text_parse_char('.', _ctx); /*char*/;
    if (kk_yielding(kk_context())) {
      kk_box_t _x5914 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4799_pdecdouble_fun5915(_ctx), _ctx); /*3926*/
      x_4833 = kk_string_unbox(_x5914); /*string*/
    }
    else {
      x_4833 = kk_std_text_parse_digits0(_ctx); /*string*/
    }
  }
  else {
    x_4833 = kk_string_empty(); /*string*/
  }
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4833, _ctx);
    kk_box_t _x5919 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4799_pdecdouble_fun5920(cur, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5919, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4798_pdecdouble(cur, x_4833, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4800_pdecdouble_fun5926__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static kk_box_t kk_std_num_float64__mlift4800_pdecdouble_fun5926(kk_function_t _fself, kk_box_t _b_5182, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4800_pdecdouble_fun5926(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4800_pdecdouble_fun5926__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4800_pdecdouble_fun5926__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4800_pdecdouble_fun5926, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4800_pdecdouble_fun5926(kk_function_t _fself, kk_box_t _b_5182, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4800_pdecdouble_fun5926__t* _self = kk_function_as(struct kk_std_num_float64__mlift4800_pdecdouble_fun5926__t*, _fself, _ctx);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur, _ctx);}, {}, _ctx)
  bool _y_5184_4745 = kk_bool_unbox(_b_5182); /*bool*/;
  double _x5927 = kk_std_num_float64__mlift4799_pdecdouble(cur, _y_5184_4745, _ctx); /*float64*/
  return kk_double_box(_x5927, _ctx);
}

double kk_std_num_float64__mlift4800_pdecdouble(kk_std_core__sslice cur, kk_string_t man, kk_context_t* _ctx) { /* (cur : sslice, man : string) -> std/text/parse/parse float64 */ 
  kk_string_drop(man, _ctx);
  kk_std_core_hnd__ev ev_4839;
  kk_ssize_t _x5922 = (KK_IZ(0)); /*ssize_t*/
  ev_4839 = kk_evv_at(_x5922,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x_4837;
  kk_box_t _x5923;
  {
    struct kk_std_core_hnd_Ev* _con5924 = kk_std_core_hnd__as_Ev(ev_4839, _ctx);
    kk_box_t _box_x5175 = _con5924->hnd;
    kk_std_core_hnd__marker m0 = _con5924->marker;
    kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x5175, KK_BORROWED, _ctx);
    kk_std_text_parse__hnd_parse_dup(h, _ctx);
    kk_std_core_hnd__clause0 _match_5597;
    kk_std_core_hnd__clause0 _brw_5598 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/;
    kk_std_text_parse__hnd_parse_drop(h, _ctx);
    _match_5597 = _brw_5598; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/
    {
      kk_function_t _fun_unbox_x5178 = _match_5597.clause;
      _x5923 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x5178, (_fun_unbox_x5178, m0, ev_4839, _ctx), _ctx); /*37*/
    }
  }
  x_4837 = kk_bool_unbox(_x5923); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x5925 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4800_pdecdouble_fun5926(cur, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5925, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4799_pdecdouble(cur, x_4837, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4801_pdecdouble_fun5929__t {
  struct kk_function_s _base;
  kk_std_core__sslice cur;
};
static kk_box_t kk_std_num_float64__mlift4801_pdecdouble_fun5929(kk_function_t _fself, kk_box_t _b_5186, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4801_pdecdouble_fun5929(kk_std_core__sslice cur, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4801_pdecdouble_fun5929__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4801_pdecdouble_fun5929__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4801_pdecdouble_fun5929, kk_context());
  _self->cur = cur;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4801_pdecdouble_fun5929(kk_function_t _fself, kk_box_t _b_5186, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4801_pdecdouble_fun5929__t* _self = kk_function_as(struct kk_std_num_float64__mlift4801_pdecdouble_fun5929__t*, _fself, _ctx);
  kk_std_core__sslice cur = _self->cur; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(cur, _ctx);}, {}, _ctx)
  kk_string_t man_5188 = kk_string_unbox(_b_5186); /*string*/;
  double _x5930 = kk_std_num_float64__mlift4800_pdecdouble(cur, man_5188, _ctx); /*float64*/
  return kk_double_box(_x5930, _ctx);
}

double kk_std_num_float64__mlift4801_pdecdouble(kk_std_core__sslice cur, kk_context_t* _ctx) { /* (cur : sslice) -> std/text/parse/parse float64 */ 
  kk_string_t x_4841 = kk_std_text_parse_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4841, _ctx);
    kk_box_t _x5928 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4801_pdecdouble_fun5929(cur, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5928, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4800_pdecdouble(cur, x_4841, _ctx);
  }
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5935__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5935(kk_function_t _fself, kk_box_t _b_5196, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5935(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5935, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5935(kk_function_t _fself, kk_box_t _b_5196, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5936;
  kk_std_core__sslice _x5937 = kk_std_core__sslice_unbox(_b_5196, KK_OWNED, _ctx); /*sslice*/
  _x5936 = kk_std_num_float64__mlift4801_pdecdouble(_x5937, _ctx); /*float64*/
  return kk_double_box(_x5936, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5939__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_4843;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5939(kk_function_t _fself, kk_box_t _b_5198, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5939(kk_std_core__sslice x_4843, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5939__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun5939__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun5939, kk_context());
  _self->x_4843 = x_4843;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5939(kk_function_t _fself, kk_box_t _b_5198, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5939__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun5939__t*, _fself, _ctx);
  kk_std_core__sslice x_4843 = _self->x_4843; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_4843, _ctx);}, {}, _ctx)
  kk_string_t man_5241 = kk_string_unbox(_b_5198); /*string*/;
  double _x5940 = kk_std_num_float64__mlift4800_pdecdouble(x_4843, man_5241, _ctx); /*float64*/
  return kk_double_box(_x5940, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5945__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_4843;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5945(kk_function_t _fself, kk_box_t _b_5206, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5945(kk_std_core__sslice x_4843, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5945__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun5945__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun5945, kk_context());
  _self->x_4843 = x_4843;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5945(kk_function_t _fself, kk_box_t _b_5206, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5945__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun5945__t*, _fself, _ctx);
  kk_std_core__sslice x_4843 = _self->x_4843; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_4843, _ctx);}, {}, _ctx)
  bool _y_5242_4745 = kk_bool_unbox(_b_5206); /*bool*/;
  double _x5946 = kk_std_num_float64__mlift4799_pdecdouble(x_4843, _y_5242_4745, _ctx); /*float64*/
  return kk_double_box(_x5946, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5948__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5948(kk_function_t _fself, kk_box_t _b_5208, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5948(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5948, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5948(kk_function_t _fself, kk_box_t _b_5208, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x5949;
  kk_char_t _x5950 = kk_char_unbox(_b_5208, KK_OWNED, _ctx); /*char*/
  _x5949 = kk_std_num_float64__mlift4797_pdecdouble(_x5950, _ctx); /*string*/
  return kk_string_box(_x5949);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5953__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_4843;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5953(kk_function_t _fself, kk_box_t _b_5211, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5953(kk_std_core__sslice x_4843, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5953__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun5953__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun5953, kk_context());
  _self->x_4843 = x_4843;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5953(kk_function_t _fself, kk_box_t _b_5211, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5953__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun5953__t*, _fself, _ctx);
  kk_std_core__sslice x_4843 = _self->x_4843; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_4843, _ctx);}, {}, _ctx)
  kk_string_t _c_5243_4748 = kk_string_unbox(_b_5211); /*string*/;
  double _x5954 = kk_std_num_float64__mlift4798_pdecdouble(x_4843, _c_5243_4748, _ctx); /*float64*/
  return kk_double_box(_x5954, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5961__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_4843;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5961(kk_function_t _fself, kk_box_t _b_5219, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5961(kk_std_core__sslice x_4843, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5961__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun5961__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun5961, kk_context());
  _self->x_4843 = x_4843;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5961(kk_function_t _fself, kk_box_t _b_5219, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5961__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun5961__t*, _fself, _ctx);
  kk_std_core__sslice x_4843 = _self->x_4843; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_4843, _ctx);}, {}, _ctx)
  bool _y_5244_4749 = kk_bool_unbox(_b_5219); /*bool*/;
  double _x5962 = kk_std_num_float64__mlift4796_pdecdouble(x_4843, _y_5244_4749, _ctx); /*float64*/
  return kk_double_box(_x5962, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5966__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5966(kk_function_t _fself, kk_box_t _b_5221, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5966(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5966, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5966(kk_function_t _fself, kk_box_t _b_5221, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x5967;
  kk_char_t _x5968 = kk_char_unbox(_b_5221, KK_OWNED, _ctx); /*char*/
  _x5967 = kk_std_num_float64__mlift4794_pdecdouble(_x5968, _ctx); /*int*/
  return kk_integer_box(_x5967, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5970__t {
  struct kk_function_s _base;
  kk_std_core__sslice x_4843;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5970(kk_function_t _fself, kk_box_t _b_5227, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5970(kk_std_core__sslice x_4843, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5970__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdecdouble_fun5970__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdecdouble_fun5970, kk_context());
  _self->x_4843 = x_4843;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5971__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5971(kk_function_t _fself, kk_box_t _b_5225, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5971(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5971, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5971(kk_function_t _fself, kk_box_t _b_5225, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5972;
  kk_string_t _x5973 = kk_string_unbox(_b_5225); /*string*/
  _x5972 = kk_std_num_float64_prim_parse_float64(_x5973, _ctx); /*float64*/
  return kk_double_box(_x5972, _ctx);
}
static kk_box_t kk_std_num_float64_pdecdouble_fun5970(kk_function_t _fself, kk_box_t _b_5227, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdecdouble_fun5970__t* _self = kk_function_as(struct kk_std_num_float64_pdecdouble_fun5970__t*, _fself, _ctx);
  kk_std_core__sslice x_4843 = _self->x_4843; /* sslice */
  kk_drop_match(_self, {kk_std_core__sslice_dup(x_4843, _ctx);}, {}, _ctx)
  kk_integer_t _c_5245_4752 = kk_integer_unbox(_b_5227, _ctx); /*int*/;
  kk_integer_drop(_c_5245_4752, _ctx);
  kk_string_t _x1_4787 = kk_std_core_string_3(x_4843, _ctx); /*string*/;
  return kk_std_core_hnd__open_none1(kk_std_num_float64_new_pdecdouble_fun5971(_ctx), kk_string_box(_x1_4787), _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdecdouble_fun5975__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdecdouble_fun5975(kk_function_t _fself, kk_box_t _b_5230, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdecdouble_fun5975(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdecdouble_fun5975, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdecdouble_fun5975(kk_function_t _fself, kk_box_t _b_5230, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x5976;
  kk_string_t _x5977 = kk_string_unbox(_b_5230); /*string*/
  _x5976 = kk_std_num_float64_prim_parse_float64(_x5977, _ctx); /*float64*/
  return kk_double_box(_x5976, _ctx);
}

double kk_std_num_float64_pdecdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  kk_std_core_hnd__ev ev_4846;
  kk_ssize_t _x5931 = (KK_IZ(0)); /*ssize_t*/
  ev_4846 = kk_evv_at(_x5931,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  kk_std_core__sslice x_4843;
  kk_box_t _x5932;
  {
    struct kk_std_core_hnd_Ev* _con5933 = kk_std_core_hnd__as_Ev(ev_4846, _ctx);
    kk_box_t _box_x5189 = _con5933->hnd;
    kk_std_core_hnd__marker m0 = _con5933->marker;
    kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x5189, KK_BORROWED, _ctx);
    kk_std_text_parse__hnd_parse_dup(h, _ctx);
    kk_std_core_hnd__clause0 _match_5593;
    kk_std_core_hnd__clause0 _brw_5594 = kk_std_text_parse__select_current_input(h, _ctx); /*std/core/hnd/clause0<sslice,std/text/parse/.hnd-parse,373,374>*/;
    kk_std_text_parse__hnd_parse_drop(h, _ctx);
    _match_5593 = _brw_5594; /*std/core/hnd/clause0<sslice,std/text/parse/.hnd-parse,373,374>*/
    {
      kk_function_t _fun_unbox_x5192 = _match_5593.clause;
      _x5932 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x5192, (_fun_unbox_x5192, m0, ev_4846, _ctx), _ctx); /*37*/
    }
  }
  x_4843 = kk_std_core__sslice_unbox(_x5932, KK_OWNED, _ctx); /*sslice*/
  if (kk_yielding(kk_context())) {
    kk_std_core__sslice_drop(x_4843, _ctx);
    kk_box_t _x5934 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5935(_ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5934, KK_OWNED, _ctx);
  }
  {
    kk_string_t x0_4848 = kk_std_text_parse_digits(_ctx); /*string*/;
    kk_string_drop(x0_4848, _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x5938 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5939(x_4843, _ctx), _ctx); /*3926*/
      return kk_double_unbox(_x5938, KK_OWNED, _ctx);
    }
    {
      kk_std_core_hnd__ev ev0_4854;
      kk_ssize_t _x5941 = (KK_IZ(0)); /*ssize_t*/
      ev0_4854 = kk_evv_at(_x5941,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
      bool x1_4851;
      kk_box_t _x5942;
      {
        struct kk_std_core_hnd_Ev* _con5943 = kk_std_core_hnd__as_Ev(ev0_4854, _ctx);
        kk_box_t _box_x5199 = _con5943->hnd;
        kk_std_core_hnd__marker m00 = _con5943->marker;
        kk_std_text_parse__hnd_parse h0 = kk_std_text_parse__hnd_parse_unbox(_box_x5199, KK_BORROWED, _ctx);
        kk_std_text_parse__hnd_parse_dup(h0, _ctx);
        kk_std_core_hnd__clause0 _match_5591;
        kk_std_core_hnd__clause0 _brw_5592 = kk_std_text_parse__select_pick(h0, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/;
        kk_std_text_parse__hnd_parse_drop(h0, _ctx);
        _match_5591 = _brw_5592; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/
        {
          kk_function_t _fun_unbox_x5202 = _match_5591.clause;
          _x5942 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x5202, (_fun_unbox_x5202, m00, ev0_4854, _ctx), _ctx); /*37*/
        }
      }
      x1_4851 = kk_bool_unbox(_x5942); /*bool*/
      if (kk_yielding(kk_context())) {
        kk_box_t _x5944 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5945(x_4843, _ctx), _ctx); /*3926*/
        return kk_double_unbox(_x5944, KK_OWNED, _ctx);
      }
      {
        kk_string_t x2_4856;
        if (x1_4851) {
          kk_char_t x3_4859 = kk_std_text_parse_char('.', _ctx); /*char*/;
          if (kk_yielding(kk_context())) {
            kk_box_t _x5947 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5948(_ctx), _ctx); /*3926*/
            x2_4856 = kk_string_unbox(_x5947); /*string*/
          }
          else {
            x2_4856 = kk_std_text_parse_digits0(_ctx); /*string*/
          }
        }
        else {
          x2_4856 = kk_string_empty(); /*string*/
        }
        if (kk_yielding(kk_context())) {
          kk_string_drop(x2_4856, _ctx);
          kk_box_t _x5952 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5953(x_4843, _ctx), _ctx); /*3926*/
          return kk_double_unbox(_x5952, KK_OWNED, _ctx);
        }
        {
          kk_string_t frac;
          kk_string_t _x5955;
          kk_define_string_literal(, _s5956, 1, "0", _ctx)
          _x5955 = kk_string_dup(_s5956, _ctx); /*string*/
          frac = kk_std_core_trim_right_1(x2_4856, _x5955, _ctx); /*string*/
          kk_string_drop(frac, _ctx);
          kk_std_core_hnd__ev ev1_4864;
          kk_ssize_t _x5957 = (KK_IZ(0)); /*ssize_t*/
          ev1_4864 = kk_evv_at(_x5957,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
          bool x4_4861;
          kk_box_t _x5958;
          {
            struct kk_std_core_hnd_Ev* _con5959 = kk_std_core_hnd__as_Ev(ev1_4864, _ctx);
            kk_box_t _box_x5212 = _con5959->hnd;
            kk_std_core_hnd__marker m01 = _con5959->marker;
            kk_std_text_parse__hnd_parse h1 = kk_std_text_parse__hnd_parse_unbox(_box_x5212, KK_BORROWED, _ctx);
            kk_std_text_parse__hnd_parse_dup(h1, _ctx);
            kk_std_core_hnd__clause0 _match_5588;
            kk_std_core_hnd__clause0 _brw_5589 = kk_std_text_parse__select_pick(h1, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/;
            kk_std_text_parse__hnd_parse_drop(h1, _ctx);
            _match_5588 = _brw_5589; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/
            {
              kk_function_t _fun_unbox_x5215 = _match_5588.clause;
              _x5958 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x5215, (_fun_unbox_x5215, m01, ev1_4864, _ctx), _ctx); /*37*/
            }
          }
          x4_4861 = kk_bool_unbox(_x5958); /*bool*/
          if (kk_yielding(kk_context())) {
            kk_box_t _x5960 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5961(x_4843, _ctx), _ctx); /*3926*/
            return kk_double_unbox(_x5960, KK_OWNED, _ctx);
          }
          {
            kk_integer_t x5_4866;
            if (x4_4861) {
              kk_char_t x6_4869;
              kk_string_t _x5963;
              kk_define_string_literal(, _s5964, 2, "eE", _ctx)
              _x5963 = kk_string_dup(_s5964, _ctx); /*string*/
              x6_4869 = kk_std_text_parse_one_of(_x5963, _ctx); /*char*/
              if (kk_yielding(kk_context())) {
                kk_box_t _x5965 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5966(_ctx), _ctx); /*3926*/
                x5_4866 = kk_integer_unbox(_x5965, _ctx); /*int*/
              }
              else {
                x5_4866 = kk_std_text_parse_pint(_ctx); /*int*/
              }
            }
            else {
              x5_4866 = kk_integer_from_small(0); /*int*/
            }
            kk_integer_drop(x5_4866, _ctx);
            if (kk_yielding(kk_context())) {
              kk_box_t _x5969 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdecdouble_fun5970(x_4843, _ctx), _ctx); /*3926*/
              return kk_double_unbox(_x5969, KK_OWNED, _ctx);
            }
            {
              kk_string_t _x1_47870 = kk_std_core_string_3(x_4843, _ctx); /*string*/;
              kk_box_t _x5974 = kk_std_core_hnd__open_none1(kk_std_num_float64_new_pdecdouble_fun5975(_ctx), kk_string_box(_x1_47870), _ctx); /*3357*/
              return kk_double_unbox(_x5974, KK_OWNED, _ctx);
            }
          }
        }
      }
    }
  }
}
 
// monadic lift

double kk_std_num_float64__mlift4803_phexdouble(kk_string_t frac, kk_string_t man, kk_integer_t _c_4763, kk_context_t* _ctx) { /* (frac : string, man : string, int) -> float64 */ 
  kk_string_t _x10_4790;
  kk_string_t _x5978 = kk_string_dup(frac, _ctx); /*string*/
  _x10_4790 = kk_std_core__lp__plus__plus__1_rp_(man, _x5978, _ctx); /*string*/
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<std/text/parse/parse>*/;
  kk_std_core_types__maybe x;
  kk_string_t _x5979;
  kk_string_t _x5980 = kk_string_trim_left(_x10_4790,kk_context()); /*string*/
  _x5979 = kk_string_trim_right(_x5980,kk_context()); /*string*/
  x = kk_std_core_xparse_int(_x5979, true, _ctx); /*maybe<int>*/
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<std/text/parse/parse>*/;
  kk_unit_t keep0 = kk_Unit;
  kk_evv_set(w0,kk_context());
  kk_integer_t y_4785;
  kk_integer_t _x5981 = kk_std_core_count_1(frac, _ctx); /*int*/
  y_4785 = kk_integer_mul((kk_integer_from_small(4)),_x5981,kk_context()); /*int*/
  kk_integer_t e = kk_integer_sub(_c_4763,y_4785,kk_context()); /*int*/;
  kk_evv_t w1 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<std/text/parse/parse>*/;
  double x4;
  double _x5982;
  kk_integer_t _x5983;
  if (kk_std_core_types__is_Nothing(x, _ctx)) {
    _x5983 = kk_integer_from_small(0); /*int*/
  }
  else {
    kk_box_t _box_x5246 = x._cons.Just.value;
    kk_integer_t x3 = kk_integer_unbox(_box_x5246, _ctx);
    kk_integer_dup(x3, _ctx);
    kk_std_core_types__maybe_drop(x, _ctx);
    _x5983 = x3; /*int*/
  }
  _x5982 = kk_integer_as_double(_x5983,kk_context()); /*float64*/
  x4 = kk_std_num_float64_ldexp(_x5982, e, _ctx); /*float64*/
  kk_unit_t keep1 = kk_Unit;
  kk_evv_set(w1,kk_context());
  return x4;
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4804_phexdouble_fun5987__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4804_phexdouble_fun5987(kk_function_t _fself, kk_box_t _b_5248, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4804_phexdouble_fun5987(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4804_phexdouble_fun5987, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4804_phexdouble_fun5987(kk_function_t _fself, kk_box_t _b_5248, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x5988;
  kk_char_t _x5989 = kk_char_unbox(_b_5248, KK_OWNED, _ctx); /*char*/
  _x5988 = kk_std_num_float64__mlift4802_phexdouble(_x5989, _ctx); /*int*/
  return kk_integer_box(_x5988, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4804_phexdouble_fun5991__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t man;
};
static kk_box_t kk_std_num_float64__mlift4804_phexdouble_fun5991(kk_function_t _fself, kk_box_t _b_5251, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4804_phexdouble_fun5991(kk_string_t frac, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4804_phexdouble_fun5991__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4804_phexdouble_fun5991__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4804_phexdouble_fun5991, kk_context());
  _self->frac = frac;
  _self->man = man;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4804_phexdouble_fun5991(kk_function_t _fself, kk_box_t _b_5251, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4804_phexdouble_fun5991__t* _self = kk_function_as(struct kk_std_num_float64__mlift4804_phexdouble_fun5991__t*, _fself, _ctx);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(frac, _ctx);kk_string_dup(man, _ctx);}, {}, _ctx)
  kk_integer_t _c_5253_4763 = kk_integer_unbox(_b_5251, _ctx); /*int*/;
  double _x5992 = kk_std_num_float64__mlift4803_phexdouble(frac, man, _c_5253_4763, _ctx); /*float64*/
  return kk_double_box(_x5992, _ctx);
}

double kk_std_num_float64__mlift4804_phexdouble(kk_string_t frac, kk_string_t man, bool _y_4760, kk_context_t* _ctx) { /* (frac : string, man : string, bool) -> std/text/parse/parse float64 */ 
  kk_integer_t x_4882;
  if (_y_4760) {
    kk_char_t x0_4884;
    kk_string_t _x5984;
    kk_define_string_literal(, _s5985, 2, "pP", _ctx)
    _x5984 = kk_string_dup(_s5985, _ctx); /*string*/
    x0_4884 = kk_std_text_parse_one_of(_x5984, _ctx); /*char*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x5986 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4804_phexdouble_fun5987(_ctx), _ctx); /*3926*/
      x_4882 = kk_integer_unbox(_x5986, _ctx); /*int*/
    }
    else {
      x_4882 = kk_std_text_parse_pint(_ctx); /*int*/
    }
  }
  else {
    x_4882 = kk_integer_from_small(0); /*int*/
  }
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_4882, _ctx);
    kk_box_t _x5990 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4804_phexdouble_fun5991(frac, man, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5990, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4803_phexdouble(frac, man, x_4882, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4806_phexdouble_fun5999__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t man;
};
static kk_box_t kk_std_num_float64__mlift4806_phexdouble_fun5999(kk_function_t _fself, kk_box_t _b_5261, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4806_phexdouble_fun5999(kk_string_t frac, kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4806_phexdouble_fun5999__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4806_phexdouble_fun5999__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4806_phexdouble_fun5999, kk_context());
  _self->frac = frac;
  _self->man = man;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4806_phexdouble_fun5999(kk_function_t _fself, kk_box_t _b_5261, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4806_phexdouble_fun5999__t* _self = kk_function_as(struct kk_std_num_float64__mlift4806_phexdouble_fun5999__t*, _fself, _ctx);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(frac, _ctx);kk_string_dup(man, _ctx);}, {}, _ctx)
  bool _y_5263_4760 = kk_bool_unbox(_b_5261); /*bool*/;
  double _x6000 = kk_std_num_float64__mlift4804_phexdouble(frac, man, _y_5263_4760, _ctx); /*float64*/
  return kk_double_box(_x6000, _ctx);
}

double kk_std_num_float64__mlift4806_phexdouble(kk_string_t man, kk_string_t _c_4759, kk_context_t* _ctx) { /* (man : string, string) -> float64 */ 
  kk_string_t frac;
  kk_string_t _x5993;
  kk_define_string_literal(, _s5994, 1, "0", _ctx)
  _x5993 = kk_string_dup(_s5994, _ctx); /*string*/
  frac = kk_std_core_trim_right_1(_c_4759, _x5993, _ctx); /*string*/
  kk_std_core_hnd__ev ev_4888;
  kk_ssize_t _x5995 = (KK_IZ(0)); /*ssize_t*/
  ev_4888 = kk_evv_at(_x5995,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x_4886;
  kk_box_t _x5996;
  {
    struct kk_std_core_hnd_Ev* _con5997 = kk_std_core_hnd__as_Ev(ev_4888, _ctx);
    kk_box_t _box_x5254 = _con5997->hnd;
    kk_std_core_hnd__marker m0 = _con5997->marker;
    kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x5254, KK_BORROWED, _ctx);
    kk_std_text_parse__hnd_parse_dup(h, _ctx);
    kk_std_core_hnd__clause0 _match_5577;
    kk_std_core_hnd__clause0 _brw_5578 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/;
    kk_std_text_parse__hnd_parse_drop(h, _ctx);
    _match_5577 = _brw_5578; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/
    {
      kk_function_t _fun_unbox_x5257 = _match_5577.clause;
      _x5996 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x5257, (_fun_unbox_x5257, m0, ev_4888, _ctx), _ctx); /*37*/
    }
  }
  x_4886 = kk_bool_unbox(_x5996); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x5998 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4806_phexdouble_fun5999(frac, man, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x5998, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4804_phexdouble(frac, man, x_4886, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4807_phexdouble_fun6002__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4807_phexdouble_fun6002(kk_function_t _fself, kk_box_t _b_5265, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4807_phexdouble_fun6002(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4807_phexdouble_fun6002, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4807_phexdouble_fun6002(kk_function_t _fself, kk_box_t _b_5265, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x6003;
  kk_char_t _x6004 = kk_char_unbox(_b_5265, KK_OWNED, _ctx); /*char*/
  _x6003 = kk_std_num_float64__mlift4805_phexdouble(_x6004, _ctx); /*string*/
  return kk_string_box(_x6003);
}


// lift anonymous function
struct kk_std_num_float64__mlift4807_phexdouble_fun6007__t {
  struct kk_function_s _base;
  kk_string_t man;
};
static kk_box_t kk_std_num_float64__mlift4807_phexdouble_fun6007(kk_function_t _fself, kk_box_t _b_5268, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4807_phexdouble_fun6007(kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4807_phexdouble_fun6007__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4807_phexdouble_fun6007__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4807_phexdouble_fun6007, kk_context());
  _self->man = man;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4807_phexdouble_fun6007(kk_function_t _fself, kk_box_t _b_5268, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4807_phexdouble_fun6007__t* _self = kk_function_as(struct kk_std_num_float64__mlift4807_phexdouble_fun6007__t*, _fself, _ctx);
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(man, _ctx);}, {}, _ctx)
  kk_string_t _c_5270_4759 = kk_string_unbox(_b_5268); /*string*/;
  double _x6008 = kk_std_num_float64__mlift4806_phexdouble(man, _c_5270_4759, _ctx); /*float64*/
  return kk_double_box(_x6008, _ctx);
}

double kk_std_num_float64__mlift4807_phexdouble(kk_string_t man, bool _y_4756, kk_context_t* _ctx) { /* (man : string, bool) -> std/text/parse/parse float64 */ 
  kk_string_t x_4890;
  if (_y_4756) {
    kk_char_t x0_4892 = kk_std_text_parse_char('.', _ctx); /*char*/;
    if (kk_yielding(kk_context())) {
      kk_box_t _x6001 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4807_phexdouble_fun6002(_ctx), _ctx); /*3926*/
      x_4890 = kk_string_unbox(_x6001); /*string*/
    }
    else {
      x_4890 = kk_std_text_parse_hex_digits(_ctx); /*string*/
    }
  }
  else {
    x_4890 = kk_string_empty(); /*string*/
  }
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4890, _ctx);
    kk_box_t _x6006 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4807_phexdouble_fun6007(man, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x6006, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4806_phexdouble(man, x_4890, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4808_phexdouble_fun6013__t {
  struct kk_function_s _base;
  kk_string_t man;
};
static kk_box_t kk_std_num_float64__mlift4808_phexdouble_fun6013(kk_function_t _fself, kk_box_t _b_5278, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4808_phexdouble_fun6013(kk_string_t man, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4808_phexdouble_fun6013__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4808_phexdouble_fun6013__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4808_phexdouble_fun6013, kk_context());
  _self->man = man;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4808_phexdouble_fun6013(kk_function_t _fself, kk_box_t _b_5278, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4808_phexdouble_fun6013__t* _self = kk_function_as(struct kk_std_num_float64__mlift4808_phexdouble_fun6013__t*, _fself, _ctx);
  kk_string_t man = _self->man; /* string */
  kk_drop_match(_self, {kk_string_dup(man, _ctx);}, {}, _ctx)
  bool _y_5280_4756 = kk_bool_unbox(_b_5278); /*bool*/;
  double _x6014 = kk_std_num_float64__mlift4807_phexdouble(man, _y_5280_4756, _ctx); /*float64*/
  return kk_double_box(_x6014, _ctx);
}

double kk_std_num_float64__mlift4808_phexdouble(kk_string_t man, kk_context_t* _ctx) { /* (man : string) -> std/text/parse/parse float64 */ 
  kk_std_core_hnd__ev ev_4896;
  kk_ssize_t _x6009 = (KK_IZ(0)); /*ssize_t*/
  ev_4896 = kk_evv_at(_x6009,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
  bool x_4894;
  kk_box_t _x6010;
  {
    struct kk_std_core_hnd_Ev* _con6011 = kk_std_core_hnd__as_Ev(ev_4896, _ctx);
    kk_box_t _box_x5271 = _con6011->hnd;
    kk_std_core_hnd__marker m0 = _con6011->marker;
    kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x5271, KK_BORROWED, _ctx);
    kk_std_text_parse__hnd_parse_dup(h, _ctx);
    kk_std_core_hnd__clause0 _match_5572;
    kk_std_core_hnd__clause0 _brw_5573 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/;
    kk_std_text_parse__hnd_parse_drop(h, _ctx);
    _match_5572 = _brw_5573; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/
    {
      kk_function_t _fun_unbox_x5274 = _match_5572.clause;
      _x6010 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x5274, (_fun_unbox_x5274, m0, ev_4896, _ctx), _ctx); /*37*/
    }
  }
  x_4894 = kk_bool_unbox(_x6010); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x6012 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4808_phexdouble_fun6013(man, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x6012, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4807_phexdouble(man, x_4894, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4809_phexdouble_fun6016__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4809_phexdouble_fun6016(kk_function_t _fself, kk_box_t _b_5282, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4809_phexdouble_fun6016(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4809_phexdouble_fun6016, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4809_phexdouble_fun6016(kk_function_t _fself, kk_box_t _b_5282, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6017;
  kk_string_t _x6018 = kk_string_unbox(_b_5282); /*string*/
  _x6017 = kk_std_num_float64__mlift4808_phexdouble(_x6018, _ctx); /*float64*/
  return kk_double_box(_x6017, _ctx);
}

double kk_std_num_float64__mlift4809_phexdouble(kk_char_t wild__0, kk_context_t* _ctx) { /* (wild_0 : char) -> std/text/parse/parse float64 */ 
  kk_string_t x_4898 = kk_std_text_parse_hex_digits(_ctx); /*string*/;
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_4898, _ctx);
    kk_box_t _x6015 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4809_phexdouble_fun6016(_ctx), _ctx); /*3926*/
    return kk_double_unbox(_x6015, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4808_phexdouble(x_4898, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4810_phexdouble_fun6022__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4810_phexdouble_fun6022(kk_function_t _fself, kk_box_t _b_5285, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4810_phexdouble_fun6022(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4810_phexdouble_fun6022, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4810_phexdouble_fun6022(kk_function_t _fself, kk_box_t _b_5285, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6023;
  kk_char_t _x6024 = kk_char_unbox(_b_5285, KK_OWNED, _ctx); /*char*/
  _x6023 = kk_std_num_float64__mlift4809_phexdouble(_x6024, _ctx); /*float64*/
  return kk_double_box(_x6023, _ctx);
}

double kk_std_num_float64__mlift4810_phexdouble(kk_char_t wild__, kk_context_t* _ctx) { /* (wild_ : char) -> std/text/parse/parse float64 */ 
  kk_char_t x_4900;
  kk_string_t _x6019;
  kk_define_string_literal(, _s6020, 2, "xX", _ctx)
  _x6019 = kk_string_dup(_s6020, _ctx); /*string*/
  x_4900 = kk_std_text_parse_one_of(_x6019, _ctx); /*char*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x6021 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4810_phexdouble_fun6022(_ctx), _ctx); /*3926*/
    return kk_double_unbox(_x6021, KK_OWNED, _ctx);
  }
  {
    return kk_std_num_float64__mlift4809_phexdouble(x_4900, _ctx);
  }
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun6026__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun6026(kk_function_t _fself, kk_box_t _b_5288, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun6026(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun6026, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun6026(kk_function_t _fself, kk_box_t _b_5288, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6027;
  kk_char_t _x6028 = kk_char_unbox(_b_5288, KK_OWNED, _ctx); /*char*/
  _x6027 = kk_std_num_float64__mlift4810_phexdouble(_x6028, _ctx); /*float64*/
  return kk_double_box(_x6027, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun6032__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun6032(kk_function_t _fself, kk_box_t _b_5290, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun6032(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun6032, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun6032(kk_function_t _fself, kk_box_t _b_5290, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6033;
  kk_char_t _x6034 = kk_char_unbox(_b_5290, KK_OWNED, _ctx); /*char*/
  _x6033 = kk_std_num_float64__mlift4809_phexdouble(_x6034, _ctx); /*float64*/
  return kk_double_box(_x6033, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun6036__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun6036(kk_function_t _fself, kk_box_t _b_5292, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun6036(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun6036, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun6036(kk_function_t _fself, kk_box_t _b_5292, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6037;
  kk_string_t _x6038 = kk_string_unbox(_b_5292); /*string*/
  _x6037 = kk_std_num_float64__mlift4808_phexdouble(_x6038, _ctx); /*float64*/
  return kk_double_box(_x6037, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun6043__t {
  struct kk_function_s _base;
  kk_string_t x1_4908;
};
static kk_box_t kk_std_num_float64_phexdouble_fun6043(kk_function_t _fself, kk_box_t _b_5300, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun6043(kk_string_t x1_4908, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun6043__t* _self = kk_function_alloc_as(struct kk_std_num_float64_phexdouble_fun6043__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_phexdouble_fun6043, kk_context());
  _self->x1_4908 = x1_4908;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun6043(kk_function_t _fself, kk_box_t _b_5300, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun6043__t* _self = kk_function_as(struct kk_std_num_float64_phexdouble_fun6043__t*, _fself, _ctx);
  kk_string_t x1_4908 = _self->x1_4908; /* string */
  kk_drop_match(_self, {kk_string_dup(x1_4908, _ctx);}, {}, _ctx)
  bool _y_5327_4756 = kk_bool_unbox(_b_5300); /*bool*/;
  double _x6044 = kk_std_num_float64__mlift4807_phexdouble(x1_4908, _y_5327_4756, _ctx); /*float64*/
  return kk_double_box(_x6044, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun6046__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun6046(kk_function_t _fself, kk_box_t _b_5302, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun6046(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun6046, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun6046(kk_function_t _fself, kk_box_t _b_5302, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x6047;
  kk_char_t _x6048 = kk_char_unbox(_b_5302, KK_OWNED, _ctx); /*char*/
  _x6047 = kk_std_num_float64__mlift4805_phexdouble(_x6048, _ctx); /*string*/
  return kk_string_box(_x6047);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun6051__t {
  struct kk_function_s _base;
  kk_string_t x1_4908;
};
static kk_box_t kk_std_num_float64_phexdouble_fun6051(kk_function_t _fself, kk_box_t _b_5305, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun6051(kk_string_t x1_4908, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun6051__t* _self = kk_function_alloc_as(struct kk_std_num_float64_phexdouble_fun6051__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_phexdouble_fun6051, kk_context());
  _self->x1_4908 = x1_4908;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun6051(kk_function_t _fself, kk_box_t _b_5305, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun6051__t* _self = kk_function_as(struct kk_std_num_float64_phexdouble_fun6051__t*, _fself, _ctx);
  kk_string_t x1_4908 = _self->x1_4908; /* string */
  kk_drop_match(_self, {kk_string_dup(x1_4908, _ctx);}, {}, _ctx)
  kk_string_t _c_5328_4759 = kk_string_unbox(_b_5305); /*string*/;
  double _x6052 = kk_std_num_float64__mlift4806_phexdouble(x1_4908, _c_5328_4759, _ctx); /*float64*/
  return kk_double_box(_x6052, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun6059__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t x1_4908;
};
static kk_box_t kk_std_num_float64_phexdouble_fun6059(kk_function_t _fself, kk_box_t _b_5313, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun6059(kk_string_t frac, kk_string_t x1_4908, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun6059__t* _self = kk_function_alloc_as(struct kk_std_num_float64_phexdouble_fun6059__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_phexdouble_fun6059, kk_context());
  _self->frac = frac;
  _self->x1_4908 = x1_4908;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun6059(kk_function_t _fself, kk_box_t _b_5313, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun6059__t* _self = kk_function_as(struct kk_std_num_float64_phexdouble_fun6059__t*, _fself, _ctx);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t x1_4908 = _self->x1_4908; /* string */
  kk_drop_match(_self, {kk_string_dup(frac, _ctx);kk_string_dup(x1_4908, _ctx);}, {}, _ctx)
  bool _y_5329_4760 = kk_bool_unbox(_b_5313); /*bool*/;
  double _x6060 = kk_std_num_float64__mlift4804_phexdouble(frac, x1_4908, _y_5329_4760, _ctx); /*float64*/
  return kk_double_box(_x6060, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun6064__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_phexdouble_fun6064(kk_function_t _fself, kk_box_t _b_5315, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun6064(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_phexdouble_fun6064, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun6064(kk_function_t _fself, kk_box_t _b_5315, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _x6065;
  kk_char_t _x6066 = kk_char_unbox(_b_5315, KK_OWNED, _ctx); /*char*/
  _x6065 = kk_std_num_float64__mlift4802_phexdouble(_x6066, _ctx); /*int*/
  return kk_integer_box(_x6065, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_phexdouble_fun6068__t {
  struct kk_function_s _base;
  kk_string_t frac;
  kk_string_t x1_4908;
};
static kk_box_t kk_std_num_float64_phexdouble_fun6068(kk_function_t _fself, kk_box_t _b_5318, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_phexdouble_fun6068(kk_string_t frac, kk_string_t x1_4908, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun6068__t* _self = kk_function_alloc_as(struct kk_std_num_float64_phexdouble_fun6068__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_phexdouble_fun6068, kk_context());
  _self->frac = frac;
  _self->x1_4908 = x1_4908;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_phexdouble_fun6068(kk_function_t _fself, kk_box_t _b_5318, kk_context_t* _ctx) {
  struct kk_std_num_float64_phexdouble_fun6068__t* _self = kk_function_as(struct kk_std_num_float64_phexdouble_fun6068__t*, _fself, _ctx);
  kk_string_t frac = _self->frac; /* string */
  kk_string_t x1_4908 = _self->x1_4908; /* string */
  kk_drop_match(_self, {kk_string_dup(frac, _ctx);kk_string_dup(x1_4908, _ctx);}, {}, _ctx)
  kk_integer_t _c_5330_4763 = kk_integer_unbox(_b_5318, _ctx); /*int*/;
  double _x6069 = kk_std_num_float64__mlift4803_phexdouble(frac, x1_4908, _c_5330_4763, _ctx); /*float64*/
  return kk_double_box(_x6069, _ctx);
}

double kk_std_num_float64_phexdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  kk_char_t x_4902 = kk_std_text_parse_char('0', _ctx); /*char*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6025 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun6026(_ctx), _ctx); /*3926*/
    return kk_double_unbox(_x6025, KK_OWNED, _ctx);
  }
  {
    kk_char_t x0_4905;
    kk_string_t _x6029;
    kk_define_string_literal(, _s6030, 2, "xX", _ctx)
    _x6029 = kk_string_dup(_s6030, _ctx); /*string*/
    x0_4905 = kk_std_text_parse_one_of(_x6029, _ctx); /*char*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x6031 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun6032(_ctx), _ctx); /*3926*/
      return kk_double_unbox(_x6031, KK_OWNED, _ctx);
    }
    {
      kk_string_t x1_4908 = kk_std_text_parse_hex_digits(_ctx); /*string*/;
      if (kk_yielding(kk_context())) {
        kk_string_drop(x1_4908, _ctx);
        kk_box_t _x6035 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun6036(_ctx), _ctx); /*3926*/
        return kk_double_unbox(_x6035, KK_OWNED, _ctx);
      }
      {
        kk_std_core_hnd__ev ev_4914;
        kk_ssize_t _x6039 = (KK_IZ(0)); /*ssize_t*/
        ev_4914 = kk_evv_at(_x6039,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
        bool x2_4911;
        kk_box_t _x6040;
        {
          struct kk_std_core_hnd_Ev* _con6041 = kk_std_core_hnd__as_Ev(ev_4914, _ctx);
          kk_box_t _box_x5293 = _con6041->hnd;
          kk_std_core_hnd__marker m0 = _con6041->marker;
          kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x5293, KK_BORROWED, _ctx);
          kk_std_text_parse__hnd_parse_dup(h, _ctx);
          kk_std_core_hnd__clause0 _match_5567;
          kk_std_core_hnd__clause0 _brw_5568 = kk_std_text_parse__select_pick(h, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/;
          kk_std_text_parse__hnd_parse_drop(h, _ctx);
          _match_5567 = _brw_5568; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/
          {
            kk_function_t _fun_unbox_x5296 = _match_5567.clause;
            _x6040 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x5296, (_fun_unbox_x5296, m0, ev_4914, _ctx), _ctx); /*37*/
          }
        }
        x2_4911 = kk_bool_unbox(_x6040); /*bool*/
        if (kk_yielding(kk_context())) {
          kk_box_t _x6042 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun6043(x1_4908, _ctx), _ctx); /*3926*/
          return kk_double_unbox(_x6042, KK_OWNED, _ctx);
        }
        {
          kk_string_t x3_4916;
          if (x2_4911) {
            kk_char_t x4_4919 = kk_std_text_parse_char('.', _ctx); /*char*/;
            if (kk_yielding(kk_context())) {
              kk_box_t _x6045 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun6046(_ctx), _ctx); /*3926*/
              x3_4916 = kk_string_unbox(_x6045); /*string*/
            }
            else {
              x3_4916 = kk_std_text_parse_hex_digits(_ctx); /*string*/
            }
          }
          else {
            x3_4916 = kk_string_empty(); /*string*/
          }
          if (kk_yielding(kk_context())) {
            kk_string_drop(x3_4916, _ctx);
            kk_box_t _x6050 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun6051(x1_4908, _ctx), _ctx); /*3926*/
            return kk_double_unbox(_x6050, KK_OWNED, _ctx);
          }
          {
            kk_string_t frac;
            kk_string_t _x6053;
            kk_define_string_literal(, _s6054, 1, "0", _ctx)
            _x6053 = kk_string_dup(_s6054, _ctx); /*string*/
            frac = kk_std_core_trim_right_1(x3_4916, _x6053, _ctx); /*string*/
            kk_std_core_hnd__ev ev0_4924;
            kk_ssize_t _x6055 = (KK_IZ(0)); /*ssize_t*/
            ev0_4924 = kk_evv_at(_x6055,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
            bool x5_4921;
            kk_box_t _x6056;
            {
              struct kk_std_core_hnd_Ev* _con6057 = kk_std_core_hnd__as_Ev(ev0_4924, _ctx);
              kk_box_t _box_x5306 = _con6057->hnd;
              kk_std_core_hnd__marker m00 = _con6057->marker;
              kk_std_text_parse__hnd_parse h0 = kk_std_text_parse__hnd_parse_unbox(_box_x5306, KK_BORROWED, _ctx);
              kk_std_text_parse__hnd_parse_dup(h0, _ctx);
              kk_std_core_hnd__clause0 _match_5564;
              kk_std_core_hnd__clause0 _brw_5565 = kk_std_text_parse__select_pick(h0, _ctx); /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/;
              kk_std_text_parse__hnd_parse_drop(h0, _ctx);
              _match_5564 = _brw_5565; /*std/core/hnd/clause0<bool,std/text/parse/.hnd-parse,412,413>*/
              {
                kk_function_t _fun_unbox_x5309 = _match_5564.clause;
                _x6056 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_context_t*), _fun_unbox_x5309, (_fun_unbox_x5309, m00, ev0_4924, _ctx), _ctx); /*37*/
              }
            }
            x5_4921 = kk_bool_unbox(_x6056); /*bool*/
            if (kk_yielding(kk_context())) {
              kk_box_t _x6058 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun6059(frac, x1_4908, _ctx), _ctx); /*3926*/
              return kk_double_unbox(_x6058, KK_OWNED, _ctx);
            }
            {
              kk_integer_t x6_4926;
              if (x5_4921) {
                kk_char_t x7_4929;
                kk_string_t _x6061;
                kk_define_string_literal(, _s6062, 2, "pP", _ctx)
                _x6061 = kk_string_dup(_s6062, _ctx); /*string*/
                x7_4929 = kk_std_text_parse_one_of(_x6061, _ctx); /*char*/
                if (kk_yielding(kk_context())) {
                  kk_box_t _x6063 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun6064(_ctx), _ctx); /*3926*/
                  x6_4926 = kk_integer_unbox(_x6063, _ctx); /*int*/
                }
                else {
                  x6_4926 = kk_std_text_parse_pint(_ctx); /*int*/
                }
              }
              else {
                x6_4926 = kk_integer_from_small(0); /*int*/
              }
              if (kk_yielding(kk_context())) {
                kk_integer_drop(x6_4926, _ctx);
                kk_box_t _x6067 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_phexdouble_fun6068(frac, x1_4908, _ctx), _ctx); /*3926*/
                return kk_double_unbox(_x6067, KK_OWNED, _ctx);
              }
              {
                kk_string_t _x10_4790;
                kk_string_t _x6070 = kk_string_dup(frac, _ctx); /*string*/
                _x10_4790 = kk_std_core__lp__plus__plus__1_rp_(x1_4908, _x6070, _ctx); /*string*/
                kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<std/text/parse/parse>*/;
                kk_std_core_types__maybe x8;
                kk_string_t _x6071;
                kk_string_t _x6072 = kk_string_trim_left(_x10_4790,kk_context()); /*string*/
                _x6071 = kk_string_trim_right(_x6072,kk_context()); /*string*/
                x8 = kk_std_core_xparse_int(_x6071, true, _ctx); /*maybe<int>*/
                kk_unit_t keep = kk_Unit;
                kk_evv_set(w,kk_context());
                kk_evv_t w0 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<std/text/parse/parse>*/;
                kk_unit_t keep0 = kk_Unit;
                kk_evv_set(w0,kk_context());
                kk_integer_t y_4785;
                kk_integer_t _x6073 = kk_std_core_count_1(frac, _ctx); /*int*/
                y_4785 = kk_integer_mul((kk_integer_from_small(4)),_x6073,kk_context()); /*int*/
                kk_integer_t e = kk_integer_sub(x6_4926,y_4785,kk_context()); /*int*/;
                kk_evv_t w1 = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<std/text/parse/parse>*/;
                double x14;
                double _x6074;
                kk_integer_t _x6075;
                if (kk_std_core_types__is_Nothing(x8, _ctx)) {
                  _x6075 = kk_integer_from_small(0); /*int*/
                }
                else {
                  kk_box_t _box_x5319 = x8._cons.Just.value;
                  kk_integer_t x12 = kk_integer_unbox(_box_x5319, _ctx);
                  kk_integer_dup(x12, _ctx);
                  kk_std_core_types__maybe_drop(x8, _ctx);
                  _x6075 = x12; /*int*/
                }
                _x6074 = kk_integer_as_double(_x6075,kk_context()); /*float64*/
                x14 = kk_std_num_float64_ldexp(_x6074, e, _ctx); /*float64*/
                kk_unit_t keep1 = kk_Unit;
                kk_evv_set(w1,kk_context());
                return x14;
              }
            }
          }
        }
      }
    }
  }
}


// lift anonymous function
struct kk_std_num_float64_pspecial_fun6076__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun6076(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun6076(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun6076, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pspecial_fun6081__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun6081(kk_function_t _fself, kk_box_t _b_5332, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun6081(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun6081, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pspecial_fun6081(kk_function_t _fself, kk_box_t _b_5332, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6082;
  kk_string_t _x6083 = kk_string_unbox(_b_5332); /*string*/
  _x6082 = kk_std_num_float64__mlift4811_pspecial(_x6083, _ctx); /*float64*/
  return kk_double_box(_x6082, _ctx);
}
static kk_box_t kk_std_num_float64_pspecial_fun6076(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x_4940;
  kk_string_t _x6077;
  kk_define_string_literal(, _s6078, 3, "nan", _ctx)
  _x6077 = kk_string_dup(_s6078, _ctx); /*string*/
  x_4940 = kk_std_text_parse_pstring(_x6077, _ctx); /*string*/
  kk_string_drop(x_4940, _ctx);
  double _x6079;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6080 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pspecial_fun6081(_ctx), _ctx); /*3926*/
    _x6079 = kk_double_unbox(_x6080, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x6079 = kk_std_num_float64_nan; /*float64*/
  }
  return kk_double_box(_x6079, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pspecial_fun6085__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun6085(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun6085(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun6085, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pspecial_fun6090__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun6090(kk_function_t _fself, kk_box_t _b_5334, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun6090(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun6090, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pspecial_fun6090(kk_function_t _fself, kk_box_t _b_5334, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6091;
  kk_string_t _x6092 = kk_string_unbox(_b_5334); /*string*/
  _x6091 = kk_std_num_float64__mlift4812_pspecial(_x6092, _ctx); /*float64*/
  return kk_double_box(_x6091, _ctx);
}
static kk_box_t kk_std_num_float64_pspecial_fun6085(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x0_4942;
  kk_string_t _x6086;
  kk_define_string_literal(, _s6087, 8, "infinity", _ctx)
  _x6086 = kk_string_dup(_s6087, _ctx); /*string*/
  x0_4942 = kk_std_text_parse_pstring(_x6086, _ctx); /*string*/
  kk_string_drop(x0_4942, _ctx);
  double _x6088;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6089 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pspecial_fun6090(_ctx), _ctx); /*3926*/
    _x6088 = kk_double_unbox(_x6089, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x6088 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x6088, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pspecial_fun6094__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun6094(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun6094(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun6094, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pspecial_fun6099__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pspecial_fun6099(kk_function_t _fself, kk_box_t _b_5336, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pspecial_fun6099(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pspecial_fun6099, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pspecial_fun6099(kk_function_t _fself, kk_box_t _b_5336, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6100;
  kk_string_t _x6101 = kk_string_unbox(_b_5336); /*string*/
  _x6100 = kk_std_num_float64__mlift4813_pspecial(_x6101, _ctx); /*float64*/
  return kk_double_box(_x6100, _ctx);
}
static kk_box_t kk_std_num_float64_pspecial_fun6094(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x1_4944;
  kk_string_t _x6095;
  kk_define_string_literal(, _s6096, 3, "inf", _ctx)
  _x6095 = kk_string_dup(_s6096, _ctx); /*string*/
  x1_4944 = kk_std_text_parse_pstring(_x6095, _ctx); /*string*/
  kk_string_drop(x1_4944, _ctx);
  double _x6097;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6098 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pspecial_fun6099(_ctx), _ctx); /*3926*/
    _x6097 = kk_double_unbox(_x6098, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x6097 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x6097, _ctx);
}

double kk_std_num_float64_pspecial(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  kk_std_core__list ps_4544;
  kk_std_core__list _x6084;
  kk_std_core__list _x6093 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pspecial_fun6094(_ctx), _ctx), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x6084 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pspecial_fun6085(_ctx), _ctx), _x6093, _ctx); /*list<61>*/
  ps_4544 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pspecial_fun6076(_ctx), _ctx), _x6084, _ctx); /*list<() -> std/text/parse/parse float64>*/
  if (kk_std_core__is_Nil(ps_4544, _ctx)) {
    kk_std_core_hnd__ev ev_4946;
    kk_ssize_t _x6102 = (KK_IZ(0)); /*ssize_t*/
    ev_4946 = kk_evv_at(_x6102,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
    kk_box_t _x6103;
    {
      struct kk_std_core_hnd_Ev* _con6104 = kk_std_core_hnd__as_Ev(ev_4946, _ctx);
      kk_box_t _box_x5355 = _con6104->hnd;
      kk_std_core_hnd__marker m0 = _con6104->marker;
      kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x5355, KK_BORROWED, _ctx);
      kk_std_text_parse__hnd_parse_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_5551;
      kk_std_core_hnd__clause1 _brw_5552 = kk_std_text_parse__select_fail(h, _ctx); /*std/core/hnd/clause1<string,394,std/text/parse/.hnd-parse,395,396>*/;
      kk_std_text_parse__hnd_parse_drop(h, _ctx);
      _match_5551 = _brw_5552; /*std/core/hnd/clause1<string,394,std/text/parse/.hnd-parse,395,396>*/
      {
        kk_function_t _fun_unbox_x5359 = _match_5551.clause;
        kk_box_t _x6105;
        kk_string_t _x6106;
        kk_define_string_literal(, _s6107, 23, "no further alternatives", _ctx)
        _x6106 = kk_string_dup(_s6107, _ctx); /*string*/
        _x6105 = kk_string_box(_x6106); /*51*/
        _x6103 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x5359, (_fun_unbox_x5359, m0, ev_4946, _x6105, _ctx), _ctx); /*52*/
      }
    }
    return kk_double_unbox(_x6103, KK_OWNED, _ctx);
  }
  {
    kk_box_t _x6108 = kk_std_text_parse__unroll2246_choose(ps_4544, _ctx); /*765*/
    return kk_double_unbox(_x6108, KK_OWNED, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6109__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6109(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6109(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4818_pdouble_fun6109, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6109(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6110 = kk_std_num_float64_phexdouble(_ctx); /*float64*/
  return kk_double_box(_x6110, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6112__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6112(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6112(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4818_pdouble_fun6112, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6112(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6113 = kk_std_num_float64_pdecdouble(_ctx); /*float64*/
  return kk_double_box(_x6113, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6115__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6115(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6115(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4818_pdouble_fun6115, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6116__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6116(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6116(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4818_pdouble_fun6116, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6121__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6121(kk_function_t _fself, kk_box_t _b_5366, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6121(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4818_pdouble_fun6121, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6121(kk_function_t _fself, kk_box_t _b_5366, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6122;
  kk_string_t _x6123 = kk_string_unbox(_b_5366); /*string*/
  _x6122 = kk_std_num_float64__mlift4814_pdouble(_x6123, _ctx); /*float64*/
  return kk_double_box(_x6122, _ctx);
}
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6116(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x_4949;
  kk_string_t _x6117;
  kk_define_string_literal(, _s6118, 3, "nan", _ctx)
  _x6117 = kk_string_dup(_s6118, _ctx); /*string*/
  x_4949 = kk_std_text_parse_pstring(_x6117, _ctx); /*string*/
  kk_string_drop(x_4949, _ctx);
  double _x6119;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6120 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4818_pdouble_fun6121(_ctx), _ctx); /*3926*/
    _x6119 = kk_double_unbox(_x6120, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x6119 = kk_std_num_float64_nan; /*float64*/
  }
  return kk_double_box(_x6119, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6125__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6125(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6125(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4818_pdouble_fun6125, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6130__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6130(kk_function_t _fself, kk_box_t _b_5368, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6130(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4818_pdouble_fun6130, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6130(kk_function_t _fself, kk_box_t _b_5368, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6131;
  kk_string_t _x6132 = kk_string_unbox(_b_5368); /*string*/
  _x6131 = kk_std_num_float64__mlift4815_pdouble(_x6132, _ctx); /*float64*/
  return kk_double_box(_x6131, _ctx);
}
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6125(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x0_4951;
  kk_string_t _x6126;
  kk_define_string_literal(, _s6127, 8, "infinity", _ctx)
  _x6126 = kk_string_dup(_s6127, _ctx); /*string*/
  x0_4951 = kk_std_text_parse_pstring(_x6126, _ctx); /*string*/
  kk_string_drop(x0_4951, _ctx);
  double _x6128;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6129 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4818_pdouble_fun6130(_ctx), _ctx); /*3926*/
    _x6128 = kk_double_unbox(_x6129, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x6128 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x6128, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6134__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6134(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6134(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4818_pdouble_fun6134, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6139__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6139(kk_function_t _fself, kk_box_t _b_5370, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6139(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4818_pdouble_fun6139, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6139(kk_function_t _fself, kk_box_t _b_5370, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6140;
  kk_string_t _x6141 = kk_string_unbox(_b_5370); /*string*/
  _x6140 = kk_std_num_float64__mlift4816_pdouble(_x6141, _ctx); /*float64*/
  return kk_double_box(_x6140, _ctx);
}
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6134(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x1_4953;
  kk_string_t _x6135;
  kk_define_string_literal(, _s6136, 3, "inf", _ctx)
  _x6135 = kk_string_dup(_s6136, _ctx); /*string*/
  x1_4953 = kk_std_text_parse_pstring(_x6135, _ctx); /*string*/
  kk_string_drop(x1_4953, _ctx);
  double _x6137;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6138 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4818_pdouble_fun6139(_ctx), _ctx); /*3926*/
    _x6137 = kk_double_unbox(_x6138, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x6137 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x6137, _ctx);
}
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6115(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list ps0_4546;
  kk_std_core__list _x6124;
  kk_std_core__list _x6133 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4818_pdouble_fun6134(_ctx), _ctx), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x6124 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4818_pdouble_fun6125(_ctx), _ctx), _x6133, _ctx); /*list<61>*/
  ps0_4546 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4818_pdouble_fun6116(_ctx), _ctx), _x6124, _ctx); /*list<() -> std/text/parse/parse float64>*/
  double _x6142;
  if (kk_std_core__is_Nil(ps0_4546, _ctx)) {
    kk_std_core_hnd__ev ev_4955;
    kk_ssize_t _x6143 = (KK_IZ(0)); /*ssize_t*/
    ev_4955 = kk_evv_at(_x6143,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
    kk_box_t _x6144;
    {
      struct kk_std_core_hnd_Ev* _con6145 = kk_std_core_hnd__as_Ev(ev_4955, _ctx);
      kk_box_t _box_x5389 = _con6145->hnd;
      kk_std_core_hnd__marker m0 = _con6145->marker;
      kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x5389, KK_BORROWED, _ctx);
      kk_std_text_parse__hnd_parse_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_5546;
      kk_std_core_hnd__clause1 _brw_5547 = kk_std_text_parse__select_fail(h, _ctx); /*std/core/hnd/clause1<string,394,std/text/parse/.hnd-parse,395,396>*/;
      kk_std_text_parse__hnd_parse_drop(h, _ctx);
      _match_5546 = _brw_5547; /*std/core/hnd/clause1<string,394,std/text/parse/.hnd-parse,395,396>*/
      {
        kk_function_t _fun_unbox_x5393 = _match_5546.clause;
        kk_box_t _x6146;
        kk_string_t _x6147;
        kk_define_string_literal(, _s6148, 23, "no further alternatives", _ctx)
        _x6147 = kk_string_dup(_s6148, _ctx); /*string*/
        _x6146 = kk_string_box(_x6147); /*51*/
        _x6144 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x5393, (_fun_unbox_x5393, m0, ev_4955, _x6146, _ctx), _ctx); /*52*/
      }
    }
    _x6142 = kk_double_unbox(_x6144, KK_OWNED, _ctx); /*float64*/
  }
  else {
    kk_box_t _x6149 = kk_std_text_parse__unroll2246_choose(ps0_4546, _ctx); /*765*/
    _x6142 = kk_double_unbox(_x6149, KK_OWNED, _ctx); /*float64*/
  }
  return kk_double_box(_x6142, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6151__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6151(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6151(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64__mlift4818_pdouble_fun6151, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6151(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  return kk_double_box(0x0p+0, _ctx);
}


// lift anonymous function
struct kk_std_num_float64__mlift4818_pdouble_fun6160__t {
  struct kk_function_s _base;
  bool neg;
};
static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6160(kk_function_t _fself, kk_box_t _b_5430, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64__new_mlift4818_pdouble_fun6160(bool neg, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4818_pdouble_fun6160__t* _self = kk_function_alloc_as(struct kk_std_num_float64__mlift4818_pdouble_fun6160__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64__mlift4818_pdouble_fun6160, kk_context());
  _self->neg = neg;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64__mlift4818_pdouble_fun6160(kk_function_t _fself, kk_box_t _b_5430, kk_context_t* _ctx) {
  struct kk_std_num_float64__mlift4818_pdouble_fun6160__t* _self = kk_function_as(struct kk_std_num_float64__mlift4818_pdouble_fun6160__t*, _fself, _ctx);
  bool neg = _self->neg; /* bool */
  kk_drop_match(_self, {;}, {}, _ctx)
  double _x6161;
  double _c_5432_4779 = kk_double_unbox(_b_5430, KK_OWNED, _ctx); /*float64*/;
  if (neg) {
    _x6161 = (-_c_5432_4779); /*float64*/
  }
  else {
    _x6161 = _c_5432_4779; /*float64*/
  }
  return kk_double_box(_x6161, _ctx);
}

double kk_std_num_float64__mlift4818_pdouble(bool neg, kk_context_t* _ctx) { /* (neg : bool) -> std/text/parse/parse float64 */ 
  kk_std_core__list ps_4545;
  kk_std_core__list _x6111;
  kk_std_core__list _x6114;
  kk_std_core__list _x6150 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4818_pdouble_fun6151(_ctx), _ctx), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x6114 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4818_pdouble_fun6115(_ctx), _ctx), _x6150, _ctx); /*list<61>*/
  _x6111 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4818_pdouble_fun6112(_ctx), _ctx), _x6114, _ctx); /*list<61>*/
  ps_4545 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64__new_mlift4818_pdouble_fun6109(_ctx), _ctx), _x6111, _ctx); /*list<() -> std/text/parse/parse float64>*/
  double x3_4958;
  if (kk_std_core__is_Nil(ps_4545, _ctx)) {
    kk_std_core_hnd__ev ev0_4960;
    kk_ssize_t _x6152 = (KK_IZ(0)); /*ssize_t*/
    ev0_4960 = kk_evv_at(_x6152,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
    kk_box_t _x6153;
    {
      struct kk_std_core_hnd_Ev* _con6154 = kk_std_core_hnd__as_Ev(ev0_4960, _ctx);
      kk_box_t _box_x5419 = _con6154->hnd;
      kk_std_core_hnd__marker m00 = _con6154->marker;
      kk_std_text_parse__hnd_parse h0 = kk_std_text_parse__hnd_parse_unbox(_box_x5419, KK_BORROWED, _ctx);
      kk_std_text_parse__hnd_parse_dup(h0, _ctx);
      kk_std_core_hnd__clause1 _match_5544;
      kk_std_core_hnd__clause1 _brw_5545 = kk_std_text_parse__select_fail(h0, _ctx); /*std/core/hnd/clause1<string,394,std/text/parse/.hnd-parse,395,396>*/;
      kk_std_text_parse__hnd_parse_drop(h0, _ctx);
      _match_5544 = _brw_5545; /*std/core/hnd/clause1<string,394,std/text/parse/.hnd-parse,395,396>*/
      {
        kk_function_t _fun_unbox_x5423 = _match_5544.clause;
        kk_box_t _x6155;
        kk_string_t _x6156;
        kk_define_string_literal(, _s6157, 23, "no further alternatives", _ctx)
        _x6156 = kk_string_dup(_s6157, _ctx); /*string*/
        _x6155 = kk_string_box(_x6156); /*51*/
        _x6153 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x5423, (_fun_unbox_x5423, m00, ev0_4960, _x6155, _ctx), _ctx); /*52*/
      }
    }
    x3_4958 = kk_double_unbox(_x6153, KK_OWNED, _ctx); /*float64*/
  }
  else {
    kk_box_t _x6158 = kk_std_text_parse__unroll2246_choose(ps_4545, _ctx); /*765*/
    x3_4958 = kk_double_unbox(_x6158, KK_OWNED, _ctx); /*float64*/
  }
  if (kk_yielding(kk_context())) {
    kk_box_t _x6159 = kk_std_core_hnd_yield_extend(kk_std_num_float64__new_mlift4818_pdouble_fun6160(neg, _ctx), _ctx); /*3926*/
    return kk_double_unbox(_x6159, KK_OWNED, _ctx);
  }
  {
    double _c_5433_4779 = x3_4958; /*float64*/;
    if (neg) {
      return (-_c_5433_4779);
    }
    {
      return _c_5433_4779;
    }
  }
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun6163__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6163(kk_function_t _fself, kk_box_t _b_5435, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6163(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6163, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun6163(kk_function_t _fself, kk_box_t _b_5435, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6164;
  bool _x6165 = kk_bool_unbox(_b_5435); /*bool*/
  _x6164 = kk_std_num_float64__mlift4818_pdouble(_x6165, _ctx); /*float64*/
  return kk_double_box(_x6164, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun6166__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6166(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6166(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6166, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun6166(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6167 = kk_std_num_float64_phexdouble(_ctx); /*float64*/
  return kk_double_box(_x6167, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun6169__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6169(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6169(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6169, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun6169(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6170 = kk_std_num_float64_pdecdouble(_ctx); /*float64*/
  return kk_double_box(_x6170, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun6172__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6172(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6172(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6172, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun6173__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6173(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6173(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6173, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun6178__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6178(kk_function_t _fself, kk_box_t _b_5437, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6178(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6178, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun6178(kk_function_t _fself, kk_box_t _b_5437, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6179;
  kk_string_t _x6180 = kk_string_unbox(_b_5437); /*string*/
  _x6179 = kk_std_num_float64__mlift4814_pdouble(_x6180, _ctx); /*float64*/
  return kk_double_box(_x6179, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun6173(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x0_4968;
  kk_string_t _x6174;
  kk_define_string_literal(, _s6175, 3, "nan", _ctx)
  _x6174 = kk_string_dup(_s6175, _ctx); /*string*/
  x0_4968 = kk_std_text_parse_pstring(_x6174, _ctx); /*string*/
  kk_string_drop(x0_4968, _ctx);
  double _x6176;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6177 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun6178(_ctx), _ctx); /*3926*/
    _x6176 = kk_double_unbox(_x6177, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x6176 = kk_std_num_float64_nan; /*float64*/
  }
  return kk_double_box(_x6176, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun6182__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6182(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6182(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6182, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun6187__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6187(kk_function_t _fself, kk_box_t _b_5439, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6187(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6187, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun6187(kk_function_t _fself, kk_box_t _b_5439, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6188;
  kk_string_t _x6189 = kk_string_unbox(_b_5439); /*string*/
  _x6188 = kk_std_num_float64__mlift4815_pdouble(_x6189, _ctx); /*float64*/
  return kk_double_box(_x6188, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun6182(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x1_4970;
  kk_string_t _x6183;
  kk_define_string_literal(, _s6184, 8, "infinity", _ctx)
  _x6183 = kk_string_dup(_s6184, _ctx); /*string*/
  x1_4970 = kk_std_text_parse_pstring(_x6183, _ctx); /*string*/
  kk_string_drop(x1_4970, _ctx);
  double _x6185;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6186 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun6187(_ctx), _ctx); /*3926*/
    _x6185 = kk_double_unbox(_x6186, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x6185 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x6185, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun6191__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6191(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6191(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6191, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_num_float64_pdouble_fun6196__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6196(kk_function_t _fself, kk_box_t _b_5441, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6196(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6196, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun6196(kk_function_t _fself, kk_box_t _b_5441, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6197;
  kk_string_t _x6198 = kk_string_unbox(_b_5441); /*string*/
  _x6197 = kk_std_num_float64__mlift4816_pdouble(_x6198, _ctx); /*float64*/
  return kk_double_box(_x6197, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun6191(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t x2_4972;
  kk_string_t _x6192;
  kk_define_string_literal(, _s6193, 3, "inf", _ctx)
  _x6192 = kk_string_dup(_s6193, _ctx); /*string*/
  x2_4972 = kk_std_text_parse_pstring(_x6192, _ctx); /*string*/
  kk_string_drop(x2_4972, _ctx);
  double _x6194;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6195 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun6196(_ctx), _ctx); /*3926*/
    _x6194 = kk_double_unbox(_x6195, KK_OWNED, _ctx); /*float64*/
  }
  else {
    _x6194 = kk_std_num_float64_posinf; /*float64*/
  }
  return kk_double_box(_x6194, _ctx);
}
static kk_box_t kk_std_num_float64_pdouble_fun6172(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__list ps0_4546;
  kk_std_core__list _x6181;
  kk_std_core__list _x6190 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun6191(_ctx), _ctx), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
  _x6181 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun6182(_ctx), _ctx), _x6190, _ctx); /*list<61>*/
  ps0_4546 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun6173(_ctx), _ctx), _x6181, _ctx); /*list<() -> std/text/parse/parse float64>*/
  double _x6199;
  if (kk_std_core__is_Nil(ps0_4546, _ctx)) {
    kk_std_core_hnd__ev ev_4974;
    kk_ssize_t _x6200 = (KK_IZ(0)); /*ssize_t*/
    ev_4974 = kk_evv_at(_x6200,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
    kk_box_t _x6201;
    {
      struct kk_std_core_hnd_Ev* _con6202 = kk_std_core_hnd__as_Ev(ev_4974, _ctx);
      kk_box_t _box_x5460 = _con6202->hnd;
      kk_std_core_hnd__marker m0 = _con6202->marker;
      kk_std_text_parse__hnd_parse h = kk_std_text_parse__hnd_parse_unbox(_box_x5460, KK_BORROWED, _ctx);
      kk_std_text_parse__hnd_parse_dup(h, _ctx);
      kk_std_core_hnd__clause1 _match_5538;
      kk_std_core_hnd__clause1 _brw_5539 = kk_std_text_parse__select_fail(h, _ctx); /*std/core/hnd/clause1<string,394,std/text/parse/.hnd-parse,395,396>*/;
      kk_std_text_parse__hnd_parse_drop(h, _ctx);
      _match_5538 = _brw_5539; /*std/core/hnd/clause1<string,394,std/text/parse/.hnd-parse,395,396>*/
      {
        kk_function_t _fun_unbox_x5464 = _match_5538.clause;
        kk_box_t _x6203;
        kk_string_t _x6204;
        kk_define_string_literal(, _s6205, 23, "no further alternatives", _ctx)
        _x6204 = kk_string_dup(_s6205, _ctx); /*string*/
        _x6203 = kk_string_box(_x6204); /*51*/
        _x6201 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x5464, (_fun_unbox_x5464, m0, ev_4974, _x6203, _ctx), _ctx); /*52*/
      }
    }
    _x6199 = kk_double_unbox(_x6201, KK_OWNED, _ctx); /*float64*/
  }
  else {
    kk_box_t _x6206 = kk_std_text_parse__unroll2246_choose(ps0_4546, _ctx); /*765*/
    _x6199 = kk_double_unbox(_x6206, KK_OWNED, _ctx); /*float64*/
  }
  return kk_double_box(_x6199, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun6208__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_pdouble_fun6208(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6208(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_pdouble_fun6208, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun6208(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  return kk_double_box(0x0p+0, _ctx);
}


// lift anonymous function
struct kk_std_num_float64_pdouble_fun6217__t {
  struct kk_function_s _base;
  bool x_4965;
};
static kk_box_t kk_std_num_float64_pdouble_fun6217(kk_function_t _fself, kk_box_t _b_5501, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_pdouble_fun6217(bool x_4965, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdouble_fun6217__t* _self = kk_function_alloc_as(struct kk_std_num_float64_pdouble_fun6217__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_num_float64_pdouble_fun6217, kk_context());
  _self->x_4965 = x_4965;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_num_float64_pdouble_fun6217(kk_function_t _fself, kk_box_t _b_5501, kk_context_t* _ctx) {
  struct kk_std_num_float64_pdouble_fun6217__t* _self = kk_function_as(struct kk_std_num_float64_pdouble_fun6217__t*, _fself, _ctx);
  bool x_4965 = _self->x_4965; /* bool */
  kk_drop_match(_self, {;}, {}, _ctx)
  double _c_5504_4779 = kk_double_unbox(_b_5501, KK_OWNED, _ctx); /*float64*/;
  double _x6218;
  if (x_4965) {
    _x6218 = (-_c_5504_4779); /*float64*/
  }
  else {
    _x6218 = _c_5504_4779; /*float64*/
  }
  return kk_double_box(_x6218, _ctx);
}

double kk_std_num_float64_pdouble(kk_context_t* _ctx) { /* () -> std/text/parse/parse float64 */ 
  bool x_4965 = kk_std_text_parse_sign(_ctx); /*bool*/;
  if (kk_yielding(kk_context())) {
    kk_box_t _x6162 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun6163(_ctx), _ctx); /*3926*/
    return kk_double_unbox(_x6162, KK_OWNED, _ctx);
  }
  {
    kk_std_core__list ps_4545;
    kk_std_core__list _x6168;
    kk_std_core__list _x6171;
    kk_std_core__list _x6207 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun6208(_ctx), _ctx), kk_std_core__new_Nil(_ctx), _ctx); /*list<61>*/
    _x6171 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun6172(_ctx), _ctx), _x6207, _ctx); /*list<61>*/
    _x6168 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun6169(_ctx), _ctx), _x6171, _ctx); /*list<61>*/
    ps_4545 = kk_std_core__new_Cons(kk_reuse_null, 0, kk_function_box(kk_std_num_float64_new_pdouble_fun6166(_ctx), _ctx), _x6168, _ctx); /*list<() -> std/text/parse/parse float64>*/
    double x4_4977;
    if (kk_std_core__is_Nil(ps_4545, _ctx)) {
      kk_std_core_hnd__ev ev0_4980;
      kk_ssize_t _x6209 = (KK_IZ(0)); /*ssize_t*/
      ev0_4980 = kk_evv_at(_x6209,kk_context()); /*std/core/hnd/ev<std/text/parse/.hnd-parse>*/
      kk_box_t _x6210;
      {
        struct kk_std_core_hnd_Ev* _con6211 = kk_std_core_hnd__as_Ev(ev0_4980, _ctx);
        kk_box_t _box_x5490 = _con6211->hnd;
        kk_std_core_hnd__marker m00 = _con6211->marker;
        kk_std_text_parse__hnd_parse h0 = kk_std_text_parse__hnd_parse_unbox(_box_x5490, KK_BORROWED, _ctx);
        kk_std_text_parse__hnd_parse_dup(h0, _ctx);
        kk_std_core_hnd__clause1 _match_5536;
        kk_std_core_hnd__clause1 _brw_5537 = kk_std_text_parse__select_fail(h0, _ctx); /*std/core/hnd/clause1<string,394,std/text/parse/.hnd-parse,395,396>*/;
        kk_std_text_parse__hnd_parse_drop(h0, _ctx);
        _match_5536 = _brw_5537; /*std/core/hnd/clause1<string,394,std/text/parse/.hnd-parse,395,396>*/
        {
          kk_function_t _fun_unbox_x5494 = _match_5536.clause;
          kk_box_t _x6212;
          kk_string_t _x6213;
          kk_define_string_literal(, _s6214, 23, "no further alternatives", _ctx)
          _x6213 = kk_string_dup(_s6214, _ctx); /*string*/
          _x6212 = kk_string_box(_x6213); /*51*/
          _x6210 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x5494, (_fun_unbox_x5494, m00, ev0_4980, _x6212, _ctx), _ctx); /*52*/
        }
      }
      x4_4977 = kk_double_unbox(_x6210, KK_OWNED, _ctx); /*float64*/
    }
    else {
      kk_box_t _x6215 = kk_std_text_parse__unroll2246_choose(ps_4545, _ctx); /*765*/
      x4_4977 = kk_double_unbox(_x6215, KK_OWNED, _ctx); /*float64*/
    }
    if (kk_yielding(kk_context())) {
      kk_box_t _x6216 = kk_std_core_hnd_yield_extend(kk_std_num_float64_new_pdouble_fun6217(x_4965, _ctx), _ctx); /*3926*/
      return kk_double_unbox(_x6216, KK_OWNED, _ctx);
    }
    if (x_4965) {
      return (-x4_4977);
    }
    {
      return x4_4977;
    }
  }
}
 
// Parse a float64 number. Can be "NaN", "Inf(inity)" (case-insensitive),
// a fix-point number (`1.2`) or in scientific notation (`-2.3e-5`).
// Also allows floats in [hexadecimal notation](https://books.google.com/books?id=FgMsCwAAQBAJ&pg=PA41) (`0xA.Fp-10`) that can
// be represented precisely (and are the preferred _round trip_ format).


// lift anonymous function
struct kk_std_num_float64_parse_float64_fun6223__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_num_float64_parse_float64_fun6223(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_num_float64_new_parse_float64_fun6223(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_num_float64_parse_float64_fun6223, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_num_float64_parse_float64_fun6223(kk_function_t _fself, kk_context_t* _ctx) {
  kk_unused(_fself);
  double _x6224 = kk_std_num_float64_pdouble(_ctx); /*float64*/
  return kk_double_box(_x6224, _ctx);
}

kk_std_core_types__maybe kk_std_num_float64_parse_float64(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> maybe<float64> */ 
  kk_string_t s0_4548;
  kk_string_t _x6219;
  kk_string_t _x6220 = kk_string_trim_left(s,kk_context()); /*string*/
  _x6219 = kk_string_trim_right(_x6220,kk_context()); /*string*/
  s0_4548 = kk_std_core_to_lower(_x6219, _ctx); /*string*/
  kk_std_core__sslice _b_5507_5505;
  kk_string_t _x6221 = kk_string_dup(s0_4548, _ctx); /*string*/
  kk_integer_t _x6222 = kk_string_len_int(s0_4548,kk_context()); /*int*/
  _b_5507_5505 = kk_std_core__new_Sslice(_x6221, kk_integer_from_small(0), _x6222, _ctx); /*sslice*/
  kk_std_text_parse__parse_error perr_4547 = kk_std_text_parse_parse_eof(_b_5507_5505, kk_std_num_float64_new_parse_float64_fun6223(_ctx), _ctx); /*std/text/parse/parse-error<float64>*/;
  if (kk_std_text_parse__is_ParseOk(perr_4547, _ctx)) {
    struct kk_std_text_parse_ParseOk* _con6225 = kk_std_text_parse__as_ParseOk(perr_4547, _ctx);
    kk_box_t _box_x5509 = _con6225->result;
    kk_std_core__sslice _pat00 = _con6225->rest;
    double x0 = kk_double_unbox(_box_x5509, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(perr_4547, _ctx)) {
      kk_std_core__sslice_drop(_pat00, _ctx);
      kk_box_drop(_box_x5509, _ctx);
      kk_datatype_ptr_free(perr_4547, _ctx);
    }
    else {
      kk_datatype_ptr_decref(perr_4547, _ctx);
    }
    return kk_std_core_types__new_Just(kk_double_box(x0, _ctx), _ctx);
  }
  {
    struct kk_std_text_parse_ParseError* _con6226 = kk_std_text_parse__as_ParseError(perr_4547, _ctx);
    kk_std_core__sslice _pat5 = _con6226->rest;
    kk_string_t msg = _con6226->msg;
    if kk_likely(kk_datatype_ptr_is_unique(perr_4547, _ctx)) {
      kk_string_drop(msg, _ctx);
      kk_std_core__sslice_drop(_pat5, _ctx);
      kk_datatype_ptr_free(perr_4547, _ctx);
    }
    else {
      kk_datatype_ptr_decref(perr_4547, _ctx);
    }
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Round a float64 to a specified precision. Rounds to the  even number in case of a tie.
// `123.456.round-to-prec(2) == 123.46`
// `123.456.round-to-prec(-1) == 120.0`

double kk_std_num_float64_round_to_prec(double d, kk_integer_t prec, kk_context_t* _ctx) { /* (d : float64, prec : int) -> float64 */ 
  bool _match_5533 = kk_integer_lte_borrow(prec,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_5533) {
    kk_integer_drop(prec, _ctx);
    return kk_double_round_even(d,kk_context());
  }
  {
    double p;
    double _x6227 = kk_integer_as_double(prec,kk_context()); /*float64*/
    p = pow(10.0,_x6227); /*float64*/
    double _x6228;
    double _x6229 = (d * p); /*float64*/
    _x6228 = kk_double_round_even(_x6229,kk_context()); /*float64*/
    return (_x6228 / p);
  }
}
 
/* Show a float64 in [hexadecimal notation](https://books.google.com/books?id=FgMsCwAAQBAJ&pg=PA41).
An advantage of this format is that it precisely represents the `:float64` and can
reliably (and efficiently) be parsed back, i.e. `d.show-hex.parse-float64 == Just(d)`.
The significant is the _hexadecimal_ fraction while the
exponent after the `p` is the _decimal_ power of 2.
 For example, ``0xA.Fp-10`` = (10 + 15/16)&middot;2^-10^  (not 2^-16^!) = 0.01068115234375.
 Equivalently, ``0xA.Fp-10 == 0x5.78p-9 == 0x2.BCp-8 == 0x1.5Ep-7``.
```
> flt-min.show-hex
"0x1.0p-1022"
> 0.1.show-hex
"0x1.999999999999Ap-4"
> flt-max.show-hex
"0x1.FFFFFFFFFFFFFp+1023"
> -0.0.show-hex
"-0x0.0p+0"
> nan.show-hex
"NaN"
> 0.01068115234375.show-hex
"0x1.5Ep-7"
```
.
*/

kk_string_t kk_std_num_float64_show_hex(double d, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (d : float64, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  bool b_4550 = isfinite(d); /*bool*/;
  if (b_4550) {
    kk_std_core_types__tuple2_ _match_5524 = kk_std_num_float64_decode(d, _ctx); /*(int, int)*/;
    {
      kk_box_t _box_x5512 = _match_5524.fst;
      kk_box_t _box_x5513 = _match_5524.snd;
      kk_integer_t m = kk_integer_unbox(_box_x5512, _ctx);
      kk_integer_t e = kk_integer_unbox(_box_x5513, _ctx);
      kk_integer_dup(e, _ctx);
      kk_integer_dup(m, _ctx);
      kk_std_core_types__tuple2__drop(_match_5524, _ctx);
      kk_string_t man;
      kk_integer_t _x6230 = kk_integer_abs(m,kk_context()); /*int*/
      kk_std_core_types__optional _x6231 = kk_std_core_types__new_Optional(kk_integer_box(kk_integer_from_small(1), _ctx), _ctx); /*optional<116>*/
      kk_std_core_types__optional _x6232;
      kk_box_t _x6233;
      bool _x6234;
      if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
        kk_box_t _box_x5515 = use_capitals._cons.Optional.value;
        bool _use_capitals_3963 = kk_bool_unbox(_box_x5515);
        kk_std_core_types__optional_drop(use_capitals, _ctx);
        _x6234 = _use_capitals_3963; /*bool*/
      }
      else {
        kk_std_core_types__optional_drop(use_capitals, _ctx);
        _x6234 = true; /*bool*/
      }
      _x6233 = kk_bool_box(_x6234); /*116*/
      _x6232 = kk_std_core_types__new_Optional(_x6233, _ctx); /*optional<116>*/
      kk_std_core_types__optional _x6235;
      kk_box_t _x6236;
      kk_string_t _x6237 = kk_string_empty(); /*string*/
      _x6236 = kk_string_box(_x6237); /*116*/
      _x6235 = kk_std_core_types__new_Optional(_x6236, _ctx); /*optional<116>*/
      man = kk_std_core_show_hex(_x6230, _x6231, _x6232, _x6235, _ctx); /*string*/
      kk_integer_t x0_4553;
      kk_string_t _x6239 = kk_string_dup(man, _ctx); /*string*/
      x0_4553 = kk_std_core_count_1(_x6239, _ctx); /*int*/
      kk_integer_t y_4552;
      kk_integer_t _x6240 = kk_integer_add_small_const(x0_4553, -1, _ctx); /*int*/
      y_4552 = kk_integer_mul((kk_integer_from_small(4)),_x6240,kk_context()); /*int*/
      kk_integer_t exp0 = kk_integer_add(e,y_4552,kk_context()); /*int*/;
      kk_string_t exp;
      kk_string_t _x6241;
      bool _match_5532 = kk_integer_gte_borrow(exp0,(kk_integer_from_small(0)),kk_context()); /*bool*/;
      if (_match_5532) {
        kk_define_string_literal(, _s6242, 1, "+", _ctx)
        _x6241 = kk_string_dup(_s6242, _ctx); /*string*/
      }
      else {
        _x6241 = kk_string_empty(); /*string*/
      }
      kk_string_t _x6244 = kk_std_core_show(exp0, _ctx); /*string*/
      exp = kk_std_core__lp__plus__plus__1_rp_(_x6241, _x6244, _ctx); /*string*/
      kk_string_t s_4555;
      kk_string_t _x6245;
      kk_string_t _x6246 = kk_string_dup(man, _ctx); /*string*/
      _x6245 = kk_std_core_tail_2(_x6246, _ctx); /*string*/
      kk_string_t _x6247;
      kk_define_string_literal(, _s6248, 1, "0", _ctx)
      _x6247 = kk_string_dup(_s6248, _ctx); /*string*/
      s_4555 = kk_std_core_trim_right_1(_x6245, _x6247, _ctx); /*string*/
      kk_integer_t width0_4556;
      bool _match_5529;
      kk_integer_t _brw_5530;
      if (kk_std_core_types__is_Optional(width, _ctx)) {
        kk_box_t _box_x5521 = width._cons.Optional.value;
        kk_integer_t _width_3959 = kk_integer_unbox(_box_x5521, _ctx);
        kk_integer_dup(_width_3959, _ctx);
        _brw_5530 = _width_3959; /*int*/
      }
      else {
        _brw_5530 = kk_integer_from_small(1); /*int*/
      }
      bool _brw_5531 = kk_integer_gte_borrow((kk_integer_from_small(1)),_brw_5530,kk_context()); /*bool*/;
      kk_integer_drop(_brw_5530, _ctx);
      _match_5529 = _brw_5531; /*bool*/
      if (_match_5529) {
        kk_std_core_types__optional_drop(width, _ctx);
        width0_4556 = kk_integer_from_small(1); /*int*/
      }
      else {
        if (kk_std_core_types__is_Optional(width, _ctx)) {
          kk_box_t _box_x5522 = width._cons.Optional.value;
          kk_integer_t _width_39590 = kk_integer_unbox(_box_x5522, _ctx);
          kk_integer_dup(_width_39590, _ctx);
          kk_std_core_types__optional_drop(width, _ctx);
          width0_4556 = _width_39590; /*int*/
        }
        else {
          kk_std_core_types__optional_drop(width, _ctx);
          width0_4556 = kk_integer_from_small(1); /*int*/
        }
      }
      kk_integer_t n;
      kk_string_t _x6249 = kk_string_dup(s_4555, _ctx); /*string*/
      n = kk_string_len_int(_x6249,kk_context()); /*int*/
      kk_string_t frac;
      bool _match_5528 = kk_integer_lte_borrow(width0_4556,n,kk_context()); /*bool*/;
      if (_match_5528) {
        kk_integer_drop(width0_4556, _ctx);
        kk_integer_drop(n, _ctx);
        frac = s_4555; /*string*/
      }
      else {
        kk_string_t s0_17759 = kk_std_core_string('0', _ctx); /*string*/;
        kk_integer_t n0_17760 = kk_integer_sub(width0_4556,n,kk_context()); /*int*/;
        kk_string_t _x6250;
        kk_ssize_t _x6251 = kk_std_core_ssize__t(n0_17760, _ctx); /*ssize_t*/
        _x6250 = kk_std_core_repeatz(s0_17759, _x6251, _ctx); /*string*/
        frac = kk_std_core__lp__plus__plus__1_rp_(s_4555, _x6250, _ctx); /*string*/
      }
      kk_string_t sign;
      bool _match_5525 = (d < (0x0p+0)); /*bool*/;
      if (_match_5525) {
        kk_define_string_literal(, _s6252, 1, "-", _ctx)
        sign = kk_string_dup(_s6252, _ctx); /*string*/
      }
      else {
        bool _match_5526 = (d == (0x0p+0)); /*bool*/;
        if (_match_5526) {
          bool _match_5527;
          double _x6253 = (0x1p0 / d); /*float64*/
          _match_5527 = (isinf(_x6253) && signbit(_x6253)); /*bool*/
          if (_match_5527) {
            kk_define_string_literal(, _s6254, 1, "-", _ctx)
            sign = kk_string_dup(_s6254, _ctx); /*string*/
          }
          else {
            sign = kk_string_empty(); /*string*/
          }
        }
        else {
          sign = kk_string_empty(); /*string*/
        }
      }
      kk_string_t _x6257;
      kk_string_t _x6258;
      if (kk_std_core_types__is_Optional(pre, _ctx)) {
        kk_box_t _box_x5523 = pre._cons.Optional.value;
        kk_string_t _pre_3967 = kk_string_unbox(_box_x5523);
        kk_string_dup(_pre_3967, _ctx);
        kk_std_core_types__optional_drop(pre, _ctx);
        _x6258 = _pre_3967; /*string*/
      }
      else {
        kk_std_core_types__optional_drop(pre, _ctx);
        kk_define_string_literal(, _s6259, 2, "0x", _ctx)
        _x6258 = kk_string_dup(_s6259, _ctx); /*string*/
      }
      kk_string_t _x6260;
      kk_string_t _x6261 = kk_std_core_head_3(man, _ctx); /*string*/
      kk_string_t _x6262;
      kk_string_t _x6263;
      kk_define_string_literal(, _s6264, 1, ".", _ctx)
      _x6263 = kk_string_dup(_s6264, _ctx); /*string*/
      kk_string_t _x6265;
      kk_string_t _x6266;
      kk_string_t _x6267;
      kk_define_string_literal(, _s6268, 1, "p", _ctx)
      _x6267 = kk_string_dup(_s6268, _ctx); /*string*/
      _x6266 = kk_std_core__lp__plus__plus__1_rp_(_x6267, exp, _ctx); /*string*/
      _x6265 = kk_std_core__lp__plus__plus__1_rp_(frac, _x6266, _ctx); /*string*/
      _x6262 = kk_std_core__lp__plus__plus__1_rp_(_x6263, _x6265, _ctx); /*string*/
      _x6260 = kk_std_core__lp__plus__plus__1_rp_(_x6261, _x6262, _ctx); /*string*/
      _x6257 = kk_std_core__lp__plus__plus__1_rp_(_x6258, _x6260, _ctx); /*string*/
      return kk_std_core__lp__plus__plus__1_rp_(sign, _x6257, _ctx);
    }
  }
  {
    kk_std_core_types__optional_drop(width, _ctx);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    return kk_std_core_show_1(d, kk_std_core_types__new_None(_ctx), _ctx);
  }
}

// initialization
void kk_std_num_float64__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  kk_std_core__init(_ctx);
  kk_std_text_parse__init(_ctx);
  kk_std_num_int64__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  {
    kk_std_num_float64_flt_max_prec = kk_integer_from_small(15); /*int*/
  }
  {
    kk_std_num_float64_rad2deg = ((0x1.68p7) / (0x1.921fb54442d18p1)); /*float64*/
  }
  {
    kk_std_num_float64_deg2rad = ((0x1.921fb54442d18p1) / (0x1.68p7)); /*float64*/
  }
  {
    kk_std_num_float64_neginf = kk_std_num_float64_make_neginf(_ctx); /*float64*/
  }
  {
    kk_std_num_float64_posinf = kk_std_num_float64_make_posinf(_ctx); /*float64*/
  }
  {
    kk_std_num_float64_nan = kk_std_num_float64_make_nan(_ctx); /*float64*/
  }
}

// termination
void kk_std_num_float64__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_integer_drop(kk_std_num_float64_flt_max_prec, _ctx);
  kk_std_num_int64__done(_ctx);
  kk_std_text_parse__done(_ctx);
  kk_std_core__done(_ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
