// Koka generated module: "std/core", koka version: 2.4.2, platform: 64-bit
#include "std_core.h"
/*---------------------------------------------------------------------------
  Copyright 2020-2021, Microsoft Research, Daan Leijen.

  This is free software; you can redistribute it and/or modify it under the
  terms of the Apache License, Version 2.0. A copy of the License can be
  found in the LICENSE file at the root of this distribution.
---------------------------------------------------------------------------*/

kk_std_core__list kk_vector_to_list(kk_vector_t v, kk_std_core__list tail, kk_context_t* ctx) {
  // todo: avoid boxed_dup if v is unique
  kk_ssize_t n;
  kk_box_t* p = kk_vector_buf_borrow(v, &n, ctx);
  if (n <= 0) {
    kk_vector_drop(v,ctx);
    return tail;
  }
  kk_std_core__list nil  = kk_std_core__new_Nil(ctx);
  struct kk_std_core_Cons* cons = NULL;
  kk_std_core__list list = kk_std_core__new_Nil(ctx);
  for( kk_ssize_t i = 0; i < n; i++ ) {
    kk_std_core__list hd = kk_std_core__new_Cons(kk_reuse_null,0,kk_box_dup(p[i],ctx), nil, ctx);
    if (cons==NULL) {
      list = hd;
    }
    else {
      cons->tail = hd;
    }
    cons = kk_std_core__as_Cons(hd,ctx);
  }
  if (cons == NULL) { list = tail; } 
               else { cons->tail = tail; }
  kk_vector_drop(v,ctx);
  return list;
}

kk_vector_t kk_list_to_vector(kk_std_core__list xs, kk_context_t* ctx) {
  // todo: avoid boxed_dup if xs is unique
  // find the length
  kk_ssize_t len = 0;
  kk_std_core__list ys = xs;
  while (kk_std_core__is_Cons(ys,ctx)) {
    struct kk_std_core_Cons* cons = kk_std_core__as_Cons(ys,ctx);
    len++;
    ys = cons->tail;
  }
  // alloc the vector and copy
  kk_box_t* p;
  kk_vector_t v = kk_vector_alloc_uninit(len, &p, ctx);  
  ys = xs;
  for( kk_ssize_t i = 0; i < len; i++) {
    struct kk_std_core_Cons* cons = kk_std_core__as_Cons(ys,ctx);
    ys = cons->tail;
    p[i] = kk_box_dup(cons->head,ctx);
  }
  kk_std_core__list_drop(xs,ctx);  // todo: drop while visiting?
  return v;
}

kk_vector_t kk_vector_init( kk_ssize_t n, kk_function_t init, kk_context_t* ctx) {
  kk_box_t* p;
  kk_vector_t v = kk_vector_alloc_uninit(n, &p, ctx);  
  for(kk_ssize_t i = 0; i < n; i++) {
    kk_function_dup(init,ctx);
    p[i] = kk_function_call(kk_box_t,(kk_function_t,kk_ssize_t,kk_context_t*),init,(init,i,ctx),ctx);
  }
  kk_function_drop(init,ctx);
  return v;
}

kk_box_t kk_main_console( kk_function_t action, kk_context_t* ctx ) {
  return kk_function_call(kk_box_t,(kk_function_t,kk_unit_t,kk_context_t*),action,(action,kk_Unit,ctx),ctx);
}


kk_std_core__list kk_string_to_list(kk_string_t s, kk_context_t* ctx) {
  kk_ssize_t len;
  const uint8_t* p = kk_string_buf_borrow(s,&len,ctx);
  const uint8_t* const end = p + len;
  kk_std_core__list nil  = kk_std_core__new_Nil(ctx);
  kk_std_core__list list = nil;
  struct kk_std_core_Cons* tl = NULL;
  kk_ssize_t count;
  while( p < end ) {
    kk_char_t c = kk_utf8_read(p,&count);
    p += count;
    kk_std_core__list cons = kk_std_core__new_Cons(kk_reuse_null,0,kk_char_box(c,ctx), nil, ctx);
    if (tl!=NULL) {
      tl->tail = cons;
    }
    else {
      list = cons;
    }
    tl = kk_std_core__as_Cons(cons,ctx);
  }
  kk_string_drop(s,ctx);
  return list;
}

kk_string_t kk_string_from_list(kk_std_core__list cs, kk_context_t* ctx) {
  // TODO: optimize for short strings to write directly into a local buffer?
  // find total UTF8 length
  kk_ssize_t len = 0;
  kk_std_core__list xs = cs;
  while (kk_std_core__is_Cons(xs,ctx)) {
    struct kk_std_core_Cons* cons = kk_std_core__as_Cons(xs,ctx);
    len += kk_utf8_len(kk_char_unbox(cons->head,KK_BORROWED,ctx));
    xs = cons->tail;
  }
  // allocate and copy the characters
  uint8_t* p;
  kk_string_t s = kk_unsafe_string_alloc_buf(len,&p,ctx);  // must be initialized
  xs = cs;
  while (kk_std_core__is_Cons(xs,ctx)) {
    struct kk_std_core_Cons* cons = kk_std_core__as_Cons(xs,ctx);
    kk_ssize_t count;
    kk_utf8_write( kk_char_unbox(cons->head,KK_BORROWED,ctx), p, &count );
    p += count;
    xs = cons->tail;
  }
  kk_assert_internal(*p == 0 && (p - kk_string_buf_borrow(s,NULL,ctx)) == len);
  kk_std_core__list_drop(cs,ctx);  // todo: drop while visiting?
  return s;
}

static inline void kk_sslice_start_end_borrowx( kk_std_core__sslice sslice, const uint8_t** start, const uint8_t** end, const uint8_t** sstart, const uint8_t** send, kk_context_t* ctx) {
  kk_ssize_t strlen;
  const uint8_t* s = kk_string_buf_borrow(sslice.str,&strlen,ctx);
  kk_ssize_t slstart = kk_integer_clamp_ssize_t_borrow(sslice.start,ctx);
  kk_ssize_t sllen   = kk_integer_clamp_ssize_t_borrow(sslice.len,ctx);
  *start = s + slstart;
  *end = s + slstart + sllen;
  if (sstart != NULL) *sstart = s;
  if (send != NULL) *send = s + strlen;
  kk_assert_internal(*start >= s && *start <= *end);
  kk_assert_internal(*end >= *start && *end <= s + strlen);
}

static inline void kk_sslice_start_end_borrow( kk_std_core__sslice sslice, const uint8_t** start, const uint8_t** end, kk_context_t* ctx) {
  kk_sslice_start_end_borrowx(sslice,start,end,NULL,NULL,ctx);
}

kk_integer_t kk_slice_count( kk_std_core__sslice sslice, kk_context_t* ctx ) {
  // TODO: optimize this by extending kk_string_count
  const uint8_t* start;
  const uint8_t* end;
  kk_sslice_start_end_borrow(sslice, &start, &end, ctx);
  kk_ssize_t count = 0;
  while( start < end && *start != 0 ) {
    const uint8_t* next = kk_utf8_next(start);
    count++;
    start = next;
  }
  kk_std_core__sslice_drop(sslice,ctx);
  return kk_integer_from_ssize_t(count,ctx);
}

kk_string_t kk_slice_to_string( kk_std_core__sslice  sslice, kk_context_t* ctx ) {
  const uint8_t* start;
  const uint8_t* end;
  kk_sslice_start_end_borrow(sslice, &start, &end, ctx);
  // is it the full string?
  if (kk_integer_is_zero_borrow(sslice.start) && 
      kk_integer_eq_borrow(sslice.len,kk_integer_from_ssize_t(kk_string_len_borrow(sslice.str,ctx),ctx),ctx)) {
    // TODO: drop sslice and dup sslice.str?
    return sslice.str;
  }
  else {
    // if not, we copy len bytes
    kk_string_t s = kk_string_alloc_dupn_valid_utf8(kk_integer_clamp_ssize_t_borrow(sslice.len,ctx), start, ctx);
    kk_std_core__sslice_drop(sslice,ctx);
    return s;
  }
}

kk_std_core__sslice kk_slice_first( kk_string_t str, kk_context_t* ctx ) {
  kk_ssize_t slen;
  const uint8_t* s = kk_string_buf_borrow(str,&slen,ctx);
  const uint8_t* next = (slen > 0 ? kk_utf8_next(s) : s);
  return kk_std_core__new_Sslice(str, kk_integer_zero, kk_integer_from_ptrdiff_t(next - s,ctx), ctx);
}

kk_std_core__sslice kk_slice_last( kk_string_t str, kk_context_t* ctx ) {
  kk_ssize_t slen;
  const uint8_t* s = kk_string_buf_borrow(str,&slen,ctx);
  const uint8_t* end = s + slen;
  const uint8_t* prev = (s==end ? s : kk_utf8_prev(end));
  return kk_std_core__new_Sslice(str, kk_integer_from_ptrdiff_t(prev - s,ctx), kk_integer_from_ptrdiff_t(end - prev,ctx), ctx);
}

kk_std_core__sslice kk_slice_between( struct kk_std_core_Sslice slice1, struct kk_std_core_Sslice slice2, kk_context_t* ctx ) {
  const uint8_t* s1 = kk_string_buf_borrow( slice1.str, NULL, ctx );
  const uint8_t* s2 = kk_string_buf_borrow( slice2.str, NULL, ctx );
  if (s1 != s2) {
    kk_info_message("between: not equal slices: %p vs. %p\n", s1, s2);
    return kk_std_core__new_Sslice(kk_string_empty(), kk_integer_zero, kk_integer_min_one, ctx); // invalid slice
  }
  
  kk_integer_t start;
  kk_integer_t len;
  if (kk_integer_lte_borrow(slice1.start,slice2.start,ctx)) {
    start = kk_integer_dup(slice1.start,ctx);
    len   = kk_integer_sub(kk_integer_dup(slice2.start,ctx),kk_integer_dup(slice1.start,ctx),ctx);
  }
  else  {
    start = kk_integer_dup(slice2.start,ctx);
    len   = kk_integer_sub(kk_integer_dup(slice1.start,ctx),kk_integer_dup(slice2.start,ctx),ctx);
  }  
  return kk_std_core__new_Sslice(slice1.str, start, len, ctx);
}

kk_std_core_types__maybe kk_slice_next( struct kk_std_core_Sslice slice, kk_context_t* ctx ) {
  if (!kk_integer_is_pos_borrow(slice.len,ctx)) {
    kk_std_core__sslice_drop(slice,ctx);
    return kk_std_core_types__new_Nothing(ctx);
  }
  const uint8_t* start;
  const uint8_t* end;
  kk_sslice_start_end_borrow(slice, &start, &end, ctx);
  kk_ssize_t clen;
  const kk_char_t c = kk_utf8_read(start,&clen);
  kk_assert_internal(clen > 0 && clen <= kk_integer_clamp_ssize_t_borrow(slice.len,ctx));
  kk_integer_t iclen = kk_integer_min(kk_integer_from_ssize_t(clen,ctx),kk_integer_dup(slice.len,ctx),ctx);
  // TODO: specialize type to avoid boxing
  // note: don't drop slice as we take over all fields  
  kk_integer_t istart = kk_integer_add(slice.start,kk_integer_dup(iclen,ctx),ctx);
  kk_integer_t ilen   = kk_integer_sub(slice.len,iclen,ctx);
  kk_std_core__sslice snext = kk_std_core__new_Sslice(slice.str, istart, ilen, ctx);
  kk_std_core_types__tuple2_ res = kk_std_core_types__new_dash__lp__comma__rp_( kk_char_box(c,ctx), kk_std_core__sslice_box(snext,ctx), ctx);
  return kk_std_core_types__new_Just( kk_std_core_types__tuple2__box(res,ctx), ctx );
}

/* Borrow count */
struct kk_std_core_Sslice kk_slice_extend_borrow( struct kk_std_core_Sslice slice, kk_integer_t count, kk_context_t* ctx ) {
  kk_ssize_t cnt = kk_integer_clamp_ssize_t_borrow(count,ctx);
  if (cnt==0 || (!kk_integer_is_pos_borrow(slice.len,ctx) && cnt<0)) return slice;
  const uint8_t* s0;
  const uint8_t* s1;
  kk_sslice_start_end_borrow(slice,&s0,&s1,ctx);
  const uint8_t* t  = s1;
  if (cnt >= 0) {
    do {
      t = kk_utf8_next(t);
      cnt--;
    } while (cnt > 0 && *t != 0);
  }
  else {  // cnt < 0
    const uint8_t* sstart = s0 - kk_integer_clamp_ssize_t_borrow(slice.start,ctx);
    do {
      t = kk_utf8_prev(t);
      cnt++;
    } while (cnt < 0 && t > sstart);
  }
  if (t == s1) return slice;  // length is unchanged
  kk_integer_drop(slice.len,ctx);
  return kk_std_core__new_Sslice(slice.str, slice.start, kk_integer_from_ptrdiff_t(t < s0 ? 0 : (t - s0),ctx), ctx);
}

/* Borrow count */
struct kk_std_core_Sslice kk_slice_advance_borrow( struct kk_std_core_Sslice slice, kk_integer_t count, kk_context_t* ctx ) {
  const kk_ssize_t cnt0 = kk_integer_clamp_ssize_t_borrow(count,ctx);
  kk_ssize_t cnt = cnt0;
  if (cnt==0 || (kk_integer_is_zero_borrow(slice.start) && cnt<0)) return slice;
  const uint8_t* sstart;
  const uint8_t* s0;
  const uint8_t* s1;
  const uint8_t* send;
  kk_sslice_start_end_borrowx(slice,&s0,&s1,&sstart,&send,ctx);
  // advance the start
  const uint8_t* t0  = s0;
  if (cnt >= 0) {
    do {
      t0 = kk_utf8_next(t0);
      cnt--;
    } while (cnt > 0 && t0 < send);
  }
  else {  // cnt < 0
    do {
      t0 = kk_utf8_prev(t0);
      cnt++;
    } while (cnt < 0 && t0 > sstart);
  }
  if (t0 == s0) return slice;  // start is unchanged
  // "t0" points to the new start, now advance the end by the same amount of codepoints
  const uint8_t* t1 = s1;
  cnt = cnt0;
  if (cnt >= 0) {
    do {
      t1 = kk_utf8_next(t1);
      cnt--;
    } while (cnt > 0 && t1 < send);
  }
  else {  // cnt < 0
    do {
      t1 = kk_utf8_prev(t1);
      cnt++;
    } while (cnt < 0 && t1 > sstart);
  }
  // t1 points to the new end
  kk_assert_internal(t1 >= t0);
  kk_integer_drop(slice.start,ctx);
  kk_integer_drop(slice.len,ctx);
  return kk_std_core__new_Sslice(slice.str, kk_integer_from_ptrdiff_t(t0 - sstart,ctx), 
                                            kk_integer_from_ptrdiff_t(t1 - t0,ctx), ctx);
}

/* Borrow iupto */
struct kk_std_core_Sslice kk_slice_common_prefix_borrow( kk_string_t str1, kk_string_t str2, kk_integer_t iupto, kk_context_t* ctx ) {
  const uint8_t* s1 = kk_string_buf_borrow(str1,NULL,ctx);
  const uint8_t* s2 = kk_string_buf_borrow(str2,NULL,ctx);
  kk_ssize_t upto = kk_integer_clamp_ssize_t_borrow(iupto,ctx);
  kk_ssize_t count;
  for(count = 0; count < upto && *s1 != 0 && *s2 != 0; count++, s1++, s2++ ) {
    if (*s1 != *s2) break;
  }
  kk_string_drop(str2,ctx);
  return kk_std_core__new_Sslice(str1, kk_integer_zero, kk_integer_from_ssize_t(count,ctx), ctx);
}


kk_std_core__error kk_error_ok( kk_box_t result, kk_context_t* ctx ) {
  return kk_std_core__new_Ok( result, ctx );
}

kk_std_core__error kk_error_from_errno( int err, kk_context_t* ctx ) {  
  kk_string_t msg;
  #if defined(__GLIBC__) && !defined(WIN32) && !defined(__APPLE__) && !defined(__FreeBSD__)
    // GNU version of strerror_r
    char buf[256];
    char* serr = strerror_r(err, buf, 255); buf[255] = 0;
    msg = kk_string_alloc_from_qutf8( serr, ctx );
  #elif (/* _POSIX_C_SOURCE >= 200112L ||*/ !defined(WIN32) && (_XOPEN_SOURCE >= 600 || defined(__APPLE__) || defined(__FreeBSD__) || defined(__MUSL__)))
    // XSI version of strerror_r
    char buf[256];
    strerror_r(err, buf, 255); buf[255] = 0;
    msg = kk_string_alloc_from_qutf8( buf, ctx );
  #elif defined(_MSC_VER) || (__STDC_VERSION__ >= 201112L || __cplusplus >= 201103L)
    // MSVC, or C/C++ 11
    char buf[256];
    strerror_s(buf, 255, err); buf[255] = 0;
    msg = kk_string_alloc_from_qutf8( buf, ctx );
  #else
    // Old style
    msg = kk_string_alloc_from_qutf8( strerror(err), ctx );
  #endif
  return kk_std_core__new_Error( kk_std_core__new_Exception( msg, kk_std_core__new_ExnSystem(kk_reuse_null, 0, kk_integer_from_int(err,ctx), ctx), ctx), ctx );  
}


kk_unit_t kk_assert_fail( kk_string_t msg, kk_context_t* ctx ) {
  kk_fatal_error(EINVAL, "assertion failed: %s\n", kk_string_cbuf_borrow(msg,NULL,ctx));
  kk_string_drop(msg,ctx);
  return kk_Unit;
}
kk_declare_string_literal(, kk_std_core__tag_ExnError, 17, "std/core/ExnError")
kk_declare_string_literal(, kk_std_core__tag_ExnAssert, 18, "std/core/ExnAssert")
kk_declare_string_literal(, kk_std_core__tag_ExnTodo, 16, "std/core/ExnTodo")
kk_declare_string_literal(, kk_std_core__tag_ExnRange, 17, "std/core/ExnRange")
kk_declare_string_literal(, kk_std_core__tag_ExnPattern, 19, "std/core/ExnPattern")
kk_declare_string_literal(, kk_std_core__tag_ExnSystem, 18, "std/core/ExnSystem")
kk_declare_string_literal(, kk_std_core__tag_ExnInternal, 20, "std/core/ExnInternal")

kk_std_core__exception kk_std_core__copy(kk_std_core__exception _this, kk_std_core_types__optional message0, kk_std_core_types__optional info0, kk_context_t* _ctx) { /* (exception, message : optional<string>, info : optional<exception-info>) -> exception */ 
  kk_string_t _x21113;
  if (kk_std_core_types__is_Optional(message0, _ctx)) {
    kk_box_t _box_x19246 = message0._cons.Optional.value;
    kk_string_t _message_1695 = kk_string_unbox(_box_x19246);
    kk_string_dup(_message_1695, _ctx);
    kk_std_core_types__optional_drop(message0, _ctx);
    _x21113 = _message_1695; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(message0, _ctx);
    {
      kk_string_t _x = _this.message;
      kk_string_dup(_x, _ctx);
      _x21113 = _x; /*string*/
    }
  }
  kk_std_core__exception_info _x21114;
  if (kk_std_core_types__is_Optional(info0, _ctx)) {
    kk_box_t _box_x19247 = info0._cons.Optional.value;
    kk_std_core__exception_info _info_1701 = kk_std_core__exception_info_unbox(_box_x19247, KK_BORROWED, _ctx);
    kk_std_core__exception_info_dup(_info_1701, _ctx);
    kk_std_core_types__optional_drop(info0, _ctx);
    kk_std_core__exception_drop(_this, _ctx);
    _x21114 = _info_1701; /*exception-info*/
  }
  else {
    kk_std_core_types__optional_drop(info0, _ctx);
    {
      kk_std_core__exception_info _x0 = _this.info;
      kk_std_core__exception_info_dup(_x0, _ctx);
      kk_std_core__exception_drop(_this, _ctx);
      _x21114 = _x0; /*exception-info*/
    }
  }
  return kk_std_core__new_Exception(_x21113, _x21114, _ctx);
}

kk_std_core__delayed kk_std_core__copy_1(kk_std_core__delayed _this, kk_std_core_types__optional dref0, kk_context_t* _ctx) { /* forall<e,a> (delayed<e,a>, dref : optional<ref<global,either<() -> e a,a>>>) -> delayed<e,a> */ 
  kk_ref_t _x21115;
  if (kk_std_core_types__is_Optional(dref0, _ctx)) {
    kk_box_t _box_x19248 = dref0._cons.Optional.value;
    kk_ref_t _dref_1734 = kk_ref_unbox(_box_x19248, _ctx);
    kk_ref_dup(_dref_1734, _ctx);
    kk_std_core_types__optional_drop(dref0, _ctx);
    kk_std_core__delayed_drop(_this, _ctx);
    _x21115 = _dref_1734; /*ref<global,either<() -> 1746 1747,1747>>*/
  }
  else {
    kk_std_core_types__optional_drop(dref0, _ctx);
    {
      kk_ref_t _x = _this.dref;
      _x21115 = _x; /*ref<global,either<() -> 1746 1747,1747>>*/
    }
  }
  return kk_std_core__new_Delay(_x21115, _ctx);
}

kk_std_core__sslice kk_std_core__copy_2(kk_std_core__sslice _this, kk_std_core_types__optional str0, kk_std_core_types__optional start0, kk_std_core_types__optional len0, kk_context_t* _ctx) { /* (sslice, str : optional<string>, start : optional<int>, len : optional<int>) -> sslice */ 
  kk_string_t _x21117;
  if (kk_std_core_types__is_Optional(str0, _ctx)) {
    kk_box_t _box_x19249 = str0._cons.Optional.value;
    kk_string_t _str_1833 = kk_string_unbox(_box_x19249);
    kk_string_dup(_str_1833, _ctx);
    kk_std_core_types__optional_drop(str0, _ctx);
    _x21117 = _str_1833; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(str0, _ctx);
    {
      kk_string_t _x = _this.str;
      kk_string_dup(_x, _ctx);
      _x21117 = _x; /*string*/
    }
  }
  kk_integer_t _x21118;
  if (kk_std_core_types__is_Optional(start0, _ctx)) {
    kk_box_t _box_x19250 = start0._cons.Optional.value;
    kk_integer_t _start_1839 = kk_integer_unbox(_box_x19250, _ctx);
    kk_integer_dup(_start_1839, _ctx);
    kk_std_core_types__optional_drop(start0, _ctx);
    _x21118 = _start_1839; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(start0, _ctx);
    {
      kk_integer_t _x0 = _this.start;
      kk_integer_dup(_x0, _ctx);
      _x21118 = _x0; /*int*/
    }
  }
  kk_integer_t _x21119;
  if (kk_std_core_types__is_Optional(len0, _ctx)) {
    kk_box_t _box_x19251 = len0._cons.Optional.value;
    kk_integer_t _len_1845 = kk_integer_unbox(_box_x19251, _ctx);
    kk_integer_dup(_len_1845, _ctx);
    kk_std_core_types__optional_drop(len0, _ctx);
    kk_std_core__sslice_drop(_this, _ctx);
    _x21119 = _len_1845; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(len0, _ctx);
    {
      kk_integer_t _x1 = _this.len;
      kk_integer_dup(_x1, _ctx);
      kk_std_core__sslice_drop(_this, _ctx);
      _x21119 = _x1; /*int*/
    }
  }
  return kk_std_core__new_Sslice(_x21117, _x21118, _x21119, _ctx);
}

kk_std_core__stream kk_std_core__copy_3(kk_std_core__stream _this, kk_std_core_types__optional head0, kk_std_core_types__optional tail0, kk_context_t* _ctx) { /* forall<a> (stream<a>, head : optional<a>, tail : optional<stream<a>>) -> stream<a> */ 
  kk_box_t _x21122;
  if (kk_std_core_types__is_Optional(head0, _ctx)) {
    kk_box_t _head_1891 = head0._cons.Optional.value;
    kk_box_dup(_head_1891, _ctx);
    kk_std_core_types__optional_drop(head0, _ctx);
    _x21122 = _head_1891; /*1908*/
  }
  else {
    kk_std_core_types__optional_drop(head0, _ctx);
    {
      struct kk_std_core_Next* _con21123 = kk_std_core__as_Next(_this, _ctx);
      kk_box_t _x = _con21123->head;
      kk_box_dup(_x, _ctx);
      _x21122 = _x; /*1908*/
    }
  }
  kk_std_core__stream _x21124;
  if (kk_std_core_types__is_Optional(tail0, _ctx)) {
    kk_box_t _box_x19252 = tail0._cons.Optional.value;
    kk_std_core__stream _tail_1898 = kk_std_core__stream_unbox(_box_x19252, KK_BORROWED, _ctx);
    kk_std_core__stream_dup(_tail_1898, _ctx);
    kk_std_core_types__optional_drop(tail0, _ctx);
    kk_std_core__stream_drop(_this, _ctx);
    _x21124 = _tail_1898; /*stream<1908>*/
  }
  else {
    kk_std_core_types__optional_drop(tail0, _ctx);
    {
      struct kk_std_core_Next* _con21125 = kk_std_core__as_Next(_this, _ctx);
      kk_box_t _pat01 = _con21125->head;
      kk_std_core__stream _x0 = _con21125->tail;
      if kk_likely(kk_datatype_ptr_is_unique(_this, _ctx)) {
        kk_box_drop(_pat01, _ctx);
        kk_datatype_ptr_free(_this, _ctx);
      }
      else {
        kk_std_core__stream_dup(_x0, _ctx);
        kk_datatype_ptr_decref(_this, _ctx);
      }
      _x21124 = _x0; /*stream<1908>*/
    }
  }
  return kk_std_core__new_Next(kk_reuse_null, 0, _x21122, _x21124, _ctx);
}
 
// runtime tag for the `:exn` effect

kk_std_core_hnd__htag kk_std_core__tag_exn;
 
// handler for the `:exn` effect

kk_box_t kk_std_core__handle_exn(int32_t cfc, kk_std_core__hnd_exn hnd, kk_function_t ret, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e,b> (cfc : int32, hnd : .hnd-exn<e,b>, ret : (res : a) -> e b, action : () -> <exn|e> a) -> e b */ 
  kk_std_core_hnd__htag _x21129 = kk_std_core_hnd__htag_dup(kk_std_core__tag_exn, _ctx); /*std/core/hnd/htag<.hnd-exn>*/
  return kk_std_core_hnd__hhandle(_x21129, cfc, kk_std_core__hnd_exn_box(hnd, _ctx), ret, action, _ctx);
}
 
// Unsafe: transform any type to a `null` type; used internally by the compiler.

kk_std_core__null kk_std_core__null_any(kk_box_t x, kk_context_t* _ctx) { /* forall<a> (x : a) -> null<a> */ 
  return (kk_box_is_null(x) ? kk_datatype_null() : kk_datatype_unbox(x));
}

kk_ref_t kk_std_core_redirect;
 
// Print a string to the console, including a final newline character.

kk_unit_t kk_std_core_xprintsln(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> console () */ 
  kk_println(s,kk_context()); return kk_Unit;
}

kk_integer_t kk_std_core_string_compare(kk_string_t x, kk_string_t y, kk_context_t* _ctx) { /* (x : string, y : string) -> int */ 
  return kk_string_cmp_int(x,y,kk_context());
}
 
// Convert an integer to an `:int32`. The number is _clamped_ to the maximal or minimum `:int32`
// value if it is outside the range of an `:int32`.

int32_t kk_std_core_int32(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int32 */ 
  return kk_integer_clamp32(i,kk_context());
}
 
// Convert an integer to an `:ssize_t`. The number is _clamped_ to the maximal or minimum `:ssize_t`
// value if it is outside the range of an `:ssize_t`.

kk_ssize_t kk_std_core_ssize__t(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> ssize_t */ 
  return kk_integer_clamp_ssize_t(i,kk_context());
}
 
// Convert a character to a string

kk_string_t kk_std_core_string(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> string */ 
  return kk_string_from_char(c,kk_context());
}
 
// Convert a vector of characters to a string.

kk_string_t kk_std_core_string_1(kk_vector_t _arg1, kk_context_t* _ctx) { /* (vector<char>) -> string */ 
  return kk_string_from_chars(_arg1,kk_context());
}
 
// Convert a list of characters to a string

kk_string_t kk_std_core_string_2(kk_std_core__list cs, kk_context_t* _ctx) { /* (cs : list<char>) -> total string */ 
  return kk_string_from_list(cs,kk_context());
}
 
// O(n). Copy the `slice` argument into a fresh string.
// Takes O(1) time if the slice covers the entire string.

kk_string_t kk_std_core_string_3(kk_std_core__sslice slice0, kk_context_t* _ctx) { /* (slice : sslice) -> string */ 
  return kk_slice_to_string(slice0,kk_context());
}
 
// Convert a vector to a list with an optional tail.

kk_std_core__list kk_std_core_vlist(kk_vector_t v, kk_std_core_types__optional tail0, kk_context_t* _ctx) { /* forall<a> (v : vector<a>, tail : optional<list<a>>) -> list<a> */ 
  kk_std_core__list _x21131;
  if (kk_std_core_types__is_Optional(tail0, _ctx)) {
    kk_box_t _box_x19266 = tail0._cons.Optional.value;
    kk_std_core__list _tail_2139 = kk_std_core__list_unbox(_box_x19266, KK_BORROWED, _ctx);
    kk_std_core__list_dup(_tail_2139, _ctx);
    kk_std_core_types__optional_drop(tail0, _ctx);
    _x21131 = _tail_2139; /*list<2149>*/
  }
  else {
    kk_std_core_types__optional_drop(tail0, _ctx);
    _x21131 = kk_std_core__new_Nil(_ctx); /*list<2149>*/
  }
  return kk_vector_to_list(v,_x21131,kk_context());
}

kk_string_t kk_std_core_int_show_hex(kk_integer_t i, bool use_capitals, kk_context_t* _ctx) { /* (i : int, use-capitals : bool) -> string */ 
  return kk_integer_to_hex_string(i,use_capitals,kk_context());
}

kk_string_t kk_std_core_repeatz(kk_string_t s, kk_ssize_t n, kk_context_t* _ctx) { /* (s : string, n : ssize_t) -> string */ 
  return kk_string_repeat(s,n,kk_context());
}

kk_string_t kk_std_core_show_expx(double d, int32_t prec, kk_context_t* _ctx) { /* (d : float64, prec : int32) -> string */ 
  return kk_double_show_exp(d,prec,kk_context());
}

kk_string_t kk_std_core_show_fixedx(double d, int32_t prec, kk_context_t* _ctx) { /* (d : float64, prec : int32) -> string */ 
  return kk_double_show_fixed(d,prec,kk_context());
}
 
// Print a string to the console

kk_unit_t kk_std_core_xprints(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> console () */ 
  kk_print(s,kk_context()); return kk_Unit;
}
 
// Raise an integer `i` to the power of `exp`.

kk_integer_t kk_std_core_pow(kk_integer_t i, kk_integer_t exp, kk_context_t* _ctx) { /* (i : int, exp : int) -> int */ 
  return kk_integer_pow(i,exp,kk_context());
}
 
// O(`count`). Advance the start position of a string slice by `count` characters
// up to the end of the string.
// A negative `count` advances the start position backwards upto the first position
// in a string.
// Maintains the character count of the original slice upto the end of the string.
// For example:
//
// * `"abc".first.advance(1).string == "b"`,
// * `"abc".first.advance(3).string == ""`,
// * `"abc".last.advance(-1).string == "b"`.
//

kk_std_core__sslice kk_std_core_advance(kk_std_core__sslice slice0, kk_integer_t count, kk_context_t* _ctx) { /* (slice : sslice, count : int) -> sslice */ 
  return kk_slice_advance_borrow(slice0,count,kk_context());
}

kk_unit_t kk_std_core_unsafe_assert_fail(kk_string_t msg, kk_context_t* _ctx) { /* (msg : string) -> () */ 
  kk_assert_fail(msg,kk_context()); return kk_Unit;
}
 
// O(`count`). Extend a string slice by `count` characters up to the end of the string.
// A negative `count` shrinks the slice up to the empty slice.
// For example:
//
// * `"abc".first.extend(1).string == "ab"`
// * `"abc".last.extend(-1).string == ""`
//

kk_std_core__sslice kk_std_core_extend(kk_std_core__sslice slice0, kk_integer_t count, kk_context_t* _ctx) { /* (slice : sslice, count : int) -> sslice */ 
  return kk_slice_extend_borrow(slice0,count,kk_context());
}

kk_std_core__sslice kk_std_core_first1(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> sslice */ 
  return kk_slice_first(s,kk_context());
}
 
// Convert a string to upper-case

kk_string_t kk_std_core_to_upper(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  return kk_string_to_upper(s,kk_context());
}

kk_integer_t kk_std_core_cdiv_exp10(kk_integer_t i, kk_integer_t n, kk_context_t* _ctx) { /* (i : int, n : int) -> int */ 
  return kk_integer_cdiv_pow10(i,n,kk_context());
}

kk_integer_t kk_std_core_mul_exp10(kk_integer_t i, kk_integer_t n, kk_context_t* _ctx) { /* (i : int, n : int) -> int */ 
  return kk_integer_mul_pow10(i,n,kk_context());
}
 
// Return the common prefix of two strings (upto `upto` characters (default is minimum length of the two strings))

kk_std_core__sslice kk_std_core_common_prefix(kk_string_t s, kk_string_t t, kk_std_core_types__optional upto, kk_context_t* _ctx) { /* (s : string, t : string, upto : optional<int>) -> sslice */ 
  kk_integer_t _brw_21012;
  if (kk_std_core_types__is_Optional(upto, _ctx)) {
    kk_box_t _box_x19267 = upto._cons.Optional.value;
    kk_integer_t _upto_2249 = kk_integer_unbox(_box_x19267, _ctx);
    _brw_21012 = kk_integer_dup(_upto_2249, _ctx); /*int*/
  }
  else {
    _brw_21012 = kk_integer_from_small(-1); /*int*/
  }
  kk_std_core__sslice _brw_21013 = kk_slice_common_prefix_borrow(s,t,_brw_21012,kk_context()); /*sslice*/;
  kk_integer_drop(_brw_21012, _ctx);
  return _brw_21013;
}
 
// lifted local: concat, concat-pre

kk_std_core__list kk_std_core__trmc_lift17311_concat(kk_std_core__list ys, kk_std_core__list zss, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, zss : list<list<a>>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con21132 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con21132->head;
    kk_std_core__list yy = _con21132->tail;
    kk_reuse_t _ru_21015 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_21015 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core__list _trmc_18360 = kk_datatype_null(); /*list<2297>*/;
    kk_std_core__list _trmc_18361 = kk_std_core__new_Cons(_ru_21015, 0, y, _trmc_18360, _ctx); /*list<2297>*/;
    kk_box_t* _b_19279_19273 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18361, _ctx)->tail)); /*field-addr<list<2297>>*/;
    { // tailcall
      kk_std_core_types__cctx _x21133 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18361, _ctx)),_b_19279_19273,true,kk_context()); /*ctx<0>*/
      ys = yy;
      _acc = _x21133;
      goto kk__tailcall;
    }
  }
  if (kk_std_core__is_Cons(zss, _ctx)) {
    struct kk_std_core_Cons* _con21134 = kk_std_core__as_Cons(zss, _ctx);
    kk_box_t _box_x19274 = _con21134->head;
    kk_std_core__list zzs = _con21134->tail;
    kk_std_core__list zs = kk_std_core__list_unbox(_box_x19274, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(zss, _ctx)) {
      kk_datatype_ptr_free(zss, _ctx);
    }
    else {
      kk_std_core__list_dup(zs, _ctx);
      kk_std_core__list_dup(zzs, _ctx);
      kk_datatype_ptr_decref(zss, _ctx);
    }
    { // tailcall
      ys = zs;
      zss = zzs;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x21135 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21135, KK_OWNED, _ctx);
  }
}
 
// lifted local: concat, concat-pre

kk_std_core__list kk_std_core__lift17311_concat(kk_std_core__list ys0, kk_std_core__list zss0, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, zss : list<list<a>>) -> list<a> */ 
  kk_std_core_types__cctx _x21136 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17311_concat(ys0, zss0, _x21136, _ctx);
}
extern kk_box_t kk_std_core_const_fun21137_1(kk_function_t _fself, kk_box_t ___wildcard__109__6, kk_context_t* _ctx) {
  struct kk_std_core_const_fun21137__t_1* _self = kk_function_as(struct kk_std_core_const_fun21137__t_1*, _fself, _ctx);
  kk_box_t default0 = _self->default0; /* 2325 */
  kk_drop_match(_self, {kk_box_dup(default0, _ctx);}, {}, _ctx)
  kk_box_drop(___wildcard__109__6, _ctx);
  return default0;
}
 
// If the slice is not empty,
// return the first character, and a new slice that is advanced by 1.

kk_std_core_types__maybe kk_std_core_next(kk_std_core__sslice slice0, kk_context_t* _ctx) { /* (slice : sslice) -> maybe<(char, sslice)> */ 
  return kk_slice_next(slice0,kk_context());
}
 
// Return the number of decimal digits of `i`. Return `0` when `i==0`.

kk_integer_t kk_std_core_count_digits(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int */ 
  return kk_integer_count_digits(i,kk_context());
}
 
// Transform an `:error` type to an `:either` value.

kk_std_core_types__either kk_std_core_either(kk_std_core__error t, kk_context_t* _ctx) { /* forall<a> (t : error<a>) -> either<exception,a> */ 
  if (kk_std_core__is_Error(t, _ctx)) {
    kk_std_core__exception exn0 = t._cons.Error.exception;
    kk_std_core__exception_dup(exn0, _ctx);
    kk_std_core__error_drop(t, _ctx);
    return kk_std_core_types__new_Left(kk_std_core__exception_box(exn0, _ctx), _ctx);
  }
  {
    kk_box_t x = t._cons.Ok.result;
    return kk_std_core_types__new_Right(x, _ctx);
  }
}
 
// An empty slice

kk_std_core__sslice kk_std_core_empty;

bool kk_std_core_xends_with(kk_string_t s, kk_string_t post, kk_context_t* _ctx) { /* (s : string, post : string) -> bool */ 
  return kk_string_ends_with(s,post,kk_context());
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18788_trmc_lift17312_flatmap(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core__list zz, kk_std_core__list ys1_17367, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e list<b>, zz : list<a>, ys1.17367 : list<b>) -> e list<b> */ 
  return kk_std_core__trmc_lift17312_flatmap(f, ys1_17367, zz, _acc, _ctx);
}
 
// lifted local: flatmap, flatmap-pre


// lift anonymous function
struct kk_std_core__trmc_lift17312_flatmap_fun21145__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list zz0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_lift17312_flatmap_fun21145(kk_function_t _fself, kk_box_t _b_19294, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_lift17312_flatmap_fun21145(kk_function_t f0, kk_std_core__list zz0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17312_flatmap_fun21145__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_lift17312_flatmap_fun21145__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_lift17312_flatmap_fun21145, kk_context());
  _self->f0 = f0;
  _self->zz0 = zz0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_lift17312_flatmap_fun21145(kk_function_t _fself, kk_box_t _b_19294, kk_context_t* _ctx) {
  struct kk_std_core__trmc_lift17312_flatmap_fun21145__t* _self = kk_function_as(struct kk_std_core__trmc_lift17312_flatmap_fun21145__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (2479) -> 2481 list<2480> */
  kk_std_core__list zz0 = _self->zz0; /* list<2479> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<2480>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(zz0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_std_core__list ys1_19306_173670 = kk_std_core__list_unbox(_b_19294, KK_OWNED, _ctx); /*list<2480>*/;
  kk_std_core__list _x21146 = kk_std_core__mlift18788_trmc_lift17312_flatmap(_acc0, f0, zz0, ys1_19306_173670, _ctx); /*list<2480>*/
  return kk_std_core__list_box(_x21146, _ctx);
}

kk_std_core__list kk_std_core__trmc_lift17312_flatmap(kk_function_t f0, kk_std_core__list ys, kk_std_core__list zs, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e list<b>, ys : list<b>, zs : list<a>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con21140 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con21140->head;
    kk_std_core__list yy = _con21140->tail;
    kk_reuse_t _ru_21017 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_21017 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core__list _trmc_18362 = kk_datatype_null(); /*list<2480>*/;
    kk_std_core__list _trmc_18363 = kk_std_core__new_Cons(_ru_21017, kk_field_index_of(struct kk_std_core_Cons, tail), y, _trmc_18362, _ctx); /*list<2480>*/;
    kk_box_t* _b_19299_19292 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18363, _ctx)->tail)); /*field-addr<list<2480>>*/;
    { // tailcall
      kk_std_core_types__cctx _x21141 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_18363, _ctx)),_b_19299_19292,false,kk_context()); /*ctx<0>*/
      ys = yy;
      _acc0 = _x21141;
      goto kk__tailcall;
    }
  }
  if (kk_std_core__is_Cons(zs, _ctx)) {
    struct kk_std_core_Cons* _con21142 = kk_std_core__as_Cons(zs, _ctx);
    kk_box_t z = _con21142->head;
    kk_std_core__list zz0 = _con21142->tail;
    if kk_likely(kk_datatype_ptr_is_unique(zs, _ctx)) {
      kk_datatype_ptr_free(zs, _ctx);
    }
    else {
      kk_box_dup(z, _ctx);
      kk_std_core__list_dup(zz0, _ctx);
      kk_datatype_ptr_decref(zs, _ctx);
    }
    kk_std_core__list x_18857;
    kk_function_t _x21143 = kk_function_dup(f0, _ctx); /*(2479) -> 2481 list<2480>*/
    x_18857 = kk_function_call(kk_std_core__list, (kk_function_t, kk_box_t, kk_context_t*), _x21143, (_x21143, z, _ctx), _ctx); /*list<2480>*/
    if (kk_yielding(kk_context())) {
      kk_std_core__list_drop(x_18857, _ctx);
      kk_box_t _x21144 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_lift17312_flatmap_fun21145(f0, zz0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x21144, KK_OWNED, _ctx);
    }
    { // tailcall
      ys = x_18857;
      zs = zz0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(f0, _ctx);
    kk_box_t _x21147 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21147, KK_OWNED, _ctx);
  }
}
 
// lifted local: flatmap, flatmap-pre

kk_std_core__list kk_std_core__lift17312_flatmap(kk_function_t f1, kk_std_core__list ys0, kk_std_core__list zs0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e list<b>, ys : list<b>, zs : list<a>) -> e list<b> */ 
  kk_std_core_types__cctx _x21148 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift17312_flatmap(f1, ys0, zs0, _x21148, _ctx);
}
 
// lifted local: reverse-append, reverse-acc

kk_std_core__list kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__list acc, kk_std_core__list ys, kk_context_t* _ctx) { /* forall<a> (acc : list<a>, ys : list<a>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con21149 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t x = _con21149->head;
    kk_std_core__list xx = _con21149->tail;
    kk_reuse_t _ru_21019 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_21019 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    { // tailcall
      kk_std_core__list _x21150 = kk_std_core__new_Cons(_ru_21019, 0, x, acc, _ctx); /*list<61>*/
      acc = _x21150;
      ys = xx;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18790_force_fun21154__t {
  struct kk_function_s _base;
  kk_ref_t r;
};
static kk_box_t kk_std_core__mlift18790_force_fun21154(kk_function_t _fself, kk_box_t x0, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18790_force_fun21154(kk_ref_t r, kk_context_t* _ctx) {
  struct kk_std_core__mlift18790_force_fun21154__t* _self = kk_function_alloc_as(struct kk_std_core__mlift18790_force_fun21154__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18790_force_fun21154, kk_context());
  _self->r = r;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18790_force_fun21154(kk_function_t _fself, kk_box_t x0, kk_context_t* _ctx) {
  struct kk_std_core__mlift18790_force_fun21154__t* _self = kk_function_as(struct kk_std_core__mlift18790_force_fun21154__t*, _fself, _ctx);
  kk_ref_t r = _self->r; /* ref<global,either<() -> 2616 2615,2615>> */
  kk_drop_match(_self, {kk_ref_dup(r, _ctx);}, {}, _ctx)
  kk_unit_t __ = kk_Unit;
  kk_unit_t _brw_21009 = kk_Unit;
  kk_box_t _x21155;
  kk_std_core_types__either _x21156;
  kk_box_t _x21157 = kk_box_dup(x0, _ctx); /*2615*/
  _x21156 = kk_std_core_types__new_Right(_x21157, _ctx); /*either<76,77>*/
  _x21155 = kk_std_core_types__either_box(_x21156, _ctx); /*176*/
  kk_ref_set_borrow(r,_x21155,kk_context());
  kk_ref_drop(r, _ctx);
  _brw_21009;
  return x0;
}

kk_box_t kk_std_core__mlift18790_force(kk_ref_t r, kk_function_t _y_18444, kk_context_t* _ctx) { /* forall<a,e> (r : ref<global,either<() -> e a,a>>, () -> <st<global>,div|e> a) -> <alloc<global>,div,read<global>,write<global>|e> a */ 
  kk_box_t x_18860 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), _y_18444, (_y_18444, _ctx), _ctx); /*2615*/;
  kk_function_t next0_18861 = kk_std_core__new_mlift18790_force_fun21154(r, _ctx); /*(2615) -> <st<global>,div|2616> 2615*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18860, _ctx);
    return kk_std_core_hnd_yield_extend(next0_18861, _ctx);
  }
  {
    return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), next0_18861, (next0_18861, x_18860, _ctx), _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18791_force_fun21158__t {
  struct kk_function_s _base;
  kk_ref_t r;
};
static kk_box_t kk_std_core__mlift18791_force_fun21158(kk_function_t _fself, kk_box_t _b_19319, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18791_force_fun21158(kk_ref_t r, kk_context_t* _ctx) {
  struct kk_std_core__mlift18791_force_fun21158__t* _self = kk_function_alloc_as(struct kk_std_core__mlift18791_force_fun21158__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18791_force_fun21158, kk_context());
  _self->r = r;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18791_force_fun21158(kk_function_t _fself, kk_box_t _b_19319, kk_context_t* _ctx) {
  struct kk_std_core__mlift18791_force_fun21158__t* _self = kk_function_as(struct kk_std_core__mlift18791_force_fun21158__t*, _fself, _ctx);
  kk_ref_t r = _self->r; /* ref<global,either<() -> 2616 2615,2615>> */
  kk_drop_match(_self, {kk_ref_dup(r, _ctx);}, {}, _ctx)
  kk_function_t _x21159 = kk_function_unbox(_b_19319, _ctx); /*() -> <st<global>,div|2616> 19320*/
  return kk_std_core__mlift18790_force(r, _x21159, _ctx);
}

kk_box_t kk_std_core__mlift18791_force(kk_ref_t r, kk_std_core_types__either _y_18442, kk_context_t* _ctx) { /* forall<a,e> (r : ref<global,either<() -> e a,a>>, either<() -> e a,a>) -> <read<global>,div,alloc<global>,write<global>|e> a */ 
  if (kk_std_core_types__is_Right(_y_18442, _ctx)) {
    kk_box_t x = _y_18442._cons.Right.right;
    kk_ref_drop(r, _ctx);
    return x;
  }
  {
    kk_box_t _fun_unbox_x19316 = _y_18442._cons.Left.left;
    if (kk_yielding(kk_context())) {
      kk_box_drop(_fun_unbox_x19316, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18791_force_fun21158(r, _ctx), _ctx);
    }
    {
      kk_function_t _x21160 = kk_function_unbox(_fun_unbox_x19316, _ctx); /*() -> 2616 19317*/
      return kk_std_core__mlift18790_force(r, _x21160, _ctx);
    }
  }
}
 
// Force a delayed value; the value is computed only on the first
// call to `force` and cached afterwards.


// lift anonymous function
struct kk_std_core_force_fun21163__t {
  struct kk_function_s _base;
  kk_std_core__delayed delayed;
};
static kk_box_t kk_std_core_force_fun21163(kk_function_t _fself, kk_box_t _b_19326, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_force_fun21163(kk_std_core__delayed delayed, kk_context_t* _ctx) {
  struct kk_std_core_force_fun21163__t* _self = kk_function_alloc_as(struct kk_std_core_force_fun21163__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_force_fun21163, kk_context());
  _self->delayed = delayed;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_force_fun21163(kk_function_t _fself, kk_box_t _b_19326, kk_context_t* _ctx) {
  struct kk_std_core_force_fun21163__t* _self = kk_function_as(struct kk_std_core_force_fun21163__t*, _fself, _ctx);
  kk_std_core__delayed delayed = _self->delayed; /* delayed<2616,2615> */
  kk_drop_match(_self, {kk_std_core__delayed_dup(delayed, _ctx);}, {}, _ctx)
  kk_std_core_types__either _y_19328_18442 = kk_std_core_types__either_unbox(_b_19326, KK_OWNED, _ctx); /*either<() -> 2616 2615,2615>*/;
  kk_ref_t _x21164;
  {
    kk_ref_t _x0 = delayed.dref;
    _x21164 = _x0; /*ref<global,either<() -> 2616 2615,2615>>*/
  }
  return kk_std_core__mlift18791_force(_x21164, _y_19328_18442, _ctx);
}

kk_box_t kk_std_core_force(kk_std_core__delayed delayed, kk_context_t* _ctx) { /* forall<a,e> (delayed : delayed<e,a>) -> e a */ 
  kk_std_core_types__either x_18867;
  kk_box_t _x21161;
  kk_ref_t _x21162;
  {
    kk_ref_t _x = delayed.dref;
    kk_ref_dup(_x, _ctx);
    _x21162 = _x; /*ref<global,either<() -> 2616 2615,2615>>*/
  }
  _x21161 = kk_ref_get(_x21162,kk_context()); /*190*/
  x_18867 = kk_std_core_types__either_unbox(_x21161, KK_OWNED, _ctx); /*either<() -> 2616 2615,2615>*/
  if (kk_yielding(kk_context())) {
    kk_std_core_types__either_drop(x_18867, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_new_force_fun21163(delayed, _ctx), _ctx);
  }
  {
    kk_std_core_types__either _y_19329_18442 = x_18867; /*either<() -> 2616 2615,2615>*/;
    kk_ref_t _x21165;
    {
      kk_ref_t _x0 = delayed.dref;
      _x21165 = _x0; /*ref<global,either<() -> 2616 2615,2615>>*/
    }
    return kk_std_core__mlift18791_force(_x21165, _y_19329_18442, _ctx);
  }
}
 
// Generic show: shows the internal representation of an object as a string
// Note: this breaks parametricity so it should not be pub

kk_string_t kk_std_core_gshow(kk_box_t _arg1, kk_context_t* _ctx) { /* forall<a> (a) -> string */ 
  return kk_show_any(_arg1,kk_context());
}
 
// Return the host environment: `dotnet`, `browser`, `webworker`, `node`, or `libc`.

kk_string_t kk_std_core_host(kk_context_t* _ctx) { /* () -> ndet string */ 
  return kk_get_host(kk_context());
}
 
// clamp an `:int` to fit in an `:int64_t`.

int64_t kk_std_core_int64(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int64 */ 
  return kk_integer_clamp64(i,kk_context());
}
 
// clamp an `:int` to fit in an `:int16`.

int16_t kk_std_core_int16(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int16 */ 
  return kk_integer_clamp_int16(i,kk_context());
}
 
// clamp an `:int` to fit in an `:int8`.

int8_t kk_std_core_int8(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int8 */ 
  return kk_integer_clamp_int8(i,kk_context());
}
 
// lifted local: intersperse, before

kk_std_core__list kk_std_core__trmc_unroll17328_lift17314_intersperse(kk_box_t sep, kk_std_core__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (sep : a, ys : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con21166 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con21166->head;
    kk_std_core__list yy = _con21166->tail;
    kk_reuse_t _ru_21020 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_21020 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_std_core__list _trmc_18364;
    kk_std_core__list _x21167 = kk_datatype_null(); /*list<2702>*/
    _trmc_18364 = kk_std_core__new_Cons(_ru_21020, 0, y, _x21167, _ctx); /*list<2702>*/
    kk_box_t* _b_19340_19335 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18364, _ctx)->tail)); /*field-addr<list<2702>>*/;
    { // tailcall
      kk_box_t _x21168 = kk_box_dup(sep, _ctx); /*2702*/
      kk_std_core_types__cctx _x21169;
      kk_box_t _x21170;
      kk_std_core__list _x21171 = kk_std_core__new_Cons(kk_reuse_null, 0, sep, _trmc_18364, _ctx); /*list<61>*/
      _x21170 = kk_std_core__list_box(_x21171, _ctx); /*0*/
      _x21169 = kk_cctx_extend(_acc,_x21170,_b_19340_19335,true,kk_context()); /*ctx<0>*/
      sep = _x21168;
      ys = yy;
      _acc = _x21169;
      goto kk__tailcall;
    }
  }
  {
    kk_box_drop(sep, _ctx);
    kk_box_t _x21172 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21172, KK_OWNED, _ctx);
  }
}
 
// lifted local: intersperse, before

kk_std_core__list kk_std_core__unroll17328_lift17314_intersperse(kk_box_t sep0, kk_std_core__list ys0, kk_context_t* _ctx) { /* forall<a> (sep : a, ys : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x21173 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17328_lift17314_intersperse(sep0, ys0, _x21173, _ctx);
}
 
// Insert a separator `sep`  between all elements of a list `xs` .

kk_std_core__list kk_std_core_intersperse(kk_std_core__list xs, kk_box_t sep, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, sep : a) -> list<a> */ 
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21174 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21174->head;
    kk_std_core__list xx = _con21174->tail;
    kk_reuse_t _ru_21021 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_21021 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core__list _x21175;
    if (kk_std_core__is_Nil(xx, _ctx)) {
      kk_box_drop(sep, _ctx);
      _x21175 = kk_std_core__new_Nil(_ctx); /*forall<a> list<a>*/
    }
    else {
      _x21175 = kk_std_core__unroll17328_lift17314_intersperse(sep, xx, _ctx); /*forall<a> list<a>*/
    }
    return kk_std_core__new_Cons(_ru_21021, 0, x, _x21175, _ctx);
  }
  {
    kk_box_drop(sep, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
}
 
// clamp an `:int` to fit in an `:intptr_t`.

intptr_t kk_std_core_intptr__t(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> intptr_t */ 
  return kk_integer_clamp_intptr_t(i,kk_context());
}
 
// An invalid slice

kk_std_core__sslice kk_std_core_invalid;
 
// Return the number of ending `0` digits of `i`. Return `0` when `i==0`.

kk_integer_t kk_std_core_is_exp10(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int */ 
  return kk_integer_ctz(i,kk_context());
}

kk_std_core__sslice kk_std_core_last1(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> sslice */ 
  return kk_slice_last(s,kk_context());
}
 
// Used by the compiler to wrap main console applications

kk_box_t kk_std_core_main_console(kk_function_t main, kk_context_t* _ctx) { /* forall<a,e> (main : () -> e a) -> e a */ 
  return kk_main_console(main,kk_context());
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18792_trmc_unroll17329_lift17315_map_peek(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core__list yy, kk_box_t _trmc_18366, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (value : a, rest : list<a>) -> e b, yy : list<a>, b) -> e list<b> */ 
  kk_std_core__list _trmc_18367 = kk_datatype_null(); /*list<2798>*/;
  kk_std_core__list _trmc_18368 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_18366, _trmc_18367, _ctx); /*list<2798>*/;
  kk_box_t* _b_19354_19351 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18368, _ctx)->tail)); /*field-addr<list<2798>>*/;
  kk_std_core_types__cctx _x21178 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18368, _ctx)),_b_19354_19351,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17329_lift17315_map_peek(f, yy, _x21178, _ctx);
}
 
// lifted local: map-peek, mappeek


// lift anonymous function
struct kk_std_core__trmc_unroll17329_lift17315_map_peek_fun21183__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list yy0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17329_lift17315_map_peek_fun21183(kk_function_t _fself, kk_box_t _b_19359, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17329_lift17315_map_peek_fun21183(kk_function_t f0, kk_std_core__list yy0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17329_lift17315_map_peek_fun21183__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17329_lift17315_map_peek_fun21183__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17329_lift17315_map_peek_fun21183, kk_context());
  _self->f0 = f0;
  _self->yy0 = yy0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17329_lift17315_map_peek_fun21183(kk_function_t _fself, kk_box_t _b_19359, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17329_lift17315_map_peek_fun21183__t* _self = kk_function_as(struct kk_std_core__trmc_unroll17329_lift17315_map_peek_fun21183__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (value : 2797, rest : list<2797>) -> 2799 2798 */
  kk_std_core__list yy0 = _self->yy0; /* list<2797> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<2798>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(yy0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_19377_183660 = _b_19359; /*2798*/;
  kk_std_core__list _x21184 = kk_std_core__mlift18792_trmc_unroll17329_lift17315_map_peek(_acc0, f0, yy0, _trmc_19377_183660, _ctx); /*list<2798>*/
  return kk_std_core__list_box(_x21184, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17329_lift17315_map_peek(kk_function_t f0, kk_std_core__list ys, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (value : a, rest : list<a>) -> e b, ys : list<a>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con21179 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con21179->head;
    kk_std_core__list yy0 = _con21179->tail;
    kk_reuse_t _ru_21022 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_21022 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_box_t x_18869;
    kk_function_t _x21181 = kk_function_dup(f0, _ctx); /*(value : 2797, rest : list<2797>) -> 2799 2798*/
    kk_std_core__list _x21180 = kk_std_core__list_dup(yy0, _ctx); /*list<2797>*/
    x_18869 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_std_core__list, kk_context_t*), _x21181, (_x21181, y, _x21180, _ctx), _ctx); /*2798*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_21022,kk_context());
      kk_box_drop(x_18869, _ctx);
      kk_box_t _x21182 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17329_lift17315_map_peek_fun21183(f0, yy0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x21182, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_183670 = kk_datatype_null(); /*list<2798>*/;
      kk_std_core__list _trmc_183680 = kk_std_core__new_Cons(_ru_21022, kk_field_index_of(struct kk_std_core_Cons, tail), x_18869, _trmc_183670, _ctx); /*list<2798>*/;
      kk_box_t* _b_19371_19365 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_183680, _ctx)->tail)); /*field-addr<list<2798>>*/;
      { // tailcall
        kk_std_core_types__cctx _x21185 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_183680, _ctx)),_b_19371_19365,false,kk_context()); /*ctx<0>*/
        ys = yy0;
        _acc0 = _x21185;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(f0, _ctx);
    kk_box_t _x21186 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21186, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-peek, mappeek

kk_std_core__list kk_std_core__unroll17329_lift17315_map_peek(kk_function_t f1, kk_std_core__list ys0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (value : a, rest : list<a>) -> e b, ys : list<a>) -> e list<b> */ 
  kk_std_core_types__cctx _x21187 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17329_lift17315_map_peek(f1, ys0, _x21187, _ctx);
}

kk_ref_t kk_std_core_trace_enabled;
 
// Compose two funs `f` and `g`.


// lift anonymous function
struct kk_std_core_o_fun21188__t {
  struct kk_function_s _base;
  kk_function_t f;
  kk_function_t g;
};
static kk_box_t kk_std_core_o_fun21188(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_o_fun21188(kk_function_t f, kk_function_t g, kk_context_t* _ctx) {
  struct kk_std_core_o_fun21188__t* _self = kk_function_alloc_as(struct kk_std_core_o_fun21188__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_o_fun21188, kk_context());
  _self->f = f;
  _self->g = g;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_o_fun21188(kk_function_t _fself, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_o_fun21188__t* _self = kk_function_as(struct kk_std_core_o_fun21188__t*, _fself, _ctx);
  kk_function_t f = _self->f; /* (2840) -> 2837 2838 */
  kk_function_t g = _self->g; /* (2836) -> 2837 2840 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_function_dup(g, _ctx);}, {}, _ctx)
  kk_box_t x0_18872 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), g, (g, x, _ctx), _ctx); /*2840*/;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x0_18872, _ctx);
    return kk_std_core_hnd_yield_extend(f, _ctx);
  }
  {
    return kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x0_18872, _ctx), _ctx);
  }
}

kk_function_t kk_std_core_o(kk_function_t f, kk_function_t g, kk_context_t* _ctx) { /* forall<a,b,c,e> (f : (a) -> e b, g : (c) -> e a) -> ((x : c) -> e b) */ 
  return kk_std_core_new_o_fun21188(f, g, _ctx);
}
 
// monadic lift

kk_box_t kk_std_core__mlift18793_once(kk_function_t calc, kk_ref_t r, kk_std_core_types__maybe _y_18459, kk_context_t* _ctx) { /* forall<_h,_e,a> (calc : () -> a, r : ref<_h,maybe<a>>, maybe<a>) -> <read<_h>,write<_h>,div|_e> a */ 
  if (kk_std_core_types__is_Just(_y_18459, _ctx)) {
    kk_box_t x = _y_18459._cons.Just.value;
    kk_ref_drop(r, _ctx);
    kk_function_drop(calc, _ctx);
    return x;
  }
  {
    kk_box_t x0 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), calc, (calc, _ctx), _ctx); /*2961*/;
    kk_unit_t __ = kk_Unit;
    kk_unit_t _brw_21003 = kk_Unit;
    kk_box_t _x21190;
    kk_std_core_types__maybe _x21191;
    kk_box_t _x21192 = kk_box_dup(x0, _ctx); /*2961*/
    _x21191 = kk_std_core_types__new_Just(_x21192, _ctx); /*maybe<111>*/
    _x21190 = kk_std_core_types__maybe_box(_x21191, _ctx); /*176*/
    kk_ref_set_borrow(r,_x21190,kk_context());
    kk_ref_drop(r, _ctx);
    _brw_21003;
    return x0;
  }
}
 
// Given a total function to calculate a value `:a`, return
// a total function that only calculates the value once and then
// returns the cached result.


// lift anonymous function
struct kk_std_core_once_fun21193__t {
  struct kk_function_s _base;
  kk_function_t calc;
  kk_ref_t r;
};
static kk_box_t kk_std_core_once_fun21193(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_once_fun21193(kk_function_t calc, kk_ref_t r, kk_context_t* _ctx) {
  struct kk_std_core_once_fun21193__t* _self = kk_function_alloc_as(struct kk_std_core_once_fun21193__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_once_fun21193, kk_context());
  _self->calc = calc;
  _self->r = r;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_once_fun21196__t {
  struct kk_function_s _base;
  kk_function_t calc;
  kk_ref_t r;
};
static kk_box_t kk_std_core_once_fun21196(kk_function_t _fself, kk_std_core_types__maybe _y_18459, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_once_fun21196(kk_function_t calc, kk_ref_t r, kk_context_t* _ctx) {
  struct kk_std_core_once_fun21196__t* _self = kk_function_alloc_as(struct kk_std_core_once_fun21196__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_once_fun21196, kk_context());
  _self->calc = calc;
  _self->r = r;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_once_fun21196(kk_function_t _fself, kk_std_core_types__maybe _y_18459, kk_context_t* _ctx) {
  struct kk_std_core_once_fun21196__t* _self = kk_function_as(struct kk_std_core_once_fun21196__t*, _fself, _ctx);
  kk_function_t calc = _self->calc; /* () -> 2961 */
  kk_ref_t r = _self->r; /* ref<_2870,maybe<2961>> */
  kk_drop_match(_self, {kk_function_dup(calc, _ctx);kk_ref_dup(r, _ctx);}, {}, _ctx)
  if (kk_std_core_types__is_Just(_y_18459, _ctx)) {
    kk_box_t x0 = _y_18459._cons.Just.value;
    kk_ref_drop(r, _ctx);
    kk_function_drop(calc, _ctx);
    return x0;
  }
  {
    kk_box_t x00 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), calc, (calc, _ctx), _ctx); /*2961*/;
    kk_unit_t __ = kk_Unit;
    kk_unit_t _brw_21002 = kk_Unit;
    kk_box_t _x21197;
    kk_std_core_types__maybe _x21198;
    kk_box_t _x21199 = kk_box_dup(x00, _ctx); /*2961*/
    _x21198 = kk_std_core_types__new_Just(_x21199, _ctx); /*maybe<111>*/
    _x21197 = kk_std_core_types__maybe_box(_x21198, _ctx); /*176*/
    kk_ref_set_borrow(r,_x21197,kk_context());
    kk_ref_drop(r, _ctx);
    _brw_21002;
    return x00;
  }
}


// lift anonymous function
struct kk_std_core_once_fun21200__t {
  struct kk_function_s _base;
  kk_function_t next0_18877;
};
static kk_box_t kk_std_core_once_fun21200(kk_function_t _fself, kk_box_t _b_19394, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_once_fun21200(kk_function_t next0_18877, kk_context_t* _ctx) {
  struct kk_std_core_once_fun21200__t* _self = kk_function_alloc_as(struct kk_std_core_once_fun21200__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_once_fun21200, kk_context());
  _self->next0_18877 = next0_18877;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_once_fun21200(kk_function_t _fself, kk_box_t _b_19394, kk_context_t* _ctx) {
  struct kk_std_core_once_fun21200__t* _self = kk_function_as(struct kk_std_core_once_fun21200__t*, _fself, _ctx);
  kk_function_t next0_18877 = _self->next0_18877; /* (maybe<2961>) -> <read<_2870>,write<_2870>,div|_2953> 2961 */
  kk_drop_match(_self, {kk_function_dup(next0_18877, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _x21201 = kk_std_core_types__maybe_unbox(_b_19394, KK_OWNED, _ctx); /*maybe<2961>*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__maybe, kk_context_t*), next0_18877, (next0_18877, _x21201, _ctx), _ctx);
}
static kk_box_t kk_std_core_once_fun21193(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_once_fun21193__t* _self = kk_function_as(struct kk_std_core_once_fun21193__t*, _fself, _ctx);
  kk_function_t calc = _self->calc; /* () -> 2961 */
  kk_ref_t r = _self->r; /* ref<_2870,maybe<2961>> */
  kk_drop_match(_self, {kk_function_dup(calc, _ctx);kk_ref_dup(r, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe x_18876;
  kk_box_t _x21194;
  kk_ref_t _x21195 = kk_ref_dup(r, _ctx); /*ref<_2870,maybe<2961>>*/
  _x21194 = kk_ref_get(_x21195,kk_context()); /*190*/
  x_18876 = kk_std_core_types__maybe_unbox(_x21194, KK_OWNED, _ctx); /*maybe<2961>*/
  kk_function_t next0_18877 = kk_std_core_new_once_fun21196(calc, r, _ctx); /*(maybe<2961>) -> <read<_2870>,write<_2870>,div|_2953> 2961*/;
  if (kk_yielding(kk_context())) {
    kk_std_core_types__maybe_drop(x_18876, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_new_once_fun21200(next0_18877, _ctx), _ctx);
  }
  {
    return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_types__maybe, kk_context_t*), next0_18877, (next0_18877, x_18876, _ctx), _ctx);
  }
}

kk_function_t kk_std_core_once(kk_function_t calc, kk_context_t* _ctx) { /* forall<a> (calc : () -> a) -> (() -> a) */ 
  kk_ref_t r = kk_ref_alloc((kk_std_core_types__maybe_box(kk_std_core_types__new_Nothing(_ctx), _ctx)),kk_context()); /*ref<_2870,maybe<2961>>*/;
  return kk_std_core_new_once_fun21193(calc, r, _ctx);
}

kk_std_core_types__maybe kk_std_core_xparse_int(kk_string_t s, bool hex, kk_context_t* _ctx) { /* (s : string, hex : bool) -> maybe<int> */ 
  return kk_integer_xparse(s,hex,kk_context());
}
 
// Internal: used for value effects
// TODO: revisit value effects codegen

kk_box_t kk_std_core_phantom(kk_context_t* _ctx) { /* forall<a> () -> a */ 
  return kk_box_null();
}
 
// Convert a string to lower-case

kk_string_t kk_std_core_to_lower(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  return kk_string_to_lower(s,kk_context());
}

kk_unit_t kk_std_core_xtrace(kk_string_t message0, kk_context_t* _ctx) { /* (message : string) -> () */ 
  kk_trace(message0,kk_context()); return kk_Unit;
}

kk_unit_t kk_std_core_xtrace_any(kk_string_t message0, kk_box_t x, kk_context_t* _ctx) { /* forall<a> (message : string, x : a) -> () */ 
  kk_trace_any(message0,x,kk_context()); return kk_Unit;
}
 
// clamp an `:int` to fit in an `:int8` but interpret the `:int` as an unsigned 8-bit value,
// and clamp between 0 and 255.

int8_t kk_std_core_uint8(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> int8 */ 
  return kk_integer_clamp_byte(i,kk_context());
}

kk_ref_t kk_std_core_unique_count;

kk_vector_t kk_std_core_unvlist(kk_std_core__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> vector<a> */ 
  return kk_list_to_vector(xs,kk_context());
}
 
// Create a new vector of length `n`  with initial elements given by function `f` .

kk_vector_t kk_std_core_vector_initz(kk_ssize_t n, kk_function_t f, kk_context_t* _ctx) { /* forall<a> (n : ssize_t, f : (ssize_t) -> a) -> vector<a> */ 
  return kk_vector_init(n,f,kk_context());
}

bool kk_std_core__lp__excl__eq__4_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_20999;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_20999 = kk_integer_from_small(-1); /*int*/
    goto _match21202;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_20999 = kk_integer_from_small(0); /*int*/
    goto _match21202;
  }
  {
    _brw_20999 = kk_integer_from_small(1); /*int*/
  }
  _match21202: ;
  kk_integer_t _brw_20998;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_20998 = kk_integer_from_small(-1); /*int*/
    goto _match21203;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_20998 = kk_integer_from_small(0); /*int*/
    goto _match21203;
  }
  {
    _brw_20998 = kk_integer_from_small(1); /*int*/
  }
  _match21203: ;
  bool _brw_21000 = kk_integer_neq_borrow(_brw_20999,_brw_20998,kk_context()); /*bool*/;
  kk_integer_drop(_brw_20999, _ctx);
  kk_integer_drop(_brw_20998, _ctx);
  return _brw_21000;
}
 
// Append two lists.

kk_std_core__list kk_std_core__trmc_unroll17330_append(kk_std_core__list xs, kk_std_core__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21205 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21205->head;
    kk_std_core__list xx = _con21205->tail;
    kk_reuse_t _ru_21023 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_21023 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core__list _trmc_18369 = kk_datatype_null(); /*list<3252>*/;
    kk_std_core__list _trmc_18370 = kk_std_core__new_Cons(_ru_21023, 0, x, _trmc_18369, _ctx); /*list<3252>*/;
    kk_box_t* _b_19408_19403 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18370, _ctx)->tail)); /*field-addr<list<3252>>*/;
    { // tailcall
      kk_std_core_types__cctx _x21206 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18370, _ctx)),_b_19408_19403,true,kk_context()); /*ctx<0>*/
      xs = xx;
      _acc = _x21206;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x21207 = kk_cctx_apply(_acc,(kk_std_core__list_box(ys, _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21207, KK_OWNED, _ctx);
  }
}
 
// Append two lists.

kk_std_core__list kk_std_core__unroll17330_append(kk_std_core__list xs0, kk_std_core__list ys0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ys : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x21208 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17330_append(xs0, ys0, _x21208, _ctx);
}
 
// Append two strings.

kk_string_t kk_std_core__lp__plus__plus__1_rp_(kk_string_t x, kk_string_t y, kk_context_t* _ctx) { /* (x : string, y : string) -> string */ 
  return kk_string_cat(x,y,kk_context());
}

kk_unit_t kk_std_core_printsln(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> console () */ 
  kk_std_core_types__maybe _match_20997;
  kk_box_t _x21210;
  kk_ref_t _x21211 = kk_ref_dup(kk_std_core_redirect, _ctx); /*ref<global,maybe<(string) -> console ()>>*/
  _x21210 = kk_ref_get(_x21211,kk_context()); /*190*/
  _match_20997 = kk_std_core_types__maybe_unbox(_x21210, KK_OWNED, _ctx); /*maybe<(string) -> console ()>*/
  if (kk_std_core_types__is_Nothing(_match_20997, _ctx)) {
    kk_std_core_xprintsln(s, _ctx); return kk_Unit;
  }
  {
    kk_box_t _fun_unbox_x19418 = _match_20997._cons.Just.value;
    kk_string_t _b_19421;
    kk_string_t _x21212;
    kk_define_string_literal(, _s21213, 1, "\n", _ctx)
    _x21212 = kk_string_dup(_s21213, _ctx); /*string*/
    _b_19421 = kk_std_core__lp__plus__plus__1_rp_(s, _x21212, _ctx); /*string*/
    kk_box_t _x21214;
    kk_function_t _x21215 = kk_function_unbox(_fun_unbox_x19418, _ctx); /*(19419) -> console 19420*/
    _x21214 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21215, (_x21215, kk_string_box(_b_19421), _ctx), _ctx); /*19420*/
    kk_unit_unbox(_x21214); return kk_Unit;
  }
}

bool kk_std_core__lp__eq__eq__4_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_20995;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_20995 = kk_integer_from_small(-1); /*int*/
    goto _match21216;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_20995 = kk_integer_from_small(0); /*int*/
    goto _match21216;
  }
  {
    _brw_20995 = kk_integer_from_small(1); /*int*/
  }
  _match21216: ;
  kk_integer_t _brw_20994;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_20994 = kk_integer_from_small(-1); /*int*/
    goto _match21217;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_20994 = kk_integer_from_small(0); /*int*/
    goto _match21217;
  }
  {
    _brw_20994 = kk_integer_from_small(1); /*int*/
  }
  _match21217: ;
  bool _brw_20996 = kk_integer_eq_borrow(_brw_20995,_brw_20994,kk_context()); /*bool*/;
  kk_integer_drop(_brw_20995, _ctx);
  kk_integer_drop(_brw_20994, _ctx);
  return _brw_20996;
}

bool kk_std_core__lp__lt__5_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_20992;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_20992 = kk_integer_from_small(-1); /*int*/
    goto _match21218;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_20992 = kk_integer_from_small(0); /*int*/
    goto _match21218;
  }
  {
    _brw_20992 = kk_integer_from_small(1); /*int*/
  }
  _match21218: ;
  kk_integer_t _brw_20991;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_20991 = kk_integer_from_small(-1); /*int*/
    goto _match21219;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_20991 = kk_integer_from_small(0); /*int*/
    goto _match21219;
  }
  {
    _brw_20991 = kk_integer_from_small(1); /*int*/
  }
  _match21219: ;
  bool _brw_20993 = kk_integer_lt_borrow(_brw_20992,_brw_20991,kk_context()); /*bool*/;
  kk_integer_drop(_brw_20992, _ctx);
  kk_integer_drop(_brw_20991, _ctx);
  return _brw_20993;
}

kk_std_core_types__order kk_std_core_order(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> order */ 
  bool _match_20988 = kk_integer_lt_borrow(i,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_20988) {
    kk_integer_drop(i, _ctx);
    return kk_std_core_types__new_Lt(_ctx);
  }
  {
    bool _match_20989;
    bool _brw_20990 = kk_integer_gt_borrow(i,(kk_integer_from_small(0)),kk_context()); /*bool*/;
    kk_integer_drop(i, _ctx);
    _match_20989 = _brw_20990; /*bool*/
    if (_match_20989) {
      return kk_std_core_types__new_Gt(_ctx);
    }
    {
      return kk_std_core_types__new_Eq(_ctx);
    }
  }
}
 
// Compare two strings.
// Uses the character codes directly for comparison

kk_std_core_types__order kk_std_core_compare_3(kk_string_t x, kk_string_t y, kk_context_t* _ctx) { /* (x : string, y : string) -> order */ 
  kk_integer_t i_17396 = kk_std_core_string_compare(x, y, _ctx); /*int*/;
  bool _match_20985 = kk_integer_lt_borrow(i_17396,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_20985) {
    kk_integer_drop(i_17396, _ctx);
    return kk_std_core_types__new_Lt(_ctx);
  }
  {
    bool _match_20986;
    bool _brw_20987 = kk_integer_gt_borrow(i_17396,(kk_integer_from_small(0)),kk_context()); /*bool*/;
    kk_integer_drop(i_17396, _ctx);
    _match_20986 = _brw_20987; /*bool*/
    if (_match_20986) {
      return kk_std_core_types__new_Gt(_ctx);
    }
    {
      return kk_std_core_types__new_Eq(_ctx);
    }
  }
}

bool kk_std_core__lp__gt__3_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_20981;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_20981 = kk_integer_from_small(-1); /*int*/
    goto _match21221;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_20981 = kk_integer_from_small(0); /*int*/
    goto _match21221;
  }
  {
    _brw_20981 = kk_integer_from_small(1); /*int*/
  }
  _match21221: ;
  kk_integer_t _brw_20980;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_20980 = kk_integer_from_small(-1); /*int*/
    goto _match21222;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_20980 = kk_integer_from_small(0); /*int*/
    goto _match21222;
  }
  {
    _brw_20980 = kk_integer_from_small(1); /*int*/
  }
  _match21222: ;
  bool _brw_20982 = kk_integer_gt_borrow(_brw_20981,_brw_20980,kk_context()); /*bool*/;
  kk_integer_drop(_brw_20981, _ctx);
  kk_integer_drop(_brw_20980, _ctx);
  return _brw_20982;
}

kk_std_core_types__order kk_std_core_compare_2(bool x, bool y, kk_context_t* _ctx) { /* (x : bool, y : bool) -> order */ 
  if (x) {
    if (x) {
      if (y) {
        return kk_std_core_types__new_Eq(_ctx);
      }
      {
        return kk_std_core_types__new_Gt(_ctx);
      }
    }
    {
      return kk_std_core_types__new_Eq(_ctx);
    }
  }
  if (y) {
    return kk_std_core_types__new_Lt(_ctx);
  }
  if (x) {
    if (y) {
      return kk_std_core_types__new_Eq(_ctx);
    }
    {
      return kk_std_core_types__new_Gt(_ctx);
    }
  }
  {
    return kk_std_core_types__new_Eq(_ctx);
  }
}

bool kk_std_core__lp__gt__eq__4_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_20974;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_20974 = kk_integer_from_small(-1); /*int*/
    goto _match21224;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_20974 = kk_integer_from_small(0); /*int*/
    goto _match21224;
  }
  {
    _brw_20974 = kk_integer_from_small(1); /*int*/
  }
  _match21224: ;
  kk_integer_t _brw_20973;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_20973 = kk_integer_from_small(-1); /*int*/
    goto _match21225;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_20973 = kk_integer_from_small(0); /*int*/
    goto _match21225;
  }
  {
    _brw_20973 = kk_integer_from_small(1); /*int*/
  }
  _match21225: ;
  bool _brw_20975 = kk_integer_gte_borrow(_brw_20974,_brw_20973,kk_context()); /*bool*/;
  kk_integer_drop(_brw_20974, _ctx);
  kk_integer_drop(_brw_20973, _ctx);
  return _brw_20975;
}
 
// lifted local: joinsep, join-acc

kk_string_t kk_std_core__unroll17331_lift17316_joinsep(kk_string_t sep, kk_std_core__list ys, kk_string_t acc, kk_context_t* _ctx) { /* (sep : string, ys : list<string>, acc : string) -> string */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con21227 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t _box_x19423 = _con21227->head;
    kk_std_core__list yy = _con21227->tail;
    kk_string_t y = kk_string_unbox(_box_x19423);
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_datatype_ptr_free(ys, _ctx);
    }
    else {
      kk_string_dup(y, _ctx);
      kk_std_core__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_string_t acc0_17425;
    kk_string_t _x21228;
    kk_string_t _x21229 = kk_string_dup(sep, _ctx); /*string*/
    _x21228 = kk_std_core__lp__plus__plus__1_rp_(_x21229, y, _ctx); /*string*/
    acc0_17425 = kk_std_core__lp__plus__plus__1_rp_(acc, _x21228, _ctx); /*string*/
    { // tailcall
      ys = yy;
      acc = acc0_17425;
      goto kk__tailcall;
    }
  }
  {
    kk_string_drop(sep, _ctx);
    return acc;
  }
}
 
// Concatenate all strings in a list

kk_string_t kk_std_core_joinsep(kk_std_core__list xs, kk_string_t sep, kk_context_t* _ctx) { /* (xs : list<string>, sep : string) -> string */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_string_drop(sep, _ctx);
    return kk_string_empty();
  }
  {
    struct kk_std_core_Cons* _con21231 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x19424 = _con21231->head;
    kk_std_core__list xx = _con21231->tail;
    kk_string_t x = kk_string_unbox(_box_x19424);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      kk_string_drop(sep, _ctx);
      return x;
    }
    {
      return kk_std_core__unroll17331_lift17316_joinsep(sep, xx, x, _ctx);
    }
  }
}
 
// Concatenate all strings in a list

kk_string_t kk_std_core_join_2(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_Cons* _con21233 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x19425 = _con21233->head;
    kk_std_core__list xx = _con21233->tail;
    kk_string_t x = kk_string_unbox(_box_x19425);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      return x;
    }
    {
      kk_string_t _x21234 = kk_string_empty(); /*string*/
      return kk_std_core__unroll17331_lift17316_joinsep(_x21234, xx, x, _ctx);
    }
  }
}
 
// Concatenate all strings in a list using a specific separator

kk_string_t kk_std_core_join_3(kk_std_core__list xs, kk_string_t sep, kk_context_t* _ctx) { /* (xs : list<string>, sep : string) -> string */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_string_drop(sep, _ctx);
    return kk_string_empty();
  }
  {
    struct kk_std_core_Cons* _con21237 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x19426 = _con21237->head;
    kk_std_core__list xx = _con21237->tail;
    kk_string_t x = kk_string_unbox(_box_x19426);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      kk_string_drop(sep, _ctx);
      return x;
    }
    {
      return kk_std_core__unroll17331_lift17316_joinsep(sep, xx, x, _ctx);
    }
  }
}

bool kk_std_core__lp__lt__eq__5_rp_(kk_std_core_types__order x, kk_std_core_types__order y, kk_context_t* _ctx) { /* (x : order, y : order) -> bool */ 
  kk_integer_t _brw_20969;
  if (kk_std_core_types__is_Lt(x, _ctx)) {
    _brw_20969 = kk_integer_from_small(-1); /*int*/
    goto _match21238;
  }
  if (kk_std_core_types__is_Eq(x, _ctx)) {
    _brw_20969 = kk_integer_from_small(0); /*int*/
    goto _match21238;
  }
  {
    _brw_20969 = kk_integer_from_small(1); /*int*/
  }
  _match21238: ;
  kk_integer_t _brw_20968;
  if (kk_std_core_types__is_Lt(y, _ctx)) {
    _brw_20968 = kk_integer_from_small(-1); /*int*/
    goto _match21239;
  }
  if (kk_std_core_types__is_Eq(y, _ctx)) {
    _brw_20968 = kk_integer_from_small(0); /*int*/
    goto _match21239;
  }
  {
    _brw_20968 = kk_integer_from_small(1); /*int*/
  }
  _match21239: ;
  bool _brw_20970 = kk_integer_lte_borrow(_brw_20969,_brw_20968,kk_context()); /*bool*/;
  kk_integer_drop(_brw_20969, _ctx);
  kk_integer_drop(_brw_20968, _ctx);
  return _brw_20970;
}

kk_ssize_t kk_std_core_decr_1(kk_ssize_t i, kk_context_t* _ctx) { /* (i : ssize_t) -> ssize_t */ 
  return (i - 1);
}

kk_ssize_t kk_std_core_incr_1(kk_ssize_t i, kk_context_t* _ctx) { /* (i : ssize_t) -> ssize_t */ 
  return (i + 1);
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18794_lift17317_forz(kk_function_t action, kk_ssize_t end, kk_ssize_t i, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<e> (action : (ssize_t) -> e (), end : ssize_t, i : ssize_t, wild_ : ()) -> e () */ 
  kk_ssize_t i0_17448 = kk_std_core_incr_1(i, _ctx); /*ssize_t*/;
  kk_std_core__lift17317_forz(action, end, i0_17448, _ctx); return kk_Unit;
}
 
// lifted local: forz, rep


// lift anonymous function
struct kk_std_core__lift17317_forz_fun21243__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_ssize_t end0;
  kk_ssize_t i0;
};
static kk_box_t kk_std_core__lift17317_forz_fun21243(kk_function_t _fself, kk_box_t _b_19428, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift17317_forz_fun21243(kk_function_t action0, kk_ssize_t end0, kk_ssize_t i0, kk_context_t* _ctx) {
  struct kk_std_core__lift17317_forz_fun21243__t* _self = kk_function_alloc_as(struct kk_std_core__lift17317_forz_fun21243__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift17317_forz_fun21243, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift17317_forz_fun21243(kk_function_t _fself, kk_box_t _b_19428, kk_context_t* _ctx) {
  struct kk_std_core__lift17317_forz_fun21243__t* _self = kk_function_as(struct kk_std_core__lift17317_forz_fun21243__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (ssize_t) -> 4452 () */
  kk_ssize_t end0 = _self->end0; /* ssize_t */
  kk_ssize_t i0 = _self->i0; /* ssize_t */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);;;}, {}, _ctx)
  kk_unit_t wild__0_19430 = kk_Unit;
  kk_unit_unbox(_b_19428);
  kk_unit_t _x21244 = kk_Unit;
  kk_std_core__mlift18794_lift17317_forz(action0, end0, i0, wild__0_19430, _ctx);
  return kk_unit_box(_x21244);
}

kk_unit_t kk_std_core__lift17317_forz(kk_function_t action0, kk_ssize_t end0, kk_ssize_t i0, kk_context_t* _ctx) { /* forall<e> (action : (ssize_t) -> e (), end : ssize_t, i : ssize_t) -> e () */ 
  kk__tailcall: ;
  bool _match_20964 = (i0 <= end0); /*bool*/;
  if (_match_20964) {
    kk_unit_t x_18881 = kk_Unit;
    kk_function_t _x21241 = kk_function_dup(action0, _ctx); /*(ssize_t) -> 4452 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_ssize_t, kk_context_t*), _x21241, (_x21241, i0, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21242 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift17317_forz_fun21243(action0, end0, i0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21242); return kk_Unit;
    }
    {
      kk_ssize_t i0_174480 = kk_std_core_incr_1(i0, _ctx); /*ssize_t*/;
      { // tailcall
        i0 = i0_174480;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18795_lift18298_foreach_indexedz(kk_ssize_t end18037, kk_function_t f, kk_ssize_t i18038, kk_vector_t v, kk_unit_t wild__18040, kk_context_t* _ctx) { /* forall<a,e> (end18037 : ssize_t, f : (ssize_t, a) -> e (), i18038 : ssize_t, v : vector<a>, wild_18040 : ()) -> e () */ 
  kk_ssize_t i0_1744818041 = kk_std_core_incr_1(i18038, _ctx); /*ssize_t*/;
  kk_std_core__lift18298_foreach_indexedz(f, v, end18037, i0_1744818041, _ctx); return kk_Unit;
}
 
// lifted local: foreach-indexedz, .spec.18043
// specialized: std/core/.lift17317-forz, on parameters action18036, using:
// action18036 = fn<(e :: E)>(i0: ssize_t){
//   f(i0, (std/core/types/.open<(total :: E),(e :: E),(v : (vector :: V -> V)<a>, index : ssize_t) -> (total :: E) a,(v : (vector :: V -> V)<a>, index : ssize_t) -> (e :: E) a>((std/core/unsafe-idx<a>))(v, i0)));
// }


// lift anonymous function
struct kk_std_core__lift18298_foreach_indexedz_fun21248__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_vector_t v0;
  kk_ssize_t end180370;
  kk_ssize_t i180380;
};
static kk_box_t kk_std_core__lift18298_foreach_indexedz_fun21248(kk_function_t _fself, kk_box_t _b_19432, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18298_foreach_indexedz_fun21248(kk_function_t f0, kk_vector_t v0, kk_ssize_t end180370, kk_ssize_t i180380, kk_context_t* _ctx) {
  struct kk_std_core__lift18298_foreach_indexedz_fun21248__t* _self = kk_function_alloc_as(struct kk_std_core__lift18298_foreach_indexedz_fun21248__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18298_foreach_indexedz_fun21248, kk_context());
  _self->f0 = f0;
  _self->v0 = v0;
  _self->end180370 = end180370;
  _self->i180380 = i180380;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18298_foreach_indexedz_fun21248(kk_function_t _fself, kk_box_t _b_19432, kk_context_t* _ctx) {
  struct kk_std_core__lift18298_foreach_indexedz_fun21248__t* _self = kk_function_as(struct kk_std_core__lift18298_foreach_indexedz_fun21248__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (ssize_t, 4486) -> 4487 () */
  kk_vector_t v0 = _self->v0; /* vector<4486> */
  kk_ssize_t end180370 = _self->end180370; /* ssize_t */
  kk_ssize_t i180380 = _self->i180380; /* ssize_t */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_vector_dup(v0, _ctx);;;}, {}, _ctx)
  kk_unit_t wild__180400_19434 = kk_Unit;
  kk_unit_unbox(_b_19432);
  kk_unit_t _x21249 = kk_Unit;
  kk_std_core__mlift18795_lift18298_foreach_indexedz(end180370, f0, i180380, v0, wild__180400_19434, _ctx);
  return kk_unit_box(_x21249);
}

kk_unit_t kk_std_core__lift18298_foreach_indexedz(kk_function_t f0, kk_vector_t v0, kk_ssize_t end180370, kk_ssize_t i180380, kk_context_t* _ctx) { /* forall<a,e> (f : (ssize_t, a) -> e (), v : vector<a>, end18037 : ssize_t, i18038 : ssize_t) -> e () */ 
  kk__tailcall: ;
  bool _match_20962 = (i180380 <= end180370); /*bool*/;
  if (_match_20962) {
    kk_unit_t x_18884 = kk_Unit;
    kk_function_t _x21246 = kk_function_dup(f0, _ctx); /*(ssize_t, 4486) -> 4487 ()*/
    kk_box_t _x21245 = kk_vector_at_borrow(v0,i180380,kk_context()); /*228*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_ssize_t, kk_box_t, kk_context_t*), _x21246, (_x21246, i180380, _x21245, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21247 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18298_foreach_indexedz_fun21248(f0, v0, end180370, i180380, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21247); return kk_Unit;
    }
    {
      kk_ssize_t i0_17448180410 = kk_std_core_incr_1(i180380, _ctx); /*ssize_t*/;
      { // tailcall
        i180380 = i0_17448180410;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_vector_drop(v0, _ctx);
    kk_function_drop(f0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// lifted local: length.1, len

kk_integer_t kk_std_core__unroll17332_lift17318_length_1(kk_std_core__list ys, kk_integer_t acc, kk_context_t* _ctx) { /* forall<a> (ys : list<a>, acc : int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con21251 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t _pat0 = _con21251->head;
    kk_std_core__list yy = _con21251->tail;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_box_drop(_pat0, _ctx);
      kk_datatype_ptr_free(ys, _ctx);
    }
    else {
      kk_std_core__list_dup(yy, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    { // tailcall
      kk_integer_t _x21252 = kk_integer_add_small_const(acc, 1, _ctx); /*int*/
      ys = yy;
      acc = _x21252;
      goto kk__tailcall;
    }
  }
  {
    return acc;
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core__trmc_list(kk_integer_t lo, kk_integer_t hi, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int, hi : int, ctx<list<int>>) -> total list<int> */ 
  kk__tailcall: ;
  bool _match_20961 = kk_integer_lte_borrow(lo,hi,kk_context()); /*bool*/;
  if (_match_20961) {
    kk_std_core__list _trmc_18371 = kk_datatype_null(); /*list<int>*/;
    kk_std_core__list _trmc_18372;
    kk_box_t _x21254;
    kk_integer_t _x21255 = kk_integer_dup(lo, _ctx); /*int*/
    _x21254 = kk_integer_box(_x21255, _ctx); /*61*/
    _trmc_18372 = kk_std_core__new_Cons(kk_reuse_null, 0, _x21254, _trmc_18371, _ctx); /*list<int>*/
    kk_box_t* _b_19449_19444 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18372, _ctx)->tail)); /*field-addr<list<int>>*/;
    { // tailcall
      kk_integer_t _x21256 = kk_integer_add_small_const(lo, 1, _ctx); /*int*/
      kk_std_core_types__cctx _x21257 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18372, _ctx)),_b_19449_19444,true,kk_context()); /*ctx<0>*/
      lo = _x21256;
      _acc = _x21257;
      goto kk__tailcall;
    }
  }
  {
    kk_integer_drop(lo, _ctx);
    kk_integer_drop(hi, _ctx);
    kk_box_t _x21258 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21258, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core_list(kk_integer_t lo0, kk_integer_t hi0, kk_context_t* _ctx) { /* (lo : int, hi : int) -> total list<int> */ 
  kk_std_core_types__cctx _x21259 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list(lo0, hi0, _x21259, _ctx);
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core__trmc_list_1(kk_integer_t lo, kk_integer_t hi, kk_integer_t stride, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (lo : int, hi : int, stride : int, ctx<list<int>>) -> total list<int> */ 
  kk__tailcall: ;
  bool _match_20960 = kk_integer_lte_borrow(lo,hi,kk_context()); /*bool*/;
  if (_match_20960) {
    kk_std_core__list _trmc_18373 = kk_datatype_null(); /*list<int>*/;
    kk_std_core__list _trmc_18374;
    kk_box_t _x21260;
    kk_integer_t _x21261 = kk_integer_dup(lo, _ctx); /*int*/
    _x21260 = kk_integer_box(_x21261, _ctx); /*61*/
    _trmc_18374 = kk_std_core__new_Cons(kk_reuse_null, 0, _x21260, _trmc_18373, _ctx); /*list<int>*/
    kk_box_t* _b_19469_19464 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18374, _ctx)->tail)); /*field-addr<list<int>>*/;
    { // tailcall
      kk_integer_t _x21262;
      kk_integer_t _x21263 = kk_integer_dup(stride, _ctx); /*int*/
      _x21262 = kk_integer_add(lo,_x21263,kk_context()); /*int*/
      kk_std_core_types__cctx _x21264 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18374, _ctx)),_b_19469_19464,true,kk_context()); /*ctx<0>*/
      lo = _x21262;
      _acc = _x21264;
      goto kk__tailcall;
    }
  }
  {
    kk_integer_drop(stride, _ctx);
    kk_integer_drop(lo, _ctx);
    kk_integer_drop(hi, _ctx);
    kk_box_t _x21265 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21265, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core_list_1(kk_integer_t lo0, kk_integer_t hi0, kk_integer_t stride0, kk_context_t* _ctx) { /* (lo : int, hi : int, stride : int) -> total list<int> */ 
  kk_std_core_types__cctx _x21266 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list_1(lo0, hi0, stride0, _x21266, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18796_trmc_list_2(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t hi, kk_integer_t lo, kk_box_t _trmc_18375, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, f : (int) -> e a, hi : int, lo : int, a) -> e list<a> */ 
  kk_std_core__list _trmc_18376 = kk_datatype_null(); /*list<5040>*/;
  kk_std_core__list _trmc_18377 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_18375, _trmc_18376, _ctx); /*list<5040>*/;
  kk_box_t* _b_19483_19480 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18377, _ctx)->tail)); /*field-addr<list<5040>>*/;
  kk_integer_t _x21267 = kk_integer_add_small_const(lo, 1, _ctx); /*int*/
  kk_std_core_types__cctx _x21268 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18377, _ctx)),_b_19483_19480,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list_2(_x21267, hi, f, _x21268, _ctx);
}
 
// Applies a function `f` to list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.


// lift anonymous function
struct kk_std_core__trmc_list_fun21272__t_2 {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_integer_t hi0;
  kk_integer_t lo0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_list_fun21272_2(kk_function_t _fself, kk_box_t _b_19488, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_list_fun21272_2(kk_function_t f0, kk_integer_t hi0, kk_integer_t lo0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_list_fun21272__t_2* _self = kk_function_alloc_as(struct kk_std_core__trmc_list_fun21272__t_2, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_list_fun21272_2, kk_context());
  _self->f0 = f0;
  _self->hi0 = hi0;
  _self->lo0 = lo0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_list_fun21272_2(kk_function_t _fself, kk_box_t _b_19488, kk_context_t* _ctx) {
  struct kk_std_core__trmc_list_fun21272__t_2* _self = kk_function_as(struct kk_std_core__trmc_list_fun21272__t_2*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int) -> 5041 5040 */
  kk_integer_t hi0 = _self->hi0; /* int */
  kk_integer_t lo0 = _self->lo0; /* int */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<5040>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_integer_dup(hi0, _ctx);kk_integer_dup(lo0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_19506_183750 = _b_19488; /*5040*/;
  kk_std_core__list _x21273 = kk_std_core__mlift18796_trmc_list_2(_acc0, f0, hi0, lo0, _trmc_19506_183750, _ctx); /*list<5040>*/
  return kk_std_core__list_box(_x21273, _ctx);
}

kk_std_core__list kk_std_core__trmc_list_2(kk_integer_t lo0, kk_integer_t hi0, kk_function_t f0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, f : (int) -> e a, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  bool _match_20958 = kk_integer_lte_borrow(lo0,hi0,kk_context()); /*bool*/;
  if (_match_20958) {
    kk_box_t x_18887;
    kk_function_t _x21270 = kk_function_dup(f0, _ctx); /*(int) -> 5041 5040*/
    kk_integer_t _x21269 = kk_integer_dup(lo0, _ctx); /*int*/
    x_18887 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_context_t*), _x21270, (_x21270, _x21269, _ctx), _ctx); /*5040*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_18887, _ctx);
      kk_box_t _x21271 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_list_fun21272_2(f0, hi0, lo0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x21271, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_183760 = kk_datatype_null(); /*list<5040>*/;
      kk_std_core__list _trmc_183770 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), x_18887, _trmc_183760, _ctx); /*list<5040>*/;
      kk_box_t* _b_19500_19494 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_183770, _ctx)->tail)); /*field-addr<list<5040>>*/;
      { // tailcall
        kk_integer_t _x21274 = kk_integer_add_small_const(lo0, 1, _ctx); /*int*/
        kk_std_core_types__cctx _x21275 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_183770, _ctx)),_b_19500_19494,false,kk_context()); /*ctx<0>*/
        lo0 = _x21274;
        _acc0 = _x21275;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(lo0, _ctx);
    kk_integer_drop(hi0, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x21276 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21276, KK_OWNED, _ctx);
  }
}
 
// Applies a function `f` to list of increasing elements from `lo`  to `hi`
// (including both `lo`  and `hi` ).
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core_list_2(kk_integer_t lo1, kk_integer_t hi1, kk_function_t f1, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, f : (int) -> e a) -> e list<a> */ 
  kk_std_core_types__cctx _x21277 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list_2(lo1, hi1, f1, _x21277, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18797_trmc_list_3(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t hi, kk_integer_t lo, kk_integer_t stride, kk_box_t _trmc_18378, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, f : (int) -> e a, hi : int, lo : int, stride : int, a) -> e list<a> */ 
  kk_std_core__list _trmc_18379 = kk_datatype_null(); /*list<5131>*/;
  kk_std_core__list _trmc_18380 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_18378, _trmc_18379, _ctx); /*list<5131>*/;
  kk_box_t* _b_19515_19512 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18380, _ctx)->tail)); /*field-addr<list<5131>>*/;
  kk_integer_t _x21278;
  kk_integer_t _x21279 = kk_integer_dup(stride, _ctx); /*int*/
  _x21278 = kk_integer_add(lo,_x21279,kk_context()); /*int*/
  kk_std_core_types__cctx _x21280 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18380, _ctx)),_b_19515_19512,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list_3(_x21278, hi, stride, f, _x21280, _ctx);
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.


// lift anonymous function
struct kk_std_core__trmc_list_fun21284__t_3 {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_integer_t hi0;
  kk_integer_t lo0;
  kk_integer_t stride0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_list_fun21284_3(kk_function_t _fself, kk_box_t _b_19520, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_list_fun21284_3(kk_function_t f0, kk_integer_t hi0, kk_integer_t lo0, kk_integer_t stride0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_list_fun21284__t_3* _self = kk_function_alloc_as(struct kk_std_core__trmc_list_fun21284__t_3, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_list_fun21284_3, kk_context());
  _self->f0 = f0;
  _self->hi0 = hi0;
  _self->lo0 = lo0;
  _self->stride0 = stride0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_list_fun21284_3(kk_function_t _fself, kk_box_t _b_19520, kk_context_t* _ctx) {
  struct kk_std_core__trmc_list_fun21284__t_3* _self = kk_function_as(struct kk_std_core__trmc_list_fun21284__t_3*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int) -> 5132 5131 */
  kk_integer_t hi0 = _self->hi0; /* int */
  kk_integer_t lo0 = _self->lo0; /* int */
  kk_integer_t stride0 = _self->stride0; /* int */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<5131>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_integer_dup(hi0, _ctx);kk_integer_dup(lo0, _ctx);kk_integer_dup(stride0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_19538_183780 = _b_19520; /*5131*/;
  kk_std_core__list _x21285 = kk_std_core__mlift18797_trmc_list_3(_acc0, f0, hi0, lo0, stride0, _trmc_19538_183780, _ctx); /*list<5131>*/
  return kk_std_core__list_box(_x21285, _ctx);
}

kk_std_core__list kk_std_core__trmc_list_3(kk_integer_t lo0, kk_integer_t hi0, kk_integer_t stride0, kk_function_t f0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, stride : int, f : (int) -> e a, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  bool _match_20956 = kk_integer_lte_borrow(lo0,hi0,kk_context()); /*bool*/;
  if (_match_20956) {
    kk_box_t x_18890;
    kk_function_t _x21282 = kk_function_dup(f0, _ctx); /*(int) -> 5132 5131*/
    kk_integer_t _x21281 = kk_integer_dup(lo0, _ctx); /*int*/
    x_18890 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_context_t*), _x21282, (_x21282, _x21281, _ctx), _ctx); /*5131*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_18890, _ctx);
      kk_box_t _x21283 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_list_fun21284_3(f0, hi0, lo0, stride0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x21283, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_183790 = kk_datatype_null(); /*list<5131>*/;
      kk_std_core__list _trmc_183800 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), x_18890, _trmc_183790, _ctx); /*list<5131>*/;
      kk_box_t* _b_19532_19526 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_183800, _ctx)->tail)); /*field-addr<list<5131>>*/;
      { // tailcall
        kk_integer_t _x21286;
        kk_integer_t _x21287 = kk_integer_dup(stride0, _ctx); /*int*/
        _x21286 = kk_integer_add(lo0,_x21287,kk_context()); /*int*/
        kk_std_core_types__cctx _x21288 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_183800, _ctx)),_b_19532_19526,false,kk_context()); /*ctx<0>*/
        lo0 = _x21286;
        _acc0 = _x21288;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(stride0, _ctx);
    kk_integer_drop(lo0, _ctx);
    kk_integer_drop(hi0, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x21289 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21289, KK_OWNED, _ctx);
  }
}
 
// Returns an integer list of increasing elements from `lo`  to `hi` with stride `stride`.
// If `lo > hi`  the function returns the empty list.

kk_std_core__list kk_std_core_list_3(kk_integer_t lo1, kk_integer_t hi1, kk_integer_t stride1, kk_function_t f1, kk_context_t* _ctx) { /* forall<a,e> (lo : int, hi : int, stride : int, f : (int) -> e a) -> e list<a> */ 
  kk_std_core_types__cctx _x21290 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_list_3(lo1, hi1, stride1, f1, _x21290, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18798_trmc_unroll17333_map_5(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core__list xx, kk_box_t _trmc_18381, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e b, xx : list<a>, b) -> e list<b> */ 
  kk_std_core__list _trmc_18382 = kk_datatype_null(); /*list<6253>*/;
  kk_std_core__list _trmc_18383 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_18381, _trmc_18382, _ctx); /*list<6253>*/;
  kk_box_t* _b_19547_19544 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18383, _ctx)->tail)); /*field-addr<list<6253>>*/;
  kk_std_core_types__cctx _x21291 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18383, _ctx)),_b_19547_19544,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17333_map_5(xx, f, _x21291, _ctx);
}
 
// Apply a function `f`  to each element of the input list in sequence.


// lift anonymous function
struct kk_std_core__trmc_unroll17333_map_fun21295__t_5 {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17333_map_fun21295_5(kk_function_t _fself, kk_box_t _b_19552, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17333_map_fun21295_5(kk_function_t f0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17333_map_fun21295__t_5* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17333_map_fun21295__t_5, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17333_map_fun21295_5, kk_context());
  _self->f0 = f0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17333_map_fun21295_5(kk_function_t _fself, kk_box_t _b_19552, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17333_map_fun21295__t_5* _self = kk_function_as(struct kk_std_core__trmc_unroll17333_map_fun21295__t_5*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (6252) -> 6254 6253 */
  kk_std_core__list xx0 = _self->xx0; /* list<6252> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<6253>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_19570_183810 = _b_19552; /*6253*/;
  kk_std_core__list _x21296 = kk_std_core__mlift18798_trmc_unroll17333_map_5(_acc0, f0, xx0, _trmc_19570_183810, _ctx); /*list<6253>*/
  return kk_std_core__list_box(_x21296, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17333_map_5(kk_std_core__list xs, kk_function_t f0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e b, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21292 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21292->head;
    kk_std_core__list xx0 = _con21292->tail;
    kk_reuse_t _ru_21029 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_21029 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t x0_18893;
    kk_function_t _x21293 = kk_function_dup(f0, _ctx); /*(6252) -> 6254 6253*/
    x0_18893 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21293, (_x21293, x, _ctx), _ctx); /*6253*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_21029,kk_context());
      kk_box_drop(x0_18893, _ctx);
      kk_box_t _x21294 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17333_map_fun21295_5(f0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x21294, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_183820 = kk_datatype_null(); /*list<6253>*/;
      kk_std_core__list _trmc_183830 = kk_std_core__new_Cons(_ru_21029, kk_field_index_of(struct kk_std_core_Cons, tail), x0_18893, _trmc_183820, _ctx); /*list<6253>*/;
      kk_box_t* _b_19564_19558 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_183830, _ctx)->tail)); /*field-addr<list<6253>>*/;
      { // tailcall
        kk_std_core_types__cctx _x21297 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_183830, _ctx)),_b_19564_19558,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x21297;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(f0, _ctx);
    kk_box_t _x21298 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21298, KK_OWNED, _ctx);
  }
}
 
// Apply a function `f`  to each element of the input list in sequence.

kk_std_core__list kk_std_core__unroll17333_map_5(kk_std_core__list xs0, kk_function_t f1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e b) -> e list<b> */ 
  kk_std_core_types__cctx _x21299 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17333_map_5(xs0, f1, _x21299, _ctx);
}
 
// lifted local: list.4, .spec.18051
// specialized: std/core/.unroll17333-map.5, on parameters f18046, using:
// f18046 = std/core/char

kk_std_core__list kk_std_core__trmc_lift18299_list_4(kk_std_core__list xs18045, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (xs18045 : list<int>, ctx<list<char>>) -> total list<char> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18045, _ctx)) {
    struct kk_std_core_Cons* _con21300 = kk_std_core__as_Cons(xs18045, _ctx);
    kk_box_t _box_x19571 = _con21300->head;
    kk_std_core__list xx18049 = _con21300->tail;
    kk_integer_t x18048 = kk_integer_unbox(_box_x19571, _ctx);
    kk_reuse_t _ru_21030 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs18045, _ctx)) {
      _ru_21030 = (kk_datatype_ptr_reuse(xs18045, _ctx));
    }
    else {
      kk_integer_dup(x18048, _ctx);
      kk_std_core__list_dup(xx18049, _ctx);
      kk_datatype_ptr_decref(xs18045, _ctx);
    }
    kk_char_t _trmc_18384 = kk_integer_clamp32(x18048,kk_context()); /*char*/;
    kk_std_core__list _trmc_18385 = kk_datatype_null(); /*list<char>*/;
    kk_std_core__list _trmc_18386 = kk_std_core__new_Cons(_ru_21030, 0, kk_char_box(_trmc_18384, _ctx), _trmc_18385, _ctx); /*list<char>*/;
    kk_box_t* _b_19586_19581 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18386, _ctx)->tail)); /*field-addr<list<char>>*/;
    { // tailcall
      kk_std_core_types__cctx _x21301 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18386, _ctx)),_b_19586_19581,true,kk_context()); /*ctx<0>*/
      xs18045 = xx18049;
      _acc = _x21301;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x21302 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21302, KK_OWNED, _ctx);
  }
}
 
// lifted local: list.4, .spec.18051
// specialized: std/core/.unroll17333-map.5, on parameters f18046, using:
// f18046 = std/core/char

kk_std_core__list kk_std_core__lift18299_list_4(kk_std_core__list xs180450, kk_context_t* _ctx) { /* (xs18045 : list<int>) -> total list<char> */ 
  kk_std_core_types__cctx _x21303 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift18299_list_4(xs180450, _x21303, _ctx);
}
 
// Convert a string to a list of characters

kk_std_core__list kk_std_core_list_6(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> total list<char> */ 
  return kk_string_to_list(s,kk_context());
}


// lift anonymous function
struct kk_std_core_map_fun21307__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_map_fun21307(kk_function_t _fself, kk_box_t _b_19593, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21307(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_map_fun21307, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_map_fun21307(kk_function_t _fself, kk_box_t _b_19593, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _y_19595_18483 = _b_19593; /*5433*/;
  kk_std_core_types__maybe _x21308 = kk_std_core_types__new_Just(_y_19595_18483, _ctx); /*maybe<111>*/
  return kk_std_core_types__maybe_box(_x21308, _ctx);
}

kk_std_core_types__maybe kk_std_core_map(kk_std_core_types__maybe m, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (m : maybe<a>, f : (a) -> e b) -> e maybe<b> */ 
  if (kk_std_core_types__is_Nothing(m, _ctx)) {
    kk_function_drop(f, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_box_t x = m._cons.Just.value;
    kk_box_t x0_18896 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx), _ctx); /*5433*/;
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18896, _ctx);
      kk_box_t _x21306 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21307(_ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x21306, KK_OWNED, _ctx);
    }
    {
      return kk_std_core_types__new_Just(x0_18896, _ctx);
    }
  }
}
 
// Map over the `Right` component of an `:either` type.


// lift anonymous function
struct kk_std_core_map_fun21310__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_map_fun21310_1(kk_function_t _fself, kk_box_t _b_19597, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21310_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_map_fun21310_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_map_fun21310_1(kk_function_t _fself, kk_box_t _b_19597, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _y_19599_18485 = _b_19597; /*5471*/;
  kk_std_core_types__either _x21311 = kk_std_core_types__new_Right(_y_19599_18485, _ctx); /*either<76,77>*/
  return kk_std_core_types__either_box(_x21311, _ctx);
}

kk_std_core_types__either kk_std_core_map_1(kk_std_core_types__either e, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,c,e> (e : either<a,b>, f : (b) -> e c) -> e either<a,c> */ 
  if (kk_std_core_types__is_Right(e, _ctx)) {
    kk_box_t x = e._cons.Right.right;
    kk_box_t x0_18900 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, x, _ctx), _ctx); /*5471*/;
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18900, _ctx);
      kk_box_t _x21309 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21310_1(_ctx), _ctx); /*3926*/
      return kk_std_core_types__either_unbox(_x21309, KK_OWNED, _ctx);
    }
    {
      return kk_std_core_types__new_Right(x0_18900, _ctx);
    }
  }
  {
    kk_box_t x00 = e._cons.Left.left;
    kk_function_drop(f, _ctx);
    return kk_std_core_types__new_Left(x00, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18802_map_fun21314__t_2 {
  struct kk_function_s _base;
  kk_box_t _y_18487;
};
static kk_box_t kk_std_core__mlift18802_map_fun21314_2(kk_function_t _fself, kk_box_t _b_19601, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18802_map_fun21314_2(kk_box_t _y_18487, kk_context_t* _ctx) {
  struct kk_std_core__mlift18802_map_fun21314__t_2* _self = kk_function_alloc_as(struct kk_std_core__mlift18802_map_fun21314__t_2, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18802_map_fun21314_2, kk_context());
  _self->_y_18487 = _y_18487;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18802_map_fun21314_2(kk_function_t _fself, kk_box_t _b_19601, kk_context_t* _ctx) {
  struct kk_std_core__mlift18802_map_fun21314__t_2* _self = kk_function_as(struct kk_std_core__mlift18802_map_fun21314__t_2*, _fself, _ctx);
  kk_box_t _y_18487 = _self->_y_18487; /* 5616 */
  kk_drop_match(_self, {kk_box_dup(_y_18487, _ctx);}, {}, _ctx)
  kk_box_t _y_19603_18488 = _b_19601; /*5616*/;
  kk_std_core_types__tuple2_ _x21315 = kk_std_core_types__new_dash__lp__comma__rp_(_y_18487, _y_19603_18488, _ctx); /*(6, 7)*/
  return kk_std_core_types__tuple2__box(_x21315, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core__mlift18802_map_2(kk_function_t f, kk_std_core_types__tuple2_ t, kk_box_t _y_18487, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e b, t : (a, a), b) -> e (b, b) */ 
  kk_box_t x_18904;
  kk_box_t _x21312;
  {
    kk_box_t _x0 = t.snd;
    kk_box_dup(_x0, _ctx);
    kk_std_core_types__tuple2__drop(t, _ctx);
    _x21312 = _x0; /*5615*/
  }
  x_18904 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x21312, _ctx), _ctx); /*5616*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18904, _ctx);
    kk_box_t _x21313 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18802_map_fun21314_2(_y_18487, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple2__unbox(_x21313, KK_OWNED, _ctx);
  }
  {
    return kk_std_core_types__new_dash__lp__comma__rp_(_y_18487, x_18904, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_map_fun21319__t_2 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple2_ t;
};
static kk_box_t kk_std_core_map_fun21319_2(kk_function_t _fself, kk_box_t _b_19605, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21319_2(kk_function_t f, kk_std_core_types__tuple2_ t, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21319__t_2* _self = kk_function_alloc_as(struct kk_std_core_map_fun21319__t_2, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21319_2, kk_context());
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21319_2(kk_function_t _fself, kk_box_t _b_19605, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21319__t_2* _self = kk_function_as(struct kk_std_core_map_fun21319__t_2*, _fself, _ctx);
  kk_function_t f = _self->f; /* (5615) -> 5617 5616 */
  kk_std_core_types__tuple2_ t = _self->t; /* (5615, 5615) */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple2__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_19610_18487 = _b_19605; /*5616*/;
  kk_std_core_types__tuple2_ _x21320 = kk_std_core__mlift18802_map_2(f, t, _y_19610_18487, _ctx); /*(5616, 5616)*/
  return kk_std_core_types__tuple2__box(_x21320, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun21323__t_2 {
  struct kk_function_s _base;
  kk_box_t x_18908;
};
static kk_box_t kk_std_core_map_fun21323_2(kk_function_t _fself, kk_box_t _b_19607, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21323_2(kk_box_t x_18908, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21323__t_2* _self = kk_function_alloc_as(struct kk_std_core_map_fun21323__t_2, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21323_2, kk_context());
  _self->x_18908 = x_18908;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21323_2(kk_function_t _fself, kk_box_t _b_19607, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21323__t_2* _self = kk_function_as(struct kk_std_core_map_fun21323__t_2*, _fself, _ctx);
  kk_box_t x_18908 = _self->x_18908; /* 5616 */
  kk_drop_match(_self, {kk_box_dup(x_18908, _ctx);}, {}, _ctx)
  kk_box_t _y_19611_18488 = _b_19607; /*5616*/;
  kk_std_core_types__tuple2_ _x21324 = kk_std_core_types__new_dash__lp__comma__rp_(x_18908, _y_19611_18488, _ctx); /*(6, 7)*/
  return kk_std_core_types__tuple2__box(_x21324, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core_map_2(kk_std_core_types__tuple2_ t, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (t : (a, a), f : (a) -> e b) -> e (b, b) */ 
  kk_box_t x_18908;
  kk_function_t _x21317 = kk_function_dup(f, _ctx); /*(5615) -> 5617 5616*/
  kk_box_t _x21316;
  {
    kk_box_t _x = t.fst;
    kk_box_dup(_x, _ctx);
    _x21316 = _x; /*5615*/
  }
  x_18908 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21317, (_x21317, _x21316, _ctx), _ctx); /*5616*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18908, _ctx);
    kk_box_t _x21318 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21319_2(f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple2__unbox(_x21318, KK_OWNED, _ctx);
  }
  {
    kk_box_t x0_18911;
    kk_box_t _x21321;
    {
      kk_box_t _x0 = t.snd;
      kk_box_dup(_x0, _ctx);
      kk_std_core_types__tuple2__drop(t, _ctx);
      _x21321 = _x0; /*5615*/
    }
    x0_18911 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x21321, _ctx), _ctx); /*5616*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18911, _ctx);
      kk_box_t _x21322 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21323_2(x_18908, _ctx), _ctx); /*3926*/
      return kk_std_core_types__tuple2__unbox(_x21322, KK_OWNED, _ctx);
    }
    {
      return kk_std_core_types__new_dash__lp__comma__rp_(x_18908, x0_18911, _ctx);
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18804_map_fun21327__t_3 {
  struct kk_function_s _base;
  kk_box_t _y_18489;
  kk_box_t _y_18490;
};
static kk_box_t kk_std_core__mlift18804_map_fun21327_3(kk_function_t _fself, kk_box_t _b_19613, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18804_map_fun21327_3(kk_box_t _y_18489, kk_box_t _y_18490, kk_context_t* _ctx) {
  struct kk_std_core__mlift18804_map_fun21327__t_3* _self = kk_function_alloc_as(struct kk_std_core__mlift18804_map_fun21327__t_3, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18804_map_fun21327_3, kk_context());
  _self->_y_18489 = _y_18489;
  _self->_y_18490 = _y_18490;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18804_map_fun21327_3(kk_function_t _fself, kk_box_t _b_19613, kk_context_t* _ctx) {
  struct kk_std_core__mlift18804_map_fun21327__t_3* _self = kk_function_as(struct kk_std_core__mlift18804_map_fun21327__t_3*, _fself, _ctx);
  kk_box_t _y_18489 = _self->_y_18489; /* 5834 */
  kk_box_t _y_18490 = _self->_y_18490; /* 5834 */
  kk_drop_match(_self, {kk_box_dup(_y_18489, _ctx);kk_box_dup(_y_18490, _ctx);}, {}, _ctx)
  kk_box_t _y_19615_18491 = _b_19613; /*5834*/;
  kk_std_core_types__tuple3_ _x21328 = kk_std_core_types__new_dash__lp__comma__comma__rp_(_y_18489, _y_18490, _y_19615_18491, _ctx); /*(13, 14, 15)*/
  return kk_std_core_types__tuple3__box(_x21328, _ctx);
}

kk_std_core_types__tuple3_ kk_std_core__mlift18804_map_3(kk_box_t _y_18489, kk_function_t f, kk_std_core_types__tuple3_ t, kk_box_t _y_18490, kk_context_t* _ctx) { /* forall<a,b,e> (b, f : (a) -> e b, t : (a, a, a), b) -> e (b, b, b) */ 
  kk_box_t x_18916;
  kk_box_t _x21325;
  {
    kk_box_t _x1 = t.thd;
    kk_box_dup(_x1, _ctx);
    kk_std_core_types__tuple3__drop(t, _ctx);
    _x21325 = _x1; /*5833*/
  }
  x_18916 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x21325, _ctx), _ctx); /*5834*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18916, _ctx);
    kk_box_t _x21326 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18804_map_fun21327_3(_y_18489, _y_18490, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple3__unbox(_x21326, KK_OWNED, _ctx);
  }
  {
    return kk_std_core_types__new_dash__lp__comma__comma__rp_(_y_18489, _y_18490, x_18916, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18805_map_fun21332__t_3 {
  struct kk_function_s _base;
  kk_box_t _y_18489;
  kk_function_t f;
  kk_std_core_types__tuple3_ t;
};
static kk_box_t kk_std_core__mlift18805_map_fun21332_3(kk_function_t _fself, kk_box_t _b_19617, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18805_map_fun21332_3(kk_box_t _y_18489, kk_function_t f, kk_std_core_types__tuple3_ t, kk_context_t* _ctx) {
  struct kk_std_core__mlift18805_map_fun21332__t_3* _self = kk_function_alloc_as(struct kk_std_core__mlift18805_map_fun21332__t_3, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18805_map_fun21332_3, kk_context());
  _self->_y_18489 = _y_18489;
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18805_map_fun21332_3(kk_function_t _fself, kk_box_t _b_19617, kk_context_t* _ctx) {
  struct kk_std_core__mlift18805_map_fun21332__t_3* _self = kk_function_as(struct kk_std_core__mlift18805_map_fun21332__t_3*, _fself, _ctx);
  kk_box_t _y_18489 = _self->_y_18489; /* 5834 */
  kk_function_t f = _self->f; /* (5833) -> 5835 5834 */
  kk_std_core_types__tuple3_ t = _self->t; /* (5833, 5833, 5833) */
  kk_drop_match(_self, {kk_box_dup(_y_18489, _ctx);kk_function_dup(f, _ctx);kk_std_core_types__tuple3__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_19619_18490 = _b_19617; /*5834*/;
  kk_std_core_types__tuple3_ _x21333 = kk_std_core__mlift18804_map_3(_y_18489, f, t, _y_19619_18490, _ctx); /*(5834, 5834, 5834)*/
  return kk_std_core_types__tuple3__box(_x21333, _ctx);
}

kk_std_core_types__tuple3_ kk_std_core__mlift18805_map_3(kk_function_t f, kk_std_core_types__tuple3_ t, kk_box_t _y_18489, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e b, t : (a, a, a), b) -> e (b, b, b) */ 
  kk_box_t x_18921;
  kk_function_t _x21330 = kk_function_dup(f, _ctx); /*(5833) -> 5835 5834*/
  kk_box_t _x21329;
  {
    kk_box_t _x0 = t.snd;
    kk_box_dup(_x0, _ctx);
    _x21329 = _x0; /*5833*/
  }
  x_18921 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21330, (_x21330, _x21329, _ctx), _ctx); /*5834*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18921, _ctx);
    kk_box_t _x21331 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18805_map_fun21332_3(_y_18489, f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple3__unbox(_x21331, KK_OWNED, _ctx);
  }
  {
    return kk_std_core__mlift18804_map_3(_y_18489, f, t, x_18921, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_map_fun21337__t_3 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple3_ t;
};
static kk_box_t kk_std_core_map_fun21337_3(kk_function_t _fself, kk_box_t _b_19621, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21337_3(kk_function_t f, kk_std_core_types__tuple3_ t, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21337__t_3* _self = kk_function_alloc_as(struct kk_std_core_map_fun21337__t_3, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21337_3, kk_context());
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21337_3(kk_function_t _fself, kk_box_t _b_19621, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21337__t_3* _self = kk_function_as(struct kk_std_core_map_fun21337__t_3*, _fself, _ctx);
  kk_function_t f = _self->f; /* (5833) -> 5835 5834 */
  kk_std_core_types__tuple3_ t = _self->t; /* (5833, 5833, 5833) */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple3__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_19629_18489 = _b_19621; /*5834*/;
  kk_std_core_types__tuple3_ _x21338 = kk_std_core__mlift18805_map_3(f, t, _y_19629_18489, _ctx); /*(5834, 5834, 5834)*/
  return kk_std_core_types__tuple3__box(_x21338, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun21342__t_3 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple3_ t;
  kk_box_t x_18923;
};
static kk_box_t kk_std_core_map_fun21342_3(kk_function_t _fself, kk_box_t _b_19623, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21342_3(kk_function_t f, kk_std_core_types__tuple3_ t, kk_box_t x_18923, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21342__t_3* _self = kk_function_alloc_as(struct kk_std_core_map_fun21342__t_3, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21342_3, kk_context());
  _self->f = f;
  _self->t = t;
  _self->x_18923 = x_18923;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21342_3(kk_function_t _fself, kk_box_t _b_19623, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21342__t_3* _self = kk_function_as(struct kk_std_core_map_fun21342__t_3*, _fself, _ctx);
  kk_function_t f = _self->f; /* (5833) -> 5835 5834 */
  kk_std_core_types__tuple3_ t = _self->t; /* (5833, 5833, 5833) */
  kk_box_t x_18923 = _self->x_18923; /* 5834 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple3__dup(t, _ctx);kk_box_dup(x_18923, _ctx);}, {}, _ctx)
  kk_box_t _y_19630_18490 = _b_19623; /*5834*/;
  kk_std_core_types__tuple3_ _x21343 = kk_std_core__mlift18804_map_3(x_18923, f, t, _y_19630_18490, _ctx); /*(5834, 5834, 5834)*/
  return kk_std_core_types__tuple3__box(_x21343, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun21346__t_3 {
  struct kk_function_s _base;
  kk_box_t x_18923;
  kk_box_t x0_18926;
};
static kk_box_t kk_std_core_map_fun21346_3(kk_function_t _fself, kk_box_t _b_19625, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21346_3(kk_box_t x_18923, kk_box_t x0_18926, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21346__t_3* _self = kk_function_alloc_as(struct kk_std_core_map_fun21346__t_3, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21346_3, kk_context());
  _self->x_18923 = x_18923;
  _self->x0_18926 = x0_18926;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21346_3(kk_function_t _fself, kk_box_t _b_19625, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21346__t_3* _self = kk_function_as(struct kk_std_core_map_fun21346__t_3*, _fself, _ctx);
  kk_box_t x_18923 = _self->x_18923; /* 5834 */
  kk_box_t x0_18926 = _self->x0_18926; /* 5834 */
  kk_drop_match(_self, {kk_box_dup(x_18923, _ctx);kk_box_dup(x0_18926, _ctx);}, {}, _ctx)
  kk_box_t _y_19631_18491 = _b_19625; /*5834*/;
  kk_std_core_types__tuple3_ _x21347 = kk_std_core_types__new_dash__lp__comma__comma__rp_(x_18923, x0_18926, _y_19631_18491, _ctx); /*(13, 14, 15)*/
  return kk_std_core_types__tuple3__box(_x21347, _ctx);
}

kk_std_core_types__tuple3_ kk_std_core_map_3(kk_std_core_types__tuple3_ t, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (t : (a, a, a), f : (a) -> e b) -> e (b, b, b) */ 
  kk_box_t x_18923;
  kk_function_t _x21335 = kk_function_dup(f, _ctx); /*(5833) -> 5835 5834*/
  kk_box_t _x21334;
  {
    kk_box_t _x = t.fst;
    kk_box_dup(_x, _ctx);
    _x21334 = _x; /*5833*/
  }
  x_18923 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21335, (_x21335, _x21334, _ctx), _ctx); /*5834*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18923, _ctx);
    kk_box_t _x21336 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21337_3(f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple3__unbox(_x21336, KK_OWNED, _ctx);
  }
  {
    kk_box_t x0_18926;
    kk_function_t _x21340 = kk_function_dup(f, _ctx); /*(5833) -> 5835 5834*/
    kk_box_t _x21339;
    {
      kk_box_t _x0 = t.snd;
      kk_box_dup(_x0, _ctx);
      _x21339 = _x0; /*5833*/
    }
    x0_18926 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21340, (_x21340, _x21339, _ctx), _ctx); /*5834*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18926, _ctx);
      kk_box_t _x21341 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21342_3(f, t, x_18923, _ctx), _ctx); /*3926*/
      return kk_std_core_types__tuple3__unbox(_x21341, KK_OWNED, _ctx);
    }
    {
      kk_box_t x1_18929;
      kk_box_t _x21344;
      {
        kk_box_t _x1 = t.thd;
        kk_box_dup(_x1, _ctx);
        kk_std_core_types__tuple3__drop(t, _ctx);
        _x21344 = _x1; /*5833*/
      }
      x1_18929 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x21344, _ctx), _ctx); /*5834*/
      if (kk_yielding(kk_context())) {
        kk_box_drop(x1_18929, _ctx);
        kk_box_t _x21345 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21346_3(x_18923, x0_18926, _ctx), _ctx); /*3926*/
        return kk_std_core_types__tuple3__unbox(_x21345, KK_OWNED, _ctx);
      }
      {
        return kk_std_core_types__new_dash__lp__comma__comma__rp_(x_18923, x0_18926, x1_18929, _ctx);
      }
    }
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18807_map_fun21351__t_4 {
  struct kk_function_s _base;
  kk_box_t _y_18492;
  kk_box_t _y_18493;
  kk_box_t _y_18494;
};
static kk_box_t kk_std_core__mlift18807_map_fun21351_4(kk_function_t _fself, kk_box_t _b_19633, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18807_map_fun21351_4(kk_box_t _y_18492, kk_box_t _y_18493, kk_box_t _y_18494, kk_context_t* _ctx) {
  struct kk_std_core__mlift18807_map_fun21351__t_4* _self = kk_function_alloc_as(struct kk_std_core__mlift18807_map_fun21351__t_4, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18807_map_fun21351_4, kk_context());
  _self->_y_18492 = _y_18492;
  _self->_y_18493 = _y_18493;
  _self->_y_18494 = _y_18494;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18807_map_fun21351_4(kk_function_t _fself, kk_box_t _b_19633, kk_context_t* _ctx) {
  struct kk_std_core__mlift18807_map_fun21351__t_4* _self = kk_function_as(struct kk_std_core__mlift18807_map_fun21351__t_4*, _fself, _ctx);
  kk_box_t _y_18492 = _self->_y_18492; /* 6121 */
  kk_box_t _y_18493 = _self->_y_18493; /* 6121 */
  kk_box_t _y_18494 = _self->_y_18494; /* 6121 */
  kk_drop_match(_self, {kk_box_dup(_y_18492, _ctx);kk_box_dup(_y_18493, _ctx);kk_box_dup(_y_18494, _ctx);}, {}, _ctx)
  kk_box_t _y_19635_18495 = _b_19633; /*6121*/;
  kk_std_core_types__tuple4_ _x21352 = kk_std_core_types__new_dash__lp__comma__comma__comma__rp_(kk_reuse_null, 0, _y_18492, _y_18493, _y_18494, _y_19635_18495, _ctx); /*(22, 23, 24, 25)*/
  return kk_std_core_types__tuple4__box(_x21352, _ctx);
}

kk_std_core_types__tuple4_ kk_std_core__mlift18807_map_4(kk_box_t _y_18492, kk_box_t _y_18493, kk_function_t f, kk_std_core_types__tuple4_ t, kk_box_t _y_18494, kk_context_t* _ctx) { /* forall<a,b,e> (b, b, f : (a) -> e b, t : (a, a, a, a), b) -> e (b, b, b, b) */ 
  kk_box_t x_18935;
  kk_box_t _x21348;
  {
    struct kk_std_core_types__Tuple4_* _con21349 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
    kk_box_t _pat02 = _con21349->fst;
    kk_box_t _pat12 = _con21349->snd;
    kk_box_t _pat22 = _con21349->thd;
    kk_box_t _x2 = _con21349->field4;
    if kk_likely(kk_datatype_ptr_is_unique(t, _ctx)) {
      kk_box_drop(_pat22, _ctx);
      kk_box_drop(_pat12, _ctx);
      kk_box_drop(_pat02, _ctx);
      kk_datatype_ptr_free(t, _ctx);
    }
    else {
      kk_box_dup(_x2, _ctx);
      kk_datatype_ptr_decref(t, _ctx);
    }
    _x21348 = _x2; /*6120*/
  }
  x_18935 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x21348, _ctx), _ctx); /*6121*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18935, _ctx);
    kk_box_t _x21350 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18807_map_fun21351_4(_y_18492, _y_18493, _y_18494, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple4__unbox(_x21350, KK_OWNED, _ctx);
  }
  {
    return kk_std_core_types__new_dash__lp__comma__comma__comma__rp_(kk_reuse_null, 0, _y_18492, _y_18493, _y_18494, x_18935, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18808_map_fun21357__t_4 {
  struct kk_function_s _base;
  kk_box_t _y_18492;
  kk_box_t _y_18493;
  kk_function_t f;
  kk_std_core_types__tuple4_ t;
};
static kk_box_t kk_std_core__mlift18808_map_fun21357_4(kk_function_t _fself, kk_box_t _b_19637, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18808_map_fun21357_4(kk_box_t _y_18492, kk_box_t _y_18493, kk_function_t f, kk_std_core_types__tuple4_ t, kk_context_t* _ctx) {
  struct kk_std_core__mlift18808_map_fun21357__t_4* _self = kk_function_alloc_as(struct kk_std_core__mlift18808_map_fun21357__t_4, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18808_map_fun21357_4, kk_context());
  _self->_y_18492 = _y_18492;
  _self->_y_18493 = _y_18493;
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18808_map_fun21357_4(kk_function_t _fself, kk_box_t _b_19637, kk_context_t* _ctx) {
  struct kk_std_core__mlift18808_map_fun21357__t_4* _self = kk_function_as(struct kk_std_core__mlift18808_map_fun21357__t_4*, _fself, _ctx);
  kk_box_t _y_18492 = _self->_y_18492; /* 6121 */
  kk_box_t _y_18493 = _self->_y_18493; /* 6121 */
  kk_function_t f = _self->f; /* (6120) -> 6122 6121 */
  kk_std_core_types__tuple4_ t = _self->t; /* (6120, 6120, 6120, 6120) */
  kk_drop_match(_self, {kk_box_dup(_y_18492, _ctx);kk_box_dup(_y_18493, _ctx);kk_function_dup(f, _ctx);kk_std_core_types__tuple4__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_19639_18494 = _b_19637; /*6121*/;
  kk_std_core_types__tuple4_ _x21358 = kk_std_core__mlift18807_map_4(_y_18492, _y_18493, f, t, _y_19639_18494, _ctx); /*(6121, 6121, 6121, 6121)*/
  return kk_std_core_types__tuple4__box(_x21358, _ctx);
}

kk_std_core_types__tuple4_ kk_std_core__mlift18808_map_4(kk_box_t _y_18492, kk_function_t f, kk_std_core_types__tuple4_ t, kk_box_t _y_18493, kk_context_t* _ctx) { /* forall<a,b,e> (b, f : (a) -> e b, t : (a, a, a, a), b) -> e (b, b, b, b) */ 
  kk_box_t x_18941;
  kk_function_t _x21355 = kk_function_dup(f, _ctx); /*(6120) -> 6122 6121*/
  kk_box_t _x21353;
  {
    struct kk_std_core_types__Tuple4_* _con21354 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
    kk_box_t _x1 = _con21354->thd;
    kk_box_dup(_x1, _ctx);
    _x21353 = _x1; /*6120*/
  }
  x_18941 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21355, (_x21355, _x21353, _ctx), _ctx); /*6121*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18941, _ctx);
    kk_box_t _x21356 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18808_map_fun21357_4(_y_18492, _y_18493, f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple4__unbox(_x21356, KK_OWNED, _ctx);
  }
  {
    return kk_std_core__mlift18807_map_4(_y_18492, _y_18493, f, t, x_18941, _ctx);
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18809_map_fun21363__t_4 {
  struct kk_function_s _base;
  kk_box_t _y_18492;
  kk_function_t f;
  kk_std_core_types__tuple4_ t;
};
static kk_box_t kk_std_core__mlift18809_map_fun21363_4(kk_function_t _fself, kk_box_t _b_19641, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18809_map_fun21363_4(kk_box_t _y_18492, kk_function_t f, kk_std_core_types__tuple4_ t, kk_context_t* _ctx) {
  struct kk_std_core__mlift18809_map_fun21363__t_4* _self = kk_function_alloc_as(struct kk_std_core__mlift18809_map_fun21363__t_4, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18809_map_fun21363_4, kk_context());
  _self->_y_18492 = _y_18492;
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18809_map_fun21363_4(kk_function_t _fself, kk_box_t _b_19641, kk_context_t* _ctx) {
  struct kk_std_core__mlift18809_map_fun21363__t_4* _self = kk_function_as(struct kk_std_core__mlift18809_map_fun21363__t_4*, _fself, _ctx);
  kk_box_t _y_18492 = _self->_y_18492; /* 6121 */
  kk_function_t f = _self->f; /* (6120) -> 6122 6121 */
  kk_std_core_types__tuple4_ t = _self->t; /* (6120, 6120, 6120, 6120) */
  kk_drop_match(_self, {kk_box_dup(_y_18492, _ctx);kk_function_dup(f, _ctx);kk_std_core_types__tuple4__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_19643_18493 = _b_19641; /*6121*/;
  kk_std_core_types__tuple4_ _x21364 = kk_std_core__mlift18808_map_4(_y_18492, f, t, _y_19643_18493, _ctx); /*(6121, 6121, 6121, 6121)*/
  return kk_std_core_types__tuple4__box(_x21364, _ctx);
}

kk_std_core_types__tuple4_ kk_std_core__mlift18809_map_4(kk_function_t f, kk_std_core_types__tuple4_ t, kk_box_t _y_18492, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e b, t : (a, a, a, a), b) -> e (b, b, b, b) */ 
  kk_box_t x_18943;
  kk_function_t _x21361 = kk_function_dup(f, _ctx); /*(6120) -> 6122 6121*/
  kk_box_t _x21359;
  {
    struct kk_std_core_types__Tuple4_* _con21360 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
    kk_box_t _x0 = _con21360->snd;
    kk_box_dup(_x0, _ctx);
    _x21359 = _x0; /*6120*/
  }
  x_18943 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21361, (_x21361, _x21359, _ctx), _ctx); /*6121*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18943, _ctx);
    kk_box_t _x21362 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18809_map_fun21363_4(_y_18492, f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple4__unbox(_x21362, KK_OWNED, _ctx);
  }
  {
    return kk_std_core__mlift18808_map_4(_y_18492, f, t, x_18943, _ctx);
  }
}


// lift anonymous function
struct kk_std_core_map_fun21369__t_4 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple4_ t;
};
static kk_box_t kk_std_core_map_fun21369_4(kk_function_t _fself, kk_box_t _b_19645, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21369_4(kk_function_t f, kk_std_core_types__tuple4_ t, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21369__t_4* _self = kk_function_alloc_as(struct kk_std_core_map_fun21369__t_4, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21369_4, kk_context());
  _self->f = f;
  _self->t = t;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21369_4(kk_function_t _fself, kk_box_t _b_19645, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21369__t_4* _self = kk_function_as(struct kk_std_core_map_fun21369__t_4*, _fself, _ctx);
  kk_function_t f = _self->f; /* (6120) -> 6122 6121 */
  kk_std_core_types__tuple4_ t = _self->t; /* (6120, 6120, 6120, 6120) */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple4__dup(t, _ctx);}, {}, _ctx)
  kk_box_t _y_19656_18492 = _b_19645; /*6121*/;
  kk_std_core_types__tuple4_ _x21370 = kk_std_core__mlift18809_map_4(f, t, _y_19656_18492, _ctx); /*(6121, 6121, 6121, 6121)*/
  return kk_std_core_types__tuple4__box(_x21370, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun21375__t_4 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple4_ t;
  kk_box_t x_18945;
};
static kk_box_t kk_std_core_map_fun21375_4(kk_function_t _fself, kk_box_t _b_19647, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21375_4(kk_function_t f, kk_std_core_types__tuple4_ t, kk_box_t x_18945, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21375__t_4* _self = kk_function_alloc_as(struct kk_std_core_map_fun21375__t_4, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21375_4, kk_context());
  _self->f = f;
  _self->t = t;
  _self->x_18945 = x_18945;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21375_4(kk_function_t _fself, kk_box_t _b_19647, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21375__t_4* _self = kk_function_as(struct kk_std_core_map_fun21375__t_4*, _fself, _ctx);
  kk_function_t f = _self->f; /* (6120) -> 6122 6121 */
  kk_std_core_types__tuple4_ t = _self->t; /* (6120, 6120, 6120, 6120) */
  kk_box_t x_18945 = _self->x_18945; /* 6121 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple4__dup(t, _ctx);kk_box_dup(x_18945, _ctx);}, {}, _ctx)
  kk_box_t _y_19657_18493 = _b_19647; /*6121*/;
  kk_std_core_types__tuple4_ _x21376 = kk_std_core__mlift18808_map_4(x_18945, f, t, _y_19657_18493, _ctx); /*(6121, 6121, 6121, 6121)*/
  return kk_std_core_types__tuple4__box(_x21376, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun21381__t_4 {
  struct kk_function_s _base;
  kk_function_t f;
  kk_std_core_types__tuple4_ t;
  kk_box_t x_18945;
  kk_box_t x0_18948;
};
static kk_box_t kk_std_core_map_fun21381_4(kk_function_t _fself, kk_box_t _b_19649, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21381_4(kk_function_t f, kk_std_core_types__tuple4_ t, kk_box_t x_18945, kk_box_t x0_18948, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21381__t_4* _self = kk_function_alloc_as(struct kk_std_core_map_fun21381__t_4, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21381_4, kk_context());
  _self->f = f;
  _self->t = t;
  _self->x_18945 = x_18945;
  _self->x0_18948 = x0_18948;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21381_4(kk_function_t _fself, kk_box_t _b_19649, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21381__t_4* _self = kk_function_as(struct kk_std_core_map_fun21381__t_4*, _fself, _ctx);
  kk_function_t f = _self->f; /* (6120) -> 6122 6121 */
  kk_std_core_types__tuple4_ t = _self->t; /* (6120, 6120, 6120, 6120) */
  kk_box_t x_18945 = _self->x_18945; /* 6121 */
  kk_box_t x0_18948 = _self->x0_18948; /* 6121 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);kk_std_core_types__tuple4__dup(t, _ctx);kk_box_dup(x_18945, _ctx);kk_box_dup(x0_18948, _ctx);}, {}, _ctx)
  kk_box_t _y_19658_18494 = _b_19649; /*6121*/;
  kk_std_core_types__tuple4_ _x21382 = kk_std_core__mlift18807_map_4(x_18945, x0_18948, f, t, _y_19658_18494, _ctx); /*(6121, 6121, 6121, 6121)*/
  return kk_std_core_types__tuple4__box(_x21382, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun21386__t_4 {
  struct kk_function_s _base;
  kk_box_t x_18945;
  kk_box_t x0_18948;
  kk_box_t x1_18951;
};
static kk_box_t kk_std_core_map_fun21386_4(kk_function_t _fself, kk_box_t _b_19651, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21386_4(kk_box_t x_18945, kk_box_t x0_18948, kk_box_t x1_18951, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21386__t_4* _self = kk_function_alloc_as(struct kk_std_core_map_fun21386__t_4, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21386_4, kk_context());
  _self->x_18945 = x_18945;
  _self->x0_18948 = x0_18948;
  _self->x1_18951 = x1_18951;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21386_4(kk_function_t _fself, kk_box_t _b_19651, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21386__t_4* _self = kk_function_as(struct kk_std_core_map_fun21386__t_4*, _fself, _ctx);
  kk_box_t x_18945 = _self->x_18945; /* 6121 */
  kk_box_t x0_18948 = _self->x0_18948; /* 6121 */
  kk_box_t x1_18951 = _self->x1_18951; /* 6121 */
  kk_drop_match(_self, {kk_box_dup(x_18945, _ctx);kk_box_dup(x0_18948, _ctx);kk_box_dup(x1_18951, _ctx);}, {}, _ctx)
  kk_box_t _y_19659_18495 = _b_19651; /*6121*/;
  kk_std_core_types__tuple4_ _x21387 = kk_std_core_types__new_dash__lp__comma__comma__comma__rp_(kk_reuse_null, 0, x_18945, x0_18948, x1_18951, _y_19659_18495, _ctx); /*(22, 23, 24, 25)*/
  return kk_std_core_types__tuple4__box(_x21387, _ctx);
}

kk_std_core_types__tuple4_ kk_std_core_map_4(kk_std_core_types__tuple4_ t, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (t : (a, a, a, a), f : (a) -> e b) -> e (b, b, b, b) */ 
  kk_box_t x_18945;
  kk_function_t _x21367 = kk_function_dup(f, _ctx); /*(6120) -> 6122 6121*/
  kk_box_t _x21365;
  {
    struct kk_std_core_types__Tuple4_* _con21366 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
    kk_box_t _x = _con21366->fst;
    kk_box_dup(_x, _ctx);
    _x21365 = _x; /*6120*/
  }
  x_18945 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21367, (_x21367, _x21365, _ctx), _ctx); /*6121*/
  if (kk_yielding(kk_context())) {
    kk_box_drop(x_18945, _ctx);
    kk_box_t _x21368 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21369_4(f, t, _ctx), _ctx); /*3926*/
    return kk_std_core_types__tuple4__unbox(_x21368, KK_OWNED, _ctx);
  }
  {
    kk_box_t x0_18948;
    kk_function_t _x21373 = kk_function_dup(f, _ctx); /*(6120) -> 6122 6121*/
    kk_box_t _x21371;
    {
      struct kk_std_core_types__Tuple4_* _con21372 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
      kk_box_t _x0 = _con21372->snd;
      kk_box_dup(_x0, _ctx);
      _x21371 = _x0; /*6120*/
    }
    x0_18948 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21373, (_x21373, _x21371, _ctx), _ctx); /*6121*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_18948, _ctx);
      kk_box_t _x21374 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21375_4(f, t, x_18945, _ctx), _ctx); /*3926*/
      return kk_std_core_types__tuple4__unbox(_x21374, KK_OWNED, _ctx);
    }
    {
      kk_box_t x1_18951;
      kk_function_t _x21379 = kk_function_dup(f, _ctx); /*(6120) -> 6122 6121*/
      kk_box_t _x21377;
      {
        struct kk_std_core_types__Tuple4_* _con21378 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
        kk_box_t _x1 = _con21378->thd;
        kk_box_dup(_x1, _ctx);
        _x21377 = _x1; /*6120*/
      }
      x1_18951 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21379, (_x21379, _x21377, _ctx), _ctx); /*6121*/
      if (kk_yielding(kk_context())) {
        kk_box_drop(x1_18951, _ctx);
        kk_box_t _x21380 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21381_4(f, t, x_18945, x0_18948, _ctx), _ctx); /*3926*/
        return kk_std_core_types__tuple4__unbox(_x21380, KK_OWNED, _ctx);
      }
      {
        kk_box_t x2_18954;
        kk_box_t _x21383;
        {
          struct kk_std_core_types__Tuple4_* _con21384 = kk_std_core_types__as_dash__lp__comma__comma__comma__rp_(t, _ctx);
          kk_box_t _pat020 = _con21384->fst;
          kk_box_t _pat12 = _con21384->snd;
          kk_box_t _pat22 = _con21384->thd;
          kk_box_t _x2 = _con21384->field4;
          if kk_likely(kk_datatype_ptr_is_unique(t, _ctx)) {
            kk_box_drop(_pat22, _ctx);
            kk_box_drop(_pat12, _ctx);
            kk_box_drop(_pat020, _ctx);
            kk_datatype_ptr_free(t, _ctx);
          }
          else {
            kk_box_dup(_x2, _ctx);
            kk_datatype_ptr_decref(t, _ctx);
          }
          _x21383 = _x2; /*6120*/
        }
        x2_18954 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), f, (f, _x21383, _ctx), _ctx); /*6121*/
        if (kk_yielding(kk_context())) {
          kk_box_drop(x2_18954, _ctx);
          kk_box_t _x21385 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21386_4(x_18945, x0_18948, x1_18951, _ctx), _ctx); /*3926*/
          return kk_std_core_types__tuple4__unbox(_x21385, KK_OWNED, _ctx);
        }
        {
          return kk_std_core_types__new_dash__lp__comma__comma__comma__rp_(kk_reuse_null, 0, x_18945, x0_18948, x1_18951, x2_18954, _ctx);
        }
      }
    }
  }
}
 
// Apply a function `f` to each character in a string


// lift anonymous function
struct kk_std_core_map_fun21388__t_6 {
  struct kk_function_s _base;
  kk_function_t f;
};
static kk_box_t kk_std_core_map_fun21388_6(kk_function_t _fself, kk_box_t _b_19662, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21388_6(kk_function_t f, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21388__t_6* _self = kk_function_alloc_as(struct kk_std_core_map_fun21388__t_6, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21388_6, kk_context());
  _self->f = f;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21388_6(kk_function_t _fself, kk_box_t _b_19662, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21388__t_6* _self = kk_function_as(struct kk_std_core_map_fun21388__t_6*, _fself, _ctx);
  kk_function_t f = _self->f; /* (char) -> 6589 char */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);}, {}, _ctx)
  kk_char_t _x21389;
  kk_char_t _x21390 = kk_char_unbox(_b_19662, KK_OWNED, _ctx); /*char*/
  _x21389 = kk_function_call(kk_char_t, (kk_function_t, kk_char_t, kk_context_t*), f, (f, _x21390, _ctx), _ctx); /*char*/
  return kk_char_box(_x21389, _ctx);
}


// lift anonymous function
struct kk_std_core_map_fun21392__t_6 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_map_fun21392_6(kk_function_t _fself, kk_box_t _b_19666, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21392_6(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_map_fun21392_6, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_map_fun21392_6(kk_function_t _fself, kk_box_t _b_19666, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x21393;
  kk_std_core__list _x21394 = kk_std_core__list_unbox(_b_19666, KK_OWNED, _ctx); /*list<char>*/
  _x21393 = kk_std_core_string_2(_x21394, _ctx); /*string*/
  return kk_string_box(_x21393);
}

kk_string_t kk_std_core_map_6(kk_string_t s, kk_function_t f, kk_context_t* _ctx) { /* forall<e> (s : string, f : (char) -> e char) -> e string */ 
  kk_std_core__list xs_17463 = kk_std_core_list_6(s, _ctx); /*list<char>*/;
  kk_std_core__list x_18961;
  if (kk_std_core__is_Nil(xs_17463, _ctx)) {
    kk_function_drop(f, _ctx);
    x_18961 = kk_std_core__new_Nil(_ctx); /*list<char>*/
  }
  else {
    x_18961 = kk_std_core__unroll17333_map_5(xs_17463, kk_std_core_new_map_fun21388_6(f, _ctx), _ctx); /*list<char>*/
  }
  if (kk_yielding(kk_context())) {
    kk_std_core__list_drop(x_18961, _ctx);
    kk_box_t _x21391 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21392_6(_ctx), _ctx); /*3926*/
    return kk_string_unbox(_x21391);
  }
  {
    return kk_std_core_string_2(x_18961, _ctx);
  }
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18810_lift18300_map_7(kk_ssize_t end18053, kk_function_t f, kk_ssize_t i18054, kk_vector_t v, kk_vector_t w, kk_box_t _y_18498, kk_context_t* _ctx) { /* forall<a,b,e> (end18053 : ssize_t, f : (a) -> e b, i18054 : ssize_t, v : vector<a>, w : vector<b>, b) -> e () */ 
  kk_unit_t __18056 = kk_Unit;
  kk_vector_t _x21395 = kk_vector_dup(w, _ctx); /*vector<6638>*/
  kk_vector_unsafe_assign(_x21395,i18054,_y_18498,kk_context());
  kk_ssize_t i0_1744818057 = kk_std_core_incr_1(i18054, _ctx); /*ssize_t*/;
  kk_std_core__lift18300_map_7(f, v, w, end18053, i0_1744818057, _ctx); return kk_Unit;
}
 
// lifted local: map.7, .spec.18059
// specialized: std/core/.lift17317-forz, on parameters action18052, using:
// action18052 = fn<(e :: E)>(i0: ssize_t){
//   val x.17873 : a
//         = std/core/types/.open<(total :: E),(e :: E),(v : (vector :: V -> V)<a>, index : ssize_t) -> (total :: E) a,(v : (vector :: V -> V)<a>, index : ssize_t) -> (e :: E) a>((std/core/unsafe-idx<a>))(v, i0);
//   std/core/types/.open<(total :: E),(e :: E),(v : (vector :: V -> V)<a>, i : ssize_t, x : a) -> (total :: E) (),(v : (vector :: V -> V)<a>, i : ssize_t, x : a) -> (e :: E) ()>((std/core/unsafe-assign<a>))(w, i0, (f(x.17873)));
// }


// lift anonymous function
struct kk_std_core__lift18300_map_fun21398__t_7 {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_vector_t v0;
  kk_vector_t w0;
  kk_ssize_t end180530;
  kk_ssize_t i180540;
};
static kk_box_t kk_std_core__lift18300_map_fun21398_7(kk_function_t _fself, kk_box_t _b_19669, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18300_map_fun21398_7(kk_function_t f0, kk_vector_t v0, kk_vector_t w0, kk_ssize_t end180530, kk_ssize_t i180540, kk_context_t* _ctx) {
  struct kk_std_core__lift18300_map_fun21398__t_7* _self = kk_function_alloc_as(struct kk_std_core__lift18300_map_fun21398__t_7, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18300_map_fun21398_7, kk_context());
  _self->f0 = f0;
  _self->v0 = v0;
  _self->w0 = w0;
  _self->end180530 = end180530;
  _self->i180540 = i180540;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18300_map_fun21398_7(kk_function_t _fself, kk_box_t _b_19669, kk_context_t* _ctx) {
  struct kk_std_core__lift18300_map_fun21398__t_7* _self = kk_function_as(struct kk_std_core__lift18300_map_fun21398__t_7*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (6637) -> 6639 6638 */
  kk_vector_t v0 = _self->v0; /* vector<6637> */
  kk_vector_t w0 = _self->w0; /* vector<6638> */
  kk_ssize_t end180530 = _self->end180530; /* ssize_t */
  kk_ssize_t i180540 = _self->i180540; /* ssize_t */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_vector_dup(v0, _ctx);kk_vector_dup(w0, _ctx);;;}, {}, _ctx)
  kk_box_t _y_19671_184980 = _b_19669; /*6638*/;
  kk_unit_t _x21399 = kk_Unit;
  kk_std_core__mlift18810_lift18300_map_7(end180530, f0, i180540, v0, w0, _y_19671_184980, _ctx);
  return kk_unit_box(_x21399);
}

kk_unit_t kk_std_core__lift18300_map_7(kk_function_t f0, kk_vector_t v0, kk_vector_t w0, kk_ssize_t end180530, kk_ssize_t i180540, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e b, v : vector<a>, w : vector<b>, end18053 : ssize_t, i18054 : ssize_t) -> e () */ 
  kk__tailcall: ;
  bool _match_20935 = (i180540 <= end180530); /*bool*/;
  if (_match_20935) {
    kk_box_t x_17873 = kk_vector_at_borrow(v0,i180540,kk_context()); /*6637*/;
    kk_box_t x_18963;
    kk_function_t _x21396 = kk_function_dup(f0, _ctx); /*(6637) -> 6639 6638*/
    x_18963 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21396, (_x21396, x_17873, _ctx), _ctx); /*6638*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_18963, _ctx);
      kk_box_t _x21397 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18300_map_fun21398_7(f0, v0, w0, end180530, i180540, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21397); return kk_Unit;
    }
    {
      kk_unit_t __180560 = kk_Unit;
      kk_vector_t _x21400 = kk_vector_dup(w0, _ctx); /*vector<6638>*/
      kk_vector_unsafe_assign(_x21400,i180540,x_18963,kk_context());
      kk_ssize_t i0_17448180570 = kk_std_core_incr_1(i180540, _ctx); /*ssize_t*/;
      { // tailcall
        i180540 = i0_17448180570;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_vector_drop(w0, _ctx);
    kk_vector_drop(v0, _ctx);
    kk_function_drop(f0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Apply a total function `f` to each element in a vector `v`


// lift anonymous function
struct kk_std_core_map_fun21407__t_7 {
  struct kk_function_s _base;
  kk_vector_t w;
};
static kk_box_t kk_std_core_map_fun21407_7(kk_function_t _fself, kk_box_t _b_19673, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_map_fun21407_7(kk_vector_t w, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21407__t_7* _self = kk_function_alloc_as(struct kk_std_core_map_fun21407__t_7, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_map_fun21407_7, kk_context());
  _self->w = w;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_map_fun21407_7(kk_function_t _fself, kk_box_t _b_19673, kk_context_t* _ctx) {
  struct kk_std_core_map_fun21407__t_7* _self = kk_function_as(struct kk_std_core_map_fun21407__t_7*, _fself, _ctx);
  kk_vector_t w = _self->w; /* vector<6638> */
  kk_drop_match(_self, {kk_vector_dup(w, _ctx);}, {}, _ctx)
  kk_unit_t wild___19675 = kk_Unit;
  kk_unit_unbox(_b_19673);
  return kk_vector_box(w, _ctx);
}

kk_vector_t kk_std_core_map_7(kk_vector_t v, kk_function_t f, kk_context_t* _ctx) { /* forall<a,b,e> (v : vector<a>, f : (a) -> e b) -> e vector<b> */ 
  kk_vector_t w;
  kk_ssize_t _x21401;
  kk_integer_t _x21402;
  kk_ssize_t _x21403 = kk_vector_len_borrow(v,kk_context()); /*ssize_t*/
  _x21402 = kk_integer_from_ssize_t(_x21403,kk_context()); /*int*/
  _x21401 = kk_std_core_ssize__t(_x21402, _ctx); /*ssize_t*/
  w = kk_vector_alloc_uninit(_x21401,NULL,kk_context()); /*vector<6638>*/
  kk_ssize_t start0_17467 = (KK_IZ(0)); /*ssize_t*/;
  kk_ssize_t end_17468;
  kk_ssize_t _x21404 = kk_vector_len_borrow(v,kk_context()); /*ssize_t*/
  end_17468 = kk_std_core_decr_1(_x21404, _ctx); /*ssize_t*/
  kk_unit_t x_18966 = kk_Unit;
  kk_vector_t _x21405 = kk_vector_dup(w, _ctx); /*vector<6638>*/
  kk_std_core__lift18300_map_7(f, v, _x21405, end_17468, start0_17467, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x21406 = kk_std_core_hnd_yield_extend(kk_std_core_new_map_fun21407_7(w, _ctx), _ctx); /*3926*/
    return kk_vector_unbox(_x21406, _ctx);
  }
  {
    return w;
  }
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18812_lift17319_for(kk_function_t action, kk_integer_t end, kk_integer_t i, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<e> (action : (int) -> e (), end : int, i : int, wild_ : ()) -> e () */ 
  kk_integer_t i0_17470 = kk_integer_add_small_const(i, 1, _ctx); /*int*/;
  kk_std_core__lift17319_for(action, end, i0_17470, _ctx); return kk_Unit;
}
 
// lifted local: for, rep


// lift anonymous function
struct kk_std_core__lift17319_for_fun21411__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_integer_t end0;
  kk_integer_t i0;
};
static kk_box_t kk_std_core__lift17319_for_fun21411(kk_function_t _fself, kk_box_t _b_19677, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift17319_for_fun21411(kk_function_t action0, kk_integer_t end0, kk_integer_t i0, kk_context_t* _ctx) {
  struct kk_std_core__lift17319_for_fun21411__t* _self = kk_function_alloc_as(struct kk_std_core__lift17319_for_fun21411__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift17319_for_fun21411, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift17319_for_fun21411(kk_function_t _fself, kk_box_t _b_19677, kk_context_t* _ctx) {
  struct kk_std_core__lift17319_for_fun21411__t* _self = kk_function_as(struct kk_std_core__lift17319_for_fun21411__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (int) -> 7419 () */
  kk_integer_t end0 = _self->end0; /* int */
  kk_integer_t i0 = _self->i0; /* int */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_integer_dup(end0, _ctx);kk_integer_dup(i0, _ctx);}, {}, _ctx)
  kk_unit_t wild__0_19679 = kk_Unit;
  kk_unit_unbox(_b_19677);
  kk_unit_t _x21412 = kk_Unit;
  kk_std_core__mlift18812_lift17319_for(action0, end0, i0, wild__0_19679, _ctx);
  return kk_unit_box(_x21412);
}

kk_unit_t kk_std_core__lift17319_for(kk_function_t action0, kk_integer_t end0, kk_integer_t i0, kk_context_t* _ctx) { /* forall<e> (action : (int) -> e (), end : int, i : int) -> e () */ 
  kk__tailcall: ;
  bool _match_20932 = kk_integer_lte_borrow(i0,end0,kk_context()); /*bool*/;
  if (_match_20932) {
    kk_unit_t x_18971 = kk_Unit;
    kk_function_t _x21409 = kk_function_dup(action0, _ctx); /*(int) -> 7419 ()*/
    kk_integer_t _x21408 = kk_integer_dup(i0, _ctx); /*int*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_context_t*), _x21409, (_x21409, _x21408, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21410 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift17319_for_fun21411(action0, end0, i0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21410); return kk_Unit;
    }
    {
      kk_integer_t i0_174700 = kk_integer_add_small_const(i0, 1, _ctx); /*int*/;
      { // tailcall
        i0 = i0_174700;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i0, _ctx);
    kk_integer_drop(end0, _ctx);
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18813_lift18301_repeat_1(kk_function_t action, kk_integer_t end18062, kk_integer_t i18063, kk_unit_t wild__18065, kk_context_t* _ctx) { /* forall<e> (action : () -> e (), end18062 : int, i18063 : int, wild_18065 : ()) -> e () */ 
  kk_integer_t i0_1747018067 = kk_integer_add_small_const(i18063, 1, _ctx); /*int*/;
  kk_std_core__lift18301_repeat_1(action, end18062, i0_1747018067, _ctx); return kk_Unit;
}
 
// lifted local: repeat.1, .spec.18069
// specialized: std/core/.lift17319-for, on parameters action18061, using:
// action18061 = fn<(e :: E)>(i0: int){
//   action();
// }


// lift anonymous function
struct kk_std_core__lift18301_repeat_fun21418__t_1 {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_integer_t end180620;
  kk_integer_t i180630;
};
static kk_box_t kk_std_core__lift18301_repeat_fun21418_1(kk_function_t _fself, kk_box_t _b_19681, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18301_repeat_fun21418_1(kk_function_t action0, kk_integer_t end180620, kk_integer_t i180630, kk_context_t* _ctx) {
  struct kk_std_core__lift18301_repeat_fun21418__t_1* _self = kk_function_alloc_as(struct kk_std_core__lift18301_repeat_fun21418__t_1, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18301_repeat_fun21418_1, kk_context());
  _self->action0 = action0;
  _self->end180620 = end180620;
  _self->i180630 = i180630;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18301_repeat_fun21418_1(kk_function_t _fself, kk_box_t _b_19681, kk_context_t* _ctx) {
  struct kk_std_core__lift18301_repeat_fun21418__t_1* _self = kk_function_as(struct kk_std_core__lift18301_repeat_fun21418__t_1*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* () -> 7438 () */
  kk_integer_t end180620 = _self->end180620; /* int */
  kk_integer_t i180630 = _self->i180630; /* int */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_integer_dup(end180620, _ctx);kk_integer_dup(i180630, _ctx);}, {}, _ctx)
  kk_unit_t wild__180650_19683 = kk_Unit;
  kk_unit_unbox(_b_19681);
  kk_unit_t _x21419 = kk_Unit;
  kk_std_core__mlift18813_lift18301_repeat_1(action0, end180620, i180630, wild__180650_19683, _ctx);
  return kk_unit_box(_x21419);
}

kk_unit_t kk_std_core__lift18301_repeat_1(kk_function_t action0, kk_integer_t end180620, kk_integer_t i180630, kk_context_t* _ctx) { /* forall<e> (action : () -> e (), end18062 : int, i18063 : int) -> e () */ 
  kk__tailcall: ;
  bool _match_20930 = kk_integer_lte_borrow(i180630,end180620,kk_context()); /*bool*/;
  if (_match_20930) {
    kk_unit_t x_18974 = kk_Unit;
    kk_function_t _x21416 = kk_function_dup(action0, _ctx); /*() -> 7438 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), _x21416, (_x21416, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21417 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18301_repeat_fun21418_1(action0, end180620, i180630, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21417); return kk_Unit;
    }
    {
      kk_integer_t i0_17470180670 = kk_integer_add_small_const(i180630, 1, _ctx); /*int*/;
      { // tailcall
        i180630 = i0_17470180670;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i180630, _ctx);
    kk_integer_drop(end180620, _ctx);
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Right-align a string to width `width`  using `fill`  (default is a space) to fill from the left.

kk_string_t kk_std_core_pad_left(kk_string_t s, kk_integer_t width, kk_std_core_types__optional fill, kk_context_t* _ctx) { /* (s : string, width : int, fill : optional<char>) -> string */ 
  kk_integer_t n;
  kk_string_t _x21421 = kk_string_dup(s, _ctx); /*string*/
  n = kk_string_len_int(_x21421,kk_context()); /*int*/
  bool _match_20929 = kk_integer_lte_borrow(width,n,kk_context()); /*bool*/;
  if (_match_20929) {
    kk_integer_drop(n, _ctx);
    kk_std_core_types__optional_drop(fill, _ctx);
    return s;
  }
  {
    kk_string_t s0_17476;
    kk_char_t _x21422;
    if (kk_std_core_types__is_Optional(fill, _ctx)) {
      kk_box_t _box_x19684 = fill._cons.Optional.value;
      kk_char_t _fill_7448 = kk_char_unbox(_box_x19684, KK_BORROWED, _ctx);
      kk_std_core_types__optional_drop(fill, _ctx);
      _x21422 = _fill_7448; /*char*/
    }
    else {
      kk_std_core_types__optional_drop(fill, _ctx);
      _x21422 = ' '; /*char*/
    }
    s0_17476 = kk_std_core_string(_x21422, _ctx); /*string*/
    kk_integer_t n0_17477;
    kk_integer_t _x21423 = kk_integer_dup(width, _ctx); /*int*/
    n0_17477 = kk_integer_sub(_x21423,n,kk_context()); /*int*/
    kk_string_t _x21424;
    kk_ssize_t _x21425 = kk_std_core_ssize__t(n0_17477, _ctx); /*ssize_t*/
    _x21424 = kk_std_core_repeatz(s0_17476, _x21425, _ctx); /*string*/
    return kk_std_core__lp__plus__plus__1_rp_(_x21424, s, _ctx);
  }
}
 
// Show an `:int` as a hexadecimal value.
// The `width`  parameter specifies how wide the hex value is where `"0"`  is used to align.
// The `use-capitals` parameter (= `True`) determines if captical letters should be used to display the hexadecimal digits.
// The `pre` (=`"0x"`) is an optional prefix for the number (goes between the sign and the number).

kk_string_t kk_std_core_show_hex(kk_integer_t i, kk_std_core_types__optional width, kk_std_core_types__optional use_capitals, kk_std_core_types__optional pre, kk_context_t* _ctx) { /* (i : int, width : optional<int>, use-capitals : optional<bool>, pre : optional<string>) -> string */ 
  kk_string_t s_17480;
  kk_integer_t _x21426;
  kk_integer_t _x21427 = kk_integer_dup(i, _ctx); /*int*/
  _x21426 = kk_integer_abs(_x21427,kk_context()); /*int*/
  bool _x21428;
  if (kk_std_core_types__is_Optional(use_capitals, _ctx)) {
    kk_box_t _box_x19685 = use_capitals._cons.Optional.value;
    bool _use_capitals_7592 = kk_bool_unbox(_box_x19685);
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x21428 = _use_capitals_7592; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(use_capitals, _ctx);
    _x21428 = true; /*bool*/
  }
  s_17480 = kk_std_core_int_show_hex(_x21426, _x21428, _ctx); /*string*/
  kk_integer_t n;
  kk_string_t _x21429 = kk_string_dup(s_17480, _ctx); /*string*/
  n = kk_string_len_int(_x21429,kk_context()); /*int*/
  kk_string_t _x21430;
  bool _match_20927;
  bool _brw_20928 = kk_integer_lt_borrow(i,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  kk_integer_drop(i, _ctx);
  _match_20927 = _brw_20928; /*bool*/
  if (_match_20927) {
    kk_define_string_literal(, _s21431, 1, "-", _ctx)
    _x21430 = kk_string_dup(_s21431, _ctx); /*string*/
  }
  else {
    _x21430 = kk_string_empty(); /*string*/
  }
  kk_string_t _x21433;
  kk_string_t _x21434;
  if (kk_std_core_types__is_Optional(pre, _ctx)) {
    kk_box_t _box_x19686 = pre._cons.Optional.value;
    kk_string_t _pre_7596 = kk_string_unbox(_box_x19686);
    kk_string_dup(_pre_7596, _ctx);
    kk_std_core_types__optional_drop(pre, _ctx);
    _x21434 = _pre_7596; /*string*/
  }
  else {
    kk_std_core_types__optional_drop(pre, _ctx);
    kk_define_string_literal(, _s21435, 2, "0x", _ctx)
    _x21434 = kk_string_dup(_s21435, _ctx); /*string*/
  }
  kk_string_t _x21436;
  bool _match_20924;
  kk_integer_t _brw_20925;
  if (kk_std_core_types__is_Optional(width, _ctx)) {
    kk_box_t _box_x19687 = width._cons.Optional.value;
    kk_integer_t _width_7588 = kk_integer_unbox(_box_x19687, _ctx);
    kk_integer_dup(_width_7588, _ctx);
    _brw_20925 = _width_7588; /*int*/
  }
  else {
    _brw_20925 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_20926 = kk_integer_lte_borrow(_brw_20925,n,kk_context()); /*bool*/;
  kk_integer_drop(_brw_20925, _ctx);
  _match_20924 = _brw_20926; /*bool*/
  if (_match_20924) {
    kk_std_core_types__optional_drop(width, _ctx);
    kk_integer_drop(n, _ctx);
    _x21436 = s_17480; /*string*/
  }
  else {
    kk_string_t s0_17483 = kk_std_core_string('0', _ctx); /*string*/;
    kk_integer_t n0_17484;
    kk_integer_t _x21437;
    if (kk_std_core_types__is_Optional(width, _ctx)) {
      kk_box_t _box_x19688 = width._cons.Optional.value;
      kk_integer_t _width_75880 = kk_integer_unbox(_box_x19688, _ctx);
      kk_integer_dup(_width_75880, _ctx);
      kk_std_core_types__optional_drop(width, _ctx);
      _x21437 = _width_75880; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(width, _ctx);
      _x21437 = kk_integer_from_small(1); /*int*/
    }
    n0_17484 = kk_integer_sub(_x21437,n,kk_context()); /*int*/
    kk_string_t _x21438;
    kk_ssize_t _x21439 = kk_std_core_ssize__t(n0_17484, _ctx); /*ssize_t*/
    _x21438 = kk_std_core_repeatz(s0_17483, _x21439, _ctx); /*string*/
    _x21436 = kk_std_core__lp__plus__plus__1_rp_(_x21438, s_17480, _ctx); /*string*/
  }
  _x21433 = kk_std_core__lp__plus__plus__1_rp_(_x21434, _x21436, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x21430, _x21433, _ctx);
}
 
// Show a character as a string

kk_string_t kk_std_core_show_char(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> string */ 
  bool _match_20871 = (c < (' ')); /*bool*/;
  if (_match_20871) {
    bool _match_20898 = (c == 0x000A); /*bool*/;
    if (_match_20898) {
      kk_define_string_literal(, _s21445, 2, "\\n", _ctx)
      return kk_string_dup(_s21445, _ctx);
    }
    {
      bool _match_20899 = (c == 0x000D); /*bool*/;
      if (_match_20899) {
        kk_define_string_literal(, _s21446, 2, "\\r", _ctx)
        return kk_string_dup(_s21446, _ctx);
      }
      {
        bool _match_20900 = (c == 0x0009); /*bool*/;
        if (_match_20900) {
          kk_define_string_literal(, _s21447, 2, "\\t", _ctx)
          return kk_string_dup(_s21447, _ctx);
        }
        {
          bool _match_20901;
          kk_integer_t _brw_20918 = kk_integer_from_int(c,kk_context()); /*int*/;
          bool _brw_20919 = kk_integer_lte_borrow(_brw_20918,(kk_integer_from_small(255)),kk_context()); /*bool*/;
          kk_integer_drop(_brw_20918, _ctx);
          _match_20901 = _brw_20919; /*bool*/
          if (_match_20901) {
            kk_integer_t _arg_8042 = kk_integer_from_int(c,kk_context()); /*int*/;
            kk_string_t s_17495;
            kk_integer_t _x21448;
            kk_integer_t _x21449 = kk_integer_dup(_arg_8042, _ctx); /*int*/
            _x21448 = kk_integer_abs(_x21449,kk_context()); /*int*/
            bool _x21450;
            kk_std_core_types__optional _match_20917 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
            if (kk_std_core_types__is_Optional(_match_20917, _ctx)) {
              kk_box_t _box_x19689 = _match_20917._cons.Optional.value;
              bool _use_capitals_7592 = kk_bool_unbox(_box_x19689);
              kk_std_core_types__optional_drop(_match_20917, _ctx);
              _x21450 = _use_capitals_7592; /*bool*/
            }
            else {
              kk_std_core_types__optional_drop(_match_20917, _ctx);
              _x21450 = true; /*bool*/
            }
            s_17495 = kk_std_core_int_show_hex(_x21448, _x21450, _ctx); /*string*/
            kk_integer_t n;
            kk_string_t _x21451 = kk_string_dup(s_17495, _ctx); /*string*/
            n = kk_string_len_int(_x21451,kk_context()); /*int*/
            kk_string_t _x21452;
            kk_define_string_literal(, _s21453, 2, "\\x", _ctx)
            _x21452 = kk_string_dup(_s21453, _ctx); /*string*/
            kk_string_t _x21454;
            kk_string_t _x21455;
            bool _match_20915;
            bool _brw_20916 = kk_integer_lt_borrow(_arg_8042,(kk_integer_from_small(0)),kk_context()); /*bool*/;
            kk_integer_drop(_arg_8042, _ctx);
            _match_20915 = _brw_20916; /*bool*/
            if (_match_20915) {
              kk_define_string_literal(, _s21456, 1, "-", _ctx)
              _x21455 = kk_string_dup(_s21456, _ctx); /*string*/
            }
            else {
              _x21455 = kk_string_empty(); /*string*/
            }
            kk_string_t _x21458;
            kk_string_t _x21459 = kk_string_empty(); /*string*/
            kk_string_t _x21461;
            bool _match_20914 = kk_integer_lte_borrow((kk_integer_from_small(2)),n,kk_context()); /*bool*/;
            if (_match_20914) {
              kk_integer_drop(n, _ctx);
              _x21461 = s_17495; /*string*/
            }
            else {
              kk_string_t s0_17498 = kk_std_core_string('0', _ctx); /*string*/;
              kk_integer_t n0_17499 = kk_integer_sub((kk_integer_from_small(2)),n,kk_context()); /*int*/;
              kk_string_t _x21462;
              kk_ssize_t _x21463 = kk_std_core_ssize__t(n0_17499, _ctx); /*ssize_t*/
              _x21462 = kk_std_core_repeatz(s0_17498, _x21463, _ctx); /*string*/
              _x21461 = kk_std_core__lp__plus__plus__1_rp_(_x21462, s_17495, _ctx); /*string*/
            }
            _x21458 = kk_std_core__lp__plus__plus__1_rp_(_x21459, _x21461, _ctx); /*string*/
            _x21454 = kk_std_core__lp__plus__plus__1_rp_(_x21455, _x21458, _ctx); /*string*/
            return kk_std_core__lp__plus__plus__1_rp_(_x21452, _x21454, _ctx);
          }
          {
            bool _match_20902;
            kk_integer_t _brw_20912 = kk_integer_from_int(c,kk_context()); /*int*/;
            kk_integer_t _brw_20911 = kk_integer_from_int(65535, _ctx); /*int*/;
            bool _brw_20913 = kk_integer_lte_borrow(_brw_20912,_brw_20911,kk_context()); /*bool*/;
            kk_integer_drop(_brw_20912, _ctx);
            kk_integer_drop(_brw_20911, _ctx);
            _match_20902 = _brw_20913; /*bool*/
            if (_match_20902) {
              kk_integer_t _arg_8140 = kk_integer_from_int(c,kk_context()); /*int*/;
              kk_string_t s1_17506;
              kk_integer_t _x21464;
              kk_integer_t _x21465 = kk_integer_dup(_arg_8140, _ctx); /*int*/
              _x21464 = kk_integer_abs(_x21465,kk_context()); /*int*/
              bool _x21466;
              kk_std_core_types__optional _match_20910 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
              if (kk_std_core_types__is_Optional(_match_20910, _ctx)) {
                kk_box_t _box_x19690 = _match_20910._cons.Optional.value;
                bool _use_capitals_75920 = kk_bool_unbox(_box_x19690);
                kk_std_core_types__optional_drop(_match_20910, _ctx);
                _x21466 = _use_capitals_75920; /*bool*/
              }
              else {
                kk_std_core_types__optional_drop(_match_20910, _ctx);
                _x21466 = true; /*bool*/
              }
              s1_17506 = kk_std_core_int_show_hex(_x21464, _x21466, _ctx); /*string*/
              kk_integer_t n1;
              kk_string_t _x21467 = kk_string_dup(s1_17506, _ctx); /*string*/
              n1 = kk_string_len_int(_x21467,kk_context()); /*int*/
              kk_string_t _x21468;
              kk_define_string_literal(, _s21469, 2, "\\u", _ctx)
              _x21468 = kk_string_dup(_s21469, _ctx); /*string*/
              kk_string_t _x21470;
              kk_string_t _x21471;
              bool _match_20908;
              bool _brw_20909 = kk_integer_lt_borrow(_arg_8140,(kk_integer_from_small(0)),kk_context()); /*bool*/;
              kk_integer_drop(_arg_8140, _ctx);
              _match_20908 = _brw_20909; /*bool*/
              if (_match_20908) {
                kk_define_string_literal(, _s21472, 1, "-", _ctx)
                _x21471 = kk_string_dup(_s21472, _ctx); /*string*/
              }
              else {
                _x21471 = kk_string_empty(); /*string*/
              }
              kk_string_t _x21474;
              kk_string_t _x21475 = kk_string_empty(); /*string*/
              kk_string_t _x21477;
              bool _match_20907 = kk_integer_lte_borrow((kk_integer_from_small(4)),n1,kk_context()); /*bool*/;
              if (_match_20907) {
                kk_integer_drop(n1, _ctx);
                _x21477 = s1_17506; /*string*/
              }
              else {
                kk_string_t s2_17509 = kk_std_core_string('0', _ctx); /*string*/;
                kk_integer_t n2_17510 = kk_integer_sub((kk_integer_from_small(4)),n1,kk_context()); /*int*/;
                kk_string_t _x21478;
                kk_ssize_t _x21479 = kk_std_core_ssize__t(n2_17510, _ctx); /*ssize_t*/
                _x21478 = kk_std_core_repeatz(s2_17509, _x21479, _ctx); /*string*/
                _x21477 = kk_std_core__lp__plus__plus__1_rp_(_x21478, s1_17506, _ctx); /*string*/
              }
              _x21474 = kk_std_core__lp__plus__plus__1_rp_(_x21475, _x21477, _ctx); /*string*/
              _x21470 = kk_std_core__lp__plus__plus__1_rp_(_x21471, _x21474, _ctx); /*string*/
              return kk_std_core__lp__plus__plus__1_rp_(_x21468, _x21470, _ctx);
            }
            {
              kk_integer_t _arg_8194 = kk_integer_from_int(c,kk_context()); /*int*/;
              kk_string_t s3_17517;
              kk_integer_t _x21480;
              kk_integer_t _x21481 = kk_integer_dup(_arg_8194, _ctx); /*int*/
              _x21480 = kk_integer_abs(_x21481,kk_context()); /*int*/
              bool _x21482;
              kk_std_core_types__optional _match_20906 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
              if (kk_std_core_types__is_Optional(_match_20906, _ctx)) {
                kk_box_t _box_x19691 = _match_20906._cons.Optional.value;
                bool _use_capitals_75921 = kk_bool_unbox(_box_x19691);
                kk_std_core_types__optional_drop(_match_20906, _ctx);
                _x21482 = _use_capitals_75921; /*bool*/
              }
              else {
                kk_std_core_types__optional_drop(_match_20906, _ctx);
                _x21482 = true; /*bool*/
              }
              s3_17517 = kk_std_core_int_show_hex(_x21480, _x21482, _ctx); /*string*/
              kk_integer_t n3;
              kk_string_t _x21483 = kk_string_dup(s3_17517, _ctx); /*string*/
              n3 = kk_string_len_int(_x21483,kk_context()); /*int*/
              kk_string_t _x21484;
              kk_define_string_literal(, _s21485, 2, "\\U", _ctx)
              _x21484 = kk_string_dup(_s21485, _ctx); /*string*/
              kk_string_t _x21486;
              kk_string_t _x21487;
              bool _match_20904;
              bool _brw_20905 = kk_integer_lt_borrow(_arg_8194,(kk_integer_from_small(0)),kk_context()); /*bool*/;
              kk_integer_drop(_arg_8194, _ctx);
              _match_20904 = _brw_20905; /*bool*/
              if (_match_20904) {
                kk_define_string_literal(, _s21488, 1, "-", _ctx)
                _x21487 = kk_string_dup(_s21488, _ctx); /*string*/
              }
              else {
                _x21487 = kk_string_empty(); /*string*/
              }
              kk_string_t _x21490;
              kk_string_t _x21491 = kk_string_empty(); /*string*/
              kk_string_t _x21493;
              bool _match_20903 = kk_integer_lte_borrow((kk_integer_from_small(6)),n3,kk_context()); /*bool*/;
              if (_match_20903) {
                kk_integer_drop(n3, _ctx);
                _x21493 = s3_17517; /*string*/
              }
              else {
                kk_string_t s4_17520 = kk_std_core_string('0', _ctx); /*string*/;
                kk_integer_t n4_17521 = kk_integer_sub((kk_integer_from_small(6)),n3,kk_context()); /*int*/;
                kk_string_t _x21494;
                kk_ssize_t _x21495 = kk_std_core_ssize__t(n4_17521, _ctx); /*ssize_t*/
                _x21494 = kk_std_core_repeatz(s4_17520, _x21495, _ctx); /*string*/
                _x21493 = kk_std_core__lp__plus__plus__1_rp_(_x21494, s3_17517, _ctx); /*string*/
              }
              _x21490 = kk_std_core__lp__plus__plus__1_rp_(_x21491, _x21493, _ctx); /*string*/
              _x21486 = kk_std_core__lp__plus__plus__1_rp_(_x21487, _x21490, _ctx); /*string*/
              return kk_std_core__lp__plus__plus__1_rp_(_x21484, _x21486, _ctx);
            }
          }
        }
      }
    }
  }
  {
    bool _match_20872 = (c > ('~')); /*bool*/;
    if (_match_20872) {
      bool _match_20876 = (c == 0x000A); /*bool*/;
      if (_match_20876) {
        kk_define_string_literal(, _s21496, 2, "\\n", _ctx)
        return kk_string_dup(_s21496, _ctx);
      }
      {
        bool _match_20877 = (c == 0x000D); /*bool*/;
        if (_match_20877) {
          kk_define_string_literal(, _s21497, 2, "\\r", _ctx)
          return kk_string_dup(_s21497, _ctx);
        }
        {
          bool _match_20878 = (c == 0x0009); /*bool*/;
          if (_match_20878) {
            kk_define_string_literal(, _s21498, 2, "\\t", _ctx)
            return kk_string_dup(_s21498, _ctx);
          }
          {
            bool _match_20879;
            kk_integer_t _brw_20896 = kk_integer_from_int(c,kk_context()); /*int*/;
            bool _brw_20897 = kk_integer_lte_borrow(_brw_20896,(kk_integer_from_small(255)),kk_context()); /*bool*/;
            kk_integer_drop(_brw_20896, _ctx);
            _match_20879 = _brw_20897; /*bool*/
            if (_match_20879) {
              kk_integer_t _arg_80420 = kk_integer_from_int(c,kk_context()); /*int*/;
              kk_string_t s5_17528;
              kk_integer_t _x21499;
              kk_integer_t _x21500 = kk_integer_dup(_arg_80420, _ctx); /*int*/
              _x21499 = kk_integer_abs(_x21500,kk_context()); /*int*/
              bool _x21501;
              kk_std_core_types__optional _match_20895 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
              if (kk_std_core_types__is_Optional(_match_20895, _ctx)) {
                kk_box_t _box_x19692 = _match_20895._cons.Optional.value;
                bool _use_capitals_75922 = kk_bool_unbox(_box_x19692);
                kk_std_core_types__optional_drop(_match_20895, _ctx);
                _x21501 = _use_capitals_75922; /*bool*/
              }
              else {
                kk_std_core_types__optional_drop(_match_20895, _ctx);
                _x21501 = true; /*bool*/
              }
              s5_17528 = kk_std_core_int_show_hex(_x21499, _x21501, _ctx); /*string*/
              kk_integer_t n5;
              kk_string_t _x21502 = kk_string_dup(s5_17528, _ctx); /*string*/
              n5 = kk_string_len_int(_x21502,kk_context()); /*int*/
              kk_string_t _x21503;
              kk_define_string_literal(, _s21504, 2, "\\x", _ctx)
              _x21503 = kk_string_dup(_s21504, _ctx); /*string*/
              kk_string_t _x21505;
              kk_string_t _x21506;
              bool _match_20893;
              bool _brw_20894 = kk_integer_lt_borrow(_arg_80420,(kk_integer_from_small(0)),kk_context()); /*bool*/;
              kk_integer_drop(_arg_80420, _ctx);
              _match_20893 = _brw_20894; /*bool*/
              if (_match_20893) {
                kk_define_string_literal(, _s21507, 1, "-", _ctx)
                _x21506 = kk_string_dup(_s21507, _ctx); /*string*/
              }
              else {
                _x21506 = kk_string_empty(); /*string*/
              }
              kk_string_t _x21509;
              kk_string_t _x21510 = kk_string_empty(); /*string*/
              kk_string_t _x21512;
              bool _match_20892 = kk_integer_lte_borrow((kk_integer_from_small(2)),n5,kk_context()); /*bool*/;
              if (_match_20892) {
                kk_integer_drop(n5, _ctx);
                _x21512 = s5_17528; /*string*/
              }
              else {
                kk_string_t s6_17531 = kk_std_core_string('0', _ctx); /*string*/;
                kk_integer_t n6_17532 = kk_integer_sub((kk_integer_from_small(2)),n5,kk_context()); /*int*/;
                kk_string_t _x21513;
                kk_ssize_t _x21514 = kk_std_core_ssize__t(n6_17532, _ctx); /*ssize_t*/
                _x21513 = kk_std_core_repeatz(s6_17531, _x21514, _ctx); /*string*/
                _x21512 = kk_std_core__lp__plus__plus__1_rp_(_x21513, s5_17528, _ctx); /*string*/
              }
              _x21509 = kk_std_core__lp__plus__plus__1_rp_(_x21510, _x21512, _ctx); /*string*/
              _x21505 = kk_std_core__lp__plus__plus__1_rp_(_x21506, _x21509, _ctx); /*string*/
              return kk_std_core__lp__plus__plus__1_rp_(_x21503, _x21505, _ctx);
            }
            {
              bool _match_20880;
              kk_integer_t _brw_20890 = kk_integer_from_int(c,kk_context()); /*int*/;
              kk_integer_t _brw_20889 = kk_integer_from_int(65535, _ctx); /*int*/;
              bool _brw_20891 = kk_integer_lte_borrow(_brw_20890,_brw_20889,kk_context()); /*bool*/;
              kk_integer_drop(_brw_20890, _ctx);
              kk_integer_drop(_brw_20889, _ctx);
              _match_20880 = _brw_20891; /*bool*/
              if (_match_20880) {
                kk_integer_t _arg_81400 = kk_integer_from_int(c,kk_context()); /*int*/;
                kk_string_t s7_17539;
                kk_integer_t _x21515;
                kk_integer_t _x21516 = kk_integer_dup(_arg_81400, _ctx); /*int*/
                _x21515 = kk_integer_abs(_x21516,kk_context()); /*int*/
                bool _x21517;
                kk_std_core_types__optional _match_20888 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
                if (kk_std_core_types__is_Optional(_match_20888, _ctx)) {
                  kk_box_t _box_x19693 = _match_20888._cons.Optional.value;
                  bool _use_capitals_75923 = kk_bool_unbox(_box_x19693);
                  kk_std_core_types__optional_drop(_match_20888, _ctx);
                  _x21517 = _use_capitals_75923; /*bool*/
                }
                else {
                  kk_std_core_types__optional_drop(_match_20888, _ctx);
                  _x21517 = true; /*bool*/
                }
                s7_17539 = kk_std_core_int_show_hex(_x21515, _x21517, _ctx); /*string*/
                kk_integer_t n7;
                kk_string_t _x21518 = kk_string_dup(s7_17539, _ctx); /*string*/
                n7 = kk_string_len_int(_x21518,kk_context()); /*int*/
                kk_string_t _x21519;
                kk_define_string_literal(, _s21520, 2, "\\u", _ctx)
                _x21519 = kk_string_dup(_s21520, _ctx); /*string*/
                kk_string_t _x21521;
                kk_string_t _x21522;
                bool _match_20886;
                bool _brw_20887 = kk_integer_lt_borrow(_arg_81400,(kk_integer_from_small(0)),kk_context()); /*bool*/;
                kk_integer_drop(_arg_81400, _ctx);
                _match_20886 = _brw_20887; /*bool*/
                if (_match_20886) {
                  kk_define_string_literal(, _s21523, 1, "-", _ctx)
                  _x21522 = kk_string_dup(_s21523, _ctx); /*string*/
                }
                else {
                  _x21522 = kk_string_empty(); /*string*/
                }
                kk_string_t _x21525;
                kk_string_t _x21526 = kk_string_empty(); /*string*/
                kk_string_t _x21528;
                bool _match_20885 = kk_integer_lte_borrow((kk_integer_from_small(4)),n7,kk_context()); /*bool*/;
                if (_match_20885) {
                  kk_integer_drop(n7, _ctx);
                  _x21528 = s7_17539; /*string*/
                }
                else {
                  kk_string_t s8_17542 = kk_std_core_string('0', _ctx); /*string*/;
                  kk_integer_t n8_17543 = kk_integer_sub((kk_integer_from_small(4)),n7,kk_context()); /*int*/;
                  kk_string_t _x21529;
                  kk_ssize_t _x21530 = kk_std_core_ssize__t(n8_17543, _ctx); /*ssize_t*/
                  _x21529 = kk_std_core_repeatz(s8_17542, _x21530, _ctx); /*string*/
                  _x21528 = kk_std_core__lp__plus__plus__1_rp_(_x21529, s7_17539, _ctx); /*string*/
                }
                _x21525 = kk_std_core__lp__plus__plus__1_rp_(_x21526, _x21528, _ctx); /*string*/
                _x21521 = kk_std_core__lp__plus__plus__1_rp_(_x21522, _x21525, _ctx); /*string*/
                return kk_std_core__lp__plus__plus__1_rp_(_x21519, _x21521, _ctx);
              }
              {
                kk_integer_t _arg_81940 = kk_integer_from_int(c,kk_context()); /*int*/;
                kk_string_t s9_17550;
                kk_integer_t _x21531;
                kk_integer_t _x21532 = kk_integer_dup(_arg_81940, _ctx); /*int*/
                _x21531 = kk_integer_abs(_x21532,kk_context()); /*int*/
                bool _x21533;
                kk_std_core_types__optional _match_20884 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
                if (kk_std_core_types__is_Optional(_match_20884, _ctx)) {
                  kk_box_t _box_x19694 = _match_20884._cons.Optional.value;
                  bool _use_capitals_75924 = kk_bool_unbox(_box_x19694);
                  kk_std_core_types__optional_drop(_match_20884, _ctx);
                  _x21533 = _use_capitals_75924; /*bool*/
                }
                else {
                  kk_std_core_types__optional_drop(_match_20884, _ctx);
                  _x21533 = true; /*bool*/
                }
                s9_17550 = kk_std_core_int_show_hex(_x21531, _x21533, _ctx); /*string*/
                kk_integer_t n9;
                kk_string_t _x21534 = kk_string_dup(s9_17550, _ctx); /*string*/
                n9 = kk_string_len_int(_x21534,kk_context()); /*int*/
                kk_string_t _x21535;
                kk_define_string_literal(, _s21536, 2, "\\U", _ctx)
                _x21535 = kk_string_dup(_s21536, _ctx); /*string*/
                kk_string_t _x21537;
                kk_string_t _x21538;
                bool _match_20882;
                bool _brw_20883 = kk_integer_lt_borrow(_arg_81940,(kk_integer_from_small(0)),kk_context()); /*bool*/;
                kk_integer_drop(_arg_81940, _ctx);
                _match_20882 = _brw_20883; /*bool*/
                if (_match_20882) {
                  kk_define_string_literal(, _s21539, 1, "-", _ctx)
                  _x21538 = kk_string_dup(_s21539, _ctx); /*string*/
                }
                else {
                  _x21538 = kk_string_empty(); /*string*/
                }
                kk_string_t _x21541;
                kk_string_t _x21542 = kk_string_empty(); /*string*/
                kk_string_t _x21544;
                bool _match_20881 = kk_integer_lte_borrow((kk_integer_from_small(6)),n9,kk_context()); /*bool*/;
                if (_match_20881) {
                  kk_integer_drop(n9, _ctx);
                  _x21544 = s9_17550; /*string*/
                }
                else {
                  kk_string_t s10_17553 = kk_std_core_string('0', _ctx); /*string*/;
                  kk_integer_t n10_17554 = kk_integer_sub((kk_integer_from_small(6)),n9,kk_context()); /*int*/;
                  kk_string_t _x21545;
                  kk_ssize_t _x21546 = kk_std_core_ssize__t(n10_17554, _ctx); /*ssize_t*/
                  _x21545 = kk_std_core_repeatz(s10_17553, _x21546, _ctx); /*string*/
                  _x21544 = kk_std_core__lp__plus__plus__1_rp_(_x21545, s9_17550, _ctx); /*string*/
                }
                _x21541 = kk_std_core__lp__plus__plus__1_rp_(_x21542, _x21544, _ctx); /*string*/
                _x21537 = kk_std_core__lp__plus__plus__1_rp_(_x21538, _x21541, _ctx); /*string*/
                return kk_std_core__lp__plus__plus__1_rp_(_x21535, _x21537, _ctx);
              }
            }
          }
        }
      }
    }
    {
      bool _match_20873 = (c == ('\'')); /*bool*/;
      if (_match_20873) {
        kk_define_string_literal(, _s21547, 2, "\\\'", _ctx)
        return kk_string_dup(_s21547, _ctx);
      }
      {
        bool _match_20874 = (c == ('"')); /*bool*/;
        if (_match_20874) {
          kk_define_string_literal(, _s21548, 2, "\\\"", _ctx)
          return kk_string_dup(_s21548, _ctx);
        }
        {
          bool _match_20875 = (c == ('\\')); /*bool*/;
          if (_match_20875) {
            kk_define_string_literal(, _s21549, 2, "\\\\", _ctx)
            return kk_string_dup(_s21549, _ctx);
          }
          {
            return kk_std_core_string(c, _ctx);
          }
        }
      }
    }
  }
}
 
// Show a `:float64` in exponential (scientific) notation.
// The optional `precision` (= `-17`) specifies the precision.
// If `>=0` it specifies the number of digits behind the dot (up to `17` max).
// If negative, then at most the absolute value of `precision` digits behind the dot are used.

kk_string_t kk_std_core_show_exp(double d, kk_std_core_types__optional precision, kk_context_t* _ctx) { /* (d : float64, precision : optional<int>) -> string */ 
  int32_t _x21550;
  kk_integer_t _x21551;
  if (kk_std_core_types__is_Optional(precision, _ctx)) {
    kk_box_t _box_x19695 = precision._cons.Optional.value;
    kk_integer_t _precision_8272 = kk_integer_unbox(_box_x19695, _ctx);
    kk_integer_dup(_precision_8272, _ctx);
    kk_std_core_types__optional_drop(precision, _ctx);
    _x21551 = _precision_8272; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(precision, _ctx);
    _x21551 = kk_integer_from_small(-17); /*int*/
  }
  _x21550 = kk_std_core_int32(_x21551, _ctx); /*int32*/
  return kk_std_core_show_expx(d, _x21550, _ctx);
}
 
// Show a `:float64` fixed-point notation.
// The optional `precision` (= `-2`) specifies the maximum precision.
// If `>=0` it specifies the number of digits behind the dot (up to `20` max).
// If negative, then at most the absolute value of `precision` digits behind the dot are used.
// This may still show a number in exponential notation if the it is too small or large,
// in particular, for  a `d` where `d > 1.0e21` or `d < 1.0e-15`, or if
// `precision.abs > 17`, the `show-exp` routine is used.

kk_string_t kk_std_core_show_fixed(double d, kk_std_core_types__optional precision, kk_context_t* _ctx) { /* (d : float64, precision : optional<int>) -> string */ 
  double dabs = kk_double_abs(d); /*float64*/;
  bool _match_20869 = (dabs < (0x1.203af9ee75616p-50)); /*bool*/;
  if (_match_20869) {
    int32_t _x21552;
    kk_integer_t _x21553;
    if (kk_std_core_types__is_Optional(precision, _ctx)) {
      kk_box_t _box_x19696 = precision._cons.Optional.value;
      kk_integer_t _precision_8283 = kk_integer_unbox(_box_x19696, _ctx);
      kk_integer_dup(_precision_8283, _ctx);
      kk_std_core_types__optional_drop(precision, _ctx);
      _x21553 = _precision_8283; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(precision, _ctx);
      _x21553 = kk_integer_from_small(-2); /*int*/
    }
    _x21552 = kk_std_core_int32(_x21553, _ctx); /*int32*/
    return kk_std_core_show_expx(d, _x21552, _ctx);
  }
  {
    bool _match_20870 = (dabs > (0x1.b1ae4d6e2ef5p69)); /*bool*/;
    if (_match_20870) {
      int32_t _x21554;
      kk_integer_t _x21555;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x19697 = precision._cons.Optional.value;
        kk_integer_t _precision_82830 = kk_integer_unbox(_box_x19697, _ctx);
        kk_integer_dup(_precision_82830, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x21555 = _precision_82830; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x21555 = kk_integer_from_small(-2); /*int*/
      }
      _x21554 = kk_std_core_int32(_x21555, _ctx); /*int32*/
      return kk_std_core_show_expx(d, _x21554, _ctx);
    }
    {
      int32_t _x21556;
      kk_integer_t _x21557;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x19698 = precision._cons.Optional.value;
        kk_integer_t _precision_82831 = kk_integer_unbox(_box_x19698, _ctx);
        kk_integer_dup(_precision_82831, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x21557 = _precision_82831; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x21557 = kk_integer_from_small(-2); /*int*/
      }
      _x21556 = kk_std_core_int32(_x21557, _ctx); /*int32*/
      return kk_std_core_show_fixedx(d, _x21556, _ctx);
    }
  }
}
 
// monadic lift

kk_string_t kk_std_core__mlift18814_show_list(kk_std_core__list _c_18511, kk_context_t* _ctx) { /* (list<string>) -> string */ 
  kk_string_t _x21558;
  kk_define_string_literal(, _s21559, 1, "[", _ctx)
  _x21558 = kk_string_dup(_s21559, _ctx); /*string*/
  kk_string_t _x21560;
  kk_string_t _x21561;
  if (kk_std_core__is_Nil(_c_18511, _ctx)) {
    _x21561 = kk_string_empty(); /*string*/
  }
  else {
    struct kk_std_core_Cons* _con21563 = kk_std_core__as_Cons(_c_18511, _ctx);
    kk_box_t _box_x19699 = _con21563->head;
    kk_std_core__list xx = _con21563->tail;
    kk_string_t x = kk_string_unbox(_box_x19699);
    if kk_likely(kk_datatype_ptr_is_unique(_c_18511, _ctx)) {
      kk_datatype_ptr_free(_c_18511, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(_c_18511, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      _x21561 = x; /*string*/
    }
    else {
      kk_string_t _x21564;
      kk_define_string_literal(, _s21565, 1, ",", _ctx)
      _x21564 = kk_string_dup(_s21565, _ctx); /*string*/
      _x21561 = kk_std_core__unroll17331_lift17316_joinsep(_x21564, xx, x, _ctx); /*string*/
    }
  }
  kk_string_t _x21566;
  kk_define_string_literal(, _s21567, 1, "]", _ctx)
  _x21566 = kk_string_dup(_s21567, _ctx); /*string*/
  _x21560 = kk_std_core__lp__plus__plus__1_rp_(_x21561, _x21566, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x21558, _x21560, _ctx);
}
 
// Convert a list to a string


// lift anonymous function
struct kk_std_core_show_list_fun21568__t {
  struct kk_function_s _base;
  kk_function_t show_elem;
};
static kk_box_t kk_std_core_show_list_fun21568(kk_function_t _fself, kk_box_t _b_19702, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_show_list_fun21568(kk_function_t show_elem, kk_context_t* _ctx) {
  struct kk_std_core_show_list_fun21568__t* _self = kk_function_alloc_as(struct kk_std_core_show_list_fun21568__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_show_list_fun21568, kk_context());
  _self->show_elem = show_elem;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_show_list_fun21568(kk_function_t _fself, kk_box_t _b_19702, kk_context_t* _ctx) {
  struct kk_std_core_show_list_fun21568__t* _self = kk_function_as(struct kk_std_core_show_list_fun21568__t*, _fself, _ctx);
  kk_function_t show_elem = _self->show_elem; /* (8848) -> 8849 string */
  kk_drop_match(_self, {kk_function_dup(show_elem, _ctx);}, {}, _ctx)
  kk_string_t _x21569 = kk_function_call(kk_string_t, (kk_function_t, kk_box_t, kk_context_t*), show_elem, (show_elem, _b_19702, _ctx), _ctx); /*string*/
  return kk_string_box(_x21569);
}


// lift anonymous function
struct kk_std_core_show_list_fun21571__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_show_list_fun21571(kk_function_t _fself, kk_box_t _b_19706, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_show_list_fun21571(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_show_list_fun21571, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_show_list_fun21571(kk_function_t _fself, kk_box_t _b_19706, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_string_t _x21572;
  kk_std_core__list _x21573 = kk_std_core__list_unbox(_b_19706, KK_OWNED, _ctx); /*list<string>*/
  _x21572 = kk_std_core__mlift18814_show_list(_x21573, _ctx); /*string*/
  return kk_string_box(_x21572);
}

kk_string_t kk_std_core_show_list(kk_std_core__list xs, kk_function_t show_elem, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, show-elem : (a) -> e string) -> e string */ 
  kk_std_core__list x_18977;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(show_elem, _ctx);
    x_18977 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  }
  else {
    x_18977 = kk_std_core__unroll17333_map_5(xs, kk_std_core_new_show_list_fun21568(show_elem, _ctx), _ctx); /*list<string>*/
  }
  if (kk_yielding(kk_context())) {
    kk_std_core__list_drop(x_18977, _ctx);
    kk_box_t _x21570 = kk_std_core_hnd_yield_extend(kk_std_core_new_show_list_fun21571(_ctx), _ctx); /*3926*/
    return kk_string_unbox(_x21570);
  }
  {
    kk_string_t _x21574;
    kk_define_string_literal(, _s21575, 1, "[", _ctx)
    _x21574 = kk_string_dup(_s21575, _ctx); /*string*/
    kk_string_t _x21576;
    kk_string_t _x21577;
    if (kk_std_core__is_Nil(x_18977, _ctx)) {
      _x21577 = kk_string_empty(); /*string*/
    }
    else {
      struct kk_std_core_Cons* _con21579 = kk_std_core__as_Cons(x_18977, _ctx);
      kk_box_t _box_x19707 = _con21579->head;
      kk_std_core__list xx = _con21579->tail;
      kk_string_t x0 = kk_string_unbox(_box_x19707);
      if kk_likely(kk_datatype_ptr_is_unique(x_18977, _ctx)) {
        kk_datatype_ptr_free(x_18977, _ctx);
      }
      else {
        kk_string_dup(x0, _ctx);
        kk_std_core__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(x_18977, _ctx);
      }
      if (kk_std_core__is_Nil(xx, _ctx)) {
        _x21577 = x0; /*string*/
      }
      else {
        kk_string_t _x21580;
        kk_define_string_literal(, _s21581, 1, ",", _ctx)
        _x21580 = kk_string_dup(_s21581, _ctx); /*string*/
        _x21577 = kk_std_core__unroll17331_lift17316_joinsep(_x21580, xx, x0, _ctx); /*string*/
      }
    }
    kk_string_t _x21582;
    kk_define_string_literal(, _s21583, 1, "]", _ctx)
    _x21582 = kk_string_dup(_s21583, _ctx); /*string*/
    _x21576 = kk_std_core__lp__plus__plus__1_rp_(_x21577, _x21582, _ctx); /*string*/
    return kk_std_core__lp__plus__plus__1_rp_(_x21574, _x21576, _ctx);
  }
}
 
// Convert an `:int` to a string

kk_string_t kk_std_core_show(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> string */ 
  return kk_integer_to_string(i,kk_context());
}
 
// Show a `:float64` as a string.
// If `d >= 1.0e-5` and `d < 1.0e+21`, `show-fixed` is used and otherwise `show-exp`.
// Default `precision` is `-17`.

kk_string_t kk_std_core_show_1(double d, kk_std_core_types__optional precision, kk_context_t* _ctx) { /* (d : float64, precision : optional<int>) -> string */ 
  double dabs = kk_double_abs(d); /*float64*/;
  bool _match_20864 = (dabs >= (0x1.4f8b588e368f1p-17)); /*bool*/;
  if (_match_20864) {
    bool _match_20865 = (dabs < (0x1.b1ae4d6e2ef5p69)); /*bool*/;
    if (_match_20865) {
      double dabs0 = kk_double_abs(d); /*float64*/;
      bool _match_20866 = (dabs0 < (0x1.203af9ee75616p-50)); /*bool*/;
      if (_match_20866) {
        int32_t _x21584;
        kk_integer_t _x21585;
        if (kk_std_core_types__is_Optional(precision, _ctx)) {
          kk_box_t _box_x19709 = precision._cons.Optional.value;
          kk_integer_t _precision_8858 = kk_integer_unbox(_box_x19709, _ctx);
          kk_integer_dup(_precision_8858, _ctx);
          kk_std_core_types__optional_drop(precision, _ctx);
          _x21585 = _precision_8858; /*int*/
        }
        else {
          kk_std_core_types__optional_drop(precision, _ctx);
          _x21585 = kk_integer_from_small(-17); /*int*/
        }
        _x21584 = kk_std_core_int32(_x21585, _ctx); /*int32*/
        return kk_std_core_show_expx(d, _x21584, _ctx);
      }
      {
        bool _match_20867 = (dabs0 > (0x1.b1ae4d6e2ef5p69)); /*bool*/;
        if (_match_20867) {
          int32_t _x21586;
          kk_integer_t _x21587;
          if (kk_std_core_types__is_Optional(precision, _ctx)) {
            kk_box_t _box_x19710 = precision._cons.Optional.value;
            kk_integer_t _precision_88580 = kk_integer_unbox(_box_x19710, _ctx);
            kk_integer_dup(_precision_88580, _ctx);
            kk_std_core_types__optional_drop(precision, _ctx);
            _x21587 = _precision_88580; /*int*/
          }
          else {
            kk_std_core_types__optional_drop(precision, _ctx);
            _x21587 = kk_integer_from_small(-17); /*int*/
          }
          _x21586 = kk_std_core_int32(_x21587, _ctx); /*int32*/
          return kk_std_core_show_expx(d, _x21586, _ctx);
        }
        {
          int32_t _x21588;
          kk_integer_t _x21589;
          if (kk_std_core_types__is_Optional(precision, _ctx)) {
            kk_box_t _box_x19711 = precision._cons.Optional.value;
            kk_integer_t _precision_88581 = kk_integer_unbox(_box_x19711, _ctx);
            kk_integer_dup(_precision_88581, _ctx);
            kk_std_core_types__optional_drop(precision, _ctx);
            _x21589 = _precision_88581; /*int*/
          }
          else {
            kk_std_core_types__optional_drop(precision, _ctx);
            _x21589 = kk_integer_from_small(-17); /*int*/
          }
          _x21588 = kk_std_core_int32(_x21589, _ctx); /*int32*/
          return kk_std_core_show_fixedx(d, _x21588, _ctx);
        }
      }
    }
    {
      int32_t _x21590;
      kk_integer_t _x21591;
      if (kk_std_core_types__is_Optional(precision, _ctx)) {
        kk_box_t _box_x19712 = precision._cons.Optional.value;
        kk_integer_t _precision_88582 = kk_integer_unbox(_box_x19712, _ctx);
        kk_integer_dup(_precision_88582, _ctx);
        kk_std_core_types__optional_drop(precision, _ctx);
        _x21591 = _precision_88582; /*int*/
      }
      else {
        kk_std_core_types__optional_drop(precision, _ctx);
        _x21591 = kk_integer_from_small(-17); /*int*/
      }
      _x21590 = kk_std_core_int32(_x21591, _ctx); /*int32*/
      return kk_std_core_show_expx(d, _x21590, _ctx);
    }
  }
  {
    int32_t _x21592;
    kk_integer_t _x21593;
    if (kk_std_core_types__is_Optional(precision, _ctx)) {
      kk_box_t _box_x19713 = precision._cons.Optional.value;
      kk_integer_t _precision_88583 = kk_integer_unbox(_box_x19713, _ctx);
      kk_integer_dup(_precision_88583, _ctx);
      kk_std_core_types__optional_drop(precision, _ctx);
      _x21593 = _precision_88583; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(precision, _ctx);
      _x21593 = kk_integer_from_small(-17); /*int*/
    }
    _x21592 = kk_std_core_int32(_x21593, _ctx); /*int32*/
    return kk_std_core_show_expx(d, _x21592, _ctx);
  }
}
 
// lifted local: xs.17574, show.3, .spec.18077
// specialized: std/core/.unroll17333-map.5, on parameters f18072, using:
// f18072 = std/core/show-char

kk_std_core__list kk_std_core__trmc_lift18302_show_3(kk_std_core__list xs18071, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (xs18071 : list<char>, ctx<list<string>>) -> list<string> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18071, _ctx)) {
    struct kk_std_core_Cons* _con21600 = kk_std_core__as_Cons(xs18071, _ctx);
    kk_box_t _box_x19714 = _con21600->head;
    kk_std_core__list xx18075 = _con21600->tail;
    kk_char_t x18074 = kk_char_unbox(_box_x19714, KK_BORROWED, _ctx);
    kk_reuse_t _ru_21035 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs18071, _ctx)) {
      _ru_21035 = (kk_datatype_ptr_reuse(xs18071, _ctx));
    }
    else {
      kk_std_core__list_dup(xx18075, _ctx);
      kk_datatype_ptr_decref(xs18071, _ctx);
    }
    kk_string_t _trmc_18387 = kk_std_core_show_char(x18074, _ctx); /*string*/;
    kk_std_core__list _trmc_18388 = kk_datatype_null(); /*list<string>*/;
    kk_std_core__list _trmc_18389 = kk_std_core__new_Cons(_ru_21035, 0, kk_string_box(_trmc_18387), _trmc_18388, _ctx); /*list<string>*/;
    kk_box_t* _b_19729_19724 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18389, _ctx)->tail)); /*field-addr<list<string>>*/;
    { // tailcall
      kk_std_core_types__cctx _x21601 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18389, _ctx)),_b_19729_19724,true,kk_context()); /*ctx<0>*/
      xs18071 = xx18075;
      _acc = _x21601;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x21602 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21602, KK_OWNED, _ctx);
  }
}
 
// lifted local: xs.17574, show.3, .spec.18077
// specialized: std/core/.unroll17333-map.5, on parameters f18072, using:
// f18072 = std/core/show-char

kk_std_core__list kk_std_core__lift18302_show_3(kk_std_core__list xs180710, kk_context_t* _ctx) { /* (xs18071 : list<char>) -> list<string> */ 
  kk_std_core_types__cctx _x21603 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift18302_show_3(xs180710, _x21603, _ctx);
}
 
// Show a string as a string literal

kk_string_t kk_std_core_show_3(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  kk_std_core__list xs1_17575 = kk_std_core_list_6(s, _ctx); /*list<char>*/;
  kk_std_core__list xs_17574;
  if (kk_std_core__is_Nil(xs1_17575, _ctx)) {
    xs_17574 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  }
  else {
    xs_17574 = kk_std_core__lift18302_show_3(xs1_17575, _ctx); /*list<string>*/
  }
  kk_string_t _x21604;
  kk_define_string_literal(, _s21605, 1, "\"", _ctx)
  _x21604 = kk_string_dup(_s21605, _ctx); /*string*/
  kk_string_t _x21606;
  kk_string_t _x21607;
  if (kk_std_core__is_Nil(xs_17574, _ctx)) {
    _x21607 = kk_string_empty(); /*string*/
  }
  else {
    struct kk_std_core_Cons* _con21609 = kk_std_core__as_Cons(xs_17574, _ctx);
    kk_box_t _box_x19735 = _con21609->head;
    kk_std_core__list xx = _con21609->tail;
    kk_string_t x = kk_string_unbox(_box_x19735);
    if kk_likely(kk_datatype_ptr_is_unique(xs_17574, _ctx)) {
      kk_datatype_ptr_free(xs_17574, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs_17574, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      _x21607 = x; /*string*/
    }
    else {
      kk_string_t _x21610 = kk_string_empty(); /*string*/
      _x21607 = kk_std_core__unroll17331_lift17316_joinsep(_x21610, xx, x, _ctx); /*string*/
    }
  }
  kk_string_t _x21612;
  kk_define_string_literal(, _s21613, 1, "\"", _ctx)
  _x21612 = kk_string_dup(_s21613, _ctx); /*string*/
  _x21606 = kk_std_core__lp__plus__plus__1_rp_(_x21607, _x21612, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x21604, _x21606, _ctx);
}
 
// lifted local: xs018080, .lift18303-show.7, show.7, .spec.18097
// specialized: std/core/.unroll17333-map.5, on parameters f18092, using:
// f18092 = std/core/show.3

kk_std_core__list kk_std_core__trmc_lift18304_show_7(kk_std_core__list xs18091, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (xs18091 : list<string>, ctx<list<string>>) -> list<string> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18091, _ctx)) {
    struct kk_std_core_Cons* _con21618 = kk_std_core__as_Cons(xs18091, _ctx);
    kk_box_t _box_x19736 = _con21618->head;
    kk_std_core__list xx18095 = _con21618->tail;
    kk_string_t x18094 = kk_string_unbox(_box_x19736);
    kk_reuse_t _ru_21037 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs18091, _ctx)) {
      _ru_21037 = (kk_datatype_ptr_reuse(xs18091, _ctx));
    }
    else {
      kk_string_dup(x18094, _ctx);
      kk_std_core__list_dup(xx18095, _ctx);
      kk_datatype_ptr_decref(xs18091, _ctx);
    }
    kk_string_t _trmc_18390 = kk_std_core_show_3(x18094, _ctx); /*string*/;
    kk_std_core__list _trmc_18391 = kk_datatype_null(); /*list<string>*/;
    kk_std_core__list _trmc_18392 = kk_std_core__new_Cons(_ru_21037, 0, kk_string_box(_trmc_18390), _trmc_18391, _ctx); /*list<string>*/;
    kk_box_t* _b_19751_19746 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18392, _ctx)->tail)); /*field-addr<list<string>>*/;
    { // tailcall
      kk_std_core_types__cctx _x21619 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18392, _ctx)),_b_19751_19746,true,kk_context()); /*ctx<0>*/
      xs18091 = xx18095;
      _acc = _x21619;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x21620 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21620, KK_OWNED, _ctx);
  }
}
 
// lifted local: xs018080, .lift18303-show.7, show.7, .spec.18097
// specialized: std/core/.unroll17333-map.5, on parameters f18092, using:
// f18092 = std/core/show.3

kk_std_core__list kk_std_core__lift18304_show_7(kk_std_core__list xs180910, kk_context_t* _ctx) { /* (xs18091 : list<string>) -> list<string> */ 
  kk_std_core_types__cctx _x21621 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift18304_show_7(xs180910, _x21621, _ctx);
}
 
// lifted local: show.7, .spec.18090
// specialized: std/core/show-list, on parameters show-elem18079, using:
// show-elem18079 = std/core/show.3

kk_string_t kk_std_core__lift18303_show_7(kk_std_core__list xs18078, kk_context_t* _ctx) { /* (xs18078 : list<string>) -> string */ 
  kk_std_core__list xs018080;
  if (kk_std_core__is_Nil(xs18078, _ctx)) {
    xs018080 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  }
  else {
    xs018080 = kk_std_core__lift18304_show_7(xs18078, _ctx); /*list<string>*/
  }
  kk_string_t _x21622;
  kk_define_string_literal(, _s21623, 1, "[", _ctx)
  _x21622 = kk_string_dup(_s21623, _ctx); /*string*/
  kk_string_t _x21624;
  kk_string_t _x21625;
  if (kk_std_core__is_Nil(xs018080, _ctx)) {
    _x21625 = kk_string_empty(); /*string*/
  }
  else {
    struct kk_std_core_Cons* _con21627 = kk_std_core__as_Cons(xs018080, _ctx);
    kk_box_t _box_x19757 = _con21627->head;
    kk_std_core__list xx18085 = _con21627->tail;
    kk_string_t x18084 = kk_string_unbox(_box_x19757);
    if kk_likely(kk_datatype_ptr_is_unique(xs018080, _ctx)) {
      kk_datatype_ptr_free(xs018080, _ctx);
    }
    else {
      kk_string_dup(x18084, _ctx);
      kk_std_core__list_dup(xx18085, _ctx);
      kk_datatype_ptr_decref(xs018080, _ctx);
    }
    if (kk_std_core__is_Nil(xx18085, _ctx)) {
      _x21625 = x18084; /*string*/
    }
    else {
      kk_string_t _x21628;
      kk_define_string_literal(, _s21629, 1, ",", _ctx)
      _x21628 = kk_string_dup(_s21629, _ctx); /*string*/
      _x21625 = kk_std_core__unroll17331_lift17316_joinsep(_x21628, xx18085, x18084, _ctx); /*string*/
    }
  }
  kk_string_t _x21630;
  kk_define_string_literal(, _s21631, 1, "]", _ctx)
  _x21630 = kk_string_dup(_s21631, _ctx); /*string*/
  _x21624 = kk_std_core__lp__plus__plus__1_rp_(_x21625, _x21630, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x21622, _x21624, _ctx);
}
 
// lifted local: xs018100, .lift18305-show.8, show.8, .spec.18117
// specialized: std/core/.unroll17333-map.5, on parameters f18112, using:
// f18112 = std/core/show

kk_std_core__list kk_std_core__trmc_lift18306_show_8(kk_std_core__list xs18111, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (xs18111 : list<int>, ctx<list<string>>) -> list<string> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18111, _ctx)) {
    struct kk_std_core_Cons* _con21632 = kk_std_core__as_Cons(xs18111, _ctx);
    kk_box_t _box_x19758 = _con21632->head;
    kk_std_core__list xx18115 = _con21632->tail;
    kk_integer_t x18114 = kk_integer_unbox(_box_x19758, _ctx);
    kk_reuse_t _ru_21039 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs18111, _ctx)) {
      _ru_21039 = (kk_datatype_ptr_reuse(xs18111, _ctx));
    }
    else {
      kk_integer_dup(x18114, _ctx);
      kk_std_core__list_dup(xx18115, _ctx);
      kk_datatype_ptr_decref(xs18111, _ctx);
    }
    kk_string_t _trmc_18393 = kk_std_core_show(x18114, _ctx); /*string*/;
    kk_std_core__list _trmc_18394 = kk_datatype_null(); /*list<string>*/;
    kk_std_core__list _trmc_18395 = kk_std_core__new_Cons(_ru_21039, 0, kk_string_box(_trmc_18393), _trmc_18394, _ctx); /*list<string>*/;
    kk_box_t* _b_19773_19768 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18395, _ctx)->tail)); /*field-addr<list<string>>*/;
    { // tailcall
      kk_std_core_types__cctx _x21633 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18395, _ctx)),_b_19773_19768,true,kk_context()); /*ctx<0>*/
      xs18111 = xx18115;
      _acc = _x21633;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x21634 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21634, KK_OWNED, _ctx);
  }
}
 
// lifted local: xs018100, .lift18305-show.8, show.8, .spec.18117
// specialized: std/core/.unroll17333-map.5, on parameters f18112, using:
// f18112 = std/core/show

kk_std_core__list kk_std_core__lift18306_show_8(kk_std_core__list xs181110, kk_context_t* _ctx) { /* (xs18111 : list<int>) -> list<string> */ 
  kk_std_core_types__cctx _x21635 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift18306_show_8(xs181110, _x21635, _ctx);
}
 
// lifted local: show.8, .spec.18110
// specialized: std/core/show-list, on parameters show-elem18099, using:
// show-elem18099 = std/core/show

kk_string_t kk_std_core__lift18305_show_8(kk_std_core__list xs18098, kk_context_t* _ctx) { /* (xs18098 : list<int>) -> string */ 
  kk_std_core__list xs018100;
  if (kk_std_core__is_Nil(xs18098, _ctx)) {
    xs018100 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  }
  else {
    xs018100 = kk_std_core__lift18306_show_8(xs18098, _ctx); /*list<string>*/
  }
  kk_string_t _x21636;
  kk_define_string_literal(, _s21637, 1, "[", _ctx)
  _x21636 = kk_string_dup(_s21637, _ctx); /*string*/
  kk_string_t _x21638;
  kk_string_t _x21639;
  if (kk_std_core__is_Nil(xs018100, _ctx)) {
    _x21639 = kk_string_empty(); /*string*/
  }
  else {
    struct kk_std_core_Cons* _con21641 = kk_std_core__as_Cons(xs018100, _ctx);
    kk_box_t _box_x19779 = _con21641->head;
    kk_std_core__list xx18105 = _con21641->tail;
    kk_string_t x18104 = kk_string_unbox(_box_x19779);
    if kk_likely(kk_datatype_ptr_is_unique(xs018100, _ctx)) {
      kk_datatype_ptr_free(xs018100, _ctx);
    }
    else {
      kk_string_dup(x18104, _ctx);
      kk_std_core__list_dup(xx18105, _ctx);
      kk_datatype_ptr_decref(xs018100, _ctx);
    }
    if (kk_std_core__is_Nil(xx18105, _ctx)) {
      _x21639 = x18104; /*string*/
    }
    else {
      kk_string_t _x21642;
      kk_define_string_literal(, _s21643, 1, ",", _ctx)
      _x21642 = kk_string_dup(_s21643, _ctx); /*string*/
      _x21639 = kk_std_core__unroll17331_lift17316_joinsep(_x21642, xx18105, x18104, _ctx); /*string*/
    }
  }
  kk_string_t _x21644;
  kk_define_string_literal(, _s21645, 1, "]", _ctx)
  _x21644 = kk_string_dup(_s21645, _ctx); /*string*/
  _x21638 = kk_std_core__lp__plus__plus__1_rp_(_x21639, _x21644, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x21636, _x21638, _ctx);
}
 
// lifted local: xs018120, .lift18307-show.9, show.9, .spec.18137
// specialized: std/core/.unroll17333-map.5, on parameters f18132, using:
// f18132 = std/core/show.4

kk_std_core__list kk_std_core__trmc_lift18308_show_9(kk_std_core__list xs18131, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* (xs18131 : list<bool>, ctx<list<string>>) -> list<string> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18131, _ctx)) {
    struct kk_std_core_Cons* _con21646 = kk_std_core__as_Cons(xs18131, _ctx);
    kk_box_t _box_x19780 = _con21646->head;
    kk_std_core__list xx18135 = _con21646->tail;
    bool x18134 = kk_bool_unbox(_box_x19780);
    kk_reuse_t _ru_21041 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs18131, _ctx)) {
      _ru_21041 = (kk_datatype_ptr_reuse(xs18131, _ctx));
    }
    else {
      kk_std_core__list_dup(xx18135, _ctx);
      kk_datatype_ptr_decref(xs18131, _ctx);
    }
    kk_std_core__list _trmc_18397 = kk_datatype_null(); /*list<string>*/;
    kk_std_core__list _trmc_18398;
    kk_box_t _x21647;
    kk_string_t _x21648;
    if (x18134) {
      kk_define_string_literal(, _s21649, 4, "True", _ctx)
      _x21648 = kk_string_dup(_s21649, _ctx); /*string*/
    }
    else {
      kk_define_string_literal(, _s21650, 5, "False", _ctx)
      _x21648 = kk_string_dup(_s21650, _ctx); /*string*/
    }
    _x21647 = kk_string_box(_x21648); /*61*/
    _trmc_18398 = kk_std_core__new_Cons(_ru_21041, 0, _x21647, _trmc_18397, _ctx); /*list<string>*/
    kk_box_t* _b_19795_19790 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18398, _ctx)->tail)); /*field-addr<list<string>>*/;
    { // tailcall
      kk_std_core_types__cctx _x21651 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18398, _ctx)),_b_19795_19790,true,kk_context()); /*ctx<0>*/
      xs18131 = xx18135;
      _acc = _x21651;
      goto kk__tailcall;
    }
  }
  {
    kk_box_t _x21652 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21652, KK_OWNED, _ctx);
  }
}
 
// lifted local: xs018120, .lift18307-show.9, show.9, .spec.18137
// specialized: std/core/.unroll17333-map.5, on parameters f18132, using:
// f18132 = std/core/show.4

kk_std_core__list kk_std_core__lift18308_show_9(kk_std_core__list xs181310, kk_context_t* _ctx) { /* (xs18131 : list<bool>) -> list<string> */ 
  kk_std_core_types__cctx _x21653 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift18308_show_9(xs181310, _x21653, _ctx);
}
 
// lifted local: show.9, .spec.18130
// specialized: std/core/show-list, on parameters show-elem18119, using:
// show-elem18119 = std/core/show.4

kk_string_t kk_std_core__lift18307_show_9(kk_std_core__list xs18118, kk_context_t* _ctx) { /* (xs18118 : list<bool>) -> string */ 
  kk_std_core__list xs018120;
  if (kk_std_core__is_Nil(xs18118, _ctx)) {
    xs018120 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  }
  else {
    xs018120 = kk_std_core__lift18308_show_9(xs18118, _ctx); /*list<string>*/
  }
  kk_string_t _x21654;
  kk_define_string_literal(, _s21655, 1, "[", _ctx)
  _x21654 = kk_string_dup(_s21655, _ctx); /*string*/
  kk_string_t _x21656;
  kk_string_t _x21657;
  if (kk_std_core__is_Nil(xs018120, _ctx)) {
    _x21657 = kk_string_empty(); /*string*/
  }
  else {
    struct kk_std_core_Cons* _con21659 = kk_std_core__as_Cons(xs018120, _ctx);
    kk_box_t _box_x19801 = _con21659->head;
    kk_std_core__list xx18125 = _con21659->tail;
    kk_string_t x18124 = kk_string_unbox(_box_x19801);
    if kk_likely(kk_datatype_ptr_is_unique(xs018120, _ctx)) {
      kk_datatype_ptr_free(xs018120, _ctx);
    }
    else {
      kk_string_dup(x18124, _ctx);
      kk_std_core__list_dup(xx18125, _ctx);
      kk_datatype_ptr_decref(xs018120, _ctx);
    }
    if (kk_std_core__is_Nil(xx18125, _ctx)) {
      _x21657 = x18124; /*string*/
    }
    else {
      kk_string_t _x21660;
      kk_define_string_literal(, _s21661, 1, ",", _ctx)
      _x21660 = kk_string_dup(_s21661, _ctx); /*string*/
      _x21657 = kk_std_core__unroll17331_lift17316_joinsep(_x21660, xx18125, x18124, _ctx); /*string*/
    }
  }
  kk_string_t _x21662;
  kk_define_string_literal(, _s21663, 1, "]", _ctx)
  _x21662 = kk_string_dup(_s21663, _ctx); /*string*/
  _x21656 = kk_std_core__lp__plus__plus__1_rp_(_x21657, _x21662, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x21654, _x21656, _ctx);
}

kk_unit_t kk_std_core_prints(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> console () */ 
  kk_std_core_types__maybe _match_20863;
  kk_box_t _x21672;
  kk_ref_t _x21673 = kk_ref_dup(kk_std_core_redirect, _ctx); /*ref<global,maybe<(string) -> console ()>>*/
  _x21672 = kk_ref_get(_x21673,kk_context()); /*190*/
  _match_20863 = kk_std_core_types__maybe_unbox(_x21672, KK_OWNED, _ctx); /*maybe<(string) -> console ()>*/
  if (kk_std_core_types__is_Nothing(_match_20863, _ctx)) {
    kk_std_core_xprints(s, _ctx); return kk_Unit;
  }
  {
    kk_box_t _fun_unbox_x19806 = _match_20863._cons.Just.value;
    kk_box_t _x21674;
    kk_function_t _x21675 = kk_function_unbox(_fun_unbox_x19806, _ctx); /*(19807) -> console 19808*/
    _x21674 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_context_t*), _x21675, (_x21675, kk_string_box(s), _ctx), _ctx); /*19808*/
    kk_unit_unbox(_x21674); return kk_Unit;
  }
}


// lift anonymous function
struct kk_std_core__default_exn_fun21680__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core__default_exn_fun21680(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun21680(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core__default_exn_fun21680, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_core__default_exn_fun21681__t {
  struct kk_function_s _base;
  kk_std_core__exception x;
};
static kk_box_t kk_std_core__default_exn_fun21681(kk_function_t _fself, kk_function_t _b_19821, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun21681(kk_std_core__exception x, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun21681__t* _self = kk_function_alloc_as(struct kk_std_core__default_exn_fun21681__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__default_exn_fun21681, kk_context());
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core__default_exn_fun21682__t {
  struct kk_function_s _base;
  kk_function_t _b_19821;
};
static kk_unit_t kk_std_core__default_exn_fun21682(kk_function_t _fself, kk_std_core_hnd__resume_result _b_19822, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun21682(kk_function_t _b_19821, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun21682__t* _self = kk_function_alloc_as(struct kk_std_core__default_exn_fun21682__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__default_exn_fun21682, kk_context());
  _self->_b_19821 = _b_19821;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_unit_t kk_std_core__default_exn_fun21682(kk_function_t _fself, kk_std_core_hnd__resume_result _b_19822, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun21682__t* _self = kk_function_as(struct kk_std_core__default_exn_fun21682__t*, _fself, _ctx);
  kk_function_t _b_19821 = _self->_b_19821; /* (std/core/hnd/resume-result<3990,3993>) -> 3992 3993 */
  kk_drop_match(_self, {kk_function_dup(_b_19821, _ctx);}, {}, _ctx)
  kk_box_t _x21683 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), _b_19821, (_b_19821, _b_19822, _ctx), _ctx); /*3993*/
  return kk_unit_unbox(_x21683);
}
static kk_box_t kk_std_core__default_exn_fun21681(kk_function_t _fself, kk_function_t _b_19821, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun21681__t* _self = kk_function_as(struct kk_std_core__default_exn_fun21681__t*, _fself, _ctx);
  kk_std_core__exception x = _self->x; /* exception */
  kk_drop_match(_self, {kk_std_core__exception_dup(x, _ctx);}, {}, _ctx)
  kk_function_t ___wildcard__525__45_19839 = kk_std_core__new_default_exn_fun21682(_b_19821, _ctx); /*(std/core/hnd/resume-result<9952,()>) -> <console|9950> ()*/;
  kk_function_drop(___wildcard__525__45_19839, _ctx);
  kk_unit_t __ = kk_Unit;
  kk_string_t _x21684;
  kk_define_string_literal(, _s21685, 20, "uncaught exception: ", _ctx)
  _x21684 = kk_string_dup(_s21685, _ctx); /*string*/
  kk_std_core_prints(_x21684, _ctx);
  kk_unit_t _x21686 = kk_Unit;
  kk_string_t _x21687;
  {
    kk_string_t _x = x.message;
    kk_string_dup(_x, _ctx);
    kk_std_core__exception_drop(x, _ctx);
    _x21687 = _x; /*string*/
  }
  kk_std_core_printsln(_x21687, _ctx);
  return kk_unit_box(_x21686);
}
static kk_box_t kk_std_core__default_exn_fun21680(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_datatype_ptr_dropn(___wildcard__525__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core__new_default_exn_fun21681(x, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core__default_exn_fun21690__t {
  struct kk_function_s _base;
  kk_function_t _b_19836_19823;
};
static kk_box_t kk_std_core__default_exn_fun21690(kk_function_t _fself, kk_std_core_hnd__marker _b_19824, kk_std_core_hnd__ev _b_19825, kk_box_t _b_19826, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun21690(kk_function_t _b_19836_19823, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun21690__t* _self = kk_function_alloc_as(struct kk_std_core__default_exn_fun21690__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__default_exn_fun21690, kk_context());
  _self->_b_19836_19823 = _b_19836_19823;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__default_exn_fun21690(kk_function_t _fself, kk_std_core_hnd__marker _b_19824, kk_std_core_hnd__ev _b_19825, kk_box_t _b_19826, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun21690__t* _self = kk_function_as(struct kk_std_core__default_exn_fun21690__t*, _fself, _ctx);
  kk_function_t _b_19836_19823 = _self->_b_19836_19823; /* (m0 : std/core/hnd/marker<<console|9950>,()>, std/core/hnd/ev<.hnd-exn>, x : exception) -> <console|9950> 9952 */
  kk_drop_match(_self, {kk_function_dup(_b_19836_19823, _ctx);}, {}, _ctx)
  kk_std_core__exception _x21691 = kk_std_core__exception_unbox(_b_19826, KK_OWNED, _ctx); /*exception*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_std_core__exception, kk_context_t*), _b_19836_19823, (_b_19836_19823, _b_19824, _b_19825, _x21691, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core__default_exn_fun21692__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core__default_exn_fun21692(kk_function_t _fself, kk_box_t _b_19831, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun21692(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core__default_exn_fun21692, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core__default_exn_fun21692(kk_function_t _fself, kk_box_t _b_19831, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_unit_t _x0_19840 = kk_Unit;
  kk_unit_unbox(_b_19831);
  return kk_unit_box(_x0_19840);
}


// lift anonymous function
struct kk_std_core__default_exn_fun21693__t {
  struct kk_function_s _base;
  kk_function_t action;
};
static kk_box_t kk_std_core__default_exn_fun21693(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_default_exn_fun21693(kk_function_t action, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun21693__t* _self = kk_function_alloc_as(struct kk_std_core__default_exn_fun21693__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__default_exn_fun21693, kk_context());
  _self->action = action;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__default_exn_fun21693(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core__default_exn_fun21693__t* _self = kk_function_as(struct kk_std_core__default_exn_fun21693__t*, _fself, _ctx);
  kk_function_t action = _self->action; /* () -> <exn,console|9950> () */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);}, {}, _ctx)
  kk_unit_t _x21694 = kk_Unit;
  kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx);
  return kk_unit_box(_x21694);
}

kk_unit_t kk_std_core__default_exn(kk_function_t action, kk_context_t* _ctx) { /* forall<e> (action : () -> <console,exn|e> ()) -> <console|e> () */ 
  int32_t _b_19832_19827 = (KK_I32(0)); /*int32*/;
  kk_box_t _x21679;
  kk_function_t _b_19836_19823 = kk_std_core__new_default_exn_fun21680(_ctx); /*(m0 : std/core/hnd/marker<<console|9950>,()>, std/core/hnd/ev<.hnd-exn>, x : exception) -> <console|9950> 9952*/;
  kk_std_core__hnd_exn _x21688;
  kk_std_core_hnd__clause1 _x21689 = kk_std_core_hnd__new_Clause1(kk_std_core__new_default_exn_fun21690(_b_19836_19823, _ctx), _ctx); /*std/core/hnd/clause1<51,52,53,54,55>*/
  _x21688 = kk_std_core__new_Hnd_exn(kk_reuse_null, 0, _x21689, _ctx); /*.hnd-exn<11,12>*/
  _x21679 = kk_std_core__handle_exn(_b_19832_19827, _x21688, kk_std_core__new_default_exn_fun21692(_ctx), kk_std_core__new_default_exn_fun21693(action, _ctx), _ctx); /*1976*/
  kk_unit_unbox(_x21679); return kk_Unit;
}
 
// Get (zero-based) element `n`  of a list. Return a `:maybe` type.

kk_std_core_types__maybe kk_std_core__unroll17334_op(kk_std_core__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> maybe<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21695 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21695->head;
    kk_std_core__list xx = _con21695->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool _match_20860 = kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
    if (_match_20860) {
      kk_box_drop(x, _ctx);
      { // tailcall
        kk_integer_t _x21696 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        xs = xx;
        n = _x21696;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core__list_drop(xx, _ctx);
      bool _match_20861;
      bool _brw_20862 = kk_integer_eq_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
      kk_integer_drop(n, _ctx);
      _match_20861 = _brw_20862; /*bool*/
      if (_match_20861) {
        return kk_std_core_types__new_Just(x, _ctx);
      }
      {
        kk_box_drop(x, _ctx);
        return kk_std_core_types__new_Nothing(_ctx);
      }
    }
  }
  {
    kk_integer_drop(n, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// O(1). Return the string slice from the end of `slice` argument
// to the end of the string.

kk_std_core__sslice kk_std_core_after(kk_std_core__sslice slice0, kk_context_t* _ctx) { /* (slice : sslice) -> sslice */ 
  {
    kk_string_t s = slice0.str;
    kk_integer_t start0 = slice0.start;
    kk_integer_t len0 = slice0.len;
    kk_integer_t x0_17589;
    kk_string_t _x21697 = kk_string_dup(s, _ctx); /*string*/
    x0_17589 = kk_string_len_int(_x21697,kk_context()); /*int*/
    kk_integer_t y0_17590;
    kk_integer_t _x21698 = kk_integer_dup(start0, _ctx); /*int*/
    kk_integer_t _x21699 = kk_integer_dup(len0, _ctx); /*int*/
    y0_17590 = kk_integer_add(_x21698,_x21699,kk_context()); /*int*/
    kk_integer_t _x21700 = kk_integer_add(start0,len0,kk_context()); /*int*/
    kk_integer_t _x21701 = kk_integer_sub(x0_17589,y0_17590,kk_context()); /*int*/
    return kk_std_core__new_Sslice(s, _x21700, _x21701, _ctx);
  }
}
 
// monadic lift

bool kk_std_core__mlift18815_unroll17335_all(kk_function_t predicate, kk_std_core__list xx, bool _y_18514, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xx : list<a>, bool) -> e bool */ 
  if (_y_18514) {
    return kk_std_core__unroll17335_all(xx, predicate, _ctx);
  }
  {
    kk_std_core__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return false;
  }
}
 
// Do all elements satisfy a predicate ?


// lift anonymous function
struct kk_std_core__unroll17335_all_fun21705__t {
  struct kk_function_s _base;
  kk_function_t predicate0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core__unroll17335_all_fun21705(kk_function_t _fself, kk_box_t _b_19842, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_unroll17335_all_fun21705(kk_function_t predicate0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core__unroll17335_all_fun21705__t* _self = kk_function_alloc_as(struct kk_std_core__unroll17335_all_fun21705__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__unroll17335_all_fun21705, kk_context());
  _self->predicate0 = predicate0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__unroll17335_all_fun21705(kk_function_t _fself, kk_box_t _b_19842, kk_context_t* _ctx) {
  struct kk_std_core__unroll17335_all_fun21705__t* _self = kk_function_as(struct kk_std_core__unroll17335_all_fun21705__t*, _fself, _ctx);
  kk_function_t predicate0 = _self->predicate0; /* (10199) -> 10200 bool */
  kk_std_core__list xx0 = _self->xx0; /* list<10199> */
  kk_drop_match(_self, {kk_function_dup(predicate0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  bool _y_19844_185140 = kk_bool_unbox(_b_19842); /*bool*/;
  bool _x21706 = kk_std_core__mlift18815_unroll17335_all(predicate0, xx0, _y_19844_185140, _ctx); /*bool*/
  return kk_bool_box(_x21706);
}

bool kk_std_core__unroll17335_all(kk_std_core__list xs, kk_function_t predicate0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e bool */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21702 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21702->head;
    kk_std_core__list xx0 = _con21702->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x0_18985;
    kk_function_t _x21703 = kk_function_dup(predicate0, _ctx); /*(10199) -> 10200 bool*/
    x0_18985 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x21703, (_x21703, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x21704 = kk_std_core_hnd_yield_extend(kk_std_core__new_unroll17335_all_fun21705(predicate0, xx0, _ctx), _ctx); /*3926*/
      return kk_bool_unbox(_x21704);
    }
    if (x0_18985) { // tailcall
                    xs = xx0;
                    goto kk__tailcall;
    }
    {
      kk_std_core__list_drop(xx0, _ctx);
      kk_function_drop(predicate0, _ctx);
      return false;
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    return true;
  }
}
 
// monadic lift

bool kk_std_core__mlift18816_unroll17336_any(kk_function_t predicate, kk_std_core__list xx, bool _y_18520, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xx : list<a>, bool) -> e bool */ 
  if (_y_18520) {
    kk_std_core__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return true;
  }
  {
    return kk_std_core__unroll17336_any(xx, predicate, _ctx);
  }
}
 
// Are there any elements in a list that satisfy a predicate ?


// lift anonymous function
struct kk_std_core__unroll17336_any_fun21710__t {
  struct kk_function_s _base;
  kk_function_t predicate0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core__unroll17336_any_fun21710(kk_function_t _fself, kk_box_t _b_19846, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_unroll17336_any_fun21710(kk_function_t predicate0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core__unroll17336_any_fun21710__t* _self = kk_function_alloc_as(struct kk_std_core__unroll17336_any_fun21710__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__unroll17336_any_fun21710, kk_context());
  _self->predicate0 = predicate0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__unroll17336_any_fun21710(kk_function_t _fself, kk_box_t _b_19846, kk_context_t* _ctx) {
  struct kk_std_core__unroll17336_any_fun21710__t* _self = kk_function_as(struct kk_std_core__unroll17336_any_fun21710__t*, _fself, _ctx);
  kk_function_t predicate0 = _self->predicate0; /* (10227) -> 10228 bool */
  kk_std_core__list xx0 = _self->xx0; /* list<10227> */
  kk_drop_match(_self, {kk_function_dup(predicate0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  bool _y_19848_185200 = kk_bool_unbox(_b_19846); /*bool*/;
  bool _x21711 = kk_std_core__mlift18816_unroll17336_any(predicate0, xx0, _y_19848_185200, _ctx); /*bool*/
  return kk_bool_box(_x21711);
}

bool kk_std_core__unroll17336_any(kk_std_core__list xs, kk_function_t predicate0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e bool */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21707 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21707->head;
    kk_std_core__list xx0 = _con21707->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x0_18988;
    kk_function_t _x21708 = kk_function_dup(predicate0, _ctx); /*(10227) -> 10228 bool*/
    x0_18988 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x21708, (_x21708, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x21709 = kk_std_core_hnd_yield_extend(kk_std_core__new_unroll17336_any_fun21710(predicate0, xx0, _ctx), _ctx); /*3926*/
      return kk_bool_unbox(_x21709);
    }
    if (x0_18988) {
      kk_std_core__list_drop(xx0, _ctx);
      kk_function_drop(predicate0, _ctx);
      return true;
    }
    { // tailcall
      xs = xx0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    return false;
  }
}
 
// Return the element at position `index` in vector `v`, or `Nothing` if out of bounds

kk_std_core_types__maybe kk_std_core_at(kk_vector_t v, kk_integer_t index, kk_context_t* _ctx) { /* forall<a> (v : vector<a>, index : int) -> maybe<a> */ 
  kk_ssize_t idx;
  kk_integer_t _x21712 = kk_integer_dup(index, _ctx); /*int*/
  idx = kk_std_core_ssize__t(_x21712, _ctx); /*ssize_t*/
  bool _match_20857;
  kk_ssize_t _x21713 = kk_vector_len_borrow(v,kk_context()); /*ssize_t*/
  _match_20857 = (_x21713 <= idx); /*bool*/
  if (_match_20857) {
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_box_t _x21714 = kk_vector_at_borrow(v,idx,kk_context()); /*228*/
    return kk_std_core_types__new_Just(_x21714, _ctx);
  }
}
 
// O(`n`). The first `n` (default = `1`) characters in a string.

kk_std_core__sslice kk_std_core_first(kk_string_t s, kk_std_core_types__optional n, kk_context_t* _ctx) { /* (s : string, n : optional<int>) -> sslice */ 
  kk_std_core__sslice slice0 = kk_std_core_first1(s, _ctx); /*sslice*/;
  bool _match_20851;
  kk_integer_t _brw_20854;
  if (kk_std_core_types__is_Optional(n, _ctx)) {
    kk_box_t _box_x19849 = n._cons.Optional.value;
    kk_integer_t _n_10357 = kk_integer_unbox(_box_x19849, _ctx);
    kk_integer_dup(_n_10357, _ctx);
    _brw_20854 = _n_10357; /*int*/
  }
  else {
    _brw_20854 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_20855 = kk_integer_eq_borrow(_brw_20854,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_20854, _ctx);
  _match_20851 = _brw_20855; /*bool*/
  if (_match_20851) {
    kk_std_core_types__optional_drop(n, _ctx);
    return slice0;
  }
  {
    kk_integer_t _brw_20852;
    kk_integer_t _x21717;
    if (kk_std_core_types__is_Optional(n, _ctx)) {
      kk_box_t _box_x19850 = n._cons.Optional.value;
      kk_integer_t _n_103570 = kk_integer_unbox(_box_x19850, _ctx);
      kk_integer_dup(_n_103570, _ctx);
      kk_std_core_types__optional_drop(n, _ctx);
      _x21717 = _n_103570; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(n, _ctx);
      _x21717 = kk_integer_from_small(1); /*int*/
    }
    _brw_20852 = kk_integer_add_small_const(_x21717, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_20853 = kk_std_core_extend(slice0, _brw_20852, _ctx); /*sslice*/;
    kk_integer_drop(_brw_20852, _ctx);
    return _brw_20853;
  }
}
 
// Convert the first character of a string to uppercase.

kk_string_t kk_std_core_capitalize(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  kk_std_core__sslice slice2;
  kk_string_t _x21718 = kk_string_dup(s, _ctx); /*string*/
  slice2 = kk_std_core_first1(_x21718, _ctx); /*sslice*/
  kk_std_core__sslice slice1_17600;
  bool _match_20844;
  kk_integer_t _brw_20849;
  kk_std_core_types__optional _match_20848 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_20848, _ctx)) {
    kk_box_t _box_x19851 = _match_20848._cons.Optional.value;
    kk_integer_t _n_103570 = kk_integer_unbox(_box_x19851, _ctx);
    kk_integer_dup(_n_103570, _ctx);
    kk_std_core_types__optional_drop(_match_20848, _ctx);
    _brw_20849 = _n_103570; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_20848, _ctx);
    _brw_20849 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_20850 = kk_integer_eq_borrow(_brw_20849,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_20849, _ctx);
  _match_20844 = _brw_20850; /*bool*/
  if (_match_20844) {
    slice1_17600 = slice2; /*sslice*/
  }
  else {
    kk_integer_t _brw_20846;
    kk_integer_t _x21719;
    kk_std_core_types__optional _match_20845 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_20845, _ctx)) {
      kk_box_t _box_x19852 = _match_20845._cons.Optional.value;
      kk_integer_t _n_1035700 = kk_integer_unbox(_box_x19852, _ctx);
      kk_integer_dup(_n_1035700, _ctx);
      kk_std_core_types__optional_drop(_match_20845, _ctx);
      _x21719 = _n_1035700; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(_match_20845, _ctx);
      _x21719 = kk_integer_from_small(1); /*int*/
    }
    _brw_20846 = kk_integer_add_small_const(_x21719, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_20847 = kk_std_core_extend(slice2, _brw_20846, _ctx); /*sslice*/;
    kk_integer_drop(_brw_20846, _ctx);
    slice1_17600 = _brw_20847; /*sslice*/
  }
  kk_std_core__sslice slice0 = kk_std_core_first1(s, _ctx); /*sslice*/;
  kk_string_t _x21720;
  kk_string_t _x21721;
  kk_std_core__sslice _x21722;
  bool _match_20837;
  kk_integer_t _brw_20842;
  kk_std_core_types__optional _match_20841 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_20841, _ctx)) {
    kk_box_t _box_x19853 = _match_20841._cons.Optional.value;
    kk_integer_t _n_10357 = kk_integer_unbox(_box_x19853, _ctx);
    kk_integer_dup(_n_10357, _ctx);
    kk_std_core_types__optional_drop(_match_20841, _ctx);
    _brw_20842 = _n_10357; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_20841, _ctx);
    _brw_20842 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_20843 = kk_integer_eq_borrow(_brw_20842,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_20842, _ctx);
  _match_20837 = _brw_20843; /*bool*/
  if (_match_20837) {
    _x21722 = slice0; /*sslice*/
  }
  else {
    kk_integer_t _brw_20839;
    kk_integer_t _x21723;
    kk_std_core_types__optional _match_20838 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_20838, _ctx)) {
      kk_box_t _box_x19854 = _match_20838._cons.Optional.value;
      kk_integer_t _n_103571 = kk_integer_unbox(_box_x19854, _ctx);
      kk_integer_dup(_n_103571, _ctx);
      kk_std_core_types__optional_drop(_match_20838, _ctx);
      _x21723 = _n_103571; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(_match_20838, _ctx);
      _x21723 = kk_integer_from_small(1); /*int*/
    }
    _brw_20839 = kk_integer_add_small_const(_x21723, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_20840 = kk_std_core_extend(slice0, _brw_20839, _ctx); /*sslice*/;
    kk_integer_drop(_brw_20839, _ctx);
    _x21722 = _brw_20840; /*sslice*/
  }
  _x21721 = kk_std_core_string_3(_x21722, _ctx); /*string*/
  _x21720 = kk_std_core_to_upper(_x21721, _ctx); /*string*/
  kk_string_t _x21724;
  kk_std_core__sslice _x21725;
  {
    kk_string_t s1 = slice1_17600.str;
    kk_integer_t start0 = slice1_17600.start;
    kk_integer_t len0 = slice1_17600.len;
    kk_integer_t x1_17607;
    kk_string_t _x21726 = kk_string_dup(s1, _ctx); /*string*/
    x1_17607 = kk_string_len_int(_x21726,kk_context()); /*int*/
    kk_integer_t y1_17608;
    kk_integer_t _x21727 = kk_integer_dup(start0, _ctx); /*int*/
    kk_integer_t _x21728 = kk_integer_dup(len0, _ctx); /*int*/
    y1_17608 = kk_integer_add(_x21727,_x21728,kk_context()); /*int*/
    kk_integer_t _x21729 = kk_integer_add(start0,len0,kk_context()); /*int*/
    kk_integer_t _x21730 = kk_integer_sub(x1_17607,y1_17608,kk_context()); /*int*/
    _x21725 = kk_std_core__new_Sslice(s1, _x21729, _x21730, _ctx); /*sslice*/
  }
  _x21724 = kk_std_core_string_3(_x21725, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x21720, _x21724, _ctx);
}
 
// Catch any exception raised in `action` and handle it.
// Use `on-exn` or `on-exit` when appropiate.


// lift anonymous function
struct kk_std_core_try_fun21731__t {
  struct kk_function_s _base;
  kk_function_t hndl;
};
static kk_box_t kk_std_core_try_fun21731(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21731(kk_function_t hndl, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21731__t* _self = kk_function_alloc_as(struct kk_std_core_try_fun21731__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun21731, kk_context());
  _self->hndl = hndl;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_try_fun21732__t {
  struct kk_function_s _base;
  kk_function_t hndl;
  kk_std_core__exception x;
};
static kk_box_t kk_std_core_try_fun21732(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21732(kk_function_t hndl, kk_std_core__exception x, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21732__t* _self = kk_function_alloc_as(struct kk_std_core_try_fun21732__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun21732, kk_context());
  _self->hndl = hndl;
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_try_fun21732(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21732__t* _self = kk_function_as(struct kk_std_core_try_fun21732__t*, _fself, _ctx);
  kk_function_t hndl = _self->hndl; /* (exception) -> 10534 10533 */
  kk_std_core__exception x = _self->x; /* exception */
  kk_drop_match(_self, {kk_function_dup(hndl, _ctx);kk_std_core__exception_dup(x, _ctx);}, {}, _ctx)
  kk_function_drop(___wildcard__525__45, _ctx);
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core__exception, kk_context_t*), hndl, (hndl, x, _ctx), _ctx);
}
static kk_box_t kk_std_core_try_fun21731(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21731__t* _self = kk_function_as(struct kk_std_core_try_fun21731__t*, _fself, _ctx);
  kk_function_t hndl = _self->hndl; /* (exception) -> 10534 10533 */
  kk_drop_match(_self, {kk_function_dup(hndl, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__525__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_new_try_fun21732(hndl, x, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_fun21735__t {
  struct kk_function_s _base;
  kk_function_t _b_19859_19855;
};
static kk_box_t kk_std_core_try_fun21735(kk_function_t _fself, kk_std_core_hnd__marker _b_19856, kk_std_core_hnd__ev _b_19857, kk_box_t _b_19858, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21735(kk_function_t _b_19859_19855, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21735__t* _self = kk_function_alloc_as(struct kk_std_core_try_fun21735__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun21735, kk_context());
  _self->_b_19859_19855 = _b_19859_19855;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_try_fun21735(kk_function_t _fself, kk_std_core_hnd__marker _b_19856, kk_std_core_hnd__ev _b_19857, kk_box_t _b_19858, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21735__t* _self = kk_function_as(struct kk_std_core_try_fun21735__t*, _fself, _ctx);
  kk_function_t _b_19859_19855 = _self->_b_19859_19855; /* (m0 : std/core/hnd/marker<10534,10533>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 10534 10520 */
  kk_drop_match(_self, {kk_function_dup(_b_19859_19855, _ctx);}, {}, _ctx)
  kk_std_core__exception _x21736 = kk_std_core__exception_unbox(_b_19858, KK_OWNED, _ctx); /*exception*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_std_core__exception, kk_context_t*), _b_19859_19855, (_b_19859_19855, _b_19856, _b_19857, _x21736, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_fun21737__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_try_fun21737(kk_function_t _fself, kk_box_t _x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21737(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_try_fun21737, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_try_fun21737(kk_function_t _fself, kk_box_t _x, kk_context_t* _ctx) {
  kk_unused(_fself);
  return _x;
}

kk_box_t kk_std_core_try(kk_function_t action, kk_function_t hndl, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <exn|e> a, hndl : (exception) -> e a) -> e a */ 
  kk_function_t _b_19859_19855 = kk_std_core_new_try_fun21731(hndl, _ctx); /*(m0 : std/core/hnd/marker<10534,10533>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 10534 10520*/;
  kk_std_core__hnd_exn _x21733;
  kk_std_core_hnd__clause1 _x21734 = kk_std_core_hnd__new_Clause1(kk_std_core_new_try_fun21735(_b_19859_19855, _ctx), _ctx); /*std/core/hnd/clause1<51,52,53,54,55>*/
  _x21733 = kk_std_core__new_Hnd_exn(kk_reuse_null, 0, _x21734, _ctx); /*.hnd-exn<11,12>*/
  return kk_std_core__handle_exn((KK_I32(0)), _x21733, kk_std_core_new_try_fun21737(_ctx), action, _ctx);
}
 
// Transform an exception effect to an  `:error` type.


// lift anonymous function
struct kk_std_core_try_fun21739__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_try_fun21739_1(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21739_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_try_fun21739_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}



// lift anonymous function
struct kk_std_core_try_fun21740__t_1 {
  struct kk_function_s _base;
  kk_std_core__exception x;
};
static kk_box_t kk_std_core_try_fun21740_1(kk_function_t _fself, kk_function_t _b_19862, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21740_1(kk_std_core__exception x, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21740__t_1* _self = kk_function_alloc_as(struct kk_std_core_try_fun21740__t_1, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun21740_1, kk_context());
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_try_fun21741__t_1 {
  struct kk_function_s _base;
  kk_function_t _b_19862;
};
static kk_std_core__error kk_std_core_try_fun21741_1(kk_function_t _fself, kk_std_core_hnd__resume_result _b_19863, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21741_1(kk_function_t _b_19862, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21741__t_1* _self = kk_function_alloc_as(struct kk_std_core_try_fun21741__t_1, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun21741_1, kk_context());
  _self->_b_19862 = _b_19862;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_std_core__error kk_std_core_try_fun21741_1(kk_function_t _fself, kk_std_core_hnd__resume_result _b_19863, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21741__t_1* _self = kk_function_as(struct kk_std_core_try_fun21741__t_1*, _fself, _ctx);
  kk_function_t _b_19862 = _self->_b_19862; /* (std/core/hnd/resume-result<3990,3993>) -> 3992 3993 */
  kk_drop_match(_self, {kk_function_dup(_b_19862, _ctx);}, {}, _ctx)
  kk_box_t _x21742 = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__resume_result, kk_context_t*), _b_19862, (_b_19862, _b_19863, _ctx), _ctx); /*3993*/
  return kk_std_core__error_unbox(_x21742, KK_OWNED, _ctx);
}
static kk_box_t kk_std_core_try_fun21740_1(kk_function_t _fself, kk_function_t _b_19862, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21740__t_1* _self = kk_function_as(struct kk_std_core_try_fun21740__t_1*, _fself, _ctx);
  kk_std_core__exception x = _self->x; /* exception */
  kk_drop_match(_self, {kk_std_core__exception_dup(x, _ctx);}, {}, _ctx)
  kk_function_t ___wildcard__525__45_19883 = kk_std_core_new_try_fun21741_1(_b_19862, _ctx); /*(std/core/hnd/resume-result<10520,error<10572>>) -> 10573 error<10572>*/;
  kk_function_drop(___wildcard__525__45_19883, _ctx);
  kk_std_core__error _x21743 = kk_std_core__new_Error(x, _ctx); /*error<30>*/
  return kk_std_core__error_box(_x21743, _ctx);
}
static kk_box_t kk_std_core_try_fun21739_1(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_datatype_ptr_dropn(___wildcard__525__16, (KK_I32(3)), _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_new_try_fun21740_1(x, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_fun21746__t_1 {
  struct kk_function_s _base;
  kk_function_t _b_19879_19864;
};
static kk_box_t kk_std_core_try_fun21746_1(kk_function_t _fself, kk_std_core_hnd__marker _b_19865, kk_std_core_hnd__ev _b_19866, kk_box_t _b_19867, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21746_1(kk_function_t _b_19879_19864, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21746__t_1* _self = kk_function_alloc_as(struct kk_std_core_try_fun21746__t_1, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun21746_1, kk_context());
  _self->_b_19879_19864 = _b_19879_19864;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_try_fun21746_1(kk_function_t _fself, kk_std_core_hnd__marker _b_19865, kk_std_core_hnd__ev _b_19866, kk_box_t _b_19867, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21746__t_1* _self = kk_function_as(struct kk_std_core_try_fun21746__t_1*, _fself, _ctx);
  kk_function_t _b_19879_19864 = _self->_b_19879_19864; /* (m0 : std/core/hnd/marker<10573,error<10572>>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 10573 10520 */
  kk_drop_match(_self, {kk_function_dup(_b_19879_19864, _ctx);}, {}, _ctx)
  kk_std_core__exception _x21747 = kk_std_core__exception_unbox(_b_19867, KK_OWNED, _ctx); /*exception*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_std_core__exception, kk_context_t*), _b_19879_19864, (_b_19879_19864, _b_19865, _b_19866, _x21747, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_fun21748__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_try_fun21748_1(kk_function_t _fself, kk_box_t _b_19874, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21748_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_try_fun21748_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_try_fun21748_1(kk_function_t _fself, kk_box_t _b_19874, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core__error _x_19884 = kk_std_core__error_unbox(_b_19874, KK_OWNED, _ctx); /*error<10572>*/;
  return kk_std_core__error_box(_x_19884, _ctx);
}


// lift anonymous function
struct kk_std_core_try_fun21749__t_1 {
  struct kk_function_s _base;
  kk_function_t action;
};
static kk_box_t kk_std_core_try_fun21749_1(kk_function_t _fself, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21749_1(kk_function_t action, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21749__t_1* _self = kk_function_alloc_as(struct kk_std_core_try_fun21749__t_1, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_fun21749_1, kk_context());
  _self->action = action;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_try_fun21752__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_try_fun21752_1(kk_function_t _fself, kk_box_t _b_19869, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_fun21752_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_try_fun21752_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_try_fun21752_1(kk_function_t _fself, kk_box_t _b_19869, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_box_t _y_19885_18527 = _b_19869; /*10572*/;
  kk_std_core__error _x21753 = kk_std_core__new_Ok(_y_19885_18527, _ctx); /*error<30>*/
  return kk_std_core__error_box(_x21753, _ctx);
}
static kk_box_t kk_std_core_try_fun21749_1(kk_function_t _fself, kk_context_t* _ctx) {
  struct kk_std_core_try_fun21749__t_1* _self = kk_function_as(struct kk_std_core_try_fun21749__t_1*, _fself, _ctx);
  kk_function_t action = _self->action; /* () -> <exn|10573> 10572 */
  kk_drop_match(_self, {kk_function_dup(action, _ctx);}, {}, _ctx)
  kk_box_t x0_18993 = kk_function_call(kk_box_t, (kk_function_t, kk_context_t*), action, (action, _ctx), _ctx); /*10572*/;
  kk_std_core__error _x21750;
  if (kk_yielding(kk_context())) {
    kk_box_drop(x0_18993, _ctx);
    kk_box_t _x21751 = kk_std_core_hnd_yield_extend(kk_std_core_new_try_fun21752_1(_ctx), _ctx); /*3926*/
    _x21750 = kk_std_core__error_unbox(_x21751, KK_OWNED, _ctx); /*error<10572>*/
  }
  else {
    _x21750 = kk_std_core__new_Ok(x0_18993, _ctx); /*error<10572>*/
  }
  return kk_std_core__error_box(_x21750, _ctx);
}

kk_std_core__error kk_std_core_try_1(kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (action : () -> <exn|e> a) -> e error<a> */ 
  int32_t _b_19875_19870 = (KK_I32(0)); /*int32*/;
  kk_box_t _x21738;
  kk_function_t _b_19879_19864 = kk_std_core_new_try_fun21739_1(_ctx); /*(m0 : std/core/hnd/marker<10573,error<10572>>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 10573 10520*/;
  kk_std_core__hnd_exn _x21744;
  kk_std_core_hnd__clause1 _x21745 = kk_std_core_hnd__new_Clause1(kk_std_core_new_try_fun21746_1(_b_19879_19864, _ctx), _ctx); /*std/core/hnd/clause1<51,52,53,54,55>*/
  _x21744 = kk_std_core__new_Hnd_exn(kk_reuse_null, 0, _x21745, _ctx); /*.hnd-exn<11,12>*/
  _x21738 = kk_std_core__handle_exn(_b_19875_19870, _x21744, kk_std_core_new_try_fun21748_1(_ctx), kk_std_core_new_try_fun21749_1(action, _ctx), _ctx); /*1976*/
  return kk_std_core__error_unbox(_x21738, KK_OWNED, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core_cdivmod_exp10(kk_integer_t i, kk_integer_t n, kk_context_t* _ctx) { /* (i : int, n : int) -> (int, int) */ 
  bool _match_20835 = kk_integer_lte_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_20835) {
    kk_integer_drop(n, _ctx);
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(i, _ctx), kk_integer_box(kk_integer_from_small(0), _ctx), _ctx);
  }
  {
    kk_integer_t cq;
    kk_integer_t _x21754 = kk_integer_dup(i, _ctx); /*int*/
    kk_integer_t _x21755 = kk_integer_dup(n, _ctx); /*int*/
    cq = kk_std_core_cdiv_exp10(_x21754, _x21755, _ctx); /*int*/
    kk_integer_t y_17614;
    kk_integer_t _x21756 = kk_integer_dup(cq, _ctx); /*int*/
    y_17614 = kk_std_core_mul_exp10(_x21756, n, _ctx); /*int*/
    kk_integer_t cr = kk_integer_sub(i,y_17614,kk_context()); /*int*/;
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(cq, _ctx), kk_integer_box(cr, _ctx), _ctx);
  }
}
 
// Concatenate a list of `:maybe` values

kk_std_core__list kk_std_core__trmc_unroll17337_concat_maybe(kk_std_core__list xs, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<maybe<a>>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21757 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x19894 = _con21757->head;
    kk_std_core__list xx = _con21757->tail;
    kk_std_core_types__maybe x = kk_std_core_types__maybe_unbox(_box_x19894, KK_BORROWED, _ctx);
    kk_reuse_t _ru_21047 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core_types__maybe_dup(x, _ctx);
      kk_box_drop(_box_x19894, _ctx);
      _ru_21047 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_std_core_types__maybe_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core_types__is_Just(x, _ctx)) {
      kk_box_t y = x._cons.Just.value;
      kk_std_core__list _trmc_18399 = kk_datatype_null(); /*list<10712>*/;
      kk_std_core__list _trmc_18400 = kk_std_core__new_Cons(_ru_21047, 0, y, _trmc_18399, _ctx); /*list<10712>*/;
      kk_box_t* _b_19905_19900 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18400, _ctx)->tail)); /*field-addr<list<10712>>*/;
      { // tailcall
        kk_std_core_types__cctx _x21758 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18400, _ctx)),_b_19905_19900,true,kk_context()); /*ctx<0>*/
        xs = xx;
        _acc = _x21758;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_21047,kk_context());
      { // tailcall
        xs = xx;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_box_t _x21759 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21759, KK_OWNED, _ctx);
  }
}
 
// Concatenate a list of `:maybe` values

kk_std_core__list kk_std_core__unroll17337_concat_maybe(kk_std_core__list xs0, kk_context_t* _ctx) { /* forall<a> (xs : list<maybe<a>>) -> list<a> */ 
  kk_std_core_types__cctx _x21760 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17337_concat_maybe(xs0, _x21760, _ctx);
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18818_lift17320_for_whilez(kk_function_t action, kk_ssize_t end, kk_ssize_t i, kk_std_core_types__maybe _y_18530, kk_context_t* _ctx) { /* forall<a,e> (action : (ssize_t) -> e maybe<a>, end : ssize_t, i : ssize_t, maybe<a>) -> e maybe<a> */ 
  if (kk_std_core_types__is_Nothing(_y_18530, _ctx)) {
    kk_ssize_t i0_17615 = kk_std_core_incr_1(i, _ctx); /*ssize_t*/;
    return kk_std_core__lift17320_for_whilez(action, end, i0_17615, _ctx);
  }
  {
    kk_box_t x = _y_18530._cons.Just.value;
    kk_function_drop(action, _ctx);
    return kk_std_core_types__new_Just(x, _ctx);
  }
}
 
// lifted local: for-whilez, rep


// lift anonymous function
struct kk_std_core__lift17320_for_whilez_fun21763__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_ssize_t end0;
  kk_ssize_t i0;
};
static kk_box_t kk_std_core__lift17320_for_whilez_fun21763(kk_function_t _fself, kk_box_t _b_19912, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift17320_for_whilez_fun21763(kk_function_t action0, kk_ssize_t end0, kk_ssize_t i0, kk_context_t* _ctx) {
  struct kk_std_core__lift17320_for_whilez_fun21763__t* _self = kk_function_alloc_as(struct kk_std_core__lift17320_for_whilez_fun21763__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift17320_for_whilez_fun21763, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift17320_for_whilez_fun21763(kk_function_t _fself, kk_box_t _b_19912, kk_context_t* _ctx) {
  struct kk_std_core__lift17320_for_whilez_fun21763__t* _self = kk_function_as(struct kk_std_core__lift17320_for_whilez_fun21763__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (ssize_t) -> 10767 maybe<10766> */
  kk_ssize_t end0 = _self->end0; /* ssize_t */
  kk_ssize_t i0 = _self->i0; /* ssize_t */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);;;}, {}, _ctx)
  kk_std_core_types__maybe _y_19914_185300 = kk_std_core_types__maybe_unbox(_b_19912, KK_OWNED, _ctx); /*maybe<10766>*/;
  kk_std_core_types__maybe _x21764 = kk_std_core__mlift18818_lift17320_for_whilez(action0, end0, i0, _y_19914_185300, _ctx); /*maybe<10766>*/
  return kk_std_core_types__maybe_box(_x21764, _ctx);
}

kk_std_core_types__maybe kk_std_core__lift17320_for_whilez(kk_function_t action0, kk_ssize_t end0, kk_ssize_t i0, kk_context_t* _ctx) { /* forall<a,e> (action : (ssize_t) -> e maybe<a>, end : ssize_t, i : ssize_t) -> e maybe<a> */ 
  kk__tailcall: ;
  bool _match_20833 = (i0 <= end0); /*bool*/;
  if (_match_20833) {
    kk_std_core_types__maybe x0_18996;
    kk_function_t _x21761 = kk_function_dup(action0, _ctx); /*(ssize_t) -> 10767 maybe<10766>*/
    x0_18996 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_ssize_t, kk_context_t*), _x21761, (_x21761, i0, _ctx), _ctx); /*maybe<10766>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_18996, _ctx);
      kk_box_t _x21762 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift17320_for_whilez_fun21763(action0, end0, i0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x21762, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x0_18996, _ctx)) {
      kk_ssize_t i0_176150 = kk_std_core_incr_1(i0, _ctx); /*ssize_t*/;
      { // tailcall
        i0 = i0_176150;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t x1 = x0_18996._cons.Just.value;
      kk_function_drop(action0, _ctx);
      return kk_std_core_types__new_Just(x1, _ctx);
    }
  }
  {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18819_unroll17338_foreach_while(kk_function_t action, kk_std_core__list xx, kk_std_core_types__maybe _y_18535, kk_context_t* _ctx) { /* forall<a,b,e> (action : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e maybe<b> */ 
  if (kk_std_core_types__is_Nothing(_y_18535, _ctx)) {
    return kk_std_core__unroll17338_foreach_while(xx, action, _ctx);
  }
  {
    kk_std_core__list_drop(xx, _ctx);
    kk_function_drop(action, _ctx);
    return _y_18535;
  }
}
 
// Invoke `action` for each element of a list while `action` return `Nothing`


// lift anonymous function
struct kk_std_core__unroll17338_foreach_while_fun21770__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core__unroll17338_foreach_while_fun21770(kk_function_t _fself, kk_box_t _b_19916, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_unroll17338_foreach_while_fun21770(kk_function_t action0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core__unroll17338_foreach_while_fun21770__t* _self = kk_function_alloc_as(struct kk_std_core__unroll17338_foreach_while_fun21770__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__unroll17338_foreach_while_fun21770, kk_context());
  _self->action0 = action0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__unroll17338_foreach_while_fun21770(kk_function_t _fself, kk_box_t _b_19916, kk_context_t* _ctx) {
  struct kk_std_core__unroll17338_foreach_while_fun21770__t* _self = kk_function_as(struct kk_std_core__unroll17338_foreach_while_fun21770__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (10898) -> 10900 maybe<10899> */
  kk_std_core__list xx0 = _self->xx0; /* list<10898> */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_19918_185350 = kk_std_core_types__maybe_unbox(_b_19916, KK_OWNED, _ctx); /*maybe<10899>*/;
  kk_std_core_types__maybe _x21771 = kk_std_core__mlift18819_unroll17338_foreach_while(action0, xx0, _y_19918_185350, _ctx); /*maybe<10899>*/
  return kk_std_core_types__maybe_box(_x21771, _ctx);
}

kk_std_core_types__maybe kk_std_core__unroll17338_foreach_while(kk_std_core__list xs, kk_function_t action0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>) -> e maybe<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    struct kk_std_core_Cons* _con21767 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21767->head;
    kk_std_core__list xx0 = _con21767->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x0_18999;
    kk_function_t _x21768 = kk_function_dup(action0, _ctx); /*(10898) -> 10900 maybe<10899>*/
    x0_18999 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x21768, (_x21768, x, _ctx), _ctx); /*maybe<10899>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_18999, _ctx);
      kk_box_t _x21769 = kk_std_core_hnd_yield_extend(kk_std_core__new_unroll17338_foreach_while_fun21770(action0, xx0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x21769, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x0_18999, _ctx)) { // tailcall
                                                         xs = xx0;
                                                         goto kk__tailcall;
    }
    {
      kk_std_core__list_drop(xx0, _ctx);
      kk_function_drop(action0, _ctx);
      return x0_18999;
    }
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18820_foreach_while_1(kk_function_t action, kk_std_core__sslice rest, kk_std_core_types__maybe _y_18541, kk_context_t* _ctx) { /* forall<a,e> (action : (c : char) -> e maybe<a>, rest : sslice, maybe<a>) -> e maybe<a> */ 
  if (kk_std_core_types__is_Nothing(_y_18541, _ctx)) {
    return kk_std_core_foreach_while_1(rest, action, _ctx);
  }
  {
    kk_std_core__sslice_drop(rest, _ctx);
    kk_function_drop(action, _ctx);
    return _y_18541;
  }
}
 
// Apply a function for each character in a string slice.
// If `action` returns `Just`, the function returns immediately with that result.


// lift anonymous function
struct kk_std_core_foreach_while_fun21774__t_1 {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_std_core__sslice rest0;
};
static kk_box_t kk_std_core_foreach_while_fun21774_1(kk_function_t _fself, kk_box_t _b_19923, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_while_fun21774_1(kk_function_t action0, kk_std_core__sslice rest0, kk_context_t* _ctx) {
  struct kk_std_core_foreach_while_fun21774__t_1* _self = kk_function_alloc_as(struct kk_std_core_foreach_while_fun21774__t_1, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foreach_while_fun21774_1, kk_context());
  _self->action0 = action0;
  _self->rest0 = rest0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_foreach_while_fun21774_1(kk_function_t _fself, kk_box_t _b_19923, kk_context_t* _ctx) {
  struct kk_std_core_foreach_while_fun21774__t_1* _self = kk_function_as(struct kk_std_core_foreach_while_fun21774__t_1*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (c : char) -> 10985 maybe<10984> */
  kk_std_core__sslice rest0 = _self->rest0; /* sslice */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_std_core__sslice_dup(rest0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_19925_185410 = kk_std_core_types__maybe_unbox(_b_19923, KK_OWNED, _ctx); /*maybe<10984>*/;
  kk_std_core_types__maybe _x21775 = kk_std_core__mlift18820_foreach_while_1(action0, rest0, _y_19925_185410, _ctx); /*maybe<10984>*/
  return kk_std_core_types__maybe_box(_x21775, _ctx);
}

kk_std_core_types__maybe kk_std_core_foreach_while_1(kk_std_core__sslice slice0, kk_function_t action0, kk_context_t* _ctx) { /* forall<a,e> (slice : sslice, action : (c : char) -> e maybe<a>) -> e maybe<a> */ 
  kk__tailcall: ;
  kk_std_core_types__maybe _match_20830 = kk_std_core_next(slice0, _ctx); /*maybe<(char, sslice)>*/;
  if (kk_std_core_types__is_Nothing(_match_20830, _ctx)) {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_box_t _box_x19919 = _match_20830._cons.Just.value;
    kk_std_core_types__tuple2_ _pat1 = kk_std_core_types__tuple2__unbox(_box_x19919, KK_BORROWED, _ctx);
    kk_box_t _box_x19920 = _pat1.fst;
    kk_box_t _box_x19921 = _pat1.snd;
    kk_std_core__sslice rest0 = kk_std_core__sslice_unbox(_box_x19921, KK_BORROWED, _ctx);
    kk_char_t c = kk_char_unbox(_box_x19920, KK_BORROWED, _ctx);
    kk_std_core__sslice_dup(rest0, _ctx);
    kk_std_core_types__maybe_drop(_match_20830, _ctx);
    kk_std_core_types__maybe x_19002;
    kk_function_t _x21772 = kk_function_dup(action0, _ctx); /*(c : char) -> 10985 maybe<10984>*/
    x_19002 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_char_t, kk_context_t*), _x21772, (_x21772, c, _ctx), _ctx); /*maybe<10984>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x_19002, _ctx);
      kk_box_t _x21773 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_while_fun21774_1(action0, rest0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x21773, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x_19002, _ctx)) { // tailcall
                                                        slice0 = rest0;
                                                        goto kk__tailcall;
    }
    {
      kk_std_core__sslice_drop(rest0, _ctx);
      kk_function_drop(action0, _ctx);
      return x_19002;
    }
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18821_lift18309_foreach_while_3(kk_ssize_t end18139, kk_function_t f, kk_ssize_t i18140, kk_vector_t v, kk_std_core_types__maybe _y_18546, kk_context_t* _ctx) { /* forall<a,b,e> (end18139 : ssize_t, f : (a) -> e maybe<b>, i18140 : ssize_t, v : vector<a>, maybe<b>) -> e maybe<b> */ 
  if (kk_std_core_types__is_Nothing(_y_18546, _ctx)) {
    kk_ssize_t i0_1761518143 = kk_std_core_incr_1(i18140, _ctx); /*ssize_t*/;
    return kk_std_core__lift18309_foreach_while_3(f, v, end18139, i0_1761518143, _ctx);
  }
  {
    kk_box_t x18145 = _y_18546._cons.Just.value;
    kk_vector_drop(v, _ctx);
    kk_function_drop(f, _ctx);
    return kk_std_core_types__new_Just(x18145, _ctx);
  }
}
 
// lifted local: foreach-while.3, .spec.18147
// specialized: std/core/.lift17320-for-whilez, on parameters action18138, using:
// action18138 = fn<(e :: E)>(i0: ssize_t){
//   f((std/core/types/.open<(total :: E),(e :: E),(v : (vector :: V -> V)<a>, index : ssize_t) -> (total :: E) a,(v : (vector :: V -> V)<a>, index : ssize_t) -> (e :: E) a>((std/core/unsafe-idx<a>))(v, i0)));
// }


// lift anonymous function
struct kk_std_core__lift18309_foreach_while_fun21782__t_3 {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_vector_t v0;
  kk_ssize_t end181390;
  kk_ssize_t i181400;
};
static kk_box_t kk_std_core__lift18309_foreach_while_fun21782_3(kk_function_t _fself, kk_box_t _b_19927, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18309_foreach_while_fun21782_3(kk_function_t f0, kk_vector_t v0, kk_ssize_t end181390, kk_ssize_t i181400, kk_context_t* _ctx) {
  struct kk_std_core__lift18309_foreach_while_fun21782__t_3* _self = kk_function_alloc_as(struct kk_std_core__lift18309_foreach_while_fun21782__t_3, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18309_foreach_while_fun21782_3, kk_context());
  _self->f0 = f0;
  _self->v0 = v0;
  _self->end181390 = end181390;
  _self->i181400 = i181400;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18309_foreach_while_fun21782_3(kk_function_t _fself, kk_box_t _b_19927, kk_context_t* _ctx) {
  struct kk_std_core__lift18309_foreach_while_fun21782__t_3* _self = kk_function_as(struct kk_std_core__lift18309_foreach_while_fun21782__t_3*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (11083) -> 11085 maybe<11084> */
  kk_vector_t v0 = _self->v0; /* vector<11083> */
  kk_ssize_t end181390 = _self->end181390; /* ssize_t */
  kk_ssize_t i181400 = _self->i181400; /* ssize_t */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_vector_dup(v0, _ctx);;;}, {}, _ctx)
  kk_std_core_types__maybe _y_19929_185460 = kk_std_core_types__maybe_unbox(_b_19927, KK_OWNED, _ctx); /*maybe<11084>*/;
  kk_std_core_types__maybe _x21783 = kk_std_core__mlift18821_lift18309_foreach_while_3(end181390, f0, i181400, v0, _y_19929_185460, _ctx); /*maybe<11084>*/
  return kk_std_core_types__maybe_box(_x21783, _ctx);
}

kk_std_core_types__maybe kk_std_core__lift18309_foreach_while_3(kk_function_t f0, kk_vector_t v0, kk_ssize_t end181390, kk_ssize_t i181400, kk_context_t* _ctx) { /* forall<a,b,e> (f : (a) -> e maybe<b>, v : vector<a>, end18139 : ssize_t, i18140 : ssize_t) -> e maybe<b> */ 
  kk__tailcall: ;
  bool _match_20828 = (i181400 <= end181390); /*bool*/;
  if (_match_20828) {
    kk_std_core_types__maybe x_19005;
    kk_function_t _x21780 = kk_function_dup(f0, _ctx); /*(11083) -> 11085 maybe<11084>*/
    kk_box_t _x21779 = kk_vector_at_borrow(v0,i181400,kk_context()); /*228*/
    x_19005 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x21780, (_x21780, _x21779, _ctx), _ctx); /*maybe<11084>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x_19005, _ctx);
      kk_box_t _x21781 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18309_foreach_while_fun21782_3(f0, v0, end181390, i181400, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x21781, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x_19005, _ctx)) {
      kk_ssize_t i0_17615181430 = kk_std_core_incr_1(i181400, _ctx); /*ssize_t*/;
      { // tailcall
        i181400 = i0_17615181430;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t x181450 = x_19005._cons.Just.value;
      kk_vector_drop(v0, _ctx);
      kk_function_drop(f0, _ctx);
      return kk_std_core_types__new_Just(x181450, _ctx);
    }
  }
  {
    kk_vector_drop(v0, _ctx);
    kk_function_drop(f0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18822_unroll17339_foreach(kk_function_t action, kk_std_core__list xx, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<a,e> (action : (a) -> e (), xx : list<a>, wild_ : ()) -> e () */ 
  kk_std_core__unroll17339_foreach(xx, action, _ctx); return kk_Unit;
}
 
// Invoke `action` for each element of a list


// lift anonymous function
struct kk_std_core__unroll17339_foreach_fun21788__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core__unroll17339_foreach_fun21788(kk_function_t _fself, kk_box_t _b_19931, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_unroll17339_foreach_fun21788(kk_function_t action0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core__unroll17339_foreach_fun21788__t* _self = kk_function_alloc_as(struct kk_std_core__unroll17339_foreach_fun21788__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__unroll17339_foreach_fun21788, kk_context());
  _self->action0 = action0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__unroll17339_foreach_fun21788(kk_function_t _fself, kk_box_t _b_19931, kk_context_t* _ctx) {
  struct kk_std_core__unroll17339_foreach_fun21788__t* _self = kk_function_as(struct kk_std_core__unroll17339_foreach_fun21788__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (11277) -> 11278 () */
  kk_std_core__list xx0 = _self->xx0; /* list<11277> */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  kk_unit_t wild__0_19933 = kk_Unit;
  kk_unit_unbox(_b_19931);
  kk_unit_t _x21789 = kk_Unit;
  kk_std_core__mlift18822_unroll17339_foreach(action0, xx0, wild__0_19933, _ctx);
  return kk_unit_box(_x21789);
}

kk_unit_t kk_std_core__unroll17339_foreach(kk_std_core__list xs, kk_function_t action0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, action : (a) -> e ()) -> e () */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21785 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21785->head;
    kk_std_core__list xx0 = _con21785->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_unit_t x0_19008 = kk_Unit;
    kk_function_t _x21786 = kk_function_dup(action0, _ctx); /*(11277) -> 11278 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_box_t, kk_context_t*), _x21786, (_x21786, x, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21787 = kk_std_core_hnd_yield_extend(kk_std_core__new_unroll17339_foreach_fun21788(action0, xx0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21787); return kk_Unit;
    }
    { // tailcall
      xs = xx0;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18823_lift18310_foreach_1(kk_function_t action, kk_std_core__sslice rest18155, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<_a,e> (action : (c : char) -> e (), rest18155 : sslice, wild_ : ()) -> e maybe<_a> */ 
  return kk_std_core__lift18310_foreach_1(action, rest18155, _ctx);
}
 
// lifted local: foreach.1, .spec.18161
// specialized: std/core/foreach-while.1, on parameters action18150, using:
// action18150 = fn<(e :: E)>(c: char){
//   val _ : ()
//         = action(c);
//   std/core/types/Nothing<_a>;
// }


// lift anonymous function
struct kk_std_core__lift18310_foreach_fun21792__t_1 {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_std_core__sslice rest181550;
};
static kk_box_t kk_std_core__lift18310_foreach_fun21792_1(kk_function_t _fself, kk_box_t _b_19938, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18310_foreach_fun21792_1(kk_function_t action0, kk_std_core__sslice rest181550, kk_context_t* _ctx) {
  struct kk_std_core__lift18310_foreach_fun21792__t_1* _self = kk_function_alloc_as(struct kk_std_core__lift18310_foreach_fun21792__t_1, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18310_foreach_fun21792_1, kk_context());
  _self->action0 = action0;
  _self->rest181550 = rest181550;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18310_foreach_fun21792_1(kk_function_t _fself, kk_box_t _b_19938, kk_context_t* _ctx) {
  struct kk_std_core__lift18310_foreach_fun21792__t_1* _self = kk_function_as(struct kk_std_core__lift18310_foreach_fun21792__t_1*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (c : char) -> 11336 () */
  kk_std_core__sslice rest181550 = _self->rest181550; /* sslice */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_std_core__sslice_dup(rest181550, _ctx);}, {}, _ctx)
  kk_unit_t wild__0_19940 = kk_Unit;
  kk_unit_unbox(_b_19938);
  kk_std_core_types__maybe _x21793 = kk_std_core__mlift18823_lift18310_foreach_1(action0, rest181550, wild__0_19940, _ctx); /*maybe<_11323>*/
  return kk_std_core_types__maybe_box(_x21793, _ctx);
}

kk_std_core_types__maybe kk_std_core__lift18310_foreach_1(kk_function_t action0, kk_std_core__sslice slice018149, kk_context_t* _ctx) { /* forall<_a,e> (action : (c : char) -> e (), slice018149 : sslice) -> e maybe<_a> */ 
  kk__tailcall: ;
  kk_std_core_types__maybe _match_20825 = kk_std_core_next(slice018149, _ctx); /*maybe<(char, sslice)>*/;
  if (kk_std_core_types__is_Nothing(_match_20825, _ctx)) {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_box_t _box_x19934 = _match_20825._cons.Just.value;
    kk_std_core_types__tuple2_ _pat118153 = kk_std_core_types__tuple2__unbox(_box_x19934, KK_BORROWED, _ctx);
    kk_box_t _box_x19935 = _pat118153.fst;
    kk_box_t _box_x19936 = _pat118153.snd;
    kk_std_core__sslice rest181550 = kk_std_core__sslice_unbox(_box_x19936, KK_BORROWED, _ctx);
    kk_char_t c18154 = kk_char_unbox(_box_x19935, KK_BORROWED, _ctx);
    kk_std_core__sslice_dup(rest181550, _ctx);
    kk_std_core_types__maybe_drop(_match_20825, _ctx);
    kk_unit_t x_19011 = kk_Unit;
    kk_function_t _x21790 = kk_function_dup(action0, _ctx); /*(c : char) -> 11336 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_char_t, kk_context_t*), _x21790, (_x21790, c18154, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21791 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18310_foreach_fun21792_1(action0, rest181550, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x21791, KK_OWNED, _ctx);
    }
    { // tailcall
      slice018149 = rest181550;
      goto kk__tailcall;
    }
  }
}
 
// Apply a function for each character in a string slice.


// lift anonymous function
struct kk_std_core_foreach_fun21795__t_1 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_foreach_fun21795_1(kk_function_t _fself, kk_box_t _b_19942, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_fun21795_1(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_foreach_fun21795_1, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_foreach_fun21795_1(kk_function_t _fself, kk_box_t _b_19942, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__maybe wild__0_19944 = kk_std_core_types__maybe_unbox(_b_19942, KK_OWNED, _ctx); /*maybe<_11323>*/;
  kk_std_core_types__maybe_drop(wild__0_19944, _ctx);
  return kk_unit_box(kk_Unit);
}

kk_unit_t kk_std_core_foreach_1(kk_std_core__sslice slice0, kk_function_t action, kk_context_t* _ctx) { /* forall<e> (slice : sslice, action : (c : char) -> e ()) -> e () */ 
  kk_std_core_types__maybe x_19014 = kk_std_core__lift18310_foreach_1(action, slice0, _ctx); /*maybe<_11323>*/;
  kk_std_core_types__maybe_drop(x_19014, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x21794 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_fun21795_1(_ctx), _ctx); /*3926*/
    kk_unit_unbox(_x21794); return kk_Unit;
  }
  {
    kk_Unit; return kk_Unit;
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18825_lift18311_foreach_2(kk_function_t action, kk_std_core__sslice rest18169, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<_a,e> (action : (c : char) -> e (), rest18169 : sslice, wild_ : ()) -> e maybe<_a> */ 
  return kk_std_core__lift18311_foreach_2(action, rest18169, _ctx);
}
 
// lifted local: foreach.2, .spec.18175
// specialized: std/core/foreach-while.1, on parameters action18164, using:
// action18164 = fn<(e :: E)>(c: char){
//   val _ : ()
//         = action(c);
//   std/core/types/Nothing<_a>;
// }


// lift anonymous function
struct kk_std_core__lift18311_foreach_fun21798__t_2 {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_std_core__sslice rest181690;
};
static kk_box_t kk_std_core__lift18311_foreach_fun21798_2(kk_function_t _fself, kk_box_t _b_19949, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18311_foreach_fun21798_2(kk_function_t action0, kk_std_core__sslice rest181690, kk_context_t* _ctx) {
  struct kk_std_core__lift18311_foreach_fun21798__t_2* _self = kk_function_alloc_as(struct kk_std_core__lift18311_foreach_fun21798__t_2, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18311_foreach_fun21798_2, kk_context());
  _self->action0 = action0;
  _self->rest181690 = rest181690;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18311_foreach_fun21798_2(kk_function_t _fself, kk_box_t _b_19949, kk_context_t* _ctx) {
  struct kk_std_core__lift18311_foreach_fun21798__t_2* _self = kk_function_as(struct kk_std_core__lift18311_foreach_fun21798__t_2*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (c : char) -> 11375 () */
  kk_std_core__sslice rest181690 = _self->rest181690; /* sslice */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_std_core__sslice_dup(rest181690, _ctx);}, {}, _ctx)
  kk_unit_t wild__0_19951 = kk_Unit;
  kk_unit_unbox(_b_19949);
  kk_std_core_types__maybe _x21799 = kk_std_core__mlift18825_lift18311_foreach_2(action0, rest181690, wild__0_19951, _ctx); /*maybe<_11323>*/
  return kk_std_core_types__maybe_box(_x21799, _ctx);
}

kk_std_core_types__maybe kk_std_core__lift18311_foreach_2(kk_function_t action0, kk_std_core__sslice slice018163, kk_context_t* _ctx) { /* forall<_a,e> (action : (c : char) -> e (), slice018163 : sslice) -> e maybe<_a> */ 
  kk__tailcall: ;
  kk_std_core_types__maybe _match_20822 = kk_std_core_next(slice018163, _ctx); /*maybe<(char, sslice)>*/;
  if (kk_std_core_types__is_Nothing(_match_20822, _ctx)) {
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_box_t _box_x19945 = _match_20822._cons.Just.value;
    kk_std_core_types__tuple2_ _pat118167 = kk_std_core_types__tuple2__unbox(_box_x19945, KK_BORROWED, _ctx);
    kk_box_t _box_x19946 = _pat118167.fst;
    kk_box_t _box_x19947 = _pat118167.snd;
    kk_std_core__sslice rest181690 = kk_std_core__sslice_unbox(_box_x19947, KK_BORROWED, _ctx);
    kk_char_t c18168 = kk_char_unbox(_box_x19946, KK_BORROWED, _ctx);
    kk_std_core__sslice_dup(rest181690, _ctx);
    kk_std_core_types__maybe_drop(_match_20822, _ctx);
    kk_unit_t x_19018 = kk_Unit;
    kk_function_t _x21796 = kk_function_dup(action0, _ctx); /*(c : char) -> 11375 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_char_t, kk_context_t*), _x21796, (_x21796, c18168, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21797 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18311_foreach_fun21798_2(action0, rest181690, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x21797, KK_OWNED, _ctx);
    }
    { // tailcall
      slice018163 = rest181690;
      goto kk__tailcall;
    }
  }
}
 
// Invoke a function for each character in a string


// lift anonymous function
struct kk_std_core_foreach_fun21803__t_2 {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_foreach_fun21803_2(kk_function_t _fself, kk_box_t _b_19953, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foreach_fun21803_2(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_foreach_fun21803_2, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_foreach_fun21803_2(kk_function_t _fself, kk_box_t _b_19953, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_std_core_types__maybe wild__0_19955 = kk_std_core_types__maybe_unbox(_b_19953, KK_OWNED, _ctx); /*maybe<_11323>*/;
  kk_std_core_types__maybe_drop(wild__0_19955, _ctx);
  return kk_unit_box(kk_Unit);
}

kk_unit_t kk_std_core_foreach_2(kk_string_t s, kk_function_t action, kk_context_t* _ctx) { /* forall<e> (s : string, action : (c : char) -> e ()) -> e () */ 
  kk_std_core__sslice slice0_17619;
  kk_string_t _x21800 = kk_string_dup(s, _ctx); /*string*/
  kk_integer_t _x21801 = kk_string_len_int(s,kk_context()); /*int*/
  slice0_17619 = kk_std_core__new_Sslice(_x21800, kk_integer_from_small(0), _x21801, _ctx); /*sslice*/
  kk_std_core_types__maybe x_19021 = kk_std_core__lift18311_foreach_2(action, slice0_17619, _ctx); /*maybe<_11323>*/;
  kk_std_core_types__maybe_drop(x_19021, _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x21802 = kk_std_core_hnd_yield_extend(kk_std_core_new_foreach_fun21803_2(_ctx), _ctx); /*3926*/
    kk_unit_unbox(_x21802); return kk_Unit;
  }
  {
    kk_Unit; return kk_Unit;
  }
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18827_lift18312_foreach_3(kk_ssize_t end18178, kk_function_t f, kk_ssize_t i18179, kk_vector_t v, kk_unit_t wild__18181, kk_context_t* _ctx) { /* forall<a,e> (end18178 : ssize_t, f : (a) -> e (), i18179 : ssize_t, v : vector<a>, wild_18181 : ()) -> e () */ 
  kk_ssize_t i0_1744818182 = kk_std_core_incr_1(i18179, _ctx); /*ssize_t*/;
  kk_std_core__lift18312_foreach_3(f, v, end18178, i0_1744818182, _ctx); return kk_Unit;
}
 
// lifted local: foreach.3, .spec.18184
// specialized: std/core/.lift17317-forz, on parameters action18177, using:
// action18177 = fn<(e :: E)>(i0: ssize_t){
//   val x.17875 : a
//         = std/core/types/.open<(total :: E),(e :: E),(v : (vector :: V -> V)<a>, index : ssize_t) -> (total :: E) a,(v : (vector :: V -> V)<a>, index : ssize_t) -> (e :: E) a>((std/core/unsafe-idx<a>))(v, i0);
//   f(x.17875);
// }


// lift anonymous function
struct kk_std_core__lift18312_foreach_fun21806__t_3 {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_vector_t v0;
  kk_ssize_t end181780;
  kk_ssize_t i181790;
};
static kk_box_t kk_std_core__lift18312_foreach_fun21806_3(kk_function_t _fself, kk_box_t _b_19957, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18312_foreach_fun21806_3(kk_function_t f0, kk_vector_t v0, kk_ssize_t end181780, kk_ssize_t i181790, kk_context_t* _ctx) {
  struct kk_std_core__lift18312_foreach_fun21806__t_3* _self = kk_function_alloc_as(struct kk_std_core__lift18312_foreach_fun21806__t_3, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18312_foreach_fun21806_3, kk_context());
  _self->f0 = f0;
  _self->v0 = v0;
  _self->end181780 = end181780;
  _self->i181790 = i181790;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18312_foreach_fun21806_3(kk_function_t _fself, kk_box_t _b_19957, kk_context_t* _ctx) {
  struct kk_std_core__lift18312_foreach_fun21806__t_3* _self = kk_function_as(struct kk_std_core__lift18312_foreach_fun21806__t_3*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (11390) -> 11391 () */
  kk_vector_t v0 = _self->v0; /* vector<11390> */
  kk_ssize_t end181780 = _self->end181780; /* ssize_t */
  kk_ssize_t i181790 = _self->i181790; /* ssize_t */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_vector_dup(v0, _ctx);;;}, {}, _ctx)
  kk_unit_t wild__181810_19959 = kk_Unit;
  kk_unit_unbox(_b_19957);
  kk_unit_t _x21807 = kk_Unit;
  kk_std_core__mlift18827_lift18312_foreach_3(end181780, f0, i181790, v0, wild__181810_19959, _ctx);
  return kk_unit_box(_x21807);
}

kk_unit_t kk_std_core__lift18312_foreach_3(kk_function_t f0, kk_vector_t v0, kk_ssize_t end181780, kk_ssize_t i181790, kk_context_t* _ctx) { /* forall<a,e> (f : (a) -> e (), v : vector<a>, end18178 : ssize_t, i18179 : ssize_t) -> e () */ 
  kk__tailcall: ;
  bool _match_20819 = (i181790 <= end181780); /*bool*/;
  if (_match_20819) {
    kk_box_t x_17875 = kk_vector_at_borrow(v0,i181790,kk_context()); /*11390*/;
    kk_unit_t x_19025 = kk_Unit;
    kk_function_t _x21804 = kk_function_dup(f0, _ctx); /*(11390) -> 11391 ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_box_t, kk_context_t*), _x21804, (_x21804, x_17875, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21805 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18312_foreach_fun21806_3(f0, v0, end181780, i181790, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21805); return kk_Unit;
    }
    {
      kk_ssize_t i0_17448181820 = kk_std_core_incr_1(i181790, _ctx); /*ssize_t*/;
      { // tailcall
        i181790 = i0_17448181820;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_vector_drop(v0, _ctx);
    kk_function_drop(f0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// O(n). Return the number of characters in a string.

kk_integer_t kk_std_core_count_1(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> int */ 
  return kk_string_count_int(s,kk_context());
}
 
// O(n). Return the number of characters in a string slice

kk_integer_t kk_std_core_count_2(kk_std_core__sslice slice0, kk_context_t* _ctx) { /* (slice : sslice) -> int */ 
  return kk_slice_count(slice0,kk_context());
}
 
// lifted local: count.3, .spec.18198
// specialized: std/core/foreach-while.1, on parameters action18187, using:
// action18187 = fn<((local :: H -> X)<(h :: H)>)>(c: char){
//   val _ : ()
//         = match ((pred(c))) {
//           ((std/core/types/True() : bool ) as .pat: bool)
//              -> val x.17629 : int
//                       = std/core/types/local-get<int,(h :: H),((<>) :: E)>(cnt);
//             std/core/types/local-set<int,((<>) :: E),(h :: H)>(cnt, (std/core/int-add(x.17629, 1)));
//           ((.skip std/core/types/False() : bool ) as .pat0: bool)
//              -> std/core/types/();
//         };
//   std/core/types/Nothing<_a>;
// }

kk_std_core_types__maybe kk_std_core__lift18313_count_3(kk_ref_t cnt, kk_function_t pred, kk_std_core__sslice slice018186, kk_context_t* _ctx) { /* forall<_a,h> (cnt : local-var<h,int>, pred : (char) -> bool, slice018186 : sslice) -> (local<h>) maybe<_a> */ 
  kk__tailcall: ;
  kk_std_core_types__maybe _match_20817 = kk_std_core_next(slice018186, _ctx); /*maybe<(char, sslice)>*/;
  if (kk_std_core_types__is_Nothing(_match_20817, _ctx)) {
    kk_function_drop(pred, _ctx);
    kk_ref_drop(cnt, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_box_t _box_x19960 = _match_20817._cons.Just.value;
    kk_std_core_types__tuple2_ _pat118190 = kk_std_core_types__tuple2__unbox(_box_x19960, KK_BORROWED, _ctx);
    kk_box_t _box_x19961 = _pat118190.fst;
    kk_box_t _box_x19962 = _pat118190.snd;
    kk_std_core__sslice rest18192 = kk_std_core__sslice_unbox(_box_x19962, KK_BORROWED, _ctx);
    kk_char_t c18191 = kk_char_unbox(_box_x19961, KK_BORROWED, _ctx);
    kk_std_core__sslice_dup(rest18192, _ctx);
    kk_std_core_types__maybe_drop(_match_20817, _ctx);
    kk_unit_t __ = kk_Unit;
    bool _match_20818;
    kk_function_t _x21809 = kk_function_dup(pred, _ctx); /*(char) -> bool*/
    _match_20818 = kk_function_call(bool, (kk_function_t, kk_char_t, kk_context_t*), _x21809, (_x21809, c18191, _ctx), _ctx); /*bool*/
    if (_match_20818) {
      kk_integer_t x_17629;
      kk_box_t _x21810;
      kk_ref_t _x21811 = kk_ref_dup(cnt, _ctx); /*local-var<11584,int>*/
      _x21810 = kk_ref_get(_x21811,kk_context()); /*264*/
      x_17629 = kk_integer_unbox(_x21810, _ctx); /*int*/
      kk_integer_t _b_19968_19966 = kk_integer_add_small_const(x_17629, 1, _ctx); /*int*/;
      kk_ref_set_borrow(cnt,(kk_integer_box(_b_19968_19966, _ctx)),kk_context());
    }
    else {
      
    }
    { // tailcall
      slice018186 = rest18192;
      goto kk__tailcall;
    }
  }
}
 
// Count the number of times a predicate is true for each character in a string

kk_integer_t kk_std_core_count_3(kk_string_t s, kk_function_t pred, kk_context_t* _ctx) { /* (s : string, pred : (char) -> bool) -> int */ 
  kk_ref_t loc = kk_ref_alloc((kk_integer_box(kk_integer_from_small(0), _ctx)),kk_context()); /*local-var<11584,int>*/;
  kk_std_core__sslice slice0_17631;
  kk_string_t _x21812 = kk_string_dup(s, _ctx); /*string*/
  kk_integer_t _x21813 = kk_string_len_int(s,kk_context()); /*int*/
  slice0_17631 = kk_std_core__new_Sslice(_x21812, kk_integer_from_small(0), _x21813, _ctx); /*sslice*/
  kk_std_core_types__maybe __0;
  kk_ref_t _x21814 = kk_ref_dup(loc, _ctx); /*local-var<11584,int>*/
  __0 = kk_std_core__lift18313_count_3(_x21814, pred, slice0_17631, _ctx); /*maybe<_11323>*/
  kk_std_core_types__maybe_drop(__0, _ctx);
  kk_integer_t res;
  kk_box_t _x21815;
  kk_ref_t _x21816 = kk_ref_dup(loc, _ctx); /*local-var<11584,int>*/
  _x21815 = kk_ref_get(_x21816,kk_context()); /*264*/
  res = kk_integer_unbox(_x21815, _ctx); /*int*/
  kk_box_t _x21817 = kk_std_core_hnd_prompt_local_var(loc, kk_integer_box(res, _ctx), _ctx); /*10459*/
  return kk_integer_unbox(_x21817, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core_divmod_exp10(kk_integer_t i, kk_integer_t n, kk_context_t* _ctx) { /* (i : int, n : int) -> (int, int) */ 
  kk_std_core_types__tuple2_ _match_20815;
  kk_integer_t _x21821 = kk_integer_dup(n, _ctx); /*int*/
  _match_20815 = kk_std_core_cdivmod_exp10(i, _x21821, _ctx); /*(int, int)*/
  {
    kk_box_t _box_x19982 = _match_20815.fst;
    kk_box_t _box_x19983 = _match_20815.snd;
    kk_integer_t cq = kk_integer_unbox(_box_x19982, _ctx);
    kk_integer_t cr = kk_integer_unbox(_box_x19983, _ctx);
    kk_integer_dup(cq, _ctx);
    kk_integer_dup(cr, _ctx);
    kk_std_core_types__tuple2__drop(_match_20815, _ctx);
    bool b_17636 = kk_integer_lt_borrow(cr,(kk_integer_from_small(0)),kk_context()); /*bool*/;
    if (b_17636) {
      kk_integer_t y0_17642 = kk_std_core_mul_exp10(kk_integer_from_small(1), n, _ctx); /*int*/;
      kk_integer_t _b_19988_19984 = kk_integer_add_small_const(cq, -1, _ctx); /*int*/;
      kk_integer_t _b_19989_19985 = kk_integer_add(cr,y0_17642,kk_context()); /*int*/;
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(_b_19988_19984, _ctx), kk_integer_box(_b_19989_19985, _ctx), _ctx);
    }
    {
      kk_integer_drop(n, _ctx);
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_integer_box(cq, _ctx), kk_integer_box(cr, _ctx), _ctx);
    }
  }
}
 
// Drop the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core__list kk_std_core_drop(kk_std_core__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21822 = kk_std_core__as_Cons(xs, _ctx);
    if (kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context())) {
      kk_box_t _pat0 = _con21822->head;
      kk_std_core__list xx = _con21822->tail;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_box_drop(_pat0, _ctx);
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_std_core__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      { // tailcall
        kk_integer_t _x21823 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        xs = xx;
        n = _x21823;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(n, _ctx);
    return xs;
  }
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18828_unroll17340_drop_while(kk_function_t predicate, kk_std_core__list xs, kk_std_core__list xx, bool _y_18570, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, xs : list<a>, xx : list<a>, bool) -> e list<a> */ 
  if (_y_18570) {
    kk_std_core__list_drop(xs, _ctx);
    return kk_std_core__unroll17340_drop_while(xx, predicate, _ctx);
  }
  {
    kk_std_core__list_drop(xx, _ctx);
    kk_function_drop(predicate, _ctx);
    return xs;
  }
}
 
// Drop all initial elements that satisfy `predicate`


// lift anonymous function
struct kk_std_core__unroll17340_drop_while_fun21827__t {
  struct kk_function_s _base;
  kk_function_t predicate0;
  kk_std_core__list xs0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core__unroll17340_drop_while_fun21827(kk_function_t _fself, kk_box_t _b_19993, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_unroll17340_drop_while_fun21827(kk_function_t predicate0, kk_std_core__list xs0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core__unroll17340_drop_while_fun21827__t* _self = kk_function_alloc_as(struct kk_std_core__unroll17340_drop_while_fun21827__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__unroll17340_drop_while_fun21827, kk_context());
  _self->predicate0 = predicate0;
  _self->xs0 = xs0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__unroll17340_drop_while_fun21827(kk_function_t _fself, kk_box_t _b_19993, kk_context_t* _ctx) {
  struct kk_std_core__unroll17340_drop_while_fun21827__t* _self = kk_function_as(struct kk_std_core__unroll17340_drop_while_fun21827__t*, _fself, _ctx);
  kk_function_t predicate0 = _self->predicate0; /* (11842) -> 11843 bool */
  kk_std_core__list xs0 = _self->xs0; /* list<11842> */
  kk_std_core__list xx0 = _self->xx0; /* list<11842> */
  kk_drop_match(_self, {kk_function_dup(predicate0, _ctx);kk_std_core__list_dup(xs0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  bool _y_19995_185700 = kk_bool_unbox(_b_19993); /*bool*/;
  kk_std_core__list _x21828 = kk_std_core__mlift18828_unroll17340_drop_while(predicate0, xs0, xx0, _y_19995_185700, _ctx); /*list<11842>*/
  return kk_std_core__list_box(_x21828, _ctx);
}

kk_std_core__list kk_std_core__unroll17340_drop_while(kk_std_core__list xs0, kk_function_t predicate0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs0, _ctx)) {
    struct kk_std_core_Cons* _con21824 = kk_std_core__as_Cons(xs0, _ctx);
    kk_box_t x = _con21824->head;
    kk_std_core__list xx0 = _con21824->tail;
    kk_box_dup(x, _ctx);
    kk_std_core__list_dup(xx0, _ctx);
    bool x0_19030;
    kk_function_t _x21825 = kk_function_dup(predicate0, _ctx); /*(11842) -> 11843 bool*/
    x0_19030 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x21825, (_x21825, x, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x21826 = kk_std_core_hnd_yield_extend(kk_std_core__new_unroll17340_drop_while_fun21827(predicate0, xs0, xx0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x21826, KK_OWNED, _ctx);
    }
    if (x0_19030) {
      if kk_likely(kk_datatype_ptr_is_unique(xs0, _ctx)) {
        kk_std_core__list_drop(xx0, _ctx);
        kk_box_drop(x, _ctx);
        kk_datatype_ptr_free(xs0, _ctx);
      }
      else {
        kk_datatype_ptr_decref(xs0, _ctx);
      }
      { // tailcall
        xs0 = xx0;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core__list_drop(xx0, _ctx);
      kk_function_drop(predicate0, _ctx);
      return xs0;
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    return kk_std_core__new_Nil(_ctx);
  }
}
 
// Does string `s`  end with `post`?
// If so, returns a slice of `s` from the start up to the `post` string at the end.

kk_std_core_types__maybe kk_std_core_ends_with(kk_string_t s, kk_string_t post, kk_context_t* _ctx) { /* (s : string, post : string) -> maybe<sslice> */ 
  bool _match_20813;
  kk_string_t _x21829 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x21830 = kk_string_dup(post, _ctx); /*string*/
  _match_20813 = kk_std_core_xends_with(_x21829, _x21830, _ctx); /*bool*/
  if (_match_20813) {
    kk_integer_t x_17646;
    kk_string_t _x21831 = kk_string_dup(s, _ctx); /*string*/
    x_17646 = kk_string_len_int(_x21831,kk_context()); /*int*/
    kk_integer_t y_17647 = kk_string_len_int(post,kk_context()); /*int*/;
    kk_std_core__sslice _b_19997_19996;
    kk_integer_t _x21832 = kk_integer_sub(x_17646,y_17647,kk_context()); /*int*/
    _b_19997_19996 = kk_std_core__new_Sslice(s, kk_integer_from_small(0), _x21832, _ctx); /*sslice*/
    return kk_std_core_types__new_Just(kk_std_core__sslice_box(_b_19997_19996, _ctx), _ctx);
  }
  {
    kk_string_drop(s, _ctx);
    kk_string_drop(post, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Throw an exception with a specified message.

kk_box_t kk_std_core_throw(kk_string_t message0, kk_std_core_types__optional info0, kk_context_t* _ctx) { /* forall<a> (message : string, info : optional<exception-info>) -> exn a */ 
  kk_std_core_hnd__ev ev_19033;
  kk_ssize_t _x21833 = (KK_IZ(0)); /*ssize_t*/
  ev_19033 = kk_evv_at(_x21833,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
  {
    struct kk_std_core_hnd_Ev* _con21834 = kk_std_core_hnd__as_Ev(ev_19033, _ctx);
    kk_box_t _box_x19998 = _con21834->hnd;
    kk_std_core_hnd__marker m0 = _con21834->marker;
    kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x19998, KK_BORROWED, _ctx);
    kk_std_core__hnd_exn_dup(h, _ctx);
    {
      struct kk_std_core__Hnd_exn* _con21835 = kk_std_core__as_Hnd_exn(h, _ctx);
      kk_std_core_hnd__clause1 ctl_throw_exn = _con21835->ctl_throw_exn;
      if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
        kk_datatype_ptr_free(h, _ctx);
      }
      else {
        kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
        kk_datatype_ptr_decref(h, _ctx);
      }
      {
        kk_function_t _fun_unbox_x20002 = ctl_throw_exn.clause;
        kk_box_t _x21836;
        kk_std_core__exception _x21837;
        kk_std_core__exception_info _x21838;
        if (kk_std_core_types__is_Optional(info0, _ctx)) {
          kk_box_t _box_x20006 = info0._cons.Optional.value;
          kk_std_core__exception_info _info_11917 = kk_std_core__exception_info_unbox(_box_x20006, KK_BORROWED, _ctx);
          kk_std_core__exception_info_dup(_info_11917, _ctx);
          kk_std_core_types__optional_drop(info0, _ctx);
          _x21838 = _info_11917; /*exception-info*/
        }
        else {
          kk_std_core_types__optional_drop(info0, _ctx);
          _x21838 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
        }
        _x21837 = kk_std_core__new_Exception(message0, _x21838, _ctx); /*exception*/
        _x21836 = kk_std_core__exception_box(_x21837, _ctx); /*51*/
        return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x20002, (_fun_unbox_x20002, m0, ev_19033, _x21836, _ctx), _ctx);
      }
    }
  }
}
 
// monadic lift

kk_box_t kk_std_core__mlift18829_error_pattern(kk_string_t definition, kk_string_t location, kk_string_t _c_18577, kk_context_t* _ctx) { /* forall<a> (definition : string, location : string, string) -> a */ 
  kk_string_t message0_17649;
  kk_string_t _x21839 = kk_string_dup(location, _ctx); /*string*/
  kk_string_t _x21840;
  kk_string_t _x21841;
  kk_define_string_literal(, _s21842, 23, ": pattern match failure", _ctx)
  _x21841 = kk_string_dup(_s21842, _ctx); /*string*/
  _x21840 = kk_std_core__lp__plus__plus__1_rp_(_c_18577, _x21841, _ctx); /*string*/
  message0_17649 = kk_std_core__lp__plus__plus__1_rp_(_x21839, _x21840, _ctx); /*string*/
  kk_std_core_hnd__ev ev_19036;
  kk_ssize_t _x21843 = (KK_IZ(0)); /*ssize_t*/
  ev_19036 = kk_evv_at(_x21843,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
  {
    struct kk_std_core_hnd_Ev* _con21844 = kk_std_core_hnd__as_Ev(ev_19036, _ctx);
    kk_box_t _box_x20007 = _con21844->hnd;
    kk_std_core_hnd__marker m0 = _con21844->marker;
    kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x20007, KK_BORROWED, _ctx);
    kk_std_core__hnd_exn_dup(h, _ctx);
    {
      struct kk_std_core__Hnd_exn* _con21845 = kk_std_core__as_Hnd_exn(h, _ctx);
      kk_std_core_hnd__clause1 ctl_throw_exn = _con21845->ctl_throw_exn;
      if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
        kk_datatype_ptr_free(h, _ctx);
      }
      else {
        kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
        kk_datatype_ptr_decref(h, _ctx);
      }
      {
        kk_function_t _fun_unbox_x20011 = ctl_throw_exn.clause;
        kk_box_t _x21846;
        kk_std_core__exception _x21847;
        kk_std_core__exception_info _x21848 = kk_std_core__new_ExnPattern(kk_reuse_null, 0, location, definition, _ctx); /*exception-info*/
        _x21847 = kk_std_core__new_Exception(message0_17649, _x21848, _ctx); /*exception*/
        _x21846 = kk_std_core__exception_box(_x21847, _ctx); /*51*/
        return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x20011, (_fun_unbox_x20011, m0, ev_19036, _x21846, _ctx), _ctx);
      }
    }
  }
}
 
// Raise a pattern match exception. This is function is used internally by the
// compiler to generate error messages on pattern match failures.


// lift anonymous function
struct kk_std_core_error_pattern_fun21856__t {
  struct kk_function_s _base;
  kk_string_t definition;
  kk_string_t location;
};
static kk_box_t kk_std_core_error_pattern_fun21856(kk_function_t _fself, kk_box_t _b_20016, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_error_pattern_fun21856(kk_string_t definition, kk_string_t location, kk_context_t* _ctx) {
  struct kk_std_core_error_pattern_fun21856__t* _self = kk_function_alloc_as(struct kk_std_core_error_pattern_fun21856__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_error_pattern_fun21856, kk_context());
  _self->definition = definition;
  _self->location = location;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_error_pattern_fun21856(kk_function_t _fself, kk_box_t _b_20016, kk_context_t* _ctx) {
  struct kk_std_core_error_pattern_fun21856__t* _self = kk_function_as(struct kk_std_core_error_pattern_fun21856__t*, _fself, _ctx);
  kk_string_t definition = _self->definition; /* string */
  kk_string_t location = _self->location; /* string */
  kk_drop_match(_self, {kk_string_dup(definition, _ctx);kk_string_dup(location, _ctx);}, {}, _ctx)
  kk_string_t _x21857 = kk_string_unbox(_b_20016); /*string*/
  return kk_std_core__mlift18829_error_pattern(definition, location, _x21857, _ctx);
}

kk_box_t kk_std_core_error_pattern(kk_string_t location, kk_string_t definition, kk_context_t* _ctx) { /* forall<a> (location : string, definition : string) -> exn a */ 
  kk_string_t x_19039;
  bool _match_20812;
  kk_string_t _x21849 = kk_string_dup(definition, _ctx); /*string*/
  kk_string_t _x21850 = kk_string_empty(); /*string*/
  _match_20812 = kk_string_is_eq(_x21849,_x21850,kk_context()); /*bool*/
  if (_match_20812) {
    x_19039 = kk_string_empty(); /*string*/
  }
  else {
    kk_string_t _x21853;
    kk_define_string_literal(, _s21854, 2, ": ", _ctx)
    _x21853 = kk_string_dup(_s21854, _ctx); /*string*/
    kk_string_t _x21855 = kk_string_dup(definition, _ctx); /*string*/
    x_19039 = kk_std_core__lp__plus__plus__1_rp_(_x21853, _x21855, _ctx); /*string*/
  }
  if (kk_yielding(kk_context())) {
    kk_string_drop(x_19039, _ctx);
    return kk_std_core_hnd_yield_extend(kk_std_core_new_error_pattern_fun21856(definition, location, _ctx), _ctx);
  }
  {
    kk_string_t message0_17649;
    kk_string_t _x21858 = kk_string_dup(location, _ctx); /*string*/
    kk_string_t _x21859;
    kk_string_t _x21860;
    kk_define_string_literal(, _s21861, 23, ": pattern match failure", _ctx)
    _x21860 = kk_string_dup(_s21861, _ctx); /*string*/
    _x21859 = kk_std_core__lp__plus__plus__1_rp_(x_19039, _x21860, _ctx); /*string*/
    message0_17649 = kk_std_core__lp__plus__plus__1_rp_(_x21858, _x21859, _ctx); /*string*/
    kk_std_core_hnd__ev ev_19042;
    kk_ssize_t _x21862 = (KK_IZ(0)); /*ssize_t*/
    ev_19042 = kk_evv_at(_x21862,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    {
      struct kk_std_core_hnd_Ev* _con21863 = kk_std_core_hnd__as_Ev(ev_19042, _ctx);
      kk_box_t _box_x20017 = _con21863->hnd;
      kk_std_core_hnd__marker m0 = _con21863->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x20017, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      {
        struct kk_std_core__Hnd_exn* _con21864 = kk_std_core__as_Hnd_exn(h, _ctx);
        kk_std_core_hnd__clause1 ctl_throw_exn = _con21864->ctl_throw_exn;
        if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
          kk_datatype_ptr_free(h, _ctx);
        }
        else {
          kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
          kk_datatype_ptr_decref(h, _ctx);
        }
        {
          kk_function_t _fun_unbox_x20021 = ctl_throw_exn.clause;
          kk_box_t _x21865;
          kk_std_core__exception _x21866;
          kk_std_core__exception_info _x21867 = kk_std_core__new_ExnPattern(kk_reuse_null, 0, location, definition, _ctx); /*exception-info*/
          _x21866 = kk_std_core__new_Exception(message0_17649, _x21867, _ctx); /*exception*/
          _x21865 = kk_std_core__exception_box(_x21866, _ctx); /*51*/
          return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x20021, (_fun_unbox_x20021, m0, ev_19042, _x21865, _ctx), _ctx);
        }
      }
    }
  }
}
 
// Transform an `:error` type back to an `exn` effect.

kk_box_t kk_std_core_untry(kk_std_core__error err, kk_context_t* _ctx) { /* forall<a> (err : error<a>) -> exn a */ 
  if (kk_std_core__is_Error(err, _ctx)) {
    kk_std_core__exception exn0 = err._cons.Error.exception;
    kk_std_core__exception_dup(exn0, _ctx);
    kk_std_core__error_drop(err, _ctx);
    kk_std_core_hnd__ev ev_19045;
    kk_ssize_t _x21868 = (KK_IZ(0)); /*ssize_t*/
    ev_19045 = kk_evv_at(_x21868,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    {
      struct kk_std_core_hnd_Ev* _con21869 = kk_std_core_hnd__as_Ev(ev_19045, _ctx);
      kk_box_t _box_x20027 = _con21869->hnd;
      kk_std_core_hnd__marker m0 = _con21869->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x20027, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      {
        struct kk_std_core__Hnd_exn* _con21870 = kk_std_core__as_Hnd_exn(h, _ctx);
        kk_std_core_hnd__clause1 ctl_throw_exn = _con21870->ctl_throw_exn;
        if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
          kk_datatype_ptr_free(h, _ctx);
        }
        else {
          kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
          kk_datatype_ptr_decref(h, _ctx);
        }
        {
          kk_function_t _fun_unbox_x20031 = ctl_throw_exn.clause;
          return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x20031, (_fun_unbox_x20031, m0, ev_19045, kk_std_core__exception_box(exn0, _ctx), _ctx), _ctx);
        }
      }
    }
  }
  {
    kk_box_t x0 = err._cons.Ok.result;
    return x0;
  }
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18830_trmc_unroll17341_filter(kk_std_core_types__cctx _acc, kk_function_t pred, kk_box_t x, kk_std_core__list xx, bool _y_18582, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, pred : (a) -> e bool, x : a, xx : list<a>, bool) -> e list<a> */ 
  if (_y_18582) {
    kk_std_core__list _trmc_18401 = kk_datatype_null(); /*list<12137>*/;
    kk_std_core__list _trmc_18402 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), x, _trmc_18401, _ctx); /*list<12137>*/;
    kk_box_t* _b_20043_20040 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18402, _ctx)->tail)); /*field-addr<list<12137>>*/;
    kk_std_core_types__cctx _x21871 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18402, _ctx)),_b_20043_20040,false,kk_context()); /*ctx<0>*/
    return kk_std_core__trmc_unroll17341_filter(xx, pred, _x21871, _ctx);
  }
  {
    kk_box_drop(x, _ctx);
    return kk_std_core__trmc_unroll17341_filter(xx, pred, _acc, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filter([1,2,3],odd?) == [1,3]`


// lift anonymous function
struct kk_std_core__trmc_unroll17341_filter_fun21876__t {
  struct kk_function_s _base;
  kk_function_t pred0;
  kk_box_t x0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17341_filter_fun21876(kk_function_t _fself, kk_box_t _b_20048, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17341_filter_fun21876(kk_function_t pred0, kk_box_t x0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17341_filter_fun21876__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17341_filter_fun21876__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17341_filter_fun21876, kk_context());
  _self->pred0 = pred0;
  _self->x0 = x0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17341_filter_fun21876(kk_function_t _fself, kk_box_t _b_20048, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17341_filter_fun21876__t* _self = kk_function_as(struct kk_std_core__trmc_unroll17341_filter_fun21876__t*, _fself, _ctx);
  kk_function_t pred0 = _self->pred0; /* (12137) -> 12138 bool */
  kk_box_t x0 = _self->x0; /* 12137 */
  kk_std_core__list xx0 = _self->xx0; /* list<12137> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<12137>> */
  kk_drop_match(_self, {kk_function_dup(pred0, _ctx);kk_box_dup(x0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  bool _y_20066_185820 = kk_bool_unbox(_b_20048); /*bool*/;
  kk_std_core__list _x21877 = kk_std_core__mlift18830_trmc_unroll17341_filter(_acc0, pred0, x0, xx0, _y_20066_185820, _ctx); /*list<12137>*/
  return kk_std_core__list_box(_x21877, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17341_filter(kk_std_core__list xs, kk_function_t pred0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21872 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x0 = _con21872->head;
    kk_std_core__list xx0 = _con21872->tail;
    kk_reuse_t _ru_21056 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_21056 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x0, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x1_19048;
    kk_function_t _x21874 = kk_function_dup(pred0, _ctx); /*(12137) -> 12138 bool*/
    kk_box_t _x21873 = kk_box_dup(x0, _ctx); /*12137*/
    x1_19048 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x21874, (_x21874, _x21873, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_21056,kk_context());
      kk_box_t _x21875 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17341_filter_fun21876(pred0, x0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x21875, KK_OWNED, _ctx);
    }
    if (x1_19048) {
      kk_std_core__list _trmc_184010 = kk_datatype_null(); /*list<12137>*/;
      kk_std_core__list _trmc_184020 = kk_std_core__new_Cons(_ru_21056, kk_field_index_of(struct kk_std_core_Cons, tail), x0, _trmc_184010, _ctx); /*list<12137>*/;
      kk_box_t* _b_20060_20054 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_184020, _ctx)->tail)); /*field-addr<list<12137>>*/;
      { // tailcall
        kk_std_core_types__cctx _x21878 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_184020, _ctx)),_b_20060_20054,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x21878;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_21056,kk_context());
      kk_box_drop(x0, _ctx);
      { // tailcall
        xs = xx0;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(pred0, _ctx);
    kk_box_t _x21879 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21879, KK_OWNED, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filter([1,2,3],odd?) == [1,3]`

kk_std_core__list kk_std_core__unroll17341_filter(kk_std_core__list xs0, kk_function_t pred1, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool) -> e list<a> */ 
  kk_std_core_types__cctx _x21880 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17341_filter(xs0, pred1, _x21880, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18831_trmc_unroll17342_filter_map(kk_std_core_types__cctx _acc, kk_function_t pred, kk_std_core__list xx, kk_std_core_types__maybe _y_18590, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, pred : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Nothing(_y_18590, _ctx)) {
    return kk_std_core__trmc_unroll17342_filter_map(xx, pred, _acc, _ctx);
  }
  {
    kk_box_t y = _y_18590._cons.Just.value;
    kk_std_core__list _trmc_18403 = kk_datatype_null(); /*list<12183>*/;
    kk_std_core__list _trmc_18404 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), y, _trmc_18403, _ctx); /*list<12183>*/;
    kk_box_t* _b_20075_20072 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18404, _ctx)->tail)); /*field-addr<list<12183>>*/;
    kk_std_core_types__cctx _x21881 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18404, _ctx)),_b_20075_20072,false,kk_context()); /*ctx<0>*/
    return kk_std_core__trmc_unroll17342_filter_map(xx, pred, _x21881, _ctx);
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filterMap([1,2,3],fn(i) { if i.odd? then Nothing else Just(i*i) }) == [4]`


// lift anonymous function
struct kk_std_core__trmc_unroll17342_filter_map_fun21886__t {
  struct kk_function_s _base;
  kk_function_t pred0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17342_filter_map_fun21886(kk_function_t _fself, kk_box_t _b_20082, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17342_filter_map_fun21886(kk_function_t pred0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17342_filter_map_fun21886__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17342_filter_map_fun21886__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17342_filter_map_fun21886, kk_context());
  _self->pred0 = pred0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17342_filter_map_fun21886(kk_function_t _fself, kk_box_t _b_20082, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17342_filter_map_fun21886__t* _self = kk_function_as(struct kk_std_core__trmc_unroll17342_filter_map_fun21886__t*, _fself, _ctx);
  kk_function_t pred0 = _self->pred0; /* (12182) -> 12184 maybe<12183> */
  kk_std_core__list xx0 = _self->xx0; /* list<12182> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<12183>> */
  kk_drop_match(_self, {kk_function_dup(pred0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_20098_185900 = kk_std_core_types__maybe_unbox(_b_20082, KK_OWNED, _ctx); /*maybe<12183>*/;
  kk_std_core__list _x21887 = kk_std_core__mlift18831_trmc_unroll17342_filter_map(_acc0, pred0, xx0, _y_20098_185900, _ctx); /*list<12183>*/
  return kk_std_core__list_box(_x21887, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17342_filter_map(kk_std_core__list xs, kk_function_t pred0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, pred : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(pred0, _ctx);
    kk_box_t _x21882 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21882, KK_OWNED, _ctx);
  }
  {
    struct kk_std_core_Cons* _con21883 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21883->head;
    kk_std_core__list xx0 = _con21883->tail;
    kk_reuse_t _ru_21057 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_21057 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x0_19051;
    kk_function_t _x21884 = kk_function_dup(pred0, _ctx); /*(12182) -> 12184 maybe<12183>*/
    x0_19051 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x21884, (_x21884, x, _ctx), _ctx); /*maybe<12183>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_21057,kk_context());
      kk_std_core_types__maybe_drop(x0_19051, _ctx);
      kk_box_t _x21885 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17342_filter_map_fun21886(pred0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x21885, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x0_19051, _ctx)) {
      kk_reuse_drop(_ru_21057,kk_context());
      { // tailcall
        xs = xx0;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t y0 = x0_19051._cons.Just.value;
      kk_std_core__list _trmc_184030 = kk_datatype_null(); /*list<12183>*/;
      kk_std_core__list _trmc_184040 = kk_std_core__new_Cons(_ru_21057, kk_field_index_of(struct kk_std_core_Cons, tail), y0, _trmc_184030, _ctx); /*list<12183>*/;
      kk_box_t* _b_20094_20088 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_184040, _ctx)->tail)); /*field-addr<list<12183>>*/;
      { // tailcall
        kk_std_core_types__cctx _x21888 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_184040, _ctx)),_b_20094_20088,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x21888;
        goto kk__tailcall;
      }
    }
  }
}
 
// Retain only those elements of a list that satisfy the given predicate `pred`.
// For example: `filterMap([1,2,3],fn(i) { if i.odd? then Nothing else Just(i*i) }) == [4]`

kk_std_core__list kk_std_core__unroll17342_filter_map(kk_std_core__list xs0, kk_function_t pred1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, pred : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x21889 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17342_filter_map(xs0, pred1, _x21889, _ctx);
}

bool kk_std_core_is_zero_1(kk_ssize_t i, kk_context_t* _ctx) { /* (i : ssize_t) -> bool */ 
  return (i == 0);
}
 
// lifted local: find, .spec.18208
// specialized: std/core/.unroll17338-foreach-while, on parameters action18201, using:
// action18201 = fn(x: 12281){
//   match ((pred(x))) {
//     ((std/core/types/True() : bool ) as .pat1: bool)
//        -> std/core/types/Just<a>(x);
//     ((.skip std/core/types/False() : bool ) as .pat00: bool)
//        -> std/core/types/Nothing<a>;
//   };
// }

kk_std_core_types__maybe kk_std_core__lift18314_find(kk_function_t pred, kk_std_core__list xs18200, kk_context_t* _ctx) { /* forall<a> (pred : (a) -> bool, xs18200 : list<a>) -> maybe<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs18200, _ctx)) {
    kk_function_drop(pred, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    struct kk_std_core_Cons* _con21890 = kk_std_core__as_Cons(xs18200, _ctx);
    kk_box_t x18204 = _con21890->head;
    kk_std_core__list xx18205 = _con21890->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs18200, _ctx)) {
      kk_datatype_ptr_free(xs18200, _ctx);
    }
    else {
      kk_box_dup(x18204, _ctx);
      kk_std_core__list_dup(xx18205, _ctx);
      kk_datatype_ptr_decref(xs18200, _ctx);
    }
    bool _match_20808;
    kk_function_t _x21892 = kk_function_dup(pred, _ctx); /*(12281) -> bool*/
    kk_box_t _x21891 = kk_box_dup(x18204, _ctx); /*12281*/
    _match_20808 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x21892, (_x21892, _x21891, _ctx), _ctx); /*bool*/
    if (_match_20808) {
      kk_std_core__list_drop(xx18205, _ctx);
      kk_function_drop(pred, _ctx);
      return kk_std_core_types__new_Just(x18204, _ctx);
    }
    {
      kk_box_drop(x18204, _ctx);
      { // tailcall
        xs18200 = xx18205;
        goto kk__tailcall;
      }
    }
  }
}
 
// O(n). If it occurs, return the position of substring `sub` in `s`, tupled with
// the position just following the substring `sub`.

kk_std_core_types__maybe kk_std_core_find_1(kk_string_t s, kk_string_t sub, kk_context_t* _ctx) { /* (s : string, sub : string) -> maybe<sslice> */ 
  kk_ssize_t i;
  kk_string_t _x21893 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x21894 = kk_string_dup(sub, _ctx); /*string*/
  i = kk_string_index_of1(_x21893,_x21894,kk_context()); /*ssize_t*/
  bool _match_20807 = kk_std_core_is_zero_1(i, _ctx); /*bool*/;
  if (_match_20807) {
    kk_string_drop(sub, _ctx);
    kk_string_drop(s, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_std_core__sslice _b_20100_20099;
    kk_integer_t _x21895;
    kk_ssize_t _x21896 = kk_std_core_decr_1(i, _ctx); /*ssize_t*/
    _x21895 = kk_integer_from_ssize_t(_x21896,kk_context()); /*int*/
    kk_integer_t _x21897 = kk_string_len_int(sub,kk_context()); /*int*/
    _b_20100_20099 = kk_std_core__new_Sslice(s, _x21895, _x21897, _ctx); /*sslice*/
    return kk_std_core_types__new_Just(kk_std_core__sslice_box(_b_20100_20099, _ctx), _ctx);
  }
}
 
// Return the last index of substring `sub` in `s` if it occurs.

kk_std_core_types__maybe kk_std_core_find_last(kk_string_t s, kk_string_t sub, kk_context_t* _ctx) { /* (s : string, sub : string) -> maybe<sslice> */ 
  kk_ssize_t i;
  kk_string_t _x21898 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x21899 = kk_string_dup(sub, _ctx); /*string*/
  i = kk_string_last_index_of1(_x21898,_x21899,kk_context()); /*ssize_t*/
  bool _match_20806 = kk_std_core_is_zero_1(i, _ctx); /*bool*/;
  if (_match_20806) {
    kk_string_drop(sub, _ctx);
    kk_string_drop(s, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    kk_std_core__sslice _b_20102_20101;
    kk_integer_t _x21900;
    kk_ssize_t _x21901 = kk_std_core_decr_1(i, _ctx); /*ssize_t*/
    _x21900 = kk_integer_from_ssize_t(_x21901,kk_context()); /*int*/
    kk_integer_t _x21902 = kk_string_len_int(sub,kk_context()); /*int*/
    _b_20102_20101 = kk_std_core__new_Sslice(s, _x21900, _x21902, _ctx); /*sslice*/
    return kk_std_core_types__new_Just(kk_std_core__sslice_box(_b_20102_20101, _ctx), _ctx);
  }
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18832_trmc_unroll17343_flatmap_maybe(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core__list xx, kk_std_core_types__maybe _y_18598, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Just(_y_18598, _ctx)) {
    kk_box_t y = _y_18598._cons.Just.value;
    kk_std_core__list _trmc_18405 = kk_datatype_null(); /*list<12527>*/;
    kk_std_core__list _trmc_18406 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), y, _trmc_18405, _ctx); /*list<12527>*/;
    kk_box_t* _b_20111_20108 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18406, _ctx)->tail)); /*field-addr<list<12527>>*/;
    kk_std_core_types__cctx _x21903 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18406, _ctx)),_b_20111_20108,false,kk_context()); /*ctx<0>*/
    return kk_std_core__trmc_unroll17343_flatmap_maybe(xx, f, _x21903, _ctx);
  }
  {
    return kk_std_core__trmc_unroll17343_flatmap_maybe(xx, f, _acc, _ctx);
  }
}
 
// Concatenate the `Just` result elements from applying a function to all elements.


// lift anonymous function
struct kk_std_core__trmc_unroll17343_flatmap_maybe_fun21907__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17343_flatmap_maybe_fun21907(kk_function_t _fself, kk_box_t _b_20116, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17343_flatmap_maybe_fun21907(kk_function_t f0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17343_flatmap_maybe_fun21907__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17343_flatmap_maybe_fun21907__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17343_flatmap_maybe_fun21907, kk_context());
  _self->f0 = f0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17343_flatmap_maybe_fun21907(kk_function_t _fself, kk_box_t _b_20116, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17343_flatmap_maybe_fun21907__t* _self = kk_function_as(struct kk_std_core__trmc_unroll17343_flatmap_maybe_fun21907__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (12526) -> 12528 maybe<12527> */
  kk_std_core__list xx0 = _self->xx0; /* list<12526> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<12527>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_20134_185980 = kk_std_core_types__maybe_unbox(_b_20116, KK_OWNED, _ctx); /*maybe<12527>*/;
  kk_std_core__list _x21908 = kk_std_core__mlift18832_trmc_unroll17343_flatmap_maybe(_acc0, f0, xx0, _y_20134_185980, _ctx); /*list<12527>*/
  return kk_std_core__list_box(_x21908, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17343_flatmap_maybe(kk_std_core__list xs, kk_function_t f0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21904 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21904->head;
    kk_std_core__list xx0 = _con21904->tail;
    kk_reuse_t _ru_21059 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_21059 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x0_19054;
    kk_function_t _x21905 = kk_function_dup(f0, _ctx); /*(12526) -> 12528 maybe<12527>*/
    x0_19054 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x21905, (_x21905, x, _ctx), _ctx); /*maybe<12527>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_21059,kk_context());
      kk_std_core_types__maybe_drop(x0_19054, _ctx);
      kk_box_t _x21906 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17343_flatmap_maybe_fun21907(f0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x21906, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Just(x0_19054, _ctx)) {
      kk_box_t y0 = x0_19054._cons.Just.value;
      kk_std_core__list _trmc_184050 = kk_datatype_null(); /*list<12527>*/;
      kk_std_core__list _trmc_184060 = kk_std_core__new_Cons(_ru_21059, kk_field_index_of(struct kk_std_core_Cons, tail), y0, _trmc_184050, _ctx); /*list<12527>*/;
      kk_box_t* _b_20128_20122 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_184060, _ctx)->tail)); /*field-addr<list<12527>>*/;
      { // tailcall
        kk_std_core_types__cctx _x21909 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_184060, _ctx)),_b_20128_20122,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x21909;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_21059,kk_context());
      { // tailcall
        xs = xx0;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(f0, _ctx);
    kk_box_t _x21910 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x21910, KK_OWNED, _ctx);
  }
}
 
// Concatenate the `Just` result elements from applying a function to all elements.

kk_std_core__list kk_std_core__unroll17343_flatmap_maybe(kk_std_core__list xs0, kk_function_t f1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, f : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x21911 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17343_flatmap_maybe(xs0, f1, _x21911, _ctx);
}
 
// monadic lift

kk_box_t kk_std_core__mlift18833_fold_int(kk_integer_t end, kk_function_t f, kk_integer_t start0, kk_box_t x, kk_context_t* _ctx) { /* forall<a,e> (end : int, f : (int, a) -> e a, start0 : int, x : a) -> e a */ 
  kk_integer_t _x21912 = kk_integer_add_small_const(start0, 1, _ctx); /*int*/
  return kk_std_core_fold_int(_x21912, end, x, f, _ctx);
}
 
// fold over the integers between [`start`,`end`] (inclusive).


// lift anonymous function
struct kk_std_core_fold_int_fun21915__t {
  struct kk_function_s _base;
  kk_integer_t end0;
  kk_function_t f0;
  kk_integer_t start00;
};
static kk_box_t kk_std_core_fold_int_fun21915(kk_function_t _fself, kk_box_t x1, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_fold_int_fun21915(kk_integer_t end0, kk_function_t f0, kk_integer_t start00, kk_context_t* _ctx) {
  struct kk_std_core_fold_int_fun21915__t* _self = kk_function_alloc_as(struct kk_std_core_fold_int_fun21915__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_fold_int_fun21915, kk_context());
  _self->end0 = end0;
  _self->f0 = f0;
  _self->start00 = start00;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_fold_int_fun21915(kk_function_t _fself, kk_box_t x1, kk_context_t* _ctx) {
  struct kk_std_core_fold_int_fun21915__t* _self = kk_function_as(struct kk_std_core_fold_int_fun21915__t*, _fself, _ctx);
  kk_integer_t end0 = _self->end0; /* int */
  kk_function_t f0 = _self->f0; /* (int, 12587) -> 12588 12587 */
  kk_integer_t start00 = _self->start00; /* int */
  kk_drop_match(_self, {kk_integer_dup(end0, _ctx);kk_function_dup(f0, _ctx);kk_integer_dup(start00, _ctx);}, {}, _ctx)
  return kk_std_core__mlift18833_fold_int(end0, f0, start00, x1, _ctx);
}

kk_box_t kk_std_core_fold_int(kk_integer_t start00, kk_integer_t end0, kk_box_t init0, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,e> (start : int, end : int, init : a, f : (int, a) -> e a) -> e a */ 
  kk__tailcall: ;
  bool _match_20803 = kk_integer_gte_borrow(start00,end0,kk_context()); /*bool*/;
  if (_match_20803) {
    kk_integer_drop(start00, _ctx);
    kk_function_drop(f0, _ctx);
    kk_integer_drop(end0, _ctx);
    return init0;
  }
  {
    kk_box_t x0_19057;
    kk_function_t _x21914 = kk_function_dup(f0, _ctx); /*(int, 12587) -> 12588 12587*/
    kk_integer_t _x21913 = kk_integer_dup(start00, _ctx); /*int*/
    x0_19057 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x21914, (_x21914, _x21913, init0, _ctx), _ctx); /*12587*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_19057, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core_new_fold_int_fun21915(end0, f0, start00, _ctx), _ctx);
    }
    { // tailcall
      kk_integer_t _x21916 = kk_integer_add_small_const(start00, 1, _ctx); /*int*/
      start00 = _x21916;
      init0 = x0_19057;
      goto kk__tailcall;
    }
  }
}
 
// monadic lift

kk_box_t kk_std_core__mlift18834_fold_while_int(kk_integer_t end, kk_function_t f, kk_box_t init0, kk_integer_t start0, kk_std_core_types__maybe _y_18610, kk_context_t* _ctx) { /* forall<a,e> (end : int, f : (int, a) -> e maybe<a>, init0 : a, start0 : int, maybe<a>) -> e a */ 
  if (kk_std_core_types__is_Just(_y_18610, _ctx)) {
    kk_box_t x = _y_18610._cons.Just.value;
    kk_box_drop(init0, _ctx);
    kk_integer_t _x21918 = kk_integer_add_small_const(start0, 1, _ctx); /*int*/
    return kk_std_core_fold_while_int(_x21918, end, x, f, _ctx);
  }
  {
    kk_integer_drop(start0, _ctx);
    kk_function_drop(f, _ctx);
    kk_integer_drop(end, _ctx);
    return init0;
  }
}


// lift anonymous function
struct kk_std_core_fold_while_int_fun21922__t {
  struct kk_function_s _base;
  kk_integer_t end0;
  kk_function_t f0;
  kk_box_t init00;
  kk_integer_t start00;
};
static kk_box_t kk_std_core_fold_while_int_fun21922(kk_function_t _fself, kk_box_t _b_20136, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_fold_while_int_fun21922(kk_integer_t end0, kk_function_t f0, kk_box_t init00, kk_integer_t start00, kk_context_t* _ctx) {
  struct kk_std_core_fold_while_int_fun21922__t* _self = kk_function_alloc_as(struct kk_std_core_fold_while_int_fun21922__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_fold_while_int_fun21922, kk_context());
  _self->end0 = end0;
  _self->f0 = f0;
  _self->init00 = init00;
  _self->start00 = start00;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_fold_while_int_fun21922(kk_function_t _fself, kk_box_t _b_20136, kk_context_t* _ctx) {
  struct kk_std_core_fold_while_int_fun21922__t* _self = kk_function_as(struct kk_std_core_fold_while_int_fun21922__t*, _fself, _ctx);
  kk_integer_t end0 = _self->end0; /* int */
  kk_function_t f0 = _self->f0; /* (int, 12692) -> 12693 maybe<12692> */
  kk_box_t init00 = _self->init00; /* 12692 */
  kk_integer_t start00 = _self->start00; /* int */
  kk_drop_match(_self, {kk_integer_dup(end0, _ctx);kk_function_dup(f0, _ctx);kk_box_dup(init00, _ctx);kk_integer_dup(start00, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _x21923 = kk_std_core_types__maybe_unbox(_b_20136, KK_OWNED, _ctx); /*maybe<12692>*/
  return kk_std_core__mlift18834_fold_while_int(end0, f0, init00, start00, _x21923, _ctx);
}

kk_box_t kk_std_core_fold_while_int(kk_integer_t start00, kk_integer_t end0, kk_box_t init00, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,e> (start : int, end : int, init : a, f : (int, a) -> e maybe<a>) -> e a */ 
  kk__tailcall: ;
  bool _match_20801 = kk_integer_gte_borrow(start00,end0,kk_context()); /*bool*/;
  if (_match_20801) {
    kk_integer_drop(start00, _ctx);
    kk_function_drop(f0, _ctx);
    kk_integer_drop(end0, _ctx);
    return init00;
  }
  {
    kk_std_core_types__maybe x0_19060;
    kk_function_t _x21921 = kk_function_dup(f0, _ctx); /*(int, 12692) -> 12693 maybe<12692>*/
    kk_integer_t _x21919 = kk_integer_dup(start00, _ctx); /*int*/
    kk_box_t _x21920 = kk_box_dup(init00, _ctx); /*12692*/
    x0_19060 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x21921, (_x21921, _x21919, _x21920, _ctx), _ctx); /*maybe<12692>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x0_19060, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core_new_fold_while_int_fun21922(end0, f0, init00, start00, _ctx), _ctx);
    }
    if (kk_std_core_types__is_Just(x0_19060, _ctx)) {
      kk_box_t x1 = x0_19060._cons.Just.value;
      kk_box_drop(init00, _ctx);
      { // tailcall
        kk_integer_t _x21924 = kk_integer_add_small_const(start00, 1, _ctx); /*int*/
        start00 = _x21924;
        init00 = x1;
        goto kk__tailcall;
      }
    }
    {
      kk_integer_drop(start00, _ctx);
      kk_function_drop(f0, _ctx);
      kk_integer_drop(end0, _ctx);
      return init00;
    }
  }
}
 
// monadic lift

kk_box_t kk_std_core__mlift18835_unroll17344_foldl(kk_function_t f, kk_std_core__list xx, kk_box_t _y_18614, kk_context_t* _ctx) { /* forall<a,e,b> (f : (a, b) -> e a, xx : list<b>, a) -> e a */ 
  return kk_std_core__unroll17344_foldl(xx, _y_18614, f, _ctx);
}
 
// Fold a list from the left, i.e. `foldl([1,2],0,(+)) == (0+1)+2`
// Since `foldl` is tail recursive, it is preferred over `foldr` when using an associative function `f`


// lift anonymous function
struct kk_std_core__unroll17344_foldl_fun21927__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core__unroll17344_foldl_fun21927(kk_function_t _fself, kk_box_t _y_186140, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_unroll17344_foldl_fun21927(kk_function_t f0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core__unroll17344_foldl_fun21927__t* _self = kk_function_alloc_as(struct kk_std_core__unroll17344_foldl_fun21927__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__unroll17344_foldl_fun21927, kk_context());
  _self->f0 = f0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__unroll17344_foldl_fun21927(kk_function_t _fself, kk_box_t _y_186140, kk_context_t* _ctx) {
  struct kk_std_core__unroll17344_foldl_fun21927__t* _self = kk_function_as(struct kk_std_core__unroll17344_foldl_fun21927__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (12696, 12701) -> 12698 12696 */
  kk_std_core__list xx0 = _self->xx0; /* list<12701> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  return kk_std_core__mlift18835_unroll17344_foldl(f0, xx0, _y_186140, _ctx);
}

kk_box_t kk_std_core__unroll17344_foldl(kk_std_core__list xs, kk_box_t z, kk_function_t f0, kk_context_t* _ctx) { /* forall<a,b,e> (list<a>, b, (b, a) -> e b) -> e b */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21925 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21925->head;
    kk_std_core__list xx0 = _con21925->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_t x0_19063;
    kk_function_t _x21926 = kk_function_dup(f0, _ctx); /*(12696, 12701) -> 12698 12696*/
    x0_19063 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x21926, (_x21926, z, x, _ctx), _ctx); /*12696*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x0_19063, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core__new_unroll17344_foldl_fun21927(f0, xx0, _ctx), _ctx);
    }
    { // tailcall
      xs = xx0;
      z = x0_19063;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(f0, _ctx);
    return z;
  }
}


// lift anonymous function
struct kk_std_core_foldl1_fun21938__t {
  struct kk_function_s _base;
  kk_ssize_t i_19066;
};
static kk_box_t kk_std_core_foldl1_fun21938(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foldl1_fun21938(kk_ssize_t i_19066, kk_context_t* _ctx) {
  struct kk_std_core_foldl1_fun21938__t* _self = kk_function_alloc_as(struct kk_std_core_foldl1_fun21938__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foldl1_fun21938, kk_context());
  _self->i_19066 = i_19066;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_foldl1_fun21938(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_foldl1_fun21938__t* _self = kk_function_as(struct kk_std_core_foldl1_fun21938__t*, _fself, _ctx);
  kk_ssize_t i_19066 = _self->i_19066; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i_19066, cont, res, _ctx);
}

kk_box_t kk_std_core_foldl1(kk_std_core__list xs, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, f : (a, a) -> <exn|e> a) -> <exn|e> a */ 
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con21928 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con21928->head;
    kk_std_core__list xx = _con21928->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      kk_function_drop(f, _ctx);
      return x;
    }
    {
      return kk_std_core__unroll17344_foldl(xx, x, f, _ctx);
    }
  }
  {
    kk_function_drop(f, _ctx);
    kk_ssize_t i_19066;
    kk_std_core_hnd__htag _x21929 = kk_std_core_hnd__htag_dup(kk_std_core__tag_exn, _ctx); /*std/core/hnd/htag<.hnd-exn>*/
    i_19066 = kk_std_core_hnd__evv_index(_x21929, _ctx); /*std/core/hnd/ev-index*/
    kk_evv_t w = kk_evv_swap_create1(i_19066,kk_context()); /*std/core/hnd/evv<<exn|12756>>*/;
    kk_std_core_hnd__ev ev_19070;
    kk_ssize_t _x21930 = (KK_IZ(0)); /*ssize_t*/
    ev_19070 = kk_evv_at(_x21930,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t y;
    {
      struct kk_std_core_hnd_Ev* _con21931 = kk_std_core_hnd__as_Ev(ev_19070, _ctx);
      kk_box_t _box_x20139 = _con21931->hnd;
      kk_std_core_hnd__marker m0 = _con21931->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x20139, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      {
        struct kk_std_core__Hnd_exn* _con21932 = kk_std_core__as_Hnd_exn(h, _ctx);
        kk_std_core_hnd__clause1 ctl_throw_exn = _con21932->ctl_throw_exn;
        if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
          kk_datatype_ptr_free(h, _ctx);
        }
        else {
          kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
          kk_datatype_ptr_decref(h, _ctx);
        }
        {
          kk_function_t _fun_unbox_x20143 = ctl_throw_exn.clause;
          kk_box_t _x21933;
          kk_std_core__exception _x21934;
          kk_string_t _x21935;
          kk_define_string_literal(, _s21936, 33, "unexpected Nil in std/core/foldl1", _ctx)
          _x21935 = kk_string_dup(_s21936, _ctx); /*string*/
          kk_std_core__exception_info _x21937;
          kk_std_core_types__optional _match_20799 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
          if (kk_std_core_types__is_Optional(_match_20799, _ctx)) {
            kk_box_t _box_x20147 = _match_20799._cons.Optional.value;
            kk_std_core__exception_info _info_11917 = kk_std_core__exception_info_unbox(_box_x20147, KK_BORROWED, _ctx);
            kk_std_core__exception_info_dup(_info_11917, _ctx);
            kk_std_core_types__optional_drop(_match_20799, _ctx);
            _x21937 = _info_11917; /*exception-info*/
          }
          else {
            kk_std_core_types__optional_drop(_match_20799, _ctx);
            _x21937 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
          }
          _x21934 = kk_std_core__new_Exception(_x21935, _x21937, _ctx); /*exception*/
          _x21933 = kk_std_core__exception_box(_x21934, _ctx); /*51*/
          y = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x20143, (_fun_unbox_x20143, m0, ev_19070, _x21933, _ctx), _ctx); /*12755*/
        }
      }
    }
    kk_unit_t __ = kk_Unit;
    kk_evv_set(w,kk_context());
    if (kk_yielding(kk_context())) {
      kk_box_drop(y, _ctx);
      return kk_std_core_hnd_yield_cont(kk_std_core_new_foldl1_fun21938(i_19066, _ctx), _ctx);
    }
    {
      return y;
    }
  }
}
 
// monadic lift

kk_box_t kk_std_core__mlift18836_lift18315_foldr(kk_function_t f, kk_std_core__list xx18215, kk_box_t z182110_18351, kk_context_t* _ctx) { /* forall<a,e,b> (f : (b, a) -> e a, xx18215 : list<b>, z182110.18351 : a) -> e a */ 
  return kk_std_core__lift18315_foldr(f, xx18215, z182110_18351, _ctx);
}
 
// lifted local: foldr, .spec.18217
// specialized: std/core/.unroll17344-foldl, on parameters f18212, using:
// f18212 = fn<(e :: E)>(x: 12770, y: 12774){
//   f(y, x);
// }


// lift anonymous function
struct kk_std_core__lift18315_foldr_fun21941__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list xx182150;
};
static kk_box_t kk_std_core__lift18315_foldr_fun21941(kk_function_t _fself, kk_box_t z182110_183510, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18315_foldr_fun21941(kk_function_t f0, kk_std_core__list xx182150, kk_context_t* _ctx) {
  struct kk_std_core__lift18315_foldr_fun21941__t* _self = kk_function_alloc_as(struct kk_std_core__lift18315_foldr_fun21941__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18315_foldr_fun21941, kk_context());
  _self->f0 = f0;
  _self->xx182150 = xx182150;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18315_foldr_fun21941(kk_function_t _fself, kk_box_t z182110_183510, kk_context_t* _ctx) {
  struct kk_std_core__lift18315_foldr_fun21941__t* _self = kk_function_as(struct kk_std_core__lift18315_foldr_fun21941__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (12774, 12770) -> 12772 12770 */
  kk_std_core__list xx182150 = _self->xx182150; /* list<12774> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(xx182150, _ctx);}, {}, _ctx)
  return kk_std_core__mlift18836_lift18315_foldr(f0, xx182150, z182110_183510, _ctx);
}

kk_box_t kk_std_core__lift18315_foldr(kk_function_t f0, kk_std_core__list xs18210, kk_box_t z18211, kk_context_t* _ctx) { /* forall<a,e,b> (f : (b, a) -> e a, xs18210 : list<b>, z18211 : a) -> e a */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18210, _ctx)) {
    struct kk_std_core_Cons* _con21939 = kk_std_core__as_Cons(xs18210, _ctx);
    kk_box_t x18214 = _con21939->head;
    kk_std_core__list xx182150 = _con21939->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs18210, _ctx)) {
      kk_datatype_ptr_free(xs18210, _ctx);
    }
    else {
      kk_box_dup(x18214, _ctx);
      kk_std_core__list_dup(xx182150, _ctx);
      kk_datatype_ptr_decref(xs18210, _ctx);
    }
    kk_box_t x_19073;
    kk_function_t _x21940 = kk_function_dup(f0, _ctx); /*(12774, 12770) -> 12772 12770*/
    x_19073 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x21940, (_x21940, x18214, z18211, _ctx), _ctx); /*12770*/
    if (kk_yielding(kk_context())) {
      kk_box_drop(x_19073, _ctx);
      return kk_std_core_hnd_yield_extend(kk_std_core__new_lift18315_foldr_fun21941(f0, xx182150, _ctx), _ctx);
    }
    { // tailcall
      xs18210 = xx182150;
      z18211 = x_19073;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(f0, _ctx);
    return z18211;
  }
}


// lift anonymous function
struct kk_std_core_foldr1_fun21952__t {
  struct kk_function_s _base;
  kk_ssize_t i_19078;
};
static kk_box_t kk_std_core_foldr1_fun21952(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_foldr1_fun21952(kk_ssize_t i_19078, kk_context_t* _ctx) {
  struct kk_std_core_foldr1_fun21952__t* _self = kk_function_alloc_as(struct kk_std_core_foldr1_fun21952__t, 1, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_foldr1_fun21952, kk_context());
  _self->i_19078 = i_19078;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_foldr1_fun21952(kk_function_t _fself, kk_function_t cont, kk_box_t res, kk_context_t* _ctx) {
  struct kk_std_core_foldr1_fun21952__t* _self = kk_function_as(struct kk_std_core_foldr1_fun21952__t*, _fself, _ctx);
  kk_ssize_t i_19078 = _self->i_19078; /* std/core/hnd/ev-index */
  kk_drop_match(_self, {;}, {}, _ctx)
  return kk_std_core_hnd_open_at1(i_19078, cont, res, _ctx);
}

kk_box_t kk_std_core_foldr1(kk_std_core__list xs, kk_function_t f, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, f : (a, a) -> <exn|e> a) -> <exn|e> a */ 
  kk_evv_t w = kk_evv_swap_create0(kk_context()); /*std/core/hnd/evv<<exn|12809>>*/;
  kk_std_core__list x;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    x = kk_std_core__new_Nil(_ctx); /*list<12808>*/
  }
  else {
    x = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), xs, _ctx); /*list<12808>*/
  }
  kk_unit_t keep = kk_Unit;
  kk_evv_set(w,kk_context());
  if (kk_std_core__is_Cons(x, _ctx)) {
    struct kk_std_core_Cons* _con21942 = kk_std_core__as_Cons(x, _ctx);
    kk_box_t x0 = _con21942->head;
    kk_std_core__list xx = _con21942->tail;
    if kk_likely(kk_datatype_ptr_is_unique(x, _ctx)) {
      kk_datatype_ptr_free(x, _ctx);
    }
    else {
      kk_box_dup(x0, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(x, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      kk_function_drop(f, _ctx);
      return x0;
    }
    {
      return kk_std_core__unroll17344_foldl(xx, x0, f, _ctx);
    }
  }
  {
    kk_function_drop(f, _ctx);
    kk_ssize_t i_19078;
    kk_std_core_hnd__htag _x21943 = kk_std_core_hnd__htag_dup(kk_std_core__tag_exn, _ctx); /*std/core/hnd/htag<.hnd-exn>*/
    i_19078 = kk_std_core_hnd__evv_index(_x21943, _ctx); /*std/core/hnd/ev-index*/
    kk_evv_t w0 = kk_evv_swap_create1(i_19078,kk_context()); /*std/core/hnd/evv<<exn|12809>>*/;
    kk_std_core_hnd__ev ev_19082;
    kk_ssize_t _x21944 = (KK_IZ(0)); /*ssize_t*/
    ev_19082 = kk_evv_at(_x21944,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    kk_box_t y;
    {
      struct kk_std_core_hnd_Ev* _con21945 = kk_std_core_hnd__as_Ev(ev_19082, _ctx);
      kk_box_t _box_x20148 = _con21945->hnd;
      kk_std_core_hnd__marker m0 = _con21945->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x20148, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      {
        struct kk_std_core__Hnd_exn* _con21946 = kk_std_core__as_Hnd_exn(h, _ctx);
        kk_std_core_hnd__clause1 ctl_throw_exn = _con21946->ctl_throw_exn;
        if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
          kk_datatype_ptr_free(h, _ctx);
        }
        else {
          kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
          kk_datatype_ptr_decref(h, _ctx);
        }
        {
          kk_function_t _fun_unbox_x20152 = ctl_throw_exn.clause;
          kk_box_t _x21947;
          kk_std_core__exception _x21948;
          kk_string_t _x21949;
          kk_define_string_literal(, _s21950, 33, "unexpected Nil in std/core/foldl1", _ctx)
          _x21949 = kk_string_dup(_s21950, _ctx); /*string*/
          kk_std_core__exception_info _x21951;
          kk_std_core_types__optional _match_20796 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
          if (kk_std_core_types__is_Optional(_match_20796, _ctx)) {
            kk_box_t _box_x20156 = _match_20796._cons.Optional.value;
            kk_std_core__exception_info _info_11917 = kk_std_core__exception_info_unbox(_box_x20156, KK_BORROWED, _ctx);
            kk_std_core__exception_info_dup(_info_11917, _ctx);
            kk_std_core_types__optional_drop(_match_20796, _ctx);
            _x21951 = _info_11917; /*exception-info*/
          }
          else {
            kk_std_core_types__optional_drop(_match_20796, _ctx);
            _x21951 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
          }
          _x21948 = kk_std_core__new_Exception(_x21949, _x21951, _ctx); /*exception*/
          _x21947 = kk_std_core__exception_box(_x21948, _ctx); /*51*/
          y = kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x20152, (_fun_unbox_x20152, m0, ev_19082, _x21947, _ctx), _ctx); /*12808*/
        }
      }
    }
    kk_unit_t __ = kk_Unit;
    kk_evv_set(w0,kk_context());
    if (kk_yielding(kk_context())) {
      kk_box_drop(y, _ctx);
      return kk_std_core_hnd_yield_cont(kk_std_core_new_foldr1_fun21952(i_19078, _ctx), _ctx);
    }
    {
      return y;
    }
  }
}
 
// monadic lift

kk_std_core_types__maybe kk_std_core__mlift18837_lift17321_for_while(kk_function_t action, kk_integer_t end, kk_integer_t i, kk_std_core_types__maybe _y_18634, kk_context_t* _ctx) { /* forall<a,e> (action : (int) -> e maybe<a>, end : int, i : int, maybe<a>) -> e maybe<a> */ 
  if (kk_std_core_types__is_Nothing(_y_18634, _ctx)) {
    kk_integer_t i0_17682 = kk_integer_add_small_const(i, 1, _ctx); /*int*/;
    return kk_std_core__lift17321_for_while(action, end, i0_17682, _ctx);
  }
  {
    kk_box_t x0 = _y_18634._cons.Just.value;
    kk_integer_drop(i, _ctx);
    kk_integer_drop(end, _ctx);
    kk_function_drop(action, _ctx);
    return kk_std_core_types__new_Just(x0, _ctx);
  }
}
 
// lifted local: for-while, rep


// lift anonymous function
struct kk_std_core__lift17321_for_while_fun21956__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_integer_t end0;
  kk_integer_t i0;
};
static kk_box_t kk_std_core__lift17321_for_while_fun21956(kk_function_t _fself, kk_box_t _b_20158, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift17321_for_while_fun21956(kk_function_t action0, kk_integer_t end0, kk_integer_t i0, kk_context_t* _ctx) {
  struct kk_std_core__lift17321_for_while_fun21956__t* _self = kk_function_alloc_as(struct kk_std_core__lift17321_for_while_fun21956__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift17321_for_while_fun21956, kk_context());
  _self->action0 = action0;
  _self->end0 = end0;
  _self->i0 = i0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift17321_for_while_fun21956(kk_function_t _fself, kk_box_t _b_20158, kk_context_t* _ctx) {
  struct kk_std_core__lift17321_for_while_fun21956__t* _self = kk_function_as(struct kk_std_core__lift17321_for_while_fun21956__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (int) -> 12860 maybe<12859> */
  kk_integer_t end0 = _self->end0; /* int */
  kk_integer_t i0 = _self->i0; /* int */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_integer_dup(end0, _ctx);kk_integer_dup(i0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_20160_186340 = kk_std_core_types__maybe_unbox(_b_20158, KK_OWNED, _ctx); /*maybe<12859>*/;
  kk_std_core_types__maybe _x21957 = kk_std_core__mlift18837_lift17321_for_while(action0, end0, i0, _y_20160_186340, _ctx); /*maybe<12859>*/
  return kk_std_core_types__maybe_box(_x21957, _ctx);
}

kk_std_core_types__maybe kk_std_core__lift17321_for_while(kk_function_t action0, kk_integer_t end0, kk_integer_t i0, kk_context_t* _ctx) { /* forall<a,e> (action : (int) -> e maybe<a>, end : int, i : int) -> e maybe<a> */ 
  kk__tailcall: ;
  bool _match_20793 = kk_integer_lte_borrow(i0,end0,kk_context()); /*bool*/;
  if (_match_20793) {
    kk_std_core_types__maybe x_19085;
    kk_function_t _x21954 = kk_function_dup(action0, _ctx); /*(int) -> 12860 maybe<12859>*/
    kk_integer_t _x21953 = kk_integer_dup(i0, _ctx); /*int*/
    x_19085 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_integer_t, kk_context_t*), _x21954, (_x21954, _x21953, _ctx), _ctx); /*maybe<12859>*/
    if (kk_yielding(kk_context())) {
      kk_std_core_types__maybe_drop(x_19085, _ctx);
      kk_box_t _x21955 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift17321_for_while_fun21956(action0, end0, i0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__maybe_unbox(_x21955, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Nothing(x_19085, _ctx)) {
      kk_integer_t i0_176820 = kk_integer_add_small_const(i0, 1, _ctx); /*int*/;
      { // tailcall
        i0 = i0_176820;
        goto kk__tailcall;
      }
    }
    {
      kk_box_t x00 = x_19085._cons.Just.value;
      kk_integer_drop(i0, _ctx);
      kk_integer_drop(end0, _ctx);
      kk_function_drop(action0, _ctx);
      return kk_std_core_types__new_Just(x00, _ctx);
    }
  }
  {
    kk_integer_drop(i0, _ctx);
    kk_integer_drop(end0, _ctx);
    kk_function_drop(action0, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18838_lift18316_foreach_indexed(kk_function_t action, kk_ref_t i, kk_std_core__list xx18224, kk_unit_t wild__18225, kk_context_t* _ctx) { /* forall<h,a,e> (action : (int, a) -> e (), i : local-var<h,int>, xx18224 : list<a>, wild_18225 : ()) -> <local<h>|e> () */ 
  kk_std_core__lift18316_foreach_indexed(action, i, xx18224, _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18839_lift18316_foreach_indexed_fun21959__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_ref_t i0;
  kk_std_core__list xx182240;
};
static kk_box_t kk_std_core__mlift18839_lift18316_foreach_indexed_fun21959(kk_function_t _fself, kk_box_t _b_20166, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18839_lift18316_foreach_indexed_fun21959(kk_function_t action0, kk_ref_t i0, kk_std_core__list xx182240, kk_context_t* _ctx) {
  struct kk_std_core__mlift18839_lift18316_foreach_indexed_fun21959__t* _self = kk_function_alloc_as(struct kk_std_core__mlift18839_lift18316_foreach_indexed_fun21959__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18839_lift18316_foreach_indexed_fun21959, kk_context());
  _self->action0 = action0;
  _self->i0 = i0;
  _self->xx182240 = xx182240;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18839_lift18316_foreach_indexed_fun21959(kk_function_t _fself, kk_box_t _b_20166, kk_context_t* _ctx) {
  struct kk_std_core__mlift18839_lift18316_foreach_indexed_fun21959__t* _self = kk_function_as(struct kk_std_core__mlift18839_lift18316_foreach_indexed_fun21959__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (int, 12970) -> 12971 () */
  kk_ref_t i0 = _self->i0; /* local-var<12964,int> */
  kk_std_core__list xx182240 = _self->xx182240; /* list<12970> */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_ref_dup(i0, _ctx);kk_std_core__list_dup(xx182240, _ctx);}, {}, _ctx)
  kk_unit_t wild__182250_20168 = kk_Unit;
  kk_unit_unbox(_b_20166);
  kk_unit_t _x21960 = kk_Unit;
  kk_std_core__mlift18838_lift18316_foreach_indexed(action0, i0, xx182240, wild__182250_20168, _ctx);
  return kk_unit_box(_x21960);
}

kk_unit_t kk_std_core__mlift18839_lift18316_foreach_indexed(kk_function_t action0, kk_ref_t i0, kk_std_core__list xx182240, kk_integer_t _y_18642, kk_context_t* _ctx) { /* forall<h,a,e> (action : (int, a) -> e (), i : local-var<h,int>, xx18224 : list<a>, int) -> <local<h>|e> () */ 
  kk_integer_t _b_20164_20162 = kk_integer_add_small_const(_y_18642, 1, _ctx); /*int*/;
  kk_unit_t x_19088 = kk_Unit;
  kk_ref_set_borrow(i0,(kk_integer_box(_b_20164_20162, _ctx)),kk_context());
  if (kk_yielding(kk_context())) {
    kk_box_t _x21958 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18839_lift18316_foreach_indexed_fun21959(action0, i0, xx182240, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x21958); return kk_Unit;
  }
  {
    kk_std_core__mlift18838_lift18316_foreach_indexed(action0, i0, xx182240, x_19088, _ctx); return kk_Unit;
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18840_lift18316_foreach_indexed_fun21964__t {
  struct kk_function_s _base;
  kk_function_t action1;
  kk_ref_t i1;
  kk_std_core__list xx182241;
};
static kk_box_t kk_std_core__mlift18840_lift18316_foreach_indexed_fun21964(kk_function_t _fself, kk_box_t _b_20172, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18840_lift18316_foreach_indexed_fun21964(kk_function_t action1, kk_ref_t i1, kk_std_core__list xx182241, kk_context_t* _ctx) {
  struct kk_std_core__mlift18840_lift18316_foreach_indexed_fun21964__t* _self = kk_function_alloc_as(struct kk_std_core__mlift18840_lift18316_foreach_indexed_fun21964__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18840_lift18316_foreach_indexed_fun21964, kk_context());
  _self->action1 = action1;
  _self->i1 = i1;
  _self->xx182241 = xx182241;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18840_lift18316_foreach_indexed_fun21964(kk_function_t _fself, kk_box_t _b_20172, kk_context_t* _ctx) {
  struct kk_std_core__mlift18840_lift18316_foreach_indexed_fun21964__t* _self = kk_function_as(struct kk_std_core__mlift18840_lift18316_foreach_indexed_fun21964__t*, _fself, _ctx);
  kk_function_t action1 = _self->action1; /* (int, 12970) -> 12971 () */
  kk_ref_t i1 = _self->i1; /* local-var<12964,int> */
  kk_std_core__list xx182241 = _self->xx182241; /* list<12970> */
  kk_drop_match(_self, {kk_function_dup(action1, _ctx);kk_ref_dup(i1, _ctx);kk_std_core__list_dup(xx182241, _ctx);}, {}, _ctx)
  kk_integer_t _y_20174_186420 = kk_integer_unbox(_b_20172, _ctx); /*int*/;
  kk_unit_t _x21965 = kk_Unit;
  kk_std_core__mlift18839_lift18316_foreach_indexed(action1, i1, xx182241, _y_20174_186420, _ctx);
  return kk_unit_box(_x21965);
}

kk_unit_t kk_std_core__mlift18840_lift18316_foreach_indexed(kk_function_t action1, kk_ref_t i1, kk_std_core__list xx182241, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<h,a,e> (action : (int, a) -> e (), i : local-var<h,int>, xx18224 : list<a>, wild_ : ()) -> <local<h>|e> () */ 
  kk_integer_t x0_19090;
  kk_box_t _x21961;
  kk_ref_t _x21962 = kk_ref_dup(i1, _ctx); /*local-var<12964,int>*/
  _x21961 = kk_ref_get(_x21962,kk_context()); /*264*/
  x0_19090 = kk_integer_unbox(_x21961, _ctx); /*int*/
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x0_19090, _ctx);
    kk_box_t _x21963 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18840_lift18316_foreach_indexed_fun21964(action1, i1, xx182241, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x21963); return kk_Unit;
  }
  {
    kk_std_core__mlift18839_lift18316_foreach_indexed(action1, i1, xx182241, x0_19090, _ctx); return kk_Unit;
  }
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18841_lift18316_foreach_indexed_fun21968__t {
  struct kk_function_s _base;
  kk_function_t action2;
  kk_ref_t i2;
  kk_std_core__list xx182242;
};
static kk_box_t kk_std_core__mlift18841_lift18316_foreach_indexed_fun21968(kk_function_t _fself, kk_box_t _b_20176, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18841_lift18316_foreach_indexed_fun21968(kk_function_t action2, kk_ref_t i2, kk_std_core__list xx182242, kk_context_t* _ctx) {
  struct kk_std_core__mlift18841_lift18316_foreach_indexed_fun21968__t* _self = kk_function_alloc_as(struct kk_std_core__mlift18841_lift18316_foreach_indexed_fun21968__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18841_lift18316_foreach_indexed_fun21968, kk_context());
  _self->action2 = action2;
  _self->i2 = i2;
  _self->xx182242 = xx182242;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18841_lift18316_foreach_indexed_fun21968(kk_function_t _fself, kk_box_t _b_20176, kk_context_t* _ctx) {
  struct kk_std_core__mlift18841_lift18316_foreach_indexed_fun21968__t* _self = kk_function_as(struct kk_std_core__mlift18841_lift18316_foreach_indexed_fun21968__t*, _fself, _ctx);
  kk_function_t action2 = _self->action2; /* (int, 12970) -> 12971 () */
  kk_ref_t i2 = _self->i2; /* local-var<12964,int> */
  kk_std_core__list xx182242 = _self->xx182242; /* list<12970> */
  kk_drop_match(_self, {kk_function_dup(action2, _ctx);kk_ref_dup(i2, _ctx);kk_std_core__list_dup(xx182242, _ctx);}, {}, _ctx)
  kk_unit_t wild__0_20178 = kk_Unit;
  kk_unit_unbox(_b_20176);
  kk_unit_t _x21969 = kk_Unit;
  kk_std_core__mlift18840_lift18316_foreach_indexed(action2, i2, xx182242, wild__0_20178, _ctx);
  return kk_unit_box(_x21969);
}

kk_unit_t kk_std_core__mlift18841_lift18316_foreach_indexed(kk_function_t action2, kk_ref_t i2, kk_box_t x18223, kk_std_core__list xx182242, kk_integer_t j, kk_context_t* _ctx) { /* forall<h,a,e> (action : (int, a) -> e (), i : local-var<h,int>, x18223 : a, xx18224 : list<a>, j : int) -> <local<h>|e> () */ 
  kk_unit_t x1_19092 = kk_Unit;
  kk_function_t _x21966 = kk_function_dup(action2, _ctx); /*(int, 12970) -> 12971 ()*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x21966, (_x21966, j, x18223, _ctx), _ctx);
  if (kk_yielding(kk_context())) {
    kk_box_t _x21967 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18841_lift18316_foreach_indexed_fun21968(action2, i2, xx182242, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x21967); return kk_Unit;
  }
  {
    kk_std_core__mlift18840_lift18316_foreach_indexed(action2, i2, xx182242, x1_19092, _ctx); return kk_Unit;
  }
}
 
// lifted local: foreach-indexed, .spec.18227
// specialized: std/core/.unroll17339-foreach, on parameters action18221, using:
// action18221 = fn<<(local :: H -> X)<(h :: H)>|(e :: E)>>(x: 12970){
//   val j : int;
//   val _ : ();
//   std/core/types/local-set<int,(e :: E),(h :: H)>(i, (std/core/types/.open<((<>) :: E),<(local :: H -> X)<(h :: H)>|(e :: E)>,(x : int, y : int) -> int,(x : int, y : int) -> <(local :: H -> X)<(h :: H)>|(e :: E)> int>((fn(x0: int, y: int){
//       (std/core/int-add(x0, y));
//     }))((std/core/types/local-get<int,(h :: H),(e :: E)>(i)), 1)));
// }


// lift anonymous function
struct kk_std_core__lift18316_foreach_indexed_fun21974__t {
  struct kk_function_s _base;
  kk_function_t action4;
  kk_ref_t i3;
  kk_box_t x182230;
  kk_std_core__list xx182243;
};
static kk_box_t kk_std_core__lift18316_foreach_indexed_fun21974(kk_function_t _fself, kk_box_t _b_20182, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18316_foreach_indexed_fun21974(kk_function_t action4, kk_ref_t i3, kk_box_t x182230, kk_std_core__list xx182243, kk_context_t* _ctx) {
  struct kk_std_core__lift18316_foreach_indexed_fun21974__t* _self = kk_function_alloc_as(struct kk_std_core__lift18316_foreach_indexed_fun21974__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18316_foreach_indexed_fun21974, kk_context());
  _self->action4 = action4;
  _self->i3 = i3;
  _self->x182230 = x182230;
  _self->xx182243 = xx182243;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18316_foreach_indexed_fun21974(kk_function_t _fself, kk_box_t _b_20182, kk_context_t* _ctx) {
  struct kk_std_core__lift18316_foreach_indexed_fun21974__t* _self = kk_function_as(struct kk_std_core__lift18316_foreach_indexed_fun21974__t*, _fself, _ctx);
  kk_function_t action4 = _self->action4; /* (int, 12970) -> 12971 () */
  kk_ref_t i3 = _self->i3; /* local-var<12964,int> */
  kk_box_t x182230 = _self->x182230; /* 12970 */
  kk_std_core__list xx182243 = _self->xx182243; /* list<12970> */
  kk_drop_match(_self, {kk_function_dup(action4, _ctx);kk_ref_dup(i3, _ctx);kk_box_dup(x182230, _ctx);kk_std_core__list_dup(xx182243, _ctx);}, {}, _ctx)
  kk_integer_t j0_20199 = kk_integer_unbox(_b_20182, _ctx); /*int*/;
  kk_unit_t _x21975 = kk_Unit;
  kk_std_core__mlift18841_lift18316_foreach_indexed(action4, i3, x182230, xx182243, j0_20199, _ctx);
  return kk_unit_box(_x21975);
}


// lift anonymous function
struct kk_std_core__lift18316_foreach_indexed_fun21978__t {
  struct kk_function_s _base;
  kk_function_t action4;
  kk_ref_t i3;
  kk_std_core__list xx182243;
};
static kk_box_t kk_std_core__lift18316_foreach_indexed_fun21978(kk_function_t _fself, kk_box_t _b_20184, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18316_foreach_indexed_fun21978(kk_function_t action4, kk_ref_t i3, kk_std_core__list xx182243, kk_context_t* _ctx) {
  struct kk_std_core__lift18316_foreach_indexed_fun21978__t* _self = kk_function_alloc_as(struct kk_std_core__lift18316_foreach_indexed_fun21978__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18316_foreach_indexed_fun21978, kk_context());
  _self->action4 = action4;
  _self->i3 = i3;
  _self->xx182243 = xx182243;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18316_foreach_indexed_fun21978(kk_function_t _fself, kk_box_t _b_20184, kk_context_t* _ctx) {
  struct kk_std_core__lift18316_foreach_indexed_fun21978__t* _self = kk_function_as(struct kk_std_core__lift18316_foreach_indexed_fun21978__t*, _fself, _ctx);
  kk_function_t action4 = _self->action4; /* (int, 12970) -> 12971 () */
  kk_ref_t i3 = _self->i3; /* local-var<12964,int> */
  kk_std_core__list xx182243 = _self->xx182243; /* list<12970> */
  kk_drop_match(_self, {kk_function_dup(action4, _ctx);kk_ref_dup(i3, _ctx);kk_std_core__list_dup(xx182243, _ctx);}, {}, _ctx)
  kk_unit_t wild__1_20200 = kk_Unit;
  kk_unit_unbox(_b_20184);
  kk_unit_t _x21979 = kk_Unit;
  kk_std_core__mlift18840_lift18316_foreach_indexed(action4, i3, xx182243, wild__1_20200, _ctx);
  return kk_unit_box(_x21979);
}


// lift anonymous function
struct kk_std_core__lift18316_foreach_indexed_fun21983__t {
  struct kk_function_s _base;
  kk_function_t action4;
  kk_ref_t i3;
  kk_std_core__list xx182243;
};
static kk_box_t kk_std_core__lift18316_foreach_indexed_fun21983(kk_function_t _fself, kk_box_t _b_20188, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18316_foreach_indexed_fun21983(kk_function_t action4, kk_ref_t i3, kk_std_core__list xx182243, kk_context_t* _ctx) {
  struct kk_std_core__lift18316_foreach_indexed_fun21983__t* _self = kk_function_alloc_as(struct kk_std_core__lift18316_foreach_indexed_fun21983__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18316_foreach_indexed_fun21983, kk_context());
  _self->action4 = action4;
  _self->i3 = i3;
  _self->xx182243 = xx182243;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18316_foreach_indexed_fun21983(kk_function_t _fself, kk_box_t _b_20188, kk_context_t* _ctx) {
  struct kk_std_core__lift18316_foreach_indexed_fun21983__t* _self = kk_function_as(struct kk_std_core__lift18316_foreach_indexed_fun21983__t*, _fself, _ctx);
  kk_function_t action4 = _self->action4; /* (int, 12970) -> 12971 () */
  kk_ref_t i3 = _self->i3; /* local-var<12964,int> */
  kk_std_core__list xx182243 = _self->xx182243; /* list<12970> */
  kk_drop_match(_self, {kk_function_dup(action4, _ctx);kk_ref_dup(i3, _ctx);kk_std_core__list_dup(xx182243, _ctx);}, {}, _ctx)
  kk_integer_t _y_20201_186421 = kk_integer_unbox(_b_20188, _ctx); /*int*/;
  kk_unit_t _x21984 = kk_Unit;
  kk_std_core__mlift18839_lift18316_foreach_indexed(action4, i3, xx182243, _y_20201_186421, _ctx);
  return kk_unit_box(_x21984);
}


// lift anonymous function
struct kk_std_core__lift18316_foreach_indexed_fun21986__t {
  struct kk_function_s _base;
  kk_function_t action4;
  kk_ref_t i3;
  kk_std_core__list xx182243;
};
static kk_box_t kk_std_core__lift18316_foreach_indexed_fun21986(kk_function_t _fself, kk_box_t _b_20194, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18316_foreach_indexed_fun21986(kk_function_t action4, kk_ref_t i3, kk_std_core__list xx182243, kk_context_t* _ctx) {
  struct kk_std_core__lift18316_foreach_indexed_fun21986__t* _self = kk_function_alloc_as(struct kk_std_core__lift18316_foreach_indexed_fun21986__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18316_foreach_indexed_fun21986, kk_context());
  _self->action4 = action4;
  _self->i3 = i3;
  _self->xx182243 = xx182243;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18316_foreach_indexed_fun21986(kk_function_t _fself, kk_box_t _b_20194, kk_context_t* _ctx) {
  struct kk_std_core__lift18316_foreach_indexed_fun21986__t* _self = kk_function_as(struct kk_std_core__lift18316_foreach_indexed_fun21986__t*, _fself, _ctx);
  kk_function_t action4 = _self->action4; /* (int, 12970) -> 12971 () */
  kk_ref_t i3 = _self->i3; /* local-var<12964,int> */
  kk_std_core__list xx182243 = _self->xx182243; /* list<12970> */
  kk_drop_match(_self, {kk_function_dup(action4, _ctx);kk_ref_dup(i3, _ctx);kk_std_core__list_dup(xx182243, _ctx);}, {}, _ctx)
  kk_unit_t wild__182251_20202 = kk_Unit;
  kk_unit_unbox(_b_20194);
  kk_unit_t _x21987 = kk_Unit;
  kk_std_core__mlift18838_lift18316_foreach_indexed(action4, i3, xx182243, wild__182251_20202, _ctx);
  return kk_unit_box(_x21987);
}

kk_unit_t kk_std_core__lift18316_foreach_indexed(kk_function_t action4, kk_ref_t i3, kk_std_core__list xs18220, kk_context_t* _ctx) { /* forall<h,a,e> (action : (int, a) -> e (), i : local-var<h,int>, xs18220 : list<a>) -> <local<h>|e> () */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18220, _ctx)) {
    struct kk_std_core_Cons* _con21970 = kk_std_core__as_Cons(xs18220, _ctx);
    kk_box_t x182230 = _con21970->head;
    kk_std_core__list xx182243 = _con21970->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs18220, _ctx)) {
      kk_datatype_ptr_free(xs18220, _ctx);
    }
    else {
      kk_box_dup(x182230, _ctx);
      kk_std_core__list_dup(xx182243, _ctx);
      kk_datatype_ptr_decref(xs18220, _ctx);
    }
    kk_integer_t x2_19095;
    kk_box_t _x21971;
    kk_ref_t _x21972 = kk_ref_dup(i3, _ctx); /*local-var<12964,int>*/
    _x21971 = kk_ref_get(_x21972,kk_context()); /*264*/
    x2_19095 = kk_integer_unbox(_x21971, _ctx); /*int*/
    if (kk_yielding(kk_context())) {
      kk_integer_drop(x2_19095, _ctx);
      kk_box_t _x21973 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18316_foreach_indexed_fun21974(action4, i3, x182230, xx182243, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21973); return kk_Unit;
    }
    {
      kk_unit_t x3_19098 = kk_Unit;
      kk_function_t _x21976 = kk_function_dup(action4, _ctx); /*(int, 12970) -> 12971 ()*/
      kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x21976, (_x21976, x2_19095, x182230, _ctx), _ctx);
      if (kk_yielding(kk_context())) {
        kk_box_t _x21977 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18316_foreach_indexed_fun21978(action4, i3, xx182243, _ctx), _ctx); /*3926*/
        kk_unit_unbox(_x21977); return kk_Unit;
      }
      {
        kk_integer_t x4_19102;
        kk_box_t _x21980;
        kk_ref_t _x21981 = kk_ref_dup(i3, _ctx); /*local-var<12964,int>*/
        _x21980 = kk_ref_get(_x21981,kk_context()); /*264*/
        x4_19102 = kk_integer_unbox(_x21980, _ctx); /*int*/
        if (kk_yielding(kk_context())) {
          kk_integer_drop(x4_19102, _ctx);
          kk_box_t _x21982 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18316_foreach_indexed_fun21983(action4, i3, xx182243, _ctx), _ctx); /*3926*/
          kk_unit_unbox(_x21982); return kk_Unit;
        }
        {
          kk_integer_t _b_20192_20190 = kk_integer_add_small_const(x4_19102, 1, _ctx); /*int*/;
          kk_unit_t x5_19105 = kk_Unit;
          kk_ref_set_borrow(i3,(kk_integer_box(_b_20192_20190, _ctx)),kk_context());
          if (kk_yielding(kk_context())) {
            kk_box_t _x21985 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18316_foreach_indexed_fun21986(action4, i3, xx182243, _ctx), _ctx); /*3926*/
            kk_unit_unbox(_x21985); return kk_Unit;
          }
          { // tailcall
            xs18220 = xx182243;
            goto kk__tailcall;
          }
        }
      }
    }
  }
  {
    kk_ref_drop(i3, _ctx);
    kk_function_drop(action4, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Invoke `action` for each element of a list, passing also the position of the element.

kk_unit_t kk_std_core_foreach_indexed(kk_std_core__list xs, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, action : (int, a) -> e ()) -> e () */ 
  kk_ref_t loc = kk_ref_alloc((kk_integer_box(kk_integer_from_small(0), _ctx)),kk_context()); /*local-var<12964,int>*/;
  kk_unit_t res = kk_Unit;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(action, _ctx);
  }
  else {
    kk_ref_t _x21988 = kk_ref_dup(loc, _ctx); /*local-var<12964,int>*/
    kk_std_core__lift18316_foreach_indexed(action, _x21988, xs, _ctx);
  }
  kk_box_t _x21989 = kk_std_core_hnd_prompt_local_var(loc, kk_unit_box(res), _ctx); /*10459*/
  kk_unit_unbox(_x21989); return kk_Unit;
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18842_lift18317_foreach_indexed_1(kk_ssize_t end18230, kk_function_t f, kk_ssize_t i18231, kk_vector_t v, kk_unit_t wild__18233, kk_context_t* _ctx) { /* forall<a,e> (end18230 : ssize_t, f : (int, a) -> e (), i18231 : ssize_t, v : vector<a>, wild_18233 : ()) -> e () */ 
  kk_ssize_t i0_1744818234 = kk_std_core_incr_1(i18231, _ctx); /*ssize_t*/;
  kk_std_core__lift18317_foreach_indexed_1(f, v, end18230, i0_1744818234, _ctx); return kk_Unit;
}
 
// lifted local: foreach-indexed.1, .spec.18236
// specialized: std/core/.lift17317-forz, on parameters action18229, using:
// action18229 = fn<(e :: E)>(i0: ssize_t){
//   val x.17878 : a
//         = std/core/types/.open<(total :: E),(e :: E),(v : (vector :: V -> V)<a>, index : ssize_t) -> (total :: E) a,(v : (vector :: V -> V)<a>, index : ssize_t) -> (e :: E) a>((std/core/unsafe-idx<a>))(v, i0);
//   f((std/core/types/.open<((<>) :: E),(e :: E),(i : ssize_t) -> int,(i : ssize_t) -> (e :: E) int>(std/core/int.2)(i0)), x.17878);
// }


// lift anonymous function
struct kk_std_core__lift18317_foreach_indexed_fun21993__t_1 {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_vector_t v0;
  kk_ssize_t end182300;
  kk_ssize_t i182310;
};
static kk_box_t kk_std_core__lift18317_foreach_indexed_fun21993_1(kk_function_t _fself, kk_box_t _b_20210, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_lift18317_foreach_indexed_fun21993_1(kk_function_t f0, kk_vector_t v0, kk_ssize_t end182300, kk_ssize_t i182310, kk_context_t* _ctx) {
  struct kk_std_core__lift18317_foreach_indexed_fun21993__t_1* _self = kk_function_alloc_as(struct kk_std_core__lift18317_foreach_indexed_fun21993__t_1, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__lift18317_foreach_indexed_fun21993_1, kk_context());
  _self->f0 = f0;
  _self->v0 = v0;
  _self->end182300 = end182300;
  _self->i182310 = i182310;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__lift18317_foreach_indexed_fun21993_1(kk_function_t _fself, kk_box_t _b_20210, kk_context_t* _ctx) {
  struct kk_std_core__lift18317_foreach_indexed_fun21993__t_1* _self = kk_function_as(struct kk_std_core__lift18317_foreach_indexed_fun21993__t_1*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int, 13001) -> 13002 () */
  kk_vector_t v0 = _self->v0; /* vector<13001> */
  kk_ssize_t end182300 = _self->end182300; /* ssize_t */
  kk_ssize_t i182310 = _self->i182310; /* ssize_t */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_vector_dup(v0, _ctx);;;}, {}, _ctx)
  kk_unit_t wild__182330_20212 = kk_Unit;
  kk_unit_unbox(_b_20210);
  kk_unit_t _x21994 = kk_Unit;
  kk_std_core__mlift18842_lift18317_foreach_indexed_1(end182300, f0, i182310, v0, wild__182330_20212, _ctx);
  return kk_unit_box(_x21994);
}

kk_unit_t kk_std_core__lift18317_foreach_indexed_1(kk_function_t f0, kk_vector_t v0, kk_ssize_t end182300, kk_ssize_t i182310, kk_context_t* _ctx) { /* forall<a,e> (f : (int, a) -> e (), v : vector<a>, end18230 : ssize_t, i18231 : ssize_t) -> e () */ 
  kk__tailcall: ;
  bool _match_20784 = (i182310 <= end182300); /*bool*/;
  if (_match_20784) {
    kk_box_t x_17878 = kk_vector_at_borrow(v0,i182310,kk_context()); /*13001*/;
    kk_unit_t x_19110 = kk_Unit;
    kk_function_t _x21991 = kk_function_dup(f0, _ctx); /*(int, 13001) -> 13002 ()*/
    kk_integer_t _x21990 = kk_integer_from_ssize_t(i182310,kk_context()); /*int*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x21991, (_x21991, _x21990, x_17878, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x21992 = kk_std_core_hnd_yield_extend(kk_std_core__new_lift18317_foreach_indexed_fun21993_1(f0, v0, end182300, i182310, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x21992); return kk_Unit;
    }
    {
      kk_ssize_t i0_17448182340 = kk_std_core_incr_1(i182310, _ctx); /*ssize_t*/;
      { // tailcall
        i182310 = i0_17448182340;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_vector_drop(v0, _ctx);
    kk_function_drop(f0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Return the head of list if the list is not empty.

kk_std_core_types__maybe kk_std_core_head_1(kk_std_core__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> maybe<a> */ 
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22004 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con22004->head;
    kk_std_core__list _pat0 = _con22004->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core__list_drop(_pat0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return kk_std_core_types__new_Just(x, _ctx);
  }
  {
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Return the head of list if the list is not empty, or use `default` otherwise

kk_box_t kk_std_core_head_2(kk_std_core__list xs, kk_box_t default0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, default : a) -> a */ 
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22005 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con22005->head;
    kk_std_core__list _pat0 = _con22005->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core__list_drop(_pat0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_box_drop(default0, _ctx);
    return x;
  }
  {
    return default0;
  }
}
 
// Return the first character of a string as a string (or the empty string)

kk_string_t kk_std_core_head_3(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  kk_std_core__sslice slice0 = kk_std_core_first1(s, _ctx); /*sslice*/;
  kk_std_core__sslice _x22006;
  bool _match_20777;
  kk_integer_t _brw_20782;
  kk_std_core_types__optional _match_20781 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_20781, _ctx)) {
    kk_box_t _box_x20213 = _match_20781._cons.Optional.value;
    kk_integer_t _n_10357 = kk_integer_unbox(_box_x20213, _ctx);
    kk_integer_dup(_n_10357, _ctx);
    kk_std_core_types__optional_drop(_match_20781, _ctx);
    _brw_20782 = _n_10357; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_20781, _ctx);
    _brw_20782 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_20783 = kk_integer_eq_borrow(_brw_20782,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_20782, _ctx);
  _match_20777 = _brw_20783; /*bool*/
  if (_match_20777) {
    _x22006 = slice0; /*sslice*/
  }
  else {
    kk_integer_t _brw_20779;
    kk_integer_t _x22007;
    kk_std_core_types__optional _match_20778 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_20778, _ctx)) {
      kk_box_t _box_x20214 = _match_20778._cons.Optional.value;
      kk_integer_t _n_103570 = kk_integer_unbox(_box_x20214, _ctx);
      kk_integer_dup(_n_103570, _ctx);
      kk_std_core_types__optional_drop(_match_20778, _ctx);
      _x22007 = _n_103570; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(_match_20778, _ctx);
      _x22007 = kk_integer_from_small(1); /*int*/
    }
    _brw_20779 = kk_integer_add_small_const(_x22007, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_20780 = kk_std_core_extend(slice0, _brw_20779, _ctx); /*sslice*/;
    kk_integer_drop(_brw_20779, _ctx);
    _x22006 = _brw_20780; /*sslice*/
  }
  return kk_std_core_string_3(_x22006, _ctx);
}
 
// Return the first character of a string (or `Nothing` for the empty string).


// lift anonymous function
struct kk_std_core_head_char_fun22011__t {
  struct kk_function_s _base;
};
static kk_std_core_types__maybe kk_std_core_head_char_fun22011(kk_function_t _fself, kk_char_t _b_20215, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_head_char_fun22011(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_head_char_fun22011, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_std_core_types__maybe kk_std_core_head_char_fun22011(kk_function_t _fself, kk_char_t _b_20215, kk_context_t* _ctx) {
  kk_unused(_fself);
  return kk_std_core_types__new_Just(kk_char_box(_b_20215, _ctx), _ctx);
}

kk_std_core_types__maybe kk_std_core_head_char(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> maybe<char> */ 
  kk_std_core__sslice _x22008;
  kk_string_t _x22009 = kk_string_dup(s, _ctx); /*string*/
  kk_integer_t _x22010 = kk_string_len_int(s,kk_context()); /*int*/
  _x22008 = kk_std_core__new_Sslice(_x22009, kk_integer_from_small(0), _x22010, _ctx); /*sslice*/
  return kk_std_core_foreach_while_1(_x22008, kk_std_core_new_head_char_fun22011(_ctx), _ctx);
}

kk_integer_t kk_std_core__unroll17345_index_of_acc(kk_std_core__list xs, kk_function_t pred, kk_integer_t idx, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, pred : (a) -> bool, idx : int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22012 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con22012->head;
    kk_std_core__list xx = _con22012->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool _match_20776;
    kk_function_t _x22013 = kk_function_dup(pred, _ctx); /*(13377) -> bool*/
    _match_20776 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x22013, (_x22013, x, _ctx), _ctx); /*bool*/
    if (_match_20776) {
      kk_std_core__list_drop(xx, _ctx);
      kk_function_drop(pred, _ctx);
      return idx;
    }
    { // tailcall
      kk_integer_t _x22014 = kk_integer_add_small_const(idx, 1, _ctx); /*int*/
      xs = xx;
      idx = _x22014;
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(pred, _ctx);
    kk_integer_drop(idx, _ctx);
    return kk_integer_from_small(-1);
  }
}
 
// Return the list without its last element.
// Return an empty list for an empty list.

kk_std_core__list kk_std_core__trmc_init(kk_std_core__list xs, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22015 = kk_std_core__as_Cons(xs, _ctx);
    kk_std_core__list xx = _con22015->tail;
    if (kk_std_core__is_Cons(xx, _ctx)) {
      struct kk_std_core_Cons* _con22016 = kk_std_core__as_Cons(xx, _ctx);
      kk_box_t x = _con22015->head;
      kk_reuse_t _ru_21070 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        _ru_21070 = (kk_datatype_ptr_reuse(xs, _ctx));
      }
      else {
        kk_box_dup(x, _ctx);
        kk_std_core__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_std_core__list _trmc_18407 = kk_datatype_null(); /*list<13414>*/;
      kk_std_core__list _trmc_18408 = kk_std_core__new_Cons(_ru_21070, 0, x, _trmc_18407, _ctx); /*list<13414>*/;
      kk_box_t* _b_20226_20221 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18408, _ctx)->tail)); /*field-addr<list<13414>>*/;
      { // tailcall
        kk_std_core_types__cctx _x22017 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18408, _ctx)),_b_20226_20221,true,kk_context()); /*ctx<0>*/
        xs = xx;
        _acc = _x22017;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_std_core__list_drop(xs, _ctx);
    kk_box_t _x22018 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22018, KK_OWNED, _ctx);
  }
}
 
// Return the list without its last element.
// Return an empty list for an empty list.

kk_std_core__list kk_std_core_init(kk_std_core__list xs0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x22019 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_init(xs0, _x22019, _ctx);
}
 
// Is the character an ASCII letter is-

bool kk_std_core_is_alpha(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> bool */ 
  bool _match_20770 = (c >= ('a')); /*bool*/;
  if (_match_20770) {
    bool _match_20772 = (c <= ('z')); /*bool*/;
    if (_match_20772) {
      return true;
    }
    {
      bool _match_20773 = (c >= ('A')); /*bool*/;
      if (_match_20773) {
        return (c <= ('Z'));
      }
      {
        return false;
      }
    }
  }
  {
    bool _match_20771 = (c >= ('A')); /*bool*/;
    if (_match_20771) {
      return (c <= ('Z'));
    }
    {
      return false;
    }
  }
}
 
// Is the character an ASCII hexa-decimal digit ?

bool kk_std_core_is_hex_digit(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> bool */ 
  bool _match_20757 = (c >= ('0')); /*bool*/;
  if (_match_20757) {
    bool _match_20762 = (c <= ('9')); /*bool*/;
    if (_match_20762) {
      return true;
    }
    {
      bool _match_20763 = (c >= ('a')); /*bool*/;
      if (_match_20763) {
        bool _match_20765 = (c <= ('f')); /*bool*/;
        if (_match_20765) {
          return true;
        }
        {
          bool _match_20766 = (c >= ('A')); /*bool*/;
          if (_match_20766) {
            return (c <= ('F'));
          }
          {
            return false;
          }
        }
      }
      {
        bool _match_20764 = (c >= ('A')); /*bool*/;
        if (_match_20764) {
          return (c <= ('F'));
        }
        {
          return false;
        }
      }
    }
  }
  {
    bool _match_20758 = (c >= ('a')); /*bool*/;
    if (_match_20758) {
      bool _match_20760 = (c <= ('f')); /*bool*/;
      if (_match_20760) {
        return true;
      }
      {
        bool _match_20761 = (c >= ('A')); /*bool*/;
        if (_match_20761) {
          return (c <= ('F'));
        }
        {
          return false;
        }
      }
    }
    {
      bool _match_20759 = (c >= ('A')); /*bool*/;
      if (_match_20759) {
        return (c <= ('F'));
      }
      {
        return false;
      }
    }
  }
}
 
// Tests if a character is an element of `" \t\n\r"`

bool kk_std_core_is_white(kk_char_t c, kk_context_t* _ctx) { /* (c : char) -> bool */ 
  bool _match_20750 = (c == (' ')); /*bool*/;
  if (_match_20750) {
    return true;
  }
  {
    bool _match_20751 = (c == 0x0009); /*bool*/;
    if (_match_20751) {
      return true;
    }
    {
      bool _match_20752 = (c == 0x000A); /*bool*/;
      if (_match_20752) {
        return true;
      }
      {
        return (c == 0x000D);
      }
    }
  }
}
 
// Append `end` to each string in the list `xs` and join them all together.
// `join-end([],end) === ""`
// `join-end(["a","b"],"/") === "a/b/"`

kk_string_t kk_std_core_join_end(kk_std_core__list xs, kk_string_t end, kk_context_t* _ctx) { /* (xs : list<string>, end : string) -> string */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_string_drop(end, _ctx);
    return kk_string_empty();
  }
  {
    kk_string_t _x22023;
    if (kk_std_core__is_Nil(xs, _ctx)) {
      _x22023 = kk_string_empty(); /*string*/
    }
    else {
      struct kk_std_core_Cons* _con22025 = kk_std_core__as_Cons(xs, _ctx);
      kk_box_t _box_x20232 = _con22025->head;
      kk_std_core__list xx = _con22025->tail;
      kk_string_t x = kk_string_unbox(_box_x20232);
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_string_dup(x, _ctx);
        kk_std_core__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      if (kk_std_core__is_Nil(xx, _ctx)) {
        _x22023 = x; /*string*/
      }
      else {
        kk_string_t _x22026 = kk_string_dup(end, _ctx); /*string*/
        _x22023 = kk_std_core__unroll17331_lift17316_joinsep(_x22026, xx, x, _ctx); /*string*/
      }
    }
    return kk_std_core__lp__plus__plus__1_rp_(_x22023, end, _ctx);
  }
}
 
// Return the last element of a list (or `Nothing` for the empty list)

kk_std_core_types__maybe kk_std_core_last(kk_std_core__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> maybe<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22027 = kk_std_core__as_Cons(xs, _ctx);
    kk_std_core__list _pat0 = _con22027->tail;
    if (kk_std_core__is_Nil(_pat0, _ctx)) {
      kk_box_t x = _con22027->head;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_box_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      return kk_std_core_types__new_Just(x, _ctx);
    }
  }
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22028 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _pat2 = _con22028->head;
    kk_std_core__list xx = _con22028->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_pat2, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    { // tailcall
      xs = xx;
      goto kk__tailcall;
    }
  }
  {
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Return the last element of a list (or `default` for the empty list)

kk_box_t kk_std_core_last_1(kk_std_core__list xs, kk_box_t default0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, default : a) -> a */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22029 = kk_std_core__as_Cons(xs, _ctx);
    kk_std_core__list _pat0 = _con22029->tail;
    if (kk_std_core__is_Nil(_pat0, _ctx)) {
      kk_box_t x = _con22029->head;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        kk_datatype_ptr_free(xs, _ctx);
      }
      else {
        kk_box_dup(x, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_box_drop(default0, _ctx);
      return x;
    }
  }
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22030 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _pat2 = _con22030->head;
    kk_std_core__list xx = _con22030->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_pat2, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    { // tailcall
      xs = xx;
      goto kk__tailcall;
    }
  }
  {
    return default0;
  }
}
 
// O(`n`). The last `n` (default = `1`) characters in a string

kk_std_core__sslice kk_std_core_last_2(kk_string_t s, kk_std_core_types__optional n, kk_context_t* _ctx) { /* (s : string, n : optional<int>) -> sslice */ 
  kk_std_core__sslice slice0 = kk_std_core_last1(s, _ctx); /*sslice*/;
  bool _match_20742;
  kk_integer_t _brw_20748;
  if (kk_std_core_types__is_Optional(n, _ctx)) {
    kk_box_t _box_x20233 = n._cons.Optional.value;
    kk_integer_t _n_14007 = kk_integer_unbox(_box_x20233, _ctx);
    kk_integer_dup(_n_14007, _ctx);
    _brw_20748 = _n_14007; /*int*/
  }
  else {
    _brw_20748 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_20749 = kk_integer_eq_borrow(_brw_20748,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_20748, _ctx);
  _match_20742 = _brw_20749; /*bool*/
  if (_match_20742) {
    kk_std_core_types__optional_drop(n, _ctx);
    return slice0;
  }
  {
    kk_std_core__sslice _own_20744;
    kk_integer_t _brw_20745;
    kk_integer_t _x22031;
    if (kk_std_core_types__is_Optional(n, _ctx)) {
      kk_box_t _box_x20234 = n._cons.Optional.value;
      kk_integer_t _n_140070 = kk_integer_unbox(_box_x20234, _ctx);
      kk_integer_dup(_n_140070, _ctx);
      _x22031 = _n_140070; /*int*/
    }
    else {
      _x22031 = kk_integer_from_small(1); /*int*/
    }
    _brw_20745 = kk_integer_sub((kk_integer_from_small(1)),_x22031,kk_context()); /*int*/
    kk_std_core__sslice _brw_20746 = kk_std_core_advance(slice0, _brw_20745, _ctx); /*sslice*/;
    kk_integer_drop(_brw_20745, _ctx);
    _own_20744 = _brw_20746; /*sslice*/
    kk_integer_t _brw_20743;
    kk_integer_t _x22032;
    if (kk_std_core_types__is_Optional(n, _ctx)) {
      kk_box_t _box_x20235 = n._cons.Optional.value;
      kk_integer_t _n_140071 = kk_integer_unbox(_box_x20235, _ctx);
      kk_integer_dup(_n_140071, _ctx);
      kk_std_core_types__optional_drop(n, _ctx);
      _x22032 = _n_140071; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(n, _ctx);
      _x22032 = kk_integer_from_small(1); /*int*/
    }
    _brw_20743 = kk_integer_add_small_const(_x22032, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_20747 = kk_std_core_extend(_own_20744, _brw_20743, _ctx); /*sslice*/;
    kk_integer_drop(_brw_20743, _ctx);
    return _brw_20747;
  }
}
 
// Take the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core__list kk_std_core__trmc_take(kk_std_core__list xs, kk_integer_t n, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22033 = kk_std_core__as_Cons(xs, _ctx);
    if (kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context())) {
      kk_box_t x = _con22033->head;
      kk_std_core__list xx = _con22033->tail;
      kk_reuse_t _ru_21076 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
        _ru_21076 = (kk_datatype_ptr_reuse(xs, _ctx));
      }
      else {
        kk_box_dup(x, _ctx);
        kk_std_core__list_dup(xx, _ctx);
        kk_datatype_ptr_decref(xs, _ctx);
      }
      kk_std_core__list _trmc_18409 = kk_datatype_null(); /*list<14131>*/;
      kk_std_core__list _trmc_18410 = kk_std_core__new_Cons(_ru_21076, 0, x, _trmc_18409, _ctx); /*list<14131>*/;
      kk_box_t* _b_20246_20241 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18410, _ctx)->tail)); /*field-addr<list<14131>>*/;
      { // tailcall
        kk_integer_t _x22034 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
        kk_std_core_types__cctx _x22035 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18410, _ctx)),_b_20246_20241,true,kk_context()); /*ctx<0>*/
        xs = xx;
        n = _x22034;
        _acc = _x22035;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_std_core__list_drop(xs, _ctx);
    kk_integer_drop(n, _ctx);
    kk_box_t _x22036 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22036, KK_OWNED, _ctx);
  }
}
 
// Take the first `n` elements of a list (or fewer if the list is shorter than `n`)

kk_std_core__list kk_std_core_take(kk_std_core__list xs0, kk_integer_t n0, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> list<a> */ 
  kk_std_core_types__cctx _x22037 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_take(xs0, n0, _x22037, _ctx);
}
 
// split a list at position `n`

kk_std_core_types__tuple2_ kk_std_core_split(kk_std_core__list xs, kk_integer_t n, kk_context_t* _ctx) { /* forall<a> (xs : list<a>, n : int) -> (list<a>, list<a>) */ 
  kk_std_core__list _b_20254_20252;
  kk_std_core__list _x22038 = kk_std_core__list_dup(xs, _ctx); /*list<14151>*/
  kk_integer_t _x22039 = kk_integer_dup(n, _ctx); /*int*/
  _b_20254_20252 = kk_std_core_take(_x22038, _x22039, _ctx); /*list<14151>*/
  kk_std_core__list _b_20255_20253 = kk_std_core_drop(xs, n, _ctx); /*list<14151>*/;
  return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_20254_20252, _ctx), kk_std_core__list_box(_b_20255_20253, _ctx), _ctx);
}
 
// lifted local: lookup, .spec.18246
// specialized: std/core/.unroll17338-foreach-while, on parameters action18239, using:
// action18239 = fn(kv: (14483, 14484)){
//   match ((pred((match (kv) {
//     ((.skip std/core/types/(,)((.x: 14483) : a, (.pat00: 14484) : a) : (a, b) ) as .pat1: (14483, 14484))
//        -> .x;
//   })))) {
//     ((std/core/types/True() : bool ) as .pat2: bool)
//        -> std/core/types/Just<a>((match (kv) {
//         ((.skip std/core/types/(,)((.pat01: 14483) : a, (.x0: 14484) : a) : (a, b) ) as .pat3: (14483, 14484))
//            -> .x0;
//       }));
//     ((.skip std/core/types/False() : bool ) as .pat02: bool)
//        -> std/core/types/Nothing<a>;
//   };
// }

kk_std_core_types__maybe kk_std_core__lift18318_lookup(kk_function_t pred, kk_std_core__list xs18238, kk_context_t* _ctx) { /* forall<a,b> (pred : (a) -> bool, xs18238 : list<(a, b)>) -> maybe<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs18238, _ctx)) {
    kk_function_drop(pred, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    struct kk_std_core_Cons* _con22044 = kk_std_core__as_Cons(xs18238, _ctx);
    kk_box_t _box_x20256 = _con22044->head;
    kk_std_core__list xx18243 = _con22044->tail;
    kk_std_core_types__tuple2_ x18242 = kk_std_core_types__tuple2__unbox(_box_x20256, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs18238, _ctx)) {
      kk_std_core_types__tuple2__dup(x18242, _ctx);
      kk_box_drop(_box_x20256, _ctx);
      kk_datatype_ptr_free(xs18238, _ctx);
    }
    else {
      kk_std_core_types__tuple2__dup(x18242, _ctx);
      kk_std_core__list_dup(xx18243, _ctx);
      kk_datatype_ptr_decref(xs18238, _ctx);
    }
    bool _match_20741;
    kk_function_t _x22046 = kk_function_dup(pred, _ctx); /*(14483) -> bool*/
    kk_box_t _x22045;
    {
      kk_box_t _x = x18242.fst;
      kk_box_dup(_x, _ctx);
      _x22045 = _x; /*14483*/
    }
    _match_20741 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x22046, (_x22046, _x22045, _ctx), _ctx); /*bool*/
    if (_match_20741) {
      kk_std_core__list_drop(xx18243, _ctx);
      kk_function_drop(pred, _ctx);
      kk_box_t _x22047;
      {
        kk_box_t _x0 = x18242.snd;
        kk_box_dup(_x0, _ctx);
        kk_std_core_types__tuple2__drop(x18242, _ctx);
        _x22047 = _x0; /*14484*/
      }
      return kk_std_core_types__new_Just(_x22047, _ctx);
    }
    {
      kk_std_core_types__tuple2__drop(x18242, _ctx);
      { // tailcall
        xs18238 = xx18243;
        goto kk__tailcall;
      }
    }
  }
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18843_trmc_unroll17346_lift17322_map_indexed(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i0_17731, kk_std_core__list yy, kk_box_t _trmc_18411, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (idx : int, value : a) -> e b, i0.17731 : int, yy : list<a>, b) -> e list<b> */ 
  kk_std_core__list _trmc_18412 = kk_datatype_null(); /*list<14539>*/;
  kk_std_core__list _trmc_18413 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_18411, _trmc_18412, _ctx); /*list<14539>*/;
  kk_box_t* _b_20265_20262 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18413, _ctx)->tail)); /*field-addr<list<14539>>*/;
  kk_std_core_types__cctx _x22048 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18413, _ctx)),_b_20265_20262,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17346_lift17322_map_indexed(f, yy, i0_17731, _x22048, _ctx);
}
 
// lifted local: map-indexed, map-idx


// lift anonymous function
struct kk_std_core__trmc_unroll17346_lift17322_map_indexed_fun22053__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_integer_t i0_177310;
  kk_std_core__list yy0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17346_lift17322_map_indexed_fun22053(kk_function_t _fself, kk_box_t _b_20270, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17346_lift17322_map_indexed_fun22053(kk_function_t f0, kk_integer_t i0_177310, kk_std_core__list yy0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17346_lift17322_map_indexed_fun22053__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17346_lift17322_map_indexed_fun22053__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17346_lift17322_map_indexed_fun22053, kk_context());
  _self->f0 = f0;
  _self->i0_177310 = i0_177310;
  _self->yy0 = yy0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17346_lift17322_map_indexed_fun22053(kk_function_t _fself, kk_box_t _b_20270, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17346_lift17322_map_indexed_fun22053__t* _self = kk_function_as(struct kk_std_core__trmc_unroll17346_lift17322_map_indexed_fun22053__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (idx : int, value : 14538) -> 14540 14539 */
  kk_integer_t i0_177310 = _self->i0_177310; /* int */
  kk_std_core__list yy0 = _self->yy0; /* list<14538> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<14539>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_integer_dup(i0_177310, _ctx);kk_std_core__list_dup(yy0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_20288_184110 = _b_20270; /*14539*/;
  kk_std_core__list _x22054 = kk_std_core__mlift18843_trmc_unroll17346_lift17322_map_indexed(_acc0, f0, i0_177310, yy0, _trmc_20288_184110, _ctx); /*list<14539>*/
  return kk_std_core__list_box(_x22054, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17346_lift17322_map_indexed(kk_function_t f0, kk_std_core__list ys, kk_integer_t i, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a) -> e b, ys : list<a>, i : int, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con22049 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con22049->head;
    kk_std_core__list yy0 = _con22049->tail;
    kk_reuse_t _ru_21078 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_21078 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_integer_t i0_177310;
    kk_integer_t _x22050 = kk_integer_dup(i, _ctx); /*int*/
    i0_177310 = kk_integer_add_small_const(_x22050, 1, _ctx); /*int*/
    kk_box_t x_19113;
    kk_function_t _x22051 = kk_function_dup(f0, _ctx); /*(idx : int, value : 14538) -> 14540 14539*/
    x_19113 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_context_t*), _x22051, (_x22051, i, y, _ctx), _ctx); /*14539*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_21078,kk_context());
      kk_box_drop(x_19113, _ctx);
      kk_box_t _x22052 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17346_lift17322_map_indexed_fun22053(f0, i0_177310, yy0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x22052, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_184120 = kk_datatype_null(); /*list<14539>*/;
      kk_std_core__list _trmc_184130 = kk_std_core__new_Cons(_ru_21078, kk_field_index_of(struct kk_std_core_Cons, tail), x_19113, _trmc_184120, _ctx); /*list<14539>*/;
      kk_box_t* _b_20282_20276 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_184130, _ctx)->tail)); /*field-addr<list<14539>>*/;
      { // tailcall
        kk_std_core_types__cctx _x22055 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_184130, _ctx)),_b_20282_20276,false,kk_context()); /*ctx<0>*/
        ys = yy0;
        i = i0_177310;
        _acc0 = _x22055;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x22056 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22056, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-indexed, map-idx

kk_std_core__list kk_std_core__unroll17346_lift17322_map_indexed(kk_function_t f1, kk_std_core__list ys0, kk_integer_t i0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a) -> e b, ys : list<a>, i : int) -> e list<b> */ 
  kk_std_core_types__cctx _x22057 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17346_lift17322_map_indexed(f1, ys0, i0, _x22057, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18844_trmc_unroll17347_lift17323_map_indexed_peek(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i0_17736, kk_std_core__list yy, kk_box_t _trmc_18414, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, f : (idx : int, value : a, rest : list<a>) -> e b, i0.17736 : int, yy : list<a>, b) -> e list<b> */ 
  kk_std_core__list _trmc_18415 = kk_datatype_null(); /*list<14596>*/;
  kk_std_core__list _trmc_18416 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_18414, _trmc_18415, _ctx); /*list<14596>*/;
  kk_box_t* _b_20297_20294 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18416, _ctx)->tail)); /*field-addr<list<14596>>*/;
  kk_std_core_types__cctx _x22058 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18416, _ctx)),_b_20297_20294,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek(f, yy, i0_17736, _x22058, _ctx);
}
 
// lifted local: map-indexed-peek, mapidx


// lift anonymous function
struct kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek_fun22064__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_integer_t i0_177360;
  kk_std_core__list yy0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek_fun22064(kk_function_t _fself, kk_box_t _b_20302, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17347_lift17323_map_indexed_peek_fun22064(kk_function_t f0, kk_integer_t i0_177360, kk_std_core__list yy0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek_fun22064__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek_fun22064__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek_fun22064, kk_context());
  _self->f0 = f0;
  _self->i0_177360 = i0_177360;
  _self->yy0 = yy0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek_fun22064(kk_function_t _fself, kk_box_t _b_20302, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek_fun22064__t* _self = kk_function_as(struct kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek_fun22064__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (idx : int, value : 14595, rest : list<14595>) -> 14597 14596 */
  kk_integer_t i0_177360 = _self->i0_177360; /* int */
  kk_std_core__list yy0 = _self->yy0; /* list<14595> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<14596>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_integer_dup(i0_177360, _ctx);kk_std_core__list_dup(yy0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_20320_184140 = _b_20302; /*14596*/;
  kk_std_core__list _x22065 = kk_std_core__mlift18844_trmc_unroll17347_lift17323_map_indexed_peek(_acc0, f0, i0_177360, yy0, _trmc_20320_184140, _ctx); /*list<14596>*/
  return kk_std_core__list_box(_x22065, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek(kk_function_t f0, kk_std_core__list ys, kk_integer_t i, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a, rest : list<a>) -> e b, ys : list<a>, i : int, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con22059 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t y = _con22059->head;
    kk_std_core__list yy0 = _con22059->tail;
    kk_reuse_t _ru_21079 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      _ru_21079 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(y, _ctx);
      kk_std_core__list_dup(yy0, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    kk_integer_t i0_177360;
    kk_integer_t _x22060 = kk_integer_dup(i, _ctx); /*int*/
    i0_177360 = kk_integer_add_small_const(_x22060, 1, _ctx); /*int*/
    kk_box_t x_19116;
    kk_function_t _x22062 = kk_function_dup(f0, _ctx); /*(idx : int, value : 14595, rest : list<14595>) -> 14597 14596*/
    kk_std_core__list _x22061 = kk_std_core__list_dup(yy0, _ctx); /*list<14595>*/
    x_19116 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_std_core__list, kk_context_t*), _x22062, (_x22062, i, y, _x22061, _ctx), _ctx); /*14596*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_21079,kk_context());
      kk_box_drop(x_19116, _ctx);
      kk_box_t _x22063 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17347_lift17323_map_indexed_peek_fun22064(f0, i0_177360, yy0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x22063, KK_OWNED, _ctx);
    }
    {
      kk_std_core__list _trmc_184150 = kk_datatype_null(); /*list<14596>*/;
      kk_std_core__list _trmc_184160 = kk_std_core__new_Cons(_ru_21079, kk_field_index_of(struct kk_std_core_Cons, tail), x_19116, _trmc_184150, _ctx); /*list<14596>*/;
      kk_box_t* _b_20314_20308 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_184160, _ctx)->tail)); /*field-addr<list<14596>>*/;
      { // tailcall
        kk_std_core_types__cctx _x22066 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_184160, _ctx)),_b_20314_20308,false,kk_context()); /*ctx<0>*/
        ys = yy0;
        i = i0_177360;
        _acc0 = _x22066;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_integer_drop(i, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x22067 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22067, KK_OWNED, _ctx);
  }
}
 
// lifted local: map-indexed-peek, mapidx

kk_std_core__list kk_std_core__unroll17347_lift17323_map_indexed_peek(kk_function_t f1, kk_std_core__list ys0, kk_integer_t i0, kk_context_t* _ctx) { /* forall<a,b,e> (f : (idx : int, value : a, rest : list<a>) -> e b, ys : list<a>, i : int) -> e list<b> */ 
  kk_std_core_types__cctx _x22068 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17347_lift17323_map_indexed_peek(f1, ys0, i0, _x22068, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18845_trmc_unroll17348_map_while(kk_std_core_types__cctx _acc, kk_function_t action, kk_std_core__list xx, kk_std_core_types__maybe _y_18670, kk_context_t* _ctx) { /* forall<a,b,e> (ctx<list<b>>, action : (a) -> e maybe<b>, xx : list<a>, maybe<b>) -> e list<b> */ 
  if (kk_std_core_types__is_Just(_y_18670, _ctx)) {
    kk_box_t y = _y_18670._cons.Just.value;
    kk_std_core__list _trmc_18417 = kk_datatype_null(); /*list<14638>*/;
    kk_std_core__list _trmc_18418 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), y, _trmc_18417, _ctx); /*list<14638>*/;
    kk_box_t* _b_20331_20326 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18418, _ctx)->tail)); /*field-addr<list<14638>>*/;
    kk_std_core_types__cctx _x22069 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18418, _ctx)),_b_20331_20326,false,kk_context()); /*ctx<0>*/
    return kk_std_core__trmc_unroll17348_map_while(xx, action, _x22069, _ctx);
  }
  {
    kk_std_core__list_drop(xx, _ctx);
    kk_function_drop(action, _ctx);
    kk_box_t _x22070 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22070, KK_OWNED, _ctx);
  }
}
 
// Invoke `action` on each element of a list while `action` returns `Just`


// lift anonymous function
struct kk_std_core__trmc_unroll17348_map_while_fun22075__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17348_map_while_fun22075(kk_function_t _fself, kk_box_t _b_20340, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17348_map_while_fun22075(kk_function_t action0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17348_map_while_fun22075__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17348_map_while_fun22075__t, 4, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17348_map_while_fun22075, kk_context());
  _self->action0 = action0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17348_map_while_fun22075(kk_function_t _fself, kk_box_t _b_20340, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17348_map_while_fun22075__t* _self = kk_function_as(struct kk_std_core__trmc_unroll17348_map_while_fun22075__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* (14637) -> 14639 maybe<14638> */
  kk_std_core__list xx0 = _self->xx0; /* list<14637> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<14638>> */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_std_core_types__maybe _y_20360_186700 = kk_std_core_types__maybe_unbox(_b_20340, KK_OWNED, _ctx); /*maybe<14638>*/;
  kk_std_core__list _x22076 = kk_std_core__mlift18845_trmc_unroll17348_map_while(_acc0, action0, xx0, _y_20360_186700, _ctx); /*list<14638>*/
  return kk_std_core__list_box(_x22076, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17348_map_while(kk_std_core__list xs, kk_function_t action0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>, ctx<list<b>>) -> e list<b> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(action0, _ctx);
    kk_box_t _x22071 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22071, KK_OWNED, _ctx);
  }
  {
    struct kk_std_core_Cons* _con22072 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con22072->head;
    kk_std_core__list xx0 = _con22072->tail;
    kk_reuse_t _ru_21080 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_21080 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__maybe x0_19119;
    kk_function_t _x22073 = kk_function_dup(action0, _ctx); /*(14637) -> 14639 maybe<14638>*/
    x0_19119 = kk_function_call(kk_std_core_types__maybe, (kk_function_t, kk_box_t, kk_context_t*), _x22073, (_x22073, x, _ctx), _ctx); /*maybe<14638>*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_21080,kk_context());
      kk_std_core_types__maybe_drop(x0_19119, _ctx);
      kk_box_t _x22074 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17348_map_while_fun22075(action0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x22074, KK_OWNED, _ctx);
    }
    if (kk_std_core_types__is_Just(x0_19119, _ctx)) {
      kk_box_t y0 = x0_19119._cons.Just.value;
      kk_std_core__list _trmc_184170 = kk_datatype_null(); /*list<14638>*/;
      kk_std_core__list _trmc_184180 = kk_std_core__new_Cons(_ru_21080, kk_field_index_of(struct kk_std_core_Cons, tail), y0, _trmc_184170, _ctx); /*list<14638>*/;
      kk_box_t* _b_20354_20346 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_184180, _ctx)->tail)); /*field-addr<list<14638>>*/;
      { // tailcall
        kk_std_core_types__cctx _x22077 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_184180, _ctx)),_b_20354_20346,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x22077;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_21080,kk_context());
      kk_std_core__list_drop(xx0, _ctx);
      kk_function_drop(action0, _ctx);
      kk_box_t _x22078 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
      return kk_std_core__list_unbox(_x22078, KK_OWNED, _ctx);
    }
  }
}
 
// Invoke `action` on each element of a list while `action` returns `Just`

kk_std_core__list kk_std_core__unroll17348_map_while(kk_std_core__list xs0, kk_function_t action1, kk_context_t* _ctx) { /* forall<a,b,e> (xs : list<a>, action : (a) -> e maybe<b>) -> e list<b> */ 
  kk_std_core_types__cctx _x22079 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17348_map_while(xs0, action1, _x22079, _ctx);
}
 
// lifted local: maximum, .spec.18255
// specialized: std/core/.unroll17344-foldl, on parameters f18250, using:
// f18250 = std/core/max

kk_integer_t kk_std_core__lift18319_maximum(kk_std_core__list xs18248, kk_integer_t z18249, kk_context_t* _ctx) { /* (xs18248 : list<int>, z18249 : int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18248, _ctx)) {
    struct kk_std_core_Cons* _con22080 = kk_std_core__as_Cons(xs18248, _ctx);
    kk_box_t _box_x20361 = _con22080->head;
    kk_std_core__list xx18253 = _con22080->tail;
    kk_integer_t x18252 = kk_integer_unbox(_box_x20361, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs18248, _ctx)) {
      kk_datatype_ptr_free(xs18248, _ctx);
    }
    else {
      kk_integer_dup(x18252, _ctx);
      kk_std_core__list_dup(xx18253, _ctx);
      kk_datatype_ptr_decref(xs18248, _ctx);
    }
    { // tailcall
      kk_integer_t _x22081;
      bool _match_20735 = kk_integer_gte_borrow(z18249,x18252,kk_context()); /*bool*/;
      if (_match_20735) {
        kk_integer_drop(x18252, _ctx);
        _x22081 = z18249; /*int*/
      }
      else {
        kk_integer_drop(z18249, _ctx);
        _x22081 = x18252; /*int*/
      }
      xs18248 = xx18253;
      z18249 = _x22081;
      goto kk__tailcall;
    }
  }
  {
    return z18249;
  }
}
 
// Returns the largest element of a list of integers (or `default` (=`0`) for the empty list)

kk_integer_t kk_std_core_maximum(kk_std_core__list xs, kk_std_core_types__optional default0, kk_context_t* _ctx) { /* (xs : list<int>, default : optional<int>) -> int */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    if (kk_std_core_types__is_Optional(default0, _ctx)) {
      kk_box_t _box_x20362 = default0._cons.Optional.value;
      kk_integer_t _default_14687 = kk_integer_unbox(_box_x20362, _ctx);
      kk_integer_dup(_default_14687, _ctx);
      kk_std_core_types__optional_drop(default0, _ctx);
      return _default_14687;
    }
    {
      kk_std_core_types__optional_drop(default0, _ctx);
      return kk_integer_from_small(0);
    }
  }
  {
    struct kk_std_core_Cons* _con22082 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x20363 = _con22082->head;
    kk_std_core__list xx = _con22082->tail;
    kk_integer_t x = kk_integer_unbox(_box_x20363, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_integer_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__optional_drop(default0, _ctx);
    if (kk_std_core__is_Nil(xx, _ctx)) {
      return x;
    }
    {
      return kk_std_core__lift18319_maximum(xx, x, _ctx);
    }
  }
}
 
// lifted local: maximum.1, .spec.18263
// specialized: std/core/.unroll17344-foldl, on parameters f18258, using:
// f18258 = std/core/max.1

double kk_std_core__lift18320_maximum_1(kk_std_core__list xs18256, double z18257, kk_context_t* _ctx) { /* (xs18256 : list<float64>, z18257 : float64) -> float64 */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18256, _ctx)) {
    struct kk_std_core_Cons* _con22083 = kk_std_core__as_Cons(xs18256, _ctx);
    kk_box_t _box_x20364 = _con22083->head;
    kk_std_core__list xx18261 = _con22083->tail;
    double x18260 = kk_double_unbox(_box_x20364, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs18256, _ctx)) {
      kk_box_drop(_box_x20364, _ctx);
      kk_datatype_ptr_free(xs18256, _ctx);
    }
    else {
      kk_std_core__list_dup(xx18261, _ctx);
      kk_datatype_ptr_decref(xs18256, _ctx);
    }
    { // tailcall
      double _x22084;
      bool _match_20734 = (z18257 >= x18260); /*bool*/;
      if (_match_20734) {
        _x22084 = z18257; /*float64*/
      }
      else {
        _x22084 = x18260; /*float64*/
      }
      xs18256 = xx18261;
      z18257 = _x22084;
      goto kk__tailcall;
    }
  }
  {
    return z18257;
  }
}
 
// Returns the largest element of a list of floats (or `0` for the empty list)

double kk_std_core_maximum_1(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    return 0x0p+0;
  }
  {
    struct kk_std_core_Cons* _con22085 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x20365 = _con22085->head;
    kk_std_core__list xx = _con22085->tail;
    double x = kk_double_unbox(_box_x20365, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_box_x20365, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      return x;
    }
    {
      return kk_std_core__lift18320_maximum_1(xx, x, _ctx);
    }
  }
}
 
// Convert a list to a `:maybe` type, using `Nothing` for an empty list, and otherwise `Just` on the head element.
// Note: this is just `head`.

kk_std_core_types__maybe kk_std_core_maybe_3(kk_std_core__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> maybe<a> */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    struct kk_std_core_Cons* _con22086 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con22086->head;
    kk_std_core__list _pat1 = _con22086->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_std_core__list_drop(_pat1, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return kk_std_core_types__new_Just(x, _ctx);
  }
}
 
// Transform a string to a maybe type, using `Nothing` for an empty string

kk_std_core_types__maybe kk_std_core_maybe_6(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> maybe<string> */ 
  bool _match_20732;
  kk_string_t _x22087 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x22088 = kk_string_empty(); /*string*/
  _match_20732 = kk_string_is_eq(_x22087,_x22088,kk_context()); /*bool*/
  if (_match_20732) {
    kk_string_drop(s, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
  {
    return kk_std_core_types__new_Just(kk_string_box(s), _ctx);
  }
}
 
// Transform a `:null` type to a `:maybe` type. Note that it is not
// always the case that `id(x) == maybe(null(x))` (e.g. when `x = Just(Nothing)`).

kk_std_core_types__maybe kk_std_core_maybe_8(kk_std_core__null n, kk_context_t* _ctx) { /* forall<a> (n : null<a>) -> maybe<a> */ 
  return (kk_datatype_is_null(n) ? kk_std_core_types__new_Nothing(kk_context()) : kk_std_core_types__new_Just(kk_datatype_box(n),kk_context()));
}
 
// lifted local: minimum, .spec.18271
// specialized: std/core/.unroll17344-foldl, on parameters f18266, using:
// f18266 = std/core/min

kk_integer_t kk_std_core__lift18321_minimum(kk_std_core__list xs18264, kk_integer_t z18265, kk_context_t* _ctx) { /* (xs18264 : list<int>, z18265 : int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18264, _ctx)) {
    struct kk_std_core_Cons* _con22090 = kk_std_core__as_Cons(xs18264, _ctx);
    kk_box_t _box_x20372 = _con22090->head;
    kk_std_core__list xx18269 = _con22090->tail;
    kk_integer_t x18268 = kk_integer_unbox(_box_x20372, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs18264, _ctx)) {
      kk_datatype_ptr_free(xs18264, _ctx);
    }
    else {
      kk_integer_dup(x18268, _ctx);
      kk_std_core__list_dup(xx18269, _ctx);
      kk_datatype_ptr_decref(xs18264, _ctx);
    }
    { // tailcall
      kk_integer_t _x22091;
      bool _match_20729 = kk_integer_lte_borrow(z18265,x18268,kk_context()); /*bool*/;
      if (_match_20729) {
        kk_integer_drop(x18268, _ctx);
        _x22091 = z18265; /*int*/
      }
      else {
        kk_integer_drop(z18265, _ctx);
        _x22091 = x18268; /*int*/
      }
      xs18264 = xx18269;
      z18265 = _x22091;
      goto kk__tailcall;
    }
  }
  {
    return z18265;
  }
}
 
// Returns the smallest element of a list of integers (or `default` (=`0`) for the empty list)

kk_integer_t kk_std_core_minimum(kk_std_core__list xs, kk_std_core_types__optional default0, kk_context_t* _ctx) { /* (xs : list<int>, default : optional<int>) -> int */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    if (kk_std_core_types__is_Optional(default0, _ctx)) {
      kk_box_t _box_x20373 = default0._cons.Optional.value;
      kk_integer_t _default_15166 = kk_integer_unbox(_box_x20373, _ctx);
      kk_integer_dup(_default_15166, _ctx);
      kk_std_core_types__optional_drop(default0, _ctx);
      return _default_15166;
    }
    {
      kk_std_core_types__optional_drop(default0, _ctx);
      return kk_integer_from_small(0);
    }
  }
  {
    struct kk_std_core_Cons* _con22092 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x20374 = _con22092->head;
    kk_std_core__list xx = _con22092->tail;
    kk_integer_t x = kk_integer_unbox(_box_x20374, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_integer_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    kk_std_core_types__optional_drop(default0, _ctx);
    if (kk_std_core__is_Nil(xx, _ctx)) {
      return x;
    }
    {
      return kk_std_core__lift18321_minimum(xx, x, _ctx);
    }
  }
}
 
// lifted local: minimum.1, .spec.18279
// specialized: std/core/.unroll17344-foldl, on parameters f18274, using:
// f18274 = std/core/min.1

double kk_std_core__lift18322_minimum_1(kk_std_core__list xs18272, double z18273, kk_context_t* _ctx) { /* (xs18272 : list<float64>, z18273 : float64) -> float64 */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18272, _ctx)) {
    struct kk_std_core_Cons* _con22093 = kk_std_core__as_Cons(xs18272, _ctx);
    kk_box_t _box_x20375 = _con22093->head;
    kk_std_core__list xx18277 = _con22093->tail;
    double x18276 = kk_double_unbox(_box_x20375, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs18272, _ctx)) {
      kk_box_drop(_box_x20375, _ctx);
      kk_datatype_ptr_free(xs18272, _ctx);
    }
    else {
      kk_std_core__list_dup(xx18277, _ctx);
      kk_datatype_ptr_decref(xs18272, _ctx);
    }
    { // tailcall
      double _x22094;
      bool _match_20728 = (z18273 <= x18276); /*bool*/;
      if (_match_20728) {
        _x22094 = z18273; /*float64*/
      }
      else {
        _x22094 = x18276; /*float64*/
      }
      xs18272 = xx18277;
      z18273 = _x22094;
      goto kk__tailcall;
    }
  }
  {
    return z18273;
  }
}
 
// Returns the smallest element of a list of floats (or `0` for the empty list)

double kk_std_core_minimum_1(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<float64>) -> float64 */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    return 0x0p+0;
  }
  {
    struct kk_std_core_Cons* _con22095 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x20376 = _con22095->head;
    kk_std_core__list xx = _con22095->tail;
    double x = kk_double_unbox(_box_x20376, KK_BORROWED, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_box_x20376, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      return x;
    }
    {
      return kk_std_core__lift18322_minimum_1(xx, x, _ctx);
    }
  }
}
 
// Disable tracing completely.

kk_unit_t kk_std_core_notrace(kk_context_t* _ctx) { /* () -> (st<global>) () */ 
  kk_ref_set_borrow(kk_std_core_trace_enabled,(kk_bool_box(false)),kk_context()); return kk_Unit;
}
 
// Transform a `:maybe` type to a `:null` type (using `null` for `Nothing`).

kk_std_core__null kk_std_core_null(kk_std_core_types__maybe x, kk_context_t* _ctx) { /* forall<a> (x : maybe<a>) -> null<a> */ 
  return (kk_std_core_types__is_Nothing(x,kk_context()) ? kk_datatype_null() : kk_datatype_unbox((x)._cons.Just.value) /* kk_datatype_unbox(kk_datatype_unjust(x,kk_context())) */ );
}
 
// Cast a integer that is zero to a null

kk_std_core__null kk_std_core_null_1(kk_integer_t i, kk_context_t* _ctx) { /* (i : int) -> null<int> */ 
  kk_std_core_types__maybe _x22096;
  bool _match_20727 = kk_integer_eq_borrow(i,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_20727) {
    kk_integer_drop(i, _ctx);
    _x22096 = kk_std_core_types__new_Nothing(_ctx); /*forall<a> maybe<a>*/
  }
  else {
    _x22096 = kk_std_core_types__new_Just(kk_integer_box(i, _ctx), _ctx); /*forall<a> maybe<a>*/
  }
  return kk_std_core_null(_x22096, _ctx);
}
 
// Cast an empty string a null

kk_std_core__null kk_std_core_null_2(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> null<string> */ 
  kk_std_core_types__maybe _x22097;
  bool _match_20726;
  kk_string_t _x22098 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x22099 = kk_string_empty(); /*string*/
  _match_20726 = kk_string_is_eq(_x22098,_x22099,kk_context()); /*bool*/
  if (_match_20726) {
    kk_string_drop(s, _ctx);
    _x22097 = kk_std_core_types__new_Nothing(_ctx); /*forall<a> maybe<a>*/
  }
  else {
    _x22097 = kk_std_core_types__new_Just(kk_string_box(s), _ctx); /*forall<a> maybe<a>*/
  }
  return kk_std_core_null(_x22097, _ctx);
}
 
// Left-align a string to width `width`  using `fill`  (default is a space) to fill on the right.

kk_string_t kk_std_core_pad_right(kk_string_t s, kk_integer_t width, kk_std_core_types__optional fill, kk_context_t* _ctx) { /* (s : string, width : int, fill : optional<char>) -> string */ 
  kk_integer_t n;
  kk_string_t _x22102 = kk_string_dup(s, _ctx); /*string*/
  n = kk_string_len_int(_x22102,kk_context()); /*int*/
  bool _match_20725 = kk_integer_lte_borrow(width,n,kk_context()); /*bool*/;
  if (_match_20725) {
    kk_integer_drop(n, _ctx);
    kk_std_core_types__optional_drop(fill, _ctx);
    return s;
  }
  {
    kk_string_t s0_17759;
    kk_char_t _x22103;
    if (kk_std_core_types__is_Optional(fill, _ctx)) {
      kk_box_t _box_x20387 = fill._cons.Optional.value;
      kk_char_t _fill_15568 = kk_char_unbox(_box_x20387, KK_BORROWED, _ctx);
      kk_std_core_types__optional_drop(fill, _ctx);
      _x22103 = _fill_15568; /*char*/
    }
    else {
      kk_std_core_types__optional_drop(fill, _ctx);
      _x22103 = ' '; /*char*/
    }
    s0_17759 = kk_std_core_string(_x22103, _ctx); /*string*/
    kk_integer_t n0_17760;
    kk_integer_t _x22104 = kk_integer_dup(width, _ctx); /*int*/
    n0_17760 = kk_integer_sub(_x22104,n,kk_context()); /*int*/
    kk_string_t _x22105;
    kk_ssize_t _x22106 = kk_std_core_ssize__t(n0_17760, _ctx); /*ssize_t*/
    _x22105 = kk_std_core_repeatz(s0_17759, _x22106, _ctx); /*string*/
    return kk_std_core__lp__plus__plus__1_rp_(s, _x22105, _ctx);
  }
}
 
// Is `pre`  a prefix of `s`? If so, returns a slice
// of `s` following `pre` up to the end of `s`.

kk_std_core_types__maybe kk_std_core_starts_with(kk_string_t s, kk_string_t pre, kk_context_t* _ctx) { /* (s : string, pre : string) -> maybe<sslice> */ 
  bool _match_20724;
  kk_string_t _x22107 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x22108 = kk_string_dup(pre, _ctx); /*string*/
  _match_20724 = kk_string_starts_with(_x22107,_x22108,kk_context()); /*bool*/
  if (_match_20724) {
    kk_integer_t x_17763;
    kk_string_t _x22109 = kk_string_dup(s, _ctx); /*string*/
    x_17763 = kk_string_len_int(_x22109,kk_context()); /*int*/
    kk_integer_t y_17764;
    kk_string_t _x22110 = kk_string_dup(pre, _ctx); /*string*/
    y_17764 = kk_string_len_int(_x22110,kk_context()); /*int*/
    kk_std_core__sslice _b_20389_20388;
    kk_integer_t _x22111 = kk_string_len_int(pre,kk_context()); /*int*/
    kk_integer_t _x22112 = kk_integer_sub(x_17763,y_17764,kk_context()); /*int*/
    _b_20389_20388 = kk_std_core__new_Sslice(s, _x22111, _x22112, _ctx); /*sslice*/
    return kk_std_core_types__new_Just(kk_std_core__sslice_box(_b_20389_20388, _ctx), _ctx);
  }
  {
    kk_string_drop(s, _ctx);
    kk_string_drop(pre, _ctx);
    return kk_std_core_types__new_Nothing(_ctx);
  }
}
 
// Trim off a substring `sub` while `s` starts with that string.

kk_string_t kk_std_core_trim_left_1(kk_string_t s, kk_string_t sub, kk_context_t* _ctx) { /* (s : string, sub : string) -> string */ 
  kk__tailcall: ;
  bool _match_20722;
  kk_string_t _x22113 = kk_string_dup(sub, _ctx); /*string*/
  kk_string_t _x22114 = kk_string_empty(); /*string*/
  _match_20722 = kk_string_is_eq(_x22113,_x22114,kk_context()); /*bool*/
  if (_match_20722) {
    kk_string_drop(sub, _ctx);
    return s;
  }
  {
    kk_std_core_types__maybe _match_20723;
    kk_string_t _x22116 = kk_string_dup(s, _ctx); /*string*/
    kk_string_t _x22117 = kk_string_dup(sub, _ctx); /*string*/
    _match_20723 = kk_std_core_starts_with(_x22116, _x22117, _ctx); /*maybe<sslice>*/
    if (kk_std_core_types__is_Just(_match_20723, _ctx)) {
      kk_box_t _box_x20390 = _match_20723._cons.Just.value;
      kk_std_core__sslice slice0 = kk_std_core__sslice_unbox(_box_x20390, KK_BORROWED, _ctx);
      kk_string_drop(s, _ctx);
      kk_std_core__sslice_dup(slice0, _ctx);
      kk_std_core_types__maybe_drop(_match_20723, _ctx);
      { // tailcall
        kk_string_t _x22118 = kk_std_core_string_3(slice0, _ctx); /*string*/
        s = _x22118;
        goto kk__tailcall;
      }
    }
    {
      kk_string_drop(sub, _ctx);
      return s;
    }
  }
}
 
// Trim off a substring `sub` while `s` ends with that string.

kk_string_t kk_std_core_trim_right_1(kk_string_t s, kk_string_t sub, kk_context_t* _ctx) { /* (s : string, sub : string) -> string */ 
  kk__tailcall: ;
  bool _match_20720;
  kk_string_t _x22119 = kk_string_dup(sub, _ctx); /*string*/
  kk_string_t _x22120 = kk_string_empty(); /*string*/
  _match_20720 = kk_string_is_eq(_x22119,_x22120,kk_context()); /*bool*/
  if (_match_20720) {
    kk_string_drop(sub, _ctx);
    return s;
  }
  {
    kk_std_core_types__maybe _match_20721;
    kk_string_t _x22122 = kk_string_dup(s, _ctx); /*string*/
    kk_string_t _x22123 = kk_string_dup(sub, _ctx); /*string*/
    _match_20721 = kk_std_core_ends_with(_x22122, _x22123, _ctx); /*maybe<sslice>*/
    if (kk_std_core_types__is_Just(_match_20721, _ctx)) {
      kk_box_t _box_x20391 = _match_20721._cons.Just.value;
      kk_std_core__sslice slice0 = kk_std_core__sslice_unbox(_box_x20391, KK_BORROWED, _ctx);
      kk_string_drop(s, _ctx);
      kk_std_core__sslice_dup(slice0, _ctx);
      kk_std_core_types__maybe_drop(_match_20721, _ctx);
      { // tailcall
        kk_string_t _x22124 = kk_std_core_string_3(slice0, _ctx); /*string*/
        s = _x22124;
        goto kk__tailcall;
      }
    }
    {
      kk_string_drop(sub, _ctx);
      return s;
    }
  }
}
 
// Parse an integer after trimming whitespace.
// If an illegal digit character is encountered `Nothing` is returned.
// An empty string will result in `Just(0)`.
// A string can start with a `-` sign for negative numbers,
// and with `0x` or `0X` for hexadecimal numbers (in which case the `hex` parameter is ignored).

kk_std_core_types__maybe kk_std_core_parse_int(kk_string_t s, kk_std_core_types__optional hex, kk_context_t* _ctx) { /* (s : string, hex : optional<bool>) -> maybe<int> */ 
  kk_string_t _x22126;
  kk_string_t _x22127 = kk_string_trim_left(s,kk_context()); /*string*/
  _x22126 = kk_string_trim_right(_x22127,kk_context()); /*string*/
  bool _x22128;
  if (kk_std_core_types__is_Optional(hex, _ctx)) {
    kk_box_t _box_x20392 = hex._cons.Optional.value;
    bool _hex_15862 = kk_bool_unbox(_box_x20392);
    kk_std_core_types__optional_drop(hex, _ctx);
    _x22128 = _hex_15862; /*bool*/
  }
  else {
    kk_std_core_types__optional_drop(hex, _ctx);
    _x22128 = false; /*bool*/
  }
  return kk_std_core_xparse_int(_x22126, _x22128, _ctx);
}
 
// Parse an integer using `parseInt`. If an illegal digit character is encountered the
// `default` value is returned. An empty string will also result in `default`.

kk_integer_t kk_std_core_parse_int_default(kk_string_t s, kk_std_core_types__optional default0, kk_std_core_types__optional hex, kk_context_t* _ctx) { /* (s : string, default : optional<int>, hex : optional<bool>) -> int */ 
  bool _match_20719;
  kk_string_t _x22129 = kk_string_dup(s, _ctx); /*string*/
  kk_string_t _x22130 = kk_string_empty(); /*string*/
  _match_20719 = kk_string_is_eq(_x22129,_x22130,kk_context()); /*bool*/
  if (_match_20719) {
    kk_string_drop(s, _ctx);
    kk_std_core_types__optional_drop(hex, _ctx);
    if (kk_std_core_types__is_Optional(default0, _ctx)) {
      kk_box_t _box_x20393 = default0._cons.Optional.value;
      kk_integer_t _default_15874 = kk_integer_unbox(_box_x20393, _ctx);
      kk_integer_dup(_default_15874, _ctx);
      kk_std_core_types__optional_drop(default0, _ctx);
      return _default_15874;
    }
    {
      kk_std_core_types__optional_drop(default0, _ctx);
      return kk_integer_from_small(0);
    }
  }
  {
    kk_std_core_types__maybe m_17769;
    kk_string_t _x22132;
    kk_string_t _x22133 = kk_string_trim_left(s,kk_context()); /*string*/
    _x22132 = kk_string_trim_right(_x22133,kk_context()); /*string*/
    bool _x22134;
    if (kk_std_core_types__is_Optional(hex, _ctx)) {
      kk_box_t _box_x20394 = hex._cons.Optional.value;
      bool _hex_15878 = kk_bool_unbox(_box_x20394);
      kk_std_core_types__optional_drop(hex, _ctx);
      _x22134 = _hex_15878; /*bool*/
    }
    else {
      kk_std_core_types__optional_drop(hex, _ctx);
      _x22134 = false; /*bool*/
    }
    m_17769 = kk_std_core_xparse_int(_x22132, _x22134, _ctx); /*maybe<int>*/
    if (kk_std_core_types__is_Nothing(m_17769, _ctx)) {
      if (kk_std_core_types__is_Optional(default0, _ctx)) {
        kk_box_t _box_x20395 = default0._cons.Optional.value;
        kk_integer_t _default_158740 = kk_integer_unbox(_box_x20395, _ctx);
        kk_integer_dup(_default_158740, _ctx);
        kk_std_core_types__optional_drop(default0, _ctx);
        return _default_158740;
      }
      {
        kk_std_core_types__optional_drop(default0, _ctx);
        return kk_integer_from_small(0);
      }
    }
    {
      kk_box_t _box_x20396 = m_17769._cons.Just.value;
      kk_integer_t x = kk_integer_unbox(_box_x20396, _ctx);
      kk_integer_dup(x, _ctx);
      kk_std_core_types__maybe_drop(m_17769, _ctx);
      kk_std_core_types__optional_drop(default0, _ctx);
      return x;
    }
  }
}
 
// monadic lift

kk_std_core_types__tuple2_ kk_std_core__mlift18846_unroll17349_partition_acc(kk_std_core__list acc1, kk_std_core__list acc2, kk_function_t pred, kk_box_t x, kk_std_core__list xx, bool _y_18679, kk_context_t* _ctx) { /* forall<a,e> (acc1 : list<a>, acc2 : list<a>, pred : (a) -> e bool, x : a, xx : list<a>, bool) -> e (list<a>, list<a>) */ 
  if (_y_18679) {
    kk_std_core__list _x22135 = kk_std_core__new_Cons(kk_reuse_null, 0, x, acc1, _ctx); /*list<61>*/
    return kk_std_core__unroll17349_partition_acc(xx, pred, _x22135, acc2, _ctx);
  }
  {
    kk_std_core__list _x22136 = kk_std_core__new_Cons(kk_reuse_null, 0, x, acc2, _ctx); /*list<61>*/
    return kk_std_core__unroll17349_partition_acc(xx, pred, acc1, _x22136, _ctx);
  }
}


// lift anonymous function
struct kk_std_core__unroll17349_partition_acc_fun22141__t {
  struct kk_function_s _base;
  kk_std_core__list acc10;
  kk_std_core__list acc20;
  kk_function_t pred0;
  kk_box_t x0;
  kk_std_core__list xx0;
};
static kk_box_t kk_std_core__unroll17349_partition_acc_fun22141(kk_function_t _fself, kk_box_t _b_20400, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_unroll17349_partition_acc_fun22141(kk_std_core__list acc10, kk_std_core__list acc20, kk_function_t pred0, kk_box_t x0, kk_std_core__list xx0, kk_context_t* _ctx) {
  struct kk_std_core__unroll17349_partition_acc_fun22141__t* _self = kk_function_alloc_as(struct kk_std_core__unroll17349_partition_acc_fun22141__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__unroll17349_partition_acc_fun22141, kk_context());
  _self->acc10 = acc10;
  _self->acc20 = acc20;
  _self->pred0 = pred0;
  _self->x0 = x0;
  _self->xx0 = xx0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__unroll17349_partition_acc_fun22141(kk_function_t _fself, kk_box_t _b_20400, kk_context_t* _ctx) {
  struct kk_std_core__unroll17349_partition_acc_fun22141__t* _self = kk_function_as(struct kk_std_core__unroll17349_partition_acc_fun22141__t*, _fself, _ctx);
  kk_std_core__list acc10 = _self->acc10; /* list<15996> */
  kk_std_core__list acc20 = _self->acc20; /* list<15996> */
  kk_function_t pred0 = _self->pred0; /* (15996) -> 15997 bool */
  kk_box_t x0 = _self->x0; /* 15996 */
  kk_std_core__list xx0 = _self->xx0; /* list<15996> */
  kk_drop_match(_self, {kk_std_core__list_dup(acc10, _ctx);kk_std_core__list_dup(acc20, _ctx);kk_function_dup(pred0, _ctx);kk_box_dup(x0, _ctx);kk_std_core__list_dup(xx0, _ctx);}, {}, _ctx)
  bool _y_20404_186790 = kk_bool_unbox(_b_20400); /*bool*/;
  kk_std_core_types__tuple2_ _x22142 = kk_std_core__mlift18846_unroll17349_partition_acc(acc10, acc20, pred0, x0, xx0, _y_20404_186790, _ctx); /*(list<15996>, list<15996>)*/
  return kk_std_core_types__tuple2__box(_x22142, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core__unroll17349_partition_acc(kk_std_core__list xs, kk_function_t pred0, kk_std_core__list acc10, kk_std_core__list acc20, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool, acc1 : list<a>, acc2 : list<a>) -> e (list<a>, list<a>) */ 
  kk__tailcall: ;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(pred0, _ctx);
    kk_std_core__list _b_20401_20397;
    if (kk_std_core__is_Nil(acc10, _ctx)) {
      _b_20401_20397 = kk_std_core__new_Nil(_ctx); /*list<15996>*/
    }
    else {
      _b_20401_20397 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc10, _ctx); /*list<15996>*/
    }
    kk_std_core__list _b_20402_20398;
    if (kk_std_core__is_Nil(acc20, _ctx)) {
      _b_20402_20398 = kk_std_core__new_Nil(_ctx); /*list<15996>*/
    }
    else {
      _b_20402_20398 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc20, _ctx); /*list<15996>*/
    }
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_20401_20397, _ctx), kk_std_core__list_box(_b_20402_20398, _ctx), _ctx);
  }
  {
    struct kk_std_core_Cons* _con22137 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x0 = _con22137->head;
    kk_std_core__list xx0 = _con22137->tail;
    kk_reuse_t _ru_21090 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_21090 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x0, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x1_19130;
    kk_function_t _x22139 = kk_function_dup(pred0, _ctx); /*(15996) -> 15997 bool*/
    kk_box_t _x22138 = kk_box_dup(x0, _ctx); /*15996*/
    x1_19130 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x22139, (_x22139, _x22138, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_21090,kk_context());
      kk_box_t _x22140 = kk_std_core_hnd_yield_extend(kk_std_core__new_unroll17349_partition_acc_fun22141(acc10, acc20, pred0, x0, xx0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__tuple2__unbox(_x22140, KK_OWNED, _ctx);
    }
    if (x1_19130) { // tailcall
                    kk_std_core__list _x22143 = kk_std_core__new_Cons(_ru_21090, 0, x0, acc10, _ctx); /*list<61>*/
                    xs = xx0;
                    acc10 = _x22143;
                    goto kk__tailcall;
    }
    { // tailcall
      kk_std_core__list _x22144 = kk_std_core__new_Cons(_ru_21090, 0, x0, acc20, _ctx); /*list<61>*/
      xs = xx0;
      acc20 = _x22144;
      goto kk__tailcall;
    }
  }
}
 
// Partition a list in two lists where the first list contains
// those elements that satisfy the given predicate `pred`.
// For example: `partition([1,2,3],odd?) == ([1,3],[2])`

kk_std_core_types__tuple2_ kk_std_core_partition(kk_std_core__list xs, kk_function_t pred, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, pred : (a) -> e bool) -> e (list<a>, list<a>) */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(pred, _ctx);
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx), kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx), _ctx);
  }
  {
    return kk_std_core__unroll17349_partition_acc(xs, pred, kk_std_core__new_Nil(_ctx), kk_std_core__new_Nil(_ctx), _ctx);
  }
}
 
// redirect `print` and `println` calls to a specified function.


// lift anonymous function
struct kk_std_core_print_redirect_fun22147__t {
  struct kk_function_s _base;
  kk_function_t print0;
};
static kk_box_t kk_std_core_print_redirect_fun22147(kk_function_t _fself, kk_box_t _b_20416, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_print_redirect_fun22147(kk_function_t print0, kk_context_t* _ctx) {
  struct kk_std_core_print_redirect_fun22147__t* _self = kk_function_alloc_as(struct kk_std_core_print_redirect_fun22147__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_print_redirect_fun22147, kk_context());
  _self->print0 = print0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_print_redirect_fun22147(kk_function_t _fself, kk_box_t _b_20416, kk_context_t* _ctx) {
  struct kk_std_core_print_redirect_fun22147__t* _self = kk_function_as(struct kk_std_core_print_redirect_fun22147__t*, _fself, _ctx);
  kk_function_t print0 = _self->print0; /* (msg : string) -> console () */
  kk_drop_match(_self, {kk_function_dup(print0, _ctx);}, {}, _ctx)
  kk_unit_t _x22148 = kk_Unit;
  kk_string_t _x22149 = kk_string_unbox(_b_20416); /*string*/
  kk_function_call(kk_unit_t, (kk_function_t, kk_string_t, kk_context_t*), print0, (print0, _x22149, _ctx), _ctx);
  return kk_unit_box(_x22148);
}

kk_unit_t kk_std_core_print_redirect(kk_function_t print0, kk_context_t* _ctx) { /* (print : (msg : string) -> console ()) -> io () */ 
  kk_box_t _x22145;
  kk_std_core_types__maybe _x22146 = kk_std_core_types__new_Just(kk_function_box(kk_std_core_new_print_redirect_fun22147(print0, _ctx), _ctx), _ctx); /*maybe<111>*/
  _x22145 = kk_std_core_types__maybe_box(_x22146, _ctx); /*176*/
  kk_ref_set_borrow(kk_std_core_redirect,_x22145,kk_context()); return kk_Unit;
}
 
// lifted local: remove, .spec.18288
// specialized: std/core/.unroll17341-filter, on parameters pred18281, using:
// pred18281 = fn(x: 16065){
//   val b.17794 : bool
//         = pred(x);
//   match (b.17794) {
//     ((std/core/types/True() : bool ) as .pat0: bool)
//        -> std/core/types/False;
//     ((.skip std/core/types/False() : bool ) as .pat00: bool)
//        -> std/core/types/True;
//   };
// }

kk_std_core__list kk_std_core__trmc_lift18323_remove(kk_function_t pred, kk_std_core__list xs18280, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (pred : (a) -> bool, xs18280 : list<a>, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18280, _ctx)) {
    struct kk_std_core_Cons* _con22150 = kk_std_core__as_Cons(xs18280, _ctx);
    kk_box_t x18283 = _con22150->head;
    kk_std_core__list xx18284 = _con22150->tail;
    kk_reuse_t _ru_21091 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs18280, _ctx)) {
      _ru_21091 = (kk_datatype_ptr_reuse(xs18280, _ctx));
    }
    else {
      kk_box_dup(x18283, _ctx);
      kk_std_core__list_dup(xx18284, _ctx);
      kk_datatype_ptr_decref(xs18280, _ctx);
    }
    bool b_17794;
    kk_function_t _x22152 = kk_function_dup(pred, _ctx); /*(16065) -> bool*/
    kk_box_t _x22151 = kk_box_dup(x18283, _ctx); /*16065*/
    b_17794 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x22152, (_x22152, _x22151, _ctx), _ctx); /*bool*/
    if (b_17794) {
      kk_reuse_drop(_ru_21091,kk_context());
      kk_box_drop(x18283, _ctx);
      { // tailcall
        xs18280 = xx18284;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core__list _trmc_18419 = kk_datatype_null(); /*list<16065>*/;
      kk_std_core__list _trmc_18420 = kk_std_core__new_Cons(_ru_21091, 0, x18283, _trmc_18419, _ctx); /*list<16065>*/;
      kk_box_t* _b_20432_20427 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18420, _ctx)->tail)); /*field-addr<list<16065>>*/;
      { // tailcall
        kk_std_core_types__cctx _x22153 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18420, _ctx)),_b_20432_20427,true,kk_context()); /*ctx<0>*/
        xs18280 = xx18284;
        _acc = _x22153;
        goto kk__tailcall;
      }
    }
  }
  {
    kk_function_drop(pred, _ctx);
    kk_box_t _x22154 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22154, KK_OWNED, _ctx);
  }
}
 
// lifted local: remove, .spec.18288
// specialized: std/core/.unroll17341-filter, on parameters pred18281, using:
// pred18281 = fn(x: 16065){
//   val b.17794 : bool
//         = pred(x);
//   match (b.17794) {
//     ((std/core/types/True() : bool ) as .pat0: bool)
//        -> std/core/types/False;
//     ((.skip std/core/types/False() : bool ) as .pat00: bool)
//        -> std/core/types/True;
//   };
// }

kk_std_core__list kk_std_core__lift18323_remove(kk_function_t pred0, kk_std_core__list xs182800, kk_context_t* _ctx) { /* forall<a> (pred : (a) -> bool, xs18280 : list<a>) -> list<a> */ 
  kk_std_core_types__cctx _x22155 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_lift18323_remove(pred0, xs182800, _x22155, _ctx);
}
 
// Create a list of `n`  repeated elementes `x`

kk_std_core__list kk_std_core__trmc_replicate(kk_box_t x, kk_integer_t n, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a> (x : a, n : int, ctx<list<a>>) -> list<a> */ 
  kk__tailcall: ;
  bool _match_20717 = kk_integer_gt_borrow(n,(kk_integer_from_small(0)),kk_context()); /*bool*/;
  if (_match_20717) {
    kk_std_core__list _trmc_18421 = kk_datatype_null(); /*list<16103>*/;
    kk_std_core__list _trmc_18422;
    kk_box_t _x22156 = kk_box_dup(x, _ctx); /*16103*/
    _trmc_18422 = kk_std_core__new_Cons(kk_reuse_null, 0, _x22156, _trmc_18421, _ctx); /*list<16103>*/
    kk_box_t* _b_20448_20443 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18422, _ctx)->tail)); /*field-addr<list<16103>>*/;
    { // tailcall
      kk_integer_t _x22157 = kk_integer_add_small_const(n, -1, _ctx); /*int*/
      kk_std_core_types__cctx _x22158 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18422, _ctx)),_b_20448_20443,true,kk_context()); /*ctx<0>*/
      n = _x22157;
      _acc = _x22158;
      goto kk__tailcall;
    }
  }
  {
    kk_box_drop(x, _ctx);
    kk_integer_drop(n, _ctx);
    kk_box_t _x22159 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22159, KK_OWNED, _ctx);
  }
}
 
// Create a list of `n`  repeated elementes `x`

kk_std_core__list kk_std_core_replicate(kk_box_t x0, kk_integer_t n0, kk_context_t* _ctx) { /* forall<a> (x : a, n : int) -> list<a> */ 
  kk_std_core_types__cctx _x22160 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_replicate(x0, n0, _x22160, _ctx);
}
 
// Concatenate all strings in a list in reverse order

kk_string_t kk_std_core_reverse_join(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  kk_std_core__list xs0_17798;
  if (kk_std_core__is_Nil(xs, _ctx)) {
    xs0_17798 = kk_std_core__new_Nil(_ctx); /*list<string>*/
  }
  else {
    xs0_17798 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), xs, _ctx); /*list<string>*/
  }
  if (kk_std_core__is_Nil(xs0_17798, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_Cons* _con22162 = kk_std_core__as_Cons(xs0_17798, _ctx);
    kk_box_t _box_x20454 = _con22162->head;
    kk_std_core__list xx = _con22162->tail;
    kk_string_t x = kk_string_unbox(_box_x20454);
    if kk_likely(kk_datatype_ptr_is_unique(xs0_17798, _ctx)) {
      kk_datatype_ptr_free(xs0_17798, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs0_17798, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      return x;
    }
    {
      kk_string_t _x22163 = kk_string_empty(); /*string*/
      return kk_std_core__unroll17331_lift17316_joinsep(_x22163, xx, x, _ctx);
    }
  }
}

kk_string_t kk_std_core_show_tuple(kk_std_core_types__tuple2_ x, kk_function_t showfst, kk_function_t showsnd, kk_context_t* _ctx) { /* forall<a,b> (x : (a, b), showfst : (a) -> string, showsnd : (b) -> string) -> string */ 
  kk_string_t _x22165;
  kk_define_string_literal(, _s22166, 1, "(", _ctx)
  _x22165 = kk_string_dup(_s22166, _ctx); /*string*/
  kk_string_t _x22167;
  kk_string_t _x22168;
  kk_box_t _x22169;
  {
    kk_box_t _x = x.fst;
    kk_box_dup(_x, _ctx);
    _x22169 = _x; /*16462*/
  }
  _x22168 = kk_function_call(kk_string_t, (kk_function_t, kk_box_t, kk_context_t*), showfst, (showfst, _x22169, _ctx), _ctx); /*string*/
  kk_string_t _x22170;
  kk_string_t _x22171;
  kk_define_string_literal(, _s22172, 1, ",", _ctx)
  _x22171 = kk_string_dup(_s22172, _ctx); /*string*/
  kk_string_t _x22173;
  kk_string_t _x22174;
  kk_box_t _x22175;
  {
    kk_box_t _x0 = x.snd;
    kk_box_dup(_x0, _ctx);
    kk_std_core_types__tuple2__drop(x, _ctx);
    _x22175 = _x0; /*16463*/
  }
  _x22174 = kk_function_call(kk_string_t, (kk_function_t, kk_box_t, kk_context_t*), showsnd, (showsnd, _x22175, _ctx), _ctx); /*string*/
  kk_string_t _x22176;
  kk_define_string_literal(, _s22177, 1, ")", _ctx)
  _x22176 = kk_string_dup(_s22177, _ctx); /*string*/
  _x22173 = kk_std_core__lp__plus__plus__1_rp_(_x22174, _x22176, _ctx); /*string*/
  _x22170 = kk_std_core__lp__plus__plus__1_rp_(_x22171, _x22173, _ctx); /*string*/
  _x22167 = kk_std_core__lp__plus__plus__1_rp_(_x22168, _x22170, _ctx); /*string*/
  return kk_std_core__lp__plus__plus__1_rp_(_x22165, _x22167, _ctx);
}
 
// monadic lift

kk_std_core_types__tuple2_ kk_std_core__mlift18847_unroll17350_lift17324_span(kk_std_core__list acc, kk_function_t predicate, kk_box_t y, kk_std_core__list ys, kk_std_core__list yy, bool _y_18688, kk_context_t* _ctx) { /* forall<a,e> (acc : list<a>, predicate : (a) -> e bool, y : a, ys : list<a>, yy : list<a>, bool) -> e (list<a>, list<a>) */ 
  if (_y_18688) {
    kk_std_core__list_drop(ys, _ctx);
    kk_std_core__list _x22178 = kk_std_core__new_Cons(kk_reuse_null, 0, y, acc, _ctx); /*list<61>*/
    return kk_std_core__unroll17350_lift17324_span(predicate, yy, _x22178, _ctx);
  }
  {
    kk_std_core__list_drop(yy, _ctx);
    kk_box_drop(y, _ctx);
    kk_function_drop(predicate, _ctx);
    kk_std_core__list _b_20457_20455;
    if (kk_std_core__is_Nil(acc, _ctx)) {
      _b_20457_20455 = kk_std_core__new_Nil(_ctx); /*list<16562>*/
    }
    else {
      _b_20457_20455 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc, _ctx); /*list<16562>*/
    }
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_20457_20455, _ctx), kk_std_core__list_box(ys, _ctx), _ctx);
  }
}
 
// lifted local: span, span-acc
// todo: implement TRMC with multiple results to avoid the reverse


// lift anonymous function
struct kk_std_core__unroll17350_lift17324_span_fun22183__t {
  struct kk_function_s _base;
  kk_std_core__list acc0;
  kk_function_t predicate0;
  kk_box_t y0;
  kk_std_core__list ys0;
  kk_std_core__list yy0;
};
static kk_box_t kk_std_core__unroll17350_lift17324_span_fun22183(kk_function_t _fself, kk_box_t _b_20460, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_unroll17350_lift17324_span_fun22183(kk_std_core__list acc0, kk_function_t predicate0, kk_box_t y0, kk_std_core__list ys0, kk_std_core__list yy0, kk_context_t* _ctx) {
  struct kk_std_core__unroll17350_lift17324_span_fun22183__t* _self = kk_function_alloc_as(struct kk_std_core__unroll17350_lift17324_span_fun22183__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__unroll17350_lift17324_span_fun22183, kk_context());
  _self->acc0 = acc0;
  _self->predicate0 = predicate0;
  _self->y0 = y0;
  _self->ys0 = ys0;
  _self->yy0 = yy0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__unroll17350_lift17324_span_fun22183(kk_function_t _fself, kk_box_t _b_20460, kk_context_t* _ctx) {
  struct kk_std_core__unroll17350_lift17324_span_fun22183__t* _self = kk_function_as(struct kk_std_core__unroll17350_lift17324_span_fun22183__t*, _fself, _ctx);
  kk_std_core__list acc0 = _self->acc0; /* list<16562> */
  kk_function_t predicate0 = _self->predicate0; /* (16562) -> 16563 bool */
  kk_box_t y0 = _self->y0; /* 16562 */
  kk_std_core__list ys0 = _self->ys0; /* list<16562> */
  kk_std_core__list yy0 = _self->yy0; /* list<16562> */
  kk_drop_match(_self, {kk_std_core__list_dup(acc0, _ctx);kk_function_dup(predicate0, _ctx);kk_box_dup(y0, _ctx);kk_std_core__list_dup(ys0, _ctx);kk_std_core__list_dup(yy0, _ctx);}, {}, _ctx)
  bool _y_20470_186880 = kk_bool_unbox(_b_20460); /*bool*/;
  kk_std_core_types__tuple2_ _x22184 = kk_std_core__mlift18847_unroll17350_lift17324_span(acc0, predicate0, y0, ys0, yy0, _y_20470_186880, _ctx); /*(list<16562>, list<16562>)*/
  return kk_std_core_types__tuple2__box(_x22184, _ctx);
}

kk_std_core_types__tuple2_ kk_std_core__unroll17350_lift17324_span(kk_function_t predicate0, kk_std_core__list ys0, kk_std_core__list acc0, kk_context_t* _ctx) { /* forall<a,e> (predicate : (a) -> e bool, ys : list<a>, acc : list<a>) -> e (list<a>, list<a>) */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys0, _ctx)) {
    struct kk_std_core_Cons* _con22179 = kk_std_core__as_Cons(ys0, _ctx);
    kk_box_t y0 = _con22179->head;
    kk_std_core__list yy0 = _con22179->tail;
    kk_box_dup(y0, _ctx);
    kk_std_core__list_dup(yy0, _ctx);
    bool x_19133;
    kk_function_t _x22181 = kk_function_dup(predicate0, _ctx); /*(16562) -> 16563 bool*/
    kk_box_t _x22180 = kk_box_dup(y0, _ctx); /*16562*/
    x_19133 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x22181, (_x22181, _x22180, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_box_t _x22182 = kk_std_core_hnd_yield_extend(kk_std_core__new_unroll17350_lift17324_span_fun22183(acc0, predicate0, y0, ys0, yy0, _ctx), _ctx); /*3926*/
      return kk_std_core_types__tuple2__unbox(_x22182, KK_OWNED, _ctx);
    }
    if (x_19133) {
      kk_reuse_t _ru_21093 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys0, _ctx)) {
        kk_std_core__list_drop(yy0, _ctx);
        kk_box_drop(y0, _ctx);
        _ru_21093 = (kk_datatype_ptr_reuse(ys0, _ctx));
      }
      else {
        kk_datatype_ptr_decref(ys0, _ctx);
      }
      { // tailcall
        kk_std_core__list _x22185 = kk_std_core__new_Cons(_ru_21093, 0, y0, acc0, _ctx); /*list<61>*/
        ys0 = yy0;
        acc0 = _x22185;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core__list_drop(yy0, _ctx);
      kk_box_drop(y0, _ctx);
      kk_function_drop(predicate0, _ctx);
      kk_std_core__list _b_20466_20461;
      if (kk_std_core__is_Nil(acc0, _ctx)) {
        _b_20466_20461 = kk_std_core__new_Nil(_ctx); /*list<16562>*/
      }
      else {
        _b_20466_20461 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc0, _ctx); /*list<16562>*/
      }
      return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_20466_20461, _ctx), kk_std_core__list_box(ys0, _ctx), _ctx);
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    kk_std_core__list _b_20468_20463;
    if (kk_std_core__is_Nil(acc0, _ctx)) {
      _b_20468_20463 = kk_std_core__new_Nil(_ctx); /*list<16562>*/
    }
    else {
      _b_20468_20463 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc0, _ctx); /*list<16562>*/
    }
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_20468_20463, _ctx), kk_std_core__list_box(ys0, _ctx), _ctx);
  }
}

kk_std_core_types__tuple2_ kk_std_core_span(kk_std_core__list xs, kk_function_t predicate, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e (list<a>, list<a>) */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    kk_function_drop(predicate, _ctx);
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx), kk_std_core__list_box(xs, _ctx), _ctx);
  }
  {
    return kk_std_core__unroll17350_lift17324_span(predicate, xs, kk_std_core__new_Nil(_ctx), _ctx);
  }
}
 
// lifted local: sum, .spec.18297
// specialized: std/core/.unroll17344-foldl, on parameters f18292, using:
// f18292 = std/core/(+.4)

kk_integer_t kk_std_core__lift18324_sum(kk_std_core__list xs18290, kk_integer_t z18291, kk_context_t* _ctx) { /* (xs18290 : list<int>, z18291 : int) -> int */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs18290, _ctx)) {
    struct kk_std_core_Cons* _con22186 = kk_std_core__as_Cons(xs18290, _ctx);
    kk_box_t _box_x20479 = _con22186->head;
    kk_std_core__list xx18295 = _con22186->tail;
    kk_integer_t x18294 = kk_integer_unbox(_box_x20479, _ctx);
    if kk_likely(kk_datatype_ptr_is_unique(xs18290, _ctx)) {
      kk_datatype_ptr_free(xs18290, _ctx);
    }
    else {
      kk_integer_dup(x18294, _ctx);
      kk_std_core__list_dup(xx18295, _ctx);
      kk_datatype_ptr_decref(xs18290, _ctx);
    }
    { // tailcall
      kk_integer_t _x22187 = kk_integer_add(z18291,x18294,kk_context()); /*int*/
      xs18290 = xx18295;
      z18291 = _x22187;
      goto kk__tailcall;
    }
  }
  {
    return z18291;
  }
}
 
// Return the tail of list. Returns the empty list if `xs` is empty.

kk_std_core__list kk_std_core_tail_1(kk_std_core__list xs, kk_context_t* _ctx) { /* forall<a> (xs : list<a>) -> list<a> */ 
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22188 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _pat0 = _con22188->head;
    kk_std_core__list xx = _con22188->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_box_drop(_pat0, _ctx);
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    return xx;
  }
  {
    return kk_std_core__new_Nil(_ctx);
  }
}
 
// Return the tail of a string (or the empty string)

kk_string_t kk_std_core_tail_2(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> string */ 
  kk_std_core__sslice slice1 = kk_std_core_first1(s, _ctx); /*sslice*/;
  kk_std_core__sslice slice0_17824;
  bool _match_20707;
  kk_integer_t _brw_20712;
  kk_std_core_types__optional _match_20711 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_20711, _ctx)) {
    kk_box_t _box_x20480 = _match_20711._cons.Optional.value;
    kk_integer_t _n_10357 = kk_integer_unbox(_box_x20480, _ctx);
    kk_integer_dup(_n_10357, _ctx);
    kk_std_core_types__optional_drop(_match_20711, _ctx);
    _brw_20712 = _n_10357; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_20711, _ctx);
    _brw_20712 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_20713 = kk_integer_eq_borrow(_brw_20712,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_20712, _ctx);
  _match_20707 = _brw_20713; /*bool*/
  if (_match_20707) {
    slice0_17824 = slice1; /*sslice*/
  }
  else {
    kk_integer_t _brw_20709;
    kk_integer_t _x22189;
    kk_std_core_types__optional _match_20708 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_20708, _ctx)) {
      kk_box_t _box_x20481 = _match_20708._cons.Optional.value;
      kk_integer_t _n_103570 = kk_integer_unbox(_box_x20481, _ctx);
      kk_integer_dup(_n_103570, _ctx);
      kk_std_core_types__optional_drop(_match_20708, _ctx);
      _x22189 = _n_103570; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(_match_20708, _ctx);
      _x22189 = kk_integer_from_small(1); /*int*/
    }
    _brw_20709 = kk_integer_add_small_const(_x22189, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_20710 = kk_std_core_extend(slice1, _brw_20709, _ctx); /*sslice*/;
    kk_integer_drop(_brw_20709, _ctx);
    slice0_17824 = _brw_20710; /*sslice*/
  }
  kk_std_core__sslice _x22190;
  {
    kk_string_t s0 = slice0_17824.str;
    kk_integer_t start0 = slice0_17824.start;
    kk_integer_t len0 = slice0_17824.len;
    kk_integer_t x0_17831;
    kk_string_t _x22191 = kk_string_dup(s0, _ctx); /*string*/
    x0_17831 = kk_string_len_int(_x22191,kk_context()); /*int*/
    kk_integer_t y0_17832;
    kk_integer_t _x22192 = kk_integer_dup(start0, _ctx); /*int*/
    kk_integer_t _x22193 = kk_integer_dup(len0, _ctx); /*int*/
    y0_17832 = kk_integer_add(_x22192,_x22193,kk_context()); /*int*/
    kk_integer_t _x22194 = kk_integer_add(start0,len0,kk_context()); /*int*/
    kk_integer_t _x22195 = kk_integer_sub(x0_17831,y0_17832,kk_context()); /*int*/
    _x22190 = kk_std_core__new_Sslice(s0, _x22194, _x22195, _ctx); /*sslice*/
  }
  return kk_std_core_string_3(_x22190, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18848_trmc_unroll17351_take_while(kk_std_core_types__cctx _acc, kk_function_t predicate, kk_box_t x, kk_std_core__list xx, bool _y_18696, kk_context_t* _ctx) { /* forall<a,e> (ctx<list<a>>, predicate : (a) -> e bool, x : a, xx : list<a>, bool) -> e list<a> */ 
  if (_y_18696) {
    kk_std_core__list _trmc_18423 = kk_datatype_null(); /*list<16673>*/;
    kk_std_core__list _trmc_18424 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), x, _trmc_18423, _ctx); /*list<16673>*/;
    kk_box_t* _b_20492_20487 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18424, _ctx)->tail)); /*field-addr<list<16673>>*/;
    kk_std_core_types__cctx _x22196 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18424, _ctx)),_b_20492_20487,false,kk_context()); /*ctx<0>*/
    return kk_std_core__trmc_unroll17351_take_while(xx, predicate, _x22196, _ctx);
  }
  {
    kk_std_core__list_drop(xx, _ctx);
    kk_box_drop(x, _ctx);
    kk_function_drop(predicate, _ctx);
    kk_box_t _x22197 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22197, KK_OWNED, _ctx);
  }
}
 
// Keep only those initial elements that satisfy `predicate`


// lift anonymous function
struct kk_std_core__trmc_unroll17351_take_while_fun22202__t {
  struct kk_function_s _base;
  kk_function_t predicate0;
  kk_box_t x0;
  kk_std_core__list xx0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17351_take_while_fun22202(kk_function_t _fself, kk_box_t _b_20499, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17351_take_while_fun22202(kk_function_t predicate0, kk_box_t x0, kk_std_core__list xx0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17351_take_while_fun22202__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17351_take_while_fun22202__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17351_take_while_fun22202, kk_context());
  _self->predicate0 = predicate0;
  _self->x0 = x0;
  _self->xx0 = xx0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17351_take_while_fun22202(kk_function_t _fself, kk_box_t _b_20499, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17351_take_while_fun22202__t* _self = kk_function_as(struct kk_std_core__trmc_unroll17351_take_while_fun22202__t*, _fself, _ctx);
  kk_function_t predicate0 = _self->predicate0; /* (16673) -> 16674 bool */
  kk_box_t x0 = _self->x0; /* 16673 */
  kk_std_core__list xx0 = _self->xx0; /* list<16673> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<16673>> */
  kk_drop_match(_self, {kk_function_dup(predicate0, _ctx);kk_box_dup(x0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  bool _y_20521_186960 = kk_bool_unbox(_b_20499); /*bool*/;
  kk_std_core__list _x22203 = kk_std_core__mlift18848_trmc_unroll17351_take_while(_acc0, predicate0, x0, xx0, _y_20521_186960, _ctx); /*list<16673>*/
  return kk_std_core__list_box(_x22203, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17351_take_while(kk_std_core__list xs, kk_function_t predicate0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool, ctx<list<a>>) -> e list<a> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22198 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x0 = _con22198->head;
    kk_std_core__list xx0 = _con22198->tail;
    kk_reuse_t _ru_21096 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      _ru_21096 = (kk_datatype_ptr_reuse(xs, _ctx));
    }
    else {
      kk_box_dup(x0, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    bool x1_19138;
    kk_function_t _x22200 = kk_function_dup(predicate0, _ctx); /*(16673) -> 16674 bool*/
    kk_box_t _x22199 = kk_box_dup(x0, _ctx); /*16673*/
    x1_19138 = kk_function_call(bool, (kk_function_t, kk_box_t, kk_context_t*), _x22200, (_x22200, _x22199, _ctx), _ctx); /*bool*/
    if (kk_yielding(kk_context())) {
      kk_reuse_drop(_ru_21096,kk_context());
      kk_box_t _x22201 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17351_take_while_fun22202(predicate0, x0, xx0, _acc0, _ctx), _ctx); /*3926*/
      return kk_std_core__list_unbox(_x22201, KK_OWNED, _ctx);
    }
    if (x1_19138) {
      kk_std_core__list _trmc_184230 = kk_datatype_null(); /*list<16673>*/;
      kk_std_core__list _trmc_184240 = kk_std_core__new_Cons(_ru_21096, kk_field_index_of(struct kk_std_core_Cons, tail), x0, _trmc_184230, _ctx); /*list<16673>*/;
      kk_box_t* _b_20513_20505 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_184240, _ctx)->tail)); /*field-addr<list<16673>>*/;
      { // tailcall
        kk_std_core_types__cctx _x22204 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_184240, _ctx)),_b_20513_20505,false,kk_context()); /*ctx<0>*/
        xs = xx0;
        _acc0 = _x22204;
        goto kk__tailcall;
      }
    }
    {
      kk_reuse_drop(_ru_21096,kk_context());
      kk_std_core__list_drop(xx0, _ctx);
      kk_box_drop(x0, _ctx);
      kk_function_drop(predicate0, _ctx);
      kk_box_t _x22205 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
      return kk_std_core__list_unbox(_x22205, KK_OWNED, _ctx);
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    kk_box_t _x22206 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22206, KK_OWNED, _ctx);
  }
}
 
// Keep only those initial elements that satisfy `predicate`

kk_std_core__list kk_std_core__unroll17351_take_while(kk_std_core__list xs0, kk_function_t predicate1, kk_context_t* _ctx) { /* forall<a,e> (xs : list<a>, predicate : (a) -> e bool) -> e list<a> */ 
  kk_std_core_types__cctx _x22207 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17351_take_while(xs0, predicate1, _x22207, _ctx);
}
 
// Trace a message used for debug purposes.
// The behaviour is system dependent. On a browser and node it uses
// `console.log`  by default.
// Disabled if `notrace` is called.


// lift anonymous function
struct kk_std_core_trace_fun22211__t {
  struct kk_function_s _base;
  kk_string_t message0;
};
static kk_box_t kk_std_core_trace_fun22211(kk_function_t _fself, kk_box_t _b_20525, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_trace_fun22211(kk_string_t message0, kk_context_t* _ctx) {
  struct kk_std_core_trace_fun22211__t* _self = kk_function_alloc_as(struct kk_std_core_trace_fun22211__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_trace_fun22211, kk_context());
  _self->message0 = message0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_trace_fun22211(kk_function_t _fself, kk_box_t _b_20525, kk_context_t* _ctx) {
  struct kk_std_core_trace_fun22211__t* _self = kk_function_as(struct kk_std_core_trace_fun22211__t*, _fself, _ctx);
  kk_string_t message0 = _self->message0; /* string */
  kk_drop_match(_self, {kk_string_dup(message0, _ctx);}, {}, _ctx)
  kk_unit_t _x22212 = kk_Unit;
  bool _y_20527_18703 = kk_bool_unbox(_b_20525); /*bool*/;
  if (_y_20527_18703) {
    kk_std_core_xtrace(message0, _ctx);
  }
  else {
    kk_string_drop(message0, _ctx);
  }
  return kk_unit_box(_x22212);
}

kk_unit_t kk_std_core_trace(kk_string_t message0, kk_context_t* _ctx) { /* (message : string) -> () */ 
  bool x_19141;
  kk_box_t _x22208;
  kk_ref_t _x22209 = kk_ref_dup(kk_std_core_trace_enabled, _ctx); /*ref<global,bool>*/
  _x22208 = kk_ref_get(_x22209,kk_context()); /*190*/
  x_19141 = kk_bool_unbox(_x22208); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x22210 = kk_std_core_hnd_yield_extend(kk_std_core_new_trace_fun22211(message0, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x22210); return kk_Unit;
  }
  if (x_19141) {
    kk_std_core_xtrace(message0, _ctx); return kk_Unit;
  }
  {
    kk_string_drop(message0, _ctx);
    kk_Unit; return kk_Unit;
  }
}


// lift anonymous function
struct kk_std_core_trace_any_fun22216__t {
  struct kk_function_s _base;
  kk_string_t message0;
  kk_box_t x;
};
static kk_box_t kk_std_core_trace_any_fun22216(kk_function_t _fself, kk_box_t _b_20532, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_trace_any_fun22216(kk_string_t message0, kk_box_t x, kk_context_t* _ctx) {
  struct kk_std_core_trace_any_fun22216__t* _self = kk_function_alloc_as(struct kk_std_core_trace_any_fun22216__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_trace_any_fun22216, kk_context());
  _self->message0 = message0;
  _self->x = x;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_trace_any_fun22216(kk_function_t _fself, kk_box_t _b_20532, kk_context_t* _ctx) {
  struct kk_std_core_trace_any_fun22216__t* _self = kk_function_as(struct kk_std_core_trace_any_fun22216__t*, _fself, _ctx);
  kk_string_t message0 = _self->message0; /* string */
  kk_box_t x = _self->x; /* 16782 */
  kk_drop_match(_self, {kk_string_dup(message0, _ctx);kk_box_dup(x, _ctx);}, {}, _ctx)
  kk_unit_t _x22217 = kk_Unit;
  bool _y_20534_18705 = kk_bool_unbox(_b_20532); /*bool*/;
  if (_y_20534_18705) {
    kk_std_core_xtrace_any(message0, x, _ctx);
  }
  else {
    kk_box_drop(x, _ctx);
    kk_string_drop(message0, _ctx);
  }
  return kk_unit_box(_x22217);
}

kk_unit_t kk_std_core_trace_any(kk_string_t message0, kk_box_t x, kk_context_t* _ctx) { /* forall<a> (message : string, x : a) -> () */ 
  bool x0_19145;
  kk_box_t _x22213;
  kk_ref_t _x22214 = kk_ref_dup(kk_std_core_trace_enabled, _ctx); /*ref<global,bool>*/
  _x22213 = kk_ref_get(_x22214,kk_context()); /*190*/
  x0_19145 = kk_bool_unbox(_x22213); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x22215 = kk_std_core_hnd_yield_extend(kk_std_core_new_trace_any_fun22216(message0, x, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x22215); return kk_Unit;
  }
  if (x0_19145) {
    kk_std_core_xtrace_any(message0, x, _ctx); return kk_Unit;
  }
  {
    kk_box_drop(x, _ctx);
    kk_string_drop(message0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Truncate a string to `count` characters.

kk_string_t kk_std_core_truncate(kk_string_t s, kk_integer_t count, kk_context_t* _ctx) { /* (s : string, count : int) -> string */ 
  kk_std_core__sslice slice0 = kk_std_core_first1(s, _ctx); /*sslice*/;
  kk_std_core__sslice _x22218;
  kk_std_core__sslice _own_20695;
  bool _match_20696;
  kk_integer_t _brw_20701;
  kk_std_core_types__optional _match_20700 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
  if (kk_std_core_types__is_Optional(_match_20700, _ctx)) {
    kk_box_t _box_x20536 = _match_20700._cons.Optional.value;
    kk_integer_t _n_10357 = kk_integer_unbox(_box_x20536, _ctx);
    kk_integer_dup(_n_10357, _ctx);
    kk_std_core_types__optional_drop(_match_20700, _ctx);
    _brw_20701 = _n_10357; /*int*/
  }
  else {
    kk_std_core_types__optional_drop(_match_20700, _ctx);
    _brw_20701 = kk_integer_from_small(1); /*int*/
  }
  bool _brw_20702 = kk_integer_eq_borrow(_brw_20701,(kk_integer_from_small(1)),kk_context()); /*bool*/;
  kk_integer_drop(_brw_20701, _ctx);
  _match_20696 = _brw_20702; /*bool*/
  if (_match_20696) {
    _own_20695 = slice0; /*sslice*/
  }
  else {
    kk_integer_t _brw_20698;
    kk_integer_t _x22219;
    kk_std_core_types__optional _match_20697 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
    if (kk_std_core_types__is_Optional(_match_20697, _ctx)) {
      kk_box_t _box_x20537 = _match_20697._cons.Optional.value;
      kk_integer_t _n_103570 = kk_integer_unbox(_box_x20537, _ctx);
      kk_integer_dup(_n_103570, _ctx);
      kk_std_core_types__optional_drop(_match_20697, _ctx);
      _x22219 = _n_103570; /*int*/
    }
    else {
      kk_std_core_types__optional_drop(_match_20697, _ctx);
      _x22219 = kk_integer_from_small(1); /*int*/
    }
    _brw_20698 = kk_integer_add_small_const(_x22219, -1, _ctx); /*int*/
    kk_std_core__sslice _brw_20699 = kk_std_core_extend(slice0, _brw_20698, _ctx); /*sslice*/;
    kk_integer_drop(_brw_20698, _ctx);
    _own_20695 = _brw_20699; /*sslice*/
  }
  kk_integer_t _brw_20694 = kk_integer_add_small_const(count, -1, _ctx); /*int*/;
  kk_std_core__sslice _brw_20703 = kk_std_core_extend(_own_20695, _brw_20694, _ctx); /*sslice*/;
  kk_integer_drop(_brw_20694, _ctx);
  _x22218 = _brw_20703; /*sslice*/
  return kk_std_core_string_3(_x22218, _ctx);
}
 
// Return a default value when an exception is raised


// lift anonymous function
struct kk_std_core_try_default_fun22220__t {
  struct kk_function_s _base;
  kk_box_t value;
};
static kk_box_t kk_std_core_try_default_fun22220(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_default_fun22220(kk_box_t value, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun22220__t* _self = kk_function_alloc_as(struct kk_std_core_try_default_fun22220__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_default_fun22220, kk_context());
  _self->value = value;
  return kk_datatype_from_base(&_self->_base, kk_context());
}



// lift anonymous function
struct kk_std_core_try_default_fun22221__t {
  struct kk_function_s _base;
  kk_box_t value;
};
static kk_box_t kk_std_core_try_default_fun22221(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_default_fun22221(kk_box_t value, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun22221__t* _self = kk_function_alloc_as(struct kk_std_core_try_default_fun22221__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_default_fun22221, kk_context());
  _self->value = value;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_try_default_fun22221(kk_function_t _fself, kk_function_t ___wildcard__525__45, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun22221__t* _self = kk_function_as(struct kk_std_core_try_default_fun22221__t*, _fself, _ctx);
  kk_box_t value = _self->value; /* 16858 */
  kk_drop_match(_self, {kk_box_dup(value, _ctx);}, {}, _ctx)
  kk_function_drop(___wildcard__525__45, _ctx);
  return value;
}
static kk_box_t kk_std_core_try_default_fun22220(kk_function_t _fself, kk_std_core_hnd__marker m0, kk_std_core_hnd__ev ___wildcard__525__16, kk_std_core__exception x, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun22220__t* _self = kk_function_as(struct kk_std_core_try_default_fun22220__t*, _fself, _ctx);
  kk_box_t value = _self->value; /* 16858 */
  kk_drop_match(_self, {kk_box_dup(value, _ctx);}, {}, _ctx)
  kk_datatype_ptr_dropn(___wildcard__525__16, (KK_I32(3)), _ctx);
  kk_std_core__exception_drop(x, _ctx);
  return kk_std_core_hnd_yield_to_final(m0, kk_std_core_new_try_default_fun22221(value, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_default_fun22224__t {
  struct kk_function_s _base;
  kk_function_t _b_20542_20538;
};
static kk_box_t kk_std_core_try_default_fun22224(kk_function_t _fself, kk_std_core_hnd__marker _b_20539, kk_std_core_hnd__ev _b_20540, kk_box_t _b_20541, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_default_fun22224(kk_function_t _b_20542_20538, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun22224__t* _self = kk_function_alloc_as(struct kk_std_core_try_default_fun22224__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_try_default_fun22224, kk_context());
  _self->_b_20542_20538 = _b_20542_20538;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_try_default_fun22224(kk_function_t _fself, kk_std_core_hnd__marker _b_20539, kk_std_core_hnd__ev _b_20540, kk_box_t _b_20541, kk_context_t* _ctx) {
  struct kk_std_core_try_default_fun22224__t* _self = kk_function_as(struct kk_std_core_try_default_fun22224__t*, _fself, _ctx);
  kk_function_t _b_20542_20538 = _self->_b_20542_20538; /* (m0 : std/core/hnd/marker<16859,16858>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 16859 10520 */
  kk_drop_match(_self, {kk_function_dup(_b_20542_20538, _ctx);}, {}, _ctx)
  kk_std_core__exception _x22225 = kk_std_core__exception_unbox(_b_20541, KK_OWNED, _ctx); /*exception*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_std_core__exception, kk_context_t*), _b_20542_20538, (_b_20542_20538, _b_20539, _b_20540, _x22225, _ctx), _ctx);
}


// lift anonymous function
struct kk_std_core_try_default_fun22226__t {
  struct kk_function_s _base;
};
static kk_box_t kk_std_core_try_default_fun22226(kk_function_t _fself, kk_box_t _x, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_try_default_fun22226(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_try_default_fun22226, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_box_t kk_std_core_try_default_fun22226(kk_function_t _fself, kk_box_t _x, kk_context_t* _ctx) {
  kk_unused(_fself);
  return _x;
}

kk_box_t kk_std_core_try_default(kk_box_t value, kk_function_t action, kk_context_t* _ctx) { /* forall<a,e> (value : a, action : () -> <exn|e> a) -> e a */ 
  kk_function_t _b_20542_20538 = kk_std_core_new_try_default_fun22220(value, _ctx); /*(m0 : std/core/hnd/marker<16859,16858>, std/core/hnd/ev<.hnd-exn>, x : exception) -> 16859 10520*/;
  kk_std_core__hnd_exn _x22222;
  kk_std_core_hnd__clause1 _x22223 = kk_std_core_hnd__new_Clause1(kk_std_core_new_try_default_fun22224(_b_20542_20538, _ctx), _ctx); /*std/core/hnd/clause1<51,52,53,54,55>*/
  _x22222 = kk_std_core__new_Hnd_exn(kk_reuse_null, 0, _x22223, _ctx); /*.hnd-exn<11,12>*/
  return kk_std_core__handle_exn((KK_I32(0)), _x22222, kk_std_core_new_try_default_fun22226(_ctx), action, _ctx);
}
 
// Returns a unique integer (modulo 32-bits).


// lift anonymous function
struct kk_std_core_unique_fun22230__t {
  struct kk_function_s _base;
};
static kk_integer_t kk_std_core_unique_fun22230(kk_function_t _fself, kk_integer_t u, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_unique_fun22230(kk_context_t* _ctx) {
  kk_define_static_function(_fself, kk_std_core_unique_fun22230, _ctx)
  return kk_function_dup(_fself,kk_context());
}

static kk_integer_t kk_std_core_unique_fun22230(kk_function_t _fself, kk_integer_t u, kk_context_t* _ctx) {
  kk_unused(_fself);
  kk_integer_t _b_20552_20550;
  kk_integer_t _x22231 = kk_integer_dup(u, _ctx); /*int*/
  _b_20552_20550 = kk_integer_add_small_const(_x22231, 1, _ctx); /*int*/
  kk_unit_t __ = kk_Unit;
  kk_ref_set_borrow(kk_std_core_unique_count,(kk_integer_box(_b_20552_20550, _ctx)),kk_context());
  return u;
}


// lift anonymous function
struct kk_std_core_unique_fun22233__t {
  struct kk_function_s _base;
  kk_function_t next0_19152;
};
static kk_box_t kk_std_core_unique_fun22233(kk_function_t _fself, kk_box_t _b_20554, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_unique_fun22233(kk_function_t next0_19152, kk_context_t* _ctx) {
  struct kk_std_core_unique_fun22233__t* _self = kk_function_alloc_as(struct kk_std_core_unique_fun22233__t, 2, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_unique_fun22233, kk_context());
  _self->next0_19152 = next0_19152;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_unique_fun22233(kk_function_t _fself, kk_box_t _b_20554, kk_context_t* _ctx) {
  struct kk_std_core_unique_fun22233__t* _self = kk_function_as(struct kk_std_core_unique_fun22233__t*, _fself, _ctx);
  kk_function_t next0_19152 = _self->next0_19152; /* (int) -> <read<global>,write<global>|_16919> int */
  kk_drop_match(_self, {kk_function_dup(next0_19152, _ctx);}, {}, _ctx)
  kk_integer_t _x22234;
  kk_integer_t _x22235 = kk_integer_unbox(_b_20554, _ctx); /*int*/
  _x22234 = kk_function_call(kk_integer_t, (kk_function_t, kk_integer_t, kk_context_t*), next0_19152, (next0_19152, _x22235, _ctx), _ctx); /*int*/
  return kk_integer_box(_x22234, _ctx);
}

kk_integer_t kk_std_core_unique(kk_context_t* _ctx) { /* () -> ndet int */ 
  kk_integer_t x_19151;
  kk_box_t _x22228;
  kk_ref_t _x22229 = kk_ref_dup(kk_std_core_unique_count, _ctx); /*ref<global,int>*/
  _x22228 = kk_ref_get(_x22229,kk_context()); /*190*/
  x_19151 = kk_integer_unbox(_x22228, _ctx); /*int*/
  kk_function_t next0_19152 = kk_std_core_new_unique_fun22230(_ctx); /*(int) -> <read<global>,write<global>|_16919> int*/;
  if (kk_yielding(kk_context())) {
    kk_integer_drop(x_19151, _ctx);
    kk_box_t _x22232 = kk_std_core_hnd_yield_extend(kk_std_core_new_unique_fun22233(next0_19152, _ctx), _ctx); /*3926*/
    return kk_integer_unbox(_x22232, _ctx);
  }
  {
    return kk_function_call(kk_integer_t, (kk_function_t, kk_integer_t, kk_context_t*), next0_19152, (next0_19152, x_19151, _ctx), _ctx);
  }
}
 
// Get the value of the `Just` constructor or raise an exception

kk_box_t kk_std_core_unjust(kk_std_core_types__maybe m, kk_context_t* _ctx) { /* forall<a> (m : maybe<a>) -> exn a */ 
  if (kk_std_core_types__is_Just(m, _ctx)) {
    kk_box_t x = m._cons.Just.value;
    return x;
  }
  {
    kk_std_core_hnd__ev ev_19154;
    kk_ssize_t _x22236 = (KK_IZ(0)); /*ssize_t*/
    ev_19154 = kk_evv_at(_x22236,kk_context()); /*std/core/hnd/ev<.hnd-exn>*/
    {
      struct kk_std_core_hnd_Ev* _con22237 = kk_std_core_hnd__as_Ev(ev_19154, _ctx);
      kk_box_t _box_x20556 = _con22237->hnd;
      kk_std_core_hnd__marker m0 = _con22237->marker;
      kk_std_core__hnd_exn h = kk_std_core__hnd_exn_unbox(_box_x20556, KK_BORROWED, _ctx);
      kk_std_core__hnd_exn_dup(h, _ctx);
      {
        struct kk_std_core__Hnd_exn* _con22238 = kk_std_core__as_Hnd_exn(h, _ctx);
        kk_std_core_hnd__clause1 ctl_throw_exn = _con22238->ctl_throw_exn;
        if kk_likely(kk_datatype_ptr_is_unique(h, _ctx)) {
          kk_datatype_ptr_free(h, _ctx);
        }
        else {
          kk_std_core_hnd__clause1_dup(ctl_throw_exn, _ctx);
          kk_datatype_ptr_decref(h, _ctx);
        }
        {
          kk_function_t _fun_unbox_x20560 = ctl_throw_exn.clause;
          kk_box_t _x22239;
          kk_std_core__exception _x22240;
          kk_string_t _x22241;
          kk_define_string_literal(, _s22242, 37, "unexpected Nothing in std/core/unjust", _ctx)
          _x22241 = kk_string_dup(_s22242, _ctx); /*string*/
          kk_std_core__exception_info _x22243;
          kk_std_core_types__optional _match_20692 = kk_std_core_types__new_None(_ctx); /*forall<a> optional<a>*/;
          if (kk_std_core_types__is_Optional(_match_20692, _ctx)) {
            kk_box_t _box_x20564 = _match_20692._cons.Optional.value;
            kk_std_core__exception_info _info_11917 = kk_std_core__exception_info_unbox(_box_x20564, KK_BORROWED, _ctx);
            kk_std_core__exception_info_dup(_info_11917, _ctx);
            kk_std_core_types__optional_drop(_match_20692, _ctx);
            _x22243 = _info_11917; /*exception-info*/
          }
          else {
            kk_std_core_types__optional_drop(_match_20692, _ctx);
            _x22243 = kk_std_core__new_ExnError(_ctx); /*exception-info*/
          }
          _x22240 = kk_std_core__new_Exception(_x22241, _x22243, _ctx); /*exception*/
          _x22239 = kk_std_core__exception_box(_x22240, _ctx); /*51*/
          return kk_function_call(kk_box_t, (kk_function_t, kk_std_core_hnd__marker, kk_std_core_hnd__ev, kk_box_t, kk_context_t*), _fun_unbox_x20560, (_fun_unbox_x20560, m0, ev_19154, _x22239, _ctx), _ctx);
        }
      }
    }
  }
}
 
// Join a list of strings with newlines

kk_string_t kk_std_core_unlines(kk_std_core__list xs, kk_context_t* _ctx) { /* (xs : list<string>) -> string */ 
  if (kk_std_core__is_Nil(xs, _ctx)) {
    return kk_string_empty();
  }
  {
    struct kk_std_core_Cons* _con22245 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t _box_x20565 = _con22245->head;
    kk_std_core__list xx = _con22245->tail;
    kk_string_t x = kk_string_unbox(_box_x20565);
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_string_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Nil(xx, _ctx)) {
      return x;
    }
    {
      kk_string_t _x22246;
      kk_define_string_literal(, _s22247, 1, "\n", _ctx)
      _x22246 = kk_string_dup(_s22247, _ctx); /*string*/
      return kk_std_core__unroll17331_lift17316_joinsep(_x22246, xx, x, _ctx);
    }
  }
}
 
// lifted local: unzip, iter
// todo: implement TRMC for multiple results

kk_std_core_types__tuple2_ kk_std_core__unroll17352_lift17325_unzip(kk_std_core__list ys, kk_std_core__list acc1, kk_std_core__list acc2, kk_context_t* _ctx) { /* forall<a,b> (ys : list<(a, b)>, acc1 : list<a>, acc2 : list<b>) -> (list<a>, list<b>) */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(ys, _ctx)) {
    struct kk_std_core_Cons* _con22248 = kk_std_core__as_Cons(ys, _ctx);
    kk_box_t _box_x20566 = _con22248->head;
    kk_std_core_types__tuple2_ _pat0 = kk_std_core_types__tuple2__unbox(_box_x20566, KK_BORROWED, _ctx);
    kk_std_core__list xx = _con22248->tail;
    kk_box_t x = _pat0.fst;
    kk_box_t y = _pat0.snd;
    kk_reuse_t _ru_21099 = kk_reuse_null; /*reuse*/;
    if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
      kk_box_dup(x, _ctx);
      kk_box_dup(y, _ctx);
      kk_box_drop(_box_x20566, _ctx);
      _ru_21099 = (kk_datatype_ptr_reuse(ys, _ctx));
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_box_dup(y, _ctx);
      kk_datatype_ptr_decref(ys, _ctx);
    }
    { // tailcall
      kk_std_core__list _x22249 = kk_std_core__new_Cons(_ru_21099, 0, x, acc1, _ctx); /*list<61>*/
      kk_std_core__list _x22250 = kk_std_core__new_Cons(kk_reuse_null, 0, y, acc2, _ctx); /*list<61>*/
      ys = xx;
      acc1 = _x22249;
      acc2 = _x22250;
      goto kk__tailcall;
    }
  }
  {
    kk_std_core__list _b_20569_20567;
    if (kk_std_core__is_Nil(acc1, _ctx)) {
      _b_20569_20567 = kk_std_core__new_Nil(_ctx); /*list<16974>*/
    }
    else {
      _b_20569_20567 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc1, _ctx); /*list<16974>*/
    }
    kk_std_core__list _b_20570_20568;
    if (kk_std_core__is_Nil(acc2, _ctx)) {
      _b_20570_20568 = kk_std_core__new_Nil(_ctx); /*list<16975>*/
    }
    else {
      _b_20570_20568 = kk_std_core__unroll17327_lift17313_reverse_append(kk_std_core__new_Nil(_ctx), acc2, _ctx); /*list<16975>*/
    }
    return kk_std_core_types__new_dash__lp__comma__rp_(kk_std_core__list_box(_b_20569_20567, _ctx), kk_std_core__list_box(_b_20570_20568, _ctx), _ctx);
  }
}
 
// Convert a string to a vector of characters.

kk_vector_t kk_std_core_vector_1(kk_string_t s, kk_context_t* _ctx) { /* (s : string) -> vector<char> */ 
  return kk_string_to_chars(s,kk_context());
}
extern kk_box_t kk_std_core_vector_fun22253_2(kk_function_t _fself, kk_ssize_t ___wildcard__1859__30, kk_context_t* _ctx) {
  struct kk_std_core_vector_fun22253__t_2* _self = kk_function_as(struct kk_std_core_vector_fun22253__t_2*, _fself, _ctx);
  kk_box_t default0 = _self->default0; /* 17051 */
  kk_drop_match(_self, {kk_box_dup(default0, _ctx);}, {}, _ctx)
  return default0;
}
extern kk_box_t kk_std_core_vector_init_fun22256(kk_function_t _fself, kk_ssize_t i, kk_context_t* _ctx) {
  struct kk_std_core_vector_init_fun22256__t* _self = kk_function_as(struct kk_std_core_vector_init_fun22256__t*, _fself, _ctx);
  kk_function_t f = _self->f; /* (int) -> 17121 */
  kk_drop_match(_self, {kk_function_dup(f, _ctx);}, {}, _ctx)
  kk_integer_t _x22257 = kk_integer_from_ssize_t(i,kk_context()); /*int*/
  return kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_context_t*), f, (f, _x22257, _ctx), _ctx);
}
 
// monadic lift

kk_unit_t kk_std_core__mlift18852_while(kk_function_t action, kk_function_t predicate, kk_unit_t wild__, kk_context_t* _ctx) { /* forall<e> (action : () -> <div|e> (), predicate : () -> <div|e> bool, wild_ : ()) -> <div|e> () */ 
  kk_std_core_while(predicate, action, _ctx); return kk_Unit;
}
 
// monadic lift


// lift anonymous function
struct kk_std_core__mlift18853_while_fun22260__t {
  struct kk_function_s _base;
  kk_function_t action0;
  kk_function_t predicate0;
};
static kk_box_t kk_std_core__mlift18853_while_fun22260(kk_function_t _fself, kk_box_t _b_20580, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_mlift18853_while_fun22260(kk_function_t action0, kk_function_t predicate0, kk_context_t* _ctx) {
  struct kk_std_core__mlift18853_while_fun22260__t* _self = kk_function_alloc_as(struct kk_std_core__mlift18853_while_fun22260__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__mlift18853_while_fun22260, kk_context());
  _self->action0 = action0;
  _self->predicate0 = predicate0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__mlift18853_while_fun22260(kk_function_t _fself, kk_box_t _b_20580, kk_context_t* _ctx) {
  struct kk_std_core__mlift18853_while_fun22260__t* _self = kk_function_as(struct kk_std_core__mlift18853_while_fun22260__t*, _fself, _ctx);
  kk_function_t action0 = _self->action0; /* () -> <div|17142> () */
  kk_function_t predicate0 = _self->predicate0; /* () -> <div|17142> bool */
  kk_drop_match(_self, {kk_function_dup(action0, _ctx);kk_function_dup(predicate0, _ctx);}, {}, _ctx)
  kk_unit_t wild__0_20582 = kk_Unit;
  kk_unit_unbox(_b_20580);
  kk_unit_t _x22261 = kk_Unit;
  kk_std_core__mlift18852_while(action0, predicate0, wild__0_20582, _ctx);
  return kk_unit_box(_x22261);
}

kk_unit_t kk_std_core__mlift18853_while(kk_function_t action0, kk_function_t predicate0, bool _y_18711, kk_context_t* _ctx) { /* forall<e> (action : () -> <div|e> (), predicate : () -> <div|e> bool, bool) -> <div|e> () */ 
  if (_y_18711) {
    kk_unit_t x_19157 = kk_Unit;
    kk_function_t _x22258 = kk_function_dup(action0, _ctx); /*() -> <div|17142> ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), _x22258, (_x22258, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x22259 = kk_std_core_hnd_yield_extend(kk_std_core__new_mlift18853_while_fun22260(action0, predicate0, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x22259); return kk_Unit;
    }
    {
      kk_std_core__mlift18852_while(action0, predicate0, x_19157, _ctx); return kk_Unit;
    }
  }
  {
    kk_function_drop(predicate0, _ctx);
    kk_function_drop(action0, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// The `while` fun executes `action`  as long as `pred`  is `true`.


// lift anonymous function
struct kk_std_core_while_fun22264__t {
  struct kk_function_s _base;
  kk_function_t action1;
  kk_function_t predicate1;
};
static kk_box_t kk_std_core_while_fun22264(kk_function_t _fself, kk_box_t _b_20584, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_while_fun22264(kk_function_t action1, kk_function_t predicate1, kk_context_t* _ctx) {
  struct kk_std_core_while_fun22264__t* _self = kk_function_alloc_as(struct kk_std_core_while_fun22264__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_while_fun22264, kk_context());
  _self->action1 = action1;
  _self->predicate1 = predicate1;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_while_fun22264(kk_function_t _fself, kk_box_t _b_20584, kk_context_t* _ctx) {
  struct kk_std_core_while_fun22264__t* _self = kk_function_as(struct kk_std_core_while_fun22264__t*, _fself, _ctx);
  kk_function_t action1 = _self->action1; /* () -> <div|17142> () */
  kk_function_t predicate1 = _self->predicate1; /* () -> <div|17142> bool */
  kk_drop_match(_self, {kk_function_dup(action1, _ctx);kk_function_dup(predicate1, _ctx);}, {}, _ctx)
  bool _y_20589_187110 = kk_bool_unbox(_b_20584); /*bool*/;
  kk_unit_t _x22265 = kk_Unit;
  kk_std_core__mlift18853_while(action1, predicate1, _y_20589_187110, _ctx);
  return kk_unit_box(_x22265);
}


// lift anonymous function
struct kk_std_core_while_fun22268__t {
  struct kk_function_s _base;
  kk_function_t action1;
  kk_function_t predicate1;
};
static kk_box_t kk_std_core_while_fun22268(kk_function_t _fself, kk_box_t _b_20586, kk_context_t* _ctx);
static kk_function_t kk_std_core_new_while_fun22268(kk_function_t action1, kk_function_t predicate1, kk_context_t* _ctx) {
  struct kk_std_core_while_fun22268__t* _self = kk_function_alloc_as(struct kk_std_core_while_fun22268__t, 3, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core_while_fun22268, kk_context());
  _self->action1 = action1;
  _self->predicate1 = predicate1;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core_while_fun22268(kk_function_t _fself, kk_box_t _b_20586, kk_context_t* _ctx) {
  struct kk_std_core_while_fun22268__t* _self = kk_function_as(struct kk_std_core_while_fun22268__t*, _fself, _ctx);
  kk_function_t action1 = _self->action1; /* () -> <div|17142> () */
  kk_function_t predicate1 = _self->predicate1; /* () -> <div|17142> bool */
  kk_drop_match(_self, {kk_function_dup(action1, _ctx);kk_function_dup(predicate1, _ctx);}, {}, _ctx)
  kk_unit_t wild__1_20590 = kk_Unit;
  kk_unit_unbox(_b_20586);
  kk_unit_t _x22269 = kk_Unit;
  kk_std_core__mlift18852_while(action1, predicate1, wild__1_20590, _ctx);
  return kk_unit_box(_x22269);
}

kk_unit_t kk_std_core_while(kk_function_t predicate1, kk_function_t action1, kk_context_t* _ctx) { /* forall<e> (predicate : () -> <div|e> bool, action : () -> <div|e> ()) -> <div|e> () */ 
  kk__tailcall: ;
  bool x0_19159;
  kk_function_t _x22262 = kk_function_dup(predicate1, _ctx); /*() -> <div|17142> bool*/
  x0_19159 = kk_function_call(bool, (kk_function_t, kk_context_t*), _x22262, (_x22262, _ctx), _ctx); /*bool*/
  if (kk_yielding(kk_context())) {
    kk_box_t _x22263 = kk_std_core_hnd_yield_extend(kk_std_core_new_while_fun22264(action1, predicate1, _ctx), _ctx); /*3926*/
    kk_unit_unbox(_x22263); return kk_Unit;
  }
  if (x0_19159) {
    kk_unit_t x1_19162 = kk_Unit;
    kk_function_t _x22266 = kk_function_dup(action1, _ctx); /*() -> <div|17142> ()*/
    kk_function_call(kk_unit_t, (kk_function_t, kk_context_t*), _x22266, (_x22266, _ctx), _ctx);
    if (kk_yielding(kk_context())) {
      kk_box_t _x22267 = kk_std_core_hnd_yield_extend(kk_std_core_new_while_fun22268(action1, predicate1, _ctx), _ctx); /*3926*/
      kk_unit_unbox(_x22267); return kk_Unit;
    }
    { // tailcall
      goto kk__tailcall;
    }
  }
  {
    kk_function_drop(predicate1, _ctx);
    kk_function_drop(action1, _ctx);
    kk_Unit; return kk_Unit;
  }
}
 
// Zip two lists together by pairing the corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core__list kk_std_core__trmc_unroll17353_zip(kk_std_core__list xs, kk_std_core__list ys, kk_std_core_types__cctx _acc, kk_context_t* _ctx) { /* forall<a,b> (xs : list<a>, ys : list<b>, ctx<list<(a, b)>>) -> list<(a, b)> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22270 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con22270->head;
    kk_std_core__list xx = _con22270->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Cons(ys, _ctx)) {
      struct kk_std_core_Cons* _con22271 = kk_std_core__as_Cons(ys, _ctx);
      kk_box_t y = _con22271->head;
      kk_std_core__list yy = _con22271->tail;
      kk_reuse_t _ru_21101 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_21101 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core__list_dup(yy, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_std_core__list _trmc_18425 = kk_datatype_null(); /*list<(17185, 17186)>*/;
      kk_std_core__list _trmc_18426;
      kk_box_t _x22272;
      kk_std_core_types__tuple2_ _x22273 = kk_std_core_types__new_dash__lp__comma__rp_(x, y, _ctx); /*(6, 7)*/
      _x22272 = kk_std_core_types__tuple2__box(_x22273, _ctx); /*61*/
      _trmc_18426 = kk_std_core__new_Cons(_ru_21101, 0, _x22272, _trmc_18425, _ctx); /*list<(17185, 17186)>*/
      kk_box_t* _b_20607_20600 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18426, _ctx)->tail)); /*field-addr<list<(17185, 17186)>>*/;
      { // tailcall
        kk_std_core_types__cctx _x22274 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18426, _ctx)),_b_20607_20600,true,kk_context()); /*ctx<0>*/
        xs = xx;
        ys = yy;
        _acc = _x22274;
        goto kk__tailcall;
      }
    }
    {
      kk_std_core__list_drop(xx, _ctx);
      kk_box_drop(x, _ctx);
      kk_box_t _x22275 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
      return kk_std_core__list_unbox(_x22275, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core__list_drop(ys, _ctx);
    kk_box_t _x22276 = kk_cctx_apply(_acc,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),true,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22276, KK_OWNED, _ctx);
  }
}
 
// Zip two lists together by pairing the corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core__list kk_std_core__unroll17353_zip(kk_std_core__list xs0, kk_std_core__list ys0, kk_context_t* _ctx) { /* forall<a,b> (xs : list<a>, ys : list<b>) -> list<(a, b)> */ 
  kk_std_core_types__cctx _x22277 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17353_zip(xs0, ys0, _x22277, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18854_trmc_unroll17354_zipwith(kk_std_core_types__cctx _acc, kk_function_t f, kk_std_core__list xx, kk_std_core__list yy, kk_box_t _trmc_18427, kk_context_t* _ctx) { /* forall<a,b,c,e> (ctx<list<c>>, f : (a, b) -> e c, xx : list<a>, yy : list<b>, c) -> e list<c> */ 
  kk_std_core__list _trmc_18428 = kk_datatype_null(); /*list<17233>*/;
  kk_std_core__list _trmc_18429 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_18427, _trmc_18428, _ctx); /*list<17233>*/;
  kk_box_t* _b_20623_20620 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18429, _ctx)->tail)); /*field-addr<list<17233>>*/;
  kk_std_core_types__cctx _x22278 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18429, _ctx)),_b_20623_20620,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17354_zipwith(xx, yy, f, _x22278, _ctx);
}
 
// Zip two lists together by apply a function `f` to all corresponding elements.
// The returned list is only as long as the smallest input list.


// lift anonymous function
struct kk_std_core__trmc_unroll17354_zipwith_fun22283__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_std_core__list xx0;
  kk_std_core__list yy0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17354_zipwith_fun22283(kk_function_t _fself, kk_box_t _b_20628, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17354_zipwith_fun22283(kk_function_t f0, kk_std_core__list xx0, kk_std_core__list yy0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17354_zipwith_fun22283__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17354_zipwith_fun22283__t, 5, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17354_zipwith_fun22283, kk_context());
  _self->f0 = f0;
  _self->xx0 = xx0;
  _self->yy0 = yy0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17354_zipwith_fun22283(kk_function_t _fself, kk_box_t _b_20628, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17354_zipwith_fun22283__t* _self = kk_function_as(struct kk_std_core__trmc_unroll17354_zipwith_fun22283__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (17231, 17232) -> 17234 17233 */
  kk_std_core__list xx0 = _self->xx0; /* list<17231> */
  kk_std_core__list yy0 = _self->yy0; /* list<17232> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<17233>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core__list_dup(yy0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_20650_184270 = _b_20628; /*17233*/;
  kk_std_core__list _x22284 = kk_std_core__mlift18854_trmc_unroll17354_zipwith(_acc0, f0, xx0, yy0, _trmc_20650_184270, _ctx); /*list<17233>*/
  return kk_std_core__list_box(_x22284, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17354_zipwith(kk_std_core__list xs, kk_std_core__list ys, kk_function_t f0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,c,e> (xs : list<a>, ys : list<b>, f : (a, b) -> e c, ctx<list<c>>) -> e list<c> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22279 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con22279->head;
    kk_std_core__list xx0 = _con22279->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Cons(ys, _ctx)) {
      struct kk_std_core_Cons* _con22280 = kk_std_core__as_Cons(ys, _ctx);
      kk_box_t y = _con22280->head;
      kk_std_core__list yy0 = _con22280->tail;
      kk_reuse_t _ru_21103 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_21103 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core__list_dup(yy0, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_box_t x0_19165;
      kk_function_t _x22281 = kk_function_dup(f0, _ctx); /*(17231, 17232) -> 17234 17233*/
      x0_19165 = kk_function_call(kk_box_t, (kk_function_t, kk_box_t, kk_box_t, kk_context_t*), _x22281, (_x22281, x, y, _ctx), _ctx); /*17233*/
      if (kk_yielding(kk_context())) {
        kk_reuse_drop(_ru_21103,kk_context());
        kk_box_drop(x0_19165, _ctx);
        kk_box_t _x22282 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17354_zipwith_fun22283(f0, xx0, yy0, _acc0, _ctx), _ctx); /*3926*/
        return kk_std_core__list_unbox(_x22282, KK_OWNED, _ctx);
      }
      {
        kk_std_core__list _trmc_184280 = kk_datatype_null(); /*list<17233>*/;
        kk_std_core__list _trmc_184290 = kk_std_core__new_Cons(_ru_21103, kk_field_index_of(struct kk_std_core_Cons, tail), x0_19165, _trmc_184280, _ctx); /*list<17233>*/;
        kk_box_t* _b_20642_20634 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_184290, _ctx)->tail)); /*field-addr<list<17233>>*/;
        { // tailcall
          kk_std_core_types__cctx _x22285 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_184290, _ctx)),_b_20642_20634,false,kk_context()); /*ctx<0>*/
          xs = xx0;
          ys = yy0;
          _acc0 = _x22285;
          goto kk__tailcall;
        }
      }
    }
    {
      kk_std_core__list_drop(xx0, _ctx);
      kk_box_drop(x, _ctx);
      kk_function_drop(f0, _ctx);
      kk_box_t _x22286 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
      return kk_std_core__list_unbox(_x22286, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core__list_drop(ys, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x22287 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22287, KK_OWNED, _ctx);
  }
}
 
// Zip two lists together by apply a function `f` to all corresponding elements.
// The returned list is only as long as the smallest input list.

kk_std_core__list kk_std_core__unroll17354_zipwith(kk_std_core__list xs0, kk_std_core__list ys0, kk_function_t f1, kk_context_t* _ctx) { /* forall<a,b,c,e> (xs : list<a>, ys : list<b>, f : (a, b) -> e c) -> e list<c> */ 
  kk_std_core_types__cctx _x22288 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17354_zipwith(xs0, ys0, f1, _x22288, _ctx);
}
 
// monadic lift

kk_std_core__list kk_std_core__mlift18855_trmc_unroll17355_lift17326_zipwith_indexed(kk_std_core_types__cctx _acc, kk_function_t f, kk_integer_t i0_17863, kk_std_core__list xx, kk_std_core__list yy, kk_box_t _trmc_18430, kk_context_t* _ctx) { /* forall<a,b,c,e> (ctx<list<c>>, f : (int, a, b) -> e c, i0.17863 : int, xx : list<a>, yy : list<b>, c) -> e list<c> */ 
  kk_std_core__list _trmc_18431 = kk_datatype_null(); /*list<17307>*/;
  kk_std_core__list _trmc_18432 = kk_std_core__new_Cons(kk_reuse_null, kk_field_index_of(struct kk_std_core_Cons, tail), _trmc_18430, _trmc_18431, _ctx); /*list<17307>*/;
  kk_box_t* _b_20659_20656 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_18432, _ctx)->tail)); /*field-addr<list<17307>>*/;
  kk_std_core_types__cctx _x22289 = kk_cctx_extend(_acc,(kk_std_core__list_box(_trmc_18432, _ctx)),_b_20659_20656,false,kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed(f, i0_17863, xx, yy, _x22289, _ctx);
}
 
// lifted local: zipwith-indexed, zipwith-iter


// lift anonymous function
struct kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed_fun22295__t {
  struct kk_function_s _base;
  kk_function_t f0;
  kk_integer_t i0_178630;
  kk_std_core__list xx0;
  kk_std_core__list yy0;
  kk_std_core_types__cctx _acc0;
};
static kk_box_t kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed_fun22295(kk_function_t _fself, kk_box_t _b_20664, kk_context_t* _ctx);
static kk_function_t kk_std_core__new_trmc_unroll17355_lift17326_zipwith_indexed_fun22295(kk_function_t f0, kk_integer_t i0_178630, kk_std_core__list xx0, kk_std_core__list yy0, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed_fun22295__t* _self = kk_function_alloc_as(struct kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed_fun22295__t, 6, _ctx);
  _self->_base.fun = kk_kkfun_ptr_box(&kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed_fun22295, kk_context());
  _self->f0 = f0;
  _self->i0_178630 = i0_178630;
  _self->xx0 = xx0;
  _self->yy0 = yy0;
  _self->_acc0 = _acc0;
  return kk_datatype_from_base(&_self->_base, kk_context());
}

static kk_box_t kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed_fun22295(kk_function_t _fself, kk_box_t _b_20664, kk_context_t* _ctx) {
  struct kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed_fun22295__t* _self = kk_function_as(struct kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed_fun22295__t*, _fself, _ctx);
  kk_function_t f0 = _self->f0; /* (int, 17305, 17306) -> 17308 17307 */
  kk_integer_t i0_178630 = _self->i0_178630; /* int */
  kk_std_core__list xx0 = _self->xx0; /* list<17305> */
  kk_std_core__list yy0 = _self->yy0; /* list<17306> */
  kk_std_core_types__cctx _acc0 = _self->_acc0; /* ctx<list<17307>> */
  kk_drop_match(_self, {kk_function_dup(f0, _ctx);kk_integer_dup(i0_178630, _ctx);kk_std_core__list_dup(xx0, _ctx);kk_std_core__list_dup(yy0, _ctx);kk_std_core_types__cctx_dup(_acc0, _ctx);}, {}, _ctx)
  kk_box_t _trmc_20686_184300 = _b_20664; /*17307*/;
  kk_std_core__list _x22296 = kk_std_core__mlift18855_trmc_unroll17355_lift17326_zipwith_indexed(_acc0, f0, i0_178630, xx0, yy0, _trmc_20686_184300, _ctx); /*list<17307>*/
  return kk_std_core__list_box(_x22296, _ctx);
}

kk_std_core__list kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed(kk_function_t f0, kk_integer_t i, kk_std_core__list xs, kk_std_core__list ys, kk_std_core_types__cctx _acc0, kk_context_t* _ctx) { /* forall<a,b,c,e> (f : (int, a, b) -> e c, i : int, xs : list<a>, ys : list<b>, ctx<list<c>>) -> e list<c> */ 
  kk__tailcall: ;
  if (kk_std_core__is_Cons(xs, _ctx)) {
    struct kk_std_core_Cons* _con22290 = kk_std_core__as_Cons(xs, _ctx);
    kk_box_t x = _con22290->head;
    kk_std_core__list xx0 = _con22290->tail;
    if kk_likely(kk_datatype_ptr_is_unique(xs, _ctx)) {
      kk_datatype_ptr_free(xs, _ctx);
    }
    else {
      kk_box_dup(x, _ctx);
      kk_std_core__list_dup(xx0, _ctx);
      kk_datatype_ptr_decref(xs, _ctx);
    }
    if (kk_std_core__is_Cons(ys, _ctx)) {
      struct kk_std_core_Cons* _con22291 = kk_std_core__as_Cons(ys, _ctx);
      kk_box_t y = _con22291->head;
      kk_std_core__list yy0 = _con22291->tail;
      kk_reuse_t _ru_21105 = kk_reuse_null; /*reuse*/;
      if kk_likely(kk_datatype_ptr_is_unique(ys, _ctx)) {
        _ru_21105 = (kk_datatype_ptr_reuse(ys, _ctx));
      }
      else {
        kk_box_dup(y, _ctx);
        kk_std_core__list_dup(yy0, _ctx);
        kk_datatype_ptr_decref(ys, _ctx);
      }
      kk_integer_t i0_178630;
      kk_integer_t _x22292 = kk_integer_dup(i, _ctx); /*int*/
      i0_178630 = kk_integer_add_small_const(_x22292, 1, _ctx); /*int*/
      kk_box_t x0_19168;
      kk_function_t _x22293 = kk_function_dup(f0, _ctx); /*(int, 17305, 17306) -> 17308 17307*/
      x0_19168 = kk_function_call(kk_box_t, (kk_function_t, kk_integer_t, kk_box_t, kk_box_t, kk_context_t*), _x22293, (_x22293, i, x, y, _ctx), _ctx); /*17307*/
      if (kk_yielding(kk_context())) {
        kk_reuse_drop(_ru_21105,kk_context());
        kk_box_drop(x0_19168, _ctx);
        kk_box_t _x22294 = kk_std_core_hnd_yield_extend(kk_std_core__new_trmc_unroll17355_lift17326_zipwith_indexed_fun22295(f0, i0_178630, xx0, yy0, _acc0, _ctx), _ctx); /*3926*/
        return kk_std_core__list_unbox(_x22294, KK_OWNED, _ctx);
      }
      {
        kk_std_core__list _trmc_184310 = kk_datatype_null(); /*list<17307>*/;
        kk_std_core__list _trmc_184320 = kk_std_core__new_Cons(_ru_21105, kk_field_index_of(struct kk_std_core_Cons, tail), x0_19168, _trmc_184310, _ctx); /*list<17307>*/;
        kk_box_t* _b_20678_20670 = (kk_box_t*)((&kk_std_core__as_Cons(_trmc_184320, _ctx)->tail)); /*field-addr<list<17307>>*/;
        { // tailcall
          kk_std_core_types__cctx _x22297 = kk_cctx_extend(_acc0,(kk_std_core__list_box(_trmc_184320, _ctx)),_b_20678_20670,false,kk_context()); /*ctx<0>*/
          i = i0_178630;
          xs = xx0;
          ys = yy0;
          _acc0 = _x22297;
          goto kk__tailcall;
        }
      }
    }
    {
      kk_std_core__list_drop(xx0, _ctx);
      kk_box_drop(x, _ctx);
      kk_integer_drop(i, _ctx);
      kk_function_drop(f0, _ctx);
      kk_box_t _x22298 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
      return kk_std_core__list_unbox(_x22298, KK_OWNED, _ctx);
    }
  }
  {
    kk_std_core__list_drop(ys, _ctx);
    kk_integer_drop(i, _ctx);
    kk_function_drop(f0, _ctx);
    kk_box_t _x22299 = kk_cctx_apply(_acc0,(kk_std_core__list_box(kk_std_core__new_Nil(_ctx), _ctx)),false,kk_context()); /*-1*/
    return kk_std_core__list_unbox(_x22299, KK_OWNED, _ctx);
  }
}
 
// lifted local: zipwith-indexed, zipwith-iter

kk_std_core__list kk_std_core__unroll17355_lift17326_zipwith_indexed(kk_function_t f1, kk_integer_t i0, kk_std_core__list xs0, kk_std_core__list ys0, kk_context_t* _ctx) { /* forall<a,b,c,e> (f : (int, a, b) -> e c, i : int, xs : list<a>, ys : list<b>) -> e list<c> */ 
  kk_std_core_types__cctx _x22300 = kk_cctx_empty(kk_context()); /*ctx<0>*/
  return kk_std_core__trmc_unroll17355_lift17326_zipwith_indexed(f1, i0, xs0, ys0, _x22300, _ctx);
}

// initialization
void kk_std_core__init(kk_context_t* _ctx){
  static bool _kk_initialized = false;
  if (_kk_initialized) return;
  _kk_initialized = true;
  kk_std_core_types__init(_ctx);
  kk_std_core_hnd__init(_ctx);
  #if defined(KK_CUSTOM_INIT)
    KK_CUSTOM_INIT (_ctx);
  #endif
  kk_init_string_literal(kk_std_core__tag_ExnError, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnAssert, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnTodo, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnRange, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnPattern, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnSystem, _ctx)
  kk_init_string_literal(kk_std_core__tag_ExnInternal, _ctx)
  {
    kk_string_t _x21127;
    kk_define_string_literal(, _s21128, 8, "exn.core", _ctx)
    _x21127 = kk_string_dup(_s21128, _ctx); /*string*/
    kk_std_core__tag_exn = kk_std_core_hnd__new_Htag(_x21127, _ctx); /*std/core/hnd/htag<.hnd-exn>*/
  }
  {
    kk_std_core_redirect = kk_ref_alloc((kk_std_core_types__maybe_box(kk_std_core_types__new_Nothing(_ctx), _ctx)),kk_context()); /*ref<global,maybe<(string) -> console ()>>*/
  }
  {
    kk_string_t _x21138 = kk_string_empty(); /*string*/
    kk_std_core_empty = kk_std_core__new_Sslice(_x21138, kk_integer_from_small(0), kk_integer_from_small(0), _ctx); /*sslice*/
  }
  {
    kk_string_t _x21176 = kk_string_empty(); /*string*/
    kk_std_core_invalid = kk_std_core__new_Sslice(_x21176, kk_integer_from_small(-1), kk_integer_from_small(0), _ctx); /*sslice*/
  }
  {
    kk_std_core_trace_enabled = kk_ref_alloc((kk_bool_box(true)),kk_context()); /*ref<global,bool>*/
  }
  {
    kk_std_core_unique_count = kk_ref_alloc((kk_integer_box(kk_integer_from_small(0), _ctx)),kk_context()); /*ref<global,int>*/
  }
}

// termination
void kk_std_core__done(kk_context_t* _ctx){
  static bool _kk_done = false;
  if (_kk_done) return;
  _kk_done = true;
  #if defined(KK_CUSTOM_DONE)
    KK_CUSTOM_DONE (_ctx);
  #endif
  kk_ref_drop(kk_std_core_unique_count, _ctx);
  kk_ref_drop(kk_std_core_trace_enabled, _ctx);
  kk_std_core__sslice_drop(kk_std_core_invalid, _ctx);
  kk_std_core__sslice_drop(kk_std_core_empty, _ctx);
  kk_ref_drop(kk_std_core_redirect, _ctx);
  kk_std_core_hnd__htag_drop(kk_std_core__tag_exn, _ctx);
  kk_std_core_hnd__done(_ctx);
  kk_std_core_types__done(_ctx);
}
